-- MySQL dump 10.13  Distrib 5.7.18, for macos10.12 (x86_64)
--
-- ------------------------------------------------------
-- Server version	5.7.36-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `acl_apps`
--

DROP TABLE IF EXISTS `acl_apps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_apps` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `description` text,
  `app_id` text,
  `secret_key` text,
  PRIMARY KEY (`id`),
  KEY `ix_acl_apps_deleted` (`deleted`),
  KEY `ix_acl_apps_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_apps`
--

LOCK TABLES `acl_apps` WRITE;
/*!40000 ALTER TABLE `acl_apps` DISABLE KEYS */;
INSERT INTO `acl_apps` VALUES (NULL,0,NULL,NULL,1,'cmdb',NULL,NULL,NULL),(NULL,0,NULL,NULL,2,'backend',NULL,NULL,NULL);
/*!40000 ALTER TABLE `acl_apps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_audit_permission_logs`
--

DROP TABLE IF EXISTS `acl_audit_permission_logs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_audit_permission_logs` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app_id` int(11) DEFAULT NULL,
  `operate_uid` int(11) DEFAULT NULL COMMENT '操作人uid',
  `operate_type` varchar(16) DEFAULT NULL COMMENT '操作类型',
  `rid` int(11) DEFAULT NULL COMMENT '角色id',
  `resource_type_id` int(11) DEFAULT NULL COMMENT '资源类型id',
  `resource_ids` json DEFAULT NULL COMMENT '资源',
  `group_ids` json DEFAULT NULL COMMENT '资源组',
  `permission_ids` json DEFAULT NULL COMMENT '权限',
  `source` varchar(16) DEFAULT NULL COMMENT '来源',
  PRIMARY KEY (`id`),
  KEY `ix_acl_audit_permission_logs_resource_type_id` (`resource_type_id`),
  KEY `ix_acl_audit_permission_logs_operate_uid` (`operate_uid`),
  KEY `ix_acl_audit_permission_logs_deleted` (`deleted`),
  KEY `ix_acl_audit_permission_logs_app_id` (`app_id`),
  KEY `ix_acl_audit_permission_logs_rid` (`rid`),
  KEY `ix_acl_audit_permission_logs_operate_type` (`operate_type`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_audit_permission_logs`
--

LOCK TABLES `acl_audit_permission_logs` WRITE;
/*!40000 ALTER TABLE `acl_audit_permission_logs` DISABLE KEYS */;
INSERT INTO `acl_audit_permission_logs` VALUES (NULL,0,'2023-07-11 14:39:53',NULL,1,1,3,'grant',4,3,'[2]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,2,1,3,'grant',4,3,'[3]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,3,1,3,'grant',4,3,'[4]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,4,1,3,'grant',4,3,'[5]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,5,1,3,'grant',4,3,'[6]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,6,1,3,'grant',4,3,'[7]','[]','[7, 8, 9, 10, 11, 12]','acl'),(NULL,0,'2023-07-11 14:39:53',NULL,7,1,3,'grant',4,3,'[8]','[]','[7, 8, 9, 10, 11, 12]','acl');
/*!40000 ALTER TABLE `acl_audit_permission_logs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_audit_resource_logs`
--

DROP TABLE IF EXISTS `acl_audit_resource_logs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_audit_resource_logs` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app_id` int(11) DEFAULT NULL,
  `operate_uid` int(11) DEFAULT NULL COMMENT '操作人uid',
  `operate_type` varchar(16) DEFAULT NULL COMMENT '操作类型',
  `scope` varchar(16) DEFAULT NULL COMMENT '范围',
  `link_id` int(11) DEFAULT NULL COMMENT '资源名',
  `origin` json DEFAULT NULL COMMENT '原始数据',
  `current` json DEFAULT NULL COMMENT '当前数据',
  `extra` json DEFAULT NULL COMMENT '权限名',
  `source` varchar(16) DEFAULT NULL COMMENT '来源',
  PRIMARY KEY (`id`),
  KEY `ix_acl_audit_resource_logs_app_id` (`app_id`),
  KEY `ix_acl_audit_resource_logs_deleted` (`deleted`),
  KEY `ix_acl_audit_resource_logs_link_id` (`link_id`),
  KEY `ix_acl_audit_resource_logs_operate_uid` (`operate_uid`),
  KEY `ix_acl_audit_resource_logs_operate_type` (`operate_type`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_audit_resource_logs`
--

LOCK TABLES `acl_audit_resource_logs` WRITE;
/*!40000 ALTER TABLE `acl_audit_resource_logs` DISABLE KEYS */;
INSERT INTO `acl_audit_resource_logs` VALUES (NULL,0,'2023-07-11 14:38:56',NULL,1,1,3,'update','resource_type',3,'{\"id\": 3, \"name\": \"CIType\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"id\": 3, \"name\": \"CIType\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"permission_ids\": {\"origin\": [7, 8, 9, 10], \"current\": [7, 8, 9, 10, 11]}}','acl'),(NULL,0,'2023-07-11 14:39:03',NULL,2,1,3,'update','resource_type',3,'{\"id\": 3, \"name\": \"CIType\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"id\": 3, \"name\": \"CIType\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"permission_ids\": {\"origin\": [7, 8, 9, 10, 11], \"current\": [7, 8, 9, 10, 11, 12]}}','acl'),(NULL,0,'2023-07-11 14:39:12',NULL,3,1,3,'update','resource_type',2,'{\"id\": 2, \"name\": \"RelationView\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"id\": 2, \"name\": \"RelationView\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"permission_ids\": {\"origin\": [3, 4, 5, 6], \"current\": [3, 4, 5, 6, 13]}}','acl'),(NULL,0,'2023-07-11 14:39:29',NULL,4,1,3,'create','resource_type',4,'{}','{\"id\": 4, \"name\": \"CITypeRelation\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2023-07-11 14:39:29\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"permission_ids\": {\"origin\": [], \"current\": [14, 15, 16]}}','acl'),(NULL,0,'2023-07-11 14:39:37',NULL,5,1,3,'create','resource_type',5,'{}','{\"id\": 5, \"name\": \"CIFilter\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2023-07-11 14:39:37\", \"deleted_at\": null, \"updated_at\": null, \"description\": \"\"}','{\"permission_ids\": {\"origin\": [], \"current\": [17]}}','acl'),(NULL,0,'2023-07-11 14:49:30',NULL,6,1,3,'delete','resource',10,'{\"id\": 10, \"uid\": null, \"name\": \"服务树\", \"app_id\": 1, \"deleted\": false, \"created_at\": \"2019-12-11 11:58:04\", \"deleted_at\": null, \"updated_at\": null, \"resource_type_id\": 2}','{}','{}','acl');
/*!40000 ALTER TABLE `acl_audit_resource_logs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_audit_role_logs`
--

DROP TABLE IF EXISTS `acl_audit_role_logs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_audit_role_logs` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app_id` int(11) DEFAULT NULL,
  `operate_uid` int(11) DEFAULT NULL COMMENT '操作人uid',
  `operate_type` varchar(32) DEFAULT NULL COMMENT '操作类型',
  `scope` varchar(16) DEFAULT NULL COMMENT '范围',
  `link_id` int(11) DEFAULT NULL COMMENT '资源id',
  `origin` json DEFAULT NULL COMMENT '原始数据',
  `current` json DEFAULT NULL COMMENT '当前数据',
  `extra` json DEFAULT NULL COMMENT '其他内容',
  `source` varchar(16) DEFAULT NULL COMMENT '来源',
  PRIMARY KEY (`id`),
  KEY `ix_acl_audit_role_logs_operate_uid` (`operate_uid`),
  KEY `ix_acl_audit_role_logs_deleted` (`deleted`),
  KEY `ix_acl_audit_role_logs_link_id` (`link_id`),
  KEY `ix_acl_audit_role_logs_operate_type` (`operate_type`),
  KEY `ix_acl_audit_role_logs_app_id` (`app_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_audit_role_logs`
--

LOCK TABLES `acl_audit_role_logs` WRITE;
/*!40000 ALTER TABLE `acl_audit_role_logs` DISABLE KEYS */;
/*!40000 ALTER TABLE `acl_audit_role_logs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_audit_trigger_logs`
--

DROP TABLE IF EXISTS `acl_audit_trigger_logs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_audit_trigger_logs` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app_id` int(11) DEFAULT NULL,
  `trigger_id` int(11) DEFAULT NULL COMMENT 'trigger',
  `operate_uid` int(11) DEFAULT NULL COMMENT '操作人uid',
  `operate_type` varchar(16) DEFAULT NULL COMMENT '操作类型',
  `origin` json DEFAULT NULL COMMENT '原始数据',
  `current` json DEFAULT NULL COMMENT '当前数据',
  `extra` json DEFAULT NULL COMMENT '权限名',
  `source` varchar(16) DEFAULT NULL COMMENT '来源',
  PRIMARY KEY (`id`),
  KEY `ix_acl_audit_trigger_logs_operate_uid` (`operate_uid`),
  KEY `ix_acl_audit_trigger_logs_operate_type` (`operate_type`),
  KEY `ix_acl_audit_trigger_logs_app_id` (`app_id`),
  KEY `ix_acl_audit_trigger_logs_deleted` (`deleted`),
  KEY `ix_acl_audit_trigger_logs_trigger_id` (`trigger_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_audit_trigger_logs`
--

LOCK TABLES `acl_audit_trigger_logs` WRITE;
/*!40000 ALTER TABLE `acl_audit_trigger_logs` DISABLE KEYS */;
/*!40000 ALTER TABLE `acl_audit_trigger_logs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_operation_records`
--

DROP TABLE IF EXISTS `acl_operation_records`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_operation_records` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app` varchar(32) DEFAULT NULL,
  `rolename` varchar(32) DEFAULT NULL,
  `operate` enum('2','4','1','0','3') NOT NULL,
  `obj` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_acl_operation_records_app` (`app`),
  KEY `ix_acl_operation_records_deleted` (`deleted`),
  KEY `ix_acl_operation_records_rolename` (`rolename`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_operation_records`
--

LOCK TABLES `acl_operation_records` WRITE;
/*!40000 ALTER TABLE `acl_operation_records` DISABLE KEYS */;
INSERT INTO `acl_operation_records` VALUES (NULL,0,'2023-07-11 15:19:33',NULL,1,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,2,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,3,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,4,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,5,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,6,NULL,'demo','0','[\"ACL\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,7,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,8,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,9,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,10,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,11,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,12,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,13,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,14,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,15,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,16,NULL,'demo','0','[\"ACL\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,17,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,18,NULL,'demo','0','[\"ACL\"]'),(NULL,0,'2023-07-11 15:19:33',NULL,19,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,20,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,21,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,22,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,23,NULL,'demo','0','[\"ACL\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,24,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,25,NULL,'demo','0','[\"ACL\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,26,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,27,'backend','demo','1','[\"resources\"]'),(NULL,0,'2023-07-11 15:19:34',NULL,28,'backend','demo','1','[\"resources\"]');
/*!40000 ALTER TABLE `acl_operation_records` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_permissions`
--

DROP TABLE IF EXISTS `acl_permissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_permissions` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `resource_type_id` int(11) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `resource_type_id` (`resource_type_id`),
  KEY `app_id` (`app_id`),
  KEY `ix_acl_permissions_deleted` (`deleted`),
  CONSTRAINT `acl_permissions_ibfk_1` FOREIGN KEY (`resource_type_id`) REFERENCES `acl_resource_types` (`id`),
  CONSTRAINT `acl_permissions_ibfk_2` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_permissions`
--

LOCK TABLES `acl_permissions` WRITE;
/*!40000 ALTER TABLE `acl_permissions` DISABLE KEYS */;
INSERT INTO `acl_permissions` VALUES ('2019-12-11 12:02:11',1,NULL,'2019-12-11 12:02:11',1,'perm1',1,1),(NULL,0,'2019-12-11 11:58:04',NULL,3,'update',2,1),(NULL,0,'2019-12-11 11:58:04',NULL,4,'read',2,1),(NULL,0,'2019-12-11 11:58:04',NULL,5,'delete',2,1),(NULL,0,'2019-12-11 11:58:04',NULL,6,'add',2,1),(NULL,0,'2019-12-11 11:58:04',NULL,7,'update',3,1),(NULL,0,'2019-12-11 11:58:04',NULL,8,'read',3,1),(NULL,0,'2019-12-11 11:58:04',NULL,9,'delete',3,1),(NULL,0,'2019-12-11 11:58:04',NULL,10,'add',3,1),(NULL,0,'2023-07-11 14:38:56',NULL,11,'grant',3,1),(NULL,0,'2023-07-11 14:39:03',NULL,12,'config',3,1),(NULL,0,'2023-07-11 14:39:12',NULL,13,'grant',2,1),(NULL,0,'2023-07-11 14:39:29',NULL,14,'create',4,1),(NULL,0,'2023-07-11 14:39:29',NULL,15,'delete',4,1),(NULL,0,'2023-07-11 14:39:29',NULL,16,'grant',4,1),(NULL,0,'2023-07-11 14:39:37',NULL,17,'read',5,1);
/*!40000 ALTER TABLE `acl_permissions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_resource_group_items`
--

DROP TABLE IF EXISTS `acl_resource_group_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_resource_group_items` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `resource_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`),
  KEY `resource_id` (`resource_id`),
  KEY `ix_acl_resource_group_items_deleted` (`deleted`),
  CONSTRAINT `acl_resource_group_items_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `acl_resource_groups` (`id`),
  CONSTRAINT `acl_resource_group_items_ibfk_2` FOREIGN KEY (`resource_id`) REFERENCES `acl_resources` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_resource_group_items`
--

LOCK TABLES `acl_resource_group_items` WRITE;
/*!40000 ALTER TABLE `acl_resource_group_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `acl_resource_group_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_resource_groups`
--

DROP TABLE IF EXISTS `acl_resource_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_resource_groups` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `resource_type_id` int(11) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `resource_type_id` (`resource_type_id`),
  KEY `app_id` (`app_id`),
  KEY `ix_acl_resource_groups_name` (`name`),
  KEY `ix_acl_resource_groups_deleted` (`deleted`),
  CONSTRAINT `acl_resource_groups_ibfk_1` FOREIGN KEY (`resource_type_id`) REFERENCES `acl_resource_types` (`id`),
  CONSTRAINT `acl_resource_groups_ibfk_2` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_resource_groups`
--

LOCK TABLES `acl_resource_groups` WRITE;
/*!40000 ALTER TABLE `acl_resource_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `acl_resource_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_resource_types`
--

DROP TABLE IF EXISTS `acl_resource_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_resource_types` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `description` text,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `app_id` (`app_id`),
  KEY `ix_acl_resource_types_deleted` (`deleted`),
  KEY `ix_acl_resource_types_name` (`name`),
  CONSTRAINT `acl_resource_types_ibfk_1` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_resource_types`
--

LOCK TABLES `acl_resource_types` WRITE;
/*!40000 ALTER TABLE `acl_resource_types` DISABLE KEYS */;
INSERT INTO `acl_resource_types` VALUES ('2019-12-11 12:02:11',1,NULL,'2019-12-11 12:02:11',1,'DAG',NULL,1),(NULL,0,'2019-12-11 11:58:04',NULL,2,'RelationView','',1),(NULL,0,'2019-12-11 11:58:04',NULL,3,'CIType','',1),(NULL,0,'2023-07-11 14:39:29',NULL,4,'CITypeRelation','',1),(NULL,0,'2023-07-11 14:39:37',NULL,5,'CIFilter','',1);
/*!40000 ALTER TABLE `acl_resource_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_resources`
--

DROP TABLE IF EXISTS `acl_resources`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_resources` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) NOT NULL,
  `resource_type_id` int(11) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `resource_type_id` (`resource_type_id`),
  KEY `app_id` (`app_id`),
  KEY `ix_acl_resources_deleted` (`deleted`),
  KEY `ix_acl_resources_uid` (`uid`),
  CONSTRAINT `acl_resources_ibfk_1` FOREIGN KEY (`resource_type_id`) REFERENCES `acl_resource_types` (`id`),
  CONSTRAINT `acl_resources_ibfk_2` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_resources`
--

LOCK TABLES `acl_resources` WRITE;
/*!40000 ALTER TABLE `acl_resources` DISABLE KEYS */;
INSERT INTO `acl_resources` VALUES (NULL,0,NULL,NULL,1,'1',1,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,2,'bu',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,3,'product',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,4,'app',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,5,'server',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,6,'docker',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,7,'NIC',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,8,'harddisk',3,1,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,9,'RAM',3,1,NULL),('2023-07-11 14:49:27',1,'2019-12-11 11:58:04','2023-07-11 14:49:27',10,'服务树',2,1,NULL);
/*!40000 ALTER TABLE `acl_resources` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_role_permissions`
--

DROP TABLE IF EXISTS `acl_role_permissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_role_permissions` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rid` int(11) DEFAULT NULL,
  `resource_id` int(11) DEFAULT NULL,
  `group_id` int(11) DEFAULT NULL,
  `perm_id` int(11) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `rid` (`rid`),
  KEY `resource_id` (`resource_id`),
  KEY `group_id` (`group_id`),
  KEY `perm_id` (`perm_id`),
  KEY `ix_acl_role_permissions_deleted` (`deleted`),
  KEY `acl_role_permissions_ibfk_5` (`app_id`),
  CONSTRAINT `acl_role_permissions_ibfk_1` FOREIGN KEY (`rid`) REFERENCES `acl_roles` (`id`),
  CONSTRAINT `acl_role_permissions_ibfk_2` FOREIGN KEY (`resource_id`) REFERENCES `acl_resources` (`id`),
  CONSTRAINT `acl_role_permissions_ibfk_3` FOREIGN KEY (`group_id`) REFERENCES `acl_resource_groups` (`id`),
  CONSTRAINT `acl_role_permissions_ibfk_4` FOREIGN KEY (`perm_id`) REFERENCES `acl_permissions` (`id`),
  CONSTRAINT `acl_role_permissions_ibfk_5` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=61 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_role_permissions`
--

LOCK TABLES `acl_role_permissions` WRITE;
/*!40000 ALTER TABLE `acl_role_permissions` DISABLE KEYS */;
INSERT INTO `acl_role_permissions` VALUES (NULL,0,'2019-11-24 16:34:04',NULL,2,1,1,NULL,1,1),(NULL,0,'2019-12-11 11:58:04',NULL,4,3,2,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,5,3,3,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,6,3,4,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,7,3,5,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,8,3,6,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,9,3,7,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,10,3,8,NULL,4,1),(NULL,0,'2019-12-11 11:58:04',NULL,11,3,9,NULL,4,1),('2023-07-11 14:49:29',1,'2019-12-11 11:58:04','2023-07-11 14:49:29',12,3,10,NULL,4,1),(NULL,0,'2023-07-11 14:39:53',NULL,13,4,2,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,14,4,2,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,15,4,2,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,16,4,2,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,17,4,2,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,18,4,2,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,19,4,3,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,20,4,3,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,21,4,3,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,22,4,3,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,23,4,3,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,24,4,3,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,25,4,4,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,26,4,4,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,27,4,4,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,28,4,4,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,29,4,4,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,30,4,4,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,31,4,5,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,32,4,5,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,33,4,5,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,34,4,5,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,35,4,5,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,36,4,5,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,37,4,6,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,38,4,6,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,39,4,6,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,40,4,6,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,41,4,6,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,42,4,6,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,43,4,7,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,44,4,7,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,45,4,7,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,46,4,7,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,47,4,7,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,48,4,7,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,49,4,8,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,50,4,8,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,51,4,8,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,52,4,8,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,53,4,8,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,54,4,8,NULL,12,1),(NULL,0,'2023-07-11 14:39:53',NULL,55,4,9,NULL,7,1),(NULL,0,'2023-07-11 14:39:53',NULL,56,4,9,NULL,8,1),(NULL,0,'2023-07-11 14:39:53',NULL,57,4,9,NULL,9,1),(NULL,0,'2023-07-11 14:39:53',NULL,58,4,9,NULL,11,1),(NULL,0,'2023-07-11 14:39:53',NULL,59,4,9,NULL,10,1),(NULL,0,'2023-07-11 14:39:53',NULL,60,4,9,NULL,12,1);
/*!40000 ALTER TABLE `acl_role_permissions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_role_relations`
--

DROP TABLE IF EXISTS `acl_role_relations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_role_relations` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) DEFAULT NULL,
  `child_id` int(11) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `child_id` (`child_id`),
  KEY `ix_acl_role_relations_deleted` (`deleted`),
  KEY `acl_role_relations_ibfk_1` (`parent_id`),
  KEY `acl_role_relations_ibfk_3` (`app_id`),
  CONSTRAINT `acl_role_relations_ibfk_1` FOREIGN KEY (`parent_id`) REFERENCES `acl_roles` (`id`),
  CONSTRAINT `acl_role_relations_ibfk_2` FOREIGN KEY (`child_id`) REFERENCES `acl_roles` (`id`),
  CONSTRAINT `acl_role_relations_ibfk_3` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_role_relations`
--

LOCK TABLES `acl_role_relations` WRITE;
/*!40000 ALTER TABLE `acl_role_relations` DISABLE KEYS */;
INSERT INTO `acl_role_relations` VALUES (NULL,0,'2019-12-11 12:01:54',NULL,2,1,4,1),(NULL,0,'2019-12-11 12:09:06',NULL,3,3,4,1);
/*!40000 ALTER TABLE `acl_role_relations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_roles`
--

DROP TABLE IF EXISTS `acl_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_roles` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `is_app_admin` tinyint(1) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `password` varchar(80) DEFAULT NULL,
  `key` varchar(32) DEFAULT NULL,
  `secret` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `app_id` (`app_id`),
  KEY `uid` (`uid`),
  KEY `ix_acl_roles_deleted` (`deleted`),
  CONSTRAINT `acl_roles_ibfk_1` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`),
  CONSTRAINT `acl_roles_ibfk_2` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_roles`
--

LOCK TABLES `acl_roles` WRITE;
/*!40000 ALTER TABLE `acl_roles` DISABLE KEYS */;
INSERT INTO `acl_roles` VALUES (NULL,0,NULL,NULL,1,'admin',NULL,1,NULL,NULL,NULL,NULL),('2019-12-11 12:01:46',1,'2019-11-24 22:11:29','2019-12-11 12:01:46',2,'pm',1,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-12-11 11:58:04',NULL,3,'CMDB_READ_ALL',0,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-12-11 12:01:40',NULL,4,'demo',1,1,3,NULL,NULL,NULL);
/*!40000 ALTER TABLE `acl_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `acl_triggers`
--

DROP TABLE IF EXISTS `acl_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_triggers` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `wildcard` text,
  `uid` text,
  `resource_type_id` int(11) DEFAULT NULL,
  `roles` text,
  `permissions` text,
  `enabled` tinyint(1) DEFAULT NULL,
  `app_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `resource_type_id` (`resource_type_id`),
  KEY `app_id` (`app_id`),
  KEY `ix_acl_triggers_deleted` (`deleted`),
  CONSTRAINT `acl_triggers_ibfk_1` FOREIGN KEY (`resource_type_id`) REFERENCES `acl_resource_types` (`id`),
  CONSTRAINT `acl_triggers_ibfk_2` FOREIGN KEY (`app_id`) REFERENCES `acl_apps` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acl_triggers`
--

LOCK TABLES `acl_triggers` WRITE;
/*!40000 ALTER TABLE `acl_triggers` DISABLE KEYS */;
/*!40000 ALTER TABLE `acl_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ad_ci`
--

DROP TABLE IF EXISTS `c_ad_ci`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ad_ci` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) DEFAULT NULL,
  `adt_id` int(11) DEFAULT NULL,
  `unique_value` varchar(128) DEFAULT NULL,
  `instance` json DEFAULT NULL,
  `ci_id` int(11) DEFAULT NULL,
  `is_accept` tinyint(1) DEFAULT NULL,
  `accept_by` varchar(64) DEFAULT NULL,
  `accept_time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `adt_id` (`adt_id`),
  KEY `ix_c_ad_ci_deleted` (`deleted`),
  KEY `ix_c_ad_ci_unique_value` (`unique_value`),
  KEY `ix_c_ad_ci_accept_by` (`accept_by`),
  KEY `ix_c_ad_ci_ci_id` (`ci_id`),
  CONSTRAINT `c_ad_ci_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_ad_ci_ibfk_2` FOREIGN KEY (`adt_id`) REFERENCES `c_ad_ci_types` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ad_ci`
--

LOCK TABLES `c_ad_ci` WRITE;
/*!40000 ALTER TABLE `c_ad_ci` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_ad_ci` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ad_ci_types`
--

DROP TABLE IF EXISTS `c_ad_ci_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ad_ci_types` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) DEFAULT NULL,
  `adr_id` int(11) DEFAULT NULL,
  `attributes` json DEFAULT NULL,
  `relation` json DEFAULT NULL,
  `auto_accept` tinyint(1) DEFAULT NULL,
  `agent_id` varchar(8) DEFAULT NULL,
  `query_expr` text,
  `interval` int(11) DEFAULT NULL,
  `cron` varchar(128) DEFAULT NULL,
  `extra_option` json DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `adr_id` (`adr_id`),
  KEY `ix_c_ad_ci_types_deleted` (`deleted`),
  KEY `ix_c_ad_ci_types_uid` (`uid`),
  KEY `ix_c_ad_ci_types_agent_id` (`agent_id`),
  CONSTRAINT `c_ad_ci_types_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_ad_ci_types_ibfk_2` FOREIGN KEY (`adr_id`) REFERENCES `c_ad_rules` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ad_ci_types`
--

LOCK TABLES `c_ad_ci_types` WRITE;
/*!40000 ALTER TABLE `c_ad_ci_types` DISABLE KEYS */;
INSERT INTO `c_ad_ci_types` VALUES (NULL,0,'2023-07-11 15:24:08',NULL,2,4,9,NULL,NULL,0,NULL,NULL,300,NULL,NULL,3);
/*!40000 ALTER TABLE `c_ad_ci_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ad_rules`
--

DROP TABLE IF EXISTS `c_ad_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ad_rules` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) DEFAULT NULL,
  `type` enum('agent','snmp','http') DEFAULT NULL,
  `is_inner` tinyint(1) DEFAULT NULL,
  `owner` int(11) DEFAULT NULL,
  `option` json DEFAULT NULL,
  `attributes` json DEFAULT NULL,
  `is_plugin` tinyint(1) DEFAULT NULL,
  `plugin_script` text,
  `unique_key` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_ad_rules_is_inner` (`is_inner`),
  KEY `ix_c_ad_rules_type` (`type`),
  KEY `ix_c_ad_rules_deleted` (`deleted`),
  KEY `ix_c_ad_rules_owner` (`owner`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ad_rules`
--

LOCK TABLES `c_ad_rules` WRITE;
/*!40000 ALTER TABLE `c_ad_rules` DISABLE KEYS */;
INSERT INTO `c_ad_rules` VALUES (NULL,0,'2023-07-11 15:19:44',NULL,1,'阿里云','http',1,NULL,'{\"icon\": {\"name\": \"caise-aliyun\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,2,'腾讯云','http',1,NULL,'{\"icon\": {\"name\": \"caise-tengxunyun\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,3,'华为云','http',1,NULL,'{\"icon\": {\"name\": \"caise-huaweiyun\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,4,'AWS','http',1,NULL,'{\"icon\": {\"name\": \"caise-aws\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,5,'交换机','snmp',1,NULL,'{\"icon\": {\"name\": \"caise-jiaohuanji\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,6,'路由器','snmp',1,NULL,'{\"icon\": {\"name\": \"caise-luyouqi\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,7,'防火墙','snmp',1,NULL,'{\"icon\": {\"name\": \"caise-fanghuoqiang\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:19:44',NULL,8,'打印机','snmp',1,NULL,'{\"icon\": {\"name\": \"caise-dayinji\"}}',NULL,0,NULL,NULL),(NULL,0,'2023-07-11 15:20:08',NULL,9,'server','agent',1,NULL,'{\"icon\": {\"name\": \"caise-wuliji\", \"color\": \"\"}}','[]',0,NULL,NULL),(NULL,0,'2023-07-11 15:20:18',NULL,10,'vserver','agent',1,NULL,'{\"icon\": {\"name\": \"caise-xuniji\", \"color\": \"\"}}','[]',0,NULL,NULL),(NULL,0,'2023-07-11 15:20:38',NULL,11,'NIC','agent',1,NULL,'{\"icon\": {\"name\": \"caise-wangka\", \"color\": \"\"}}','[]',0,NULL,NULL);
/*!40000 ALTER TABLE `c_ad_rules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_attribute_histories`
--

DROP TABLE IF EXISTS `c_attribute_histories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_attribute_histories` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `operate_type` enum('0','1','2') DEFAULT NULL,
  `record_id` int(11) NOT NULL,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) DEFAULT NULL,
  `old` text,
  `new` text,
  PRIMARY KEY (`id`),
  KEY `record_id` (`record_id`),
  KEY `ix_c_attribute_histories_ci_id` (`ci_id`),
  KEY `ix_c_attribute_histories_deleted` (`deleted`),
  KEY `ix_c_attribute_histories_attr_id` (`attr_id`),
  CONSTRAINT `c_attribute_histories_ibfk_1` FOREIGN KEY (`record_id`) REFERENCES `c_records` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14418 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_attribute_histories`
--

LOCK TABLES `c_attribute_histories` WRITE;
/*!40000 ALTER TABLE `c_attribute_histories` DISABLE KEYS */;
INSERT INTO `c_attribute_histories` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,1,'0',1,53,1,NULL,'XXXXXX事业部1'),(NULL,0,'2019-11-29 22:12:14',NULL,2,'0',2,54,3,NULL,'产品线1-1'),(NULL,0,'2019-11-29 22:12:14',NULL,3,'0',4,55,4,NULL,'App1-1-1'),(NULL,0,'2019-11-29 22:12:14',NULL,4,'0',6,56,16,NULL,'cmdb1-1-1-1'),(NULL,0,'2019-11-29 22:12:14',NULL,5,'0',7,56,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:14',NULL,6,'0',8,56,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:15',NULL,7,'0',9,56,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,8,'0',10,56,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,9,'0',11,56,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:15',NULL,10,'0',12,56,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,11,'0',13,56,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:15',NULL,12,'0',14,56,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,13,'0',15,56,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,14,'0',16,56,15,NULL,'10.1.1.1'),(NULL,0,'2019-11-29 22:12:15',NULL,15,'0',17,56,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,16,'0',18,56,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,17,'0',19,56,5,NULL,'e0e2de4550164ffd8e8e0a5e9d93143a'),(NULL,0,'2019-11-29 22:12:15',NULL,18,'0',20,56,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:15',NULL,19,'0',22,57,16,NULL,'cmdb1-1-1-2'),(NULL,0,'2019-11-29 22:12:15',NULL,20,'0',23,57,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,21,'0',24,57,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:15',NULL,22,'0',25,57,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,23,'0',26,57,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,24,'0',27,57,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:15',NULL,25,'0',28,57,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,26,'0',29,57,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:15',NULL,27,'0',30,57,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,28,'0',31,57,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,29,'0',32,57,15,NULL,'10.1.1.2'),(NULL,0,'2019-11-29 22:12:15',NULL,30,'0',33,57,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,31,'0',34,57,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,32,'0',35,57,5,NULL,'135709447098441fa1e002688f271125'),(NULL,0,'2019-11-29 22:12:15',NULL,33,'0',36,57,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:15',NULL,34,'0',38,58,16,NULL,'cmdb1-1-1-3'),(NULL,0,'2019-11-29 22:12:15',NULL,35,'0',39,58,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,36,'0',40,58,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:15',NULL,37,'0',41,58,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,38,'0',42,58,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,39,'0',43,58,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:15',NULL,40,'0',44,58,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,41,'0',45,58,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:15',NULL,42,'0',46,58,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,43,'0',47,58,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,44,'0',48,58,15,NULL,'10.1.1.3'),(NULL,0,'2019-11-29 22:12:15',NULL,45,'0',49,58,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,46,'0',50,58,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,47,'0',51,58,5,NULL,'1b64e1e09d5a414aa4bb523662161cb1'),(NULL,0,'2019-11-29 22:12:15',NULL,48,'0',52,58,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:15',NULL,49,'0',54,59,16,NULL,'cmdb1-1-1-4'),(NULL,0,'2019-11-29 22:12:15',NULL,50,'0',55,59,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,51,'0',56,59,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:15',NULL,52,'0',57,59,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,53,'0',58,59,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,54,'0',59,59,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:15',NULL,55,'0',60,59,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,56,'0',61,59,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:15',NULL,57,'0',62,59,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,58,'0',63,59,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,59,'0',64,59,15,NULL,'10.1.1.4'),(NULL,0,'2019-11-29 22:12:15',NULL,60,'0',65,59,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,61,'0',66,59,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,62,'0',67,59,5,NULL,'ba95232e7a0548d3b1ddf97992025a81'),(NULL,0,'2019-11-29 22:12:15',NULL,63,'0',68,59,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:15',NULL,64,'0',70,60,16,NULL,'cmdb1-1-1-5'),(NULL,0,'2019-11-29 22:12:15',NULL,65,'0',71,60,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,66,'0',72,60,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:15',NULL,67,'0',73,60,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,68,'0',74,60,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,69,'0',75,60,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:16',NULL,70,'0',76,60,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,71,'0',77,60,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:16',NULL,72,'0',78,60,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,73,'0',79,60,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,74,'0',80,60,15,NULL,'10.1.1.5'),(NULL,0,'2019-11-29 22:12:16',NULL,75,'0',81,60,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,76,'0',82,60,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,77,'0',83,60,5,NULL,'ca3ce54d669441bba11691f60fba6f18'),(NULL,0,'2019-11-29 22:12:16',NULL,78,'0',84,60,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:16',NULL,79,'0',86,61,16,NULL,'cmdb1-1-1-6'),(NULL,0,'2019-11-29 22:12:16',NULL,80,'0',87,61,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,81,'0',88,61,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:16',NULL,82,'0',89,61,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,83,'0',90,61,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,84,'0',91,61,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:16',NULL,85,'0',92,61,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,86,'0',93,61,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:16',NULL,87,'0',94,61,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,88,'0',95,61,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,89,'0',96,61,15,NULL,'10.1.1.6'),(NULL,0,'2019-11-29 22:12:16',NULL,90,'0',97,61,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,91,'0',98,61,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,92,'0',99,61,5,NULL,'ff775e7d32ea48c28eddc138c789d1f5'),(NULL,0,'2019-11-29 22:12:16',NULL,93,'0',100,61,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:16',NULL,94,'0',102,62,16,NULL,'cmdb1-1-1-7'),(NULL,0,'2019-11-29 22:12:16',NULL,95,'0',103,62,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,96,'0',104,62,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:16',NULL,97,'0',105,62,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,98,'0',106,62,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,99,'0',107,62,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:16',NULL,100,'0',108,62,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,101,'0',109,62,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:16',NULL,102,'0',110,62,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,103,'0',111,62,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,104,'0',112,62,15,NULL,'10.1.1.7'),(NULL,0,'2019-11-29 22:12:16',NULL,105,'0',113,62,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,106,'0',114,62,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,107,'0',115,62,5,NULL,'aa7e9b6e6bc64d829ba514a551aa85b0'),(NULL,0,'2019-11-29 22:12:16',NULL,108,'0',116,62,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:16',NULL,109,'0',118,63,16,NULL,'cmdb1-1-1-8'),(NULL,0,'2019-11-29 22:12:16',NULL,110,'0',119,63,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,111,'0',120,63,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:16',NULL,112,'0',121,63,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,113,'0',122,63,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,114,'0',123,63,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:16',NULL,115,'0',124,63,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,116,'0',125,63,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:16',NULL,117,'0',126,63,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,118,'0',127,63,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,119,'0',128,63,15,NULL,'10.1.1.8'),(NULL,0,'2019-11-29 22:12:16',NULL,120,'0',129,63,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,121,'0',130,63,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,122,'0',131,63,5,NULL,'353684a6f1fe406da1713f9e357a7ed1'),(NULL,0,'2019-11-29 22:12:16',NULL,123,'0',132,63,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:16',NULL,124,'0',134,64,16,NULL,'cmdb1-1-1-9'),(NULL,0,'2019-11-29 22:12:16',NULL,125,'0',135,64,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,126,'0',136,64,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:16',NULL,127,'0',137,64,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,128,'0',138,64,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,129,'0',139,64,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:16',NULL,130,'0',140,64,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,131,'0',141,64,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:16',NULL,132,'0',142,64,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,133,'0',143,64,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,134,'0',144,64,15,NULL,'10.1.1.9'),(NULL,0,'2019-11-29 22:12:16',NULL,135,'0',145,64,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,136,'0',146,64,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,137,'0',147,64,5,NULL,'f522f5ba167f4dccbaaed0b4ecd19a1e'),(NULL,0,'2019-11-29 22:12:17',NULL,138,'0',148,64,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:17',NULL,139,'0',150,65,16,NULL,'cmdb1-1-1-10'),(NULL,0,'2019-11-29 22:12:17',NULL,140,'0',151,65,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,141,'0',152,65,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:17',NULL,142,'0',153,65,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,143,'0',154,65,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,144,'0',155,65,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:17',NULL,145,'0',156,65,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,146,'0',157,65,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:17',NULL,147,'0',158,65,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,148,'0',159,65,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,149,'0',160,65,15,NULL,'10.1.1.10'),(NULL,0,'2019-11-29 22:12:17',NULL,150,'0',161,65,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,151,'0',162,65,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,152,'0',163,65,5,NULL,'4234b45efeda416e8886e97844142f35'),(NULL,0,'2019-11-29 22:12:17',NULL,153,'0',164,65,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:17',NULL,154,'0',166,66,16,NULL,'cmdb1-1-1-11'),(NULL,0,'2019-11-29 22:12:17',NULL,155,'0',167,66,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,156,'0',168,66,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:17',NULL,157,'0',169,66,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,158,'0',170,66,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,159,'0',171,66,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:17',NULL,160,'0',172,66,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,161,'0',173,66,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:17',NULL,162,'0',174,66,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,163,'0',175,66,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,164,'0',176,66,15,NULL,'10.1.1.11'),(NULL,0,'2019-11-29 22:12:17',NULL,165,'0',177,66,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,166,'0',178,66,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,167,'0',179,66,5,NULL,'3575873b2aaa45c9bb0ab14e514eef17'),(NULL,0,'2019-11-29 22:12:17',NULL,168,'0',180,66,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:17',NULL,169,'0',182,67,16,NULL,'cmdb1-1-1-12'),(NULL,0,'2019-11-29 22:12:17',NULL,170,'0',183,67,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,171,'0',184,67,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:17',NULL,172,'0',185,67,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,173,'0',186,67,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,174,'0',187,67,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:17',NULL,175,'0',188,67,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,176,'0',189,67,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:17',NULL,177,'0',190,67,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,178,'0',191,67,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,179,'0',192,67,15,NULL,'10.1.1.12'),(NULL,0,'2019-11-29 22:12:17',NULL,180,'0',193,67,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,181,'0',194,67,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,182,'0',195,67,5,NULL,'db36a13391f540318849cb9d300ebf80'),(NULL,0,'2019-11-29 22:12:17',NULL,183,'0',196,67,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:17',NULL,184,'0',198,68,16,NULL,'cmdb1-1-1-13'),(NULL,0,'2019-11-29 22:12:17',NULL,185,'0',199,68,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,186,'0',200,68,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:17',NULL,187,'0',201,68,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,188,'0',202,68,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,189,'0',203,68,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:17',NULL,190,'0',204,68,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,191,'0',205,68,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:17',NULL,192,'0',206,68,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,193,'0',207,68,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,194,'0',208,68,15,NULL,'10.1.1.13'),(NULL,0,'2019-11-29 22:12:17',NULL,195,'0',209,68,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,196,'0',210,68,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,197,'0',211,68,5,NULL,'5ce2b965cff74ab2b09bb3bb6e50011e'),(NULL,0,'2019-11-29 22:12:17',NULL,198,'0',212,68,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:17',NULL,199,'0',214,69,16,NULL,'cmdb1-1-1-14'),(NULL,0,'2019-11-29 22:12:18',NULL,200,'0',215,69,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,201,'0',216,69,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:18',NULL,202,'0',217,69,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,203,'0',218,69,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,204,'0',219,69,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:18',NULL,205,'0',220,69,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,206,'0',221,69,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:18',NULL,207,'0',222,69,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,208,'0',223,69,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,209,'0',224,69,15,NULL,'10.1.1.14'),(NULL,0,'2019-11-29 22:12:18',NULL,210,'0',225,69,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,211,'0',226,69,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,212,'0',227,69,5,NULL,'3dcef8bc56e9441dbec5aa8cbcafa1a6'),(NULL,0,'2019-11-29 22:12:18',NULL,213,'0',228,69,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:18',NULL,214,'0',230,70,16,NULL,'cmdb1-1-1-15'),(NULL,0,'2019-11-29 22:12:18',NULL,215,'0',231,70,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,216,'0',232,70,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:18',NULL,217,'0',233,70,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,218,'0',234,70,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,219,'0',235,70,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:18',NULL,220,'0',236,70,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,221,'0',237,70,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:18',NULL,222,'0',238,70,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,223,'0',239,70,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,224,'0',240,70,15,NULL,'10.1.1.15'),(NULL,0,'2019-11-29 22:12:18',NULL,225,'0',241,70,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,226,'0',242,70,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,227,'0',243,70,5,NULL,'9abcc9da6f7b4eeb907cd8935c92c0f4'),(NULL,0,'2019-11-29 22:12:18',NULL,228,'0',244,70,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:18',NULL,229,'0',246,71,16,NULL,'cmdb1-1-1-16'),(NULL,0,'2019-11-29 22:12:18',NULL,230,'0',247,71,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,231,'0',248,71,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:18',NULL,232,'0',249,71,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,233,'0',250,71,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,234,'0',251,71,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:18',NULL,235,'0',252,71,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,236,'0',253,71,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:18',NULL,237,'0',254,71,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,238,'0',255,71,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,239,'0',256,71,15,NULL,'10.1.1.16'),(NULL,0,'2019-11-29 22:12:18',NULL,240,'0',257,71,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,241,'0',258,71,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,242,'0',259,71,5,NULL,'18bb99daaab64863be1eac53dcaaa8f8'),(NULL,0,'2019-11-29 22:12:18',NULL,243,'0',260,71,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:18',NULL,244,'0',262,72,4,NULL,'App1-1-2'),(NULL,0,'2019-11-29 22:12:18',NULL,245,'0',264,73,16,NULL,'cmdb1-1-2-1'),(NULL,0,'2019-11-29 22:12:18',NULL,246,'0',265,73,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,247,'0',266,73,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:18',NULL,248,'0',267,73,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,249,'0',268,73,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,250,'0',269,73,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:18',NULL,251,'0',270,73,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,252,'0',271,73,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:18',NULL,253,'0',272,73,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,254,'0',273,73,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,255,'0',274,73,15,NULL,'10.1.2.1'),(NULL,0,'2019-11-29 22:12:18',NULL,256,'0',275,73,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,257,'0',276,73,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,258,'0',277,73,5,NULL,'239fc3502444440d84937b089b864380'),(NULL,0,'2019-11-29 22:12:18',NULL,259,'0',278,73,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:19',NULL,260,'0',280,74,16,NULL,'cmdb1-1-2-2'),(NULL,0,'2019-11-29 22:12:19',NULL,261,'0',281,74,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,262,'0',282,74,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:19',NULL,263,'0',283,74,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,264,'0',284,74,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,265,'0',285,74,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:19',NULL,266,'0',286,74,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,267,'0',287,74,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:19',NULL,268,'0',288,74,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,269,'0',289,74,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,270,'0',290,74,15,NULL,'10.1.2.2'),(NULL,0,'2019-11-29 22:12:19',NULL,271,'0',291,74,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,272,'0',292,74,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,273,'0',293,74,5,NULL,'5d1a52bbb8714a72978eeef79b5508e4'),(NULL,0,'2019-11-29 22:12:19',NULL,274,'0',294,74,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:19',NULL,275,'0',296,75,16,NULL,'cmdb1-1-2-3'),(NULL,0,'2019-11-29 22:12:19',NULL,276,'0',297,75,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,277,'0',298,75,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:19',NULL,278,'0',299,75,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,279,'0',300,75,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,280,'0',301,75,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:19',NULL,281,'0',302,75,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,282,'0',303,75,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:19',NULL,283,'0',304,75,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,284,'0',305,75,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,285,'0',306,75,15,NULL,'10.1.2.3'),(NULL,0,'2019-11-29 22:12:19',NULL,286,'0',307,75,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,287,'0',308,75,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,288,'0',309,75,5,NULL,'0c1340ce25cf4817a3bf5db3a1373315'),(NULL,0,'2019-11-29 22:12:19',NULL,289,'0',310,75,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:19',NULL,290,'0',312,76,16,NULL,'cmdb1-1-2-4'),(NULL,0,'2019-11-29 22:12:19',NULL,291,'0',313,76,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,292,'0',314,76,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:19',NULL,293,'0',315,76,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,294,'0',316,76,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,295,'0',317,76,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:19',NULL,296,'0',318,76,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,297,'0',319,76,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:19',NULL,298,'0',320,76,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,299,'0',321,76,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,300,'0',322,76,15,NULL,'10.1.2.4'),(NULL,0,'2019-11-29 22:12:19',NULL,301,'0',323,76,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,302,'0',324,76,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,303,'0',325,76,5,NULL,'d6e35c79c2d84aec81aa8dc59c52e48f'),(NULL,0,'2019-11-29 22:12:19',NULL,304,'0',326,76,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:19',NULL,305,'0',328,77,16,NULL,'cmdb1-1-2-5'),(NULL,0,'2019-11-29 22:12:19',NULL,306,'0',329,77,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,307,'0',330,77,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:19',NULL,308,'0',331,77,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,309,'0',332,77,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,310,'0',333,77,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:19',NULL,311,'0',334,77,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,312,'0',335,77,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:19',NULL,313,'0',336,77,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,314,'0',337,77,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,315,'0',338,77,15,NULL,'10.1.2.5'),(NULL,0,'2019-11-29 22:12:19',NULL,316,'0',339,77,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,317,'0',340,77,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,318,'0',341,77,5,NULL,'f8d04a04737c44ccbbedb49acaa71d2f'),(NULL,0,'2019-11-29 22:12:19',NULL,319,'0',342,77,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:19',NULL,320,'0',344,78,16,NULL,'cmdb1-1-2-6'),(NULL,0,'2019-11-29 22:12:19',NULL,321,'0',345,78,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,322,'0',346,78,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:19',NULL,323,'0',347,78,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,324,'0',348,78,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,325,'0',349,78,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:20',NULL,326,'0',350,78,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,327,'0',351,78,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:20',NULL,328,'0',352,78,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,329,'0',353,78,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,330,'0',354,78,15,NULL,'10.1.2.6'),(NULL,0,'2019-11-29 22:12:20',NULL,331,'0',355,78,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,332,'0',356,78,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,333,'0',357,78,5,NULL,'a8911eff0b0949648f0fa298c0b310d2'),(NULL,0,'2019-11-29 22:12:20',NULL,334,'0',358,78,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:20',NULL,335,'0',360,79,16,NULL,'cmdb1-1-2-7'),(NULL,0,'2019-11-29 22:12:20',NULL,336,'0',361,79,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,337,'0',362,79,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:20',NULL,338,'0',363,79,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,339,'0',364,79,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,340,'0',365,79,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:20',NULL,341,'0',366,79,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,342,'0',367,79,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:20',NULL,343,'0',368,79,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,344,'0',369,79,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,345,'0',370,79,15,NULL,'10.1.2.7'),(NULL,0,'2019-11-29 22:12:20',NULL,346,'0',371,79,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,347,'0',372,79,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,348,'0',373,79,5,NULL,'3b7d27e1f4944012a8ba823e6f1a0431'),(NULL,0,'2019-11-29 22:12:20',NULL,349,'0',374,79,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:20',NULL,350,'0',376,80,16,NULL,'cmdb1-1-2-8'),(NULL,0,'2019-11-29 22:12:20',NULL,351,'0',377,80,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,352,'0',378,80,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:20',NULL,353,'0',379,80,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,354,'0',380,80,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,355,'0',381,80,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:20',NULL,356,'0',382,80,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,357,'0',383,80,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:20',NULL,358,'0',384,80,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,359,'0',385,80,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,360,'0',386,80,15,NULL,'10.1.2.8'),(NULL,0,'2019-11-29 22:12:20',NULL,361,'0',387,80,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,362,'0',388,80,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,363,'0',389,80,5,NULL,'1635073bb8c54cfcbda05bee97dd3e9b'),(NULL,0,'2019-11-29 22:12:20',NULL,364,'0',390,80,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:20',NULL,365,'0',392,81,16,NULL,'cmdb1-1-2-9'),(NULL,0,'2019-11-29 22:12:20',NULL,366,'0',393,81,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,367,'0',394,81,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:20',NULL,368,'0',395,81,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,369,'0',396,81,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,370,'0',397,81,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:20',NULL,371,'0',398,81,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,372,'0',399,81,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:20',NULL,373,'0',400,81,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,374,'0',401,81,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,375,'0',402,81,15,NULL,'10.1.2.9'),(NULL,0,'2019-11-29 22:12:20',NULL,376,'0',403,81,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,377,'0',404,81,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,378,'0',405,81,5,NULL,'bf196f5716084a77b28212cda7292119'),(NULL,0,'2019-11-29 22:12:20',NULL,379,'0',406,81,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:20',NULL,380,'0',408,82,16,NULL,'cmdb1-1-2-10'),(NULL,0,'2019-11-29 22:12:20',NULL,381,'0',409,82,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,382,'0',410,82,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:20',NULL,383,'0',411,82,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,384,'0',412,82,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,385,'0',413,82,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:20',NULL,386,'0',414,82,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,387,'0',415,82,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:20',NULL,388,'0',416,82,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,389,'0',417,82,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,390,'0',418,82,15,NULL,'10.1.2.10'),(NULL,0,'2019-11-29 22:12:21',NULL,391,'0',419,82,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,392,'0',420,82,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,393,'0',421,82,5,NULL,'122b6bad5438493dab32ff11140bcd43'),(NULL,0,'2019-11-29 22:12:21',NULL,394,'0',422,82,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:21',NULL,395,'0',424,83,16,NULL,'cmdb1-1-2-11'),(NULL,0,'2019-11-29 22:12:21',NULL,396,'0',425,83,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,397,'0',426,83,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:21',NULL,398,'0',427,83,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,399,'0',428,83,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,400,'0',429,83,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:21',NULL,401,'0',430,83,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,402,'0',431,83,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:21',NULL,403,'0',432,83,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,404,'0',433,83,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,405,'0',434,83,15,NULL,'10.1.2.11'),(NULL,0,'2019-11-29 22:12:21',NULL,406,'0',435,83,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,407,'0',436,83,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,408,'0',437,83,5,NULL,'8ca08fa7aed34d368ffe461a9367968d'),(NULL,0,'2019-11-29 22:12:21',NULL,409,'0',438,83,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:21',NULL,410,'0',440,84,16,NULL,'cmdb1-1-2-12'),(NULL,0,'2019-11-29 22:12:21',NULL,411,'0',441,84,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,412,'0',442,84,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:21',NULL,413,'0',443,84,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,414,'0',444,84,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,415,'0',445,84,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:21',NULL,416,'0',446,84,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,417,'0',447,84,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:21',NULL,418,'0',448,84,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,419,'0',449,84,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,420,'0',450,84,15,NULL,'10.1.2.12'),(NULL,0,'2019-11-29 22:12:21',NULL,421,'0',451,84,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,422,'0',452,84,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,423,'0',453,84,5,NULL,'db52739533a14bafa3026ccb6379ffb4'),(NULL,0,'2019-11-29 22:12:21',NULL,424,'0',454,84,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:21',NULL,425,'0',456,85,16,NULL,'cmdb1-1-2-13'),(NULL,0,'2019-11-29 22:12:21',NULL,426,'0',457,85,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,427,'0',458,85,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:21',NULL,428,'0',459,85,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,429,'0',460,85,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,430,'0',461,85,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:21',NULL,431,'0',462,85,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,432,'0',463,85,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:21',NULL,433,'0',464,85,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,434,'0',465,85,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,435,'0',466,85,15,NULL,'10.1.2.13'),(NULL,0,'2019-11-29 22:12:21',NULL,436,'0',467,85,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,437,'0',468,85,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,438,'0',469,85,5,NULL,'eb3020709bd0494d9ef02db001e69b15'),(NULL,0,'2019-11-29 22:12:21',NULL,439,'0',470,85,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:21',NULL,440,'0',472,86,16,NULL,'cmdb1-1-2-14'),(NULL,0,'2019-11-29 22:12:21',NULL,441,'0',473,86,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,442,'0',474,86,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:21',NULL,443,'0',475,86,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,444,'0',476,86,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,445,'0',477,86,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:21',NULL,446,'0',478,86,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,447,'0',479,86,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:21',NULL,448,'0',480,86,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,449,'0',481,86,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,450,'0',482,86,15,NULL,'10.1.2.14'),(NULL,0,'2019-11-29 22:12:22',NULL,451,'0',483,86,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,452,'0',484,86,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,453,'0',485,86,5,NULL,'47936f6996af4a7482300c786000b27f'),(NULL,0,'2019-11-29 22:12:22',NULL,454,'0',486,86,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:22',NULL,455,'0',488,87,16,NULL,'cmdb1-1-2-15'),(NULL,0,'2019-11-29 22:12:22',NULL,456,'0',489,87,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,457,'0',490,87,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:22',NULL,458,'0',491,87,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,459,'0',492,87,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,460,'0',493,87,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:22',NULL,461,'0',494,87,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,462,'0',495,87,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:22',NULL,463,'0',496,87,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,464,'0',497,87,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,465,'0',498,87,15,NULL,'10.1.2.15'),(NULL,0,'2019-11-29 22:12:22',NULL,466,'0',499,87,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,467,'0',500,87,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,468,'0',501,87,5,NULL,'276165379af3447aa5049104ec4ca6c2'),(NULL,0,'2019-11-29 22:12:22',NULL,469,'0',502,87,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:22',NULL,470,'0',504,88,16,NULL,'cmdb1-1-2-16'),(NULL,0,'2019-11-29 22:12:22',NULL,471,'0',505,88,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,472,'0',506,88,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:22',NULL,473,'0',507,88,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,474,'0',508,88,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,475,'0',509,88,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:22',NULL,476,'0',510,88,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,477,'0',511,88,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:22',NULL,478,'0',512,88,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,479,'0',513,88,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,480,'0',514,88,15,NULL,'10.1.2.16'),(NULL,0,'2019-11-29 22:12:22',NULL,481,'0',515,88,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,482,'0',516,88,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,483,'0',517,88,5,NULL,'16c1bc4061404873bfac0ec788ff5743'),(NULL,0,'2019-11-29 22:12:22',NULL,484,'0',518,88,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:22',NULL,485,'0',520,89,4,NULL,'App1-1-3'),(NULL,0,'2019-11-29 22:12:22',NULL,486,'0',522,90,16,NULL,'cmdb1-1-3-1'),(NULL,0,'2019-11-29 22:12:22',NULL,487,'0',523,90,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,488,'0',524,90,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:22',NULL,489,'0',525,90,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,490,'0',526,90,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,491,'0',527,90,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:22',NULL,492,'0',528,90,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,493,'0',529,90,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:22',NULL,494,'0',530,90,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,495,'0',531,90,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,496,'0',532,90,15,NULL,'10.1.3.1'),(NULL,0,'2019-11-29 22:12:22',NULL,497,'0',533,90,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,498,'0',534,90,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,499,'0',535,90,5,NULL,'e938bb89ea8540ce8399f1b4291d653b'),(NULL,0,'2019-11-29 22:12:22',NULL,500,'0',536,90,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:22',NULL,501,'0',538,91,16,NULL,'cmdb1-1-3-2'),(NULL,0,'2019-11-29 22:12:22',NULL,502,'0',539,91,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,503,'0',540,91,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:22',NULL,504,'0',541,91,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,505,'0',542,91,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,506,'0',543,91,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:22',NULL,507,'0',544,91,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,508,'0',545,91,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:23',NULL,509,'0',546,91,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,510,'0',547,91,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,511,'0',548,91,15,NULL,'10.1.3.2'),(NULL,0,'2019-11-29 22:12:23',NULL,512,'0',549,91,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,513,'0',550,91,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,514,'0',551,91,5,NULL,'ab170301858f4e749c87f4b3e493e010'),(NULL,0,'2019-11-29 22:12:23',NULL,515,'0',552,91,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:23',NULL,516,'0',554,92,16,NULL,'cmdb1-1-3-3'),(NULL,0,'2019-11-29 22:12:23',NULL,517,'0',555,92,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,518,'0',556,92,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:23',NULL,519,'0',557,92,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,520,'0',558,92,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,521,'0',559,92,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:23',NULL,522,'0',560,92,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,523,'0',561,92,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:23',NULL,524,'0',562,92,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,525,'0',563,92,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,526,'0',564,92,15,NULL,'10.1.3.3'),(NULL,0,'2019-11-29 22:12:23',NULL,527,'0',565,92,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,528,'0',566,92,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,529,'0',567,92,5,NULL,'f2654b9365a94cf28de26a36aeba4517'),(NULL,0,'2019-11-29 22:12:23',NULL,530,'0',568,92,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:23',NULL,531,'0',570,93,16,NULL,'cmdb1-1-3-4'),(NULL,0,'2019-11-29 22:12:23',NULL,532,'0',571,93,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,533,'0',572,93,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:23',NULL,534,'0',573,93,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,535,'0',574,93,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,536,'0',575,93,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:23',NULL,537,'0',576,93,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,538,'0',577,93,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:23',NULL,539,'0',578,93,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,540,'0',579,93,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,541,'0',580,93,15,NULL,'10.1.3.4'),(NULL,0,'2019-11-29 22:12:23',NULL,542,'0',581,93,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,543,'0',582,93,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,544,'0',583,93,5,NULL,'b15448f0309a423a941ba34b1ea6ee52'),(NULL,0,'2019-11-29 22:12:23',NULL,545,'0',584,93,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:23',NULL,546,'0',586,94,16,NULL,'cmdb1-1-3-5'),(NULL,0,'2019-11-29 22:12:23',NULL,547,'0',587,94,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,548,'0',588,94,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:23',NULL,549,'0',589,94,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,550,'0',590,94,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,551,'0',591,94,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:23',NULL,552,'0',592,94,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,553,'0',593,94,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:23',NULL,554,'0',594,94,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,555,'0',595,94,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,556,'0',596,94,15,NULL,'10.1.3.5'),(NULL,0,'2019-11-29 22:12:23',NULL,557,'0',597,94,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,558,'0',598,94,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,559,'0',599,94,5,NULL,'f9da1eb4ecb64a79a575c132985dca6c'),(NULL,0,'2019-11-29 22:12:23',NULL,560,'0',600,94,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:23',NULL,561,'0',602,95,16,NULL,'cmdb1-1-3-6'),(NULL,0,'2019-11-29 22:12:23',NULL,562,'0',603,95,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,563,'0',604,95,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:23',NULL,564,'0',605,95,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,565,'0',606,95,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,566,'0',607,95,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:23',NULL,567,'0',608,95,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,568,'0',609,95,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:23',NULL,569,'0',610,95,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,570,'0',611,95,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,571,'0',612,95,15,NULL,'10.1.3.6'),(NULL,0,'2019-11-29 22:12:23',NULL,572,'0',613,95,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,573,'0',614,95,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,574,'0',615,95,5,NULL,'871a00bcc2684f679ef010ff94a04084'),(NULL,0,'2019-11-29 22:12:24',NULL,575,'0',616,95,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:24',NULL,576,'0',618,96,16,NULL,'cmdb1-1-3-7'),(NULL,0,'2019-11-29 22:12:24',NULL,577,'0',619,96,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,578,'0',620,96,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:24',NULL,579,'0',621,96,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,580,'0',622,96,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,581,'0',623,96,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:24',NULL,582,'0',624,96,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,583,'0',625,96,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:24',NULL,584,'0',626,96,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,585,'0',627,96,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,586,'0',628,96,15,NULL,'10.1.3.7'),(NULL,0,'2019-11-29 22:12:24',NULL,587,'0',629,96,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,588,'0',630,96,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,589,'0',631,96,5,NULL,'cdc790dc6bd048d8b86626fa0220a499'),(NULL,0,'2019-11-29 22:12:24',NULL,590,'0',632,96,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:24',NULL,591,'0',634,97,16,NULL,'cmdb1-1-3-8'),(NULL,0,'2019-11-29 22:12:24',NULL,592,'0',635,97,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,593,'0',636,97,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:24',NULL,594,'0',637,97,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,595,'0',638,97,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,596,'0',639,97,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:24',NULL,597,'0',640,97,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,598,'0',641,97,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:24',NULL,599,'0',642,97,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,600,'0',643,97,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,601,'0',644,97,15,NULL,'10.1.3.8'),(NULL,0,'2019-11-29 22:12:24',NULL,602,'0',645,97,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,603,'0',646,97,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,604,'0',647,97,5,NULL,'5600072aea9d40bcb640c3e0e6d4e6f4'),(NULL,0,'2019-11-29 22:12:24',NULL,605,'0',648,97,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:24',NULL,606,'0',650,98,16,NULL,'cmdb1-1-3-9'),(NULL,0,'2019-11-29 22:12:24',NULL,607,'0',651,98,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,608,'0',652,98,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:24',NULL,609,'0',653,98,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,610,'0',654,98,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,611,'0',655,98,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:24',NULL,612,'0',656,98,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,613,'0',657,98,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:24',NULL,614,'0',658,98,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,615,'0',659,98,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,616,'0',660,98,15,NULL,'10.1.3.9'),(NULL,0,'2019-11-29 22:12:24',NULL,617,'0',661,98,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,618,'0',662,98,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,619,'0',663,98,5,NULL,'7d0f7edbbf804646a6d596ca8d85f79e'),(NULL,0,'2019-11-29 22:12:24',NULL,620,'0',664,98,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:24',NULL,621,'0',666,99,16,NULL,'cmdb1-1-3-10'),(NULL,0,'2019-11-29 22:12:24',NULL,622,'0',667,99,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,623,'0',668,99,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:24',NULL,624,'0',669,99,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,625,'0',670,99,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,626,'0',671,99,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:24',NULL,627,'0',672,99,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,628,'0',673,99,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:24',NULL,629,'0',674,99,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,630,'0',675,99,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,631,'0',676,99,15,NULL,'10.1.3.10'),(NULL,0,'2019-11-29 22:12:24',NULL,632,'0',677,99,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,633,'0',678,99,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,634,'0',679,99,5,NULL,'d052d2f48dd04b738045c780cf65a1f5'),(NULL,0,'2019-11-29 22:12:24',NULL,635,'0',680,99,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:25',NULL,636,'0',682,100,16,NULL,'cmdb1-1-3-11'),(NULL,0,'2019-11-29 22:12:25',NULL,637,'0',683,100,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,638,'0',684,100,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:25',NULL,639,'0',685,100,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,640,'0',686,100,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,641,'0',687,100,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:25',NULL,642,'0',688,100,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,643,'0',689,100,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:25',NULL,644,'0',690,100,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,645,'0',691,100,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,646,'0',692,100,15,NULL,'10.1.3.11'),(NULL,0,'2019-11-29 22:12:25',NULL,647,'0',693,100,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,648,'0',694,100,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,649,'0',695,100,5,NULL,'7416b86efe78466ca45e87ef384d5651'),(NULL,0,'2019-11-29 22:12:25',NULL,650,'0',696,100,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:25',NULL,651,'0',698,101,16,NULL,'cmdb1-1-3-12'),(NULL,0,'2019-11-29 22:12:25',NULL,652,'0',699,101,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,653,'0',700,101,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:25',NULL,654,'0',701,101,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,655,'0',702,101,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,656,'0',703,101,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:25',NULL,657,'0',704,101,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,658,'0',705,101,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:25',NULL,659,'0',706,101,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,660,'0',707,101,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,661,'0',708,101,15,NULL,'10.1.3.12'),(NULL,0,'2019-11-29 22:12:25',NULL,662,'0',709,101,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,663,'0',710,101,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,664,'0',711,101,5,NULL,'611605f1335f419286cd3bf644dee0b8'),(NULL,0,'2019-11-29 22:12:25',NULL,665,'0',712,101,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:25',NULL,666,'0',714,102,16,NULL,'cmdb1-1-3-13'),(NULL,0,'2019-11-29 22:12:25',NULL,667,'0',715,102,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,668,'0',716,102,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:25',NULL,669,'0',717,102,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,670,'0',718,102,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,671,'0',719,102,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:25',NULL,672,'0',720,102,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,673,'0',721,102,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:25',NULL,674,'0',722,102,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,675,'0',723,102,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,676,'0',724,102,15,NULL,'10.1.3.13'),(NULL,0,'2019-11-29 22:12:25',NULL,677,'0',725,102,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,678,'0',726,102,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,679,'0',727,102,5,NULL,'cbb4a8b7fcd5439881b46a530e39a5b5'),(NULL,0,'2019-11-29 22:12:25',NULL,680,'0',728,102,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:25',NULL,681,'0',730,103,16,NULL,'cmdb1-1-3-14'),(NULL,0,'2019-11-29 22:12:25',NULL,682,'0',731,103,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,683,'0',732,103,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:25',NULL,684,'0',733,103,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,685,'0',734,103,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,686,'0',735,103,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:25',NULL,687,'0',736,103,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,688,'0',737,103,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:25',NULL,689,'0',738,103,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,690,'0',739,103,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,691,'0',740,103,15,NULL,'10.1.3.14'),(NULL,0,'2019-11-29 22:12:25',NULL,692,'0',741,103,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,693,'0',742,103,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,694,'0',743,103,5,NULL,'cd90cb4f28cb4dcea853f3688c00204b'),(NULL,0,'2019-11-29 22:12:25',NULL,695,'0',744,103,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:25',NULL,696,'0',746,104,16,NULL,'cmdb1-1-3-15'),(NULL,0,'2019-11-29 22:12:25',NULL,697,'0',747,104,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,698,'0',748,104,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:26',NULL,699,'0',749,104,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,700,'0',750,104,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,701,'0',751,104,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:26',NULL,702,'0',752,104,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,703,'0',753,104,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:26',NULL,704,'0',754,104,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,705,'0',755,104,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,706,'0',756,104,15,NULL,'10.1.3.15'),(NULL,0,'2019-11-29 22:12:26',NULL,707,'0',757,104,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,708,'0',758,104,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,709,'0',759,104,5,NULL,'c16cdceccb424460ae7be842fd6b47f7'),(NULL,0,'2019-11-29 22:12:26',NULL,710,'0',760,104,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:26',NULL,711,'0',762,105,16,NULL,'cmdb1-1-3-16'),(NULL,0,'2019-11-29 22:12:26',NULL,712,'0',763,105,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,713,'0',764,105,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:26',NULL,714,'0',765,105,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,715,'0',766,105,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,716,'0',767,105,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:26',NULL,717,'0',768,105,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,718,'0',769,105,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:26',NULL,719,'0',770,105,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,720,'0',771,105,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,721,'0',772,105,15,NULL,'10.1.3.16'),(NULL,0,'2019-11-29 22:12:26',NULL,722,'0',773,105,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,723,'0',774,105,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,724,'0',775,105,5,NULL,'eda837f02ab34f78bb15b3af29b6eef2'),(NULL,0,'2019-11-29 22:12:26',NULL,725,'0',776,105,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:26',NULL,726,'0',778,106,4,NULL,'App1-1-4'),(NULL,0,'2019-11-29 22:12:26',NULL,727,'0',780,107,16,NULL,'cmdb1-1-4-1'),(NULL,0,'2019-11-29 22:12:26',NULL,728,'0',781,107,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,729,'0',782,107,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:26',NULL,730,'0',783,107,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,731,'0',784,107,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,732,'0',785,107,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:26',NULL,733,'0',786,107,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,734,'0',787,107,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:26',NULL,735,'0',788,107,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,736,'0',789,107,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,737,'0',790,107,15,NULL,'10.1.4.1'),(NULL,0,'2019-11-29 22:12:26',NULL,738,'0',791,107,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,739,'0',792,107,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,740,'0',793,107,5,NULL,'7aa64345966d47329e5c3addcd9725d6'),(NULL,0,'2019-11-29 22:12:26',NULL,741,'0',794,107,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:26',NULL,742,'0',796,108,16,NULL,'cmdb1-1-4-2'),(NULL,0,'2019-11-29 22:12:26',NULL,743,'0',797,108,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,744,'0',798,108,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:26',NULL,745,'0',799,108,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,746,'0',800,108,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,747,'0',801,108,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:26',NULL,748,'0',802,108,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,749,'0',803,108,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:26',NULL,750,'0',804,108,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,751,'0',805,108,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,752,'0',806,108,15,NULL,'10.1.4.2'),(NULL,0,'2019-11-29 22:12:26',NULL,753,'0',807,108,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,754,'0',808,108,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,755,'0',809,108,5,NULL,'21637e7680d64c0f8f98bb2c79a483e9'),(NULL,0,'2019-11-29 22:12:26',NULL,756,'0',810,108,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:26',NULL,757,'0',812,109,16,NULL,'cmdb1-1-4-3'),(NULL,0,'2019-11-29 22:12:26',NULL,758,'0',813,109,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,759,'0',814,109,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:26',NULL,760,'0',815,109,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,761,'0',816,109,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,762,'0',817,109,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:27',NULL,763,'0',818,109,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,764,'0',819,109,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:27',NULL,765,'0',820,109,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,766,'0',821,109,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,767,'0',822,109,15,NULL,'10.1.4.3'),(NULL,0,'2019-11-29 22:12:27',NULL,768,'0',823,109,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,769,'0',824,109,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,770,'0',825,109,5,NULL,'c9c7ad2b972345d5baff0ef01dc8da35'),(NULL,0,'2019-11-29 22:12:27',NULL,771,'0',826,109,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:27',NULL,772,'0',828,110,16,NULL,'cmdb1-1-4-4'),(NULL,0,'2019-11-29 22:12:27',NULL,773,'0',829,110,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,774,'0',830,110,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:27',NULL,775,'0',831,110,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,776,'0',832,110,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,777,'0',833,110,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:27',NULL,778,'0',834,110,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,779,'0',835,110,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:27',NULL,780,'0',836,110,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,781,'0',837,110,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,782,'0',838,110,15,NULL,'10.1.4.4'),(NULL,0,'2019-11-29 22:12:27',NULL,783,'0',839,110,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,784,'0',840,110,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,785,'0',841,110,5,NULL,'a74a926f1ad54526ad8727643e786b69'),(NULL,0,'2019-11-29 22:12:27',NULL,786,'0',842,110,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:27',NULL,787,'0',844,111,16,NULL,'cmdb1-1-4-5'),(NULL,0,'2019-11-29 22:12:27',NULL,788,'0',845,111,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,789,'0',846,111,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:27',NULL,790,'0',847,111,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,791,'0',848,111,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,792,'0',849,111,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:27',NULL,793,'0',850,111,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,794,'0',851,111,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:27',NULL,795,'0',852,111,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,796,'0',853,111,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,797,'0',854,111,15,NULL,'10.1.4.5'),(NULL,0,'2019-11-29 22:12:27',NULL,798,'0',855,111,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,799,'0',856,111,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,800,'0',857,111,5,NULL,'8748983683664ae1835845c479e5b88c'),(NULL,0,'2019-11-29 22:12:27',NULL,801,'0',858,111,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:27',NULL,802,'0',860,112,16,NULL,'cmdb1-1-4-6'),(NULL,0,'2019-11-29 22:12:27',NULL,803,'0',861,112,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,804,'0',862,112,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:27',NULL,805,'0',863,112,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,806,'0',864,112,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,807,'0',865,112,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:27',NULL,808,'0',866,112,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,809,'0',867,112,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:27',NULL,810,'0',868,112,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,811,'0',869,112,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,812,'0',870,112,15,NULL,'10.1.4.6'),(NULL,0,'2019-11-29 22:12:27',NULL,813,'0',871,112,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,814,'0',872,112,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,815,'0',873,112,5,NULL,'9fa0b1d109924d78a2bc885516749c9f'),(NULL,0,'2019-11-29 22:12:27',NULL,816,'0',874,112,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:27',NULL,817,'0',876,113,16,NULL,'cmdb1-1-4-7'),(NULL,0,'2019-11-29 22:12:27',NULL,818,'0',877,113,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,819,'0',878,113,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:27',NULL,820,'0',879,113,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,821,'0',880,113,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,822,'0',881,113,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:27',NULL,823,'0',882,113,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,824,'0',883,113,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:27',NULL,825,'0',884,113,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,826,'0',885,113,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,827,'0',886,113,15,NULL,'10.1.4.7'),(NULL,0,'2019-11-29 22:12:28',NULL,828,'0',887,113,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,829,'0',888,113,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,830,'0',889,113,5,NULL,'9a812be9a6dd4601ba9340a9946bb0f6'),(NULL,0,'2019-11-29 22:12:28',NULL,831,'0',890,113,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:28',NULL,832,'0',892,114,16,NULL,'cmdb1-1-4-8'),(NULL,0,'2019-11-29 22:12:28',NULL,833,'0',893,114,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,834,'0',894,114,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:28',NULL,835,'0',895,114,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,836,'0',896,114,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,837,'0',897,114,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:28',NULL,838,'0',898,114,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,839,'0',899,114,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:28',NULL,840,'0',900,114,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,841,'0',901,114,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,842,'0',902,114,15,NULL,'10.1.4.8'),(NULL,0,'2019-11-29 22:12:28',NULL,843,'0',903,114,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,844,'0',904,114,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,845,'0',905,114,5,NULL,'2c4cefaca8034724abbce5a12516dda2'),(NULL,0,'2019-11-29 22:12:28',NULL,846,'0',906,114,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:28',NULL,847,'0',908,115,16,NULL,'cmdb1-1-4-9'),(NULL,0,'2019-11-29 22:12:28',NULL,848,'0',909,115,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,849,'0',910,115,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:28',NULL,850,'0',911,115,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,851,'0',912,115,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,852,'0',913,115,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:28',NULL,853,'0',914,115,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,854,'0',915,115,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:28',NULL,855,'0',916,115,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,856,'0',917,115,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,857,'0',918,115,15,NULL,'10.1.4.9'),(NULL,0,'2019-11-29 22:12:28',NULL,858,'0',919,115,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,859,'0',920,115,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,860,'0',921,115,5,NULL,'68819755b43c47719b65b3f7d17d6d23'),(NULL,0,'2019-11-29 22:12:28',NULL,861,'0',922,115,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:28',NULL,862,'0',924,116,16,NULL,'cmdb1-1-4-10'),(NULL,0,'2019-11-29 22:12:28',NULL,863,'0',925,116,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,864,'0',926,116,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:28',NULL,865,'0',927,116,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,866,'0',928,116,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,867,'0',929,116,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:28',NULL,868,'0',930,116,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,869,'0',931,116,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:28',NULL,870,'0',932,116,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,871,'0',933,116,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,872,'0',934,116,15,NULL,'10.1.4.10'),(NULL,0,'2019-11-29 22:12:28',NULL,873,'0',935,116,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,874,'0',936,116,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,875,'0',937,116,5,NULL,'c19a177302474c549c51ec61a095a738'),(NULL,0,'2019-11-29 22:12:28',NULL,876,'0',938,116,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:28',NULL,877,'0',940,117,16,NULL,'cmdb1-1-4-11'),(NULL,0,'2019-11-29 22:12:28',NULL,878,'0',941,117,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,879,'0',942,117,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:28',NULL,880,'0',943,117,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,881,'0',944,117,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,882,'0',945,117,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:28',NULL,883,'0',946,117,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,884,'0',947,117,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:28',NULL,885,'0',948,117,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,886,'0',949,117,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,887,'0',950,117,15,NULL,'10.1.4.11'),(NULL,0,'2019-11-29 22:12:28',NULL,888,'0',951,117,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,889,'0',952,117,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,890,'0',953,117,5,NULL,'ce01c1bd04c14f7d87b964f62747bac2'),(NULL,0,'2019-11-29 22:12:28',NULL,891,'0',954,117,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:29',NULL,892,'0',956,118,16,NULL,'cmdb1-1-4-12'),(NULL,0,'2019-11-29 22:12:29',NULL,893,'0',957,118,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,894,'0',958,118,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:29',NULL,895,'0',959,118,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,896,'0',960,118,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,897,'0',961,118,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:29',NULL,898,'0',962,118,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,899,'0',963,118,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:29',NULL,900,'0',964,118,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,901,'0',965,118,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,902,'0',966,118,15,NULL,'10.1.4.12'),(NULL,0,'2019-11-29 22:12:29',NULL,903,'0',967,118,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,904,'0',968,118,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,905,'0',969,118,5,NULL,'ec509835eb7a47a685488087338e93fa'),(NULL,0,'2019-11-29 22:12:29',NULL,906,'0',970,118,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:29',NULL,907,'0',972,119,16,NULL,'cmdb1-1-4-13'),(NULL,0,'2019-11-29 22:12:29',NULL,908,'0',973,119,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,909,'0',974,119,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:29',NULL,910,'0',975,119,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,911,'0',976,119,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,912,'0',977,119,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:29',NULL,913,'0',978,119,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,914,'0',979,119,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:29',NULL,915,'0',980,119,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,916,'0',981,119,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,917,'0',982,119,15,NULL,'10.1.4.13'),(NULL,0,'2019-11-29 22:12:29',NULL,918,'0',983,119,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,919,'0',984,119,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,920,'0',985,119,5,NULL,'593a221c75cc45acb0925004356df4c4'),(NULL,0,'2019-11-29 22:12:29',NULL,921,'0',986,119,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:29',NULL,922,'0',988,120,16,NULL,'cmdb1-1-4-14'),(NULL,0,'2019-11-29 22:12:29',NULL,923,'0',989,120,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,924,'0',990,120,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:29',NULL,925,'0',991,120,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,926,'0',992,120,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,927,'0',993,120,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:29',NULL,928,'0',994,120,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,929,'0',995,120,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:29',NULL,930,'0',996,120,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,931,'0',997,120,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,932,'0',998,120,15,NULL,'10.1.4.14'),(NULL,0,'2019-11-29 22:12:29',NULL,933,'0',999,120,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,934,'0',1000,120,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,935,'0',1001,120,5,NULL,'603bd6e09d854a3cb4d680abfc3a7b92'),(NULL,0,'2019-11-29 22:12:29',NULL,936,'0',1002,120,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:29',NULL,937,'0',1004,121,16,NULL,'cmdb1-1-4-15'),(NULL,0,'2019-11-29 22:12:29',NULL,938,'0',1005,121,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,939,'0',1006,121,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:29',NULL,940,'0',1007,121,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,941,'0',1008,121,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,942,'0',1009,121,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:29',NULL,943,'0',1010,121,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,944,'0',1011,121,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:29',NULL,945,'0',1012,121,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,946,'0',1013,121,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,947,'0',1014,121,15,NULL,'10.1.4.15'),(NULL,0,'2019-11-29 22:12:29',NULL,948,'0',1015,121,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,949,'0',1016,121,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,950,'0',1017,121,5,NULL,'9e9bbec3932143bcac837693768c1e93'),(NULL,0,'2019-11-29 22:12:29',NULL,951,'0',1018,121,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:30',NULL,952,'0',1020,122,16,NULL,'cmdb1-1-4-16'),(NULL,0,'2019-11-29 22:12:30',NULL,953,'0',1021,122,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,954,'0',1022,122,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:30',NULL,955,'0',1023,122,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,956,'0',1024,122,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,957,'0',1025,122,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:30',NULL,958,'0',1026,122,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,959,'0',1027,122,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:30',NULL,960,'0',1028,122,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,961,'0',1029,122,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,962,'0',1030,122,15,NULL,'10.1.4.16'),(NULL,0,'2019-11-29 22:12:30',NULL,963,'0',1031,122,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,964,'0',1032,122,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,965,'0',1033,122,5,NULL,'21ab637d13914f19975346675975ca95'),(NULL,0,'2019-11-29 22:12:30',NULL,966,'0',1034,122,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:30',NULL,967,'0',1036,123,4,NULL,'App1-1-5'),(NULL,0,'2019-11-29 22:12:30',NULL,968,'0',1038,124,16,NULL,'cmdb1-1-5-1'),(NULL,0,'2019-11-29 22:12:30',NULL,969,'0',1039,124,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,970,'0',1040,124,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:30',NULL,971,'0',1041,124,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,972,'0',1042,124,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,973,'0',1043,124,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:30',NULL,974,'0',1044,124,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,975,'0',1045,124,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:30',NULL,976,'0',1046,124,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,977,'0',1047,124,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,978,'0',1048,124,15,NULL,'10.1.5.1'),(NULL,0,'2019-11-29 22:12:30',NULL,979,'0',1049,124,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,980,'0',1050,124,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,981,'0',1051,124,5,NULL,'a787d1d2393d42ab84ebfd6a6c586953'),(NULL,0,'2019-11-29 22:12:30',NULL,982,'0',1052,124,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:30',NULL,983,'0',1054,125,16,NULL,'cmdb1-1-5-2'),(NULL,0,'2019-11-29 22:12:30',NULL,984,'0',1055,125,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,985,'0',1056,125,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:30',NULL,986,'0',1057,125,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,987,'0',1058,125,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,988,'0',1059,125,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:30',NULL,989,'0',1060,125,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,990,'0',1061,125,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:30',NULL,991,'0',1062,125,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,992,'0',1063,125,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,993,'0',1064,125,15,NULL,'10.1.5.2'),(NULL,0,'2019-11-29 22:12:30',NULL,994,'0',1065,125,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,995,'0',1066,125,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,996,'0',1067,125,5,NULL,'e267be5f1c7446e39ca4ce8f83f2feef'),(NULL,0,'2019-11-29 22:12:30',NULL,997,'0',1068,125,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:30',NULL,998,'0',1070,126,16,NULL,'cmdb1-1-5-3'),(NULL,0,'2019-11-29 22:12:30',NULL,999,'0',1071,126,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,1000,'0',1072,126,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:30',NULL,1001,'0',1073,126,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,1002,'0',1074,126,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,1003,'0',1075,126,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:30',NULL,1004,'0',1076,126,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,1005,'0',1077,126,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:30',NULL,1006,'0',1078,126,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,1007,'0',1079,126,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,1008,'0',1080,126,15,NULL,'10.1.5.3'),(NULL,0,'2019-11-29 22:12:30',NULL,1009,'0',1081,126,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,1010,'0',1082,126,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,1011,'0',1083,126,5,NULL,'095b2349bf0a4fc9bf3210f3d156772e'),(NULL,0,'2019-11-29 22:12:30',NULL,1012,'0',1084,126,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:31',NULL,1013,'0',1086,127,16,NULL,'cmdb1-1-5-4'),(NULL,0,'2019-11-29 22:12:31',NULL,1014,'0',1087,127,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,1015,'0',1088,127,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:31',NULL,1016,'0',1089,127,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1017,'0',1090,127,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1018,'0',1091,127,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:31',NULL,1019,'0',1092,127,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1020,'0',1093,127,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:31',NULL,1021,'0',1094,127,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1022,'0',1095,127,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1023,'0',1096,127,15,NULL,'10.1.5.4'),(NULL,0,'2019-11-29 22:12:31',NULL,1024,'0',1097,127,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,1025,'0',1098,127,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,1026,'0',1099,127,5,NULL,'034f1e9bfd63429986dca69c0d32b74f'),(NULL,0,'2019-11-29 22:12:31',NULL,1027,'0',1100,127,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:31',NULL,1028,'0',1102,128,16,NULL,'cmdb1-1-5-5'),(NULL,0,'2019-11-29 22:12:31',NULL,1029,'0',1103,128,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,1030,'0',1104,128,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:31',NULL,1031,'0',1105,128,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1032,'0',1106,128,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1033,'0',1107,128,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:31',NULL,1034,'0',1108,128,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1035,'0',1109,128,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:31',NULL,1036,'0',1110,128,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1037,'0',1111,128,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1038,'0',1112,128,15,NULL,'10.1.5.5'),(NULL,0,'2019-11-29 22:12:31',NULL,1039,'0',1113,128,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,1040,'0',1114,128,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,1041,'0',1115,128,5,NULL,'96275a5ddfc04669bcb5e7cb0e7b93de'),(NULL,0,'2019-11-29 22:12:31',NULL,1042,'0',1116,128,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:31',NULL,1043,'0',1118,129,16,NULL,'cmdb1-1-5-6'),(NULL,0,'2019-11-29 22:12:31',NULL,1044,'0',1119,129,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,1045,'0',1120,129,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:31',NULL,1046,'0',1121,129,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1047,'0',1122,129,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1048,'0',1123,129,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:31',NULL,1049,'0',1124,129,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1050,'0',1125,129,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:31',NULL,1051,'0',1126,129,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1052,'0',1127,129,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1053,'0',1128,129,15,NULL,'10.1.5.6'),(NULL,0,'2019-11-29 22:12:31',NULL,1054,'0',1129,129,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,1055,'0',1130,129,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,1056,'0',1131,129,5,NULL,'f9f3a981e89441249771203e06692778'),(NULL,0,'2019-11-29 22:12:31',NULL,1057,'0',1132,129,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:31',NULL,1058,'0',1134,130,16,NULL,'cmdb1-1-5-7'),(NULL,0,'2019-11-29 22:12:31',NULL,1059,'0',1135,130,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,1060,'0',1136,130,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:31',NULL,1061,'0',1137,130,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1062,'0',1138,130,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1063,'0',1139,130,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:31',NULL,1064,'0',1140,130,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1065,'0',1141,130,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:31',NULL,1066,'0',1142,130,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1067,'0',1143,130,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1068,'0',1144,130,15,NULL,'10.1.5.7'),(NULL,0,'2019-11-29 22:12:31',NULL,1069,'0',1145,130,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,1070,'0',1146,130,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,1071,'0',1147,130,5,NULL,'e0d866782eed4009bddfb5bba0d64b6f'),(NULL,0,'2019-11-29 22:12:31',NULL,1072,'0',1148,130,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:32',NULL,1073,'0',1150,131,16,NULL,'cmdb1-1-5-8'),(NULL,0,'2019-11-29 22:12:32',NULL,1074,'0',1151,131,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,1075,'0',1152,131,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:32',NULL,1076,'0',1153,131,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1077,'0',1154,131,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1078,'0',1155,131,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:32',NULL,1079,'0',1156,131,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1080,'0',1157,131,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:32',NULL,1081,'0',1158,131,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1082,'0',1159,131,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1083,'0',1160,131,15,NULL,'10.1.5.8'),(NULL,0,'2019-11-29 22:12:32',NULL,1084,'0',1161,131,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,1085,'0',1162,131,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,1086,'0',1163,131,5,NULL,'3800cf3b658f4eaea7d3158c5a10fd8b'),(NULL,0,'2019-11-29 22:12:32',NULL,1087,'0',1164,131,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:32',NULL,1088,'0',1166,132,16,NULL,'cmdb1-1-5-9'),(NULL,0,'2019-11-29 22:12:32',NULL,1089,'0',1167,132,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,1090,'0',1168,132,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:32',NULL,1091,'0',1169,132,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1092,'0',1170,132,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1093,'0',1171,132,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:32',NULL,1094,'0',1172,132,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1095,'0',1173,132,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:32',NULL,1096,'0',1174,132,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1097,'0',1175,132,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1098,'0',1176,132,15,NULL,'10.1.5.9'),(NULL,0,'2019-11-29 22:12:32',NULL,1099,'0',1177,132,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,1100,'0',1178,132,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,1101,'0',1179,132,5,NULL,'24aafefc3fd74a039c57ce8e2daefe6b'),(NULL,0,'2019-11-29 22:12:32',NULL,1102,'0',1180,132,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:32',NULL,1103,'0',1182,133,16,NULL,'cmdb1-1-5-10'),(NULL,0,'2019-11-29 22:12:32',NULL,1104,'0',1183,133,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,1105,'0',1184,133,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:32',NULL,1106,'0',1185,133,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1107,'0',1186,133,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1108,'0',1187,133,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:32',NULL,1109,'0',1188,133,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1110,'0',1189,133,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:32',NULL,1111,'0',1190,133,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1112,'0',1191,133,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1113,'0',1192,133,15,NULL,'10.1.5.10'),(NULL,0,'2019-11-29 22:12:32',NULL,1114,'0',1193,133,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,1115,'0',1194,133,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,1116,'0',1195,133,5,NULL,'074090947f6849ec9509415817070ccb'),(NULL,0,'2019-11-29 22:12:32',NULL,1117,'0',1196,133,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:32',NULL,1118,'0',1198,134,16,NULL,'cmdb1-1-5-11'),(NULL,0,'2019-11-29 22:12:32',NULL,1119,'0',1199,134,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,1120,'0',1200,134,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:32',NULL,1121,'0',1201,134,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1122,'0',1202,134,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1123,'0',1203,134,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:32',NULL,1124,'0',1204,134,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1125,'0',1205,134,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:32',NULL,1126,'0',1206,134,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1127,'0',1207,134,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1128,'0',1208,134,15,NULL,'10.1.5.11'),(NULL,0,'2019-11-29 22:12:32',NULL,1129,'0',1209,134,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,1130,'0',1210,134,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,1131,'0',1211,134,5,NULL,'2e1e94d3953f4b9988ad0f1b79b15757'),(NULL,0,'2019-11-29 22:12:32',NULL,1132,'0',1212,134,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:32',NULL,1133,'0',1214,135,16,NULL,'cmdb1-1-5-12'),(NULL,0,'2019-11-29 22:12:32',NULL,1134,'0',1215,135,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,1135,'0',1216,135,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:32',NULL,1136,'0',1217,135,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1137,'0',1218,135,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1138,'0',1219,135,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:32',NULL,1139,'0',1220,135,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1140,'0',1221,135,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:33',NULL,1141,'0',1222,135,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1142,'0',1223,135,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1143,'0',1224,135,15,NULL,'10.1.5.12'),(NULL,0,'2019-11-29 22:12:33',NULL,1144,'0',1225,135,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,1145,'0',1226,135,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,1146,'0',1227,135,5,NULL,'acdbd1e1797446d4b1b8d81dd1272c2a'),(NULL,0,'2019-11-29 22:12:33',NULL,1147,'0',1228,135,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:33',NULL,1148,'0',1230,136,16,NULL,'cmdb1-1-5-13'),(NULL,0,'2019-11-29 22:12:33',NULL,1149,'0',1231,136,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,1150,'0',1232,136,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:33',NULL,1151,'0',1233,136,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1152,'0',1234,136,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1153,'0',1235,136,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:33',NULL,1154,'0',1236,136,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1155,'0',1237,136,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:33',NULL,1156,'0',1238,136,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1157,'0',1239,136,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1158,'0',1240,136,15,NULL,'10.1.5.13'),(NULL,0,'2019-11-29 22:12:33',NULL,1159,'0',1241,136,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,1160,'0',1242,136,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,1161,'0',1243,136,5,NULL,'550dccc4aa264b3b8da89af9afc0b0d1'),(NULL,0,'2019-11-29 22:12:33',NULL,1162,'0',1244,136,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:33',NULL,1163,'0',1246,137,16,NULL,'cmdb1-1-5-14'),(NULL,0,'2019-11-29 22:12:33',NULL,1164,'0',1247,137,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,1165,'0',1248,137,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:33',NULL,1166,'0',1249,137,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1167,'0',1250,137,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1168,'0',1251,137,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:33',NULL,1169,'0',1252,137,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1170,'0',1253,137,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:33',NULL,1171,'0',1254,137,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1172,'0',1255,137,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1173,'0',1256,137,15,NULL,'10.1.5.14'),(NULL,0,'2019-11-29 22:12:33',NULL,1174,'0',1257,137,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,1175,'0',1258,137,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,1176,'0',1259,137,5,NULL,'ae31164dcdee40e4934c0514d5d7f125'),(NULL,0,'2019-11-29 22:12:33',NULL,1177,'0',1260,137,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:33',NULL,1178,'0',1262,138,16,NULL,'cmdb1-1-5-15'),(NULL,0,'2019-11-29 22:12:33',NULL,1179,'0',1263,138,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,1180,'0',1264,138,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:33',NULL,1181,'0',1265,138,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1182,'0',1266,138,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1183,'0',1267,138,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:33',NULL,1184,'0',1268,138,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1185,'0',1269,138,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:33',NULL,1186,'0',1270,138,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1187,'0',1271,138,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1188,'0',1272,138,15,NULL,'10.1.5.15'),(NULL,0,'2019-11-29 22:12:33',NULL,1189,'0',1273,138,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,1190,'0',1274,138,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,1191,'0',1275,138,5,NULL,'808267a5a78b41a59914cbfda71e5d04'),(NULL,0,'2019-11-29 22:12:33',NULL,1192,'0',1276,138,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:33',NULL,1193,'0',1278,139,16,NULL,'cmdb1-1-5-16'),(NULL,0,'2019-11-29 22:12:33',NULL,1194,'0',1279,139,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,1195,'0',1280,139,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:33',NULL,1196,'0',1281,139,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1197,'0',1282,139,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1198,'0',1283,139,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:33',NULL,1199,'0',1284,139,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1200,'0',1285,139,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:33',NULL,1201,'0',1286,139,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1202,'0',1287,139,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1203,'0',1288,139,15,NULL,'10.1.5.16'),(NULL,0,'2019-11-29 22:12:33',NULL,1204,'0',1289,139,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,1205,'0',1290,139,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,1206,'0',1291,139,5,NULL,'fec2f97c7cb541eaafa66517ea08ffaf'),(NULL,0,'2019-11-29 22:12:34',NULL,1207,'0',1292,139,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:34',NULL,1208,'0',1294,140,4,NULL,'App1-1-6'),(NULL,0,'2019-11-29 22:12:34',NULL,1209,'0',1296,141,16,NULL,'cmdb1-1-6-1'),(NULL,0,'2019-11-29 22:12:34',NULL,1210,'0',1297,141,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,1211,'0',1298,141,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:34',NULL,1212,'0',1299,141,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1213,'0',1300,141,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1214,'0',1301,141,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:34',NULL,1215,'0',1302,141,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1216,'0',1303,141,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:34',NULL,1217,'0',1304,141,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1218,'0',1305,141,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1219,'0',1306,141,15,NULL,'10.1.6.1'),(NULL,0,'2019-11-29 22:12:34',NULL,1220,'0',1307,141,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,1221,'0',1308,141,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,1222,'0',1309,141,5,NULL,'4f4da7d22dab4a3594e55203bace84ef'),(NULL,0,'2019-11-29 22:12:34',NULL,1223,'0',1310,141,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:34',NULL,1224,'0',1312,142,16,NULL,'cmdb1-1-6-2'),(NULL,0,'2019-11-29 22:12:34',NULL,1225,'0',1313,142,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,1226,'0',1314,142,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:34',NULL,1227,'0',1315,142,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1228,'0',1316,142,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1229,'0',1317,142,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:34',NULL,1230,'0',1318,142,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1231,'0',1319,142,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:34',NULL,1232,'0',1320,142,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1233,'0',1321,142,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1234,'0',1322,142,15,NULL,'10.1.6.2'),(NULL,0,'2019-11-29 22:12:34',NULL,1235,'0',1323,142,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,1236,'0',1324,142,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,1237,'0',1325,142,5,NULL,'fc8abfc5512d4cb58444731707ea801d'),(NULL,0,'2019-11-29 22:12:34',NULL,1238,'0',1326,142,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:34',NULL,1239,'0',1328,143,16,NULL,'cmdb1-1-6-3'),(NULL,0,'2019-11-29 22:12:34',NULL,1240,'0',1329,143,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,1241,'0',1330,143,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:34',NULL,1242,'0',1331,143,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1243,'0',1332,143,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1244,'0',1333,143,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:34',NULL,1245,'0',1334,143,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1246,'0',1335,143,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:34',NULL,1247,'0',1336,143,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1248,'0',1337,143,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1249,'0',1338,143,15,NULL,'10.1.6.3'),(NULL,0,'2019-11-29 22:12:34',NULL,1250,'0',1339,143,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,1251,'0',1340,143,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,1252,'0',1341,143,5,NULL,'1589642b52e34fac85db0ccf4b051e40'),(NULL,0,'2019-11-29 22:12:34',NULL,1253,'0',1342,143,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:34',NULL,1254,'0',1344,144,16,NULL,'cmdb1-1-6-4'),(NULL,0,'2019-11-29 22:12:34',NULL,1255,'0',1345,144,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,1256,'0',1346,144,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:34',NULL,1257,'0',1347,144,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1258,'0',1348,144,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1259,'0',1349,144,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:34',NULL,1260,'0',1350,144,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1261,'0',1351,144,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:34',NULL,1262,'0',1352,144,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1263,'0',1353,144,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1264,'0',1354,144,15,NULL,'10.1.6.4'),(NULL,0,'2019-11-29 22:12:34',NULL,1265,'0',1355,144,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,1266,'0',1356,144,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,1267,'0',1357,144,5,NULL,'04172ddb77c7486d922636c4d538db32'),(NULL,0,'2019-11-29 22:12:35',NULL,1268,'0',1358,144,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:35',NULL,1269,'0',1360,145,16,NULL,'cmdb1-1-6-5'),(NULL,0,'2019-11-29 22:12:35',NULL,1270,'0',1361,145,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,1271,'0',1362,145,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:35',NULL,1272,'0',1363,145,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1273,'0',1364,145,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1274,'0',1365,145,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:35',NULL,1275,'0',1366,145,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1276,'0',1367,145,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:35',NULL,1277,'0',1368,145,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1278,'0',1369,145,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1279,'0',1370,145,15,NULL,'10.1.6.5'),(NULL,0,'2019-11-29 22:12:35',NULL,1280,'0',1371,145,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,1281,'0',1372,145,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,1282,'0',1373,145,5,NULL,'7a438f7b2d4f4298a15994a7341af502'),(NULL,0,'2019-11-29 22:12:35',NULL,1283,'0',1374,145,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:35',NULL,1284,'0',1376,146,16,NULL,'cmdb1-1-6-6'),(NULL,0,'2019-11-29 22:12:35',NULL,1285,'0',1377,146,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,1286,'0',1378,146,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:35',NULL,1287,'0',1379,146,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1288,'0',1380,146,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1289,'0',1381,146,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:35',NULL,1290,'0',1382,146,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1291,'0',1383,146,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:35',NULL,1292,'0',1384,146,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1293,'0',1385,146,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1294,'0',1386,146,15,NULL,'10.1.6.6'),(NULL,0,'2019-11-29 22:12:35',NULL,1295,'0',1387,146,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,1296,'0',1388,146,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,1297,'0',1389,146,5,NULL,'a74bc24ec13349c0962de62e3bc80319'),(NULL,0,'2019-11-29 22:12:35',NULL,1298,'0',1390,146,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:35',NULL,1299,'0',1392,147,16,NULL,'cmdb1-1-6-7'),(NULL,0,'2019-11-29 22:12:35',NULL,1300,'0',1393,147,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,1301,'0',1394,147,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:35',NULL,1302,'0',1395,147,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1303,'0',1396,147,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1304,'0',1397,147,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:35',NULL,1305,'0',1398,147,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1306,'0',1399,147,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:35',NULL,1307,'0',1400,147,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1308,'0',1401,147,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1309,'0',1402,147,15,NULL,'10.1.6.7'),(NULL,0,'2019-11-29 22:12:35',NULL,1310,'0',1403,147,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,1311,'0',1404,147,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,1312,'0',1405,147,5,NULL,'8c62d4a141404af9a2862b7e79a95ed4'),(NULL,0,'2019-11-29 22:12:35',NULL,1313,'0',1406,147,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:35',NULL,1314,'0',1408,148,16,NULL,'cmdb1-1-6-8'),(NULL,0,'2019-11-29 22:12:35',NULL,1315,'0',1409,148,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,1316,'0',1410,148,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:35',NULL,1317,'0',1411,148,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1318,'0',1412,148,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1319,'0',1413,148,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:35',NULL,1320,'0',1414,148,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1321,'0',1415,148,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:35',NULL,1322,'0',1416,148,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1323,'0',1417,148,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1324,'0',1418,148,15,NULL,'10.1.6.8'),(NULL,0,'2019-11-29 22:12:35',NULL,1325,'0',1419,148,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,1326,'0',1420,148,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,1327,'0',1421,148,5,NULL,'1afa76ee19de4b06beb044c352756792'),(NULL,0,'2019-11-29 22:12:35',NULL,1328,'0',1422,148,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:36',NULL,1329,'0',1424,149,16,NULL,'cmdb1-1-6-9'),(NULL,0,'2019-11-29 22:12:36',NULL,1330,'0',1425,149,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,1331,'0',1426,149,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:36',NULL,1332,'0',1427,149,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1333,'0',1428,149,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1334,'0',1429,149,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:36',NULL,1335,'0',1430,149,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1336,'0',1431,149,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:36',NULL,1337,'0',1432,149,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1338,'0',1433,149,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1339,'0',1434,149,15,NULL,'10.1.6.9'),(NULL,0,'2019-11-29 22:12:36',NULL,1340,'0',1435,149,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,1341,'0',1436,149,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,1342,'0',1437,149,5,NULL,'1fd01049ab98495f8bca9bbd35b696e6'),(NULL,0,'2019-11-29 22:12:36',NULL,1343,'0',1438,149,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:36',NULL,1344,'0',1440,150,16,NULL,'cmdb1-1-6-10'),(NULL,0,'2019-11-29 22:12:36',NULL,1345,'0',1441,150,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,1346,'0',1442,150,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:36',NULL,1347,'0',1443,150,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1348,'0',1444,150,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1349,'0',1445,150,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:36',NULL,1350,'0',1446,150,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1351,'0',1447,150,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:36',NULL,1352,'0',1448,150,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1353,'0',1449,150,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1354,'0',1450,150,15,NULL,'10.1.6.10'),(NULL,0,'2019-11-29 22:12:36',NULL,1355,'0',1451,150,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,1356,'0',1452,150,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,1357,'0',1453,150,5,NULL,'47b9983de6eb46029479deb51051bf13'),(NULL,0,'2019-11-29 22:12:36',NULL,1358,'0',1454,150,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:36',NULL,1359,'0',1456,151,16,NULL,'cmdb1-1-6-11'),(NULL,0,'2019-11-29 22:12:36',NULL,1360,'0',1457,151,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,1361,'0',1458,151,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:36',NULL,1362,'0',1459,151,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1363,'0',1460,151,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1364,'0',1461,151,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:36',NULL,1365,'0',1462,151,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1366,'0',1463,151,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:36',NULL,1367,'0',1464,151,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1368,'0',1465,151,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1369,'0',1466,151,15,NULL,'10.1.6.11'),(NULL,0,'2019-11-29 22:12:36',NULL,1370,'0',1467,151,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,1371,'0',1468,151,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,1372,'0',1469,151,5,NULL,'b0e86d12e28a4a4b8af8dd44c2d02ce2'),(NULL,0,'2019-11-29 22:12:36',NULL,1373,'0',1470,151,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:36',NULL,1374,'0',1472,152,16,NULL,'cmdb1-1-6-12'),(NULL,0,'2019-11-29 22:12:36',NULL,1375,'0',1473,152,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,1376,'0',1474,152,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:36',NULL,1377,'0',1475,152,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1378,'0',1476,152,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1379,'0',1477,152,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:36',NULL,1380,'0',1478,152,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1381,'0',1479,152,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:36',NULL,1382,'0',1480,152,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1383,'0',1481,152,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1384,'0',1482,152,15,NULL,'10.1.6.12'),(NULL,0,'2019-11-29 22:12:36',NULL,1385,'0',1483,152,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,1386,'0',1484,152,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,1387,'0',1485,152,5,NULL,'059325a77baa4c8d8a955eda371a6d0d'),(NULL,0,'2019-11-29 22:12:36',NULL,1388,'0',1486,152,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:36',NULL,1389,'0',1488,153,16,NULL,'cmdb1-1-6-13'),(NULL,0,'2019-11-29 22:12:36',NULL,1390,'0',1489,153,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,1391,'0',1490,153,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:36',NULL,1392,'0',1491,153,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1393,'0',1492,153,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1394,'0',1493,153,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:37',NULL,1395,'0',1494,153,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1396,'0',1495,153,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:37',NULL,1397,'0',1496,153,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1398,'0',1497,153,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1399,'0',1498,153,15,NULL,'10.1.6.13'),(NULL,0,'2019-11-29 22:12:37',NULL,1400,'0',1499,153,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,1401,'0',1500,153,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,1402,'0',1501,153,5,NULL,'f3c25a24f8f843deb29b671a23ff1d95'),(NULL,0,'2019-11-29 22:12:37',NULL,1403,'0',1502,153,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:37',NULL,1404,'0',1504,154,16,NULL,'cmdb1-1-6-14'),(NULL,0,'2019-11-29 22:12:37',NULL,1405,'0',1505,154,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,1406,'0',1506,154,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:37',NULL,1407,'0',1507,154,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1408,'0',1508,154,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1409,'0',1509,154,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:37',NULL,1410,'0',1510,154,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1411,'0',1511,154,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:37',NULL,1412,'0',1512,154,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1413,'0',1513,154,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1414,'0',1514,154,15,NULL,'10.1.6.14'),(NULL,0,'2019-11-29 22:12:37',NULL,1415,'0',1515,154,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,1416,'0',1516,154,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,1417,'0',1517,154,5,NULL,'acabbc340bca466db1202dc203fe7ba9'),(NULL,0,'2019-11-29 22:12:37',NULL,1418,'0',1518,154,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:37',NULL,1419,'0',1520,155,16,NULL,'cmdb1-1-6-15'),(NULL,0,'2019-11-29 22:12:37',NULL,1420,'0',1521,155,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,1421,'0',1522,155,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:37',NULL,1422,'0',1523,155,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1423,'0',1524,155,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1424,'0',1525,155,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:37',NULL,1425,'0',1526,155,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1426,'0',1527,155,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:37',NULL,1427,'0',1528,155,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1428,'0',1529,155,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1429,'0',1530,155,15,NULL,'10.1.6.15'),(NULL,0,'2019-11-29 22:12:37',NULL,1430,'0',1531,155,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,1431,'0',1532,155,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,1432,'0',1533,155,5,NULL,'dc51de0525dc4dda90d0b624bc028177'),(NULL,0,'2019-11-29 22:12:37',NULL,1433,'0',1534,155,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:37',NULL,1434,'0',1536,156,16,NULL,'cmdb1-1-6-16'),(NULL,0,'2019-11-29 22:12:37',NULL,1435,'0',1537,156,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,1436,'0',1538,156,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:37',NULL,1437,'0',1539,156,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1438,'0',1540,156,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1439,'0',1541,156,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:37',NULL,1440,'0',1542,156,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1441,'0',1543,156,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:37',NULL,1442,'0',1544,156,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1443,'0',1545,156,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1444,'0',1546,156,15,NULL,'10.1.6.16'),(NULL,0,'2019-11-29 22:12:37',NULL,1445,'0',1547,156,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,1446,'0',1548,156,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,1447,'0',1549,156,5,NULL,'c576916b20bd419f88668457b5c62ac7'),(NULL,0,'2019-11-29 22:12:37',NULL,1448,'0',1550,156,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:37',NULL,1449,'0',1552,157,4,NULL,'App1-1-7'),(NULL,0,'2019-11-29 22:12:37',NULL,1450,'0',1554,158,16,NULL,'cmdb1-1-7-1'),(NULL,0,'2019-11-29 22:12:37',NULL,1451,'0',1555,158,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,1452,'0',1556,158,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:37',NULL,1453,'0',1557,158,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1454,'0',1558,158,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1455,'0',1559,158,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:38',NULL,1456,'0',1560,158,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1457,'0',1561,158,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:38',NULL,1458,'0',1562,158,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1459,'0',1563,158,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1460,'0',1564,158,15,NULL,'10.1.7.1'),(NULL,0,'2019-11-29 22:12:38',NULL,1461,'0',1565,158,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,1462,'0',1566,158,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,1463,'0',1567,158,5,NULL,'e4ae01ee254643cbbcf570d510294645'),(NULL,0,'2019-11-29 22:12:38',NULL,1464,'0',1568,158,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:38',NULL,1465,'0',1570,159,16,NULL,'cmdb1-1-7-2'),(NULL,0,'2019-11-29 22:12:38',NULL,1466,'0',1571,159,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,1467,'0',1572,159,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:38',NULL,1468,'0',1573,159,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1469,'0',1574,159,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1470,'0',1575,159,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:38',NULL,1471,'0',1576,159,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1472,'0',1577,159,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:38',NULL,1473,'0',1578,159,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1474,'0',1579,159,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1475,'0',1580,159,15,NULL,'10.1.7.2'),(NULL,0,'2019-11-29 22:12:38',NULL,1476,'0',1581,159,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,1477,'0',1582,159,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,1478,'0',1583,159,5,NULL,'f11f1f67a41c40949b167af2488572cd'),(NULL,0,'2019-11-29 22:12:38',NULL,1479,'0',1584,159,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:38',NULL,1480,'0',1586,160,16,NULL,'cmdb1-1-7-3'),(NULL,0,'2019-11-29 22:12:38',NULL,1481,'0',1587,160,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,1482,'0',1588,160,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:38',NULL,1483,'0',1589,160,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1484,'0',1590,160,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1485,'0',1591,160,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:38',NULL,1486,'0',1592,160,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1487,'0',1593,160,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:38',NULL,1488,'0',1594,160,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1489,'0',1595,160,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1490,'0',1596,160,15,NULL,'10.1.7.3'),(NULL,0,'2019-11-29 22:12:38',NULL,1491,'0',1597,160,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,1492,'0',1598,160,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,1493,'0',1599,160,5,NULL,'04f194edffea44409dafe3f4cb0e9934'),(NULL,0,'2019-11-29 22:12:38',NULL,1494,'0',1600,160,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:38',NULL,1495,'0',1602,161,16,NULL,'cmdb1-1-7-4'),(NULL,0,'2019-11-29 22:12:38',NULL,1496,'0',1603,161,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,1497,'0',1604,161,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:38',NULL,1498,'0',1605,161,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1499,'0',1606,161,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1500,'0',1607,161,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:38',NULL,1501,'0',1608,161,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1502,'0',1609,161,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:38',NULL,1503,'0',1610,161,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1504,'0',1611,161,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1505,'0',1612,161,15,NULL,'10.1.7.4'),(NULL,0,'2019-11-29 22:12:38',NULL,1506,'0',1613,161,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,1507,'0',1614,161,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,1508,'0',1615,161,5,NULL,'9800ac1d5733474db5947edd7458a484'),(NULL,0,'2019-11-29 22:12:38',NULL,1509,'0',1616,161,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:38',NULL,1510,'0',1618,162,16,NULL,'cmdb1-1-7-5'),(NULL,0,'2019-11-29 22:12:38',NULL,1511,'0',1619,162,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,1512,'0',1620,162,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:38',NULL,1513,'0',1621,162,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1514,'0',1622,162,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1515,'0',1623,162,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:38',NULL,1516,'0',1624,162,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1517,'0',1625,162,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:38',NULL,1518,'0',1626,162,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1519,'0',1627,162,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1520,'0',1628,162,15,NULL,'10.1.7.5'),(NULL,0,'2019-11-29 22:12:39',NULL,1521,'0',1629,162,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,1522,'0',1630,162,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,1523,'0',1631,162,5,NULL,'25c2f18c0d6d4071a5d3458049745126'),(NULL,0,'2019-11-29 22:12:39',NULL,1524,'0',1632,162,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:39',NULL,1525,'0',1634,163,16,NULL,'cmdb1-1-7-6'),(NULL,0,'2019-11-29 22:12:39',NULL,1526,'0',1635,163,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,1527,'0',1636,163,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:39',NULL,1528,'0',1637,163,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1529,'0',1638,163,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1530,'0',1639,163,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:39',NULL,1531,'0',1640,163,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1532,'0',1641,163,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:39',NULL,1533,'0',1642,163,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1534,'0',1643,163,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1535,'0',1644,163,15,NULL,'10.1.7.6'),(NULL,0,'2019-11-29 22:12:39',NULL,1536,'0',1645,163,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,1537,'0',1646,163,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,1538,'0',1647,163,5,NULL,'580a9a59f1134a138bfe0146c7f608b1'),(NULL,0,'2019-11-29 22:12:39',NULL,1539,'0',1648,163,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:39',NULL,1540,'0',1650,164,16,NULL,'cmdb1-1-7-7'),(NULL,0,'2019-11-29 22:12:39',NULL,1541,'0',1651,164,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,1542,'0',1652,164,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:39',NULL,1543,'0',1653,164,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1544,'0',1654,164,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1545,'0',1655,164,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:39',NULL,1546,'0',1656,164,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1547,'0',1657,164,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:39',NULL,1548,'0',1658,164,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1549,'0',1659,164,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1550,'0',1660,164,15,NULL,'10.1.7.7'),(NULL,0,'2019-11-29 22:12:39',NULL,1551,'0',1661,164,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,1552,'0',1662,164,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,1553,'0',1663,164,5,NULL,'9cb24c1ba504491caf21ec1985b4575c'),(NULL,0,'2019-11-29 22:12:39',NULL,1554,'0',1664,164,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:39',NULL,1555,'0',1666,165,16,NULL,'cmdb1-1-7-8'),(NULL,0,'2019-11-29 22:12:39',NULL,1556,'0',1667,165,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,1557,'0',1668,165,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:39',NULL,1558,'0',1669,165,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1559,'0',1670,165,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1560,'0',1671,165,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:39',NULL,1561,'0',1672,165,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1562,'0',1673,165,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:39',NULL,1563,'0',1674,165,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1564,'0',1675,165,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1565,'0',1676,165,15,NULL,'10.1.7.8'),(NULL,0,'2019-11-29 22:12:39',NULL,1566,'0',1677,165,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,1567,'0',1678,165,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,1568,'0',1679,165,5,NULL,'9beb1c2b6e51475c8a59fc8347e1be6e'),(NULL,0,'2019-11-29 22:12:39',NULL,1569,'0',1680,165,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:39',NULL,1570,'0',1682,166,16,NULL,'cmdb1-1-7-9'),(NULL,0,'2019-11-29 22:12:39',NULL,1571,'0',1683,166,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,1572,'0',1684,166,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:39',NULL,1573,'0',1685,166,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1574,'0',1686,166,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1575,'0',1687,166,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:39',NULL,1576,'0',1688,166,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1577,'0',1689,166,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:39',NULL,1578,'0',1690,166,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1579,'0',1691,166,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1580,'0',1692,166,15,NULL,'10.1.7.9'),(NULL,0,'2019-11-29 22:12:39',NULL,1581,'0',1693,166,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,1582,'0',1694,166,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,1583,'0',1695,166,5,NULL,'a0155f427f6a4b8d84d093fd5ed4bda4'),(NULL,0,'2019-11-29 22:12:39',NULL,1584,'0',1696,166,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:40',NULL,1585,'0',1698,167,16,NULL,'cmdb1-1-7-10'),(NULL,0,'2019-11-29 22:12:40',NULL,1586,'0',1699,167,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,1587,'0',1700,167,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:40',NULL,1588,'0',1701,167,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1589,'0',1702,167,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1590,'0',1703,167,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:40',NULL,1591,'0',1704,167,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1592,'0',1705,167,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:40',NULL,1593,'0',1706,167,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1594,'0',1707,167,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1595,'0',1708,167,15,NULL,'10.1.7.10'),(NULL,0,'2019-11-29 22:12:40',NULL,1596,'0',1709,167,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,1597,'0',1710,167,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,1598,'0',1711,167,5,NULL,'dfd1a30796f74c27971e641136a09ce4'),(NULL,0,'2019-11-29 22:12:40',NULL,1599,'0',1712,167,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:40',NULL,1600,'0',1714,168,16,NULL,'cmdb1-1-7-11'),(NULL,0,'2019-11-29 22:12:40',NULL,1601,'0',1715,168,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,1602,'0',1716,168,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:40',NULL,1603,'0',1717,168,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1604,'0',1718,168,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1605,'0',1719,168,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:40',NULL,1606,'0',1720,168,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1607,'0',1721,168,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:40',NULL,1608,'0',1722,168,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1609,'0',1723,168,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1610,'0',1724,168,15,NULL,'10.1.7.11'),(NULL,0,'2019-11-29 22:12:40',NULL,1611,'0',1725,168,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,1612,'0',1726,168,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,1613,'0',1727,168,5,NULL,'e22bb43856d64920ad10559e6928bd79'),(NULL,0,'2019-11-29 22:12:40',NULL,1614,'0',1728,168,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:40',NULL,1615,'0',1730,169,16,NULL,'cmdb1-1-7-12'),(NULL,0,'2019-11-29 22:12:40',NULL,1616,'0',1731,169,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,1617,'0',1732,169,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:40',NULL,1618,'0',1733,169,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1619,'0',1734,169,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1620,'0',1735,169,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:40',NULL,1621,'0',1736,169,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1622,'0',1737,169,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:40',NULL,1623,'0',1738,169,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1624,'0',1739,169,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1625,'0',1740,169,15,NULL,'10.1.7.12'),(NULL,0,'2019-11-29 22:12:40',NULL,1626,'0',1741,169,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,1627,'0',1742,169,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,1628,'0',1743,169,5,NULL,'d931702f8503482eac27b6c24a87da2f'),(NULL,0,'2019-11-29 22:12:40',NULL,1629,'0',1744,169,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:40',NULL,1630,'0',1746,170,16,NULL,'cmdb1-1-7-13'),(NULL,0,'2019-11-29 22:12:40',NULL,1631,'0',1747,170,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,1632,'0',1748,170,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:40',NULL,1633,'0',1749,170,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1634,'0',1750,170,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1635,'0',1751,170,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:40',NULL,1636,'0',1752,170,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1637,'0',1753,170,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:40',NULL,1638,'0',1754,170,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1639,'0',1755,170,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1640,'0',1756,170,15,NULL,'10.1.7.13'),(NULL,0,'2019-11-29 22:12:40',NULL,1641,'0',1757,170,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,1642,'0',1758,170,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,1643,'0',1759,170,5,NULL,'1907ac0c59a7404babb2b2407fac19db'),(NULL,0,'2019-11-29 22:12:40',NULL,1644,'0',1760,170,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:40',NULL,1645,'0',1762,171,16,NULL,'cmdb1-1-7-14'),(NULL,0,'2019-11-29 22:12:41',NULL,1646,'0',1763,171,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,1647,'0',1764,171,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:41',NULL,1648,'0',1765,171,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1649,'0',1766,171,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1650,'0',1767,171,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:41',NULL,1651,'0',1768,171,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1652,'0',1769,171,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:41',NULL,1653,'0',1770,171,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1654,'0',1771,171,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1655,'0',1772,171,15,NULL,'10.1.7.14'),(NULL,0,'2019-11-29 22:12:41',NULL,1656,'0',1773,171,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,1657,'0',1774,171,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,1658,'0',1775,171,5,NULL,'c19d624245f24d10b0b453af4da4c73c'),(NULL,0,'2019-11-29 22:12:41',NULL,1659,'0',1776,171,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:41',NULL,1660,'0',1778,172,16,NULL,'cmdb1-1-7-15'),(NULL,0,'2019-11-29 22:12:41',NULL,1661,'0',1779,172,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,1662,'0',1780,172,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:41',NULL,1663,'0',1781,172,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1664,'0',1782,172,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1665,'0',1783,172,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:41',NULL,1666,'0',1784,172,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1667,'0',1785,172,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:41',NULL,1668,'0',1786,172,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1669,'0',1787,172,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1670,'0',1788,172,15,NULL,'10.1.7.15'),(NULL,0,'2019-11-29 22:12:41',NULL,1671,'0',1789,172,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,1672,'0',1790,172,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,1673,'0',1791,172,5,NULL,'ee93c2752e3d4f2f90580a286cf3e523'),(NULL,0,'2019-11-29 22:12:41',NULL,1674,'0',1792,172,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:41',NULL,1675,'0',1794,173,16,NULL,'cmdb1-1-7-16'),(NULL,0,'2019-11-29 22:12:41',NULL,1676,'0',1795,173,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,1677,'0',1796,173,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:41',NULL,1678,'0',1797,173,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1679,'0',1798,173,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1680,'0',1799,173,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:41',NULL,1681,'0',1800,173,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1682,'0',1801,173,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:41',NULL,1683,'0',1802,173,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1684,'0',1803,173,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1685,'0',1804,173,15,NULL,'10.1.7.16'),(NULL,0,'2019-11-29 22:12:41',NULL,1686,'0',1805,173,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,1687,'0',1806,173,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,1688,'0',1807,173,5,NULL,'8f5fbf45ee9340bfa2f4d4809cacb2e0'),(NULL,0,'2019-11-29 22:12:41',NULL,1689,'0',1808,173,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:41',NULL,1690,'0',1810,174,4,NULL,'App1-1-8'),(NULL,0,'2019-11-29 22:12:41',NULL,1691,'0',1812,175,16,NULL,'cmdb1-1-8-1'),(NULL,0,'2019-11-29 22:12:41',NULL,1692,'0',1813,175,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,1693,'0',1814,175,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:41',NULL,1694,'0',1815,175,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1695,'0',1816,175,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1696,'0',1817,175,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:41',NULL,1697,'0',1818,175,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1698,'0',1819,175,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:41',NULL,1699,'0',1820,175,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1700,'0',1821,175,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1701,'0',1822,175,15,NULL,'10.1.8.1'),(NULL,0,'2019-11-29 22:12:41',NULL,1702,'0',1823,175,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,1703,'0',1824,175,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,1704,'0',1825,175,5,NULL,'54cba24ac9054b79b1e3a728bd508da8'),(NULL,0,'2019-11-29 22:12:41',NULL,1705,'0',1826,175,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:41',NULL,1706,'0',1828,176,16,NULL,'cmdb1-1-8-2'),(NULL,0,'2019-11-29 22:12:42',NULL,1707,'0',1829,176,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,1708,'0',1830,176,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:42',NULL,1709,'0',1831,176,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1710,'0',1832,176,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1711,'0',1833,176,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:42',NULL,1712,'0',1834,176,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1713,'0',1835,176,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:42',NULL,1714,'0',1836,176,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1715,'0',1837,176,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1716,'0',1838,176,15,NULL,'10.1.8.2'),(NULL,0,'2019-11-29 22:12:42',NULL,1717,'0',1839,176,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,1718,'0',1840,176,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,1719,'0',1841,176,5,NULL,'97ed95492c714ce59e8ef6954bc77f56'),(NULL,0,'2019-11-29 22:12:42',NULL,1720,'0',1842,176,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:42',NULL,1721,'0',1844,177,16,NULL,'cmdb1-1-8-3'),(NULL,0,'2019-11-29 22:12:42',NULL,1722,'0',1845,177,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,1723,'0',1846,177,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:42',NULL,1724,'0',1847,177,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1725,'0',1848,177,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1726,'0',1849,177,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:42',NULL,1727,'0',1850,177,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1728,'0',1851,177,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:42',NULL,1729,'0',1852,177,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1730,'0',1853,177,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1731,'0',1854,177,15,NULL,'10.1.8.3'),(NULL,0,'2019-11-29 22:12:42',NULL,1732,'0',1855,177,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,1733,'0',1856,177,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,1734,'0',1857,177,5,NULL,'c8f0bcabdae54f7ab2522e8dfdfb4625'),(NULL,0,'2019-11-29 22:12:42',NULL,1735,'0',1858,177,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:42',NULL,1736,'0',1860,178,16,NULL,'cmdb1-1-8-4'),(NULL,0,'2019-11-29 22:12:42',NULL,1737,'0',1861,178,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,1738,'0',1862,178,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:42',NULL,1739,'0',1863,178,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1740,'0',1864,178,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1741,'0',1865,178,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:42',NULL,1742,'0',1866,178,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1743,'0',1867,178,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:42',NULL,1744,'0',1868,178,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1745,'0',1869,178,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1746,'0',1870,178,15,NULL,'10.1.8.4'),(NULL,0,'2019-11-29 22:12:42',NULL,1747,'0',1871,178,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,1748,'0',1872,178,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,1749,'0',1873,178,5,NULL,'d0947f55eb9c46f0b987b0f506f983e0'),(NULL,0,'2019-11-29 22:12:42',NULL,1750,'0',1874,178,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:42',NULL,1751,'0',1876,179,16,NULL,'cmdb1-1-8-5'),(NULL,0,'2019-11-29 22:12:42',NULL,1752,'0',1877,179,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,1753,'0',1878,179,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:42',NULL,1754,'0',1879,179,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1755,'0',1880,179,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1756,'0',1881,179,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:42',NULL,1757,'0',1882,179,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1758,'0',1883,179,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:42',NULL,1759,'0',1884,179,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1760,'0',1885,179,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1761,'0',1886,179,15,NULL,'10.1.8.5'),(NULL,0,'2019-11-29 22:12:42',NULL,1762,'0',1887,179,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,1763,'0',1888,179,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,1764,'0',1889,179,5,NULL,'5b4ab4d00a5b407592265287a4362fe0'),(NULL,0,'2019-11-29 22:12:42',NULL,1765,'0',1890,179,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:42',NULL,1766,'0',1892,180,16,NULL,'cmdb1-1-8-6'),(NULL,0,'2019-11-29 22:12:42',NULL,1767,'0',1893,180,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,1768,'0',1894,180,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:42',NULL,1769,'0',1895,180,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1770,'0',1896,180,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1771,'0',1897,180,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:42',NULL,1772,'0',1898,180,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1773,'0',1899,180,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:43',NULL,1774,'0',1900,180,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1775,'0',1901,180,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1776,'0',1902,180,15,NULL,'10.1.8.6'),(NULL,0,'2019-11-29 22:12:43',NULL,1777,'0',1903,180,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,1778,'0',1904,180,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,1779,'0',1905,180,5,NULL,'d98821fc54d544af8f3a1f7cfda78623'),(NULL,0,'2019-11-29 22:12:43',NULL,1780,'0',1906,180,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:43',NULL,1781,'0',1908,181,16,NULL,'cmdb1-1-8-7'),(NULL,0,'2019-11-29 22:12:43',NULL,1782,'0',1909,181,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,1783,'0',1910,181,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:43',NULL,1784,'0',1911,181,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1785,'0',1912,181,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1786,'0',1913,181,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:43',NULL,1787,'0',1914,181,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1788,'0',1915,181,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:43',NULL,1789,'0',1916,181,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1790,'0',1917,181,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1791,'0',1918,181,15,NULL,'10.1.8.7'),(NULL,0,'2019-11-29 22:12:43',NULL,1792,'0',1919,181,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,1793,'0',1920,181,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,1794,'0',1921,181,5,NULL,'2f4f6c46827d4f1d861d2617819c665c'),(NULL,0,'2019-11-29 22:12:43',NULL,1795,'0',1922,181,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:43',NULL,1796,'0',1924,182,16,NULL,'cmdb1-1-8-8'),(NULL,0,'2019-11-29 22:12:43',NULL,1797,'0',1925,182,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,1798,'0',1926,182,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:43',NULL,1799,'0',1927,182,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1800,'0',1928,182,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1801,'0',1929,182,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:43',NULL,1802,'0',1930,182,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1803,'0',1931,182,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:43',NULL,1804,'0',1932,182,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1805,'0',1933,182,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1806,'0',1934,182,15,NULL,'10.1.8.8'),(NULL,0,'2019-11-29 22:12:43',NULL,1807,'0',1935,182,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,1808,'0',1936,182,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,1809,'0',1937,182,5,NULL,'6c608ab7dd364b24b9b902885843ed93'),(NULL,0,'2019-11-29 22:12:43',NULL,1810,'0',1938,182,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:43',NULL,1811,'0',1940,183,16,NULL,'cmdb1-1-8-9'),(NULL,0,'2019-11-29 22:12:43',NULL,1812,'0',1941,183,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,1813,'0',1942,183,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:43',NULL,1814,'0',1943,183,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1815,'0',1944,183,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1816,'0',1945,183,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:43',NULL,1817,'0',1946,183,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1818,'0',1947,183,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:43',NULL,1819,'0',1948,183,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1820,'0',1949,183,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1821,'0',1950,183,15,NULL,'10.1.8.9'),(NULL,0,'2019-11-29 22:12:43',NULL,1822,'0',1951,183,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,1823,'0',1952,183,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,1824,'0',1953,183,5,NULL,'20986c66ae4d465d979b03ae73689dff'),(NULL,0,'2019-11-29 22:12:43',NULL,1825,'0',1954,183,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:43',NULL,1826,'0',1956,184,16,NULL,'cmdb1-1-8-10'),(NULL,0,'2019-11-29 22:12:43',NULL,1827,'0',1957,184,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,1828,'0',1958,184,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:43',NULL,1829,'0',1959,184,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1830,'0',1960,184,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1831,'0',1961,184,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:43',NULL,1832,'0',1962,184,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1833,'0',1963,184,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:43',NULL,1834,'0',1964,184,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1835,'0',1965,184,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1836,'0',1966,184,15,NULL,'10.1.8.10'),(NULL,0,'2019-11-29 22:12:43',NULL,1837,'0',1967,184,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,1838,'0',1968,184,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,1839,'0',1969,184,5,NULL,'fe6fcf932d924f2bbb5ccf5dce7d9a82'),(NULL,0,'2019-11-29 22:12:44',NULL,1840,'0',1970,184,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:44',NULL,1841,'0',1972,185,16,NULL,'cmdb1-1-8-11'),(NULL,0,'2019-11-29 22:12:44',NULL,1842,'0',1973,185,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,1843,'0',1974,185,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:44',NULL,1844,'0',1975,185,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1845,'0',1976,185,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1846,'0',1977,185,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:44',NULL,1847,'0',1978,185,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1848,'0',1979,185,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:44',NULL,1849,'0',1980,185,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1850,'0',1981,185,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1851,'0',1982,185,15,NULL,'10.1.8.11'),(NULL,0,'2019-11-29 22:12:44',NULL,1852,'0',1983,185,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,1853,'0',1984,185,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,1854,'0',1985,185,5,NULL,'e9c0884ef0fe4a09a8e4b0490b533d7f'),(NULL,0,'2019-11-29 22:12:44',NULL,1855,'0',1986,185,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:44',NULL,1856,'0',1988,186,16,NULL,'cmdb1-1-8-12'),(NULL,0,'2019-11-29 22:12:44',NULL,1857,'0',1989,186,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,1858,'0',1990,186,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:44',NULL,1859,'0',1991,186,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1860,'0',1992,186,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1861,'0',1993,186,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:44',NULL,1862,'0',1994,186,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1863,'0',1995,186,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:44',NULL,1864,'0',1996,186,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1865,'0',1997,186,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1866,'0',1998,186,15,NULL,'10.1.8.12'),(NULL,0,'2019-11-29 22:12:44',NULL,1867,'0',1999,186,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,1868,'0',2000,186,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,1869,'0',2001,186,5,NULL,'5cda340ac8b54a4ca5509694124f18b7'),(NULL,0,'2019-11-29 22:12:44',NULL,1870,'0',2002,186,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:44',NULL,1871,'0',2004,187,16,NULL,'cmdb1-1-8-13'),(NULL,0,'2019-11-29 22:12:44',NULL,1872,'0',2005,187,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,1873,'0',2006,187,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:44',NULL,1874,'0',2007,187,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1875,'0',2008,187,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1876,'0',2009,187,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:44',NULL,1877,'0',2010,187,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1878,'0',2011,187,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:44',NULL,1879,'0',2012,187,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1880,'0',2013,187,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1881,'0',2014,187,15,NULL,'10.1.8.13'),(NULL,0,'2019-11-29 22:12:44',NULL,1882,'0',2015,187,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,1883,'0',2016,187,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,1884,'0',2017,187,5,NULL,'6ef2254752564a36932ebe9b16a9225b'),(NULL,0,'2019-11-29 22:12:44',NULL,1885,'0',2018,187,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:44',NULL,1886,'0',2020,188,16,NULL,'cmdb1-1-8-14'),(NULL,0,'2019-11-29 22:12:44',NULL,1887,'0',2021,188,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,1888,'0',2022,188,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:44',NULL,1889,'0',2023,188,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1890,'0',2024,188,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1891,'0',2025,188,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:44',NULL,1892,'0',2026,188,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1893,'0',2027,188,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:44',NULL,1894,'0',2028,188,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1895,'0',2029,188,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1896,'0',2030,188,15,NULL,'10.1.8.14'),(NULL,0,'2019-11-29 22:12:44',NULL,1897,'0',2031,188,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,1898,'0',2032,188,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,1899,'0',2033,188,5,NULL,'c19e69a4abe2495b9a54574be1d047f8'),(NULL,0,'2019-11-29 22:12:44',NULL,1900,'0',2034,188,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:45',NULL,1901,'0',2036,189,16,NULL,'cmdb1-1-8-15'),(NULL,0,'2019-11-29 22:12:45',NULL,1902,'0',2037,189,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,1903,'0',2038,189,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:45',NULL,1904,'0',2039,189,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1905,'0',2040,189,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1906,'0',2041,189,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:45',NULL,1907,'0',2042,189,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1908,'0',2043,189,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:45',NULL,1909,'0',2044,189,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1910,'0',2045,189,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1911,'0',2046,189,15,NULL,'10.1.8.15'),(NULL,0,'2019-11-29 22:12:45',NULL,1912,'0',2047,189,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,1913,'0',2048,189,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,1914,'0',2049,189,5,NULL,'7a88c92bc3944ce9bde19d9ace6fe2d2'),(NULL,0,'2019-11-29 22:12:45',NULL,1915,'0',2050,189,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:45',NULL,1916,'0',2052,190,16,NULL,'cmdb1-1-8-16'),(NULL,0,'2019-11-29 22:12:45',NULL,1917,'0',2053,190,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,1918,'0',2054,190,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:45',NULL,1919,'0',2055,190,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1920,'0',2056,190,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1921,'0',2057,190,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:45',NULL,1922,'0',2058,190,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1923,'0',2059,190,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:45',NULL,1924,'0',2060,190,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1925,'0',2061,190,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1926,'0',2062,190,15,NULL,'10.1.8.16'),(NULL,0,'2019-11-29 22:12:45',NULL,1927,'0',2063,190,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,1928,'0',2064,190,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,1929,'0',2065,190,5,NULL,'361cd6e87c9a4dd1b07392c3e47acdc9'),(NULL,0,'2019-11-29 22:12:45',NULL,1930,'0',2066,190,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:45',NULL,1931,'0',2068,191,3,NULL,'产品线1-2'),(NULL,0,'2019-11-29 22:12:45',NULL,1932,'0',2070,192,4,NULL,'App1-2-1'),(NULL,0,'2019-11-29 22:12:45',NULL,1933,'0',2072,193,16,NULL,'cmdb1-2-1-1'),(NULL,0,'2019-11-29 22:12:45',NULL,1934,'0',2073,193,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,1935,'0',2074,193,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:45',NULL,1936,'0',2075,193,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1937,'0',2076,193,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1938,'0',2077,193,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:45',NULL,1939,'0',2078,193,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1940,'0',2079,193,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:45',NULL,1941,'0',2080,193,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1942,'0',2081,193,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1943,'0',2082,193,15,NULL,'10.2.1.1'),(NULL,0,'2019-11-29 22:12:45',NULL,1944,'0',2083,193,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,1945,'0',2084,193,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,1946,'0',2085,193,5,NULL,'38d16dfa27f44db39a5d838a1e435969'),(NULL,0,'2019-11-29 22:12:45',NULL,1947,'0',2086,193,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:45',NULL,1948,'0',2088,194,16,NULL,'cmdb1-2-1-2'),(NULL,0,'2019-11-29 22:12:45',NULL,1949,'0',2089,194,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,1950,'0',2090,194,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:45',NULL,1951,'0',2091,194,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1952,'0',2092,194,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1953,'0',2093,194,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:45',NULL,1954,'0',2094,194,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1955,'0',2095,194,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:45',NULL,1956,'0',2096,194,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1957,'0',2097,194,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1958,'0',2098,194,15,NULL,'10.2.1.2'),(NULL,0,'2019-11-29 22:12:45',NULL,1959,'0',2099,194,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,1960,'0',2100,194,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,1961,'0',2101,194,5,NULL,'47dea1ab28e84dea963422a3fa5ffb9e'),(NULL,0,'2019-11-29 22:12:46',NULL,1962,'0',2102,194,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:46',NULL,1963,'0',2104,195,16,NULL,'cmdb1-2-1-3'),(NULL,0,'2019-11-29 22:12:46',NULL,1964,'0',2105,195,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,1965,'0',2106,195,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:46',NULL,1966,'0',2107,195,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1967,'0',2108,195,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1968,'0',2109,195,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:46',NULL,1969,'0',2110,195,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1970,'0',2111,195,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:46',NULL,1971,'0',2112,195,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1972,'0',2113,195,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1973,'0',2114,195,15,NULL,'10.2.1.3'),(NULL,0,'2019-11-29 22:12:46',NULL,1974,'0',2115,195,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,1975,'0',2116,195,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,1976,'0',2117,195,5,NULL,'15b3fddb912342bbadbda03491ab2f23'),(NULL,0,'2019-11-29 22:12:46',NULL,1977,'0',2118,195,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:46',NULL,1978,'0',2120,196,16,NULL,'cmdb1-2-1-4'),(NULL,0,'2019-11-29 22:12:46',NULL,1979,'0',2121,196,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,1980,'0',2122,196,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:46',NULL,1981,'0',2123,196,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1982,'0',2124,196,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1983,'0',2125,196,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:46',NULL,1984,'0',2126,196,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1985,'0',2127,196,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:46',NULL,1986,'0',2128,196,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1987,'0',2129,196,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1988,'0',2130,196,15,NULL,'10.2.1.4'),(NULL,0,'2019-11-29 22:12:46',NULL,1989,'0',2131,196,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,1990,'0',2132,196,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,1991,'0',2133,196,5,NULL,'e10767ad6b154e05a4c3660a5031e351'),(NULL,0,'2019-11-29 22:12:46',NULL,1992,'0',2134,196,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:46',NULL,1993,'0',2136,197,16,NULL,'cmdb1-2-1-5'),(NULL,0,'2019-11-29 22:12:46',NULL,1994,'0',2137,197,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,1995,'0',2138,197,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:46',NULL,1996,'0',2139,197,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1997,'0',2140,197,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1998,'0',2141,197,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:46',NULL,1999,'0',2142,197,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,2000,'0',2143,197,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:46',NULL,2001,'0',2144,197,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,2002,'0',2145,197,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,2003,'0',2146,197,15,NULL,'10.2.1.5'),(NULL,0,'2019-11-29 22:12:46',NULL,2004,'0',2147,197,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,2005,'0',2148,197,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,2006,'0',2149,197,5,NULL,'7762d96a85944720b1cd299022f5aa15'),(NULL,0,'2019-11-29 22:12:46',NULL,2007,'0',2150,197,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:46',NULL,2008,'0',2152,198,16,NULL,'cmdb1-2-1-6'),(NULL,0,'2019-11-29 22:12:46',NULL,2009,'0',2153,198,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,2010,'0',2154,198,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:46',NULL,2011,'0',2155,198,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,2012,'0',2156,198,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,2013,'0',2157,198,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:46',NULL,2014,'0',2158,198,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,2015,'0',2159,198,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:46',NULL,2016,'0',2160,198,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,2017,'0',2161,198,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,2018,'0',2162,198,15,NULL,'10.2.1.6'),(NULL,0,'2019-11-29 22:12:46',NULL,2019,'0',2163,198,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,2020,'0',2164,198,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,2021,'0',2165,198,5,NULL,'911b7b2374a845a9bdac8f990de74d7a'),(NULL,0,'2019-11-29 22:12:46',NULL,2022,'0',2166,198,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:47',NULL,2023,'0',2168,199,16,NULL,'cmdb1-2-1-7'),(NULL,0,'2019-11-29 22:12:47',NULL,2024,'0',2169,199,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,2025,'0',2170,199,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:47',NULL,2026,'0',2171,199,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,2027,'0',2172,199,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,2028,'0',2173,199,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:47',NULL,2029,'0',2174,199,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,2030,'0',2175,199,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:47',NULL,2031,'0',2176,199,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,2032,'0',2177,199,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,2033,'0',2178,199,15,NULL,'10.2.1.7'),(NULL,0,'2019-11-29 22:12:47',NULL,2034,'0',2179,199,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,2035,'0',2180,199,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,2036,'0',2181,199,5,NULL,'8d0ab4bf7d6d4e0a80f74688961383f6'),(NULL,0,'2019-11-29 22:12:47',NULL,2037,'0',2182,199,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:47',NULL,2038,'0',2184,200,16,NULL,'cmdb1-2-1-8'),(NULL,0,'2019-11-29 22:12:47',NULL,2039,'0',2185,200,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,2040,'0',2186,200,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:47',NULL,2041,'0',2187,200,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,2042,'0',2188,200,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,2043,'0',2189,200,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:47',NULL,2044,'0',2190,200,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,2045,'0',2191,200,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:47',NULL,2046,'0',2192,200,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,2047,'0',2193,200,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,2048,'0',2194,200,15,NULL,'10.2.1.8'),(NULL,0,'2019-11-29 22:12:47',NULL,2049,'0',2195,200,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,2050,'0',2196,200,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,2051,'0',2197,200,5,NULL,'9912d08b79bc489e90651228986ffbe2'),(NULL,0,'2019-11-29 22:12:47',NULL,2052,'0',2198,200,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:47',NULL,2053,'0',2200,201,16,NULL,'cmdb1-2-1-9'),(NULL,0,'2019-11-29 22:12:47',NULL,2054,'0',2201,201,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,2055,'0',2202,201,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:47',NULL,2056,'0',2203,201,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,2057,'0',2204,201,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,2058,'0',2205,201,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:47',NULL,2059,'0',2206,201,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,2060,'0',2207,201,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:47',NULL,2061,'0',2208,201,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,2062,'0',2209,201,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,2063,'0',2210,201,15,NULL,'10.2.1.9'),(NULL,0,'2019-11-29 22:12:47',NULL,2064,'0',2211,201,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,2065,'0',2212,201,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,2066,'0',2213,201,5,NULL,'0b0b6e52e57a4ce78b5782d3fca855af'),(NULL,0,'2019-11-29 22:12:47',NULL,2067,'0',2214,201,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:47',NULL,2068,'0',2216,202,16,NULL,'cmdb1-2-1-10'),(NULL,0,'2019-11-29 22:12:47',NULL,2069,'0',2217,202,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,2070,'0',2218,202,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:47',NULL,2071,'0',2219,202,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,2072,'0',2220,202,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,2073,'0',2221,202,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:47',NULL,2074,'0',2222,202,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,2075,'0',2223,202,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:47',NULL,2076,'0',2224,202,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,2077,'0',2225,202,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,2078,'0',2226,202,15,NULL,'10.2.1.10'),(NULL,0,'2019-11-29 22:12:47',NULL,2079,'0',2227,202,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,2080,'0',2228,202,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,2081,'0',2229,202,5,NULL,'eb485d5a9bb4429487b7585b4fcc3ff9'),(NULL,0,'2019-11-29 22:12:47',NULL,2082,'0',2230,202,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:47',NULL,2083,'0',2232,203,16,NULL,'cmdb1-2-1-11'),(NULL,0,'2019-11-29 22:12:47',NULL,2084,'0',2233,203,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,2085,'0',2234,203,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:48',NULL,2086,'0',2235,203,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,2087,'0',2236,203,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,2088,'0',2237,203,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:48',NULL,2089,'0',2238,203,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,2090,'0',2239,203,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:48',NULL,2091,'0',2240,203,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,2092,'0',2241,203,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,2093,'0',2242,203,15,NULL,'10.2.1.11'),(NULL,0,'2019-11-29 22:12:48',NULL,2094,'0',2243,203,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,2095,'0',2244,203,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,2096,'0',2245,203,5,NULL,'c723da3ff2534fbbb32fb92255dd045d'),(NULL,0,'2019-11-29 22:12:48',NULL,2097,'0',2246,203,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:48',NULL,2098,'0',2248,204,16,NULL,'cmdb1-2-1-12'),(NULL,0,'2019-11-29 22:12:48',NULL,2099,'0',2249,204,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,2100,'0',2250,204,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:48',NULL,2101,'0',2251,204,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,2102,'0',2252,204,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,2103,'0',2253,204,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:48',NULL,2104,'0',2254,204,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,2105,'0',2255,204,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:48',NULL,2106,'0',2256,204,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,2107,'0',2257,204,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,2108,'0',2258,204,15,NULL,'10.2.1.12'),(NULL,0,'2019-11-29 22:12:48',NULL,2109,'0',2259,204,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,2110,'0',2260,204,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,2111,'0',2261,204,5,NULL,'44e5bf35026f4442b98be5b6699255e7'),(NULL,0,'2019-11-29 22:12:48',NULL,2112,'0',2262,204,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:48',NULL,2113,'0',2264,205,16,NULL,'cmdb1-2-1-13'),(NULL,0,'2019-11-29 22:12:48',NULL,2114,'0',2265,205,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,2115,'0',2266,205,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:48',NULL,2116,'0',2267,205,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,2117,'0',2268,205,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,2118,'0',2269,205,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:48',NULL,2119,'0',2270,205,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,2120,'0',2271,205,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:48',NULL,2121,'0',2272,205,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,2122,'0',2273,205,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,2123,'0',2274,205,15,NULL,'10.2.1.13'),(NULL,0,'2019-11-29 22:12:48',NULL,2124,'0',2275,205,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,2125,'0',2276,205,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,2126,'0',2277,205,5,NULL,'7c4b8f30e3654b03a1090f195f1858fb'),(NULL,0,'2019-11-29 22:12:48',NULL,2127,'0',2278,205,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:48',NULL,2128,'0',2280,206,16,NULL,'cmdb1-2-1-14'),(NULL,0,'2019-11-29 22:12:48',NULL,2129,'0',2281,206,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,2130,'0',2282,206,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:48',NULL,2131,'0',2283,206,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,2132,'0',2284,206,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,2133,'0',2285,206,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:48',NULL,2134,'0',2286,206,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,2135,'0',2287,206,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:48',NULL,2136,'0',2288,206,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,2137,'0',2289,206,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,2138,'0',2290,206,15,NULL,'10.2.1.14'),(NULL,0,'2019-11-29 22:12:48',NULL,2139,'0',2291,206,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,2140,'0',2292,206,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,2141,'0',2293,206,5,NULL,'a6daa6ef1a3540bcaf3a82548db4b44b'),(NULL,0,'2019-11-29 22:12:48',NULL,2142,'0',2294,206,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:48',NULL,2143,'0',2296,207,16,NULL,'cmdb1-2-1-15'),(NULL,0,'2019-11-29 22:12:48',NULL,2144,'0',2297,207,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,2145,'0',2298,207,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:48',NULL,2146,'0',2299,207,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,2147,'0',2300,207,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,2148,'0',2301,207,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:48',NULL,2149,'0',2302,207,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,2150,'0',2303,207,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:48',NULL,2151,'0',2304,207,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,2152,'0',2305,207,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,2153,'0',2306,207,15,NULL,'10.2.1.15'),(NULL,0,'2019-11-29 22:12:49',NULL,2154,'0',2307,207,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,2155,'0',2308,207,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,2156,'0',2309,207,5,NULL,'5a55f873445d4bee9acf404e6bd56db4'),(NULL,0,'2019-11-29 22:12:49',NULL,2157,'0',2310,207,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:49',NULL,2158,'0',2312,208,16,NULL,'cmdb1-2-1-16'),(NULL,0,'2019-11-29 22:12:49',NULL,2159,'0',2313,208,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,2160,'0',2314,208,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:49',NULL,2161,'0',2315,208,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,2162,'0',2316,208,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,2163,'0',2317,208,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:49',NULL,2164,'0',2318,208,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,2165,'0',2319,208,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:49',NULL,2166,'0',2320,208,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,2167,'0',2321,208,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,2168,'0',2322,208,15,NULL,'10.2.1.16'),(NULL,0,'2019-11-29 22:12:49',NULL,2169,'0',2323,208,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,2170,'0',2324,208,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,2171,'0',2325,208,5,NULL,'1f29e13d92b149e6a0c8621def400af9'),(NULL,0,'2019-11-29 22:12:49',NULL,2172,'0',2326,208,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:49',NULL,2173,'0',2328,209,4,NULL,'App1-2-2'),(NULL,0,'2019-11-29 22:12:49',NULL,2174,'0',2330,210,16,NULL,'cmdb1-2-2-1'),(NULL,0,'2019-11-29 22:12:49',NULL,2175,'0',2331,210,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,2176,'0',2332,210,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:49',NULL,2177,'0',2333,210,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,2178,'0',2334,210,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,2179,'0',2335,210,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:49',NULL,2180,'0',2336,210,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,2181,'0',2337,210,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:49',NULL,2182,'0',2338,210,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,2183,'0',2339,210,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,2184,'0',2340,210,15,NULL,'10.2.2.1'),(NULL,0,'2019-11-29 22:12:49',NULL,2185,'0',2341,210,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,2186,'0',2342,210,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,2187,'0',2343,210,5,NULL,'269a4a1d4c8a42c195a48bd52e81515b'),(NULL,0,'2019-11-29 22:12:49',NULL,2188,'0',2344,210,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:49',NULL,2189,'0',2346,211,16,NULL,'cmdb1-2-2-2'),(NULL,0,'2019-11-29 22:12:49',NULL,2190,'0',2347,211,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,2191,'0',2348,211,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:49',NULL,2192,'0',2349,211,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,2193,'0',2350,211,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,2194,'0',2351,211,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:49',NULL,2195,'0',2352,211,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,2196,'0',2353,211,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:49',NULL,2197,'0',2354,211,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,2198,'0',2355,211,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,2199,'0',2356,211,15,NULL,'10.2.2.2'),(NULL,0,'2019-11-29 22:12:49',NULL,2200,'0',2357,211,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,2201,'0',2358,211,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,2202,'0',2359,211,5,NULL,'bc530af7a1a14611b22092fe179ac3e3'),(NULL,0,'2019-11-29 22:12:49',NULL,2203,'0',2360,211,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:49',NULL,2204,'0',2362,212,16,NULL,'cmdb1-2-2-3'),(NULL,0,'2019-11-29 22:12:49',NULL,2205,'0',2363,212,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,2206,'0',2364,212,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:49',NULL,2207,'0',2365,212,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,2208,'0',2366,212,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,2209,'0',2367,212,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:49',NULL,2210,'0',2368,212,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,2211,'0',2369,212,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:50',NULL,2212,'0',2370,212,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2213,'0',2371,212,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2214,'0',2372,212,15,NULL,'10.2.2.3'),(NULL,0,'2019-11-29 22:12:50',NULL,2215,'0',2373,212,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,2216,'0',2374,212,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,2217,'0',2375,212,5,NULL,'c174da2b22f244e0841c40f863b3bb50'),(NULL,0,'2019-11-29 22:12:50',NULL,2218,'0',2376,212,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:50',NULL,2219,'0',2378,213,16,NULL,'cmdb1-2-2-4'),(NULL,0,'2019-11-29 22:12:50',NULL,2220,'0',2379,213,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,2221,'0',2380,213,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:50',NULL,2222,'0',2381,213,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2223,'0',2382,213,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2224,'0',2383,213,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:50',NULL,2225,'0',2384,213,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2226,'0',2385,213,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:50',NULL,2227,'0',2386,213,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2228,'0',2387,213,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2229,'0',2388,213,15,NULL,'10.2.2.4'),(NULL,0,'2019-11-29 22:12:50',NULL,2230,'0',2389,213,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,2231,'0',2390,213,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,2232,'0',2391,213,5,NULL,'58abb77c298846be9533dde009ba5da1'),(NULL,0,'2019-11-29 22:12:50',NULL,2233,'0',2392,213,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:50',NULL,2234,'0',2394,214,16,NULL,'cmdb1-2-2-5'),(NULL,0,'2019-11-29 22:12:50',NULL,2235,'0',2395,214,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,2236,'0',2396,214,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:50',NULL,2237,'0',2397,214,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2238,'0',2398,214,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2239,'0',2399,214,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:50',NULL,2240,'0',2400,214,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2241,'0',2401,214,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:50',NULL,2242,'0',2402,214,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2243,'0',2403,214,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2244,'0',2404,214,15,NULL,'10.2.2.5'),(NULL,0,'2019-11-29 22:12:50',NULL,2245,'0',2405,214,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,2246,'0',2406,214,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,2247,'0',2407,214,5,NULL,'4f700fffaad84d9a8bfe7ab1231e7779'),(NULL,0,'2019-11-29 22:12:50',NULL,2248,'0',2408,214,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:50',NULL,2249,'0',2410,215,16,NULL,'cmdb1-2-2-6'),(NULL,0,'2019-11-29 22:12:50',NULL,2250,'0',2411,215,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,2251,'0',2412,215,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:50',NULL,2252,'0',2413,215,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2253,'0',2414,215,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2254,'0',2415,215,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:50',NULL,2255,'0',2416,215,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2256,'0',2417,215,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:50',NULL,2257,'0',2418,215,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2258,'0',2419,215,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2259,'0',2420,215,15,NULL,'10.2.2.6'),(NULL,0,'2019-11-29 22:12:50',NULL,2260,'0',2421,215,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,2261,'0',2422,215,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,2262,'0',2423,215,5,NULL,'2d9a2e0629264d2ba07070b44494abb6'),(NULL,0,'2019-11-29 22:12:50',NULL,2263,'0',2424,215,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:50',NULL,2264,'0',2426,216,16,NULL,'cmdb1-2-2-7'),(NULL,0,'2019-11-29 22:12:50',NULL,2265,'0',2427,216,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,2266,'0',2428,216,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:50',NULL,2267,'0',2429,216,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2268,'0',2430,216,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2269,'0',2431,216,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:50',NULL,2270,'0',2432,216,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2271,'0',2433,216,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:50',NULL,2272,'0',2434,216,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2273,'0',2435,216,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2274,'0',2436,216,15,NULL,'10.2.2.7'),(NULL,0,'2019-11-29 22:12:50',NULL,2275,'0',2437,216,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,2276,'0',2438,216,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,2277,'0',2439,216,5,NULL,'b792163ebbdf437d892c23d13b310bee'),(NULL,0,'2019-11-29 22:12:51',NULL,2278,'0',2440,216,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:51',NULL,2279,'0',2442,217,16,NULL,'cmdb1-2-2-8'),(NULL,0,'2019-11-29 22:12:51',NULL,2280,'0',2443,217,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,2281,'0',2444,217,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:51',NULL,2282,'0',2445,217,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2283,'0',2446,217,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2284,'0',2447,217,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:51',NULL,2285,'0',2448,217,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2286,'0',2449,217,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:51',NULL,2287,'0',2450,217,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2288,'0',2451,217,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2289,'0',2452,217,15,NULL,'10.2.2.8'),(NULL,0,'2019-11-29 22:12:51',NULL,2290,'0',2453,217,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,2291,'0',2454,217,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,2292,'0',2455,217,5,NULL,'b1850aeb2e9045d29cfb547c0c7c2c86'),(NULL,0,'2019-11-29 22:12:51',NULL,2293,'0',2456,217,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:51',NULL,2294,'0',2458,218,16,NULL,'cmdb1-2-2-9'),(NULL,0,'2019-11-29 22:12:51',NULL,2295,'0',2459,218,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,2296,'0',2460,218,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:51',NULL,2297,'0',2461,218,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2298,'0',2462,218,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2299,'0',2463,218,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:51',NULL,2300,'0',2464,218,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2301,'0',2465,218,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:51',NULL,2302,'0',2466,218,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2303,'0',2467,218,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2304,'0',2468,218,15,NULL,'10.2.2.9'),(NULL,0,'2019-11-29 22:12:51',NULL,2305,'0',2469,218,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,2306,'0',2470,218,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,2307,'0',2471,218,5,NULL,'e72c27733ca14beab43fc82ba7dc4cea'),(NULL,0,'2019-11-29 22:12:51',NULL,2308,'0',2472,218,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:51',NULL,2309,'0',2474,219,16,NULL,'cmdb1-2-2-10'),(NULL,0,'2019-11-29 22:12:51',NULL,2310,'0',2475,219,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,2311,'0',2476,219,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:51',NULL,2312,'0',2477,219,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2313,'0',2478,219,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2314,'0',2479,219,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:51',NULL,2315,'0',2480,219,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2316,'0',2481,219,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:51',NULL,2317,'0',2482,219,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2318,'0',2483,219,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2319,'0',2484,219,15,NULL,'10.2.2.10'),(NULL,0,'2019-11-29 22:12:51',NULL,2320,'0',2485,219,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,2321,'0',2486,219,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,2322,'0',2487,219,5,NULL,'9ef89b51660e45808b035ec8ef81e66b'),(NULL,0,'2019-11-29 22:12:51',NULL,2323,'0',2488,219,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:51',NULL,2324,'0',2490,220,16,NULL,'cmdb1-2-2-11'),(NULL,0,'2019-11-29 22:12:51',NULL,2325,'0',2491,220,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,2326,'0',2492,220,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:51',NULL,2327,'0',2493,220,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2328,'0',2494,220,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2329,'0',2495,220,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:51',NULL,2330,'0',2496,220,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2331,'0',2497,220,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:51',NULL,2332,'0',2498,220,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2333,'0',2499,220,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2334,'0',2500,220,15,NULL,'10.2.2.11'),(NULL,0,'2019-11-29 22:12:51',NULL,2335,'0',2501,220,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,2336,'0',2502,220,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,2337,'0',2503,220,5,NULL,'c134f3e8978f4c27822efaa7f03a4a1a'),(NULL,0,'2019-11-29 22:12:51',NULL,2338,'0',2504,220,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:52',NULL,2339,'0',2506,221,16,NULL,'cmdb1-2-2-12'),(NULL,0,'2019-11-29 22:12:52',NULL,2340,'0',2507,221,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,2341,'0',2508,221,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:52',NULL,2342,'0',2509,221,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2343,'0',2510,221,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2344,'0',2511,221,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:52',NULL,2345,'0',2512,221,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2346,'0',2513,221,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:52',NULL,2347,'0',2514,221,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2348,'0',2515,221,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2349,'0',2516,221,15,NULL,'10.2.2.12'),(NULL,0,'2019-11-29 22:12:52',NULL,2350,'0',2517,221,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,2351,'0',2518,221,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,2352,'0',2519,221,5,NULL,'65d1f480e8a74150a736b4bd820bb9a0'),(NULL,0,'2019-11-29 22:12:52',NULL,2353,'0',2520,221,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:52',NULL,2354,'0',2522,222,16,NULL,'cmdb1-2-2-13'),(NULL,0,'2019-11-29 22:12:52',NULL,2355,'0',2523,222,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,2356,'0',2524,222,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:52',NULL,2357,'0',2525,222,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2358,'0',2526,222,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2359,'0',2527,222,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:52',NULL,2360,'0',2528,222,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2361,'0',2529,222,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:52',NULL,2362,'0',2530,222,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2363,'0',2531,222,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2364,'0',2532,222,15,NULL,'10.2.2.13'),(NULL,0,'2019-11-29 22:12:52',NULL,2365,'0',2533,222,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,2366,'0',2534,222,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,2367,'0',2535,222,5,NULL,'09a9287b5fa04b338452630a9db50019'),(NULL,0,'2019-11-29 22:12:52',NULL,2368,'0',2536,222,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:52',NULL,2369,'0',2538,223,16,NULL,'cmdb1-2-2-14'),(NULL,0,'2019-11-29 22:12:52',NULL,2370,'0',2539,223,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,2371,'0',2540,223,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:52',NULL,2372,'0',2541,223,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2373,'0',2542,223,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2374,'0',2543,223,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:52',NULL,2375,'0',2544,223,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2376,'0',2545,223,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:52',NULL,2377,'0',2546,223,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2378,'0',2547,223,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2379,'0',2548,223,15,NULL,'10.2.2.14'),(NULL,0,'2019-11-29 22:12:52',NULL,2380,'0',2549,223,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,2381,'0',2550,223,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,2382,'0',2551,223,5,NULL,'89fd6e6244f64dcf8664610aed8b1824'),(NULL,0,'2019-11-29 22:12:52',NULL,2383,'0',2552,223,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:52',NULL,2384,'0',2554,224,16,NULL,'cmdb1-2-2-15'),(NULL,0,'2019-11-29 22:12:52',NULL,2385,'0',2555,224,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,2386,'0',2556,224,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:52',NULL,2387,'0',2557,224,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2388,'0',2558,224,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2389,'0',2559,224,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:52',NULL,2390,'0',2560,224,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2391,'0',2561,224,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:52',NULL,2392,'0',2562,224,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2393,'0',2563,224,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2394,'0',2564,224,15,NULL,'10.2.2.15'),(NULL,0,'2019-11-29 22:12:52',NULL,2395,'0',2565,224,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,2396,'0',2566,224,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,2397,'0',2567,224,5,NULL,'c99523c8a0994d119b15bead8d05b3ee'),(NULL,0,'2019-11-29 22:12:52',NULL,2398,'0',2568,224,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:53',NULL,2399,'0',2570,225,16,NULL,'cmdb1-2-2-16'),(NULL,0,'2019-11-29 22:12:53',NULL,2400,'0',2571,225,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,2401,'0',2572,225,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:53',NULL,2402,'0',2573,225,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2403,'0',2574,225,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2404,'0',2575,225,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:53',NULL,2405,'0',2576,225,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2406,'0',2577,225,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:53',NULL,2407,'0',2578,225,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2408,'0',2579,225,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2409,'0',2580,225,15,NULL,'10.2.2.16'),(NULL,0,'2019-11-29 22:12:53',NULL,2410,'0',2581,225,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,2411,'0',2582,225,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,2412,'0',2583,225,5,NULL,'4838cb9e23a64592a84a4aa6f3c7e7de'),(NULL,0,'2019-11-29 22:12:53',NULL,2413,'0',2584,225,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:53',NULL,2414,'0',2586,226,4,NULL,'App1-2-3'),(NULL,0,'2019-11-29 22:12:53',NULL,2415,'0',2588,227,16,NULL,'cmdb1-2-3-1'),(NULL,0,'2019-11-29 22:12:53',NULL,2416,'0',2589,227,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,2417,'0',2590,227,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:53',NULL,2418,'0',2591,227,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2419,'0',2592,227,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2420,'0',2593,227,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:53',NULL,2421,'0',2594,227,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2422,'0',2595,227,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:53',NULL,2423,'0',2596,227,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2424,'0',2597,227,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2425,'0',2598,227,15,NULL,'10.2.3.1'),(NULL,0,'2019-11-29 22:12:53',NULL,2426,'0',2599,227,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,2427,'0',2600,227,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,2428,'0',2601,227,5,NULL,'6a84fd010e96429e9d2d0fc8585a4fc9'),(NULL,0,'2019-11-29 22:12:53',NULL,2429,'0',2602,227,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:53',NULL,2430,'0',2604,228,16,NULL,'cmdb1-2-3-2'),(NULL,0,'2019-11-29 22:12:53',NULL,2431,'0',2605,228,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,2432,'0',2606,228,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:53',NULL,2433,'0',2607,228,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2434,'0',2608,228,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2435,'0',2609,228,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:53',NULL,2436,'0',2610,228,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2437,'0',2611,228,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:53',NULL,2438,'0',2612,228,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2439,'0',2613,228,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2440,'0',2614,228,15,NULL,'10.2.3.2'),(NULL,0,'2019-11-29 22:12:53',NULL,2441,'0',2615,228,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,2442,'0',2616,228,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,2443,'0',2617,228,5,NULL,'6d02c8d4219f428b94d4aeada7d9a9a6'),(NULL,0,'2019-11-29 22:12:53',NULL,2444,'0',2618,228,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:53',NULL,2445,'0',2620,229,16,NULL,'cmdb1-2-3-3'),(NULL,0,'2019-11-29 22:12:53',NULL,2446,'0',2621,229,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,2447,'0',2622,229,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:53',NULL,2448,'0',2623,229,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2449,'0',2624,229,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2450,'0',2625,229,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:53',NULL,2451,'0',2626,229,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2452,'0',2627,229,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:53',NULL,2453,'0',2628,229,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2454,'0',2629,229,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2455,'0',2630,229,15,NULL,'10.2.3.3'),(NULL,0,'2019-11-29 22:12:53',NULL,2456,'0',2631,229,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,2457,'0',2632,229,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,2458,'0',2633,229,5,NULL,'94aa5a91c7a84571a7b27ee141de2623'),(NULL,0,'2019-11-29 22:12:53',NULL,2459,'0',2634,229,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:54',NULL,2460,'0',2636,230,16,NULL,'cmdb1-2-3-4'),(NULL,0,'2019-11-29 22:12:54',NULL,2461,'0',2637,230,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,2462,'0',2638,230,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:54',NULL,2463,'0',2639,230,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2464,'0',2640,230,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2465,'0',2641,230,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:54',NULL,2466,'0',2642,230,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2467,'0',2643,230,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:54',NULL,2468,'0',2644,230,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2469,'0',2645,230,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2470,'0',2646,230,15,NULL,'10.2.3.4'),(NULL,0,'2019-11-29 22:12:54',NULL,2471,'0',2647,230,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,2472,'0',2648,230,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,2473,'0',2649,230,5,NULL,'4867c2608c07473189ec146d64cdbb89'),(NULL,0,'2019-11-29 22:12:54',NULL,2474,'0',2650,230,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:54',NULL,2475,'0',2652,231,16,NULL,'cmdb1-2-3-5'),(NULL,0,'2019-11-29 22:12:54',NULL,2476,'0',2653,231,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,2477,'0',2654,231,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:54',NULL,2478,'0',2655,231,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2479,'0',2656,231,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2480,'0',2657,231,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:54',NULL,2481,'0',2658,231,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2482,'0',2659,231,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:54',NULL,2483,'0',2660,231,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2484,'0',2661,231,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2485,'0',2662,231,15,NULL,'10.2.3.5'),(NULL,0,'2019-11-29 22:12:54',NULL,2486,'0',2663,231,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,2487,'0',2664,231,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,2488,'0',2665,231,5,NULL,'e0f4ff4ce80349c8ad0bd1287ff6ddff'),(NULL,0,'2019-11-29 22:12:54',NULL,2489,'0',2666,231,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:54',NULL,2490,'0',2668,232,16,NULL,'cmdb1-2-3-6'),(NULL,0,'2019-11-29 22:12:54',NULL,2491,'0',2669,232,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,2492,'0',2670,232,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:54',NULL,2493,'0',2671,232,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2494,'0',2672,232,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2495,'0',2673,232,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:54',NULL,2496,'0',2674,232,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2497,'0',2675,232,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:54',NULL,2498,'0',2676,232,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2499,'0',2677,232,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2500,'0',2678,232,15,NULL,'10.2.3.6'),(NULL,0,'2019-11-29 22:12:54',NULL,2501,'0',2679,232,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,2502,'0',2680,232,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,2503,'0',2681,232,5,NULL,'ab3524a2389f4e6c92bd822cc6944df1'),(NULL,0,'2019-11-29 22:12:54',NULL,2504,'0',2682,232,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:54',NULL,2505,'0',2684,233,16,NULL,'cmdb1-2-3-7'),(NULL,0,'2019-11-29 22:12:54',NULL,2506,'0',2685,233,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,2507,'0',2686,233,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:54',NULL,2508,'0',2687,233,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2509,'0',2688,233,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2510,'0',2689,233,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:54',NULL,2511,'0',2690,233,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2512,'0',2691,233,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:54',NULL,2513,'0',2692,233,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2514,'0',2693,233,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2515,'0',2694,233,15,NULL,'10.2.3.7'),(NULL,0,'2019-11-29 22:12:54',NULL,2516,'0',2695,233,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,2517,'0',2696,233,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,2518,'0',2697,233,5,NULL,'9706e308382c4e8fbe2803b4a6ecbfe5'),(NULL,0,'2019-11-29 22:12:54',NULL,2519,'0',2698,233,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:54',NULL,2520,'0',2700,234,16,NULL,'cmdb1-2-3-8'),(NULL,0,'2019-11-29 22:12:54',NULL,2521,'0',2701,234,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,2522,'0',2702,234,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:54',NULL,2523,'0',2703,234,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2524,'0',2704,234,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2525,'0',2705,234,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:55',NULL,2526,'0',2706,234,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2527,'0',2707,234,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:55',NULL,2528,'0',2708,234,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2529,'0',2709,234,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2530,'0',2710,234,15,NULL,'10.2.3.8'),(NULL,0,'2019-11-29 22:12:55',NULL,2531,'0',2711,234,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,2532,'0',2712,234,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,2533,'0',2713,234,5,NULL,'3ebdc26582ba405781a3e2c18216b962'),(NULL,0,'2019-11-29 22:12:55',NULL,2534,'0',2714,234,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:55',NULL,2535,'0',2716,235,16,NULL,'cmdb1-2-3-9'),(NULL,0,'2019-11-29 22:12:55',NULL,2536,'0',2717,235,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,2537,'0',2718,235,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:55',NULL,2538,'0',2719,235,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2539,'0',2720,235,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2540,'0',2721,235,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:55',NULL,2541,'0',2722,235,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2542,'0',2723,235,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:55',NULL,2543,'0',2724,235,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2544,'0',2725,235,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2545,'0',2726,235,15,NULL,'10.2.3.9'),(NULL,0,'2019-11-29 22:12:55',NULL,2546,'0',2727,235,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,2547,'0',2728,235,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,2548,'0',2729,235,5,NULL,'78a4bc645ee54644b4d67679d7614aeb'),(NULL,0,'2019-11-29 22:12:55',NULL,2549,'0',2730,235,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:55',NULL,2550,'0',2732,236,16,NULL,'cmdb1-2-3-10'),(NULL,0,'2019-11-29 22:12:55',NULL,2551,'0',2733,236,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,2552,'0',2734,236,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:55',NULL,2553,'0',2735,236,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2554,'0',2736,236,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2555,'0',2737,236,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:55',NULL,2556,'0',2738,236,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2557,'0',2739,236,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:55',NULL,2558,'0',2740,236,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2559,'0',2741,236,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2560,'0',2742,236,15,NULL,'10.2.3.10'),(NULL,0,'2019-11-29 22:12:55',NULL,2561,'0',2743,236,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,2562,'0',2744,236,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,2563,'0',2745,236,5,NULL,'65c40694e19e4df59ef6dbe32ceaab19'),(NULL,0,'2019-11-29 22:12:55',NULL,2564,'0',2746,236,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:55',NULL,2565,'0',2748,237,16,NULL,'cmdb1-2-3-11'),(NULL,0,'2019-11-29 22:12:55',NULL,2566,'0',2749,237,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,2567,'0',2750,237,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:55',NULL,2568,'0',2751,237,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2569,'0',2752,237,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2570,'0',2753,237,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:55',NULL,2571,'0',2754,237,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2572,'0',2755,237,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:55',NULL,2573,'0',2756,237,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2574,'0',2757,237,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2575,'0',2758,237,15,NULL,'10.2.3.11'),(NULL,0,'2019-11-29 22:12:55',NULL,2576,'0',2759,237,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,2577,'0',2760,237,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,2578,'0',2761,237,5,NULL,'1bba58b66fca45e28193f72a9e480363'),(NULL,0,'2019-11-29 22:12:55',NULL,2579,'0',2762,237,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:55',NULL,2580,'0',2764,238,16,NULL,'cmdb1-2-3-12'),(NULL,0,'2019-11-29 22:12:55',NULL,2581,'0',2765,238,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,2582,'0',2766,238,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:55',NULL,2583,'0',2767,238,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2584,'0',2768,238,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2585,'0',2769,238,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:55',NULL,2586,'0',2770,238,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2587,'0',2771,238,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:56',NULL,2588,'0',2772,238,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2589,'0',2773,238,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2590,'0',2774,238,15,NULL,'10.2.3.12'),(NULL,0,'2019-11-29 22:12:56',NULL,2591,'0',2775,238,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,2592,'0',2776,238,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,2593,'0',2777,238,5,NULL,'36fdef4909ae4e07b21f59bb6867739b'),(NULL,0,'2019-11-29 22:12:56',NULL,2594,'0',2778,238,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:56',NULL,2595,'0',2780,239,16,NULL,'cmdb1-2-3-13'),(NULL,0,'2019-11-29 22:12:56',NULL,2596,'0',2781,239,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,2597,'0',2782,239,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:56',NULL,2598,'0',2783,239,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2599,'0',2784,239,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2600,'0',2785,239,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:56',NULL,2601,'0',2786,239,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2602,'0',2787,239,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:56',NULL,2603,'0',2788,239,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2604,'0',2789,239,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2605,'0',2790,239,15,NULL,'10.2.3.13'),(NULL,0,'2019-11-29 22:12:56',NULL,2606,'0',2791,239,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,2607,'0',2792,239,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,2608,'0',2793,239,5,NULL,'f393f76ffe354c8baaee032c788bd4f2'),(NULL,0,'2019-11-29 22:12:56',NULL,2609,'0',2794,239,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:56',NULL,2610,'0',2796,240,16,NULL,'cmdb1-2-3-14'),(NULL,0,'2019-11-29 22:12:56',NULL,2611,'0',2797,240,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,2612,'0',2798,240,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:56',NULL,2613,'0',2799,240,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2614,'0',2800,240,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2615,'0',2801,240,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:56',NULL,2616,'0',2802,240,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2617,'0',2803,240,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:56',NULL,2618,'0',2804,240,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2619,'0',2805,240,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2620,'0',2806,240,15,NULL,'10.2.3.14'),(NULL,0,'2019-11-29 22:12:56',NULL,2621,'0',2807,240,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,2622,'0',2808,240,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,2623,'0',2809,240,5,NULL,'906954eb16fe453ba67c79b35296945b'),(NULL,0,'2019-11-29 22:12:56',NULL,2624,'0',2810,240,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:56',NULL,2625,'0',2812,241,16,NULL,'cmdb1-2-3-15'),(NULL,0,'2019-11-29 22:12:56',NULL,2626,'0',2813,241,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,2627,'0',2814,241,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:56',NULL,2628,'0',2815,241,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2629,'0',2816,241,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2630,'0',2817,241,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:56',NULL,2631,'0',2818,241,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2632,'0',2819,241,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:56',NULL,2633,'0',2820,241,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2634,'0',2821,241,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2635,'0',2822,241,15,NULL,'10.2.3.15'),(NULL,0,'2019-11-29 22:12:56',NULL,2636,'0',2823,241,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,2637,'0',2824,241,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,2638,'0',2825,241,5,NULL,'fca15b033f1745c4b3ab10b51bdf563e'),(NULL,0,'2019-11-29 22:12:56',NULL,2639,'0',2826,241,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:56',NULL,2640,'0',2828,242,16,NULL,'cmdb1-2-3-16'),(NULL,0,'2019-11-29 22:12:56',NULL,2641,'0',2829,242,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,2642,'0',2830,242,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:56',NULL,2643,'0',2831,242,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2644,'0',2832,242,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2645,'0',2833,242,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:56',NULL,2646,'0',2834,242,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2647,'0',2835,242,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:56',NULL,2648,'0',2836,242,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2649,'0',2837,242,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2650,'0',2838,242,15,NULL,'10.2.3.16'),(NULL,0,'2019-11-29 22:12:56',NULL,2651,'0',2839,242,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,2652,'0',2840,242,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,2653,'0',2841,242,5,NULL,'c16efe4425c34120a155fab15700adc6'),(NULL,0,'2019-11-29 22:12:56',NULL,2654,'0',2842,242,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:57',NULL,2655,'0',2844,243,4,NULL,'App1-2-4'),(NULL,0,'2019-11-29 22:12:57',NULL,2656,'0',2846,244,16,NULL,'cmdb1-2-4-1'),(NULL,0,'2019-11-29 22:12:57',NULL,2657,'0',2847,244,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,2658,'0',2848,244,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:57',NULL,2659,'0',2849,244,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2660,'0',2850,244,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2661,'0',2851,244,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:57',NULL,2662,'0',2852,244,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2663,'0',2853,244,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:57',NULL,2664,'0',2854,244,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2665,'0',2855,244,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2666,'0',2856,244,15,NULL,'10.2.4.1'),(NULL,0,'2019-11-29 22:12:57',NULL,2667,'0',2857,244,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,2668,'0',2858,244,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,2669,'0',2859,244,5,NULL,'20f85fe6091c47068a5c10b6d3c9d4e8'),(NULL,0,'2019-11-29 22:12:57',NULL,2670,'0',2860,244,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:57',NULL,2671,'0',2862,245,16,NULL,'cmdb1-2-4-2'),(NULL,0,'2019-11-29 22:12:57',NULL,2672,'0',2863,245,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,2673,'0',2864,245,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:57',NULL,2674,'0',2865,245,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2675,'0',2866,245,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2676,'0',2867,245,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:57',NULL,2677,'0',2868,245,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2678,'0',2869,245,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:57',NULL,2679,'0',2870,245,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2680,'0',2871,245,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2681,'0',2872,245,15,NULL,'10.2.4.2'),(NULL,0,'2019-11-29 22:12:57',NULL,2682,'0',2873,245,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,2683,'0',2874,245,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,2684,'0',2875,245,5,NULL,'4cb9f8df43ae4b5baca4844f004d0320'),(NULL,0,'2019-11-29 22:12:57',NULL,2685,'0',2876,245,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:57',NULL,2686,'0',2878,246,16,NULL,'cmdb1-2-4-3'),(NULL,0,'2019-11-29 22:12:57',NULL,2687,'0',2879,246,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,2688,'0',2880,246,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:57',NULL,2689,'0',2881,246,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2690,'0',2882,246,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2691,'0',2883,246,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:57',NULL,2692,'0',2884,246,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2693,'0',2885,246,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:57',NULL,2694,'0',2886,246,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2695,'0',2887,246,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2696,'0',2888,246,15,NULL,'10.2.4.3'),(NULL,0,'2019-11-29 22:12:57',NULL,2697,'0',2889,246,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,2698,'0',2890,246,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,2699,'0',2891,246,5,NULL,'f48c2ea6816741f79ba8bd169bf3005d'),(NULL,0,'2019-11-29 22:12:57',NULL,2700,'0',2892,246,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:57',NULL,2701,'0',2894,247,16,NULL,'cmdb1-2-4-4'),(NULL,0,'2019-11-29 22:12:57',NULL,2702,'0',2895,247,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,2703,'0',2896,247,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:57',NULL,2704,'0',2897,247,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2705,'0',2898,247,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2706,'0',2899,247,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:57',NULL,2707,'0',2900,247,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2708,'0',2901,247,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:57',NULL,2709,'0',2902,247,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2710,'0',2903,247,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2711,'0',2904,247,15,NULL,'10.2.4.4'),(NULL,0,'2019-11-29 22:12:57',NULL,2712,'0',2905,247,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,2713,'0',2906,247,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,2714,'0',2907,247,5,NULL,'284327c1d86d43e7b5ba9f4b34bf9d20'),(NULL,0,'2019-11-29 22:12:57',NULL,2715,'0',2908,247,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:58',NULL,2716,'0',2910,248,16,NULL,'cmdb1-2-4-5'),(NULL,0,'2019-11-29 22:12:58',NULL,2717,'0',2911,248,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,2718,'0',2912,248,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:58',NULL,2719,'0',2913,248,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2720,'0',2914,248,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2721,'0',2915,248,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:58',NULL,2722,'0',2916,248,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2723,'0',2917,248,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:58',NULL,2724,'0',2918,248,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2725,'0',2919,248,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2726,'0',2920,248,15,NULL,'10.2.4.5'),(NULL,0,'2019-11-29 22:12:58',NULL,2727,'0',2921,248,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,2728,'0',2922,248,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,2729,'0',2923,248,5,NULL,'a6563721c0c34c8b99b7692969ab1927'),(NULL,0,'2019-11-29 22:12:58',NULL,2730,'0',2924,248,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:58',NULL,2731,'0',2926,249,16,NULL,'cmdb1-2-4-6'),(NULL,0,'2019-11-29 22:12:58',NULL,2732,'0',2927,249,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,2733,'0',2928,249,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:58',NULL,2734,'0',2929,249,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2735,'0',2930,249,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2736,'0',2931,249,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:58',NULL,2737,'0',2932,249,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2738,'0',2933,249,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:58',NULL,2739,'0',2934,249,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2740,'0',2935,249,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2741,'0',2936,249,15,NULL,'10.2.4.6'),(NULL,0,'2019-11-29 22:12:58',NULL,2742,'0',2937,249,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,2743,'0',2938,249,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,2744,'0',2939,249,5,NULL,'d807db739e2c46d3a2622a0031fcfc42'),(NULL,0,'2019-11-29 22:12:58',NULL,2745,'0',2940,249,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:58',NULL,2746,'0',2942,250,16,NULL,'cmdb1-2-4-7'),(NULL,0,'2019-11-29 22:12:58',NULL,2747,'0',2943,250,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,2748,'0',2944,250,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:58',NULL,2749,'0',2945,250,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2750,'0',2946,250,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2751,'0',2947,250,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:58',NULL,2752,'0',2948,250,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2753,'0',2949,250,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:58',NULL,2754,'0',2950,250,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2755,'0',2951,250,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2756,'0',2952,250,15,NULL,'10.2.4.7'),(NULL,0,'2019-11-29 22:12:58',NULL,2757,'0',2953,250,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,2758,'0',2954,250,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,2759,'0',2955,250,5,NULL,'cc022020f5d3404b9bf95918d65cd783'),(NULL,0,'2019-11-29 22:12:58',NULL,2760,'0',2956,250,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:58',NULL,2761,'0',2958,251,16,NULL,'cmdb1-2-4-8'),(NULL,0,'2019-11-29 22:12:58',NULL,2762,'0',2959,251,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,2763,'0',2960,251,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:58',NULL,2764,'0',2961,251,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2765,'0',2962,251,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2766,'0',2963,251,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:58',NULL,2767,'0',2964,251,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2768,'0',2965,251,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:58',NULL,2769,'0',2966,251,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2770,'0',2967,251,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2771,'0',2968,251,15,NULL,'10.2.4.8'),(NULL,0,'2019-11-29 22:12:58',NULL,2772,'0',2969,251,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,2773,'0',2970,251,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,2774,'0',2971,251,5,NULL,'3fa7378404f1457f9a93caccab3d2809'),(NULL,0,'2019-11-29 22:12:58',NULL,2775,'0',2972,251,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:58',NULL,2776,'0',2974,252,16,NULL,'cmdb1-2-4-9'),(NULL,0,'2019-11-29 22:12:58',NULL,2777,'0',2975,252,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,2778,'0',2976,252,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:59',NULL,2779,'0',2977,252,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2780,'0',2978,252,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2781,'0',2979,252,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:59',NULL,2782,'0',2980,252,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2783,'0',2981,252,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:59',NULL,2784,'0',2982,252,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2785,'0',2983,252,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2786,'0',2984,252,15,NULL,'10.2.4.9'),(NULL,0,'2019-11-29 22:12:59',NULL,2787,'0',2985,252,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,2788,'0',2986,252,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,2789,'0',2987,252,5,NULL,'573fa7095d1f46adb6f200400bd909ee'),(NULL,0,'2019-11-29 22:12:59',NULL,2790,'0',2988,252,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:59',NULL,2791,'0',2990,253,16,NULL,'cmdb1-2-4-10'),(NULL,0,'2019-11-29 22:12:59',NULL,2792,'0',2991,253,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,2793,'0',2992,253,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:59',NULL,2794,'0',2993,253,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2795,'0',2994,253,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2796,'0',2995,253,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:59',NULL,2797,'0',2996,253,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2798,'0',2997,253,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:59',NULL,2799,'0',2998,253,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2800,'0',2999,253,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2801,'0',3000,253,15,NULL,'10.2.4.10'),(NULL,0,'2019-11-29 22:12:59',NULL,2802,'0',3001,253,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,2803,'0',3002,253,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,2804,'0',3003,253,5,NULL,'47ab0abf194641b08ebad1760eab4903'),(NULL,0,'2019-11-29 22:12:59',NULL,2805,'0',3004,253,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:59',NULL,2806,'0',3006,254,16,NULL,'cmdb1-2-4-11'),(NULL,0,'2019-11-29 22:12:59',NULL,2807,'0',3007,254,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,2808,'0',3008,254,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:59',NULL,2809,'0',3009,254,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2810,'0',3010,254,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2811,'0',3011,254,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:59',NULL,2812,'0',3012,254,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2813,'0',3013,254,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:59',NULL,2814,'0',3014,254,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2815,'0',3015,254,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2816,'0',3016,254,15,NULL,'10.2.4.11'),(NULL,0,'2019-11-29 22:12:59',NULL,2817,'0',3017,254,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,2818,'0',3018,254,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,2819,'0',3019,254,5,NULL,'d60372447cf84cd2ae78fabcf874aeeb'),(NULL,0,'2019-11-29 22:12:59',NULL,2820,'0',3020,254,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:59',NULL,2821,'0',3022,255,16,NULL,'cmdb1-2-4-12'),(NULL,0,'2019-11-29 22:12:59',NULL,2822,'0',3023,255,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,2823,'0',3024,255,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:59',NULL,2824,'0',3025,255,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2825,'0',3026,255,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2826,'0',3027,255,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:59',NULL,2827,'0',3028,255,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2828,'0',3029,255,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:59',NULL,2829,'0',3030,255,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2830,'0',3031,255,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2831,'0',3032,255,15,NULL,'10.2.4.12'),(NULL,0,'2019-11-29 22:12:59',NULL,2832,'0',3033,255,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,2833,'0',3034,255,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,2834,'0',3035,255,5,NULL,'5af3e7ace4dc41a29718a65f0648a4bc'),(NULL,0,'2019-11-29 22:12:59',NULL,2835,'0',3036,255,17,NULL,'在线'),(NULL,0,'2019-11-29 22:12:59',NULL,2836,'0',3038,256,16,NULL,'cmdb1-2-4-13'),(NULL,0,'2019-11-29 22:12:59',NULL,2837,'0',3039,256,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,2838,'0',3040,256,22,NULL,'2'),(NULL,0,'2019-11-29 22:12:59',NULL,2839,'0',3041,256,28,NULL,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2840,'0',3042,256,24,NULL,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2841,'0',3043,256,29,NULL,'张江'),(NULL,0,'2019-11-29 22:12:59',NULL,2842,'0',3044,256,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2843,'0',3045,256,23,NULL,'40'),(NULL,0,'2019-11-29 22:12:59',NULL,2844,'0',3046,256,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2845,'0',3047,256,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2846,'0',3048,256,15,NULL,'10.2.4.13'),(NULL,0,'2019-11-29 22:13:00',NULL,2847,'0',3049,256,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,2848,'0',3050,256,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,2849,'0',3051,256,5,NULL,'6c10e5495886459e9e88eb7c37625d66'),(NULL,0,'2019-11-29 22:13:00',NULL,2850,'0',3052,256,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:00',NULL,2851,'0',3054,257,16,NULL,'cmdb1-2-4-14'),(NULL,0,'2019-11-29 22:13:00',NULL,2852,'0',3055,257,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,2853,'0',3056,257,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:00',NULL,2854,'0',3057,257,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2855,'0',3058,257,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2856,'0',3059,257,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:00',NULL,2857,'0',3060,257,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2858,'0',3061,257,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:00',NULL,2859,'0',3062,257,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2860,'0',3063,257,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2861,'0',3064,257,15,NULL,'10.2.4.14'),(NULL,0,'2019-11-29 22:13:00',NULL,2862,'0',3065,257,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,2863,'0',3066,257,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,2864,'0',3067,257,5,NULL,'7740020e765b4454af47f80853705922'),(NULL,0,'2019-11-29 22:13:00',NULL,2865,'0',3068,257,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:00',NULL,2866,'0',3070,258,16,NULL,'cmdb1-2-4-15'),(NULL,0,'2019-11-29 22:13:00',NULL,2867,'0',3071,258,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,2868,'0',3072,258,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:00',NULL,2869,'0',3073,258,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2870,'0',3074,258,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2871,'0',3075,258,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:00',NULL,2872,'0',3076,258,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2873,'0',3077,258,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:00',NULL,2874,'0',3078,258,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2875,'0',3079,258,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2876,'0',3080,258,15,NULL,'10.2.4.15'),(NULL,0,'2019-11-29 22:13:00',NULL,2877,'0',3081,258,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,2878,'0',3082,258,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,2879,'0',3083,258,5,NULL,'67278edf4ec445c2b6da70a9666c843a'),(NULL,0,'2019-11-29 22:13:00',NULL,2880,'0',3084,258,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:00',NULL,2881,'0',3086,259,16,NULL,'cmdb1-2-4-16'),(NULL,0,'2019-11-29 22:13:00',NULL,2882,'0',3087,259,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,2883,'0',3088,259,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:00',NULL,2884,'0',3089,259,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2885,'0',3090,259,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2886,'0',3091,259,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:00',NULL,2887,'0',3092,259,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2888,'0',3093,259,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:00',NULL,2889,'0',3094,259,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2890,'0',3095,259,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2891,'0',3096,259,15,NULL,'10.2.4.16'),(NULL,0,'2019-11-29 22:13:00',NULL,2892,'0',3097,259,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,2893,'0',3098,259,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,2894,'0',3099,259,5,NULL,'f2d6c61af1ec4e44bb99d013fac883c6'),(NULL,0,'2019-11-29 22:13:00',NULL,2895,'0',3100,259,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:00',NULL,2896,'0',3102,260,4,NULL,'App1-2-5'),(NULL,0,'2019-11-29 22:13:00',NULL,2897,'0',3104,261,16,NULL,'cmdb1-2-5-1'),(NULL,0,'2019-11-29 22:13:00',NULL,2898,'0',3105,261,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,2899,'0',3106,261,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:00',NULL,2900,'0',3107,261,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2901,'0',3108,261,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2902,'0',3109,261,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:00',NULL,2903,'0',3110,261,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2904,'0',3111,261,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:00',NULL,2905,'0',3112,261,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2906,'0',3113,261,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2907,'0',3114,261,15,NULL,'10.2.5.1'),(NULL,0,'2019-11-29 22:13:01',NULL,2908,'0',3115,261,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,2909,'0',3116,261,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,2910,'0',3117,261,5,NULL,'840309194e69481d8064fc1596a74bc8'),(NULL,0,'2019-11-29 22:13:01',NULL,2911,'0',3118,261,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:01',NULL,2912,'0',3120,262,16,NULL,'cmdb1-2-5-2'),(NULL,0,'2019-11-29 22:13:01',NULL,2913,'0',3121,262,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,2914,'0',3122,262,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:01',NULL,2915,'0',3123,262,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2916,'0',3124,262,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2917,'0',3125,262,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:01',NULL,2918,'0',3126,262,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2919,'0',3127,262,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:01',NULL,2920,'0',3128,262,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2921,'0',3129,262,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2922,'0',3130,262,15,NULL,'10.2.5.2'),(NULL,0,'2019-11-29 22:13:01',NULL,2923,'0',3131,262,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,2924,'0',3132,262,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,2925,'0',3133,262,5,NULL,'fa047f3c95fc4c079d402f98ec18322d'),(NULL,0,'2019-11-29 22:13:01',NULL,2926,'0',3134,262,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:01',NULL,2927,'0',3136,263,16,NULL,'cmdb1-2-5-3'),(NULL,0,'2019-11-29 22:13:01',NULL,2928,'0',3137,263,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,2929,'0',3138,263,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:01',NULL,2930,'0',3139,263,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2931,'0',3140,263,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2932,'0',3141,263,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:01',NULL,2933,'0',3142,263,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2934,'0',3143,263,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:01',NULL,2935,'0',3144,263,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2936,'0',3145,263,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2937,'0',3146,263,15,NULL,'10.2.5.3'),(NULL,0,'2019-11-29 22:13:01',NULL,2938,'0',3147,263,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,2939,'0',3148,263,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,2940,'0',3149,263,5,NULL,'b0c6482f8ec14fb59dad329a46b2934e'),(NULL,0,'2019-11-29 22:13:01',NULL,2941,'0',3150,263,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:01',NULL,2942,'0',3152,264,16,NULL,'cmdb1-2-5-4'),(NULL,0,'2019-11-29 22:13:01',NULL,2943,'0',3153,264,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,2944,'0',3154,264,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:01',NULL,2945,'0',3155,264,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2946,'0',3156,264,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2947,'0',3157,264,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:01',NULL,2948,'0',3158,264,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2949,'0',3159,264,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:01',NULL,2950,'0',3160,264,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2951,'0',3161,264,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2952,'0',3162,264,15,NULL,'10.2.5.4'),(NULL,0,'2019-11-29 22:13:01',NULL,2953,'0',3163,264,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,2954,'0',3164,264,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,2955,'0',3165,264,5,NULL,'b01773f3f6af4fa6b848476ec062c424'),(NULL,0,'2019-11-29 22:13:01',NULL,2956,'0',3166,264,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:01',NULL,2957,'0',3168,265,16,NULL,'cmdb1-2-5-5'),(NULL,0,'2019-11-29 22:13:01',NULL,2958,'0',3169,265,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,2959,'0',3170,265,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:01',NULL,2960,'0',3171,265,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2961,'0',3172,265,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2962,'0',3173,265,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:01',NULL,2963,'0',3174,265,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2964,'0',3175,265,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:01',NULL,2965,'0',3176,265,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2966,'0',3177,265,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2967,'0',3178,265,15,NULL,'10.2.5.5'),(NULL,0,'2019-11-29 22:13:01',NULL,2968,'0',3179,265,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,2969,'0',3180,265,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,2970,'0',3181,265,5,NULL,'03847b361e6a4c69ba910ff2e3e41859'),(NULL,0,'2019-11-29 22:13:01',NULL,2971,'0',3182,265,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:02',NULL,2972,'0',3184,266,16,NULL,'cmdb1-2-5-6'),(NULL,0,'2019-11-29 22:13:02',NULL,2973,'0',3185,266,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,2974,'0',3186,266,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:02',NULL,2975,'0',3187,266,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2976,'0',3188,266,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2977,'0',3189,266,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:02',NULL,2978,'0',3190,266,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2979,'0',3191,266,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:02',NULL,2980,'0',3192,266,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2981,'0',3193,266,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2982,'0',3194,266,15,NULL,'10.2.5.6'),(NULL,0,'2019-11-29 22:13:02',NULL,2983,'0',3195,266,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,2984,'0',3196,266,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,2985,'0',3197,266,5,NULL,'f296133e3fa34b5ea675bb3f442df68e'),(NULL,0,'2019-11-29 22:13:02',NULL,2986,'0',3198,266,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:02',NULL,2987,'0',3200,267,16,NULL,'cmdb1-2-5-7'),(NULL,0,'2019-11-29 22:13:02',NULL,2988,'0',3201,267,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,2989,'0',3202,267,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:02',NULL,2990,'0',3203,267,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2991,'0',3204,267,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2992,'0',3205,267,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:02',NULL,2993,'0',3206,267,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2994,'0',3207,267,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:02',NULL,2995,'0',3208,267,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2996,'0',3209,267,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2997,'0',3210,267,15,NULL,'10.2.5.7'),(NULL,0,'2019-11-29 22:13:02',NULL,2998,'0',3211,267,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,2999,'0',3212,267,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,3000,'0',3213,267,5,NULL,'de14e731a7bd49368cdb0e7822f5d136'),(NULL,0,'2019-11-29 22:13:02',NULL,3001,'0',3214,267,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:02',NULL,3002,'0',3216,268,16,NULL,'cmdb1-2-5-8'),(NULL,0,'2019-11-29 22:13:02',NULL,3003,'0',3217,268,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,3004,'0',3218,268,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:02',NULL,3005,'0',3219,268,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,3006,'0',3220,268,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,3007,'0',3221,268,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:02',NULL,3008,'0',3222,268,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,3009,'0',3223,268,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:02',NULL,3010,'0',3224,268,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,3011,'0',3225,268,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,3012,'0',3226,268,15,NULL,'10.2.5.8'),(NULL,0,'2019-11-29 22:13:02',NULL,3013,'0',3227,268,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,3014,'0',3228,268,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,3015,'0',3229,268,5,NULL,'6a25414594c6434099f73b28ba9bf1b9'),(NULL,0,'2019-11-29 22:13:02',NULL,3016,'0',3230,268,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:02',NULL,3017,'0',3232,269,16,NULL,'cmdb1-2-5-9'),(NULL,0,'2019-11-29 22:13:02',NULL,3018,'0',3233,269,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,3019,'0',3234,269,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:02',NULL,3020,'0',3235,269,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,3021,'0',3236,269,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,3022,'0',3237,269,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:02',NULL,3023,'0',3238,269,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,3024,'0',3239,269,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:02',NULL,3025,'0',3240,269,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,3026,'0',3241,269,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,3027,'0',3242,269,15,NULL,'10.2.5.9'),(NULL,0,'2019-11-29 22:13:02',NULL,3028,'0',3243,269,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,3029,'0',3244,269,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,3030,'0',3245,269,5,NULL,'be152ad131f441f3b8935b3d7b16cf89'),(NULL,0,'2019-11-29 22:13:02',NULL,3031,'0',3246,269,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:02',NULL,3032,'0',3248,270,16,NULL,'cmdb1-2-5-10'),(NULL,0,'2019-11-29 22:13:02',NULL,3033,'0',3249,270,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,3034,'0',3250,270,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:02',NULL,3035,'0',3251,270,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,3036,'0',3252,270,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,3037,'0',3253,270,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:03',NULL,3038,'0',3254,270,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,3039,'0',3255,270,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:03',NULL,3040,'0',3256,270,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,3041,'0',3257,270,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,3042,'0',3258,270,15,NULL,'10.2.5.10'),(NULL,0,'2019-11-29 22:13:03',NULL,3043,'0',3259,270,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,3044,'0',3260,270,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,3045,'0',3261,270,5,NULL,'88c4e19454bf4e89866ecf7ef3ac632b'),(NULL,0,'2019-11-29 22:13:03',NULL,3046,'0',3262,270,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:03',NULL,3047,'0',3264,271,16,NULL,'cmdb1-2-5-11'),(NULL,0,'2019-11-29 22:13:03',NULL,3048,'0',3265,271,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,3049,'0',3266,271,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:03',NULL,3050,'0',3267,271,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,3051,'0',3268,271,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,3052,'0',3269,271,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:03',NULL,3053,'0',3270,271,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,3054,'0',3271,271,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:03',NULL,3055,'0',3272,271,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,3056,'0',3273,271,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,3057,'0',3274,271,15,NULL,'10.2.5.11'),(NULL,0,'2019-11-29 22:13:03',NULL,3058,'0',3275,271,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,3059,'0',3276,271,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,3060,'0',3277,271,5,NULL,'b637d11ff2a54ab9a500853f7f3328b2'),(NULL,0,'2019-11-29 22:13:03',NULL,3061,'0',3278,271,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:03',NULL,3062,'0',3280,272,16,NULL,'cmdb1-2-5-12'),(NULL,0,'2019-11-29 22:13:03',NULL,3063,'0',3281,272,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,3064,'0',3282,272,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:03',NULL,3065,'0',3283,272,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,3066,'0',3284,272,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,3067,'0',3285,272,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:03',NULL,3068,'0',3286,272,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,3069,'0',3287,272,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:03',NULL,3070,'0',3288,272,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,3071,'0',3289,272,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,3072,'0',3290,272,15,NULL,'10.2.5.12'),(NULL,0,'2019-11-29 22:13:03',NULL,3073,'0',3291,272,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,3074,'0',3292,272,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,3075,'0',3293,272,5,NULL,'63495d6782884a68b303943b235dc9d9'),(NULL,0,'2019-11-29 22:13:03',NULL,3076,'0',3294,272,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:03',NULL,3077,'0',3296,273,16,NULL,'cmdb1-2-5-13'),(NULL,0,'2019-11-29 22:13:03',NULL,3078,'0',3297,273,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,3079,'0',3298,273,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:03',NULL,3080,'0',3299,273,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,3081,'0',3300,273,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,3082,'0',3301,273,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:03',NULL,3083,'0',3302,273,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,3084,'0',3303,273,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:03',NULL,3085,'0',3304,273,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,3086,'0',3305,273,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,3087,'0',3306,273,15,NULL,'10.2.5.13'),(NULL,0,'2019-11-29 22:13:03',NULL,3088,'0',3307,273,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,3089,'0',3308,273,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,3090,'0',3309,273,5,NULL,'1243259bf5024c4cb638c1bd12b0b6a2'),(NULL,0,'2019-11-29 22:13:03',NULL,3091,'0',3310,273,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:03',NULL,3092,'0',3312,274,16,NULL,'cmdb1-2-5-14'),(NULL,0,'2019-11-29 22:13:03',NULL,3093,'0',3313,274,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,3094,'0',3314,274,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:03',NULL,3095,'0',3315,274,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,3096,'0',3316,274,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,3097,'0',3317,274,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:03',NULL,3098,'0',3318,274,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,3099,'0',3319,274,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:03',NULL,3100,'0',3320,274,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,3101,'0',3321,274,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,3102,'0',3322,274,15,NULL,'10.2.5.14'),(NULL,0,'2019-11-29 22:13:04',NULL,3103,'0',3323,274,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,3104,'0',3324,274,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,3105,'0',3325,274,5,NULL,'a5f995e8fec34552a6d54b43a00da3ff'),(NULL,0,'2019-11-29 22:13:04',NULL,3106,'0',3326,274,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:04',NULL,3107,'0',3328,275,16,NULL,'cmdb1-2-5-15'),(NULL,0,'2019-11-29 22:13:04',NULL,3108,'0',3329,275,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,3109,'0',3330,275,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:04',NULL,3110,'0',3331,275,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,3111,'0',3332,275,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,3112,'0',3333,275,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:04',NULL,3113,'0',3334,275,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,3114,'0',3335,275,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:04',NULL,3115,'0',3336,275,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,3116,'0',3337,275,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,3117,'0',3338,275,15,NULL,'10.2.5.15'),(NULL,0,'2019-11-29 22:13:04',NULL,3118,'0',3339,275,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,3119,'0',3340,275,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,3120,'0',3341,275,5,NULL,'ff5c7cb4029b43579d71ed3e3555a466'),(NULL,0,'2019-11-29 22:13:04',NULL,3121,'0',3342,275,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:04',NULL,3122,'0',3344,276,16,NULL,'cmdb1-2-5-16'),(NULL,0,'2019-11-29 22:13:04',NULL,3123,'0',3345,276,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,3124,'0',3346,276,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:04',NULL,3125,'0',3347,276,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,3126,'0',3348,276,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,3127,'0',3349,276,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:04',NULL,3128,'0',3350,276,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,3129,'0',3351,276,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:04',NULL,3130,'0',3352,276,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,3131,'0',3353,276,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,3132,'0',3354,276,15,NULL,'10.2.5.16'),(NULL,0,'2019-11-29 22:13:04',NULL,3133,'0',3355,276,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,3134,'0',3356,276,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,3135,'0',3357,276,5,NULL,'c02004194f3344edba970befc53afef0'),(NULL,0,'2019-11-29 22:13:04',NULL,3136,'0',3358,276,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:04',NULL,3137,'0',3360,277,4,NULL,'App1-2-6'),(NULL,0,'2019-11-29 22:13:04',NULL,3138,'0',3362,278,16,NULL,'cmdb1-2-6-1'),(NULL,0,'2019-11-29 22:13:04',NULL,3139,'0',3363,278,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,3140,'0',3364,278,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:04',NULL,3141,'0',3365,278,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,3142,'0',3366,278,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,3143,'0',3367,278,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:04',NULL,3144,'0',3368,278,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,3145,'0',3369,278,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:04',NULL,3146,'0',3370,278,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,3147,'0',3371,278,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,3148,'0',3372,278,15,NULL,'10.2.6.1'),(NULL,0,'2019-11-29 22:13:04',NULL,3149,'0',3373,278,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,3150,'0',3374,278,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,3151,'0',3375,278,5,NULL,'ee02b907467d447581d41719fc9bac4d'),(NULL,0,'2019-11-29 22:13:04',NULL,3152,'0',3376,278,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:04',NULL,3153,'0',3378,279,16,NULL,'cmdb1-2-6-2'),(NULL,0,'2019-11-29 22:13:04',NULL,3154,'0',3379,279,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,3155,'0',3380,279,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:04',NULL,3156,'0',3381,279,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,3157,'0',3382,279,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,3158,'0',3383,279,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:04',NULL,3159,'0',3384,279,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,3160,'0',3385,279,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:04',NULL,3161,'0',3386,279,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,3162,'0',3387,279,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,3163,'0',3388,279,15,NULL,'10.2.6.2'),(NULL,0,'2019-11-29 22:13:04',NULL,3164,'0',3389,279,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,3165,'0',3390,279,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,3166,'0',3391,279,5,NULL,'946f0faa892e430993d157f49e56e9cc'),(NULL,0,'2019-11-29 22:13:05',NULL,3167,'0',3392,279,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:05',NULL,3168,'0',3394,280,16,NULL,'cmdb1-2-6-3'),(NULL,0,'2019-11-29 22:13:05',NULL,3169,'0',3395,280,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,3170,'0',3396,280,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:05',NULL,3171,'0',3397,280,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,3172,'0',3398,280,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,3173,'0',3399,280,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:05',NULL,3174,'0',3400,280,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,3175,'0',3401,280,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:05',NULL,3176,'0',3402,280,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,3177,'0',3403,280,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,3178,'0',3404,280,15,NULL,'10.2.6.3'),(NULL,0,'2019-11-29 22:13:05',NULL,3179,'0',3405,280,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,3180,'0',3406,280,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,3181,'0',3407,280,5,NULL,'681eec74ec794d359937c375145de094'),(NULL,0,'2019-11-29 22:13:05',NULL,3182,'0',3408,280,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:05',NULL,3183,'0',3410,281,16,NULL,'cmdb1-2-6-4'),(NULL,0,'2019-11-29 22:13:05',NULL,3184,'0',3411,281,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,3185,'0',3412,281,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:05',NULL,3186,'0',3413,281,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,3187,'0',3414,281,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,3188,'0',3415,281,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:05',NULL,3189,'0',3416,281,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,3190,'0',3417,281,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:05',NULL,3191,'0',3418,281,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,3192,'0',3419,281,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,3193,'0',3420,281,15,NULL,'10.2.6.4'),(NULL,0,'2019-11-29 22:13:05',NULL,3194,'0',3421,281,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,3195,'0',3422,281,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,3196,'0',3423,281,5,NULL,'d1f524ad59534e7faeb27c07a03781b7'),(NULL,0,'2019-11-29 22:13:05',NULL,3197,'0',3424,281,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:05',NULL,3198,'0',3426,282,16,NULL,'cmdb1-2-6-5'),(NULL,0,'2019-11-29 22:13:05',NULL,3199,'0',3427,282,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,3200,'0',3428,282,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:05',NULL,3201,'0',3429,282,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,3202,'0',3430,282,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,3203,'0',3431,282,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:05',NULL,3204,'0',3432,282,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,3205,'0',3433,282,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:05',NULL,3206,'0',3434,282,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,3207,'0',3435,282,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,3208,'0',3436,282,15,NULL,'10.2.6.5'),(NULL,0,'2019-11-29 22:13:05',NULL,3209,'0',3437,282,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,3210,'0',3438,282,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,3211,'0',3439,282,5,NULL,'73af42a97e1b4bf1a218ff8d06a748b2'),(NULL,0,'2019-11-29 22:13:05',NULL,3212,'0',3440,282,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:05',NULL,3213,'0',3442,283,16,NULL,'cmdb1-2-6-6'),(NULL,0,'2019-11-29 22:13:05',NULL,3214,'0',3443,283,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,3215,'0',3444,283,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:05',NULL,3216,'0',3445,283,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,3217,'0',3446,283,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,3218,'0',3447,283,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:05',NULL,3219,'0',3448,283,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,3220,'0',3449,283,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:05',NULL,3221,'0',3450,283,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,3222,'0',3451,283,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,3223,'0',3452,283,15,NULL,'10.2.6.6'),(NULL,0,'2019-11-29 22:13:05',NULL,3224,'0',3453,283,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,3225,'0',3454,283,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,3226,'0',3455,283,5,NULL,'3789c1870be740d6819bfd6c2b9ddae6'),(NULL,0,'2019-11-29 22:13:05',NULL,3227,'0',3456,283,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:06',NULL,3228,'0',3458,284,16,NULL,'cmdb1-2-6-7'),(NULL,0,'2019-11-29 22:13:06',NULL,3229,'0',3459,284,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,3230,'0',3460,284,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:06',NULL,3231,'0',3461,284,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,3232,'0',3462,284,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,3233,'0',3463,284,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:06',NULL,3234,'0',3464,284,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,3235,'0',3465,284,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:06',NULL,3236,'0',3466,284,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,3237,'0',3467,284,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,3238,'0',3468,284,15,NULL,'10.2.6.7'),(NULL,0,'2019-11-29 22:13:06',NULL,3239,'0',3469,284,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,3240,'0',3470,284,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,3241,'0',3471,284,5,NULL,'ce5f40cae7c54bd9aa2840316e340dc4'),(NULL,0,'2019-11-29 22:13:06',NULL,3242,'0',3472,284,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:06',NULL,3243,'0',3474,285,16,NULL,'cmdb1-2-6-8'),(NULL,0,'2019-11-29 22:13:06',NULL,3244,'0',3475,285,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,3245,'0',3476,285,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:06',NULL,3246,'0',3477,285,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,3247,'0',3478,285,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,3248,'0',3479,285,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:06',NULL,3249,'0',3480,285,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,3250,'0',3481,285,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:06',NULL,3251,'0',3482,285,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,3252,'0',3483,285,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,3253,'0',3484,285,15,NULL,'10.2.6.8'),(NULL,0,'2019-11-29 22:13:06',NULL,3254,'0',3485,285,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,3255,'0',3486,285,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,3256,'0',3487,285,5,NULL,'05f2911cefa849efb661da4266044c8b'),(NULL,0,'2019-11-29 22:13:06',NULL,3257,'0',3488,285,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:06',NULL,3258,'0',3490,286,16,NULL,'cmdb1-2-6-9'),(NULL,0,'2019-11-29 22:13:06',NULL,3259,'0',3491,286,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,3260,'0',3492,286,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:06',NULL,3261,'0',3493,286,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,3262,'0',3494,286,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,3263,'0',3495,286,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:06',NULL,3264,'0',3496,286,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,3265,'0',3497,286,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:06',NULL,3266,'0',3498,286,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,3267,'0',3499,286,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,3268,'0',3500,286,15,NULL,'10.2.6.9'),(NULL,0,'2019-11-29 22:13:06',NULL,3269,'0',3501,286,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,3270,'0',3502,286,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,3271,'0',3503,286,5,NULL,'a9efead21b48458e9730086656058b12'),(NULL,0,'2019-11-29 22:13:06',NULL,3272,'0',3504,286,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:06',NULL,3273,'0',3506,287,16,NULL,'cmdb1-2-6-10'),(NULL,0,'2019-11-29 22:13:06',NULL,3274,'0',3507,287,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,3275,'0',3508,287,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:06',NULL,3276,'0',3509,287,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,3277,'0',3510,287,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,3278,'0',3511,287,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:06',NULL,3279,'0',3512,287,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,3280,'0',3513,287,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:06',NULL,3281,'0',3514,287,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,3282,'0',3515,287,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,3283,'0',3516,287,15,NULL,'10.2.6.10'),(NULL,0,'2019-11-29 22:13:06',NULL,3284,'0',3517,287,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,3285,'0',3518,287,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,3286,'0',3519,287,5,NULL,'e3e654edf9224649a7ef4145d4563fdd'),(NULL,0,'2019-11-29 22:13:06',NULL,3287,'0',3520,287,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:06',NULL,3288,'0',3522,288,16,NULL,'cmdb1-2-6-11'),(NULL,0,'2019-11-29 22:13:06',NULL,3289,'0',3523,288,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,3290,'0',3524,288,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:06',NULL,3291,'0',3525,288,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,3292,'0',3526,288,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,3293,'0',3527,288,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:07',NULL,3294,'0',3528,288,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,3295,'0',3529,288,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:07',NULL,3296,'0',3530,288,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,3297,'0',3531,288,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,3298,'0',3532,288,15,NULL,'10.2.6.11'),(NULL,0,'2019-11-29 22:13:07',NULL,3299,'0',3533,288,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,3300,'0',3534,288,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,3301,'0',3535,288,5,NULL,'c1be81e35a0643489432633322615bdf'),(NULL,0,'2019-11-29 22:13:07',NULL,3302,'0',3536,288,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:07',NULL,3303,'0',3538,289,16,NULL,'cmdb1-2-6-12'),(NULL,0,'2019-11-29 22:13:07',NULL,3304,'0',3539,289,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,3305,'0',3540,289,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:07',NULL,3306,'0',3541,289,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,3307,'0',3542,289,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,3308,'0',3543,289,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:07',NULL,3309,'0',3544,289,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,3310,'0',3545,289,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:07',NULL,3311,'0',3546,289,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,3312,'0',3547,289,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,3313,'0',3548,289,15,NULL,'10.2.6.12'),(NULL,0,'2019-11-29 22:13:07',NULL,3314,'0',3549,289,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,3315,'0',3550,289,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,3316,'0',3551,289,5,NULL,'7c90d42e09a640b0b09feff524938eaa'),(NULL,0,'2019-11-29 22:13:07',NULL,3317,'0',3552,289,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:07',NULL,3318,'0',3554,290,16,NULL,'cmdb1-2-6-13'),(NULL,0,'2019-11-29 22:13:07',NULL,3319,'0',3555,290,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,3320,'0',3556,290,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:07',NULL,3321,'0',3557,290,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,3322,'0',3558,290,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,3323,'0',3559,290,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:07',NULL,3324,'0',3560,290,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,3325,'0',3561,290,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:07',NULL,3326,'0',3562,290,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,3327,'0',3563,290,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,3328,'0',3564,290,15,NULL,'10.2.6.13'),(NULL,0,'2019-11-29 22:13:07',NULL,3329,'0',3565,290,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,3330,'0',3566,290,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,3331,'0',3567,290,5,NULL,'e291ce403c084a0f8016153d0e2f793c'),(NULL,0,'2019-11-29 22:13:07',NULL,3332,'0',3568,290,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:07',NULL,3333,'0',3570,291,16,NULL,'cmdb1-2-6-14'),(NULL,0,'2019-11-29 22:13:07',NULL,3334,'0',3571,291,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,3335,'0',3572,291,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:07',NULL,3336,'0',3573,291,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,3337,'0',3574,291,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,3338,'0',3575,291,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:07',NULL,3339,'0',3576,291,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,3340,'0',3577,291,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:07',NULL,3341,'0',3578,291,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,3342,'0',3579,291,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,3343,'0',3580,291,15,NULL,'10.2.6.14'),(NULL,0,'2019-11-29 22:13:07',NULL,3344,'0',3581,291,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,3345,'0',3582,291,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,3346,'0',3583,291,5,NULL,'d1a26bda7c1c402bbec3317affc46679'),(NULL,0,'2019-11-29 22:13:07',NULL,3347,'0',3584,291,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:07',NULL,3348,'0',3586,292,16,NULL,'cmdb1-2-6-15'),(NULL,0,'2019-11-29 22:13:07',NULL,3349,'0',3587,292,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,3350,'0',3588,292,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:07',NULL,3351,'0',3589,292,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,3352,'0',3590,292,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,3353,'0',3591,292,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:07',NULL,3354,'0',3592,292,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,3355,'0',3593,292,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:07',NULL,3356,'0',3594,292,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,3357,'0',3595,292,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,3358,'0',3596,292,15,NULL,'10.2.6.15'),(NULL,0,'2019-11-29 22:13:07',NULL,3359,'0',3597,292,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,3360,'0',3598,292,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,3361,'0',3599,292,5,NULL,'016bc6ace6f44ba5987cc86af71b62d9'),(NULL,0,'2019-11-29 22:13:08',NULL,3362,'0',3600,292,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:08',NULL,3363,'0',3602,293,16,NULL,'cmdb1-2-6-16'),(NULL,0,'2019-11-29 22:13:08',NULL,3364,'0',3603,293,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,3365,'0',3604,293,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:08',NULL,3366,'0',3605,293,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,3367,'0',3606,293,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,3368,'0',3607,293,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:08',NULL,3369,'0',3608,293,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,3370,'0',3609,293,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:08',NULL,3371,'0',3610,293,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,3372,'0',3611,293,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,3373,'0',3612,293,15,NULL,'10.2.6.16'),(NULL,0,'2019-11-29 22:13:08',NULL,3374,'0',3613,293,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,3375,'0',3614,293,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,3376,'0',3615,293,5,NULL,'60c8b59019204ddf809b4cd077224cbe'),(NULL,0,'2019-11-29 22:13:08',NULL,3377,'0',3616,293,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:08',NULL,3378,'0',3618,294,4,NULL,'App1-2-7'),(NULL,0,'2019-11-29 22:13:08',NULL,3379,'0',3620,295,16,NULL,'cmdb1-2-7-1'),(NULL,0,'2019-11-29 22:13:08',NULL,3380,'0',3621,295,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,3381,'0',3622,295,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:08',NULL,3382,'0',3623,295,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,3383,'0',3624,295,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,3384,'0',3625,295,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:08',NULL,3385,'0',3626,295,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,3386,'0',3627,295,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:08',NULL,3387,'0',3628,295,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,3388,'0',3629,295,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,3389,'0',3630,295,15,NULL,'10.2.7.1'),(NULL,0,'2019-11-29 22:13:08',NULL,3390,'0',3631,295,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,3391,'0',3632,295,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,3392,'0',3633,295,5,NULL,'009524700ccf4e689a8ad2f59433452d'),(NULL,0,'2019-11-29 22:13:08',NULL,3393,'0',3634,295,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:08',NULL,3394,'0',3636,296,16,NULL,'cmdb1-2-7-2'),(NULL,0,'2019-11-29 22:13:08',NULL,3395,'0',3637,296,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,3396,'0',3638,296,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:08',NULL,3397,'0',3639,296,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,3398,'0',3640,296,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,3399,'0',3641,296,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:08',NULL,3400,'0',3642,296,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,3401,'0',3643,296,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:08',NULL,3402,'0',3644,296,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,3403,'0',3645,296,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,3404,'0',3646,296,15,NULL,'10.2.7.2'),(NULL,0,'2019-11-29 22:13:08',NULL,3405,'0',3647,296,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,3406,'0',3648,296,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,3407,'0',3649,296,5,NULL,'3c024fef992c47009b9fe41f579260c2'),(NULL,0,'2019-11-29 22:13:08',NULL,3408,'0',3650,296,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:08',NULL,3409,'0',3652,297,16,NULL,'cmdb1-2-7-3'),(NULL,0,'2019-11-29 22:13:08',NULL,3410,'0',3653,297,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,3411,'0',3654,297,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:08',NULL,3412,'0',3655,297,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,3413,'0',3656,297,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,3414,'0',3657,297,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:08',NULL,3415,'0',3658,297,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,3416,'0',3659,297,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:08',NULL,3417,'0',3660,297,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,3418,'0',3661,297,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,3419,'0',3662,297,15,NULL,'10.2.7.3'),(NULL,0,'2019-11-29 22:13:08',NULL,3420,'0',3663,297,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,3421,'0',3664,297,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,3422,'0',3665,297,5,NULL,'838c3240b4874bf2a5db622a4fa3f8ca'),(NULL,0,'2019-11-29 22:13:08',NULL,3423,'0',3666,297,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:09',NULL,3424,'0',3668,298,16,NULL,'cmdb1-2-7-4'),(NULL,0,'2019-11-29 22:13:09',NULL,3425,'0',3669,298,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,3426,'0',3670,298,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:09',NULL,3427,'0',3671,298,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,3428,'0',3672,298,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,3429,'0',3673,298,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:09',NULL,3430,'0',3674,298,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,3431,'0',3675,298,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:09',NULL,3432,'0',3676,298,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,3433,'0',3677,298,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,3434,'0',3678,298,15,NULL,'10.2.7.4'),(NULL,0,'2019-11-29 22:13:09',NULL,3435,'0',3679,298,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,3436,'0',3680,298,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,3437,'0',3681,298,5,NULL,'dd11cd9fc77a43249854e6b894ff5382'),(NULL,0,'2019-11-29 22:13:09',NULL,3438,'0',3682,298,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:09',NULL,3439,'0',3684,299,16,NULL,'cmdb1-2-7-5'),(NULL,0,'2019-11-29 22:13:09',NULL,3440,'0',3685,299,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,3441,'0',3686,299,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:09',NULL,3442,'0',3687,299,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,3443,'0',3688,299,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,3444,'0',3689,299,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:09',NULL,3445,'0',3690,299,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,3446,'0',3691,299,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:09',NULL,3447,'0',3692,299,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,3448,'0',3693,299,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,3449,'0',3694,299,15,NULL,'10.2.7.5'),(NULL,0,'2019-11-29 22:13:09',NULL,3450,'0',3695,299,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,3451,'0',3696,299,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,3452,'0',3697,299,5,NULL,'4ae20c99ddbe41afa7a6853688cc4258'),(NULL,0,'2019-11-29 22:13:09',NULL,3453,'0',3698,299,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:09',NULL,3454,'0',3700,300,16,NULL,'cmdb1-2-7-6'),(NULL,0,'2019-11-29 22:13:09',NULL,3455,'0',3701,300,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,3456,'0',3702,300,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:09',NULL,3457,'0',3703,300,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,3458,'0',3704,300,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,3459,'0',3705,300,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:09',NULL,3460,'0',3706,300,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,3461,'0',3707,300,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:09',NULL,3462,'0',3708,300,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,3463,'0',3709,300,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,3464,'0',3710,300,15,NULL,'10.2.7.6'),(NULL,0,'2019-11-29 22:13:09',NULL,3465,'0',3711,300,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,3466,'0',3712,300,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,3467,'0',3713,300,5,NULL,'53a37c3a02854a7f8aef740502063a5b'),(NULL,0,'2019-11-29 22:13:09',NULL,3468,'0',3714,300,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:09',NULL,3469,'0',3716,301,16,NULL,'cmdb1-2-7-7'),(NULL,0,'2019-11-29 22:13:09',NULL,3470,'0',3717,301,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,3471,'0',3718,301,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:09',NULL,3472,'0',3719,301,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,3473,'0',3720,301,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,3474,'0',3721,301,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:09',NULL,3475,'0',3722,301,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,3476,'0',3723,301,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:09',NULL,3477,'0',3724,301,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,3478,'0',3725,301,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,3479,'0',3726,301,15,NULL,'10.2.7.7'),(NULL,0,'2019-11-29 22:13:09',NULL,3480,'0',3727,301,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,3481,'0',3728,301,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,3482,'0',3729,301,5,NULL,'29018eee86a84181b123240c2bad7963'),(NULL,0,'2019-11-29 22:13:09',NULL,3483,'0',3730,301,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:09',NULL,3484,'0',3732,302,16,NULL,'cmdb1-2-7-8'),(NULL,0,'2019-11-29 22:13:09',NULL,3485,'0',3733,302,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,3486,'0',3734,302,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:10',NULL,3487,'0',3735,302,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,3488,'0',3736,302,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,3489,'0',3737,302,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:10',NULL,3490,'0',3738,302,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,3491,'0',3739,302,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:10',NULL,3492,'0',3740,302,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,3493,'0',3741,302,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,3494,'0',3742,302,15,NULL,'10.2.7.8'),(NULL,0,'2019-11-29 22:13:10',NULL,3495,'0',3743,302,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,3496,'0',3744,302,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,3497,'0',3745,302,5,NULL,'7c5319eacb2d43fd9fd26dff6e5f8f62'),(NULL,0,'2019-11-29 22:13:10',NULL,3498,'0',3746,302,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:10',NULL,3499,'0',3748,303,16,NULL,'cmdb1-2-7-9'),(NULL,0,'2019-11-29 22:13:10',NULL,3500,'0',3749,303,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,3501,'0',3750,303,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:10',NULL,3502,'0',3751,303,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,3503,'0',3752,303,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,3504,'0',3753,303,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:10',NULL,3505,'0',3754,303,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,3506,'0',3755,303,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:10',NULL,3507,'0',3756,303,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,3508,'0',3757,303,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,3509,'0',3758,303,15,NULL,'10.2.7.9'),(NULL,0,'2019-11-29 22:13:10',NULL,3510,'0',3759,303,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,3511,'0',3760,303,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,3512,'0',3761,303,5,NULL,'8b8eb8bbbd9d43c5ab50fc40aaf421a6'),(NULL,0,'2019-11-29 22:13:10',NULL,3513,'0',3762,303,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:10',NULL,3514,'0',3764,304,16,NULL,'cmdb1-2-7-10'),(NULL,0,'2019-11-29 22:13:10',NULL,3515,'0',3765,304,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,3516,'0',3766,304,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:10',NULL,3517,'0',3767,304,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,3518,'0',3768,304,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,3519,'0',3769,304,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:10',NULL,3520,'0',3770,304,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,3521,'0',3771,304,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:10',NULL,3522,'0',3772,304,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,3523,'0',3773,304,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,3524,'0',3774,304,15,NULL,'10.2.7.10'),(NULL,0,'2019-11-29 22:13:10',NULL,3525,'0',3775,304,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,3526,'0',3776,304,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,3527,'0',3777,304,5,NULL,'1697c3d5d84449e1bd27c46a70048ad2'),(NULL,0,'2019-11-29 22:13:10',NULL,3528,'0',3778,304,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:10',NULL,3529,'0',3780,305,16,NULL,'cmdb1-2-7-11'),(NULL,0,'2019-11-29 22:13:10',NULL,3530,'0',3781,305,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,3531,'0',3782,305,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:10',NULL,3532,'0',3783,305,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,3533,'0',3784,305,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,3534,'0',3785,305,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:10',NULL,3535,'0',3786,305,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,3536,'0',3787,305,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:10',NULL,3537,'0',3788,305,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,3538,'0',3789,305,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,3539,'0',3790,305,15,NULL,'10.2.7.11'),(NULL,0,'2019-11-29 22:13:10',NULL,3540,'0',3791,305,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,3541,'0',3792,305,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,3542,'0',3793,305,5,NULL,'17bdcbd8d4214a57a910c2fb6e10701a'),(NULL,0,'2019-11-29 22:13:10',NULL,3543,'0',3794,305,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:10',NULL,3544,'0',3796,306,16,NULL,'cmdb1-2-7-12'),(NULL,0,'2019-11-29 22:13:10',NULL,3545,'0',3797,306,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,3546,'0',3798,306,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:10',NULL,3547,'0',3799,306,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,3548,'0',3800,306,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,3549,'0',3801,306,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:10',NULL,3550,'0',3802,306,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,3551,'0',3803,306,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:10',NULL,3552,'0',3804,306,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,3553,'0',3805,306,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,3554,'0',3806,306,15,NULL,'10.2.7.12'),(NULL,0,'2019-11-29 22:13:11',NULL,3555,'0',3807,306,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,3556,'0',3808,306,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,3557,'0',3809,306,5,NULL,'95b8cd29aeed417fb46156c24606c84d'),(NULL,0,'2019-11-29 22:13:11',NULL,3558,'0',3810,306,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:11',NULL,3559,'0',3812,307,16,NULL,'cmdb1-2-7-13'),(NULL,0,'2019-11-29 22:13:11',NULL,3560,'0',3813,307,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,3561,'0',3814,307,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:11',NULL,3562,'0',3815,307,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,3563,'0',3816,307,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,3564,'0',3817,307,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:11',NULL,3565,'0',3818,307,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,3566,'0',3819,307,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:11',NULL,3567,'0',3820,307,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,3568,'0',3821,307,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,3569,'0',3822,307,15,NULL,'10.2.7.13'),(NULL,0,'2019-11-29 22:13:11',NULL,3570,'0',3823,307,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,3571,'0',3824,307,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,3572,'0',3825,307,5,NULL,'89e45af8e2a743548d24282a7d6094b6'),(NULL,0,'2019-11-29 22:13:11',NULL,3573,'0',3826,307,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:11',NULL,3574,'0',3828,308,16,NULL,'cmdb1-2-7-14'),(NULL,0,'2019-11-29 22:13:11',NULL,3575,'0',3829,308,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,3576,'0',3830,308,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:11',NULL,3577,'0',3831,308,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,3578,'0',3832,308,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,3579,'0',3833,308,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:11',NULL,3580,'0',3834,308,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,3581,'0',3835,308,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:11',NULL,3582,'0',3836,308,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,3583,'0',3837,308,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,3584,'0',3838,308,15,NULL,'10.2.7.14'),(NULL,0,'2019-11-29 22:13:11',NULL,3585,'0',3839,308,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,3586,'0',3840,308,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,3587,'0',3841,308,5,NULL,'eea1201d8993428c8198f4ddc1548d4d'),(NULL,0,'2019-11-29 22:13:11',NULL,3588,'0',3842,308,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:11',NULL,3589,'0',3844,309,16,NULL,'cmdb1-2-7-15'),(NULL,0,'2019-11-29 22:13:11',NULL,3590,'0',3845,309,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,3591,'0',3846,309,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:11',NULL,3592,'0',3847,309,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,3593,'0',3848,309,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,3594,'0',3849,309,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:11',NULL,3595,'0',3850,309,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,3596,'0',3851,309,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:11',NULL,3597,'0',3852,309,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,3598,'0',3853,309,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,3599,'0',3854,309,15,NULL,'10.2.7.15'),(NULL,0,'2019-11-29 22:13:11',NULL,3600,'0',3855,309,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,3601,'0',3856,309,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,3602,'0',3857,309,5,NULL,'6ebed311427c4f3b81f88f00ad2c819d'),(NULL,0,'2019-11-29 22:13:11',NULL,3603,'0',3858,309,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:11',NULL,3604,'0',3860,310,16,NULL,'cmdb1-2-7-16'),(NULL,0,'2019-11-29 22:13:11',NULL,3605,'0',3861,310,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,3606,'0',3862,310,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:11',NULL,3607,'0',3863,310,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,3608,'0',3864,310,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,3609,'0',3865,310,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:11',NULL,3610,'0',3866,310,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,3611,'0',3867,310,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:11',NULL,3612,'0',3868,310,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,3613,'0',3869,310,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,3614,'0',3870,310,15,NULL,'10.2.7.16'),(NULL,0,'2019-11-29 22:13:11',NULL,3615,'0',3871,310,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,3616,'0',3872,310,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,3617,'0',3873,310,5,NULL,'f942f46d14834c4b9ec167eb601efcf6'),(NULL,0,'2019-11-29 22:13:11',NULL,3618,'0',3874,310,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:12',NULL,3619,'0',3876,311,4,NULL,'App1-2-8'),(NULL,0,'2019-11-29 22:13:12',NULL,3620,'0',3878,312,16,NULL,'cmdb1-2-8-1'),(NULL,0,'2019-11-29 22:13:12',NULL,3621,'0',3879,312,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,3622,'0',3880,312,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:12',NULL,3623,'0',3881,312,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,3624,'0',3882,312,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,3625,'0',3883,312,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:12',NULL,3626,'0',3884,312,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,3627,'0',3885,312,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:12',NULL,3628,'0',3886,312,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,3629,'0',3887,312,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,3630,'0',3888,312,15,NULL,'10.2.8.1'),(NULL,0,'2019-11-29 22:13:12',NULL,3631,'0',3889,312,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,3632,'0',3890,312,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,3633,'0',3891,312,5,NULL,'4aa34260e6e94534a520f669f1ba3611'),(NULL,0,'2019-11-29 22:13:12',NULL,3634,'0',3892,312,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:12',NULL,3635,'0',3894,313,16,NULL,'cmdb1-2-8-2'),(NULL,0,'2019-11-29 22:13:12',NULL,3636,'0',3895,313,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,3637,'0',3896,313,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:12',NULL,3638,'0',3897,313,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,3639,'0',3898,313,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,3640,'0',3899,313,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:12',NULL,3641,'0',3900,313,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,3642,'0',3901,313,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:12',NULL,3643,'0',3902,313,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,3644,'0',3903,313,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,3645,'0',3904,313,15,NULL,'10.2.8.2'),(NULL,0,'2019-11-29 22:13:12',NULL,3646,'0',3905,313,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,3647,'0',3906,313,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,3648,'0',3907,313,5,NULL,'1f6a433483474b29a900af5523ea7707'),(NULL,0,'2019-11-29 22:13:12',NULL,3649,'0',3908,313,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:12',NULL,3650,'0',3910,314,16,NULL,'cmdb1-2-8-3'),(NULL,0,'2019-11-29 22:13:12',NULL,3651,'0',3911,314,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,3652,'0',3912,314,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:12',NULL,3653,'0',3913,314,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,3654,'0',3914,314,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,3655,'0',3915,314,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:12',NULL,3656,'0',3916,314,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,3657,'0',3917,314,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:12',NULL,3658,'0',3918,314,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,3659,'0',3919,314,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,3660,'0',3920,314,15,NULL,'10.2.8.3'),(NULL,0,'2019-11-29 22:13:12',NULL,3661,'0',3921,314,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,3662,'0',3922,314,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,3663,'0',3923,314,5,NULL,'89dc0a1c2f1f4125a00170bd777ca1cc'),(NULL,0,'2019-11-29 22:13:12',NULL,3664,'0',3924,314,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:12',NULL,3665,'0',3926,315,16,NULL,'cmdb1-2-8-4'),(NULL,0,'2019-11-29 22:13:12',NULL,3666,'0',3927,315,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,3667,'0',3928,315,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:12',NULL,3668,'0',3929,315,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,3669,'0',3930,315,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,3670,'0',3931,315,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:12',NULL,3671,'0',3932,315,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,3672,'0',3933,315,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:12',NULL,3673,'0',3934,315,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,3674,'0',3935,315,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,3675,'0',3936,315,15,NULL,'10.2.8.4'),(NULL,0,'2019-11-29 22:13:12',NULL,3676,'0',3937,315,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,3677,'0',3938,315,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,3678,'0',3939,315,5,NULL,'b42fbe8991744bb1a8a4a9110c20f644'),(NULL,0,'2019-11-29 22:13:12',NULL,3679,'0',3940,315,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:13',NULL,3680,'0',3942,316,16,NULL,'cmdb1-2-8-5'),(NULL,0,'2019-11-29 22:13:13',NULL,3681,'0',3943,316,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,3682,'0',3944,316,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:13',NULL,3683,'0',3945,316,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,3684,'0',3946,316,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,3685,'0',3947,316,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:13',NULL,3686,'0',3948,316,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,3687,'0',3949,316,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:13',NULL,3688,'0',3950,316,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,3689,'0',3951,316,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,3690,'0',3952,316,15,NULL,'10.2.8.5'),(NULL,0,'2019-11-29 22:13:13',NULL,3691,'0',3953,316,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,3692,'0',3954,316,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,3693,'0',3955,316,5,NULL,'0a154a1ed9174c1db1965c012e31b6e9'),(NULL,0,'2019-11-29 22:13:13',NULL,3694,'0',3956,316,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:13',NULL,3695,'0',3958,317,16,NULL,'cmdb1-2-8-6'),(NULL,0,'2019-11-29 22:13:13',NULL,3696,'0',3959,317,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,3697,'0',3960,317,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:13',NULL,3698,'0',3961,317,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,3699,'0',3962,317,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,3700,'0',3963,317,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:13',NULL,3701,'0',3964,317,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,3702,'0',3965,317,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:13',NULL,3703,'0',3966,317,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,3704,'0',3967,317,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,3705,'0',3968,317,15,NULL,'10.2.8.6'),(NULL,0,'2019-11-29 22:13:13',NULL,3706,'0',3969,317,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,3707,'0',3970,317,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,3708,'0',3971,317,5,NULL,'ecb4f2a555664b01bacfccd8f0d135a5'),(NULL,0,'2019-11-29 22:13:13',NULL,3709,'0',3972,317,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:13',NULL,3710,'0',3974,318,16,NULL,'cmdb1-2-8-7'),(NULL,0,'2019-11-29 22:13:13',NULL,3711,'0',3975,318,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,3712,'0',3976,318,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:13',NULL,3713,'0',3977,318,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,3714,'0',3978,318,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,3715,'0',3979,318,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:13',NULL,3716,'0',3980,318,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,3717,'0',3981,318,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:13',NULL,3718,'0',3982,318,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,3719,'0',3983,318,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,3720,'0',3984,318,15,NULL,'10.2.8.7'),(NULL,0,'2019-11-29 22:13:13',NULL,3721,'0',3985,318,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,3722,'0',3986,318,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,3723,'0',3987,318,5,NULL,'9e0f8426ae264ae096b1eec539e994ea'),(NULL,0,'2019-11-29 22:13:13',NULL,3724,'0',3988,318,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:13',NULL,3725,'0',3990,319,16,NULL,'cmdb1-2-8-8'),(NULL,0,'2019-11-29 22:13:13',NULL,3726,'0',3991,319,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,3727,'0',3992,319,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:13',NULL,3728,'0',3993,319,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,3729,'0',3994,319,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,3730,'0',3995,319,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:13',NULL,3731,'0',3996,319,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,3732,'0',3997,319,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:13',NULL,3733,'0',3998,319,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,3734,'0',3999,319,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,3735,'0',4000,319,15,NULL,'10.2.8.8'),(NULL,0,'2019-11-29 22:13:13',NULL,3736,'0',4001,319,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,3737,'0',4002,319,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,3738,'0',4003,319,5,NULL,'f21200a1fb134831b6a30ccc62dcbcb8'),(NULL,0,'2019-11-29 22:13:13',NULL,3739,'0',4004,319,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:13',NULL,3740,'0',4006,320,16,NULL,'cmdb1-2-8-9'),(NULL,0,'2019-11-29 22:13:13',NULL,3741,'0',4007,320,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,3742,'0',4008,320,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:14',NULL,3743,'0',4009,320,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3744,'0',4010,320,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3745,'0',4011,320,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:14',NULL,3746,'0',4012,320,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3747,'0',4013,320,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:14',NULL,3748,'0',4014,320,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3749,'0',4015,320,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3750,'0',4016,320,15,NULL,'10.2.8.9'),(NULL,0,'2019-11-29 22:13:14',NULL,3751,'0',4017,320,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,3752,'0',4018,320,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,3753,'0',4019,320,5,NULL,'6b1e0416a8064ff5acf20c829fe8a7c0'),(NULL,0,'2019-11-29 22:13:14',NULL,3754,'0',4020,320,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:14',NULL,3755,'0',4022,321,16,NULL,'cmdb1-2-8-10'),(NULL,0,'2019-11-29 22:13:14',NULL,3756,'0',4023,321,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,3757,'0',4024,321,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:14',NULL,3758,'0',4025,321,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3759,'0',4026,321,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3760,'0',4027,321,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:14',NULL,3761,'0',4028,321,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3762,'0',4029,321,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:14',NULL,3763,'0',4030,321,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3764,'0',4031,321,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3765,'0',4032,321,15,NULL,'10.2.8.10'),(NULL,0,'2019-11-29 22:13:14',NULL,3766,'0',4033,321,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,3767,'0',4034,321,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,3768,'0',4035,321,5,NULL,'831596be2da84f87a34c864e4fd4056c'),(NULL,0,'2019-11-29 22:13:14',NULL,3769,'0',4036,321,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:14',NULL,3770,'0',4038,322,16,NULL,'cmdb1-2-8-11'),(NULL,0,'2019-11-29 22:13:14',NULL,3771,'0',4039,322,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,3772,'0',4040,322,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:14',NULL,3773,'0',4041,322,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3774,'0',4042,322,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3775,'0',4043,322,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:14',NULL,3776,'0',4044,322,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3777,'0',4045,322,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:14',NULL,3778,'0',4046,322,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3779,'0',4047,322,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3780,'0',4048,322,15,NULL,'10.2.8.11'),(NULL,0,'2019-11-29 22:13:14',NULL,3781,'0',4049,322,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,3782,'0',4050,322,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,3783,'0',4051,322,5,NULL,'e6dee890f1b1473a9374117450c609f0'),(NULL,0,'2019-11-29 22:13:14',NULL,3784,'0',4052,322,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:14',NULL,3785,'0',4054,323,16,NULL,'cmdb1-2-8-12'),(NULL,0,'2019-11-29 22:13:14',NULL,3786,'0',4055,323,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,3787,'0',4056,323,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:14',NULL,3788,'0',4057,323,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3789,'0',4058,323,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3790,'0',4059,323,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:14',NULL,3791,'0',4060,323,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3792,'0',4061,323,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:14',NULL,3793,'0',4062,323,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3794,'0',4063,323,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3795,'0',4064,323,15,NULL,'10.2.8.12'),(NULL,0,'2019-11-29 22:13:14',NULL,3796,'0',4065,323,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,3797,'0',4066,323,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,3798,'0',4067,323,5,NULL,'a0b10eafe4ba4806a68477c58eff73ec'),(NULL,0,'2019-11-29 22:13:14',NULL,3799,'0',4068,323,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:14',NULL,3800,'0',4070,324,16,NULL,'cmdb1-2-8-13'),(NULL,0,'2019-11-29 22:13:14',NULL,3801,'0',4071,324,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,3802,'0',4072,324,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:14',NULL,3803,'0',4073,324,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3804,'0',4074,324,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3805,'0',4075,324,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:14',NULL,3806,'0',4076,324,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3807,'0',4077,324,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:14',NULL,3808,'0',4078,324,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3809,'0',4079,324,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3810,'0',4080,324,15,NULL,'10.2.8.13'),(NULL,0,'2019-11-29 22:13:15',NULL,3811,'0',4081,324,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,3812,'0',4082,324,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,3813,'0',4083,324,5,NULL,'bf345d003f8a479785cd25bd9761c7f6'),(NULL,0,'2019-11-29 22:13:15',NULL,3814,'0',4084,324,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:15',NULL,3815,'0',4086,325,16,NULL,'cmdb1-2-8-14'),(NULL,0,'2019-11-29 22:13:15',NULL,3816,'0',4087,325,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,3817,'0',4088,325,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:15',NULL,3818,'0',4089,325,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3819,'0',4090,325,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3820,'0',4091,325,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:15',NULL,3821,'0',4092,325,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3822,'0',4093,325,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:15',NULL,3823,'0',4094,325,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3824,'0',4095,325,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3825,'0',4096,325,15,NULL,'10.2.8.14'),(NULL,0,'2019-11-29 22:13:15',NULL,3826,'0',4097,325,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,3827,'0',4098,325,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,3828,'0',4099,325,5,NULL,'6665b45a24bb455bbd75a668d29c07ad'),(NULL,0,'2019-11-29 22:13:15',NULL,3829,'0',4100,325,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:15',NULL,3830,'0',4102,326,16,NULL,'cmdb1-2-8-15'),(NULL,0,'2019-11-29 22:13:15',NULL,3831,'0',4103,326,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,3832,'0',4104,326,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:15',NULL,3833,'0',4105,326,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3834,'0',4106,326,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3835,'0',4107,326,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:15',NULL,3836,'0',4108,326,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3837,'0',4109,326,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:15',NULL,3838,'0',4110,326,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3839,'0',4111,326,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3840,'0',4112,326,15,NULL,'10.2.8.15'),(NULL,0,'2019-11-29 22:13:15',NULL,3841,'0',4113,326,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,3842,'0',4114,326,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,3843,'0',4115,326,5,NULL,'6fc0d020978a416f9e85010c43a1f0b3'),(NULL,0,'2019-11-29 22:13:15',NULL,3844,'0',4116,326,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:15',NULL,3845,'0',4118,327,16,NULL,'cmdb1-2-8-16'),(NULL,0,'2019-11-29 22:13:15',NULL,3846,'0',4119,327,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,3847,'0',4120,327,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:15',NULL,3848,'0',4121,327,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3849,'0',4122,327,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3850,'0',4123,327,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:15',NULL,3851,'0',4124,327,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3852,'0',4125,327,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:15',NULL,3853,'0',4126,327,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3854,'0',4127,327,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3855,'0',4128,327,15,NULL,'10.2.8.16'),(NULL,0,'2019-11-29 22:13:15',NULL,3856,'0',4129,327,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,3857,'0',4130,327,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,3858,'0',4131,327,5,NULL,'ff13aa4242da486b9e77d0c8445306a8'),(NULL,0,'2019-11-29 22:13:15',NULL,3859,'0',4132,327,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:15',NULL,3860,'0',4134,328,3,NULL,'产品线1-3'),(NULL,0,'2019-11-29 22:13:15',NULL,3861,'0',4136,329,4,NULL,'App1-3-1'),(NULL,0,'2019-11-29 22:13:15',NULL,3862,'0',4138,330,16,NULL,'cmdb1-3-1-1'),(NULL,0,'2019-11-29 22:13:15',NULL,3863,'0',4139,330,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,3864,'0',4140,330,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:15',NULL,3865,'0',4141,330,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3866,'0',4142,330,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3867,'0',4143,330,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:16',NULL,3868,'0',4144,330,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3869,'0',4145,330,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:16',NULL,3870,'0',4146,330,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3871,'0',4147,330,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3872,'0',4148,330,15,NULL,'10.3.1.1'),(NULL,0,'2019-11-29 22:13:16',NULL,3873,'0',4149,330,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,3874,'0',4150,330,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,3875,'0',4151,330,5,NULL,'b63a3416587e4487b8ee9a8056c26fa8'),(NULL,0,'2019-11-29 22:13:16',NULL,3876,'0',4152,330,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:16',NULL,3877,'0',4154,331,16,NULL,'cmdb1-3-1-2'),(NULL,0,'2019-11-29 22:13:16',NULL,3878,'0',4155,331,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,3879,'0',4156,331,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:16',NULL,3880,'0',4157,331,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3881,'0',4158,331,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3882,'0',4159,331,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:16',NULL,3883,'0',4160,331,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3884,'0',4161,331,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:16',NULL,3885,'0',4162,331,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3886,'0',4163,331,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3887,'0',4164,331,15,NULL,'10.3.1.2'),(NULL,0,'2019-11-29 22:13:16',NULL,3888,'0',4165,331,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,3889,'0',4166,331,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,3890,'0',4167,331,5,NULL,'469a9209d749411ead1daa3e60b456c9'),(NULL,0,'2019-11-29 22:13:16',NULL,3891,'0',4168,331,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:16',NULL,3892,'0',4170,332,16,NULL,'cmdb1-3-1-3'),(NULL,0,'2019-11-29 22:13:16',NULL,3893,'0',4171,332,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,3894,'0',4172,332,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:16',NULL,3895,'0',4173,332,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3896,'0',4174,332,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3897,'0',4175,332,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:16',NULL,3898,'0',4176,332,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3899,'0',4177,332,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:16',NULL,3900,'0',4178,332,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3901,'0',4179,332,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3902,'0',4180,332,15,NULL,'10.3.1.3'),(NULL,0,'2019-11-29 22:13:16',NULL,3903,'0',4181,332,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,3904,'0',4182,332,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,3905,'0',4183,332,5,NULL,'f579f9dc1fb443a2b0849ea81e19b56d'),(NULL,0,'2019-11-29 22:13:16',NULL,3906,'0',4184,332,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:16',NULL,3907,'0',4186,333,16,NULL,'cmdb1-3-1-4'),(NULL,0,'2019-11-29 22:13:16',NULL,3908,'0',4187,333,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,3909,'0',4188,333,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:16',NULL,3910,'0',4189,333,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3911,'0',4190,333,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3912,'0',4191,333,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:16',NULL,3913,'0',4192,333,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3914,'0',4193,333,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:16',NULL,3915,'0',4194,333,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3916,'0',4195,333,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3917,'0',4196,333,15,NULL,'10.3.1.4'),(NULL,0,'2019-11-29 22:13:16',NULL,3918,'0',4197,333,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,3919,'0',4198,333,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,3920,'0',4199,333,5,NULL,'4b22e6ed919d4306acf4aa225e4d650e'),(NULL,0,'2019-11-29 22:13:16',NULL,3921,'0',4200,333,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:16',NULL,3922,'0',4202,334,16,NULL,'cmdb1-3-1-5'),(NULL,0,'2019-11-29 22:13:16',NULL,3923,'0',4203,334,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,3924,'0',4204,334,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:16',NULL,3925,'0',4205,334,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3926,'0',4206,334,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3927,'0',4207,334,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:16',NULL,3928,'0',4208,334,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3929,'0',4209,334,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:16',NULL,3930,'0',4210,334,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3931,'0',4211,334,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3932,'0',4212,334,15,NULL,'10.3.1.5'),(NULL,0,'2019-11-29 22:13:16',NULL,3933,'0',4213,334,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,3934,'0',4214,334,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,3935,'0',4215,334,5,NULL,'1a1d8e0296624901bc6337178146b7dc'),(NULL,0,'2019-11-29 22:13:17',NULL,3936,'0',4216,334,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:17',NULL,3937,'0',4218,335,16,NULL,'cmdb1-3-1-6'),(NULL,0,'2019-11-29 22:13:17',NULL,3938,'0',4219,335,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,3939,'0',4220,335,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:17',NULL,3940,'0',4221,335,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3941,'0',4222,335,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3942,'0',4223,335,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:17',NULL,3943,'0',4224,335,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3944,'0',4225,335,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:17',NULL,3945,'0',4226,335,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3946,'0',4227,335,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3947,'0',4228,335,15,NULL,'10.3.1.6'),(NULL,0,'2019-11-29 22:13:17',NULL,3948,'0',4229,335,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,3949,'0',4230,335,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,3950,'0',4231,335,5,NULL,'71020fa1bb604d4d99f1adaad2305bc8'),(NULL,0,'2019-11-29 22:13:17',NULL,3951,'0',4232,335,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:17',NULL,3952,'0',4234,336,16,NULL,'cmdb1-3-1-7'),(NULL,0,'2019-11-29 22:13:17',NULL,3953,'0',4235,336,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,3954,'0',4236,336,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:17',NULL,3955,'0',4237,336,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3956,'0',4238,336,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3957,'0',4239,336,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:17',NULL,3958,'0',4240,336,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3959,'0',4241,336,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:17',NULL,3960,'0',4242,336,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3961,'0',4243,336,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3962,'0',4244,336,15,NULL,'10.3.1.7'),(NULL,0,'2019-11-29 22:13:17',NULL,3963,'0',4245,336,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,3964,'0',4246,336,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,3965,'0',4247,336,5,NULL,'9583ce53991245ee938dee87252bc12e'),(NULL,0,'2019-11-29 22:13:17',NULL,3966,'0',4248,336,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:17',NULL,3967,'0',4250,337,16,NULL,'cmdb1-3-1-8'),(NULL,0,'2019-11-29 22:13:17',NULL,3968,'0',4251,337,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,3969,'0',4252,337,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:17',NULL,3970,'0',4253,337,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3971,'0',4254,337,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3972,'0',4255,337,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:17',NULL,3973,'0',4256,337,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3974,'0',4257,337,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:17',NULL,3975,'0',4258,337,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3976,'0',4259,337,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3977,'0',4260,337,15,NULL,'10.3.1.8'),(NULL,0,'2019-11-29 22:13:17',NULL,3978,'0',4261,337,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,3979,'0',4262,337,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,3980,'0',4263,337,5,NULL,'4d215f68627b4e778e88cece7a735ef7'),(NULL,0,'2019-11-29 22:13:17',NULL,3981,'0',4264,337,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:17',NULL,3982,'0',4266,338,16,NULL,'cmdb1-3-1-9'),(NULL,0,'2019-11-29 22:13:17',NULL,3983,'0',4267,338,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,3984,'0',4268,338,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:17',NULL,3985,'0',4269,338,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3986,'0',4270,338,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3987,'0',4271,338,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:17',NULL,3988,'0',4272,338,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3989,'0',4273,338,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:17',NULL,3990,'0',4274,338,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3991,'0',4275,338,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3992,'0',4276,338,15,NULL,'10.3.1.9'),(NULL,0,'2019-11-29 22:13:17',NULL,3993,'0',4277,338,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,3994,'0',4278,338,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,3995,'0',4279,338,5,NULL,'28122034789940e59bc1511e2e757763'),(NULL,0,'2019-11-29 22:13:17',NULL,3996,'0',4280,338,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:17',NULL,3997,'0',4282,339,16,NULL,'cmdb1-3-1-10'),(NULL,0,'2019-11-29 22:13:18',NULL,3998,'0',4283,339,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,3999,'0',4284,339,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:18',NULL,4000,'0',4285,339,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,4001,'0',4286,339,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,4002,'0',4287,339,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:18',NULL,4003,'0',4288,339,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,4004,'0',4289,339,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:18',NULL,4005,'0',4290,339,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,4006,'0',4291,339,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,4007,'0',4292,339,15,NULL,'10.3.1.10'),(NULL,0,'2019-11-29 22:13:18',NULL,4008,'0',4293,339,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,4009,'0',4294,339,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,4010,'0',4295,339,5,NULL,'5ed7fe3638434a19af7d89cbee7ca3f2'),(NULL,0,'2019-11-29 22:13:18',NULL,4011,'0',4296,339,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:18',NULL,4012,'0',4298,340,16,NULL,'cmdb1-3-1-11'),(NULL,0,'2019-11-29 22:13:18',NULL,4013,'0',4299,340,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,4014,'0',4300,340,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:18',NULL,4015,'0',4301,340,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,4016,'0',4302,340,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,4017,'0',4303,340,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:18',NULL,4018,'0',4304,340,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,4019,'0',4305,340,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:18',NULL,4020,'0',4306,340,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,4021,'0',4307,340,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,4022,'0',4308,340,15,NULL,'10.3.1.11'),(NULL,0,'2019-11-29 22:13:18',NULL,4023,'0',4309,340,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,4024,'0',4310,340,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,4025,'0',4311,340,5,NULL,'6d8df46d68374bc3bbda3bded7a2afe2'),(NULL,0,'2019-11-29 22:13:18',NULL,4026,'0',4312,340,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:18',NULL,4027,'0',4314,341,16,NULL,'cmdb1-3-1-12'),(NULL,0,'2019-11-29 22:13:18',NULL,4028,'0',4315,341,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,4029,'0',4316,341,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:18',NULL,4030,'0',4317,341,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,4031,'0',4318,341,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,4032,'0',4319,341,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:18',NULL,4033,'0',4320,341,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,4034,'0',4321,341,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:18',NULL,4035,'0',4322,341,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,4036,'0',4323,341,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,4037,'0',4324,341,15,NULL,'10.3.1.12'),(NULL,0,'2019-11-29 22:13:18',NULL,4038,'0',4325,341,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,4039,'0',4326,341,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,4040,'0',4327,341,5,NULL,'96cd64a33c7f45ff9c04531e6446cabd'),(NULL,0,'2019-11-29 22:13:18',NULL,4041,'0',4328,341,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:18',NULL,4042,'0',4330,342,16,NULL,'cmdb1-3-1-13'),(NULL,0,'2019-11-29 22:13:18',NULL,4043,'0',4331,342,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,4044,'0',4332,342,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:18',NULL,4045,'0',4333,342,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,4046,'0',4334,342,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,4047,'0',4335,342,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:18',NULL,4048,'0',4336,342,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,4049,'0',4337,342,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:18',NULL,4050,'0',4338,342,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,4051,'0',4339,342,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,4052,'0',4340,342,15,NULL,'10.3.1.13'),(NULL,0,'2019-11-29 22:13:18',NULL,4053,'0',4341,342,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,4054,'0',4342,342,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,4055,'0',4343,342,5,NULL,'bc49010d859f4a26a633c7987ce1a74c'),(NULL,0,'2019-11-29 22:13:18',NULL,4056,'0',4344,342,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:18',NULL,4057,'0',4346,343,16,NULL,'cmdb1-3-1-14'),(NULL,0,'2019-11-29 22:13:18',NULL,4058,'0',4347,343,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,4059,'0',4348,343,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:18',NULL,4060,'0',4349,343,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,4061,'0',4350,343,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,4062,'0',4351,343,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:18',NULL,4063,'0',4352,343,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,4064,'0',4353,343,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:18',NULL,4065,'0',4354,343,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,4066,'0',4355,343,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,4067,'0',4356,343,15,NULL,'10.3.1.14'),(NULL,0,'2019-11-29 22:13:19',NULL,4068,'0',4357,343,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,4069,'0',4358,343,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,4070,'0',4359,343,5,NULL,'852cd74ca426459ab03558ded22e6a24'),(NULL,0,'2019-11-29 22:13:19',NULL,4071,'0',4360,343,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:19',NULL,4072,'0',4362,344,16,NULL,'cmdb1-3-1-15'),(NULL,0,'2019-11-29 22:13:19',NULL,4073,'0',4363,344,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,4074,'0',4364,344,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:19',NULL,4075,'0',4365,344,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,4076,'0',4366,344,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,4077,'0',4367,344,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:19',NULL,4078,'0',4368,344,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,4079,'0',4369,344,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:19',NULL,4080,'0',4370,344,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,4081,'0',4371,344,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,4082,'0',4372,344,15,NULL,'10.3.1.15'),(NULL,0,'2019-11-29 22:13:19',NULL,4083,'0',4373,344,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,4084,'0',4374,344,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,4085,'0',4375,344,5,NULL,'1068f097b23d448e8fd82fd986acbcad'),(NULL,0,'2019-11-29 22:13:19',NULL,4086,'0',4376,344,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:19',NULL,4087,'0',4378,345,16,NULL,'cmdb1-3-1-16'),(NULL,0,'2019-11-29 22:13:19',NULL,4088,'0',4379,345,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,4089,'0',4380,345,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:19',NULL,4090,'0',4381,345,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,4091,'0',4382,345,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,4092,'0',4383,345,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:19',NULL,4093,'0',4384,345,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,4094,'0',4385,345,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:19',NULL,4095,'0',4386,345,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,4096,'0',4387,345,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,4097,'0',4388,345,15,NULL,'10.3.1.16'),(NULL,0,'2019-11-29 22:13:19',NULL,4098,'0',4389,345,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,4099,'0',4390,345,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,4100,'0',4391,345,5,NULL,'97c0172fa28b4f20bd33afac65631a39'),(NULL,0,'2019-11-29 22:13:19',NULL,4101,'0',4392,345,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:19',NULL,4102,'0',4394,346,4,NULL,'App1-3-2'),(NULL,0,'2019-11-29 22:13:19',NULL,4103,'0',4396,347,16,NULL,'cmdb1-3-2-1'),(NULL,0,'2019-11-29 22:13:19',NULL,4104,'0',4397,347,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,4105,'0',4398,347,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:19',NULL,4106,'0',4399,347,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,4107,'0',4400,347,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,4108,'0',4401,347,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:19',NULL,4109,'0',4402,347,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,4110,'0',4403,347,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:19',NULL,4111,'0',4404,347,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,4112,'0',4405,347,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,4113,'0',4406,347,15,NULL,'10.3.2.1'),(NULL,0,'2019-11-29 22:13:19',NULL,4114,'0',4407,347,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,4115,'0',4408,347,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,4116,'0',4409,347,5,NULL,'08ddd16f1e9b4d28a884153fb303d525'),(NULL,0,'2019-11-29 22:13:19',NULL,4117,'0',4410,347,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:19',NULL,4118,'0',4412,348,16,NULL,'cmdb1-3-2-2'),(NULL,0,'2019-11-29 22:13:19',NULL,4119,'0',4413,348,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,4120,'0',4414,348,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:19',NULL,4121,'0',4415,348,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,4122,'0',4416,348,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,4123,'0',4417,348,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:19',NULL,4124,'0',4418,348,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,4125,'0',4419,348,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:19',NULL,4126,'0',4420,348,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,4127,'0',4421,348,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,4128,'0',4422,348,15,NULL,'10.3.2.2'),(NULL,0,'2019-11-29 22:13:20',NULL,4129,'0',4423,348,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,4130,'0',4424,348,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,4131,'0',4425,348,5,NULL,'44077d060a3140a2a64fabfc8fbc297c'),(NULL,0,'2019-11-29 22:13:20',NULL,4132,'0',4426,348,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:20',NULL,4133,'0',4428,349,16,NULL,'cmdb1-3-2-3'),(NULL,0,'2019-11-29 22:13:20',NULL,4134,'0',4429,349,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,4135,'0',4430,349,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:20',NULL,4136,'0',4431,349,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,4137,'0',4432,349,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,4138,'0',4433,349,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:20',NULL,4139,'0',4434,349,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,4140,'0',4435,349,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:20',NULL,4141,'0',4436,349,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,4142,'0',4437,349,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,4143,'0',4438,349,15,NULL,'10.3.2.3'),(NULL,0,'2019-11-29 22:13:20',NULL,4144,'0',4439,349,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,4145,'0',4440,349,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,4146,'0',4441,349,5,NULL,'d3af8b79f67e4b1889a1f7afe0ad8d36'),(NULL,0,'2019-11-29 22:13:20',NULL,4147,'0',4442,349,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:20',NULL,4148,'0',4444,350,16,NULL,'cmdb1-3-2-4'),(NULL,0,'2019-11-29 22:13:20',NULL,4149,'0',4445,350,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,4150,'0',4446,350,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:20',NULL,4151,'0',4447,350,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,4152,'0',4448,350,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,4153,'0',4449,350,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:20',NULL,4154,'0',4450,350,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,4155,'0',4451,350,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:20',NULL,4156,'0',4452,350,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,4157,'0',4453,350,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,4158,'0',4454,350,15,NULL,'10.3.2.4'),(NULL,0,'2019-11-29 22:13:20',NULL,4159,'0',4455,350,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,4160,'0',4456,350,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,4161,'0',4457,350,5,NULL,'5e548a19ac1e4b8fb325556faf32bb5e'),(NULL,0,'2019-11-29 22:13:20',NULL,4162,'0',4458,350,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:20',NULL,4163,'0',4460,351,16,NULL,'cmdb1-3-2-5'),(NULL,0,'2019-11-29 22:13:20',NULL,4164,'0',4461,351,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,4165,'0',4462,351,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:20',NULL,4166,'0',4463,351,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,4167,'0',4464,351,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,4168,'0',4465,351,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:20',NULL,4169,'0',4466,351,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,4170,'0',4467,351,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:20',NULL,4171,'0',4468,351,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,4172,'0',4469,351,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,4173,'0',4470,351,15,NULL,'10.3.2.5'),(NULL,0,'2019-11-29 22:13:20',NULL,4174,'0',4471,351,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,4175,'0',4472,351,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,4176,'0',4473,351,5,NULL,'64f0b8348315425189f046f92522f054'),(NULL,0,'2019-11-29 22:13:20',NULL,4177,'0',4474,351,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:20',NULL,4178,'0',4476,352,16,NULL,'cmdb1-3-2-6'),(NULL,0,'2019-11-29 22:13:20',NULL,4179,'0',4477,352,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,4180,'0',4478,352,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:20',NULL,4181,'0',4479,352,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,4182,'0',4480,352,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,4183,'0',4481,352,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:20',NULL,4184,'0',4482,352,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,4185,'0',4483,352,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:20',NULL,4186,'0',4484,352,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,4187,'0',4485,352,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,4188,'0',4486,352,15,NULL,'10.3.2.6'),(NULL,0,'2019-11-29 22:13:20',NULL,4189,'0',4487,352,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,4190,'0',4488,352,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,4191,'0',4489,352,5,NULL,'285da03c3d0e42c685a332959401d949'),(NULL,0,'2019-11-29 22:13:20',NULL,4192,'0',4490,352,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:21',NULL,4193,'0',4492,353,16,NULL,'cmdb1-3-2-7'),(NULL,0,'2019-11-29 22:13:21',NULL,4194,'0',4493,353,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,4195,'0',4494,353,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:21',NULL,4196,'0',4495,353,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,4197,'0',4496,353,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,4198,'0',4497,353,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:21',NULL,4199,'0',4498,353,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,4200,'0',4499,353,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:21',NULL,4201,'0',4500,353,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,4202,'0',4501,353,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,4203,'0',4502,353,15,NULL,'10.3.2.7'),(NULL,0,'2019-11-29 22:13:21',NULL,4204,'0',4503,353,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,4205,'0',4504,353,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,4206,'0',4505,353,5,NULL,'7b870224c52444e3bdd10e20a1cda063'),(NULL,0,'2019-11-29 22:13:21',NULL,4207,'0',4506,353,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:21',NULL,4208,'0',4508,354,16,NULL,'cmdb1-3-2-8'),(NULL,0,'2019-11-29 22:13:21',NULL,4209,'0',4509,354,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,4210,'0',4510,354,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:21',NULL,4211,'0',4511,354,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,4212,'0',4512,354,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,4213,'0',4513,354,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:21',NULL,4214,'0',4514,354,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,4215,'0',4515,354,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:21',NULL,4216,'0',4516,354,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,4217,'0',4517,354,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,4218,'0',4518,354,15,NULL,'10.3.2.8'),(NULL,0,'2019-11-29 22:13:21',NULL,4219,'0',4519,354,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,4220,'0',4520,354,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,4221,'0',4521,354,5,NULL,'90cc258dc0d54454ab75ee150cbe3940'),(NULL,0,'2019-11-29 22:13:21',NULL,4222,'0',4522,354,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:21',NULL,4223,'0',4524,355,16,NULL,'cmdb1-3-2-9'),(NULL,0,'2019-11-29 22:13:21',NULL,4224,'0',4525,355,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,4225,'0',4526,355,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:21',NULL,4226,'0',4527,355,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,4227,'0',4528,355,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,4228,'0',4529,355,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:21',NULL,4229,'0',4530,355,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,4230,'0',4531,355,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:21',NULL,4231,'0',4532,355,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,4232,'0',4533,355,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,4233,'0',4534,355,15,NULL,'10.3.2.9'),(NULL,0,'2019-11-29 22:13:21',NULL,4234,'0',4535,355,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,4235,'0',4536,355,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,4236,'0',4537,355,5,NULL,'b069775983ad4fc5b5b5d930f77fe58d'),(NULL,0,'2019-11-29 22:13:21',NULL,4237,'0',4538,355,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:21',NULL,4238,'0',4540,356,16,NULL,'cmdb1-3-2-10'),(NULL,0,'2019-11-29 22:13:21',NULL,4239,'0',4541,356,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,4240,'0',4542,356,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:21',NULL,4241,'0',4543,356,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,4242,'0',4544,356,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,4243,'0',4545,356,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:21',NULL,4244,'0',4546,356,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,4245,'0',4547,356,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:21',NULL,4246,'0',4548,356,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,4247,'0',4549,356,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,4248,'0',4550,356,15,NULL,'10.3.2.10'),(NULL,0,'2019-11-29 22:13:21',NULL,4249,'0',4551,356,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,4250,'0',4552,356,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,4251,'0',4553,356,5,NULL,'e55bf4a27e114b8a801479d3ee794d98'),(NULL,0,'2019-11-29 22:13:21',NULL,4252,'0',4554,356,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:21',NULL,4253,'0',4556,357,16,NULL,'cmdb1-3-2-11'),(NULL,0,'2019-11-29 22:13:21',NULL,4254,'0',4557,357,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,4255,'0',4558,357,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:21',NULL,4256,'0',4559,357,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,4257,'0',4560,357,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,4258,'0',4561,357,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:22',NULL,4259,'0',4562,357,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,4260,'0',4563,357,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:22',NULL,4261,'0',4564,357,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,4262,'0',4565,357,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,4263,'0',4566,357,15,NULL,'10.3.2.11'),(NULL,0,'2019-11-29 22:13:22',NULL,4264,'0',4567,357,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,4265,'0',4568,357,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,4266,'0',4569,357,5,NULL,'14433921d60a4aee825e832c04ec1ea2'),(NULL,0,'2019-11-29 22:13:22',NULL,4267,'0',4570,357,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:22',NULL,4268,'0',4572,358,16,NULL,'cmdb1-3-2-12'),(NULL,0,'2019-11-29 22:13:22',NULL,4269,'0',4573,358,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,4270,'0',4574,358,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:22',NULL,4271,'0',4575,358,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,4272,'0',4576,358,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,4273,'0',4577,358,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:22',NULL,4274,'0',4578,358,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,4275,'0',4579,358,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:22',NULL,4276,'0',4580,358,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,4277,'0',4581,358,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,4278,'0',4582,358,15,NULL,'10.3.2.12'),(NULL,0,'2019-11-29 22:13:22',NULL,4279,'0',4583,358,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,4280,'0',4584,358,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,4281,'0',4585,358,5,NULL,'05c03df6ff4543e3af4aee82e5d9d18c'),(NULL,0,'2019-11-29 22:13:22',NULL,4282,'0',4586,358,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:22',NULL,4283,'0',4588,359,16,NULL,'cmdb1-3-2-13'),(NULL,0,'2019-11-29 22:13:22',NULL,4284,'0',4589,359,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,4285,'0',4590,359,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:22',NULL,4286,'0',4591,359,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,4287,'0',4592,359,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,4288,'0',4593,359,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:22',NULL,4289,'0',4594,359,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,4290,'0',4595,359,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:22',NULL,4291,'0',4596,359,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,4292,'0',4597,359,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,4293,'0',4598,359,15,NULL,'10.3.2.13'),(NULL,0,'2019-11-29 22:13:22',NULL,4294,'0',4599,359,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,4295,'0',4600,359,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,4296,'0',4601,359,5,NULL,'9d1d4cdfa0be49338636bb248d2f19e1'),(NULL,0,'2019-11-29 22:13:22',NULL,4297,'0',4602,359,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:22',NULL,4298,'0',4604,360,16,NULL,'cmdb1-3-2-14'),(NULL,0,'2019-11-29 22:13:22',NULL,4299,'0',4605,360,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,4300,'0',4606,360,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:22',NULL,4301,'0',4607,360,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,4302,'0',4608,360,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,4303,'0',4609,360,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:22',NULL,4304,'0',4610,360,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,4305,'0',4611,360,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:22',NULL,4306,'0',4612,360,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,4307,'0',4613,360,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,4308,'0',4614,360,15,NULL,'10.3.2.14'),(NULL,0,'2019-11-29 22:13:22',NULL,4309,'0',4615,360,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,4310,'0',4616,360,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,4311,'0',4617,360,5,NULL,'08569f12e6e146d2b7b31a4be5130b18'),(NULL,0,'2019-11-29 22:13:22',NULL,4312,'0',4618,360,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:22',NULL,4313,'0',4620,361,16,NULL,'cmdb1-3-2-15'),(NULL,0,'2019-11-29 22:13:22',NULL,4314,'0',4621,361,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,4315,'0',4622,361,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:22',NULL,4316,'0',4623,361,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,4317,'0',4624,361,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,4318,'0',4625,361,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:22',NULL,4319,'0',4626,361,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,4320,'0',4627,361,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:22',NULL,4321,'0',4628,361,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,4322,'0',4629,361,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,4323,'0',4630,361,15,NULL,'10.3.2.15'),(NULL,0,'2019-11-29 22:13:22',NULL,4324,'0',4631,361,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,4325,'0',4632,361,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,4326,'0',4633,361,5,NULL,'a67a96496b5d47ae8a12285408a82b00'),(NULL,0,'2019-11-29 22:13:23',NULL,4327,'0',4634,361,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:23',NULL,4328,'0',4636,362,16,NULL,'cmdb1-3-2-16'),(NULL,0,'2019-11-29 22:13:23',NULL,4329,'0',4637,362,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,4330,'0',4638,362,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:23',NULL,4331,'0',4639,362,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,4332,'0',4640,362,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,4333,'0',4641,362,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:23',NULL,4334,'0',4642,362,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,4335,'0',4643,362,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:23',NULL,4336,'0',4644,362,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,4337,'0',4645,362,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,4338,'0',4646,362,15,NULL,'10.3.2.16'),(NULL,0,'2019-11-29 22:13:23',NULL,4339,'0',4647,362,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,4340,'0',4648,362,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,4341,'0',4649,362,5,NULL,'00bac21c49024549835c7aadd2d6a93e'),(NULL,0,'2019-11-29 22:13:23',NULL,4342,'0',4650,362,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:23',NULL,4343,'0',4652,363,4,NULL,'App1-3-3'),(NULL,0,'2019-11-29 22:13:23',NULL,4344,'0',4654,364,16,NULL,'cmdb1-3-3-1'),(NULL,0,'2019-11-29 22:13:23',NULL,4345,'0',4655,364,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,4346,'0',4656,364,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:23',NULL,4347,'0',4657,364,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,4348,'0',4658,364,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,4349,'0',4659,364,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:23',NULL,4350,'0',4660,364,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,4351,'0',4661,364,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:23',NULL,4352,'0',4662,364,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,4353,'0',4663,364,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,4354,'0',4664,364,15,NULL,'10.3.3.1'),(NULL,0,'2019-11-29 22:13:23',NULL,4355,'0',4665,364,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,4356,'0',4666,364,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,4357,'0',4667,364,5,NULL,'1429014f80d649bb83da55087d91fd7f'),(NULL,0,'2019-11-29 22:13:23',NULL,4358,'0',4668,364,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:23',NULL,4359,'0',4670,365,16,NULL,'cmdb1-3-3-2'),(NULL,0,'2019-11-29 22:13:23',NULL,4360,'0',4671,365,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,4361,'0',4672,365,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:23',NULL,4362,'0',4673,365,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,4363,'0',4674,365,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,4364,'0',4675,365,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:23',NULL,4365,'0',4676,365,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,4366,'0',4677,365,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:23',NULL,4367,'0',4678,365,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,4368,'0',4679,365,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,4369,'0',4680,365,15,NULL,'10.3.3.2'),(NULL,0,'2019-11-29 22:13:23',NULL,4370,'0',4681,365,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,4371,'0',4682,365,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,4372,'0',4683,365,5,NULL,'1342d41830f0426299b1051697658394'),(NULL,0,'2019-11-29 22:13:23',NULL,4373,'0',4684,365,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:23',NULL,4374,'0',4686,366,16,NULL,'cmdb1-3-3-3'),(NULL,0,'2019-11-29 22:13:23',NULL,4375,'0',4687,366,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,4376,'0',4688,366,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:23',NULL,4377,'0',4689,366,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,4378,'0',4690,366,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,4379,'0',4691,366,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:23',NULL,4380,'0',4692,366,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,4381,'0',4693,366,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:23',NULL,4382,'0',4694,366,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,4383,'0',4695,366,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,4384,'0',4696,366,15,NULL,'10.3.3.3'),(NULL,0,'2019-11-29 22:13:23',NULL,4385,'0',4697,366,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,4386,'0',4698,366,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,4387,'0',4699,366,5,NULL,'c3fba6ff0b3d430e95fd0aa2119d8284'),(NULL,0,'2019-11-29 22:13:24',NULL,4388,'0',4700,366,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:24',NULL,4389,'0',4702,367,16,NULL,'cmdb1-3-3-4'),(NULL,0,'2019-11-29 22:13:24',NULL,4390,'0',4703,367,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,4391,'0',4704,367,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:24',NULL,4392,'0',4705,367,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,4393,'0',4706,367,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,4394,'0',4707,367,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:24',NULL,4395,'0',4708,367,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,4396,'0',4709,367,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:24',NULL,4397,'0',4710,367,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,4398,'0',4711,367,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,4399,'0',4712,367,15,NULL,'10.3.3.4'),(NULL,0,'2019-11-29 22:13:24',NULL,4400,'0',4713,367,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,4401,'0',4714,367,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,4402,'0',4715,367,5,NULL,'54b43cb8d6d64d5e8b74f4956adfcb87'),(NULL,0,'2019-11-29 22:13:24',NULL,4403,'0',4716,367,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:24',NULL,4404,'0',4718,368,16,NULL,'cmdb1-3-3-5'),(NULL,0,'2019-11-29 22:13:24',NULL,4405,'0',4719,368,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,4406,'0',4720,368,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:24',NULL,4407,'0',4721,368,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,4408,'0',4722,368,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,4409,'0',4723,368,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:24',NULL,4410,'0',4724,368,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,4411,'0',4725,368,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:24',NULL,4412,'0',4726,368,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,4413,'0',4727,368,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,4414,'0',4728,368,15,NULL,'10.3.3.5'),(NULL,0,'2019-11-29 22:13:24',NULL,4415,'0',4729,368,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,4416,'0',4730,368,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,4417,'0',4731,368,5,NULL,'b3720a1fff1b4ef3b597467fd7eeadfa'),(NULL,0,'2019-11-29 22:13:24',NULL,4418,'0',4732,368,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:24',NULL,4419,'0',4734,369,16,NULL,'cmdb1-3-3-6'),(NULL,0,'2019-11-29 22:13:24',NULL,4420,'0',4735,369,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,4421,'0',4736,369,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:24',NULL,4422,'0',4737,369,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,4423,'0',4738,369,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,4424,'0',4739,369,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:24',NULL,4425,'0',4740,369,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,4426,'0',4741,369,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:24',NULL,4427,'0',4742,369,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,4428,'0',4743,369,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,4429,'0',4744,369,15,NULL,'10.3.3.6'),(NULL,0,'2019-11-29 22:13:24',NULL,4430,'0',4745,369,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,4431,'0',4746,369,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,4432,'0',4747,369,5,NULL,'50dea25ecece4b4a8bc01cd0d387a956'),(NULL,0,'2019-11-29 22:13:24',NULL,4433,'0',4748,369,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:24',NULL,4434,'0',4750,370,16,NULL,'cmdb1-3-3-7'),(NULL,0,'2019-11-29 22:13:24',NULL,4435,'0',4751,370,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,4436,'0',4752,370,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:24',NULL,4437,'0',4753,370,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,4438,'0',4754,370,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,4439,'0',4755,370,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:24',NULL,4440,'0',4756,370,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,4441,'0',4757,370,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:24',NULL,4442,'0',4758,370,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,4443,'0',4759,370,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,4444,'0',4760,370,15,NULL,'10.3.3.7'),(NULL,0,'2019-11-29 22:13:24',NULL,4445,'0',4761,370,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,4446,'0',4762,370,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,4447,'0',4763,370,5,NULL,'7b1b3c45cffe4d39bd29afb9c8c1ac1f'),(NULL,0,'2019-11-29 22:13:24',NULL,4448,'0',4764,370,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:24',NULL,4449,'0',4766,371,16,NULL,'cmdb1-3-3-8'),(NULL,0,'2019-11-29 22:13:25',NULL,4450,'0',4767,371,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,4451,'0',4768,371,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:25',NULL,4452,'0',4769,371,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,4453,'0',4770,371,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,4454,'0',4771,371,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:25',NULL,4455,'0',4772,371,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,4456,'0',4773,371,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:25',NULL,4457,'0',4774,371,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,4458,'0',4775,371,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,4459,'0',4776,371,15,NULL,'10.3.3.8'),(NULL,0,'2019-11-29 22:13:25',NULL,4460,'0',4777,371,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,4461,'0',4778,371,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,4462,'0',4779,371,5,NULL,'a0da7b8fd31f4cea903130720800223a'),(NULL,0,'2019-11-29 22:13:25',NULL,4463,'0',4780,371,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:25',NULL,4464,'0',4782,372,16,NULL,'cmdb1-3-3-9'),(NULL,0,'2019-11-29 22:13:25',NULL,4465,'0',4783,372,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,4466,'0',4784,372,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:25',NULL,4467,'0',4785,372,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,4468,'0',4786,372,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,4469,'0',4787,372,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:25',NULL,4470,'0',4788,372,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,4471,'0',4789,372,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:25',NULL,4472,'0',4790,372,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,4473,'0',4791,372,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,4474,'0',4792,372,15,NULL,'10.3.3.9'),(NULL,0,'2019-11-29 22:13:25',NULL,4475,'0',4793,372,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,4476,'0',4794,372,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,4477,'0',4795,372,5,NULL,'c43bec26c31941f78fb7f49c47853002'),(NULL,0,'2019-11-29 22:13:25',NULL,4478,'0',4796,372,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:25',NULL,4479,'0',4798,373,16,NULL,'cmdb1-3-3-10'),(NULL,0,'2019-11-29 22:13:25',NULL,4480,'0',4799,373,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,4481,'0',4800,373,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:25',NULL,4482,'0',4801,373,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,4483,'0',4802,373,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,4484,'0',4803,373,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:25',NULL,4485,'0',4804,373,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,4486,'0',4805,373,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:25',NULL,4487,'0',4806,373,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,4488,'0',4807,373,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,4489,'0',4808,373,15,NULL,'10.3.3.10'),(NULL,0,'2019-11-29 22:13:25',NULL,4490,'0',4809,373,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,4491,'0',4810,373,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,4492,'0',4811,373,5,NULL,'6e2301755fdb4013b9a5595a4cd73f40'),(NULL,0,'2019-11-29 22:13:25',NULL,4493,'0',4812,373,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:25',NULL,4494,'0',4814,374,16,NULL,'cmdb1-3-3-11'),(NULL,0,'2019-11-29 22:13:25',NULL,4495,'0',4815,374,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,4496,'0',4816,374,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:25',NULL,4497,'0',4817,374,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,4498,'0',4818,374,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,4499,'0',4819,374,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:25',NULL,4500,'0',4820,374,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,4501,'0',4821,374,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:25',NULL,4502,'0',4822,374,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,4503,'0',4823,374,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,4504,'0',4824,374,15,NULL,'10.3.3.11'),(NULL,0,'2019-11-29 22:13:25',NULL,4505,'0',4825,374,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,4506,'0',4826,374,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,4507,'0',4827,374,5,NULL,'b7cfe9bc55ce41c2b5b030f984160852'),(NULL,0,'2019-11-29 22:13:25',NULL,4508,'0',4828,374,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:25',NULL,4509,'0',4830,375,16,NULL,'cmdb1-3-3-12'),(NULL,0,'2019-11-29 22:13:25',NULL,4510,'0',4831,375,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,4511,'0',4832,375,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:25',NULL,4512,'0',4833,375,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,4513,'0',4834,375,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,4514,'0',4835,375,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:25',NULL,4515,'0',4836,375,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,4516,'0',4837,375,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:26',NULL,4517,'0',4838,375,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,4518,'0',4839,375,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,4519,'0',4840,375,15,NULL,'10.3.3.12'),(NULL,0,'2019-11-29 22:13:26',NULL,4520,'0',4841,375,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,4521,'0',4842,375,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,4522,'0',4843,375,5,NULL,'32e18385f3c24e9183818b463cb62951'),(NULL,0,'2019-11-29 22:13:26',NULL,4523,'0',4844,375,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:26',NULL,4524,'0',4846,376,16,NULL,'cmdb1-3-3-13'),(NULL,0,'2019-11-29 22:13:26',NULL,4525,'0',4847,376,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,4526,'0',4848,376,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:26',NULL,4527,'0',4849,376,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,4528,'0',4850,376,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,4529,'0',4851,376,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:26',NULL,4530,'0',4852,376,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,4531,'0',4853,376,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:26',NULL,4532,'0',4854,376,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,4533,'0',4855,376,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,4534,'0',4856,376,15,NULL,'10.3.3.13'),(NULL,0,'2019-11-29 22:13:26',NULL,4535,'0',4857,376,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,4536,'0',4858,376,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,4537,'0',4859,376,5,NULL,'dd28195fba604e788a405b71985327bc'),(NULL,0,'2019-11-29 22:13:26',NULL,4538,'0',4860,376,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:26',NULL,4539,'0',4862,377,16,NULL,'cmdb1-3-3-14'),(NULL,0,'2019-11-29 22:13:26',NULL,4540,'0',4863,377,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,4541,'0',4864,377,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:26',NULL,4542,'0',4865,377,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,4543,'0',4866,377,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,4544,'0',4867,377,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:26',NULL,4545,'0',4868,377,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,4546,'0',4869,377,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:26',NULL,4547,'0',4870,377,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,4548,'0',4871,377,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,4549,'0',4872,377,15,NULL,'10.3.3.14'),(NULL,0,'2019-11-29 22:13:26',NULL,4550,'0',4873,377,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,4551,'0',4874,377,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,4552,'0',4875,377,5,NULL,'52e06fd49b344d4bbad67c0b8c2c511c'),(NULL,0,'2019-11-29 22:13:26',NULL,4553,'0',4876,377,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:26',NULL,4554,'0',4878,378,16,NULL,'cmdb1-3-3-15'),(NULL,0,'2019-11-29 22:13:26',NULL,4555,'0',4879,378,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,4556,'0',4880,378,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:26',NULL,4557,'0',4881,378,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,4558,'0',4882,378,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,4559,'0',4883,378,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:26',NULL,4560,'0',4884,378,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,4561,'0',4885,378,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:26',NULL,4562,'0',4886,378,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,4563,'0',4887,378,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,4564,'0',4888,378,15,NULL,'10.3.3.15'),(NULL,0,'2019-11-29 22:13:26',NULL,4565,'0',4889,378,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,4566,'0',4890,378,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,4567,'0',4891,378,5,NULL,'a20aaa68996344cc9565b2afec65bf81'),(NULL,0,'2019-11-29 22:13:26',NULL,4568,'0',4892,378,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:26',NULL,4569,'0',4894,379,16,NULL,'cmdb1-3-3-16'),(NULL,0,'2019-11-29 22:13:26',NULL,4570,'0',4895,379,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,4571,'0',4896,379,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:26',NULL,4572,'0',4897,379,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,4573,'0',4898,379,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,4574,'0',4899,379,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:26',NULL,4575,'0',4900,379,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,4576,'0',4901,379,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:26',NULL,4577,'0',4902,379,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,4578,'0',4903,379,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,4579,'0',4904,379,15,NULL,'10.3.3.16'),(NULL,0,'2019-11-29 22:13:26',NULL,4580,'0',4905,379,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,4581,'0',4906,379,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,4582,'0',4907,379,5,NULL,'3cbf6c98d356474593887fc9b55c139e'),(NULL,0,'2019-11-29 22:13:26',NULL,4583,'0',4908,379,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:27',NULL,4584,'0',4910,380,4,NULL,'App1-3-4'),(NULL,0,'2019-11-29 22:13:27',NULL,4585,'0',4912,381,16,NULL,'cmdb1-3-4-1'),(NULL,0,'2019-11-29 22:13:27',NULL,4586,'0',4913,381,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,4587,'0',4914,381,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:27',NULL,4588,'0',4915,381,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,4589,'0',4916,381,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,4590,'0',4917,381,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:27',NULL,4591,'0',4918,381,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,4592,'0',4919,381,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:27',NULL,4593,'0',4920,381,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,4594,'0',4921,381,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,4595,'0',4922,381,15,NULL,'10.3.4.1'),(NULL,0,'2019-11-29 22:13:27',NULL,4596,'0',4923,381,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,4597,'0',4924,381,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,4598,'0',4925,381,5,NULL,'f543a268cd704013b7d3bb003f48c857'),(NULL,0,'2019-11-29 22:13:27',NULL,4599,'0',4926,381,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:27',NULL,4600,'0',4928,382,16,NULL,'cmdb1-3-4-2'),(NULL,0,'2019-11-29 22:13:27',NULL,4601,'0',4929,382,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,4602,'0',4930,382,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:27',NULL,4603,'0',4931,382,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,4604,'0',4932,382,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,4605,'0',4933,382,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:27',NULL,4606,'0',4934,382,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,4607,'0',4935,382,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:27',NULL,4608,'0',4936,382,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,4609,'0',4937,382,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,4610,'0',4938,382,15,NULL,'10.3.4.2'),(NULL,0,'2019-11-29 22:13:27',NULL,4611,'0',4939,382,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,4612,'0',4940,382,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,4613,'0',4941,382,5,NULL,'b5bb7d85644c494f9003fe09b6d9a0fd'),(NULL,0,'2019-11-29 22:13:27',NULL,4614,'0',4942,382,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:27',NULL,4615,'0',4944,383,16,NULL,'cmdb1-3-4-3'),(NULL,0,'2019-11-29 22:13:27',NULL,4616,'0',4945,383,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,4617,'0',4946,383,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:27',NULL,4618,'0',4947,383,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,4619,'0',4948,383,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,4620,'0',4949,383,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:27',NULL,4621,'0',4950,383,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,4622,'0',4951,383,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:27',NULL,4623,'0',4952,383,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,4624,'0',4953,383,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,4625,'0',4954,383,15,NULL,'10.3.4.3'),(NULL,0,'2019-11-29 22:13:27',NULL,4626,'0',4955,383,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,4627,'0',4956,383,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,4628,'0',4957,383,5,NULL,'8d3daf978c294b6384a762634f317640'),(NULL,0,'2019-11-29 22:13:27',NULL,4629,'0',4958,383,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:27',NULL,4630,'0',4960,384,16,NULL,'cmdb1-3-4-4'),(NULL,0,'2019-11-29 22:13:27',NULL,4631,'0',4961,384,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,4632,'0',4962,384,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:27',NULL,4633,'0',4963,384,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,4634,'0',4964,384,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,4635,'0',4965,384,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:27',NULL,4636,'0',4966,384,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,4637,'0',4967,384,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:27',NULL,4638,'0',4968,384,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,4639,'0',4969,384,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,4640,'0',4970,384,15,NULL,'10.3.4.4'),(NULL,0,'2019-11-29 22:13:27',NULL,4641,'0',4971,384,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,4642,'0',4972,384,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,4643,'0',4973,384,5,NULL,'b7724f4c8a9f4d978f74b85c4ab7f80e'),(NULL,0,'2019-11-29 22:13:27',NULL,4644,'0',4974,384,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:28',NULL,4645,'0',4976,385,16,NULL,'cmdb1-3-4-5'),(NULL,0,'2019-11-29 22:13:28',NULL,4646,'0',4977,385,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,4647,'0',4978,385,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:28',NULL,4648,'0',4979,385,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,4649,'0',4980,385,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,4650,'0',4981,385,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:28',NULL,4651,'0',4982,385,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,4652,'0',4983,385,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:28',NULL,4653,'0',4984,385,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,4654,'0',4985,385,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,4655,'0',4986,385,15,NULL,'10.3.4.5'),(NULL,0,'2019-11-29 22:13:28',NULL,4656,'0',4987,385,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,4657,'0',4988,385,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,4658,'0',4989,385,5,NULL,'1928ad1823504fd385304cf35231d2ac'),(NULL,0,'2019-11-29 22:13:28',NULL,4659,'0',4990,385,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:28',NULL,4660,'0',4992,386,16,NULL,'cmdb1-3-4-6'),(NULL,0,'2019-11-29 22:13:28',NULL,4661,'0',4993,386,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,4662,'0',4994,386,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:28',NULL,4663,'0',4995,386,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,4664,'0',4996,386,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,4665,'0',4997,386,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:28',NULL,4666,'0',4998,386,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,4667,'0',4999,386,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:28',NULL,4668,'0',5000,386,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,4669,'0',5001,386,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,4670,'0',5002,386,15,NULL,'10.3.4.6'),(NULL,0,'2019-11-29 22:13:28',NULL,4671,'0',5003,386,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,4672,'0',5004,386,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,4673,'0',5005,386,5,NULL,'8391a7845d424ed4b59d318111be0d7d'),(NULL,0,'2019-11-29 22:13:28',NULL,4674,'0',5006,386,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:28',NULL,4675,'0',5008,387,16,NULL,'cmdb1-3-4-7'),(NULL,0,'2019-11-29 22:13:28',NULL,4676,'0',5009,387,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,4677,'0',5010,387,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:28',NULL,4678,'0',5011,387,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,4679,'0',5012,387,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,4680,'0',5013,387,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:28',NULL,4681,'0',5014,387,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,4682,'0',5015,387,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:28',NULL,4683,'0',5016,387,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,4684,'0',5017,387,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,4685,'0',5018,387,15,NULL,'10.3.4.7'),(NULL,0,'2019-11-29 22:13:28',NULL,4686,'0',5019,387,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,4687,'0',5020,387,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,4688,'0',5021,387,5,NULL,'ef8eb47b7e384916b6bea88d2724f084'),(NULL,0,'2019-11-29 22:13:28',NULL,4689,'0',5022,387,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:28',NULL,4690,'0',5024,388,16,NULL,'cmdb1-3-4-8'),(NULL,0,'2019-11-29 22:13:28',NULL,4691,'0',5025,388,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,4692,'0',5026,388,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:28',NULL,4693,'0',5027,388,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,4694,'0',5028,388,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,4695,'0',5029,388,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:28',NULL,4696,'0',5030,388,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,4697,'0',5031,388,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:28',NULL,4698,'0',5032,388,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,4699,'0',5033,388,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,4700,'0',5034,388,15,NULL,'10.3.4.8'),(NULL,0,'2019-11-29 22:13:28',NULL,4701,'0',5035,388,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,4702,'0',5036,388,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,4703,'0',5037,388,5,NULL,'4fb44e5453e2478f9c931a1275cee2a1'),(NULL,0,'2019-11-29 22:13:28',NULL,4704,'0',5038,388,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:28',NULL,4705,'0',5040,389,16,NULL,'cmdb1-3-4-9'),(NULL,0,'2019-11-29 22:13:28',NULL,4706,'0',5041,389,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,4707,'0',5042,389,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:29',NULL,4708,'0',5043,389,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,4709,'0',5044,389,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,4710,'0',5045,389,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:29',NULL,4711,'0',5046,389,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,4712,'0',5047,389,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:29',NULL,4713,'0',5048,389,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,4714,'0',5049,389,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,4715,'0',5050,389,15,NULL,'10.3.4.9'),(NULL,0,'2019-11-29 22:13:29',NULL,4716,'0',5051,389,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,4717,'0',5052,389,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,4718,'0',5053,389,5,NULL,'242da1291ba24b5aafea96d0cc58e233'),(NULL,0,'2019-11-29 22:13:29',NULL,4719,'0',5054,389,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:29',NULL,4720,'0',5056,390,16,NULL,'cmdb1-3-4-10'),(NULL,0,'2019-11-29 22:13:29',NULL,4721,'0',5057,390,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,4722,'0',5058,390,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:29',NULL,4723,'0',5059,390,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,4724,'0',5060,390,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,4725,'0',5061,390,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:29',NULL,4726,'0',5062,390,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,4727,'0',5063,390,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:29',NULL,4728,'0',5064,390,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,4729,'0',5065,390,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,4730,'0',5066,390,15,NULL,'10.3.4.10'),(NULL,0,'2019-11-29 22:13:29',NULL,4731,'0',5067,390,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,4732,'0',5068,390,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,4733,'0',5069,390,5,NULL,'94f3344570604e47a6bfc52b0e271b59'),(NULL,0,'2019-11-29 22:13:29',NULL,4734,'0',5070,390,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:29',NULL,4735,'0',5072,391,16,NULL,'cmdb1-3-4-11'),(NULL,0,'2019-11-29 22:13:29',NULL,4736,'0',5073,391,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,4737,'0',5074,391,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:29',NULL,4738,'0',5075,391,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,4739,'0',5076,391,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,4740,'0',5077,391,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:29',NULL,4741,'0',5078,391,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,4742,'0',5079,391,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:29',NULL,4743,'0',5080,391,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,4744,'0',5081,391,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,4745,'0',5082,391,15,NULL,'10.3.4.11'),(NULL,0,'2019-11-29 22:13:29',NULL,4746,'0',5083,391,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,4747,'0',5084,391,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,4748,'0',5085,391,5,NULL,'9489d645245c4f8f9c555c1977e3e38a'),(NULL,0,'2019-11-29 22:13:29',NULL,4749,'0',5086,391,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:29',NULL,4750,'0',5088,392,16,NULL,'cmdb1-3-4-12'),(NULL,0,'2019-11-29 22:13:29',NULL,4751,'0',5089,392,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,4752,'0',5090,392,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:29',NULL,4753,'0',5091,392,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,4754,'0',5092,392,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,4755,'0',5093,392,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:29',NULL,4756,'0',5094,392,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,4757,'0',5095,392,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:29',NULL,4758,'0',5096,392,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,4759,'0',5097,392,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,4760,'0',5098,392,15,NULL,'10.3.4.12'),(NULL,0,'2019-11-29 22:13:29',NULL,4761,'0',5099,392,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,4762,'0',5100,392,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,4763,'0',5101,392,5,NULL,'048c000293b545be96d70bbffbc91057'),(NULL,0,'2019-11-29 22:13:29',NULL,4764,'0',5102,392,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:29',NULL,4765,'0',5104,393,16,NULL,'cmdb1-3-4-13'),(NULL,0,'2019-11-29 22:13:29',NULL,4766,'0',5105,393,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,4767,'0',5106,393,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:29',NULL,4768,'0',5107,393,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,4769,'0',5108,393,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,4770,'0',5109,393,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:29',NULL,4771,'0',5110,393,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,4772,'0',5111,393,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:29',NULL,4773,'0',5112,393,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,4774,'0',5113,393,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,4775,'0',5114,393,15,NULL,'10.3.4.13'),(NULL,0,'2019-11-29 22:13:30',NULL,4776,'0',5115,393,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,4777,'0',5116,393,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,4778,'0',5117,393,5,NULL,'9ea6549b62b246e39ae48fa216b342bc'),(NULL,0,'2019-11-29 22:13:30',NULL,4779,'0',5118,393,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:30',NULL,4780,'0',5120,394,16,NULL,'cmdb1-3-4-14'),(NULL,0,'2019-11-29 22:13:30',NULL,4781,'0',5121,394,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,4782,'0',5122,394,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:30',NULL,4783,'0',5123,394,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,4784,'0',5124,394,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,4785,'0',5125,394,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:30',NULL,4786,'0',5126,394,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,4787,'0',5127,394,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:30',NULL,4788,'0',5128,394,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,4789,'0',5129,394,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,4790,'0',5130,394,15,NULL,'10.3.4.14'),(NULL,0,'2019-11-29 22:13:30',NULL,4791,'0',5131,394,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,4792,'0',5132,394,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,4793,'0',5133,394,5,NULL,'83c0cd6f56b44a658ec65fc306afc46c'),(NULL,0,'2019-11-29 22:13:30',NULL,4794,'0',5134,394,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:30',NULL,4795,'0',5136,395,16,NULL,'cmdb1-3-4-15'),(NULL,0,'2019-11-29 22:13:30',NULL,4796,'0',5137,395,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,4797,'0',5138,395,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:30',NULL,4798,'0',5139,395,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,4799,'0',5140,395,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,4800,'0',5141,395,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:30',NULL,4801,'0',5142,395,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,4802,'0',5143,395,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:30',NULL,4803,'0',5144,395,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,4804,'0',5145,395,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,4805,'0',5146,395,15,NULL,'10.3.4.15'),(NULL,0,'2019-11-29 22:13:30',NULL,4806,'0',5147,395,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,4807,'0',5148,395,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,4808,'0',5149,395,5,NULL,'86cbd068d48446f9b45667b7cd261408'),(NULL,0,'2019-11-29 22:13:30',NULL,4809,'0',5150,395,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:30',NULL,4810,'0',5152,396,16,NULL,'cmdb1-3-4-16'),(NULL,0,'2019-11-29 22:13:30',NULL,4811,'0',5153,396,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,4812,'0',5154,396,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:30',NULL,4813,'0',5155,396,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,4814,'0',5156,396,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,4815,'0',5157,396,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:30',NULL,4816,'0',5158,396,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,4817,'0',5159,396,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:30',NULL,4818,'0',5160,396,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,4819,'0',5161,396,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,4820,'0',5162,396,15,NULL,'10.3.4.16'),(NULL,0,'2019-11-29 22:13:30',NULL,4821,'0',5163,396,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,4822,'0',5164,396,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,4823,'0',5165,396,5,NULL,'97fecc0f54504089b69929b65cfc41b8'),(NULL,0,'2019-11-29 22:13:30',NULL,4824,'0',5166,396,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:30',NULL,4825,'0',5168,397,4,NULL,'App1-3-5'),(NULL,0,'2019-11-29 22:13:30',NULL,4826,'0',5170,398,16,NULL,'cmdb1-3-5-1'),(NULL,0,'2019-11-29 22:13:30',NULL,4827,'0',5171,398,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,4828,'0',5172,398,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:30',NULL,4829,'0',5173,398,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,4830,'0',5174,398,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,4831,'0',5175,398,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:30',NULL,4832,'0',5176,398,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,4833,'0',5177,398,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:30',NULL,4834,'0',5178,398,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,4835,'0',5179,398,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,4836,'0',5180,398,15,NULL,'10.3.5.1'),(NULL,0,'2019-11-29 22:13:31',NULL,4837,'0',5181,398,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,4838,'0',5182,398,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,4839,'0',5183,398,5,NULL,'412b23525d5547abafbdcfc49469a78b'),(NULL,0,'2019-11-29 22:13:31',NULL,4840,'0',5184,398,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:31',NULL,4841,'0',5186,399,16,NULL,'cmdb1-3-5-2'),(NULL,0,'2019-11-29 22:13:31',NULL,4842,'0',5187,399,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,4843,'0',5188,399,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:31',NULL,4844,'0',5189,399,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,4845,'0',5190,399,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,4846,'0',5191,399,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:31',NULL,4847,'0',5192,399,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,4848,'0',5193,399,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:31',NULL,4849,'0',5194,399,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,4850,'0',5195,399,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,4851,'0',5196,399,15,NULL,'10.3.5.2'),(NULL,0,'2019-11-29 22:13:31',NULL,4852,'0',5197,399,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,4853,'0',5198,399,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,4854,'0',5199,399,5,NULL,'6f5a55b6b2e04fd0b99e25c57332303b'),(NULL,0,'2019-11-29 22:13:31',NULL,4855,'0',5200,399,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:31',NULL,4856,'0',5202,400,16,NULL,'cmdb1-3-5-3'),(NULL,0,'2019-11-29 22:13:31',NULL,4857,'0',5203,400,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,4858,'0',5204,400,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:31',NULL,4859,'0',5205,400,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,4860,'0',5206,400,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,4861,'0',5207,400,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:31',NULL,4862,'0',5208,400,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,4863,'0',5209,400,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:31',NULL,4864,'0',5210,400,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,4865,'0',5211,400,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,4866,'0',5212,400,15,NULL,'10.3.5.3'),(NULL,0,'2019-11-29 22:13:31',NULL,4867,'0',5213,400,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,4868,'0',5214,400,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,4869,'0',5215,400,5,NULL,'fb291402278842359774b4813df682e6'),(NULL,0,'2019-11-29 22:13:31',NULL,4870,'0',5216,400,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:31',NULL,4871,'0',5218,401,16,NULL,'cmdb1-3-5-4'),(NULL,0,'2019-11-29 22:13:31',NULL,4872,'0',5219,401,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,4873,'0',5220,401,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:31',NULL,4874,'0',5221,401,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,4875,'0',5222,401,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,4876,'0',5223,401,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:31',NULL,4877,'0',5224,401,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,4878,'0',5225,401,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:31',NULL,4879,'0',5226,401,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,4880,'0',5227,401,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,4881,'0',5228,401,15,NULL,'10.3.5.4'),(NULL,0,'2019-11-29 22:13:31',NULL,4882,'0',5229,401,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,4883,'0',5230,401,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,4884,'0',5231,401,5,NULL,'27538d2410a844f1b2d770afd2749b35'),(NULL,0,'2019-11-29 22:13:31',NULL,4885,'0',5232,401,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:31',NULL,4886,'0',5234,402,16,NULL,'cmdb1-3-5-5'),(NULL,0,'2019-11-29 22:13:31',NULL,4887,'0',5235,402,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,4888,'0',5236,402,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:31',NULL,4889,'0',5237,402,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,4890,'0',5238,402,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,4891,'0',5239,402,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:31',NULL,4892,'0',5240,402,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,4893,'0',5241,402,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:31',NULL,4894,'0',5242,402,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,4895,'0',5243,402,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,4896,'0',5244,402,15,NULL,'10.3.5.5'),(NULL,0,'2019-11-29 22:13:31',NULL,4897,'0',5245,402,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,4898,'0',5246,402,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,4899,'0',5247,402,5,NULL,'1d547eac7f1a4594afb5290ded225729'),(NULL,0,'2019-11-29 22:13:31',NULL,4900,'0',5248,402,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:32',NULL,4901,'0',5250,403,16,NULL,'cmdb1-3-5-6'),(NULL,0,'2019-11-29 22:13:32',NULL,4902,'0',5251,403,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,4903,'0',5252,403,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:32',NULL,4904,'0',5253,403,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,4905,'0',5254,403,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,4906,'0',5255,403,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:32',NULL,4907,'0',5256,403,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,4908,'0',5257,403,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:32',NULL,4909,'0',5258,403,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,4910,'0',5259,403,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,4911,'0',5260,403,15,NULL,'10.3.5.6'),(NULL,0,'2019-11-29 22:13:32',NULL,4912,'0',5261,403,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,4913,'0',5262,403,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,4914,'0',5263,403,5,NULL,'0db127de0cfb4f75b5010c7a3fa89128'),(NULL,0,'2019-11-29 22:13:32',NULL,4915,'0',5264,403,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:32',NULL,4916,'0',5266,404,16,NULL,'cmdb1-3-5-7'),(NULL,0,'2019-11-29 22:13:32',NULL,4917,'0',5267,404,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,4918,'0',5268,404,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:32',NULL,4919,'0',5269,404,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,4920,'0',5270,404,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,4921,'0',5271,404,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:32',NULL,4922,'0',5272,404,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,4923,'0',5273,404,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:32',NULL,4924,'0',5274,404,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,4925,'0',5275,404,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,4926,'0',5276,404,15,NULL,'10.3.5.7'),(NULL,0,'2019-11-29 22:13:32',NULL,4927,'0',5277,404,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,4928,'0',5278,404,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,4929,'0',5279,404,5,NULL,'dfbc3c70affd4802a19e491a2e97b3a6'),(NULL,0,'2019-11-29 22:13:32',NULL,4930,'0',5280,404,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:32',NULL,4931,'0',5282,405,16,NULL,'cmdb1-3-5-8'),(NULL,0,'2019-11-29 22:13:32',NULL,4932,'0',5283,405,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,4933,'0',5284,405,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:32',NULL,4934,'0',5285,405,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,4935,'0',5286,405,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,4936,'0',5287,405,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:32',NULL,4937,'0',5288,405,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,4938,'0',5289,405,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:32',NULL,4939,'0',5290,405,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,4940,'0',5291,405,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,4941,'0',5292,405,15,NULL,'10.3.5.8'),(NULL,0,'2019-11-29 22:13:32',NULL,4942,'0',5293,405,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,4943,'0',5294,405,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,4944,'0',5295,405,5,NULL,'36046716487c4ab98231a8f73885691e'),(NULL,0,'2019-11-29 22:13:32',NULL,4945,'0',5296,405,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:32',NULL,4946,'0',5298,406,16,NULL,'cmdb1-3-5-9'),(NULL,0,'2019-11-29 22:13:32',NULL,4947,'0',5299,406,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,4948,'0',5300,406,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:32',NULL,4949,'0',5301,406,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,4950,'0',5302,406,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,4951,'0',5303,406,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:32',NULL,4952,'0',5304,406,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,4953,'0',5305,406,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:32',NULL,4954,'0',5306,406,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,4955,'0',5307,406,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,4956,'0',5308,406,15,NULL,'10.3.5.9'),(NULL,0,'2019-11-29 22:13:32',NULL,4957,'0',5309,406,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,4958,'0',5310,406,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,4959,'0',5311,406,5,NULL,'20b79be57dac45eb927c48362c116758'),(NULL,0,'2019-11-29 22:13:32',NULL,4960,'0',5312,406,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:32',NULL,4961,'0',5314,407,16,NULL,'cmdb1-3-5-10'),(NULL,0,'2019-11-29 22:13:32',NULL,4962,'0',5315,407,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,4963,'0',5316,407,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:33',NULL,4964,'0',5317,407,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,4965,'0',5318,407,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,4966,'0',5319,407,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:33',NULL,4967,'0',5320,407,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,4968,'0',5321,407,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:33',NULL,4969,'0',5322,407,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,4970,'0',5323,407,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,4971,'0',5324,407,15,NULL,'10.3.5.10'),(NULL,0,'2019-11-29 22:13:33',NULL,4972,'0',5325,407,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,4973,'0',5326,407,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,4974,'0',5327,407,5,NULL,'8691c0a0127742b5a212fba11ac70e7d'),(NULL,0,'2019-11-29 22:13:33',NULL,4975,'0',5328,407,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:33',NULL,4976,'0',5330,408,16,NULL,'cmdb1-3-5-11'),(NULL,0,'2019-11-29 22:13:33',NULL,4977,'0',5331,408,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,4978,'0',5332,408,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:33',NULL,4979,'0',5333,408,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,4980,'0',5334,408,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,4981,'0',5335,408,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:33',NULL,4982,'0',5336,408,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,4983,'0',5337,408,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:33',NULL,4984,'0',5338,408,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,4985,'0',5339,408,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,4986,'0',5340,408,15,NULL,'10.3.5.11'),(NULL,0,'2019-11-29 22:13:33',NULL,4987,'0',5341,408,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,4988,'0',5342,408,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,4989,'0',5343,408,5,NULL,'28865fead11648fc81f0acd2bfaa4942'),(NULL,0,'2019-11-29 22:13:33',NULL,4990,'0',5344,408,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:33',NULL,4991,'0',5346,409,16,NULL,'cmdb1-3-5-12'),(NULL,0,'2019-11-29 22:13:33',NULL,4992,'0',5347,409,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,4993,'0',5348,409,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:33',NULL,4994,'0',5349,409,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,4995,'0',5350,409,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,4996,'0',5351,409,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:33',NULL,4997,'0',5352,409,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,4998,'0',5353,409,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:33',NULL,4999,'0',5354,409,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,5000,'0',5355,409,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,5001,'0',5356,409,15,NULL,'10.3.5.12'),(NULL,0,'2019-11-29 22:13:33',NULL,5002,'0',5357,409,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,5003,'0',5358,409,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,5004,'0',5359,409,5,NULL,'bb2e990965b94908b6d095c68f17e692'),(NULL,0,'2019-11-29 22:13:33',NULL,5005,'0',5360,409,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:33',NULL,5006,'0',5362,410,16,NULL,'cmdb1-3-5-13'),(NULL,0,'2019-11-29 22:13:33',NULL,5007,'0',5363,410,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,5008,'0',5364,410,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:33',NULL,5009,'0',5365,410,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,5010,'0',5366,410,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,5011,'0',5367,410,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:33',NULL,5012,'0',5368,410,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,5013,'0',5369,410,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:33',NULL,5014,'0',5370,410,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,5015,'0',5371,410,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,5016,'0',5372,410,15,NULL,'10.3.5.13'),(NULL,0,'2019-11-29 22:13:33',NULL,5017,'0',5373,410,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,5018,'0',5374,410,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,5019,'0',5375,410,5,NULL,'96f2ffe945ce4fb1adfb343f21706923'),(NULL,0,'2019-11-29 22:13:33',NULL,5020,'0',5376,410,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:33',NULL,5021,'0',5378,411,16,NULL,'cmdb1-3-5-14'),(NULL,0,'2019-11-29 22:13:33',NULL,5022,'0',5379,411,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,5023,'0',5380,411,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:33',NULL,5024,'0',5381,411,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,5025,'0',5382,411,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,5026,'0',5383,411,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:33',NULL,5027,'0',5384,411,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,5028,'0',5385,411,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:33',NULL,5029,'0',5386,411,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,5030,'0',5387,411,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,5031,'0',5388,411,15,NULL,'10.3.5.14'),(NULL,0,'2019-11-29 22:13:34',NULL,5032,'0',5389,411,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,5033,'0',5390,411,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,5034,'0',5391,411,5,NULL,'b255a192c6074b55bd6e217e0762b761'),(NULL,0,'2019-11-29 22:13:34',NULL,5035,'0',5392,411,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:34',NULL,5036,'0',5394,412,16,NULL,'cmdb1-3-5-15'),(NULL,0,'2019-11-29 22:13:34',NULL,5037,'0',5395,412,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,5038,'0',5396,412,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:34',NULL,5039,'0',5397,412,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,5040,'0',5398,412,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,5041,'0',5399,412,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:34',NULL,5042,'0',5400,412,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,5043,'0',5401,412,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:34',NULL,5044,'0',5402,412,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,5045,'0',5403,412,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,5046,'0',5404,412,15,NULL,'10.3.5.15'),(NULL,0,'2019-11-29 22:13:34',NULL,5047,'0',5405,412,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,5048,'0',5406,412,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,5049,'0',5407,412,5,NULL,'0cc0edaa4e5e4f7cac7dc1c7925f5f6f'),(NULL,0,'2019-11-29 22:13:34',NULL,5050,'0',5408,412,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:34',NULL,5051,'0',5410,413,16,NULL,'cmdb1-3-5-16'),(NULL,0,'2019-11-29 22:13:34',NULL,5052,'0',5411,413,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,5053,'0',5412,413,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:34',NULL,5054,'0',5413,413,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,5055,'0',5414,413,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,5056,'0',5415,413,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:34',NULL,5057,'0',5416,413,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,5058,'0',5417,413,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:34',NULL,5059,'0',5418,413,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,5060,'0',5419,413,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,5061,'0',5420,413,15,NULL,'10.3.5.16'),(NULL,0,'2019-11-29 22:13:34',NULL,5062,'0',5421,413,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,5063,'0',5422,413,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,5064,'0',5423,413,5,NULL,'7381cce7748c4c37982ef9b1eb22432b'),(NULL,0,'2019-11-29 22:13:34',NULL,5065,'0',5424,413,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:34',NULL,5066,'0',5426,414,4,NULL,'App1-3-6'),(NULL,0,'2019-11-29 22:13:34',NULL,5067,'0',5428,415,16,NULL,'cmdb1-3-6-1'),(NULL,0,'2019-11-29 22:13:34',NULL,5068,'0',5429,415,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,5069,'0',5430,415,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:34',NULL,5070,'0',5431,415,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,5071,'0',5432,415,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,5072,'0',5433,415,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:34',NULL,5073,'0',5434,415,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,5074,'0',5435,415,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:34',NULL,5075,'0',5436,415,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,5076,'0',5437,415,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,5077,'0',5438,415,15,NULL,'10.3.6.1'),(NULL,0,'2019-11-29 22:13:34',NULL,5078,'0',5439,415,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,5079,'0',5440,415,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,5080,'0',5441,415,5,NULL,'a313edb64c724ff0ae7d65db72080ba7'),(NULL,0,'2019-11-29 22:13:34',NULL,5081,'0',5442,415,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:34',NULL,5082,'0',5444,416,16,NULL,'cmdb1-3-6-2'),(NULL,0,'2019-11-29 22:13:34',NULL,5083,'0',5445,416,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,5084,'0',5446,416,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:34',NULL,5085,'0',5447,416,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,5086,'0',5448,416,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,5087,'0',5449,416,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:34',NULL,5088,'0',5450,416,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,5089,'0',5451,416,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:35',NULL,5090,'0',5452,416,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,5091,'0',5453,416,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,5092,'0',5454,416,15,NULL,'10.3.6.2'),(NULL,0,'2019-11-29 22:13:35',NULL,5093,'0',5455,416,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,5094,'0',5456,416,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,5095,'0',5457,416,5,NULL,'d9d94f95e2c64eb3a5553fa7f30e813b'),(NULL,0,'2019-11-29 22:13:35',NULL,5096,'0',5458,416,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:35',NULL,5097,'0',5460,417,16,NULL,'cmdb1-3-6-3'),(NULL,0,'2019-11-29 22:13:35',NULL,5098,'0',5461,417,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,5099,'0',5462,417,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:35',NULL,5100,'0',5463,417,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,5101,'0',5464,417,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,5102,'0',5465,417,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:35',NULL,5103,'0',5466,417,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,5104,'0',5467,417,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:35',NULL,5105,'0',5468,417,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,5106,'0',5469,417,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,5107,'0',5470,417,15,NULL,'10.3.6.3'),(NULL,0,'2019-11-29 22:13:35',NULL,5108,'0',5471,417,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,5109,'0',5472,417,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,5110,'0',5473,417,5,NULL,'d9dd331139124a5180de7349e162a49a'),(NULL,0,'2019-11-29 22:13:35',NULL,5111,'0',5474,417,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:35',NULL,5112,'0',5476,418,16,NULL,'cmdb1-3-6-4'),(NULL,0,'2019-11-29 22:13:35',NULL,5113,'0',5477,418,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,5114,'0',5478,418,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:35',NULL,5115,'0',5479,418,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,5116,'0',5480,418,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,5117,'0',5481,418,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:35',NULL,5118,'0',5482,418,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,5119,'0',5483,418,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:35',NULL,5120,'0',5484,418,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,5121,'0',5485,418,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,5122,'0',5486,418,15,NULL,'10.3.6.4'),(NULL,0,'2019-11-29 22:13:35',NULL,5123,'0',5487,418,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,5124,'0',5488,418,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,5125,'0',5489,418,5,NULL,'a77a4b9c18264267b786c46794a370d2'),(NULL,0,'2019-11-29 22:13:35',NULL,5126,'0',5490,418,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:35',NULL,5127,'0',5492,419,16,NULL,'cmdb1-3-6-5'),(NULL,0,'2019-11-29 22:13:35',NULL,5128,'0',5493,419,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,5129,'0',5494,419,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:35',NULL,5130,'0',5495,419,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,5131,'0',5496,419,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,5132,'0',5497,419,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:35',NULL,5133,'0',5498,419,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,5134,'0',5499,419,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:35',NULL,5135,'0',5500,419,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,5136,'0',5501,419,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,5137,'0',5502,419,15,NULL,'10.3.6.5'),(NULL,0,'2019-11-29 22:13:35',NULL,5138,'0',5503,419,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,5139,'0',5504,419,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,5140,'0',5505,419,5,NULL,'8fe44d6eb808449f985ecfe5dfa70394'),(NULL,0,'2019-11-29 22:13:35',NULL,5141,'0',5506,419,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:35',NULL,5142,'0',5508,420,16,NULL,'cmdb1-3-6-6'),(NULL,0,'2019-11-29 22:13:35',NULL,5143,'0',5509,420,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,5144,'0',5510,420,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:35',NULL,5145,'0',5511,420,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,5146,'0',5512,420,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,5147,'0',5513,420,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:35',NULL,5148,'0',5514,420,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,5149,'0',5515,420,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:35',NULL,5150,'0',5516,420,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,5151,'0',5517,420,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,5152,'0',5518,420,15,NULL,'10.3.6.6'),(NULL,0,'2019-11-29 22:13:35',NULL,5153,'0',5519,420,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,5154,'0',5520,420,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,5155,'0',5521,420,5,NULL,'53279c4c01e048e691b3d3258ffc8297'),(NULL,0,'2019-11-29 22:13:35',NULL,5156,'0',5522,420,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:36',NULL,5157,'0',5524,421,16,NULL,'cmdb1-3-6-7'),(NULL,0,'2019-11-29 22:13:36',NULL,5158,'0',5525,421,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,5159,'0',5526,421,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:36',NULL,5160,'0',5527,421,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,5161,'0',5528,421,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,5162,'0',5529,421,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:36',NULL,5163,'0',5530,421,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,5164,'0',5531,421,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:36',NULL,5165,'0',5532,421,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,5166,'0',5533,421,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,5167,'0',5534,421,15,NULL,'10.3.6.7'),(NULL,0,'2019-11-29 22:13:36',NULL,5168,'0',5535,421,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,5169,'0',5536,421,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,5170,'0',5537,421,5,NULL,'5d1e5d99a6fd4c14acb6f9a797b0e43f'),(NULL,0,'2019-11-29 22:13:36',NULL,5171,'0',5538,421,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:36',NULL,5172,'0',5540,422,16,NULL,'cmdb1-3-6-8'),(NULL,0,'2019-11-29 22:13:36',NULL,5173,'0',5541,422,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,5174,'0',5542,422,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:36',NULL,5175,'0',5543,422,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,5176,'0',5544,422,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,5177,'0',5545,422,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:36',NULL,5178,'0',5546,422,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,5179,'0',5547,422,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:36',NULL,5180,'0',5548,422,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,5181,'0',5549,422,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,5182,'0',5550,422,15,NULL,'10.3.6.8'),(NULL,0,'2019-11-29 22:13:36',NULL,5183,'0',5551,422,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,5184,'0',5552,422,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,5185,'0',5553,422,5,NULL,'8af81ddae88040518dd13ebd52e0c62a'),(NULL,0,'2019-11-29 22:13:36',NULL,5186,'0',5554,422,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:36',NULL,5187,'0',5556,423,16,NULL,'cmdb1-3-6-9'),(NULL,0,'2019-11-29 22:13:36',NULL,5188,'0',5557,423,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,5189,'0',5558,423,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:36',NULL,5190,'0',5559,423,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,5191,'0',5560,423,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,5192,'0',5561,423,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:36',NULL,5193,'0',5562,423,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,5194,'0',5563,423,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:36',NULL,5195,'0',5564,423,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,5196,'0',5565,423,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,5197,'0',5566,423,15,NULL,'10.3.6.9'),(NULL,0,'2019-11-29 22:13:36',NULL,5198,'0',5567,423,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,5199,'0',5568,423,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,5200,'0',5569,423,5,NULL,'141454a4568449e0b140b0ae3d5eace5'),(NULL,0,'2019-11-29 22:13:36',NULL,5201,'0',5570,423,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:36',NULL,5202,'0',5572,424,16,NULL,'cmdb1-3-6-10'),(NULL,0,'2019-11-29 22:13:36',NULL,5203,'0',5573,424,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,5204,'0',5574,424,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:36',NULL,5205,'0',5575,424,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,5206,'0',5576,424,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,5207,'0',5577,424,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:36',NULL,5208,'0',5578,424,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,5209,'0',5579,424,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:36',NULL,5210,'0',5580,424,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,5211,'0',5581,424,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,5212,'0',5582,424,15,NULL,'10.3.6.10'),(NULL,0,'2019-11-29 22:13:36',NULL,5213,'0',5583,424,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,5214,'0',5584,424,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,5215,'0',5585,424,5,NULL,'a188720819d04a4b827537834662d5e4'),(NULL,0,'2019-11-29 22:13:36',NULL,5216,'0',5586,424,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:36',NULL,5217,'0',5588,425,16,NULL,'cmdb1-3-6-11'),(NULL,0,'2019-11-29 22:13:36',NULL,5218,'0',5589,425,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,5219,'0',5590,425,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:37',NULL,5220,'0',5591,425,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,5221,'0',5592,425,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,5222,'0',5593,425,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:37',NULL,5223,'0',5594,425,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,5224,'0',5595,425,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:37',NULL,5225,'0',5596,425,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,5226,'0',5597,425,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,5227,'0',5598,425,15,NULL,'10.3.6.11'),(NULL,0,'2019-11-29 22:13:37',NULL,5228,'0',5599,425,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,5229,'0',5600,425,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,5230,'0',5601,425,5,NULL,'4e1bf31d5b304d0dbcc709fd564899a7'),(NULL,0,'2019-11-29 22:13:37',NULL,5231,'0',5602,425,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:37',NULL,5232,'0',5604,426,16,NULL,'cmdb1-3-6-12'),(NULL,0,'2019-11-29 22:13:37',NULL,5233,'0',5605,426,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,5234,'0',5606,426,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:37',NULL,5235,'0',5607,426,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,5236,'0',5608,426,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,5237,'0',5609,426,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:37',NULL,5238,'0',5610,426,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,5239,'0',5611,426,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:37',NULL,5240,'0',5612,426,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,5241,'0',5613,426,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,5242,'0',5614,426,15,NULL,'10.3.6.12'),(NULL,0,'2019-11-29 22:13:37',NULL,5243,'0',5615,426,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,5244,'0',5616,426,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,5245,'0',5617,426,5,NULL,'9ff9d5ec1b564dcbbd8409b57487a5a7'),(NULL,0,'2019-11-29 22:13:37',NULL,5246,'0',5618,426,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:37',NULL,5247,'0',5620,427,16,NULL,'cmdb1-3-6-13'),(NULL,0,'2019-11-29 22:13:37',NULL,5248,'0',5621,427,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,5249,'0',5622,427,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:37',NULL,5250,'0',5623,427,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,5251,'0',5624,427,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,5252,'0',5625,427,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:37',NULL,5253,'0',5626,427,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,5254,'0',5627,427,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:37',NULL,5255,'0',5628,427,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,5256,'0',5629,427,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,5257,'0',5630,427,15,NULL,'10.3.6.13'),(NULL,0,'2019-11-29 22:13:37',NULL,5258,'0',5631,427,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,5259,'0',5632,427,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,5260,'0',5633,427,5,NULL,'fdeabc125d494ecfbc0ae71b95caf396'),(NULL,0,'2019-11-29 22:13:37',NULL,5261,'0',5634,427,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:37',NULL,5262,'0',5636,428,16,NULL,'cmdb1-3-6-14'),(NULL,0,'2019-11-29 22:13:37',NULL,5263,'0',5637,428,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,5264,'0',5638,428,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:37',NULL,5265,'0',5639,428,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,5266,'0',5640,428,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,5267,'0',5641,428,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:37',NULL,5268,'0',5642,428,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,5269,'0',5643,428,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:37',NULL,5270,'0',5644,428,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,5271,'0',5645,428,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,5272,'0',5646,428,15,NULL,'10.3.6.14'),(NULL,0,'2019-11-29 22:13:37',NULL,5273,'0',5647,428,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,5274,'0',5648,428,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,5275,'0',5649,428,5,NULL,'a4169a0aeff549c985a9f45765bc512f'),(NULL,0,'2019-11-29 22:13:37',NULL,5276,'0',5650,428,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:37',NULL,5277,'0',5652,429,16,NULL,'cmdb1-3-6-15'),(NULL,0,'2019-11-29 22:13:37',NULL,5278,'0',5653,429,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,5279,'0',5654,429,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:37',NULL,5280,'0',5655,429,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,5281,'0',5656,429,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,5282,'0',5657,429,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:37',NULL,5283,'0',5658,429,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,5284,'0',5659,429,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:37',NULL,5285,'0',5660,429,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,5286,'0',5661,429,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,5287,'0',5662,429,15,NULL,'10.3.6.15'),(NULL,0,'2019-11-29 22:13:38',NULL,5288,'0',5663,429,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,5289,'0',5664,429,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,5290,'0',5665,429,5,NULL,'7b5e34cdc6b44b11b2c29457758dc709'),(NULL,0,'2019-11-29 22:13:38',NULL,5291,'0',5666,429,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:38',NULL,5292,'0',5668,430,16,NULL,'cmdb1-3-6-16'),(NULL,0,'2019-11-29 22:13:38',NULL,5293,'0',5669,430,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,5294,'0',5670,430,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:38',NULL,5295,'0',5671,430,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,5296,'0',5672,430,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,5297,'0',5673,430,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:38',NULL,5298,'0',5674,430,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,5299,'0',5675,430,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:38',NULL,5300,'0',5676,430,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,5301,'0',5677,430,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,5302,'0',5678,430,15,NULL,'10.3.6.16'),(NULL,0,'2019-11-29 22:13:38',NULL,5303,'0',5679,430,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,5304,'0',5680,430,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,5305,'0',5681,430,5,NULL,'3d8bd8c6e28c4daeb3d8b808cbbdd874'),(NULL,0,'2019-11-29 22:13:38',NULL,5306,'0',5682,430,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:38',NULL,5307,'0',5684,431,4,NULL,'App1-3-7'),(NULL,0,'2019-11-29 22:13:38',NULL,5308,'0',5686,432,16,NULL,'cmdb1-3-7-1'),(NULL,0,'2019-11-29 22:13:38',NULL,5309,'0',5687,432,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,5310,'0',5688,432,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:38',NULL,5311,'0',5689,432,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,5312,'0',5690,432,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,5313,'0',5691,432,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:38',NULL,5314,'0',5692,432,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,5315,'0',5693,432,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:38',NULL,5316,'0',5694,432,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,5317,'0',5695,432,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,5318,'0',5696,432,15,NULL,'10.3.7.1'),(NULL,0,'2019-11-29 22:13:38',NULL,5319,'0',5697,432,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,5320,'0',5698,432,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,5321,'0',5699,432,5,NULL,'c65cc0936b4e44babbf6b0d0c40cf6d1'),(NULL,0,'2019-11-29 22:13:38',NULL,5322,'0',5700,432,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:38',NULL,5323,'0',5702,433,16,NULL,'cmdb1-3-7-2'),(NULL,0,'2019-11-29 22:13:38',NULL,5324,'0',5703,433,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,5325,'0',5704,433,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:38',NULL,5326,'0',5705,433,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,5327,'0',5706,433,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,5328,'0',5707,433,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:38',NULL,5329,'0',5708,433,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,5330,'0',5709,433,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:38',NULL,5331,'0',5710,433,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,5332,'0',5711,433,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,5333,'0',5712,433,15,NULL,'10.3.7.2'),(NULL,0,'2019-11-29 22:13:38',NULL,5334,'0',5713,433,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,5335,'0',5714,433,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,5336,'0',5715,433,5,NULL,'37d73c01969f49a4b39922426283046d'),(NULL,0,'2019-11-29 22:13:38',NULL,5337,'0',5716,433,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:38',NULL,5338,'0',5718,434,16,NULL,'cmdb1-3-7-3'),(NULL,0,'2019-11-29 22:13:38',NULL,5339,'0',5719,434,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,5340,'0',5720,434,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:38',NULL,5341,'0',5721,434,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,5342,'0',5722,434,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,5343,'0',5723,434,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:38',NULL,5344,'0',5724,434,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,5345,'0',5725,434,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:38',NULL,5346,'0',5726,434,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,5347,'0',5727,434,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,5348,'0',5728,434,15,NULL,'10.3.7.3'),(NULL,0,'2019-11-29 22:13:39',NULL,5349,'0',5729,434,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,5350,'0',5730,434,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,5351,'0',5731,434,5,NULL,'1d6b93eb8bb64b3cbf1edd4106b112ea'),(NULL,0,'2019-11-29 22:13:39',NULL,5352,'0',5732,434,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:39',NULL,5353,'0',5734,435,16,NULL,'cmdb1-3-7-4'),(NULL,0,'2019-11-29 22:13:39',NULL,5354,'0',5735,435,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,5355,'0',5736,435,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:39',NULL,5356,'0',5737,435,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,5357,'0',5738,435,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,5358,'0',5739,435,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:39',NULL,5359,'0',5740,435,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,5360,'0',5741,435,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:39',NULL,5361,'0',5742,435,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,5362,'0',5743,435,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,5363,'0',5744,435,15,NULL,'10.3.7.4'),(NULL,0,'2019-11-29 22:13:39',NULL,5364,'0',5745,435,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,5365,'0',5746,435,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,5366,'0',5747,435,5,NULL,'38488b97611341ebafa6341a064e6d60'),(NULL,0,'2019-11-29 22:13:39',NULL,5367,'0',5748,435,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:39',NULL,5368,'0',5750,436,16,NULL,'cmdb1-3-7-5'),(NULL,0,'2019-11-29 22:13:39',NULL,5369,'0',5751,436,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,5370,'0',5752,436,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:39',NULL,5371,'0',5753,436,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,5372,'0',5754,436,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,5373,'0',5755,436,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:39',NULL,5374,'0',5756,436,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,5375,'0',5757,436,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:39',NULL,5376,'0',5758,436,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,5377,'0',5759,436,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,5378,'0',5760,436,15,NULL,'10.3.7.5'),(NULL,0,'2019-11-29 22:13:39',NULL,5379,'0',5761,436,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,5380,'0',5762,436,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,5381,'0',5763,436,5,NULL,'abaeb04123994a10b2e9588ff990c43f'),(NULL,0,'2019-11-29 22:13:39',NULL,5382,'0',5764,436,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:39',NULL,5383,'0',5766,437,16,NULL,'cmdb1-3-7-6'),(NULL,0,'2019-11-29 22:13:39',NULL,5384,'0',5767,437,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,5385,'0',5768,437,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:39',NULL,5386,'0',5769,437,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,5387,'0',5770,437,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,5388,'0',5771,437,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:39',NULL,5389,'0',5772,437,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,5390,'0',5773,437,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:39',NULL,5391,'0',5774,437,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,5392,'0',5775,437,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,5393,'0',5776,437,15,NULL,'10.3.7.6'),(NULL,0,'2019-11-29 22:13:39',NULL,5394,'0',5777,437,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,5395,'0',5778,437,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,5396,'0',5779,437,5,NULL,'e6a96167ad1040bd98ac50a053839692'),(NULL,0,'2019-11-29 22:13:39',NULL,5397,'0',5780,437,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:39',NULL,5398,'0',5782,438,16,NULL,'cmdb1-3-7-7'),(NULL,0,'2019-11-29 22:13:39',NULL,5399,'0',5783,438,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,5400,'0',5784,438,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:39',NULL,5401,'0',5785,438,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,5402,'0',5786,438,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,5403,'0',5787,438,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:39',NULL,5404,'0',5788,438,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,5405,'0',5789,438,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:39',NULL,5406,'0',5790,438,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,5407,'0',5791,438,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,5408,'0',5792,438,15,NULL,'10.3.7.7'),(NULL,0,'2019-11-29 22:13:39',NULL,5409,'0',5793,438,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,5410,'0',5794,438,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,5411,'0',5795,438,5,NULL,'d6eed198a1934dcbb6beee0092148ca1'),(NULL,0,'2019-11-29 22:13:39',NULL,5412,'0',5796,438,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:40',NULL,5413,'0',5798,439,16,NULL,'cmdb1-3-7-8'),(NULL,0,'2019-11-29 22:13:40',NULL,5414,'0',5799,439,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,5415,'0',5800,439,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:40',NULL,5416,'0',5801,439,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,5417,'0',5802,439,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,5418,'0',5803,439,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:40',NULL,5419,'0',5804,439,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,5420,'0',5805,439,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:40',NULL,5421,'0',5806,439,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,5422,'0',5807,439,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,5423,'0',5808,439,15,NULL,'10.3.7.8'),(NULL,0,'2019-11-29 22:13:40',NULL,5424,'0',5809,439,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,5425,'0',5810,439,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,5426,'0',5811,439,5,NULL,'395899d43f144ab39af654fa88d9b2aa'),(NULL,0,'2019-11-29 22:13:40',NULL,5427,'0',5812,439,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:40',NULL,5428,'0',5814,440,16,NULL,'cmdb1-3-7-9'),(NULL,0,'2019-11-29 22:13:40',NULL,5429,'0',5815,440,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,5430,'0',5816,440,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:40',NULL,5431,'0',5817,440,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,5432,'0',5818,440,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,5433,'0',5819,440,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:40',NULL,5434,'0',5820,440,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,5435,'0',5821,440,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:40',NULL,5436,'0',5822,440,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,5437,'0',5823,440,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,5438,'0',5824,440,15,NULL,'10.3.7.9'),(NULL,0,'2019-11-29 22:13:40',NULL,5439,'0',5825,440,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,5440,'0',5826,440,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,5441,'0',5827,440,5,NULL,'5a94392267b44f05985fbe92fc355167'),(NULL,0,'2019-11-29 22:13:40',NULL,5442,'0',5828,440,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:40',NULL,5443,'0',5830,441,16,NULL,'cmdb1-3-7-10'),(NULL,0,'2019-11-29 22:13:40',NULL,5444,'0',5831,441,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,5445,'0',5832,441,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:40',NULL,5446,'0',5833,441,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,5447,'0',5834,441,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,5448,'0',5835,441,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:40',NULL,5449,'0',5836,441,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,5450,'0',5837,441,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:40',NULL,5451,'0',5838,441,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,5452,'0',5839,441,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,5453,'0',5840,441,15,NULL,'10.3.7.10'),(NULL,0,'2019-11-29 22:13:40',NULL,5454,'0',5841,441,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,5455,'0',5842,441,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,5456,'0',5843,441,5,NULL,'aa83098c42394c19b3b001efc18a86ea'),(NULL,0,'2019-11-29 22:13:40',NULL,5457,'0',5844,441,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:40',NULL,5458,'0',5846,442,16,NULL,'cmdb1-3-7-11'),(NULL,0,'2019-11-29 22:13:40',NULL,5459,'0',5847,442,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,5460,'0',5848,442,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:40',NULL,5461,'0',5849,442,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,5462,'0',5850,442,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,5463,'0',5851,442,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:40',NULL,5464,'0',5852,442,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,5465,'0',5853,442,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:40',NULL,5466,'0',5854,442,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,5467,'0',5855,442,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,5468,'0',5856,442,15,NULL,'10.3.7.11'),(NULL,0,'2019-11-29 22:13:40',NULL,5469,'0',5857,442,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,5470,'0',5858,442,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,5471,'0',5859,442,5,NULL,'35797a8b4266483aab82442cacbe661e'),(NULL,0,'2019-11-29 22:13:40',NULL,5472,'0',5860,442,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:40',NULL,5473,'0',5862,443,16,NULL,'cmdb1-3-7-12'),(NULL,0,'2019-11-29 22:13:40',NULL,5474,'0',5863,443,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,5475,'0',5864,443,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:40',NULL,5476,'0',5865,443,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,5477,'0',5866,443,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,5478,'0',5867,443,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:41',NULL,5479,'0',5868,443,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,5480,'0',5869,443,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:41',NULL,5481,'0',5870,443,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,5482,'0',5871,443,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,5483,'0',5872,443,15,NULL,'10.3.7.12'),(NULL,0,'2019-11-29 22:13:41',NULL,5484,'0',5873,443,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,5485,'0',5874,443,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,5486,'0',5875,443,5,NULL,'7669932171544319b3a6e634f809a412'),(NULL,0,'2019-11-29 22:13:41',NULL,5487,'0',5876,443,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:41',NULL,5488,'0',5878,444,16,NULL,'cmdb1-3-7-13'),(NULL,0,'2019-11-29 22:13:41',NULL,5489,'0',5879,444,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,5490,'0',5880,444,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:41',NULL,5491,'0',5881,444,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,5492,'0',5882,444,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,5493,'0',5883,444,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:41',NULL,5494,'0',5884,444,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,5495,'0',5885,444,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:41',NULL,5496,'0',5886,444,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,5497,'0',5887,444,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,5498,'0',5888,444,15,NULL,'10.3.7.13'),(NULL,0,'2019-11-29 22:13:41',NULL,5499,'0',5889,444,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,5500,'0',5890,444,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,5501,'0',5891,444,5,NULL,'abb891f1244e4cb08db1e5222c32e18a'),(NULL,0,'2019-11-29 22:13:41',NULL,5502,'0',5892,444,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:41',NULL,5503,'0',5894,445,16,NULL,'cmdb1-3-7-14'),(NULL,0,'2019-11-29 22:13:41',NULL,5504,'0',5895,445,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,5505,'0',5896,445,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:41',NULL,5506,'0',5897,445,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,5507,'0',5898,445,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,5508,'0',5899,445,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:41',NULL,5509,'0',5900,445,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,5510,'0',5901,445,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:41',NULL,5511,'0',5902,445,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,5512,'0',5903,445,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,5513,'0',5904,445,15,NULL,'10.3.7.14'),(NULL,0,'2019-11-29 22:13:41',NULL,5514,'0',5905,445,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,5515,'0',5906,445,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,5516,'0',5907,445,5,NULL,'f3556a4cecaf4191b884ea0b2c648044'),(NULL,0,'2019-11-29 22:13:41',NULL,5517,'0',5908,445,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:41',NULL,5518,'0',5910,446,16,NULL,'cmdb1-3-7-15'),(NULL,0,'2019-11-29 22:13:41',NULL,5519,'0',5911,446,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,5520,'0',5912,446,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:41',NULL,5521,'0',5913,446,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,5522,'0',5914,446,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,5523,'0',5915,446,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:41',NULL,5524,'0',5916,446,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,5525,'0',5917,446,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:41',NULL,5526,'0',5918,446,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,5527,'0',5919,446,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,5528,'0',5920,446,15,NULL,'10.3.7.15'),(NULL,0,'2019-11-29 22:13:41',NULL,5529,'0',5921,446,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,5530,'0',5922,446,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,5531,'0',5923,446,5,NULL,'ac2e391252544016a17f7320c40a6a12'),(NULL,0,'2019-11-29 22:13:41',NULL,5532,'0',5924,446,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:41',NULL,5533,'0',5926,447,16,NULL,'cmdb1-3-7-16'),(NULL,0,'2019-11-29 22:13:41',NULL,5534,'0',5927,447,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,5535,'0',5928,447,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:41',NULL,5536,'0',5929,447,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,5537,'0',5930,447,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,5538,'0',5931,447,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:41',NULL,5539,'0',5932,447,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,5540,'0',5933,447,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:41',NULL,5541,'0',5934,447,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,5542,'0',5935,447,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,5543,'0',5936,447,15,NULL,'10.3.7.16'),(NULL,0,'2019-11-29 22:13:42',NULL,5544,'0',5937,447,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,5545,'0',5938,447,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,5546,'0',5939,447,5,NULL,'712500f8ec6f40798c6dee7f1989c02b'),(NULL,0,'2019-11-29 22:13:42',NULL,5547,'0',5940,447,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:42',NULL,5548,'0',5942,448,4,NULL,'App1-3-8'),(NULL,0,'2019-11-29 22:13:42',NULL,5549,'0',5944,449,16,NULL,'cmdb1-3-8-1'),(NULL,0,'2019-11-29 22:13:42',NULL,5550,'0',5945,449,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,5551,'0',5946,449,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:42',NULL,5552,'0',5947,449,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,5553,'0',5948,449,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,5554,'0',5949,449,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:42',NULL,5555,'0',5950,449,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,5556,'0',5951,449,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:42',NULL,5557,'0',5952,449,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,5558,'0',5953,449,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,5559,'0',5954,449,15,NULL,'10.3.8.1'),(NULL,0,'2019-11-29 22:13:42',NULL,5560,'0',5955,449,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,5561,'0',5956,449,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,5562,'0',5957,449,5,NULL,'6143b2c007484a3d869d6d3f611be73a'),(NULL,0,'2019-11-29 22:13:42',NULL,5563,'0',5958,449,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:42',NULL,5564,'0',5960,450,16,NULL,'cmdb1-3-8-2'),(NULL,0,'2019-11-29 22:13:42',NULL,5565,'0',5961,450,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,5566,'0',5962,450,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:42',NULL,5567,'0',5963,450,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,5568,'0',5964,450,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,5569,'0',5965,450,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:42',NULL,5570,'0',5966,450,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,5571,'0',5967,450,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:42',NULL,5572,'0',5968,450,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,5573,'0',5969,450,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,5574,'0',5970,450,15,NULL,'10.3.8.2'),(NULL,0,'2019-11-29 22:13:42',NULL,5575,'0',5971,450,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,5576,'0',5972,450,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,5577,'0',5973,450,5,NULL,'932a620b971144b8a91cbfd41f3ecbca'),(NULL,0,'2019-11-29 22:13:42',NULL,5578,'0',5974,450,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:42',NULL,5579,'0',5976,451,16,NULL,'cmdb1-3-8-3'),(NULL,0,'2019-11-29 22:13:42',NULL,5580,'0',5977,451,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,5581,'0',5978,451,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:42',NULL,5582,'0',5979,451,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,5583,'0',5980,451,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,5584,'0',5981,451,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:42',NULL,5585,'0',5982,451,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,5586,'0',5983,451,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:42',NULL,5587,'0',5984,451,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,5588,'0',5985,451,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,5589,'0',5986,451,15,NULL,'10.3.8.3'),(NULL,0,'2019-11-29 22:13:42',NULL,5590,'0',5987,451,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,5591,'0',5988,451,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,5592,'0',5989,451,5,NULL,'2cf343badd474bda934522618bb90833'),(NULL,0,'2019-11-29 22:13:42',NULL,5593,'0',5990,451,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:42',NULL,5594,'0',5992,452,16,NULL,'cmdb1-3-8-4'),(NULL,0,'2019-11-29 22:13:42',NULL,5595,'0',5993,452,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,5596,'0',5994,452,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:42',NULL,5597,'0',5995,452,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,5598,'0',5996,452,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,5599,'0',5997,452,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:42',NULL,5600,'0',5998,452,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,5601,'0',5999,452,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:42',NULL,5602,'0',6000,452,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,5603,'0',6001,452,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,5604,'0',6002,452,15,NULL,'10.3.8.4'),(NULL,0,'2019-11-29 22:13:42',NULL,5605,'0',6003,452,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,5606,'0',6004,452,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,5607,'0',6005,452,5,NULL,'2e11f7ff09e742bc8ba6a93ad8d57df8'),(NULL,0,'2019-11-29 22:13:43',NULL,5608,'0',6006,452,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:43',NULL,5609,'0',6008,453,16,NULL,'cmdb1-3-8-5'),(NULL,0,'2019-11-29 22:13:43',NULL,5610,'0',6009,453,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,5611,'0',6010,453,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:43',NULL,5612,'0',6011,453,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,5613,'0',6012,453,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,5614,'0',6013,453,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:43',NULL,5615,'0',6014,453,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,5616,'0',6015,453,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:43',NULL,5617,'0',6016,453,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,5618,'0',6017,453,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,5619,'0',6018,453,15,NULL,'10.3.8.5'),(NULL,0,'2019-11-29 22:13:43',NULL,5620,'0',6019,453,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,5621,'0',6020,453,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,5622,'0',6021,453,5,NULL,'4f497a1abecd4f83889b0a91d1aeda35'),(NULL,0,'2019-11-29 22:13:43',NULL,5623,'0',6022,453,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:43',NULL,5624,'0',6024,454,16,NULL,'cmdb1-3-8-6'),(NULL,0,'2019-11-29 22:13:43',NULL,5625,'0',6025,454,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,5626,'0',6026,454,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:43',NULL,5627,'0',6027,454,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,5628,'0',6028,454,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,5629,'0',6029,454,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:43',NULL,5630,'0',6030,454,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,5631,'0',6031,454,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:43',NULL,5632,'0',6032,454,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,5633,'0',6033,454,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,5634,'0',6034,454,15,NULL,'10.3.8.6'),(NULL,0,'2019-11-29 22:13:43',NULL,5635,'0',6035,454,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,5636,'0',6036,454,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,5637,'0',6037,454,5,NULL,'680bfe1abb3047b2b827fdd87c29900f'),(NULL,0,'2019-11-29 22:13:43',NULL,5638,'0',6038,454,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:43',NULL,5639,'0',6040,455,16,NULL,'cmdb1-3-8-7'),(NULL,0,'2019-11-29 22:13:43',NULL,5640,'0',6041,455,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,5641,'0',6042,455,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:43',NULL,5642,'0',6043,455,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,5643,'0',6044,455,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,5644,'0',6045,455,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:43',NULL,5645,'0',6046,455,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,5646,'0',6047,455,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:43',NULL,5647,'0',6048,455,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,5648,'0',6049,455,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,5649,'0',6050,455,15,NULL,'10.3.8.7'),(NULL,0,'2019-11-29 22:13:43',NULL,5650,'0',6051,455,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,5651,'0',6052,455,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,5652,'0',6053,455,5,NULL,'8e47bfb26fb343478846053098a14d06'),(NULL,0,'2019-11-29 22:13:43',NULL,5653,'0',6054,455,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:43',NULL,5654,'0',6056,456,16,NULL,'cmdb1-3-8-8'),(NULL,0,'2019-11-29 22:13:43',NULL,5655,'0',6057,456,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,5656,'0',6058,456,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:43',NULL,5657,'0',6059,456,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,5658,'0',6060,456,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,5659,'0',6061,456,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:43',NULL,5660,'0',6062,456,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,5661,'0',6063,456,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:43',NULL,5662,'0',6064,456,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,5663,'0',6065,456,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,5664,'0',6066,456,15,NULL,'10.3.8.8'),(NULL,0,'2019-11-29 22:13:43',NULL,5665,'0',6067,456,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,5666,'0',6068,456,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,5667,'0',6069,456,5,NULL,'4f72e58fa1234f3ab156f100c7f588bb'),(NULL,0,'2019-11-29 22:13:43',NULL,5668,'0',6070,456,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:44',NULL,5669,'0',6072,457,16,NULL,'cmdb1-3-8-9'),(NULL,0,'2019-11-29 22:13:44',NULL,5670,'0',6073,457,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,5671,'0',6074,457,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:44',NULL,5672,'0',6075,457,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,5673,'0',6076,457,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,5674,'0',6077,457,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:44',NULL,5675,'0',6078,457,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,5676,'0',6079,457,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:44',NULL,5677,'0',6080,457,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,5678,'0',6081,457,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,5679,'0',6082,457,15,NULL,'10.3.8.9'),(NULL,0,'2019-11-29 22:13:44',NULL,5680,'0',6083,457,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,5681,'0',6084,457,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,5682,'0',6085,457,5,NULL,'2903c75f6d0541278ea8476ad3c40deb'),(NULL,0,'2019-11-29 22:13:44',NULL,5683,'0',6086,457,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:44',NULL,5684,'0',6088,458,16,NULL,'cmdb1-3-8-10'),(NULL,0,'2019-11-29 22:13:44',NULL,5685,'0',6089,458,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,5686,'0',6090,458,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:44',NULL,5687,'0',6091,458,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,5688,'0',6092,458,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,5689,'0',6093,458,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:44',NULL,5690,'0',6094,458,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,5691,'0',6095,458,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:44',NULL,5692,'0',6096,458,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,5693,'0',6097,458,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,5694,'0',6098,458,15,NULL,'10.3.8.10'),(NULL,0,'2019-11-29 22:13:44',NULL,5695,'0',6099,458,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,5696,'0',6100,458,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,5697,'0',6101,458,5,NULL,'b7d549c62d9a485ba8b31313363c2240'),(NULL,0,'2019-11-29 22:13:44',NULL,5698,'0',6102,458,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:44',NULL,5699,'0',6104,459,16,NULL,'cmdb1-3-8-11'),(NULL,0,'2019-11-29 22:13:44',NULL,5700,'0',6105,459,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,5701,'0',6106,459,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:44',NULL,5702,'0',6107,459,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,5703,'0',6108,459,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,5704,'0',6109,459,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:44',NULL,5705,'0',6110,459,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,5706,'0',6111,459,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:44',NULL,5707,'0',6112,459,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,5708,'0',6113,459,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,5709,'0',6114,459,15,NULL,'10.3.8.11'),(NULL,0,'2019-11-29 22:13:44',NULL,5710,'0',6115,459,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,5711,'0',6116,459,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,5712,'0',6117,459,5,NULL,'e45df55ed327452a95bea4cb2ecd6acd'),(NULL,0,'2019-11-29 22:13:44',NULL,5713,'0',6118,459,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:44',NULL,5714,'0',6120,460,16,NULL,'cmdb1-3-8-12'),(NULL,0,'2019-11-29 22:13:44',NULL,5715,'0',6121,460,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,5716,'0',6122,460,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:44',NULL,5717,'0',6123,460,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,5718,'0',6124,460,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,5719,'0',6125,460,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:44',NULL,5720,'0',6126,460,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,5721,'0',6127,460,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:44',NULL,5722,'0',6128,460,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,5723,'0',6129,460,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,5724,'0',6130,460,15,NULL,'10.3.8.12'),(NULL,0,'2019-11-29 22:13:44',NULL,5725,'0',6131,460,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,5726,'0',6132,460,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,5727,'0',6133,460,5,NULL,'5dc6145953524868b9cfec8de0d42ddc'),(NULL,0,'2019-11-29 22:13:44',NULL,5728,'0',6134,460,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:44',NULL,5729,'0',6136,461,16,NULL,'cmdb1-3-8-13'),(NULL,0,'2019-11-29 22:13:44',NULL,5730,'0',6137,461,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,5731,'0',6138,461,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:44',NULL,5732,'0',6139,461,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,5733,'0',6140,461,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,5734,'0',6141,461,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:45',NULL,5735,'0',6142,461,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,5736,'0',6143,461,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:45',NULL,5737,'0',6144,461,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,5738,'0',6145,461,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,5739,'0',6146,461,15,NULL,'10.3.8.13'),(NULL,0,'2019-11-29 22:13:45',NULL,5740,'0',6147,461,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,5741,'0',6148,461,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,5742,'0',6149,461,5,NULL,'e5c963b9ff6b44e0a3f39f1916f272ef'),(NULL,0,'2019-11-29 22:13:45',NULL,5743,'0',6150,461,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:45',NULL,5744,'0',6152,462,16,NULL,'cmdb1-3-8-14'),(NULL,0,'2019-11-29 22:13:45',NULL,5745,'0',6153,462,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,5746,'0',6154,462,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:45',NULL,5747,'0',6155,462,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,5748,'0',6156,462,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,5749,'0',6157,462,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:45',NULL,5750,'0',6158,462,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,5751,'0',6159,462,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:45',NULL,5752,'0',6160,462,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,5753,'0',6161,462,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,5754,'0',6162,462,15,NULL,'10.3.8.14'),(NULL,0,'2019-11-29 22:13:45',NULL,5755,'0',6163,462,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,5756,'0',6164,462,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,5757,'0',6165,462,5,NULL,'2a634e578d7c43fe98371c8bb85f4889'),(NULL,0,'2019-11-29 22:13:45',NULL,5758,'0',6166,462,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:45',NULL,5759,'0',6168,463,16,NULL,'cmdb1-3-8-15'),(NULL,0,'2019-11-29 22:13:45',NULL,5760,'0',6169,463,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,5761,'0',6170,463,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:45',NULL,5762,'0',6171,463,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,5763,'0',6172,463,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,5764,'0',6173,463,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:45',NULL,5765,'0',6174,463,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,5766,'0',6175,463,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:45',NULL,5767,'0',6176,463,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,5768,'0',6177,463,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,5769,'0',6178,463,15,NULL,'10.3.8.15'),(NULL,0,'2019-11-29 22:13:45',NULL,5770,'0',6179,463,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,5771,'0',6180,463,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,5772,'0',6181,463,5,NULL,'8996c0012a0b459fac16e9e674b0af60'),(NULL,0,'2019-11-29 22:13:45',NULL,5773,'0',6182,463,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:45',NULL,5774,'0',6184,464,16,NULL,'cmdb1-3-8-16'),(NULL,0,'2019-11-29 22:13:45',NULL,5775,'0',6185,464,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,5776,'0',6186,464,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:45',NULL,5777,'0',6187,464,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,5778,'0',6188,464,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,5779,'0',6189,464,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:45',NULL,5780,'0',6190,464,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,5781,'0',6191,464,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:45',NULL,5782,'0',6192,464,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,5783,'0',6193,464,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,5784,'0',6194,464,15,NULL,'10.3.8.16'),(NULL,0,'2019-11-29 22:13:45',NULL,5785,'0',6195,464,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,5786,'0',6196,464,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,5787,'0',6197,464,5,NULL,'5cddc85686ef40f9a04c980c2fa62bcd'),(NULL,0,'2019-11-29 22:13:45',NULL,5788,'0',6198,464,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:45',NULL,5789,'0',6200,465,3,NULL,'产品线1-4'),(NULL,0,'2019-11-29 22:13:45',NULL,5790,'0',6202,466,4,NULL,'App1-4-1'),(NULL,0,'2019-11-29 22:13:45',NULL,5791,'0',6204,467,16,NULL,'cmdb1-4-1-1'),(NULL,0,'2019-11-29 22:13:46',NULL,5792,'0',6205,467,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,5793,'0',6206,467,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:46',NULL,5794,'0',6207,467,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,5795,'0',6208,467,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,5796,'0',6209,467,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:46',NULL,5797,'0',6210,467,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,5798,'0',6211,467,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:46',NULL,5799,'0',6212,467,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,5800,'0',6213,467,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,5801,'0',6214,467,15,NULL,'10.4.1.1'),(NULL,0,'2019-11-29 22:13:46',NULL,5802,'0',6215,467,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,5803,'0',6216,467,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,5804,'0',6217,467,5,NULL,'94d5490f44814c7581c861e59cd42df6'),(NULL,0,'2019-11-29 22:13:46',NULL,5805,'0',6218,467,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:46',NULL,5806,'0',6220,468,16,NULL,'cmdb1-4-1-2'),(NULL,0,'2019-11-29 22:13:46',NULL,5807,'0',6221,468,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,5808,'0',6222,468,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:46',NULL,5809,'0',6223,468,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,5810,'0',6224,468,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,5811,'0',6225,468,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:46',NULL,5812,'0',6226,468,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,5813,'0',6227,468,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:46',NULL,5814,'0',6228,468,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,5815,'0',6229,468,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,5816,'0',6230,468,15,NULL,'10.4.1.2'),(NULL,0,'2019-11-29 22:13:46',NULL,5817,'0',6231,468,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,5818,'0',6232,468,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,5819,'0',6233,468,5,NULL,'0089e0bd1c6640b8b25bf2b1f60315cf'),(NULL,0,'2019-11-29 22:13:46',NULL,5820,'0',6234,468,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:46',NULL,5821,'0',6236,469,16,NULL,'cmdb1-4-1-3'),(NULL,0,'2019-11-29 22:13:46',NULL,5822,'0',6237,469,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,5823,'0',6238,469,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:46',NULL,5824,'0',6239,469,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,5825,'0',6240,469,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,5826,'0',6241,469,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:46',NULL,5827,'0',6242,469,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,5828,'0',6243,469,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:46',NULL,5829,'0',6244,469,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,5830,'0',6245,469,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,5831,'0',6246,469,15,NULL,'10.4.1.3'),(NULL,0,'2019-11-29 22:13:46',NULL,5832,'0',6247,469,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,5833,'0',6248,469,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,5834,'0',6249,469,5,NULL,'1480cf9dbd2445d4980d67b731d08097'),(NULL,0,'2019-11-29 22:13:46',NULL,5835,'0',6250,469,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:46',NULL,5836,'0',6252,470,16,NULL,'cmdb1-4-1-4'),(NULL,0,'2019-11-29 22:13:46',NULL,5837,'0',6253,470,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,5838,'0',6254,470,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:46',NULL,5839,'0',6255,470,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,5840,'0',6256,470,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,5841,'0',6257,470,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:46',NULL,5842,'0',6258,470,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,5843,'0',6259,470,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:46',NULL,5844,'0',6260,470,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,5845,'0',6261,470,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,5846,'0',6262,470,15,NULL,'10.4.1.4'),(NULL,0,'2019-11-29 22:13:46',NULL,5847,'0',6263,470,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,5848,'0',6264,470,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,5849,'0',6265,470,5,NULL,'26c9b4332a664e4085b0616e6a4ffbc6'),(NULL,0,'2019-11-29 22:13:46',NULL,5850,'0',6266,470,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:46',NULL,5851,'0',6268,471,16,NULL,'cmdb1-4-1-5'),(NULL,0,'2019-11-29 22:13:46',NULL,5852,'0',6269,471,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,5853,'0',6270,471,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:46',NULL,5854,'0',6271,471,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,5855,'0',6272,471,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,5856,'0',6273,471,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:46',NULL,5857,'0',6274,471,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,5858,'0',6275,471,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:46',NULL,5859,'0',6276,471,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,5860,'0',6277,471,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,5861,'0',6278,471,15,NULL,'10.4.1.5'),(NULL,0,'2019-11-29 22:13:47',NULL,5862,'0',6279,471,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,5863,'0',6280,471,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,5864,'0',6281,471,5,NULL,'32b637da2a854f66a6c1ae27385b37d3'),(NULL,0,'2019-11-29 22:13:47',NULL,5865,'0',6282,471,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:47',NULL,5866,'0',6284,472,16,NULL,'cmdb1-4-1-6'),(NULL,0,'2019-11-29 22:13:47',NULL,5867,'0',6285,472,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,5868,'0',6286,472,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:47',NULL,5869,'0',6287,472,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,5870,'0',6288,472,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,5871,'0',6289,472,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:47',NULL,5872,'0',6290,472,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,5873,'0',6291,472,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:47',NULL,5874,'0',6292,472,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,5875,'0',6293,472,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,5876,'0',6294,472,15,NULL,'10.4.1.6'),(NULL,0,'2019-11-29 22:13:47',NULL,5877,'0',6295,472,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,5878,'0',6296,472,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,5879,'0',6297,472,5,NULL,'1a1db4d91f544c1dbee68633d5b2ff96'),(NULL,0,'2019-11-29 22:13:47',NULL,5880,'0',6298,472,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:47',NULL,5881,'0',6300,473,16,NULL,'cmdb1-4-1-7'),(NULL,0,'2019-11-29 22:13:47',NULL,5882,'0',6301,473,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,5883,'0',6302,473,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:47',NULL,5884,'0',6303,473,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,5885,'0',6304,473,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,5886,'0',6305,473,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:47',NULL,5887,'0',6306,473,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,5888,'0',6307,473,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:47',NULL,5889,'0',6308,473,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,5890,'0',6309,473,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,5891,'0',6310,473,15,NULL,'10.4.1.7'),(NULL,0,'2019-11-29 22:13:47',NULL,5892,'0',6311,473,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,5893,'0',6312,473,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,5894,'0',6313,473,5,NULL,'8b4861b293994a2d8e6f8ea825a04b5e'),(NULL,0,'2019-11-29 22:13:47',NULL,5895,'0',6314,473,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:47',NULL,5896,'0',6316,474,16,NULL,'cmdb1-4-1-8'),(NULL,0,'2019-11-29 22:13:47',NULL,5897,'0',6317,474,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,5898,'0',6318,474,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:47',NULL,5899,'0',6319,474,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,5900,'0',6320,474,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,5901,'0',6321,474,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:47',NULL,5902,'0',6322,474,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,5903,'0',6323,474,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:47',NULL,5904,'0',6324,474,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,5905,'0',6325,474,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,5906,'0',6326,474,15,NULL,'10.4.1.8'),(NULL,0,'2019-11-29 22:13:47',NULL,5907,'0',6327,474,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,5908,'0',6328,474,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,5909,'0',6329,474,5,NULL,'922ae03ab56942319bcf03a88b16dfe0'),(NULL,0,'2019-11-29 22:13:47',NULL,5910,'0',6330,474,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:47',NULL,5911,'0',6332,475,16,NULL,'cmdb1-4-1-9'),(NULL,0,'2019-11-29 22:13:47',NULL,5912,'0',6333,475,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,5913,'0',6334,475,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:47',NULL,5914,'0',6335,475,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,5915,'0',6336,475,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,5916,'0',6337,475,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:47',NULL,5917,'0',6338,475,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,5918,'0',6339,475,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:47',NULL,5919,'0',6340,475,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,5920,'0',6341,475,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,5921,'0',6342,475,15,NULL,'10.4.1.9'),(NULL,0,'2019-11-29 22:13:47',NULL,5922,'0',6343,475,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,5923,'0',6344,475,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,5924,'0',6345,475,5,NULL,'0e94d33be15b46019e5a2d34f84c950d'),(NULL,0,'2019-11-29 22:13:47',NULL,5925,'0',6346,475,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:48',NULL,5926,'0',6348,476,16,NULL,'cmdb1-4-1-10'),(NULL,0,'2019-11-29 22:13:48',NULL,5927,'0',6349,476,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,5928,'0',6350,476,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:48',NULL,5929,'0',6351,476,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,5930,'0',6352,476,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,5931,'0',6353,476,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:48',NULL,5932,'0',6354,476,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,5933,'0',6355,476,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:48',NULL,5934,'0',6356,476,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,5935,'0',6357,476,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,5936,'0',6358,476,15,NULL,'10.4.1.10'),(NULL,0,'2019-11-29 22:13:48',NULL,5937,'0',6359,476,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,5938,'0',6360,476,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,5939,'0',6361,476,5,NULL,'5bbb7fc415ee4528a4a54743c0af3de5'),(NULL,0,'2019-11-29 22:13:48',NULL,5940,'0',6362,476,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:48',NULL,5941,'0',6364,477,16,NULL,'cmdb1-4-1-11'),(NULL,0,'2019-11-29 22:13:48',NULL,5942,'0',6365,477,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,5943,'0',6366,477,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:48',NULL,5944,'0',6367,477,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,5945,'0',6368,477,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,5946,'0',6369,477,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:48',NULL,5947,'0',6370,477,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,5948,'0',6371,477,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:48',NULL,5949,'0',6372,477,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,5950,'0',6373,477,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,5951,'0',6374,477,15,NULL,'10.4.1.11'),(NULL,0,'2019-11-29 22:13:48',NULL,5952,'0',6375,477,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,5953,'0',6376,477,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,5954,'0',6377,477,5,NULL,'47d60ba791c148958694975ce51c6e26'),(NULL,0,'2019-11-29 22:13:48',NULL,5955,'0',6378,477,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:48',NULL,5956,'0',6380,478,16,NULL,'cmdb1-4-1-12'),(NULL,0,'2019-11-29 22:13:48',NULL,5957,'0',6381,478,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,5958,'0',6382,478,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:48',NULL,5959,'0',6383,478,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,5960,'0',6384,478,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,5961,'0',6385,478,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:48',NULL,5962,'0',6386,478,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,5963,'0',6387,478,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:48',NULL,5964,'0',6388,478,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,5965,'0',6389,478,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,5966,'0',6390,478,15,NULL,'10.4.1.12'),(NULL,0,'2019-11-29 22:13:48',NULL,5967,'0',6391,478,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,5968,'0',6392,478,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,5969,'0',6393,478,5,NULL,'f14032e8a1c7400d8b68b5e795c5a4fd'),(NULL,0,'2019-11-29 22:13:48',NULL,5970,'0',6394,478,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:48',NULL,5971,'0',6396,479,16,NULL,'cmdb1-4-1-13'),(NULL,0,'2019-11-29 22:13:48',NULL,5972,'0',6397,479,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,5973,'0',6398,479,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:48',NULL,5974,'0',6399,479,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,5975,'0',6400,479,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,5976,'0',6401,479,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:48',NULL,5977,'0',6402,479,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,5978,'0',6403,479,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:48',NULL,5979,'0',6404,479,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,5980,'0',6405,479,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,5981,'0',6406,479,15,NULL,'10.4.1.13'),(NULL,0,'2019-11-29 22:13:48',NULL,5982,'0',6407,479,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,5983,'0',6408,479,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,5984,'0',6409,479,5,NULL,'3c17cecb628b43838c52456044f459d0'),(NULL,0,'2019-11-29 22:13:48',NULL,5985,'0',6410,479,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:48',NULL,5986,'0',6412,480,16,NULL,'cmdb1-4-1-14'),(NULL,0,'2019-11-29 22:13:48',NULL,5987,'0',6413,480,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,5988,'0',6414,480,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:48',NULL,5989,'0',6415,480,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,5990,'0',6416,480,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,5991,'0',6417,480,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:49',NULL,5992,'0',6418,480,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,5993,'0',6419,480,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:49',NULL,5994,'0',6420,480,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,5995,'0',6421,480,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,5996,'0',6422,480,15,NULL,'10.4.1.14'),(NULL,0,'2019-11-29 22:13:49',NULL,5997,'0',6423,480,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,5998,'0',6424,480,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,5999,'0',6425,480,5,NULL,'93e6139bdc4e450d82bbf1fc84069305'),(NULL,0,'2019-11-29 22:13:49',NULL,6000,'0',6426,480,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:49',NULL,6001,'0',6428,481,16,NULL,'cmdb1-4-1-15'),(NULL,0,'2019-11-29 22:13:49',NULL,6002,'0',6429,481,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,6003,'0',6430,481,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:49',NULL,6004,'0',6431,481,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,6005,'0',6432,481,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,6006,'0',6433,481,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:49',NULL,6007,'0',6434,481,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,6008,'0',6435,481,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:49',NULL,6009,'0',6436,481,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,6010,'0',6437,481,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,6011,'0',6438,481,15,NULL,'10.4.1.15'),(NULL,0,'2019-11-29 22:13:49',NULL,6012,'0',6439,481,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,6013,'0',6440,481,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,6014,'0',6441,481,5,NULL,'2f37d636566949e4bf81242a0b590995'),(NULL,0,'2019-11-29 22:13:49',NULL,6015,'0',6442,481,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:49',NULL,6016,'0',6444,482,16,NULL,'cmdb1-4-1-16'),(NULL,0,'2019-11-29 22:13:49',NULL,6017,'0',6445,482,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,6018,'0',6446,482,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:49',NULL,6019,'0',6447,482,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,6020,'0',6448,482,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,6021,'0',6449,482,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:49',NULL,6022,'0',6450,482,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,6023,'0',6451,482,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:49',NULL,6024,'0',6452,482,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,6025,'0',6453,482,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,6026,'0',6454,482,15,NULL,'10.4.1.16'),(NULL,0,'2019-11-29 22:13:49',NULL,6027,'0',6455,482,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,6028,'0',6456,482,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,6029,'0',6457,482,5,NULL,'ba4dbe2928ff4c23aedc4e9d6745dc96'),(NULL,0,'2019-11-29 22:13:49',NULL,6030,'0',6458,482,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:49',NULL,6031,'0',6460,483,4,NULL,'App1-4-2'),(NULL,0,'2019-11-29 22:13:49',NULL,6032,'0',6462,484,16,NULL,'cmdb1-4-2-1'),(NULL,0,'2019-11-29 22:13:49',NULL,6033,'0',6463,484,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,6034,'0',6464,484,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:49',NULL,6035,'0',6465,484,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,6036,'0',6466,484,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,6037,'0',6467,484,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:49',NULL,6038,'0',6468,484,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,6039,'0',6469,484,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:49',NULL,6040,'0',6470,484,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,6041,'0',6471,484,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,6042,'0',6472,484,15,NULL,'10.4.2.1'),(NULL,0,'2019-11-29 22:13:49',NULL,6043,'0',6473,484,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,6044,'0',6474,484,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,6045,'0',6475,484,5,NULL,'3b562e22fa0742c5ba64cede1e993c2c'),(NULL,0,'2019-11-29 22:13:49',NULL,6046,'0',6476,484,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:49',NULL,6047,'0',6478,485,16,NULL,'cmdb1-4-2-2'),(NULL,0,'2019-11-29 22:13:49',NULL,6048,'0',6479,485,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,6049,'0',6480,485,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:49',NULL,6050,'0',6481,485,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,6051,'0',6482,485,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,6052,'0',6483,485,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:50',NULL,6053,'0',6484,485,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,6054,'0',6485,485,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:50',NULL,6055,'0',6486,485,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,6056,'0',6487,485,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,6057,'0',6488,485,15,NULL,'10.4.2.2'),(NULL,0,'2019-11-29 22:13:50',NULL,6058,'0',6489,485,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,6059,'0',6490,485,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,6060,'0',6491,485,5,NULL,'d8db9341158d41e7994f72c0e6a98f56'),(NULL,0,'2019-11-29 22:13:50',NULL,6061,'0',6492,485,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:50',NULL,6062,'0',6494,486,16,NULL,'cmdb1-4-2-3'),(NULL,0,'2019-11-29 22:13:50',NULL,6063,'0',6495,486,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,6064,'0',6496,486,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:50',NULL,6065,'0',6497,486,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,6066,'0',6498,486,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,6067,'0',6499,486,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:50',NULL,6068,'0',6500,486,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,6069,'0',6501,486,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:50',NULL,6070,'0',6502,486,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,6071,'0',6503,486,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,6072,'0',6504,486,15,NULL,'10.4.2.3'),(NULL,0,'2019-11-29 22:13:50',NULL,6073,'0',6505,486,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,6074,'0',6506,486,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,6075,'0',6507,486,5,NULL,'9678c2e20b33415189dde6d1c9063fdc'),(NULL,0,'2019-11-29 22:13:50',NULL,6076,'0',6508,486,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:50',NULL,6077,'0',6510,487,16,NULL,'cmdb1-4-2-4'),(NULL,0,'2019-11-29 22:13:50',NULL,6078,'0',6511,487,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,6079,'0',6512,487,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:50',NULL,6080,'0',6513,487,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,6081,'0',6514,487,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,6082,'0',6515,487,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:50',NULL,6083,'0',6516,487,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,6084,'0',6517,487,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:50',NULL,6085,'0',6518,487,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,6086,'0',6519,487,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,6087,'0',6520,487,15,NULL,'10.4.2.4'),(NULL,0,'2019-11-29 22:13:50',NULL,6088,'0',6521,487,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,6089,'0',6522,487,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,6090,'0',6523,487,5,NULL,'31c02f14413d4b108dfbdbc9c9ba3ef2'),(NULL,0,'2019-11-29 22:13:50',NULL,6091,'0',6524,487,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:50',NULL,6092,'0',6526,488,16,NULL,'cmdb1-4-2-5'),(NULL,0,'2019-11-29 22:13:50',NULL,6093,'0',6527,488,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,6094,'0',6528,488,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:50',NULL,6095,'0',6529,488,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,6096,'0',6530,488,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,6097,'0',6531,488,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:50',NULL,6098,'0',6532,488,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,6099,'0',6533,488,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:50',NULL,6100,'0',6534,488,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,6101,'0',6535,488,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,6102,'0',6536,488,15,NULL,'10.4.2.5'),(NULL,0,'2019-11-29 22:13:50',NULL,6103,'0',6537,488,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,6104,'0',6538,488,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,6105,'0',6539,488,5,NULL,'bcf13e5b2ff64ccbb3da3246d174d64a'),(NULL,0,'2019-11-29 22:13:50',NULL,6106,'0',6540,488,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:50',NULL,6107,'0',6542,489,16,NULL,'cmdb1-4-2-6'),(NULL,0,'2019-11-29 22:13:50',NULL,6108,'0',6543,489,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,6109,'0',6544,489,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:50',NULL,6110,'0',6545,489,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,6111,'0',6546,489,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,6112,'0',6547,489,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:50',NULL,6113,'0',6548,489,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,6114,'0',6549,489,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:50',NULL,6115,'0',6550,489,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,6116,'0',6551,489,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,6117,'0',6552,489,15,NULL,'10.4.2.6'),(NULL,0,'2019-11-29 22:13:50',NULL,6118,'0',6553,489,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,6119,'0',6554,489,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,6120,'0',6555,489,5,NULL,'c54dbda67ea04a828ab199bfe882fe3b'),(NULL,0,'2019-11-29 22:13:51',NULL,6121,'0',6556,489,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:51',NULL,6122,'0',6558,490,16,NULL,'cmdb1-4-2-7'),(NULL,0,'2019-11-29 22:13:51',NULL,6123,'0',6559,490,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,6124,'0',6560,490,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:51',NULL,6125,'0',6561,490,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,6126,'0',6562,490,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,6127,'0',6563,490,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:51',NULL,6128,'0',6564,490,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,6129,'0',6565,490,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:51',NULL,6130,'0',6566,490,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,6131,'0',6567,490,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,6132,'0',6568,490,15,NULL,'10.4.2.7'),(NULL,0,'2019-11-29 22:13:51',NULL,6133,'0',6569,490,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,6134,'0',6570,490,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,6135,'0',6571,490,5,NULL,'b173ec65243c49ab8f32c209d3fbf461'),(NULL,0,'2019-11-29 22:13:51',NULL,6136,'0',6572,490,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:51',NULL,6137,'0',6574,491,16,NULL,'cmdb1-4-2-8'),(NULL,0,'2019-11-29 22:13:51',NULL,6138,'0',6575,491,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,6139,'0',6576,491,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:51',NULL,6140,'0',6577,491,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,6141,'0',6578,491,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,6142,'0',6579,491,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:51',NULL,6143,'0',6580,491,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,6144,'0',6581,491,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:51',NULL,6145,'0',6582,491,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,6146,'0',6583,491,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,6147,'0',6584,491,15,NULL,'10.4.2.8'),(NULL,0,'2019-11-29 22:13:51',NULL,6148,'0',6585,491,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,6149,'0',6586,491,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,6150,'0',6587,491,5,NULL,'5c2cd2c6e7ed4740acfccdc6d09c35a5'),(NULL,0,'2019-11-29 22:13:51',NULL,6151,'0',6588,491,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:51',NULL,6152,'0',6590,492,16,NULL,'cmdb1-4-2-9'),(NULL,0,'2019-11-29 22:13:51',NULL,6153,'0',6591,492,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,6154,'0',6592,492,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:51',NULL,6155,'0',6593,492,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,6156,'0',6594,492,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,6157,'0',6595,492,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:51',NULL,6158,'0',6596,492,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,6159,'0',6597,492,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:51',NULL,6160,'0',6598,492,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,6161,'0',6599,492,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,6162,'0',6600,492,15,NULL,'10.4.2.9'),(NULL,0,'2019-11-29 22:13:51',NULL,6163,'0',6601,492,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,6164,'0',6602,492,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,6165,'0',6603,492,5,NULL,'8e3f7b069f6344218688c57a51c0b8cc'),(NULL,0,'2019-11-29 22:13:51',NULL,6166,'0',6604,492,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:51',NULL,6167,'0',6606,493,16,NULL,'cmdb1-4-2-10'),(NULL,0,'2019-11-29 22:13:51',NULL,6168,'0',6607,493,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,6169,'0',6608,493,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:51',NULL,6170,'0',6609,493,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,6171,'0',6610,493,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,6172,'0',6611,493,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:51',NULL,6173,'0',6612,493,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,6174,'0',6613,493,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:51',NULL,6175,'0',6614,493,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,6176,'0',6615,493,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,6177,'0',6616,493,15,NULL,'10.4.2.10'),(NULL,0,'2019-11-29 22:13:51',NULL,6178,'0',6617,493,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,6179,'0',6618,493,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,6180,'0',6619,493,5,NULL,'a4b4ec5178a748bfb672aad87293a063'),(NULL,0,'2019-11-29 22:13:51',NULL,6181,'0',6620,493,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:52',NULL,6182,'0',6622,494,16,NULL,'cmdb1-4-2-11'),(NULL,0,'2019-11-29 22:13:52',NULL,6183,'0',6623,494,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,6184,'0',6624,494,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:52',NULL,6185,'0',6625,494,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,6186,'0',6626,494,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,6187,'0',6627,494,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:52',NULL,6188,'0',6628,494,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,6189,'0',6629,494,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:52',NULL,6190,'0',6630,494,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,6191,'0',6631,494,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,6192,'0',6632,494,15,NULL,'10.4.2.11'),(NULL,0,'2019-11-29 22:13:52',NULL,6193,'0',6633,494,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,6194,'0',6634,494,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,6195,'0',6635,494,5,NULL,'321c1a920947442dbfae84f802e3a1ae'),(NULL,0,'2019-11-29 22:13:52',NULL,6196,'0',6636,494,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:52',NULL,6197,'0',6638,495,16,NULL,'cmdb1-4-2-12'),(NULL,0,'2019-11-29 22:13:52',NULL,6198,'0',6639,495,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,6199,'0',6640,495,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:52',NULL,6200,'0',6641,495,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,6201,'0',6642,495,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,6202,'0',6643,495,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:52',NULL,6203,'0',6644,495,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,6204,'0',6645,495,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:52',NULL,6205,'0',6646,495,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,6206,'0',6647,495,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,6207,'0',6648,495,15,NULL,'10.4.2.12'),(NULL,0,'2019-11-29 22:13:52',NULL,6208,'0',6649,495,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,6209,'0',6650,495,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,6210,'0',6651,495,5,NULL,'8f2ed38879e24525952fdda6969a29b1'),(NULL,0,'2019-11-29 22:13:52',NULL,6211,'0',6652,495,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:52',NULL,6212,'0',6654,496,16,NULL,'cmdb1-4-2-13'),(NULL,0,'2019-11-29 22:13:52',NULL,6213,'0',6655,496,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,6214,'0',6656,496,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:52',NULL,6215,'0',6657,496,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,6216,'0',6658,496,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,6217,'0',6659,496,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:52',NULL,6218,'0',6660,496,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,6219,'0',6661,496,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:52',NULL,6220,'0',6662,496,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,6221,'0',6663,496,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,6222,'0',6664,496,15,NULL,'10.4.2.13'),(NULL,0,'2019-11-29 22:13:52',NULL,6223,'0',6665,496,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,6224,'0',6666,496,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,6225,'0',6667,496,5,NULL,'e093d028695d4dcf8ac96420d40fa203'),(NULL,0,'2019-11-29 22:13:52',NULL,6226,'0',6668,496,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:52',NULL,6227,'0',6670,497,16,NULL,'cmdb1-4-2-14'),(NULL,0,'2019-11-29 22:13:52',NULL,6228,'0',6671,497,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,6229,'0',6672,497,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:52',NULL,6230,'0',6673,497,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,6231,'0',6674,497,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,6232,'0',6675,497,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:52',NULL,6233,'0',6676,497,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,6234,'0',6677,497,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:52',NULL,6235,'0',6678,497,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,6236,'0',6679,497,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,6237,'0',6680,497,15,NULL,'10.4.2.14'),(NULL,0,'2019-11-29 22:13:52',NULL,6238,'0',6681,497,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,6239,'0',6682,497,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,6240,'0',6683,497,5,NULL,'05d80eb74a5a40f5a7f7cac1efe2e66d'),(NULL,0,'2019-11-29 22:13:52',NULL,6241,'0',6684,497,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:52',NULL,6242,'0',6686,498,16,NULL,'cmdb1-4-2-15'),(NULL,0,'2019-11-29 22:13:52',NULL,6243,'0',6687,498,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,6244,'0',6688,498,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:52',NULL,6245,'0',6689,498,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,6246,'0',6690,498,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,6247,'0',6691,498,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:53',NULL,6248,'0',6692,498,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,6249,'0',6693,498,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:53',NULL,6250,'0',6694,498,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,6251,'0',6695,498,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,6252,'0',6696,498,15,NULL,'10.4.2.15'),(NULL,0,'2019-11-29 22:13:53',NULL,6253,'0',6697,498,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,6254,'0',6698,498,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,6255,'0',6699,498,5,NULL,'bd865c183aec4a188ece7b44ea27b85c'),(NULL,0,'2019-11-29 22:13:53',NULL,6256,'0',6700,498,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:53',NULL,6257,'0',6702,499,16,NULL,'cmdb1-4-2-16'),(NULL,0,'2019-11-29 22:13:53',NULL,6258,'0',6703,499,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,6259,'0',6704,499,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:53',NULL,6260,'0',6705,499,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,6261,'0',6706,499,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,6262,'0',6707,499,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:53',NULL,6263,'0',6708,499,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,6264,'0',6709,499,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:53',NULL,6265,'0',6710,499,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,6266,'0',6711,499,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,6267,'0',6712,499,15,NULL,'10.4.2.16'),(NULL,0,'2019-11-29 22:13:53',NULL,6268,'0',6713,499,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,6269,'0',6714,499,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,6270,'0',6715,499,5,NULL,'51cf56e08990437e99a58745db1694cc'),(NULL,0,'2019-11-29 22:13:53',NULL,6271,'0',6716,499,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:53',NULL,6272,'0',6718,500,4,NULL,'App1-4-3'),(NULL,0,'2019-11-29 22:13:53',NULL,6273,'0',6720,501,16,NULL,'cmdb1-4-3-1'),(NULL,0,'2019-11-29 22:13:53',NULL,6274,'0',6721,501,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,6275,'0',6722,501,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:53',NULL,6276,'0',6723,501,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,6277,'0',6724,501,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,6278,'0',6725,501,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:53',NULL,6279,'0',6726,501,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,6280,'0',6727,501,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:53',NULL,6281,'0',6728,501,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,6282,'0',6729,501,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,6283,'0',6730,501,15,NULL,'10.4.3.1'),(NULL,0,'2019-11-29 22:13:53',NULL,6284,'0',6731,501,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,6285,'0',6732,501,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,6286,'0',6733,501,5,NULL,'4dc9092043984af0a2aaa3f9a7291aa3'),(NULL,0,'2019-11-29 22:13:53',NULL,6287,'0',6734,501,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:53',NULL,6288,'0',6736,502,16,NULL,'cmdb1-4-3-2'),(NULL,0,'2019-11-29 22:13:53',NULL,6289,'0',6737,502,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,6290,'0',6738,502,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:53',NULL,6291,'0',6739,502,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,6292,'0',6740,502,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,6293,'0',6741,502,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:53',NULL,6294,'0',6742,502,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,6295,'0',6743,502,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:53',NULL,6296,'0',6744,502,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,6297,'0',6745,502,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,6298,'0',6746,502,15,NULL,'10.4.3.2'),(NULL,0,'2019-11-29 22:13:53',NULL,6299,'0',6747,502,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,6300,'0',6748,502,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,6301,'0',6749,502,5,NULL,'63713541682445f6a844d268511a794b'),(NULL,0,'2019-11-29 22:13:53',NULL,6302,'0',6750,502,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:53',NULL,6303,'0',6752,503,16,NULL,'cmdb1-4-3-3'),(NULL,0,'2019-11-29 22:13:53',NULL,6304,'0',6753,503,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,6305,'0',6754,503,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:53',NULL,6306,'0',6755,503,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,6307,'0',6756,503,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,6308,'0',6757,503,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:53',NULL,6309,'0',6758,503,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,6310,'0',6759,503,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:54',NULL,6311,'0',6760,503,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,6312,'0',6761,503,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,6313,'0',6762,503,15,NULL,'10.4.3.3'),(NULL,0,'2019-11-29 22:13:54',NULL,6314,'0',6763,503,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,6315,'0',6764,503,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,6316,'0',6765,503,5,NULL,'03b800ef4d5d440793d8e463a75a0738'),(NULL,0,'2019-11-29 22:13:54',NULL,6317,'0',6766,503,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:54',NULL,6318,'0',6768,504,16,NULL,'cmdb1-4-3-4'),(NULL,0,'2019-11-29 22:13:54',NULL,6319,'0',6769,504,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,6320,'0',6770,504,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:54',NULL,6321,'0',6771,504,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,6322,'0',6772,504,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,6323,'0',6773,504,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:54',NULL,6324,'0',6774,504,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,6325,'0',6775,504,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:54',NULL,6326,'0',6776,504,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,6327,'0',6777,504,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,6328,'0',6778,504,15,NULL,'10.4.3.4'),(NULL,0,'2019-11-29 22:13:54',NULL,6329,'0',6779,504,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,6330,'0',6780,504,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,6331,'0',6781,504,5,NULL,'11e29872385a484798b4be57625b6cda'),(NULL,0,'2019-11-29 22:13:54',NULL,6332,'0',6782,504,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:54',NULL,6333,'0',6784,505,16,NULL,'cmdb1-4-3-5'),(NULL,0,'2019-11-29 22:13:54',NULL,6334,'0',6785,505,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,6335,'0',6786,505,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:54',NULL,6336,'0',6787,505,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,6337,'0',6788,505,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,6338,'0',6789,505,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:54',NULL,6339,'0',6790,505,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,6340,'0',6791,505,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:54',NULL,6341,'0',6792,505,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,6342,'0',6793,505,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,6343,'0',6794,505,15,NULL,'10.4.3.5'),(NULL,0,'2019-11-29 22:13:54',NULL,6344,'0',6795,505,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,6345,'0',6796,505,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,6346,'0',6797,505,5,NULL,'a7fd3ad2ba454f6c93e0119ca6e4c9c6'),(NULL,0,'2019-11-29 22:13:54',NULL,6347,'0',6798,505,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:54',NULL,6348,'0',6800,506,16,NULL,'cmdb1-4-3-6'),(NULL,0,'2019-11-29 22:13:54',NULL,6349,'0',6801,506,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,6350,'0',6802,506,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:54',NULL,6351,'0',6803,506,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,6352,'0',6804,506,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,6353,'0',6805,506,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:54',NULL,6354,'0',6806,506,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,6355,'0',6807,506,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:54',NULL,6356,'0',6808,506,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,6357,'0',6809,506,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,6358,'0',6810,506,15,NULL,'10.4.3.6'),(NULL,0,'2019-11-29 22:13:54',NULL,6359,'0',6811,506,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,6360,'0',6812,506,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,6361,'0',6813,506,5,NULL,'d50429e843d5482c89155e0d5022374f'),(NULL,0,'2019-11-29 22:13:54',NULL,6362,'0',6814,506,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:54',NULL,6363,'0',6816,507,16,NULL,'cmdb1-4-3-7'),(NULL,0,'2019-11-29 22:13:54',NULL,6364,'0',6817,507,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,6365,'0',6818,507,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:54',NULL,6366,'0',6819,507,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,6367,'0',6820,507,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,6368,'0',6821,507,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:54',NULL,6369,'0',6822,507,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,6370,'0',6823,507,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:54',NULL,6371,'0',6824,507,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,6372,'0',6825,507,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,6373,'0',6826,507,15,NULL,'10.4.3.7'),(NULL,0,'2019-11-29 22:13:54',NULL,6374,'0',6827,507,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,6375,'0',6828,507,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,6376,'0',6829,507,5,NULL,'9b6fc763687f444aa22cba5ee8c089c2'),(NULL,0,'2019-11-29 22:13:54',NULL,6377,'0',6830,507,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:55',NULL,6378,'0',6832,508,16,NULL,'cmdb1-4-3-8'),(NULL,0,'2019-11-29 22:13:55',NULL,6379,'0',6833,508,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,6380,'0',6834,508,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:55',NULL,6381,'0',6835,508,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,6382,'0',6836,508,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,6383,'0',6837,508,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:55',NULL,6384,'0',6838,508,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,6385,'0',6839,508,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:55',NULL,6386,'0',6840,508,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,6387,'0',6841,508,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,6388,'0',6842,508,15,NULL,'10.4.3.8'),(NULL,0,'2019-11-29 22:13:55',NULL,6389,'0',6843,508,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,6390,'0',6844,508,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,6391,'0',6845,508,5,NULL,'b32055d5cff243519bc5f89f2b47feef'),(NULL,0,'2019-11-29 22:13:55',NULL,6392,'0',6846,508,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:55',NULL,6393,'0',6848,509,16,NULL,'cmdb1-4-3-9'),(NULL,0,'2019-11-29 22:13:55',NULL,6394,'0',6849,509,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,6395,'0',6850,509,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:55',NULL,6396,'0',6851,509,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,6397,'0',6852,509,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,6398,'0',6853,509,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:55',NULL,6399,'0',6854,509,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,6400,'0',6855,509,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:55',NULL,6401,'0',6856,509,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,6402,'0',6857,509,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,6403,'0',6858,509,15,NULL,'10.4.3.9'),(NULL,0,'2019-11-29 22:13:55',NULL,6404,'0',6859,509,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,6405,'0',6860,509,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,6406,'0',6861,509,5,NULL,'aca46bc05ad94911be15e0c1ef597865'),(NULL,0,'2019-11-29 22:13:55',NULL,6407,'0',6862,509,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:55',NULL,6408,'0',6864,510,16,NULL,'cmdb1-4-3-10'),(NULL,0,'2019-11-29 22:13:55',NULL,6409,'0',6865,510,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,6410,'0',6866,510,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:55',NULL,6411,'0',6867,510,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,6412,'0',6868,510,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,6413,'0',6869,510,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:55',NULL,6414,'0',6870,510,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,6415,'0',6871,510,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:55',NULL,6416,'0',6872,510,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,6417,'0',6873,510,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,6418,'0',6874,510,15,NULL,'10.4.3.10'),(NULL,0,'2019-11-29 22:13:55',NULL,6419,'0',6875,510,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,6420,'0',6876,510,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,6421,'0',6877,510,5,NULL,'60f5e5ce1b7941f38bc1ce6fd055dee2'),(NULL,0,'2019-11-29 22:13:55',NULL,6422,'0',6878,510,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:55',NULL,6423,'0',6880,511,16,NULL,'cmdb1-4-3-11'),(NULL,0,'2019-11-29 22:13:55',NULL,6424,'0',6881,511,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,6425,'0',6882,511,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:55',NULL,6426,'0',6883,511,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,6427,'0',6884,511,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,6428,'0',6885,511,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:55',NULL,6429,'0',6886,511,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,6430,'0',6887,511,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:55',NULL,6431,'0',6888,511,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,6432,'0',6889,511,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,6433,'0',6890,511,15,NULL,'10.4.3.11'),(NULL,0,'2019-11-29 22:13:55',NULL,6434,'0',6891,511,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,6435,'0',6892,511,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,6436,'0',6893,511,5,NULL,'5822ac551b12454684c50defa178bd56'),(NULL,0,'2019-11-29 22:13:55',NULL,6437,'0',6894,511,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:55',NULL,6438,'0',6896,512,16,NULL,'cmdb1-4-3-12'),(NULL,0,'2019-11-29 22:13:55',NULL,6439,'0',6897,512,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,6440,'0',6898,512,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:56',NULL,6441,'0',6899,512,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,6442,'0',6900,512,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,6443,'0',6901,512,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:56',NULL,6444,'0',6902,512,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,6445,'0',6903,512,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:56',NULL,6446,'0',6904,512,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,6447,'0',6905,512,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,6448,'0',6906,512,15,NULL,'10.4.3.12'),(NULL,0,'2019-11-29 22:13:56',NULL,6449,'0',6907,512,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,6450,'0',6908,512,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,6451,'0',6909,512,5,NULL,'10257bf032b74faebdee0b52a7efa975'),(NULL,0,'2019-11-29 22:13:56',NULL,6452,'0',6910,512,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:56',NULL,6453,'0',6912,513,16,NULL,'cmdb1-4-3-13'),(NULL,0,'2019-11-29 22:13:56',NULL,6454,'0',6913,513,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,6455,'0',6914,513,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:56',NULL,6456,'0',6915,513,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,6457,'0',6916,513,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,6458,'0',6917,513,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:56',NULL,6459,'0',6918,513,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,6460,'0',6919,513,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:56',NULL,6461,'0',6920,513,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,6462,'0',6921,513,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,6463,'0',6922,513,15,NULL,'10.4.3.13'),(NULL,0,'2019-11-29 22:13:56',NULL,6464,'0',6923,513,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,6465,'0',6924,513,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,6466,'0',6925,513,5,NULL,'f429ddebd8e64d7293cc3a9b397abff5'),(NULL,0,'2019-11-29 22:13:56',NULL,6467,'0',6926,513,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:56',NULL,6468,'0',6928,514,16,NULL,'cmdb1-4-3-14'),(NULL,0,'2019-11-29 22:13:56',NULL,6469,'0',6929,514,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,6470,'0',6930,514,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:56',NULL,6471,'0',6931,514,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,6472,'0',6932,514,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,6473,'0',6933,514,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:56',NULL,6474,'0',6934,514,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,6475,'0',6935,514,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:56',NULL,6476,'0',6936,514,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,6477,'0',6937,514,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,6478,'0',6938,514,15,NULL,'10.4.3.14'),(NULL,0,'2019-11-29 22:13:56',NULL,6479,'0',6939,514,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,6480,'0',6940,514,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,6481,'0',6941,514,5,NULL,'6e5e3cc023fa4b34acda33d5c96f7ae7'),(NULL,0,'2019-11-29 22:13:56',NULL,6482,'0',6942,514,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:56',NULL,6483,'0',6944,515,16,NULL,'cmdb1-4-3-15'),(NULL,0,'2019-11-29 22:13:56',NULL,6484,'0',6945,515,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,6485,'0',6946,515,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:56',NULL,6486,'0',6947,515,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,6487,'0',6948,515,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,6488,'0',6949,515,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:56',NULL,6489,'0',6950,515,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,6490,'0',6951,515,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:56',NULL,6491,'0',6952,515,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,6492,'0',6953,515,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,6493,'0',6954,515,15,NULL,'10.4.3.15'),(NULL,0,'2019-11-29 22:13:56',NULL,6494,'0',6955,515,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,6495,'0',6956,515,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,6496,'0',6957,515,5,NULL,'6a3630b304634f41b8d0d493bf5ae838'),(NULL,0,'2019-11-29 22:13:56',NULL,6497,'0',6958,515,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:56',NULL,6498,'0',6960,516,16,NULL,'cmdb1-4-3-16'),(NULL,0,'2019-11-29 22:13:56',NULL,6499,'0',6961,516,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,6500,'0',6962,516,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:56',NULL,6501,'0',6963,516,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,6502,'0',6964,516,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,6503,'0',6965,516,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:56',NULL,6504,'0',6966,516,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,6505,'0',6967,516,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:56',NULL,6506,'0',6968,516,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,6507,'0',6969,516,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,6508,'0',6970,516,15,NULL,'10.4.3.16'),(NULL,0,'2019-11-29 22:13:57',NULL,6509,'0',6971,516,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,6510,'0',6972,516,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,6511,'0',6973,516,5,NULL,'5492cc0fb1654849abdcc39517cb613f'),(NULL,0,'2019-11-29 22:13:57',NULL,6512,'0',6974,516,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:57',NULL,6513,'0',6976,517,4,NULL,'App1-4-4'),(NULL,0,'2019-11-29 22:13:57',NULL,6514,'0',6978,518,16,NULL,'cmdb1-4-4-1'),(NULL,0,'2019-11-29 22:13:57',NULL,6515,'0',6979,518,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,6516,'0',6980,518,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:57',NULL,6517,'0',6981,518,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,6518,'0',6982,518,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,6519,'0',6983,518,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:57',NULL,6520,'0',6984,518,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,6521,'0',6985,518,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:57',NULL,6522,'0',6986,518,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,6523,'0',6987,518,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,6524,'0',6988,518,15,NULL,'10.4.4.1'),(NULL,0,'2019-11-29 22:13:57',NULL,6525,'0',6989,518,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,6526,'0',6990,518,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,6527,'0',6991,518,5,NULL,'98e1d4470bfc425ea02c3971ed21c726'),(NULL,0,'2019-11-29 22:13:57',NULL,6528,'0',6992,518,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:57',NULL,6529,'0',6994,519,16,NULL,'cmdb1-4-4-2'),(NULL,0,'2019-11-29 22:13:57',NULL,6530,'0',6995,519,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,6531,'0',6996,519,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:57',NULL,6532,'0',6997,519,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,6533,'0',6998,519,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,6534,'0',6999,519,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:57',NULL,6535,'0',7000,519,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,6536,'0',7001,519,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:57',NULL,6537,'0',7002,519,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,6538,'0',7003,519,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,6539,'0',7004,519,15,NULL,'10.4.4.2'),(NULL,0,'2019-11-29 22:13:57',NULL,6540,'0',7005,519,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,6541,'0',7006,519,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,6542,'0',7007,519,5,NULL,'c9b77e2bac504aa195e617c107dfc7b5'),(NULL,0,'2019-11-29 22:13:57',NULL,6543,'0',7008,519,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:57',NULL,6544,'0',7010,520,16,NULL,'cmdb1-4-4-3'),(NULL,0,'2019-11-29 22:13:57',NULL,6545,'0',7011,520,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,6546,'0',7012,520,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:57',NULL,6547,'0',7013,520,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,6548,'0',7014,520,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,6549,'0',7015,520,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:57',NULL,6550,'0',7016,520,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,6551,'0',7017,520,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:57',NULL,6552,'0',7018,520,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,6553,'0',7019,520,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,6554,'0',7020,520,15,NULL,'10.4.4.3'),(NULL,0,'2019-11-29 22:13:57',NULL,6555,'0',7021,520,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,6556,'0',7022,520,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,6557,'0',7023,520,5,NULL,'bc796cd0c1e34f9fb37a75a74f739684'),(NULL,0,'2019-11-29 22:13:57',NULL,6558,'0',7024,520,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:57',NULL,6559,'0',7026,521,16,NULL,'cmdb1-4-4-4'),(NULL,0,'2019-11-29 22:13:57',NULL,6560,'0',7027,521,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,6561,'0',7028,521,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:57',NULL,6562,'0',7029,521,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,6563,'0',7030,521,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,6564,'0',7031,521,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:57',NULL,6565,'0',7032,521,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,6566,'0',7033,521,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:57',NULL,6567,'0',7034,521,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,6568,'0',7035,521,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,6569,'0',7036,521,15,NULL,'10.4.4.4'),(NULL,0,'2019-11-29 22:13:58',NULL,6570,'0',7037,521,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,6571,'0',7038,521,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,6572,'0',7039,521,5,NULL,'eccc625506e440e58f7db6f2c00ef239'),(NULL,0,'2019-11-29 22:13:58',NULL,6573,'0',7040,521,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:58',NULL,6574,'0',7042,522,16,NULL,'cmdb1-4-4-5'),(NULL,0,'2019-11-29 22:13:58',NULL,6575,'0',7043,522,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,6576,'0',7044,522,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:58',NULL,6577,'0',7045,522,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,6578,'0',7046,522,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,6579,'0',7047,522,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:58',NULL,6580,'0',7048,522,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,6581,'0',7049,522,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:58',NULL,6582,'0',7050,522,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,6583,'0',7051,522,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,6584,'0',7052,522,15,NULL,'10.4.4.5'),(NULL,0,'2019-11-29 22:13:58',NULL,6585,'0',7053,522,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,6586,'0',7054,522,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,6587,'0',7055,522,5,NULL,'7c27818a5aed43b3a3d8fbfedb81084a'),(NULL,0,'2019-11-29 22:13:58',NULL,6588,'0',7056,522,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:58',NULL,6589,'0',7058,523,16,NULL,'cmdb1-4-4-6'),(NULL,0,'2019-11-29 22:13:58',NULL,6590,'0',7059,523,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,6591,'0',7060,523,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:58',NULL,6592,'0',7061,523,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,6593,'0',7062,523,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,6594,'0',7063,523,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:58',NULL,6595,'0',7064,523,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,6596,'0',7065,523,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:58',NULL,6597,'0',7066,523,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,6598,'0',7067,523,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,6599,'0',7068,523,15,NULL,'10.4.4.6'),(NULL,0,'2019-11-29 22:13:58',NULL,6600,'0',7069,523,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,6601,'0',7070,523,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,6602,'0',7071,523,5,NULL,'3011b3a039a44849b3cc2da1b21c98e1'),(NULL,0,'2019-11-29 22:13:58',NULL,6603,'0',7072,523,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:58',NULL,6604,'0',7074,524,16,NULL,'cmdb1-4-4-7'),(NULL,0,'2019-11-29 22:13:58',NULL,6605,'0',7075,524,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,6606,'0',7076,524,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:58',NULL,6607,'0',7077,524,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,6608,'0',7078,524,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,6609,'0',7079,524,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:58',NULL,6610,'0',7080,524,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,6611,'0',7081,524,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:58',NULL,6612,'0',7082,524,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,6613,'0',7083,524,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,6614,'0',7084,524,15,NULL,'10.4.4.7'),(NULL,0,'2019-11-29 22:13:58',NULL,6615,'0',7085,524,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,6616,'0',7086,524,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,6617,'0',7087,524,5,NULL,'bce2a1d2bac34e0da1e791b1d2c80f52'),(NULL,0,'2019-11-29 22:13:58',NULL,6618,'0',7088,524,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:58',NULL,6619,'0',7090,525,16,NULL,'cmdb1-4-4-8'),(NULL,0,'2019-11-29 22:13:58',NULL,6620,'0',7091,525,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,6621,'0',7092,525,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:58',NULL,6622,'0',7093,525,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,6623,'0',7094,525,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,6624,'0',7095,525,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:58',NULL,6625,'0',7096,525,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,6626,'0',7097,525,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:58',NULL,6627,'0',7098,525,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,6628,'0',7099,525,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,6629,'0',7100,525,15,NULL,'10.4.4.8'),(NULL,0,'2019-11-29 22:13:58',NULL,6630,'0',7101,525,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,6631,'0',7102,525,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,6632,'0',7103,525,5,NULL,'b2e7d47c08e444bcbadd7d38bdf2868a'),(NULL,0,'2019-11-29 22:13:58',NULL,6633,'0',7104,525,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:59',NULL,6634,'0',7106,526,16,NULL,'cmdb1-4-4-9'),(NULL,0,'2019-11-29 22:13:59',NULL,6635,'0',7107,526,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,6636,'0',7108,526,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:59',NULL,6637,'0',7109,526,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,6638,'0',7110,526,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,6639,'0',7111,526,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:59',NULL,6640,'0',7112,526,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,6641,'0',7113,526,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:59',NULL,6642,'0',7114,526,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,6643,'0',7115,526,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,6644,'0',7116,526,15,NULL,'10.4.4.9'),(NULL,0,'2019-11-29 22:13:59',NULL,6645,'0',7117,526,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,6646,'0',7118,526,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,6647,'0',7119,526,5,NULL,'ae322c90da664d47a6552edfa9a14f00'),(NULL,0,'2019-11-29 22:13:59',NULL,6648,'0',7120,526,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:59',NULL,6649,'0',7122,527,16,NULL,'cmdb1-4-4-10'),(NULL,0,'2019-11-29 22:13:59',NULL,6650,'0',7123,527,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,6651,'0',7124,527,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:59',NULL,6652,'0',7125,527,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,6653,'0',7126,527,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,6654,'0',7127,527,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:59',NULL,6655,'0',7128,527,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,6656,'0',7129,527,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:59',NULL,6657,'0',7130,527,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,6658,'0',7131,527,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,6659,'0',7132,527,15,NULL,'10.4.4.10'),(NULL,0,'2019-11-29 22:13:59',NULL,6660,'0',7133,527,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,6661,'0',7134,527,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,6662,'0',7135,527,5,NULL,'51ad8b8f5c7941daaac34c49092856ae'),(NULL,0,'2019-11-29 22:13:59',NULL,6663,'0',7136,527,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:59',NULL,6664,'0',7138,528,16,NULL,'cmdb1-4-4-11'),(NULL,0,'2019-11-29 22:13:59',NULL,6665,'0',7139,528,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,6666,'0',7140,528,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:59',NULL,6667,'0',7141,528,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,6668,'0',7142,528,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,6669,'0',7143,528,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:59',NULL,6670,'0',7144,528,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,6671,'0',7145,528,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:59',NULL,6672,'0',7146,528,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,6673,'0',7147,528,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,6674,'0',7148,528,15,NULL,'10.4.4.11'),(NULL,0,'2019-11-29 22:13:59',NULL,6675,'0',7149,528,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,6676,'0',7150,528,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,6677,'0',7151,528,5,NULL,'d7aea06543754716999bebfdc781a5f1'),(NULL,0,'2019-11-29 22:13:59',NULL,6678,'0',7152,528,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:59',NULL,6679,'0',7154,529,16,NULL,'cmdb1-4-4-12'),(NULL,0,'2019-11-29 22:13:59',NULL,6680,'0',7155,529,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,6681,'0',7156,529,22,NULL,'2'),(NULL,0,'2019-11-29 22:13:59',NULL,6682,'0',7157,529,28,NULL,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,6683,'0',7158,529,24,NULL,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,6684,'0',7159,529,29,NULL,'张江'),(NULL,0,'2019-11-29 22:13:59',NULL,6685,'0',7160,529,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,6686,'0',7161,529,23,NULL,'40'),(NULL,0,'2019-11-29 22:13:59',NULL,6687,'0',7162,529,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,6688,'0',7163,529,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,6689,'0',7164,529,15,NULL,'10.4.4.12'),(NULL,0,'2019-11-29 22:13:59',NULL,6690,'0',7165,529,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,6691,'0',7166,529,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,6692,'0',7167,529,5,NULL,'a49dcd92e23f466296cb85a5d2c54c3b'),(NULL,0,'2019-11-29 22:13:59',NULL,6693,'0',7168,529,17,NULL,'在线'),(NULL,0,'2019-11-29 22:13:59',NULL,6694,'0',7170,530,16,NULL,'cmdb1-4-4-13'),(NULL,0,'2019-11-29 22:13:59',NULL,6695,'0',7171,530,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,6696,'0',7172,530,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:00',NULL,6697,'0',7173,530,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,6698,'0',7174,530,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,6699,'0',7175,530,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:00',NULL,6700,'0',7176,530,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,6701,'0',7177,530,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:00',NULL,6702,'0',7178,530,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,6703,'0',7179,530,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,6704,'0',7180,530,15,NULL,'10.4.4.13'),(NULL,0,'2019-11-29 22:14:00',NULL,6705,'0',7181,530,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,6706,'0',7182,530,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,6707,'0',7183,530,5,NULL,'5e870ab25be1472f924000d8abf7a223'),(NULL,0,'2019-11-29 22:14:00',NULL,6708,'0',7184,530,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:00',NULL,6709,'0',7186,531,16,NULL,'cmdb1-4-4-14'),(NULL,0,'2019-11-29 22:14:00',NULL,6710,'0',7187,531,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,6711,'0',7188,531,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:00',NULL,6712,'0',7189,531,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,6713,'0',7190,531,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,6714,'0',7191,531,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:00',NULL,6715,'0',7192,531,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,6716,'0',7193,531,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:00',NULL,6717,'0',7194,531,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,6718,'0',7195,531,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,6719,'0',7196,531,15,NULL,'10.4.4.14'),(NULL,0,'2019-11-29 22:14:00',NULL,6720,'0',7197,531,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,6721,'0',7198,531,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,6722,'0',7199,531,5,NULL,'ac367e9a2ec1403cbfa986c73c5b4401'),(NULL,0,'2019-11-29 22:14:00',NULL,6723,'0',7200,531,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:00',NULL,6724,'0',7202,532,16,NULL,'cmdb1-4-4-15'),(NULL,0,'2019-11-29 22:14:00',NULL,6725,'0',7203,532,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,6726,'0',7204,532,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:00',NULL,6727,'0',7205,532,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,6728,'0',7206,532,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,6729,'0',7207,532,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:00',NULL,6730,'0',7208,532,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,6731,'0',7209,532,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:00',NULL,6732,'0',7210,532,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,6733,'0',7211,532,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,6734,'0',7212,532,15,NULL,'10.4.4.15'),(NULL,0,'2019-11-29 22:14:00',NULL,6735,'0',7213,532,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,6736,'0',7214,532,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,6737,'0',7215,532,5,NULL,'a255550e225343f6b6a93a1c02af573a'),(NULL,0,'2019-11-29 22:14:00',NULL,6738,'0',7216,532,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:00',NULL,6739,'0',7218,533,16,NULL,'cmdb1-4-4-16'),(NULL,0,'2019-11-29 22:14:00',NULL,6740,'0',7219,533,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,6741,'0',7220,533,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:00',NULL,6742,'0',7221,533,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,6743,'0',7222,533,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,6744,'0',7223,533,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:00',NULL,6745,'0',7224,533,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,6746,'0',7225,533,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:00',NULL,6747,'0',7226,533,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,6748,'0',7227,533,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,6749,'0',7228,533,15,NULL,'10.4.4.16'),(NULL,0,'2019-11-29 22:14:00',NULL,6750,'0',7229,533,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,6751,'0',7230,533,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,6752,'0',7231,533,5,NULL,'2cefc970e584488b8e78545978ca1f6c'),(NULL,0,'2019-11-29 22:14:00',NULL,6753,'0',7232,533,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:00',NULL,6754,'0',7234,534,4,NULL,'App1-4-5'),(NULL,0,'2019-11-29 22:14:00',NULL,6755,'0',7236,535,16,NULL,'cmdb1-4-5-1'),(NULL,0,'2019-11-29 22:14:00',NULL,6756,'0',7237,535,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,6757,'0',7238,535,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:01',NULL,6758,'0',7239,535,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,6759,'0',7240,535,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,6760,'0',7241,535,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:01',NULL,6761,'0',7242,535,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,6762,'0',7243,535,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:01',NULL,6763,'0',7244,535,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,6764,'0',7245,535,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,6765,'0',7246,535,15,NULL,'10.4.5.1'),(NULL,0,'2019-11-29 22:14:01',NULL,6766,'0',7247,535,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,6767,'0',7248,535,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,6768,'0',7249,535,5,NULL,'a9ba47ae20f94daeb306b7b24d1f7033'),(NULL,0,'2019-11-29 22:14:01',NULL,6769,'0',7250,535,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:01',NULL,6770,'0',7252,536,16,NULL,'cmdb1-4-5-2'),(NULL,0,'2019-11-29 22:14:01',NULL,6771,'0',7253,536,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,6772,'0',7254,536,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:01',NULL,6773,'0',7255,536,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,6774,'0',7256,536,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,6775,'0',7257,536,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:01',NULL,6776,'0',7258,536,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,6777,'0',7259,536,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:01',NULL,6778,'0',7260,536,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,6779,'0',7261,536,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,6780,'0',7262,536,15,NULL,'10.4.5.2'),(NULL,0,'2019-11-29 22:14:01',NULL,6781,'0',7263,536,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,6782,'0',7264,536,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,6783,'0',7265,536,5,NULL,'61c98b4f97e14366a4e610793b61baec'),(NULL,0,'2019-11-29 22:14:01',NULL,6784,'0',7266,536,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:01',NULL,6785,'0',7268,537,16,NULL,'cmdb1-4-5-3'),(NULL,0,'2019-11-29 22:14:01',NULL,6786,'0',7269,537,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,6787,'0',7270,537,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:01',NULL,6788,'0',7271,537,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,6789,'0',7272,537,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,6790,'0',7273,537,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:01',NULL,6791,'0',7274,537,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,6792,'0',7275,537,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:01',NULL,6793,'0',7276,537,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,6794,'0',7277,537,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,6795,'0',7278,537,15,NULL,'10.4.5.3'),(NULL,0,'2019-11-29 22:14:01',NULL,6796,'0',7279,537,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,6797,'0',7280,537,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,6798,'0',7281,537,5,NULL,'7075138424c143f3aab77ccdbe9c7456'),(NULL,0,'2019-11-29 22:14:01',NULL,6799,'0',7282,537,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:01',NULL,6800,'0',7284,538,16,NULL,'cmdb1-4-5-4'),(NULL,0,'2019-11-29 22:14:01',NULL,6801,'0',7285,538,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,6802,'0',7286,538,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:01',NULL,6803,'0',7287,538,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,6804,'0',7288,538,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,6805,'0',7289,538,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:01',NULL,6806,'0',7290,538,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,6807,'0',7291,538,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:01',NULL,6808,'0',7292,538,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,6809,'0',7293,538,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,6810,'0',7294,538,15,NULL,'10.4.5.4'),(NULL,0,'2019-11-29 22:14:01',NULL,6811,'0',7295,538,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,6812,'0',7296,538,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,6813,'0',7297,538,5,NULL,'4b9e56573a224de595335628e8e3ac93'),(NULL,0,'2019-11-29 22:14:01',NULL,6814,'0',7298,538,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:01',NULL,6815,'0',7300,539,16,NULL,'cmdb1-4-5-5'),(NULL,0,'2019-11-29 22:14:01',NULL,6816,'0',7301,539,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,6817,'0',7302,539,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:01',NULL,6818,'0',7303,539,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,6819,'0',7304,539,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,6820,'0',7305,539,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:01',NULL,6821,'0',7306,539,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,6822,'0',7307,539,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:02',NULL,6823,'0',7308,539,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,6824,'0',7309,539,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,6825,'0',7310,539,15,NULL,'10.4.5.5'),(NULL,0,'2019-11-29 22:14:02',NULL,6826,'0',7311,539,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,6827,'0',7312,539,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,6828,'0',7313,539,5,NULL,'5349a0363eb64bc08df37af961d3669c'),(NULL,0,'2019-11-29 22:14:02',NULL,6829,'0',7314,539,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:02',NULL,6830,'0',7316,540,16,NULL,'cmdb1-4-5-6'),(NULL,0,'2019-11-29 22:14:02',NULL,6831,'0',7317,540,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,6832,'0',7318,540,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:02',NULL,6833,'0',7319,540,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,6834,'0',7320,540,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,6835,'0',7321,540,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:02',NULL,6836,'0',7322,540,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,6837,'0',7323,540,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:02',NULL,6838,'0',7324,540,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,6839,'0',7325,540,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,6840,'0',7326,540,15,NULL,'10.4.5.6'),(NULL,0,'2019-11-29 22:14:02',NULL,6841,'0',7327,540,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,6842,'0',7328,540,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,6843,'0',7329,540,5,NULL,'2e1dcfa21fce485ba12a825c11a771e1'),(NULL,0,'2019-11-29 22:14:02',NULL,6844,'0',7330,540,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:02',NULL,6845,'0',7332,541,16,NULL,'cmdb1-4-5-7'),(NULL,0,'2019-11-29 22:14:02',NULL,6846,'0',7333,541,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,6847,'0',7334,541,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:02',NULL,6848,'0',7335,541,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,6849,'0',7336,541,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,6850,'0',7337,541,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:02',NULL,6851,'0',7338,541,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,6852,'0',7339,541,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:02',NULL,6853,'0',7340,541,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,6854,'0',7341,541,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,6855,'0',7342,541,15,NULL,'10.4.5.7'),(NULL,0,'2019-11-29 22:14:02',NULL,6856,'0',7343,541,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,6857,'0',7344,541,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,6858,'0',7345,541,5,NULL,'49d211b152984c71a183f51add44224a'),(NULL,0,'2019-11-29 22:14:02',NULL,6859,'0',7346,541,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:02',NULL,6860,'0',7348,542,16,NULL,'cmdb1-4-5-8'),(NULL,0,'2019-11-29 22:14:02',NULL,6861,'0',7349,542,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,6862,'0',7350,542,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:02',NULL,6863,'0',7351,542,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,6864,'0',7352,542,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,6865,'0',7353,542,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:02',NULL,6866,'0',7354,542,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,6867,'0',7355,542,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:02',NULL,6868,'0',7356,542,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,6869,'0',7357,542,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,6870,'0',7358,542,15,NULL,'10.4.5.8'),(NULL,0,'2019-11-29 22:14:02',NULL,6871,'0',7359,542,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,6872,'0',7360,542,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,6873,'0',7361,542,5,NULL,'bd41820553224143bc39a4f53437eb1a'),(NULL,0,'2019-11-29 22:14:02',NULL,6874,'0',7362,542,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:02',NULL,6875,'0',7364,543,16,NULL,'cmdb1-4-5-9'),(NULL,0,'2019-11-29 22:14:02',NULL,6876,'0',7365,543,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,6877,'0',7366,543,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:02',NULL,6878,'0',7367,543,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,6879,'0',7368,543,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,6880,'0',7369,543,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:02',NULL,6881,'0',7370,543,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,6882,'0',7371,543,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:02',NULL,6883,'0',7372,543,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,6884,'0',7373,543,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,6885,'0',7374,543,15,NULL,'10.4.5.9'),(NULL,0,'2019-11-29 22:14:02',NULL,6886,'0',7375,543,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,6887,'0',7376,543,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,6888,'0',7377,543,5,NULL,'433176e93fa14606ac5c145211192b14'),(NULL,0,'2019-11-29 22:14:02',NULL,6889,'0',7378,543,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:03',NULL,6890,'0',7380,544,16,NULL,'cmdb1-4-5-10'),(NULL,0,'2019-11-29 22:14:03',NULL,6891,'0',7381,544,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,6892,'0',7382,544,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:03',NULL,6893,'0',7383,544,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,6894,'0',7384,544,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,6895,'0',7385,544,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:03',NULL,6896,'0',7386,544,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,6897,'0',7387,544,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:03',NULL,6898,'0',7388,544,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,6899,'0',7389,544,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,6900,'0',7390,544,15,NULL,'10.4.5.10'),(NULL,0,'2019-11-29 22:14:03',NULL,6901,'0',7391,544,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,6902,'0',7392,544,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,6903,'0',7393,544,5,NULL,'78137b5e539a4d0f93751219de54593f'),(NULL,0,'2019-11-29 22:14:03',NULL,6904,'0',7394,544,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:03',NULL,6905,'0',7396,545,16,NULL,'cmdb1-4-5-11'),(NULL,0,'2019-11-29 22:14:03',NULL,6906,'0',7397,545,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,6907,'0',7398,545,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:03',NULL,6908,'0',7399,545,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,6909,'0',7400,545,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,6910,'0',7401,545,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:03',NULL,6911,'0',7402,545,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,6912,'0',7403,545,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:03',NULL,6913,'0',7404,545,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,6914,'0',7405,545,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,6915,'0',7406,545,15,NULL,'10.4.5.11'),(NULL,0,'2019-11-29 22:14:03',NULL,6916,'0',7407,545,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,6917,'0',7408,545,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,6918,'0',7409,545,5,NULL,'9e870b3731e24038a80824ca841fdde7'),(NULL,0,'2019-11-29 22:14:03',NULL,6919,'0',7410,545,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:03',NULL,6920,'0',7412,546,16,NULL,'cmdb1-4-5-12'),(NULL,0,'2019-11-29 22:14:03',NULL,6921,'0',7413,546,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,6922,'0',7414,546,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:03',NULL,6923,'0',7415,546,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,6924,'0',7416,546,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,6925,'0',7417,546,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:03',NULL,6926,'0',7418,546,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,6927,'0',7419,546,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:03',NULL,6928,'0',7420,546,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,6929,'0',7421,546,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,6930,'0',7422,546,15,NULL,'10.4.5.12'),(NULL,0,'2019-11-29 22:14:03',NULL,6931,'0',7423,546,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,6932,'0',7424,546,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,6933,'0',7425,546,5,NULL,'8a39bf57e8524ebdbc86243a394ae7b0'),(NULL,0,'2019-11-29 22:14:03',NULL,6934,'0',7426,546,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:03',NULL,6935,'0',7428,547,16,NULL,'cmdb1-4-5-13'),(NULL,0,'2019-11-29 22:14:03',NULL,6936,'0',7429,547,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,6937,'0',7430,547,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:03',NULL,6938,'0',7431,547,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,6939,'0',7432,547,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,6940,'0',7433,547,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:03',NULL,6941,'0',7434,547,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,6942,'0',7435,547,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:03',NULL,6943,'0',7436,547,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,6944,'0',7437,547,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,6945,'0',7438,547,15,NULL,'10.4.5.13'),(NULL,0,'2019-11-29 22:14:03',NULL,6946,'0',7439,547,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,6947,'0',7440,547,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,6948,'0',7441,547,5,NULL,'f608203deeb646e7a102c3d0a99e39dc'),(NULL,0,'2019-11-29 22:14:03',NULL,6949,'0',7442,547,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:03',NULL,6950,'0',7444,548,16,NULL,'cmdb1-4-5-14'),(NULL,0,'2019-11-29 22:14:03',NULL,6951,'0',7445,548,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,6952,'0',7446,548,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:04',NULL,6953,'0',7447,548,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,6954,'0',7448,548,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,6955,'0',7449,548,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:04',NULL,6956,'0',7450,548,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,6957,'0',7451,548,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:04',NULL,6958,'0',7452,548,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,6959,'0',7453,548,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,6960,'0',7454,548,15,NULL,'10.4.5.14'),(NULL,0,'2019-11-29 22:14:04',NULL,6961,'0',7455,548,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,6962,'0',7456,548,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,6963,'0',7457,548,5,NULL,'65e5312dc3fe4494a9c975648bd6876a'),(NULL,0,'2019-11-29 22:14:04',NULL,6964,'0',7458,548,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:04',NULL,6965,'0',7460,549,16,NULL,'cmdb1-4-5-15'),(NULL,0,'2019-11-29 22:14:04',NULL,6966,'0',7461,549,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,6967,'0',7462,549,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:04',NULL,6968,'0',7463,549,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,6969,'0',7464,549,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,6970,'0',7465,549,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:04',NULL,6971,'0',7466,549,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,6972,'0',7467,549,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:04',NULL,6973,'0',7468,549,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,6974,'0',7469,549,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,6975,'0',7470,549,15,NULL,'10.4.5.15'),(NULL,0,'2019-11-29 22:14:04',NULL,6976,'0',7471,549,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,6977,'0',7472,549,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,6978,'0',7473,549,5,NULL,'fe3413b341b3454694a4793b7a499831'),(NULL,0,'2019-11-29 22:14:04',NULL,6979,'0',7474,549,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:04',NULL,6980,'0',7476,550,16,NULL,'cmdb1-4-5-16'),(NULL,0,'2019-11-29 22:14:04',NULL,6981,'0',7477,550,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,6982,'0',7478,550,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:04',NULL,6983,'0',7479,550,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,6984,'0',7480,550,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,6985,'0',7481,550,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:04',NULL,6986,'0',7482,550,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,6987,'0',7483,550,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:04',NULL,6988,'0',7484,550,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,6989,'0',7485,550,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,6990,'0',7486,550,15,NULL,'10.4.5.16'),(NULL,0,'2019-11-29 22:14:04',NULL,6991,'0',7487,550,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,6992,'0',7488,550,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,6993,'0',7489,550,5,NULL,'68c2ced0a2854192b1f18a6f6bea4954'),(NULL,0,'2019-11-29 22:14:04',NULL,6994,'0',7490,550,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:04',NULL,6995,'0',7492,551,4,NULL,'App1-4-6'),(NULL,0,'2019-11-29 22:14:04',NULL,6996,'0',7494,552,16,NULL,'cmdb1-4-6-1'),(NULL,0,'2019-11-29 22:14:04',NULL,6997,'0',7495,552,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,6998,'0',7496,552,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:04',NULL,6999,'0',7497,552,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,7000,'0',7498,552,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,7001,'0',7499,552,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:04',NULL,7002,'0',7500,552,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,7003,'0',7501,552,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:04',NULL,7004,'0',7502,552,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,7005,'0',7503,552,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,7006,'0',7504,552,15,NULL,'10.4.6.1'),(NULL,0,'2019-11-29 22:14:04',NULL,7007,'0',7505,552,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,7008,'0',7506,552,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,7009,'0',7507,552,5,NULL,'88089f0644ba45ce97f97711092af978'),(NULL,0,'2019-11-29 22:14:04',NULL,7010,'0',7508,552,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:04',NULL,7011,'0',7510,553,16,NULL,'cmdb1-4-6-2'),(NULL,0,'2019-11-29 22:14:04',NULL,7012,'0',7511,553,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,7013,'0',7512,553,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:05',NULL,7014,'0',7513,553,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,7015,'0',7514,553,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,7016,'0',7515,553,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:05',NULL,7017,'0',7516,553,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,7018,'0',7517,553,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:05',NULL,7019,'0',7518,553,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,7020,'0',7519,553,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,7021,'0',7520,553,15,NULL,'10.4.6.2'),(NULL,0,'2019-11-29 22:14:05',NULL,7022,'0',7521,553,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,7023,'0',7522,553,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,7024,'0',7523,553,5,NULL,'d4770b1642d941ddad77ad7868d5f1a0'),(NULL,0,'2019-11-29 22:14:05',NULL,7025,'0',7524,553,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:05',NULL,7026,'0',7526,554,16,NULL,'cmdb1-4-6-3'),(NULL,0,'2019-11-29 22:14:05',NULL,7027,'0',7527,554,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,7028,'0',7528,554,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:05',NULL,7029,'0',7529,554,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,7030,'0',7530,554,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,7031,'0',7531,554,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:05',NULL,7032,'0',7532,554,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,7033,'0',7533,554,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:05',NULL,7034,'0',7534,554,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,7035,'0',7535,554,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,7036,'0',7536,554,15,NULL,'10.4.6.3'),(NULL,0,'2019-11-29 22:14:05',NULL,7037,'0',7537,554,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,7038,'0',7538,554,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,7039,'0',7539,554,5,NULL,'76fef15ad2854f73b78b9f28b9f3ab47'),(NULL,0,'2019-11-29 22:14:05',NULL,7040,'0',7540,554,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:05',NULL,7041,'0',7542,555,16,NULL,'cmdb1-4-6-4'),(NULL,0,'2019-11-29 22:14:05',NULL,7042,'0',7543,555,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,7043,'0',7544,555,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:05',NULL,7044,'0',7545,555,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,7045,'0',7546,555,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,7046,'0',7547,555,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:05',NULL,7047,'0',7548,555,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,7048,'0',7549,555,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:05',NULL,7049,'0',7550,555,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,7050,'0',7551,555,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,7051,'0',7552,555,15,NULL,'10.4.6.4'),(NULL,0,'2019-11-29 22:14:05',NULL,7052,'0',7553,555,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,7053,'0',7554,555,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,7054,'0',7555,555,5,NULL,'abd45c279fb74b40a312d8189410e6b9'),(NULL,0,'2019-11-29 22:14:05',NULL,7055,'0',7556,555,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:05',NULL,7056,'0',7558,556,16,NULL,'cmdb1-4-6-5'),(NULL,0,'2019-11-29 22:14:05',NULL,7057,'0',7559,556,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,7058,'0',7560,556,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:05',NULL,7059,'0',7561,556,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,7060,'0',7562,556,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,7061,'0',7563,556,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:05',NULL,7062,'0',7564,556,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,7063,'0',7565,556,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:05',NULL,7064,'0',7566,556,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,7065,'0',7567,556,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,7066,'0',7568,556,15,NULL,'10.4.6.5'),(NULL,0,'2019-11-29 22:14:05',NULL,7067,'0',7569,556,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,7068,'0',7570,556,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,7069,'0',7571,556,5,NULL,'2d3442ca640c4bfea283d211819961fb'),(NULL,0,'2019-11-29 22:14:05',NULL,7070,'0',7572,556,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:05',NULL,7071,'0',7574,557,16,NULL,'cmdb1-4-6-6'),(NULL,0,'2019-11-29 22:14:05',NULL,7072,'0',7575,557,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,7073,'0',7576,557,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:05',NULL,7074,'0',7577,557,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,7075,'0',7578,557,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,7076,'0',7579,557,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:05',NULL,7077,'0',7580,557,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,7078,'0',7581,557,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:05',NULL,7079,'0',7582,557,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,7080,'0',7583,557,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,7081,'0',7584,557,15,NULL,'10.4.6.6'),(NULL,0,'2019-11-29 22:14:06',NULL,7082,'0',7585,557,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,7083,'0',7586,557,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,7084,'0',7587,557,5,NULL,'ee992be6b70a47a58009a599f8d99684'),(NULL,0,'2019-11-29 22:14:06',NULL,7085,'0',7588,557,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:06',NULL,7086,'0',7590,558,16,NULL,'cmdb1-4-6-7'),(NULL,0,'2019-11-29 22:14:06',NULL,7087,'0',7591,558,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,7088,'0',7592,558,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:06',NULL,7089,'0',7593,558,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,7090,'0',7594,558,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,7091,'0',7595,558,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:06',NULL,7092,'0',7596,558,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,7093,'0',7597,558,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:06',NULL,7094,'0',7598,558,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,7095,'0',7599,558,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,7096,'0',7600,558,15,NULL,'10.4.6.7'),(NULL,0,'2019-11-29 22:14:06',NULL,7097,'0',7601,558,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,7098,'0',7602,558,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,7099,'0',7603,558,5,NULL,'18131210436d4d779e90eaae5596d2f6'),(NULL,0,'2019-11-29 22:14:06',NULL,7100,'0',7604,558,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:06',NULL,7101,'0',7606,559,16,NULL,'cmdb1-4-6-8'),(NULL,0,'2019-11-29 22:14:06',NULL,7102,'0',7607,559,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,7103,'0',7608,559,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:06',NULL,7104,'0',7609,559,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,7105,'0',7610,559,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,7106,'0',7611,559,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:06',NULL,7107,'0',7612,559,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,7108,'0',7613,559,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:06',NULL,7109,'0',7614,559,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,7110,'0',7615,559,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,7111,'0',7616,559,15,NULL,'10.4.6.8'),(NULL,0,'2019-11-29 22:14:06',NULL,7112,'0',7617,559,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,7113,'0',7618,559,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,7114,'0',7619,559,5,NULL,'6e4776e443404433b7b95729af5fbb80'),(NULL,0,'2019-11-29 22:14:06',NULL,7115,'0',7620,559,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:06',NULL,7116,'0',7622,560,16,NULL,'cmdb1-4-6-9'),(NULL,0,'2019-11-29 22:14:06',NULL,7117,'0',7623,560,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,7118,'0',7624,560,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:06',NULL,7119,'0',7625,560,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,7120,'0',7626,560,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,7121,'0',7627,560,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:06',NULL,7122,'0',7628,560,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,7123,'0',7629,560,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:06',NULL,7124,'0',7630,560,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,7125,'0',7631,560,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,7126,'0',7632,560,15,NULL,'10.4.6.9'),(NULL,0,'2019-11-29 22:14:06',NULL,7127,'0',7633,560,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,7128,'0',7634,560,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,7129,'0',7635,560,5,NULL,'2d33b323023748dab82b5e4b2dac37d1'),(NULL,0,'2019-11-29 22:14:06',NULL,7130,'0',7636,560,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:06',NULL,7131,'0',7638,561,16,NULL,'cmdb1-4-6-10'),(NULL,0,'2019-11-29 22:14:06',NULL,7132,'0',7639,561,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,7133,'0',7640,561,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:06',NULL,7134,'0',7641,561,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,7135,'0',7642,561,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,7136,'0',7643,561,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:06',NULL,7137,'0',7644,561,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,7138,'0',7645,561,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:06',NULL,7139,'0',7646,561,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,7140,'0',7647,561,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,7141,'0',7648,561,15,NULL,'10.4.6.10'),(NULL,0,'2019-11-29 22:14:06',NULL,7142,'0',7649,561,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,7143,'0',7650,561,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,7144,'0',7651,561,5,NULL,'6f3b82fd90b0423890e855c08801efce'),(NULL,0,'2019-11-29 22:14:06',NULL,7145,'0',7652,561,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:07',NULL,7146,'0',7654,562,16,NULL,'cmdb1-4-6-11'),(NULL,0,'2019-11-29 22:14:07',NULL,7147,'0',7655,562,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,7148,'0',7656,562,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:07',NULL,7149,'0',7657,562,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,7150,'0',7658,562,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,7151,'0',7659,562,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:07',NULL,7152,'0',7660,562,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,7153,'0',7661,562,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:07',NULL,7154,'0',7662,562,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,7155,'0',7663,562,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,7156,'0',7664,562,15,NULL,'10.4.6.11'),(NULL,0,'2019-11-29 22:14:07',NULL,7157,'0',7665,562,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,7158,'0',7666,562,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,7159,'0',7667,562,5,NULL,'0db9fa42abfa4373803727038fa1b9fb'),(NULL,0,'2019-11-29 22:14:07',NULL,7160,'0',7668,562,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:07',NULL,7161,'0',7670,563,16,NULL,'cmdb1-4-6-12'),(NULL,0,'2019-11-29 22:14:07',NULL,7162,'0',7671,563,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,7163,'0',7672,563,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:07',NULL,7164,'0',7673,563,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,7165,'0',7674,563,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,7166,'0',7675,563,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:07',NULL,7167,'0',7676,563,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,7168,'0',7677,563,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:07',NULL,7169,'0',7678,563,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,7170,'0',7679,563,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,7171,'0',7680,563,15,NULL,'10.4.6.12'),(NULL,0,'2019-11-29 22:14:07',NULL,7172,'0',7681,563,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,7173,'0',7682,563,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,7174,'0',7683,563,5,NULL,'3dad434cdd634548b9cb77c2af8582c5'),(NULL,0,'2019-11-29 22:14:07',NULL,7175,'0',7684,563,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:07',NULL,7176,'0',7686,564,16,NULL,'cmdb1-4-6-13'),(NULL,0,'2019-11-29 22:14:07',NULL,7177,'0',7687,564,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,7178,'0',7688,564,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:07',NULL,7179,'0',7689,564,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,7180,'0',7690,564,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,7181,'0',7691,564,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:07',NULL,7182,'0',7692,564,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,7183,'0',7693,564,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:07',NULL,7184,'0',7694,564,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,7185,'0',7695,564,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,7186,'0',7696,564,15,NULL,'10.4.6.13'),(NULL,0,'2019-11-29 22:14:07',NULL,7187,'0',7697,564,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,7188,'0',7698,564,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,7189,'0',7699,564,5,NULL,'237add16ec084ea9bbee04bfdd499c5a'),(NULL,0,'2019-11-29 22:14:07',NULL,7190,'0',7700,564,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:07',NULL,7191,'0',7702,565,16,NULL,'cmdb1-4-6-14'),(NULL,0,'2019-11-29 22:14:07',NULL,7192,'0',7703,565,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,7193,'0',7704,565,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:07',NULL,7194,'0',7705,565,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,7195,'0',7706,565,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,7196,'0',7707,565,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:07',NULL,7197,'0',7708,565,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,7198,'0',7709,565,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:07',NULL,7199,'0',7710,565,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,7200,'0',7711,565,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,7201,'0',7712,565,15,NULL,'10.4.6.14'),(NULL,0,'2019-11-29 22:14:07',NULL,7202,'0',7713,565,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,7203,'0',7714,565,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,7204,'0',7715,565,5,NULL,'4e92a7ce3058451fa8770453d9166d7c'),(NULL,0,'2019-11-29 22:14:07',NULL,7205,'0',7716,565,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:07',NULL,7206,'0',7718,566,16,NULL,'cmdb1-4-6-15'),(NULL,0,'2019-11-29 22:14:08',NULL,7207,'0',7719,566,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,7208,'0',7720,566,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:08',NULL,7209,'0',7721,566,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,7210,'0',7722,566,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,7211,'0',7723,566,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:08',NULL,7212,'0',7724,566,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,7213,'0',7725,566,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:08',NULL,7214,'0',7726,566,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,7215,'0',7727,566,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,7216,'0',7728,566,15,NULL,'10.4.6.15'),(NULL,0,'2019-11-29 22:14:08',NULL,7217,'0',7729,566,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,7218,'0',7730,566,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,7219,'0',7731,566,5,NULL,'89b41fb8f6de439a8b90153f8278f5ef'),(NULL,0,'2019-11-29 22:14:08',NULL,7220,'0',7732,566,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:08',NULL,7221,'0',7734,567,16,NULL,'cmdb1-4-6-16'),(NULL,0,'2019-11-29 22:14:08',NULL,7222,'0',7735,567,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,7223,'0',7736,567,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:08',NULL,7224,'0',7737,567,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,7225,'0',7738,567,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,7226,'0',7739,567,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:08',NULL,7227,'0',7740,567,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,7228,'0',7741,567,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:08',NULL,7229,'0',7742,567,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,7230,'0',7743,567,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,7231,'0',7744,567,15,NULL,'10.4.6.16'),(NULL,0,'2019-11-29 22:14:08',NULL,7232,'0',7745,567,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,7233,'0',7746,567,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,7234,'0',7747,567,5,NULL,'4957a679fe23419dbeefa52035718f74'),(NULL,0,'2019-11-29 22:14:08',NULL,7235,'0',7748,567,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:08',NULL,7236,'0',7750,568,4,NULL,'App1-4-7'),(NULL,0,'2019-11-29 22:14:08',NULL,7237,'0',7752,569,16,NULL,'cmdb1-4-7-1'),(NULL,0,'2019-11-29 22:14:08',NULL,7238,'0',7753,569,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,7239,'0',7754,569,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:08',NULL,7240,'0',7755,569,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,7241,'0',7756,569,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,7242,'0',7757,569,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:08',NULL,7243,'0',7758,569,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,7244,'0',7759,569,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:08',NULL,7245,'0',7760,569,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,7246,'0',7761,569,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,7247,'0',7762,569,15,NULL,'10.4.7.1'),(NULL,0,'2019-11-29 22:14:08',NULL,7248,'0',7763,569,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,7249,'0',7764,569,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,7250,'0',7765,569,5,NULL,'e03ac4739b5541ff94433533688aba9a'),(NULL,0,'2019-11-29 22:14:08',NULL,7251,'0',7766,569,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:08',NULL,7252,'0',7768,570,16,NULL,'cmdb1-4-7-2'),(NULL,0,'2019-11-29 22:14:08',NULL,7253,'0',7769,570,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,7254,'0',7770,570,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:08',NULL,7255,'0',7771,570,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,7256,'0',7772,570,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,7257,'0',7773,570,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:08',NULL,7258,'0',7774,570,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,7259,'0',7775,570,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:08',NULL,7260,'0',7776,570,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,7261,'0',7777,570,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,7262,'0',7778,570,15,NULL,'10.4.7.2'),(NULL,0,'2019-11-29 22:14:08',NULL,7263,'0',7779,570,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,7264,'0',7780,570,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,7265,'0',7781,570,5,NULL,'57f6b209181f4ab6bc3f0e97bfa2d163'),(NULL,0,'2019-11-29 22:14:08',NULL,7266,'0',7782,570,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:08',NULL,7267,'0',7784,571,16,NULL,'cmdb1-4-7-3'),(NULL,0,'2019-11-29 22:14:08',NULL,7268,'0',7785,571,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,7269,'0',7786,571,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:09',NULL,7270,'0',7787,571,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,7271,'0',7788,571,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,7272,'0',7789,571,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:09',NULL,7273,'0',7790,571,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,7274,'0',7791,571,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:09',NULL,7275,'0',7792,571,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,7276,'0',7793,571,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,7277,'0',7794,571,15,NULL,'10.4.7.3'),(NULL,0,'2019-11-29 22:14:09',NULL,7278,'0',7795,571,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,7279,'0',7796,571,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,7280,'0',7797,571,5,NULL,'e7f331aee8314e30becfc78c242306ec'),(NULL,0,'2019-11-29 22:14:09',NULL,7281,'0',7798,571,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:09',NULL,7282,'0',7800,572,16,NULL,'cmdb1-4-7-4'),(NULL,0,'2019-11-29 22:14:09',NULL,7283,'0',7801,572,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,7284,'0',7802,572,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:09',NULL,7285,'0',7803,572,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,7286,'0',7804,572,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,7287,'0',7805,572,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:09',NULL,7288,'0',7806,572,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,7289,'0',7807,572,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:09',NULL,7290,'0',7808,572,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,7291,'0',7809,572,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,7292,'0',7810,572,15,NULL,'10.4.7.4'),(NULL,0,'2019-11-29 22:14:09',NULL,7293,'0',7811,572,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,7294,'0',7812,572,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,7295,'0',7813,572,5,NULL,'50580cc807054ab98b463f6458cf16d5'),(NULL,0,'2019-11-29 22:14:09',NULL,7296,'0',7814,572,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:09',NULL,7297,'0',7816,573,16,NULL,'cmdb1-4-7-5'),(NULL,0,'2019-11-29 22:14:09',NULL,7298,'0',7817,573,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,7299,'0',7818,573,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:09',NULL,7300,'0',7819,573,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,7301,'0',7820,573,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,7302,'0',7821,573,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:09',NULL,7303,'0',7822,573,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,7304,'0',7823,573,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:09',NULL,7305,'0',7824,573,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,7306,'0',7825,573,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,7307,'0',7826,573,15,NULL,'10.4.7.5'),(NULL,0,'2019-11-29 22:14:09',NULL,7308,'0',7827,573,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,7309,'0',7828,573,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,7310,'0',7829,573,5,NULL,'002d003cb0544f5a96be5f2e84a036d4'),(NULL,0,'2019-11-29 22:14:09',NULL,7311,'0',7830,573,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:09',NULL,7312,'0',7832,574,16,NULL,'cmdb1-4-7-6'),(NULL,0,'2019-11-29 22:14:09',NULL,7313,'0',7833,574,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,7314,'0',7834,574,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:09',NULL,7315,'0',7835,574,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,7316,'0',7836,574,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,7317,'0',7837,574,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:09',NULL,7318,'0',7838,574,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,7319,'0',7839,574,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:09',NULL,7320,'0',7840,574,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,7321,'0',7841,574,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,7322,'0',7842,574,15,NULL,'10.4.7.6'),(NULL,0,'2019-11-29 22:14:09',NULL,7323,'0',7843,574,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,7324,'0',7844,574,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,7325,'0',7845,574,5,NULL,'fc68f9746def4e39b94ba4a8489f6e41'),(NULL,0,'2019-11-29 22:14:09',NULL,7326,'0',7846,574,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:09',NULL,7327,'0',7848,575,16,NULL,'cmdb1-4-7-7'),(NULL,0,'2019-11-29 22:14:09',NULL,7328,'0',7849,575,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,7329,'0',7850,575,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:09',NULL,7330,'0',7851,575,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,7331,'0',7852,575,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,7332,'0',7853,575,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:09',NULL,7333,'0',7854,575,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,7334,'0',7855,575,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:09',NULL,7335,'0',7856,575,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,7336,'0',7857,575,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,7337,'0',7858,575,15,NULL,'10.4.7.7'),(NULL,0,'2019-11-29 22:14:10',NULL,7338,'0',7859,575,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,7339,'0',7860,575,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,7340,'0',7861,575,5,NULL,'e8f8a779f27048189f0a299b0b43f0c8'),(NULL,0,'2019-11-29 22:14:10',NULL,7341,'0',7862,575,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:10',NULL,7342,'0',7864,576,16,NULL,'cmdb1-4-7-8'),(NULL,0,'2019-11-29 22:14:10',NULL,7343,'0',7865,576,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,7344,'0',7866,576,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:10',NULL,7345,'0',7867,576,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,7346,'0',7868,576,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,7347,'0',7869,576,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:10',NULL,7348,'0',7870,576,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,7349,'0',7871,576,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:10',NULL,7350,'0',7872,576,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,7351,'0',7873,576,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,7352,'0',7874,576,15,NULL,'10.4.7.8'),(NULL,0,'2019-11-29 22:14:10',NULL,7353,'0',7875,576,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,7354,'0',7876,576,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,7355,'0',7877,576,5,NULL,'65b2f0416e79483e8320b3415de8f091'),(NULL,0,'2019-11-29 22:14:10',NULL,7356,'0',7878,576,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:10',NULL,7357,'0',7880,577,16,NULL,'cmdb1-4-7-9'),(NULL,0,'2019-11-29 22:14:10',NULL,7358,'0',7881,577,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,7359,'0',7882,577,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:10',NULL,7360,'0',7883,577,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,7361,'0',7884,577,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,7362,'0',7885,577,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:10',NULL,7363,'0',7886,577,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,7364,'0',7887,577,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:10',NULL,7365,'0',7888,577,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,7366,'0',7889,577,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,7367,'0',7890,577,15,NULL,'10.4.7.9'),(NULL,0,'2019-11-29 22:14:10',NULL,7368,'0',7891,577,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,7369,'0',7892,577,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,7370,'0',7893,577,5,NULL,'8c357f99ee74488da78465cb9e9018ea'),(NULL,0,'2019-11-29 22:14:10',NULL,7371,'0',7894,577,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:10',NULL,7372,'0',7896,578,16,NULL,'cmdb1-4-7-10'),(NULL,0,'2019-11-29 22:14:10',NULL,7373,'0',7897,578,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,7374,'0',7898,578,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:10',NULL,7375,'0',7899,578,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,7376,'0',7900,578,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,7377,'0',7901,578,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:10',NULL,7378,'0',7902,578,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,7379,'0',7903,578,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:10',NULL,7380,'0',7904,578,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,7381,'0',7905,578,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,7382,'0',7906,578,15,NULL,'10.4.7.10'),(NULL,0,'2019-11-29 22:14:10',NULL,7383,'0',7907,578,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,7384,'0',7908,578,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,7385,'0',7909,578,5,NULL,'604678a98b0945999d1c6d5193baddb1'),(NULL,0,'2019-11-29 22:14:10',NULL,7386,'0',7910,578,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:10',NULL,7387,'0',7912,579,16,NULL,'cmdb1-4-7-11'),(NULL,0,'2019-11-29 22:14:10',NULL,7388,'0',7913,579,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,7389,'0',7914,579,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:10',NULL,7390,'0',7915,579,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,7391,'0',7916,579,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,7392,'0',7917,579,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:10',NULL,7393,'0',7918,579,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,7394,'0',7919,579,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:10',NULL,7395,'0',7920,579,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,7396,'0',7921,579,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,7397,'0',7922,579,15,NULL,'10.4.7.11'),(NULL,0,'2019-11-29 22:14:10',NULL,7398,'0',7923,579,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,7399,'0',7924,579,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,7400,'0',7925,579,5,NULL,'09e5ee08c8af42bbb923abc9afe46a2c'),(NULL,0,'2019-11-29 22:14:10',NULL,7401,'0',7926,579,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:11',NULL,7402,'0',7928,580,16,NULL,'cmdb1-4-7-12'),(NULL,0,'2019-11-29 22:14:11',NULL,7403,'0',7929,580,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,7404,'0',7930,580,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:11',NULL,7405,'0',7931,580,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,7406,'0',7932,580,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,7407,'0',7933,580,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:11',NULL,7408,'0',7934,580,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,7409,'0',7935,580,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:11',NULL,7410,'0',7936,580,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,7411,'0',7937,580,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,7412,'0',7938,580,15,NULL,'10.4.7.12'),(NULL,0,'2019-11-29 22:14:11',NULL,7413,'0',7939,580,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,7414,'0',7940,580,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,7415,'0',7941,580,5,NULL,'fa36b2f8b0764c109af884ee38284ae4'),(NULL,0,'2019-11-29 22:14:11',NULL,7416,'0',7942,580,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:11',NULL,7417,'0',7944,581,16,NULL,'cmdb1-4-7-13'),(NULL,0,'2019-11-29 22:14:11',NULL,7418,'0',7945,581,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,7419,'0',7946,581,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:11',NULL,7420,'0',7947,581,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,7421,'0',7948,581,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,7422,'0',7949,581,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:11',NULL,7423,'0',7950,581,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,7424,'0',7951,581,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:11',NULL,7425,'0',7952,581,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,7426,'0',7953,581,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,7427,'0',7954,581,15,NULL,'10.4.7.13'),(NULL,0,'2019-11-29 22:14:11',NULL,7428,'0',7955,581,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,7429,'0',7956,581,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,7430,'0',7957,581,5,NULL,'52c8e20009234c84956a5f59ca09ec87'),(NULL,0,'2019-11-29 22:14:11',NULL,7431,'0',7958,581,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:11',NULL,7432,'0',7960,582,16,NULL,'cmdb1-4-7-14'),(NULL,0,'2019-11-29 22:14:11',NULL,7433,'0',7961,582,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,7434,'0',7962,582,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:11',NULL,7435,'0',7963,582,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,7436,'0',7964,582,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,7437,'0',7965,582,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:11',NULL,7438,'0',7966,582,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,7439,'0',7967,582,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:11',NULL,7440,'0',7968,582,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,7441,'0',7969,582,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,7442,'0',7970,582,15,NULL,'10.4.7.14'),(NULL,0,'2019-11-29 22:14:11',NULL,7443,'0',7971,582,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,7444,'0',7972,582,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,7445,'0',7973,582,5,NULL,'74af0ebc45cf41d5b9cae14b9718ed5f'),(NULL,0,'2019-11-29 22:14:11',NULL,7446,'0',7974,582,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:11',NULL,7447,'0',7976,583,16,NULL,'cmdb1-4-7-15'),(NULL,0,'2019-11-29 22:14:11',NULL,7448,'0',7977,583,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,7449,'0',7978,583,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:11',NULL,7450,'0',7979,583,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,7451,'0',7980,583,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,7452,'0',7981,583,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:11',NULL,7453,'0',7982,583,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,7454,'0',7983,583,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:11',NULL,7455,'0',7984,583,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,7456,'0',7985,583,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,7457,'0',7986,583,15,NULL,'10.4.7.15'),(NULL,0,'2019-11-29 22:14:11',NULL,7458,'0',7987,583,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,7459,'0',7988,583,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,7460,'0',7989,583,5,NULL,'35e0212e4d0b49719f4854288cf42e65'),(NULL,0,'2019-11-29 22:14:11',NULL,7461,'0',7990,583,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:11',NULL,7462,'0',7992,584,16,NULL,'cmdb1-4-7-16'),(NULL,0,'2019-11-29 22:14:11',NULL,7463,'0',7993,584,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,7464,'0',7994,584,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:12',NULL,7465,'0',7995,584,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,7466,'0',7996,584,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,7467,'0',7997,584,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:12',NULL,7468,'0',7998,584,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,7469,'0',7999,584,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:12',NULL,7470,'0',8000,584,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,7471,'0',8001,584,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,7472,'0',8002,584,15,NULL,'10.4.7.16'),(NULL,0,'2019-11-29 22:14:12',NULL,7473,'0',8003,584,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,7474,'0',8004,584,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,7475,'0',8005,584,5,NULL,'ba018b916df54a6da353df679322abc0'),(NULL,0,'2019-11-29 22:14:12',NULL,7476,'0',8006,584,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:12',NULL,7477,'0',8008,585,4,NULL,'App1-4-8'),(NULL,0,'2019-11-29 22:14:12',NULL,7478,'0',8010,586,16,NULL,'cmdb1-4-8-1'),(NULL,0,'2019-11-29 22:14:12',NULL,7479,'0',8011,586,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,7480,'0',8012,586,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:12',NULL,7481,'0',8013,586,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,7482,'0',8014,586,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,7483,'0',8015,586,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:12',NULL,7484,'0',8016,586,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,7485,'0',8017,586,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:12',NULL,7486,'0',8018,586,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,7487,'0',8019,586,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,7488,'0',8020,586,15,NULL,'10.4.8.1'),(NULL,0,'2019-11-29 22:14:12',NULL,7489,'0',8021,586,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,7490,'0',8022,586,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,7491,'0',8023,586,5,NULL,'8b04dfff1c6348c1a94dffd07c6e1f9c'),(NULL,0,'2019-11-29 22:14:12',NULL,7492,'0',8024,586,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:12',NULL,7493,'0',8026,587,16,NULL,'cmdb1-4-8-2'),(NULL,0,'2019-11-29 22:14:12',NULL,7494,'0',8027,587,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,7495,'0',8028,587,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:12',NULL,7496,'0',8029,587,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,7497,'0',8030,587,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,7498,'0',8031,587,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:12',NULL,7499,'0',8032,587,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,7500,'0',8033,587,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:12',NULL,7501,'0',8034,587,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,7502,'0',8035,587,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,7503,'0',8036,587,15,NULL,'10.4.8.2'),(NULL,0,'2019-11-29 22:14:12',NULL,7504,'0',8037,587,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,7505,'0',8038,587,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,7506,'0',8039,587,5,NULL,'8a139eb2fc2f4cfdad631b8fac14e671'),(NULL,0,'2019-11-29 22:14:12',NULL,7507,'0',8040,587,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:12',NULL,7508,'0',8042,588,16,NULL,'cmdb1-4-8-3'),(NULL,0,'2019-11-29 22:14:12',NULL,7509,'0',8043,588,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,7510,'0',8044,588,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:12',NULL,7511,'0',8045,588,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,7512,'0',8046,588,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,7513,'0',8047,588,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:12',NULL,7514,'0',8048,588,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,7515,'0',8049,588,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:12',NULL,7516,'0',8050,588,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,7517,'0',8051,588,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,7518,'0',8052,588,15,NULL,'10.4.8.3'),(NULL,0,'2019-11-29 22:14:12',NULL,7519,'0',8053,588,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,7520,'0',8054,588,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,7521,'0',8055,588,5,NULL,'997b3ab39bf24fc5acf90e55033e573a'),(NULL,0,'2019-11-29 22:14:12',NULL,7522,'0',8056,588,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:12',NULL,7523,'0',8058,589,16,NULL,'cmdb1-4-8-4'),(NULL,0,'2019-11-29 22:14:12',NULL,7524,'0',8059,589,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,7525,'0',8060,589,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:12',NULL,7526,'0',8061,589,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,7527,'0',8062,589,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,7528,'0',8063,589,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:13',NULL,7529,'0',8064,589,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,7530,'0',8065,589,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:13',NULL,7531,'0',8066,589,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,7532,'0',8067,589,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,7533,'0',8068,589,15,NULL,'10.4.8.4'),(NULL,0,'2019-11-29 22:14:13',NULL,7534,'0',8069,589,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,7535,'0',8070,589,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,7536,'0',8071,589,5,NULL,'330acde820fa47abbbcebb3a91fd1b3e'),(NULL,0,'2019-11-29 22:14:13',NULL,7537,'0',8072,589,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:13',NULL,7538,'0',8074,590,16,NULL,'cmdb1-4-8-5'),(NULL,0,'2019-11-29 22:14:13',NULL,7539,'0',8075,590,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,7540,'0',8076,590,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:13',NULL,7541,'0',8077,590,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,7542,'0',8078,590,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,7543,'0',8079,590,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:13',NULL,7544,'0',8080,590,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,7545,'0',8081,590,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:13',NULL,7546,'0',8082,590,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,7547,'0',8083,590,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,7548,'0',8084,590,15,NULL,'10.4.8.5'),(NULL,0,'2019-11-29 22:14:13',NULL,7549,'0',8085,590,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,7550,'0',8086,590,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,7551,'0',8087,590,5,NULL,'2426982b469c40c7aef748894f134f64'),(NULL,0,'2019-11-29 22:14:13',NULL,7552,'0',8088,590,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:13',NULL,7553,'0',8090,591,16,NULL,'cmdb1-4-8-6'),(NULL,0,'2019-11-29 22:14:13',NULL,7554,'0',8091,591,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,7555,'0',8092,591,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:13',NULL,7556,'0',8093,591,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,7557,'0',8094,591,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,7558,'0',8095,591,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:13',NULL,7559,'0',8096,591,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,7560,'0',8097,591,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:13',NULL,7561,'0',8098,591,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,7562,'0',8099,591,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,7563,'0',8100,591,15,NULL,'10.4.8.6'),(NULL,0,'2019-11-29 22:14:13',NULL,7564,'0',8101,591,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,7565,'0',8102,591,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,7566,'0',8103,591,5,NULL,'3bf02860dfec4cb99f3bc355e7c6a1b3'),(NULL,0,'2019-11-29 22:14:13',NULL,7567,'0',8104,591,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:13',NULL,7568,'0',8106,592,16,NULL,'cmdb1-4-8-7'),(NULL,0,'2019-11-29 22:14:13',NULL,7569,'0',8107,592,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,7570,'0',8108,592,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:13',NULL,7571,'0',8109,592,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,7572,'0',8110,592,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,7573,'0',8111,592,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:13',NULL,7574,'0',8112,592,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,7575,'0',8113,592,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:13',NULL,7576,'0',8114,592,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,7577,'0',8115,592,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,7578,'0',8116,592,15,NULL,'10.4.8.7'),(NULL,0,'2019-11-29 22:14:13',NULL,7579,'0',8117,592,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,7580,'0',8118,592,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,7581,'0',8119,592,5,NULL,'367b27dc515e46afb17b1df7fbb9f01a'),(NULL,0,'2019-11-29 22:14:13',NULL,7582,'0',8120,592,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:13',NULL,7583,'0',8122,593,16,NULL,'cmdb1-4-8-8'),(NULL,0,'2019-11-29 22:14:13',NULL,7584,'0',8123,593,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,7585,'0',8124,593,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:13',NULL,7586,'0',8125,593,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,7587,'0',8126,593,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,7588,'0',8127,593,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:13',NULL,7589,'0',8128,593,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,7590,'0',8129,593,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:13',NULL,7591,'0',8130,593,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,7592,'0',8131,593,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,7593,'0',8132,593,15,NULL,'10.4.8.8'),(NULL,0,'2019-11-29 22:14:14',NULL,7594,'0',8133,593,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,7595,'0',8134,593,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,7596,'0',8135,593,5,NULL,'baa02f8a050448578407692dbd5c9dca'),(NULL,0,'2019-11-29 22:14:14',NULL,7597,'0',8136,593,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:14',NULL,7598,'0',8138,594,16,NULL,'cmdb1-4-8-9'),(NULL,0,'2019-11-29 22:14:14',NULL,7599,'0',8139,594,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,7600,'0',8140,594,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:14',NULL,7601,'0',8141,594,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,7602,'0',8142,594,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,7603,'0',8143,594,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:14',NULL,7604,'0',8144,594,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,7605,'0',8145,594,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:14',NULL,7606,'0',8146,594,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,7607,'0',8147,594,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,7608,'0',8148,594,15,NULL,'10.4.8.9'),(NULL,0,'2019-11-29 22:14:14',NULL,7609,'0',8149,594,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,7610,'0',8150,594,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,7611,'0',8151,594,5,NULL,'90d39fe8f11e4ad0b47db79b68bfb9ca'),(NULL,0,'2019-11-29 22:14:14',NULL,7612,'0',8152,594,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:14',NULL,7613,'0',8154,595,16,NULL,'cmdb1-4-8-10'),(NULL,0,'2019-11-29 22:14:14',NULL,7614,'0',8155,595,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,7615,'0',8156,595,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:14',NULL,7616,'0',8157,595,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,7617,'0',8158,595,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,7618,'0',8159,595,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:14',NULL,7619,'0',8160,595,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,7620,'0',8161,595,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:14',NULL,7621,'0',8162,595,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,7622,'0',8163,595,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,7623,'0',8164,595,15,NULL,'10.4.8.10'),(NULL,0,'2019-11-29 22:14:14',NULL,7624,'0',8165,595,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,7625,'0',8166,595,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,7626,'0',8167,595,5,NULL,'d74fe8d2571a43f99f0a8f9a2f6b3512'),(NULL,0,'2019-11-29 22:14:14',NULL,7627,'0',8168,595,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:14',NULL,7628,'0',8170,596,16,NULL,'cmdb1-4-8-11'),(NULL,0,'2019-11-29 22:14:14',NULL,7629,'0',8171,596,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,7630,'0',8172,596,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:14',NULL,7631,'0',8173,596,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,7632,'0',8174,596,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,7633,'0',8175,596,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:14',NULL,7634,'0',8176,596,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,7635,'0',8177,596,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:14',NULL,7636,'0',8178,596,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,7637,'0',8179,596,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,7638,'0',8180,596,15,NULL,'10.4.8.11'),(NULL,0,'2019-11-29 22:14:14',NULL,7639,'0',8181,596,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,7640,'0',8182,596,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,7641,'0',8183,596,5,NULL,'a4d0d22c9ce84cf2ae63286aed7373be'),(NULL,0,'2019-11-29 22:14:14',NULL,7642,'0',8184,596,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:14',NULL,7643,'0',8186,597,16,NULL,'cmdb1-4-8-12'),(NULL,0,'2019-11-29 22:14:14',NULL,7644,'0',8187,597,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,7645,'0',8188,597,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:14',NULL,7646,'0',8189,597,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,7647,'0',8190,597,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,7648,'0',8191,597,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:14',NULL,7649,'0',8192,597,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,7650,'0',8193,597,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:14',NULL,7651,'0',8194,597,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,7652,'0',8195,597,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,7653,'0',8196,597,15,NULL,'10.4.8.12'),(NULL,0,'2019-11-29 22:14:14',NULL,7654,'0',8197,597,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,7655,'0',8198,597,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,7656,'0',8199,597,5,NULL,'a121b090b249441388a0725781df34c5'),(NULL,0,'2019-11-29 22:14:14',NULL,7657,'0',8200,597,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:15',NULL,7658,'0',8202,598,16,NULL,'cmdb1-4-8-13'),(NULL,0,'2019-11-29 22:14:15',NULL,7659,'0',8203,598,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,7660,'0',8204,598,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:15',NULL,7661,'0',8205,598,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,7662,'0',8206,598,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,7663,'0',8207,598,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:15',NULL,7664,'0',8208,598,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,7665,'0',8209,598,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:15',NULL,7666,'0',8210,598,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,7667,'0',8211,598,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,7668,'0',8212,598,15,NULL,'10.4.8.13'),(NULL,0,'2019-11-29 22:14:15',NULL,7669,'0',8213,598,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,7670,'0',8214,598,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,7671,'0',8215,598,5,NULL,'f1939d7704824e47ac0d4a06ec6f9ec9'),(NULL,0,'2019-11-29 22:14:15',NULL,7672,'0',8216,598,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:15',NULL,7673,'0',8218,599,16,NULL,'cmdb1-4-8-14'),(NULL,0,'2019-11-29 22:14:15',NULL,7674,'0',8219,599,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,7675,'0',8220,599,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:15',NULL,7676,'0',8221,599,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,7677,'0',8222,599,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,7678,'0',8223,599,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:15',NULL,7679,'0',8224,599,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,7680,'0',8225,599,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:15',NULL,7681,'0',8226,599,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,7682,'0',8227,599,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,7683,'0',8228,599,15,NULL,'10.4.8.14'),(NULL,0,'2019-11-29 22:14:15',NULL,7684,'0',8229,599,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,7685,'0',8230,599,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,7686,'0',8231,599,5,NULL,'d1e2330817584df6bc7f2156405b01d5'),(NULL,0,'2019-11-29 22:14:15',NULL,7687,'0',8232,599,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:15',NULL,7688,'0',8234,600,16,NULL,'cmdb1-4-8-15'),(NULL,0,'2019-11-29 22:14:15',NULL,7689,'0',8235,600,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,7690,'0',8236,600,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:15',NULL,7691,'0',8237,600,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,7692,'0',8238,600,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,7693,'0',8239,600,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:15',NULL,7694,'0',8240,600,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,7695,'0',8241,600,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:15',NULL,7696,'0',8242,600,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,7697,'0',8243,600,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,7698,'0',8244,600,15,NULL,'10.4.8.15'),(NULL,0,'2019-11-29 22:14:15',NULL,7699,'0',8245,600,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,7700,'0',8246,600,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,7701,'0',8247,600,5,NULL,'cde414de3e97466599fd309d2a19ca69'),(NULL,0,'2019-11-29 22:14:15',NULL,7702,'0',8248,600,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:15',NULL,7703,'0',8250,601,16,NULL,'cmdb1-4-8-16'),(NULL,0,'2019-11-29 22:14:15',NULL,7704,'0',8251,601,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,7705,'0',8252,601,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:15',NULL,7706,'0',8253,601,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,7707,'0',8254,601,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,7708,'0',8255,601,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:15',NULL,7709,'0',8256,601,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,7710,'0',8257,601,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:15',NULL,7711,'0',8258,601,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,7712,'0',8259,601,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,7713,'0',8260,601,15,NULL,'10.4.8.16'),(NULL,0,'2019-11-29 22:14:15',NULL,7714,'0',8261,601,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,7715,'0',8262,601,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,7716,'0',8263,601,5,NULL,'3645b5fda28e499d9d8bf19397682263'),(NULL,0,'2019-11-29 22:14:15',NULL,7717,'0',8264,601,17,NULL,'在线'),(NULL,0,'2019-11-29 22:14:16',NULL,7718,'0',8266,602,1,NULL,'XXXXXX事业部2'),(NULL,0,'2019-11-29 22:14:16',NULL,7719,'0',8267,603,3,NULL,'产品线2-1'),(NULL,0,'2019-11-29 22:14:16',NULL,7720,'0',8269,604,4,NULL,'App2-1-1'),(NULL,0,'2019-11-29 22:14:16',NULL,7721,'0',8271,605,16,NULL,'cmdb2-1-1-1'),(NULL,0,'2019-11-29 22:14:16',NULL,7722,'0',8272,605,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:16',NULL,7723,'0',8273,605,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:16',NULL,7724,'0',8274,605,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:16',NULL,7725,'0',8275,605,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:16',NULL,7726,'0',8276,605,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:16',NULL,7727,'0',8277,605,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:16',NULL,7728,'0',8278,605,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:16',NULL,7729,'0',8279,605,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:16',NULL,7730,'0',8280,605,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:16',NULL,7731,'1',8281,605,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,7732,'0',8282,606,16,NULL,'cmdb2-1-1-2'),(NULL,0,'2019-11-29 22:14:16',NULL,7733,'0',8283,606,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:16',NULL,7734,'0',8284,606,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:16',NULL,7735,'0',8285,606,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:16',NULL,7736,'0',8286,606,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:16',NULL,7737,'0',8287,606,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:16',NULL,7738,'0',8288,606,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:16',NULL,7739,'0',8289,606,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:16',NULL,7740,'0',8290,606,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:16',NULL,7741,'0',8291,606,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:16',NULL,7742,'1',8292,606,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,7743,'0',8293,607,16,NULL,'cmdb2-1-1-3'),(NULL,0,'2019-11-29 22:14:16',NULL,7744,'0',8294,607,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:16',NULL,7745,'0',8295,607,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:16',NULL,7746,'0',8296,607,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:16',NULL,7747,'0',8297,607,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:16',NULL,7748,'0',8298,607,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:16',NULL,7749,'0',8299,607,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:16',NULL,7750,'0',8300,607,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:16',NULL,7751,'0',8301,607,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:16',NULL,7752,'0',8302,607,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:16',NULL,7753,'1',8303,607,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,7754,'0',8304,608,16,NULL,'cmdb2-1-1-4'),(NULL,0,'2019-11-29 22:14:16',NULL,7755,'0',8305,608,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:16',NULL,7756,'0',8306,608,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:16',NULL,7757,'0',8307,608,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:16',NULL,7758,'0',8308,608,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:16',NULL,7759,'0',8309,608,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:16',NULL,7760,'0',8310,608,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:17',NULL,7761,'0',8311,608,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:17',NULL,7762,'0',8312,608,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:17',NULL,7763,'0',8313,608,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:17',NULL,7764,'1',8314,608,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,7765,'0',8315,609,16,NULL,'cmdb2-1-1-5'),(NULL,0,'2019-11-29 22:14:17',NULL,7766,'0',8316,609,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:17',NULL,7767,'0',8317,609,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:17',NULL,7768,'0',8318,609,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:17',NULL,7769,'0',8319,609,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:17',NULL,7770,'0',8320,609,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:17',NULL,7771,'0',8321,609,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:17',NULL,7772,'0',8322,609,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:17',NULL,7773,'0',8323,609,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:17',NULL,7774,'0',8324,609,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:17',NULL,7775,'1',8325,609,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,7776,'0',8326,610,16,NULL,'cmdb2-1-1-6'),(NULL,0,'2019-11-29 22:14:17',NULL,7777,'0',8327,610,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:17',NULL,7778,'0',8328,610,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:17',NULL,7779,'0',8329,610,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:17',NULL,7780,'0',8330,610,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:17',NULL,7781,'0',8331,610,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:17',NULL,7782,'0',8332,610,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:17',NULL,7783,'0',8333,610,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:17',NULL,7784,'0',8334,610,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:17',NULL,7785,'0',8335,610,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:17',NULL,7786,'1',8336,610,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,7787,'0',8337,611,16,NULL,'cmdb2-1-1-7'),(NULL,0,'2019-11-29 22:14:17',NULL,7788,'0',8338,611,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:17',NULL,7789,'0',8339,611,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:17',NULL,7790,'0',8340,611,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:17',NULL,7791,'0',8341,611,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:17',NULL,7792,'0',8342,611,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:17',NULL,7793,'0',8343,611,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:17',NULL,7794,'0',8344,611,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:17',NULL,7795,'0',8345,611,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:17',NULL,7796,'0',8346,611,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:17',NULL,7797,'1',8347,611,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,7798,'0',8348,612,16,NULL,'cmdb2-1-1-8'),(NULL,0,'2019-11-29 22:14:17',NULL,7799,'0',8349,612,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:17',NULL,7800,'0',8350,612,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:17',NULL,7801,'0',8351,612,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:17',NULL,7802,'0',8352,612,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:17',NULL,7803,'0',8353,612,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:17',NULL,7804,'0',8354,612,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:17',NULL,7805,'0',8355,612,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:17',NULL,7806,'0',8356,612,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:18',NULL,7807,'0',8357,612,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:18',NULL,7808,'1',8358,612,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,7809,'0',8359,613,16,NULL,'cmdb2-1-1-9'),(NULL,0,'2019-11-29 22:14:18',NULL,7810,'0',8360,613,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:18',NULL,7811,'0',8361,613,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:18',NULL,7812,'0',8362,613,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:18',NULL,7813,'0',8363,613,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:18',NULL,7814,'0',8364,613,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:18',NULL,7815,'0',8365,613,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:18',NULL,7816,'0',8366,613,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:18',NULL,7817,'0',8367,613,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:18',NULL,7818,'0',8368,613,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:18',NULL,7819,'1',8369,613,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,7820,'0',8370,614,16,NULL,'cmdb2-1-1-10'),(NULL,0,'2019-11-29 22:14:18',NULL,7821,'0',8371,614,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:18',NULL,7822,'0',8372,614,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:18',NULL,7823,'0',8373,614,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:18',NULL,7824,'0',8374,614,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:18',NULL,7825,'0',8375,614,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:18',NULL,7826,'0',8376,614,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:18',NULL,7827,'0',8377,614,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:18',NULL,7828,'0',8378,614,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:18',NULL,7829,'0',8379,614,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:18',NULL,7830,'1',8380,614,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,7831,'0',8381,615,16,NULL,'cmdb2-1-1-11'),(NULL,0,'2019-11-29 22:14:18',NULL,7832,'0',8382,615,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:18',NULL,7833,'0',8383,615,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:18',NULL,7834,'0',8384,615,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:18',NULL,7835,'0',8385,615,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:18',NULL,7836,'0',8386,615,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:18',NULL,7837,'0',8387,615,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:18',NULL,7838,'0',8388,615,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:18',NULL,7839,'0',8389,615,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:18',NULL,7840,'0',8390,615,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:18',NULL,7841,'1',8391,615,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,7842,'0',8392,616,16,NULL,'cmdb2-1-1-12'),(NULL,0,'2019-11-29 22:14:18',NULL,7843,'0',8393,616,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:18',NULL,7844,'0',8394,616,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:18',NULL,7845,'0',8395,616,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:18',NULL,7846,'0',8396,616,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:18',NULL,7847,'0',8397,616,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:18',NULL,7848,'0',8398,616,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:18',NULL,7849,'0',8399,616,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:18',NULL,7850,'0',8400,616,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:18',NULL,7851,'0',8401,616,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:19',NULL,7852,'1',8402,616,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,7853,'0',8403,617,16,NULL,'cmdb2-1-1-13'),(NULL,0,'2019-11-29 22:14:19',NULL,7854,'0',8404,617,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:19',NULL,7855,'0',8405,617,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:19',NULL,7856,'0',8406,617,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:19',NULL,7857,'0',8407,617,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:19',NULL,7858,'0',8408,617,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:19',NULL,7859,'0',8409,617,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:19',NULL,7860,'0',8410,617,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:19',NULL,7861,'0',8411,617,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:19',NULL,7862,'0',8412,617,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:19',NULL,7863,'1',8413,617,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,7864,'0',8414,618,16,NULL,'cmdb2-1-1-14'),(NULL,0,'2019-11-29 22:14:19',NULL,7865,'0',8415,618,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:19',NULL,7866,'0',8416,618,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:19',NULL,7867,'0',8417,618,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:19',NULL,7868,'0',8418,618,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:19',NULL,7869,'0',8419,618,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:19',NULL,7870,'0',8420,618,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:19',NULL,7871,'0',8421,618,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:19',NULL,7872,'0',8422,618,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:19',NULL,7873,'0',8423,618,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:19',NULL,7874,'1',8424,618,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,7875,'0',8425,619,16,NULL,'cmdb2-1-1-15'),(NULL,0,'2019-11-29 22:14:19',NULL,7876,'0',8426,619,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:19',NULL,7877,'0',8427,619,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:19',NULL,7878,'0',8428,619,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:19',NULL,7879,'0',8429,619,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:19',NULL,7880,'0',8430,619,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:19',NULL,7881,'0',8431,619,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:19',NULL,7882,'0',8432,619,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:19',NULL,7883,'0',8433,619,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:19',NULL,7884,'0',8434,619,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:19',NULL,7885,'1',8435,619,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,7886,'0',8436,620,16,NULL,'cmdb2-1-1-16'),(NULL,0,'2019-11-29 22:14:19',NULL,7887,'0',8437,620,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:19',NULL,7888,'0',8438,620,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:19',NULL,7889,'0',8439,620,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:19',NULL,7890,'0',8440,620,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:19',NULL,7891,'0',8441,620,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:19',NULL,7892,'0',8442,620,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:19',NULL,7893,'0',8443,620,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:19',NULL,7894,'0',8444,620,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:19',NULL,7895,'0',8445,620,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:20',NULL,7896,'1',8446,620,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,7897,'0',8447,621,4,NULL,'App2-1-2'),(NULL,0,'2019-11-29 22:14:20',NULL,7898,'0',8449,622,16,NULL,'cmdb2-1-2-1'),(NULL,0,'2019-11-29 22:14:20',NULL,7899,'0',8450,622,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:20',NULL,7900,'0',8451,622,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:20',NULL,7901,'0',8452,622,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:20',NULL,7902,'0',8453,622,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:20',NULL,7903,'0',8454,622,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:20',NULL,7904,'0',8455,622,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:20',NULL,7905,'0',8456,622,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:20',NULL,7906,'0',8457,622,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:20',NULL,7907,'0',8458,622,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:20',NULL,7908,'1',8459,622,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,7909,'0',8460,623,16,NULL,'cmdb2-1-2-2'),(NULL,0,'2019-11-29 22:14:20',NULL,7910,'0',8461,623,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:20',NULL,7911,'0',8462,623,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:20',NULL,7912,'0',8463,623,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:20',NULL,7913,'0',8464,623,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:20',NULL,7914,'0',8465,623,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:20',NULL,7915,'0',8466,623,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:20',NULL,7916,'0',8467,623,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:20',NULL,7917,'0',8468,623,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:20',NULL,7918,'0',8469,623,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:20',NULL,7919,'1',8470,623,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,7920,'0',8471,624,16,NULL,'cmdb2-1-2-3'),(NULL,0,'2019-11-29 22:14:20',NULL,7921,'0',8472,624,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:20',NULL,7922,'0',8473,624,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:20',NULL,7923,'0',8474,624,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:20',NULL,7924,'0',8475,624,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:20',NULL,7925,'0',8476,624,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:20',NULL,7926,'0',8477,624,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:20',NULL,7927,'0',8478,624,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:20',NULL,7928,'0',8479,624,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:20',NULL,7929,'0',8480,624,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:20',NULL,7930,'1',8481,624,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,7931,'0',8482,625,16,NULL,'cmdb2-1-2-4'),(NULL,0,'2019-11-29 22:14:20',NULL,7932,'0',8483,625,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:20',NULL,7933,'0',8484,625,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:20',NULL,7934,'0',8485,625,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:20',NULL,7935,'0',8486,625,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:20',NULL,7936,'0',8487,625,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:20',NULL,7937,'0',8488,625,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:20',NULL,7938,'0',8489,625,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:20',NULL,7939,'0',8490,625,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:20',NULL,7940,'0',8491,625,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:21',NULL,7941,'1',8492,625,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,7942,'0',8493,626,16,NULL,'cmdb2-1-2-5'),(NULL,0,'2019-11-29 22:14:21',NULL,7943,'0',8494,626,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:21',NULL,7944,'0',8495,626,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:21',NULL,7945,'0',8496,626,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:21',NULL,7946,'0',8497,626,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:21',NULL,7947,'0',8498,626,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:21',NULL,7948,'0',8499,626,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:21',NULL,7949,'0',8500,626,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:21',NULL,7950,'0',8501,626,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:21',NULL,7951,'0',8502,626,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:21',NULL,7952,'1',8503,626,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,7953,'0',8504,627,16,NULL,'cmdb2-1-2-6'),(NULL,0,'2019-11-29 22:14:21',NULL,7954,'0',8505,627,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:21',NULL,7955,'0',8506,627,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:21',NULL,7956,'0',8507,627,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:21',NULL,7957,'0',8508,627,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:21',NULL,7958,'0',8509,627,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:21',NULL,7959,'0',8510,627,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:21',NULL,7960,'0',8511,627,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:21',NULL,7961,'0',8512,627,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:21',NULL,7962,'0',8513,627,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:21',NULL,7963,'1',8514,627,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,7964,'0',8515,628,16,NULL,'cmdb2-1-2-7'),(NULL,0,'2019-11-29 22:14:21',NULL,7965,'0',8516,628,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:21',NULL,7966,'0',8517,628,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:21',NULL,7967,'0',8518,628,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:21',NULL,7968,'0',8519,628,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:21',NULL,7969,'0',8520,628,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:21',NULL,7970,'0',8521,628,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:21',NULL,7971,'0',8522,628,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:21',NULL,7972,'0',8523,628,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:21',NULL,7973,'0',8524,628,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:21',NULL,7974,'1',8525,628,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,7975,'0',8526,629,16,NULL,'cmdb2-1-2-8'),(NULL,0,'2019-11-29 22:14:21',NULL,7976,'0',8527,629,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:21',NULL,7977,'0',8528,629,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:21',NULL,7978,'0',8529,629,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:21',NULL,7979,'0',8530,629,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:21',NULL,7980,'0',8531,629,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:21',NULL,7981,'0',8532,629,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:21',NULL,7982,'0',8533,629,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:21',NULL,7983,'0',8534,629,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:21',NULL,7984,'0',8535,629,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:22',NULL,7985,'1',8536,629,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,7986,'0',8537,630,16,NULL,'cmdb2-1-2-9'),(NULL,0,'2019-11-29 22:14:22',NULL,7987,'0',8538,630,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:22',NULL,7988,'0',8539,630,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:22',NULL,7989,'0',8540,630,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:22',NULL,7990,'0',8541,630,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:22',NULL,7991,'0',8542,630,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:22',NULL,7992,'0',8543,630,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:22',NULL,7993,'0',8544,630,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:22',NULL,7994,'0',8545,630,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:22',NULL,7995,'0',8546,630,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:22',NULL,7996,'1',8547,630,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,7997,'0',8548,631,16,NULL,'cmdb2-1-2-10'),(NULL,0,'2019-11-29 22:14:22',NULL,7998,'0',8549,631,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:22',NULL,7999,'0',8550,631,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:22',NULL,8000,'0',8551,631,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:22',NULL,8001,'0',8552,631,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:22',NULL,8002,'0',8553,631,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:22',NULL,8003,'0',8554,631,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:22',NULL,8004,'0',8555,631,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:22',NULL,8005,'0',8556,631,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:22',NULL,8006,'0',8557,631,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:22',NULL,8007,'1',8558,631,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8008,'0',8559,632,16,NULL,'cmdb2-1-2-11'),(NULL,0,'2019-11-29 22:14:22',NULL,8009,'0',8560,632,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:22',NULL,8010,'0',8561,632,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:22',NULL,8011,'0',8562,632,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:22',NULL,8012,'0',8563,632,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:22',NULL,8013,'0',8564,632,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:22',NULL,8014,'0',8565,632,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:22',NULL,8015,'0',8566,632,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:22',NULL,8016,'0',8567,632,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:22',NULL,8017,'0',8568,632,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:22',NULL,8018,'1',8569,632,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8019,'0',8570,633,16,NULL,'cmdb2-1-2-12'),(NULL,0,'2019-11-29 22:14:22',NULL,8020,'0',8571,633,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:22',NULL,8021,'0',8572,633,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:22',NULL,8022,'0',8573,633,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:22',NULL,8023,'0',8574,633,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:22',NULL,8024,'0',8575,633,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:22',NULL,8025,'0',8576,633,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:22',NULL,8026,'0',8577,633,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:22',NULL,8027,'0',8578,633,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:22',NULL,8028,'0',8579,633,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:23',NULL,8029,'1',8580,633,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8030,'0',8581,634,16,NULL,'cmdb2-1-2-13'),(NULL,0,'2019-11-29 22:14:23',NULL,8031,'0',8582,634,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:23',NULL,8032,'0',8583,634,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:23',NULL,8033,'0',8584,634,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:23',NULL,8034,'0',8585,634,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:23',NULL,8035,'0',8586,634,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:23',NULL,8036,'0',8587,634,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:23',NULL,8037,'0',8588,634,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:23',NULL,8038,'0',8589,634,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:23',NULL,8039,'0',8590,634,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:23',NULL,8040,'1',8591,634,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8041,'0',8592,635,16,NULL,'cmdb2-1-2-14'),(NULL,0,'2019-11-29 22:14:23',NULL,8042,'0',8593,635,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:23',NULL,8043,'0',8594,635,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:23',NULL,8044,'0',8595,635,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:23',NULL,8045,'0',8596,635,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:23',NULL,8046,'0',8597,635,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:23',NULL,8047,'0',8598,635,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:23',NULL,8048,'0',8599,635,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:23',NULL,8049,'0',8600,635,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:23',NULL,8050,'0',8601,635,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:23',NULL,8051,'1',8602,635,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8052,'0',8603,636,16,NULL,'cmdb2-1-2-15'),(NULL,0,'2019-11-29 22:14:23',NULL,8053,'0',8604,636,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:23',NULL,8054,'0',8605,636,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:23',NULL,8055,'0',8606,636,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:23',NULL,8056,'0',8607,636,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:23',NULL,8057,'0',8608,636,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:23',NULL,8058,'0',8609,636,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:23',NULL,8059,'0',8610,636,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:23',NULL,8060,'0',8611,636,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:23',NULL,8061,'0',8612,636,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:23',NULL,8062,'1',8613,636,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8063,'0',8614,637,16,NULL,'cmdb2-1-2-16'),(NULL,0,'2019-11-29 22:14:23',NULL,8064,'0',8615,637,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:23',NULL,8065,'0',8616,637,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:23',NULL,8066,'0',8617,637,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:23',NULL,8067,'0',8618,637,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:23',NULL,8068,'0',8619,637,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:23',NULL,8069,'0',8620,637,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:23',NULL,8070,'0',8621,637,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:23',NULL,8071,'0',8622,637,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:23',NULL,8072,'0',8623,637,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:24',NULL,8073,'1',8624,637,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8074,'0',8625,638,4,NULL,'App2-1-3'),(NULL,0,'2019-11-29 22:14:24',NULL,8075,'0',8627,639,16,NULL,'cmdb2-1-3-1'),(NULL,0,'2019-11-29 22:14:24',NULL,8076,'0',8628,639,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:24',NULL,8077,'0',8629,639,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:24',NULL,8078,'0',8630,639,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:24',NULL,8079,'0',8631,639,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:24',NULL,8080,'0',8632,639,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:24',NULL,8081,'0',8633,639,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:24',NULL,8082,'0',8634,639,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:24',NULL,8083,'0',8635,639,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:24',NULL,8084,'0',8636,639,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:24',NULL,8085,'1',8637,639,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8086,'0',8638,640,16,NULL,'cmdb2-1-3-2'),(NULL,0,'2019-11-29 22:14:24',NULL,8087,'0',8639,640,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:24',NULL,8088,'0',8640,640,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:24',NULL,8089,'0',8641,640,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:24',NULL,8090,'0',8642,640,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:24',NULL,8091,'0',8643,640,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:24',NULL,8092,'0',8644,640,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:24',NULL,8093,'0',8645,640,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:24',NULL,8094,'0',8646,640,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:24',NULL,8095,'0',8647,640,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:24',NULL,8096,'1',8648,640,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8097,'0',8649,641,16,NULL,'cmdb2-1-3-3'),(NULL,0,'2019-11-29 22:14:24',NULL,8098,'0',8650,641,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:24',NULL,8099,'0',8651,641,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:24',NULL,8100,'0',8652,641,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:24',NULL,8101,'0',8653,641,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:24',NULL,8102,'0',8654,641,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:24',NULL,8103,'0',8655,641,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:24',NULL,8104,'0',8656,641,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:24',NULL,8105,'0',8657,641,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:24',NULL,8106,'0',8658,641,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:24',NULL,8107,'1',8659,641,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8108,'0',8660,642,16,NULL,'cmdb2-1-3-4'),(NULL,0,'2019-11-29 22:14:24',NULL,8109,'0',8661,642,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:24',NULL,8110,'0',8662,642,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:24',NULL,8111,'0',8663,642,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:24',NULL,8112,'0',8664,642,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:24',NULL,8113,'0',8665,642,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:24',NULL,8114,'0',8666,642,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:24',NULL,8115,'0',8667,642,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:24',NULL,8116,'0',8668,642,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:24',NULL,8117,'0',8669,642,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:25',NULL,8118,'1',8670,642,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8119,'0',8671,643,16,NULL,'cmdb2-1-3-5'),(NULL,0,'2019-11-29 22:14:25',NULL,8120,'0',8672,643,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:25',NULL,8121,'0',8673,643,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:25',NULL,8122,'0',8674,643,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:25',NULL,8123,'0',8675,643,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:25',NULL,8124,'0',8676,643,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:25',NULL,8125,'0',8677,643,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:25',NULL,8126,'0',8678,643,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:25',NULL,8127,'0',8679,643,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:25',NULL,8128,'0',8680,643,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:25',NULL,8129,'1',8681,643,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8130,'0',8682,644,16,NULL,'cmdb2-1-3-6'),(NULL,0,'2019-11-29 22:14:25',NULL,8131,'0',8683,644,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:25',NULL,8132,'0',8684,644,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:25',NULL,8133,'0',8685,644,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:25',NULL,8134,'0',8686,644,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:25',NULL,8135,'0',8687,644,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:25',NULL,8136,'0',8688,644,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:25',NULL,8137,'0',8689,644,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:25',NULL,8138,'0',8690,644,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:25',NULL,8139,'0',8691,644,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:25',NULL,8140,'1',8692,644,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8141,'0',8693,645,16,NULL,'cmdb2-1-3-7'),(NULL,0,'2019-11-29 22:14:25',NULL,8142,'0',8694,645,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:25',NULL,8143,'0',8695,645,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:25',NULL,8144,'0',8696,645,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:25',NULL,8145,'0',8697,645,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:25',NULL,8146,'0',8698,645,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:25',NULL,8147,'0',8699,645,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:25',NULL,8148,'0',8700,645,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:25',NULL,8149,'0',8701,645,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:25',NULL,8150,'0',8702,645,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:25',NULL,8151,'1',8703,645,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8152,'0',8704,646,16,NULL,'cmdb2-1-3-8'),(NULL,0,'2019-11-29 22:14:25',NULL,8153,'0',8705,646,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:25',NULL,8154,'0',8706,646,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:25',NULL,8155,'0',8707,646,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:25',NULL,8156,'0',8708,646,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:25',NULL,8157,'0',8709,646,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:25',NULL,8158,'0',8710,646,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:25',NULL,8159,'0',8711,646,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:25',NULL,8160,'0',8712,646,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:25',NULL,8161,'0',8713,646,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:26',NULL,8162,'1',8714,646,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8163,'0',8715,647,16,NULL,'cmdb2-1-3-9'),(NULL,0,'2019-11-29 22:14:26',NULL,8164,'0',8716,647,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:26',NULL,8165,'0',8717,647,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:26',NULL,8166,'0',8718,647,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:26',NULL,8167,'0',8719,647,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:26',NULL,8168,'0',8720,647,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:26',NULL,8169,'0',8721,647,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:26',NULL,8170,'0',8722,647,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:26',NULL,8171,'0',8723,647,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:26',NULL,8172,'0',8724,647,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:26',NULL,8173,'1',8725,647,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8174,'0',8726,648,16,NULL,'cmdb2-1-3-10'),(NULL,0,'2019-11-29 22:14:26',NULL,8175,'0',8727,648,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:26',NULL,8176,'0',8728,648,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:26',NULL,8177,'0',8729,648,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:26',NULL,8178,'0',8730,648,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:26',NULL,8179,'0',8731,648,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:26',NULL,8180,'0',8732,648,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:26',NULL,8181,'0',8733,648,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:26',NULL,8182,'0',8734,648,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:26',NULL,8183,'0',8735,648,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:26',NULL,8184,'1',8736,648,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8185,'0',8737,649,16,NULL,'cmdb2-1-3-11'),(NULL,0,'2019-11-29 22:14:26',NULL,8186,'0',8738,649,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:26',NULL,8187,'0',8739,649,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:26',NULL,8188,'0',8740,649,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:26',NULL,8189,'0',8741,649,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:26',NULL,8190,'0',8742,649,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:26',NULL,8191,'0',8743,649,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:26',NULL,8192,'0',8744,649,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:26',NULL,8193,'0',8745,649,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:26',NULL,8194,'0',8746,649,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:26',NULL,8195,'1',8747,649,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8196,'0',8748,650,16,NULL,'cmdb2-1-3-12'),(NULL,0,'2019-11-29 22:14:26',NULL,8197,'0',8749,650,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:26',NULL,8198,'0',8750,650,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:26',NULL,8199,'0',8751,650,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:26',NULL,8200,'0',8752,650,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:26',NULL,8201,'0',8753,650,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:26',NULL,8202,'0',8754,650,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:26',NULL,8203,'0',8755,650,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:26',NULL,8204,'0',8756,650,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:26',NULL,8205,'0',8757,650,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:27',NULL,8206,'1',8758,650,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8207,'0',8759,651,16,NULL,'cmdb2-1-3-13'),(NULL,0,'2019-11-29 22:14:27',NULL,8208,'0',8760,651,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:27',NULL,8209,'0',8761,651,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:27',NULL,8210,'0',8762,651,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:27',NULL,8211,'0',8763,651,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:27',NULL,8212,'0',8764,651,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:27',NULL,8213,'0',8765,651,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:27',NULL,8214,'0',8766,651,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:27',NULL,8215,'0',8767,651,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:27',NULL,8216,'0',8768,651,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:27',NULL,8217,'1',8769,651,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8218,'0',8770,652,16,NULL,'cmdb2-1-3-14'),(NULL,0,'2019-11-29 22:14:27',NULL,8219,'0',8771,652,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:27',NULL,8220,'0',8772,652,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:27',NULL,8221,'0',8773,652,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:27',NULL,8222,'0',8774,652,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:27',NULL,8223,'0',8775,652,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:27',NULL,8224,'0',8776,652,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:27',NULL,8225,'0',8777,652,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:27',NULL,8226,'0',8778,652,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:27',NULL,8227,'0',8779,652,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:27',NULL,8228,'1',8780,652,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8229,'0',8781,653,16,NULL,'cmdb2-1-3-15'),(NULL,0,'2019-11-29 22:14:27',NULL,8230,'0',8782,653,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:27',NULL,8231,'0',8783,653,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:27',NULL,8232,'0',8784,653,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:27',NULL,8233,'0',8785,653,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:27',NULL,8234,'0',8786,653,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:27',NULL,8235,'0',8787,653,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:27',NULL,8236,'0',8788,653,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:27',NULL,8237,'0',8789,653,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:27',NULL,8238,'0',8790,653,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:27',NULL,8239,'1',8791,653,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8240,'0',8792,654,16,NULL,'cmdb2-1-3-16'),(NULL,0,'2019-11-29 22:14:27',NULL,8241,'0',8793,654,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:27',NULL,8242,'0',8794,654,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:27',NULL,8243,'0',8795,654,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:27',NULL,8244,'0',8796,654,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:27',NULL,8245,'0',8797,654,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:27',NULL,8246,'0',8798,654,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:27',NULL,8247,'0',8799,654,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:27',NULL,8248,'0',8800,654,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:27',NULL,8249,'0',8801,654,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:28',NULL,8250,'1',8802,654,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8251,'0',8803,655,4,NULL,'App2-1-4'),(NULL,0,'2019-11-29 22:14:28',NULL,8252,'0',8805,656,16,NULL,'cmdb2-1-4-1'),(NULL,0,'2019-11-29 22:14:28',NULL,8253,'0',8806,656,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:28',NULL,8254,'0',8807,656,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:28',NULL,8255,'0',8808,656,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:28',NULL,8256,'0',8809,656,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:28',NULL,8257,'0',8810,656,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:28',NULL,8258,'0',8811,656,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:28',NULL,8259,'0',8812,656,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:28',NULL,8260,'0',8813,656,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:28',NULL,8261,'0',8814,656,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:28',NULL,8262,'1',8815,656,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8263,'0',8816,657,16,NULL,'cmdb2-1-4-2'),(NULL,0,'2019-11-29 22:14:28',NULL,8264,'0',8817,657,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:28',NULL,8265,'0',8818,657,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:28',NULL,8266,'0',8819,657,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:28',NULL,8267,'0',8820,657,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:28',NULL,8268,'0',8821,657,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:28',NULL,8269,'0',8822,657,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:28',NULL,8270,'0',8823,657,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:28',NULL,8271,'0',8824,657,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:28',NULL,8272,'0',8825,657,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:28',NULL,8273,'1',8826,657,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8274,'0',8827,658,16,NULL,'cmdb2-1-4-3'),(NULL,0,'2019-11-29 22:14:28',NULL,8275,'0',8828,658,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:28',NULL,8276,'0',8829,658,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:28',NULL,8277,'0',8830,658,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:28',NULL,8278,'0',8831,658,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:28',NULL,8279,'0',8832,658,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:28',NULL,8280,'0',8833,658,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:28',NULL,8281,'0',8834,658,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:28',NULL,8282,'0',8835,658,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:28',NULL,8283,'0',8836,658,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:28',NULL,8284,'1',8837,658,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8285,'0',8838,659,16,NULL,'cmdb2-1-4-4'),(NULL,0,'2019-11-29 22:14:28',NULL,8286,'0',8839,659,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:28',NULL,8287,'0',8840,659,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:28',NULL,8288,'0',8841,659,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:28',NULL,8289,'0',8842,659,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:28',NULL,8290,'0',8843,659,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:28',NULL,8291,'0',8844,659,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:28',NULL,8292,'0',8845,659,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:28',NULL,8293,'0',8846,659,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:28',NULL,8294,'0',8847,659,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:29',NULL,8295,'1',8848,659,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8296,'0',8849,660,16,NULL,'cmdb2-1-4-5'),(NULL,0,'2019-11-29 22:14:29',NULL,8297,'0',8850,660,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:29',NULL,8298,'0',8851,660,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:29',NULL,8299,'0',8852,660,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:29',NULL,8300,'0',8853,660,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:29',NULL,8301,'0',8854,660,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:29',NULL,8302,'0',8855,660,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:29',NULL,8303,'0',8856,660,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:29',NULL,8304,'0',8857,660,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:29',NULL,8305,'0',8858,660,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:29',NULL,8306,'1',8859,660,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8307,'0',8860,661,16,NULL,'cmdb2-1-4-6'),(NULL,0,'2019-11-29 22:14:29',NULL,8308,'0',8861,661,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:29',NULL,8309,'0',8862,661,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:29',NULL,8310,'0',8863,661,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:29',NULL,8311,'0',8864,661,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:29',NULL,8312,'0',8865,661,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:29',NULL,8313,'0',8866,661,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:29',NULL,8314,'0',8867,661,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:29',NULL,8315,'0',8868,661,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:29',NULL,8316,'0',8869,661,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:29',NULL,8317,'1',8870,661,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8318,'0',8871,662,16,NULL,'cmdb2-1-4-7'),(NULL,0,'2019-11-29 22:14:29',NULL,8319,'0',8872,662,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:29',NULL,8320,'0',8873,662,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:29',NULL,8321,'0',8874,662,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:29',NULL,8322,'0',8875,662,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:29',NULL,8323,'0',8876,662,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:29',NULL,8324,'0',8877,662,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:29',NULL,8325,'0',8878,662,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:29',NULL,8326,'0',8879,662,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:29',NULL,8327,'0',8880,662,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:29',NULL,8328,'1',8881,662,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8329,'0',8882,663,16,NULL,'cmdb2-1-4-8'),(NULL,0,'2019-11-29 22:14:29',NULL,8330,'0',8883,663,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:29',NULL,8331,'0',8884,663,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:29',NULL,8332,'0',8885,663,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:29',NULL,8333,'0',8886,663,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:29',NULL,8334,'0',8887,663,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:29',NULL,8335,'0',8888,663,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:29',NULL,8336,'0',8889,663,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:29',NULL,8337,'0',8890,663,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:29',NULL,8338,'0',8891,663,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:30',NULL,8339,'1',8892,663,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8340,'0',8893,664,16,NULL,'cmdb2-1-4-9'),(NULL,0,'2019-11-29 22:14:30',NULL,8341,'0',8894,664,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:30',NULL,8342,'0',8895,664,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:30',NULL,8343,'0',8896,664,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:30',NULL,8344,'0',8897,664,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:30',NULL,8345,'0',8898,664,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:30',NULL,8346,'0',8899,664,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:30',NULL,8347,'0',8900,664,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:30',NULL,8348,'0',8901,664,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:30',NULL,8349,'0',8902,664,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:30',NULL,8350,'1',8903,664,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8351,'0',8904,665,16,NULL,'cmdb2-1-4-10'),(NULL,0,'2019-11-29 22:14:30',NULL,8352,'0',8905,665,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:30',NULL,8353,'0',8906,665,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:30',NULL,8354,'0',8907,665,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:30',NULL,8355,'0',8908,665,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:30',NULL,8356,'0',8909,665,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:30',NULL,8357,'0',8910,665,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:30',NULL,8358,'0',8911,665,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:30',NULL,8359,'0',8912,665,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:30',NULL,8360,'0',8913,665,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:30',NULL,8361,'1',8914,665,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8362,'0',8915,666,16,NULL,'cmdb2-1-4-11'),(NULL,0,'2019-11-29 22:14:30',NULL,8363,'0',8916,666,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:30',NULL,8364,'0',8917,666,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:30',NULL,8365,'0',8918,666,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:30',NULL,8366,'0',8919,666,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:30',NULL,8367,'0',8920,666,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:30',NULL,8368,'0',8921,666,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:30',NULL,8369,'0',8922,666,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:30',NULL,8370,'0',8923,666,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:30',NULL,8371,'0',8924,666,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:30',NULL,8372,'1',8925,666,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8373,'0',8926,667,16,NULL,'cmdb2-1-4-12'),(NULL,0,'2019-11-29 22:14:30',NULL,8374,'0',8927,667,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:30',NULL,8375,'0',8928,667,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:30',NULL,8376,'0',8929,667,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:30',NULL,8377,'0',8930,667,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:30',NULL,8378,'0',8931,667,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:30',NULL,8379,'0',8932,667,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:30',NULL,8380,'0',8933,667,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:30',NULL,8381,'0',8934,667,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:30',NULL,8382,'0',8935,667,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:30',NULL,8383,'1',8936,667,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8384,'0',8937,668,16,NULL,'cmdb2-1-4-13'),(NULL,0,'2019-11-29 22:14:31',NULL,8385,'0',8938,668,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:31',NULL,8386,'0',8939,668,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:31',NULL,8387,'0',8940,668,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:31',NULL,8388,'0',8941,668,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:31',NULL,8389,'0',8942,668,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:31',NULL,8390,'0',8943,668,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:31',NULL,8391,'0',8944,668,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:31',NULL,8392,'0',8945,668,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:31',NULL,8393,'0',8946,668,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:31',NULL,8394,'1',8947,668,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8395,'0',8948,669,16,NULL,'cmdb2-1-4-14'),(NULL,0,'2019-11-29 22:14:31',NULL,8396,'0',8949,669,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:31',NULL,8397,'0',8950,669,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:31',NULL,8398,'0',8951,669,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:31',NULL,8399,'0',8952,669,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:31',NULL,8400,'0',8953,669,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:31',NULL,8401,'0',8954,669,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:31',NULL,8402,'0',8955,669,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:31',NULL,8403,'0',8956,669,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:31',NULL,8404,'0',8957,669,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:31',NULL,8405,'1',8958,669,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8406,'0',8959,670,16,NULL,'cmdb2-1-4-15'),(NULL,0,'2019-11-29 22:14:31',NULL,8407,'0',8960,670,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:31',NULL,8408,'0',8961,670,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:31',NULL,8409,'0',8962,670,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:31',NULL,8410,'0',8963,670,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:31',NULL,8411,'0',8964,670,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:31',NULL,8412,'0',8965,670,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:31',NULL,8413,'0',8966,670,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:31',NULL,8414,'0',8967,670,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:31',NULL,8415,'0',8968,670,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:31',NULL,8416,'1',8969,670,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8417,'0',8970,671,16,NULL,'cmdb2-1-4-16'),(NULL,0,'2019-11-29 22:14:31',NULL,8418,'0',8971,671,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:31',NULL,8419,'0',8972,671,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:31',NULL,8420,'0',8973,671,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:31',NULL,8421,'0',8974,671,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:31',NULL,8422,'0',8975,671,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:31',NULL,8423,'0',8976,671,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:31',NULL,8424,'0',8977,671,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:31',NULL,8425,'0',8978,671,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:31',NULL,8426,'0',8979,671,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:31',NULL,8427,'1',8980,671,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8428,'0',8981,672,4,NULL,'App2-1-5'),(NULL,0,'2019-11-29 22:14:32',NULL,8429,'0',8983,673,16,NULL,'cmdb2-1-5-1'),(NULL,0,'2019-11-29 22:14:32',NULL,8430,'0',8984,673,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:32',NULL,8431,'0',8985,673,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:32',NULL,8432,'0',8986,673,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:32',NULL,8433,'0',8987,673,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:32',NULL,8434,'0',8988,673,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:32',NULL,8435,'0',8989,673,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:32',NULL,8436,'0',8990,673,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:32',NULL,8437,'0',8991,673,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:32',NULL,8438,'0',8992,673,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:32',NULL,8439,'1',8993,673,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8440,'0',8994,674,16,NULL,'cmdb2-1-5-2'),(NULL,0,'2019-11-29 22:14:32',NULL,8441,'0',8995,674,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:32',NULL,8442,'0',8996,674,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:32',NULL,8443,'0',8997,674,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:32',NULL,8444,'0',8998,674,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:32',NULL,8445,'0',8999,674,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:32',NULL,8446,'0',9000,674,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:32',NULL,8447,'0',9001,674,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:32',NULL,8448,'0',9002,674,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:32',NULL,8449,'0',9003,674,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:32',NULL,8450,'1',9004,674,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8451,'0',9005,675,16,NULL,'cmdb2-1-5-3'),(NULL,0,'2019-11-29 22:14:32',NULL,8452,'0',9006,675,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:32',NULL,8453,'0',9007,675,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:32',NULL,8454,'0',9008,675,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:32',NULL,8455,'0',9009,675,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:32',NULL,8456,'0',9010,675,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:32',NULL,8457,'0',9011,675,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:32',NULL,8458,'0',9012,675,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:32',NULL,8459,'0',9013,675,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:32',NULL,8460,'0',9014,675,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:32',NULL,8461,'1',9015,675,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8462,'0',9016,676,16,NULL,'cmdb2-1-5-4'),(NULL,0,'2019-11-29 22:14:32',NULL,8463,'0',9017,676,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:32',NULL,8464,'0',9018,676,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:32',NULL,8465,'0',9019,676,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:32',NULL,8466,'0',9020,676,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:32',NULL,8467,'0',9021,676,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:32',NULL,8468,'0',9022,676,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:32',NULL,8469,'0',9023,676,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:32',NULL,8470,'0',9024,676,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:32',NULL,8471,'0',9025,676,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:33',NULL,8472,'1',9026,676,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,8473,'0',9027,677,16,NULL,'cmdb2-1-5-5'),(NULL,0,'2019-11-29 22:14:33',NULL,8474,'0',9028,677,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:33',NULL,8475,'0',9029,677,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:33',NULL,8476,'0',9030,677,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:33',NULL,8477,'0',9031,677,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:33',NULL,8478,'0',9032,677,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:33',NULL,8479,'0',9033,677,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:33',NULL,8480,'0',9034,677,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:33',NULL,8481,'0',9035,677,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:33',NULL,8482,'0',9036,677,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:33',NULL,8483,'1',9037,677,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,8484,'0',9038,678,16,NULL,'cmdb2-1-5-6'),(NULL,0,'2019-11-29 22:14:33',NULL,8485,'0',9039,678,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:33',NULL,8486,'0',9040,678,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:33',NULL,8487,'0',9041,678,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:33',NULL,8488,'0',9042,678,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:33',NULL,8489,'0',9043,678,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:33',NULL,8490,'0',9044,678,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:33',NULL,8491,'0',9045,678,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:33',NULL,8492,'0',9046,678,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:33',NULL,8493,'0',9047,678,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:33',NULL,8494,'1',9048,678,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,8495,'0',9049,679,16,NULL,'cmdb2-1-5-7'),(NULL,0,'2019-11-29 22:14:33',NULL,8496,'0',9050,679,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:33',NULL,8497,'0',9051,679,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:33',NULL,8498,'0',9052,679,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:33',NULL,8499,'0',9053,679,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:33',NULL,8500,'0',9054,679,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:33',NULL,8501,'0',9055,679,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:33',NULL,8502,'0',9056,679,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:33',NULL,8503,'0',9057,679,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:33',NULL,8504,'0',9058,679,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:33',NULL,8505,'1',9059,679,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,8506,'0',9060,680,16,NULL,'cmdb2-1-5-8'),(NULL,0,'2019-11-29 22:14:33',NULL,8507,'0',9061,680,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:33',NULL,8508,'0',9062,680,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:33',NULL,8509,'0',9063,680,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:33',NULL,8510,'0',9064,680,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:33',NULL,8511,'0',9065,680,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:33',NULL,8512,'0',9066,680,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:33',NULL,8513,'0',9067,680,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:33',NULL,8514,'0',9068,680,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:33',NULL,8515,'0',9069,680,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:33',NULL,8516,'1',9070,680,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,8517,'0',9071,681,16,NULL,'cmdb2-1-5-9'),(NULL,0,'2019-11-29 22:14:34',NULL,8518,'0',9072,681,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:34',NULL,8519,'0',9073,681,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:34',NULL,8520,'0',9074,681,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:34',NULL,8521,'0',9075,681,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:34',NULL,8522,'0',9076,681,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:34',NULL,8523,'0',9077,681,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:34',NULL,8524,'0',9078,681,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:34',NULL,8525,'0',9079,681,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:34',NULL,8526,'0',9080,681,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:34',NULL,8527,'1',9081,681,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,8528,'0',9082,682,16,NULL,'cmdb2-1-5-10'),(NULL,0,'2019-11-29 22:14:34',NULL,8529,'0',9083,682,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:34',NULL,8530,'0',9084,682,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:34',NULL,8531,'0',9085,682,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:34',NULL,8532,'0',9086,682,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:34',NULL,8533,'0',9087,682,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:34',NULL,8534,'0',9088,682,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:34',NULL,8535,'0',9089,682,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:34',NULL,8536,'0',9090,682,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:34',NULL,8537,'0',9091,682,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:34',NULL,8538,'1',9092,682,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,8539,'0',9093,683,16,NULL,'cmdb2-1-5-11'),(NULL,0,'2019-11-29 22:14:34',NULL,8540,'0',9094,683,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:34',NULL,8541,'0',9095,683,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:34',NULL,8542,'0',9096,683,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:34',NULL,8543,'0',9097,683,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:34',NULL,8544,'0',9098,683,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:34',NULL,8545,'0',9099,683,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:34',NULL,8546,'0',9100,683,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:34',NULL,8547,'0',9101,683,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:34',NULL,8548,'0',9102,683,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:34',NULL,8549,'1',9103,683,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,8550,'0',9104,684,16,NULL,'cmdb2-1-5-12'),(NULL,0,'2019-11-29 22:14:34',NULL,8551,'0',9105,684,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:34',NULL,8552,'0',9106,684,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:34',NULL,8553,'0',9107,684,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:34',NULL,8554,'0',9108,684,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:34',NULL,8555,'0',9109,684,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:34',NULL,8556,'0',9110,684,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:34',NULL,8557,'0',9111,684,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:34',NULL,8558,'0',9112,684,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:34',NULL,8559,'0',9113,684,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:34',NULL,8560,'1',9114,684,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,8561,'0',9115,685,16,NULL,'cmdb2-1-5-13'),(NULL,0,'2019-11-29 22:14:35',NULL,8562,'0',9116,685,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:35',NULL,8563,'0',9117,685,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:35',NULL,8564,'0',9118,685,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:35',NULL,8565,'0',9119,685,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:35',NULL,8566,'0',9120,685,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:35',NULL,8567,'0',9121,685,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:35',NULL,8568,'0',9122,685,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:35',NULL,8569,'0',9123,685,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:35',NULL,8570,'0',9124,685,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:35',NULL,8571,'1',9125,685,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,8572,'0',9126,686,16,NULL,'cmdb2-1-5-14'),(NULL,0,'2019-11-29 22:14:35',NULL,8573,'0',9127,686,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:35',NULL,8574,'0',9128,686,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:35',NULL,8575,'0',9129,686,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:35',NULL,8576,'0',9130,686,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:35',NULL,8577,'0',9131,686,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:35',NULL,8578,'0',9132,686,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:35',NULL,8579,'0',9133,686,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:35',NULL,8580,'0',9134,686,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:35',NULL,8581,'0',9135,686,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:35',NULL,8582,'1',9136,686,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,8583,'0',9137,687,16,NULL,'cmdb2-1-5-15'),(NULL,0,'2019-11-29 22:14:35',NULL,8584,'0',9138,687,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:35',NULL,8585,'0',9139,687,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:35',NULL,8586,'0',9140,687,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:35',NULL,8587,'0',9141,687,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:35',NULL,8588,'0',9142,687,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:35',NULL,8589,'0',9143,687,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:35',NULL,8590,'0',9144,687,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:35',NULL,8591,'0',9145,687,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:35',NULL,8592,'0',9146,687,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:35',NULL,8593,'1',9147,687,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,8594,'0',9148,688,16,NULL,'cmdb2-1-5-16'),(NULL,0,'2019-11-29 22:14:35',NULL,8595,'0',9149,688,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:35',NULL,8596,'0',9150,688,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:35',NULL,8597,'0',9151,688,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:35',NULL,8598,'0',9152,688,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:35',NULL,8599,'0',9153,688,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:35',NULL,8600,'0',9154,688,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:35',NULL,8601,'0',9155,688,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:35',NULL,8602,'0',9156,688,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:35',NULL,8603,'0',9157,688,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:35',NULL,8604,'1',9158,688,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,8605,'0',9159,689,4,NULL,'App2-1-6'),(NULL,0,'2019-11-29 22:14:36',NULL,8606,'0',9161,690,16,NULL,'cmdb2-1-6-1'),(NULL,0,'2019-11-29 22:14:36',NULL,8607,'0',9162,690,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:36',NULL,8608,'0',9163,690,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:36',NULL,8609,'0',9164,690,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:36',NULL,8610,'0',9165,690,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:36',NULL,8611,'0',9166,690,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:36',NULL,8612,'0',9167,690,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:36',NULL,8613,'0',9168,690,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:36',NULL,8614,'0',9169,690,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:36',NULL,8615,'0',9170,690,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:36',NULL,8616,'1',9171,690,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,8617,'0',9172,691,16,NULL,'cmdb2-1-6-2'),(NULL,0,'2019-11-29 22:14:36',NULL,8618,'0',9173,691,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:36',NULL,8619,'0',9174,691,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:36',NULL,8620,'0',9175,691,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:36',NULL,8621,'0',9176,691,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:36',NULL,8622,'0',9177,691,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:36',NULL,8623,'0',9178,691,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:36',NULL,8624,'0',9179,691,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:36',NULL,8625,'0',9180,691,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:36',NULL,8626,'0',9181,691,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:36',NULL,8627,'1',9182,691,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,8628,'0',9183,692,16,NULL,'cmdb2-1-6-3'),(NULL,0,'2019-11-29 22:14:36',NULL,8629,'0',9184,692,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:36',NULL,8630,'0',9185,692,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:36',NULL,8631,'0',9186,692,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:36',NULL,8632,'0',9187,692,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:36',NULL,8633,'0',9188,692,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:36',NULL,8634,'0',9189,692,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:36',NULL,8635,'0',9190,692,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:36',NULL,8636,'0',9191,692,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:36',NULL,8637,'0',9192,692,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:36',NULL,8638,'1',9193,692,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,8639,'0',9194,693,16,NULL,'cmdb2-1-6-4'),(NULL,0,'2019-11-29 22:14:36',NULL,8640,'0',9195,693,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:36',NULL,8641,'0',9196,693,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:36',NULL,8642,'0',9197,693,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:36',NULL,8643,'0',9198,693,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:36',NULL,8644,'0',9199,693,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:36',NULL,8645,'0',9200,693,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:36',NULL,8646,'0',9201,693,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:36',NULL,8647,'0',9202,693,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:36',NULL,8648,'0',9203,693,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:37',NULL,8649,'1',9204,693,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,8650,'0',9205,694,16,NULL,'cmdb2-1-6-5'),(NULL,0,'2019-11-29 22:14:37',NULL,8651,'0',9206,694,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:37',NULL,8652,'0',9207,694,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:37',NULL,8653,'0',9208,694,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:37',NULL,8654,'0',9209,694,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:37',NULL,8655,'0',9210,694,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:37',NULL,8656,'0',9211,694,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:37',NULL,8657,'0',9212,694,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:37',NULL,8658,'0',9213,694,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:37',NULL,8659,'0',9214,694,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:37',NULL,8660,'1',9215,694,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,8661,'0',9216,695,16,NULL,'cmdb2-1-6-6'),(NULL,0,'2019-11-29 22:14:37',NULL,8662,'0',9217,695,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:37',NULL,8663,'0',9218,695,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:37',NULL,8664,'0',9219,695,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:37',NULL,8665,'0',9220,695,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:37',NULL,8666,'0',9221,695,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:37',NULL,8667,'0',9222,695,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:37',NULL,8668,'0',9223,695,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:37',NULL,8669,'0',9224,695,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:37',NULL,8670,'0',9225,695,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:37',NULL,8671,'1',9226,695,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,8672,'0',9227,696,16,NULL,'cmdb2-1-6-7'),(NULL,0,'2019-11-29 22:14:37',NULL,8673,'0',9228,696,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:37',NULL,8674,'0',9229,696,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:37',NULL,8675,'0',9230,696,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:37',NULL,8676,'0',9231,696,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:37',NULL,8677,'0',9232,696,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:37',NULL,8678,'0',9233,696,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:37',NULL,8679,'0',9234,696,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:37',NULL,8680,'0',9235,696,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:37',NULL,8681,'0',9236,696,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:37',NULL,8682,'1',9237,696,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,8683,'0',9238,697,16,NULL,'cmdb2-1-6-8'),(NULL,0,'2019-11-29 22:14:37',NULL,8684,'0',9239,697,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:37',NULL,8685,'0',9240,697,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:37',NULL,8686,'0',9241,697,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:37',NULL,8687,'0',9242,697,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:37',NULL,8688,'0',9243,697,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:37',NULL,8689,'0',9244,697,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:37',NULL,8690,'0',9245,697,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:37',NULL,8691,'0',9246,697,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:37',NULL,8692,'0',9247,697,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:38',NULL,8693,'1',9248,697,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,8694,'0',9249,698,16,NULL,'cmdb2-1-6-9'),(NULL,0,'2019-11-29 22:14:38',NULL,8695,'0',9250,698,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:38',NULL,8696,'0',9251,698,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:38',NULL,8697,'0',9252,698,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:38',NULL,8698,'0',9253,698,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:38',NULL,8699,'0',9254,698,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:38',NULL,8700,'0',9255,698,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:38',NULL,8701,'0',9256,698,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:38',NULL,8702,'0',9257,698,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:38',NULL,8703,'0',9258,698,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:38',NULL,8704,'1',9259,698,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,8705,'0',9260,699,16,NULL,'cmdb2-1-6-10'),(NULL,0,'2019-11-29 22:14:38',NULL,8706,'0',9261,699,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:38',NULL,8707,'0',9262,699,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:38',NULL,8708,'0',9263,699,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:38',NULL,8709,'0',9264,699,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:38',NULL,8710,'0',9265,699,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:38',NULL,8711,'0',9266,699,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:38',NULL,8712,'0',9267,699,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:38',NULL,8713,'0',9268,699,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:38',NULL,8714,'0',9269,699,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:38',NULL,8715,'1',9270,699,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,8716,'0',9271,700,16,NULL,'cmdb2-1-6-11'),(NULL,0,'2019-11-29 22:14:38',NULL,8717,'0',9272,700,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:38',NULL,8718,'0',9273,700,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:38',NULL,8719,'0',9274,700,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:38',NULL,8720,'0',9275,700,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:38',NULL,8721,'0',9276,700,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:38',NULL,8722,'0',9277,700,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:38',NULL,8723,'0',9278,700,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:38',NULL,8724,'0',9279,700,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:38',NULL,8725,'0',9280,700,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:38',NULL,8726,'1',9281,700,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,8727,'0',9282,701,16,NULL,'cmdb2-1-6-12'),(NULL,0,'2019-11-29 22:14:38',NULL,8728,'0',9283,701,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:38',NULL,8729,'0',9284,701,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:38',NULL,8730,'0',9285,701,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:38',NULL,8731,'0',9286,701,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:38',NULL,8732,'0',9287,701,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:38',NULL,8733,'0',9288,701,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:38',NULL,8734,'0',9289,701,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:38',NULL,8735,'0',9290,701,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:38',NULL,8736,'0',9291,701,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:38',NULL,8737,'1',9292,701,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,8738,'0',9293,702,16,NULL,'cmdb2-1-6-13'),(NULL,0,'2019-11-29 22:14:39',NULL,8739,'0',9294,702,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:39',NULL,8740,'0',9295,702,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:39',NULL,8741,'0',9296,702,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:39',NULL,8742,'0',9297,702,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:39',NULL,8743,'0',9298,702,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:39',NULL,8744,'0',9299,702,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:39',NULL,8745,'0',9300,702,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:39',NULL,8746,'0',9301,702,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:39',NULL,8747,'0',9302,702,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:39',NULL,8748,'1',9303,702,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,8749,'0',9304,703,16,NULL,'cmdb2-1-6-14'),(NULL,0,'2019-11-29 22:14:39',NULL,8750,'0',9305,703,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:39',NULL,8751,'0',9306,703,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:39',NULL,8752,'0',9307,703,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:39',NULL,8753,'0',9308,703,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:39',NULL,8754,'0',9309,703,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:39',NULL,8755,'0',9310,703,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:39',NULL,8756,'0',9311,703,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:39',NULL,8757,'0',9312,703,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:39',NULL,8758,'0',9313,703,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:39',NULL,8759,'1',9314,703,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,8760,'0',9315,704,16,NULL,'cmdb2-1-6-15'),(NULL,0,'2019-11-29 22:14:39',NULL,8761,'0',9316,704,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:39',NULL,8762,'0',9317,704,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:39',NULL,8763,'0',9318,704,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:39',NULL,8764,'0',9319,704,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:39',NULL,8765,'0',9320,704,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:39',NULL,8766,'0',9321,704,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:39',NULL,8767,'0',9322,704,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:39',NULL,8768,'0',9323,704,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:39',NULL,8769,'0',9324,704,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:39',NULL,8770,'1',9325,704,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,8771,'0',9326,705,16,NULL,'cmdb2-1-6-16'),(NULL,0,'2019-11-29 22:14:39',NULL,8772,'0',9327,705,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:39',NULL,8773,'0',9328,705,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:39',NULL,8774,'0',9329,705,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:39',NULL,8775,'0',9330,705,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:39',NULL,8776,'0',9331,705,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:39',NULL,8777,'0',9332,705,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:39',NULL,8778,'0',9333,705,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:39',NULL,8779,'0',9334,705,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:39',NULL,8780,'0',9335,705,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:39',NULL,8781,'1',9336,705,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,8782,'0',9337,706,4,NULL,'App2-1-7'),(NULL,0,'2019-11-29 22:14:40',NULL,8783,'0',9339,707,16,NULL,'cmdb2-1-7-1'),(NULL,0,'2019-11-29 22:14:40',NULL,8784,'0',9340,707,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:40',NULL,8785,'0',9341,707,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:40',NULL,8786,'0',9342,707,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:40',NULL,8787,'0',9343,707,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:40',NULL,8788,'0',9344,707,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:40',NULL,8789,'0',9345,707,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:40',NULL,8790,'0',9346,707,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:40',NULL,8791,'0',9347,707,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:40',NULL,8792,'0',9348,707,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:40',NULL,8793,'1',9349,707,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,8794,'0',9350,708,16,NULL,'cmdb2-1-7-2'),(NULL,0,'2019-11-29 22:14:40',NULL,8795,'0',9351,708,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:40',NULL,8796,'0',9352,708,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:40',NULL,8797,'0',9353,708,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:40',NULL,8798,'0',9354,708,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:40',NULL,8799,'0',9355,708,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:40',NULL,8800,'0',9356,708,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:40',NULL,8801,'0',9357,708,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:40',NULL,8802,'0',9358,708,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:40',NULL,8803,'0',9359,708,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:40',NULL,8804,'1',9360,708,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,8805,'0',9361,709,16,NULL,'cmdb2-1-7-3'),(NULL,0,'2019-11-29 22:14:40',NULL,8806,'0',9362,709,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:40',NULL,8807,'0',9363,709,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:40',NULL,8808,'0',9364,709,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:40',NULL,8809,'0',9365,709,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:40',NULL,8810,'0',9366,709,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:40',NULL,8811,'0',9367,709,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:40',NULL,8812,'0',9368,709,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:40',NULL,8813,'0',9369,709,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:40',NULL,8814,'0',9370,709,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:40',NULL,8815,'1',9371,709,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,8816,'0',9372,710,16,NULL,'cmdb2-1-7-4'),(NULL,0,'2019-11-29 22:14:40',NULL,8817,'0',9373,710,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:40',NULL,8818,'0',9374,710,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:40',NULL,8819,'0',9375,710,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:40',NULL,8820,'0',9376,710,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:40',NULL,8821,'0',9377,710,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:40',NULL,8822,'0',9378,710,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:40',NULL,8823,'0',9379,710,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:40',NULL,8824,'0',9380,710,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:40',NULL,8825,'0',9381,710,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:41',NULL,8826,'1',9382,710,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,8827,'0',9383,711,16,NULL,'cmdb2-1-7-5'),(NULL,0,'2019-11-29 22:14:41',NULL,8828,'0',9384,711,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:41',NULL,8829,'0',9385,711,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:41',NULL,8830,'0',9386,711,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:41',NULL,8831,'0',9387,711,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:41',NULL,8832,'0',9388,711,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:41',NULL,8833,'0',9389,711,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:41',NULL,8834,'0',9390,711,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:41',NULL,8835,'0',9391,711,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:41',NULL,8836,'0',9392,711,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:41',NULL,8837,'1',9393,711,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,8838,'0',9394,712,16,NULL,'cmdb2-1-7-6'),(NULL,0,'2019-11-29 22:14:41',NULL,8839,'0',9395,712,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:41',NULL,8840,'0',9396,712,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:41',NULL,8841,'0',9397,712,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:41',NULL,8842,'0',9398,712,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:41',NULL,8843,'0',9399,712,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:41',NULL,8844,'0',9400,712,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:41',NULL,8845,'0',9401,712,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:41',NULL,8846,'0',9402,712,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:41',NULL,8847,'0',9403,712,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:41',NULL,8848,'1',9404,712,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,8849,'0',9405,713,16,NULL,'cmdb2-1-7-7'),(NULL,0,'2019-11-29 22:14:41',NULL,8850,'0',9406,713,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:41',NULL,8851,'0',9407,713,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:41',NULL,8852,'0',9408,713,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:41',NULL,8853,'0',9409,713,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:41',NULL,8854,'0',9410,713,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:41',NULL,8855,'0',9411,713,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:41',NULL,8856,'0',9412,713,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:41',NULL,8857,'0',9413,713,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:41',NULL,8858,'0',9414,713,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:41',NULL,8859,'1',9415,713,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,8860,'0',9416,714,16,NULL,'cmdb2-1-7-8'),(NULL,0,'2019-11-29 22:14:41',NULL,8861,'0',9417,714,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:41',NULL,8862,'0',9418,714,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:41',NULL,8863,'0',9419,714,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:41',NULL,8864,'0',9420,714,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:41',NULL,8865,'0',9421,714,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:41',NULL,8866,'0',9422,714,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:41',NULL,8867,'0',9423,714,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:41',NULL,8868,'0',9424,714,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:41',NULL,8869,'0',9425,714,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:41',NULL,8870,'1',9426,714,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,8871,'0',9427,715,16,NULL,'cmdb2-1-7-9'),(NULL,0,'2019-11-29 22:14:42',NULL,8872,'0',9428,715,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:42',NULL,8873,'0',9429,715,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:42',NULL,8874,'0',9430,715,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:42',NULL,8875,'0',9431,715,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:42',NULL,8876,'0',9432,715,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:42',NULL,8877,'0',9433,715,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:42',NULL,8878,'0',9434,715,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:42',NULL,8879,'0',9435,715,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:42',NULL,8880,'0',9436,715,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:42',NULL,8881,'1',9437,715,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,8882,'0',9438,716,16,NULL,'cmdb2-1-7-10'),(NULL,0,'2019-11-29 22:14:42',NULL,8883,'0',9439,716,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:42',NULL,8884,'0',9440,716,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:42',NULL,8885,'0',9441,716,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:42',NULL,8886,'0',9442,716,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:42',NULL,8887,'0',9443,716,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:42',NULL,8888,'0',9444,716,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:42',NULL,8889,'0',9445,716,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:42',NULL,8890,'0',9446,716,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:42',NULL,8891,'0',9447,716,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:42',NULL,8892,'1',9448,716,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,8893,'0',9449,717,16,NULL,'cmdb2-1-7-11'),(NULL,0,'2019-11-29 22:14:42',NULL,8894,'0',9450,717,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:42',NULL,8895,'0',9451,717,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:42',NULL,8896,'0',9452,717,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:42',NULL,8897,'0',9453,717,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:42',NULL,8898,'0',9454,717,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:42',NULL,8899,'0',9455,717,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:42',NULL,8900,'0',9456,717,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:42',NULL,8901,'0',9457,717,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:42',NULL,8902,'0',9458,717,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:42',NULL,8903,'1',9459,717,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,8904,'0',9460,718,16,NULL,'cmdb2-1-7-12'),(NULL,0,'2019-11-29 22:14:42',NULL,8905,'0',9461,718,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:42',NULL,8906,'0',9462,718,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:42',NULL,8907,'0',9463,718,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:42',NULL,8908,'0',9464,718,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:42',NULL,8909,'0',9465,718,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:42',NULL,8910,'0',9466,718,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:42',NULL,8911,'0',9467,718,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:42',NULL,8912,'0',9468,718,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:42',NULL,8913,'0',9469,718,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:42',NULL,8914,'1',9470,718,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,8915,'0',9471,719,16,NULL,'cmdb2-1-7-13'),(NULL,0,'2019-11-29 22:14:43',NULL,8916,'0',9472,719,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:43',NULL,8917,'0',9473,719,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:43',NULL,8918,'0',9474,719,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:43',NULL,8919,'0',9475,719,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:43',NULL,8920,'0',9476,719,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:43',NULL,8921,'0',9477,719,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:43',NULL,8922,'0',9478,719,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:43',NULL,8923,'0',9479,719,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:43',NULL,8924,'0',9480,719,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:43',NULL,8925,'1',9481,719,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,8926,'0',9482,720,16,NULL,'cmdb2-1-7-14'),(NULL,0,'2019-11-29 22:14:43',NULL,8927,'0',9483,720,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:43',NULL,8928,'0',9484,720,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:43',NULL,8929,'0',9485,720,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:43',NULL,8930,'0',9486,720,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:43',NULL,8931,'0',9487,720,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:43',NULL,8932,'0',9488,720,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:43',NULL,8933,'0',9489,720,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:43',NULL,8934,'0',9490,720,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:43',NULL,8935,'0',9491,720,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:43',NULL,8936,'1',9492,720,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,8937,'0',9493,721,16,NULL,'cmdb2-1-7-15'),(NULL,0,'2019-11-29 22:14:43',NULL,8938,'0',9494,721,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:43',NULL,8939,'0',9495,721,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:43',NULL,8940,'0',9496,721,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:43',NULL,8941,'0',9497,721,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:43',NULL,8942,'0',9498,721,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:43',NULL,8943,'0',9499,721,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:43',NULL,8944,'0',9500,721,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:43',NULL,8945,'0',9501,721,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:43',NULL,8946,'0',9502,721,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:43',NULL,8947,'1',9503,721,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,8948,'0',9504,722,16,NULL,'cmdb2-1-7-16'),(NULL,0,'2019-11-29 22:14:43',NULL,8949,'0',9505,722,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:43',NULL,8950,'0',9506,722,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:43',NULL,8951,'0',9507,722,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:43',NULL,8952,'0',9508,722,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:43',NULL,8953,'0',9509,722,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:43',NULL,8954,'0',9510,722,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:43',NULL,8955,'0',9511,722,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:43',NULL,8956,'0',9512,722,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:43',NULL,8957,'0',9513,722,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:43',NULL,8958,'1',9514,722,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,8959,'0',9515,723,4,NULL,'App2-1-8'),(NULL,0,'2019-11-29 22:14:44',NULL,8960,'0',9517,724,16,NULL,'cmdb2-1-8-1'),(NULL,0,'2019-11-29 22:14:44',NULL,8961,'0',9518,724,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:44',NULL,8962,'0',9519,724,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:44',NULL,8963,'0',9520,724,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:44',NULL,8964,'0',9521,724,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:44',NULL,8965,'0',9522,724,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:44',NULL,8966,'0',9523,724,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:44',NULL,8967,'0',9524,724,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:44',NULL,8968,'0',9525,724,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:44',NULL,8969,'0',9526,724,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:44',NULL,8970,'1',9527,724,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,8971,'0',9528,725,16,NULL,'cmdb2-1-8-2'),(NULL,0,'2019-11-29 22:14:44',NULL,8972,'0',9529,725,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:44',NULL,8973,'0',9530,725,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:44',NULL,8974,'0',9531,725,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:44',NULL,8975,'0',9532,725,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:44',NULL,8976,'0',9533,725,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:44',NULL,8977,'0',9534,725,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:44',NULL,8978,'0',9535,725,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:44',NULL,8979,'0',9536,725,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:44',NULL,8980,'0',9537,725,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:44',NULL,8981,'1',9538,725,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,8982,'0',9539,726,16,NULL,'cmdb2-1-8-3'),(NULL,0,'2019-11-29 22:14:44',NULL,8983,'0',9540,726,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:44',NULL,8984,'0',9541,726,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:44',NULL,8985,'0',9542,726,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:44',NULL,8986,'0',9543,726,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:44',NULL,8987,'0',9544,726,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:44',NULL,8988,'0',9545,726,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:44',NULL,8989,'0',9546,726,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:44',NULL,8990,'0',9547,726,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:44',NULL,8991,'0',9548,726,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:44',NULL,8992,'1',9549,726,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,8993,'0',9550,727,16,NULL,'cmdb2-1-8-4'),(NULL,0,'2019-11-29 22:14:44',NULL,8994,'0',9551,727,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:44',NULL,8995,'0',9552,727,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:44',NULL,8996,'0',9553,727,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:44',NULL,8997,'0',9554,727,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:44',NULL,8998,'0',9555,727,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:44',NULL,8999,'0',9556,727,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:44',NULL,9000,'0',9557,727,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:44',NULL,9001,'0',9558,727,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:44',NULL,9002,'0',9559,727,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:45',NULL,9003,'1',9560,727,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9004,'0',9561,728,16,NULL,'cmdb2-1-8-5'),(NULL,0,'2019-11-29 22:14:45',NULL,9005,'0',9562,728,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:45',NULL,9006,'0',9563,728,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:45',NULL,9007,'0',9564,728,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:45',NULL,9008,'0',9565,728,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:45',NULL,9009,'0',9566,728,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:45',NULL,9010,'0',9567,728,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:45',NULL,9011,'0',9568,728,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:45',NULL,9012,'0',9569,728,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:45',NULL,9013,'0',9570,728,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:45',NULL,9014,'1',9571,728,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9015,'0',9572,729,16,NULL,'cmdb2-1-8-6'),(NULL,0,'2019-11-29 22:14:45',NULL,9016,'0',9573,729,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:45',NULL,9017,'0',9574,729,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:45',NULL,9018,'0',9575,729,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:45',NULL,9019,'0',9576,729,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:45',NULL,9020,'0',9577,729,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:45',NULL,9021,'0',9578,729,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:45',NULL,9022,'0',9579,729,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:45',NULL,9023,'0',9580,729,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:45',NULL,9024,'0',9581,729,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:45',NULL,9025,'1',9582,729,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9026,'0',9583,730,16,NULL,'cmdb2-1-8-7'),(NULL,0,'2019-11-29 22:14:45',NULL,9027,'0',9584,730,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:45',NULL,9028,'0',9585,730,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:45',NULL,9029,'0',9586,730,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:45',NULL,9030,'0',9587,730,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:45',NULL,9031,'0',9588,730,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:45',NULL,9032,'0',9589,730,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:45',NULL,9033,'0',9590,730,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:45',NULL,9034,'0',9591,730,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:45',NULL,9035,'0',9592,730,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:45',NULL,9036,'1',9593,730,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9037,'0',9594,731,16,NULL,'cmdb2-1-8-8'),(NULL,0,'2019-11-29 22:14:45',NULL,9038,'0',9595,731,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:45',NULL,9039,'0',9596,731,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:45',NULL,9040,'0',9597,731,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:45',NULL,9041,'0',9598,731,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:45',NULL,9042,'0',9599,731,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:45',NULL,9043,'0',9600,731,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:45',NULL,9044,'0',9601,731,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:45',NULL,9045,'0',9602,731,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:45',NULL,9046,'0',9603,731,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:46',NULL,9047,'1',9604,731,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9048,'0',9605,732,16,NULL,'cmdb2-1-8-9'),(NULL,0,'2019-11-29 22:14:46',NULL,9049,'0',9606,732,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:46',NULL,9050,'0',9607,732,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:46',NULL,9051,'0',9608,732,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:46',NULL,9052,'0',9609,732,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:46',NULL,9053,'0',9610,732,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:46',NULL,9054,'0',9611,732,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:46',NULL,9055,'0',9612,732,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:46',NULL,9056,'0',9613,732,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:46',NULL,9057,'0',9614,732,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:46',NULL,9058,'1',9615,732,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9059,'0',9616,733,16,NULL,'cmdb2-1-8-10'),(NULL,0,'2019-11-29 22:14:46',NULL,9060,'0',9617,733,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:46',NULL,9061,'0',9618,733,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:46',NULL,9062,'0',9619,733,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:46',NULL,9063,'0',9620,733,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:46',NULL,9064,'0',9621,733,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:46',NULL,9065,'0',9622,733,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:46',NULL,9066,'0',9623,733,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:46',NULL,9067,'0',9624,733,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:46',NULL,9068,'0',9625,733,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:46',NULL,9069,'1',9626,733,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9070,'0',9627,734,16,NULL,'cmdb2-1-8-11'),(NULL,0,'2019-11-29 22:14:46',NULL,9071,'0',9628,734,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:46',NULL,9072,'0',9629,734,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:46',NULL,9073,'0',9630,734,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:46',NULL,9074,'0',9631,734,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:46',NULL,9075,'0',9632,734,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:46',NULL,9076,'0',9633,734,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:46',NULL,9077,'0',9634,734,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:46',NULL,9078,'0',9635,734,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:46',NULL,9079,'0',9636,734,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:46',NULL,9080,'1',9637,734,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9081,'0',9638,735,16,NULL,'cmdb2-1-8-12'),(NULL,0,'2019-11-29 22:14:46',NULL,9082,'0',9639,735,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:46',NULL,9083,'0',9640,735,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:46',NULL,9084,'0',9641,735,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:46',NULL,9085,'0',9642,735,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:46',NULL,9086,'0',9643,735,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:46',NULL,9087,'0',9644,735,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:46',NULL,9088,'0',9645,735,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:46',NULL,9089,'0',9646,735,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:46',NULL,9090,'0',9647,735,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:47',NULL,9091,'1',9648,735,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9092,'0',9649,736,16,NULL,'cmdb2-1-8-13'),(NULL,0,'2019-11-29 22:14:47',NULL,9093,'0',9650,736,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:47',NULL,9094,'0',9651,736,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:47',NULL,9095,'0',9652,736,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:47',NULL,9096,'0',9653,736,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:47',NULL,9097,'0',9654,736,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:47',NULL,9098,'0',9655,736,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:47',NULL,9099,'0',9656,736,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:47',NULL,9100,'0',9657,736,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:47',NULL,9101,'0',9658,736,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:47',NULL,9102,'1',9659,736,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9103,'0',9660,737,16,NULL,'cmdb2-1-8-14'),(NULL,0,'2019-11-29 22:14:47',NULL,9104,'0',9661,737,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:47',NULL,9105,'0',9662,737,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:47',NULL,9106,'0',9663,737,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:47',NULL,9107,'0',9664,737,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:47',NULL,9108,'0',9665,737,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:47',NULL,9109,'0',9666,737,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:47',NULL,9110,'0',9667,737,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:47',NULL,9111,'0',9668,737,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:47',NULL,9112,'0',9669,737,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:47',NULL,9113,'1',9670,737,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9114,'0',9671,738,16,NULL,'cmdb2-1-8-15'),(NULL,0,'2019-11-29 22:14:47',NULL,9115,'0',9672,738,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:47',NULL,9116,'0',9673,738,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:47',NULL,9117,'0',9674,738,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:47',NULL,9118,'0',9675,738,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:47',NULL,9119,'0',9676,738,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:47',NULL,9120,'0',9677,738,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:47',NULL,9121,'0',9678,738,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:47',NULL,9122,'0',9679,738,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:47',NULL,9123,'0',9680,738,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:47',NULL,9124,'1',9681,738,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9125,'0',9682,739,16,NULL,'cmdb2-1-8-16'),(NULL,0,'2019-11-29 22:14:47',NULL,9126,'0',9683,739,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:47',NULL,9127,'0',9684,739,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:47',NULL,9128,'0',9685,739,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:47',NULL,9129,'0',9686,739,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:47',NULL,9130,'0',9687,739,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:47',NULL,9131,'0',9688,739,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:47',NULL,9132,'0',9689,739,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:47',NULL,9133,'0',9690,739,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:47',NULL,9134,'0',9691,739,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:47',NULL,9135,'1',9692,739,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9136,'0',9693,740,3,NULL,'产品线2-2'),(NULL,0,'2019-11-29 22:14:48',NULL,9137,'0',9695,741,4,NULL,'App2-2-1'),(NULL,0,'2019-11-29 22:14:48',NULL,9138,'0',9697,742,16,NULL,'cmdb2-2-1-1'),(NULL,0,'2019-11-29 22:14:48',NULL,9139,'0',9698,742,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:48',NULL,9140,'0',9699,742,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:48',NULL,9141,'0',9700,742,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:48',NULL,9142,'0',9701,742,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:48',NULL,9143,'0',9702,742,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:48',NULL,9144,'0',9703,742,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:48',NULL,9145,'0',9704,742,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:48',NULL,9146,'0',9705,742,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:48',NULL,9147,'0',9706,742,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:48',NULL,9148,'1',9707,742,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9149,'0',9708,743,16,NULL,'cmdb2-2-1-2'),(NULL,0,'2019-11-29 22:14:48',NULL,9150,'0',9709,743,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:48',NULL,9151,'0',9710,743,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:48',NULL,9152,'0',9711,743,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:48',NULL,9153,'0',9712,743,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:48',NULL,9154,'0',9713,743,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:48',NULL,9155,'0',9714,743,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:48',NULL,9156,'0',9715,743,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:48',NULL,9157,'0',9716,743,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:48',NULL,9158,'0',9717,743,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:48',NULL,9159,'1',9718,743,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9160,'0',9719,744,16,NULL,'cmdb2-2-1-3'),(NULL,0,'2019-11-29 22:14:48',NULL,9161,'0',9720,744,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:48',NULL,9162,'0',9721,744,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:48',NULL,9163,'0',9722,744,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:48',NULL,9164,'0',9723,744,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:48',NULL,9165,'0',9724,744,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:48',NULL,9166,'0',9725,744,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:48',NULL,9167,'0',9726,744,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:48',NULL,9168,'0',9727,744,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:48',NULL,9169,'0',9728,744,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:48',NULL,9170,'1',9729,744,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9171,'0',9730,745,16,NULL,'cmdb2-2-1-4'),(NULL,0,'2019-11-29 22:14:48',NULL,9172,'0',9731,745,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:48',NULL,9173,'0',9732,745,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:48',NULL,9174,'0',9733,745,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:48',NULL,9175,'0',9734,745,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:48',NULL,9176,'0',9735,745,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:48',NULL,9177,'0',9736,745,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:48',NULL,9178,'0',9737,745,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:48',NULL,9179,'0',9738,745,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:48',NULL,9180,'0',9739,745,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:49',NULL,9181,'1',9740,745,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9182,'0',9741,746,16,NULL,'cmdb2-2-1-5'),(NULL,0,'2019-11-29 22:14:49',NULL,9183,'0',9742,746,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:49',NULL,9184,'0',9743,746,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:49',NULL,9185,'0',9744,746,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:49',NULL,9186,'0',9745,746,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:49',NULL,9187,'0',9746,746,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:49',NULL,9188,'0',9747,746,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:49',NULL,9189,'0',9748,746,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:49',NULL,9190,'0',9749,746,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:49',NULL,9191,'0',9750,746,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:49',NULL,9192,'1',9751,746,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9193,'0',9752,747,16,NULL,'cmdb2-2-1-6'),(NULL,0,'2019-11-29 22:14:49',NULL,9194,'0',9753,747,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:49',NULL,9195,'0',9754,747,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:49',NULL,9196,'0',9755,747,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:49',NULL,9197,'0',9756,747,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:49',NULL,9198,'0',9757,747,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:49',NULL,9199,'0',9758,747,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:49',NULL,9200,'0',9759,747,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:49',NULL,9201,'0',9760,747,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:49',NULL,9202,'0',9761,747,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:49',NULL,9203,'1',9762,747,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9204,'0',9763,748,16,NULL,'cmdb2-2-1-7'),(NULL,0,'2019-11-29 22:14:49',NULL,9205,'0',9764,748,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:49',NULL,9206,'0',9765,748,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:49',NULL,9207,'0',9766,748,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:49',NULL,9208,'0',9767,748,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:49',NULL,9209,'0',9768,748,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:49',NULL,9210,'0',9769,748,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:49',NULL,9211,'0',9770,748,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:49',NULL,9212,'0',9771,748,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:49',NULL,9213,'0',9772,748,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:49',NULL,9214,'1',9773,748,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9215,'0',9774,749,16,NULL,'cmdb2-2-1-8'),(NULL,0,'2019-11-29 22:14:49',NULL,9216,'0',9775,749,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:49',NULL,9217,'0',9776,749,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:49',NULL,9218,'0',9777,749,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:49',NULL,9219,'0',9778,749,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:49',NULL,9220,'0',9779,749,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:49',NULL,9221,'0',9780,749,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:49',NULL,9222,'0',9781,749,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:49',NULL,9223,'0',9782,749,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:49',NULL,9224,'0',9783,749,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:50',NULL,9225,'1',9784,749,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9226,'0',9785,750,16,NULL,'cmdb2-2-1-9'),(NULL,0,'2019-11-29 22:14:50',NULL,9227,'0',9786,750,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:50',NULL,9228,'0',9787,750,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:50',NULL,9229,'0',9788,750,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:50',NULL,9230,'0',9789,750,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:50',NULL,9231,'0',9790,750,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:50',NULL,9232,'0',9791,750,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:50',NULL,9233,'0',9792,750,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:50',NULL,9234,'0',9793,750,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:50',NULL,9235,'0',9794,750,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:50',NULL,9236,'1',9795,750,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9237,'0',9796,751,16,NULL,'cmdb2-2-1-10'),(NULL,0,'2019-11-29 22:14:50',NULL,9238,'0',9797,751,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:50',NULL,9239,'0',9798,751,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:50',NULL,9240,'0',9799,751,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:50',NULL,9241,'0',9800,751,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:50',NULL,9242,'0',9801,751,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:50',NULL,9243,'0',9802,751,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:50',NULL,9244,'0',9803,751,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:50',NULL,9245,'0',9804,751,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:50',NULL,9246,'0',9805,751,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:50',NULL,9247,'1',9806,751,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9248,'0',9807,752,16,NULL,'cmdb2-2-1-11'),(NULL,0,'2019-11-29 22:14:50',NULL,9249,'0',9808,752,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:50',NULL,9250,'0',9809,752,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:50',NULL,9251,'0',9810,752,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:50',NULL,9252,'0',9811,752,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:50',NULL,9253,'0',9812,752,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:50',NULL,9254,'0',9813,752,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:50',NULL,9255,'0',9814,752,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:50',NULL,9256,'0',9815,752,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:50',NULL,9257,'0',9816,752,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:50',NULL,9258,'1',9817,752,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9259,'0',9818,753,16,NULL,'cmdb2-2-1-12'),(NULL,0,'2019-11-29 22:14:50',NULL,9260,'0',9819,753,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:50',NULL,9261,'0',9820,753,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:50',NULL,9262,'0',9821,753,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:50',NULL,9263,'0',9822,753,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:50',NULL,9264,'0',9823,753,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:50',NULL,9265,'0',9824,753,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:50',NULL,9266,'0',9825,753,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:50',NULL,9267,'0',9826,753,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:50',NULL,9268,'0',9827,753,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:51',NULL,9269,'1',9828,753,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9270,'0',9829,754,16,NULL,'cmdb2-2-1-13'),(NULL,0,'2019-11-29 22:14:51',NULL,9271,'0',9830,754,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:51',NULL,9272,'0',9831,754,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:51',NULL,9273,'0',9832,754,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:51',NULL,9274,'0',9833,754,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:51',NULL,9275,'0',9834,754,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:51',NULL,9276,'0',9835,754,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:51',NULL,9277,'0',9836,754,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:51',NULL,9278,'0',9837,754,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:51',NULL,9279,'0',9838,754,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:51',NULL,9280,'1',9839,754,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9281,'0',9840,755,16,NULL,'cmdb2-2-1-14'),(NULL,0,'2019-11-29 22:14:51',NULL,9282,'0',9841,755,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:51',NULL,9283,'0',9842,755,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:51',NULL,9284,'0',9843,755,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:51',NULL,9285,'0',9844,755,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:51',NULL,9286,'0',9845,755,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:51',NULL,9287,'0',9846,755,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:51',NULL,9288,'0',9847,755,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:51',NULL,9289,'0',9848,755,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:51',NULL,9290,'0',9849,755,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:51',NULL,9291,'1',9850,755,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9292,'0',9851,756,16,NULL,'cmdb2-2-1-15'),(NULL,0,'2019-11-29 22:14:51',NULL,9293,'0',9852,756,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:51',NULL,9294,'0',9853,756,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:51',NULL,9295,'0',9854,756,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:51',NULL,9296,'0',9855,756,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:51',NULL,9297,'0',9856,756,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:51',NULL,9298,'0',9857,756,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:51',NULL,9299,'0',9858,756,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:51',NULL,9300,'0',9859,756,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:51',NULL,9301,'0',9860,756,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:51',NULL,9302,'1',9861,756,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9303,'0',9862,757,16,NULL,'cmdb2-2-1-16'),(NULL,0,'2019-11-29 22:14:51',NULL,9304,'0',9863,757,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:51',NULL,9305,'0',9864,757,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:51',NULL,9306,'0',9865,757,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:51',NULL,9307,'0',9866,757,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:51',NULL,9308,'0',9867,757,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:51',NULL,9309,'0',9868,757,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:51',NULL,9310,'0',9869,757,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:51',NULL,9311,'0',9870,757,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:51',NULL,9312,'0',9871,757,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:52',NULL,9313,'1',9872,757,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9314,'0',9873,758,4,NULL,'App2-2-2'),(NULL,0,'2019-11-29 22:14:52',NULL,9315,'0',9875,759,16,NULL,'cmdb2-2-2-1'),(NULL,0,'2019-11-29 22:14:52',NULL,9316,'0',9876,759,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:52',NULL,9317,'0',9877,759,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:52',NULL,9318,'0',9878,759,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:52',NULL,9319,'0',9879,759,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:52',NULL,9320,'0',9880,759,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:52',NULL,9321,'0',9881,759,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:52',NULL,9322,'0',9882,759,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:52',NULL,9323,'0',9883,759,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:52',NULL,9324,'0',9884,759,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:52',NULL,9325,'1',9885,759,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9326,'0',9886,760,16,NULL,'cmdb2-2-2-2'),(NULL,0,'2019-11-29 22:14:52',NULL,9327,'0',9887,760,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:52',NULL,9328,'0',9888,760,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:52',NULL,9329,'0',9889,760,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:52',NULL,9330,'0',9890,760,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:52',NULL,9331,'0',9891,760,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:52',NULL,9332,'0',9892,760,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:52',NULL,9333,'0',9893,760,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:52',NULL,9334,'0',9894,760,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:52',NULL,9335,'0',9895,760,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:52',NULL,9336,'1',9896,760,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9337,'0',9897,761,16,NULL,'cmdb2-2-2-3'),(NULL,0,'2019-11-29 22:14:52',NULL,9338,'0',9898,761,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:52',NULL,9339,'0',9899,761,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:52',NULL,9340,'0',9900,761,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:52',NULL,9341,'0',9901,761,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:52',NULL,9342,'0',9902,761,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:52',NULL,9343,'0',9903,761,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:52',NULL,9344,'0',9904,761,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:52',NULL,9345,'0',9905,761,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:52',NULL,9346,'0',9906,761,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:52',NULL,9347,'1',9907,761,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9348,'0',9908,762,16,NULL,'cmdb2-2-2-4'),(NULL,0,'2019-11-29 22:14:52',NULL,9349,'0',9909,762,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:52',NULL,9350,'0',9910,762,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:52',NULL,9351,'0',9911,762,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:52',NULL,9352,'0',9912,762,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:52',NULL,9353,'0',9913,762,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:52',NULL,9354,'0',9914,762,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:52',NULL,9355,'0',9915,762,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:52',NULL,9356,'0',9916,762,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:52',NULL,9357,'0',9917,762,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:53',NULL,9358,'1',9918,762,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9359,'0',9919,763,16,NULL,'cmdb2-2-2-5'),(NULL,0,'2019-11-29 22:14:53',NULL,9360,'0',9920,763,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:53',NULL,9361,'0',9921,763,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:53',NULL,9362,'0',9922,763,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:53',NULL,9363,'0',9923,763,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:53',NULL,9364,'0',9924,763,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:53',NULL,9365,'0',9925,763,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:53',NULL,9366,'0',9926,763,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:53',NULL,9367,'0',9927,763,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:53',NULL,9368,'0',9928,763,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:53',NULL,9369,'1',9929,763,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9370,'0',9930,764,16,NULL,'cmdb2-2-2-6'),(NULL,0,'2019-11-29 22:14:53',NULL,9371,'0',9931,764,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:53',NULL,9372,'0',9932,764,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:53',NULL,9373,'0',9933,764,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:53',NULL,9374,'0',9934,764,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:53',NULL,9375,'0',9935,764,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:53',NULL,9376,'0',9936,764,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:53',NULL,9377,'0',9937,764,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:53',NULL,9378,'0',9938,764,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:53',NULL,9379,'0',9939,764,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:53',NULL,9380,'1',9940,764,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9381,'0',9941,765,16,NULL,'cmdb2-2-2-7'),(NULL,0,'2019-11-29 22:14:53',NULL,9382,'0',9942,765,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:53',NULL,9383,'0',9943,765,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:53',NULL,9384,'0',9944,765,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:53',NULL,9385,'0',9945,765,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:53',NULL,9386,'0',9946,765,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:53',NULL,9387,'0',9947,765,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:53',NULL,9388,'0',9948,765,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:53',NULL,9389,'0',9949,765,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:53',NULL,9390,'0',9950,765,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:53',NULL,9391,'1',9951,765,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9392,'0',9952,766,16,NULL,'cmdb2-2-2-8'),(NULL,0,'2019-11-29 22:14:53',NULL,9393,'0',9953,766,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:53',NULL,9394,'0',9954,766,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:53',NULL,9395,'0',9955,766,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:53',NULL,9396,'0',9956,766,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:53',NULL,9397,'0',9957,766,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:53',NULL,9398,'0',9958,766,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:53',NULL,9399,'0',9959,766,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:53',NULL,9400,'0',9960,766,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:53',NULL,9401,'0',9961,766,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:54',NULL,9402,'1',9962,766,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9403,'0',9963,767,16,NULL,'cmdb2-2-2-9'),(NULL,0,'2019-11-29 22:14:54',NULL,9404,'0',9964,767,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:54',NULL,9405,'0',9965,767,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:54',NULL,9406,'0',9966,767,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:54',NULL,9407,'0',9967,767,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:54',NULL,9408,'0',9968,767,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:54',NULL,9409,'0',9969,767,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:54',NULL,9410,'0',9970,767,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:54',NULL,9411,'0',9971,767,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:54',NULL,9412,'0',9972,767,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:54',NULL,9413,'1',9973,767,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9414,'0',9974,768,16,NULL,'cmdb2-2-2-10'),(NULL,0,'2019-11-29 22:14:54',NULL,9415,'0',9975,768,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:54',NULL,9416,'0',9976,768,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:54',NULL,9417,'0',9977,768,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:54',NULL,9418,'0',9978,768,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:54',NULL,9419,'0',9979,768,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:54',NULL,9420,'0',9980,768,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:54',NULL,9421,'0',9981,768,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:54',NULL,9422,'0',9982,768,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:54',NULL,9423,'0',9983,768,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:54',NULL,9424,'1',9984,768,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9425,'0',9985,769,16,NULL,'cmdb2-2-2-11'),(NULL,0,'2019-11-29 22:14:54',NULL,9426,'0',9986,769,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:54',NULL,9427,'0',9987,769,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:54',NULL,9428,'0',9988,769,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:54',NULL,9429,'0',9989,769,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:54',NULL,9430,'0',9990,769,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:54',NULL,9431,'0',9991,769,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:54',NULL,9432,'0',9992,769,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:54',NULL,9433,'0',9993,769,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:54',NULL,9434,'0',9994,769,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:54',NULL,9435,'1',9995,769,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9436,'0',9996,770,16,NULL,'cmdb2-2-2-12'),(NULL,0,'2019-11-29 22:14:54',NULL,9437,'0',9997,770,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:54',NULL,9438,'0',9998,770,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:54',NULL,9439,'0',9999,770,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:54',NULL,9440,'0',10000,770,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:54',NULL,9441,'0',10001,770,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:54',NULL,9442,'0',10002,770,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:54',NULL,9443,'0',10003,770,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:54',NULL,9444,'0',10004,770,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:54',NULL,9445,'0',10005,770,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:55',NULL,9446,'1',10006,770,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,9447,'0',10007,771,16,NULL,'cmdb2-2-2-13'),(NULL,0,'2019-11-29 22:14:55',NULL,9448,'0',10008,771,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:55',NULL,9449,'0',10009,771,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:55',NULL,9450,'0',10010,771,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:55',NULL,9451,'0',10011,771,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:55',NULL,9452,'0',10012,771,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:55',NULL,9453,'0',10013,771,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:55',NULL,9454,'0',10014,771,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:55',NULL,9455,'0',10015,771,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:55',NULL,9456,'0',10016,771,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:55',NULL,9457,'1',10017,771,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,9458,'0',10018,772,16,NULL,'cmdb2-2-2-14'),(NULL,0,'2019-11-29 22:14:55',NULL,9459,'0',10019,772,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:55',NULL,9460,'0',10020,772,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:55',NULL,9461,'0',10021,772,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:55',NULL,9462,'0',10022,772,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:55',NULL,9463,'0',10023,772,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:55',NULL,9464,'0',10024,772,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:55',NULL,9465,'0',10025,772,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:55',NULL,9466,'0',10026,772,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:55',NULL,9467,'0',10027,772,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:55',NULL,9468,'1',10028,772,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,9469,'0',10029,773,16,NULL,'cmdb2-2-2-15'),(NULL,0,'2019-11-29 22:14:55',NULL,9470,'0',10030,773,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:55',NULL,9471,'0',10031,773,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:55',NULL,9472,'0',10032,773,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:55',NULL,9473,'0',10033,773,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:55',NULL,9474,'0',10034,773,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:55',NULL,9475,'0',10035,773,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:55',NULL,9476,'0',10036,773,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:55',NULL,9477,'0',10037,773,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:55',NULL,9478,'0',10038,773,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:55',NULL,9479,'1',10039,773,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,9480,'0',10040,774,16,NULL,'cmdb2-2-2-16'),(NULL,0,'2019-11-29 22:14:55',NULL,9481,'0',10041,774,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:55',NULL,9482,'0',10042,774,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:55',NULL,9483,'0',10043,774,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:55',NULL,9484,'0',10044,774,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:55',NULL,9485,'0',10045,774,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:55',NULL,9486,'0',10046,774,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:55',NULL,9487,'0',10047,774,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:55',NULL,9488,'0',10048,774,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:55',NULL,9489,'0',10049,774,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:55',NULL,9490,'1',10050,774,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,9491,'0',10051,775,4,NULL,'App2-2-3'),(NULL,0,'2019-11-29 22:14:56',NULL,9492,'0',10053,776,16,NULL,'cmdb2-2-3-1'),(NULL,0,'2019-11-29 22:14:56',NULL,9493,'0',10054,776,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:56',NULL,9494,'0',10055,776,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:56',NULL,9495,'0',10056,776,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:56',NULL,9496,'0',10057,776,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:56',NULL,9497,'0',10058,776,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:56',NULL,9498,'0',10059,776,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:56',NULL,9499,'0',10060,776,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:56',NULL,9500,'0',10061,776,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:56',NULL,9501,'0',10062,776,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:56',NULL,9502,'1',10063,776,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,9503,'0',10064,777,16,NULL,'cmdb2-2-3-2'),(NULL,0,'2019-11-29 22:14:56',NULL,9504,'0',10065,777,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:56',NULL,9505,'0',10066,777,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:56',NULL,9506,'0',10067,777,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:56',NULL,9507,'0',10068,777,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:56',NULL,9508,'0',10069,777,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:56',NULL,9509,'0',10070,777,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:56',NULL,9510,'0',10071,777,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:56',NULL,9511,'0',10072,777,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:56',NULL,9512,'0',10073,777,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:56',NULL,9513,'1',10074,777,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,9514,'0',10075,778,16,NULL,'cmdb2-2-3-3'),(NULL,0,'2019-11-29 22:14:56',NULL,9515,'0',10076,778,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:56',NULL,9516,'0',10077,778,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:56',NULL,9517,'0',10078,778,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:56',NULL,9518,'0',10079,778,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:56',NULL,9519,'0',10080,778,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:56',NULL,9520,'0',10081,778,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:56',NULL,9521,'0',10082,778,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:56',NULL,9522,'0',10083,778,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:56',NULL,9523,'0',10084,778,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:56',NULL,9524,'1',10085,778,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,9525,'0',10086,779,16,NULL,'cmdb2-2-3-4'),(NULL,0,'2019-11-29 22:14:56',NULL,9526,'0',10087,779,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:56',NULL,9527,'0',10088,779,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:56',NULL,9528,'0',10089,779,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:56',NULL,9529,'0',10090,779,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:56',NULL,9530,'0',10091,779,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:56',NULL,9531,'0',10092,779,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:56',NULL,9532,'0',10093,779,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:56',NULL,9533,'0',10094,779,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:56',NULL,9534,'0',10095,779,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:57',NULL,9535,'1',10096,779,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,9536,'0',10097,780,16,NULL,'cmdb2-2-3-5'),(NULL,0,'2019-11-29 22:14:57',NULL,9537,'0',10098,780,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:57',NULL,9538,'0',10099,780,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:57',NULL,9539,'0',10100,780,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:57',NULL,9540,'0',10101,780,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:57',NULL,9541,'0',10102,780,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:57',NULL,9542,'0',10103,780,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:57',NULL,9543,'0',10104,780,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:57',NULL,9544,'0',10105,780,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:57',NULL,9545,'0',10106,780,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:57',NULL,9546,'1',10107,780,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,9547,'0',10108,781,16,NULL,'cmdb2-2-3-6'),(NULL,0,'2019-11-29 22:14:57',NULL,9548,'0',10109,781,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:57',NULL,9549,'0',10110,781,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:57',NULL,9550,'0',10111,781,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:57',NULL,9551,'0',10112,781,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:57',NULL,9552,'0',10113,781,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:57',NULL,9553,'0',10114,781,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:57',NULL,9554,'0',10115,781,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:57',NULL,9555,'0',10116,781,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:57',NULL,9556,'0',10117,781,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:57',NULL,9557,'1',10118,781,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,9558,'0',10119,782,16,NULL,'cmdb2-2-3-7'),(NULL,0,'2019-11-29 22:14:57',NULL,9559,'0',10120,782,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:57',NULL,9560,'0',10121,782,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:57',NULL,9561,'0',10122,782,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:57',NULL,9562,'0',10123,782,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:57',NULL,9563,'0',10124,782,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:57',NULL,9564,'0',10125,782,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:57',NULL,9565,'0',10126,782,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:57',NULL,9566,'0',10127,782,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:57',NULL,9567,'0',10128,782,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:57',NULL,9568,'1',10129,782,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,9569,'0',10130,783,16,NULL,'cmdb2-2-3-8'),(NULL,0,'2019-11-29 22:14:57',NULL,9570,'0',10131,783,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:57',NULL,9571,'0',10132,783,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:57',NULL,9572,'0',10133,783,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:57',NULL,9573,'0',10134,783,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:57',NULL,9574,'0',10135,783,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:57',NULL,9575,'0',10136,783,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:57',NULL,9576,'0',10137,783,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:57',NULL,9577,'0',10138,783,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:57',NULL,9578,'0',10139,783,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:58',NULL,9579,'1',10140,783,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,9580,'0',10141,784,16,NULL,'cmdb2-2-3-9'),(NULL,0,'2019-11-29 22:14:58',NULL,9581,'0',10142,784,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:58',NULL,9582,'0',10143,784,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:58',NULL,9583,'0',10144,784,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:58',NULL,9584,'0',10145,784,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:58',NULL,9585,'0',10146,784,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:58',NULL,9586,'0',10147,784,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:58',NULL,9587,'0',10148,784,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:58',NULL,9588,'0',10149,784,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:58',NULL,9589,'0',10150,784,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:58',NULL,9590,'1',10151,784,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,9591,'0',10152,785,16,NULL,'cmdb2-2-3-10'),(NULL,0,'2019-11-29 22:14:58',NULL,9592,'0',10153,785,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:58',NULL,9593,'0',10154,785,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:58',NULL,9594,'0',10155,785,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:58',NULL,9595,'0',10156,785,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:58',NULL,9596,'0',10157,785,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:58',NULL,9597,'0',10158,785,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:58',NULL,9598,'0',10159,785,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:58',NULL,9599,'0',10160,785,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:58',NULL,9600,'0',10161,785,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:58',NULL,9601,'1',10162,785,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,9602,'0',10163,786,16,NULL,'cmdb2-2-3-11'),(NULL,0,'2019-11-29 22:14:58',NULL,9603,'0',10164,786,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:58',NULL,9604,'0',10165,786,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:58',NULL,9605,'0',10166,786,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:58',NULL,9606,'0',10167,786,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:58',NULL,9607,'0',10168,786,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:58',NULL,9608,'0',10169,786,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:58',NULL,9609,'0',10170,786,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:58',NULL,9610,'0',10171,786,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:58',NULL,9611,'0',10172,786,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:58',NULL,9612,'1',10173,786,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,9613,'0',10174,787,16,NULL,'cmdb2-2-3-12'),(NULL,0,'2019-11-29 22:14:58',NULL,9614,'0',10175,787,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:58',NULL,9615,'0',10176,787,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:58',NULL,9616,'0',10177,787,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:58',NULL,9617,'0',10178,787,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:58',NULL,9618,'0',10179,787,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:58',NULL,9619,'0',10180,787,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:58',NULL,9620,'0',10181,787,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:58',NULL,9621,'0',10182,787,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:58',NULL,9622,'0',10183,787,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:59',NULL,9623,'1',10184,787,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,9624,'0',10185,788,16,NULL,'cmdb2-2-3-13'),(NULL,0,'2019-11-29 22:14:59',NULL,9625,'0',10186,788,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:59',NULL,9626,'0',10187,788,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:59',NULL,9627,'0',10188,788,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:59',NULL,9628,'0',10189,788,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:59',NULL,9629,'0',10190,788,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:59',NULL,9630,'0',10191,788,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:59',NULL,9631,'0',10192,788,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:59',NULL,9632,'0',10193,788,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:59',NULL,9633,'0',10194,788,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:59',NULL,9634,'1',10195,788,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,9635,'0',10196,789,16,NULL,'cmdb2-2-3-14'),(NULL,0,'2019-11-29 22:14:59',NULL,9636,'0',10197,789,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:59',NULL,9637,'0',10198,789,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:59',NULL,9638,'0',10199,789,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:59',NULL,9639,'0',10200,789,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:59',NULL,9640,'0',10201,789,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:59',NULL,9641,'0',10202,789,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:59',NULL,9642,'0',10203,789,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:59',NULL,9643,'0',10204,789,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:59',NULL,9644,'0',10205,789,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:59',NULL,9645,'1',10206,789,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,9646,'0',10207,790,16,NULL,'cmdb2-2-3-15'),(NULL,0,'2019-11-29 22:14:59',NULL,9647,'0',10208,790,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:59',NULL,9648,'0',10209,790,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:59',NULL,9649,'0',10210,790,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:59',NULL,9650,'0',10211,790,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:59',NULL,9651,'0',10212,790,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:59',NULL,9652,'0',10213,790,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:59',NULL,9653,'0',10214,790,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:59',NULL,9654,'0',10215,790,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:59',NULL,9655,'0',10216,790,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:59',NULL,9656,'1',10217,790,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,9657,'0',10218,791,16,NULL,'cmdb2-2-3-16'),(NULL,0,'2019-11-29 22:14:59',NULL,9658,'0',10219,791,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:59',NULL,9659,'0',10220,791,22,NULL,'2'),(NULL,0,'2019-11-29 22:14:59',NULL,9660,'0',10221,791,28,NULL,'prod'),(NULL,0,'2019-11-29 22:14:59',NULL,9661,'0',10222,791,24,NULL,'enable'),(NULL,0,'2019-11-29 22:14:59',NULL,9662,'0',10223,791,29,NULL,'张江'),(NULL,0,'2019-11-29 22:14:59',NULL,9663,'0',10224,791,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:59',NULL,9664,'0',10225,791,23,NULL,'40'),(NULL,0,'2019-11-29 22:14:59',NULL,9665,'0',10226,791,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:14:59',NULL,9666,'0',10227,791,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:59',NULL,9667,'1',10228,791,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,9668,'0',10229,792,4,NULL,'App2-2-4'),(NULL,0,'2019-11-29 22:15:00',NULL,9669,'0',10231,793,16,NULL,'cmdb2-2-4-1'),(NULL,0,'2019-11-29 22:15:00',NULL,9670,'0',10232,793,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:00',NULL,9671,'0',10233,793,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:00',NULL,9672,'0',10234,793,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:00',NULL,9673,'0',10235,793,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:00',NULL,9674,'0',10236,793,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:00',NULL,9675,'0',10237,793,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:00',NULL,9676,'0',10238,793,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:00',NULL,9677,'0',10239,793,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:00',NULL,9678,'0',10240,793,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:00',NULL,9679,'1',10241,793,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,9680,'0',10242,794,16,NULL,'cmdb2-2-4-2'),(NULL,0,'2019-11-29 22:15:00',NULL,9681,'0',10243,794,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:00',NULL,9682,'0',10244,794,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:00',NULL,9683,'0',10245,794,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:00',NULL,9684,'0',10246,794,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:00',NULL,9685,'0',10247,794,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:00',NULL,9686,'0',10248,794,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:00',NULL,9687,'0',10249,794,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:00',NULL,9688,'0',10250,794,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:00',NULL,9689,'0',10251,794,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:00',NULL,9690,'1',10252,794,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,9691,'0',10253,795,16,NULL,'cmdb2-2-4-3'),(NULL,0,'2019-11-29 22:15:00',NULL,9692,'0',10254,795,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:00',NULL,9693,'0',10255,795,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:00',NULL,9694,'0',10256,795,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:00',NULL,9695,'0',10257,795,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:00',NULL,9696,'0',10258,795,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:00',NULL,9697,'0',10259,795,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:00',NULL,9698,'0',10260,795,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:00',NULL,9699,'0',10261,795,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:00',NULL,9700,'0',10262,795,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:00',NULL,9701,'1',10263,795,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,9702,'0',10264,796,16,NULL,'cmdb2-2-4-4'),(NULL,0,'2019-11-29 22:15:00',NULL,9703,'0',10265,796,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:00',NULL,9704,'0',10266,796,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:00',NULL,9705,'0',10267,796,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:00',NULL,9706,'0',10268,796,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:00',NULL,9707,'0',10269,796,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:00',NULL,9708,'0',10270,796,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:00',NULL,9709,'0',10271,796,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:00',NULL,9710,'0',10272,796,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:00',NULL,9711,'0',10273,796,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:01',NULL,9712,'1',10274,796,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,9713,'0',10275,797,16,NULL,'cmdb2-2-4-5'),(NULL,0,'2019-11-29 22:15:01',NULL,9714,'0',10276,797,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:01',NULL,9715,'0',10277,797,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:01',NULL,9716,'0',10278,797,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:01',NULL,9717,'0',10279,797,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:01',NULL,9718,'0',10280,797,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:01',NULL,9719,'0',10281,797,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:01',NULL,9720,'0',10282,797,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:01',NULL,9721,'0',10283,797,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:01',NULL,9722,'0',10284,797,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:01',NULL,9723,'1',10285,797,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,9724,'0',10286,798,16,NULL,'cmdb2-2-4-6'),(NULL,0,'2019-11-29 22:15:01',NULL,9725,'0',10287,798,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:01',NULL,9726,'0',10288,798,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:01',NULL,9727,'0',10289,798,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:01',NULL,9728,'0',10290,798,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:01',NULL,9729,'0',10291,798,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:01',NULL,9730,'0',10292,798,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:01',NULL,9731,'0',10293,798,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:01',NULL,9732,'0',10294,798,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:01',NULL,9733,'0',10295,798,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:01',NULL,9734,'1',10296,798,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,9735,'0',10297,799,16,NULL,'cmdb2-2-4-7'),(NULL,0,'2019-11-29 22:15:01',NULL,9736,'0',10298,799,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:01',NULL,9737,'0',10299,799,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:01',NULL,9738,'0',10300,799,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:01',NULL,9739,'0',10301,799,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:01',NULL,9740,'0',10302,799,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:01',NULL,9741,'0',10303,799,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:01',NULL,9742,'0',10304,799,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:01',NULL,9743,'0',10305,799,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:01',NULL,9744,'0',10306,799,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:01',NULL,9745,'1',10307,799,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,9746,'0',10308,800,16,NULL,'cmdb2-2-4-8'),(NULL,0,'2019-11-29 22:15:01',NULL,9747,'0',10309,800,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:01',NULL,9748,'0',10310,800,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:01',NULL,9749,'0',10311,800,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:01',NULL,9750,'0',10312,800,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:01',NULL,9751,'0',10313,800,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:01',NULL,9752,'0',10314,800,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:01',NULL,9753,'0',10315,800,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:01',NULL,9754,'0',10316,800,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:01',NULL,9755,'0',10317,800,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:02',NULL,9756,'1',10318,800,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,9757,'0',10319,801,16,NULL,'cmdb2-2-4-9'),(NULL,0,'2019-11-29 22:15:02',NULL,9758,'0',10320,801,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:02',NULL,9759,'0',10321,801,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:02',NULL,9760,'0',10322,801,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:02',NULL,9761,'0',10323,801,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:02',NULL,9762,'0',10324,801,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:02',NULL,9763,'0',10325,801,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:02',NULL,9764,'0',10326,801,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:02',NULL,9765,'0',10327,801,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:02',NULL,9766,'0',10328,801,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:02',NULL,9767,'1',10329,801,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,9768,'0',10330,802,16,NULL,'cmdb2-2-4-10'),(NULL,0,'2019-11-29 22:15:02',NULL,9769,'0',10331,802,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:02',NULL,9770,'0',10332,802,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:02',NULL,9771,'0',10333,802,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:02',NULL,9772,'0',10334,802,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:02',NULL,9773,'0',10335,802,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:02',NULL,9774,'0',10336,802,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:02',NULL,9775,'0',10337,802,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:02',NULL,9776,'0',10338,802,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:02',NULL,9777,'0',10339,802,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:02',NULL,9778,'1',10340,802,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,9779,'0',10341,803,16,NULL,'cmdb2-2-4-11'),(NULL,0,'2019-11-29 22:15:02',NULL,9780,'0',10342,803,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:02',NULL,9781,'0',10343,803,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:02',NULL,9782,'0',10344,803,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:02',NULL,9783,'0',10345,803,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:02',NULL,9784,'0',10346,803,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:02',NULL,9785,'0',10347,803,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:02',NULL,9786,'0',10348,803,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:02',NULL,9787,'0',10349,803,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:02',NULL,9788,'0',10350,803,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:02',NULL,9789,'1',10351,803,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,9790,'0',10352,804,16,NULL,'cmdb2-2-4-12'),(NULL,0,'2019-11-29 22:15:02',NULL,9791,'0',10353,804,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:02',NULL,9792,'0',10354,804,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:02',NULL,9793,'0',10355,804,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:02',NULL,9794,'0',10356,804,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:02',NULL,9795,'0',10357,804,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:02',NULL,9796,'0',10358,804,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:02',NULL,9797,'0',10359,804,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:02',NULL,9798,'0',10360,804,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:02',NULL,9799,'0',10361,804,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:02',NULL,9800,'1',10362,804,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,9801,'0',10363,805,16,NULL,'cmdb2-2-4-13'),(NULL,0,'2019-11-29 22:15:03',NULL,9802,'0',10364,805,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:03',NULL,9803,'0',10365,805,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:03',NULL,9804,'0',10366,805,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:03',NULL,9805,'0',10367,805,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:03',NULL,9806,'0',10368,805,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:03',NULL,9807,'0',10369,805,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:03',NULL,9808,'0',10370,805,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:03',NULL,9809,'0',10371,805,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:03',NULL,9810,'0',10372,805,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:03',NULL,9811,'1',10373,805,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,9812,'0',10374,806,16,NULL,'cmdb2-2-4-14'),(NULL,0,'2019-11-29 22:15:03',NULL,9813,'0',10375,806,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:03',NULL,9814,'0',10376,806,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:03',NULL,9815,'0',10377,806,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:03',NULL,9816,'0',10378,806,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:03',NULL,9817,'0',10379,806,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:03',NULL,9818,'0',10380,806,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:03',NULL,9819,'0',10381,806,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:03',NULL,9820,'0',10382,806,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:03',NULL,9821,'0',10383,806,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:03',NULL,9822,'1',10384,806,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,9823,'0',10385,807,16,NULL,'cmdb2-2-4-15'),(NULL,0,'2019-11-29 22:15:03',NULL,9824,'0',10386,807,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:03',NULL,9825,'0',10387,807,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:03',NULL,9826,'0',10388,807,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:03',NULL,9827,'0',10389,807,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:03',NULL,9828,'0',10390,807,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:03',NULL,9829,'0',10391,807,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:03',NULL,9830,'0',10392,807,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:03',NULL,9831,'0',10393,807,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:03',NULL,9832,'0',10394,807,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:03',NULL,9833,'1',10395,807,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,9834,'0',10396,808,16,NULL,'cmdb2-2-4-16'),(NULL,0,'2019-11-29 22:15:03',NULL,9835,'0',10397,808,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:03',NULL,9836,'0',10398,808,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:03',NULL,9837,'0',10399,808,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:03',NULL,9838,'0',10400,808,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:03',NULL,9839,'0',10401,808,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:03',NULL,9840,'0',10402,808,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:03',NULL,9841,'0',10403,808,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:03',NULL,9842,'0',10404,808,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:03',NULL,9843,'0',10405,808,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:03',NULL,9844,'1',10406,808,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,9845,'0',10407,809,4,NULL,'App2-2-5'),(NULL,0,'2019-11-29 22:15:04',NULL,9846,'0',10409,810,16,NULL,'cmdb2-2-5-1'),(NULL,0,'2019-11-29 22:15:04',NULL,9847,'0',10410,810,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:04',NULL,9848,'0',10411,810,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:04',NULL,9849,'0',10412,810,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:04',NULL,9850,'0',10413,810,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:04',NULL,9851,'0',10414,810,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:04',NULL,9852,'0',10415,810,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:04',NULL,9853,'0',10416,810,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:04',NULL,9854,'0',10417,810,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:04',NULL,9855,'0',10418,810,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:04',NULL,9856,'1',10419,810,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,9857,'0',10420,811,16,NULL,'cmdb2-2-5-2'),(NULL,0,'2019-11-29 22:15:04',NULL,9858,'0',10421,811,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:04',NULL,9859,'0',10422,811,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:04',NULL,9860,'0',10423,811,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:04',NULL,9861,'0',10424,811,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:04',NULL,9862,'0',10425,811,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:04',NULL,9863,'0',10426,811,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:04',NULL,9864,'0',10427,811,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:04',NULL,9865,'0',10428,811,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:04',NULL,9866,'0',10429,811,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:04',NULL,9867,'1',10430,811,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,9868,'0',10431,812,16,NULL,'cmdb2-2-5-3'),(NULL,0,'2019-11-29 22:15:04',NULL,9869,'0',10432,812,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:04',NULL,9870,'0',10433,812,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:04',NULL,9871,'0',10434,812,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:04',NULL,9872,'0',10435,812,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:04',NULL,9873,'0',10436,812,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:04',NULL,9874,'0',10437,812,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:04',NULL,9875,'0',10438,812,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:04',NULL,9876,'0',10439,812,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:04',NULL,9877,'0',10440,812,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:04',NULL,9878,'1',10441,812,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,9879,'0',10442,813,16,NULL,'cmdb2-2-5-4'),(NULL,0,'2019-11-29 22:15:04',NULL,9880,'0',10443,813,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:04',NULL,9881,'0',10444,813,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:04',NULL,9882,'0',10445,813,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:04',NULL,9883,'0',10446,813,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:04',NULL,9884,'0',10447,813,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:04',NULL,9885,'0',10448,813,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:04',NULL,9886,'0',10449,813,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:04',NULL,9887,'0',10450,813,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:04',NULL,9888,'0',10451,813,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:05',NULL,9889,'1',10452,813,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,9890,'0',10453,814,16,NULL,'cmdb2-2-5-5'),(NULL,0,'2019-11-29 22:15:05',NULL,9891,'0',10454,814,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:05',NULL,9892,'0',10455,814,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:05',NULL,9893,'0',10456,814,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:05',NULL,9894,'0',10457,814,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:05',NULL,9895,'0',10458,814,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:05',NULL,9896,'0',10459,814,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:05',NULL,9897,'0',10460,814,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:05',NULL,9898,'0',10461,814,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:05',NULL,9899,'0',10462,814,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:05',NULL,9900,'1',10463,814,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,9901,'0',10464,815,16,NULL,'cmdb2-2-5-6'),(NULL,0,'2019-11-29 22:15:05',NULL,9902,'0',10465,815,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:05',NULL,9903,'0',10466,815,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:05',NULL,9904,'0',10467,815,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:05',NULL,9905,'0',10468,815,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:05',NULL,9906,'0',10469,815,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:05',NULL,9907,'0',10470,815,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:05',NULL,9908,'0',10471,815,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:05',NULL,9909,'0',10472,815,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:05',NULL,9910,'0',10473,815,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:05',NULL,9911,'1',10474,815,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,9912,'0',10475,816,16,NULL,'cmdb2-2-5-7'),(NULL,0,'2019-11-29 22:15:05',NULL,9913,'0',10476,816,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:05',NULL,9914,'0',10477,816,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:05',NULL,9915,'0',10478,816,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:05',NULL,9916,'0',10479,816,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:05',NULL,9917,'0',10480,816,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:05',NULL,9918,'0',10481,816,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:05',NULL,9919,'0',10482,816,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:05',NULL,9920,'0',10483,816,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:05',NULL,9921,'0',10484,816,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:05',NULL,9922,'1',10485,816,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,9923,'0',10486,817,16,NULL,'cmdb2-2-5-8'),(NULL,0,'2019-11-29 22:15:05',NULL,9924,'0',10487,817,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:05',NULL,9925,'0',10488,817,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:05',NULL,9926,'0',10489,817,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:05',NULL,9927,'0',10490,817,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:05',NULL,9928,'0',10491,817,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:05',NULL,9929,'0',10492,817,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:05',NULL,9930,'0',10493,817,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:05',NULL,9931,'0',10494,817,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:05',NULL,9932,'0',10495,817,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:05',NULL,9933,'1',10496,817,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,9934,'0',10497,818,16,NULL,'cmdb2-2-5-9'),(NULL,0,'2019-11-29 22:15:06',NULL,9935,'0',10498,818,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:06',NULL,9936,'0',10499,818,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:06',NULL,9937,'0',10500,818,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:06',NULL,9938,'0',10501,818,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:06',NULL,9939,'0',10502,818,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:06',NULL,9940,'0',10503,818,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:06',NULL,9941,'0',10504,818,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:06',NULL,9942,'0',10505,818,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:06',NULL,9943,'0',10506,818,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:06',NULL,9944,'1',10507,818,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,9945,'0',10508,819,16,NULL,'cmdb2-2-5-10'),(NULL,0,'2019-11-29 22:15:06',NULL,9946,'0',10509,819,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:06',NULL,9947,'0',10510,819,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:06',NULL,9948,'0',10511,819,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:06',NULL,9949,'0',10512,819,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:06',NULL,9950,'0',10513,819,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:06',NULL,9951,'0',10514,819,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:06',NULL,9952,'0',10515,819,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:06',NULL,9953,'0',10516,819,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:06',NULL,9954,'0',10517,819,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:06',NULL,9955,'1',10518,819,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,9956,'0',10519,820,16,NULL,'cmdb2-2-5-11'),(NULL,0,'2019-11-29 22:15:06',NULL,9957,'0',10520,820,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:06',NULL,9958,'0',10521,820,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:06',NULL,9959,'0',10522,820,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:06',NULL,9960,'0',10523,820,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:06',NULL,9961,'0',10524,820,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:06',NULL,9962,'0',10525,820,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:06',NULL,9963,'0',10526,820,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:06',NULL,9964,'0',10527,820,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:06',NULL,9965,'0',10528,820,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:06',NULL,9966,'1',10529,820,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,9967,'0',10530,821,16,NULL,'cmdb2-2-5-12'),(NULL,0,'2019-11-29 22:15:06',NULL,9968,'0',10531,821,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:06',NULL,9969,'0',10532,821,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:06',NULL,9970,'0',10533,821,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:06',NULL,9971,'0',10534,821,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:06',NULL,9972,'0',10535,821,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:06',NULL,9973,'0',10536,821,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:06',NULL,9974,'0',10537,821,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:06',NULL,9975,'0',10538,821,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:06',NULL,9976,'0',10539,821,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:06',NULL,9977,'1',10540,821,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,9978,'0',10541,822,16,NULL,'cmdb2-2-5-13'),(NULL,0,'2019-11-29 22:15:07',NULL,9979,'0',10542,822,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:07',NULL,9980,'0',10543,822,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:07',NULL,9981,'0',10544,822,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:07',NULL,9982,'0',10545,822,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:07',NULL,9983,'0',10546,822,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:07',NULL,9984,'0',10547,822,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:07',NULL,9985,'0',10548,822,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:07',NULL,9986,'0',10549,822,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:07',NULL,9987,'0',10550,822,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:07',NULL,9988,'1',10551,822,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,9989,'0',10552,823,16,NULL,'cmdb2-2-5-14'),(NULL,0,'2019-11-29 22:15:07',NULL,9990,'0',10553,823,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:07',NULL,9991,'0',10554,823,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:07',NULL,9992,'0',10555,823,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:07',NULL,9993,'0',10556,823,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:07',NULL,9994,'0',10557,823,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:07',NULL,9995,'0',10558,823,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:07',NULL,9996,'0',10559,823,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:07',NULL,9997,'0',10560,823,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:07',NULL,9998,'0',10561,823,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:07',NULL,9999,'1',10562,823,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10000,'0',10563,824,16,NULL,'cmdb2-2-5-15'),(NULL,0,'2019-11-29 22:15:07',NULL,10001,'0',10564,824,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:07',NULL,10002,'0',10565,824,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:07',NULL,10003,'0',10566,824,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:07',NULL,10004,'0',10567,824,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:07',NULL,10005,'0',10568,824,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:07',NULL,10006,'0',10569,824,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:07',NULL,10007,'0',10570,824,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:07',NULL,10008,'0',10571,824,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:07',NULL,10009,'0',10572,824,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:07',NULL,10010,'1',10573,824,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10011,'0',10574,825,16,NULL,'cmdb2-2-5-16'),(NULL,0,'2019-11-29 22:15:07',NULL,10012,'0',10575,825,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:07',NULL,10013,'0',10576,825,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:07',NULL,10014,'0',10577,825,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:07',NULL,10015,'0',10578,825,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:07',NULL,10016,'0',10579,825,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:07',NULL,10017,'0',10580,825,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:07',NULL,10018,'0',10581,825,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:07',NULL,10019,'0',10582,825,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:07',NULL,10020,'0',10583,825,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:07',NULL,10021,'1',10584,825,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10022,'0',10585,826,4,NULL,'App2-2-6'),(NULL,0,'2019-11-29 22:15:08',NULL,10023,'0',10587,827,16,NULL,'cmdb2-2-6-1'),(NULL,0,'2019-11-29 22:15:08',NULL,10024,'0',10588,827,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:08',NULL,10025,'0',10589,827,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:08',NULL,10026,'0',10590,827,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:08',NULL,10027,'0',10591,827,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:08',NULL,10028,'0',10592,827,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:08',NULL,10029,'0',10593,827,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:08',NULL,10030,'0',10594,827,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:08',NULL,10031,'0',10595,827,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:08',NULL,10032,'0',10596,827,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:08',NULL,10033,'1',10597,827,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10034,'0',10598,828,16,NULL,'cmdb2-2-6-2'),(NULL,0,'2019-11-29 22:15:08',NULL,10035,'0',10599,828,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:08',NULL,10036,'0',10600,828,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:08',NULL,10037,'0',10601,828,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:08',NULL,10038,'0',10602,828,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:08',NULL,10039,'0',10603,828,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:08',NULL,10040,'0',10604,828,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:08',NULL,10041,'0',10605,828,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:08',NULL,10042,'0',10606,828,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:08',NULL,10043,'0',10607,828,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:08',NULL,10044,'1',10608,828,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10045,'0',10609,829,16,NULL,'cmdb2-2-6-3'),(NULL,0,'2019-11-29 22:15:08',NULL,10046,'0',10610,829,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:08',NULL,10047,'0',10611,829,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:08',NULL,10048,'0',10612,829,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:08',NULL,10049,'0',10613,829,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:08',NULL,10050,'0',10614,829,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:08',NULL,10051,'0',10615,829,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:08',NULL,10052,'0',10616,829,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:08',NULL,10053,'0',10617,829,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:08',NULL,10054,'0',10618,829,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:08',NULL,10055,'1',10619,829,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10056,'0',10620,830,16,NULL,'cmdb2-2-6-4'),(NULL,0,'2019-11-29 22:15:08',NULL,10057,'0',10621,830,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:08',NULL,10058,'0',10622,830,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:08',NULL,10059,'0',10623,830,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:08',NULL,10060,'0',10624,830,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:08',NULL,10061,'0',10625,830,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:08',NULL,10062,'0',10626,830,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:08',NULL,10063,'0',10627,830,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:08',NULL,10064,'0',10628,830,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:08',NULL,10065,'0',10629,830,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:08',NULL,10066,'1',10630,830,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10067,'0',10631,831,16,NULL,'cmdb2-2-6-5'),(NULL,0,'2019-11-29 22:15:09',NULL,10068,'0',10632,831,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:09',NULL,10069,'0',10633,831,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:09',NULL,10070,'0',10634,831,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:09',NULL,10071,'0',10635,831,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:09',NULL,10072,'0',10636,831,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:09',NULL,10073,'0',10637,831,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:09',NULL,10074,'0',10638,831,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:09',NULL,10075,'0',10639,831,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:09',NULL,10076,'0',10640,831,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:09',NULL,10077,'1',10641,831,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10078,'0',10642,832,16,NULL,'cmdb2-2-6-6'),(NULL,0,'2019-11-29 22:15:09',NULL,10079,'0',10643,832,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:09',NULL,10080,'0',10644,832,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:09',NULL,10081,'0',10645,832,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:09',NULL,10082,'0',10646,832,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:09',NULL,10083,'0',10647,832,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:09',NULL,10084,'0',10648,832,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:09',NULL,10085,'0',10649,832,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:09',NULL,10086,'0',10650,832,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:09',NULL,10087,'0',10651,832,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:09',NULL,10088,'1',10652,832,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10089,'0',10653,833,16,NULL,'cmdb2-2-6-7'),(NULL,0,'2019-11-29 22:15:09',NULL,10090,'0',10654,833,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:09',NULL,10091,'0',10655,833,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:09',NULL,10092,'0',10656,833,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:09',NULL,10093,'0',10657,833,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:09',NULL,10094,'0',10658,833,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:09',NULL,10095,'0',10659,833,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:09',NULL,10096,'0',10660,833,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:09',NULL,10097,'0',10661,833,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:09',NULL,10098,'0',10662,833,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:09',NULL,10099,'1',10663,833,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10100,'0',10664,834,16,NULL,'cmdb2-2-6-8'),(NULL,0,'2019-11-29 22:15:09',NULL,10101,'0',10665,834,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:09',NULL,10102,'0',10666,834,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:09',NULL,10103,'0',10667,834,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:09',NULL,10104,'0',10668,834,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:09',NULL,10105,'0',10669,834,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:09',NULL,10106,'0',10670,834,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:09',NULL,10107,'0',10671,834,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:09',NULL,10108,'0',10672,834,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:09',NULL,10109,'0',10673,834,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:09',NULL,10110,'1',10674,834,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10111,'0',10675,835,16,NULL,'cmdb2-2-6-9'),(NULL,0,'2019-11-29 22:15:10',NULL,10112,'0',10676,835,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:10',NULL,10113,'0',10677,835,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:10',NULL,10114,'0',10678,835,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:10',NULL,10115,'0',10679,835,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:10',NULL,10116,'0',10680,835,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:10',NULL,10117,'0',10681,835,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:10',NULL,10118,'0',10682,835,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:10',NULL,10119,'0',10683,835,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:10',NULL,10120,'0',10684,835,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:10',NULL,10121,'1',10685,835,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10122,'0',10686,836,16,NULL,'cmdb2-2-6-10'),(NULL,0,'2019-11-29 22:15:10',NULL,10123,'0',10687,836,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:10',NULL,10124,'0',10688,836,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:10',NULL,10125,'0',10689,836,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:10',NULL,10126,'0',10690,836,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:10',NULL,10127,'0',10691,836,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:10',NULL,10128,'0',10692,836,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:10',NULL,10129,'0',10693,836,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:10',NULL,10130,'0',10694,836,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:10',NULL,10131,'0',10695,836,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:10',NULL,10132,'1',10696,836,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10133,'0',10697,837,16,NULL,'cmdb2-2-6-11'),(NULL,0,'2019-11-29 22:15:10',NULL,10134,'0',10698,837,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:10',NULL,10135,'0',10699,837,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:10',NULL,10136,'0',10700,837,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:10',NULL,10137,'0',10701,837,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:10',NULL,10138,'0',10702,837,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:10',NULL,10139,'0',10703,837,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:10',NULL,10140,'0',10704,837,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:10',NULL,10141,'0',10705,837,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:10',NULL,10142,'0',10706,837,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:10',NULL,10143,'1',10707,837,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10144,'0',10708,838,16,NULL,'cmdb2-2-6-12'),(NULL,0,'2019-11-29 22:15:10',NULL,10145,'0',10709,838,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:10',NULL,10146,'0',10710,838,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:10',NULL,10147,'0',10711,838,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:10',NULL,10148,'0',10712,838,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:10',NULL,10149,'0',10713,838,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:10',NULL,10150,'0',10714,838,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:10',NULL,10151,'0',10715,838,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:10',NULL,10152,'0',10716,838,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:10',NULL,10153,'0',10717,838,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:10',NULL,10154,'1',10718,838,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10155,'0',10719,839,16,NULL,'cmdb2-2-6-13'),(NULL,0,'2019-11-29 22:15:10',NULL,10156,'0',10720,839,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:10',NULL,10157,'0',10721,839,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:11',NULL,10158,'0',10722,839,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:11',NULL,10159,'0',10723,839,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:11',NULL,10160,'0',10724,839,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:11',NULL,10161,'0',10725,839,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:11',NULL,10162,'0',10726,839,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:11',NULL,10163,'0',10727,839,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:11',NULL,10164,'0',10728,839,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:11',NULL,10165,'1',10729,839,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10166,'0',10730,840,16,NULL,'cmdb2-2-6-14'),(NULL,0,'2019-11-29 22:15:11',NULL,10167,'0',10731,840,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:11',NULL,10168,'0',10732,840,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:11',NULL,10169,'0',10733,840,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:11',NULL,10170,'0',10734,840,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:11',NULL,10171,'0',10735,840,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:11',NULL,10172,'0',10736,840,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:11',NULL,10173,'0',10737,840,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:11',NULL,10174,'0',10738,840,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:11',NULL,10175,'0',10739,840,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:11',NULL,10176,'1',10740,840,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10177,'0',10741,841,16,NULL,'cmdb2-2-6-15'),(NULL,0,'2019-11-29 22:15:11',NULL,10178,'0',10742,841,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:11',NULL,10179,'0',10743,841,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:11',NULL,10180,'0',10744,841,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:11',NULL,10181,'0',10745,841,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:11',NULL,10182,'0',10746,841,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:11',NULL,10183,'0',10747,841,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:11',NULL,10184,'0',10748,841,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:11',NULL,10185,'0',10749,841,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:11',NULL,10186,'0',10750,841,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:11',NULL,10187,'1',10751,841,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10188,'0',10752,842,16,NULL,'cmdb2-2-6-16'),(NULL,0,'2019-11-29 22:15:11',NULL,10189,'0',10753,842,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:11',NULL,10190,'0',10754,842,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:11',NULL,10191,'0',10755,842,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:11',NULL,10192,'0',10756,842,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:11',NULL,10193,'0',10757,842,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:11',NULL,10194,'0',10758,842,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:11',NULL,10195,'0',10759,842,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:11',NULL,10196,'0',10760,842,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:11',NULL,10197,'0',10761,842,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:11',NULL,10198,'1',10762,842,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10199,'0',10763,843,4,NULL,'App2-2-7'),(NULL,0,'2019-11-29 22:15:12',NULL,10200,'0',10765,844,16,NULL,'cmdb2-2-7-1'),(NULL,0,'2019-11-29 22:15:12',NULL,10201,'0',10766,844,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:12',NULL,10202,'0',10767,844,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:12',NULL,10203,'0',10768,844,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:12',NULL,10204,'0',10769,844,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:12',NULL,10205,'0',10770,844,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:12',NULL,10206,'0',10771,844,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:12',NULL,10207,'0',10772,844,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:12',NULL,10208,'0',10773,844,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:12',NULL,10209,'0',10774,844,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:12',NULL,10210,'1',10775,844,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10211,'0',10776,845,16,NULL,'cmdb2-2-7-2'),(NULL,0,'2019-11-29 22:15:12',NULL,10212,'0',10777,845,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:12',NULL,10213,'0',10778,845,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:12',NULL,10214,'0',10779,845,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:12',NULL,10215,'0',10780,845,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:12',NULL,10216,'0',10781,845,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:12',NULL,10217,'0',10782,845,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:12',NULL,10218,'0',10783,845,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:12',NULL,10219,'0',10784,845,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:12',NULL,10220,'0',10785,845,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:12',NULL,10221,'1',10786,845,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10222,'0',10787,846,16,NULL,'cmdb2-2-7-3'),(NULL,0,'2019-11-29 22:15:12',NULL,10223,'0',10788,846,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:12',NULL,10224,'0',10789,846,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:12',NULL,10225,'0',10790,846,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:12',NULL,10226,'0',10791,846,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:12',NULL,10227,'0',10792,846,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:12',NULL,10228,'0',10793,846,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:12',NULL,10229,'0',10794,846,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:12',NULL,10230,'0',10795,846,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:12',NULL,10231,'0',10796,846,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:12',NULL,10232,'1',10797,846,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10233,'0',10798,847,16,NULL,'cmdb2-2-7-4'),(NULL,0,'2019-11-29 22:15:12',NULL,10234,'0',10799,847,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:12',NULL,10235,'0',10800,847,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:12',NULL,10236,'0',10801,847,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:12',NULL,10237,'0',10802,847,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:12',NULL,10238,'0',10803,847,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:12',NULL,10239,'0',10804,847,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:12',NULL,10240,'0',10805,847,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:12',NULL,10241,'0',10806,847,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:12',NULL,10242,'0',10807,847,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:12',NULL,10243,'1',10808,847,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10244,'0',10809,848,16,NULL,'cmdb2-2-7-5'),(NULL,0,'2019-11-29 22:15:12',NULL,10245,'0',10810,848,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:13',NULL,10246,'0',10811,848,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:13',NULL,10247,'0',10812,848,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:13',NULL,10248,'0',10813,848,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:13',NULL,10249,'0',10814,848,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:13',NULL,10250,'0',10815,848,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:13',NULL,10251,'0',10816,848,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:13',NULL,10252,'0',10817,848,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:13',NULL,10253,'0',10818,848,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:13',NULL,10254,'1',10819,848,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10255,'0',10820,849,16,NULL,'cmdb2-2-7-6'),(NULL,0,'2019-11-29 22:15:13',NULL,10256,'0',10821,849,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:13',NULL,10257,'0',10822,849,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:13',NULL,10258,'0',10823,849,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:13',NULL,10259,'0',10824,849,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:13',NULL,10260,'0',10825,849,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:13',NULL,10261,'0',10826,849,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:13',NULL,10262,'0',10827,849,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:13',NULL,10263,'0',10828,849,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:13',NULL,10264,'0',10829,849,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:13',NULL,10265,'1',10830,849,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10266,'0',10831,850,16,NULL,'cmdb2-2-7-7'),(NULL,0,'2019-11-29 22:15:13',NULL,10267,'0',10832,850,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:13',NULL,10268,'0',10833,850,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:13',NULL,10269,'0',10834,850,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:13',NULL,10270,'0',10835,850,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:13',NULL,10271,'0',10836,850,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:13',NULL,10272,'0',10837,850,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:13',NULL,10273,'0',10838,850,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:13',NULL,10274,'0',10839,850,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:13',NULL,10275,'0',10840,850,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:13',NULL,10276,'1',10841,850,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10277,'0',10842,851,16,NULL,'cmdb2-2-7-8'),(NULL,0,'2019-11-29 22:15:13',NULL,10278,'0',10843,851,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:13',NULL,10279,'0',10844,851,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:13',NULL,10280,'0',10845,851,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:13',NULL,10281,'0',10846,851,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:13',NULL,10282,'0',10847,851,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:13',NULL,10283,'0',10848,851,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:13',NULL,10284,'0',10849,851,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:13',NULL,10285,'0',10850,851,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:13',NULL,10286,'0',10851,851,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:13',NULL,10287,'1',10852,851,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10288,'0',10853,852,16,NULL,'cmdb2-2-7-9'),(NULL,0,'2019-11-29 22:15:13',NULL,10289,'0',10854,852,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:13',NULL,10290,'0',10855,852,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:13',NULL,10291,'0',10856,852,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:14',NULL,10292,'0',10857,852,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:14',NULL,10293,'0',10858,852,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:14',NULL,10294,'0',10859,852,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:14',NULL,10295,'0',10860,852,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:14',NULL,10296,'0',10861,852,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:14',NULL,10297,'0',10862,852,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:14',NULL,10298,'1',10863,852,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10299,'0',10864,853,16,NULL,'cmdb2-2-7-10'),(NULL,0,'2019-11-29 22:15:14',NULL,10300,'0',10865,853,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:14',NULL,10301,'0',10866,853,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:14',NULL,10302,'0',10867,853,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:14',NULL,10303,'0',10868,853,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:14',NULL,10304,'0',10869,853,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:14',NULL,10305,'0',10870,853,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:14',NULL,10306,'0',10871,853,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:14',NULL,10307,'0',10872,853,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:14',NULL,10308,'0',10873,853,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:14',NULL,10309,'1',10874,853,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10310,'0',10875,854,16,NULL,'cmdb2-2-7-11'),(NULL,0,'2019-11-29 22:15:14',NULL,10311,'0',10876,854,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:14',NULL,10312,'0',10877,854,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:14',NULL,10313,'0',10878,854,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:14',NULL,10314,'0',10879,854,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:14',NULL,10315,'0',10880,854,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:14',NULL,10316,'0',10881,854,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:14',NULL,10317,'0',10882,854,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:14',NULL,10318,'0',10883,854,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:14',NULL,10319,'0',10884,854,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:14',NULL,10320,'1',10885,854,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10321,'0',10886,855,16,NULL,'cmdb2-2-7-12'),(NULL,0,'2019-11-29 22:15:14',NULL,10322,'0',10887,855,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:14',NULL,10323,'0',10888,855,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:14',NULL,10324,'0',10889,855,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:14',NULL,10325,'0',10890,855,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:14',NULL,10326,'0',10891,855,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:14',NULL,10327,'0',10892,855,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:14',NULL,10328,'0',10893,855,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:14',NULL,10329,'0',10894,855,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:14',NULL,10330,'0',10895,855,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:14',NULL,10331,'1',10896,855,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10332,'0',10897,856,16,NULL,'cmdb2-2-7-13'),(NULL,0,'2019-11-29 22:15:14',NULL,10333,'0',10898,856,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:14',NULL,10334,'0',10899,856,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:14',NULL,10335,'0',10900,856,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:15',NULL,10336,'0',10901,856,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:15',NULL,10337,'0',10902,856,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:15',NULL,10338,'0',10903,856,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:15',NULL,10339,'0',10904,856,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:15',NULL,10340,'0',10905,856,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:15',NULL,10341,'0',10906,856,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:15',NULL,10342,'1',10907,856,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10343,'0',10908,857,16,NULL,'cmdb2-2-7-14'),(NULL,0,'2019-11-29 22:15:15',NULL,10344,'0',10909,857,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:15',NULL,10345,'0',10910,857,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:15',NULL,10346,'0',10911,857,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:15',NULL,10347,'0',10912,857,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:15',NULL,10348,'0',10913,857,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:15',NULL,10349,'0',10914,857,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:15',NULL,10350,'0',10915,857,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:15',NULL,10351,'0',10916,857,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:15',NULL,10352,'0',10917,857,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:15',NULL,10353,'1',10918,857,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10354,'0',10919,858,16,NULL,'cmdb2-2-7-15'),(NULL,0,'2019-11-29 22:15:15',NULL,10355,'0',10920,858,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:15',NULL,10356,'0',10921,858,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:15',NULL,10357,'0',10922,858,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:15',NULL,10358,'0',10923,858,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:15',NULL,10359,'0',10924,858,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:15',NULL,10360,'0',10925,858,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:15',NULL,10361,'0',10926,858,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:15',NULL,10362,'0',10927,858,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:15',NULL,10363,'0',10928,858,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:15',NULL,10364,'1',10929,858,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10365,'0',10930,859,16,NULL,'cmdb2-2-7-16'),(NULL,0,'2019-11-29 22:15:15',NULL,10366,'0',10931,859,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:15',NULL,10367,'0',10932,859,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:15',NULL,10368,'0',10933,859,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:15',NULL,10369,'0',10934,859,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:15',NULL,10370,'0',10935,859,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:15',NULL,10371,'0',10936,859,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:15',NULL,10372,'0',10937,859,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:15',NULL,10373,'0',10938,859,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:15',NULL,10374,'0',10939,859,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:15',NULL,10375,'1',10940,859,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10376,'0',10941,860,4,NULL,'App2-2-8'),(NULL,0,'2019-11-29 22:15:16',NULL,10377,'0',10943,861,16,NULL,'cmdb2-2-8-1'),(NULL,0,'2019-11-29 22:15:16',NULL,10378,'0',10944,861,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:16',NULL,10379,'0',10945,861,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:16',NULL,10380,'0',10946,861,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:16',NULL,10381,'0',10947,861,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:16',NULL,10382,'0',10948,861,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:16',NULL,10383,'0',10949,861,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:16',NULL,10384,'0',10950,861,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:16',NULL,10385,'0',10951,861,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:16',NULL,10386,'0',10952,861,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:16',NULL,10387,'1',10953,861,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10388,'0',10954,862,16,NULL,'cmdb2-2-8-2'),(NULL,0,'2019-11-29 22:15:16',NULL,10389,'0',10955,862,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:16',NULL,10390,'0',10956,862,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:16',NULL,10391,'0',10957,862,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:16',NULL,10392,'0',10958,862,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:16',NULL,10393,'0',10959,862,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:16',NULL,10394,'0',10960,862,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:16',NULL,10395,'0',10961,862,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:16',NULL,10396,'0',10962,862,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:16',NULL,10397,'0',10963,862,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:16',NULL,10398,'1',10964,862,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10399,'0',10965,863,16,NULL,'cmdb2-2-8-3'),(NULL,0,'2019-11-29 22:15:16',NULL,10400,'0',10966,863,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:16',NULL,10401,'0',10967,863,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:16',NULL,10402,'0',10968,863,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:16',NULL,10403,'0',10969,863,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:16',NULL,10404,'0',10970,863,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:16',NULL,10405,'0',10971,863,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:16',NULL,10406,'0',10972,863,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:16',NULL,10407,'0',10973,863,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:16',NULL,10408,'0',10974,863,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:16',NULL,10409,'1',10975,863,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10410,'0',10976,864,16,NULL,'cmdb2-2-8-4'),(NULL,0,'2019-11-29 22:15:16',NULL,10411,'0',10977,864,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:16',NULL,10412,'0',10978,864,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:16',NULL,10413,'0',10979,864,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:16',NULL,10414,'0',10980,864,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:16',NULL,10415,'0',10981,864,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:16',NULL,10416,'0',10982,864,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:16',NULL,10417,'0',10983,864,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:16',NULL,10418,'0',10984,864,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:16',NULL,10419,'0',10985,864,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:16',NULL,10420,'1',10986,864,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10421,'0',10987,865,16,NULL,'cmdb2-2-8-5'),(NULL,0,'2019-11-29 22:15:16',NULL,10422,'0',10988,865,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:16',NULL,10423,'0',10989,865,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:17',NULL,10424,'0',10990,865,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:17',NULL,10425,'0',10991,865,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:17',NULL,10426,'0',10992,865,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:17',NULL,10427,'0',10993,865,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:17',NULL,10428,'0',10994,865,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:17',NULL,10429,'0',10995,865,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:17',NULL,10430,'0',10996,865,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:17',NULL,10431,'1',10997,865,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10432,'0',10998,866,16,NULL,'cmdb2-2-8-6'),(NULL,0,'2019-11-29 22:15:17',NULL,10433,'0',10999,866,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:17',NULL,10434,'0',11000,866,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:17',NULL,10435,'0',11001,866,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:17',NULL,10436,'0',11002,866,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:17',NULL,10437,'0',11003,866,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:17',NULL,10438,'0',11004,866,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:17',NULL,10439,'0',11005,866,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:17',NULL,10440,'0',11006,866,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:17',NULL,10441,'0',11007,866,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:17',NULL,10442,'1',11008,866,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10443,'0',11009,867,16,NULL,'cmdb2-2-8-7'),(NULL,0,'2019-11-29 22:15:17',NULL,10444,'0',11010,867,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:17',NULL,10445,'0',11011,867,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:17',NULL,10446,'0',11012,867,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:17',NULL,10447,'0',11013,867,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:17',NULL,10448,'0',11014,867,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:17',NULL,10449,'0',11015,867,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:17',NULL,10450,'0',11016,867,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:17',NULL,10451,'0',11017,867,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:17',NULL,10452,'0',11018,867,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:17',NULL,10453,'1',11019,867,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10454,'0',11020,868,16,NULL,'cmdb2-2-8-8'),(NULL,0,'2019-11-29 22:15:17',NULL,10455,'0',11021,868,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:17',NULL,10456,'0',11022,868,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:17',NULL,10457,'0',11023,868,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:17',NULL,10458,'0',11024,868,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:17',NULL,10459,'0',11025,868,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:17',NULL,10460,'0',11026,868,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:17',NULL,10461,'0',11027,868,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:17',NULL,10462,'0',11028,868,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:17',NULL,10463,'0',11029,868,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:17',NULL,10464,'1',11030,868,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10465,'0',11031,869,16,NULL,'cmdb2-2-8-9'),(NULL,0,'2019-11-29 22:15:17',NULL,10466,'0',11032,869,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:17',NULL,10467,'0',11033,869,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:17',NULL,10468,'0',11034,869,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:17',NULL,10469,'0',11035,869,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:18',NULL,10470,'0',11036,869,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:18',NULL,10471,'0',11037,869,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:18',NULL,10472,'0',11038,869,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:18',NULL,10473,'0',11039,869,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:18',NULL,10474,'0',11040,869,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:18',NULL,10475,'1',11041,869,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,10476,'0',11042,870,16,NULL,'cmdb2-2-8-10'),(NULL,0,'2019-11-29 22:15:18',NULL,10477,'0',11043,870,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:18',NULL,10478,'0',11044,870,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:18',NULL,10479,'0',11045,870,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:18',NULL,10480,'0',11046,870,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:18',NULL,10481,'0',11047,870,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:18',NULL,10482,'0',11048,870,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:18',NULL,10483,'0',11049,870,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:18',NULL,10484,'0',11050,870,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:18',NULL,10485,'0',11051,870,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:18',NULL,10486,'1',11052,870,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,10487,'0',11053,871,16,NULL,'cmdb2-2-8-11'),(NULL,0,'2019-11-29 22:15:18',NULL,10488,'0',11054,871,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:18',NULL,10489,'0',11055,871,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:18',NULL,10490,'0',11056,871,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:18',NULL,10491,'0',11057,871,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:18',NULL,10492,'0',11058,871,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:18',NULL,10493,'0',11059,871,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:18',NULL,10494,'0',11060,871,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:18',NULL,10495,'0',11061,871,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:18',NULL,10496,'0',11062,871,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:18',NULL,10497,'1',11063,871,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,10498,'0',11064,872,16,NULL,'cmdb2-2-8-12'),(NULL,0,'2019-11-29 22:15:18',NULL,10499,'0',11065,872,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:18',NULL,10500,'0',11066,872,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:18',NULL,10501,'0',11067,872,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:18',NULL,10502,'0',11068,872,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:18',NULL,10503,'0',11069,872,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:18',NULL,10504,'0',11070,872,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:18',NULL,10505,'0',11071,872,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:18',NULL,10506,'0',11072,872,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:18',NULL,10507,'0',11073,872,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:18',NULL,10508,'1',11074,872,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,10509,'0',11075,873,16,NULL,'cmdb2-2-8-13'),(NULL,0,'2019-11-29 22:15:18',NULL,10510,'0',11076,873,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:18',NULL,10511,'0',11077,873,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:18',NULL,10512,'0',11078,873,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:18',NULL,10513,'0',11079,873,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:18',NULL,10514,'0',11080,873,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:19',NULL,10515,'0',11081,873,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:19',NULL,10516,'0',11082,873,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:19',NULL,10517,'0',11083,873,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:19',NULL,10518,'0',11084,873,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:19',NULL,10519,'1',11085,873,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,10520,'0',11086,874,16,NULL,'cmdb2-2-8-14'),(NULL,0,'2019-11-29 22:15:19',NULL,10521,'0',11087,874,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:19',NULL,10522,'0',11088,874,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:19',NULL,10523,'0',11089,874,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:19',NULL,10524,'0',11090,874,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:19',NULL,10525,'0',11091,874,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:19',NULL,10526,'0',11092,874,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:19',NULL,10527,'0',11093,874,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:19',NULL,10528,'0',11094,874,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:19',NULL,10529,'0',11095,874,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:19',NULL,10530,'1',11096,874,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,10531,'0',11097,875,16,NULL,'cmdb2-2-8-15'),(NULL,0,'2019-11-29 22:15:19',NULL,10532,'0',11098,875,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:19',NULL,10533,'0',11099,875,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:19',NULL,10534,'0',11100,875,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:19',NULL,10535,'0',11101,875,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:19',NULL,10536,'0',11102,875,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:19',NULL,10537,'0',11103,875,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:19',NULL,10538,'0',11104,875,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:19',NULL,10539,'0',11105,875,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:19',NULL,10540,'0',11106,875,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:19',NULL,10541,'1',11107,875,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,10542,'0',11108,876,16,NULL,'cmdb2-2-8-16'),(NULL,0,'2019-11-29 22:15:19',NULL,10543,'0',11109,876,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:19',NULL,10544,'0',11110,876,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:19',NULL,10545,'0',11111,876,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:19',NULL,10546,'0',11112,876,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:19',NULL,10547,'0',11113,876,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:19',NULL,10548,'0',11114,876,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:19',NULL,10549,'0',11115,876,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:19',NULL,10550,'0',11116,876,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:19',NULL,10551,'0',11117,876,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:19',NULL,10552,'1',11118,876,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,10553,'0',11119,877,3,NULL,'产品线2-3'),(NULL,0,'2019-11-29 22:15:20',NULL,10554,'0',11121,878,4,NULL,'App2-3-1'),(NULL,0,'2019-11-29 22:15:20',NULL,10555,'0',11123,879,16,NULL,'cmdb2-3-1-1'),(NULL,0,'2019-11-29 22:15:20',NULL,10556,'0',11124,879,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,10557,'0',11125,879,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:20',NULL,10558,'0',11126,879,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,10559,'0',11127,879,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,10560,'0',11128,879,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:20',NULL,10561,'0',11129,879,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,10562,'0',11130,879,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:20',NULL,10563,'0',11131,879,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,10564,'0',11132,879,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,10565,'0',11133,879,15,NULL,'10.6.1.1'),(NULL,0,'2019-11-29 22:15:20',NULL,10566,'0',11134,879,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,10567,'0',11135,879,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,10568,'0',11136,879,5,NULL,'a51588e5ff69413dbd3a62a5e59ab75f'),(NULL,0,'2019-11-29 22:15:20',NULL,10569,'0',11137,879,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:20',NULL,10570,'0',11139,880,16,NULL,'cmdb2-3-1-2'),(NULL,0,'2019-11-29 22:15:20',NULL,10571,'0',11140,880,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,10572,'0',11141,880,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:20',NULL,10573,'0',11142,880,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,10574,'0',11143,880,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,10575,'0',11144,880,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:20',NULL,10576,'0',11145,880,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,10577,'0',11146,880,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:20',NULL,10578,'0',11147,880,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,10579,'0',11148,880,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,10580,'0',11149,880,15,NULL,'10.6.1.2'),(NULL,0,'2019-11-29 22:15:20',NULL,10581,'0',11150,880,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,10582,'0',11151,880,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,10583,'0',11152,880,5,NULL,'e7401a12eefb43e190ac00219b1b854e'),(NULL,0,'2019-11-29 22:15:20',NULL,10584,'0',11153,880,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:20',NULL,10585,'0',11155,881,16,NULL,'cmdb2-3-1-3'),(NULL,0,'2019-11-29 22:15:20',NULL,10586,'0',11156,881,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,10587,'0',11157,881,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:20',NULL,10588,'0',11158,881,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,10589,'0',11159,881,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,10590,'0',11160,881,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:20',NULL,10591,'0',11161,881,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,10592,'0',11162,881,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:20',NULL,10593,'0',11163,881,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,10594,'0',11164,881,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,10595,'0',11165,881,15,NULL,'10.6.1.3'),(NULL,0,'2019-11-29 22:15:20',NULL,10596,'0',11166,881,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,10597,'0',11167,881,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,10598,'0',11168,881,5,NULL,'d6739e303ad6477daba35cfdc7168486'),(NULL,0,'2019-11-29 22:15:20',NULL,10599,'0',11169,881,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:20',NULL,10600,'0',11171,882,16,NULL,'cmdb2-3-1-4'),(NULL,0,'2019-11-29 22:15:20',NULL,10601,'0',11172,882,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,10602,'0',11173,882,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:20',NULL,10603,'0',11174,882,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,10604,'0',11175,882,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,10605,'0',11176,882,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:20',NULL,10606,'0',11177,882,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,10607,'0',11178,882,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:20',NULL,10608,'0',11179,882,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,10609,'0',11180,882,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,10610,'0',11181,882,15,NULL,'10.6.1.4'),(NULL,0,'2019-11-29 22:15:20',NULL,10611,'0',11182,882,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,10612,'0',11183,882,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,10613,'0',11184,882,5,NULL,'fede831bf67e4b6384dcf9cfc0f6e9cf'),(NULL,0,'2019-11-29 22:15:20',NULL,10614,'0',11185,882,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:21',NULL,10615,'0',11187,883,16,NULL,'cmdb2-3-1-5'),(NULL,0,'2019-11-29 22:15:21',NULL,10616,'0',11188,883,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,10617,'0',11189,883,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:21',NULL,10618,'0',11190,883,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,10619,'0',11191,883,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,10620,'0',11192,883,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:21',NULL,10621,'0',11193,883,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,10622,'0',11194,883,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:21',NULL,10623,'0',11195,883,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,10624,'0',11196,883,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,10625,'0',11197,883,15,NULL,'10.6.1.5'),(NULL,0,'2019-11-29 22:15:21',NULL,10626,'0',11198,883,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,10627,'0',11199,883,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,10628,'0',11200,883,5,NULL,'f86695c415354fd8b76a2fd0d4ed5632'),(NULL,0,'2019-11-29 22:15:21',NULL,10629,'0',11201,883,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:21',NULL,10630,'0',11203,884,16,NULL,'cmdb2-3-1-6'),(NULL,0,'2019-11-29 22:15:21',NULL,10631,'0',11204,884,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,10632,'0',11205,884,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:21',NULL,10633,'0',11206,884,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,10634,'0',11207,884,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,10635,'0',11208,884,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:21',NULL,10636,'0',11209,884,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,10637,'0',11210,884,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:21',NULL,10638,'0',11211,884,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,10639,'0',11212,884,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,10640,'0',11213,884,15,NULL,'10.6.1.6'),(NULL,0,'2019-11-29 22:15:21',NULL,10641,'0',11214,884,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,10642,'0',11215,884,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,10643,'0',11216,884,5,NULL,'346bc36452324ef18772e7a2f1e9334c'),(NULL,0,'2019-11-29 22:15:21',NULL,10644,'0',11217,884,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:21',NULL,10645,'0',11219,885,16,NULL,'cmdb2-3-1-7'),(NULL,0,'2019-11-29 22:15:21',NULL,10646,'0',11220,885,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,10647,'0',11221,885,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:21',NULL,10648,'0',11222,885,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,10649,'0',11223,885,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,10650,'0',11224,885,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:21',NULL,10651,'0',11225,885,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,10652,'0',11226,885,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:21',NULL,10653,'0',11227,885,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,10654,'0',11228,885,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,10655,'0',11229,885,15,NULL,'10.6.1.7'),(NULL,0,'2019-11-29 22:15:21',NULL,10656,'0',11230,885,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,10657,'0',11231,885,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,10658,'0',11232,885,5,NULL,'129c945885a84f86b4cf8f69ca6ff6dd'),(NULL,0,'2019-11-29 22:15:21',NULL,10659,'0',11233,885,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:21',NULL,10660,'0',11235,886,16,NULL,'cmdb2-3-1-8'),(NULL,0,'2019-11-29 22:15:21',NULL,10661,'0',11236,886,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,10662,'0',11237,886,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:21',NULL,10663,'0',11238,886,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,10664,'0',11239,886,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,10665,'0',11240,886,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:21',NULL,10666,'0',11241,886,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,10667,'0',11242,886,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:21',NULL,10668,'0',11243,886,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,10669,'0',11244,886,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,10670,'0',11245,886,15,NULL,'10.6.1.8'),(NULL,0,'2019-11-29 22:15:21',NULL,10671,'0',11246,886,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,10672,'0',11247,886,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,10673,'0',11248,886,5,NULL,'8775da8c72da4e96a0afe20680d2908d'),(NULL,0,'2019-11-29 22:15:21',NULL,10674,'0',11249,886,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:21',NULL,10675,'0',11251,887,16,NULL,'cmdb2-3-1-9'),(NULL,0,'2019-11-29 22:15:21',NULL,10676,'0',11252,887,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,10677,'0',11253,887,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:21',NULL,10678,'0',11254,887,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,10679,'0',11255,887,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,10680,'0',11256,887,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:21',NULL,10681,'0',11257,887,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,10682,'0',11258,887,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:22',NULL,10683,'0',11259,887,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,10684,'0',11260,887,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,10685,'0',11261,887,15,NULL,'10.6.1.9'),(NULL,0,'2019-11-29 22:15:22',NULL,10686,'0',11262,887,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,10687,'0',11263,887,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,10688,'0',11264,887,5,NULL,'0dadd45c144542c1a94ffd125061daa4'),(NULL,0,'2019-11-29 22:15:22',NULL,10689,'0',11265,887,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:22',NULL,10690,'0',11267,888,16,NULL,'cmdb2-3-1-10'),(NULL,0,'2019-11-29 22:15:22',NULL,10691,'0',11268,888,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,10692,'0',11269,888,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:22',NULL,10693,'0',11270,888,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,10694,'0',11271,888,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,10695,'0',11272,888,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:22',NULL,10696,'0',11273,888,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,10697,'0',11274,888,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:22',NULL,10698,'0',11275,888,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,10699,'0',11276,888,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,10700,'0',11277,888,15,NULL,'10.6.1.10'),(NULL,0,'2019-11-29 22:15:22',NULL,10701,'0',11278,888,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,10702,'0',11279,888,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,10703,'0',11280,888,5,NULL,'40cc9f7ddaa1484dba1e34dc45a47e48'),(NULL,0,'2019-11-29 22:15:22',NULL,10704,'0',11281,888,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:22',NULL,10705,'0',11283,889,16,NULL,'cmdb2-3-1-11'),(NULL,0,'2019-11-29 22:15:22',NULL,10706,'0',11284,889,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,10707,'0',11285,889,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:22',NULL,10708,'0',11286,889,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,10709,'0',11287,889,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,10710,'0',11288,889,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:22',NULL,10711,'0',11289,889,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,10712,'0',11290,889,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:22',NULL,10713,'0',11291,889,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,10714,'0',11292,889,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,10715,'0',11293,889,15,NULL,'10.6.1.11'),(NULL,0,'2019-11-29 22:15:22',NULL,10716,'0',11294,889,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,10717,'0',11295,889,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,10718,'0',11296,889,5,NULL,'0967866961f1471d8a12671d87d27ca3'),(NULL,0,'2019-11-29 22:15:22',NULL,10719,'0',11297,889,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:22',NULL,10720,'0',11299,890,16,NULL,'cmdb2-3-1-12'),(NULL,0,'2019-11-29 22:15:22',NULL,10721,'0',11300,890,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,10722,'0',11301,890,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:22',NULL,10723,'0',11302,890,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,10724,'0',11303,890,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,10725,'0',11304,890,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:22',NULL,10726,'0',11305,890,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,10727,'0',11306,890,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:22',NULL,10728,'0',11307,890,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,10729,'0',11308,890,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,10730,'0',11309,890,15,NULL,'10.6.1.12'),(NULL,0,'2019-11-29 22:15:22',NULL,10731,'0',11310,890,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,10732,'0',11311,890,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,10733,'0',11312,890,5,NULL,'955586eca6eb4b2aa414c2bab0a4f6aa'),(NULL,0,'2019-11-29 22:15:22',NULL,10734,'0',11313,890,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:22',NULL,10735,'0',11315,891,16,NULL,'cmdb2-3-1-13'),(NULL,0,'2019-11-29 22:15:22',NULL,10736,'0',11316,891,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,10737,'0',11317,891,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:22',NULL,10738,'0',11318,891,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,10739,'0',11319,891,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,10740,'0',11320,891,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:22',NULL,10741,'0',11321,891,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,10742,'0',11322,891,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:22',NULL,10743,'0',11323,891,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,10744,'0',11324,891,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,10745,'0',11325,891,15,NULL,'10.6.1.13'),(NULL,0,'2019-11-29 22:15:22',NULL,10746,'0',11326,891,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,10747,'0',11327,891,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,10748,'0',11328,891,5,NULL,'200ffc9f7c9a4e86a176ef7ef8960072'),(NULL,0,'2019-11-29 22:15:23',NULL,10749,'0',11329,891,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:23',NULL,10750,'0',11331,892,16,NULL,'cmdb2-3-1-14'),(NULL,0,'2019-11-29 22:15:23',NULL,10751,'0',11332,892,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,10752,'0',11333,892,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:23',NULL,10753,'0',11334,892,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,10754,'0',11335,892,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,10755,'0',11336,892,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:23',NULL,10756,'0',11337,892,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,10757,'0',11338,892,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:23',NULL,10758,'0',11339,892,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,10759,'0',11340,892,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,10760,'0',11341,892,15,NULL,'10.6.1.14'),(NULL,0,'2019-11-29 22:15:23',NULL,10761,'0',11342,892,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,10762,'0',11343,892,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,10763,'0',11344,892,5,NULL,'50c2ce4f47a74b89b3cefd2990b3e339'),(NULL,0,'2019-11-29 22:15:23',NULL,10764,'0',11345,892,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:23',NULL,10765,'0',11347,893,16,NULL,'cmdb2-3-1-15'),(NULL,0,'2019-11-29 22:15:23',NULL,10766,'0',11348,893,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,10767,'0',11349,893,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:23',NULL,10768,'0',11350,893,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,10769,'0',11351,893,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,10770,'0',11352,893,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:23',NULL,10771,'0',11353,893,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,10772,'0',11354,893,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:23',NULL,10773,'0',11355,893,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,10774,'0',11356,893,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,10775,'0',11357,893,15,NULL,'10.6.1.15'),(NULL,0,'2019-11-29 22:15:23',NULL,10776,'0',11358,893,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,10777,'0',11359,893,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,10778,'0',11360,893,5,NULL,'70d5e923a72443fd9f1c1fe17a4aa2fa'),(NULL,0,'2019-11-29 22:15:23',NULL,10779,'0',11361,893,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:23',NULL,10780,'0',11363,894,16,NULL,'cmdb2-3-1-16'),(NULL,0,'2019-11-29 22:15:23',NULL,10781,'0',11364,894,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,10782,'0',11365,894,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:23',NULL,10783,'0',11366,894,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,10784,'0',11367,894,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,10785,'0',11368,894,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:23',NULL,10786,'0',11369,894,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,10787,'0',11370,894,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:23',NULL,10788,'0',11371,894,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,10789,'0',11372,894,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,10790,'0',11373,894,15,NULL,'10.6.1.16'),(NULL,0,'2019-11-29 22:15:23',NULL,10791,'0',11374,894,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,10792,'0',11375,894,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,10793,'0',11376,894,5,NULL,'d6299d23c68c414594d2c71d5861ee62'),(NULL,0,'2019-11-29 22:15:23',NULL,10794,'0',11377,894,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:23',NULL,10795,'0',11379,895,4,NULL,'App2-3-2'),(NULL,0,'2019-11-29 22:15:23',NULL,10796,'0',11381,896,16,NULL,'cmdb2-3-2-1'),(NULL,0,'2019-11-29 22:15:23',NULL,10797,'0',11382,896,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,10798,'0',11383,896,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:23',NULL,10799,'0',11384,896,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,10800,'0',11385,896,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,10801,'0',11386,896,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:23',NULL,10802,'0',11387,896,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,10803,'0',11388,896,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:23',NULL,10804,'0',11389,896,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,10805,'0',11390,896,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,10806,'0',11391,896,15,NULL,'10.6.2.1'),(NULL,0,'2019-11-29 22:15:23',NULL,10807,'0',11392,896,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,10808,'0',11393,896,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,10809,'0',11394,896,5,NULL,'4906bee8655348be85d89cde35504ba5'),(NULL,0,'2019-11-29 22:15:23',NULL,10810,'0',11395,896,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:24',NULL,10811,'0',11397,897,16,NULL,'cmdb2-3-2-2'),(NULL,0,'2019-11-29 22:15:24',NULL,10812,'0',11398,897,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,10813,'0',11399,897,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:24',NULL,10814,'0',11400,897,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,10815,'0',11401,897,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,10816,'0',11402,897,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:24',NULL,10817,'0',11403,897,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,10818,'0',11404,897,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:24',NULL,10819,'0',11405,897,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,10820,'0',11406,897,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,10821,'0',11407,897,15,NULL,'10.6.2.2'),(NULL,0,'2019-11-29 22:15:24',NULL,10822,'0',11408,897,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,10823,'0',11409,897,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,10824,'0',11410,897,5,NULL,'8f7d4ebadae44507a4ba71374c42cd96'),(NULL,0,'2019-11-29 22:15:24',NULL,10825,'0',11411,897,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:24',NULL,10826,'0',11413,898,16,NULL,'cmdb2-3-2-3'),(NULL,0,'2019-11-29 22:15:24',NULL,10827,'0',11414,898,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,10828,'0',11415,898,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:24',NULL,10829,'0',11416,898,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,10830,'0',11417,898,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,10831,'0',11418,898,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:24',NULL,10832,'0',11419,898,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,10833,'0',11420,898,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:24',NULL,10834,'0',11421,898,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,10835,'0',11422,898,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,10836,'0',11423,898,15,NULL,'10.6.2.3'),(NULL,0,'2019-11-29 22:15:24',NULL,10837,'0',11424,898,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,10838,'0',11425,898,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,10839,'0',11426,898,5,NULL,'aba7ad28c5cb4a5cb38451bac746fac4'),(NULL,0,'2019-11-29 22:15:24',NULL,10840,'0',11427,898,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:24',NULL,10841,'0',11429,899,16,NULL,'cmdb2-3-2-4'),(NULL,0,'2019-11-29 22:15:24',NULL,10842,'0',11430,899,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,10843,'0',11431,899,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:24',NULL,10844,'0',11432,899,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,10845,'0',11433,899,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,10846,'0',11434,899,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:24',NULL,10847,'0',11435,899,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,10848,'0',11436,899,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:24',NULL,10849,'0',11437,899,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,10850,'0',11438,899,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,10851,'0',11439,899,15,NULL,'10.6.2.4'),(NULL,0,'2019-11-29 22:15:24',NULL,10852,'0',11440,899,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,10853,'0',11441,899,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,10854,'0',11442,899,5,NULL,'8d808b6436a24345884fc9095d741838'),(NULL,0,'2019-11-29 22:15:24',NULL,10855,'0',11443,899,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:24',NULL,10856,'0',11445,900,16,NULL,'cmdb2-3-2-5'),(NULL,0,'2019-11-29 22:15:24',NULL,10857,'0',11446,900,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,10858,'0',11447,900,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:24',NULL,10859,'0',11448,900,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,10860,'0',11449,900,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,10861,'0',11450,900,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:24',NULL,10862,'0',11451,900,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,10863,'0',11452,900,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:24',NULL,10864,'0',11453,900,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,10865,'0',11454,900,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,10866,'0',11455,900,15,NULL,'10.6.2.5'),(NULL,0,'2019-11-29 22:15:24',NULL,10867,'0',11456,900,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,10868,'0',11457,900,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,10869,'0',11458,900,5,NULL,'75b8dddf52914a6c96a89ae377dd7ac3'),(NULL,0,'2019-11-29 22:15:24',NULL,10870,'0',11459,900,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:24',NULL,10871,'0',11461,901,16,NULL,'cmdb2-3-2-6'),(NULL,0,'2019-11-29 22:15:24',NULL,10872,'0',11462,901,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,10873,'0',11463,901,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:25',NULL,10874,'0',11464,901,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,10875,'0',11465,901,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,10876,'0',11466,901,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:25',NULL,10877,'0',11467,901,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,10878,'0',11468,901,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:25',NULL,10879,'0',11469,901,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,10880,'0',11470,901,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,10881,'0',11471,901,15,NULL,'10.6.2.6'),(NULL,0,'2019-11-29 22:15:25',NULL,10882,'0',11472,901,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,10883,'0',11473,901,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,10884,'0',11474,901,5,NULL,'929ae3f143b742ee81ec316a25ede075'),(NULL,0,'2019-11-29 22:15:25',NULL,10885,'0',11475,901,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:25',NULL,10886,'0',11477,902,16,NULL,'cmdb2-3-2-7'),(NULL,0,'2019-11-29 22:15:25',NULL,10887,'0',11478,902,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,10888,'0',11479,902,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:25',NULL,10889,'0',11480,902,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,10890,'0',11481,902,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,10891,'0',11482,902,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:25',NULL,10892,'0',11483,902,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,10893,'0',11484,902,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:25',NULL,10894,'0',11485,902,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,10895,'0',11486,902,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,10896,'0',11487,902,15,NULL,'10.6.2.7'),(NULL,0,'2019-11-29 22:15:25',NULL,10897,'0',11488,902,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,10898,'0',11489,902,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,10899,'0',11490,902,5,NULL,'da27aba3d9ef4234ae715878b034920c'),(NULL,0,'2019-11-29 22:15:25',NULL,10900,'0',11491,902,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:25',NULL,10901,'0',11493,903,16,NULL,'cmdb2-3-2-8'),(NULL,0,'2019-11-29 22:15:25',NULL,10902,'0',11494,903,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,10903,'0',11495,903,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:25',NULL,10904,'0',11496,903,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,10905,'0',11497,903,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,10906,'0',11498,903,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:25',NULL,10907,'0',11499,903,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,10908,'0',11500,903,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:25',NULL,10909,'0',11501,903,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,10910,'0',11502,903,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,10911,'0',11503,903,15,NULL,'10.6.2.8'),(NULL,0,'2019-11-29 22:15:25',NULL,10912,'0',11504,903,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,10913,'0',11505,903,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,10914,'0',11506,903,5,NULL,'e2c2df1da0f8426181f5d64da5bf8d3b'),(NULL,0,'2019-11-29 22:15:25',NULL,10915,'0',11507,903,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:25',NULL,10916,'0',11509,904,16,NULL,'cmdb2-3-2-9'),(NULL,0,'2019-11-29 22:15:25',NULL,10917,'0',11510,904,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,10918,'0',11511,904,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:25',NULL,10919,'0',11512,904,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,10920,'0',11513,904,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,10921,'0',11514,904,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:25',NULL,10922,'0',11515,904,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,10923,'0',11516,904,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:25',NULL,10924,'0',11517,904,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,10925,'0',11518,904,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,10926,'0',11519,904,15,NULL,'10.6.2.9'),(NULL,0,'2019-11-29 22:15:25',NULL,10927,'0',11520,904,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,10928,'0',11521,904,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,10929,'0',11522,904,5,NULL,'3f615595fe3a47ed8a71f054f32803b2'),(NULL,0,'2019-11-29 22:15:25',NULL,10930,'0',11523,904,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:25',NULL,10931,'0',11525,905,16,NULL,'cmdb2-3-2-10'),(NULL,0,'2019-11-29 22:15:25',NULL,10932,'0',11526,905,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,10933,'0',11527,905,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:25',NULL,10934,'0',11528,905,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,10935,'0',11529,905,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,10936,'0',11530,905,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:25',NULL,10937,'0',11531,905,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,10938,'0',11532,905,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:26',NULL,10939,'0',11533,905,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,10940,'0',11534,905,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,10941,'0',11535,905,15,NULL,'10.6.2.10'),(NULL,0,'2019-11-29 22:15:26',NULL,10942,'0',11536,905,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,10943,'0',11537,905,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,10944,'0',11538,905,5,NULL,'653cf1ca94884b42a20b62ed1f77fd0f'),(NULL,0,'2019-11-29 22:15:26',NULL,10945,'0',11539,905,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:26',NULL,10946,'0',11541,906,16,NULL,'cmdb2-3-2-11'),(NULL,0,'2019-11-29 22:15:26',NULL,10947,'0',11542,906,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,10948,'0',11543,906,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:26',NULL,10949,'0',11544,906,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,10950,'0',11545,906,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,10951,'0',11546,906,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:26',NULL,10952,'0',11547,906,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,10953,'0',11548,906,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:26',NULL,10954,'0',11549,906,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,10955,'0',11550,906,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,10956,'0',11551,906,15,NULL,'10.6.2.11'),(NULL,0,'2019-11-29 22:15:26',NULL,10957,'0',11552,906,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,10958,'0',11553,906,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,10959,'0',11554,906,5,NULL,'e2a689f0bf364e4cb0388801c1744506'),(NULL,0,'2019-11-29 22:15:26',NULL,10960,'0',11555,906,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:26',NULL,10961,'0',11557,907,16,NULL,'cmdb2-3-2-12'),(NULL,0,'2019-11-29 22:15:26',NULL,10962,'0',11558,907,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,10963,'0',11559,907,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:26',NULL,10964,'0',11560,907,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,10965,'0',11561,907,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,10966,'0',11562,907,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:26',NULL,10967,'0',11563,907,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,10968,'0',11564,907,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:26',NULL,10969,'0',11565,907,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,10970,'0',11566,907,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,10971,'0',11567,907,15,NULL,'10.6.2.12'),(NULL,0,'2019-11-29 22:15:26',NULL,10972,'0',11568,907,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,10973,'0',11569,907,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,10974,'0',11570,907,5,NULL,'ffc8e85cb1a54f44b52dfad60befd8cf'),(NULL,0,'2019-11-29 22:15:26',NULL,10975,'0',11571,907,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:26',NULL,10976,'0',11573,908,16,NULL,'cmdb2-3-2-13'),(NULL,0,'2019-11-29 22:15:26',NULL,10977,'0',11574,908,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,10978,'0',11575,908,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:26',NULL,10979,'0',11576,908,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,10980,'0',11577,908,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,10981,'0',11578,908,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:26',NULL,10982,'0',11579,908,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,10983,'0',11580,908,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:26',NULL,10984,'0',11581,908,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,10985,'0',11582,908,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,10986,'0',11583,908,15,NULL,'10.6.2.13'),(NULL,0,'2019-11-29 22:15:26',NULL,10987,'0',11584,908,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,10988,'0',11585,908,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,10989,'0',11586,908,5,NULL,'e085988d580c4b94a5dc7f433d557846'),(NULL,0,'2019-11-29 22:15:26',NULL,10990,'0',11587,908,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:26',NULL,10991,'0',11589,909,16,NULL,'cmdb2-3-2-14'),(NULL,0,'2019-11-29 22:15:26',NULL,10992,'0',11590,909,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,10993,'0',11591,909,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:26',NULL,10994,'0',11592,909,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,10995,'0',11593,909,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,10996,'0',11594,909,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:26',NULL,10997,'0',11595,909,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,10998,'0',11596,909,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:26',NULL,10999,'0',11597,909,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,11000,'0',11598,909,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,11001,'0',11599,909,15,NULL,'10.6.2.14'),(NULL,0,'2019-11-29 22:15:26',NULL,11002,'0',11600,909,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,11003,'0',11601,909,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,11004,'0',11602,909,5,NULL,'50faee862d2841348f5570812bc7a8ff'),(NULL,0,'2019-11-29 22:15:26',NULL,11005,'0',11603,909,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:27',NULL,11006,'0',11605,910,16,NULL,'cmdb2-3-2-15'),(NULL,0,'2019-11-29 22:15:27',NULL,11007,'0',11606,910,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,11008,'0',11607,910,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:27',NULL,11009,'0',11608,910,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,11010,'0',11609,910,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,11011,'0',11610,910,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:27',NULL,11012,'0',11611,910,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,11013,'0',11612,910,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:27',NULL,11014,'0',11613,910,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,11015,'0',11614,910,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,11016,'0',11615,910,15,NULL,'10.6.2.15'),(NULL,0,'2019-11-29 22:15:27',NULL,11017,'0',11616,910,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,11018,'0',11617,910,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,11019,'0',11618,910,5,NULL,'a262f90dea93417cb60c0bacba34f35e'),(NULL,0,'2019-11-29 22:15:27',NULL,11020,'0',11619,910,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:27',NULL,11021,'0',11621,911,16,NULL,'cmdb2-3-2-16'),(NULL,0,'2019-11-29 22:15:27',NULL,11022,'0',11622,911,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,11023,'0',11623,911,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:27',NULL,11024,'0',11624,911,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,11025,'0',11625,911,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,11026,'0',11626,911,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:27',NULL,11027,'0',11627,911,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,11028,'0',11628,911,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:27',NULL,11029,'0',11629,911,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,11030,'0',11630,911,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,11031,'0',11631,911,15,NULL,'10.6.2.16'),(NULL,0,'2019-11-29 22:15:27',NULL,11032,'0',11632,911,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,11033,'0',11633,911,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,11034,'0',11634,911,5,NULL,'e7609bf8c37e4df9b1c668d8fe923e31'),(NULL,0,'2019-11-29 22:15:27',NULL,11035,'0',11635,911,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:27',NULL,11036,'0',11637,912,4,NULL,'App2-3-3'),(NULL,0,'2019-11-29 22:15:27',NULL,11037,'0',11639,913,16,NULL,'cmdb2-3-3-1'),(NULL,0,'2019-11-29 22:15:27',NULL,11038,'0',11640,913,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,11039,'0',11641,913,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:27',NULL,11040,'0',11642,913,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,11041,'0',11643,913,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,11042,'0',11644,913,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:27',NULL,11043,'0',11645,913,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,11044,'0',11646,913,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:27',NULL,11045,'0',11647,913,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,11046,'0',11648,913,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,11047,'0',11649,913,15,NULL,'10.6.3.1'),(NULL,0,'2019-11-29 22:15:27',NULL,11048,'0',11650,913,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,11049,'0',11651,913,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,11050,'0',11652,913,5,NULL,'8121e27494e94612a3334771af9bce6c'),(NULL,0,'2019-11-29 22:15:27',NULL,11051,'0',11653,913,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:27',NULL,11052,'0',11655,914,16,NULL,'cmdb2-3-3-2'),(NULL,0,'2019-11-29 22:15:27',NULL,11053,'0',11656,914,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,11054,'0',11657,914,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:27',NULL,11055,'0',11658,914,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,11056,'0',11659,914,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,11057,'0',11660,914,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:27',NULL,11058,'0',11661,914,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,11059,'0',11662,914,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:27',NULL,11060,'0',11663,914,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,11061,'0',11664,914,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,11062,'0',11665,914,15,NULL,'10.6.3.2'),(NULL,0,'2019-11-29 22:15:27',NULL,11063,'0',11666,914,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,11064,'0',11667,914,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,11065,'0',11668,914,5,NULL,'c90204263f8942168ae0b146c3a36a01'),(NULL,0,'2019-11-29 22:15:27',NULL,11066,'0',11669,914,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:28',NULL,11067,'0',11671,915,16,NULL,'cmdb2-3-3-3'),(NULL,0,'2019-11-29 22:15:28',NULL,11068,'0',11672,915,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,11069,'0',11673,915,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:28',NULL,11070,'0',11674,915,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,11071,'0',11675,915,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,11072,'0',11676,915,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:28',NULL,11073,'0',11677,915,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,11074,'0',11678,915,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:28',NULL,11075,'0',11679,915,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,11076,'0',11680,915,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,11077,'0',11681,915,15,NULL,'10.6.3.3'),(NULL,0,'2019-11-29 22:15:28',NULL,11078,'0',11682,915,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,11079,'0',11683,915,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,11080,'0',11684,915,5,NULL,'f7d03b9ecc084bd391b58d1afd02671c'),(NULL,0,'2019-11-29 22:15:28',NULL,11081,'0',11685,915,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:28',NULL,11082,'0',11687,916,16,NULL,'cmdb2-3-3-4'),(NULL,0,'2019-11-29 22:15:28',NULL,11083,'0',11688,916,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,11084,'0',11689,916,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:28',NULL,11085,'0',11690,916,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,11086,'0',11691,916,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,11087,'0',11692,916,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:28',NULL,11088,'0',11693,916,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,11089,'0',11694,916,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:28',NULL,11090,'0',11695,916,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,11091,'0',11696,916,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,11092,'0',11697,916,15,NULL,'10.6.3.4'),(NULL,0,'2019-11-29 22:15:28',NULL,11093,'0',11698,916,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,11094,'0',11699,916,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,11095,'0',11700,916,5,NULL,'3f9b57fbb9bd4cb7bb99058cee005d20'),(NULL,0,'2019-11-29 22:15:28',NULL,11096,'0',11701,916,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:28',NULL,11097,'0',11703,917,16,NULL,'cmdb2-3-3-5'),(NULL,0,'2019-11-29 22:15:28',NULL,11098,'0',11704,917,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,11099,'0',11705,917,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:28',NULL,11100,'0',11706,917,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,11101,'0',11707,917,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,11102,'0',11708,917,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:28',NULL,11103,'0',11709,917,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,11104,'0',11710,917,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:28',NULL,11105,'0',11711,917,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,11106,'0',11712,917,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,11107,'0',11713,917,15,NULL,'10.6.3.5'),(NULL,0,'2019-11-29 22:15:28',NULL,11108,'0',11714,917,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,11109,'0',11715,917,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,11110,'0',11716,917,5,NULL,'b427ee9775784e19b35042dbe748dc10'),(NULL,0,'2019-11-29 22:15:28',NULL,11111,'0',11717,917,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:28',NULL,11112,'0',11719,918,16,NULL,'cmdb2-3-3-6'),(NULL,0,'2019-11-29 22:15:28',NULL,11113,'0',11720,918,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,11114,'0',11721,918,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:28',NULL,11115,'0',11722,918,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,11116,'0',11723,918,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,11117,'0',11724,918,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:28',NULL,11118,'0',11725,918,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,11119,'0',11726,918,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:28',NULL,11120,'0',11727,918,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,11121,'0',11728,918,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,11122,'0',11729,918,15,NULL,'10.6.3.6'),(NULL,0,'2019-11-29 22:15:28',NULL,11123,'0',11730,918,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,11124,'0',11731,918,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,11125,'0',11732,918,5,NULL,'1c453a163b5b43ae80db3477e3a83cf1'),(NULL,0,'2019-11-29 22:15:28',NULL,11126,'0',11733,918,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:28',NULL,11127,'0',11735,919,16,NULL,'cmdb2-3-3-7'),(NULL,0,'2019-11-29 22:15:28',NULL,11128,'0',11736,919,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,11129,'0',11737,919,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:29',NULL,11130,'0',11738,919,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,11131,'0',11739,919,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,11132,'0',11740,919,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:29',NULL,11133,'0',11741,919,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,11134,'0',11742,919,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:29',NULL,11135,'0',11743,919,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,11136,'0',11744,919,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,11137,'0',11745,919,15,NULL,'10.6.3.7'),(NULL,0,'2019-11-29 22:15:29',NULL,11138,'0',11746,919,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,11139,'0',11747,919,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,11140,'0',11748,919,5,NULL,'85b2b06c544048ae99979a310f5f7023'),(NULL,0,'2019-11-29 22:15:29',NULL,11141,'0',11749,919,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:29',NULL,11142,'0',11751,920,16,NULL,'cmdb2-3-3-8'),(NULL,0,'2019-11-29 22:15:29',NULL,11143,'0',11752,920,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,11144,'0',11753,920,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:29',NULL,11145,'0',11754,920,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,11146,'0',11755,920,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,11147,'0',11756,920,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:29',NULL,11148,'0',11757,920,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,11149,'0',11758,920,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:29',NULL,11150,'0',11759,920,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,11151,'0',11760,920,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,11152,'0',11761,920,15,NULL,'10.6.3.8'),(NULL,0,'2019-11-29 22:15:29',NULL,11153,'0',11762,920,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,11154,'0',11763,920,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,11155,'0',11764,920,5,NULL,'617cac71514d46cdb163b9c057593f4d'),(NULL,0,'2019-11-29 22:15:29',NULL,11156,'0',11765,920,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:29',NULL,11157,'0',11767,921,16,NULL,'cmdb2-3-3-9'),(NULL,0,'2019-11-29 22:15:29',NULL,11158,'0',11768,921,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,11159,'0',11769,921,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:29',NULL,11160,'0',11770,921,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,11161,'0',11771,921,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,11162,'0',11772,921,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:29',NULL,11163,'0',11773,921,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,11164,'0',11774,921,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:29',NULL,11165,'0',11775,921,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,11166,'0',11776,921,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,11167,'0',11777,921,15,NULL,'10.6.3.9'),(NULL,0,'2019-11-29 22:15:29',NULL,11168,'0',11778,921,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,11169,'0',11779,921,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,11170,'0',11780,921,5,NULL,'fa575de38b4d4d94986391b9a7b70729'),(NULL,0,'2019-11-29 22:15:29',NULL,11171,'0',11781,921,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:29',NULL,11172,'0',11783,922,16,NULL,'cmdb2-3-3-10'),(NULL,0,'2019-11-29 22:15:29',NULL,11173,'0',11784,922,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,11174,'0',11785,922,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:29',NULL,11175,'0',11786,922,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,11176,'0',11787,922,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,11177,'0',11788,922,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:29',NULL,11178,'0',11789,922,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,11179,'0',11790,922,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:29',NULL,11180,'0',11791,922,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,11181,'0',11792,922,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,11182,'0',11793,922,15,NULL,'10.6.3.10'),(NULL,0,'2019-11-29 22:15:29',NULL,11183,'0',11794,922,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,11184,'0',11795,922,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,11185,'0',11796,922,5,NULL,'026da94df6a5447992e7361ddb6b45ba'),(NULL,0,'2019-11-29 22:15:29',NULL,11186,'0',11797,922,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:29',NULL,11187,'0',11799,923,16,NULL,'cmdb2-3-3-11'),(NULL,0,'2019-11-29 22:15:29',NULL,11188,'0',11800,923,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,11189,'0',11801,923,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:29',NULL,11190,'0',11802,923,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,11191,'0',11803,923,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,11192,'0',11804,923,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:29',NULL,11193,'0',11805,923,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,11194,'0',11806,923,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:29',NULL,11195,'0',11807,923,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,11196,'0',11808,923,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,11197,'0',11809,923,15,NULL,'10.6.3.11'),(NULL,0,'2019-11-29 22:15:30',NULL,11198,'0',11810,923,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,11199,'0',11811,923,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,11200,'0',11812,923,5,NULL,'e346bad70c874d488adcf8bee9b6bd00'),(NULL,0,'2019-11-29 22:15:30',NULL,11201,'0',11813,923,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:30',NULL,11202,'0',11815,924,16,NULL,'cmdb2-3-3-12'),(NULL,0,'2019-11-29 22:15:30',NULL,11203,'0',11816,924,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,11204,'0',11817,924,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:30',NULL,11205,'0',11818,924,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,11206,'0',11819,924,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,11207,'0',11820,924,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:30',NULL,11208,'0',11821,924,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,11209,'0',11822,924,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:30',NULL,11210,'0',11823,924,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,11211,'0',11824,924,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,11212,'0',11825,924,15,NULL,'10.6.3.12'),(NULL,0,'2019-11-29 22:15:30',NULL,11213,'0',11826,924,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,11214,'0',11827,924,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,11215,'0',11828,924,5,NULL,'a13595606ec741ea8bdc7266c163a76a'),(NULL,0,'2019-11-29 22:15:30',NULL,11216,'0',11829,924,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:30',NULL,11217,'0',11831,925,16,NULL,'cmdb2-3-3-13'),(NULL,0,'2019-11-29 22:15:30',NULL,11218,'0',11832,925,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,11219,'0',11833,925,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:30',NULL,11220,'0',11834,925,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,11221,'0',11835,925,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,11222,'0',11836,925,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:30',NULL,11223,'0',11837,925,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,11224,'0',11838,925,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:30',NULL,11225,'0',11839,925,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,11226,'0',11840,925,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,11227,'0',11841,925,15,NULL,'10.6.3.13'),(NULL,0,'2019-11-29 22:15:30',NULL,11228,'0',11842,925,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,11229,'0',11843,925,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,11230,'0',11844,925,5,NULL,'9eeeaddf6dd74582bd5f5c55120b6dd2'),(NULL,0,'2019-11-29 22:15:30',NULL,11231,'0',11845,925,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:30',NULL,11232,'0',11847,926,16,NULL,'cmdb2-3-3-14'),(NULL,0,'2019-11-29 22:15:30',NULL,11233,'0',11848,926,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,11234,'0',11849,926,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:30',NULL,11235,'0',11850,926,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,11236,'0',11851,926,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,11237,'0',11852,926,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:30',NULL,11238,'0',11853,926,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,11239,'0',11854,926,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:30',NULL,11240,'0',11855,926,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,11241,'0',11856,926,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,11242,'0',11857,926,15,NULL,'10.6.3.14'),(NULL,0,'2019-11-29 22:15:30',NULL,11243,'0',11858,926,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,11244,'0',11859,926,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,11245,'0',11860,926,5,NULL,'0f342327ef7741e694d63833f6dc41cb'),(NULL,0,'2019-11-29 22:15:30',NULL,11246,'0',11861,926,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:30',NULL,11247,'0',11863,927,16,NULL,'cmdb2-3-3-15'),(NULL,0,'2019-11-29 22:15:30',NULL,11248,'0',11864,927,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,11249,'0',11865,927,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:30',NULL,11250,'0',11866,927,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,11251,'0',11867,927,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,11252,'0',11868,927,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:30',NULL,11253,'0',11869,927,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,11254,'0',11870,927,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:30',NULL,11255,'0',11871,927,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,11256,'0',11872,927,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,11257,'0',11873,927,15,NULL,'10.6.3.15'),(NULL,0,'2019-11-29 22:15:30',NULL,11258,'0',11874,927,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,11259,'0',11875,927,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,11260,'0',11876,927,5,NULL,'ade4a2dc470b487b853d0335faa8f662'),(NULL,0,'2019-11-29 22:15:30',NULL,11261,'0',11877,927,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:31',NULL,11262,'0',11879,928,16,NULL,'cmdb2-3-3-16'),(NULL,0,'2019-11-29 22:15:31',NULL,11263,'0',11880,928,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,11264,'0',11881,928,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:31',NULL,11265,'0',11882,928,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,11266,'0',11883,928,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,11267,'0',11884,928,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:31',NULL,11268,'0',11885,928,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,11269,'0',11886,928,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:31',NULL,11270,'0',11887,928,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,11271,'0',11888,928,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,11272,'0',11889,928,15,NULL,'10.6.3.16'),(NULL,0,'2019-11-29 22:15:31',NULL,11273,'0',11890,928,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,11274,'0',11891,928,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,11275,'0',11892,928,5,NULL,'726485a0297740eaa1484195cfa46ac9'),(NULL,0,'2019-11-29 22:15:31',NULL,11276,'0',11893,928,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:31',NULL,11277,'0',11895,929,4,NULL,'App2-3-4'),(NULL,0,'2019-11-29 22:15:31',NULL,11278,'0',11897,930,16,NULL,'cmdb2-3-4-1'),(NULL,0,'2019-11-29 22:15:31',NULL,11279,'0',11898,930,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,11280,'0',11899,930,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:31',NULL,11281,'0',11900,930,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,11282,'0',11901,930,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,11283,'0',11902,930,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:31',NULL,11284,'0',11903,930,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,11285,'0',11904,930,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:31',NULL,11286,'0',11905,930,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,11287,'0',11906,930,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,11288,'0',11907,930,15,NULL,'10.6.4.1'),(NULL,0,'2019-11-29 22:15:31',NULL,11289,'0',11908,930,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,11290,'0',11909,930,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,11291,'0',11910,930,5,NULL,'0f8beca863f64c35981fcd0b6da79051'),(NULL,0,'2019-11-29 22:15:31',NULL,11292,'0',11911,930,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:31',NULL,11293,'0',11913,931,16,NULL,'cmdb2-3-4-2'),(NULL,0,'2019-11-29 22:15:31',NULL,11294,'0',11914,931,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,11295,'0',11915,931,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:31',NULL,11296,'0',11916,931,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,11297,'0',11917,931,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,11298,'0',11918,931,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:31',NULL,11299,'0',11919,931,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,11300,'0',11920,931,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:31',NULL,11301,'0',11921,931,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,11302,'0',11922,931,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,11303,'0',11923,931,15,NULL,'10.6.4.2'),(NULL,0,'2019-11-29 22:15:31',NULL,11304,'0',11924,931,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,11305,'0',11925,931,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,11306,'0',11926,931,5,NULL,'b324341056974b87bb63eba4e1e84d09'),(NULL,0,'2019-11-29 22:15:31',NULL,11307,'0',11927,931,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:31',NULL,11308,'0',11929,932,16,NULL,'cmdb2-3-4-3'),(NULL,0,'2019-11-29 22:15:31',NULL,11309,'0',11930,932,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,11310,'0',11931,932,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:31',NULL,11311,'0',11932,932,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,11312,'0',11933,932,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,11313,'0',11934,932,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:31',NULL,11314,'0',11935,932,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,11315,'0',11936,932,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:31',NULL,11316,'0',11937,932,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,11317,'0',11938,932,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,11318,'0',11939,932,15,NULL,'10.6.4.3'),(NULL,0,'2019-11-29 22:15:31',NULL,11319,'0',11940,932,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,11320,'0',11941,932,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,11321,'0',11942,932,5,NULL,'6105d4e9a9f74c42bee6e512300c3c11'),(NULL,0,'2019-11-29 22:15:31',NULL,11322,'0',11943,932,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:32',NULL,11323,'0',11945,933,16,NULL,'cmdb2-3-4-4'),(NULL,0,'2019-11-29 22:15:32',NULL,11324,'0',11946,933,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,11325,'0',11947,933,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:32',NULL,11326,'0',11948,933,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,11327,'0',11949,933,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,11328,'0',11950,933,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:32',NULL,11329,'0',11951,933,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,11330,'0',11952,933,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:32',NULL,11331,'0',11953,933,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,11332,'0',11954,933,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,11333,'0',11955,933,15,NULL,'10.6.4.4'),(NULL,0,'2019-11-29 22:15:32',NULL,11334,'0',11956,933,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,11335,'0',11957,933,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,11336,'0',11958,933,5,NULL,'9c23f2955b0c4bb3b9199dd01d3f6ba3'),(NULL,0,'2019-11-29 22:15:32',NULL,11337,'0',11959,933,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:32',NULL,11338,'0',11961,934,16,NULL,'cmdb2-3-4-5'),(NULL,0,'2019-11-29 22:15:32',NULL,11339,'0',11962,934,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,11340,'0',11963,934,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:32',NULL,11341,'0',11964,934,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,11342,'0',11965,934,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,11343,'0',11966,934,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:32',NULL,11344,'0',11967,934,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,11345,'0',11968,934,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:32',NULL,11346,'0',11969,934,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,11347,'0',11970,934,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,11348,'0',11971,934,15,NULL,'10.6.4.5'),(NULL,0,'2019-11-29 22:15:32',NULL,11349,'0',11972,934,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,11350,'0',11973,934,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,11351,'0',11974,934,5,NULL,'6fa3953735fd4c42910eb251a22405f1'),(NULL,0,'2019-11-29 22:15:32',NULL,11352,'0',11975,934,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:32',NULL,11353,'0',11977,935,16,NULL,'cmdb2-3-4-6'),(NULL,0,'2019-11-29 22:15:32',NULL,11354,'0',11978,935,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,11355,'0',11979,935,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:32',NULL,11356,'0',11980,935,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,11357,'0',11981,935,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,11358,'0',11982,935,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:32',NULL,11359,'0',11983,935,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,11360,'0',11984,935,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:32',NULL,11361,'0',11985,935,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,11362,'0',11986,935,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,11363,'0',11987,935,15,NULL,'10.6.4.6'),(NULL,0,'2019-11-29 22:15:32',NULL,11364,'0',11988,935,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,11365,'0',11989,935,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,11366,'0',11990,935,5,NULL,'cb8f2371a62842498407cd35f2a6153b'),(NULL,0,'2019-11-29 22:15:32',NULL,11367,'0',11991,935,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:32',NULL,11368,'0',11993,936,16,NULL,'cmdb2-3-4-7'),(NULL,0,'2019-11-29 22:15:32',NULL,11369,'0',11994,936,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,11370,'0',11995,936,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:32',NULL,11371,'0',11996,936,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,11372,'0',11997,936,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,11373,'0',11998,936,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:32',NULL,11374,'0',11999,936,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,11375,'0',12000,936,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:32',NULL,11376,'0',12001,936,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,11377,'0',12002,936,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,11378,'0',12003,936,15,NULL,'10.6.4.7'),(NULL,0,'2019-11-29 22:15:32',NULL,11379,'0',12004,936,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,11380,'0',12005,936,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,11381,'0',12006,936,5,NULL,'c5b03f91d9554f81afd7c8b0c0ac756a'),(NULL,0,'2019-11-29 22:15:32',NULL,11382,'0',12007,936,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:32',NULL,11383,'0',12009,937,16,NULL,'cmdb2-3-4-8'),(NULL,0,'2019-11-29 22:15:32',NULL,11384,'0',12010,937,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,11385,'0',12011,937,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:32',NULL,11386,'0',12012,937,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,11387,'0',12013,937,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,11388,'0',12014,937,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:33',NULL,11389,'0',12015,937,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,11390,'0',12016,937,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:33',NULL,11391,'0',12017,937,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,11392,'0',12018,937,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,11393,'0',12019,937,15,NULL,'10.6.4.8'),(NULL,0,'2019-11-29 22:15:33',NULL,11394,'0',12020,937,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,11395,'0',12021,937,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,11396,'0',12022,937,5,NULL,'7d508f974e3c4df69ffa5da9e6abab37'),(NULL,0,'2019-11-29 22:15:33',NULL,11397,'0',12023,937,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:33',NULL,11398,'0',12025,938,16,NULL,'cmdb2-3-4-9'),(NULL,0,'2019-11-29 22:15:33',NULL,11399,'0',12026,938,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,11400,'0',12027,938,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:33',NULL,11401,'0',12028,938,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,11402,'0',12029,938,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,11403,'0',12030,938,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:33',NULL,11404,'0',12031,938,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,11405,'0',12032,938,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:33',NULL,11406,'0',12033,938,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,11407,'0',12034,938,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,11408,'0',12035,938,15,NULL,'10.6.4.9'),(NULL,0,'2019-11-29 22:15:33',NULL,11409,'0',12036,938,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,11410,'0',12037,938,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,11411,'0',12038,938,5,NULL,'bc2d884128df4300adc5f7be1461c780'),(NULL,0,'2019-11-29 22:15:33',NULL,11412,'0',12039,938,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:33',NULL,11413,'0',12041,939,16,NULL,'cmdb2-3-4-10'),(NULL,0,'2019-11-29 22:15:33',NULL,11414,'0',12042,939,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,11415,'0',12043,939,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:33',NULL,11416,'0',12044,939,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,11417,'0',12045,939,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,11418,'0',12046,939,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:33',NULL,11419,'0',12047,939,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,11420,'0',12048,939,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:33',NULL,11421,'0',12049,939,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,11422,'0',12050,939,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,11423,'0',12051,939,15,NULL,'10.6.4.10'),(NULL,0,'2019-11-29 22:15:33',NULL,11424,'0',12052,939,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,11425,'0',12053,939,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,11426,'0',12054,939,5,NULL,'0b89dd5d406849748a963c7597b11ddb'),(NULL,0,'2019-11-29 22:15:33',NULL,11427,'0',12055,939,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:33',NULL,11428,'0',12057,940,16,NULL,'cmdb2-3-4-11'),(NULL,0,'2019-11-29 22:15:33',NULL,11429,'0',12058,940,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,11430,'0',12059,940,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:33',NULL,11431,'0',12060,940,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,11432,'0',12061,940,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,11433,'0',12062,940,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:33',NULL,11434,'0',12063,940,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,11435,'0',12064,940,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:33',NULL,11436,'0',12065,940,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,11437,'0',12066,940,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,11438,'0',12067,940,15,NULL,'10.6.4.11'),(NULL,0,'2019-11-29 22:15:33',NULL,11439,'0',12068,940,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,11440,'0',12069,940,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,11441,'0',12070,940,5,NULL,'792ef66eda2046f6a0699fbfe2d1a781'),(NULL,0,'2019-11-29 22:15:33',NULL,11442,'0',12071,940,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:33',NULL,11443,'0',12073,941,16,NULL,'cmdb2-3-4-12'),(NULL,0,'2019-11-29 22:15:33',NULL,11444,'0',12074,941,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,11445,'0',12075,941,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:33',NULL,11446,'0',12076,941,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,11447,'0',12077,941,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,11448,'0',12078,941,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:33',NULL,11449,'0',12079,941,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,11450,'0',12080,941,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:33',NULL,11451,'0',12081,941,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,11452,'0',12082,941,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,11453,'0',12083,941,15,NULL,'10.6.4.12'),(NULL,0,'2019-11-29 22:15:34',NULL,11454,'0',12084,941,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,11455,'0',12085,941,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,11456,'0',12086,941,5,NULL,'c5eac1cf026b4fb2a20662ff2b2d89ab'),(NULL,0,'2019-11-29 22:15:34',NULL,11457,'0',12087,941,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:34',NULL,11458,'0',12089,942,16,NULL,'cmdb2-3-4-13'),(NULL,0,'2019-11-29 22:15:34',NULL,11459,'0',12090,942,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,11460,'0',12091,942,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:34',NULL,11461,'0',12092,942,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,11462,'0',12093,942,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,11463,'0',12094,942,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:34',NULL,11464,'0',12095,942,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,11465,'0',12096,942,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:34',NULL,11466,'0',12097,942,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,11467,'0',12098,942,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,11468,'0',12099,942,15,NULL,'10.6.4.13'),(NULL,0,'2019-11-29 22:15:34',NULL,11469,'0',12100,942,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,11470,'0',12101,942,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,11471,'0',12102,942,5,NULL,'cf93ff9fdf0246a3afb252f85f33dea8'),(NULL,0,'2019-11-29 22:15:34',NULL,11472,'0',12103,942,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:34',NULL,11473,'0',12105,943,16,NULL,'cmdb2-3-4-14'),(NULL,0,'2019-11-29 22:15:34',NULL,11474,'0',12106,943,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,11475,'0',12107,943,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:34',NULL,11476,'0',12108,943,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,11477,'0',12109,943,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,11478,'0',12110,943,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:34',NULL,11479,'0',12111,943,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,11480,'0',12112,943,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:34',NULL,11481,'0',12113,943,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,11482,'0',12114,943,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,11483,'0',12115,943,15,NULL,'10.6.4.14'),(NULL,0,'2019-11-29 22:15:34',NULL,11484,'0',12116,943,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,11485,'0',12117,943,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,11486,'0',12118,943,5,NULL,'789183f3a6554fe6ab4b33f9a81c7f79'),(NULL,0,'2019-11-29 22:15:34',NULL,11487,'0',12119,943,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:34',NULL,11488,'0',12121,944,16,NULL,'cmdb2-3-4-15'),(NULL,0,'2019-11-29 22:15:34',NULL,11489,'0',12122,944,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,11490,'0',12123,944,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:34',NULL,11491,'0',12124,944,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,11492,'0',12125,944,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,11493,'0',12126,944,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:34',NULL,11494,'0',12127,944,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,11495,'0',12128,944,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:34',NULL,11496,'0',12129,944,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,11497,'0',12130,944,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,11498,'0',12131,944,15,NULL,'10.6.4.15'),(NULL,0,'2019-11-29 22:15:34',NULL,11499,'0',12132,944,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,11500,'0',12133,944,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,11501,'0',12134,944,5,NULL,'2a4acaa1d49149fcb247177c027e8128'),(NULL,0,'2019-11-29 22:15:34',NULL,11502,'0',12135,944,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:34',NULL,11503,'0',12137,945,16,NULL,'cmdb2-3-4-16'),(NULL,0,'2019-11-29 22:15:34',NULL,11504,'0',12138,945,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,11505,'0',12139,945,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:34',NULL,11506,'0',12140,945,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,11507,'0',12141,945,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,11508,'0',12142,945,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:34',NULL,11509,'0',12143,945,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,11510,'0',12144,945,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:34',NULL,11511,'0',12145,945,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,11512,'0',12146,945,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,11513,'0',12147,945,15,NULL,'10.6.4.16'),(NULL,0,'2019-11-29 22:15:34',NULL,11514,'0',12148,945,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,11515,'0',12149,945,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,11516,'0',12150,945,5,NULL,'8cdf163dd50546ef9125c4a7bad1fd5c'),(NULL,0,'2019-11-29 22:15:34',NULL,11517,'0',12151,945,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:35',NULL,11518,'0',12153,946,4,NULL,'App2-3-5'),(NULL,0,'2019-11-29 22:15:35',NULL,11519,'0',12155,947,16,NULL,'cmdb2-3-5-1'),(NULL,0,'2019-11-29 22:15:35',NULL,11520,'0',12156,947,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,11521,'0',12157,947,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:35',NULL,11522,'0',12158,947,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,11523,'0',12159,947,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,11524,'0',12160,947,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:35',NULL,11525,'0',12161,947,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,11526,'0',12162,947,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:35',NULL,11527,'0',12163,947,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,11528,'0',12164,947,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,11529,'0',12165,947,15,NULL,'10.6.5.1'),(NULL,0,'2019-11-29 22:15:35',NULL,11530,'0',12166,947,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,11531,'0',12167,947,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,11532,'0',12168,947,5,NULL,'45d2099af1034aca9f1a4f0bfcf88f09'),(NULL,0,'2019-11-29 22:15:35',NULL,11533,'0',12169,947,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:35',NULL,11534,'0',12171,948,16,NULL,'cmdb2-3-5-2'),(NULL,0,'2019-11-29 22:15:35',NULL,11535,'0',12172,948,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,11536,'0',12173,948,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:35',NULL,11537,'0',12174,948,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,11538,'0',12175,948,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,11539,'0',12176,948,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:35',NULL,11540,'0',12177,948,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,11541,'0',12178,948,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:35',NULL,11542,'0',12179,948,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,11543,'0',12180,948,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,11544,'0',12181,948,15,NULL,'10.6.5.2'),(NULL,0,'2019-11-29 22:15:35',NULL,11545,'0',12182,948,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,11546,'0',12183,948,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,11547,'0',12184,948,5,NULL,'f98e3993085b45adac4a0ab9a007bf11'),(NULL,0,'2019-11-29 22:15:35',NULL,11548,'0',12185,948,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:35',NULL,11549,'0',12187,949,16,NULL,'cmdb2-3-5-3'),(NULL,0,'2019-11-29 22:15:35',NULL,11550,'0',12188,949,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,11551,'0',12189,949,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:35',NULL,11552,'0',12190,949,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,11553,'0',12191,949,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,11554,'0',12192,949,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:35',NULL,11555,'0',12193,949,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,11556,'0',12194,949,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:35',NULL,11557,'0',12195,949,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,11558,'0',12196,949,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,11559,'0',12197,949,15,NULL,'10.6.5.3'),(NULL,0,'2019-11-29 22:15:35',NULL,11560,'0',12198,949,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,11561,'0',12199,949,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,11562,'0',12200,949,5,NULL,'94c173e2a2c0493e85b3f2288f05843d'),(NULL,0,'2019-11-29 22:15:35',NULL,11563,'0',12201,949,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:35',NULL,11564,'0',12203,950,16,NULL,'cmdb2-3-5-4'),(NULL,0,'2019-11-29 22:15:35',NULL,11565,'0',12204,950,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,11566,'0',12205,950,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:35',NULL,11567,'0',12206,950,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,11568,'0',12207,950,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,11569,'0',12208,950,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:35',NULL,11570,'0',12209,950,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,11571,'0',12210,950,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:35',NULL,11572,'0',12211,950,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,11573,'0',12212,950,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,11574,'0',12213,950,15,NULL,'10.6.5.4'),(NULL,0,'2019-11-29 22:15:35',NULL,11575,'0',12214,950,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,11576,'0',12215,950,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,11577,'0',12216,950,5,NULL,'3a200c82ac0f47f48e8f16f03e328064'),(NULL,0,'2019-11-29 22:15:35',NULL,11578,'0',12217,950,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:36',NULL,11579,'0',12219,951,16,NULL,'cmdb2-3-5-5'),(NULL,0,'2019-11-29 22:15:36',NULL,11580,'0',12220,951,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,11581,'0',12221,951,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:36',NULL,11582,'0',12222,951,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,11583,'0',12223,951,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,11584,'0',12224,951,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:36',NULL,11585,'0',12225,951,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,11586,'0',12226,951,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:36',NULL,11587,'0',12227,951,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,11588,'0',12228,951,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,11589,'0',12229,951,15,NULL,'10.6.5.5'),(NULL,0,'2019-11-29 22:15:36',NULL,11590,'0',12230,951,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,11591,'0',12231,951,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,11592,'0',12232,951,5,NULL,'d49836803eed4ba9abe9873391b729fc'),(NULL,0,'2019-11-29 22:15:36',NULL,11593,'0',12233,951,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:36',NULL,11594,'0',12235,952,16,NULL,'cmdb2-3-5-6'),(NULL,0,'2019-11-29 22:15:36',NULL,11595,'0',12236,952,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,11596,'0',12237,952,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:36',NULL,11597,'0',12238,952,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,11598,'0',12239,952,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,11599,'0',12240,952,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:36',NULL,11600,'0',12241,952,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,11601,'0',12242,952,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:36',NULL,11602,'0',12243,952,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,11603,'0',12244,952,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,11604,'0',12245,952,15,NULL,'10.6.5.6'),(NULL,0,'2019-11-29 22:15:36',NULL,11605,'0',12246,952,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,11606,'0',12247,952,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,11607,'0',12248,952,5,NULL,'6ed982a4c7b84e30872c555248a58ce2'),(NULL,0,'2019-11-29 22:15:36',NULL,11608,'0',12249,952,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:36',NULL,11609,'0',12251,953,16,NULL,'cmdb2-3-5-7'),(NULL,0,'2019-11-29 22:15:36',NULL,11610,'0',12252,953,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,11611,'0',12253,953,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:36',NULL,11612,'0',12254,953,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,11613,'0',12255,953,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,11614,'0',12256,953,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:36',NULL,11615,'0',12257,953,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,11616,'0',12258,953,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:36',NULL,11617,'0',12259,953,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,11618,'0',12260,953,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,11619,'0',12261,953,15,NULL,'10.6.5.7'),(NULL,0,'2019-11-29 22:15:36',NULL,11620,'0',12262,953,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,11621,'0',12263,953,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,11622,'0',12264,953,5,NULL,'bb29e40425de4f40baaa1fb1878f8cc5'),(NULL,0,'2019-11-29 22:15:36',NULL,11623,'0',12265,953,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:36',NULL,11624,'0',12267,954,16,NULL,'cmdb2-3-5-8'),(NULL,0,'2019-11-29 22:15:36',NULL,11625,'0',12268,954,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,11626,'0',12269,954,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:36',NULL,11627,'0',12270,954,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,11628,'0',12271,954,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,11629,'0',12272,954,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:36',NULL,11630,'0',12273,954,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,11631,'0',12274,954,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:36',NULL,11632,'0',12275,954,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,11633,'0',12276,954,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,11634,'0',12277,954,15,NULL,'10.6.5.8'),(NULL,0,'2019-11-29 22:15:36',NULL,11635,'0',12278,954,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,11636,'0',12279,954,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,11637,'0',12280,954,5,NULL,'548a4b736fd74bb5ad890741f16ba062'),(NULL,0,'2019-11-29 22:15:36',NULL,11638,'0',12281,954,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:36',NULL,11639,'0',12283,955,16,NULL,'cmdb2-3-5-9'),(NULL,0,'2019-11-29 22:15:36',NULL,11640,'0',12284,955,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,11641,'0',12285,955,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:36',NULL,11642,'0',12286,955,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,11643,'0',12287,955,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,11644,'0',12288,955,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:37',NULL,11645,'0',12289,955,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,11646,'0',12290,955,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:37',NULL,11647,'0',12291,955,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,11648,'0',12292,955,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,11649,'0',12293,955,15,NULL,'10.6.5.9'),(NULL,0,'2019-11-29 22:15:37',NULL,11650,'0',12294,955,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,11651,'0',12295,955,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,11652,'0',12296,955,5,NULL,'f2e625041b9d40ccb719a8733f0291ca'),(NULL,0,'2019-11-29 22:15:37',NULL,11653,'0',12297,955,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:37',NULL,11654,'0',12299,956,16,NULL,'cmdb2-3-5-10'),(NULL,0,'2019-11-29 22:15:37',NULL,11655,'0',12300,956,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,11656,'0',12301,956,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:37',NULL,11657,'0',12302,956,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,11658,'0',12303,956,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,11659,'0',12304,956,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:37',NULL,11660,'0',12305,956,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,11661,'0',12306,956,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:37',NULL,11662,'0',12307,956,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,11663,'0',12308,956,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,11664,'0',12309,956,15,NULL,'10.6.5.10'),(NULL,0,'2019-11-29 22:15:37',NULL,11665,'0',12310,956,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,11666,'0',12311,956,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,11667,'0',12312,956,5,NULL,'713853c7ffed48b4aff314ea2980a405'),(NULL,0,'2019-11-29 22:15:37',NULL,11668,'0',12313,956,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:37',NULL,11669,'0',12315,957,16,NULL,'cmdb2-3-5-11'),(NULL,0,'2019-11-29 22:15:37',NULL,11670,'0',12316,957,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,11671,'0',12317,957,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:37',NULL,11672,'0',12318,957,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,11673,'0',12319,957,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,11674,'0',12320,957,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:37',NULL,11675,'0',12321,957,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,11676,'0',12322,957,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:37',NULL,11677,'0',12323,957,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,11678,'0',12324,957,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,11679,'0',12325,957,15,NULL,'10.6.5.11'),(NULL,0,'2019-11-29 22:15:37',NULL,11680,'0',12326,957,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,11681,'0',12327,957,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,11682,'0',12328,957,5,NULL,'3ba64d42a56645b8abae961d9de01ab2'),(NULL,0,'2019-11-29 22:15:37',NULL,11683,'0',12329,957,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:37',NULL,11684,'0',12331,958,16,NULL,'cmdb2-3-5-12'),(NULL,0,'2019-11-29 22:15:37',NULL,11685,'0',12332,958,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,11686,'0',12333,958,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:37',NULL,11687,'0',12334,958,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,11688,'0',12335,958,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,11689,'0',12336,958,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:37',NULL,11690,'0',12337,958,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,11691,'0',12338,958,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:37',NULL,11692,'0',12339,958,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,11693,'0',12340,958,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,11694,'0',12341,958,15,NULL,'10.6.5.12'),(NULL,0,'2019-11-29 22:15:37',NULL,11695,'0',12342,958,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,11696,'0',12343,958,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,11697,'0',12344,958,5,NULL,'8655c18b5751458fa4c30788d33ee8a6'),(NULL,0,'2019-11-29 22:15:37',NULL,11698,'0',12345,958,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:37',NULL,11699,'0',12347,959,16,NULL,'cmdb2-3-5-13'),(NULL,0,'2019-11-29 22:15:37',NULL,11700,'0',12348,959,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,11701,'0',12349,959,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:37',NULL,11702,'0',12350,959,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,11703,'0',12351,959,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,11704,'0',12352,959,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:37',NULL,11705,'0',12353,959,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,11706,'0',12354,959,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:37',NULL,11707,'0',12355,959,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,11708,'0',12356,959,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,11709,'0',12357,959,15,NULL,'10.6.5.13'),(NULL,0,'2019-11-29 22:15:38',NULL,11710,'0',12358,959,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,11711,'0',12359,959,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,11712,'0',12360,959,5,NULL,'d223d1350c9e4f58bf78f300aab17ea8'),(NULL,0,'2019-11-29 22:15:38',NULL,11713,'0',12361,959,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:38',NULL,11714,'0',12363,960,16,NULL,'cmdb2-3-5-14'),(NULL,0,'2019-11-29 22:15:38',NULL,11715,'0',12364,960,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,11716,'0',12365,960,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:38',NULL,11717,'0',12366,960,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,11718,'0',12367,960,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,11719,'0',12368,960,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:38',NULL,11720,'0',12369,960,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,11721,'0',12370,960,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:38',NULL,11722,'0',12371,960,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,11723,'0',12372,960,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,11724,'0',12373,960,15,NULL,'10.6.5.14'),(NULL,0,'2019-11-29 22:15:38',NULL,11725,'0',12374,960,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,11726,'0',12375,960,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,11727,'0',12376,960,5,NULL,'63974d2f1d664108857fb871b6add483'),(NULL,0,'2019-11-29 22:15:38',NULL,11728,'0',12377,960,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:38',NULL,11729,'0',12379,961,16,NULL,'cmdb2-3-5-15'),(NULL,0,'2019-11-29 22:15:38',NULL,11730,'0',12380,961,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,11731,'0',12381,961,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:38',NULL,11732,'0',12382,961,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,11733,'0',12383,961,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,11734,'0',12384,961,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:38',NULL,11735,'0',12385,961,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,11736,'0',12386,961,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:38',NULL,11737,'0',12387,961,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,11738,'0',12388,961,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,11739,'0',12389,961,15,NULL,'10.6.5.15'),(NULL,0,'2019-11-29 22:15:38',NULL,11740,'0',12390,961,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,11741,'0',12391,961,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,11742,'0',12392,961,5,NULL,'030e00a2c82545dc9a3fc42c275f22e4'),(NULL,0,'2019-11-29 22:15:38',NULL,11743,'0',12393,961,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:38',NULL,11744,'0',12395,962,16,NULL,'cmdb2-3-5-16'),(NULL,0,'2019-11-29 22:15:38',NULL,11745,'0',12396,962,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,11746,'0',12397,962,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:38',NULL,11747,'0',12398,962,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,11748,'0',12399,962,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,11749,'0',12400,962,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:38',NULL,11750,'0',12401,962,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,11751,'0',12402,962,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:38',NULL,11752,'0',12403,962,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,11753,'0',12404,962,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,11754,'0',12405,962,15,NULL,'10.6.5.16'),(NULL,0,'2019-11-29 22:15:38',NULL,11755,'0',12406,962,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,11756,'0',12407,962,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,11757,'0',12408,962,5,NULL,'bc6794d967444206b53e44d17bfd77b2'),(NULL,0,'2019-11-29 22:15:38',NULL,11758,'0',12409,962,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:38',NULL,11759,'0',12411,963,4,NULL,'App2-3-6'),(NULL,0,'2019-11-29 22:15:38',NULL,11760,'0',12413,964,16,NULL,'cmdb2-3-6-1'),(NULL,0,'2019-11-29 22:15:38',NULL,11761,'0',12414,964,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,11762,'0',12415,964,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:38',NULL,11763,'0',12416,964,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,11764,'0',12417,964,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,11765,'0',12418,964,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:38',NULL,11766,'0',12419,964,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,11767,'0',12420,964,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:38',NULL,11768,'0',12421,964,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,11769,'0',12422,964,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,11770,'0',12423,964,15,NULL,'10.6.6.1'),(NULL,0,'2019-11-29 22:15:38',NULL,11771,'0',12424,964,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,11772,'0',12425,964,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,11773,'0',12426,964,5,NULL,'ec5a9583582c45ceb60d9f4eb0362e33'),(NULL,0,'2019-11-29 22:15:39',NULL,11774,'0',12427,964,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:39',NULL,11775,'0',12429,965,16,NULL,'cmdb2-3-6-2'),(NULL,0,'2019-11-29 22:15:39',NULL,11776,'0',12430,965,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,11777,'0',12431,965,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:39',NULL,11778,'0',12432,965,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,11779,'0',12433,965,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,11780,'0',12434,965,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:39',NULL,11781,'0',12435,965,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,11782,'0',12436,965,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:39',NULL,11783,'0',12437,965,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,11784,'0',12438,965,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,11785,'0',12439,965,15,NULL,'10.6.6.2'),(NULL,0,'2019-11-29 22:15:39',NULL,11786,'0',12440,965,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,11787,'0',12441,965,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,11788,'0',12442,965,5,NULL,'9a5546eb08be46e3a9a30e5679ad9588'),(NULL,0,'2019-11-29 22:15:39',NULL,11789,'0',12443,965,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:39',NULL,11790,'0',12445,966,16,NULL,'cmdb2-3-6-3'),(NULL,0,'2019-11-29 22:15:39',NULL,11791,'0',12446,966,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,11792,'0',12447,966,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:39',NULL,11793,'0',12448,966,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,11794,'0',12449,966,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,11795,'0',12450,966,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:39',NULL,11796,'0',12451,966,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,11797,'0',12452,966,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:39',NULL,11798,'0',12453,966,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,11799,'0',12454,966,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,11800,'0',12455,966,15,NULL,'10.6.6.3'),(NULL,0,'2019-11-29 22:15:39',NULL,11801,'0',12456,966,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,11802,'0',12457,966,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,11803,'0',12458,966,5,NULL,'122b56d579084755b5e30f1a5b49c1cc'),(NULL,0,'2019-11-29 22:15:39',NULL,11804,'0',12459,966,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:39',NULL,11805,'0',12461,967,16,NULL,'cmdb2-3-6-4'),(NULL,0,'2019-11-29 22:15:39',NULL,11806,'0',12462,967,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,11807,'0',12463,967,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:39',NULL,11808,'0',12464,967,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,11809,'0',12465,967,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,11810,'0',12466,967,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:39',NULL,11811,'0',12467,967,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,11812,'0',12468,967,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:39',NULL,11813,'0',12469,967,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,11814,'0',12470,967,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,11815,'0',12471,967,15,NULL,'10.6.6.4'),(NULL,0,'2019-11-29 22:15:39',NULL,11816,'0',12472,967,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,11817,'0',12473,967,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,11818,'0',12474,967,5,NULL,'e953abb618354d8090a284eab155e40e'),(NULL,0,'2019-11-29 22:15:39',NULL,11819,'0',12475,967,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:39',NULL,11820,'0',12477,968,16,NULL,'cmdb2-3-6-5'),(NULL,0,'2019-11-29 22:15:39',NULL,11821,'0',12478,968,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,11822,'0',12479,968,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:39',NULL,11823,'0',12480,968,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,11824,'0',12481,968,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,11825,'0',12482,968,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:39',NULL,11826,'0',12483,968,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,11827,'0',12484,968,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:39',NULL,11828,'0',12485,968,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,11829,'0',12486,968,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,11830,'0',12487,968,15,NULL,'10.6.6.5'),(NULL,0,'2019-11-29 22:15:39',NULL,11831,'0',12488,968,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,11832,'0',12489,968,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,11833,'0',12490,968,5,NULL,'cb893a3216f54f62aade291a11cf90ed'),(NULL,0,'2019-11-29 22:15:39',NULL,11834,'0',12491,968,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:39',NULL,11835,'0',12493,969,16,NULL,'cmdb2-3-6-6'),(NULL,0,'2019-11-29 22:15:40',NULL,11836,'0',12494,969,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,11837,'0',12495,969,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:40',NULL,11838,'0',12496,969,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,11839,'0',12497,969,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,11840,'0',12498,969,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:40',NULL,11841,'0',12499,969,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,11842,'0',12500,969,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:40',NULL,11843,'0',12501,969,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,11844,'0',12502,969,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,11845,'0',12503,969,15,NULL,'10.6.6.6'),(NULL,0,'2019-11-29 22:15:40',NULL,11846,'0',12504,969,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,11847,'0',12505,969,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,11848,'0',12506,969,5,NULL,'8377ccac8ee7411587abf86a28e2c10d'),(NULL,0,'2019-11-29 22:15:40',NULL,11849,'0',12507,969,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:40',NULL,11850,'0',12509,970,16,NULL,'cmdb2-3-6-7'),(NULL,0,'2019-11-29 22:15:40',NULL,11851,'0',12510,970,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,11852,'0',12511,970,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:40',NULL,11853,'0',12512,970,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,11854,'0',12513,970,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,11855,'0',12514,970,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:40',NULL,11856,'0',12515,970,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,11857,'0',12516,970,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:40',NULL,11858,'0',12517,970,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,11859,'0',12518,970,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,11860,'0',12519,970,15,NULL,'10.6.6.7'),(NULL,0,'2019-11-29 22:15:40',NULL,11861,'0',12520,970,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,11862,'0',12521,970,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,11863,'0',12522,970,5,NULL,'935a04fc3a6743ce98ddd3d997b8ff70'),(NULL,0,'2019-11-29 22:15:40',NULL,11864,'0',12523,970,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:40',NULL,11865,'0',12525,971,16,NULL,'cmdb2-3-6-8'),(NULL,0,'2019-11-29 22:15:40',NULL,11866,'0',12526,971,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,11867,'0',12527,971,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:40',NULL,11868,'0',12528,971,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,11869,'0',12529,971,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,11870,'0',12530,971,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:40',NULL,11871,'0',12531,971,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,11872,'0',12532,971,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:40',NULL,11873,'0',12533,971,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,11874,'0',12534,971,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,11875,'0',12535,971,15,NULL,'10.6.6.8'),(NULL,0,'2019-11-29 22:15:40',NULL,11876,'0',12536,971,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,11877,'0',12537,971,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,11878,'0',12538,971,5,NULL,'470484578a5d444a824892da8ebf4a93'),(NULL,0,'2019-11-29 22:15:40',NULL,11879,'0',12539,971,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:40',NULL,11880,'0',12541,972,16,NULL,'cmdb2-3-6-9'),(NULL,0,'2019-11-29 22:15:40',NULL,11881,'0',12542,972,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,11882,'0',12543,972,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:40',NULL,11883,'0',12544,972,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,11884,'0',12545,972,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,11885,'0',12546,972,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:40',NULL,11886,'0',12547,972,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,11887,'0',12548,972,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:40',NULL,11888,'0',12549,972,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,11889,'0',12550,972,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,11890,'0',12551,972,15,NULL,'10.6.6.9'),(NULL,0,'2019-11-29 22:15:40',NULL,11891,'0',12552,972,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,11892,'0',12553,972,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,11893,'0',12554,972,5,NULL,'581c96ee4915468d9124e133c36037d6'),(NULL,0,'2019-11-29 22:15:40',NULL,11894,'0',12555,972,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:40',NULL,11895,'0',12557,973,16,NULL,'cmdb2-3-6-10'),(NULL,0,'2019-11-29 22:15:40',NULL,11896,'0',12558,973,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,11897,'0',12559,973,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:40',NULL,11898,'0',12560,973,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,11899,'0',12561,973,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,11900,'0',12562,973,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:40',NULL,11901,'0',12563,973,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,11902,'0',12564,973,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:41',NULL,11903,'0',12565,973,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,11904,'0',12566,973,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,11905,'0',12567,973,15,NULL,'10.6.6.10'),(NULL,0,'2019-11-29 22:15:41',NULL,11906,'0',12568,973,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,11907,'0',12569,973,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,11908,'0',12570,973,5,NULL,'7d248203ef334599958c7e7727b00927'),(NULL,0,'2019-11-29 22:15:41',NULL,11909,'0',12571,973,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:41',NULL,11910,'0',12573,974,16,NULL,'cmdb2-3-6-11'),(NULL,0,'2019-11-29 22:15:41',NULL,11911,'0',12574,974,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,11912,'0',12575,974,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:41',NULL,11913,'0',12576,974,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,11914,'0',12577,974,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,11915,'0',12578,974,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:41',NULL,11916,'0',12579,974,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,11917,'0',12580,974,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:41',NULL,11918,'0',12581,974,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,11919,'0',12582,974,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,11920,'0',12583,974,15,NULL,'10.6.6.11'),(NULL,0,'2019-11-29 22:15:41',NULL,11921,'0',12584,974,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,11922,'0',12585,974,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,11923,'0',12586,974,5,NULL,'facffa3b32f44e9890a960306dd67069'),(NULL,0,'2019-11-29 22:15:41',NULL,11924,'0',12587,974,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:41',NULL,11925,'0',12589,975,16,NULL,'cmdb2-3-6-12'),(NULL,0,'2019-11-29 22:15:41',NULL,11926,'0',12590,975,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,11927,'0',12591,975,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:41',NULL,11928,'0',12592,975,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,11929,'0',12593,975,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,11930,'0',12594,975,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:41',NULL,11931,'0',12595,975,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,11932,'0',12596,975,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:41',NULL,11933,'0',12597,975,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,11934,'0',12598,975,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,11935,'0',12599,975,15,NULL,'10.6.6.12'),(NULL,0,'2019-11-29 22:15:41',NULL,11936,'0',12600,975,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,11937,'0',12601,975,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,11938,'0',12602,975,5,NULL,'6cae4694ddb14d3aaebbbbee8abb1b37'),(NULL,0,'2019-11-29 22:15:41',NULL,11939,'0',12603,975,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:41',NULL,11940,'0',12605,976,16,NULL,'cmdb2-3-6-13'),(NULL,0,'2019-11-29 22:15:41',NULL,11941,'0',12606,976,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,11942,'0',12607,976,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:41',NULL,11943,'0',12608,976,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,11944,'0',12609,976,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,11945,'0',12610,976,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:41',NULL,11946,'0',12611,976,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,11947,'0',12612,976,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:41',NULL,11948,'0',12613,976,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,11949,'0',12614,976,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,11950,'0',12615,976,15,NULL,'10.6.6.13'),(NULL,0,'2019-11-29 22:15:41',NULL,11951,'0',12616,976,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,11952,'0',12617,976,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,11953,'0',12618,976,5,NULL,'2459a335d0904682aa3e680414daaf47'),(NULL,0,'2019-11-29 22:15:41',NULL,11954,'0',12619,976,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:41',NULL,11955,'0',12621,977,16,NULL,'cmdb2-3-6-14'),(NULL,0,'2019-11-29 22:15:41',NULL,11956,'0',12622,977,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,11957,'0',12623,977,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:41',NULL,11958,'0',12624,977,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,11959,'0',12625,977,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,11960,'0',12626,977,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:41',NULL,11961,'0',12627,977,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,11962,'0',12628,977,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:41',NULL,11963,'0',12629,977,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,11964,'0',12630,977,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,11965,'0',12631,977,15,NULL,'10.6.6.14'),(NULL,0,'2019-11-29 22:15:41',NULL,11966,'0',12632,977,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,11967,'0',12633,977,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,11968,'0',12634,977,5,NULL,'5a271c4af80a4b0cbee6d06c02995634'),(NULL,0,'2019-11-29 22:15:42',NULL,11969,'0',12635,977,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:42',NULL,11970,'0',12637,978,16,NULL,'cmdb2-3-6-15'),(NULL,0,'2019-11-29 22:15:42',NULL,11971,'0',12638,978,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,11972,'0',12639,978,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:42',NULL,11973,'0',12640,978,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,11974,'0',12641,978,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,11975,'0',12642,978,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:42',NULL,11976,'0',12643,978,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,11977,'0',12644,978,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:42',NULL,11978,'0',12645,978,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,11979,'0',12646,978,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,11980,'0',12647,978,15,NULL,'10.6.6.15'),(NULL,0,'2019-11-29 22:15:42',NULL,11981,'0',12648,978,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,11982,'0',12649,978,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,11983,'0',12650,978,5,NULL,'05d3def759034097b36eca3fd38f8f53'),(NULL,0,'2019-11-29 22:15:42',NULL,11984,'0',12651,978,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:42',NULL,11985,'0',12653,979,16,NULL,'cmdb2-3-6-16'),(NULL,0,'2019-11-29 22:15:42',NULL,11986,'0',12654,979,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,11987,'0',12655,979,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:42',NULL,11988,'0',12656,979,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,11989,'0',12657,979,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,11990,'0',12658,979,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:42',NULL,11991,'0',12659,979,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,11992,'0',12660,979,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:42',NULL,11993,'0',12661,979,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,11994,'0',12662,979,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,11995,'0',12663,979,15,NULL,'10.6.6.16'),(NULL,0,'2019-11-29 22:15:42',NULL,11996,'0',12664,979,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,11997,'0',12665,979,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,11998,'0',12666,979,5,NULL,'c516a5d167da4c31a452756698b9df51'),(NULL,0,'2019-11-29 22:15:42',NULL,11999,'0',12667,979,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:42',NULL,12000,'0',12669,980,4,NULL,'App2-3-7'),(NULL,0,'2019-11-29 22:15:42',NULL,12001,'0',12671,981,16,NULL,'cmdb2-3-7-1'),(NULL,0,'2019-11-29 22:15:42',NULL,12002,'0',12672,981,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,12003,'0',12673,981,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:42',NULL,12004,'0',12674,981,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,12005,'0',12675,981,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,12006,'0',12676,981,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:42',NULL,12007,'0',12677,981,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,12008,'0',12678,981,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:42',NULL,12009,'0',12679,981,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,12010,'0',12680,981,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,12011,'0',12681,981,15,NULL,'10.6.7.1'),(NULL,0,'2019-11-29 22:15:42',NULL,12012,'0',12682,981,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,12013,'0',12683,981,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,12014,'0',12684,981,5,NULL,'fb250053978341dd8217dec4d7fb7b78'),(NULL,0,'2019-11-29 22:15:42',NULL,12015,'0',12685,981,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:42',NULL,12016,'0',12687,982,16,NULL,'cmdb2-3-7-2'),(NULL,0,'2019-11-29 22:15:42',NULL,12017,'0',12688,982,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,12018,'0',12689,982,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:42',NULL,12019,'0',12690,982,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,12020,'0',12691,982,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,12021,'0',12692,982,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:42',NULL,12022,'0',12693,982,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,12023,'0',12694,982,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:42',NULL,12024,'0',12695,982,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,12025,'0',12696,982,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,12026,'0',12697,982,15,NULL,'10.6.7.2'),(NULL,0,'2019-11-29 22:15:42',NULL,12027,'0',12698,982,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,12028,'0',12699,982,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,12029,'0',12700,982,5,NULL,'8cb2dbc46b38472d9aef955792f58e53'),(NULL,0,'2019-11-29 22:15:42',NULL,12030,'0',12701,982,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:43',NULL,12031,'0',12703,983,16,NULL,'cmdb2-3-7-3'),(NULL,0,'2019-11-29 22:15:43',NULL,12032,'0',12704,983,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,12033,'0',12705,983,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:43',NULL,12034,'0',12706,983,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,12035,'0',12707,983,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,12036,'0',12708,983,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:43',NULL,12037,'0',12709,983,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,12038,'0',12710,983,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:43',NULL,12039,'0',12711,983,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,12040,'0',12712,983,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,12041,'0',12713,983,15,NULL,'10.6.7.3'),(NULL,0,'2019-11-29 22:15:43',NULL,12042,'0',12714,983,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,12043,'0',12715,983,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,12044,'0',12716,983,5,NULL,'9745b19ca24742cd8662d9f124b6d31b'),(NULL,0,'2019-11-29 22:15:43',NULL,12045,'0',12717,983,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:43',NULL,12046,'0',12719,984,16,NULL,'cmdb2-3-7-4'),(NULL,0,'2019-11-29 22:15:43',NULL,12047,'0',12720,984,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,12048,'0',12721,984,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:43',NULL,12049,'0',12722,984,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,12050,'0',12723,984,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,12051,'0',12724,984,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:43',NULL,12052,'0',12725,984,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,12053,'0',12726,984,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:43',NULL,12054,'0',12727,984,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,12055,'0',12728,984,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,12056,'0',12729,984,15,NULL,'10.6.7.4'),(NULL,0,'2019-11-29 22:15:43',NULL,12057,'0',12730,984,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,12058,'0',12731,984,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,12059,'0',12732,984,5,NULL,'b349914826e9429db94389dfefcb91a6'),(NULL,0,'2019-11-29 22:15:43',NULL,12060,'0',12733,984,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:43',NULL,12061,'0',12735,985,16,NULL,'cmdb2-3-7-5'),(NULL,0,'2019-11-29 22:15:43',NULL,12062,'0',12736,985,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,12063,'0',12737,985,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:43',NULL,12064,'0',12738,985,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,12065,'0',12739,985,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,12066,'0',12740,985,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:43',NULL,12067,'0',12741,985,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,12068,'0',12742,985,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:43',NULL,12069,'0',12743,985,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,12070,'0',12744,985,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,12071,'0',12745,985,15,NULL,'10.6.7.5'),(NULL,0,'2019-11-29 22:15:43',NULL,12072,'0',12746,985,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,12073,'0',12747,985,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,12074,'0',12748,985,5,NULL,'c9308a0cce5d4467a0b91685033191ce'),(NULL,0,'2019-11-29 22:15:43',NULL,12075,'0',12749,985,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:43',NULL,12076,'0',12751,986,16,NULL,'cmdb2-3-7-6'),(NULL,0,'2019-11-29 22:15:43',NULL,12077,'0',12752,986,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,12078,'0',12753,986,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:43',NULL,12079,'0',12754,986,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,12080,'0',12755,986,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,12081,'0',12756,986,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:43',NULL,12082,'0',12757,986,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,12083,'0',12758,986,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:43',NULL,12084,'0',12759,986,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,12085,'0',12760,986,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,12086,'0',12761,986,15,NULL,'10.6.7.6'),(NULL,0,'2019-11-29 22:15:43',NULL,12087,'0',12762,986,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,12088,'0',12763,986,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,12089,'0',12764,986,5,NULL,'be452e0f2d374d13a284f7b2ce4e033a'),(NULL,0,'2019-11-29 22:15:43',NULL,12090,'0',12765,986,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:43',NULL,12091,'0',12767,987,16,NULL,'cmdb2-3-7-7'),(NULL,0,'2019-11-29 22:15:43',NULL,12092,'0',12768,987,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,12093,'0',12769,987,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:44',NULL,12094,'0',12770,987,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,12095,'0',12771,987,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,12096,'0',12772,987,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:44',NULL,12097,'0',12773,987,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,12098,'0',12774,987,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:44',NULL,12099,'0',12775,987,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,12100,'0',12776,987,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,12101,'0',12777,987,15,NULL,'10.6.7.7'),(NULL,0,'2019-11-29 22:15:44',NULL,12102,'0',12778,987,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,12103,'0',12779,987,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,12104,'0',12780,987,5,NULL,'ee84600553414f8a9ee63a3bb5d1efa2'),(NULL,0,'2019-11-29 22:15:44',NULL,12105,'0',12781,987,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:44',NULL,12106,'0',12783,988,16,NULL,'cmdb2-3-7-8'),(NULL,0,'2019-11-29 22:15:44',NULL,12107,'0',12784,988,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,12108,'0',12785,988,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:44',NULL,12109,'0',12786,988,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,12110,'0',12787,988,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,12111,'0',12788,988,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:44',NULL,12112,'0',12789,988,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,12113,'0',12790,988,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:44',NULL,12114,'0',12791,988,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,12115,'0',12792,988,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,12116,'0',12793,988,15,NULL,'10.6.7.8'),(NULL,0,'2019-11-29 22:15:44',NULL,12117,'0',12794,988,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,12118,'0',12795,988,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,12119,'0',12796,988,5,NULL,'330e1db7a68c42b0882a785da4c980d3'),(NULL,0,'2019-11-29 22:15:44',NULL,12120,'0',12797,988,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:44',NULL,12121,'0',12799,989,16,NULL,'cmdb2-3-7-9'),(NULL,0,'2019-11-29 22:15:44',NULL,12122,'0',12800,989,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,12123,'0',12801,989,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:44',NULL,12124,'0',12802,989,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,12125,'0',12803,989,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,12126,'0',12804,989,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:44',NULL,12127,'0',12805,989,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,12128,'0',12806,989,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:44',NULL,12129,'0',12807,989,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,12130,'0',12808,989,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,12131,'0',12809,989,15,NULL,'10.6.7.9'),(NULL,0,'2019-11-29 22:15:44',NULL,12132,'0',12810,989,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,12133,'0',12811,989,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,12134,'0',12812,989,5,NULL,'01781d0f4e784d419c91c3719c2cafe2'),(NULL,0,'2019-11-29 22:15:44',NULL,12135,'0',12813,989,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:44',NULL,12136,'0',12815,990,16,NULL,'cmdb2-3-7-10'),(NULL,0,'2019-11-29 22:15:44',NULL,12137,'0',12816,990,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,12138,'0',12817,990,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:44',NULL,12139,'0',12818,990,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,12140,'0',12819,990,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,12141,'0',12820,990,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:44',NULL,12142,'0',12821,990,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,12143,'0',12822,990,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:44',NULL,12144,'0',12823,990,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,12145,'0',12824,990,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,12146,'0',12825,990,15,NULL,'10.6.7.10'),(NULL,0,'2019-11-29 22:15:44',NULL,12147,'0',12826,990,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,12148,'0',12827,990,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,12149,'0',12828,990,5,NULL,'c58f7bb0a8014ca3904d92c58f19ea63'),(NULL,0,'2019-11-29 22:15:44',NULL,12150,'0',12829,990,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:44',NULL,12151,'0',12831,991,16,NULL,'cmdb2-3-7-11'),(NULL,0,'2019-11-29 22:15:44',NULL,12152,'0',12832,991,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,12153,'0',12833,991,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:44',NULL,12154,'0',12834,991,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,12155,'0',12835,991,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,12156,'0',12836,991,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:45',NULL,12157,'0',12837,991,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,12158,'0',12838,991,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:45',NULL,12159,'0',12839,991,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,12160,'0',12840,991,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,12161,'0',12841,991,15,NULL,'10.6.7.11'),(NULL,0,'2019-11-29 22:15:45',NULL,12162,'0',12842,991,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,12163,'0',12843,991,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,12164,'0',12844,991,5,NULL,'5b0463d2e25c45ceb2c81ae0ab5e30fa'),(NULL,0,'2019-11-29 22:15:45',NULL,12165,'0',12845,991,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:45',NULL,12166,'0',12847,992,16,NULL,'cmdb2-3-7-12'),(NULL,0,'2019-11-29 22:15:45',NULL,12167,'0',12848,992,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,12168,'0',12849,992,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:45',NULL,12169,'0',12850,992,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,12170,'0',12851,992,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,12171,'0',12852,992,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:45',NULL,12172,'0',12853,992,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,12173,'0',12854,992,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:45',NULL,12174,'0',12855,992,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,12175,'0',12856,992,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,12176,'0',12857,992,15,NULL,'10.6.7.12'),(NULL,0,'2019-11-29 22:15:45',NULL,12177,'0',12858,992,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,12178,'0',12859,992,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,12179,'0',12860,992,5,NULL,'ca63579637f7429bb537ed88f7d039c0'),(NULL,0,'2019-11-29 22:15:45',NULL,12180,'0',12861,992,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:45',NULL,12181,'0',12863,993,16,NULL,'cmdb2-3-7-13'),(NULL,0,'2019-11-29 22:15:45',NULL,12182,'0',12864,993,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,12183,'0',12865,993,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:45',NULL,12184,'0',12866,993,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,12185,'0',12867,993,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,12186,'0',12868,993,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:45',NULL,12187,'0',12869,993,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,12188,'0',12870,993,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:45',NULL,12189,'0',12871,993,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,12190,'0',12872,993,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,12191,'0',12873,993,15,NULL,'10.6.7.13'),(NULL,0,'2019-11-29 22:15:45',NULL,12192,'0',12874,993,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,12193,'0',12875,993,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,12194,'0',12876,993,5,NULL,'0569f2250e074a4d9f8655c41783dcc3'),(NULL,0,'2019-11-29 22:15:45',NULL,12195,'0',12877,993,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:45',NULL,12196,'0',12879,994,16,NULL,'cmdb2-3-7-14'),(NULL,0,'2019-11-29 22:15:45',NULL,12197,'0',12880,994,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,12198,'0',12881,994,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:45',NULL,12199,'0',12882,994,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,12200,'0',12883,994,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,12201,'0',12884,994,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:45',NULL,12202,'0',12885,994,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,12203,'0',12886,994,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:45',NULL,12204,'0',12887,994,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,12205,'0',12888,994,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,12206,'0',12889,994,15,NULL,'10.6.7.14'),(NULL,0,'2019-11-29 22:15:45',NULL,12207,'0',12890,994,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,12208,'0',12891,994,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,12209,'0',12892,994,5,NULL,'fce6a732c533426f9628d8d23ff2a904'),(NULL,0,'2019-11-29 22:15:45',NULL,12210,'0',12893,994,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:45',NULL,12211,'0',12895,995,16,NULL,'cmdb2-3-7-15'),(NULL,0,'2019-11-29 22:15:45',NULL,12212,'0',12896,995,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,12213,'0',12897,995,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:45',NULL,12214,'0',12898,995,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,12215,'0',12899,995,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,12216,'0',12900,995,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:45',NULL,12217,'0',12901,995,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,12218,'0',12902,995,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:45',NULL,12219,'0',12903,995,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,12220,'0',12904,995,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,12221,'0',12905,995,15,NULL,'10.6.7.15'),(NULL,0,'2019-11-29 22:15:46',NULL,12222,'0',12906,995,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,12223,'0',12907,995,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,12224,'0',12908,995,5,NULL,'e28d9a1a3b0c4020a8ab7f3c22de4144'),(NULL,0,'2019-11-29 22:15:46',NULL,12225,'0',12909,995,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:46',NULL,12226,'0',12911,996,16,NULL,'cmdb2-3-7-16'),(NULL,0,'2019-11-29 22:15:46',NULL,12227,'0',12912,996,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,12228,'0',12913,996,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:46',NULL,12229,'0',12914,996,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,12230,'0',12915,996,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,12231,'0',12916,996,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:46',NULL,12232,'0',12917,996,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,12233,'0',12918,996,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:46',NULL,12234,'0',12919,996,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,12235,'0',12920,996,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,12236,'0',12921,996,15,NULL,'10.6.7.16'),(NULL,0,'2019-11-29 22:15:46',NULL,12237,'0',12922,996,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,12238,'0',12923,996,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,12239,'0',12924,996,5,NULL,'6b489daa718d40bab66683eb7ad3584a'),(NULL,0,'2019-11-29 22:15:46',NULL,12240,'0',12925,996,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:46',NULL,12241,'0',12927,997,4,NULL,'App2-3-8'),(NULL,0,'2019-11-29 22:15:46',NULL,12242,'0',12929,998,16,NULL,'cmdb2-3-8-1'),(NULL,0,'2019-11-29 22:15:46',NULL,12243,'0',12930,998,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,12244,'0',12931,998,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:46',NULL,12245,'0',12932,998,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,12246,'0',12933,998,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,12247,'0',12934,998,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:46',NULL,12248,'0',12935,998,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,12249,'0',12936,998,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:46',NULL,12250,'0',12937,998,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,12251,'0',12938,998,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,12252,'0',12939,998,15,NULL,'10.6.8.1'),(NULL,0,'2019-11-29 22:15:46',NULL,12253,'0',12940,998,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,12254,'0',12941,998,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,12255,'0',12942,998,5,NULL,'d93ba051ec4b44ccb77e4d029d576a34'),(NULL,0,'2019-11-29 22:15:46',NULL,12256,'0',12943,998,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:46',NULL,12257,'0',12945,999,16,NULL,'cmdb2-3-8-2'),(NULL,0,'2019-11-29 22:15:46',NULL,12258,'0',12946,999,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,12259,'0',12947,999,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:46',NULL,12260,'0',12948,999,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,12261,'0',12949,999,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,12262,'0',12950,999,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:46',NULL,12263,'0',12951,999,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,12264,'0',12952,999,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:46',NULL,12265,'0',12953,999,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,12266,'0',12954,999,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,12267,'0',12955,999,15,NULL,'10.6.8.2'),(NULL,0,'2019-11-29 22:15:46',NULL,12268,'0',12956,999,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,12269,'0',12957,999,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,12270,'0',12958,999,5,NULL,'50f26ec6aeab4f4ca5784483cbf45b4b'),(NULL,0,'2019-11-29 22:15:46',NULL,12271,'0',12959,999,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:46',NULL,12272,'0',12961,1000,16,NULL,'cmdb2-3-8-3'),(NULL,0,'2019-11-29 22:15:46',NULL,12273,'0',12962,1000,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,12274,'0',12963,1000,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:46',NULL,12275,'0',12964,1000,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,12276,'0',12965,1000,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,12277,'0',12966,1000,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:46',NULL,12278,'0',12967,1000,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,12279,'0',12968,1000,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:46',NULL,12280,'0',12969,1000,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,12281,'0',12970,1000,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,12282,'0',12971,1000,15,NULL,'10.6.8.3'),(NULL,0,'2019-11-29 22:15:46',NULL,12283,'0',12972,1000,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,12284,'0',12973,1000,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,12285,'0',12974,1000,5,NULL,'8a18ea58afbd40c1a80500277c320e7e'),(NULL,0,'2019-11-29 22:15:47',NULL,12286,'0',12975,1000,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:47',NULL,12287,'0',12977,1001,16,NULL,'cmdb2-3-8-4'),(NULL,0,'2019-11-29 22:15:47',NULL,12288,'0',12978,1001,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,12289,'0',12979,1001,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:47',NULL,12290,'0',12980,1001,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,12291,'0',12981,1001,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,12292,'0',12982,1001,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:47',NULL,12293,'0',12983,1001,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,12294,'0',12984,1001,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:47',NULL,12295,'0',12985,1001,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,12296,'0',12986,1001,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,12297,'0',12987,1001,15,NULL,'10.6.8.4'),(NULL,0,'2019-11-29 22:15:47',NULL,12298,'0',12988,1001,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,12299,'0',12989,1001,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,12300,'0',12990,1001,5,NULL,'084bbd89baed45888b4c366714ee9176'),(NULL,0,'2019-11-29 22:15:47',NULL,12301,'0',12991,1001,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:47',NULL,12302,'0',12993,1002,16,NULL,'cmdb2-3-8-5'),(NULL,0,'2019-11-29 22:15:47',NULL,12303,'0',12994,1002,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,12304,'0',12995,1002,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:47',NULL,12305,'0',12996,1002,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,12306,'0',12997,1002,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,12307,'0',12998,1002,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:47',NULL,12308,'0',12999,1002,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,12309,'0',13000,1002,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:47',NULL,12310,'0',13001,1002,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,12311,'0',13002,1002,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,12312,'0',13003,1002,15,NULL,'10.6.8.5'),(NULL,0,'2019-11-29 22:15:47',NULL,12313,'0',13004,1002,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,12314,'0',13005,1002,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,12315,'0',13006,1002,5,NULL,'bbddc57aab58492397197765f86a1f35'),(NULL,0,'2019-11-29 22:15:47',NULL,12316,'0',13007,1002,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:47',NULL,12317,'0',13009,1003,16,NULL,'cmdb2-3-8-6'),(NULL,0,'2019-11-29 22:15:47',NULL,12318,'0',13010,1003,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,12319,'0',13011,1003,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:47',NULL,12320,'0',13012,1003,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,12321,'0',13013,1003,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,12322,'0',13014,1003,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:47',NULL,12323,'0',13015,1003,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,12324,'0',13016,1003,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:47',NULL,12325,'0',13017,1003,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,12326,'0',13018,1003,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,12327,'0',13019,1003,15,NULL,'10.6.8.6'),(NULL,0,'2019-11-29 22:15:47',NULL,12328,'0',13020,1003,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,12329,'0',13021,1003,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,12330,'0',13022,1003,5,NULL,'488e7a7c24a54ae784065595a35f77c1'),(NULL,0,'2019-11-29 22:15:47',NULL,12331,'0',13023,1003,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:47',NULL,12332,'0',13025,1004,16,NULL,'cmdb2-3-8-7'),(NULL,0,'2019-11-29 22:15:47',NULL,12333,'0',13026,1004,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,12334,'0',13027,1004,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:47',NULL,12335,'0',13028,1004,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,12336,'0',13029,1004,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,12337,'0',13030,1004,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:47',NULL,12338,'0',13031,1004,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,12339,'0',13032,1004,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:47',NULL,12340,'0',13033,1004,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,12341,'0',13034,1004,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,12342,'0',13035,1004,15,NULL,'10.6.8.7'),(NULL,0,'2019-11-29 22:15:47',NULL,12343,'0',13036,1004,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,12344,'0',13037,1004,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,12345,'0',13038,1004,5,NULL,'ce6237678b48494698fb56b54bafcc5a'),(NULL,0,'2019-11-29 22:15:47',NULL,12346,'0',13039,1004,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:48',NULL,12347,'0',13041,1005,16,NULL,'cmdb2-3-8-8'),(NULL,0,'2019-11-29 22:15:48',NULL,12348,'0',13042,1005,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,12349,'0',13043,1005,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:48',NULL,12350,'0',13044,1005,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,12351,'0',13045,1005,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,12352,'0',13046,1005,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:48',NULL,12353,'0',13047,1005,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,12354,'0',13048,1005,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:48',NULL,12355,'0',13049,1005,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,12356,'0',13050,1005,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,12357,'0',13051,1005,15,NULL,'10.6.8.8'),(NULL,0,'2019-11-29 22:15:48',NULL,12358,'0',13052,1005,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,12359,'0',13053,1005,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,12360,'0',13054,1005,5,NULL,'11001bc3f0044e2ca65271ef8d444abf'),(NULL,0,'2019-11-29 22:15:48',NULL,12361,'0',13055,1005,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:48',NULL,12362,'0',13057,1006,16,NULL,'cmdb2-3-8-9'),(NULL,0,'2019-11-29 22:15:48',NULL,12363,'0',13058,1006,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,12364,'0',13059,1006,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:48',NULL,12365,'0',13060,1006,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,12366,'0',13061,1006,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,12367,'0',13062,1006,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:48',NULL,12368,'0',13063,1006,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,12369,'0',13064,1006,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:48',NULL,12370,'0',13065,1006,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,12371,'0',13066,1006,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,12372,'0',13067,1006,15,NULL,'10.6.8.9'),(NULL,0,'2019-11-29 22:15:48',NULL,12373,'0',13068,1006,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,12374,'0',13069,1006,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,12375,'0',13070,1006,5,NULL,'df9b8dec1a7a47aebfcb5d8d754c2b2b'),(NULL,0,'2019-11-29 22:15:48',NULL,12376,'0',13071,1006,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:48',NULL,12377,'0',13073,1007,16,NULL,'cmdb2-3-8-10'),(NULL,0,'2019-11-29 22:15:48',NULL,12378,'0',13074,1007,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,12379,'0',13075,1007,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:48',NULL,12380,'0',13076,1007,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,12381,'0',13077,1007,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,12382,'0',13078,1007,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:48',NULL,12383,'0',13079,1007,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,12384,'0',13080,1007,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:48',NULL,12385,'0',13081,1007,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,12386,'0',13082,1007,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,12387,'0',13083,1007,15,NULL,'10.6.8.10'),(NULL,0,'2019-11-29 22:15:48',NULL,12388,'0',13084,1007,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,12389,'0',13085,1007,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,12390,'0',13086,1007,5,NULL,'76ab67bd8faa499cbdbd524508c115fc'),(NULL,0,'2019-11-29 22:15:48',NULL,12391,'0',13087,1007,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:48',NULL,12392,'0',13089,1008,16,NULL,'cmdb2-3-8-11'),(NULL,0,'2019-11-29 22:15:48',NULL,12393,'0',13090,1008,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,12394,'0',13091,1008,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:48',NULL,12395,'0',13092,1008,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,12396,'0',13093,1008,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,12397,'0',13094,1008,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:48',NULL,12398,'0',13095,1008,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,12399,'0',13096,1008,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:48',NULL,12400,'0',13097,1008,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,12401,'0',13098,1008,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,12402,'0',13099,1008,15,NULL,'10.6.8.11'),(NULL,0,'2019-11-29 22:15:48',NULL,12403,'0',13100,1008,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,12404,'0',13101,1008,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,12405,'0',13102,1008,5,NULL,'e1e5d3ce07e846ccb4acbf5c9730f51b'),(NULL,0,'2019-11-29 22:15:48',NULL,12406,'0',13103,1008,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:48',NULL,12407,'0',13105,1009,16,NULL,'cmdb2-3-8-12'),(NULL,0,'2019-11-29 22:15:48',NULL,12408,'0',13106,1009,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,12409,'0',13107,1009,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:48',NULL,12410,'0',13108,1009,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,12411,'0',13109,1009,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,12412,'0',13110,1009,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:49',NULL,12413,'0',13111,1009,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,12414,'0',13112,1009,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:49',NULL,12415,'0',13113,1009,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,12416,'0',13114,1009,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,12417,'0',13115,1009,15,NULL,'10.6.8.12'),(NULL,0,'2019-11-29 22:15:49',NULL,12418,'0',13116,1009,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,12419,'0',13117,1009,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,12420,'0',13118,1009,5,NULL,'5ecb36599fa34f4d87be8b43a78af8dd'),(NULL,0,'2019-11-29 22:15:49',NULL,12421,'0',13119,1009,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:49',NULL,12422,'0',13121,1010,16,NULL,'cmdb2-3-8-13'),(NULL,0,'2019-11-29 22:15:49',NULL,12423,'0',13122,1010,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,12424,'0',13123,1010,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:49',NULL,12425,'0',13124,1010,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,12426,'0',13125,1010,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,12427,'0',13126,1010,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:49',NULL,12428,'0',13127,1010,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,12429,'0',13128,1010,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:49',NULL,12430,'0',13129,1010,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,12431,'0',13130,1010,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,12432,'0',13131,1010,15,NULL,'10.6.8.13'),(NULL,0,'2019-11-29 22:15:49',NULL,12433,'0',13132,1010,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,12434,'0',13133,1010,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,12435,'0',13134,1010,5,NULL,'605227e802f14fe1b5e40485b4baa502'),(NULL,0,'2019-11-29 22:15:49',NULL,12436,'0',13135,1010,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:49',NULL,12437,'0',13137,1011,16,NULL,'cmdb2-3-8-14'),(NULL,0,'2019-11-29 22:15:49',NULL,12438,'0',13138,1011,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,12439,'0',13139,1011,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:49',NULL,12440,'0',13140,1011,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,12441,'0',13141,1011,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,12442,'0',13142,1011,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:49',NULL,12443,'0',13143,1011,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,12444,'0',13144,1011,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:49',NULL,12445,'0',13145,1011,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,12446,'0',13146,1011,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,12447,'0',13147,1011,15,NULL,'10.6.8.14'),(NULL,0,'2019-11-29 22:15:49',NULL,12448,'0',13148,1011,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,12449,'0',13149,1011,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,12450,'0',13150,1011,5,NULL,'fbbf0be2c8a54beabe59e5bfa7111d85'),(NULL,0,'2019-11-29 22:15:49',NULL,12451,'0',13151,1011,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:49',NULL,12452,'0',13153,1012,16,NULL,'cmdb2-3-8-15'),(NULL,0,'2019-11-29 22:15:49',NULL,12453,'0',13154,1012,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,12454,'0',13155,1012,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:49',NULL,12455,'0',13156,1012,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,12456,'0',13157,1012,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,12457,'0',13158,1012,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:49',NULL,12458,'0',13159,1012,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,12459,'0',13160,1012,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:49',NULL,12460,'0',13161,1012,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,12461,'0',13162,1012,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,12462,'0',13163,1012,15,NULL,'10.6.8.15'),(NULL,0,'2019-11-29 22:15:49',NULL,12463,'0',13164,1012,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,12464,'0',13165,1012,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,12465,'0',13166,1012,5,NULL,'722393d22a7c403ab83d3c39d6a0735c'),(NULL,0,'2019-11-29 22:15:49',NULL,12466,'0',13167,1012,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:49',NULL,12467,'0',13169,1013,16,NULL,'cmdb2-3-8-16'),(NULL,0,'2019-11-29 22:15:49',NULL,12468,'0',13170,1013,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,12469,'0',13171,1013,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:49',NULL,12470,'0',13172,1013,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,12471,'0',13173,1013,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,12472,'0',13174,1013,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:49',NULL,12473,'0',13175,1013,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,12474,'0',13176,1013,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:49',NULL,12475,'0',13177,1013,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,12476,'0',13178,1013,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,12477,'0',13179,1013,15,NULL,'10.6.8.16'),(NULL,0,'2019-11-29 22:15:49',NULL,12478,'0',13180,1013,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,12479,'0',13181,1013,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,12480,'0',13182,1013,5,NULL,'6cf0e714d2864f72ac529cbc649142d8'),(NULL,0,'2019-11-29 22:15:50',NULL,12481,'0',13183,1013,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:50',NULL,12482,'0',13185,1014,3,NULL,'产品线2-4'),(NULL,0,'2019-11-29 22:15:50',NULL,12483,'0',13187,1015,4,NULL,'App2-4-1'),(NULL,0,'2019-11-29 22:15:50',NULL,12484,'0',13189,1016,16,NULL,'cmdb2-4-1-1'),(NULL,0,'2019-11-29 22:15:50',NULL,12485,'0',13190,1016,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,12486,'0',13191,1016,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:50',NULL,12487,'0',13192,1016,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,12488,'0',13193,1016,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,12489,'0',13194,1016,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:50',NULL,12490,'0',13195,1016,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,12491,'0',13196,1016,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:50',NULL,12492,'0',13197,1016,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,12493,'0',13198,1016,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,12494,'0',13199,1016,15,NULL,'10.8.1.1'),(NULL,0,'2019-11-29 22:15:50',NULL,12495,'0',13200,1016,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,12496,'0',13201,1016,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,12497,'0',13202,1016,5,NULL,'9d2a6e24a8284c948a27dbb041f2e6e9'),(NULL,0,'2019-11-29 22:15:50',NULL,12498,'0',13203,1016,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:50',NULL,12499,'0',13205,1017,16,NULL,'cmdb2-4-1-2'),(NULL,0,'2019-11-29 22:15:50',NULL,12500,'0',13206,1017,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,12501,'0',13207,1017,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:50',NULL,12502,'0',13208,1017,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,12503,'0',13209,1017,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,12504,'0',13210,1017,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:50',NULL,12505,'0',13211,1017,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,12506,'0',13212,1017,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:50',NULL,12507,'0',13213,1017,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,12508,'0',13214,1017,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,12509,'0',13215,1017,15,NULL,'10.8.1.2'),(NULL,0,'2019-11-29 22:15:50',NULL,12510,'0',13216,1017,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,12511,'0',13217,1017,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,12512,'0',13218,1017,5,NULL,'980c4afee3024ecc93280ff7a9126583'),(NULL,0,'2019-11-29 22:15:50',NULL,12513,'0',13219,1017,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:50',NULL,12514,'0',13221,1018,16,NULL,'cmdb2-4-1-3'),(NULL,0,'2019-11-29 22:15:50',NULL,12515,'0',13222,1018,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,12516,'0',13223,1018,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:50',NULL,12517,'0',13224,1018,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,12518,'0',13225,1018,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,12519,'0',13226,1018,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:50',NULL,12520,'0',13227,1018,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,12521,'0',13228,1018,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:50',NULL,12522,'0',13229,1018,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,12523,'0',13230,1018,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,12524,'0',13231,1018,15,NULL,'10.8.1.3'),(NULL,0,'2019-11-29 22:15:50',NULL,12525,'0',13232,1018,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,12526,'0',13233,1018,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,12527,'0',13234,1018,5,NULL,'25c6611771fe44b99544f774f1b771a2'),(NULL,0,'2019-11-29 22:15:50',NULL,12528,'0',13235,1018,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:50',NULL,12529,'0',13237,1019,16,NULL,'cmdb2-4-1-4'),(NULL,0,'2019-11-29 22:15:50',NULL,12530,'0',13238,1019,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,12531,'0',13239,1019,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:50',NULL,12532,'0',13240,1019,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,12533,'0',13241,1019,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,12534,'0',13242,1019,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:50',NULL,12535,'0',13243,1019,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,12536,'0',13244,1019,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:50',NULL,12537,'0',13245,1019,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,12538,'0',13246,1019,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,12539,'0',13247,1019,15,NULL,'10.8.1.4'),(NULL,0,'2019-11-29 22:15:51',NULL,12540,'0',13248,1019,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,12541,'0',13249,1019,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,12542,'0',13250,1019,5,NULL,'4271b3e3953b41649a7ad591537119ca'),(NULL,0,'2019-11-29 22:15:51',NULL,12543,'0',13251,1019,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:51',NULL,12544,'0',13253,1020,16,NULL,'cmdb2-4-1-5'),(NULL,0,'2019-11-29 22:15:51',NULL,12545,'0',13254,1020,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,12546,'0',13255,1020,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:51',NULL,12547,'0',13256,1020,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,12548,'0',13257,1020,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,12549,'0',13258,1020,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:51',NULL,12550,'0',13259,1020,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,12551,'0',13260,1020,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:51',NULL,12552,'0',13261,1020,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,12553,'0',13262,1020,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,12554,'0',13263,1020,15,NULL,'10.8.1.5'),(NULL,0,'2019-11-29 22:15:51',NULL,12555,'0',13264,1020,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,12556,'0',13265,1020,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,12557,'0',13266,1020,5,NULL,'e91d7052f0d64800ada3901d2e11a2e3'),(NULL,0,'2019-11-29 22:15:51',NULL,12558,'0',13267,1020,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:51',NULL,12559,'0',13269,1021,16,NULL,'cmdb2-4-1-6'),(NULL,0,'2019-11-29 22:15:51',NULL,12560,'0',13270,1021,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,12561,'0',13271,1021,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:51',NULL,12562,'0',13272,1021,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,12563,'0',13273,1021,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,12564,'0',13274,1021,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:51',NULL,12565,'0',13275,1021,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,12566,'0',13276,1021,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:51',NULL,12567,'0',13277,1021,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,12568,'0',13278,1021,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,12569,'0',13279,1021,15,NULL,'10.8.1.6'),(NULL,0,'2019-11-29 22:15:51',NULL,12570,'0',13280,1021,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,12571,'0',13281,1021,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,12572,'0',13282,1021,5,NULL,'96237283543d48c6a0462d9f5a4006f2'),(NULL,0,'2019-11-29 22:15:51',NULL,12573,'0',13283,1021,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:51',NULL,12574,'0',13285,1022,16,NULL,'cmdb2-4-1-7'),(NULL,0,'2019-11-29 22:15:51',NULL,12575,'0',13286,1022,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,12576,'0',13287,1022,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:51',NULL,12577,'0',13288,1022,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,12578,'0',13289,1022,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,12579,'0',13290,1022,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:51',NULL,12580,'0',13291,1022,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,12581,'0',13292,1022,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:51',NULL,12582,'0',13293,1022,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,12583,'0',13294,1022,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,12584,'0',13295,1022,15,NULL,'10.8.1.7'),(NULL,0,'2019-11-29 22:15:51',NULL,12585,'0',13296,1022,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,12586,'0',13297,1022,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,12587,'0',13298,1022,5,NULL,'e5a8b331ba0447be8c7cfb6f391e155c'),(NULL,0,'2019-11-29 22:15:51',NULL,12588,'0',13299,1022,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:51',NULL,12589,'0',13301,1023,16,NULL,'cmdb2-4-1-8'),(NULL,0,'2019-11-29 22:15:51',NULL,12590,'0',13302,1023,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,12591,'0',13303,1023,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:51',NULL,12592,'0',13304,1023,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,12593,'0',13305,1023,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,12594,'0',13306,1023,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:51',NULL,12595,'0',13307,1023,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,12596,'0',13308,1023,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:51',NULL,12597,'0',13309,1023,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,12598,'0',13310,1023,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,12599,'0',13311,1023,15,NULL,'10.8.1.8'),(NULL,0,'2019-11-29 22:15:51',NULL,12600,'0',13312,1023,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,12601,'0',13313,1023,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,12602,'0',13314,1023,5,NULL,'82114dab1ac24e3d92184f40415fb5ed'),(NULL,0,'2019-11-29 22:15:51',NULL,12603,'0',13315,1023,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:52',NULL,12604,'0',13317,1024,16,NULL,'cmdb2-4-1-9'),(NULL,0,'2019-11-29 22:15:52',NULL,12605,'0',13318,1024,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,12606,'0',13319,1024,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:52',NULL,12607,'0',13320,1024,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,12608,'0',13321,1024,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,12609,'0',13322,1024,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:52',NULL,12610,'0',13323,1024,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,12611,'0',13324,1024,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:52',NULL,12612,'0',13325,1024,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,12613,'0',13326,1024,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,12614,'0',13327,1024,15,NULL,'10.8.1.9'),(NULL,0,'2019-11-29 22:15:52',NULL,12615,'0',13328,1024,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,12616,'0',13329,1024,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,12617,'0',13330,1024,5,NULL,'c7484cc24d614919a1ef7d5c6aba37db'),(NULL,0,'2019-11-29 22:15:52',NULL,12618,'0',13331,1024,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:52',NULL,12619,'0',13333,1025,16,NULL,'cmdb2-4-1-10'),(NULL,0,'2019-11-29 22:15:52',NULL,12620,'0',13334,1025,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,12621,'0',13335,1025,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:52',NULL,12622,'0',13336,1025,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,12623,'0',13337,1025,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,12624,'0',13338,1025,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:52',NULL,12625,'0',13339,1025,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,12626,'0',13340,1025,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:52',NULL,12627,'0',13341,1025,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,12628,'0',13342,1025,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,12629,'0',13343,1025,15,NULL,'10.8.1.10'),(NULL,0,'2019-11-29 22:15:52',NULL,12630,'0',13344,1025,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,12631,'0',13345,1025,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,12632,'0',13346,1025,5,NULL,'123fc39f1cd3410999ef9f564ff546da'),(NULL,0,'2019-11-29 22:15:52',NULL,12633,'0',13347,1025,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:52',NULL,12634,'0',13349,1026,16,NULL,'cmdb2-4-1-11'),(NULL,0,'2019-11-29 22:15:52',NULL,12635,'0',13350,1026,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,12636,'0',13351,1026,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:52',NULL,12637,'0',13352,1026,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,12638,'0',13353,1026,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,12639,'0',13354,1026,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:52',NULL,12640,'0',13355,1026,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,12641,'0',13356,1026,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:52',NULL,12642,'0',13357,1026,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,12643,'0',13358,1026,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,12644,'0',13359,1026,15,NULL,'10.8.1.11'),(NULL,0,'2019-11-29 22:15:52',NULL,12645,'0',13360,1026,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,12646,'0',13361,1026,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,12647,'0',13362,1026,5,NULL,'92b413f7f82840768d9c774f816e5f61'),(NULL,0,'2019-11-29 22:15:52',NULL,12648,'0',13363,1026,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:52',NULL,12649,'0',13365,1027,16,NULL,'cmdb2-4-1-12'),(NULL,0,'2019-11-29 22:15:52',NULL,12650,'0',13366,1027,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,12651,'0',13367,1027,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:52',NULL,12652,'0',13368,1027,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,12653,'0',13369,1027,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,12654,'0',13370,1027,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:52',NULL,12655,'0',13371,1027,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,12656,'0',13372,1027,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:52',NULL,12657,'0',13373,1027,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,12658,'0',13374,1027,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,12659,'0',13375,1027,15,NULL,'10.8.1.12'),(NULL,0,'2019-11-29 22:15:52',NULL,12660,'0',13376,1027,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,12661,'0',13377,1027,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,12662,'0',13378,1027,5,NULL,'677b3740a35f4c7f8b4e498b7f495c4e'),(NULL,0,'2019-11-29 22:15:52',NULL,12663,'0',13379,1027,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:52',NULL,12664,'0',13381,1028,16,NULL,'cmdb2-4-1-13'),(NULL,0,'2019-11-29 22:15:52',NULL,12665,'0',13382,1028,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,12666,'0',13383,1028,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:52',NULL,12667,'0',13384,1028,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,12668,'0',13385,1028,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,12669,'0',13386,1028,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:53',NULL,12670,'0',13387,1028,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,12671,'0',13388,1028,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:53',NULL,12672,'0',13389,1028,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,12673,'0',13390,1028,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,12674,'0',13391,1028,15,NULL,'10.8.1.13'),(NULL,0,'2019-11-29 22:15:53',NULL,12675,'0',13392,1028,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,12676,'0',13393,1028,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,12677,'0',13394,1028,5,NULL,'25ac0f09731e4a699e75c29c75ccc14f'),(NULL,0,'2019-11-29 22:15:53',NULL,12678,'0',13395,1028,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:53',NULL,12679,'0',13397,1029,16,NULL,'cmdb2-4-1-14'),(NULL,0,'2019-11-29 22:15:53',NULL,12680,'0',13398,1029,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,12681,'0',13399,1029,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:53',NULL,12682,'0',13400,1029,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,12683,'0',13401,1029,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,12684,'0',13402,1029,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:53',NULL,12685,'0',13403,1029,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,12686,'0',13404,1029,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:53',NULL,12687,'0',13405,1029,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,12688,'0',13406,1029,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,12689,'0',13407,1029,15,NULL,'10.8.1.14'),(NULL,0,'2019-11-29 22:15:53',NULL,12690,'0',13408,1029,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,12691,'0',13409,1029,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,12692,'0',13410,1029,5,NULL,'c790fe82a6fb4bbba1b614eb0e389ad3'),(NULL,0,'2019-11-29 22:15:53',NULL,12693,'0',13411,1029,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:53',NULL,12694,'0',13413,1030,16,NULL,'cmdb2-4-1-15'),(NULL,0,'2019-11-29 22:15:53',NULL,12695,'0',13414,1030,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,12696,'0',13415,1030,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:53',NULL,12697,'0',13416,1030,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,12698,'0',13417,1030,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,12699,'0',13418,1030,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:53',NULL,12700,'0',13419,1030,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,12701,'0',13420,1030,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:53',NULL,12702,'0',13421,1030,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,12703,'0',13422,1030,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,12704,'0',13423,1030,15,NULL,'10.8.1.15'),(NULL,0,'2019-11-29 22:15:53',NULL,12705,'0',13424,1030,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,12706,'0',13425,1030,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,12707,'0',13426,1030,5,NULL,'f6899d474ba343b0837f2f984c6f7f68'),(NULL,0,'2019-11-29 22:15:53',NULL,12708,'0',13427,1030,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:53',NULL,12709,'0',13429,1031,16,NULL,'cmdb2-4-1-16'),(NULL,0,'2019-11-29 22:15:53',NULL,12710,'0',13430,1031,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,12711,'0',13431,1031,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:53',NULL,12712,'0',13432,1031,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,12713,'0',13433,1031,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,12714,'0',13434,1031,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:53',NULL,12715,'0',13435,1031,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,12716,'0',13436,1031,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:53',NULL,12717,'0',13437,1031,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,12718,'0',13438,1031,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,12719,'0',13439,1031,15,NULL,'10.8.1.16'),(NULL,0,'2019-11-29 22:15:53',NULL,12720,'0',13440,1031,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,12721,'0',13441,1031,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,12722,'0',13442,1031,5,NULL,'8a14df81c0cc4bdbb373e60c0bdf4141'),(NULL,0,'2019-11-29 22:15:53',NULL,12723,'0',13443,1031,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:53',NULL,12724,'0',13445,1032,4,NULL,'App2-4-2'),(NULL,0,'2019-11-29 22:15:53',NULL,12725,'0',13447,1033,16,NULL,'cmdb2-4-2-1'),(NULL,0,'2019-11-29 22:15:53',NULL,12726,'0',13448,1033,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,12727,'0',13449,1033,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:53',NULL,12728,'0',13450,1033,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,12729,'0',13451,1033,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,12730,'0',13452,1033,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:54',NULL,12731,'0',13453,1033,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,12732,'0',13454,1033,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:54',NULL,12733,'0',13455,1033,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,12734,'0',13456,1033,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,12735,'0',13457,1033,15,NULL,'10.8.2.1'),(NULL,0,'2019-11-29 22:15:54',NULL,12736,'0',13458,1033,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,12737,'0',13459,1033,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,12738,'0',13460,1033,5,NULL,'a40eff57dddf408ba5a127864cd21883'),(NULL,0,'2019-11-29 22:15:54',NULL,12739,'0',13461,1033,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:54',NULL,12740,'0',13463,1034,16,NULL,'cmdb2-4-2-2'),(NULL,0,'2019-11-29 22:15:54',NULL,12741,'0',13464,1034,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,12742,'0',13465,1034,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:54',NULL,12743,'0',13466,1034,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,12744,'0',13467,1034,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,12745,'0',13468,1034,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:54',NULL,12746,'0',13469,1034,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,12747,'0',13470,1034,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:54',NULL,12748,'0',13471,1034,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,12749,'0',13472,1034,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,12750,'0',13473,1034,15,NULL,'10.8.2.2'),(NULL,0,'2019-11-29 22:15:54',NULL,12751,'0',13474,1034,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,12752,'0',13475,1034,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,12753,'0',13476,1034,5,NULL,'b27c27b8ecf941a58702b41c18e51e42'),(NULL,0,'2019-11-29 22:15:54',NULL,12754,'0',13477,1034,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:54',NULL,12755,'0',13479,1035,16,NULL,'cmdb2-4-2-3'),(NULL,0,'2019-11-29 22:15:54',NULL,12756,'0',13480,1035,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,12757,'0',13481,1035,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:54',NULL,12758,'0',13482,1035,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,12759,'0',13483,1035,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,12760,'0',13484,1035,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:54',NULL,12761,'0',13485,1035,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,12762,'0',13486,1035,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:54',NULL,12763,'0',13487,1035,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,12764,'0',13488,1035,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,12765,'0',13489,1035,15,NULL,'10.8.2.3'),(NULL,0,'2019-11-29 22:15:54',NULL,12766,'0',13490,1035,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,12767,'0',13491,1035,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,12768,'0',13492,1035,5,NULL,'3a02345ffbf74bd7bfed2ac4e569d22e'),(NULL,0,'2019-11-29 22:15:54',NULL,12769,'0',13493,1035,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:54',NULL,12770,'0',13495,1036,16,NULL,'cmdb2-4-2-4'),(NULL,0,'2019-11-29 22:15:54',NULL,12771,'0',13496,1036,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,12772,'0',13497,1036,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:54',NULL,12773,'0',13498,1036,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,12774,'0',13499,1036,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,12775,'0',13500,1036,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:54',NULL,12776,'0',13501,1036,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,12777,'0',13502,1036,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:54',NULL,12778,'0',13503,1036,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,12779,'0',13504,1036,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,12780,'0',13505,1036,15,NULL,'10.8.2.4'),(NULL,0,'2019-11-29 22:15:54',NULL,12781,'0',13506,1036,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,12782,'0',13507,1036,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,12783,'0',13508,1036,5,NULL,'6a6634e29d484e229c64dce10629c459'),(NULL,0,'2019-11-29 22:15:54',NULL,12784,'0',13509,1036,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:54',NULL,12785,'0',13511,1037,16,NULL,'cmdb2-4-2-5'),(NULL,0,'2019-11-29 22:15:54',NULL,12786,'0',13512,1037,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,12787,'0',13513,1037,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:54',NULL,12788,'0',13514,1037,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,12789,'0',13515,1037,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,12790,'0',13516,1037,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:54',NULL,12791,'0',13517,1037,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,12792,'0',13518,1037,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:54',NULL,12793,'0',13519,1037,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,12794,'0',13520,1037,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,12795,'0',13521,1037,15,NULL,'10.8.2.5'),(NULL,0,'2019-11-29 22:15:55',NULL,12796,'0',13522,1037,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,12797,'0',13523,1037,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,12798,'0',13524,1037,5,NULL,'2cf2870fb36d46c59554ff734eb1e5df'),(NULL,0,'2019-11-29 22:15:55',NULL,12799,'0',13525,1037,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:55',NULL,12800,'0',13527,1038,16,NULL,'cmdb2-4-2-6'),(NULL,0,'2019-11-29 22:15:55',NULL,12801,'0',13528,1038,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,12802,'0',13529,1038,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:55',NULL,12803,'0',13530,1038,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,12804,'0',13531,1038,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,12805,'0',13532,1038,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:55',NULL,12806,'0',13533,1038,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,12807,'0',13534,1038,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:55',NULL,12808,'0',13535,1038,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,12809,'0',13536,1038,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,12810,'0',13537,1038,15,NULL,'10.8.2.6'),(NULL,0,'2019-11-29 22:15:55',NULL,12811,'0',13538,1038,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,12812,'0',13539,1038,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,12813,'0',13540,1038,5,NULL,'d0b474e37f8e4188bab04e04c1080517'),(NULL,0,'2019-11-29 22:15:55',NULL,12814,'0',13541,1038,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:55',NULL,12815,'0',13543,1039,16,NULL,'cmdb2-4-2-7'),(NULL,0,'2019-11-29 22:15:55',NULL,12816,'0',13544,1039,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,12817,'0',13545,1039,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:55',NULL,12818,'0',13546,1039,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,12819,'0',13547,1039,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,12820,'0',13548,1039,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:55',NULL,12821,'0',13549,1039,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,12822,'0',13550,1039,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:55',NULL,12823,'0',13551,1039,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,12824,'0',13552,1039,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,12825,'0',13553,1039,15,NULL,'10.8.2.7'),(NULL,0,'2019-11-29 22:15:55',NULL,12826,'0',13554,1039,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,12827,'0',13555,1039,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,12828,'0',13556,1039,5,NULL,'f7267a593dc94988867e44d0a6073ef4'),(NULL,0,'2019-11-29 22:15:55',NULL,12829,'0',13557,1039,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:55',NULL,12830,'0',13559,1040,16,NULL,'cmdb2-4-2-8'),(NULL,0,'2019-11-29 22:15:55',NULL,12831,'0',13560,1040,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,12832,'0',13561,1040,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:55',NULL,12833,'0',13562,1040,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,12834,'0',13563,1040,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,12835,'0',13564,1040,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:55',NULL,12836,'0',13565,1040,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,12837,'0',13566,1040,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:55',NULL,12838,'0',13567,1040,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,12839,'0',13568,1040,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,12840,'0',13569,1040,15,NULL,'10.8.2.8'),(NULL,0,'2019-11-29 22:15:55',NULL,12841,'0',13570,1040,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,12842,'0',13571,1040,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,12843,'0',13572,1040,5,NULL,'1dad41b947ff4471bbbacd33c53a34a0'),(NULL,0,'2019-11-29 22:15:55',NULL,12844,'0',13573,1040,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:55',NULL,12845,'0',13575,1041,16,NULL,'cmdb2-4-2-9'),(NULL,0,'2019-11-29 22:15:55',NULL,12846,'0',13576,1041,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,12847,'0',13577,1041,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:55',NULL,12848,'0',13578,1041,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,12849,'0',13579,1041,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,12850,'0',13580,1041,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:55',NULL,12851,'0',13581,1041,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,12852,'0',13582,1041,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:55',NULL,12853,'0',13583,1041,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,12854,'0',13584,1041,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,12855,'0',13585,1041,15,NULL,'10.8.2.9'),(NULL,0,'2019-11-29 22:15:55',NULL,12856,'0',13586,1041,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,12857,'0',13587,1041,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,12858,'0',13588,1041,5,NULL,'261b5cb0e5e647699638c358fd826d5c'),(NULL,0,'2019-11-29 22:15:55',NULL,12859,'0',13589,1041,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:56',NULL,12860,'0',13591,1042,16,NULL,'cmdb2-4-2-10'),(NULL,0,'2019-11-29 22:15:56',NULL,12861,'0',13592,1042,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,12862,'0',13593,1042,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:56',NULL,12863,'0',13594,1042,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,12864,'0',13595,1042,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,12865,'0',13596,1042,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:56',NULL,12866,'0',13597,1042,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,12867,'0',13598,1042,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:56',NULL,12868,'0',13599,1042,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,12869,'0',13600,1042,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,12870,'0',13601,1042,15,NULL,'10.8.2.10'),(NULL,0,'2019-11-29 22:15:56',NULL,12871,'0',13602,1042,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,12872,'0',13603,1042,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,12873,'0',13604,1042,5,NULL,'3699900cdc6d4877afc1da97ce983fb6'),(NULL,0,'2019-11-29 22:15:56',NULL,12874,'0',13605,1042,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:56',NULL,12875,'0',13607,1043,16,NULL,'cmdb2-4-2-11'),(NULL,0,'2019-11-29 22:15:56',NULL,12876,'0',13608,1043,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,12877,'0',13609,1043,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:56',NULL,12878,'0',13610,1043,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,12879,'0',13611,1043,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,12880,'0',13612,1043,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:56',NULL,12881,'0',13613,1043,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,12882,'0',13614,1043,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:56',NULL,12883,'0',13615,1043,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,12884,'0',13616,1043,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,12885,'0',13617,1043,15,NULL,'10.8.2.11'),(NULL,0,'2019-11-29 22:15:56',NULL,12886,'0',13618,1043,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,12887,'0',13619,1043,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,12888,'0',13620,1043,5,NULL,'e9adfadfe705431bb11e28d0bd418105'),(NULL,0,'2019-11-29 22:15:56',NULL,12889,'0',13621,1043,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:56',NULL,12890,'0',13623,1044,16,NULL,'cmdb2-4-2-12'),(NULL,0,'2019-11-29 22:15:56',NULL,12891,'0',13624,1044,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,12892,'0',13625,1044,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:56',NULL,12893,'0',13626,1044,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,12894,'0',13627,1044,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,12895,'0',13628,1044,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:56',NULL,12896,'0',13629,1044,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,12897,'0',13630,1044,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:56',NULL,12898,'0',13631,1044,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,12899,'0',13632,1044,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,12900,'0',13633,1044,15,NULL,'10.8.2.12'),(NULL,0,'2019-11-29 22:15:56',NULL,12901,'0',13634,1044,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,12902,'0',13635,1044,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,12903,'0',13636,1044,5,NULL,'e4da5c49801c441da7a9584e51386c31'),(NULL,0,'2019-11-29 22:15:56',NULL,12904,'0',13637,1044,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:56',NULL,12905,'0',13639,1045,16,NULL,'cmdb2-4-2-13'),(NULL,0,'2019-11-29 22:15:56',NULL,12906,'0',13640,1045,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,12907,'0',13641,1045,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:56',NULL,12908,'0',13642,1045,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,12909,'0',13643,1045,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,12910,'0',13644,1045,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:56',NULL,12911,'0',13645,1045,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,12912,'0',13646,1045,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:56',NULL,12913,'0',13647,1045,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,12914,'0',13648,1045,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,12915,'0',13649,1045,15,NULL,'10.8.2.13'),(NULL,0,'2019-11-29 22:15:56',NULL,12916,'0',13650,1045,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,12917,'0',13651,1045,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,12918,'0',13652,1045,5,NULL,'6c4fb5174994401f871320762aab4680'),(NULL,0,'2019-11-29 22:15:56',NULL,12919,'0',13653,1045,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:56',NULL,12920,'0',13655,1046,16,NULL,'cmdb2-4-2-14'),(NULL,0,'2019-11-29 22:15:56',NULL,12921,'0',13656,1046,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,12922,'0',13657,1046,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:56',NULL,12923,'0',13658,1046,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,12924,'0',13659,1046,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,12925,'0',13660,1046,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:57',NULL,12926,'0',13661,1046,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,12927,'0',13662,1046,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:57',NULL,12928,'0',13663,1046,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,12929,'0',13664,1046,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,12930,'0',13665,1046,15,NULL,'10.8.2.14'),(NULL,0,'2019-11-29 22:15:57',NULL,12931,'0',13666,1046,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,12932,'0',13667,1046,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,12933,'0',13668,1046,5,NULL,'9153657595214fc7a549176cfefa7980'),(NULL,0,'2019-11-29 22:15:57',NULL,12934,'0',13669,1046,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:57',NULL,12935,'0',13671,1047,16,NULL,'cmdb2-4-2-15'),(NULL,0,'2019-11-29 22:15:57',NULL,12936,'0',13672,1047,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,12937,'0',13673,1047,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:57',NULL,12938,'0',13674,1047,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,12939,'0',13675,1047,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,12940,'0',13676,1047,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:57',NULL,12941,'0',13677,1047,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,12942,'0',13678,1047,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:57',NULL,12943,'0',13679,1047,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,12944,'0',13680,1047,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,12945,'0',13681,1047,15,NULL,'10.8.2.15'),(NULL,0,'2019-11-29 22:15:57',NULL,12946,'0',13682,1047,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,12947,'0',13683,1047,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,12948,'0',13684,1047,5,NULL,'ccb1744825ed4bfcaaedc418af1c91ca'),(NULL,0,'2019-11-29 22:15:57',NULL,12949,'0',13685,1047,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:57',NULL,12950,'0',13687,1048,16,NULL,'cmdb2-4-2-16'),(NULL,0,'2019-11-29 22:15:57',NULL,12951,'0',13688,1048,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,12952,'0',13689,1048,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:57',NULL,12953,'0',13690,1048,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,12954,'0',13691,1048,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,12955,'0',13692,1048,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:57',NULL,12956,'0',13693,1048,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,12957,'0',13694,1048,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:57',NULL,12958,'0',13695,1048,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,12959,'0',13696,1048,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,12960,'0',13697,1048,15,NULL,'10.8.2.16'),(NULL,0,'2019-11-29 22:15:57',NULL,12961,'0',13698,1048,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,12962,'0',13699,1048,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,12963,'0',13700,1048,5,NULL,'fd882e1d405c4e958a20065f6878e3a5'),(NULL,0,'2019-11-29 22:15:57',NULL,12964,'0',13701,1048,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:57',NULL,12965,'0',13703,1049,4,NULL,'App2-4-3'),(NULL,0,'2019-11-29 22:15:57',NULL,12966,'0',13705,1050,16,NULL,'cmdb2-4-3-1'),(NULL,0,'2019-11-29 22:15:57',NULL,12967,'0',13706,1050,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,12968,'0',13707,1050,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:57',NULL,12969,'0',13708,1050,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,12970,'0',13709,1050,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,12971,'0',13710,1050,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:57',NULL,12972,'0',13711,1050,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,12973,'0',13712,1050,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:57',NULL,12974,'0',13713,1050,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,12975,'0',13714,1050,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,12976,'0',13715,1050,15,NULL,'10.8.3.1'),(NULL,0,'2019-11-29 22:15:57',NULL,12977,'0',13716,1050,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,12978,'0',13717,1050,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,12979,'0',13718,1050,5,NULL,'570f667a7f8e465cbbd6609c3c2c92f7'),(NULL,0,'2019-11-29 22:15:57',NULL,12980,'0',13719,1050,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:57',NULL,12981,'0',13721,1051,16,NULL,'cmdb2-4-3-2'),(NULL,0,'2019-11-29 22:15:57',NULL,12982,'0',13722,1051,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,12983,'0',13723,1051,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:57',NULL,12984,'0',13724,1051,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,12985,'0',13725,1051,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,12986,'0',13726,1051,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:57',NULL,12987,'0',13727,1051,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,12988,'0',13728,1051,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:58',NULL,12989,'0',13729,1051,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,12990,'0',13730,1051,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,12991,'0',13731,1051,15,NULL,'10.8.3.2'),(NULL,0,'2019-11-29 22:15:58',NULL,12992,'0',13732,1051,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,12993,'0',13733,1051,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,12994,'0',13734,1051,5,NULL,'4a24b0924da84c3b9dbca591b5a5c99a'),(NULL,0,'2019-11-29 22:15:58',NULL,12995,'0',13735,1051,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:58',NULL,12996,'0',13737,1052,16,NULL,'cmdb2-4-3-3'),(NULL,0,'2019-11-29 22:15:58',NULL,12997,'0',13738,1052,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,12998,'0',13739,1052,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:58',NULL,12999,'0',13740,1052,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,13000,'0',13741,1052,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,13001,'0',13742,1052,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:58',NULL,13002,'0',13743,1052,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,13003,'0',13744,1052,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:58',NULL,13004,'0',13745,1052,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,13005,'0',13746,1052,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,13006,'0',13747,1052,15,NULL,'10.8.3.3'),(NULL,0,'2019-11-29 22:15:58',NULL,13007,'0',13748,1052,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,13008,'0',13749,1052,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,13009,'0',13750,1052,5,NULL,'ccab04214b814c96bd9a8bd2cce0c1df'),(NULL,0,'2019-11-29 22:15:58',NULL,13010,'0',13751,1052,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:58',NULL,13011,'0',13753,1053,16,NULL,'cmdb2-4-3-4'),(NULL,0,'2019-11-29 22:15:58',NULL,13012,'0',13754,1053,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,13013,'0',13755,1053,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:58',NULL,13014,'0',13756,1053,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,13015,'0',13757,1053,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,13016,'0',13758,1053,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:58',NULL,13017,'0',13759,1053,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,13018,'0',13760,1053,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:58',NULL,13019,'0',13761,1053,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,13020,'0',13762,1053,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,13021,'0',13763,1053,15,NULL,'10.8.3.4'),(NULL,0,'2019-11-29 22:15:58',NULL,13022,'0',13764,1053,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,13023,'0',13765,1053,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,13024,'0',13766,1053,5,NULL,'86e50f937c50484ab1de19c9d5106ed0'),(NULL,0,'2019-11-29 22:15:58',NULL,13025,'0',13767,1053,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:58',NULL,13026,'0',13769,1054,16,NULL,'cmdb2-4-3-5'),(NULL,0,'2019-11-29 22:15:58',NULL,13027,'0',13770,1054,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,13028,'0',13771,1054,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:58',NULL,13029,'0',13772,1054,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,13030,'0',13773,1054,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,13031,'0',13774,1054,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:58',NULL,13032,'0',13775,1054,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,13033,'0',13776,1054,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:58',NULL,13034,'0',13777,1054,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,13035,'0',13778,1054,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,13036,'0',13779,1054,15,NULL,'10.8.3.5'),(NULL,0,'2019-11-29 22:15:58',NULL,13037,'0',13780,1054,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,13038,'0',13781,1054,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,13039,'0',13782,1054,5,NULL,'11b4c6001c7f4f07a764a26f713f6498'),(NULL,0,'2019-11-29 22:15:58',NULL,13040,'0',13783,1054,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:58',NULL,13041,'0',13785,1055,16,NULL,'cmdb2-4-3-6'),(NULL,0,'2019-11-29 22:15:58',NULL,13042,'0',13786,1055,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,13043,'0',13787,1055,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:58',NULL,13044,'0',13788,1055,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,13045,'0',13789,1055,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,13046,'0',13790,1055,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:58',NULL,13047,'0',13791,1055,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,13048,'0',13792,1055,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:58',NULL,13049,'0',13793,1055,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,13050,'0',13794,1055,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,13051,'0',13795,1055,15,NULL,'10.8.3.6'),(NULL,0,'2019-11-29 22:15:59',NULL,13052,'0',13796,1055,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,13053,'0',13797,1055,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,13054,'0',13798,1055,5,NULL,'5fd30f933b524ce98339237d78cffb2d'),(NULL,0,'2019-11-29 22:15:59',NULL,13055,'0',13799,1055,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:59',NULL,13056,'0',13801,1056,16,NULL,'cmdb2-4-3-7'),(NULL,0,'2019-11-29 22:15:59',NULL,13057,'0',13802,1056,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,13058,'0',13803,1056,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:59',NULL,13059,'0',13804,1056,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,13060,'0',13805,1056,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,13061,'0',13806,1056,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:59',NULL,13062,'0',13807,1056,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,13063,'0',13808,1056,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:59',NULL,13064,'0',13809,1056,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,13065,'0',13810,1056,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,13066,'0',13811,1056,15,NULL,'10.8.3.7'),(NULL,0,'2019-11-29 22:15:59',NULL,13067,'0',13812,1056,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,13068,'0',13813,1056,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,13069,'0',13814,1056,5,NULL,'b56d5c2d016a4a0bbf0352654a53e648'),(NULL,0,'2019-11-29 22:15:59',NULL,13070,'0',13815,1056,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:59',NULL,13071,'0',13817,1057,16,NULL,'cmdb2-4-3-8'),(NULL,0,'2019-11-29 22:15:59',NULL,13072,'0',13818,1057,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,13073,'0',13819,1057,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:59',NULL,13074,'0',13820,1057,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,13075,'0',13821,1057,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,13076,'0',13822,1057,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:59',NULL,13077,'0',13823,1057,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,13078,'0',13824,1057,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:59',NULL,13079,'0',13825,1057,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,13080,'0',13826,1057,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,13081,'0',13827,1057,15,NULL,'10.8.3.8'),(NULL,0,'2019-11-29 22:15:59',NULL,13082,'0',13828,1057,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,13083,'0',13829,1057,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,13084,'0',13830,1057,5,NULL,'ebb58dea825d40ce81fe68b6206689dc'),(NULL,0,'2019-11-29 22:15:59',NULL,13085,'0',13831,1057,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:59',NULL,13086,'0',13833,1058,16,NULL,'cmdb2-4-3-9'),(NULL,0,'2019-11-29 22:15:59',NULL,13087,'0',13834,1058,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,13088,'0',13835,1058,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:59',NULL,13089,'0',13836,1058,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,13090,'0',13837,1058,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,13091,'0',13838,1058,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:59',NULL,13092,'0',13839,1058,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,13093,'0',13840,1058,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:59',NULL,13094,'0',13841,1058,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,13095,'0',13842,1058,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,13096,'0',13843,1058,15,NULL,'10.8.3.9'),(NULL,0,'2019-11-29 22:15:59',NULL,13097,'0',13844,1058,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,13098,'0',13845,1058,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,13099,'0',13846,1058,5,NULL,'7e965452847a4fc297ff7d494f5a5ba2'),(NULL,0,'2019-11-29 22:15:59',NULL,13100,'0',13847,1058,17,NULL,'在线'),(NULL,0,'2019-11-29 22:15:59',NULL,13101,'0',13849,1059,16,NULL,'cmdb2-4-3-10'),(NULL,0,'2019-11-29 22:15:59',NULL,13102,'0',13850,1059,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,13103,'0',13851,1059,22,NULL,'2'),(NULL,0,'2019-11-29 22:15:59',NULL,13104,'0',13852,1059,28,NULL,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,13105,'0',13853,1059,24,NULL,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,13106,'0',13854,1059,29,NULL,'张江'),(NULL,0,'2019-11-29 22:15:59',NULL,13107,'0',13855,1059,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,13108,'0',13856,1059,23,NULL,'40'),(NULL,0,'2019-11-29 22:15:59',NULL,13109,'0',13857,1059,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,13110,'0',13858,1059,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,13111,'0',13859,1059,15,NULL,'10.8.3.10'),(NULL,0,'2019-11-29 22:15:59',NULL,13112,'0',13860,1059,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,13113,'0',13861,1059,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,13114,'0',13862,1059,5,NULL,'539e74b5297d45828c2eaf0512e65c3f'),(NULL,0,'2019-11-29 22:15:59',NULL,13115,'0',13863,1059,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:00',NULL,13116,'0',13865,1060,16,NULL,'cmdb2-4-3-11'),(NULL,0,'2019-11-29 22:16:00',NULL,13117,'0',13866,1060,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,13118,'0',13867,1060,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:00',NULL,13119,'0',13868,1060,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,13120,'0',13869,1060,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,13121,'0',13870,1060,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:00',NULL,13122,'0',13871,1060,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,13123,'0',13872,1060,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:00',NULL,13124,'0',13873,1060,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,13125,'0',13874,1060,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,13126,'0',13875,1060,15,NULL,'10.8.3.11'),(NULL,0,'2019-11-29 22:16:00',NULL,13127,'0',13876,1060,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,13128,'0',13877,1060,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,13129,'0',13878,1060,5,NULL,'0d8ff5db57be4a3aa9035dce8e28f1a1'),(NULL,0,'2019-11-29 22:16:00',NULL,13130,'0',13879,1060,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:00',NULL,13131,'0',13881,1061,16,NULL,'cmdb2-4-3-12'),(NULL,0,'2019-11-29 22:16:00',NULL,13132,'0',13882,1061,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,13133,'0',13883,1061,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:00',NULL,13134,'0',13884,1061,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,13135,'0',13885,1061,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,13136,'0',13886,1061,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:00',NULL,13137,'0',13887,1061,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,13138,'0',13888,1061,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:00',NULL,13139,'0',13889,1061,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,13140,'0',13890,1061,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,13141,'0',13891,1061,15,NULL,'10.8.3.12'),(NULL,0,'2019-11-29 22:16:00',NULL,13142,'0',13892,1061,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,13143,'0',13893,1061,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,13144,'0',13894,1061,5,NULL,'eb9870897d6f4af4be485098e9ed068c'),(NULL,0,'2019-11-29 22:16:00',NULL,13145,'0',13895,1061,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:00',NULL,13146,'0',13897,1062,16,NULL,'cmdb2-4-3-13'),(NULL,0,'2019-11-29 22:16:00',NULL,13147,'0',13898,1062,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,13148,'0',13899,1062,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:00',NULL,13149,'0',13900,1062,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,13150,'0',13901,1062,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,13151,'0',13902,1062,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:00',NULL,13152,'0',13903,1062,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,13153,'0',13904,1062,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:00',NULL,13154,'0',13905,1062,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,13155,'0',13906,1062,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,13156,'0',13907,1062,15,NULL,'10.8.3.13'),(NULL,0,'2019-11-29 22:16:00',NULL,13157,'0',13908,1062,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,13158,'0',13909,1062,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,13159,'0',13910,1062,5,NULL,'8722ef9e22a744d9befe0c34d9a3866f'),(NULL,0,'2019-11-29 22:16:00',NULL,13160,'0',13911,1062,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:00',NULL,13161,'0',13913,1063,16,NULL,'cmdb2-4-3-14'),(NULL,0,'2019-11-29 22:16:00',NULL,13162,'0',13914,1063,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,13163,'0',13915,1063,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:00',NULL,13164,'0',13916,1063,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,13165,'0',13917,1063,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,13166,'0',13918,1063,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:00',NULL,13167,'0',13919,1063,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,13168,'0',13920,1063,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:00',NULL,13169,'0',13921,1063,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,13170,'0',13922,1063,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,13171,'0',13923,1063,15,NULL,'10.8.3.14'),(NULL,0,'2019-11-29 22:16:00',NULL,13172,'0',13924,1063,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,13173,'0',13925,1063,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,13174,'0',13926,1063,5,NULL,'527deee973a44ef68da770477a5cd17f'),(NULL,0,'2019-11-29 22:16:00',NULL,13175,'0',13927,1063,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:00',NULL,13176,'0',13929,1064,16,NULL,'cmdb2-4-3-15'),(NULL,0,'2019-11-29 22:16:00',NULL,13177,'0',13930,1064,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,13178,'0',13931,1064,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:01',NULL,13179,'0',13932,1064,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,13180,'0',13933,1064,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,13181,'0',13934,1064,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:01',NULL,13182,'0',13935,1064,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,13183,'0',13936,1064,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:01',NULL,13184,'0',13937,1064,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,13185,'0',13938,1064,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,13186,'0',13939,1064,15,NULL,'10.8.3.15'),(NULL,0,'2019-11-29 22:16:01',NULL,13187,'0',13940,1064,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,13188,'0',13941,1064,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,13189,'0',13942,1064,5,NULL,'8861f1eb99e644409de0e0d1c85d9ff1'),(NULL,0,'2019-11-29 22:16:01',NULL,13190,'0',13943,1064,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:01',NULL,13191,'0',13945,1065,16,NULL,'cmdb2-4-3-16'),(NULL,0,'2019-11-29 22:16:01',NULL,13192,'0',13946,1065,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,13193,'0',13947,1065,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:01',NULL,13194,'0',13948,1065,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,13195,'0',13949,1065,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,13196,'0',13950,1065,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:01',NULL,13197,'0',13951,1065,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,13198,'0',13952,1065,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:01',NULL,13199,'0',13953,1065,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,13200,'0',13954,1065,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,13201,'0',13955,1065,15,NULL,'10.8.3.16'),(NULL,0,'2019-11-29 22:16:01',NULL,13202,'0',13956,1065,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,13203,'0',13957,1065,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,13204,'0',13958,1065,5,NULL,'32e54a813fc549e190358aa5f5d732fd'),(NULL,0,'2019-11-29 22:16:01',NULL,13205,'0',13959,1065,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:01',NULL,13206,'0',13961,1066,4,NULL,'App2-4-4'),(NULL,0,'2019-11-29 22:16:01',NULL,13207,'0',13963,1067,16,NULL,'cmdb2-4-4-1'),(NULL,0,'2019-11-29 22:16:01',NULL,13208,'0',13964,1067,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,13209,'0',13965,1067,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:01',NULL,13210,'0',13966,1067,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,13211,'0',13967,1067,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,13212,'0',13968,1067,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:01',NULL,13213,'0',13969,1067,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,13214,'0',13970,1067,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:01',NULL,13215,'0',13971,1067,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,13216,'0',13972,1067,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,13217,'0',13973,1067,15,NULL,'10.8.4.1'),(NULL,0,'2019-11-29 22:16:01',NULL,13218,'0',13974,1067,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,13219,'0',13975,1067,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,13220,'0',13976,1067,5,NULL,'7c97eb85a3db475a9a5cc4b49a9b7699'),(NULL,0,'2019-11-29 22:16:01',NULL,13221,'0',13977,1067,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:01',NULL,13222,'0',13979,1068,16,NULL,'cmdb2-4-4-2'),(NULL,0,'2019-11-29 22:16:01',NULL,13223,'0',13980,1068,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,13224,'0',13981,1068,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:01',NULL,13225,'0',13982,1068,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,13226,'0',13983,1068,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,13227,'0',13984,1068,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:01',NULL,13228,'0',13985,1068,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,13229,'0',13986,1068,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:01',NULL,13230,'0',13987,1068,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,13231,'0',13988,1068,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,13232,'0',13989,1068,15,NULL,'10.8.4.2'),(NULL,0,'2019-11-29 22:16:01',NULL,13233,'0',13990,1068,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,13234,'0',13991,1068,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,13235,'0',13992,1068,5,NULL,'0767fecac798486da66c53d8157ad1b1'),(NULL,0,'2019-11-29 22:16:01',NULL,13236,'0',13993,1068,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:01',NULL,13237,'0',13995,1069,16,NULL,'cmdb2-4-4-3'),(NULL,0,'2019-11-29 22:16:01',NULL,13238,'0',13996,1069,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,13239,'0',13997,1069,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:02',NULL,13240,'0',13998,1069,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,13241,'0',13999,1069,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,13242,'0',14000,1069,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:02',NULL,13243,'0',14001,1069,20,NULL,'3.10.0-862.9.1.el7.x86_64');
INSERT INTO `c_attribute_histories` VALUES (NULL,0,'2019-11-29 22:16:02',NULL,13244,'0',14002,1069,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:02',NULL,13245,'0',14003,1069,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,13246,'0',14004,1069,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,13247,'0',14005,1069,15,NULL,'10.8.4.3'),(NULL,0,'2019-11-29 22:16:02',NULL,13248,'0',14006,1069,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,13249,'0',14007,1069,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,13250,'0',14008,1069,5,NULL,'16ace48258264dd192e743c0dc2ccc6c'),(NULL,0,'2019-11-29 22:16:02',NULL,13251,'0',14009,1069,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:02',NULL,13252,'0',14011,1070,16,NULL,'cmdb2-4-4-4'),(NULL,0,'2019-11-29 22:16:02',NULL,13253,'0',14012,1070,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,13254,'0',14013,1070,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:02',NULL,13255,'0',14014,1070,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,13256,'0',14015,1070,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,13257,'0',14016,1070,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:02',NULL,13258,'0',14017,1070,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,13259,'0',14018,1070,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:02',NULL,13260,'0',14019,1070,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,13261,'0',14020,1070,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,13262,'0',14021,1070,15,NULL,'10.8.4.4'),(NULL,0,'2019-11-29 22:16:02',NULL,13263,'0',14022,1070,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,13264,'0',14023,1070,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,13265,'0',14024,1070,5,NULL,'180141b6ae6246e0a418bfa827aed593'),(NULL,0,'2019-11-29 22:16:02',NULL,13266,'0',14025,1070,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:02',NULL,13267,'0',14027,1071,16,NULL,'cmdb2-4-4-5'),(NULL,0,'2019-11-29 22:16:02',NULL,13268,'0',14028,1071,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,13269,'0',14029,1071,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:02',NULL,13270,'0',14030,1071,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,13271,'0',14031,1071,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,13272,'0',14032,1071,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:02',NULL,13273,'0',14033,1071,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,13274,'0',14034,1071,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:02',NULL,13275,'0',14035,1071,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,13276,'0',14036,1071,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,13277,'0',14037,1071,15,NULL,'10.8.4.5'),(NULL,0,'2019-11-29 22:16:02',NULL,13278,'0',14038,1071,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,13279,'0',14039,1071,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,13280,'0',14040,1071,5,NULL,'065f0b658c7142e8a9793ec9b8e7ce7f'),(NULL,0,'2019-11-29 22:16:02',NULL,13281,'0',14041,1071,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:02',NULL,13282,'0',14043,1072,16,NULL,'cmdb2-4-4-6'),(NULL,0,'2019-11-29 22:16:02',NULL,13283,'0',14044,1072,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,13284,'0',14045,1072,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:02',NULL,13285,'0',14046,1072,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,13286,'0',14047,1072,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,13287,'0',14048,1072,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:02',NULL,13288,'0',14049,1072,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,13289,'0',14050,1072,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:02',NULL,13290,'0',14051,1072,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,13291,'0',14052,1072,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,13292,'0',14053,1072,15,NULL,'10.8.4.6'),(NULL,0,'2019-11-29 22:16:02',NULL,13293,'0',14054,1072,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,13294,'0',14055,1072,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,13295,'0',14056,1072,5,NULL,'3b08020ae8154e319bbe10b6f84d87b9'),(NULL,0,'2019-11-29 22:16:02',NULL,13296,'0',14057,1072,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:02',NULL,13297,'0',14059,1073,16,NULL,'cmdb2-4-4-7'),(NULL,0,'2019-11-29 22:16:02',NULL,13298,'0',14060,1073,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,13299,'0',14061,1073,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:02',NULL,13300,'0',14062,1073,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,13301,'0',14063,1073,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,13302,'0',14064,1073,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:02',NULL,13303,'0',14065,1073,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,13304,'0',14066,1073,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:02',NULL,13305,'0',14067,1073,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,13306,'0',14068,1073,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,13307,'0',14069,1073,15,NULL,'10.8.4.7'),(NULL,0,'2019-11-29 22:16:03',NULL,13308,'0',14070,1073,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,13309,'0',14071,1073,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,13310,'0',14072,1073,5,NULL,'c41f3964e68a41029c6b4207c4b63a16'),(NULL,0,'2019-11-29 22:16:03',NULL,13311,'0',14073,1073,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:03',NULL,13312,'0',14075,1074,16,NULL,'cmdb2-4-4-8'),(NULL,0,'2019-11-29 22:16:03',NULL,13313,'0',14076,1074,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,13314,'0',14077,1074,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:03',NULL,13315,'0',14078,1074,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,13316,'0',14079,1074,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,13317,'0',14080,1074,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:03',NULL,13318,'0',14081,1074,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,13319,'0',14082,1074,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:03',NULL,13320,'0',14083,1074,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,13321,'0',14084,1074,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,13322,'0',14085,1074,15,NULL,'10.8.4.8'),(NULL,0,'2019-11-29 22:16:03',NULL,13323,'0',14086,1074,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,13324,'0',14087,1074,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,13325,'0',14088,1074,5,NULL,'3b6721cac2a5470d91fa7f16829769a4'),(NULL,0,'2019-11-29 22:16:03',NULL,13326,'0',14089,1074,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:03',NULL,13327,'0',14091,1075,16,NULL,'cmdb2-4-4-9'),(NULL,0,'2019-11-29 22:16:03',NULL,13328,'0',14092,1075,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,13329,'0',14093,1075,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:03',NULL,13330,'0',14094,1075,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,13331,'0',14095,1075,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,13332,'0',14096,1075,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:03',NULL,13333,'0',14097,1075,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,13334,'0',14098,1075,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:03',NULL,13335,'0',14099,1075,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,13336,'0',14100,1075,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,13337,'0',14101,1075,15,NULL,'10.8.4.9'),(NULL,0,'2019-11-29 22:16:03',NULL,13338,'0',14102,1075,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,13339,'0',14103,1075,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,13340,'0',14104,1075,5,NULL,'21cbae733b6b47a986a6cc91935884da'),(NULL,0,'2019-11-29 22:16:03',NULL,13341,'0',14105,1075,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:03',NULL,13342,'0',14107,1076,16,NULL,'cmdb2-4-4-10'),(NULL,0,'2019-11-29 22:16:03',NULL,13343,'0',14108,1076,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,13344,'0',14109,1076,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:03',NULL,13345,'0',14110,1076,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,13346,'0',14111,1076,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,13347,'0',14112,1076,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:03',NULL,13348,'0',14113,1076,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,13349,'0',14114,1076,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:03',NULL,13350,'0',14115,1076,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,13351,'0',14116,1076,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,13352,'0',14117,1076,15,NULL,'10.8.4.10'),(NULL,0,'2019-11-29 22:16:03',NULL,13353,'0',14118,1076,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,13354,'0',14119,1076,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,13355,'0',14120,1076,5,NULL,'76fb009863ee4cbb85b6077e187386a9'),(NULL,0,'2019-11-29 22:16:03',NULL,13356,'0',14121,1076,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:03',NULL,13357,'0',14123,1077,16,NULL,'cmdb2-4-4-11'),(NULL,0,'2019-11-29 22:16:03',NULL,13358,'0',14124,1077,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,13359,'0',14125,1077,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:03',NULL,13360,'0',14126,1077,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,13361,'0',14127,1077,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,13362,'0',14128,1077,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:03',NULL,13363,'0',14129,1077,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,13364,'0',14130,1077,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:03',NULL,13365,'0',14131,1077,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,13366,'0',14132,1077,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,13367,'0',14133,1077,15,NULL,'10.8.4.11'),(NULL,0,'2019-11-29 22:16:03',NULL,13368,'0',14134,1077,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,13369,'0',14135,1077,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,13370,'0',14136,1077,5,NULL,'6c867bbbe095463088f2b5d5cb78dfad'),(NULL,0,'2019-11-29 22:16:03',NULL,13371,'0',14137,1077,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:04',NULL,13372,'0',14139,1078,16,NULL,'cmdb2-4-4-12'),(NULL,0,'2019-11-29 22:16:04',NULL,13373,'0',14140,1078,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,13374,'0',14141,1078,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:04',NULL,13375,'0',14142,1078,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,13376,'0',14143,1078,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,13377,'0',14144,1078,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:04',NULL,13378,'0',14145,1078,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,13379,'0',14146,1078,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:04',NULL,13380,'0',14147,1078,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,13381,'0',14148,1078,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,13382,'0',14149,1078,15,NULL,'10.8.4.12'),(NULL,0,'2019-11-29 22:16:04',NULL,13383,'0',14150,1078,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,13384,'0',14151,1078,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,13385,'0',14152,1078,5,NULL,'bb5dc2000f8e44089b45d6105ea43601'),(NULL,0,'2019-11-29 22:16:04',NULL,13386,'0',14153,1078,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:04',NULL,13387,'0',14155,1079,16,NULL,'cmdb2-4-4-13'),(NULL,0,'2019-11-29 22:16:04',NULL,13388,'0',14156,1079,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,13389,'0',14157,1079,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:04',NULL,13390,'0',14158,1079,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,13391,'0',14159,1079,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,13392,'0',14160,1079,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:04',NULL,13393,'0',14161,1079,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,13394,'0',14162,1079,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:04',NULL,13395,'0',14163,1079,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,13396,'0',14164,1079,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,13397,'0',14165,1079,15,NULL,'10.8.4.13'),(NULL,0,'2019-11-29 22:16:04',NULL,13398,'0',14166,1079,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,13399,'0',14167,1079,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,13400,'0',14168,1079,5,NULL,'278e04319f4041e68d5b09e05144abb2'),(NULL,0,'2019-11-29 22:16:04',NULL,13401,'0',14169,1079,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:04',NULL,13402,'0',14171,1080,16,NULL,'cmdb2-4-4-14'),(NULL,0,'2019-11-29 22:16:04',NULL,13403,'0',14172,1080,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,13404,'0',14173,1080,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:04',NULL,13405,'0',14174,1080,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,13406,'0',14175,1080,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,13407,'0',14176,1080,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:04',NULL,13408,'0',14177,1080,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,13409,'0',14178,1080,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:04',NULL,13410,'0',14179,1080,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,13411,'0',14180,1080,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,13412,'0',14181,1080,15,NULL,'10.8.4.14'),(NULL,0,'2019-11-29 22:16:04',NULL,13413,'0',14182,1080,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,13414,'0',14183,1080,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,13415,'0',14184,1080,5,NULL,'6c0f93d1b5764176a7b6542850b4690b'),(NULL,0,'2019-11-29 22:16:04',NULL,13416,'0',14185,1080,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:04',NULL,13417,'0',14187,1081,16,NULL,'cmdb2-4-4-15'),(NULL,0,'2019-11-29 22:16:04',NULL,13418,'0',14188,1081,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,13419,'0',14189,1081,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:04',NULL,13420,'0',14190,1081,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,13421,'0',14191,1081,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,13422,'0',14192,1081,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:04',NULL,13423,'0',14193,1081,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,13424,'0',14194,1081,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:04',NULL,13425,'0',14195,1081,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,13426,'0',14196,1081,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,13427,'0',14197,1081,15,NULL,'10.8.4.15'),(NULL,0,'2019-11-29 22:16:04',NULL,13428,'0',14198,1081,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,13429,'0',14199,1081,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,13430,'0',14200,1081,5,NULL,'cbce35ad727748f497638bfd10ee34d0'),(NULL,0,'2019-11-29 22:16:04',NULL,13431,'0',14201,1081,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:04',NULL,13432,'0',14203,1082,16,NULL,'cmdb2-4-4-16'),(NULL,0,'2019-11-29 22:16:04',NULL,13433,'0',14204,1082,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,13434,'0',14205,1082,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:04',NULL,13435,'0',14206,1082,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,13436,'0',14207,1082,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,13437,'0',14208,1082,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:05',NULL,13438,'0',14209,1082,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,13439,'0',14210,1082,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:05',NULL,13440,'0',14211,1082,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,13441,'0',14212,1082,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,13442,'0',14213,1082,15,NULL,'10.8.4.16'),(NULL,0,'2019-11-29 22:16:05',NULL,13443,'0',14214,1082,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,13444,'0',14215,1082,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,13445,'0',14216,1082,5,NULL,'63e9b83658f7424392b6cc4a2311c26c'),(NULL,0,'2019-11-29 22:16:05',NULL,13446,'0',14217,1082,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:05',NULL,13447,'0',14219,1083,4,NULL,'App2-4-5'),(NULL,0,'2019-11-29 22:16:05',NULL,13448,'0',14221,1084,16,NULL,'cmdb2-4-5-1'),(NULL,0,'2019-11-29 22:16:05',NULL,13449,'0',14222,1084,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,13450,'0',14223,1084,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:05',NULL,13451,'0',14224,1084,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,13452,'0',14225,1084,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,13453,'0',14226,1084,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:05',NULL,13454,'0',14227,1084,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,13455,'0',14228,1084,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:05',NULL,13456,'0',14229,1084,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,13457,'0',14230,1084,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,13458,'0',14231,1084,15,NULL,'10.8.5.1'),(NULL,0,'2019-11-29 22:16:05',NULL,13459,'0',14232,1084,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,13460,'0',14233,1084,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,13461,'0',14234,1084,5,NULL,'e4cf22096b784c509cc0e68c567c37bb'),(NULL,0,'2019-11-29 22:16:05',NULL,13462,'0',14235,1084,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:05',NULL,13463,'0',14237,1085,16,NULL,'cmdb2-4-5-2'),(NULL,0,'2019-11-29 22:16:05',NULL,13464,'0',14238,1085,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,13465,'0',14239,1085,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:05',NULL,13466,'0',14240,1085,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,13467,'0',14241,1085,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,13468,'0',14242,1085,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:05',NULL,13469,'0',14243,1085,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,13470,'0',14244,1085,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:05',NULL,13471,'0',14245,1085,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,13472,'0',14246,1085,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,13473,'0',14247,1085,15,NULL,'10.8.5.2'),(NULL,0,'2019-11-29 22:16:05',NULL,13474,'0',14248,1085,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,13475,'0',14249,1085,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,13476,'0',14250,1085,5,NULL,'67bde2d1157b463d95e4e45a65667afa'),(NULL,0,'2019-11-29 22:16:05',NULL,13477,'0',14251,1085,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:05',NULL,13478,'0',14253,1086,16,NULL,'cmdb2-4-5-3'),(NULL,0,'2019-11-29 22:16:05',NULL,13479,'0',14254,1086,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,13480,'0',14255,1086,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:05',NULL,13481,'0',14256,1086,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,13482,'0',14257,1086,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,13483,'0',14258,1086,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:05',NULL,13484,'0',14259,1086,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,13485,'0',14260,1086,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:05',NULL,13486,'0',14261,1086,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,13487,'0',14262,1086,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,13488,'0',14263,1086,15,NULL,'10.8.5.3'),(NULL,0,'2019-11-29 22:16:05',NULL,13489,'0',14264,1086,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,13490,'0',14265,1086,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,13491,'0',14266,1086,5,NULL,'2fe4fec4bb664eb4b75339d97e802036'),(NULL,0,'2019-11-29 22:16:05',NULL,13492,'0',14267,1086,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:05',NULL,13493,'0',14269,1087,16,NULL,'cmdb2-4-5-4'),(NULL,0,'2019-11-29 22:16:05',NULL,13494,'0',14270,1087,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,13495,'0',14271,1087,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:05',NULL,13496,'0',14272,1087,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,13497,'0',14273,1087,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,13498,'0',14274,1087,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:05',NULL,13499,'0',14275,1087,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,13500,'0',14276,1087,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:06',NULL,13501,'0',14277,1087,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,13502,'0',14278,1087,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,13503,'0',14279,1087,15,NULL,'10.8.5.4'),(NULL,0,'2019-11-29 22:16:06',NULL,13504,'0',14280,1087,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,13505,'0',14281,1087,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,13506,'0',14282,1087,5,NULL,'0286ccae8bb244c1b96240641455b6d4'),(NULL,0,'2019-11-29 22:16:06',NULL,13507,'0',14283,1087,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:06',NULL,13508,'0',14285,1088,16,NULL,'cmdb2-4-5-5'),(NULL,0,'2019-11-29 22:16:06',NULL,13509,'0',14286,1088,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,13510,'0',14287,1088,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:06',NULL,13511,'0',14288,1088,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,13512,'0',14289,1088,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,13513,'0',14290,1088,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:06',NULL,13514,'0',14291,1088,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,13515,'0',14292,1088,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:06',NULL,13516,'0',14293,1088,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,13517,'0',14294,1088,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,13518,'0',14295,1088,15,NULL,'10.8.5.5'),(NULL,0,'2019-11-29 22:16:06',NULL,13519,'0',14296,1088,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,13520,'0',14297,1088,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,13521,'0',14298,1088,5,NULL,'0f3fcd0c6b414e7d9fb0e428e519a568'),(NULL,0,'2019-11-29 22:16:06',NULL,13522,'0',14299,1088,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:06',NULL,13523,'0',14301,1089,16,NULL,'cmdb2-4-5-6'),(NULL,0,'2019-11-29 22:16:06',NULL,13524,'0',14302,1089,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,13525,'0',14303,1089,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:06',NULL,13526,'0',14304,1089,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,13527,'0',14305,1089,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,13528,'0',14306,1089,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:06',NULL,13529,'0',14307,1089,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,13530,'0',14308,1089,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:06',NULL,13531,'0',14309,1089,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,13532,'0',14310,1089,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,13533,'0',14311,1089,15,NULL,'10.8.5.6'),(NULL,0,'2019-11-29 22:16:06',NULL,13534,'0',14312,1089,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,13535,'0',14313,1089,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,13536,'0',14314,1089,5,NULL,'545b72645d6742c9b37c95132fc69b3d'),(NULL,0,'2019-11-29 22:16:06',NULL,13537,'0',14315,1089,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:06',NULL,13538,'0',14317,1090,16,NULL,'cmdb2-4-5-7'),(NULL,0,'2019-11-29 22:16:06',NULL,13539,'0',14318,1090,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,13540,'0',14319,1090,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:06',NULL,13541,'0',14320,1090,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,13542,'0',14321,1090,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,13543,'0',14322,1090,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:06',NULL,13544,'0',14323,1090,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,13545,'0',14324,1090,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:06',NULL,13546,'0',14325,1090,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,13547,'0',14326,1090,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,13548,'0',14327,1090,15,NULL,'10.8.5.7'),(NULL,0,'2019-11-29 22:16:06',NULL,13549,'0',14328,1090,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,13550,'0',14329,1090,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,13551,'0',14330,1090,5,NULL,'c4cf4d4a6851421986175c59d5aac9ad'),(NULL,0,'2019-11-29 22:16:06',NULL,13552,'0',14331,1090,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:06',NULL,13553,'0',14333,1091,16,NULL,'cmdb2-4-5-8'),(NULL,0,'2019-11-29 22:16:06',NULL,13554,'0',14334,1091,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,13555,'0',14335,1091,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:06',NULL,13556,'0',14336,1091,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,13557,'0',14337,1091,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,13558,'0',14338,1091,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:06',NULL,13559,'0',14339,1091,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,13560,'0',14340,1091,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:06',NULL,13561,'0',14341,1091,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,13562,'0',14342,1091,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,13563,'0',14343,1091,15,NULL,'10.8.5.8'),(NULL,0,'2019-11-29 22:16:06',NULL,13564,'0',14344,1091,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,13565,'0',14345,1091,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,13566,'0',14346,1091,5,NULL,'878bd43fc0c24c149d8bf76e4dc39256'),(NULL,0,'2019-11-29 22:16:07',NULL,13567,'0',14347,1091,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:07',NULL,13568,'0',14349,1092,16,NULL,'cmdb2-4-5-9'),(NULL,0,'2019-11-29 22:16:07',NULL,13569,'0',14350,1092,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,13570,'0',14351,1092,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:07',NULL,13571,'0',14352,1092,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,13572,'0',14353,1092,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,13573,'0',14354,1092,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:07',NULL,13574,'0',14355,1092,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,13575,'0',14356,1092,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:07',NULL,13576,'0',14357,1092,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,13577,'0',14358,1092,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,13578,'0',14359,1092,15,NULL,'10.8.5.9'),(NULL,0,'2019-11-29 22:16:07',NULL,13579,'0',14360,1092,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,13580,'0',14361,1092,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,13581,'0',14362,1092,5,NULL,'83a2a83ed6714288b941809540f3bebb'),(NULL,0,'2019-11-29 22:16:07',NULL,13582,'0',14363,1092,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:07',NULL,13583,'0',14365,1093,16,NULL,'cmdb2-4-5-10'),(NULL,0,'2019-11-29 22:16:07',NULL,13584,'0',14366,1093,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,13585,'0',14367,1093,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:07',NULL,13586,'0',14368,1093,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,13587,'0',14369,1093,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,13588,'0',14370,1093,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:07',NULL,13589,'0',14371,1093,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,13590,'0',14372,1093,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:07',NULL,13591,'0',14373,1093,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,13592,'0',14374,1093,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,13593,'0',14375,1093,15,NULL,'10.8.5.10'),(NULL,0,'2019-11-29 22:16:07',NULL,13594,'0',14376,1093,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,13595,'0',14377,1093,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,13596,'0',14378,1093,5,NULL,'55d77047d6de4132b6c7c3673fcdd542'),(NULL,0,'2019-11-29 22:16:07',NULL,13597,'0',14379,1093,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:07',NULL,13598,'0',14381,1094,16,NULL,'cmdb2-4-5-11'),(NULL,0,'2019-11-29 22:16:07',NULL,13599,'0',14382,1094,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,13600,'0',14383,1094,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:07',NULL,13601,'0',14384,1094,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,13602,'0',14385,1094,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,13603,'0',14386,1094,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:07',NULL,13604,'0',14387,1094,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,13605,'0',14388,1094,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:07',NULL,13606,'0',14389,1094,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,13607,'0',14390,1094,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,13608,'0',14391,1094,15,NULL,'10.8.5.11'),(NULL,0,'2019-11-29 22:16:07',NULL,13609,'0',14392,1094,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,13610,'0',14393,1094,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,13611,'0',14394,1094,5,NULL,'10d8605049174d7982da8b835d692cd9'),(NULL,0,'2019-11-29 22:16:07',NULL,13612,'0',14395,1094,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:07',NULL,13613,'0',14397,1095,16,NULL,'cmdb2-4-5-12'),(NULL,0,'2019-11-29 22:16:07',NULL,13614,'0',14398,1095,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,13615,'0',14399,1095,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:07',NULL,13616,'0',14400,1095,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,13617,'0',14401,1095,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,13618,'0',14402,1095,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:07',NULL,13619,'0',14403,1095,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,13620,'0',14404,1095,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:07',NULL,13621,'0',14405,1095,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,13622,'0',14406,1095,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,13623,'0',14407,1095,15,NULL,'10.8.5.12'),(NULL,0,'2019-11-29 22:16:07',NULL,13624,'0',14408,1095,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,13625,'0',14409,1095,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,13626,'0',14410,1095,5,NULL,'8ea3dad88e36472fbe1b2b2a8af50a7a'),(NULL,0,'2019-11-29 22:16:07',NULL,13627,'0',14411,1095,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:07',NULL,13628,'0',14413,1096,16,NULL,'cmdb2-4-5-13'),(NULL,0,'2019-11-29 22:16:08',NULL,13629,'0',14414,1096,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,13630,'0',14415,1096,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:08',NULL,13631,'0',14416,1096,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,13632,'0',14417,1096,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,13633,'0',14418,1096,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:08',NULL,13634,'0',14419,1096,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,13635,'0',14420,1096,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:08',NULL,13636,'0',14421,1096,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,13637,'0',14422,1096,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,13638,'0',14423,1096,15,NULL,'10.8.5.13'),(NULL,0,'2019-11-29 22:16:08',NULL,13639,'0',14424,1096,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,13640,'0',14425,1096,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,13641,'0',14426,1096,5,NULL,'58086836b5c5485aa7001333c654e26e'),(NULL,0,'2019-11-29 22:16:08',NULL,13642,'0',14427,1096,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:08',NULL,13643,'0',14429,1097,16,NULL,'cmdb2-4-5-14'),(NULL,0,'2019-11-29 22:16:08',NULL,13644,'0',14430,1097,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,13645,'0',14431,1097,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:08',NULL,13646,'0',14432,1097,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,13647,'0',14433,1097,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,13648,'0',14434,1097,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:08',NULL,13649,'0',14435,1097,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,13650,'0',14436,1097,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:08',NULL,13651,'0',14437,1097,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,13652,'0',14438,1097,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,13653,'0',14439,1097,15,NULL,'10.8.5.14'),(NULL,0,'2019-11-29 22:16:08',NULL,13654,'0',14440,1097,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,13655,'0',14441,1097,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,13656,'0',14442,1097,5,NULL,'6cf1733cec2f4ab4ad27ce49dce1bbd3'),(NULL,0,'2019-11-29 22:16:08',NULL,13657,'0',14443,1097,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:08',NULL,13658,'0',14445,1098,16,NULL,'cmdb2-4-5-15'),(NULL,0,'2019-11-29 22:16:08',NULL,13659,'0',14446,1098,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,13660,'0',14447,1098,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:08',NULL,13661,'0',14448,1098,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,13662,'0',14449,1098,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,13663,'0',14450,1098,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:08',NULL,13664,'0',14451,1098,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,13665,'0',14452,1098,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:08',NULL,13666,'0',14453,1098,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,13667,'0',14454,1098,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,13668,'0',14455,1098,15,NULL,'10.8.5.15'),(NULL,0,'2019-11-29 22:16:08',NULL,13669,'0',14456,1098,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,13670,'0',14457,1098,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,13671,'0',14458,1098,5,NULL,'40371cc58b1349d5853dcc697f881f0b'),(NULL,0,'2019-11-29 22:16:08',NULL,13672,'0',14459,1098,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:08',NULL,13673,'0',14461,1099,16,NULL,'cmdb2-4-5-16'),(NULL,0,'2019-11-29 22:16:08',NULL,13674,'0',14462,1099,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,13675,'0',14463,1099,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:08',NULL,13676,'0',14464,1099,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,13677,'0',14465,1099,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,13678,'0',14466,1099,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:08',NULL,13679,'0',14467,1099,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,13680,'0',14468,1099,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:08',NULL,13681,'0',14469,1099,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,13682,'0',14470,1099,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,13683,'0',14471,1099,15,NULL,'10.8.5.16'),(NULL,0,'2019-11-29 22:16:08',NULL,13684,'0',14472,1099,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,13685,'0',14473,1099,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,13686,'0',14474,1099,5,NULL,'d95139398a674f22b2609f423d246e2a'),(NULL,0,'2019-11-29 22:16:08',NULL,13687,'0',14475,1099,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:08',NULL,13688,'0',14477,1100,4,NULL,'App2-4-6'),(NULL,0,'2019-11-29 22:16:08',NULL,13689,'0',14479,1101,16,NULL,'cmdb2-4-6-1'),(NULL,0,'2019-11-29 22:16:08',NULL,13690,'0',14480,1101,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,13691,'0',14481,1101,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:09',NULL,13692,'0',14482,1101,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,13693,'0',14483,1101,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,13694,'0',14484,1101,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:09',NULL,13695,'0',14485,1101,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,13696,'0',14486,1101,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:09',NULL,13697,'0',14487,1101,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,13698,'0',14488,1101,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,13699,'0',14489,1101,15,NULL,'10.8.6.1'),(NULL,0,'2019-11-29 22:16:09',NULL,13700,'0',14490,1101,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,13701,'0',14491,1101,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,13702,'0',14492,1101,5,NULL,'ca3745dbe791458fa6ca8f63c3c6e9a2'),(NULL,0,'2019-11-29 22:16:09',NULL,13703,'0',14493,1101,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:09',NULL,13704,'0',14495,1102,16,NULL,'cmdb2-4-6-2'),(NULL,0,'2019-11-29 22:16:09',NULL,13705,'0',14496,1102,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,13706,'0',14497,1102,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:09',NULL,13707,'0',14498,1102,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,13708,'0',14499,1102,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,13709,'0',14500,1102,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:09',NULL,13710,'0',14501,1102,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,13711,'0',14502,1102,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:09',NULL,13712,'0',14503,1102,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,13713,'0',14504,1102,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,13714,'0',14505,1102,15,NULL,'10.8.6.2'),(NULL,0,'2019-11-29 22:16:09',NULL,13715,'0',14506,1102,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,13716,'0',14507,1102,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,13717,'0',14508,1102,5,NULL,'1db34cf74fbf40c2a4bf21db880ae298'),(NULL,0,'2019-11-29 22:16:09',NULL,13718,'0',14509,1102,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:09',NULL,13719,'0',14511,1103,16,NULL,'cmdb2-4-6-3'),(NULL,0,'2019-11-29 22:16:09',NULL,13720,'0',14512,1103,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,13721,'0',14513,1103,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:09',NULL,13722,'0',14514,1103,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,13723,'0',14515,1103,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,13724,'0',14516,1103,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:09',NULL,13725,'0',14517,1103,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,13726,'0',14518,1103,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:09',NULL,13727,'0',14519,1103,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,13728,'0',14520,1103,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,13729,'0',14521,1103,15,NULL,'10.8.6.3'),(NULL,0,'2019-11-29 22:16:09',NULL,13730,'0',14522,1103,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,13731,'0',14523,1103,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,13732,'0',14524,1103,5,NULL,'ec216c8a298249818d4e835880716aa5'),(NULL,0,'2019-11-29 22:16:09',NULL,13733,'0',14525,1103,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:09',NULL,13734,'0',14527,1104,16,NULL,'cmdb2-4-6-4'),(NULL,0,'2019-11-29 22:16:09',NULL,13735,'0',14528,1104,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,13736,'0',14529,1104,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:09',NULL,13737,'0',14530,1104,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,13738,'0',14531,1104,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,13739,'0',14532,1104,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:09',NULL,13740,'0',14533,1104,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,13741,'0',14534,1104,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:09',NULL,13742,'0',14535,1104,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,13743,'0',14536,1104,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,13744,'0',14537,1104,15,NULL,'10.8.6.4'),(NULL,0,'2019-11-29 22:16:09',NULL,13745,'0',14538,1104,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,13746,'0',14539,1104,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,13747,'0',14540,1104,5,NULL,'5b443248e53745c2b4c92f7b59ca5618'),(NULL,0,'2019-11-29 22:16:09',NULL,13748,'0',14541,1104,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:09',NULL,13749,'0',14543,1105,16,NULL,'cmdb2-4-6-5'),(NULL,0,'2019-11-29 22:16:09',NULL,13750,'0',14544,1105,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,13751,'0',14545,1105,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:09',NULL,13752,'0',14546,1105,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,13753,'0',14547,1105,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,13754,'0',14548,1105,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:09',NULL,13755,'0',14549,1105,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,13756,'0',14550,1105,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:09',NULL,13757,'0',14551,1105,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,13758,'0',14552,1105,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,13759,'0',14553,1105,15,NULL,'10.8.6.5'),(NULL,0,'2019-11-29 22:16:10',NULL,13760,'0',14554,1105,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,13761,'0',14555,1105,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,13762,'0',14556,1105,5,NULL,'dea7a2a2958a42df9ee5e3c8afabe60b'),(NULL,0,'2019-11-29 22:16:10',NULL,13763,'0',14557,1105,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:10',NULL,13764,'0',14559,1106,16,NULL,'cmdb2-4-6-6'),(NULL,0,'2019-11-29 22:16:10',NULL,13765,'0',14560,1106,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,13766,'0',14561,1106,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:10',NULL,13767,'0',14562,1106,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,13768,'0',14563,1106,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,13769,'0',14564,1106,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:10',NULL,13770,'0',14565,1106,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,13771,'0',14566,1106,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:10',NULL,13772,'0',14567,1106,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,13773,'0',14568,1106,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,13774,'0',14569,1106,15,NULL,'10.8.6.6'),(NULL,0,'2019-11-29 22:16:10',NULL,13775,'0',14570,1106,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,13776,'0',14571,1106,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,13777,'0',14572,1106,5,NULL,'f4e09fc345274b75ba762ac68e2ec005'),(NULL,0,'2019-11-29 22:16:10',NULL,13778,'0',14573,1106,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:10',NULL,13779,'0',14575,1107,16,NULL,'cmdb2-4-6-7'),(NULL,0,'2019-11-29 22:16:10',NULL,13780,'0',14576,1107,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,13781,'0',14577,1107,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:10',NULL,13782,'0',14578,1107,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,13783,'0',14579,1107,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,13784,'0',14580,1107,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:10',NULL,13785,'0',14581,1107,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,13786,'0',14582,1107,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:10',NULL,13787,'0',14583,1107,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,13788,'0',14584,1107,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,13789,'0',14585,1107,15,NULL,'10.8.6.7'),(NULL,0,'2019-11-29 22:16:10',NULL,13790,'0',14586,1107,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,13791,'0',14587,1107,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,13792,'0',14588,1107,5,NULL,'191cae6e64274448b7c063e41959d7b3'),(NULL,0,'2019-11-29 22:16:10',NULL,13793,'0',14589,1107,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:10',NULL,13794,'0',14591,1108,16,NULL,'cmdb2-4-6-8'),(NULL,0,'2019-11-29 22:16:10',NULL,13795,'0',14592,1108,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,13796,'0',14593,1108,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:10',NULL,13797,'0',14594,1108,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,13798,'0',14595,1108,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,13799,'0',14596,1108,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:10',NULL,13800,'0',14597,1108,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,13801,'0',14598,1108,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:10',NULL,13802,'0',14599,1108,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,13803,'0',14600,1108,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,13804,'0',14601,1108,15,NULL,'10.8.6.8'),(NULL,0,'2019-11-29 22:16:10',NULL,13805,'0',14602,1108,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,13806,'0',14603,1108,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,13807,'0',14604,1108,5,NULL,'4d7a27300cc340fabdbdd56d2469e698'),(NULL,0,'2019-11-29 22:16:10',NULL,13808,'0',14605,1108,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:10',NULL,13809,'0',14607,1109,16,NULL,'cmdb2-4-6-9'),(NULL,0,'2019-11-29 22:16:10',NULL,13810,'0',14608,1109,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,13811,'0',14609,1109,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:10',NULL,13812,'0',14610,1109,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,13813,'0',14611,1109,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,13814,'0',14612,1109,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:10',NULL,13815,'0',14613,1109,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,13816,'0',14614,1109,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:10',NULL,13817,'0',14615,1109,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,13818,'0',14616,1109,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,13819,'0',14617,1109,15,NULL,'10.8.6.9'),(NULL,0,'2019-11-29 22:16:10',NULL,13820,'0',14618,1109,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,13821,'0',14619,1109,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,13822,'0',14620,1109,5,NULL,'bea738516ad747529b8f40b068646664'),(NULL,0,'2019-11-29 22:16:10',NULL,13823,'0',14621,1109,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:11',NULL,13824,'0',14623,1110,16,NULL,'cmdb2-4-6-10'),(NULL,0,'2019-11-29 22:16:11',NULL,13825,'0',14624,1110,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,13826,'0',14625,1110,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:11',NULL,13827,'0',14626,1110,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,13828,'0',14627,1110,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,13829,'0',14628,1110,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:11',NULL,13830,'0',14629,1110,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,13831,'0',14630,1110,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:11',NULL,13832,'0',14631,1110,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,13833,'0',14632,1110,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,13834,'0',14633,1110,15,NULL,'10.8.6.10'),(NULL,0,'2019-11-29 22:16:11',NULL,13835,'0',14634,1110,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,13836,'0',14635,1110,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,13837,'0',14636,1110,5,NULL,'9d09f592d3a746c6ba6c0b10951dba73'),(NULL,0,'2019-11-29 22:16:11',NULL,13838,'0',14637,1110,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:11',NULL,13839,'0',14639,1111,16,NULL,'cmdb2-4-6-11'),(NULL,0,'2019-11-29 22:16:11',NULL,13840,'0',14640,1111,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,13841,'0',14641,1111,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:11',NULL,13842,'0',14642,1111,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,13843,'0',14643,1111,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,13844,'0',14644,1111,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:11',NULL,13845,'0',14645,1111,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,13846,'0',14646,1111,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:11',NULL,13847,'0',14647,1111,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,13848,'0',14648,1111,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,13849,'0',14649,1111,15,NULL,'10.8.6.11'),(NULL,0,'2019-11-29 22:16:11',NULL,13850,'0',14650,1111,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,13851,'0',14651,1111,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,13852,'0',14652,1111,5,NULL,'87691d8dd1cc4158ba613e53a16dbaae'),(NULL,0,'2019-11-29 22:16:11',NULL,13853,'0',14653,1111,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:11',NULL,13854,'0',14655,1112,16,NULL,'cmdb2-4-6-12'),(NULL,0,'2019-11-29 22:16:11',NULL,13855,'0',14656,1112,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,13856,'0',14657,1112,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:11',NULL,13857,'0',14658,1112,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,13858,'0',14659,1112,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,13859,'0',14660,1112,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:11',NULL,13860,'0',14661,1112,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,13861,'0',14662,1112,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:11',NULL,13862,'0',14663,1112,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,13863,'0',14664,1112,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,13864,'0',14665,1112,15,NULL,'10.8.6.12'),(NULL,0,'2019-11-29 22:16:11',NULL,13865,'0',14666,1112,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,13866,'0',14667,1112,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,13867,'0',14668,1112,5,NULL,'cb71f77be4574bc6ab9c6077ac9451db'),(NULL,0,'2019-11-29 22:16:11',NULL,13868,'0',14669,1112,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:11',NULL,13869,'0',14671,1113,16,NULL,'cmdb2-4-6-13'),(NULL,0,'2019-11-29 22:16:11',NULL,13870,'0',14672,1113,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,13871,'0',14673,1113,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:11',NULL,13872,'0',14674,1113,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,13873,'0',14675,1113,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,13874,'0',14676,1113,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:11',NULL,13875,'0',14677,1113,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,13876,'0',14678,1113,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:11',NULL,13877,'0',14679,1113,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,13878,'0',14680,1113,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,13879,'0',14681,1113,15,NULL,'10.8.6.13'),(NULL,0,'2019-11-29 22:16:11',NULL,13880,'0',14682,1113,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,13881,'0',14683,1113,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,13882,'0',14684,1113,5,NULL,'f9585471285e4a668a34202c97a26b93'),(NULL,0,'2019-11-29 22:16:11',NULL,13883,'0',14685,1113,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:11',NULL,13884,'0',14687,1114,16,NULL,'cmdb2-4-6-14'),(NULL,0,'2019-11-29 22:16:11',NULL,13885,'0',14688,1114,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,13886,'0',14689,1114,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:11',NULL,13887,'0',14690,1114,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,13888,'0',14691,1114,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,13889,'0',14692,1114,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:12',NULL,13890,'0',14693,1114,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,13891,'0',14694,1114,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:12',NULL,13892,'0',14695,1114,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,13893,'0',14696,1114,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,13894,'0',14697,1114,15,NULL,'10.8.6.14'),(NULL,0,'2019-11-29 22:16:12',NULL,13895,'0',14698,1114,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,13896,'0',14699,1114,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,13897,'0',14700,1114,5,NULL,'d5cf07efe1f44ab18e18d0f48aeefdad'),(NULL,0,'2019-11-29 22:16:12',NULL,13898,'0',14701,1114,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:12',NULL,13899,'0',14703,1115,16,NULL,'cmdb2-4-6-15'),(NULL,0,'2019-11-29 22:16:12',NULL,13900,'0',14704,1115,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,13901,'0',14705,1115,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:12',NULL,13902,'0',14706,1115,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,13903,'0',14707,1115,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,13904,'0',14708,1115,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:12',NULL,13905,'0',14709,1115,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,13906,'0',14710,1115,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:12',NULL,13907,'0',14711,1115,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,13908,'0',14712,1115,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,13909,'0',14713,1115,15,NULL,'10.8.6.15'),(NULL,0,'2019-11-29 22:16:12',NULL,13910,'0',14714,1115,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,13911,'0',14715,1115,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,13912,'0',14716,1115,5,NULL,'232c0bde5bc64f46baaf7ee512e4df92'),(NULL,0,'2019-11-29 22:16:12',NULL,13913,'0',14717,1115,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:12',NULL,13914,'0',14719,1116,16,NULL,'cmdb2-4-6-16'),(NULL,0,'2019-11-29 22:16:12',NULL,13915,'0',14720,1116,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,13916,'0',14721,1116,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:12',NULL,13917,'0',14722,1116,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,13918,'0',14723,1116,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,13919,'0',14724,1116,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:12',NULL,13920,'0',14725,1116,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,13921,'0',14726,1116,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:12',NULL,13922,'0',14727,1116,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,13923,'0',14728,1116,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,13924,'0',14729,1116,15,NULL,'10.8.6.16'),(NULL,0,'2019-11-29 22:16:12',NULL,13925,'0',14730,1116,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,13926,'0',14731,1116,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,13927,'0',14732,1116,5,NULL,'e76020b4a82f40a9bbfe49683e4d0f13'),(NULL,0,'2019-11-29 22:16:12',NULL,13928,'0',14733,1116,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:12',NULL,13929,'0',14735,1117,4,NULL,'App2-4-7'),(NULL,0,'2019-11-29 22:16:12',NULL,13930,'0',14737,1118,16,NULL,'cmdb2-4-7-1'),(NULL,0,'2019-11-29 22:16:12',NULL,13931,'0',14738,1118,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,13932,'0',14739,1118,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:12',NULL,13933,'0',14740,1118,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,13934,'0',14741,1118,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,13935,'0',14742,1118,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:12',NULL,13936,'0',14743,1118,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,13937,'0',14744,1118,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:12',NULL,13938,'0',14745,1118,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,13939,'0',14746,1118,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,13940,'0',14747,1118,15,NULL,'10.8.7.1'),(NULL,0,'2019-11-29 22:16:12',NULL,13941,'0',14748,1118,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,13942,'0',14749,1118,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,13943,'0',14750,1118,5,NULL,'f91216b43bfe4946b8c0aa7cc7967b1f'),(NULL,0,'2019-11-29 22:16:12',NULL,13944,'0',14751,1118,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:12',NULL,13945,'0',14753,1119,16,NULL,'cmdb2-4-7-2'),(NULL,0,'2019-11-29 22:16:12',NULL,13946,'0',14754,1119,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,13947,'0',14755,1119,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:13',NULL,13948,'0',14756,1119,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,13949,'0',14757,1119,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,13950,'0',14758,1119,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:13',NULL,13951,'0',14759,1119,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,13952,'0',14760,1119,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:13',NULL,13953,'0',14761,1119,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,13954,'0',14762,1119,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,13955,'0',14763,1119,15,NULL,'10.8.7.2'),(NULL,0,'2019-11-29 22:16:13',NULL,13956,'0',14764,1119,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,13957,'0',14765,1119,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,13958,'0',14766,1119,5,NULL,'aacc0c2e051f4fbda8366890d48c3976'),(NULL,0,'2019-11-29 22:16:13',NULL,13959,'0',14767,1119,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:13',NULL,13960,'0',14769,1120,16,NULL,'cmdb2-4-7-3'),(NULL,0,'2019-11-29 22:16:13',NULL,13961,'0',14770,1120,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,13962,'0',14771,1120,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:13',NULL,13963,'0',14772,1120,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,13964,'0',14773,1120,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,13965,'0',14774,1120,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:13',NULL,13966,'0',14775,1120,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,13967,'0',14776,1120,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:13',NULL,13968,'0',14777,1120,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,13969,'0',14778,1120,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,13970,'0',14779,1120,15,NULL,'10.8.7.3'),(NULL,0,'2019-11-29 22:16:13',NULL,13971,'0',14780,1120,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,13972,'0',14781,1120,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,13973,'0',14782,1120,5,NULL,'ca5c56dc48b442e4b49b5280e56f3afe'),(NULL,0,'2019-11-29 22:16:13',NULL,13974,'0',14783,1120,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:13',NULL,13975,'0',14785,1121,16,NULL,'cmdb2-4-7-4'),(NULL,0,'2019-11-29 22:16:13',NULL,13976,'0',14786,1121,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,13977,'0',14787,1121,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:13',NULL,13978,'0',14788,1121,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,13979,'0',14789,1121,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,13980,'0',14790,1121,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:13',NULL,13981,'0',14791,1121,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,13982,'0',14792,1121,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:13',NULL,13983,'0',14793,1121,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,13984,'0',14794,1121,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,13985,'0',14795,1121,15,NULL,'10.8.7.4'),(NULL,0,'2019-11-29 22:16:13',NULL,13986,'0',14796,1121,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,13987,'0',14797,1121,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,13988,'0',14798,1121,5,NULL,'f7f2c3d8a2a9417b824e935e8badd575'),(NULL,0,'2019-11-29 22:16:13',NULL,13989,'0',14799,1121,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:13',NULL,13990,'0',14801,1122,16,NULL,'cmdb2-4-7-5'),(NULL,0,'2019-11-29 22:16:13',NULL,13991,'0',14802,1122,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,13992,'0',14803,1122,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:13',NULL,13993,'0',14804,1122,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,13994,'0',14805,1122,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,13995,'0',14806,1122,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:13',NULL,13996,'0',14807,1122,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,13997,'0',14808,1122,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:13',NULL,13998,'0',14809,1122,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,13999,'0',14810,1122,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,14000,'0',14811,1122,15,NULL,'10.8.7.5'),(NULL,0,'2019-11-29 22:16:13',NULL,14001,'0',14812,1122,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,14002,'0',14813,1122,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,14003,'0',14814,1122,5,NULL,'1eb0746578644fcab6fb2214fc255249'),(NULL,0,'2019-11-29 22:16:13',NULL,14004,'0',14815,1122,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:13',NULL,14005,'0',14817,1123,16,NULL,'cmdb2-4-7-6'),(NULL,0,'2019-11-29 22:16:13',NULL,14006,'0',14818,1123,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,14007,'0',14819,1123,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:13',NULL,14008,'0',14820,1123,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,14009,'0',14821,1123,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,14010,'0',14822,1123,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:13',NULL,14011,'0',14823,1123,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,14012,'0',14824,1123,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:13',NULL,14013,'0',14825,1123,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,14014,'0',14826,1123,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,14015,'0',14827,1123,15,NULL,'10.8.7.6'),(NULL,0,'2019-11-29 22:16:14',NULL,14016,'0',14828,1123,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,14017,'0',14829,1123,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,14018,'0',14830,1123,5,NULL,'7af2a91c08d9499585954f0594ad1c00'),(NULL,0,'2019-11-29 22:16:14',NULL,14019,'0',14831,1123,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:14',NULL,14020,'0',14833,1124,16,NULL,'cmdb2-4-7-7'),(NULL,0,'2019-11-29 22:16:14',NULL,14021,'0',14834,1124,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,14022,'0',14835,1124,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:14',NULL,14023,'0',14836,1124,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,14024,'0',14837,1124,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,14025,'0',14838,1124,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:14',NULL,14026,'0',14839,1124,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,14027,'0',14840,1124,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:14',NULL,14028,'0',14841,1124,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,14029,'0',14842,1124,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,14030,'0',14843,1124,15,NULL,'10.8.7.7'),(NULL,0,'2019-11-29 22:16:14',NULL,14031,'0',14844,1124,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,14032,'0',14845,1124,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,14033,'0',14846,1124,5,NULL,'3ffe383a556847568e13de7a553abaf0'),(NULL,0,'2019-11-29 22:16:14',NULL,14034,'0',14847,1124,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:14',NULL,14035,'0',14849,1125,16,NULL,'cmdb2-4-7-8'),(NULL,0,'2019-11-29 22:16:14',NULL,14036,'0',14850,1125,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,14037,'0',14851,1125,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:14',NULL,14038,'0',14852,1125,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,14039,'0',14853,1125,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,14040,'0',14854,1125,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:14',NULL,14041,'0',14855,1125,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,14042,'0',14856,1125,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:14',NULL,14043,'0',14857,1125,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,14044,'0',14858,1125,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,14045,'0',14859,1125,15,NULL,'10.8.7.8'),(NULL,0,'2019-11-29 22:16:14',NULL,14046,'0',14860,1125,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,14047,'0',14861,1125,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,14048,'0',14862,1125,5,NULL,'0a4a8273537f480cbc7c35526a121f79'),(NULL,0,'2019-11-29 22:16:14',NULL,14049,'0',14863,1125,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:14',NULL,14050,'0',14865,1126,16,NULL,'cmdb2-4-7-9'),(NULL,0,'2019-11-29 22:16:14',NULL,14051,'0',14866,1126,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,14052,'0',14867,1126,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:14',NULL,14053,'0',14868,1126,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,14054,'0',14869,1126,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,14055,'0',14870,1126,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:14',NULL,14056,'0',14871,1126,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,14057,'0',14872,1126,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:14',NULL,14058,'0',14873,1126,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,14059,'0',14874,1126,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,14060,'0',14875,1126,15,NULL,'10.8.7.9'),(NULL,0,'2019-11-29 22:16:14',NULL,14061,'0',14876,1126,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,14062,'0',14877,1126,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,14063,'0',14878,1126,5,NULL,'6518467515a24cdea0d64e9691304fce'),(NULL,0,'2019-11-29 22:16:14',NULL,14064,'0',14879,1126,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:14',NULL,14065,'0',14881,1127,16,NULL,'cmdb2-4-7-10'),(NULL,0,'2019-11-29 22:16:14',NULL,14066,'0',14882,1127,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,14067,'0',14883,1127,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:14',NULL,14068,'0',14884,1127,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,14069,'0',14885,1127,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,14070,'0',14886,1127,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:14',NULL,14071,'0',14887,1127,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,14072,'0',14888,1127,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:14',NULL,14073,'0',14889,1127,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,14074,'0',14890,1127,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,14075,'0',14891,1127,15,NULL,'10.8.7.10'),(NULL,0,'2019-11-29 22:16:14',NULL,14076,'0',14892,1127,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,14077,'0',14893,1127,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,14078,'0',14894,1127,5,NULL,'84871df1f0114c70a271f580707d4fb7'),(NULL,0,'2019-11-29 22:16:14',NULL,14079,'0',14895,1127,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:15',NULL,14080,'0',14897,1128,16,NULL,'cmdb2-4-7-11'),(NULL,0,'2019-11-29 22:16:15',NULL,14081,'0',14898,1128,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,14082,'0',14899,1128,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:15',NULL,14083,'0',14900,1128,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,14084,'0',14901,1128,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,14085,'0',14902,1128,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:15',NULL,14086,'0',14903,1128,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,14087,'0',14904,1128,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:15',NULL,14088,'0',14905,1128,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,14089,'0',14906,1128,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,14090,'0',14907,1128,15,NULL,'10.8.7.11'),(NULL,0,'2019-11-29 22:16:15',NULL,14091,'0',14908,1128,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,14092,'0',14909,1128,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,14093,'0',14910,1128,5,NULL,'1c49623659874c04bd8513969c97a849'),(NULL,0,'2019-11-29 22:16:15',NULL,14094,'0',14911,1128,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:15',NULL,14095,'0',14913,1129,16,NULL,'cmdb2-4-7-12'),(NULL,0,'2019-11-29 22:16:15',NULL,14096,'0',14914,1129,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,14097,'0',14915,1129,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:15',NULL,14098,'0',14916,1129,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,14099,'0',14917,1129,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,14100,'0',14918,1129,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:15',NULL,14101,'0',14919,1129,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,14102,'0',14920,1129,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:15',NULL,14103,'0',14921,1129,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,14104,'0',14922,1129,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,14105,'0',14923,1129,15,NULL,'10.8.7.12'),(NULL,0,'2019-11-29 22:16:15',NULL,14106,'0',14924,1129,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,14107,'0',14925,1129,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,14108,'0',14926,1129,5,NULL,'122a99a332ec413f9090661c08a19355'),(NULL,0,'2019-11-29 22:16:15',NULL,14109,'0',14927,1129,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:15',NULL,14110,'0',14929,1130,16,NULL,'cmdb2-4-7-13'),(NULL,0,'2019-11-29 22:16:15',NULL,14111,'0',14930,1130,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,14112,'0',14931,1130,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:15',NULL,14113,'0',14932,1130,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,14114,'0',14933,1130,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,14115,'0',14934,1130,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:15',NULL,14116,'0',14935,1130,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,14117,'0',14936,1130,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:15',NULL,14118,'0',14937,1130,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,14119,'0',14938,1130,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,14120,'0',14939,1130,15,NULL,'10.8.7.13'),(NULL,0,'2019-11-29 22:16:15',NULL,14121,'0',14940,1130,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,14122,'0',14941,1130,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,14123,'0',14942,1130,5,NULL,'42115011c6004482bed577d2cb371cfb'),(NULL,0,'2019-11-29 22:16:15',NULL,14124,'0',14943,1130,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:15',NULL,14125,'0',14945,1131,16,NULL,'cmdb2-4-7-14'),(NULL,0,'2019-11-29 22:16:15',NULL,14126,'0',14946,1131,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,14127,'0',14947,1131,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:15',NULL,14128,'0',14948,1131,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,14129,'0',14949,1131,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,14130,'0',14950,1131,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:15',NULL,14131,'0',14951,1131,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,14132,'0',14952,1131,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:15',NULL,14133,'0',14953,1131,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,14134,'0',14954,1131,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,14135,'0',14955,1131,15,NULL,'10.8.7.14'),(NULL,0,'2019-11-29 22:16:15',NULL,14136,'0',14956,1131,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,14137,'0',14957,1131,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,14138,'0',14958,1131,5,NULL,'9d8526f7b1b74b1aabe81417ced78011'),(NULL,0,'2019-11-29 22:16:15',NULL,14139,'0',14959,1131,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:15',NULL,14140,'0',14961,1132,16,NULL,'cmdb2-4-7-15'),(NULL,0,'2019-11-29 22:16:15',NULL,14141,'0',14962,1132,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,14142,'0',14963,1132,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:15',NULL,14143,'0',14964,1132,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,14144,'0',14965,1132,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,14145,'0',14966,1132,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:16',NULL,14146,'0',14967,1132,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,14147,'0',14968,1132,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:16',NULL,14148,'0',14969,1132,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,14149,'0',14970,1132,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,14150,'0',14971,1132,15,NULL,'10.8.7.15'),(NULL,0,'2019-11-29 22:16:16',NULL,14151,'0',14972,1132,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,14152,'0',14973,1132,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,14153,'0',14974,1132,5,NULL,'228e1661257447cf99d4ed5461f5587a'),(NULL,0,'2019-11-29 22:16:16',NULL,14154,'0',14975,1132,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:16',NULL,14155,'0',14977,1133,16,NULL,'cmdb2-4-7-16'),(NULL,0,'2019-11-29 22:16:16',NULL,14156,'0',14978,1133,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,14157,'0',14979,1133,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:16',NULL,14158,'0',14980,1133,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,14159,'0',14981,1133,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,14160,'0',14982,1133,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:16',NULL,14161,'0',14983,1133,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,14162,'0',14984,1133,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:16',NULL,14163,'0',14985,1133,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,14164,'0',14986,1133,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,14165,'0',14987,1133,15,NULL,'10.8.7.16'),(NULL,0,'2019-11-29 22:16:16',NULL,14166,'0',14988,1133,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,14167,'0',14989,1133,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,14168,'0',14990,1133,5,NULL,'5851e497c1ff4ab68d8174567d4c0c64'),(NULL,0,'2019-11-29 22:16:16',NULL,14169,'0',14991,1133,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:16',NULL,14170,'0',14993,1134,4,NULL,'App2-4-8'),(NULL,0,'2019-11-29 22:16:16',NULL,14171,'0',14995,1135,16,NULL,'cmdb2-4-8-1'),(NULL,0,'2019-11-29 22:16:16',NULL,14172,'0',14996,1135,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,14173,'0',14997,1135,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:16',NULL,14174,'0',14998,1135,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,14175,'0',14999,1135,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,14176,'0',15000,1135,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:16',NULL,14177,'0',15001,1135,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,14178,'0',15002,1135,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:16',NULL,14179,'0',15003,1135,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,14180,'0',15004,1135,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,14181,'0',15005,1135,15,NULL,'10.8.8.1'),(NULL,0,'2019-11-29 22:16:16',NULL,14182,'0',15006,1135,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,14183,'0',15007,1135,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,14184,'0',15008,1135,5,NULL,'5764491d77e34de2b0e8f06fad634bf0'),(NULL,0,'2019-11-29 22:16:16',NULL,14185,'0',15009,1135,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:16',NULL,14186,'0',15011,1136,16,NULL,'cmdb2-4-8-2'),(NULL,0,'2019-11-29 22:16:16',NULL,14187,'0',15012,1136,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,14188,'0',15013,1136,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:16',NULL,14189,'0',15014,1136,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,14190,'0',15015,1136,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,14191,'0',15016,1136,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:16',NULL,14192,'0',15017,1136,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,14193,'0',15018,1136,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:16',NULL,14194,'0',15019,1136,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,14195,'0',15020,1136,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,14196,'0',15021,1136,15,NULL,'10.8.8.2'),(NULL,0,'2019-11-29 22:16:16',NULL,14197,'0',15022,1136,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,14198,'0',15023,1136,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,14199,'0',15024,1136,5,NULL,'32d27af4c1164aafbe8d67cd36ccb3f2'),(NULL,0,'2019-11-29 22:16:16',NULL,14200,'0',15025,1136,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:16',NULL,14201,'0',15027,1137,16,NULL,'cmdb2-4-8-3'),(NULL,0,'2019-11-29 22:16:16',NULL,14202,'0',15028,1137,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,14203,'0',15029,1137,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:16',NULL,14204,'0',15030,1137,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,14205,'0',15031,1137,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,14206,'0',15032,1137,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:17',NULL,14207,'0',15033,1137,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,14208,'0',15034,1137,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:17',NULL,14209,'0',15035,1137,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,14210,'0',15036,1137,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,14211,'0',15037,1137,15,NULL,'10.8.8.3'),(NULL,0,'2019-11-29 22:16:17',NULL,14212,'0',15038,1137,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,14213,'0',15039,1137,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,14214,'0',15040,1137,5,NULL,'226ffb5af5d34d26a4738a3e91fbfb89'),(NULL,0,'2019-11-29 22:16:17',NULL,14215,'0',15041,1137,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:17',NULL,14216,'0',15043,1138,16,NULL,'cmdb2-4-8-4'),(NULL,0,'2019-11-29 22:16:17',NULL,14217,'0',15044,1138,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,14218,'0',15045,1138,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:17',NULL,14219,'0',15046,1138,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,14220,'0',15047,1138,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,14221,'0',15048,1138,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:17',NULL,14222,'0',15049,1138,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,14223,'0',15050,1138,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:17',NULL,14224,'0',15051,1138,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,14225,'0',15052,1138,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,14226,'0',15053,1138,15,NULL,'10.8.8.4'),(NULL,0,'2019-11-29 22:16:17',NULL,14227,'0',15054,1138,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,14228,'0',15055,1138,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,14229,'0',15056,1138,5,NULL,'ef00d3134ebc431688d10a93a52a5264'),(NULL,0,'2019-11-29 22:16:17',NULL,14230,'0',15057,1138,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:17',NULL,14231,'0',15059,1139,16,NULL,'cmdb2-4-8-5'),(NULL,0,'2019-11-29 22:16:17',NULL,14232,'0',15060,1139,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,14233,'0',15061,1139,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:17',NULL,14234,'0',15062,1139,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,14235,'0',15063,1139,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,14236,'0',15064,1139,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:17',NULL,14237,'0',15065,1139,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,14238,'0',15066,1139,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:17',NULL,14239,'0',15067,1139,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,14240,'0',15068,1139,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,14241,'0',15069,1139,15,NULL,'10.8.8.5'),(NULL,0,'2019-11-29 22:16:17',NULL,14242,'0',15070,1139,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,14243,'0',15071,1139,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,14244,'0',15072,1139,5,NULL,'cb26fe974719452289f41d171dda9709'),(NULL,0,'2019-11-29 22:16:17',NULL,14245,'0',15073,1139,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:17',NULL,14246,'0',15075,1140,16,NULL,'cmdb2-4-8-6'),(NULL,0,'2019-11-29 22:16:17',NULL,14247,'0',15076,1140,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,14248,'0',15077,1140,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:17',NULL,14249,'0',15078,1140,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,14250,'0',15079,1140,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,14251,'0',15080,1140,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:17',NULL,14252,'0',15081,1140,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,14253,'0',15082,1140,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:17',NULL,14254,'0',15083,1140,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,14255,'0',15084,1140,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,14256,'0',15085,1140,15,NULL,'10.8.8.6'),(NULL,0,'2019-11-29 22:16:17',NULL,14257,'0',15086,1140,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,14258,'0',15087,1140,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,14259,'0',15088,1140,5,NULL,'f1a708a99d3a4bdcb2f5f4d4b0bd292b'),(NULL,0,'2019-11-29 22:16:17',NULL,14260,'0',15089,1140,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:17',NULL,14261,'0',15091,1141,16,NULL,'cmdb2-4-8-7'),(NULL,0,'2019-11-29 22:16:17',NULL,14262,'0',15092,1141,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,14263,'0',15093,1141,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:17',NULL,14264,'0',15094,1141,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,14265,'0',15095,1141,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,14266,'0',15096,1141,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:17',NULL,14267,'0',15097,1141,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,14268,'0',15098,1141,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:17',NULL,14269,'0',15099,1141,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,14270,'0',15100,1141,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,14271,'0',15101,1141,15,NULL,'10.8.8.7'),(NULL,0,'2019-11-29 22:16:17',NULL,14272,'0',15102,1141,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,14273,'0',15103,1141,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,14274,'0',15104,1141,5,NULL,'b1276ce3f1fc4361a9fb5f85b411d416'),(NULL,0,'2019-11-29 22:16:18',NULL,14275,'0',15105,1141,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:18',NULL,14276,'0',15107,1142,16,NULL,'cmdb2-4-8-8'),(NULL,0,'2019-11-29 22:16:18',NULL,14277,'0',15108,1142,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,14278,'0',15109,1142,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:18',NULL,14279,'0',15110,1142,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,14280,'0',15111,1142,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,14281,'0',15112,1142,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:18',NULL,14282,'0',15113,1142,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,14283,'0',15114,1142,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:18',NULL,14284,'0',15115,1142,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,14285,'0',15116,1142,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,14286,'0',15117,1142,15,NULL,'10.8.8.8'),(NULL,0,'2019-11-29 22:16:18',NULL,14287,'0',15118,1142,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,14288,'0',15119,1142,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,14289,'0',15120,1142,5,NULL,'e094574c5c40496099bb8bf911caab6e'),(NULL,0,'2019-11-29 22:16:18',NULL,14290,'0',15121,1142,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:18',NULL,14291,'0',15123,1143,16,NULL,'cmdb2-4-8-9'),(NULL,0,'2019-11-29 22:16:18',NULL,14292,'0',15124,1143,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,14293,'0',15125,1143,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:18',NULL,14294,'0',15126,1143,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,14295,'0',15127,1143,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,14296,'0',15128,1143,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:18',NULL,14297,'0',15129,1143,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,14298,'0',15130,1143,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:18',NULL,14299,'0',15131,1143,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,14300,'0',15132,1143,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,14301,'0',15133,1143,15,NULL,'10.8.8.9'),(NULL,0,'2019-11-29 22:16:18',NULL,14302,'0',15134,1143,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,14303,'0',15135,1143,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,14304,'0',15136,1143,5,NULL,'484b1e95c6e34194be0ff4765acc3846'),(NULL,0,'2019-11-29 22:16:18',NULL,14305,'0',15137,1143,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:18',NULL,14306,'0',15139,1144,16,NULL,'cmdb2-4-8-10'),(NULL,0,'2019-11-29 22:16:18',NULL,14307,'0',15140,1144,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,14308,'0',15141,1144,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:18',NULL,14309,'0',15142,1144,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,14310,'0',15143,1144,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,14311,'0',15144,1144,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:18',NULL,14312,'0',15145,1144,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,14313,'0',15146,1144,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:18',NULL,14314,'0',15147,1144,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,14315,'0',15148,1144,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,14316,'0',15149,1144,15,NULL,'10.8.8.10'),(NULL,0,'2019-11-29 22:16:18',NULL,14317,'0',15150,1144,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,14318,'0',15151,1144,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,14319,'0',15152,1144,5,NULL,'31947ad9c9b6417588c468d2a6cb7e4d'),(NULL,0,'2019-11-29 22:16:18',NULL,14320,'0',15153,1144,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:18',NULL,14321,'0',15155,1145,16,NULL,'cmdb2-4-8-11'),(NULL,0,'2019-11-29 22:16:18',NULL,14322,'0',15156,1145,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,14323,'0',15157,1145,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:18',NULL,14324,'0',15158,1145,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,14325,'0',15159,1145,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,14326,'0',15160,1145,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:18',NULL,14327,'0',15161,1145,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,14328,'0',15162,1145,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:18',NULL,14329,'0',15163,1145,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,14330,'0',15164,1145,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,14331,'0',15165,1145,15,NULL,'10.8.8.11'),(NULL,0,'2019-11-29 22:16:18',NULL,14332,'0',15166,1145,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,14333,'0',15167,1145,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,14334,'0',15168,1145,5,NULL,'518a7ec0c199425397a8bf5d57517d11'),(NULL,0,'2019-11-29 22:16:18',NULL,14335,'0',15169,1145,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:19',NULL,14336,'0',15171,1146,16,NULL,'cmdb2-4-8-12'),(NULL,0,'2019-11-29 22:16:19',NULL,14337,'0',15172,1146,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,14338,'0',15173,1146,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:19',NULL,14339,'0',15174,1146,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,14340,'0',15175,1146,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,14341,'0',15176,1146,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:19',NULL,14342,'0',15177,1146,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,14343,'0',15178,1146,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:19',NULL,14344,'0',15179,1146,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,14345,'0',15180,1146,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,14346,'0',15181,1146,15,NULL,'10.8.8.12'),(NULL,0,'2019-11-29 22:16:19',NULL,14347,'0',15182,1146,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,14348,'0',15183,1146,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,14349,'0',15184,1146,5,NULL,'84fda9fd4175418780324086af5a9317'),(NULL,0,'2019-11-29 22:16:19',NULL,14350,'0',15185,1146,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:19',NULL,14351,'0',15187,1147,16,NULL,'cmdb2-4-8-13'),(NULL,0,'2019-11-29 22:16:19',NULL,14352,'0',15188,1147,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,14353,'0',15189,1147,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:19',NULL,14354,'0',15190,1147,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,14355,'0',15191,1147,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,14356,'0',15192,1147,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:19',NULL,14357,'0',15193,1147,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,14358,'0',15194,1147,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:19',NULL,14359,'0',15195,1147,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,14360,'0',15196,1147,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,14361,'0',15197,1147,15,NULL,'10.8.8.13'),(NULL,0,'2019-11-29 22:16:19',NULL,14362,'0',15198,1147,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,14363,'0',15199,1147,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,14364,'0',15200,1147,5,NULL,'8a36a0017b0946f1a7c5c23ffaa665bc'),(NULL,0,'2019-11-29 22:16:19',NULL,14365,'0',15201,1147,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:19',NULL,14366,'0',15203,1148,16,NULL,'cmdb2-4-8-14'),(NULL,0,'2019-11-29 22:16:19',NULL,14367,'0',15204,1148,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,14368,'0',15205,1148,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:19',NULL,14369,'0',15206,1148,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,14370,'0',15207,1148,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,14371,'0',15208,1148,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:19',NULL,14372,'0',15209,1148,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,14373,'0',15210,1148,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:19',NULL,14374,'0',15211,1148,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,14375,'0',15212,1148,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,14376,'0',15213,1148,15,NULL,'10.8.8.14'),(NULL,0,'2019-11-29 22:16:19',NULL,14377,'0',15214,1148,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,14378,'0',15215,1148,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,14379,'0',15216,1148,5,NULL,'ce8d4d595e19471b90aa147e000ffc78'),(NULL,0,'2019-11-29 22:16:19',NULL,14380,'0',15217,1148,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:19',NULL,14381,'0',15219,1149,16,NULL,'cmdb2-4-8-15'),(NULL,0,'2019-11-29 22:16:19',NULL,14382,'0',15220,1149,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,14383,'0',15221,1149,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:19',NULL,14384,'0',15222,1149,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,14385,'0',15223,1149,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,14386,'0',15224,1149,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:19',NULL,14387,'0',15225,1149,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,14388,'0',15226,1149,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:19',NULL,14389,'0',15227,1149,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,14390,'0',15228,1149,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,14391,'0',15229,1149,15,NULL,'10.8.8.15'),(NULL,0,'2019-11-29 22:16:19',NULL,14392,'0',15230,1149,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,14393,'0',15231,1149,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,14394,'0',15232,1149,5,NULL,'133309ea54ea4e40b19dabbcc77ef8ca'),(NULL,0,'2019-11-29 22:16:19',NULL,14395,'0',15233,1149,17,NULL,'在线'),(NULL,0,'2019-11-29 22:16:19',NULL,14396,'0',15235,1150,16,NULL,'cmdb2-4-8-16'),(NULL,0,'2019-11-29 22:16:19',NULL,14397,'0',15236,1150,21,NULL,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,14398,'0',15237,1150,22,NULL,'2'),(NULL,0,'2019-11-29 22:16:19',NULL,14399,'0',15238,1150,28,NULL,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,14400,'0',15239,1150,24,NULL,'enable'),(NULL,0,'2019-11-29 22:16:20',NULL,14401,'0',15240,1150,29,NULL,'张江'),(NULL,0,'2019-11-29 22:16:20',NULL,14402,'0',15241,1150,20,NULL,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:20',NULL,14403,'0',15242,1150,23,NULL,'40'),(NULL,0,'2019-11-29 22:16:20',NULL,14404,'0',15243,1150,11,NULL,'pycook'),(NULL,0,'2019-11-29 22:16:20',NULL,14405,'0',15244,1150,19,NULL,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:20',NULL,14406,'0',15245,1150,15,NULL,'10.8.8.16'),(NULL,0,'2019-11-29 22:16:20',NULL,14407,'0',15246,1150,25,NULL,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:20',NULL,14408,'0',15247,1150,30,NULL,'64GB'),(NULL,0,'2019-11-29 22:16:20',NULL,14409,'0',15248,1150,5,NULL,'cdc42f0ed8a94bad9fae14f9f04228ab'),(NULL,0,'2019-11-29 22:16:20',NULL,14410,'0',15249,1150,17,NULL,'在线'),(NULL,0,'2019-12-11 12:00:44',NULL,14411,'1',15251,1,NULL,NULL,NULL),(NULL,0,'2019-12-11 12:09:47',NULL,14412,'0',15252,56,18,NULL,'1'),(NULL,0,'2019-12-11 12:09:52',NULL,14413,'2',15253,56,18,'1',''),(NULL,0,'2020-02-23 17:47:28',NULL,14414,'2',15254,56,29,'ZJ','ZJ'),(NULL,0,'2020-02-23 17:47:30',NULL,14415,'2',15255,56,17,'online','online'),(NULL,0,'2020-02-23 17:47:31',NULL,14416,'2',15256,56,28,'prod','prod'),(NULL,0,'2020-02-23 17:47:35',NULL,14417,'2',15257,56,5,'e0e2de4550164ffd8e8e0a5e9d93143a','e0e2de4550164ffd8e8e0a5e9d93143a');
/*!40000 ALTER TABLE `c_attribute_histories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_attributes`
--

DROP TABLE IF EXISTS `c_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_attributes` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  `alias` varchar(32) NOT NULL,
  `value_type` enum('0','1','2','3','4','5') NOT NULL,
  `is_choice` tinyint(1) DEFAULT NULL,
  `is_list` tinyint(1) DEFAULT NULL,
  `is_unique` tinyint(1) DEFAULT NULL,
  `is_index` tinyint(1) NOT NULL,
  `is_link` tinyint(1) DEFAULT NULL,
  `compute_script` text,
  `uid` int(11) DEFAULT NULL,
  `is_password` tinyint(1) DEFAULT NULL,
  `compute_expr` text,
  `choice_web_hook` json DEFAULT NULL,
  `option` json DEFAULT NULL,
  `is_computed` tinyint(4) DEFAULT '0',
  `is_sortable` tinyint(1) DEFAULT NULL,
  `default` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_attributes_deleted` (`deleted`),
  KEY `ix_c_attributes_uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=48 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_attributes`
--

LOCK TABLES `c_attributes` WRITE;
/*!40000 ALTER TABLE `c_attributes` DISABLE KEYS */;
INSERT INTO `c_attributes` VALUES (NULL,0,'2019-08-25 10:41:40',NULL,1,'bu_name','BU Name','2',0,0,1,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 10:42:47',NULL,2,'owner','Owner','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 10:43:44',NULL,3,'product_name','Product Name','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 10:44:15',NULL,4,'app_name','App Name','2',0,0,1,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 10:44:52',NULL,5,'sn','SN','2',0,0,1,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 10:45:20',NULL,6,'instance_id','Instance ID','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:01:07',NULL,7,'nic_mac','NIC MAC','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:01:31',NULL,8,'hd_sn','HD SN','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:02:45',NULL,9,'ram_sn','RAM SN','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:09:56',NULL,10,'rd_duty','Dev Duty','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:10:35',NULL,11,'op_duty','OP Duty','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:10:57',NULL,12,'qa_duty','QA Duty','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:11:27',NULL,13,'app_description','Description','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:12:25',NULL,14,'app_status','App Status','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:25:50',NULL,15,'private_ip','Private IP','2',0,1,1,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:27:14',NULL,16,'hostname','Hostname','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:29:06',NULL,17,'status','Status','2',1,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:30:28',NULL,18,'public_ip','Public IP','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:35:07',NULL,19,'os_version','OS Version','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:35:23',NULL,20,'kernel_version','Kernel Version','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:35:47',NULL,21,'cpu','CPU','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:36:05',NULL,22,'cpu_count','CPU Count','0',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:36:21',NULL,23,'logic_cpu_count','Logic CPU Count','0',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:36:45',NULL,24,'hyper_threading','Hyper Threading','2',1,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:37:05',NULL,25,'raid','RAID','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:37:27',NULL,26,'ilo_ip','ilo IP','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:37:44',NULL,27,'ilo_mac','ilo MAC','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:39:06',NULL,28,'env','Env','2',1,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:39:35',NULL,29,'idc','IDC','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:40:14',NULL,30,'ram_size','RAM Size','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:41:25','2019-08-25 11:42:05',31,'buy_date','Buy Date','4',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:41:56',NULL,32,'maintain_startdate','Maintain Start Date','4',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:42:35',NULL,33,'maintain_enddate','Maintain End Date','4',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,1,NULL),(NULL,0,'2019-08-25 11:54:54',NULL,34,'host_ip','Host IP','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:56:53',NULL,35,'nic_ip','NIC IP','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:57:05',NULL,36,'nic_status','NIC Status','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:57:24',NULL,37,'nic_type','NIC Type','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:57:42',NULL,38,'nic_interface','NIC Interface','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 11:57:53',NULL,39,'nic_speed','NIC Speed','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:00:33',NULL,40,'hd_interface_type','HD Interface Type','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:00:50',NULL,41,'hd_size','HD Size','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:01:06',NULL,42,'hd_vendor','HD Vendor','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:01:21',NULL,43,'hd_speed','HD Speed','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:01:34',NULL,44,'hd_type','HD Type','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:02:45',NULL,45,'ram_type','RAM Type','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:03:00',NULL,46,'ram_speed','RAM Speed','2',0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL),(NULL,0,'2019-08-25 12:15:58',NULL,47,'manufacturer','Manufacturer','2',0,0,0,1,0,NULL,NULL,0,NULL,NULL,NULL,0,0,NULL);
/*!40000 ALTER TABLE `c_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_c_d`
--

DROP TABLE IF EXISTS `c_c_d`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_c_d` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `category` smallint(6) DEFAULT NULL,
  `enabled` tinyint(1) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `type_id` int(11) DEFAULT NULL,
  `attr_id` int(11) DEFAULT NULL,
  `level` int(11) DEFAULT NULL,
  `options` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_c_d_deleted` (`deleted`),
  CONSTRAINT `c_c_d_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_c_d_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_c_d`
--

LOCK TABLES `c_c_d` WRITE;
/*!40000 ALTER TABLE `c_c_d` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_c_d` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_c_t_t`
--

DROP TABLE IF EXISTS `c_c_t_t`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_c_t_t` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `notify` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_c_t_t_deleted` (`deleted`),
  CONSTRAINT `c_c_t_t_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_c_t_t_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_c_t_t`
--

LOCK TABLES `c_c_t_t` WRITE;
/*!40000 ALTER TABLE `c_c_t_t` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_c_t_t` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_c_t_u_c`
--

DROP TABLE IF EXISTS `c_c_t_u_c`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_c_t_u_c` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) NOT NULL,
  `attr_ids` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_c_t_u_c_deleted` (`deleted`),
  CONSTRAINT `c_c_t_u_c_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_c_t_u_c`
--

LOCK TABLES `c_c_t_u_c` WRITE;
/*!40000 ALTER TABLE `c_c_t_u_c` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_c_t_u_c` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_choice_floats`
--

DROP TABLE IF EXISTS `c_choice_floats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_choice_floats` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `attr_id` int(11) NOT NULL,
  `value` float NOT NULL,
  `option` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_choice_floats_deleted` (`deleted`),
  CONSTRAINT `c_choice_floats_ibfk_1` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_choice_floats`
--

LOCK TABLES `c_choice_floats` WRITE;
/*!40000 ALTER TABLE `c_choice_floats` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_choice_floats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_choice_integers`
--

DROP TABLE IF EXISTS `c_choice_integers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_choice_integers` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `attr_id` int(11) NOT NULL,
  `value` int(11) NOT NULL,
  `option` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_choice_integers_deleted` (`deleted`),
  CONSTRAINT `c_choice_integers_ibfk_1` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_choice_integers`
--

LOCK TABLES `c_choice_integers` WRITE;
/*!40000 ALTER TABLE `c_choice_integers` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_choice_integers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_choice_texts`
--

DROP TABLE IF EXISTS `c_choice_texts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_choice_texts` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `attr_id` int(11) NOT NULL,
  `value` text NOT NULL,
  `option` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_choice_texts_deleted` (`deleted`),
  CONSTRAINT `c_choice_texts_ibfk_1` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_choice_texts`
--

LOCK TABLES `c_choice_texts` WRITE;
/*!40000 ALTER TABLE `c_choice_texts` DISABLE KEYS */;
INSERT INTO `c_choice_texts` VALUES (NULL,0,'2019-08-25 12:07:32',NULL,4,28,'test',NULL),(NULL,0,'2019-08-25 12:07:32',NULL,5,28,'stage',NULL),(NULL,0,'2019-08-25 12:07:32',NULL,6,28,'prod',NULL),(NULL,0,'2019-08-25 12:09:00',NULL,7,17,'online',NULL),(NULL,0,'2019-08-25 12:09:00',NULL,8,17,'standby',NULL),(NULL,0,'2019-08-25 12:09:00',NULL,9,17,'offline',NULL),(NULL,0,'2019-08-25 12:09:00',NULL,11,17,'maintenance',NULL),(NULL,0,'2019-08-25 12:09:00',NULL,12,17,'reinstall',NULL),(NULL,0,'2019-08-25 12:09:23',NULL,13,24,'enable',NULL),(NULL,0,'2019-08-25 12:09:23',NULL,14,24,'disable',NULL);
/*!40000 ALTER TABLE `c_choice_texts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_filter_perms`
--

DROP TABLE IF EXISTS `c_ci_filter_perms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_filter_perms` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `type_id` int(11) DEFAULT NULL,
  `ci_filter` text,
  `attr_filter` text,
  `rid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_ci_filter_perms_rid` (`rid`),
  KEY `ix_c_ci_filter_perms_deleted` (`deleted`),
  KEY `ix_c_ci_filter_perms_name` (`name`),
  CONSTRAINT `c_ci_filter_perms_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_filter_perms`
--

LOCK TABLES `c_ci_filter_perms` WRITE;
/*!40000 ALTER TABLE `c_ci_filter_perms` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_ci_filter_perms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_relations`
--

DROP TABLE IF EXISTS `c_ci_relations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_relations` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `first_ci_id` int(11) NOT NULL,
  `second_ci_id` int(11) NOT NULL,
  `relation_type_id` int(11) NOT NULL,
  `more` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `first_ci_id` (`first_ci_id`),
  KEY `second_ci_id` (`second_ci_id`),
  KEY `relation_type_id` (`relation_type_id`),
  KEY `more` (`more`),
  KEY `ix_c_ci_relations_deleted` (`deleted`),
  CONSTRAINT `c_ci_relations_ibfk_1` FOREIGN KEY (`first_ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_ci_relations_ibfk_2` FOREIGN KEY (`second_ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_ci_relations_ibfk_3` FOREIGN KEY (`relation_type_id`) REFERENCES `c_relation_types` (`id`),
  CONSTRAINT `c_ci_relations_ibfk_4` FOREIGN KEY (`more`) REFERENCES `c_cis` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=841 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_relations`
--

LOCK TABLES `c_ci_relations` WRITE;
/*!40000 ALTER TABLE `c_ci_relations` DISABLE KEYS */;
INSERT INTO `c_ci_relations` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,1,53,54,1,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,2,54,55,1,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,3,55,56,1,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,4,55,57,1,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,5,55,58,1,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,6,55,59,1,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,7,55,60,1,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,8,55,61,1,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,9,55,62,1,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,10,55,63,1,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,11,55,64,1,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,12,55,65,1,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,13,55,66,1,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,14,55,67,1,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,15,55,68,1,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,16,55,69,1,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,17,55,70,1,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,18,55,71,1,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,19,54,72,1,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,20,72,73,1,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,21,72,74,1,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,22,72,75,1,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,23,72,76,1,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,24,72,77,1,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,25,72,78,1,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,26,72,79,1,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,27,72,80,1,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,28,72,81,1,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,29,72,82,1,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,30,72,83,1,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,31,72,84,1,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,32,72,85,1,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,33,72,86,1,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,34,72,87,1,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,35,72,88,1,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,36,54,89,1,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,37,89,90,1,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,38,89,91,1,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,39,89,92,1,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,40,89,93,1,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,41,89,94,1,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,42,89,95,1,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,43,89,96,1,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,44,89,97,1,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,45,89,98,1,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,46,89,99,1,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,47,89,100,1,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,48,89,101,1,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,49,89,102,1,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,50,89,103,1,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,51,89,104,1,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,52,89,105,1,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,53,54,106,1,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,54,106,107,1,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,55,106,108,1,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,56,106,109,1,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,57,106,110,1,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,58,106,111,1,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,59,106,112,1,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,60,106,113,1,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,61,106,114,1,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,62,106,115,1,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,63,106,116,1,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,64,106,117,1,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,65,106,118,1,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,66,106,119,1,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,67,106,120,1,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,68,106,121,1,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,69,106,122,1,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,70,54,123,1,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,71,123,124,1,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,72,123,125,1,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,73,123,126,1,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,74,123,127,1,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,75,123,128,1,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,76,123,129,1,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,77,123,130,1,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,78,123,131,1,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,79,123,132,1,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,80,123,133,1,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,81,123,134,1,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,82,123,135,1,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,83,123,136,1,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,84,123,137,1,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,85,123,138,1,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,86,123,139,1,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,87,54,140,1,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,88,140,141,1,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,89,140,142,1,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,90,140,143,1,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,91,140,144,1,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,92,140,145,1,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,93,140,146,1,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,94,140,147,1,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,95,140,148,1,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,96,140,149,1,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,97,140,150,1,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,98,140,151,1,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,99,140,152,1,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,100,140,153,1,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,101,140,154,1,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,102,140,155,1,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,103,140,156,1,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,104,54,157,1,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,105,157,158,1,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,106,157,159,1,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,107,157,160,1,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,108,157,161,1,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,109,157,162,1,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,110,157,163,1,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,111,157,164,1,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,112,157,165,1,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,113,157,166,1,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,114,157,167,1,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,115,157,168,1,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,116,157,169,1,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,117,157,170,1,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,118,157,171,1,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,119,157,172,1,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,120,157,173,1,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,121,54,174,1,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,122,174,175,1,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,123,174,176,1,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,124,174,177,1,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,125,174,178,1,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,126,174,179,1,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,127,174,180,1,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,128,174,181,1,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,129,174,182,1,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,130,174,183,1,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,131,174,184,1,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,132,174,185,1,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,133,174,186,1,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,134,174,187,1,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,135,174,188,1,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,136,174,189,1,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,137,174,190,1,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,138,53,191,1,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,139,191,192,1,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,140,192,193,1,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,141,192,194,1,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,142,192,195,1,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,143,192,196,1,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,144,192,197,1,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,145,192,198,1,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,146,192,199,1,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,147,192,200,1,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,148,192,201,1,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,149,192,202,1,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,150,192,203,1,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,151,192,204,1,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,152,192,205,1,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,153,192,206,1,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,154,192,207,1,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,155,192,208,1,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,156,191,209,1,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,157,209,210,1,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,158,209,211,1,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,159,209,212,1,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,160,209,213,1,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,161,209,214,1,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,162,209,215,1,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,163,209,216,1,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,164,209,217,1,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,165,209,218,1,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,166,209,219,1,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,167,209,220,1,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,168,209,221,1,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,169,209,222,1,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,170,209,223,1,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,171,209,224,1,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,172,209,225,1,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,173,191,226,1,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,174,226,227,1,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,175,226,228,1,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,176,226,229,1,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,177,226,230,1,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,178,226,231,1,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,179,226,232,1,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,180,226,233,1,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,181,226,234,1,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,182,226,235,1,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,183,226,236,1,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,184,226,237,1,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,185,226,238,1,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,186,226,239,1,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,187,226,240,1,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,188,226,241,1,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,189,226,242,1,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,190,191,243,1,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,191,243,244,1,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,192,243,245,1,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,193,243,246,1,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,194,243,247,1,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,195,243,248,1,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,196,243,249,1,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,197,243,250,1,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,198,243,251,1,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,199,243,252,1,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,200,243,253,1,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,201,243,254,1,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,202,243,255,1,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,203,243,256,1,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,204,243,257,1,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,205,243,258,1,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,206,243,259,1,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,207,191,260,1,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,208,260,261,1,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,209,260,262,1,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,210,260,263,1,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,211,260,264,1,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,212,260,265,1,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,213,260,266,1,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,214,260,267,1,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,215,260,268,1,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,216,260,269,1,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,217,260,270,1,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,218,260,271,1,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,219,260,272,1,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,220,260,273,1,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,221,260,274,1,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,222,260,275,1,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,223,260,276,1,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,224,191,277,1,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,225,277,278,1,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,226,277,279,1,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,227,277,280,1,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,228,277,281,1,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,229,277,282,1,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,230,277,283,1,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,231,277,284,1,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,232,277,285,1,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,233,277,286,1,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,234,277,287,1,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,235,277,288,1,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,236,277,289,1,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,237,277,290,1,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,238,277,291,1,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,239,277,292,1,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,240,277,293,1,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,241,191,294,1,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,242,294,295,1,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,243,294,296,1,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,244,294,297,1,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,245,294,298,1,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,246,294,299,1,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,247,294,300,1,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,248,294,301,1,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,249,294,302,1,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,250,294,303,1,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,251,294,304,1,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,252,294,305,1,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,253,294,306,1,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,254,294,307,1,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,255,294,308,1,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,256,294,309,1,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,257,294,310,1,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,258,191,311,1,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,259,311,312,1,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,260,311,313,1,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,261,311,314,1,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,262,311,315,1,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,263,311,316,1,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,264,311,317,1,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,265,311,318,1,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,266,311,319,1,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,267,311,320,1,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,268,311,321,1,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,269,311,322,1,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,270,311,323,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,271,311,324,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,272,311,325,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,273,311,326,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,274,311,327,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,275,53,328,1,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,276,328,329,1,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,277,329,330,1,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,278,329,331,1,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,279,329,332,1,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,280,329,333,1,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,281,329,334,1,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,282,329,335,1,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,283,329,336,1,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,284,329,337,1,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,285,329,338,1,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,286,329,339,1,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,287,329,340,1,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,288,329,341,1,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,289,329,342,1,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,290,329,343,1,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,291,329,344,1,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,292,329,345,1,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,293,328,346,1,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,294,346,347,1,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,295,346,348,1,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,296,346,349,1,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,297,346,350,1,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,298,346,351,1,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,299,346,352,1,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,300,346,353,1,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,301,346,354,1,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,302,346,355,1,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,303,346,356,1,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,304,346,357,1,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,305,346,358,1,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,306,346,359,1,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,307,346,360,1,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,308,346,361,1,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,309,346,362,1,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,310,328,363,1,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,311,363,364,1,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,312,363,365,1,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,313,363,366,1,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,314,363,367,1,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,315,363,368,1,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,316,363,369,1,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,317,363,370,1,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,318,363,371,1,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,319,363,372,1,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,320,363,373,1,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,321,363,374,1,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,322,363,375,1,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,323,363,376,1,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,324,363,377,1,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,325,363,378,1,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,326,363,379,1,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,327,328,380,1,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,328,380,381,1,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,329,380,382,1,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,330,380,383,1,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,331,380,384,1,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,332,380,385,1,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,333,380,386,1,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,334,380,387,1,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,335,380,388,1,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,336,380,389,1,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,337,380,390,1,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,338,380,391,1,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,339,380,392,1,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,340,380,393,1,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,341,380,394,1,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,342,380,395,1,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,343,380,396,1,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,344,328,397,1,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,345,397,398,1,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,346,397,399,1,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,347,397,400,1,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,348,397,401,1,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,349,397,402,1,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,350,397,403,1,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,351,397,404,1,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,352,397,405,1,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,353,397,406,1,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,354,397,407,1,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,355,397,408,1,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,356,397,409,1,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,357,397,410,1,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,358,397,411,1,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,359,397,412,1,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,360,397,413,1,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,361,328,414,1,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,362,414,415,1,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,363,414,416,1,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,364,414,417,1,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,365,414,418,1,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,366,414,419,1,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,367,414,420,1,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,368,414,421,1,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,369,414,422,1,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,370,414,423,1,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,371,414,424,1,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,372,414,425,1,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,373,414,426,1,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,374,414,427,1,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,375,414,428,1,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,376,414,429,1,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,377,414,430,1,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,378,328,431,1,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,379,431,432,1,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,380,431,433,1,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,381,431,434,1,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,382,431,435,1,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,383,431,436,1,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,384,431,437,1,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,385,431,438,1,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,386,431,439,1,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,387,431,440,1,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,388,431,441,1,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,389,431,442,1,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,390,431,443,1,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,391,431,444,1,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,392,431,445,1,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,393,431,446,1,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,394,431,447,1,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,395,328,448,1,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,396,448,449,1,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,397,448,450,1,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,398,448,451,1,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,399,448,452,1,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,400,448,453,1,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,401,448,454,1,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,402,448,455,1,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,403,448,456,1,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,404,448,457,1,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,405,448,458,1,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,406,448,459,1,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,407,448,460,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,408,448,461,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,409,448,462,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,410,448,463,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,411,448,464,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,412,53,465,1,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,413,465,466,1,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,414,466,467,1,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,415,466,468,1,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,416,466,469,1,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,417,466,470,1,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,418,466,471,1,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,419,466,472,1,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,420,466,473,1,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,421,466,474,1,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,422,466,475,1,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,423,466,476,1,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,424,466,477,1,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,425,466,478,1,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,426,466,479,1,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,427,466,480,1,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,428,466,481,1,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,429,466,482,1,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,430,465,483,1,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,431,483,484,1,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,432,483,485,1,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,433,483,486,1,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,434,483,487,1,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,435,483,488,1,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,436,483,489,1,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,437,483,490,1,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,438,483,491,1,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,439,483,492,1,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,440,483,493,1,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,441,483,494,1,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,442,483,495,1,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,443,483,496,1,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,444,483,497,1,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,445,483,498,1,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,446,483,499,1,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,447,465,500,1,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,448,500,501,1,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,449,500,502,1,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,450,500,503,1,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,451,500,504,1,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,452,500,505,1,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,453,500,506,1,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,454,500,507,1,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,455,500,508,1,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,456,500,509,1,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,457,500,510,1,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,458,500,511,1,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,459,500,512,1,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,460,500,513,1,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,461,500,514,1,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,462,500,515,1,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,463,500,516,1,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,464,465,517,1,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,465,517,518,1,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,466,517,519,1,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,467,517,520,1,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,468,517,521,1,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,469,517,522,1,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,470,517,523,1,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,471,517,524,1,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,472,517,525,1,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,473,517,526,1,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,474,517,527,1,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,475,517,528,1,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,476,517,529,1,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,477,517,530,1,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,478,517,531,1,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,479,517,532,1,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,480,517,533,1,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,481,465,534,1,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,482,534,535,1,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,483,534,536,1,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,484,534,537,1,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,485,534,538,1,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,486,534,539,1,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,487,534,540,1,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,488,534,541,1,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,489,534,542,1,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,490,534,543,1,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,491,534,544,1,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,492,534,545,1,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,493,534,546,1,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,494,534,547,1,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,495,534,548,1,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,496,534,549,1,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,497,534,550,1,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,498,465,551,1,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,499,551,552,1,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,500,551,553,1,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,501,551,554,1,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,502,551,555,1,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,503,551,556,1,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,504,551,557,1,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,505,551,558,1,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,506,551,559,1,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,507,551,560,1,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,508,551,561,1,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,509,551,562,1,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,510,551,563,1,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,511,551,564,1,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,512,551,565,1,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,513,551,566,1,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,514,551,567,1,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,515,465,568,1,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,516,568,569,1,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,517,568,570,1,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,518,568,571,1,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,519,568,572,1,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,520,568,573,1,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,521,568,574,1,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,522,568,575,1,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,523,568,576,1,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,524,568,577,1,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,525,568,578,1,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,526,568,579,1,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,527,568,580,1,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,528,568,581,1,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,529,568,582,1,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,530,568,583,1,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,531,568,584,1,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,532,465,585,1,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,533,585,586,1,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,534,585,587,1,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,535,585,588,1,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,536,585,589,1,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,537,585,590,1,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,538,585,591,1,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,539,585,592,1,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,540,585,593,1,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,541,585,594,1,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,542,585,595,1,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,543,585,596,1,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,544,585,597,1,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,545,585,598,1,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,546,585,599,1,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,547,585,600,1,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,548,585,601,1,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,549,602,603,1,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,550,603,604,1,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,551,603,621,1,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,552,603,638,1,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,553,603,655,1,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,554,603,672,1,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,555,603,689,1,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,556,603,706,1,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,557,603,723,1,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,558,602,740,1,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,559,740,741,1,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,560,740,758,1,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,561,740,775,1,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,562,740,792,1,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,563,740,809,1,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,564,740,826,1,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,565,740,843,1,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,566,740,860,1,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,567,602,877,1,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,568,877,878,1,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,569,878,879,1,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,570,878,880,1,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,571,878,881,1,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,572,878,882,1,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,573,878,883,1,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,574,878,884,1,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,575,878,885,1,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,576,878,886,1,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,577,878,887,1,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,578,878,888,1,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,579,878,889,1,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,580,878,890,1,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,581,878,891,1,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,582,878,892,1,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,583,878,893,1,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,584,878,894,1,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,585,877,895,1,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,586,895,896,1,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,587,895,897,1,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,588,895,898,1,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,589,895,899,1,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,590,895,900,1,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,591,895,901,1,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,592,895,902,1,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,593,895,903,1,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,594,895,904,1,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,595,895,905,1,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,596,895,906,1,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,597,895,907,1,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,598,895,908,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,599,895,909,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,600,895,910,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,601,895,911,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,602,877,912,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,603,912,913,1,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,604,912,914,1,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,605,912,915,1,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,606,912,916,1,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,607,912,917,1,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,608,912,918,1,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,609,912,919,1,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,610,912,920,1,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,611,912,921,1,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,612,912,922,1,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,613,912,923,1,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,614,912,924,1,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,615,912,925,1,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,616,912,926,1,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,617,912,927,1,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,618,912,928,1,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,619,877,929,1,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,620,929,930,1,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,621,929,931,1,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,622,929,932,1,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,623,929,933,1,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,624,929,934,1,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,625,929,935,1,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,626,929,936,1,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,627,929,937,1,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,628,929,938,1,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,629,929,939,1,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,630,929,940,1,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,631,929,941,1,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,632,929,942,1,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,633,929,943,1,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,634,929,944,1,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,635,929,945,1,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,636,877,946,1,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,637,946,947,1,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,638,946,948,1,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,639,946,949,1,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,640,946,950,1,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,641,946,951,1,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,642,946,952,1,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,643,946,953,1,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,644,946,954,1,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,645,946,955,1,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,646,946,956,1,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,647,946,957,1,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,648,946,958,1,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,649,946,959,1,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,650,946,960,1,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,651,946,961,1,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,652,946,962,1,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,653,877,963,1,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,654,963,964,1,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,655,963,965,1,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,656,963,966,1,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,657,963,967,1,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,658,963,968,1,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,659,963,969,1,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,660,963,970,1,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,661,963,971,1,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,662,963,972,1,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,663,963,973,1,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,664,963,974,1,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,665,963,975,1,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,666,963,976,1,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,667,963,977,1,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,668,963,978,1,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,669,963,979,1,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,670,877,980,1,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,671,980,981,1,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,672,980,982,1,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,673,980,983,1,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,674,980,984,1,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,675,980,985,1,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,676,980,986,1,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,677,980,987,1,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,678,980,988,1,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,679,980,989,1,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,680,980,990,1,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,681,980,991,1,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,682,980,992,1,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,683,980,993,1,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,684,980,994,1,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,685,980,995,1,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,686,980,996,1,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,687,877,997,1,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,688,997,998,1,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,689,997,999,1,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,690,997,1000,1,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,691,997,1001,1,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,692,997,1002,1,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,693,997,1003,1,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,694,997,1004,1,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,695,997,1005,1,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,696,997,1006,1,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,697,997,1007,1,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,698,997,1008,1,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,699,997,1009,1,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,700,997,1010,1,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,701,997,1011,1,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,702,997,1012,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,703,997,1013,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,704,602,1014,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,705,1014,1015,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,706,1015,1016,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,707,1015,1017,1,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,708,1015,1018,1,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,709,1015,1019,1,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,710,1015,1020,1,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,711,1015,1021,1,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,712,1015,1022,1,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,713,1015,1023,1,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,714,1015,1024,1,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,715,1015,1025,1,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,716,1015,1026,1,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,717,1015,1027,1,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,718,1015,1028,1,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,719,1015,1029,1,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,720,1015,1030,1,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,721,1015,1031,1,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,722,1014,1032,1,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,723,1032,1033,1,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,724,1032,1034,1,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,725,1032,1035,1,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,726,1032,1036,1,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,727,1032,1037,1,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,728,1032,1038,1,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,729,1032,1039,1,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,730,1032,1040,1,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,731,1032,1041,1,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,732,1032,1042,1,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,733,1032,1043,1,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,734,1032,1044,1,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,735,1032,1045,1,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,736,1032,1046,1,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,737,1032,1047,1,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,738,1032,1048,1,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,739,1014,1049,1,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,740,1049,1050,1,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,741,1049,1051,1,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,742,1049,1052,1,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,743,1049,1053,1,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,744,1049,1054,1,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,745,1049,1055,1,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,746,1049,1056,1,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,747,1049,1057,1,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,748,1049,1058,1,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,749,1049,1059,1,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,750,1049,1060,1,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,751,1049,1061,1,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,752,1049,1062,1,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,753,1049,1063,1,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,754,1049,1064,1,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,755,1049,1065,1,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,756,1014,1066,1,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,757,1066,1067,1,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,758,1066,1068,1,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,759,1066,1069,1,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,760,1066,1070,1,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,761,1066,1071,1,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,762,1066,1072,1,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,763,1066,1073,1,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,764,1066,1074,1,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,765,1066,1075,1,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,766,1066,1076,1,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,767,1066,1077,1,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,768,1066,1078,1,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,769,1066,1079,1,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,770,1066,1080,1,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,771,1066,1081,1,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,772,1066,1082,1,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,773,1014,1083,1,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,774,1083,1084,1,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,775,1083,1085,1,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,776,1083,1086,1,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,777,1083,1087,1,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,778,1083,1088,1,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,779,1083,1089,1,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,780,1083,1090,1,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,781,1083,1091,1,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,782,1083,1092,1,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,783,1083,1093,1,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,784,1083,1094,1,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,785,1083,1095,1,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,786,1083,1096,1,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,787,1083,1097,1,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,788,1083,1098,1,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,789,1083,1099,1,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,790,1014,1100,1,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,791,1100,1101,1,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,792,1100,1102,1,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,793,1100,1103,1,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,794,1100,1104,1,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,795,1100,1105,1,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,796,1100,1106,1,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,797,1100,1107,1,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,798,1100,1108,1,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,799,1100,1109,1,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,800,1100,1110,1,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,801,1100,1111,1,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,802,1100,1112,1,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,803,1100,1113,1,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,804,1100,1114,1,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,805,1100,1115,1,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,806,1100,1116,1,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,807,1014,1117,1,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,808,1117,1118,1,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,809,1117,1119,1,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,810,1117,1120,1,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,811,1117,1121,1,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,812,1117,1122,1,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,813,1117,1123,1,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,814,1117,1124,1,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,815,1117,1125,1,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,816,1117,1126,1,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,817,1117,1127,1,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,818,1117,1128,1,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,819,1117,1129,1,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,820,1117,1130,1,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,821,1117,1131,1,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,822,1117,1132,1,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,823,1117,1133,1,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,824,1014,1134,1,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,825,1134,1135,1,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,826,1134,1136,1,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,827,1134,1137,1,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,828,1134,1138,1,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,829,1134,1139,1,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,830,1134,1140,1,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,831,1134,1141,1,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,832,1134,1142,1,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,833,1134,1143,1,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,834,1134,1144,1,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,835,1134,1145,1,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,836,1134,1146,1,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,837,1134,1147,1,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,838,1134,1148,1,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,839,1134,1149,1,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,840,1134,1150,1,NULL);
/*!40000 ALTER TABLE `c_ci_relations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_attribute_group_items`
--

DROP TABLE IF EXISTS `c_ci_type_attribute_group_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_attribute_group_items` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `order` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_ci_type_attribute_group_items_deleted` (`deleted`),
  CONSTRAINT `c_ci_type_attribute_group_items_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `c_ci_type_attribute_groups` (`id`),
  CONSTRAINT `c_ci_type_attribute_group_items_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_attribute_group_items`
--

LOCK TABLES `c_ci_type_attribute_group_items` WRITE;
/*!40000 ALTER TABLE `c_ci_type_attribute_group_items` DISABLE KEYS */;
INSERT INTO `c_ci_type_attribute_group_items` VALUES (NULL,0,'2019-08-25 11:49:06','2019-08-25 11:52:12',1,1,11,3),(NULL,0,'2019-08-25 11:49:38','2019-08-25 11:52:12',2,1,28,2),(NULL,0,'2019-08-25 11:49:46','2019-08-25 11:52:12',3,1,17,1),(NULL,0,'2019-08-25 11:50:21','2019-08-25 11:50:41',4,2,19,3),(NULL,0,'2019-08-25 11:50:33',NULL,5,2,16,0),(NULL,0,'2019-08-25 11:50:38',NULL,6,2,15,1),(NULL,0,'2019-08-25 11:50:41',NULL,7,2,18,2),(NULL,0,'2019-08-25 11:50:44',NULL,8,2,20,4),(NULL,0,'2019-08-25 11:51:33','2019-08-25 13:41:03',9,3,5,0),(NULL,0,'2019-08-25 11:51:36','2019-08-25 11:51:50',10,3,21,2),(NULL,0,'2019-08-25 11:51:38','2019-08-25 11:51:50',11,3,22,3),(NULL,0,'2019-08-25 11:51:40','2019-08-25 11:51:50',12,3,23,4),(NULL,0,'2019-08-25 11:51:42','2019-08-25 11:51:50',13,3,24,5),(NULL,0,'2019-08-25 11:51:44','2019-08-25 11:51:50',14,3,25,6),(NULL,0,'2019-08-25 11:51:50','2019-08-25 13:41:03',15,3,26,1),(NULL,0,'2019-08-25 11:51:53',NULL,16,2,27,5),(NULL,0,'2019-08-25 11:52:00',NULL,17,3,30,7),(NULL,0,'2019-08-25 11:52:10',NULL,18,1,29,0);
/*!40000 ALTER TABLE `c_ci_type_attribute_group_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_attribute_groups`
--

DROP TABLE IF EXISTS `c_ci_type_attribute_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_attribute_groups` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL DEFAULT '',
  `type_id` int(11) NOT NULL,
  `order` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_ci_type_attribute_groups_deleted` (`deleted`),
  CONSTRAINT `c_ci_type_attribute_groups_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_attribute_groups`
--

LOCK TABLES `c_ci_type_attribute_groups` WRITE;
/*!40000 ALTER TABLE `c_ci_type_attribute_groups` DISABLE KEYS */;
INSERT INTO `c_ci_type_attribute_groups` VALUES (NULL,0,'2019-08-25 11:48:44','2019-08-25 11:49:06',1,'business',4,0),(NULL,0,'2019-08-25 11:50:15','2019-08-25 13:39:33',2,'system',4,2),(NULL,0,'2019-08-25 11:51:23','2019-08-25 13:39:33',3,'hardware',4,1);
/*!40000 ALTER TABLE `c_ci_type_attribute_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_attributes`
--

DROP TABLE IF EXISTS `c_ci_type_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_attributes` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `order` int(11) DEFAULT NULL,
  `is_required` tinyint(1) DEFAULT NULL,
  `default_show` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_ci_type_attributes_deleted` (`deleted`),
  CONSTRAINT `c_ci_type_attributes_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_ci_type_attributes_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=56 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_attributes`
--

LOCK TABLES `c_ci_type_attributes` WRITE;
/*!40000 ALTER TABLE `c_ci_type_attributes` DISABLE KEYS */;
INSERT INTO `c_ci_type_attributes` VALUES (NULL,0,'2019-08-25 10:42:25',NULL,1,1,1,0,1,1),(NULL,0,'2019-08-25 10:42:47',NULL,2,1,2,0,0,1),(NULL,0,'2019-08-25 10:45:39',NULL,3,2,3,0,1,1),(NULL,0,'2019-08-25 10:46:08',NULL,4,3,4,0,1,1),(NULL,0,'2019-08-25 10:57:37','2019-08-25 13:41:03',5,4,5,4,1,1),(NULL,0,'2019-08-25 10:58:44',NULL,6,5,6,0,1,1),(NULL,0,'2019-08-25 11:04:12',NULL,7,6,7,0,1,1),(NULL,0,'2019-08-25 11:04:24',NULL,8,7,8,0,1,1),(NULL,0,'2019-08-25 11:04:45',NULL,9,8,9,0,1,1),(NULL,0,'2019-08-25 11:05:02',NULL,10,2,2,0,0,1),(NULL,0,'2019-08-25 11:09:56','2019-08-25 11:15:16',11,3,10,2,0,1),(NULL,0,'2019-08-25 11:10:36','2019-08-25 11:15:16',12,3,11,3,0,1),(NULL,0,'2019-08-25 11:10:57','2019-08-25 11:15:16',13,3,12,4,0,1),(NULL,0,'2019-08-25 11:11:27','2019-08-25 11:15:16',14,3,13,5,0,1),(NULL,0,'2019-08-25 11:12:25','2019-08-25 11:15:16',15,3,14,1,0,1),(NULL,0,'2019-08-25 11:25:50','2019-08-25 11:52:10',16,4,15,5,1,1),(NULL,0,'2019-08-25 11:27:14','2019-08-25 11:52:10',17,4,16,4,1,1),(NULL,0,'2019-08-25 11:27:40','2019-08-25 12:10:19',18,4,11,3,0,0),(NULL,0,'2019-08-25 11:29:06','2019-08-25 11:52:12',19,4,17,1,0,1),(NULL,0,'2019-08-25 11:30:28','2019-08-25 11:52:10',20,4,18,6,0,1),(NULL,0,'2019-08-25 11:35:07','2019-08-25 11:52:10',21,4,19,7,0,1),(NULL,0,'2019-08-25 11:35:23','2019-08-25 11:52:10',22,4,20,8,0,0),(NULL,0,'2019-08-25 11:35:48','2019-08-25 11:52:10',23,4,21,12,0,0),(NULL,0,'2019-08-25 11:36:05','2019-08-25 11:52:10',24,4,22,13,0,0),(NULL,0,'2019-08-25 11:36:21','2019-08-25 11:52:10',25,4,23,14,0,0),(NULL,0,'2019-08-25 11:36:45','2019-08-25 11:52:10',26,4,24,15,0,0),(NULL,0,'2019-08-25 11:37:05','2019-08-25 11:52:10',27,4,25,16,0,0),(NULL,0,'2019-08-25 11:37:27','2019-08-25 13:41:03',28,4,26,5,0,0),(NULL,0,'2019-08-25 11:37:45','2019-08-25 11:52:10',29,4,27,9,0,0),(NULL,0,'2019-08-25 11:39:06','2019-08-25 11:52:12',30,4,28,2,0,1),(NULL,0,'2019-08-25 11:39:35','2019-08-25 11:52:10',31,4,29,0,0,1),(NULL,0,'2019-08-25 11:40:14','2019-08-25 11:52:10',32,4,30,17,0,0),(NULL,0,'2019-08-25 11:41:25','2019-08-25 11:49:06',33,4,31,18,0,0),(NULL,0,'2019-08-25 11:41:56','2019-08-25 11:49:06',34,4,32,19,0,0),(NULL,0,'2019-08-25 11:42:35','2019-08-25 11:49:06',35,4,33,20,0,0),(NULL,0,'2019-08-25 11:54:54',NULL,36,5,34,0,0,1),(NULL,0,'2019-08-25 11:55:30',NULL,37,5,17,0,0,1),(NULL,0,'2019-08-25 11:55:30',NULL,38,5,28,0,0,1),(NULL,0,'2019-08-25 11:55:30',NULL,39,5,29,0,0,1),(NULL,0,'2019-08-25 11:55:30',NULL,40,5,10,0,0,1),(NULL,0,'2019-08-25 11:55:30',NULL,41,5,11,0,0,1),(NULL,0,'2019-08-25 11:56:53',NULL,42,6,35,0,0,1),(NULL,0,'2019-08-25 11:57:05',NULL,43,6,36,0,0,1),(NULL,0,'2019-08-25 11:57:24',NULL,44,6,37,0,0,1),(NULL,0,'2019-08-25 11:57:42',NULL,45,6,38,0,0,1),(NULL,0,'2019-08-25 11:57:53',NULL,46,6,39,0,0,1),(NULL,0,'2019-08-25 12:00:34',NULL,47,7,40,0,0,1),(NULL,0,'2019-08-25 12:00:50',NULL,48,7,41,0,0,1),(NULL,0,'2019-08-25 12:01:06',NULL,49,7,42,0,0,1),(NULL,0,'2019-08-25 12:01:21',NULL,50,7,43,0,0,1),(NULL,0,'2019-08-25 12:01:34',NULL,51,7,44,0,0,1),(NULL,0,'2019-08-25 12:02:29',NULL,52,8,30,0,0,1),(NULL,0,'2019-08-25 12:02:45',NULL,53,8,45,0,0,1),(NULL,0,'2019-08-25 12:03:00',NULL,54,8,46,0,0,1),(NULL,0,'2019-08-25 12:15:58','2019-08-25 12:16:34',55,4,47,0,0,0);
/*!40000 ALTER TABLE `c_ci_type_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_group_items`
--

DROP TABLE IF EXISTS `c_ci_type_group_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_group_items` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `type_id` int(11) NOT NULL,
  `order` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_ci_type_group_items_deleted` (`deleted`),
  CONSTRAINT `c_ci_type_group_items_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `c_ci_type_groups` (`id`),
  CONSTRAINT `c_ci_type_group_items_ibfk_2` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_group_items`
--

LOCK TABLES `c_ci_type_group_items` WRITE;
/*!40000 ALTER TABLE `c_ci_type_group_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_ci_type_group_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_groups`
--

DROP TABLE IF EXISTS `c_ci_type_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_groups` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL DEFAULT '',
  `order` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_ci_type_groups_deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_groups`
--

LOCK TABLES `c_ci_type_groups` WRITE;
/*!40000 ALTER TABLE `c_ci_type_groups` DISABLE KEYS */;
INSERT INTO `c_ci_type_groups` VALUES (NULL,0,'2023-07-11 14:47:40',NULL,1,'业务',0);
/*!40000 ALTER TABLE `c_ci_type_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_histories`
--

DROP TABLE IF EXISTS `c_ci_type_histories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_histories` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `operate_type` enum('13','8','6','11','3','2','4','5','12','7','9','0','1','10') DEFAULT NULL,
  `type_id` int(11) NOT NULL,
  `attr_id` int(11) DEFAULT NULL,
  `trigger_id` int(11) DEFAULT NULL,
  `unique_constraint_id` int(11) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `change` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_ci_type_histories_type_id` (`type_id`),
  KEY `ix_c_ci_type_histories_uid` (`uid`),
  KEY `ix_c_ci_type_histories_deleted` (`deleted`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_histories`
--

LOCK TABLES `c_ci_type_histories` WRITE;
/*!40000 ALTER TABLE `c_ci_type_histories` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_ci_type_histories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_type_relations`
--

DROP TABLE IF EXISTS `c_ci_type_relations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_type_relations` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL,
  `child_id` int(11) NOT NULL,
  `relation_type_id` int(11) NOT NULL,
  `constraint` enum('0','1','2') DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `child_id` (`child_id`),
  KEY `relation_type_id` (`relation_type_id`),
  KEY `ix_c_ci_type_relations_deleted` (`deleted`),
  CONSTRAINT `c_ci_type_relations_ibfk_1` FOREIGN KEY (`parent_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_ci_type_relations_ibfk_2` FOREIGN KEY (`child_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_ci_type_relations_ibfk_3` FOREIGN KEY (`relation_type_id`) REFERENCES `c_relation_types` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_type_relations`
--

LOCK TABLES `c_ci_type_relations` WRITE;
/*!40000 ALTER TABLE `c_ci_type_relations` DISABLE KEYS */;
INSERT INTO `c_ci_type_relations` VALUES (NULL,0,'2019-08-25 11:45:15',NULL,1,4,6,1,NULL),(NULL,0,'2019-08-25 11:45:22',NULL,2,4,7,1,NULL),(NULL,0,'2019-08-25 11:45:30',NULL,3,4,8,1,NULL),(NULL,0,'2019-08-25 12:03:20',NULL,4,1,2,1,NULL),(NULL,0,'2019-08-25 12:03:30',NULL,5,2,3,1,NULL),(NULL,0,'2019-08-25 12:03:42',NULL,6,3,4,2,NULL),(NULL,0,'2019-08-25 12:03:49',NULL,7,3,5,2,NULL);
/*!40000 ALTER TABLE `c_ci_type_relations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ci_types`
--

DROP TABLE IF EXISTS `c_ci_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ci_types` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL DEFAULT '',
  `alias` varchar(32) NOT NULL DEFAULT '',
  `unique_id` int(11) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `is_attached` tinyint(1) NOT NULL,
  `icon_url` varchar(256) NOT NULL DEFAULT '',
  `order` smallint(6) NOT NULL,
  `uid` int(11) DEFAULT NULL,
  `icon` text,
  `default_order_attr` varchar(33) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `unique_id` (`unique_id`),
  KEY `ix_c_ci_types_deleted` (`deleted`),
  CONSTRAINT `c_ci_types_ibfk_1` FOREIGN KEY (`unique_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ci_types`
--

LOCK TABLES `c_ci_types` WRITE;
/*!40000 ALTER TABLE `c_ci_types` DISABLE KEYS */;
INSERT INTO `c_ci_types` VALUES (NULL,0,'2019-08-25 10:42:25',NULL,1,'bu','BU',1,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 10:45:39',NULL,2,'product','Product',3,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 10:46:08',NULL,3,'app','Application',4,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 10:57:37',NULL,4,'server','Server',5,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 10:58:44',NULL,5,'docker','Docker',6,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 11:04:12',NULL,6,'NIC','NIC',7,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 11:04:24',NULL,7,'harddisk','harddisk',8,1,0,'',0,NULL,NULL,NULL),(NULL,0,'2019-08-25 11:04:45',NULL,8,'RAM','RAM',9,1,0,'',0,NULL,NULL,NULL);
/*!40000 ALTER TABLE `c_ci_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_cis`
--

DROP TABLE IF EXISTS `c_cis`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_cis` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) NOT NULL,
  `status` enum('0','1') DEFAULT NULL,
  `heartbeat` datetime DEFAULT NULL,
  `a` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_cis_deleted` (`deleted`),
  CONSTRAINT `c_cis_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1151 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_cis`
--

LOCK TABLES `c_cis` WRITE;
/*!40000 ALTER TABLE `c_cis` DISABLE KEYS */;
INSERT INTO `c_cis` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,53,1,NULL,'2019-11-29 22:12:14',0),(NULL,0,'2019-11-29 22:12:14',NULL,54,2,NULL,'2019-11-29 22:12:14',0),(NULL,0,'2019-11-29 22:12:14',NULL,55,3,NULL,'2019-11-29 22:12:14',0),(NULL,0,'2019-11-29 22:12:14',NULL,56,4,NULL,'2019-11-29 22:12:14',0),(NULL,0,'2019-11-29 22:12:15',NULL,57,4,NULL,'2019-11-29 22:12:15',0),(NULL,0,'2019-11-29 22:12:15',NULL,58,4,NULL,'2019-11-29 22:12:15',0),(NULL,0,'2019-11-29 22:12:15',NULL,59,4,NULL,'2019-11-29 22:12:15',0),(NULL,0,'2019-11-29 22:12:15',NULL,60,4,NULL,'2019-11-29 22:12:15',0),(NULL,0,'2019-11-29 22:12:16',NULL,61,4,NULL,'2019-11-29 22:12:16',0),(NULL,0,'2019-11-29 22:12:16',NULL,62,4,NULL,'2019-11-29 22:12:16',0),(NULL,0,'2019-11-29 22:12:16',NULL,63,4,NULL,'2019-11-29 22:12:16',0),(NULL,0,'2019-11-29 22:12:16',NULL,64,4,NULL,'2019-11-29 22:12:16',0),(NULL,0,'2019-11-29 22:12:17',NULL,65,4,NULL,'2019-11-29 22:12:17',0),(NULL,0,'2019-11-29 22:12:17',NULL,66,4,NULL,'2019-11-29 22:12:17',0),(NULL,0,'2019-11-29 22:12:17',NULL,67,4,NULL,'2019-11-29 22:12:17',0),(NULL,0,'2019-11-29 22:12:17',NULL,68,4,NULL,'2019-11-29 22:12:17',0),(NULL,0,'2019-11-29 22:12:17',NULL,69,4,NULL,'2019-11-29 22:12:17',0),(NULL,0,'2019-11-29 22:12:18',NULL,70,4,NULL,'2019-11-29 22:12:18',0),(NULL,0,'2019-11-29 22:12:18',NULL,71,4,NULL,'2019-11-29 22:12:18',0),(NULL,0,'2019-11-29 22:12:18',NULL,72,3,NULL,'2019-11-29 22:12:18',0),(NULL,0,'2019-11-29 22:12:18',NULL,73,4,NULL,'2019-11-29 22:12:18',0),(NULL,0,'2019-11-29 22:12:19',NULL,74,4,NULL,'2019-11-29 22:12:19',0),(NULL,0,'2019-11-29 22:12:19',NULL,75,4,NULL,'2019-11-29 22:12:19',0),(NULL,0,'2019-11-29 22:12:19',NULL,76,4,NULL,'2019-11-29 22:12:19',0),(NULL,0,'2019-11-29 22:12:19',NULL,77,4,NULL,'2019-11-29 22:12:19',0),(NULL,0,'2019-11-29 22:12:19',NULL,78,4,NULL,'2019-11-29 22:12:19',0),(NULL,0,'2019-11-29 22:12:20',NULL,79,4,NULL,'2019-11-29 22:12:20',0),(NULL,0,'2019-11-29 22:12:20',NULL,80,4,NULL,'2019-11-29 22:12:20',0),(NULL,0,'2019-11-29 22:12:20',NULL,81,4,NULL,'2019-11-29 22:12:20',0),(NULL,0,'2019-11-29 22:12:20',NULL,82,4,NULL,'2019-11-29 22:12:20',0),(NULL,0,'2019-11-29 22:12:21',NULL,83,4,NULL,'2019-11-29 22:12:21',0),(NULL,0,'2019-11-29 22:12:21',NULL,84,4,NULL,'2019-11-29 22:12:21',0),(NULL,0,'2019-11-29 22:12:21',NULL,85,4,NULL,'2019-11-29 22:12:21',0),(NULL,0,'2019-11-29 22:12:21',NULL,86,4,NULL,'2019-11-29 22:12:21',0),(NULL,0,'2019-11-29 22:12:22',NULL,87,4,NULL,'2019-11-29 22:12:22',0),(NULL,0,'2019-11-29 22:12:22',NULL,88,4,NULL,'2019-11-29 22:12:22',0),(NULL,0,'2019-11-29 22:12:22',NULL,89,3,NULL,'2019-11-29 22:12:22',0),(NULL,0,'2019-11-29 22:12:22',NULL,90,4,NULL,'2019-11-29 22:12:22',0),(NULL,0,'2019-11-29 22:12:22',NULL,91,4,NULL,'2019-11-29 22:12:22',0),(NULL,0,'2019-11-29 22:12:23',NULL,92,4,NULL,'2019-11-29 22:12:23',0),(NULL,0,'2019-11-29 22:12:23',NULL,93,4,NULL,'2019-11-29 22:12:23',0),(NULL,0,'2019-11-29 22:12:23',NULL,94,4,NULL,'2019-11-29 22:12:23',0),(NULL,0,'2019-11-29 22:12:23',NULL,95,4,NULL,'2019-11-29 22:12:23',0),(NULL,0,'2019-11-29 22:12:24',NULL,96,4,NULL,'2019-11-29 22:12:24',0),(NULL,0,'2019-11-29 22:12:24',NULL,97,4,NULL,'2019-11-29 22:12:24',0),(NULL,0,'2019-11-29 22:12:24',NULL,98,4,NULL,'2019-11-29 22:12:24',0),(NULL,0,'2019-11-29 22:12:24',NULL,99,4,NULL,'2019-11-29 22:12:24',0),(NULL,0,'2019-11-29 22:12:25',NULL,100,4,NULL,'2019-11-29 22:12:25',0),(NULL,0,'2019-11-29 22:12:25',NULL,101,4,NULL,'2019-11-29 22:12:25',0),(NULL,0,'2019-11-29 22:12:25',NULL,102,4,NULL,'2019-11-29 22:12:25',0),(NULL,0,'2019-11-29 22:12:25',NULL,103,4,NULL,'2019-11-29 22:12:25',0),(NULL,0,'2019-11-29 22:12:25',NULL,104,4,NULL,'2019-11-29 22:12:25',0),(NULL,0,'2019-11-29 22:12:26',NULL,105,4,NULL,'2019-11-29 22:12:26',0),(NULL,0,'2019-11-29 22:12:26',NULL,106,3,NULL,'2019-11-29 22:12:26',0),(NULL,0,'2019-11-29 22:12:26',NULL,107,4,NULL,'2019-11-29 22:12:26',0),(NULL,0,'2019-11-29 22:12:26',NULL,108,4,NULL,'2019-11-29 22:12:26',0),(NULL,0,'2019-11-29 22:12:26',NULL,109,4,NULL,'2019-11-29 22:12:26',0),(NULL,0,'2019-11-29 22:12:27',NULL,110,4,NULL,'2019-11-29 22:12:27',0),(NULL,0,'2019-11-29 22:12:27',NULL,111,4,NULL,'2019-11-29 22:12:27',0),(NULL,0,'2019-11-29 22:12:27',NULL,112,4,NULL,'2019-11-29 22:12:27',0),(NULL,0,'2019-11-29 22:12:27',NULL,113,4,NULL,'2019-11-29 22:12:27',0),(NULL,0,'2019-11-29 22:12:28',NULL,114,4,NULL,'2019-11-29 22:12:28',0),(NULL,0,'2019-11-29 22:12:28',NULL,115,4,NULL,'2019-11-29 22:12:28',0),(NULL,0,'2019-11-29 22:12:28',NULL,116,4,NULL,'2019-11-29 22:12:28',0),(NULL,0,'2019-11-29 22:12:28',NULL,117,4,NULL,'2019-11-29 22:12:28',0),(NULL,0,'2019-11-29 22:12:29',NULL,118,4,NULL,'2019-11-29 22:12:29',0),(NULL,0,'2019-11-29 22:12:29',NULL,119,4,NULL,'2019-11-29 22:12:29',0),(NULL,0,'2019-11-29 22:12:29',NULL,120,4,NULL,'2019-11-29 22:12:29',0),(NULL,0,'2019-11-29 22:12:29',NULL,121,4,NULL,'2019-11-29 22:12:29',0),(NULL,0,'2019-11-29 22:12:29',NULL,122,4,NULL,'2019-11-29 22:12:29',0),(NULL,0,'2019-11-29 22:12:30',NULL,123,3,NULL,'2019-11-29 22:12:30',0),(NULL,0,'2019-11-29 22:12:30',NULL,124,4,NULL,'2019-11-29 22:12:30',0),(NULL,0,'2019-11-29 22:12:30',NULL,125,4,NULL,'2019-11-29 22:12:30',0),(NULL,0,'2019-11-29 22:12:30',NULL,126,4,NULL,'2019-11-29 22:12:30',0),(NULL,0,'2019-11-29 22:12:31',NULL,127,4,NULL,'2019-11-29 22:12:31',0),(NULL,0,'2019-11-29 22:12:31',NULL,128,4,NULL,'2019-11-29 22:12:31',0),(NULL,0,'2019-11-29 22:12:31',NULL,129,4,NULL,'2019-11-29 22:12:31',0),(NULL,0,'2019-11-29 22:12:31',NULL,130,4,NULL,'2019-11-29 22:12:31',0),(NULL,0,'2019-11-29 22:12:31',NULL,131,4,NULL,'2019-11-29 22:12:31',0),(NULL,0,'2019-11-29 22:12:32',NULL,132,4,NULL,'2019-11-29 22:12:32',0),(NULL,0,'2019-11-29 22:12:32',NULL,133,4,NULL,'2019-11-29 22:12:32',0),(NULL,0,'2019-11-29 22:12:32',NULL,134,4,NULL,'2019-11-29 22:12:32',0),(NULL,0,'2019-11-29 22:12:32',NULL,135,4,NULL,'2019-11-29 22:12:32',0),(NULL,0,'2019-11-29 22:12:33',NULL,136,4,NULL,'2019-11-29 22:12:33',0),(NULL,0,'2019-11-29 22:12:33',NULL,137,4,NULL,'2019-11-29 22:12:33',0),(NULL,0,'2019-11-29 22:12:33',NULL,138,4,NULL,'2019-11-29 22:12:33',0),(NULL,0,'2019-11-29 22:12:33',NULL,139,4,NULL,'2019-11-29 22:12:33',0),(NULL,0,'2019-11-29 22:12:34',NULL,140,3,NULL,'2019-11-29 22:12:34',0),(NULL,0,'2019-11-29 22:12:34',NULL,141,4,NULL,'2019-11-29 22:12:34',0),(NULL,0,'2019-11-29 22:12:34',NULL,142,4,NULL,'2019-11-29 22:12:34',0),(NULL,0,'2019-11-29 22:12:34',NULL,143,4,NULL,'2019-11-29 22:12:34',0),(NULL,0,'2019-11-29 22:12:34',NULL,144,4,NULL,'2019-11-29 22:12:34',0),(NULL,0,'2019-11-29 22:12:35',NULL,145,4,NULL,'2019-11-29 22:12:35',0),(NULL,0,'2019-11-29 22:12:35',NULL,146,4,NULL,'2019-11-29 22:12:35',0),(NULL,0,'2019-11-29 22:12:35',NULL,147,4,NULL,'2019-11-29 22:12:35',0),(NULL,0,'2019-11-29 22:12:35',NULL,148,4,NULL,'2019-11-29 22:12:35',0),(NULL,0,'2019-11-29 22:12:36',NULL,149,4,NULL,'2019-11-29 22:12:36',0),(NULL,0,'2019-11-29 22:12:36',NULL,150,4,NULL,'2019-11-29 22:12:36',0),(NULL,0,'2019-11-29 22:12:36',NULL,151,4,NULL,'2019-11-29 22:12:36',0),(NULL,0,'2019-11-29 22:12:36',NULL,152,4,NULL,'2019-11-29 22:12:36',0),(NULL,0,'2019-11-29 22:12:36',NULL,153,4,NULL,'2019-11-29 22:12:36',0),(NULL,0,'2019-11-29 22:12:37',NULL,154,4,NULL,'2019-11-29 22:12:37',0),(NULL,0,'2019-11-29 22:12:37',NULL,155,4,NULL,'2019-11-29 22:12:37',0),(NULL,0,'2019-11-29 22:12:37',NULL,156,4,NULL,'2019-11-29 22:12:37',0),(NULL,0,'2019-11-29 22:12:37',NULL,157,3,NULL,'2019-11-29 22:12:37',0),(NULL,0,'2019-11-29 22:12:37',NULL,158,4,NULL,'2019-11-29 22:12:37',0),(NULL,0,'2019-11-29 22:12:38',NULL,159,4,NULL,'2019-11-29 22:12:38',0),(NULL,0,'2019-11-29 22:12:38',NULL,160,4,NULL,'2019-11-29 22:12:38',0),(NULL,0,'2019-11-29 22:12:38',NULL,161,4,NULL,'2019-11-29 22:12:38',0),(NULL,0,'2019-11-29 22:12:38',NULL,162,4,NULL,'2019-11-29 22:12:38',0),(NULL,0,'2019-11-29 22:12:39',NULL,163,4,NULL,'2019-11-29 22:12:39',0),(NULL,0,'2019-11-29 22:12:39',NULL,164,4,NULL,'2019-11-29 22:12:39',0),(NULL,0,'2019-11-29 22:12:39',NULL,165,4,NULL,'2019-11-29 22:12:39',0),(NULL,0,'2019-11-29 22:12:39',NULL,166,4,NULL,'2019-11-29 22:12:39',0),(NULL,0,'2019-11-29 22:12:40',NULL,167,4,NULL,'2019-11-29 22:12:40',0),(NULL,0,'2019-11-29 22:12:40',NULL,168,4,NULL,'2019-11-29 22:12:40',0),(NULL,0,'2019-11-29 22:12:40',NULL,169,4,NULL,'2019-11-29 22:12:40',0),(NULL,0,'2019-11-29 22:12:40',NULL,170,4,NULL,'2019-11-29 22:12:40',0),(NULL,0,'2019-11-29 22:12:40',NULL,171,4,NULL,'2019-11-29 22:12:40',0),(NULL,0,'2019-11-29 22:12:41',NULL,172,4,NULL,'2019-11-29 22:12:41',0),(NULL,0,'2019-11-29 22:12:41',NULL,173,4,NULL,'2019-11-29 22:12:41',0),(NULL,0,'2019-11-29 22:12:41',NULL,174,3,NULL,'2019-11-29 22:12:41',0),(NULL,0,'2019-11-29 22:12:41',NULL,175,4,NULL,'2019-11-29 22:12:41',0),(NULL,0,'2019-11-29 22:12:41',NULL,176,4,NULL,'2019-11-29 22:12:41',0),(NULL,0,'2019-11-29 22:12:42',NULL,177,4,NULL,'2019-11-29 22:12:42',0),(NULL,0,'2019-11-29 22:12:42',NULL,178,4,NULL,'2019-11-29 22:12:42',0),(NULL,0,'2019-11-29 22:12:42',NULL,179,4,NULL,'2019-11-29 22:12:42',0),(NULL,0,'2019-11-29 22:12:42',NULL,180,4,NULL,'2019-11-29 22:12:42',0),(NULL,0,'2019-11-29 22:12:43',NULL,181,4,NULL,'2019-11-29 22:12:43',0),(NULL,0,'2019-11-29 22:12:43',NULL,182,4,NULL,'2019-11-29 22:12:43',0),(NULL,0,'2019-11-29 22:12:43',NULL,183,4,NULL,'2019-11-29 22:12:43',0),(NULL,0,'2019-11-29 22:12:43',NULL,184,4,NULL,'2019-11-29 22:12:43',0),(NULL,0,'2019-11-29 22:12:44',NULL,185,4,NULL,'2019-11-29 22:12:44',0),(NULL,0,'2019-11-29 22:12:44',NULL,186,4,NULL,'2019-11-29 22:12:44',0),(NULL,0,'2019-11-29 22:12:44',NULL,187,4,NULL,'2019-11-29 22:12:44',0),(NULL,0,'2019-11-29 22:12:44',NULL,188,4,NULL,'2019-11-29 22:12:44',0),(NULL,0,'2019-11-29 22:12:45',NULL,189,4,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:45',NULL,190,4,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:45',NULL,191,2,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:45',NULL,192,3,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:45',NULL,193,4,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:45',NULL,194,4,NULL,'2019-11-29 22:12:45',0),(NULL,0,'2019-11-29 22:12:46',NULL,195,4,NULL,'2019-11-29 22:12:46',0),(NULL,0,'2019-11-29 22:12:46',NULL,196,4,NULL,'2019-11-29 22:12:46',0),(NULL,0,'2019-11-29 22:12:46',NULL,197,4,NULL,'2019-11-29 22:12:46',0),(NULL,0,'2019-11-29 22:12:46',NULL,198,4,NULL,'2019-11-29 22:12:46',0),(NULL,0,'2019-11-29 22:12:47',NULL,199,4,NULL,'2019-11-29 22:12:47',0),(NULL,0,'2019-11-29 22:12:47',NULL,200,4,NULL,'2019-11-29 22:12:47',0),(NULL,0,'2019-11-29 22:12:47',NULL,201,4,NULL,'2019-11-29 22:12:47',0),(NULL,0,'2019-11-29 22:12:47',NULL,202,4,NULL,'2019-11-29 22:12:47',0),(NULL,0,'2019-11-29 22:12:47',NULL,203,4,NULL,'2019-11-29 22:12:47',0),(NULL,0,'2019-11-29 22:12:48',NULL,204,4,NULL,'2019-11-29 22:12:48',0),(NULL,0,'2019-11-29 22:12:48',NULL,205,4,NULL,'2019-11-29 22:12:48',0),(NULL,0,'2019-11-29 22:12:48',NULL,206,4,NULL,'2019-11-29 22:12:48',0),(NULL,0,'2019-11-29 22:12:48',NULL,207,4,NULL,'2019-11-29 22:12:48',0),(NULL,0,'2019-11-29 22:12:49',NULL,208,4,NULL,'2019-11-29 22:12:49',0),(NULL,0,'2019-11-29 22:12:49',NULL,209,3,NULL,'2019-11-29 22:12:49',0),(NULL,0,'2019-11-29 22:12:49',NULL,210,4,NULL,'2019-11-29 22:12:49',0),(NULL,0,'2019-11-29 22:12:49',NULL,211,4,NULL,'2019-11-29 22:12:49',0),(NULL,0,'2019-11-29 22:12:49',NULL,212,4,NULL,'2019-11-29 22:12:49',0),(NULL,0,'2019-11-29 22:12:50',NULL,213,4,NULL,'2019-11-29 22:12:50',0),(NULL,0,'2019-11-29 22:12:50',NULL,214,4,NULL,'2019-11-29 22:12:50',0),(NULL,0,'2019-11-29 22:12:50',NULL,215,4,NULL,'2019-11-29 22:12:50',0),(NULL,0,'2019-11-29 22:12:50',NULL,216,4,NULL,'2019-11-29 22:12:50',0),(NULL,0,'2019-11-29 22:12:51',NULL,217,4,NULL,'2019-11-29 22:12:51',0),(NULL,0,'2019-11-29 22:12:51',NULL,218,4,NULL,'2019-11-29 22:12:51',0),(NULL,0,'2019-11-29 22:12:51',NULL,219,4,NULL,'2019-11-29 22:12:51',0),(NULL,0,'2019-11-29 22:12:51',NULL,220,4,NULL,'2019-11-29 22:12:51',0),(NULL,0,'2019-11-29 22:12:52',NULL,221,4,NULL,'2019-11-29 22:12:52',0),(NULL,0,'2019-11-29 22:12:52',NULL,222,4,NULL,'2019-11-29 22:12:52',0),(NULL,0,'2019-11-29 22:12:52',NULL,223,4,NULL,'2019-11-29 22:12:52',0),(NULL,0,'2019-11-29 22:12:52',NULL,224,4,NULL,'2019-11-29 22:12:52',0),(NULL,0,'2019-11-29 22:12:53',NULL,225,4,NULL,'2019-11-29 22:12:53',0),(NULL,0,'2019-11-29 22:12:53',NULL,226,3,NULL,'2019-11-29 22:12:53',0),(NULL,0,'2019-11-29 22:12:53',NULL,227,4,NULL,'2019-11-29 22:12:53',0),(NULL,0,'2019-11-29 22:12:53',NULL,228,4,NULL,'2019-11-29 22:12:53',0),(NULL,0,'2019-11-29 22:12:53',NULL,229,4,NULL,'2019-11-29 22:12:53',0),(NULL,0,'2019-11-29 22:12:54',NULL,230,4,NULL,'2019-11-29 22:12:54',0),(NULL,0,'2019-11-29 22:12:54',NULL,231,4,NULL,'2019-11-29 22:12:54',0),(NULL,0,'2019-11-29 22:12:54',NULL,232,4,NULL,'2019-11-29 22:12:54',0),(NULL,0,'2019-11-29 22:12:54',NULL,233,4,NULL,'2019-11-29 22:12:54',0),(NULL,0,'2019-11-29 22:12:54',NULL,234,4,NULL,'2019-11-29 22:12:54',0),(NULL,0,'2019-11-29 22:12:55',NULL,235,4,NULL,'2019-11-29 22:12:55',0),(NULL,0,'2019-11-29 22:12:55',NULL,236,4,NULL,'2019-11-29 22:12:55',0),(NULL,0,'2019-11-29 22:12:55',NULL,237,4,NULL,'2019-11-29 22:12:55',0),(NULL,0,'2019-11-29 22:12:55',NULL,238,4,NULL,'2019-11-29 22:12:55',0),(NULL,0,'2019-11-29 22:12:56',NULL,239,4,NULL,'2019-11-29 22:12:56',0),(NULL,0,'2019-11-29 22:12:56',NULL,240,4,NULL,'2019-11-29 22:12:56',0),(NULL,0,'2019-11-29 22:12:56',NULL,241,4,NULL,'2019-11-29 22:12:56',0),(NULL,0,'2019-11-29 22:12:56',NULL,242,4,NULL,'2019-11-29 22:12:56',0),(NULL,0,'2019-11-29 22:12:57',NULL,243,3,NULL,'2019-11-29 22:12:57',0),(NULL,0,'2019-11-29 22:12:57',NULL,244,4,NULL,'2019-11-29 22:12:57',0),(NULL,0,'2019-11-29 22:12:57',NULL,245,4,NULL,'2019-11-29 22:12:57',0),(NULL,0,'2019-11-29 22:12:57',NULL,246,4,NULL,'2019-11-29 22:12:57',0),(NULL,0,'2019-11-29 22:12:57',NULL,247,4,NULL,'2019-11-29 22:12:57',0),(NULL,0,'2019-11-29 22:12:58',NULL,248,4,NULL,'2019-11-29 22:12:58',0),(NULL,0,'2019-11-29 22:12:58',NULL,249,4,NULL,'2019-11-29 22:12:58',0),(NULL,0,'2019-11-29 22:12:58',NULL,250,4,NULL,'2019-11-29 22:12:58',0),(NULL,0,'2019-11-29 22:12:58',NULL,251,4,NULL,'2019-11-29 22:12:58',0),(NULL,0,'2019-11-29 22:12:58',NULL,252,4,NULL,'2019-11-29 22:12:58',0),(NULL,0,'2019-11-29 22:12:59',NULL,253,4,NULL,'2019-11-29 22:12:59',0),(NULL,0,'2019-11-29 22:12:59',NULL,254,4,NULL,'2019-11-29 22:12:59',0),(NULL,0,'2019-11-29 22:12:59',NULL,255,4,NULL,'2019-11-29 22:12:59',0),(NULL,0,'2019-11-29 22:12:59',NULL,256,4,NULL,'2019-11-29 22:12:59',0),(NULL,0,'2019-11-29 22:13:00',NULL,257,4,NULL,'2019-11-29 22:13:00',0),(NULL,0,'2019-11-29 22:13:00',NULL,258,4,NULL,'2019-11-29 22:13:00',0),(NULL,0,'2019-11-29 22:13:00',NULL,259,4,NULL,'2019-11-29 22:13:00',0),(NULL,0,'2019-11-29 22:13:00',NULL,260,3,NULL,'2019-11-29 22:13:00',0),(NULL,0,'2019-11-29 22:13:00',NULL,261,4,NULL,'2019-11-29 22:13:00',0),(NULL,0,'2019-11-29 22:13:01',NULL,262,4,NULL,'2019-11-29 22:13:01',0),(NULL,0,'2019-11-29 22:13:01',NULL,263,4,NULL,'2019-11-29 22:13:01',0),(NULL,0,'2019-11-29 22:13:01',NULL,264,4,NULL,'2019-11-29 22:13:01',0),(NULL,0,'2019-11-29 22:13:01',NULL,265,4,NULL,'2019-11-29 22:13:01',0),(NULL,0,'2019-11-29 22:13:02',NULL,266,4,NULL,'2019-11-29 22:13:02',0),(NULL,0,'2019-11-29 22:13:02',NULL,267,4,NULL,'2019-11-29 22:13:02',0),(NULL,0,'2019-11-29 22:13:02',NULL,268,4,NULL,'2019-11-29 22:13:02',0),(NULL,0,'2019-11-29 22:13:02',NULL,269,4,NULL,'2019-11-29 22:13:02',0),(NULL,0,'2019-11-29 22:13:02',NULL,270,4,NULL,'2019-11-29 22:13:02',0),(NULL,0,'2019-11-29 22:13:03',NULL,271,4,NULL,'2019-11-29 22:13:03',0),(NULL,0,'2019-11-29 22:13:03',NULL,272,4,NULL,'2019-11-29 22:13:03',0),(NULL,0,'2019-11-29 22:13:03',NULL,273,4,NULL,'2019-11-29 22:13:03',0),(NULL,0,'2019-11-29 22:13:03',NULL,274,4,NULL,'2019-11-29 22:13:03',0),(NULL,0,'2019-11-29 22:13:04',NULL,275,4,NULL,'2019-11-29 22:13:04',0),(NULL,0,'2019-11-29 22:13:04',NULL,276,4,NULL,'2019-11-29 22:13:04',0),(NULL,0,'2019-11-29 22:13:04',NULL,277,3,NULL,'2019-11-29 22:13:04',0),(NULL,0,'2019-11-29 22:13:04',NULL,278,4,NULL,'2019-11-29 22:13:04',0),(NULL,0,'2019-11-29 22:13:04',NULL,279,4,NULL,'2019-11-29 22:13:04',0),(NULL,0,'2019-11-29 22:13:05',NULL,280,4,NULL,'2019-11-29 22:13:05',0),(NULL,0,'2019-11-29 22:13:05',NULL,281,4,NULL,'2019-11-29 22:13:05',0),(NULL,0,'2019-11-29 22:13:05',NULL,282,4,NULL,'2019-11-29 22:13:05',0),(NULL,0,'2019-11-29 22:13:05',NULL,283,4,NULL,'2019-11-29 22:13:05',0),(NULL,0,'2019-11-29 22:13:06',NULL,284,4,NULL,'2019-11-29 22:13:06',0),(NULL,0,'2019-11-29 22:13:06',NULL,285,4,NULL,'2019-11-29 22:13:06',0),(NULL,0,'2019-11-29 22:13:06',NULL,286,4,NULL,'2019-11-29 22:13:06',0),(NULL,0,'2019-11-29 22:13:06',NULL,287,4,NULL,'2019-11-29 22:13:06',0),(NULL,0,'2019-11-29 22:13:06',NULL,288,4,NULL,'2019-11-29 22:13:06',0),(NULL,0,'2019-11-29 22:13:07',NULL,289,4,NULL,'2019-11-29 22:13:07',0),(NULL,0,'2019-11-29 22:13:07',NULL,290,4,NULL,'2019-11-29 22:13:07',0),(NULL,0,'2019-11-29 22:13:07',NULL,291,4,NULL,'2019-11-29 22:13:07',0),(NULL,0,'2019-11-29 22:13:07',NULL,292,4,NULL,'2019-11-29 22:13:07',0),(NULL,0,'2019-11-29 22:13:08',NULL,293,4,NULL,'2019-11-29 22:13:08',0),(NULL,0,'2019-11-29 22:13:08',NULL,294,3,NULL,'2019-11-29 22:13:08',0),(NULL,0,'2019-11-29 22:13:08',NULL,295,4,NULL,'2019-11-29 22:13:08',0),(NULL,0,'2019-11-29 22:13:08',NULL,296,4,NULL,'2019-11-29 22:13:08',0),(NULL,0,'2019-11-29 22:13:08',NULL,297,4,NULL,'2019-11-29 22:13:08',0),(NULL,0,'2019-11-29 22:13:09',NULL,298,4,NULL,'2019-11-29 22:13:09',0),(NULL,0,'2019-11-29 22:13:09',NULL,299,4,NULL,'2019-11-29 22:13:09',0),(NULL,0,'2019-11-29 22:13:09',NULL,300,4,NULL,'2019-11-29 22:13:09',0),(NULL,0,'2019-11-29 22:13:09',NULL,301,4,NULL,'2019-11-29 22:13:09',0),(NULL,0,'2019-11-29 22:13:09',NULL,302,4,NULL,'2019-11-29 22:13:09',0),(NULL,0,'2019-11-29 22:13:10',NULL,303,4,NULL,'2019-11-29 22:13:10',0),(NULL,0,'2019-11-29 22:13:10',NULL,304,4,NULL,'2019-11-29 22:13:10',0),(NULL,0,'2019-11-29 22:13:10',NULL,305,4,NULL,'2019-11-29 22:13:10',0),(NULL,0,'2019-11-29 22:13:10',NULL,306,4,NULL,'2019-11-29 22:13:10',0),(NULL,0,'2019-11-29 22:13:11',NULL,307,4,NULL,'2019-11-29 22:13:11',0),(NULL,0,'2019-11-29 22:13:11',NULL,308,4,NULL,'2019-11-29 22:13:11',0),(NULL,0,'2019-11-29 22:13:11',NULL,309,4,NULL,'2019-11-29 22:13:11',0),(NULL,0,'2019-11-29 22:13:11',NULL,310,4,NULL,'2019-11-29 22:13:11',0),(NULL,0,'2019-11-29 22:13:12',NULL,311,3,NULL,'2019-11-29 22:13:12',0),(NULL,0,'2019-11-29 22:13:12',NULL,312,4,NULL,'2019-11-29 22:13:12',0),(NULL,0,'2019-11-29 22:13:12',NULL,313,4,NULL,'2019-11-29 22:13:12',0),(NULL,0,'2019-11-29 22:13:12',NULL,314,4,NULL,'2019-11-29 22:13:12',0),(NULL,0,'2019-11-29 22:13:12',NULL,315,4,NULL,'2019-11-29 22:13:12',0),(NULL,0,'2019-11-29 22:13:13',NULL,316,4,NULL,'2019-11-29 22:13:13',0),(NULL,0,'2019-11-29 22:13:13',NULL,317,4,NULL,'2019-11-29 22:13:13',0),(NULL,0,'2019-11-29 22:13:13',NULL,318,4,NULL,'2019-11-29 22:13:13',0),(NULL,0,'2019-11-29 22:13:13',NULL,319,4,NULL,'2019-11-29 22:13:13',0),(NULL,0,'2019-11-29 22:13:13',NULL,320,4,NULL,'2019-11-29 22:13:13',0),(NULL,0,'2019-11-29 22:13:14',NULL,321,4,NULL,'2019-11-29 22:13:14',0),(NULL,0,'2019-11-29 22:13:14',NULL,322,4,NULL,'2019-11-29 22:13:14',0),(NULL,0,'2019-11-29 22:13:14',NULL,323,4,NULL,'2019-11-29 22:13:14',0),(NULL,0,'2019-11-29 22:13:14',NULL,324,4,NULL,'2019-11-29 22:13:14',0),(NULL,0,'2019-11-29 22:13:15',NULL,325,4,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:15',NULL,326,4,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:15',NULL,327,4,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:15',NULL,328,2,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:15',NULL,329,3,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:15',NULL,330,4,NULL,'2019-11-29 22:13:15',0),(NULL,0,'2019-11-29 22:13:16',NULL,331,4,NULL,'2019-11-29 22:13:16',0),(NULL,0,'2019-11-29 22:13:16',NULL,332,4,NULL,'2019-11-29 22:13:16',0),(NULL,0,'2019-11-29 22:13:16',NULL,333,4,NULL,'2019-11-29 22:13:16',0),(NULL,0,'2019-11-29 22:13:16',NULL,334,4,NULL,'2019-11-29 22:13:16',0),(NULL,0,'2019-11-29 22:13:17',NULL,335,4,NULL,'2019-11-29 22:13:17',0),(NULL,0,'2019-11-29 22:13:17',NULL,336,4,NULL,'2019-11-29 22:13:17',0),(NULL,0,'2019-11-29 22:13:17',NULL,337,4,NULL,'2019-11-29 22:13:17',0),(NULL,0,'2019-11-29 22:13:17',NULL,338,4,NULL,'2019-11-29 22:13:17',0),(NULL,0,'2019-11-29 22:13:17',NULL,339,4,NULL,'2019-11-29 22:13:17',0),(NULL,0,'2019-11-29 22:13:18',NULL,340,4,NULL,'2019-11-29 22:13:18',0),(NULL,0,'2019-11-29 22:13:18',NULL,341,4,NULL,'2019-11-29 22:13:18',0),(NULL,0,'2019-11-29 22:13:18',NULL,342,4,NULL,'2019-11-29 22:13:18',0),(NULL,0,'2019-11-29 22:13:18',NULL,343,4,NULL,'2019-11-29 22:13:18',0),(NULL,0,'2019-11-29 22:13:19',NULL,344,4,NULL,'2019-11-29 22:13:19',0),(NULL,0,'2019-11-29 22:13:19',NULL,345,4,NULL,'2019-11-29 22:13:19',0),(NULL,0,'2019-11-29 22:13:19',NULL,346,3,NULL,'2019-11-29 22:13:19',0),(NULL,0,'2019-11-29 22:13:19',NULL,347,4,NULL,'2019-11-29 22:13:19',0),(NULL,0,'2019-11-29 22:13:19',NULL,348,4,NULL,'2019-11-29 22:13:19',0),(NULL,0,'2019-11-29 22:13:20',NULL,349,4,NULL,'2019-11-29 22:13:20',0),(NULL,0,'2019-11-29 22:13:20',NULL,350,4,NULL,'2019-11-29 22:13:20',0),(NULL,0,'2019-11-29 22:13:20',NULL,351,4,NULL,'2019-11-29 22:13:20',0),(NULL,0,'2019-11-29 22:13:20',NULL,352,4,NULL,'2019-11-29 22:13:20',0),(NULL,0,'2019-11-29 22:13:21',NULL,353,4,NULL,'2019-11-29 22:13:21',0),(NULL,0,'2019-11-29 22:13:21',NULL,354,4,NULL,'2019-11-29 22:13:21',0),(NULL,0,'2019-11-29 22:13:21',NULL,355,4,NULL,'2019-11-29 22:13:21',0),(NULL,0,'2019-11-29 22:13:21',NULL,356,4,NULL,'2019-11-29 22:13:21',0),(NULL,0,'2019-11-29 22:13:21',NULL,357,4,NULL,'2019-11-29 22:13:21',0),(NULL,0,'2019-11-29 22:13:22',NULL,358,4,NULL,'2019-11-29 22:13:22',0),(NULL,0,'2019-11-29 22:13:22',NULL,359,4,NULL,'2019-11-29 22:13:22',0),(NULL,0,'2019-11-29 22:13:22',NULL,360,4,NULL,'2019-11-29 22:13:22',0),(NULL,0,'2019-11-29 22:13:22',NULL,361,4,NULL,'2019-11-29 22:13:22',0),(NULL,0,'2019-11-29 22:13:23',NULL,362,4,NULL,'2019-11-29 22:13:23',0),(NULL,0,'2019-11-29 22:13:23',NULL,363,3,NULL,'2019-11-29 22:13:23',0),(NULL,0,'2019-11-29 22:13:23',NULL,364,4,NULL,'2019-11-29 22:13:23',0),(NULL,0,'2019-11-29 22:13:23',NULL,365,4,NULL,'2019-11-29 22:13:23',0),(NULL,0,'2019-11-29 22:13:23',NULL,366,4,NULL,'2019-11-29 22:13:23',0),(NULL,0,'2019-11-29 22:13:24',NULL,367,4,NULL,'2019-11-29 22:13:24',0),(NULL,0,'2019-11-29 22:13:24',NULL,368,4,NULL,'2019-11-29 22:13:24',0),(NULL,0,'2019-11-29 22:13:24',NULL,369,4,NULL,'2019-11-29 22:13:24',0),(NULL,0,'2019-11-29 22:13:24',NULL,370,4,NULL,'2019-11-29 22:13:24',0),(NULL,0,'2019-11-29 22:13:24',NULL,371,4,NULL,'2019-11-29 22:13:24',0),(NULL,0,'2019-11-29 22:13:25',NULL,372,4,NULL,'2019-11-29 22:13:25',0),(NULL,0,'2019-11-29 22:13:25',NULL,373,4,NULL,'2019-11-29 22:13:25',0),(NULL,0,'2019-11-29 22:13:25',NULL,374,4,NULL,'2019-11-29 22:13:25',0),(NULL,0,'2019-11-29 22:13:25',NULL,375,4,NULL,'2019-11-29 22:13:25',0),(NULL,0,'2019-11-29 22:13:26',NULL,376,4,NULL,'2019-11-29 22:13:26',0),(NULL,0,'2019-11-29 22:13:26',NULL,377,4,NULL,'2019-11-29 22:13:26',0),(NULL,0,'2019-11-29 22:13:26',NULL,378,4,NULL,'2019-11-29 22:13:26',0),(NULL,0,'2019-11-29 22:13:26',NULL,379,4,NULL,'2019-11-29 22:13:26',0),(NULL,0,'2019-11-29 22:13:27',NULL,380,3,NULL,'2019-11-29 22:13:27',0),(NULL,0,'2019-11-29 22:13:27',NULL,381,4,NULL,'2019-11-29 22:13:27',0),(NULL,0,'2019-11-29 22:13:27',NULL,382,4,NULL,'2019-11-29 22:13:27',0),(NULL,0,'2019-11-29 22:13:27',NULL,383,4,NULL,'2019-11-29 22:13:27',0),(NULL,0,'2019-11-29 22:13:27',NULL,384,4,NULL,'2019-11-29 22:13:27',0),(NULL,0,'2019-11-29 22:13:28',NULL,385,4,NULL,'2019-11-29 22:13:28',0),(NULL,0,'2019-11-29 22:13:28',NULL,386,4,NULL,'2019-11-29 22:13:28',0),(NULL,0,'2019-11-29 22:13:28',NULL,387,4,NULL,'2019-11-29 22:13:28',0),(NULL,0,'2019-11-29 22:13:28',NULL,388,4,NULL,'2019-11-29 22:13:28',0),(NULL,0,'2019-11-29 22:13:28',NULL,389,4,NULL,'2019-11-29 22:13:28',0),(NULL,0,'2019-11-29 22:13:29',NULL,390,4,NULL,'2019-11-29 22:13:29',0),(NULL,0,'2019-11-29 22:13:29',NULL,391,4,NULL,'2019-11-29 22:13:29',0),(NULL,0,'2019-11-29 22:13:29',NULL,392,4,NULL,'2019-11-29 22:13:29',0),(NULL,0,'2019-11-29 22:13:29',NULL,393,4,NULL,'2019-11-29 22:13:29',0),(NULL,0,'2019-11-29 22:13:30',NULL,394,4,NULL,'2019-11-29 22:13:30',0),(NULL,0,'2019-11-29 22:13:30',NULL,395,4,NULL,'2019-11-29 22:13:30',0),(NULL,0,'2019-11-29 22:13:30',NULL,396,4,NULL,'2019-11-29 22:13:30',0),(NULL,0,'2019-11-29 22:13:30',NULL,397,3,NULL,'2019-11-29 22:13:30',0),(NULL,0,'2019-11-29 22:13:30',NULL,398,4,NULL,'2019-11-29 22:13:30',0),(NULL,0,'2019-11-29 22:13:31',NULL,399,4,NULL,'2019-11-29 22:13:31',0),(NULL,0,'2019-11-29 22:13:31',NULL,400,4,NULL,'2019-11-29 22:13:31',0),(NULL,0,'2019-11-29 22:13:31',NULL,401,4,NULL,'2019-11-29 22:13:31',0),(NULL,0,'2019-11-29 22:13:31',NULL,402,4,NULL,'2019-11-29 22:13:31',0),(NULL,0,'2019-11-29 22:13:32',NULL,403,4,NULL,'2019-11-29 22:13:32',0),(NULL,0,'2019-11-29 22:13:32',NULL,404,4,NULL,'2019-11-29 22:13:32',0),(NULL,0,'2019-11-29 22:13:32',NULL,405,4,NULL,'2019-11-29 22:13:32',0),(NULL,0,'2019-11-29 22:13:32',NULL,406,4,NULL,'2019-11-29 22:13:32',0),(NULL,0,'2019-11-29 22:13:32',NULL,407,4,NULL,'2019-11-29 22:13:32',0),(NULL,0,'2019-11-29 22:13:33',NULL,408,4,NULL,'2019-11-29 22:13:33',0),(NULL,0,'2019-11-29 22:13:33',NULL,409,4,NULL,'2019-11-29 22:13:33',0),(NULL,0,'2019-11-29 22:13:33',NULL,410,4,NULL,'2019-11-29 22:13:33',0),(NULL,0,'2019-11-29 22:13:33',NULL,411,4,NULL,'2019-11-29 22:13:33',0),(NULL,0,'2019-11-29 22:13:34',NULL,412,4,NULL,'2019-11-29 22:13:34',0),(NULL,0,'2019-11-29 22:13:34',NULL,413,4,NULL,'2019-11-29 22:13:34',0),(NULL,0,'2019-11-29 22:13:34',NULL,414,3,NULL,'2019-11-29 22:13:34',0),(NULL,0,'2019-11-29 22:13:34',NULL,415,4,NULL,'2019-11-29 22:13:34',0),(NULL,0,'2019-11-29 22:13:34',NULL,416,4,NULL,'2019-11-29 22:13:34',0),(NULL,0,'2019-11-29 22:13:35',NULL,417,4,NULL,'2019-11-29 22:13:35',0),(NULL,0,'2019-11-29 22:13:35',NULL,418,4,NULL,'2019-11-29 22:13:35',0),(NULL,0,'2019-11-29 22:13:35',NULL,419,4,NULL,'2019-11-29 22:13:35',0),(NULL,0,'2019-11-29 22:13:35',NULL,420,4,NULL,'2019-11-29 22:13:35',0),(NULL,0,'2019-11-29 22:13:36',NULL,421,4,NULL,'2019-11-29 22:13:36',0),(NULL,0,'2019-11-29 22:13:36',NULL,422,4,NULL,'2019-11-29 22:13:36',0),(NULL,0,'2019-11-29 22:13:36',NULL,423,4,NULL,'2019-11-29 22:13:36',0),(NULL,0,'2019-11-29 22:13:36',NULL,424,4,NULL,'2019-11-29 22:13:36',0),(NULL,0,'2019-11-29 22:13:36',NULL,425,4,NULL,'2019-11-29 22:13:36',0),(NULL,0,'2019-11-29 22:13:37',NULL,426,4,NULL,'2019-11-29 22:13:37',0),(NULL,0,'2019-11-29 22:13:37',NULL,427,4,NULL,'2019-11-29 22:13:37',0),(NULL,0,'2019-11-29 22:13:37',NULL,428,4,NULL,'2019-11-29 22:13:37',0),(NULL,0,'2019-11-29 22:13:37',NULL,429,4,NULL,'2019-11-29 22:13:37',0),(NULL,0,'2019-11-29 22:13:38',NULL,430,4,NULL,'2019-11-29 22:13:38',0),(NULL,0,'2019-11-29 22:13:38',NULL,431,3,NULL,'2019-11-29 22:13:38',0),(NULL,0,'2019-11-29 22:13:38',NULL,432,4,NULL,'2019-11-29 22:13:38',0),(NULL,0,'2019-11-29 22:13:38',NULL,433,4,NULL,'2019-11-29 22:13:38',0),(NULL,0,'2019-11-29 22:13:38',NULL,434,4,NULL,'2019-11-29 22:13:38',0),(NULL,0,'2019-11-29 22:13:39',NULL,435,4,NULL,'2019-11-29 22:13:39',0),(NULL,0,'2019-11-29 22:13:39',NULL,436,4,NULL,'2019-11-29 22:13:39',0),(NULL,0,'2019-11-29 22:13:39',NULL,437,4,NULL,'2019-11-29 22:13:39',0),(NULL,0,'2019-11-29 22:13:39',NULL,438,4,NULL,'2019-11-29 22:13:39',0),(NULL,0,'2019-11-29 22:13:40',NULL,439,4,NULL,'2019-11-29 22:13:40',0),(NULL,0,'2019-11-29 22:13:40',NULL,440,4,NULL,'2019-11-29 22:13:40',0),(NULL,0,'2019-11-29 22:13:40',NULL,441,4,NULL,'2019-11-29 22:13:40',0),(NULL,0,'2019-11-29 22:13:40',NULL,442,4,NULL,'2019-11-29 22:13:40',0),(NULL,0,'2019-11-29 22:13:40',NULL,443,4,NULL,'2019-11-29 22:13:40',0),(NULL,0,'2019-11-29 22:13:41',NULL,444,4,NULL,'2019-11-29 22:13:41',0),(NULL,0,'2019-11-29 22:13:41',NULL,445,4,NULL,'2019-11-29 22:13:41',0),(NULL,0,'2019-11-29 22:13:41',NULL,446,4,NULL,'2019-11-29 22:13:41',0),(NULL,0,'2019-11-29 22:13:41',NULL,447,4,NULL,'2019-11-29 22:13:41',0),(NULL,0,'2019-11-29 22:13:42',NULL,448,3,NULL,'2019-11-29 22:13:42',0),(NULL,0,'2019-11-29 22:13:42',NULL,449,4,NULL,'2019-11-29 22:13:42',0),(NULL,0,'2019-11-29 22:13:42',NULL,450,4,NULL,'2019-11-29 22:13:42',0),(NULL,0,'2019-11-29 22:13:42',NULL,451,4,NULL,'2019-11-29 22:13:42',0),(NULL,0,'2019-11-29 22:13:42',NULL,452,4,NULL,'2019-11-29 22:13:42',0),(NULL,0,'2019-11-29 22:13:43',NULL,453,4,NULL,'2019-11-29 22:13:43',0),(NULL,0,'2019-11-29 22:13:43',NULL,454,4,NULL,'2019-11-29 22:13:43',0),(NULL,0,'2019-11-29 22:13:43',NULL,455,4,NULL,'2019-11-29 22:13:43',0),(NULL,0,'2019-11-29 22:13:43',NULL,456,4,NULL,'2019-11-29 22:13:43',0),(NULL,0,'2019-11-29 22:13:44',NULL,457,4,NULL,'2019-11-29 22:13:44',0),(NULL,0,'2019-11-29 22:13:44',NULL,458,4,NULL,'2019-11-29 22:13:44',0),(NULL,0,'2019-11-29 22:13:44',NULL,459,4,NULL,'2019-11-29 22:13:44',0),(NULL,0,'2019-11-29 22:13:44',NULL,460,4,NULL,'2019-11-29 22:13:44',0),(NULL,0,'2019-11-29 22:13:44',NULL,461,4,NULL,'2019-11-29 22:13:44',0),(NULL,0,'2019-11-29 22:13:45',NULL,462,4,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:45',NULL,463,4,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:45',NULL,464,4,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:45',NULL,465,2,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:45',NULL,466,3,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:45',NULL,467,4,NULL,'2019-11-29 22:13:45',0),(NULL,0,'2019-11-29 22:13:46',NULL,468,4,NULL,'2019-11-29 22:13:46',0),(NULL,0,'2019-11-29 22:13:46',NULL,469,4,NULL,'2019-11-29 22:13:46',0),(NULL,0,'2019-11-29 22:13:46',NULL,470,4,NULL,'2019-11-29 22:13:46',0),(NULL,0,'2019-11-29 22:13:46',NULL,471,4,NULL,'2019-11-29 22:13:46',0),(NULL,0,'2019-11-29 22:13:47',NULL,472,4,NULL,'2019-11-29 22:13:47',0),(NULL,0,'2019-11-29 22:13:47',NULL,473,4,NULL,'2019-11-29 22:13:47',0),(NULL,0,'2019-11-29 22:13:47',NULL,474,4,NULL,'2019-11-29 22:13:47',0),(NULL,0,'2019-11-29 22:13:47',NULL,475,4,NULL,'2019-11-29 22:13:47',0),(NULL,0,'2019-11-29 22:13:48',NULL,476,4,NULL,'2019-11-29 22:13:48',0),(NULL,0,'2019-11-29 22:13:48',NULL,477,4,NULL,'2019-11-29 22:13:48',0),(NULL,0,'2019-11-29 22:13:48',NULL,478,4,NULL,'2019-11-29 22:13:48',0),(NULL,0,'2019-11-29 22:13:48',NULL,479,4,NULL,'2019-11-29 22:13:48',0),(NULL,0,'2019-11-29 22:13:48',NULL,480,4,NULL,'2019-11-29 22:13:48',0),(NULL,0,'2019-11-29 22:13:49',NULL,481,4,NULL,'2019-11-29 22:13:49',0),(NULL,0,'2019-11-29 22:13:49',NULL,482,4,NULL,'2019-11-29 22:13:49',0),(NULL,0,'2019-11-29 22:13:49',NULL,483,3,NULL,'2019-11-29 22:13:49',0),(NULL,0,'2019-11-29 22:13:49',NULL,484,4,NULL,'2019-11-29 22:13:49',0),(NULL,0,'2019-11-29 22:13:49',NULL,485,4,NULL,'2019-11-29 22:13:49',0),(NULL,0,'2019-11-29 22:13:50',NULL,486,4,NULL,'2019-11-29 22:13:50',0),(NULL,0,'2019-11-29 22:13:50',NULL,487,4,NULL,'2019-11-29 22:13:50',0),(NULL,0,'2019-11-29 22:13:50',NULL,488,4,NULL,'2019-11-29 22:13:50',0),(NULL,0,'2019-11-29 22:13:50',NULL,489,4,NULL,'2019-11-29 22:13:50',0),(NULL,0,'2019-11-29 22:13:51',NULL,490,4,NULL,'2019-11-29 22:13:51',0),(NULL,0,'2019-11-29 22:13:51',NULL,491,4,NULL,'2019-11-29 22:13:51',0),(NULL,0,'2019-11-29 22:13:51',NULL,492,4,NULL,'2019-11-29 22:13:51',0),(NULL,0,'2019-11-29 22:13:51',NULL,493,4,NULL,'2019-11-29 22:13:51',0),(NULL,0,'2019-11-29 22:13:52',NULL,494,4,NULL,'2019-11-29 22:13:52',0),(NULL,0,'2019-11-29 22:13:52',NULL,495,4,NULL,'2019-11-29 22:13:52',0),(NULL,0,'2019-11-29 22:13:52',NULL,496,4,NULL,'2019-11-29 22:13:52',0),(NULL,0,'2019-11-29 22:13:52',NULL,497,4,NULL,'2019-11-29 22:13:52',0),(NULL,0,'2019-11-29 22:13:52',NULL,498,4,NULL,'2019-11-29 22:13:52',0),(NULL,0,'2019-11-29 22:13:53',NULL,499,4,NULL,'2019-11-29 22:13:53',0),(NULL,0,'2019-11-29 22:13:53',NULL,500,3,NULL,'2019-11-29 22:13:53',0),(NULL,0,'2019-11-29 22:13:53',NULL,501,4,NULL,'2019-11-29 22:13:53',0),(NULL,0,'2019-11-29 22:13:53',NULL,502,4,NULL,'2019-11-29 22:13:53',0),(NULL,0,'2019-11-29 22:13:53',NULL,503,4,NULL,'2019-11-29 22:13:53',0),(NULL,0,'2019-11-29 22:13:54',NULL,504,4,NULL,'2019-11-29 22:13:54',0),(NULL,0,'2019-11-29 22:13:54',NULL,505,4,NULL,'2019-11-29 22:13:54',0),(NULL,0,'2019-11-29 22:13:54',NULL,506,4,NULL,'2019-11-29 22:13:54',0),(NULL,0,'2019-11-29 22:13:54',NULL,507,4,NULL,'2019-11-29 22:13:54',0),(NULL,0,'2019-11-29 22:13:55',NULL,508,4,NULL,'2019-11-29 22:13:55',0),(NULL,0,'2019-11-29 22:13:55',NULL,509,4,NULL,'2019-11-29 22:13:55',0),(NULL,0,'2019-11-29 22:13:55',NULL,510,4,NULL,'2019-11-29 22:13:55',0),(NULL,0,'2019-11-29 22:13:55',NULL,511,4,NULL,'2019-11-29 22:13:55',0),(NULL,0,'2019-11-29 22:13:55',NULL,512,4,NULL,'2019-11-29 22:13:55',0),(NULL,0,'2019-11-29 22:13:56',NULL,513,4,NULL,'2019-11-29 22:13:56',0),(NULL,0,'2019-11-29 22:13:56',NULL,514,4,NULL,'2019-11-29 22:13:56',0),(NULL,0,'2019-11-29 22:13:56',NULL,515,4,NULL,'2019-11-29 22:13:56',0),(NULL,0,'2019-11-29 22:13:56',NULL,516,4,NULL,'2019-11-29 22:13:56',0),(NULL,0,'2019-11-29 22:13:57',NULL,517,3,NULL,'2019-11-29 22:13:57',0),(NULL,0,'2019-11-29 22:13:57',NULL,518,4,NULL,'2019-11-29 22:13:57',0),(NULL,0,'2019-11-29 22:13:57',NULL,519,4,NULL,'2019-11-29 22:13:57',0),(NULL,0,'2019-11-29 22:13:57',NULL,520,4,NULL,'2019-11-29 22:13:57',0),(NULL,0,'2019-11-29 22:13:57',NULL,521,4,NULL,'2019-11-29 22:13:57',0),(NULL,0,'2019-11-29 22:13:58',NULL,522,4,NULL,'2019-11-29 22:13:58',0),(NULL,0,'2019-11-29 22:13:58',NULL,523,4,NULL,'2019-11-29 22:13:58',0),(NULL,0,'2019-11-29 22:13:58',NULL,524,4,NULL,'2019-11-29 22:13:58',0),(NULL,0,'2019-11-29 22:13:58',NULL,525,4,NULL,'2019-11-29 22:13:58',0),(NULL,0,'2019-11-29 22:13:59',NULL,526,4,NULL,'2019-11-29 22:13:59',0),(NULL,0,'2019-11-29 22:13:59',NULL,527,4,NULL,'2019-11-29 22:13:59',0),(NULL,0,'2019-11-29 22:13:59',NULL,528,4,NULL,'2019-11-29 22:13:59',0),(NULL,0,'2019-11-29 22:13:59',NULL,529,4,NULL,'2019-11-29 22:13:59',0),(NULL,0,'2019-11-29 22:13:59',NULL,530,4,NULL,'2019-11-29 22:13:59',0),(NULL,0,'2019-11-29 22:14:00',NULL,531,4,NULL,'2019-11-29 22:14:00',0),(NULL,0,'2019-11-29 22:14:00',NULL,532,4,NULL,'2019-11-29 22:14:00',0),(NULL,0,'2019-11-29 22:14:00',NULL,533,4,NULL,'2019-11-29 22:14:00',0),(NULL,0,'2019-11-29 22:14:00',NULL,534,3,NULL,'2019-11-29 22:14:00',0),(NULL,0,'2019-11-29 22:14:00',NULL,535,4,NULL,'2019-11-29 22:14:00',0),(NULL,0,'2019-11-29 22:14:01',NULL,536,4,NULL,'2019-11-29 22:14:01',0),(NULL,0,'2019-11-29 22:14:01',NULL,537,4,NULL,'2019-11-29 22:14:01',0),(NULL,0,'2019-11-29 22:14:01',NULL,538,4,NULL,'2019-11-29 22:14:01',0),(NULL,0,'2019-11-29 22:14:01',NULL,539,4,NULL,'2019-11-29 22:14:01',0),(NULL,0,'2019-11-29 22:14:02',NULL,540,4,NULL,'2019-11-29 22:14:02',0),(NULL,0,'2019-11-29 22:14:02',NULL,541,4,NULL,'2019-11-29 22:14:02',0),(NULL,0,'2019-11-29 22:14:02',NULL,542,4,NULL,'2019-11-29 22:14:02',0),(NULL,0,'2019-11-29 22:14:02',NULL,543,4,NULL,'2019-11-29 22:14:02',0),(NULL,0,'2019-11-29 22:14:03',NULL,544,4,NULL,'2019-11-29 22:14:03',0),(NULL,0,'2019-11-29 22:14:03',NULL,545,4,NULL,'2019-11-29 22:14:03',0),(NULL,0,'2019-11-29 22:14:03',NULL,546,4,NULL,'2019-11-29 22:14:03',0),(NULL,0,'2019-11-29 22:14:03',NULL,547,4,NULL,'2019-11-29 22:14:03',0),(NULL,0,'2019-11-29 22:14:03',NULL,548,4,NULL,'2019-11-29 22:14:03',0),(NULL,0,'2019-11-29 22:14:04',NULL,549,4,NULL,'2019-11-29 22:14:04',0),(NULL,0,'2019-11-29 22:14:04',NULL,550,4,NULL,'2019-11-29 22:14:04',0),(NULL,0,'2019-11-29 22:14:04',NULL,551,3,NULL,'2019-11-29 22:14:04',0),(NULL,0,'2019-11-29 22:14:04',NULL,552,4,NULL,'2019-11-29 22:14:04',0),(NULL,0,'2019-11-29 22:14:04',NULL,553,4,NULL,'2019-11-29 22:14:04',0),(NULL,0,'2019-11-29 22:14:05',NULL,554,4,NULL,'2019-11-29 22:14:05',0),(NULL,0,'2019-11-29 22:14:05',NULL,555,4,NULL,'2019-11-29 22:14:05',0),(NULL,0,'2019-11-29 22:14:05',NULL,556,4,NULL,'2019-11-29 22:14:05',0),(NULL,0,'2019-11-29 22:14:05',NULL,557,4,NULL,'2019-11-29 22:14:05',0),(NULL,0,'2019-11-29 22:14:06',NULL,558,4,NULL,'2019-11-29 22:14:06',0),(NULL,0,'2019-11-29 22:14:06',NULL,559,4,NULL,'2019-11-29 22:14:06',0),(NULL,0,'2019-11-29 22:14:06',NULL,560,4,NULL,'2019-11-29 22:14:06',0),(NULL,0,'2019-11-29 22:14:06',NULL,561,4,NULL,'2019-11-29 22:14:06',0),(NULL,0,'2019-11-29 22:14:07',NULL,562,4,NULL,'2019-11-29 22:14:07',0),(NULL,0,'2019-11-29 22:14:07',NULL,563,4,NULL,'2019-11-29 22:14:07',0),(NULL,0,'2019-11-29 22:14:07',NULL,564,4,NULL,'2019-11-29 22:14:07',0),(NULL,0,'2019-11-29 22:14:07',NULL,565,4,NULL,'2019-11-29 22:14:07',0),(NULL,0,'2019-11-29 22:14:07',NULL,566,4,NULL,'2019-11-29 22:14:07',0),(NULL,0,'2019-11-29 22:14:08',NULL,567,4,NULL,'2019-11-29 22:14:08',0),(NULL,0,'2019-11-29 22:14:08',NULL,568,3,NULL,'2019-11-29 22:14:08',0),(NULL,0,'2019-11-29 22:14:08',NULL,569,4,NULL,'2019-11-29 22:14:08',0),(NULL,0,'2019-11-29 22:14:08',NULL,570,4,NULL,'2019-11-29 22:14:08',0),(NULL,0,'2019-11-29 22:14:08',NULL,571,4,NULL,'2019-11-29 22:14:08',0),(NULL,0,'2019-11-29 22:14:09',NULL,572,4,NULL,'2019-11-29 22:14:09',0),(NULL,0,'2019-11-29 22:14:09',NULL,573,4,NULL,'2019-11-29 22:14:09',0),(NULL,0,'2019-11-29 22:14:09',NULL,574,4,NULL,'2019-11-29 22:14:09',0),(NULL,0,'2019-11-29 22:14:09',NULL,575,4,NULL,'2019-11-29 22:14:09',0),(NULL,0,'2019-11-29 22:14:10',NULL,576,4,NULL,'2019-11-29 22:14:10',0),(NULL,0,'2019-11-29 22:14:10',NULL,577,4,NULL,'2019-11-29 22:14:10',0),(NULL,0,'2019-11-29 22:14:10',NULL,578,4,NULL,'2019-11-29 22:14:10',0),(NULL,0,'2019-11-29 22:14:10',NULL,579,4,NULL,'2019-11-29 22:14:10',0),(NULL,0,'2019-11-29 22:14:11',NULL,580,4,NULL,'2019-11-29 22:14:11',0),(NULL,0,'2019-11-29 22:14:11',NULL,581,4,NULL,'2019-11-29 22:14:11',0),(NULL,0,'2019-11-29 22:14:11',NULL,582,4,NULL,'2019-11-29 22:14:11',0),(NULL,0,'2019-11-29 22:14:11',NULL,583,4,NULL,'2019-11-29 22:14:11',0),(NULL,0,'2019-11-29 22:14:11',NULL,584,4,NULL,'2019-11-29 22:14:11',0),(NULL,0,'2019-11-29 22:14:12',NULL,585,3,NULL,'2019-11-29 22:14:12',0),(NULL,0,'2019-11-29 22:14:12',NULL,586,4,NULL,'2019-11-29 22:14:12',0),(NULL,0,'2019-11-29 22:14:12',NULL,587,4,NULL,'2019-11-29 22:14:12',0),(NULL,0,'2019-11-29 22:14:12',NULL,588,4,NULL,'2019-11-29 22:14:12',0),(NULL,0,'2019-11-29 22:14:12',NULL,589,4,NULL,'2019-11-29 22:14:12',0),(NULL,0,'2019-11-29 22:14:13',NULL,590,4,NULL,'2019-11-29 22:14:13',0),(NULL,0,'2019-11-29 22:14:13',NULL,591,4,NULL,'2019-11-29 22:14:13',0),(NULL,0,'2019-11-29 22:14:13',NULL,592,4,NULL,'2019-11-29 22:14:13',0),(NULL,0,'2019-11-29 22:14:13',NULL,593,4,NULL,'2019-11-29 22:14:13',0),(NULL,0,'2019-11-29 22:14:14',NULL,594,4,NULL,'2019-11-29 22:14:14',0),(NULL,0,'2019-11-29 22:14:14',NULL,595,4,NULL,'2019-11-29 22:14:14',0),(NULL,0,'2019-11-29 22:14:14',NULL,596,4,NULL,'2019-11-29 22:14:14',0),(NULL,0,'2019-11-29 22:14:14',NULL,597,4,NULL,'2019-11-29 22:14:14',0),(NULL,0,'2019-11-29 22:14:15',NULL,598,4,NULL,'2019-11-29 22:14:15',0),(NULL,0,'2019-11-29 22:14:15',NULL,599,4,NULL,'2019-11-29 22:14:15',0),(NULL,0,'2019-11-29 22:14:15',NULL,600,4,NULL,'2019-11-29 22:14:15',0),(NULL,0,'2019-11-29 22:14:15',NULL,601,4,NULL,'2019-11-29 22:14:15',0),(NULL,0,'2019-11-29 22:14:16',NULL,602,1,NULL,'2019-11-29 22:14:16',0),(NULL,0,'2019-11-29 22:14:16',NULL,603,2,NULL,'2019-11-29 22:14:16',0),(NULL,0,'2019-11-29 22:14:16',NULL,604,3,NULL,'2019-11-29 22:14:16',0),(NULL,0,'2019-11-29 22:14:20',NULL,621,3,NULL,'2019-11-29 22:14:20',0),(NULL,0,'2019-11-29 22:14:24',NULL,638,3,NULL,'2019-11-29 22:14:24',0),(NULL,0,'2019-11-29 22:14:28',NULL,655,3,NULL,'2019-11-29 22:14:28',0),(NULL,0,'2019-11-29 22:14:32',NULL,672,3,NULL,'2019-11-29 22:14:32',0),(NULL,0,'2019-11-29 22:14:35',NULL,689,3,NULL,'2019-11-29 22:14:35',0),(NULL,0,'2019-11-29 22:14:39',NULL,706,3,NULL,'2019-11-29 22:14:39',0),(NULL,0,'2019-11-29 22:14:43',NULL,723,3,NULL,'2019-11-29 22:14:43',0),(NULL,0,'2019-11-29 22:14:48',NULL,740,2,NULL,'2019-11-29 22:14:48',0),(NULL,0,'2019-11-29 22:14:48',NULL,741,3,NULL,'2019-11-29 22:14:48',0),(NULL,0,'2019-11-29 22:14:52',NULL,758,3,NULL,'2019-11-29 22:14:52',0),(NULL,0,'2019-11-29 22:14:56',NULL,775,3,NULL,'2019-11-29 22:14:56',0),(NULL,0,'2019-11-29 22:15:00',NULL,792,3,NULL,'2019-11-29 22:15:00',0),(NULL,0,'2019-11-29 22:15:03',NULL,809,3,NULL,'2019-11-29 22:15:03',0),(NULL,0,'2019-11-29 22:15:07',NULL,826,3,NULL,'2019-11-29 22:15:07',0),(NULL,0,'2019-11-29 22:15:11',NULL,843,3,NULL,'2019-11-29 22:15:11',0),(NULL,0,'2019-11-29 22:15:15',NULL,860,3,NULL,'2019-11-29 22:15:15',0),(NULL,0,'2019-11-29 22:15:19',NULL,877,2,NULL,'2019-11-29 22:15:19',0),(NULL,0,'2019-11-29 22:15:19',NULL,878,3,NULL,'2019-11-29 22:15:19',0),(NULL,0,'2019-11-29 22:15:20',NULL,879,4,NULL,'2019-11-29 22:15:20',0),(NULL,0,'2019-11-29 22:15:20',NULL,880,4,NULL,'2019-11-29 22:15:20',0),(NULL,0,'2019-11-29 22:15:20',NULL,881,4,NULL,'2019-11-29 22:15:20',0),(NULL,0,'2019-11-29 22:15:20',NULL,882,4,NULL,'2019-11-29 22:15:20',0),(NULL,0,'2019-11-29 22:15:20',NULL,883,4,NULL,'2019-11-29 22:15:20',0),(NULL,0,'2019-11-29 22:15:21',NULL,884,4,NULL,'2019-11-29 22:15:21',0),(NULL,0,'2019-11-29 22:15:21',NULL,885,4,NULL,'2019-11-29 22:15:21',0),(NULL,0,'2019-11-29 22:15:21',NULL,886,4,NULL,'2019-11-29 22:15:21',0),(NULL,0,'2019-11-29 22:15:21',NULL,887,4,NULL,'2019-11-29 22:15:21',0),(NULL,0,'2019-11-29 22:15:22',NULL,888,4,NULL,'2019-11-29 22:15:22',0),(NULL,0,'2019-11-29 22:15:22',NULL,889,4,NULL,'2019-11-29 22:15:22',0),(NULL,0,'2019-11-29 22:15:22',NULL,890,4,NULL,'2019-11-29 22:15:22',0),(NULL,0,'2019-11-29 22:15:22',NULL,891,4,NULL,'2019-11-29 22:15:22',0),(NULL,0,'2019-11-29 22:15:23',NULL,892,4,NULL,'2019-11-29 22:15:23',0),(NULL,0,'2019-11-29 22:15:23',NULL,893,4,NULL,'2019-11-29 22:15:23',0),(NULL,0,'2019-11-29 22:15:23',NULL,894,4,NULL,'2019-11-29 22:15:23',0),(NULL,0,'2019-11-29 22:15:23',NULL,895,3,NULL,'2019-11-29 22:15:23',0),(NULL,0,'2019-11-29 22:15:23',NULL,896,4,NULL,'2019-11-29 22:15:23',0),(NULL,0,'2019-11-29 22:15:24',NULL,897,4,NULL,'2019-11-29 22:15:24',0),(NULL,0,'2019-11-29 22:15:24',NULL,898,4,NULL,'2019-11-29 22:15:24',0),(NULL,0,'2019-11-29 22:15:24',NULL,899,4,NULL,'2019-11-29 22:15:24',0),(NULL,0,'2019-11-29 22:15:24',NULL,900,4,NULL,'2019-11-29 22:15:24',0),(NULL,0,'2019-11-29 22:15:24',NULL,901,4,NULL,'2019-11-29 22:15:24',0),(NULL,0,'2019-11-29 22:15:25',NULL,902,4,NULL,'2019-11-29 22:15:25',0),(NULL,0,'2019-11-29 22:15:25',NULL,903,4,NULL,'2019-11-29 22:15:25',0),(NULL,0,'2019-11-29 22:15:25',NULL,904,4,NULL,'2019-11-29 22:15:25',0),(NULL,0,'2019-11-29 22:15:25',NULL,905,4,NULL,'2019-11-29 22:15:25',0),(NULL,0,'2019-11-29 22:15:26',NULL,906,4,NULL,'2019-11-29 22:15:26',0),(NULL,0,'2019-11-29 22:15:26',NULL,907,4,NULL,'2019-11-29 22:15:26',0),(NULL,0,'2019-11-29 22:15:26',NULL,908,4,NULL,'2019-11-29 22:15:26',0),(NULL,0,'2019-11-29 22:15:26',NULL,909,4,NULL,'2019-11-29 22:15:26',0),(NULL,0,'2019-11-29 22:15:27',NULL,910,4,NULL,'2019-11-29 22:15:27',0),(NULL,0,'2019-11-29 22:15:27',NULL,911,4,NULL,'2019-11-29 22:15:27',0),(NULL,0,'2019-11-29 22:15:27',NULL,912,3,NULL,'2019-11-29 22:15:27',0),(NULL,0,'2019-11-29 22:15:27',NULL,913,4,NULL,'2019-11-29 22:15:27',0),(NULL,0,'2019-11-29 22:15:27',NULL,914,4,NULL,'2019-11-29 22:15:27',0),(NULL,0,'2019-11-29 22:15:28',NULL,915,4,NULL,'2019-11-29 22:15:28',0),(NULL,0,'2019-11-29 22:15:28',NULL,916,4,NULL,'2019-11-29 22:15:28',0),(NULL,0,'2019-11-29 22:15:28',NULL,917,4,NULL,'2019-11-29 22:15:28',0),(NULL,0,'2019-11-29 22:15:28',NULL,918,4,NULL,'2019-11-29 22:15:28',0),(NULL,0,'2019-11-29 22:15:28',NULL,919,4,NULL,'2019-11-29 22:15:28',0),(NULL,0,'2019-11-29 22:15:29',NULL,920,4,NULL,'2019-11-29 22:15:29',0),(NULL,0,'2019-11-29 22:15:29',NULL,921,4,NULL,'2019-11-29 22:15:29',0),(NULL,0,'2019-11-29 22:15:29',NULL,922,4,NULL,'2019-11-29 22:15:29',0),(NULL,0,'2019-11-29 22:15:29',NULL,923,4,NULL,'2019-11-29 22:15:29',0),(NULL,0,'2019-11-29 22:15:30',NULL,924,4,NULL,'2019-11-29 22:15:30',0),(NULL,0,'2019-11-29 22:15:30',NULL,925,4,NULL,'2019-11-29 22:15:30',0),(NULL,0,'2019-11-29 22:15:30',NULL,926,4,NULL,'2019-11-29 22:15:30',0),(NULL,0,'2019-11-29 22:15:30',NULL,927,4,NULL,'2019-11-29 22:15:30',0),(NULL,0,'2019-11-29 22:15:31',NULL,928,4,NULL,'2019-11-29 22:15:31',0),(NULL,0,'2019-11-29 22:15:31',NULL,929,3,NULL,'2019-11-29 22:15:31',0),(NULL,0,'2019-11-29 22:15:31',NULL,930,4,NULL,'2019-11-29 22:15:31',0),(NULL,0,'2019-11-29 22:15:31',NULL,931,4,NULL,'2019-11-29 22:15:31',0),(NULL,0,'2019-11-29 22:15:31',NULL,932,4,NULL,'2019-11-29 22:15:31',0),(NULL,0,'2019-11-29 22:15:32',NULL,933,4,NULL,'2019-11-29 22:15:32',0),(NULL,0,'2019-11-29 22:15:32',NULL,934,4,NULL,'2019-11-29 22:15:32',0),(NULL,0,'2019-11-29 22:15:32',NULL,935,4,NULL,'2019-11-29 22:15:32',0),(NULL,0,'2019-11-29 22:15:32',NULL,936,4,NULL,'2019-11-29 22:15:32',0),(NULL,0,'2019-11-29 22:15:32',NULL,937,4,NULL,'2019-11-29 22:15:32',0),(NULL,0,'2019-11-29 22:15:33',NULL,938,4,NULL,'2019-11-29 22:15:33',0),(NULL,0,'2019-11-29 22:15:33',NULL,939,4,NULL,'2019-11-29 22:15:33',0),(NULL,0,'2019-11-29 22:15:33',NULL,940,4,NULL,'2019-11-29 22:15:33',0),(NULL,0,'2019-11-29 22:15:33',NULL,941,4,NULL,'2019-11-29 22:15:33',0),(NULL,0,'2019-11-29 22:15:34',NULL,942,4,NULL,'2019-11-29 22:15:34',0),(NULL,0,'2019-11-29 22:15:34',NULL,943,4,NULL,'2019-11-29 22:15:34',0),(NULL,0,'2019-11-29 22:15:34',NULL,944,4,NULL,'2019-11-29 22:15:34',0),(NULL,0,'2019-11-29 22:15:34',NULL,945,4,NULL,'2019-11-29 22:15:34',0),(NULL,0,'2019-11-29 22:15:35',NULL,946,3,NULL,'2019-11-29 22:15:35',0),(NULL,0,'2019-11-29 22:15:35',NULL,947,4,NULL,'2019-11-29 22:15:35',0),(NULL,0,'2019-11-29 22:15:35',NULL,948,4,NULL,'2019-11-29 22:15:35',0),(NULL,0,'2019-11-29 22:15:35',NULL,949,4,NULL,'2019-11-29 22:15:35',0),(NULL,0,'2019-11-29 22:15:35',NULL,950,4,NULL,'2019-11-29 22:15:35',0),(NULL,0,'2019-11-29 22:15:36',NULL,951,4,NULL,'2019-11-29 22:15:36',0),(NULL,0,'2019-11-29 22:15:36',NULL,952,4,NULL,'2019-11-29 22:15:36',0),(NULL,0,'2019-11-29 22:15:36',NULL,953,4,NULL,'2019-11-29 22:15:36',0),(NULL,0,'2019-11-29 22:15:36',NULL,954,4,NULL,'2019-11-29 22:15:36',0),(NULL,0,'2019-11-29 22:15:36',NULL,955,4,NULL,'2019-11-29 22:15:36',0),(NULL,0,'2019-11-29 22:15:37',NULL,956,4,NULL,'2019-11-29 22:15:37',0),(NULL,0,'2019-11-29 22:15:37',NULL,957,4,NULL,'2019-11-29 22:15:37',0),(NULL,0,'2019-11-29 22:15:37',NULL,958,4,NULL,'2019-11-29 22:15:37',0),(NULL,0,'2019-11-29 22:15:37',NULL,959,4,NULL,'2019-11-29 22:15:37',0),(NULL,0,'2019-11-29 22:15:38',NULL,960,4,NULL,'2019-11-29 22:15:38',0),(NULL,0,'2019-11-29 22:15:38',NULL,961,4,NULL,'2019-11-29 22:15:38',0),(NULL,0,'2019-11-29 22:15:38',NULL,962,4,NULL,'2019-11-29 22:15:38',0),(NULL,0,'2019-11-29 22:15:38',NULL,963,3,NULL,'2019-11-29 22:15:38',0),(NULL,0,'2019-11-29 22:15:38',NULL,964,4,NULL,'2019-11-29 22:15:38',0),(NULL,0,'2019-11-29 22:15:39',NULL,965,4,NULL,'2019-11-29 22:15:39',0),(NULL,0,'2019-11-29 22:15:39',NULL,966,4,NULL,'2019-11-29 22:15:39',0),(NULL,0,'2019-11-29 22:15:39',NULL,967,4,NULL,'2019-11-29 22:15:39',0),(NULL,0,'2019-11-29 22:15:39',NULL,968,4,NULL,'2019-11-29 22:15:39',0),(NULL,0,'2019-11-29 22:15:39',NULL,969,4,NULL,'2019-11-29 22:15:39',0),(NULL,0,'2019-11-29 22:15:40',NULL,970,4,NULL,'2019-11-29 22:15:40',0),(NULL,0,'2019-11-29 22:15:40',NULL,971,4,NULL,'2019-11-29 22:15:40',0),(NULL,0,'2019-11-29 22:15:40',NULL,972,4,NULL,'2019-11-29 22:15:40',0),(NULL,0,'2019-11-29 22:15:40',NULL,973,4,NULL,'2019-11-29 22:15:40',0),(NULL,0,'2019-11-29 22:15:41',NULL,974,4,NULL,'2019-11-29 22:15:41',0),(NULL,0,'2019-11-29 22:15:41',NULL,975,4,NULL,'2019-11-29 22:15:41',0),(NULL,0,'2019-11-29 22:15:41',NULL,976,4,NULL,'2019-11-29 22:15:41',0),(NULL,0,'2019-11-29 22:15:41',NULL,977,4,NULL,'2019-11-29 22:15:41',0),(NULL,0,'2019-11-29 22:15:42',NULL,978,4,NULL,'2019-11-29 22:15:42',0),(NULL,0,'2019-11-29 22:15:42',NULL,979,4,NULL,'2019-11-29 22:15:42',0),(NULL,0,'2019-11-29 22:15:42',NULL,980,3,NULL,'2019-11-29 22:15:42',0),(NULL,0,'2019-11-29 22:15:42',NULL,981,4,NULL,'2019-11-29 22:15:42',0),(NULL,0,'2019-11-29 22:15:42',NULL,982,4,NULL,'2019-11-29 22:15:42',0),(NULL,0,'2019-11-29 22:15:43',NULL,983,4,NULL,'2019-11-29 22:15:43',0),(NULL,0,'2019-11-29 22:15:43',NULL,984,4,NULL,'2019-11-29 22:15:43',0),(NULL,0,'2019-11-29 22:15:43',NULL,985,4,NULL,'2019-11-29 22:15:43',0),(NULL,0,'2019-11-29 22:15:43',NULL,986,4,NULL,'2019-11-29 22:15:43',0),(NULL,0,'2019-11-29 22:15:43',NULL,987,4,NULL,'2019-11-29 22:15:43',0),(NULL,0,'2019-11-29 22:15:44',NULL,988,4,NULL,'2019-11-29 22:15:44',0),(NULL,0,'2019-11-29 22:15:44',NULL,989,4,NULL,'2019-11-29 22:15:44',0),(NULL,0,'2019-11-29 22:15:44',NULL,990,4,NULL,'2019-11-29 22:15:44',0),(NULL,0,'2019-11-29 22:15:44',NULL,991,4,NULL,'2019-11-29 22:15:44',0),(NULL,0,'2019-11-29 22:15:45',NULL,992,4,NULL,'2019-11-29 22:15:45',0),(NULL,0,'2019-11-29 22:15:45',NULL,993,4,NULL,'2019-11-29 22:15:45',0),(NULL,0,'2019-11-29 22:15:45',NULL,994,4,NULL,'2019-11-29 22:15:45',0),(NULL,0,'2019-11-29 22:15:45',NULL,995,4,NULL,'2019-11-29 22:15:45',0),(NULL,0,'2019-11-29 22:15:46',NULL,996,4,NULL,'2019-11-29 22:15:46',0),(NULL,0,'2019-11-29 22:15:46',NULL,997,3,NULL,'2019-11-29 22:15:46',0),(NULL,0,'2019-11-29 22:15:46',NULL,998,4,NULL,'2019-11-29 22:15:46',0),(NULL,0,'2019-11-29 22:15:46',NULL,999,4,NULL,'2019-11-29 22:15:46',0),(NULL,0,'2019-11-29 22:15:46',NULL,1000,4,NULL,'2019-11-29 22:15:46',0),(NULL,0,'2019-11-29 22:15:47',NULL,1001,4,NULL,'2019-11-29 22:15:47',0),(NULL,0,'2019-11-29 22:15:47',NULL,1002,4,NULL,'2019-11-29 22:15:47',0),(NULL,0,'2019-11-29 22:15:47',NULL,1003,4,NULL,'2019-11-29 22:15:47',0),(NULL,0,'2019-11-29 22:15:47',NULL,1004,4,NULL,'2019-11-29 22:15:47',0),(NULL,0,'2019-11-29 22:15:47',NULL,1005,4,NULL,'2019-11-29 22:15:47',0),(NULL,0,'2019-11-29 22:15:48',NULL,1006,4,NULL,'2019-11-29 22:15:48',0),(NULL,0,'2019-11-29 22:15:48',NULL,1007,4,NULL,'2019-11-29 22:15:48',0),(NULL,0,'2019-11-29 22:15:48',NULL,1008,4,NULL,'2019-11-29 22:15:48',0),(NULL,0,'2019-11-29 22:15:48',NULL,1009,4,NULL,'2019-11-29 22:15:48',0),(NULL,0,'2019-11-29 22:15:49',NULL,1010,4,NULL,'2019-11-29 22:15:49',0),(NULL,0,'2019-11-29 22:15:49',NULL,1011,4,NULL,'2019-11-29 22:15:49',0),(NULL,0,'2019-11-29 22:15:49',NULL,1012,4,NULL,'2019-11-29 22:15:49',0),(NULL,0,'2019-11-29 22:15:49',NULL,1013,4,NULL,'2019-11-29 22:15:49',0),(NULL,0,'2019-11-29 22:15:50',NULL,1014,2,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:50',NULL,1015,3,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:50',NULL,1016,4,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:50',NULL,1017,4,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:50',NULL,1018,4,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:50',NULL,1019,4,NULL,'2019-11-29 22:15:50',0),(NULL,0,'2019-11-29 22:15:51',NULL,1020,4,NULL,'2019-11-29 22:15:51',0),(NULL,0,'2019-11-29 22:15:51',NULL,1021,4,NULL,'2019-11-29 22:15:51',0),(NULL,0,'2019-11-29 22:15:51',NULL,1022,4,NULL,'2019-11-29 22:15:51',0),(NULL,0,'2019-11-29 22:15:51',NULL,1023,4,NULL,'2019-11-29 22:15:51',0),(NULL,0,'2019-11-29 22:15:52',NULL,1024,4,NULL,'2019-11-29 22:15:52',0),(NULL,0,'2019-11-29 22:15:52',NULL,1025,4,NULL,'2019-11-29 22:15:52',0),(NULL,0,'2019-11-29 22:15:52',NULL,1026,4,NULL,'2019-11-29 22:15:52',0),(NULL,0,'2019-11-29 22:15:52',NULL,1027,4,NULL,'2019-11-29 22:15:52',0),(NULL,0,'2019-11-29 22:15:52',NULL,1028,4,NULL,'2019-11-29 22:15:52',0),(NULL,0,'2019-11-29 22:15:53',NULL,1029,4,NULL,'2019-11-29 22:15:53',0),(NULL,0,'2019-11-29 22:15:53',NULL,1030,4,NULL,'2019-11-29 22:15:53',0),(NULL,0,'2019-11-29 22:15:53',NULL,1031,4,NULL,'2019-11-29 22:15:53',0),(NULL,0,'2019-11-29 22:15:53',NULL,1032,3,NULL,'2019-11-29 22:15:53',0),(NULL,0,'2019-11-29 22:15:53',NULL,1033,4,NULL,'2019-11-29 22:15:53',0),(NULL,0,'2019-11-29 22:15:54',NULL,1034,4,NULL,'2019-11-29 22:15:54',0),(NULL,0,'2019-11-29 22:15:54',NULL,1035,4,NULL,'2019-11-29 22:15:54',0),(NULL,0,'2019-11-29 22:15:54',NULL,1036,4,NULL,'2019-11-29 22:15:54',0),(NULL,0,'2019-11-29 22:15:54',NULL,1037,4,NULL,'2019-11-29 22:15:54',0),(NULL,0,'2019-11-29 22:15:55',NULL,1038,4,NULL,'2019-11-29 22:15:55',0),(NULL,0,'2019-11-29 22:15:55',NULL,1039,4,NULL,'2019-11-29 22:15:55',0),(NULL,0,'2019-11-29 22:15:55',NULL,1040,4,NULL,'2019-11-29 22:15:55',0),(NULL,0,'2019-11-29 22:15:55',NULL,1041,4,NULL,'2019-11-29 22:15:55',0),(NULL,0,'2019-11-29 22:15:56',NULL,1042,4,NULL,'2019-11-29 22:15:56',0),(NULL,0,'2019-11-29 22:15:56',NULL,1043,4,NULL,'2019-11-29 22:15:56',0),(NULL,0,'2019-11-29 22:15:56',NULL,1044,4,NULL,'2019-11-29 22:15:56',0),(NULL,0,'2019-11-29 22:15:56',NULL,1045,4,NULL,'2019-11-29 22:15:56',0),(NULL,0,'2019-11-29 22:15:56',NULL,1046,4,NULL,'2019-11-29 22:15:56',0),(NULL,0,'2019-11-29 22:15:57',NULL,1047,4,NULL,'2019-11-29 22:15:57',0),(NULL,0,'2019-11-29 22:15:57',NULL,1048,4,NULL,'2019-11-29 22:15:57',0),(NULL,0,'2019-11-29 22:15:57',NULL,1049,3,NULL,'2019-11-29 22:15:57',0),(NULL,0,'2019-11-29 22:15:57',NULL,1050,4,NULL,'2019-11-29 22:15:57',0),(NULL,0,'2019-11-29 22:15:57',NULL,1051,4,NULL,'2019-11-29 22:15:57',0),(NULL,0,'2019-11-29 22:15:58',NULL,1052,4,NULL,'2019-11-29 22:15:58',0),(NULL,0,'2019-11-29 22:15:58',NULL,1053,4,NULL,'2019-11-29 22:15:58',0),(NULL,0,'2019-11-29 22:15:58',NULL,1054,4,NULL,'2019-11-29 22:15:58',0),(NULL,0,'2019-11-29 22:15:58',NULL,1055,4,NULL,'2019-11-29 22:15:58',0),(NULL,0,'2019-11-29 22:15:59',NULL,1056,4,NULL,'2019-11-29 22:15:59',0),(NULL,0,'2019-11-29 22:15:59',NULL,1057,4,NULL,'2019-11-29 22:15:59',0),(NULL,0,'2019-11-29 22:15:59',NULL,1058,4,NULL,'2019-11-29 22:15:59',0),(NULL,0,'2019-11-29 22:15:59',NULL,1059,4,NULL,'2019-11-29 22:15:59',0),(NULL,0,'2019-11-29 22:16:00',NULL,1060,4,NULL,'2019-11-29 22:16:00',0),(NULL,0,'2019-11-29 22:16:00',NULL,1061,4,NULL,'2019-11-29 22:16:00',0),(NULL,0,'2019-11-29 22:16:00',NULL,1062,4,NULL,'2019-11-29 22:16:00',0),(NULL,0,'2019-11-29 22:16:00',NULL,1063,4,NULL,'2019-11-29 22:16:00',0),(NULL,0,'2019-11-29 22:16:00',NULL,1064,4,NULL,'2019-11-29 22:16:00',0),(NULL,0,'2019-11-29 22:16:01',NULL,1065,4,NULL,'2019-11-29 22:16:01',0),(NULL,0,'2019-11-29 22:16:01',NULL,1066,3,NULL,'2019-11-29 22:16:01',0),(NULL,0,'2019-11-29 22:16:01',NULL,1067,4,NULL,'2019-11-29 22:16:01',0),(NULL,0,'2019-11-29 22:16:01',NULL,1068,4,NULL,'2019-11-29 22:16:01',0),(NULL,0,'2019-11-29 22:16:01',NULL,1069,4,NULL,'2019-11-29 22:16:01',0),(NULL,0,'2019-11-29 22:16:02',NULL,1070,4,NULL,'2019-11-29 22:16:02',0),(NULL,0,'2019-11-29 22:16:02',NULL,1071,4,NULL,'2019-11-29 22:16:02',0),(NULL,0,'2019-11-29 22:16:02',NULL,1072,4,NULL,'2019-11-29 22:16:02',0),(NULL,0,'2019-11-29 22:16:02',NULL,1073,4,NULL,'2019-11-29 22:16:02',0),(NULL,0,'2019-11-29 22:16:03',NULL,1074,4,NULL,'2019-11-29 22:16:03',0),(NULL,0,'2019-11-29 22:16:03',NULL,1075,4,NULL,'2019-11-29 22:16:03',0),(NULL,0,'2019-11-29 22:16:03',NULL,1076,4,NULL,'2019-11-29 22:16:03',0),(NULL,0,'2019-11-29 22:16:03',NULL,1077,4,NULL,'2019-11-29 22:16:03',0),(NULL,0,'2019-11-29 22:16:04',NULL,1078,4,NULL,'2019-11-29 22:16:04',0),(NULL,0,'2019-11-29 22:16:04',NULL,1079,4,NULL,'2019-11-29 22:16:04',0),(NULL,0,'2019-11-29 22:16:04',NULL,1080,4,NULL,'2019-11-29 22:16:04',0),(NULL,0,'2019-11-29 22:16:04',NULL,1081,4,NULL,'2019-11-29 22:16:04',0),(NULL,0,'2019-11-29 22:16:04',NULL,1082,4,NULL,'2019-11-29 22:16:04',0),(NULL,0,'2019-11-29 22:16:05',NULL,1083,3,NULL,'2019-11-29 22:16:05',0),(NULL,0,'2019-11-29 22:16:05',NULL,1084,4,NULL,'2019-11-29 22:16:05',0),(NULL,0,'2019-11-29 22:16:05',NULL,1085,4,NULL,'2019-11-29 22:16:05',0),(NULL,0,'2019-11-29 22:16:05',NULL,1086,4,NULL,'2019-11-29 22:16:05',0),(NULL,0,'2019-11-29 22:16:05',NULL,1087,4,NULL,'2019-11-29 22:16:05',0),(NULL,0,'2019-11-29 22:16:06',NULL,1088,4,NULL,'2019-11-29 22:16:06',0),(NULL,0,'2019-11-29 22:16:06',NULL,1089,4,NULL,'2019-11-29 22:16:06',0),(NULL,0,'2019-11-29 22:16:06',NULL,1090,4,NULL,'2019-11-29 22:16:06',0),(NULL,0,'2019-11-29 22:16:06',NULL,1091,4,NULL,'2019-11-29 22:16:06',0),(NULL,0,'2019-11-29 22:16:07',NULL,1092,4,NULL,'2019-11-29 22:16:07',0),(NULL,0,'2019-11-29 22:16:07',NULL,1093,4,NULL,'2019-11-29 22:16:07',0),(NULL,0,'2019-11-29 22:16:07',NULL,1094,4,NULL,'2019-11-29 22:16:07',0),(NULL,0,'2019-11-29 22:16:07',NULL,1095,4,NULL,'2019-11-29 22:16:07',0),(NULL,0,'2019-11-29 22:16:07',NULL,1096,4,NULL,'2019-11-29 22:16:07',0),(NULL,0,'2019-11-29 22:16:08',NULL,1097,4,NULL,'2019-11-29 22:16:08',0),(NULL,0,'2019-11-29 22:16:08',NULL,1098,4,NULL,'2019-11-29 22:16:08',0),(NULL,0,'2019-11-29 22:16:08',NULL,1099,4,NULL,'2019-11-29 22:16:08',0),(NULL,0,'2019-11-29 22:16:08',NULL,1100,3,NULL,'2019-11-29 22:16:08',0),(NULL,0,'2019-11-29 22:16:08',NULL,1101,4,NULL,'2019-11-29 22:16:08',0),(NULL,0,'2019-11-29 22:16:09',NULL,1102,4,NULL,'2019-11-29 22:16:09',0),(NULL,0,'2019-11-29 22:16:09',NULL,1103,4,NULL,'2019-11-29 22:16:09',0),(NULL,0,'2019-11-29 22:16:09',NULL,1104,4,NULL,'2019-11-29 22:16:09',0),(NULL,0,'2019-11-29 22:16:09',NULL,1105,4,NULL,'2019-11-29 22:16:09',0),(NULL,0,'2019-11-29 22:16:10',NULL,1106,4,NULL,'2019-11-29 22:16:10',0),(NULL,0,'2019-11-29 22:16:10',NULL,1107,4,NULL,'2019-11-29 22:16:10',0),(NULL,0,'2019-11-29 22:16:10',NULL,1108,4,NULL,'2019-11-29 22:16:10',0),(NULL,0,'2019-11-29 22:16:10',NULL,1109,4,NULL,'2019-11-29 22:16:10',0),(NULL,0,'2019-11-29 22:16:11',NULL,1110,4,NULL,'2019-11-29 22:16:11',0),(NULL,0,'2019-11-29 22:16:11',NULL,1111,4,NULL,'2019-11-29 22:16:11',0),(NULL,0,'2019-11-29 22:16:11',NULL,1112,4,NULL,'2019-11-29 22:16:11',0),(NULL,0,'2019-11-29 22:16:11',NULL,1113,4,NULL,'2019-11-29 22:16:11',0),(NULL,0,'2019-11-29 22:16:11',NULL,1114,4,NULL,'2019-11-29 22:16:11',0),(NULL,0,'2019-11-29 22:16:12',NULL,1115,4,NULL,'2019-11-29 22:16:12',0),(NULL,0,'2019-11-29 22:16:12',NULL,1116,4,NULL,'2019-11-29 22:16:12',0),(NULL,0,'2019-11-29 22:16:12',NULL,1117,3,NULL,'2019-11-29 22:16:12',0),(NULL,0,'2019-11-29 22:16:12',NULL,1118,4,NULL,'2019-11-29 22:16:12',0),(NULL,0,'2019-11-29 22:16:12',NULL,1119,4,NULL,'2019-11-29 22:16:12',0),(NULL,0,'2019-11-29 22:16:13',NULL,1120,4,NULL,'2019-11-29 22:16:13',0),(NULL,0,'2019-11-29 22:16:13',NULL,1121,4,NULL,'2019-11-29 22:16:13',0),(NULL,0,'2019-11-29 22:16:13',NULL,1122,4,NULL,'2019-11-29 22:16:13',0),(NULL,0,'2019-11-29 22:16:13',NULL,1123,4,NULL,'2019-11-29 22:16:13',0),(NULL,0,'2019-11-29 22:16:14',NULL,1124,4,NULL,'2019-11-29 22:16:14',0),(NULL,0,'2019-11-29 22:16:14',NULL,1125,4,NULL,'2019-11-29 22:16:14',0),(NULL,0,'2019-11-29 22:16:14',NULL,1126,4,NULL,'2019-11-29 22:16:14',0),(NULL,0,'2019-11-29 22:16:14',NULL,1127,4,NULL,'2019-11-29 22:16:14',0),(NULL,0,'2019-11-29 22:16:15',NULL,1128,4,NULL,'2019-11-29 22:16:15',0),(NULL,0,'2019-11-29 22:16:15',NULL,1129,4,NULL,'2019-11-29 22:16:15',0),(NULL,0,'2019-11-29 22:16:15',NULL,1130,4,NULL,'2019-11-29 22:16:15',0),(NULL,0,'2019-11-29 22:16:15',NULL,1131,4,NULL,'2019-11-29 22:16:15',0),(NULL,0,'2019-11-29 22:16:15',NULL,1132,4,NULL,'2019-11-29 22:16:15',0),(NULL,0,'2019-11-29 22:16:16',NULL,1133,4,NULL,'2019-11-29 22:16:16',0),(NULL,0,'2019-11-29 22:16:16',NULL,1134,3,NULL,'2019-11-29 22:16:16',0),(NULL,0,'2019-11-29 22:16:16',NULL,1135,4,NULL,'2019-11-29 22:16:16',0),(NULL,0,'2019-11-29 22:16:16',NULL,1136,4,NULL,'2019-11-29 22:16:16',0),(NULL,0,'2019-11-29 22:16:16',NULL,1137,4,NULL,'2019-11-29 22:16:16',0),(NULL,0,'2019-11-29 22:16:17',NULL,1138,4,NULL,'2019-11-29 22:16:17',0),(NULL,0,'2019-11-29 22:16:17',NULL,1139,4,NULL,'2019-11-29 22:16:17',0),(NULL,0,'2019-11-29 22:16:17',NULL,1140,4,NULL,'2019-11-29 22:16:17',0),(NULL,0,'2019-11-29 22:16:17',NULL,1141,4,NULL,'2019-11-29 22:16:17',0),(NULL,0,'2019-11-29 22:16:18',NULL,1142,4,NULL,'2019-11-29 22:16:18',0),(NULL,0,'2019-11-29 22:16:18',NULL,1143,4,NULL,'2019-11-29 22:16:18',0),(NULL,0,'2019-11-29 22:16:18',NULL,1144,4,NULL,'2019-11-29 22:16:18',0),(NULL,0,'2019-11-29 22:16:18',NULL,1145,4,NULL,'2019-11-29 22:16:18',0),(NULL,0,'2019-11-29 22:16:19',NULL,1146,4,NULL,'2019-11-29 22:16:19',0),(NULL,0,'2019-11-29 22:16:19',NULL,1147,4,NULL,'2019-11-29 22:16:19',0),(NULL,0,'2019-11-29 22:16:19',NULL,1148,4,NULL,'2019-11-29 22:16:19',0),(NULL,0,'2019-11-29 22:16:19',NULL,1149,4,NULL,'2019-11-29 22:16:19',0),(NULL,0,'2019-11-29 22:16:19',NULL,1150,4,NULL,'2019-11-29 22:16:19',0);
/*!40000 ALTER TABLE `c_cis` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_prv`
--

DROP TABLE IF EXISTS `c_prv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_prv` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `name` varchar(64) NOT NULL,
  `cr_ids` json DEFAULT NULL,
  `is_public` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_prv_deleted` (`deleted`),
  KEY `ix_c_prv_uid` (`uid`),
  KEY `ix_c_prv_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_prv`
--

LOCK TABLES `c_prv` WRITE;
/*!40000 ALTER TABLE `c_prv` DISABLE KEYS */;
INSERT INTO `c_prv` VALUES (NULL,0,'2023-07-11 14:49:12',NULL,1,3,'服务树','[{\"child_id\": 2, \"parent_id\": 1}, {\"child_id\": 3, \"parent_id\": 2}]',0);
/*!40000 ALTER TABLE `c_prv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_psa`
--

DROP TABLE IF EXISTS `c_psa`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_psa` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `type_id` int(11) NOT NULL,
  `attr_id` int(11) DEFAULT NULL,
  `order` smallint(6) DEFAULT NULL,
  `is_fixed` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_psa_uid` (`uid`),
  KEY `ix_c_psa_deleted` (`deleted`),
  CONSTRAINT `c_psa_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`),
  CONSTRAINT `c_psa_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_psa`
--

LOCK TABLES `c_psa` WRITE;
/*!40000 ALTER TABLE `c_psa` DISABLE KEYS */;
INSERT INTO `c_psa` VALUES ('2023-07-11 15:24:39',1,'2023-07-11 14:42:02','2023-07-11 15:24:39',1,3,4,29,0,0),('2023-07-11 15:24:39',1,'2023-07-11 14:42:02','2023-07-11 15:24:39',2,3,4,17,1,0),('2023-07-11 15:24:39',1,'2023-07-11 14:42:02','2023-07-11 15:24:39',3,3,4,28,2,0),(NULL,0,'2023-07-11 14:42:02','2023-07-11 15:24:39',4,3,4,5,0,0),(NULL,0,'2023-07-11 14:42:02','2023-07-11 15:24:39',5,3,4,16,1,0),(NULL,0,'2023-07-11 14:42:02','2023-07-11 15:24:39',6,3,4,15,2,0),(NULL,0,'2023-07-11 14:42:02','2023-07-11 15:24:39',7,3,4,18,3,0),(NULL,0,'2023-07-11 14:42:02','2023-07-11 15:24:39',8,3,4,19,4,0),(NULL,0,'2023-07-11 14:50:42',NULL,9,3,1,1,0,0),(NULL,0,'2023-07-11 14:50:42',NULL,10,3,1,2,1,0),(NULL,0,'2023-07-11 14:50:46',NULL,11,3,2,3,0,0),(NULL,0,'2023-07-11 14:50:46',NULL,12,3,2,2,1,0),(NULL,0,'2023-07-11 14:50:51',NULL,13,3,3,4,0,0),(NULL,0,'2023-07-11 14:50:51',NULL,14,3,3,14,1,0),(NULL,0,'2023-07-11 14:50:51',NULL,15,3,3,10,2,0),(NULL,0,'2023-07-11 14:50:51',NULL,16,3,3,11,3,0),(NULL,0,'2023-07-11 14:50:51',NULL,17,3,3,12,4,0),(NULL,0,'2023-07-11 14:50:51',NULL,18,3,3,13,5,0),(NULL,0,'2023-07-11 15:25:04',NULL,19,3,4,17,5,0),(NULL,0,'2023-07-11 15:25:04',NULL,20,3,4,28,6,0),(NULL,0,'2023-07-11 15:25:04',NULL,21,3,4,29,7,0),(NULL,0,'2023-07-11 15:25:04',NULL,22,3,4,11,8,0),(NULL,0,'2023-07-11 15:25:04',NULL,23,3,4,21,9,0),(NULL,0,'2023-07-11 15:25:04',NULL,24,3,4,47,10,0);
/*!40000 ALTER TABLE `c_psa` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_pso`
--

DROP TABLE IF EXISTS `c_pso`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_pso` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `prv_id` int(11) DEFAULT NULL,
  `ptv_id` int(11) DEFAULT NULL,
  `type_id` int(11) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `option` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `prv_id` (`prv_id`),
  KEY `ptv_id` (`ptv_id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_pso_uid` (`uid`),
  KEY `ix_c_pso_deleted` (`deleted`),
  CONSTRAINT `c_pso_ibfk_1` FOREIGN KEY (`prv_id`) REFERENCES `c_prv` (`id`),
  CONSTRAINT `c_pso_ibfk_2` FOREIGN KEY (`ptv_id`) REFERENCES `c_ptv` (`id`),
  CONSTRAINT `c_pso_ibfk_3` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_pso`
--

LOCK TABLES `c_pso` WRITE;
/*!40000 ALTER TABLE `c_pso` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_pso` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_ptv`
--

DROP TABLE IF EXISTS `c_ptv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_ptv` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `type_id` int(11) NOT NULL,
  `levels` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_id` (`type_id`),
  KEY `ix_c_ptv_uid` (`uid`),
  KEY `ix_c_ptv_deleted` (`deleted`),
  CONSTRAINT `c_ptv_ibfk_1` FOREIGN KEY (`type_id`) REFERENCES `c_ci_types` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_ptv`
--

LOCK TABLES `c_ptv` WRITE;
/*!40000 ALTER TABLE `c_ptv` DISABLE KEYS */;
INSERT INTO `c_ptv` VALUES (NULL,0,'2023-07-11 15:25:18',NULL,1,3,4,'[29, 28, 17]');
/*!40000 ALTER TABLE `c_ptv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_records`
--

DROP TABLE IF EXISTS `c_records`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_records` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `origin` varchar(32) DEFAULT NULL,
  `ticket_id` varchar(32) DEFAULT NULL,
  `reason` text,
  `type_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_records_uid` (`uid`),
  KEY `ix_c_records_deleted` (`deleted`),
  KEY `ix_c_records_type_id` (`type_id`)
) ENGINE=InnoDB AUTO_INCREMENT=15258 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_records`
--

LOCK TABLES `c_records` WRITE;
/*!40000 ALTER TABLE `c_records` DISABLE KEYS */;
INSERT INTO `c_records` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,1,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,2,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,3,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,4,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,5,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,6,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,7,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:14',NULL,8,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,9,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,10,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,11,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,12,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,13,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,14,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,15,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,16,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,17,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,18,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,19,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,20,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,21,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,22,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,23,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,24,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,25,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,26,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,27,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,28,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,29,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,30,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,31,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,32,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,33,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,34,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,35,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,36,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,37,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,38,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,39,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,40,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,41,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,42,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,43,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,44,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,45,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,46,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,47,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,48,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,49,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,50,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,51,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,52,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,53,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,54,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,55,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,56,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,57,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,58,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,59,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,60,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,61,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,62,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,63,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,64,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,65,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,66,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,67,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,68,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,69,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,70,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,71,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,72,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,73,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,74,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:15',NULL,75,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,76,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,77,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,78,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,79,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,80,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,81,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,82,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,83,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,84,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,85,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,86,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,87,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,88,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,89,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,90,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,91,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,92,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,93,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,94,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,95,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,96,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,97,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,98,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,99,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:16',NULL,147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:17',NULL,214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:18',NULL,279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:19',NULL,349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:20',NULL,416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:21',NULL,481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:22',NULL,545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:23',NULL,613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:24',NULL,681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:25',NULL,749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:26',NULL,815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:27',NULL,885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:28',NULL,954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:29',NULL,1019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:30',NULL,1085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:31',NULL,1150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:32',NULL,1220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:33',NULL,1291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:34',NULL,1357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:35',NULL,1423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:36',NULL,1491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:37',NULL,1557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:38',NULL,1627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:39',NULL,1696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:40',NULL,1762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:41',NULL,1828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:42',NULL,1898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:43',NULL,1967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,1999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:44',NULL,2035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:45',NULL,2099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:46',NULL,2167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:47',NULL,2234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:48',NULL,2304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:49',NULL,2369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:50',NULL,2440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:51',NULL,2505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:52',NULL,2569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:53',NULL,2634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:54',NULL,2703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:55',NULL,2770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:56',NULL,2842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:57',NULL,2908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:58',NULL,2976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,2999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:12:59',NULL,3047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:00',NULL,3115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:01',NULL,3183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:02',NULL,3251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:03',NULL,3322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:04',NULL,3389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:05',NULL,3457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:06',NULL,3527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:07',NULL,3599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:08',NULL,3666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:09',NULL,3734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:10',NULL,3806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:11',NULL,3875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:12',NULL,3941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,3999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:13',NULL,4009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:14',NULL,4080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:15',NULL,4144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:16',NULL,4215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:17',NULL,4282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:18',NULL,4355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:19',NULL,4422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:20',NULL,4491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:21',NULL,4561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:22',NULL,4632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:23',NULL,4699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:24',NULL,4766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:25',NULL,4837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:26',NULL,4908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:27',NULL,4974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,4999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:28',NULL,5042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:29',NULL,5113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:30',NULL,5180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:31',NULL,5248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:32',NULL,5316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:33',NULL,5387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:34',NULL,5451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:35',NULL,5522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:36',NULL,5590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:37',NULL,5660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:38',NULL,5728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:39',NULL,5797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:40',NULL,5865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:41',NULL,5936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,5999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,6000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,6001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,6002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,6003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:42',NULL,6004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:43',NULL,6071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:44',NULL,6141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:45',NULL,6204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:46',NULL,6276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:47',NULL,6346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:48',NULL,6415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:49',NULL,6481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:50',NULL,6553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:51',NULL,6621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:52',NULL,6690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:53',NULL,6758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:54',NULL,6830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:55',NULL,6897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:56',NULL,6968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,6999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:57',NULL,7035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:58',NULL,7104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:13:59',NULL,7171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:00',NULL,7237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:01',NULL,7306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:02',NULL,7378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:03',NULL,7445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:04',NULL,7512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:05',NULL,7582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:06',NULL,7652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:07',NULL,7719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:08',NULL,7786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:09',NULL,7856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:10',NULL,7927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:11',NULL,7995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,7996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,7997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,7998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,7999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:12',NULL,8062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:13',NULL,8130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:14',NULL,8200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:15',NULL,8265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:16',NULL,8310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:17',NULL,8356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:18',NULL,8401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:19',NULL,8445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:20',NULL,8491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:21',NULL,8535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:22',NULL,8579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:23',NULL,8623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:24',NULL,8669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:25',NULL,8713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:26',NULL,8757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:27',NULL,8802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:28',NULL,8847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:29',NULL,8891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:30',NULL,8936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:31',NULL,8980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,8999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:32',NULL,9025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:33',NULL,9070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:34',NULL,9114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:35',NULL,9159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:36',NULL,9204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:37',NULL,9247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:38',NULL,9292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:39',NULL,9336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:40',NULL,9381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:41',NULL,9426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:42',NULL,9470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:43',NULL,9515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:44',NULL,9559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:45',NULL,9603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:46',NULL,9647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:47',NULL,9692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:48',NULL,9739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:49',NULL,9783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:50',NULL,9827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:51',NULL,9871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:52',NULL,9917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:53',NULL,9961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,9999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:54',NULL,10005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:55',NULL,10050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:56',NULL,10095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:57',NULL,10139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:58',NULL,10183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:14:59',NULL,10228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:00',NULL,10273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:01',NULL,10317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:02',NULL,10362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:03',NULL,10406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:04',NULL,10451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:05',NULL,10496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:06',NULL,10541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:07',NULL,10585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:08',NULL,10630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:09',NULL,10675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:10',NULL,10721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:11',NULL,10764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:12',NULL,10810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:13',NULL,10856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:14',NULL,10901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:15',NULL,10943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:16',NULL,10989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,10999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:17',NULL,11035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:18',NULL,11081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:19',NULL,11120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:20',NULL,11186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:21',NULL,11257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:22',NULL,11328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:23',NULL,11395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:24',NULL,11462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:25',NULL,11533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:26',NULL,11603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:27',NULL,11669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:28',NULL,11737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:29',NULL,11809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:30',NULL,11878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:31',NULL,11944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,11999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:32',NULL,12012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:33',NULL,12083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:34',NULL,12152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:35',NULL,12218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:36',NULL,12286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:37',NULL,12357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:38',NULL,12426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:39',NULL,12493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:40',NULL,12563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:41',NULL,12634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:42',NULL,12701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:43',NULL,12768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:44',NULL,12835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:45',NULL,12904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:46',NULL,12972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,12999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:47',NULL,13040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:48',NULL,13111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:49',NULL,13182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:50',NULL,13246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:51',NULL,13315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:52',NULL,13384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:53',NULL,13451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:54',NULL,13522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:55',NULL,13590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:56',NULL,13660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:57',NULL,13727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:58',NULL,13794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:15:59',NULL,13863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:00',NULL,13931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:01',NULL,13998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,13999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:02',NULL,14069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:03',NULL,14138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:04',NULL,14208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14251,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14252,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14253,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14254,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14255,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14256,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14257,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14258,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14259,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14260,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14261,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14262,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14263,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14264,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14265,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14266,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14267,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14268,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14269,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14270,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14271,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14272,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14273,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14274,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:05',NULL,14275,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14276,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14277,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14278,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14279,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14280,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14281,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14282,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14283,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14284,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14285,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14286,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14287,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14288,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14289,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14290,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14291,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14292,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14293,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14294,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14295,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14296,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14297,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14298,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14299,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14300,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14301,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14302,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14303,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14304,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14305,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14306,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14307,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14308,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14309,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14310,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14311,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14312,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14313,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14314,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14315,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14316,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14317,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14318,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14319,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14320,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14321,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14322,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14323,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14324,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14325,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14326,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14327,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14328,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14329,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14330,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14331,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14332,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14333,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14334,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14335,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14336,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14337,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14338,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14339,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14340,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14341,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14342,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14343,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14344,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14345,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:06',NULL,14346,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14347,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14348,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14349,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14350,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14351,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14352,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14353,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14354,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14355,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14356,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14357,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14358,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14359,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14360,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14361,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14362,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14363,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14364,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14365,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14366,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14367,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14368,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14369,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14370,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14371,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14372,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14373,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14374,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14375,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14376,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14377,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14378,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14379,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14380,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14381,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14382,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14383,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14384,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14385,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14386,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14387,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14388,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14389,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14390,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14391,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14392,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14393,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14394,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14395,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14396,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14397,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14398,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14399,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14400,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14401,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14402,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14403,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14404,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14405,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14406,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14407,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14408,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14409,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14410,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14411,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14412,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:07',NULL,14413,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14414,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14415,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14416,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14417,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14418,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14419,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14420,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14421,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14422,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14423,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14424,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14425,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14426,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14427,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14428,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14429,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14430,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14431,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14432,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14433,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14434,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14435,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14436,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14437,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14438,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14439,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14440,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14441,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14442,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14443,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14444,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14445,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14446,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14447,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14448,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14449,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14450,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14451,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14452,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14453,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14454,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14455,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14456,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14457,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14458,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14459,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14460,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14461,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14462,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14463,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14464,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14465,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14466,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14467,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14468,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14469,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14470,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14471,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14472,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14473,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14474,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14475,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14476,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14477,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14478,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14479,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:08',NULL,14480,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14481,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14482,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14483,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14484,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14485,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14486,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14487,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14488,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14489,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14490,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14491,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14492,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14493,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14494,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14495,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14496,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14497,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14498,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14499,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14500,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14501,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14502,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14503,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14504,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14505,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14506,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14507,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14508,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14509,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14510,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14511,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14512,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14513,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14514,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14515,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14516,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14517,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14518,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14519,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14520,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14521,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14522,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14523,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14524,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14525,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14526,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14527,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14528,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14529,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14530,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14531,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14532,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14533,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14534,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14535,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14536,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14537,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14538,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14539,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14540,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14541,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14542,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14543,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14544,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14545,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14546,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14547,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14548,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14549,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14550,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:09',NULL,14551,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14552,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14553,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14554,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14555,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14556,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14557,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14558,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14559,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14560,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14561,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14562,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14563,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14564,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14565,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14566,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14567,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14568,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14569,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14570,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14571,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14572,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14573,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14574,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14575,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14576,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14577,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14578,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14579,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14580,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14581,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14582,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14583,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14584,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14585,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14586,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14587,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14588,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14589,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14590,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14591,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14592,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14593,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14594,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14595,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14596,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14597,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14598,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14599,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14600,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14601,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14602,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14603,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14604,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14605,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14606,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14607,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14608,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14609,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14610,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14611,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14612,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14613,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14614,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14615,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14616,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14617,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14618,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14619,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14620,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:10',NULL,14621,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14622,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14623,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14624,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14625,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14626,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14627,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14628,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14629,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14630,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14631,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14632,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14633,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14634,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14635,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14636,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14637,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14638,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14639,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14640,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14641,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14642,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14643,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14644,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14645,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14646,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14647,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14648,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14649,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14650,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14651,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14652,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14653,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14654,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14655,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14656,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14657,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14658,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14659,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14660,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14661,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14662,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14663,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14664,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14665,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14666,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14667,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14668,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14669,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14670,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14671,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14672,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14673,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14674,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14675,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14676,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14677,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14678,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14679,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14680,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14681,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14682,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14683,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14684,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14685,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14686,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14687,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14688,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14689,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:11',NULL,14690,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14691,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14692,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14693,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14694,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14695,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14696,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14697,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14698,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14699,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14700,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14701,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14702,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14703,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14704,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14705,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14706,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14707,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14708,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14709,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14710,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14711,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14712,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14713,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14714,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14715,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14716,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14717,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14718,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14719,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14720,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14721,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14722,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14723,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14724,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14725,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14726,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14727,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14728,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14729,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14730,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14731,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14732,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14733,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14734,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14735,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14736,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14737,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14738,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14739,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14740,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14741,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14742,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14743,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14744,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14745,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14746,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14747,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14748,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14749,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14750,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14751,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14752,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14753,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14754,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14755,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:12',NULL,14756,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14757,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14758,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14759,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14760,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14761,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14762,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14763,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14764,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14765,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14766,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14767,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14768,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14769,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14770,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14771,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14772,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14773,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14774,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14775,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14776,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14777,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14778,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14779,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14780,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14781,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14782,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14783,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14784,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14785,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14786,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14787,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14788,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14789,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14790,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14791,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14792,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14793,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14794,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14795,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14796,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14797,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14798,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14799,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14800,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14801,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14802,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14803,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14804,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14805,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14806,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14807,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14808,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14809,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14810,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14811,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14812,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14813,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14814,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14815,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14816,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14817,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14818,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14819,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14820,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14821,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14822,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14823,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14824,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14825,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14826,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:13',NULL,14827,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14828,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14829,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14830,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14831,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14832,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14833,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14834,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14835,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14836,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14837,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14838,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14839,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14840,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14841,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14842,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14843,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14844,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14845,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14846,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14847,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14848,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14849,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14850,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14851,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14852,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14853,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14854,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14855,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14856,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14857,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14858,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14859,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14860,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14861,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14862,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14863,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14864,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14865,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14866,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14867,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14868,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14869,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14870,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14871,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14872,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14873,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14874,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14875,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14876,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14877,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14878,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14879,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14880,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14881,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14882,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14883,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14884,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14885,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14886,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14887,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14888,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14889,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14890,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14891,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14892,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14893,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14894,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:14',NULL,14895,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14896,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14897,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14898,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14899,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14900,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14901,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14902,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14903,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14904,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14905,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14906,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14907,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14908,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14909,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14910,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14911,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14912,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14913,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14914,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14915,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14916,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14917,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14918,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14919,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14920,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14921,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14922,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14923,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14924,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14925,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14926,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14927,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14928,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14929,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14930,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14931,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14932,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14933,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14934,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14935,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14936,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14937,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14938,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14939,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14940,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14941,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14942,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14943,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14944,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14945,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14946,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14947,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14948,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14949,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14950,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14951,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14952,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14953,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14954,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14955,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14956,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14957,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14958,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14959,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14960,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14961,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14962,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14963,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:15',NULL,14964,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14965,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14966,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14967,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14968,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14969,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14970,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14971,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14972,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14973,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14974,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14975,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14976,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14977,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14978,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14979,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14980,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14981,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14982,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14983,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14984,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14985,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14986,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14987,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14988,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14989,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14990,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14991,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14992,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14993,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14994,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14995,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14996,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14997,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14998,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,14999,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15000,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15001,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15002,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15003,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15004,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15005,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15006,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15007,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15008,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15009,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15010,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15011,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15012,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15013,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15014,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15015,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15016,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15017,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15018,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15019,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15020,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15021,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15022,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15023,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15024,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15025,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15026,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15027,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15028,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15029,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15030,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:16',NULL,15031,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15032,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15033,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15034,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15035,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15036,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15037,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15038,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15039,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15040,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15041,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15042,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15043,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15044,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15045,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15046,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15047,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15048,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15049,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15050,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15051,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15052,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15053,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15054,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15055,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15056,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15057,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15058,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15059,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15060,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15061,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15062,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15063,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15064,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15065,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15066,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15067,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15068,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15069,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15070,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15071,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15072,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15073,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15074,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15075,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15076,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15077,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15078,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15079,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15080,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15081,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15082,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15083,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15084,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15085,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15086,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15087,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15088,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15089,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15090,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15091,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15092,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15093,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15094,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15095,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15096,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15097,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15098,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15099,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15100,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15101,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:17',NULL,15102,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15103,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15104,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15105,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15106,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15107,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15108,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15109,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15110,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15111,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15112,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15113,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15114,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15115,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15116,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15117,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15118,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15119,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15120,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15121,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15122,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15123,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15124,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15125,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15126,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15127,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15128,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15129,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15130,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15131,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15132,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15133,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15134,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15135,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15136,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15137,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15138,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15139,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15140,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15141,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15142,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15143,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15144,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15145,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15146,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15147,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15148,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15149,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15150,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15151,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15152,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15153,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15154,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15155,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15156,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15157,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15158,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15159,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15160,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15161,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15162,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15163,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15164,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15165,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15166,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15167,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15168,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15169,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:18',NULL,15170,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15171,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15172,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15173,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15174,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15175,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15176,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15177,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15178,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15179,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15180,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15181,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15182,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15183,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15184,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15185,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15186,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15187,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15188,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15189,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15190,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15191,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15192,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15193,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15194,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15195,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15196,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15197,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15198,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15199,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15200,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15201,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15202,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15203,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15204,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15205,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15206,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15207,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15208,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15209,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15210,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15211,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15212,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15213,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15214,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15215,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15216,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15217,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15218,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15219,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15220,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15221,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15222,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15223,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15224,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15225,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15226,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15227,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15228,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15229,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15230,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15231,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15232,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15233,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15234,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15235,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15236,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15237,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15238,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:19',NULL,15239,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15240,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15241,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15242,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15243,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15244,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15245,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15246,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15247,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15248,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15249,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-11-29 22:16:20',NULL,15250,1,NULL,NULL,NULL,NULL),(NULL,0,'2019-12-11 12:00:44',NULL,15251,2,NULL,NULL,NULL,NULL),(NULL,0,'2019-12-11 12:09:47',NULL,15252,3,NULL,NULL,NULL,NULL),(NULL,0,'2019-12-11 12:09:52',NULL,15253,3,NULL,NULL,NULL,NULL),(NULL,0,'2020-02-23 17:47:28',NULL,15254,3,NULL,NULL,NULL,NULL),(NULL,0,'2020-02-23 17:47:30',NULL,15255,3,NULL,NULL,NULL,NULL),(NULL,0,'2020-02-23 17:47:31',NULL,15256,3,NULL,NULL,NULL,NULL),(NULL,0,'2020-02-23 17:47:35',NULL,15257,3,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `c_records` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_relation_histories`
--

DROP TABLE IF EXISTS `c_relation_histories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_relation_histories` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `operate_type` enum('0','1') DEFAULT NULL,
  `record_id` int(11) NOT NULL,
  `first_ci_id` int(11) DEFAULT NULL,
  `second_ci_id` int(11) DEFAULT NULL,
  `relation_type_id` int(11) DEFAULT NULL,
  `relation_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `record_id` (`record_id`),
  KEY `relation_type_id` (`relation_type_id`),
  KEY `ix_c_relation_histories_deleted` (`deleted`),
  CONSTRAINT `c_relation_histories_ibfk_1` FOREIGN KEY (`record_id`) REFERENCES `c_records` (`id`),
  CONSTRAINT `c_relation_histories_ibfk_2` FOREIGN KEY (`relation_type_id`) REFERENCES `c_relation_types` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=841 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_relation_histories`
--

LOCK TABLES `c_relation_histories` WRITE;
/*!40000 ALTER TABLE `c_relation_histories` DISABLE KEYS */;
INSERT INTO `c_relation_histories` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,1,'0',3,53,54,1,1),(NULL,0,'2019-11-29 22:12:14',NULL,2,'0',5,54,55,1,2),(NULL,0,'2019-11-29 22:12:15',NULL,3,'0',21,55,56,1,3),(NULL,0,'2019-11-29 22:12:15',NULL,4,'0',37,55,57,1,4),(NULL,0,'2019-11-29 22:12:15',NULL,5,'0',53,55,58,1,5),(NULL,0,'2019-11-29 22:12:15',NULL,6,'0',69,55,59,1,6),(NULL,0,'2019-11-29 22:12:16',NULL,7,'0',85,55,60,1,7),(NULL,0,'2019-11-29 22:12:16',NULL,8,'0',101,55,61,1,8),(NULL,0,'2019-11-29 22:12:16',NULL,9,'0',117,55,62,1,9),(NULL,0,'2019-11-29 22:12:16',NULL,10,'0',133,55,63,1,10),(NULL,0,'2019-11-29 22:12:17',NULL,11,'0',149,55,64,1,11),(NULL,0,'2019-11-29 22:12:17',NULL,12,'0',165,55,65,1,12),(NULL,0,'2019-11-29 22:12:17',NULL,13,'0',181,55,66,1,13),(NULL,0,'2019-11-29 22:12:17',NULL,14,'0',197,55,67,1,14),(NULL,0,'2019-11-29 22:12:17',NULL,15,'0',213,55,68,1,15),(NULL,0,'2019-11-29 22:12:18',NULL,16,'0',229,55,69,1,16),(NULL,0,'2019-11-29 22:12:18',NULL,17,'0',245,55,70,1,17),(NULL,0,'2019-11-29 22:12:18',NULL,18,'0',261,55,71,1,18),(NULL,0,'2019-11-29 22:12:18',NULL,19,'0',263,54,72,1,19),(NULL,0,'2019-11-29 22:12:18',NULL,20,'0',279,72,73,1,20),(NULL,0,'2019-11-29 22:12:19',NULL,21,'0',295,72,74,1,21),(NULL,0,'2019-11-29 22:12:19',NULL,22,'0',311,72,75,1,22),(NULL,0,'2019-11-29 22:12:19',NULL,23,'0',327,72,76,1,23),(NULL,0,'2019-11-29 22:12:19',NULL,24,'0',343,72,77,1,24),(NULL,0,'2019-11-29 22:12:20',NULL,25,'0',359,72,78,1,25),(NULL,0,'2019-11-29 22:12:20',NULL,26,'0',375,72,79,1,26),(NULL,0,'2019-11-29 22:12:20',NULL,27,'0',391,72,80,1,27),(NULL,0,'2019-11-29 22:12:20',NULL,28,'0',407,72,81,1,28),(NULL,0,'2019-11-29 22:12:21',NULL,29,'0',423,72,82,1,29),(NULL,0,'2019-11-29 22:12:21',NULL,30,'0',439,72,83,1,30),(NULL,0,'2019-11-29 22:12:21',NULL,31,'0',455,72,84,1,31),(NULL,0,'2019-11-29 22:12:21',NULL,32,'0',471,72,85,1,32),(NULL,0,'2019-11-29 22:12:22',NULL,33,'0',487,72,86,1,33),(NULL,0,'2019-11-29 22:12:22',NULL,34,'0',503,72,87,1,34),(NULL,0,'2019-11-29 22:12:22',NULL,35,'0',519,72,88,1,35),(NULL,0,'2019-11-29 22:12:22',NULL,36,'0',521,54,89,1,36),(NULL,0,'2019-11-29 22:12:22',NULL,37,'0',537,89,90,1,37),(NULL,0,'2019-11-29 22:12:23',NULL,38,'0',553,89,91,1,38),(NULL,0,'2019-11-29 22:12:23',NULL,39,'0',569,89,92,1,39),(NULL,0,'2019-11-29 22:12:23',NULL,40,'0',585,89,93,1,40),(NULL,0,'2019-11-29 22:12:23',NULL,41,'0',601,89,94,1,41),(NULL,0,'2019-11-29 22:12:24',NULL,42,'0',617,89,95,1,42),(NULL,0,'2019-11-29 22:12:24',NULL,43,'0',633,89,96,1,43),(NULL,0,'2019-11-29 22:12:24',NULL,44,'0',649,89,97,1,44),(NULL,0,'2019-11-29 22:12:24',NULL,45,'0',665,89,98,1,45),(NULL,0,'2019-11-29 22:12:24',NULL,46,'0',681,89,99,1,46),(NULL,0,'2019-11-29 22:12:25',NULL,47,'0',697,89,100,1,47),(NULL,0,'2019-11-29 22:12:25',NULL,48,'0',713,89,101,1,48),(NULL,0,'2019-11-29 22:12:25',NULL,49,'0',729,89,102,1,49),(NULL,0,'2019-11-29 22:12:25',NULL,50,'0',745,89,103,1,50),(NULL,0,'2019-11-29 22:12:26',NULL,51,'0',761,89,104,1,51),(NULL,0,'2019-11-29 22:12:26',NULL,52,'0',777,89,105,1,52),(NULL,0,'2019-11-29 22:12:26',NULL,53,'0',779,54,106,1,53),(NULL,0,'2019-11-29 22:12:26',NULL,54,'0',795,106,107,1,54),(NULL,0,'2019-11-29 22:12:26',NULL,55,'0',811,106,108,1,55),(NULL,0,'2019-11-29 22:12:27',NULL,56,'0',827,106,109,1,56),(NULL,0,'2019-11-29 22:12:27',NULL,57,'0',843,106,110,1,57),(NULL,0,'2019-11-29 22:12:27',NULL,58,'0',859,106,111,1,58),(NULL,0,'2019-11-29 22:12:27',NULL,59,'0',875,106,112,1,59),(NULL,0,'2019-11-29 22:12:28',NULL,60,'0',891,106,113,1,60),(NULL,0,'2019-11-29 22:12:28',NULL,61,'0',907,106,114,1,61),(NULL,0,'2019-11-29 22:12:28',NULL,62,'0',923,106,115,1,62),(NULL,0,'2019-11-29 22:12:28',NULL,63,'0',939,106,116,1,63),(NULL,0,'2019-11-29 22:12:29',NULL,64,'0',955,106,117,1,64),(NULL,0,'2019-11-29 22:12:29',NULL,65,'0',971,106,118,1,65),(NULL,0,'2019-11-29 22:12:29',NULL,66,'0',987,106,119,1,66),(NULL,0,'2019-11-29 22:12:29',NULL,67,'0',1003,106,120,1,67),(NULL,0,'2019-11-29 22:12:29',NULL,68,'0',1019,106,121,1,68),(NULL,0,'2019-11-29 22:12:30',NULL,69,'0',1035,106,122,1,69),(NULL,0,'2019-11-29 22:12:30',NULL,70,'0',1037,54,123,1,70),(NULL,0,'2019-11-29 22:12:30',NULL,71,'0',1053,123,124,1,71),(NULL,0,'2019-11-29 22:12:30',NULL,72,'0',1069,123,125,1,72),(NULL,0,'2019-11-29 22:12:31',NULL,73,'0',1085,123,126,1,73),(NULL,0,'2019-11-29 22:12:31',NULL,74,'0',1101,123,127,1,74),(NULL,0,'2019-11-29 22:12:31',NULL,75,'0',1117,123,128,1,75),(NULL,0,'2019-11-29 22:12:31',NULL,76,'0',1133,123,129,1,76),(NULL,0,'2019-11-29 22:12:31',NULL,77,'0',1149,123,130,1,77),(NULL,0,'2019-11-29 22:12:32',NULL,78,'0',1165,123,131,1,78),(NULL,0,'2019-11-29 22:12:32',NULL,79,'0',1181,123,132,1,79),(NULL,0,'2019-11-29 22:12:32',NULL,80,'0',1197,123,133,1,80),(NULL,0,'2019-11-29 22:12:32',NULL,81,'0',1213,123,134,1,81),(NULL,0,'2019-11-29 22:12:33',NULL,82,'0',1229,123,135,1,82),(NULL,0,'2019-11-29 22:12:33',NULL,83,'0',1245,123,136,1,83),(NULL,0,'2019-11-29 22:12:33',NULL,84,'0',1261,123,137,1,84),(NULL,0,'2019-11-29 22:12:33',NULL,85,'0',1277,123,138,1,85),(NULL,0,'2019-11-29 22:12:34',NULL,86,'0',1293,123,139,1,86),(NULL,0,'2019-11-29 22:12:34',NULL,87,'0',1295,54,140,1,87),(NULL,0,'2019-11-29 22:12:34',NULL,88,'0',1311,140,141,1,88),(NULL,0,'2019-11-29 22:12:34',NULL,89,'0',1327,140,142,1,89),(NULL,0,'2019-11-29 22:12:34',NULL,90,'0',1343,140,143,1,90),(NULL,0,'2019-11-29 22:12:35',NULL,91,'0',1359,140,144,1,91),(NULL,0,'2019-11-29 22:12:35',NULL,92,'0',1375,140,145,1,92),(NULL,0,'2019-11-29 22:12:35',NULL,93,'0',1391,140,146,1,93),(NULL,0,'2019-11-29 22:12:35',NULL,94,'0',1407,140,147,1,94),(NULL,0,'2019-11-29 22:12:35',NULL,95,'0',1423,140,148,1,95),(NULL,0,'2019-11-29 22:12:36',NULL,96,'0',1439,140,149,1,96),(NULL,0,'2019-11-29 22:12:36',NULL,97,'0',1455,140,150,1,97),(NULL,0,'2019-11-29 22:12:36',NULL,98,'0',1471,140,151,1,98),(NULL,0,'2019-11-29 22:12:36',NULL,99,'0',1487,140,152,1,99),(NULL,0,'2019-11-29 22:12:37',NULL,100,'0',1503,140,153,1,100),(NULL,0,'2019-11-29 22:12:37',NULL,101,'0',1519,140,154,1,101),(NULL,0,'2019-11-29 22:12:37',NULL,102,'0',1535,140,155,1,102),(NULL,0,'2019-11-29 22:12:37',NULL,103,'0',1551,140,156,1,103),(NULL,0,'2019-11-29 22:12:37',NULL,104,'0',1553,54,157,1,104),(NULL,0,'2019-11-29 22:12:38',NULL,105,'0',1569,157,158,1,105),(NULL,0,'2019-11-29 22:12:38',NULL,106,'0',1585,157,159,1,106),(NULL,0,'2019-11-29 22:12:38',NULL,107,'0',1601,157,160,1,107),(NULL,0,'2019-11-29 22:12:38',NULL,108,'0',1617,157,161,1,108),(NULL,0,'2019-11-29 22:12:39',NULL,109,'0',1633,157,162,1,109),(NULL,0,'2019-11-29 22:12:39',NULL,110,'0',1649,157,163,1,110),(NULL,0,'2019-11-29 22:12:39',NULL,111,'0',1665,157,164,1,111),(NULL,0,'2019-11-29 22:12:39',NULL,112,'0',1681,157,165,1,112),(NULL,0,'2019-11-29 22:12:40',NULL,113,'0',1697,157,166,1,113),(NULL,0,'2019-11-29 22:12:40',NULL,114,'0',1713,157,167,1,114),(NULL,0,'2019-11-29 22:12:40',NULL,115,'0',1729,157,168,1,115),(NULL,0,'2019-11-29 22:12:40',NULL,116,'0',1745,157,169,1,116),(NULL,0,'2019-11-29 22:12:40',NULL,117,'0',1761,157,170,1,117),(NULL,0,'2019-11-29 22:12:41',NULL,118,'0',1777,157,171,1,118),(NULL,0,'2019-11-29 22:12:41',NULL,119,'0',1793,157,172,1,119),(NULL,0,'2019-11-29 22:12:41',NULL,120,'0',1809,157,173,1,120),(NULL,0,'2019-11-29 22:12:41',NULL,121,'0',1811,54,174,1,121),(NULL,0,'2019-11-29 22:12:41',NULL,122,'0',1827,174,175,1,122),(NULL,0,'2019-11-29 22:12:42',NULL,123,'0',1843,174,176,1,123),(NULL,0,'2019-11-29 22:12:42',NULL,124,'0',1859,174,177,1,124),(NULL,0,'2019-11-29 22:12:42',NULL,125,'0',1875,174,178,1,125),(NULL,0,'2019-11-29 22:12:42',NULL,126,'0',1891,174,179,1,126),(NULL,0,'2019-11-29 22:12:43',NULL,127,'0',1907,174,180,1,127),(NULL,0,'2019-11-29 22:12:43',NULL,128,'0',1923,174,181,1,128),(NULL,0,'2019-11-29 22:12:43',NULL,129,'0',1939,174,182,1,129),(NULL,0,'2019-11-29 22:12:43',NULL,130,'0',1955,174,183,1,130),(NULL,0,'2019-11-29 22:12:44',NULL,131,'0',1971,174,184,1,131),(NULL,0,'2019-11-29 22:12:44',NULL,132,'0',1987,174,185,1,132),(NULL,0,'2019-11-29 22:12:44',NULL,133,'0',2003,174,186,1,133),(NULL,0,'2019-11-29 22:12:44',NULL,134,'0',2019,174,187,1,134),(NULL,0,'2019-11-29 22:12:44',NULL,135,'0',2035,174,188,1,135),(NULL,0,'2019-11-29 22:12:45',NULL,136,'0',2051,174,189,1,136),(NULL,0,'2019-11-29 22:12:45',NULL,137,'0',2067,174,190,1,137),(NULL,0,'2019-11-29 22:12:45',NULL,138,'0',2069,53,191,1,138),(NULL,0,'2019-11-29 22:12:45',NULL,139,'0',2071,191,192,1,139),(NULL,0,'2019-11-29 22:12:45',NULL,140,'0',2087,192,193,1,140),(NULL,0,'2019-11-29 22:12:46',NULL,141,'0',2103,192,194,1,141),(NULL,0,'2019-11-29 22:12:46',NULL,142,'0',2119,192,195,1,142),(NULL,0,'2019-11-29 22:12:46',NULL,143,'0',2135,192,196,1,143),(NULL,0,'2019-11-29 22:12:46',NULL,144,'0',2151,192,197,1,144),(NULL,0,'2019-11-29 22:12:46',NULL,145,'0',2167,192,198,1,145),(NULL,0,'2019-11-29 22:12:47',NULL,146,'0',2183,192,199,1,146),(NULL,0,'2019-11-29 22:12:47',NULL,147,'0',2199,192,200,1,147),(NULL,0,'2019-11-29 22:12:47',NULL,148,'0',2215,192,201,1,148),(NULL,0,'2019-11-29 22:12:47',NULL,149,'0',2231,192,202,1,149),(NULL,0,'2019-11-29 22:12:48',NULL,150,'0',2247,192,203,1,150),(NULL,0,'2019-11-29 22:12:48',NULL,151,'0',2263,192,204,1,151),(NULL,0,'2019-11-29 22:12:48',NULL,152,'0',2279,192,205,1,152),(NULL,0,'2019-11-29 22:12:48',NULL,153,'0',2295,192,206,1,153),(NULL,0,'2019-11-29 22:12:49',NULL,154,'0',2311,192,207,1,154),(NULL,0,'2019-11-29 22:12:49',NULL,155,'0',2327,192,208,1,155),(NULL,0,'2019-11-29 22:12:49',NULL,156,'0',2329,191,209,1,156),(NULL,0,'2019-11-29 22:12:49',NULL,157,'0',2345,209,210,1,157),(NULL,0,'2019-11-29 22:12:49',NULL,158,'0',2361,209,211,1,158),(NULL,0,'2019-11-29 22:12:50',NULL,159,'0',2377,209,212,1,159),(NULL,0,'2019-11-29 22:12:50',NULL,160,'0',2393,209,213,1,160),(NULL,0,'2019-11-29 22:12:50',NULL,161,'0',2409,209,214,1,161),(NULL,0,'2019-11-29 22:12:50',NULL,162,'0',2425,209,215,1,162),(NULL,0,'2019-11-29 22:12:51',NULL,163,'0',2441,209,216,1,163),(NULL,0,'2019-11-29 22:12:51',NULL,164,'0',2457,209,217,1,164),(NULL,0,'2019-11-29 22:12:51',NULL,165,'0',2473,209,218,1,165),(NULL,0,'2019-11-29 22:12:51',NULL,166,'0',2489,209,219,1,166),(NULL,0,'2019-11-29 22:12:51',NULL,167,'0',2505,209,220,1,167),(NULL,0,'2019-11-29 22:12:52',NULL,168,'0',2521,209,221,1,168),(NULL,0,'2019-11-29 22:12:52',NULL,169,'0',2537,209,222,1,169),(NULL,0,'2019-11-29 22:12:52',NULL,170,'0',2553,209,223,1,170),(NULL,0,'2019-11-29 22:12:52',NULL,171,'0',2569,209,224,1,171),(NULL,0,'2019-11-29 22:12:53',NULL,172,'0',2585,209,225,1,172),(NULL,0,'2019-11-29 22:12:53',NULL,173,'0',2587,191,226,1,173),(NULL,0,'2019-11-29 22:12:53',NULL,174,'0',2603,226,227,1,174),(NULL,0,'2019-11-29 22:12:53',NULL,175,'0',2619,226,228,1,175),(NULL,0,'2019-11-29 22:12:54',NULL,176,'0',2635,226,229,1,176),(NULL,0,'2019-11-29 22:12:54',NULL,177,'0',2651,226,230,1,177),(NULL,0,'2019-11-29 22:12:54',NULL,178,'0',2667,226,231,1,178),(NULL,0,'2019-11-29 22:12:54',NULL,179,'0',2683,226,232,1,179),(NULL,0,'2019-11-29 22:12:54',NULL,180,'0',2699,226,233,1,180),(NULL,0,'2019-11-29 22:12:55',NULL,181,'0',2715,226,234,1,181),(NULL,0,'2019-11-29 22:12:55',NULL,182,'0',2731,226,235,1,182),(NULL,0,'2019-11-29 22:12:55',NULL,183,'0',2747,226,236,1,183),(NULL,0,'2019-11-29 22:12:55',NULL,184,'0',2763,226,237,1,184),(NULL,0,'2019-11-29 22:12:56',NULL,185,'0',2779,226,238,1,185),(NULL,0,'2019-11-29 22:12:56',NULL,186,'0',2795,226,239,1,186),(NULL,0,'2019-11-29 22:12:56',NULL,187,'0',2811,226,240,1,187),(NULL,0,'2019-11-29 22:12:56',NULL,188,'0',2827,226,241,1,188),(NULL,0,'2019-11-29 22:12:57',NULL,189,'0',2843,226,242,1,189),(NULL,0,'2019-11-29 22:12:57',NULL,190,'0',2845,191,243,1,190),(NULL,0,'2019-11-29 22:12:57',NULL,191,'0',2861,243,244,1,191),(NULL,0,'2019-11-29 22:12:57',NULL,192,'0',2877,243,245,1,192),(NULL,0,'2019-11-29 22:12:57',NULL,193,'0',2893,243,246,1,193),(NULL,0,'2019-11-29 22:12:58',NULL,194,'0',2909,243,247,1,194),(NULL,0,'2019-11-29 22:12:58',NULL,195,'0',2925,243,248,1,195),(NULL,0,'2019-11-29 22:12:58',NULL,196,'0',2941,243,249,1,196),(NULL,0,'2019-11-29 22:12:58',NULL,197,'0',2957,243,250,1,197),(NULL,0,'2019-11-29 22:12:58',NULL,198,'0',2973,243,251,1,198),(NULL,0,'2019-11-29 22:12:59',NULL,199,'0',2989,243,252,1,199),(NULL,0,'2019-11-29 22:12:59',NULL,200,'0',3005,243,253,1,200),(NULL,0,'2019-11-29 22:12:59',NULL,201,'0',3021,243,254,1,201),(NULL,0,'2019-11-29 22:12:59',NULL,202,'0',3037,243,255,1,202),(NULL,0,'2019-11-29 22:13:00',NULL,203,'0',3053,243,256,1,203),(NULL,0,'2019-11-29 22:13:00',NULL,204,'0',3069,243,257,1,204),(NULL,0,'2019-11-29 22:13:00',NULL,205,'0',3085,243,258,1,205),(NULL,0,'2019-11-29 22:13:00',NULL,206,'0',3101,243,259,1,206),(NULL,0,'2019-11-29 22:13:00',NULL,207,'0',3103,191,260,1,207),(NULL,0,'2019-11-29 22:13:01',NULL,208,'0',3119,260,261,1,208),(NULL,0,'2019-11-29 22:13:01',NULL,209,'0',3135,260,262,1,209),(NULL,0,'2019-11-29 22:13:01',NULL,210,'0',3151,260,263,1,210),(NULL,0,'2019-11-29 22:13:01',NULL,211,'0',3167,260,264,1,211),(NULL,0,'2019-11-29 22:13:01',NULL,212,'0',3183,260,265,1,212),(NULL,0,'2019-11-29 22:13:02',NULL,213,'0',3199,260,266,1,213),(NULL,0,'2019-11-29 22:13:02',NULL,214,'0',3215,260,267,1,214),(NULL,0,'2019-11-29 22:13:02',NULL,215,'0',3231,260,268,1,215),(NULL,0,'2019-11-29 22:13:02',NULL,216,'0',3247,260,269,1,216),(NULL,0,'2019-11-29 22:13:03',NULL,217,'0',3263,260,270,1,217),(NULL,0,'2019-11-29 22:13:03',NULL,218,'0',3279,260,271,1,218),(NULL,0,'2019-11-29 22:13:03',NULL,219,'0',3295,260,272,1,219),(NULL,0,'2019-11-29 22:13:03',NULL,220,'0',3311,260,273,1,220),(NULL,0,'2019-11-29 22:13:04',NULL,221,'0',3327,260,274,1,221),(NULL,0,'2019-11-29 22:13:04',NULL,222,'0',3343,260,275,1,222),(NULL,0,'2019-11-29 22:13:04',NULL,223,'0',3359,260,276,1,223),(NULL,0,'2019-11-29 22:13:04',NULL,224,'0',3361,191,277,1,224),(NULL,0,'2019-11-29 22:13:04',NULL,225,'0',3377,277,278,1,225),(NULL,0,'2019-11-29 22:13:05',NULL,226,'0',3393,277,279,1,226),(NULL,0,'2019-11-29 22:13:05',NULL,227,'0',3409,277,280,1,227),(NULL,0,'2019-11-29 22:13:05',NULL,228,'0',3425,277,281,1,228),(NULL,0,'2019-11-29 22:13:05',NULL,229,'0',3441,277,282,1,229),(NULL,0,'2019-11-29 22:13:05',NULL,230,'0',3457,277,283,1,230),(NULL,0,'2019-11-29 22:13:06',NULL,231,'0',3473,277,284,1,231),(NULL,0,'2019-11-29 22:13:06',NULL,232,'0',3489,277,285,1,232),(NULL,0,'2019-11-29 22:13:06',NULL,233,'0',3505,277,286,1,233),(NULL,0,'2019-11-29 22:13:06',NULL,234,'0',3521,277,287,1,234),(NULL,0,'2019-11-29 22:13:07',NULL,235,'0',3537,277,288,1,235),(NULL,0,'2019-11-29 22:13:07',NULL,236,'0',3553,277,289,1,236),(NULL,0,'2019-11-29 22:13:07',NULL,237,'0',3569,277,290,1,237),(NULL,0,'2019-11-29 22:13:07',NULL,238,'0',3585,277,291,1,238),(NULL,0,'2019-11-29 22:13:08',NULL,239,'0',3601,277,292,1,239),(NULL,0,'2019-11-29 22:13:08',NULL,240,'0',3617,277,293,1,240),(NULL,0,'2019-11-29 22:13:08',NULL,241,'0',3619,191,294,1,241),(NULL,0,'2019-11-29 22:13:08',NULL,242,'0',3635,294,295,1,242),(NULL,0,'2019-11-29 22:13:08',NULL,243,'0',3651,294,296,1,243),(NULL,0,'2019-11-29 22:13:09',NULL,244,'0',3667,294,297,1,244),(NULL,0,'2019-11-29 22:13:09',NULL,245,'0',3683,294,298,1,245),(NULL,0,'2019-11-29 22:13:09',NULL,246,'0',3699,294,299,1,246),(NULL,0,'2019-11-29 22:13:09',NULL,247,'0',3715,294,300,1,247),(NULL,0,'2019-11-29 22:13:09',NULL,248,'0',3731,294,301,1,248),(NULL,0,'2019-11-29 22:13:10',NULL,249,'0',3747,294,302,1,249),(NULL,0,'2019-11-29 22:13:10',NULL,250,'0',3763,294,303,1,250),(NULL,0,'2019-11-29 22:13:10',NULL,251,'0',3779,294,304,1,251),(NULL,0,'2019-11-29 22:13:10',NULL,252,'0',3795,294,305,1,252),(NULL,0,'2019-11-29 22:13:11',NULL,253,'0',3811,294,306,1,253),(NULL,0,'2019-11-29 22:13:11',NULL,254,'0',3827,294,307,1,254),(NULL,0,'2019-11-29 22:13:11',NULL,255,'0',3843,294,308,1,255),(NULL,0,'2019-11-29 22:13:11',NULL,256,'0',3859,294,309,1,256),(NULL,0,'2019-11-29 22:13:11',NULL,257,'0',3875,294,310,1,257),(NULL,0,'2019-11-29 22:13:12',NULL,258,'0',3877,191,311,1,258),(NULL,0,'2019-11-29 22:13:12',NULL,259,'0',3893,311,312,1,259),(NULL,0,'2019-11-29 22:13:12',NULL,260,'0',3909,311,313,1,260),(NULL,0,'2019-11-29 22:13:12',NULL,261,'0',3925,311,314,1,261),(NULL,0,'2019-11-29 22:13:12',NULL,262,'0',3941,311,315,1,262),(NULL,0,'2019-11-29 22:13:13',NULL,263,'0',3957,311,316,1,263),(NULL,0,'2019-11-29 22:13:13',NULL,264,'0',3973,311,317,1,264),(NULL,0,'2019-11-29 22:13:13',NULL,265,'0',3989,311,318,1,265),(NULL,0,'2019-11-29 22:13:13',NULL,266,'0',4005,311,319,1,266),(NULL,0,'2019-11-29 22:13:14',NULL,267,'0',4021,311,320,1,267),(NULL,0,'2019-11-29 22:13:14',NULL,268,'0',4037,311,321,1,268),(NULL,0,'2019-11-29 22:13:14',NULL,269,'0',4053,311,322,1,269),(NULL,0,'2019-11-29 22:13:14',NULL,270,'0',4069,311,323,1,270),(NULL,0,'2019-11-29 22:13:15',NULL,271,'0',4085,311,324,1,271),(NULL,0,'2019-11-29 22:13:15',NULL,272,'0',4101,311,325,1,272),(NULL,0,'2019-11-29 22:13:15',NULL,273,'0',4117,311,326,1,273),(NULL,0,'2019-11-29 22:13:15',NULL,274,'0',4133,311,327,1,274),(NULL,0,'2019-11-29 22:13:15',NULL,275,'0',4135,53,328,1,275),(NULL,0,'2019-11-29 22:13:15',NULL,276,'0',4137,328,329,1,276),(NULL,0,'2019-11-29 22:13:16',NULL,277,'0',4153,329,330,1,277),(NULL,0,'2019-11-29 22:13:16',NULL,278,'0',4169,329,331,1,278),(NULL,0,'2019-11-29 22:13:16',NULL,279,'0',4185,329,332,1,279),(NULL,0,'2019-11-29 22:13:16',NULL,280,'0',4201,329,333,1,280),(NULL,0,'2019-11-29 22:13:17',NULL,281,'0',4217,329,334,1,281),(NULL,0,'2019-11-29 22:13:17',NULL,282,'0',4233,329,335,1,282),(NULL,0,'2019-11-29 22:13:17',NULL,283,'0',4249,329,336,1,283),(NULL,0,'2019-11-29 22:13:17',NULL,284,'0',4265,329,337,1,284),(NULL,0,'2019-11-29 22:13:17',NULL,285,'0',4281,329,338,1,285),(NULL,0,'2019-11-29 22:13:18',NULL,286,'0',4297,329,339,1,286),(NULL,0,'2019-11-29 22:13:18',NULL,287,'0',4313,329,340,1,287),(NULL,0,'2019-11-29 22:13:18',NULL,288,'0',4329,329,341,1,288),(NULL,0,'2019-11-29 22:13:18',NULL,289,'0',4345,329,342,1,289),(NULL,0,'2019-11-29 22:13:19',NULL,290,'0',4361,329,343,1,290),(NULL,0,'2019-11-29 22:13:19',NULL,291,'0',4377,329,344,1,291),(NULL,0,'2019-11-29 22:13:19',NULL,292,'0',4393,329,345,1,292),(NULL,0,'2019-11-29 22:13:19',NULL,293,'0',4395,328,346,1,293),(NULL,0,'2019-11-29 22:13:19',NULL,294,'0',4411,346,347,1,294),(NULL,0,'2019-11-29 22:13:20',NULL,295,'0',4427,346,348,1,295),(NULL,0,'2019-11-29 22:13:20',NULL,296,'0',4443,346,349,1,296),(NULL,0,'2019-11-29 22:13:20',NULL,297,'0',4459,346,350,1,297),(NULL,0,'2019-11-29 22:13:20',NULL,298,'0',4475,346,351,1,298),(NULL,0,'2019-11-29 22:13:20',NULL,299,'0',4491,346,352,1,299),(NULL,0,'2019-11-29 22:13:21',NULL,300,'0',4507,346,353,1,300),(NULL,0,'2019-11-29 22:13:21',NULL,301,'0',4523,346,354,1,301),(NULL,0,'2019-11-29 22:13:21',NULL,302,'0',4539,346,355,1,302),(NULL,0,'2019-11-29 22:13:21',NULL,303,'0',4555,346,356,1,303),(NULL,0,'2019-11-29 22:13:22',NULL,304,'0',4571,346,357,1,304),(NULL,0,'2019-11-29 22:13:22',NULL,305,'0',4587,346,358,1,305),(NULL,0,'2019-11-29 22:13:22',NULL,306,'0',4603,346,359,1,306),(NULL,0,'2019-11-29 22:13:22',NULL,307,'0',4619,346,360,1,307),(NULL,0,'2019-11-29 22:13:23',NULL,308,'0',4635,346,361,1,308),(NULL,0,'2019-11-29 22:13:23',NULL,309,'0',4651,346,362,1,309),(NULL,0,'2019-11-29 22:13:23',NULL,310,'0',4653,328,363,1,310),(NULL,0,'2019-11-29 22:13:23',NULL,311,'0',4669,363,364,1,311),(NULL,0,'2019-11-29 22:13:23',NULL,312,'0',4685,363,365,1,312),(NULL,0,'2019-11-29 22:13:24',NULL,313,'0',4701,363,366,1,313),(NULL,0,'2019-11-29 22:13:24',NULL,314,'0',4717,363,367,1,314),(NULL,0,'2019-11-29 22:13:24',NULL,315,'0',4733,363,368,1,315),(NULL,0,'2019-11-29 22:13:24',NULL,316,'0',4749,363,369,1,316),(NULL,0,'2019-11-29 22:13:24',NULL,317,'0',4765,363,370,1,317),(NULL,0,'2019-11-29 22:13:25',NULL,318,'0',4781,363,371,1,318),(NULL,0,'2019-11-29 22:13:25',NULL,319,'0',4797,363,372,1,319),(NULL,0,'2019-11-29 22:13:25',NULL,320,'0',4813,363,373,1,320),(NULL,0,'2019-11-29 22:13:25',NULL,321,'0',4829,363,374,1,321),(NULL,0,'2019-11-29 22:13:26',NULL,322,'0',4845,363,375,1,322),(NULL,0,'2019-11-29 22:13:26',NULL,323,'0',4861,363,376,1,323),(NULL,0,'2019-11-29 22:13:26',NULL,324,'0',4877,363,377,1,324),(NULL,0,'2019-11-29 22:13:26',NULL,325,'0',4893,363,378,1,325),(NULL,0,'2019-11-29 22:13:27',NULL,326,'0',4909,363,379,1,326),(NULL,0,'2019-11-29 22:13:27',NULL,327,'0',4911,328,380,1,327),(NULL,0,'2019-11-29 22:13:27',NULL,328,'0',4927,380,381,1,328),(NULL,0,'2019-11-29 22:13:27',NULL,329,'0',4943,380,382,1,329),(NULL,0,'2019-11-29 22:13:27',NULL,330,'0',4959,380,383,1,330),(NULL,0,'2019-11-29 22:13:28',NULL,331,'0',4975,380,384,1,331),(NULL,0,'2019-11-29 22:13:28',NULL,332,'0',4991,380,385,1,332),(NULL,0,'2019-11-29 22:13:28',NULL,333,'0',5007,380,386,1,333),(NULL,0,'2019-11-29 22:13:28',NULL,334,'0',5023,380,387,1,334),(NULL,0,'2019-11-29 22:13:28',NULL,335,'0',5039,380,388,1,335),(NULL,0,'2019-11-29 22:13:29',NULL,336,'0',5055,380,389,1,336),(NULL,0,'2019-11-29 22:13:29',NULL,337,'0',5071,380,390,1,337),(NULL,0,'2019-11-29 22:13:29',NULL,338,'0',5087,380,391,1,338),(NULL,0,'2019-11-29 22:13:29',NULL,339,'0',5103,380,392,1,339),(NULL,0,'2019-11-29 22:13:30',NULL,340,'0',5119,380,393,1,340),(NULL,0,'2019-11-29 22:13:30',NULL,341,'0',5135,380,394,1,341),(NULL,0,'2019-11-29 22:13:30',NULL,342,'0',5151,380,395,1,342),(NULL,0,'2019-11-29 22:13:30',NULL,343,'0',5167,380,396,1,343),(NULL,0,'2019-11-29 22:13:30',NULL,344,'0',5169,328,397,1,344),(NULL,0,'2019-11-29 22:13:31',NULL,345,'0',5185,397,398,1,345),(NULL,0,'2019-11-29 22:13:31',NULL,346,'0',5201,397,399,1,346),(NULL,0,'2019-11-29 22:13:31',NULL,347,'0',5217,397,400,1,347),(NULL,0,'2019-11-29 22:13:31',NULL,348,'0',5233,397,401,1,348),(NULL,0,'2019-11-29 22:13:32',NULL,349,'0',5249,397,402,1,349),(NULL,0,'2019-11-29 22:13:32',NULL,350,'0',5265,397,403,1,350),(NULL,0,'2019-11-29 22:13:32',NULL,351,'0',5281,397,404,1,351),(NULL,0,'2019-11-29 22:13:32',NULL,352,'0',5297,397,405,1,352),(NULL,0,'2019-11-29 22:13:32',NULL,353,'0',5313,397,406,1,353),(NULL,0,'2019-11-29 22:13:33',NULL,354,'0',5329,397,407,1,354),(NULL,0,'2019-11-29 22:13:33',NULL,355,'0',5345,397,408,1,355),(NULL,0,'2019-11-29 22:13:33',NULL,356,'0',5361,397,409,1,356),(NULL,0,'2019-11-29 22:13:33',NULL,357,'0',5377,397,410,1,357),(NULL,0,'2019-11-29 22:13:34',NULL,358,'0',5393,397,411,1,358),(NULL,0,'2019-11-29 22:13:34',NULL,359,'0',5409,397,412,1,359),(NULL,0,'2019-11-29 22:13:34',NULL,360,'0',5425,397,413,1,360),(NULL,0,'2019-11-29 22:13:34',NULL,361,'0',5427,328,414,1,361),(NULL,0,'2019-11-29 22:13:34',NULL,362,'0',5443,414,415,1,362),(NULL,0,'2019-11-29 22:13:35',NULL,363,'0',5459,414,416,1,363),(NULL,0,'2019-11-29 22:13:35',NULL,364,'0',5475,414,417,1,364),(NULL,0,'2019-11-29 22:13:35',NULL,365,'0',5491,414,418,1,365),(NULL,0,'2019-11-29 22:13:35',NULL,366,'0',5507,414,419,1,366),(NULL,0,'2019-11-29 22:13:36',NULL,367,'0',5523,414,420,1,367),(NULL,0,'2019-11-29 22:13:36',NULL,368,'0',5539,414,421,1,368),(NULL,0,'2019-11-29 22:13:36',NULL,369,'0',5555,414,422,1,369),(NULL,0,'2019-11-29 22:13:36',NULL,370,'0',5571,414,423,1,370),(NULL,0,'2019-11-29 22:13:36',NULL,371,'0',5587,414,424,1,371),(NULL,0,'2019-11-29 22:13:37',NULL,372,'0',5603,414,425,1,372),(NULL,0,'2019-11-29 22:13:37',NULL,373,'0',5619,414,426,1,373),(NULL,0,'2019-11-29 22:13:37',NULL,374,'0',5635,414,427,1,374),(NULL,0,'2019-11-29 22:13:37',NULL,375,'0',5651,414,428,1,375),(NULL,0,'2019-11-29 22:13:38',NULL,376,'0',5667,414,429,1,376),(NULL,0,'2019-11-29 22:13:38',NULL,377,'0',5683,414,430,1,377),(NULL,0,'2019-11-29 22:13:38',NULL,378,'0',5685,328,431,1,378),(NULL,0,'2019-11-29 22:13:38',NULL,379,'0',5701,431,432,1,379),(NULL,0,'2019-11-29 22:13:38',NULL,380,'0',5717,431,433,1,380),(NULL,0,'2019-11-29 22:13:39',NULL,381,'0',5733,431,434,1,381),(NULL,0,'2019-11-29 22:13:39',NULL,382,'0',5749,431,435,1,382),(NULL,0,'2019-11-29 22:13:39',NULL,383,'0',5765,431,436,1,383),(NULL,0,'2019-11-29 22:13:39',NULL,384,'0',5781,431,437,1,384),(NULL,0,'2019-11-29 22:13:39',NULL,385,'0',5797,431,438,1,385),(NULL,0,'2019-11-29 22:13:40',NULL,386,'0',5813,431,439,1,386),(NULL,0,'2019-11-29 22:13:40',NULL,387,'0',5829,431,440,1,387),(NULL,0,'2019-11-29 22:13:40',NULL,388,'0',5845,431,441,1,388),(NULL,0,'2019-11-29 22:13:40',NULL,389,'0',5861,431,442,1,389),(NULL,0,'2019-11-29 22:13:41',NULL,390,'0',5877,431,443,1,390),(NULL,0,'2019-11-29 22:13:41',NULL,391,'0',5893,431,444,1,391),(NULL,0,'2019-11-29 22:13:41',NULL,392,'0',5909,431,445,1,392),(NULL,0,'2019-11-29 22:13:41',NULL,393,'0',5925,431,446,1,393),(NULL,0,'2019-11-29 22:13:42',NULL,394,'0',5941,431,447,1,394),(NULL,0,'2019-11-29 22:13:42',NULL,395,'0',5943,328,448,1,395),(NULL,0,'2019-11-29 22:13:42',NULL,396,'0',5959,448,449,1,396),(NULL,0,'2019-11-29 22:13:42',NULL,397,'0',5975,448,450,1,397),(NULL,0,'2019-11-29 22:13:42',NULL,398,'0',5991,448,451,1,398),(NULL,0,'2019-11-29 22:13:43',NULL,399,'0',6007,448,452,1,399),(NULL,0,'2019-11-29 22:13:43',NULL,400,'0',6023,448,453,1,400),(NULL,0,'2019-11-29 22:13:43',NULL,401,'0',6039,448,454,1,401),(NULL,0,'2019-11-29 22:13:43',NULL,402,'0',6055,448,455,1,402),(NULL,0,'2019-11-29 22:13:43',NULL,403,'0',6071,448,456,1,403),(NULL,0,'2019-11-29 22:13:44',NULL,404,'0',6087,448,457,1,404),(NULL,0,'2019-11-29 22:13:44',NULL,405,'0',6103,448,458,1,405),(NULL,0,'2019-11-29 22:13:44',NULL,406,'0',6119,448,459,1,406),(NULL,0,'2019-11-29 22:13:44',NULL,407,'0',6135,448,460,1,407),(NULL,0,'2019-11-29 22:13:45',NULL,408,'0',6151,448,461,1,408),(NULL,0,'2019-11-29 22:13:45',NULL,409,'0',6167,448,462,1,409),(NULL,0,'2019-11-29 22:13:45',NULL,410,'0',6183,448,463,1,410),(NULL,0,'2019-11-29 22:13:45',NULL,411,'0',6199,448,464,1,411),(NULL,0,'2019-11-29 22:13:45',NULL,412,'0',6201,53,465,1,412),(NULL,0,'2019-11-29 22:13:45',NULL,413,'0',6203,465,466,1,413),(NULL,0,'2019-11-29 22:13:46',NULL,414,'0',6219,466,467,1,414),(NULL,0,'2019-11-29 22:13:46',NULL,415,'0',6235,466,468,1,415),(NULL,0,'2019-11-29 22:13:46',NULL,416,'0',6251,466,469,1,416),(NULL,0,'2019-11-29 22:13:46',NULL,417,'0',6267,466,470,1,417),(NULL,0,'2019-11-29 22:13:47',NULL,418,'0',6283,466,471,1,418),(NULL,0,'2019-11-29 22:13:47',NULL,419,'0',6299,466,472,1,419),(NULL,0,'2019-11-29 22:13:47',NULL,420,'0',6315,466,473,1,420),(NULL,0,'2019-11-29 22:13:47',NULL,421,'0',6331,466,474,1,421),(NULL,0,'2019-11-29 22:13:48',NULL,422,'0',6347,466,475,1,422),(NULL,0,'2019-11-29 22:13:48',NULL,423,'0',6363,466,476,1,423),(NULL,0,'2019-11-29 22:13:48',NULL,424,'0',6379,466,477,1,424),(NULL,0,'2019-11-29 22:13:48',NULL,425,'0',6395,466,478,1,425),(NULL,0,'2019-11-29 22:13:48',NULL,426,'0',6411,466,479,1,426),(NULL,0,'2019-11-29 22:13:49',NULL,427,'0',6427,466,480,1,427),(NULL,0,'2019-11-29 22:13:49',NULL,428,'0',6443,466,481,1,428),(NULL,0,'2019-11-29 22:13:49',NULL,429,'0',6459,466,482,1,429),(NULL,0,'2019-11-29 22:13:49',NULL,430,'0',6461,465,483,1,430),(NULL,0,'2019-11-29 22:13:49',NULL,431,'0',6477,483,484,1,431),(NULL,0,'2019-11-29 22:13:50',NULL,432,'0',6493,483,485,1,432),(NULL,0,'2019-11-29 22:13:50',NULL,433,'0',6509,483,486,1,433),(NULL,0,'2019-11-29 22:13:50',NULL,434,'0',6525,483,487,1,434),(NULL,0,'2019-11-29 22:13:50',NULL,435,'0',6541,483,488,1,435),(NULL,0,'2019-11-29 22:13:51',NULL,436,'0',6557,483,489,1,436),(NULL,0,'2019-11-29 22:13:51',NULL,437,'0',6573,483,490,1,437),(NULL,0,'2019-11-29 22:13:51',NULL,438,'0',6589,483,491,1,438),(NULL,0,'2019-11-29 22:13:51',NULL,439,'0',6605,483,492,1,439),(NULL,0,'2019-11-29 22:13:51',NULL,440,'0',6621,483,493,1,440),(NULL,0,'2019-11-29 22:13:52',NULL,441,'0',6637,483,494,1,441),(NULL,0,'2019-11-29 22:13:52',NULL,442,'0',6653,483,495,1,442),(NULL,0,'2019-11-29 22:13:52',NULL,443,'0',6669,483,496,1,443),(NULL,0,'2019-11-29 22:13:52',NULL,444,'0',6685,483,497,1,444),(NULL,0,'2019-11-29 22:13:53',NULL,445,'0',6701,483,498,1,445),(NULL,0,'2019-11-29 22:13:53',NULL,446,'0',6717,483,499,1,446),(NULL,0,'2019-11-29 22:13:53',NULL,447,'0',6719,465,500,1,447),(NULL,0,'2019-11-29 22:13:53',NULL,448,'0',6735,500,501,1,448),(NULL,0,'2019-11-29 22:13:53',NULL,449,'0',6751,500,502,1,449),(NULL,0,'2019-11-29 22:13:54',NULL,450,'0',6767,500,503,1,450),(NULL,0,'2019-11-29 22:13:54',NULL,451,'0',6783,500,504,1,451),(NULL,0,'2019-11-29 22:13:54',NULL,452,'0',6799,500,505,1,452),(NULL,0,'2019-11-29 22:13:54',NULL,453,'0',6815,500,506,1,453),(NULL,0,'2019-11-29 22:13:55',NULL,454,'0',6831,500,507,1,454),(NULL,0,'2019-11-29 22:13:55',NULL,455,'0',6847,500,508,1,455),(NULL,0,'2019-11-29 22:13:55',NULL,456,'0',6863,500,509,1,456),(NULL,0,'2019-11-29 22:13:55',NULL,457,'0',6879,500,510,1,457),(NULL,0,'2019-11-29 22:13:55',NULL,458,'0',6895,500,511,1,458),(NULL,0,'2019-11-29 22:13:56',NULL,459,'0',6911,500,512,1,459),(NULL,0,'2019-11-29 22:13:56',NULL,460,'0',6927,500,513,1,460),(NULL,0,'2019-11-29 22:13:56',NULL,461,'0',6943,500,514,1,461),(NULL,0,'2019-11-29 22:13:56',NULL,462,'0',6959,500,515,1,462),(NULL,0,'2019-11-29 22:13:57',NULL,463,'0',6975,500,516,1,463),(NULL,0,'2019-11-29 22:13:57',NULL,464,'0',6977,465,517,1,464),(NULL,0,'2019-11-29 22:13:57',NULL,465,'0',6993,517,518,1,465),(NULL,0,'2019-11-29 22:13:57',NULL,466,'0',7009,517,519,1,466),(NULL,0,'2019-11-29 22:13:57',NULL,467,'0',7025,517,520,1,467),(NULL,0,'2019-11-29 22:13:58',NULL,468,'0',7041,517,521,1,468),(NULL,0,'2019-11-29 22:13:58',NULL,469,'0',7057,517,522,1,469),(NULL,0,'2019-11-29 22:13:58',NULL,470,'0',7073,517,523,1,470),(NULL,0,'2019-11-29 22:13:58',NULL,471,'0',7089,517,524,1,471),(NULL,0,'2019-11-29 22:13:59',NULL,472,'0',7105,517,525,1,472),(NULL,0,'2019-11-29 22:13:59',NULL,473,'0',7121,517,526,1,473),(NULL,0,'2019-11-29 22:13:59',NULL,474,'0',7137,517,527,1,474),(NULL,0,'2019-11-29 22:13:59',NULL,475,'0',7153,517,528,1,475),(NULL,0,'2019-11-29 22:13:59',NULL,476,'0',7169,517,529,1,476),(NULL,0,'2019-11-29 22:14:00',NULL,477,'0',7185,517,530,1,477),(NULL,0,'2019-11-29 22:14:00',NULL,478,'0',7201,517,531,1,478),(NULL,0,'2019-11-29 22:14:00',NULL,479,'0',7217,517,532,1,479),(NULL,0,'2019-11-29 22:14:00',NULL,480,'0',7233,517,533,1,480),(NULL,0,'2019-11-29 22:14:00',NULL,481,'0',7235,465,534,1,481),(NULL,0,'2019-11-29 22:14:01',NULL,482,'0',7251,534,535,1,482),(NULL,0,'2019-11-29 22:14:01',NULL,483,'0',7267,534,536,1,483),(NULL,0,'2019-11-29 22:14:01',NULL,484,'0',7283,534,537,1,484),(NULL,0,'2019-11-29 22:14:01',NULL,485,'0',7299,534,538,1,485),(NULL,0,'2019-11-29 22:14:02',NULL,486,'0',7315,534,539,1,486),(NULL,0,'2019-11-29 22:14:02',NULL,487,'0',7331,534,540,1,487),(NULL,0,'2019-11-29 22:14:02',NULL,488,'0',7347,534,541,1,488),(NULL,0,'2019-11-29 22:14:02',NULL,489,'0',7363,534,542,1,489),(NULL,0,'2019-11-29 22:14:03',NULL,490,'0',7379,534,543,1,490),(NULL,0,'2019-11-29 22:14:03',NULL,491,'0',7395,534,544,1,491),(NULL,0,'2019-11-29 22:14:03',NULL,492,'0',7411,534,545,1,492),(NULL,0,'2019-11-29 22:14:03',NULL,493,'0',7427,534,546,1,493),(NULL,0,'2019-11-29 22:14:03',NULL,494,'0',7443,534,547,1,494),(NULL,0,'2019-11-29 22:14:04',NULL,495,'0',7459,534,548,1,495),(NULL,0,'2019-11-29 22:14:04',NULL,496,'0',7475,534,549,1,496),(NULL,0,'2019-11-29 22:14:04',NULL,497,'0',7491,534,550,1,497),(NULL,0,'2019-11-29 22:14:04',NULL,498,'0',7493,465,551,1,498),(NULL,0,'2019-11-29 22:14:04',NULL,499,'0',7509,551,552,1,499),(NULL,0,'2019-11-29 22:14:05',NULL,500,'0',7525,551,553,1,500),(NULL,0,'2019-11-29 22:14:05',NULL,501,'0',7541,551,554,1,501),(NULL,0,'2019-11-29 22:14:05',NULL,502,'0',7557,551,555,1,502),(NULL,0,'2019-11-29 22:14:05',NULL,503,'0',7573,551,556,1,503),(NULL,0,'2019-11-29 22:14:06',NULL,504,'0',7589,551,557,1,504),(NULL,0,'2019-11-29 22:14:06',NULL,505,'0',7605,551,558,1,505),(NULL,0,'2019-11-29 22:14:06',NULL,506,'0',7621,551,559,1,506),(NULL,0,'2019-11-29 22:14:06',NULL,507,'0',7637,551,560,1,507),(NULL,0,'2019-11-29 22:14:07',NULL,508,'0',7653,551,561,1,508),(NULL,0,'2019-11-29 22:14:07',NULL,509,'0',7669,551,562,1,509),(NULL,0,'2019-11-29 22:14:07',NULL,510,'0',7685,551,563,1,510),(NULL,0,'2019-11-29 22:14:07',NULL,511,'0',7701,551,564,1,511),(NULL,0,'2019-11-29 22:14:07',NULL,512,'0',7717,551,565,1,512),(NULL,0,'2019-11-29 22:14:08',NULL,513,'0',7733,551,566,1,513),(NULL,0,'2019-11-29 22:14:08',NULL,514,'0',7749,551,567,1,514),(NULL,0,'2019-11-29 22:14:08',NULL,515,'0',7751,465,568,1,515),(NULL,0,'2019-11-29 22:14:08',NULL,516,'0',7767,568,569,1,516),(NULL,0,'2019-11-29 22:14:08',NULL,517,'0',7783,568,570,1,517),(NULL,0,'2019-11-29 22:14:09',NULL,518,'0',7799,568,571,1,518),(NULL,0,'2019-11-29 22:14:09',NULL,519,'0',7815,568,572,1,519),(NULL,0,'2019-11-29 22:14:09',NULL,520,'0',7831,568,573,1,520),(NULL,0,'2019-11-29 22:14:09',NULL,521,'0',7847,568,574,1,521),(NULL,0,'2019-11-29 22:14:10',NULL,522,'0',7863,568,575,1,522),(NULL,0,'2019-11-29 22:14:10',NULL,523,'0',7879,568,576,1,523),(NULL,0,'2019-11-29 22:14:10',NULL,524,'0',7895,568,577,1,524),(NULL,0,'2019-11-29 22:14:10',NULL,525,'0',7911,568,578,1,525),(NULL,0,'2019-11-29 22:14:11',NULL,526,'0',7927,568,579,1,526),(NULL,0,'2019-11-29 22:14:11',NULL,527,'0',7943,568,580,1,527),(NULL,0,'2019-11-29 22:14:11',NULL,528,'0',7959,568,581,1,528),(NULL,0,'2019-11-29 22:14:11',NULL,529,'0',7975,568,582,1,529),(NULL,0,'2019-11-29 22:14:11',NULL,530,'0',7991,568,583,1,530),(NULL,0,'2019-11-29 22:14:12',NULL,531,'0',8007,568,584,1,531),(NULL,0,'2019-11-29 22:14:12',NULL,532,'0',8009,465,585,1,532),(NULL,0,'2019-11-29 22:14:12',NULL,533,'0',8025,585,586,1,533),(NULL,0,'2019-11-29 22:14:12',NULL,534,'0',8041,585,587,1,534),(NULL,0,'2019-11-29 22:14:12',NULL,535,'0',8057,585,588,1,535),(NULL,0,'2019-11-29 22:14:13',NULL,536,'0',8073,585,589,1,536),(NULL,0,'2019-11-29 22:14:13',NULL,537,'0',8089,585,590,1,537),(NULL,0,'2019-11-29 22:14:13',NULL,538,'0',8105,585,591,1,538),(NULL,0,'2019-11-29 22:14:13',NULL,539,'0',8121,585,592,1,539),(NULL,0,'2019-11-29 22:14:14',NULL,540,'0',8137,585,593,1,540),(NULL,0,'2019-11-29 22:14:14',NULL,541,'0',8153,585,594,1,541),(NULL,0,'2019-11-29 22:14:14',NULL,542,'0',8169,585,595,1,542),(NULL,0,'2019-11-29 22:14:14',NULL,543,'0',8185,585,596,1,543),(NULL,0,'2019-11-29 22:14:15',NULL,544,'0',8201,585,597,1,544),(NULL,0,'2019-11-29 22:14:15',NULL,545,'0',8217,585,598,1,545),(NULL,0,'2019-11-29 22:14:15',NULL,546,'0',8233,585,599,1,546),(NULL,0,'2019-11-29 22:14:15',NULL,547,'0',8249,585,600,1,547),(NULL,0,'2019-11-29 22:14:15',NULL,548,'0',8265,585,601,1,548),(NULL,0,'2019-11-29 22:14:16',NULL,549,'0',8268,602,603,1,549),(NULL,0,'2019-11-29 22:14:16',NULL,550,'0',8270,603,604,1,550),(NULL,0,'2019-11-29 22:14:20',NULL,551,'0',8448,603,621,1,551),(NULL,0,'2019-11-29 22:14:24',NULL,552,'0',8626,603,638,1,552),(NULL,0,'2019-11-29 22:14:28',NULL,553,'0',8804,603,655,1,553),(NULL,0,'2019-11-29 22:14:32',NULL,554,'0',8982,603,672,1,554),(NULL,0,'2019-11-29 22:14:36',NULL,555,'0',9160,603,689,1,555),(NULL,0,'2019-11-29 22:14:40',NULL,556,'0',9338,603,706,1,556),(NULL,0,'2019-11-29 22:14:44',NULL,557,'0',9516,603,723,1,557),(NULL,0,'2019-11-29 22:14:48',NULL,558,'0',9694,602,740,1,558),(NULL,0,'2019-11-29 22:14:48',NULL,559,'0',9696,740,741,1,559),(NULL,0,'2019-11-29 22:14:52',NULL,560,'0',9874,740,758,1,560),(NULL,0,'2019-11-29 22:14:56',NULL,561,'0',10052,740,775,1,561),(NULL,0,'2019-11-29 22:15:00',NULL,562,'0',10230,740,792,1,562),(NULL,0,'2019-11-29 22:15:04',NULL,563,'0',10408,740,809,1,563),(NULL,0,'2019-11-29 22:15:08',NULL,564,'0',10586,740,826,1,564),(NULL,0,'2019-11-29 22:15:11',NULL,565,'0',10764,740,843,1,565),(NULL,0,'2019-11-29 22:15:15',NULL,566,'0',10942,740,860,1,566),(NULL,0,'2019-11-29 22:15:19',NULL,567,'0',11120,602,877,1,567),(NULL,0,'2019-11-29 22:15:20',NULL,568,'0',11122,877,878,1,568),(NULL,0,'2019-11-29 22:15:20',NULL,569,'0',11138,878,879,1,569),(NULL,0,'2019-11-29 22:15:20',NULL,570,'0',11154,878,880,1,570),(NULL,0,'2019-11-29 22:15:20',NULL,571,'0',11170,878,881,1,571),(NULL,0,'2019-11-29 22:15:20',NULL,572,'0',11186,878,882,1,572),(NULL,0,'2019-11-29 22:15:21',NULL,573,'0',11202,878,883,1,573),(NULL,0,'2019-11-29 22:15:21',NULL,574,'0',11218,878,884,1,574),(NULL,0,'2019-11-29 22:15:21',NULL,575,'0',11234,878,885,1,575),(NULL,0,'2019-11-29 22:15:21',NULL,576,'0',11250,878,886,1,576),(NULL,0,'2019-11-29 22:15:22',NULL,577,'0',11266,878,887,1,577),(NULL,0,'2019-11-29 22:15:22',NULL,578,'0',11282,878,888,1,578),(NULL,0,'2019-11-29 22:15:22',NULL,579,'0',11298,878,889,1,579),(NULL,0,'2019-11-29 22:15:22',NULL,580,'0',11314,878,890,1,580),(NULL,0,'2019-11-29 22:15:23',NULL,581,'0',11330,878,891,1,581),(NULL,0,'2019-11-29 22:15:23',NULL,582,'0',11346,878,892,1,582),(NULL,0,'2019-11-29 22:15:23',NULL,583,'0',11362,878,893,1,583),(NULL,0,'2019-11-29 22:15:23',NULL,584,'0',11378,878,894,1,584),(NULL,0,'2019-11-29 22:15:23',NULL,585,'0',11380,877,895,1,585),(NULL,0,'2019-11-29 22:15:24',NULL,586,'0',11396,895,896,1,586),(NULL,0,'2019-11-29 22:15:24',NULL,587,'0',11412,895,897,1,587),(NULL,0,'2019-11-29 22:15:24',NULL,588,'0',11428,895,898,1,588),(NULL,0,'2019-11-29 22:15:24',NULL,589,'0',11444,895,899,1,589),(NULL,0,'2019-11-29 22:15:24',NULL,590,'0',11460,895,900,1,590),(NULL,0,'2019-11-29 22:15:25',NULL,591,'0',11476,895,901,1,591),(NULL,0,'2019-11-29 22:15:25',NULL,592,'0',11492,895,902,1,592),(NULL,0,'2019-11-29 22:15:25',NULL,593,'0',11508,895,903,1,593),(NULL,0,'2019-11-29 22:15:25',NULL,594,'0',11524,895,904,1,594),(NULL,0,'2019-11-29 22:15:26',NULL,595,'0',11540,895,905,1,595),(NULL,0,'2019-11-29 22:15:26',NULL,596,'0',11556,895,906,1,596),(NULL,0,'2019-11-29 22:15:26',NULL,597,'0',11572,895,907,1,597),(NULL,0,'2019-11-29 22:15:26',NULL,598,'0',11588,895,908,1,598),(NULL,0,'2019-11-29 22:15:27',NULL,599,'0',11604,895,909,1,599),(NULL,0,'2019-11-29 22:15:27',NULL,600,'0',11620,895,910,1,600),(NULL,0,'2019-11-29 22:15:27',NULL,601,'0',11636,895,911,1,601),(NULL,0,'2019-11-29 22:15:27',NULL,602,'0',11638,877,912,1,602),(NULL,0,'2019-11-29 22:15:27',NULL,603,'0',11654,912,913,1,603),(NULL,0,'2019-11-29 22:15:28',NULL,604,'0',11670,912,914,1,604),(NULL,0,'2019-11-29 22:15:28',NULL,605,'0',11686,912,915,1,605),(NULL,0,'2019-11-29 22:15:28',NULL,606,'0',11702,912,916,1,606),(NULL,0,'2019-11-29 22:15:28',NULL,607,'0',11718,912,917,1,607),(NULL,0,'2019-11-29 22:15:28',NULL,608,'0',11734,912,918,1,608),(NULL,0,'2019-11-29 22:15:29',NULL,609,'0',11750,912,919,1,609),(NULL,0,'2019-11-29 22:15:29',NULL,610,'0',11766,912,920,1,610),(NULL,0,'2019-11-29 22:15:29',NULL,611,'0',11782,912,921,1,611),(NULL,0,'2019-11-29 22:15:29',NULL,612,'0',11798,912,922,1,612),(NULL,0,'2019-11-29 22:15:30',NULL,613,'0',11814,912,923,1,613),(NULL,0,'2019-11-29 22:15:30',NULL,614,'0',11830,912,924,1,614),(NULL,0,'2019-11-29 22:15:30',NULL,615,'0',11846,912,925,1,615),(NULL,0,'2019-11-29 22:15:30',NULL,616,'0',11862,912,926,1,616),(NULL,0,'2019-11-29 22:15:30',NULL,617,'0',11878,912,927,1,617),(NULL,0,'2019-11-29 22:15:31',NULL,618,'0',11894,912,928,1,618),(NULL,0,'2019-11-29 22:15:31',NULL,619,'0',11896,877,929,1,619),(NULL,0,'2019-11-29 22:15:31',NULL,620,'0',11912,929,930,1,620),(NULL,0,'2019-11-29 22:15:31',NULL,621,'0',11928,929,931,1,621),(NULL,0,'2019-11-29 22:15:31',NULL,622,'0',11944,929,932,1,622),(NULL,0,'2019-11-29 22:15:32',NULL,623,'0',11960,929,933,1,623),(NULL,0,'2019-11-29 22:15:32',NULL,624,'0',11976,929,934,1,624),(NULL,0,'2019-11-29 22:15:32',NULL,625,'0',11992,929,935,1,625),(NULL,0,'2019-11-29 22:15:32',NULL,626,'0',12008,929,936,1,626),(NULL,0,'2019-11-29 22:15:33',NULL,627,'0',12024,929,937,1,627),(NULL,0,'2019-11-29 22:15:33',NULL,628,'0',12040,929,938,1,628),(NULL,0,'2019-11-29 22:15:33',NULL,629,'0',12056,929,939,1,629),(NULL,0,'2019-11-29 22:15:33',NULL,630,'0',12072,929,940,1,630),(NULL,0,'2019-11-29 22:15:34',NULL,631,'0',12088,929,941,1,631),(NULL,0,'2019-11-29 22:15:34',NULL,632,'0',12104,929,942,1,632),(NULL,0,'2019-11-29 22:15:34',NULL,633,'0',12120,929,943,1,633),(NULL,0,'2019-11-29 22:15:34',NULL,634,'0',12136,929,944,1,634),(NULL,0,'2019-11-29 22:15:34',NULL,635,'0',12152,929,945,1,635),(NULL,0,'2019-11-29 22:15:35',NULL,636,'0',12154,877,946,1,636),(NULL,0,'2019-11-29 22:15:35',NULL,637,'0',12170,946,947,1,637),(NULL,0,'2019-11-29 22:15:35',NULL,638,'0',12186,946,948,1,638),(NULL,0,'2019-11-29 22:15:35',NULL,639,'0',12202,946,949,1,639),(NULL,0,'2019-11-29 22:15:35',NULL,640,'0',12218,946,950,1,640),(NULL,0,'2019-11-29 22:15:36',NULL,641,'0',12234,946,951,1,641),(NULL,0,'2019-11-29 22:15:36',NULL,642,'0',12250,946,952,1,642),(NULL,0,'2019-11-29 22:15:36',NULL,643,'0',12266,946,953,1,643),(NULL,0,'2019-11-29 22:15:36',NULL,644,'0',12282,946,954,1,644),(NULL,0,'2019-11-29 22:15:37',NULL,645,'0',12298,946,955,1,645),(NULL,0,'2019-11-29 22:15:37',NULL,646,'0',12314,946,956,1,646),(NULL,0,'2019-11-29 22:15:37',NULL,647,'0',12330,946,957,1,647),(NULL,0,'2019-11-29 22:15:37',NULL,648,'0',12346,946,958,1,648),(NULL,0,'2019-11-29 22:15:38',NULL,649,'0',12362,946,959,1,649),(NULL,0,'2019-11-29 22:15:38',NULL,650,'0',12378,946,960,1,650),(NULL,0,'2019-11-29 22:15:38',NULL,651,'0',12394,946,961,1,651),(NULL,0,'2019-11-29 22:15:38',NULL,652,'0',12410,946,962,1,652),(NULL,0,'2019-11-29 22:15:38',NULL,653,'0',12412,877,963,1,653),(NULL,0,'2019-11-29 22:15:39',NULL,654,'0',12428,963,964,1,654),(NULL,0,'2019-11-29 22:15:39',NULL,655,'0',12444,963,965,1,655),(NULL,0,'2019-11-29 22:15:39',NULL,656,'0',12460,963,966,1,656),(NULL,0,'2019-11-29 22:15:39',NULL,657,'0',12476,963,967,1,657),(NULL,0,'2019-11-29 22:15:39',NULL,658,'0',12492,963,968,1,658),(NULL,0,'2019-11-29 22:15:40',NULL,659,'0',12508,963,969,1,659),(NULL,0,'2019-11-29 22:15:40',NULL,660,'0',12524,963,970,1,660),(NULL,0,'2019-11-29 22:15:40',NULL,661,'0',12540,963,971,1,661),(NULL,0,'2019-11-29 22:15:40',NULL,662,'0',12556,963,972,1,662),(NULL,0,'2019-11-29 22:15:41',NULL,663,'0',12572,963,973,1,663),(NULL,0,'2019-11-29 22:15:41',NULL,664,'0',12588,963,974,1,664),(NULL,0,'2019-11-29 22:15:41',NULL,665,'0',12604,963,975,1,665),(NULL,0,'2019-11-29 22:15:41',NULL,666,'0',12620,963,976,1,666),(NULL,0,'2019-11-29 22:15:42',NULL,667,'0',12636,963,977,1,667),(NULL,0,'2019-11-29 22:15:42',NULL,668,'0',12652,963,978,1,668),(NULL,0,'2019-11-29 22:15:42',NULL,669,'0',12668,963,979,1,669),(NULL,0,'2019-11-29 22:15:42',NULL,670,'0',12670,877,980,1,670),(NULL,0,'2019-11-29 22:15:42',NULL,671,'0',12686,980,981,1,671),(NULL,0,'2019-11-29 22:15:43',NULL,672,'0',12702,980,982,1,672),(NULL,0,'2019-11-29 22:15:43',NULL,673,'0',12718,980,983,1,673),(NULL,0,'2019-11-29 22:15:43',NULL,674,'0',12734,980,984,1,674),(NULL,0,'2019-11-29 22:15:43',NULL,675,'0',12750,980,985,1,675),(NULL,0,'2019-11-29 22:15:43',NULL,676,'0',12766,980,986,1,676),(NULL,0,'2019-11-29 22:15:44',NULL,677,'0',12782,980,987,1,677),(NULL,0,'2019-11-29 22:15:44',NULL,678,'0',12798,980,988,1,678),(NULL,0,'2019-11-29 22:15:44',NULL,679,'0',12814,980,989,1,679),(NULL,0,'2019-11-29 22:15:44',NULL,680,'0',12830,980,990,1,680),(NULL,0,'2019-11-29 22:15:45',NULL,681,'0',12846,980,991,1,681),(NULL,0,'2019-11-29 22:15:45',NULL,682,'0',12862,980,992,1,682),(NULL,0,'2019-11-29 22:15:45',NULL,683,'0',12878,980,993,1,683),(NULL,0,'2019-11-29 22:15:45',NULL,684,'0',12894,980,994,1,684),(NULL,0,'2019-11-29 22:15:46',NULL,685,'0',12910,980,995,1,685),(NULL,0,'2019-11-29 22:15:46',NULL,686,'0',12926,980,996,1,686),(NULL,0,'2019-11-29 22:15:46',NULL,687,'0',12928,877,997,1,687),(NULL,0,'2019-11-29 22:15:46',NULL,688,'0',12944,997,998,1,688),(NULL,0,'2019-11-29 22:15:46',NULL,689,'0',12960,997,999,1,689),(NULL,0,'2019-11-29 22:15:47',NULL,690,'0',12976,997,1000,1,690),(NULL,0,'2019-11-29 22:15:47',NULL,691,'0',12992,997,1001,1,691),(NULL,0,'2019-11-29 22:15:47',NULL,692,'0',13008,997,1002,1,692),(NULL,0,'2019-11-29 22:15:47',NULL,693,'0',13024,997,1003,1,693),(NULL,0,'2019-11-29 22:15:47',NULL,694,'0',13040,997,1004,1,694),(NULL,0,'2019-11-29 22:15:48',NULL,695,'0',13056,997,1005,1,695),(NULL,0,'2019-11-29 22:15:48',NULL,696,'0',13072,997,1006,1,696),(NULL,0,'2019-11-29 22:15:48',NULL,697,'0',13088,997,1007,1,697),(NULL,0,'2019-11-29 22:15:48',NULL,698,'0',13104,997,1008,1,698),(NULL,0,'2019-11-29 22:15:49',NULL,699,'0',13120,997,1009,1,699),(NULL,0,'2019-11-29 22:15:49',NULL,700,'0',13136,997,1010,1,700),(NULL,0,'2019-11-29 22:15:49',NULL,701,'0',13152,997,1011,1,701),(NULL,0,'2019-11-29 22:15:49',NULL,702,'0',13168,997,1012,1,702),(NULL,0,'2019-11-29 22:15:50',NULL,703,'0',13184,997,1013,1,703),(NULL,0,'2019-11-29 22:15:50',NULL,704,'0',13186,602,1014,1,704),(NULL,0,'2019-11-29 22:15:50',NULL,705,'0',13188,1014,1015,1,705),(NULL,0,'2019-11-29 22:15:50',NULL,706,'0',13204,1015,1016,1,706),(NULL,0,'2019-11-29 22:15:50',NULL,707,'0',13220,1015,1017,1,707),(NULL,0,'2019-11-29 22:15:50',NULL,708,'0',13236,1015,1018,1,708),(NULL,0,'2019-11-29 22:15:51',NULL,709,'0',13252,1015,1019,1,709),(NULL,0,'2019-11-29 22:15:51',NULL,710,'0',13268,1015,1020,1,710),(NULL,0,'2019-11-29 22:15:51',NULL,711,'0',13284,1015,1021,1,711),(NULL,0,'2019-11-29 22:15:51',NULL,712,'0',13300,1015,1022,1,712),(NULL,0,'2019-11-29 22:15:52',NULL,713,'0',13316,1015,1023,1,713),(NULL,0,'2019-11-29 22:15:52',NULL,714,'0',13332,1015,1024,1,714),(NULL,0,'2019-11-29 22:15:52',NULL,715,'0',13348,1015,1025,1,715),(NULL,0,'2019-11-29 22:15:52',NULL,716,'0',13364,1015,1026,1,716),(NULL,0,'2019-11-29 22:15:52',NULL,717,'0',13380,1015,1027,1,717),(NULL,0,'2019-11-29 22:15:53',NULL,718,'0',13396,1015,1028,1,718),(NULL,0,'2019-11-29 22:15:53',NULL,719,'0',13412,1015,1029,1,719),(NULL,0,'2019-11-29 22:15:53',NULL,720,'0',13428,1015,1030,1,720),(NULL,0,'2019-11-29 22:15:53',NULL,721,'0',13444,1015,1031,1,721),(NULL,0,'2019-11-29 22:15:53',NULL,722,'0',13446,1014,1032,1,722),(NULL,0,'2019-11-29 22:15:54',NULL,723,'0',13462,1032,1033,1,723),(NULL,0,'2019-11-29 22:15:54',NULL,724,'0',13478,1032,1034,1,724),(NULL,0,'2019-11-29 22:15:54',NULL,725,'0',13494,1032,1035,1,725),(NULL,0,'2019-11-29 22:15:54',NULL,726,'0',13510,1032,1036,1,726),(NULL,0,'2019-11-29 22:15:55',NULL,727,'0',13526,1032,1037,1,727),(NULL,0,'2019-11-29 22:15:55',NULL,728,'0',13542,1032,1038,1,728),(NULL,0,'2019-11-29 22:15:55',NULL,729,'0',13558,1032,1039,1,729),(NULL,0,'2019-11-29 22:15:55',NULL,730,'0',13574,1032,1040,1,730),(NULL,0,'2019-11-29 22:15:55',NULL,731,'0',13590,1032,1041,1,731),(NULL,0,'2019-11-29 22:15:56',NULL,732,'0',13606,1032,1042,1,732),(NULL,0,'2019-11-29 22:15:56',NULL,733,'0',13622,1032,1043,1,733),(NULL,0,'2019-11-29 22:15:56',NULL,734,'0',13638,1032,1044,1,734),(NULL,0,'2019-11-29 22:15:56',NULL,735,'0',13654,1032,1045,1,735),(NULL,0,'2019-11-29 22:15:57',NULL,736,'0',13670,1032,1046,1,736),(NULL,0,'2019-11-29 22:15:57',NULL,737,'0',13686,1032,1047,1,737),(NULL,0,'2019-11-29 22:15:57',NULL,738,'0',13702,1032,1048,1,738),(NULL,0,'2019-11-29 22:15:57',NULL,739,'0',13704,1014,1049,1,739),(NULL,0,'2019-11-29 22:15:57',NULL,740,'0',13720,1049,1050,1,740),(NULL,0,'2019-11-29 22:15:58',NULL,741,'0',13736,1049,1051,1,741),(NULL,0,'2019-11-29 22:15:58',NULL,742,'0',13752,1049,1052,1,742),(NULL,0,'2019-11-29 22:15:58',NULL,743,'0',13768,1049,1053,1,743),(NULL,0,'2019-11-29 22:15:58',NULL,744,'0',13784,1049,1054,1,744),(NULL,0,'2019-11-29 22:15:59',NULL,745,'0',13800,1049,1055,1,745),(NULL,0,'2019-11-29 22:15:59',NULL,746,'0',13816,1049,1056,1,746),(NULL,0,'2019-11-29 22:15:59',NULL,747,'0',13832,1049,1057,1,747),(NULL,0,'2019-11-29 22:15:59',NULL,748,'0',13848,1049,1058,1,748),(NULL,0,'2019-11-29 22:16:00',NULL,749,'0',13864,1049,1059,1,749),(NULL,0,'2019-11-29 22:16:00',NULL,750,'0',13880,1049,1060,1,750),(NULL,0,'2019-11-29 22:16:00',NULL,751,'0',13896,1049,1061,1,751),(NULL,0,'2019-11-29 22:16:00',NULL,752,'0',13912,1049,1062,1,752),(NULL,0,'2019-11-29 22:16:00',NULL,753,'0',13928,1049,1063,1,753),(NULL,0,'2019-11-29 22:16:01',NULL,754,'0',13944,1049,1064,1,754),(NULL,0,'2019-11-29 22:16:01',NULL,755,'0',13960,1049,1065,1,755),(NULL,0,'2019-11-29 22:16:01',NULL,756,'0',13962,1014,1066,1,756),(NULL,0,'2019-11-29 22:16:01',NULL,757,'0',13978,1066,1067,1,757),(NULL,0,'2019-11-29 22:16:01',NULL,758,'0',13994,1066,1068,1,758),(NULL,0,'2019-11-29 22:16:02',NULL,759,'0',14010,1066,1069,1,759),(NULL,0,'2019-11-29 22:16:02',NULL,760,'0',14026,1066,1070,1,760),(NULL,0,'2019-11-29 22:16:02',NULL,761,'0',14042,1066,1071,1,761),(NULL,0,'2019-11-29 22:16:02',NULL,762,'0',14058,1066,1072,1,762),(NULL,0,'2019-11-29 22:16:03',NULL,763,'0',14074,1066,1073,1,763),(NULL,0,'2019-11-29 22:16:03',NULL,764,'0',14090,1066,1074,1,764),(NULL,0,'2019-11-29 22:16:03',NULL,765,'0',14106,1066,1075,1,765),(NULL,0,'2019-11-29 22:16:03',NULL,766,'0',14122,1066,1076,1,766),(NULL,0,'2019-11-29 22:16:03',NULL,767,'0',14138,1066,1077,1,767),(NULL,0,'2019-11-29 22:16:04',NULL,768,'0',14154,1066,1078,1,768),(NULL,0,'2019-11-29 22:16:04',NULL,769,'0',14170,1066,1079,1,769),(NULL,0,'2019-11-29 22:16:04',NULL,770,'0',14186,1066,1080,1,770),(NULL,0,'2019-11-29 22:16:04',NULL,771,'0',14202,1066,1081,1,771),(NULL,0,'2019-11-29 22:16:05',NULL,772,'0',14218,1066,1082,1,772),(NULL,0,'2019-11-29 22:16:05',NULL,773,'0',14220,1014,1083,1,773),(NULL,0,'2019-11-29 22:16:05',NULL,774,'0',14236,1083,1084,1,774),(NULL,0,'2019-11-29 22:16:05',NULL,775,'0',14252,1083,1085,1,775),(NULL,0,'2019-11-29 22:16:05',NULL,776,'0',14268,1083,1086,1,776),(NULL,0,'2019-11-29 22:16:06',NULL,777,'0',14284,1083,1087,1,777),(NULL,0,'2019-11-29 22:16:06',NULL,778,'0',14300,1083,1088,1,778),(NULL,0,'2019-11-29 22:16:06',NULL,779,'0',14316,1083,1089,1,779),(NULL,0,'2019-11-29 22:16:06',NULL,780,'0',14332,1083,1090,1,780),(NULL,0,'2019-11-29 22:16:07',NULL,781,'0',14348,1083,1091,1,781),(NULL,0,'2019-11-29 22:16:07',NULL,782,'0',14364,1083,1092,1,782),(NULL,0,'2019-11-29 22:16:07',NULL,783,'0',14380,1083,1093,1,783),(NULL,0,'2019-11-29 22:16:07',NULL,784,'0',14396,1083,1094,1,784),(NULL,0,'2019-11-29 22:16:07',NULL,785,'0',14412,1083,1095,1,785),(NULL,0,'2019-11-29 22:16:08',NULL,786,'0',14428,1083,1096,1,786),(NULL,0,'2019-11-29 22:16:08',NULL,787,'0',14444,1083,1097,1,787),(NULL,0,'2019-11-29 22:16:08',NULL,788,'0',14460,1083,1098,1,788),(NULL,0,'2019-11-29 22:16:08',NULL,789,'0',14476,1083,1099,1,789),(NULL,0,'2019-11-29 22:16:08',NULL,790,'0',14478,1014,1100,1,790),(NULL,0,'2019-11-29 22:16:09',NULL,791,'0',14494,1100,1101,1,791),(NULL,0,'2019-11-29 22:16:09',NULL,792,'0',14510,1100,1102,1,792),(NULL,0,'2019-11-29 22:16:09',NULL,793,'0',14526,1100,1103,1,793),(NULL,0,'2019-11-29 22:16:09',NULL,794,'0',14542,1100,1104,1,794),(NULL,0,'2019-11-29 22:16:10',NULL,795,'0',14558,1100,1105,1,795),(NULL,0,'2019-11-29 22:16:10',NULL,796,'0',14574,1100,1106,1,796),(NULL,0,'2019-11-29 22:16:10',NULL,797,'0',14590,1100,1107,1,797),(NULL,0,'2019-11-29 22:16:10',NULL,798,'0',14606,1100,1108,1,798),(NULL,0,'2019-11-29 22:16:11',NULL,799,'0',14622,1100,1109,1,799),(NULL,0,'2019-11-29 22:16:11',NULL,800,'0',14638,1100,1110,1,800),(NULL,0,'2019-11-29 22:16:11',NULL,801,'0',14654,1100,1111,1,801),(NULL,0,'2019-11-29 22:16:11',NULL,802,'0',14670,1100,1112,1,802),(NULL,0,'2019-11-29 22:16:11',NULL,803,'0',14686,1100,1113,1,803),(NULL,0,'2019-11-29 22:16:12',NULL,804,'0',14702,1100,1114,1,804),(NULL,0,'2019-11-29 22:16:12',NULL,805,'0',14718,1100,1115,1,805),(NULL,0,'2019-11-29 22:16:12',NULL,806,'0',14734,1100,1116,1,806),(NULL,0,'2019-11-29 22:16:12',NULL,807,'0',14736,1014,1117,1,807),(NULL,0,'2019-11-29 22:16:12',NULL,808,'0',14752,1117,1118,1,808),(NULL,0,'2019-11-29 22:16:13',NULL,809,'0',14768,1117,1119,1,809),(NULL,0,'2019-11-29 22:16:13',NULL,810,'0',14784,1117,1120,1,810),(NULL,0,'2019-11-29 22:16:13',NULL,811,'0',14800,1117,1121,1,811),(NULL,0,'2019-11-29 22:16:13',NULL,812,'0',14816,1117,1122,1,812),(NULL,0,'2019-11-29 22:16:14',NULL,813,'0',14832,1117,1123,1,813),(NULL,0,'2019-11-29 22:16:14',NULL,814,'0',14848,1117,1124,1,814),(NULL,0,'2019-11-29 22:16:14',NULL,815,'0',14864,1117,1125,1,815),(NULL,0,'2019-11-29 22:16:14',NULL,816,'0',14880,1117,1126,1,816),(NULL,0,'2019-11-29 22:16:15',NULL,817,'0',14896,1117,1127,1,817),(NULL,0,'2019-11-29 22:16:15',NULL,818,'0',14912,1117,1128,1,818),(NULL,0,'2019-11-29 22:16:15',NULL,819,'0',14928,1117,1129,1,819),(NULL,0,'2019-11-29 22:16:15',NULL,820,'0',14944,1117,1130,1,820),(NULL,0,'2019-11-29 22:16:15',NULL,821,'0',14960,1117,1131,1,821),(NULL,0,'2019-11-29 22:16:16',NULL,822,'0',14976,1117,1132,1,822),(NULL,0,'2019-11-29 22:16:16',NULL,823,'0',14992,1117,1133,1,823),(NULL,0,'2019-11-29 22:16:16',NULL,824,'0',14994,1014,1134,1,824),(NULL,0,'2019-11-29 22:16:16',NULL,825,'0',15010,1134,1135,1,825),(NULL,0,'2019-11-29 22:16:16',NULL,826,'0',15026,1134,1136,1,826),(NULL,0,'2019-11-29 22:16:17',NULL,827,'0',15042,1134,1137,1,827),(NULL,0,'2019-11-29 22:16:17',NULL,828,'0',15058,1134,1138,1,828),(NULL,0,'2019-11-29 22:16:17',NULL,829,'0',15074,1134,1139,1,829),(NULL,0,'2019-11-29 22:16:17',NULL,830,'0',15090,1134,1140,1,830),(NULL,0,'2019-11-29 22:16:18',NULL,831,'0',15106,1134,1141,1,831),(NULL,0,'2019-11-29 22:16:18',NULL,832,'0',15122,1134,1142,1,832),(NULL,0,'2019-11-29 22:16:18',NULL,833,'0',15138,1134,1143,1,833),(NULL,0,'2019-11-29 22:16:18',NULL,834,'0',15154,1134,1144,1,834),(NULL,0,'2019-11-29 22:16:18',NULL,835,'0',15170,1134,1145,1,835),(NULL,0,'2019-11-29 22:16:19',NULL,836,'0',15186,1134,1146,1,836),(NULL,0,'2019-11-29 22:16:19',NULL,837,'0',15202,1134,1147,1,837),(NULL,0,'2019-11-29 22:16:19',NULL,838,'0',15218,1134,1148,1,838),(NULL,0,'2019-11-29 22:16:19',NULL,839,'0',15234,1134,1149,1,839),(NULL,0,'2019-11-29 22:16:20',NULL,840,'0',15250,1134,1150,1,840);
/*!40000 ALTER TABLE `c_relation_histories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_relation_types`
--

DROP TABLE IF EXISTS `c_relation_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_relation_types` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(16) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `ix_c_relation_types_name` (`name`),
  KEY `ix_c_relation_types_deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_relation_types`
--

LOCK TABLES `c_relation_types` WRITE;
/*!40000 ALTER TABLE `c_relation_types` DISABLE KEYS */;
INSERT INTO `c_relation_types` VALUES (NULL,0,NULL,NULL,1,'contain'),(NULL,0,NULL,NULL,2,'deploy'),(NULL,0,NULL,NULL,3,'install'),(NULL,0,NULL,NULL,4,'connect');
/*!40000 ALTER TABLE `c_relation_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_sc`
--

DROP TABLE IF EXISTS `c_sc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_sc` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) DEFAULT NULL,
  `option` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_c_sc_deleted` (`deleted`),
  KEY `ix_c_sc_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_sc`
--

LOCK TABLES `c_sc` WRITE;
/*!40000 ALTER TABLE `c_sc` DISABLE KEYS */;
INSERT INTO `c_sc` VALUES (NULL,0,'2023-07-11 14:49:02',NULL,1,'ci_type_relation_layout','[{\"x\": 674.167787843871, \"y\": 153.6474508437579, \"id\": \"6\"}, {\"x\": 586, \"y\": 275, \"id\": \"4\"}, {\"x\": 728.6584774442731, \"y\": 321.3525491562421, \"id\": \"7\"}, {\"x\": 669, \"y\": 462, \"id\": \"8\"}, {\"x\": 138.46514708427696, \"y\": 322.037808470444, \"id\": \"2\"}, {\"x\": 94, \"y\": 106, \"id\": \"1\"}, {\"x\": 443.34152255572695, \"y\": 228.64745084375792, \"id\": \"3\"}, {\"x\": 411, \"y\": 463, \"id\": \"5\"}]');
/*!40000 ALTER TABLE `c_sc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_datetime`
--

DROP TABLE IF EXISTS `c_value_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_datetime` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_value_datetime_deleted` (`deleted`),
  CONSTRAINT `c_value_datetime_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_datetime_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_datetime`
--

LOCK TABLES `c_value_datetime` WRITE;
/*!40000 ALTER TABLE `c_value_datetime` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_floats`
--

DROP TABLE IF EXISTS `c_value_floats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_floats` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` float NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_value_floats_deleted` (`deleted`),
  CONSTRAINT `c_value_floats_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_floats_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_floats`
--

LOCK TABLES `c_value_floats` WRITE;
/*!40000 ALTER TABLE `c_value_floats` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_floats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_index_datetime`
--

DROP TABLE IF EXISTS `c_value_index_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_index_datetime` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `ix_c_value_index_datetime_deleted` (`deleted`),
  KEY `datetime_attr_value_index` (`attr_id`,`value`),
  CONSTRAINT `c_value_index_datetime_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_index_datetime_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_index_datetime`
--

LOCK TABLES `c_value_index_datetime` WRITE;
/*!40000 ALTER TABLE `c_value_index_datetime` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_index_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_index_floats`
--

DROP TABLE IF EXISTS `c_value_index_floats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_index_floats` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` float NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `float_attr_value_index` (`attr_id`,`value`),
  KEY `ix_c_value_index_floats_deleted` (`deleted`),
  CONSTRAINT `c_value_index_floats_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_index_floats_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_index_floats`
--

LOCK TABLES `c_value_index_floats` WRITE;
/*!40000 ALTER TABLE `c_value_index_floats` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_index_floats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_index_integers`
--

DROP TABLE IF EXISTS `c_value_index_integers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_index_integers` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `integer_attr_value_index` (`attr_id`,`value`),
  KEY `ix_c_value_index_integers_deleted` (`deleted`),
  CONSTRAINT `c_value_index_integers_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_index_integers_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2149 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_index_integers`
--

LOCK TABLES `c_value_index_integers` WRITE;
/*!40000 ALTER TABLE `c_value_index_integers` DISABLE KEYS */;
INSERT INTO `c_value_index_integers` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,101,56,22,2),(NULL,0,'2019-11-29 22:12:15',NULL,102,56,23,40),(NULL,0,'2019-11-29 22:12:15',NULL,103,57,22,2),(NULL,0,'2019-11-29 22:12:15',NULL,104,57,23,40),(NULL,0,'2019-11-29 22:12:15',NULL,105,58,22,2),(NULL,0,'2019-11-29 22:12:15',NULL,106,58,23,40),(NULL,0,'2019-11-29 22:12:15',NULL,107,59,22,2),(NULL,0,'2019-11-29 22:12:15',NULL,108,59,23,40),(NULL,0,'2019-11-29 22:12:15',NULL,109,60,22,2),(NULL,0,'2019-11-29 22:12:16',NULL,110,60,23,40),(NULL,0,'2019-11-29 22:12:16',NULL,111,61,22,2),(NULL,0,'2019-11-29 22:12:16',NULL,112,61,23,40),(NULL,0,'2019-11-29 22:12:16',NULL,113,62,22,2),(NULL,0,'2019-11-29 22:12:16',NULL,114,62,23,40),(NULL,0,'2019-11-29 22:12:16',NULL,115,63,22,2),(NULL,0,'2019-11-29 22:12:16',NULL,116,63,23,40),(NULL,0,'2019-11-29 22:12:16',NULL,117,64,22,2),(NULL,0,'2019-11-29 22:12:16',NULL,118,64,23,40),(NULL,0,'2019-11-29 22:12:17',NULL,119,65,22,2),(NULL,0,'2019-11-29 22:12:17',NULL,120,65,23,40),(NULL,0,'2019-11-29 22:12:17',NULL,121,66,22,2),(NULL,0,'2019-11-29 22:12:17',NULL,122,66,23,40),(NULL,0,'2019-11-29 22:12:17',NULL,123,67,22,2),(NULL,0,'2019-11-29 22:12:17',NULL,124,67,23,40),(NULL,0,'2019-11-29 22:12:17',NULL,125,68,22,2),(NULL,0,'2019-11-29 22:12:17',NULL,126,68,23,40),(NULL,0,'2019-11-29 22:12:18',NULL,127,69,22,2),(NULL,0,'2019-11-29 22:12:18',NULL,128,69,23,40),(NULL,0,'2019-11-29 22:12:18',NULL,129,70,22,2),(NULL,0,'2019-11-29 22:12:18',NULL,130,70,23,40),(NULL,0,'2019-11-29 22:12:18',NULL,131,71,22,2),(NULL,0,'2019-11-29 22:12:18',NULL,132,71,23,40),(NULL,0,'2019-11-29 22:12:18',NULL,133,73,22,2),(NULL,0,'2019-11-29 22:12:18',NULL,134,73,23,40),(NULL,0,'2019-11-29 22:12:19',NULL,135,74,22,2),(NULL,0,'2019-11-29 22:12:19',NULL,136,74,23,40),(NULL,0,'2019-11-29 22:12:19',NULL,137,75,22,2),(NULL,0,'2019-11-29 22:12:19',NULL,138,75,23,40),(NULL,0,'2019-11-29 22:12:19',NULL,139,76,22,2),(NULL,0,'2019-11-29 22:12:19',NULL,140,76,23,40),(NULL,0,'2019-11-29 22:12:19',NULL,141,77,22,2),(NULL,0,'2019-11-29 22:12:19',NULL,142,77,23,40),(NULL,0,'2019-11-29 22:12:19',NULL,143,78,22,2),(NULL,0,'2019-11-29 22:12:20',NULL,144,78,23,40),(NULL,0,'2019-11-29 22:12:20',NULL,145,79,22,2),(NULL,0,'2019-11-29 22:12:20',NULL,146,79,23,40),(NULL,0,'2019-11-29 22:12:20',NULL,147,80,22,2),(NULL,0,'2019-11-29 22:12:20',NULL,148,80,23,40),(NULL,0,'2019-11-29 22:12:20',NULL,149,81,22,2),(NULL,0,'2019-11-29 22:12:20',NULL,150,81,23,40),(NULL,0,'2019-11-29 22:12:20',NULL,151,82,22,2),(NULL,0,'2019-11-29 22:12:20',NULL,152,82,23,40),(NULL,0,'2019-11-29 22:12:21',NULL,153,83,22,2),(NULL,0,'2019-11-29 22:12:21',NULL,154,83,23,40),(NULL,0,'2019-11-29 22:12:21',NULL,155,84,22,2),(NULL,0,'2019-11-29 22:12:21',NULL,156,84,23,40),(NULL,0,'2019-11-29 22:12:21',NULL,157,85,22,2),(NULL,0,'2019-11-29 22:12:21',NULL,158,85,23,40),(NULL,0,'2019-11-29 22:12:21',NULL,159,86,22,2),(NULL,0,'2019-11-29 22:12:21',NULL,160,86,23,40),(NULL,0,'2019-11-29 22:12:22',NULL,161,87,22,2),(NULL,0,'2019-11-29 22:12:22',NULL,162,87,23,40),(NULL,0,'2019-11-29 22:12:22',NULL,163,88,22,2),(NULL,0,'2019-11-29 22:12:22',NULL,164,88,23,40),(NULL,0,'2019-11-29 22:12:22',NULL,165,90,22,2),(NULL,0,'2019-11-29 22:12:22',NULL,166,90,23,40),(NULL,0,'2019-11-29 22:12:22',NULL,167,91,22,2),(NULL,0,'2019-11-29 22:12:22',NULL,168,91,23,40),(NULL,0,'2019-11-29 22:12:23',NULL,169,92,22,2),(NULL,0,'2019-11-29 22:12:23',NULL,170,92,23,40),(NULL,0,'2019-11-29 22:12:23',NULL,171,93,22,2),(NULL,0,'2019-11-29 22:12:23',NULL,172,93,23,40),(NULL,0,'2019-11-29 22:12:23',NULL,173,94,22,2),(NULL,0,'2019-11-29 22:12:23',NULL,174,94,23,40),(NULL,0,'2019-11-29 22:12:23',NULL,175,95,22,2),(NULL,0,'2019-11-29 22:12:23',NULL,176,95,23,40),(NULL,0,'2019-11-29 22:12:24',NULL,177,96,22,2),(NULL,0,'2019-11-29 22:12:24',NULL,178,96,23,40),(NULL,0,'2019-11-29 22:12:24',NULL,179,97,22,2),(NULL,0,'2019-11-29 22:12:24',NULL,180,97,23,40),(NULL,0,'2019-11-29 22:12:24',NULL,181,98,22,2),(NULL,0,'2019-11-29 22:12:24',NULL,182,98,23,40),(NULL,0,'2019-11-29 22:12:24',NULL,183,99,22,2),(NULL,0,'2019-11-29 22:12:24',NULL,184,99,23,40),(NULL,0,'2019-11-29 22:12:25',NULL,185,100,22,2),(NULL,0,'2019-11-29 22:12:25',NULL,186,100,23,40),(NULL,0,'2019-11-29 22:12:25',NULL,187,101,22,2),(NULL,0,'2019-11-29 22:12:25',NULL,188,101,23,40),(NULL,0,'2019-11-29 22:12:25',NULL,189,102,22,2),(NULL,0,'2019-11-29 22:12:25',NULL,190,102,23,40),(NULL,0,'2019-11-29 22:12:25',NULL,191,103,22,2),(NULL,0,'2019-11-29 22:12:25',NULL,192,103,23,40),(NULL,0,'2019-11-29 22:12:25',NULL,193,104,22,2),(NULL,0,'2019-11-29 22:12:26',NULL,194,104,23,40),(NULL,0,'2019-11-29 22:12:26',NULL,195,105,22,2),(NULL,0,'2019-11-29 22:12:26',NULL,196,105,23,40),(NULL,0,'2019-11-29 22:12:26',NULL,197,107,22,2),(NULL,0,'2019-11-29 22:12:26',NULL,198,107,23,40),(NULL,0,'2019-11-29 22:12:26',NULL,199,108,22,2),(NULL,0,'2019-11-29 22:12:26',NULL,200,108,23,40),(NULL,0,'2019-11-29 22:12:26',NULL,201,109,22,2),(NULL,0,'2019-11-29 22:12:27',NULL,202,109,23,40),(NULL,0,'2019-11-29 22:12:27',NULL,203,110,22,2),(NULL,0,'2019-11-29 22:12:27',NULL,204,110,23,40),(NULL,0,'2019-11-29 22:12:27',NULL,205,111,22,2),(NULL,0,'2019-11-29 22:12:27',NULL,206,111,23,40),(NULL,0,'2019-11-29 22:12:27',NULL,207,112,22,2),(NULL,0,'2019-11-29 22:12:27',NULL,208,112,23,40),(NULL,0,'2019-11-29 22:12:27',NULL,209,113,22,2),(NULL,0,'2019-11-29 22:12:27',NULL,210,113,23,40),(NULL,0,'2019-11-29 22:12:28',NULL,211,114,22,2),(NULL,0,'2019-11-29 22:12:28',NULL,212,114,23,40),(NULL,0,'2019-11-29 22:12:28',NULL,213,115,22,2),(NULL,0,'2019-11-29 22:12:28',NULL,214,115,23,40),(NULL,0,'2019-11-29 22:12:28',NULL,215,116,22,2),(NULL,0,'2019-11-29 22:12:28',NULL,216,116,23,40),(NULL,0,'2019-11-29 22:12:28',NULL,217,117,22,2),(NULL,0,'2019-11-29 22:12:28',NULL,218,117,23,40),(NULL,0,'2019-11-29 22:12:29',NULL,219,118,22,2),(NULL,0,'2019-11-29 22:12:29',NULL,220,118,23,40),(NULL,0,'2019-11-29 22:12:29',NULL,221,119,22,2),(NULL,0,'2019-11-29 22:12:29',NULL,222,119,23,40),(NULL,0,'2019-11-29 22:12:29',NULL,223,120,22,2),(NULL,0,'2019-11-29 22:12:29',NULL,224,120,23,40),(NULL,0,'2019-11-29 22:12:29',NULL,225,121,22,2),(NULL,0,'2019-11-29 22:12:29',NULL,226,121,23,40),(NULL,0,'2019-11-29 22:12:30',NULL,227,122,22,2),(NULL,0,'2019-11-29 22:12:30',NULL,228,122,23,40),(NULL,0,'2019-11-29 22:12:30',NULL,229,124,22,2),(NULL,0,'2019-11-29 22:12:30',NULL,230,124,23,40),(NULL,0,'2019-11-29 22:12:30',NULL,231,125,22,2),(NULL,0,'2019-11-29 22:12:30',NULL,232,125,23,40),(NULL,0,'2019-11-29 22:12:30',NULL,233,126,22,2),(NULL,0,'2019-11-29 22:12:30',NULL,234,126,23,40),(NULL,0,'2019-11-29 22:12:31',NULL,235,127,22,2),(NULL,0,'2019-11-29 22:12:31',NULL,236,127,23,40),(NULL,0,'2019-11-29 22:12:31',NULL,237,128,22,2),(NULL,0,'2019-11-29 22:12:31',NULL,238,128,23,40),(NULL,0,'2019-11-29 22:12:31',NULL,239,129,22,2),(NULL,0,'2019-11-29 22:12:31',NULL,240,129,23,40),(NULL,0,'2019-11-29 22:12:31',NULL,241,130,22,2),(NULL,0,'2019-11-29 22:12:31',NULL,242,130,23,40),(NULL,0,'2019-11-29 22:12:32',NULL,243,131,22,2),(NULL,0,'2019-11-29 22:12:32',NULL,244,131,23,40),(NULL,0,'2019-11-29 22:12:32',NULL,245,132,22,2),(NULL,0,'2019-11-29 22:12:32',NULL,246,132,23,40),(NULL,0,'2019-11-29 22:12:32',NULL,247,133,22,2),(NULL,0,'2019-11-29 22:12:32',NULL,248,133,23,40),(NULL,0,'2019-11-29 22:12:32',NULL,249,134,22,2),(NULL,0,'2019-11-29 22:12:32',NULL,250,134,23,40),(NULL,0,'2019-11-29 22:12:32',NULL,251,135,22,2),(NULL,0,'2019-11-29 22:12:32',NULL,252,135,23,40),(NULL,0,'2019-11-29 22:12:33',NULL,253,136,22,2),(NULL,0,'2019-11-29 22:12:33',NULL,254,136,23,40),(NULL,0,'2019-11-29 22:12:33',NULL,255,137,22,2),(NULL,0,'2019-11-29 22:12:33',NULL,256,137,23,40),(NULL,0,'2019-11-29 22:12:33',NULL,257,138,22,2),(NULL,0,'2019-11-29 22:12:33',NULL,258,138,23,40),(NULL,0,'2019-11-29 22:12:33',NULL,259,139,22,2),(NULL,0,'2019-11-29 22:12:33',NULL,260,139,23,40),(NULL,0,'2019-11-29 22:12:34',NULL,261,141,22,2),(NULL,0,'2019-11-29 22:12:34',NULL,262,141,23,40),(NULL,0,'2019-11-29 22:12:34',NULL,263,142,22,2),(NULL,0,'2019-11-29 22:12:34',NULL,264,142,23,40),(NULL,0,'2019-11-29 22:12:34',NULL,265,143,22,2),(NULL,0,'2019-11-29 22:12:34',NULL,266,143,23,40),(NULL,0,'2019-11-29 22:12:34',NULL,267,144,22,2),(NULL,0,'2019-11-29 22:12:34',NULL,268,144,23,40),(NULL,0,'2019-11-29 22:12:35',NULL,269,145,22,2),(NULL,0,'2019-11-29 22:12:35',NULL,270,145,23,40),(NULL,0,'2019-11-29 22:12:35',NULL,271,146,22,2),(NULL,0,'2019-11-29 22:12:35',NULL,272,146,23,40),(NULL,0,'2019-11-29 22:12:35',NULL,273,147,22,2),(NULL,0,'2019-11-29 22:12:35',NULL,274,147,23,40),(NULL,0,'2019-11-29 22:12:35',NULL,275,148,22,2),(NULL,0,'2019-11-29 22:12:35',NULL,276,148,23,40),(NULL,0,'2019-11-29 22:12:36',NULL,277,149,22,2),(NULL,0,'2019-11-29 22:12:36',NULL,278,149,23,40),(NULL,0,'2019-11-29 22:12:36',NULL,279,150,22,2),(NULL,0,'2019-11-29 22:12:36',NULL,280,150,23,40),(NULL,0,'2019-11-29 22:12:36',NULL,281,151,22,2),(NULL,0,'2019-11-29 22:12:36',NULL,282,151,23,40),(NULL,0,'2019-11-29 22:12:36',NULL,283,152,22,2),(NULL,0,'2019-11-29 22:12:36',NULL,284,152,23,40),(NULL,0,'2019-11-29 22:12:36',NULL,285,153,22,2),(NULL,0,'2019-11-29 22:12:37',NULL,286,153,23,40),(NULL,0,'2019-11-29 22:12:37',NULL,287,154,22,2),(NULL,0,'2019-11-29 22:12:37',NULL,288,154,23,40),(NULL,0,'2019-11-29 22:12:37',NULL,289,155,22,2),(NULL,0,'2019-11-29 22:12:37',NULL,290,155,23,40),(NULL,0,'2019-11-29 22:12:37',NULL,291,156,22,2),(NULL,0,'2019-11-29 22:12:37',NULL,292,156,23,40),(NULL,0,'2019-11-29 22:12:37',NULL,293,158,22,2),(NULL,0,'2019-11-29 22:12:38',NULL,294,158,23,40),(NULL,0,'2019-11-29 22:12:38',NULL,295,159,22,2),(NULL,0,'2019-11-29 22:12:38',NULL,296,159,23,40),(NULL,0,'2019-11-29 22:12:38',NULL,297,160,22,2),(NULL,0,'2019-11-29 22:12:38',NULL,298,160,23,40),(NULL,0,'2019-11-29 22:12:38',NULL,299,161,22,2),(NULL,0,'2019-11-29 22:12:38',NULL,300,161,23,40),(NULL,0,'2019-11-29 22:12:38',NULL,301,162,22,2),(NULL,0,'2019-11-29 22:12:38',NULL,302,162,23,40),(NULL,0,'2019-11-29 22:12:39',NULL,303,163,22,2),(NULL,0,'2019-11-29 22:12:39',NULL,304,163,23,40),(NULL,0,'2019-11-29 22:12:39',NULL,305,164,22,2),(NULL,0,'2019-11-29 22:12:39',NULL,306,164,23,40),(NULL,0,'2019-11-29 22:12:39',NULL,307,165,22,2),(NULL,0,'2019-11-29 22:12:39',NULL,308,165,23,40),(NULL,0,'2019-11-29 22:12:39',NULL,309,166,22,2),(NULL,0,'2019-11-29 22:12:39',NULL,310,166,23,40),(NULL,0,'2019-11-29 22:12:40',NULL,311,167,22,2),(NULL,0,'2019-11-29 22:12:40',NULL,312,167,23,40),(NULL,0,'2019-11-29 22:12:40',NULL,313,168,22,2),(NULL,0,'2019-11-29 22:12:40',NULL,314,168,23,40),(NULL,0,'2019-11-29 22:12:40',NULL,315,169,22,2),(NULL,0,'2019-11-29 22:12:40',NULL,316,169,23,40),(NULL,0,'2019-11-29 22:12:40',NULL,317,170,22,2),(NULL,0,'2019-11-29 22:12:40',NULL,318,170,23,40),(NULL,0,'2019-11-29 22:12:41',NULL,319,171,22,2),(NULL,0,'2019-11-29 22:12:41',NULL,320,171,23,40),(NULL,0,'2019-11-29 22:12:41',NULL,321,172,22,2),(NULL,0,'2019-11-29 22:12:41',NULL,322,172,23,40),(NULL,0,'2019-11-29 22:12:41',NULL,323,173,22,2),(NULL,0,'2019-11-29 22:12:41',NULL,324,173,23,40),(NULL,0,'2019-11-29 22:12:41',NULL,325,175,22,2),(NULL,0,'2019-11-29 22:12:41',NULL,326,175,23,40),(NULL,0,'2019-11-29 22:12:42',NULL,327,176,22,2),(NULL,0,'2019-11-29 22:12:42',NULL,328,176,23,40),(NULL,0,'2019-11-29 22:12:42',NULL,329,177,22,2),(NULL,0,'2019-11-29 22:12:42',NULL,330,177,23,40),(NULL,0,'2019-11-29 22:12:42',NULL,331,178,22,2),(NULL,0,'2019-11-29 22:12:42',NULL,332,178,23,40),(NULL,0,'2019-11-29 22:12:42',NULL,333,179,22,2),(NULL,0,'2019-11-29 22:12:42',NULL,334,179,23,40),(NULL,0,'2019-11-29 22:12:42',NULL,335,180,22,2),(NULL,0,'2019-11-29 22:12:43',NULL,336,180,23,40),(NULL,0,'2019-11-29 22:12:43',NULL,337,181,22,2),(NULL,0,'2019-11-29 22:12:43',NULL,338,181,23,40),(NULL,0,'2019-11-29 22:12:43',NULL,339,182,22,2),(NULL,0,'2019-11-29 22:12:43',NULL,340,182,23,40),(NULL,0,'2019-11-29 22:12:43',NULL,341,183,22,2),(NULL,0,'2019-11-29 22:12:43',NULL,342,183,23,40),(NULL,0,'2019-11-29 22:12:43',NULL,343,184,22,2),(NULL,0,'2019-11-29 22:12:43',NULL,344,184,23,40),(NULL,0,'2019-11-29 22:12:44',NULL,345,185,22,2),(NULL,0,'2019-11-29 22:12:44',NULL,346,185,23,40),(NULL,0,'2019-11-29 22:12:44',NULL,347,186,22,2),(NULL,0,'2019-11-29 22:12:44',NULL,348,186,23,40),(NULL,0,'2019-11-29 22:12:44',NULL,349,187,22,2),(NULL,0,'2019-11-29 22:12:44',NULL,350,187,23,40),(NULL,0,'2019-11-29 22:12:44',NULL,351,188,22,2),(NULL,0,'2019-11-29 22:12:44',NULL,352,188,23,40),(NULL,0,'2019-11-29 22:12:45',NULL,353,189,22,2),(NULL,0,'2019-11-29 22:12:45',NULL,354,189,23,40),(NULL,0,'2019-11-29 22:12:45',NULL,355,190,22,2),(NULL,0,'2019-11-29 22:12:45',NULL,356,190,23,40),(NULL,0,'2019-11-29 22:12:45',NULL,357,193,22,2),(NULL,0,'2019-11-29 22:12:45',NULL,358,193,23,40),(NULL,0,'2019-11-29 22:12:45',NULL,359,194,22,2),(NULL,0,'2019-11-29 22:12:45',NULL,360,194,23,40),(NULL,0,'2019-11-29 22:12:46',NULL,361,195,22,2),(NULL,0,'2019-11-29 22:12:46',NULL,362,195,23,40),(NULL,0,'2019-11-29 22:12:46',NULL,363,196,22,2),(NULL,0,'2019-11-29 22:12:46',NULL,364,196,23,40),(NULL,0,'2019-11-29 22:12:46',NULL,365,197,22,2),(NULL,0,'2019-11-29 22:12:46',NULL,366,197,23,40),(NULL,0,'2019-11-29 22:12:46',NULL,367,198,22,2),(NULL,0,'2019-11-29 22:12:46',NULL,368,198,23,40),(NULL,0,'2019-11-29 22:12:47',NULL,369,199,22,2),(NULL,0,'2019-11-29 22:12:47',NULL,370,199,23,40),(NULL,0,'2019-11-29 22:12:47',NULL,371,200,22,2),(NULL,0,'2019-11-29 22:12:47',NULL,372,200,23,40),(NULL,0,'2019-11-29 22:12:47',NULL,373,201,22,2),(NULL,0,'2019-11-29 22:12:47',NULL,374,201,23,40),(NULL,0,'2019-11-29 22:12:47',NULL,375,202,22,2),(NULL,0,'2019-11-29 22:12:47',NULL,376,202,23,40),(NULL,0,'2019-11-29 22:12:47',NULL,377,203,22,2),(NULL,0,'2019-11-29 22:12:48',NULL,378,203,23,40),(NULL,0,'2019-11-29 22:12:48',NULL,379,204,22,2),(NULL,0,'2019-11-29 22:12:48',NULL,380,204,23,40),(NULL,0,'2019-11-29 22:12:48',NULL,381,205,22,2),(NULL,0,'2019-11-29 22:12:48',NULL,382,205,23,40),(NULL,0,'2019-11-29 22:12:48',NULL,383,206,22,2),(NULL,0,'2019-11-29 22:12:48',NULL,384,206,23,40),(NULL,0,'2019-11-29 22:12:48',NULL,385,207,22,2),(NULL,0,'2019-11-29 22:12:48',NULL,386,207,23,40),(NULL,0,'2019-11-29 22:12:49',NULL,387,208,22,2),(NULL,0,'2019-11-29 22:12:49',NULL,388,208,23,40),(NULL,0,'2019-11-29 22:12:49',NULL,389,210,22,2),(NULL,0,'2019-11-29 22:12:49',NULL,390,210,23,40),(NULL,0,'2019-11-29 22:12:49',NULL,391,211,22,2),(NULL,0,'2019-11-29 22:12:49',NULL,392,211,23,40),(NULL,0,'2019-11-29 22:12:49',NULL,393,212,22,2),(NULL,0,'2019-11-29 22:12:49',NULL,394,212,23,40),(NULL,0,'2019-11-29 22:12:50',NULL,395,213,22,2),(NULL,0,'2019-11-29 22:12:50',NULL,396,213,23,40),(NULL,0,'2019-11-29 22:12:50',NULL,397,214,22,2),(NULL,0,'2019-11-29 22:12:50',NULL,398,214,23,40),(NULL,0,'2019-11-29 22:12:50',NULL,399,215,22,2),(NULL,0,'2019-11-29 22:12:50',NULL,400,215,23,40),(NULL,0,'2019-11-29 22:12:50',NULL,401,216,22,2),(NULL,0,'2019-11-29 22:12:50',NULL,402,216,23,40),(NULL,0,'2019-11-29 22:12:51',NULL,403,217,22,2),(NULL,0,'2019-11-29 22:12:51',NULL,404,217,23,40),(NULL,0,'2019-11-29 22:12:51',NULL,405,218,22,2),(NULL,0,'2019-11-29 22:12:51',NULL,406,218,23,40),(NULL,0,'2019-11-29 22:12:51',NULL,407,219,22,2),(NULL,0,'2019-11-29 22:12:51',NULL,408,219,23,40),(NULL,0,'2019-11-29 22:12:51',NULL,409,220,22,2),(NULL,0,'2019-11-29 22:12:51',NULL,410,220,23,40),(NULL,0,'2019-11-29 22:12:52',NULL,411,221,22,2),(NULL,0,'2019-11-29 22:12:52',NULL,412,221,23,40),(NULL,0,'2019-11-29 22:12:52',NULL,413,222,22,2),(NULL,0,'2019-11-29 22:12:52',NULL,414,222,23,40),(NULL,0,'2019-11-29 22:12:52',NULL,415,223,22,2),(NULL,0,'2019-11-29 22:12:52',NULL,416,223,23,40),(NULL,0,'2019-11-29 22:12:52',NULL,417,224,22,2),(NULL,0,'2019-11-29 22:12:52',NULL,418,224,23,40),(NULL,0,'2019-11-29 22:12:53',NULL,419,225,22,2),(NULL,0,'2019-11-29 22:12:53',NULL,420,225,23,40),(NULL,0,'2019-11-29 22:12:53',NULL,421,227,22,2),(NULL,0,'2019-11-29 22:12:53',NULL,422,227,23,40),(NULL,0,'2019-11-29 22:12:53',NULL,423,228,22,2),(NULL,0,'2019-11-29 22:12:53',NULL,424,228,23,40),(NULL,0,'2019-11-29 22:12:53',NULL,425,229,22,2),(NULL,0,'2019-11-29 22:12:53',NULL,426,229,23,40),(NULL,0,'2019-11-29 22:12:54',NULL,427,230,22,2),(NULL,0,'2019-11-29 22:12:54',NULL,428,230,23,40),(NULL,0,'2019-11-29 22:12:54',NULL,429,231,22,2),(NULL,0,'2019-11-29 22:12:54',NULL,430,231,23,40),(NULL,0,'2019-11-29 22:12:54',NULL,431,232,22,2),(NULL,0,'2019-11-29 22:12:54',NULL,432,232,23,40),(NULL,0,'2019-11-29 22:12:54',NULL,433,233,22,2),(NULL,0,'2019-11-29 22:12:54',NULL,434,233,23,40),(NULL,0,'2019-11-29 22:12:54',NULL,435,234,22,2),(NULL,0,'2019-11-29 22:12:55',NULL,436,234,23,40),(NULL,0,'2019-11-29 22:12:55',NULL,437,235,22,2),(NULL,0,'2019-11-29 22:12:55',NULL,438,235,23,40),(NULL,0,'2019-11-29 22:12:55',NULL,439,236,22,2),(NULL,0,'2019-11-29 22:12:55',NULL,440,236,23,40),(NULL,0,'2019-11-29 22:12:55',NULL,441,237,22,2),(NULL,0,'2019-11-29 22:12:55',NULL,442,237,23,40),(NULL,0,'2019-11-29 22:12:55',NULL,443,238,22,2),(NULL,0,'2019-11-29 22:12:55',NULL,444,238,23,40),(NULL,0,'2019-11-29 22:12:56',NULL,445,239,22,2),(NULL,0,'2019-11-29 22:12:56',NULL,446,239,23,40),(NULL,0,'2019-11-29 22:12:56',NULL,447,240,22,2),(NULL,0,'2019-11-29 22:12:56',NULL,448,240,23,40),(NULL,0,'2019-11-29 22:12:56',NULL,449,241,22,2),(NULL,0,'2019-11-29 22:12:56',NULL,450,241,23,40),(NULL,0,'2019-11-29 22:12:56',NULL,451,242,22,2),(NULL,0,'2019-11-29 22:12:56',NULL,452,242,23,40),(NULL,0,'2019-11-29 22:12:57',NULL,453,244,22,2),(NULL,0,'2019-11-29 22:12:57',NULL,454,244,23,40),(NULL,0,'2019-11-29 22:12:57',NULL,455,245,22,2),(NULL,0,'2019-11-29 22:12:57',NULL,456,245,23,40),(NULL,0,'2019-11-29 22:12:57',NULL,457,246,22,2),(NULL,0,'2019-11-29 22:12:57',NULL,458,246,23,40),(NULL,0,'2019-11-29 22:12:57',NULL,459,247,22,2),(NULL,0,'2019-11-29 22:12:57',NULL,460,247,23,40),(NULL,0,'2019-11-29 22:12:58',NULL,461,248,22,2),(NULL,0,'2019-11-29 22:12:58',NULL,462,248,23,40),(NULL,0,'2019-11-29 22:12:58',NULL,463,249,22,2),(NULL,0,'2019-11-29 22:12:58',NULL,464,249,23,40),(NULL,0,'2019-11-29 22:12:58',NULL,465,250,22,2),(NULL,0,'2019-11-29 22:12:58',NULL,466,250,23,40),(NULL,0,'2019-11-29 22:12:58',NULL,467,251,22,2),(NULL,0,'2019-11-29 22:12:58',NULL,468,251,23,40),(NULL,0,'2019-11-29 22:12:58',NULL,469,252,22,2),(NULL,0,'2019-11-29 22:12:59',NULL,470,252,23,40),(NULL,0,'2019-11-29 22:12:59',NULL,471,253,22,2),(NULL,0,'2019-11-29 22:12:59',NULL,472,253,23,40),(NULL,0,'2019-11-29 22:12:59',NULL,473,254,22,2),(NULL,0,'2019-11-29 22:12:59',NULL,474,254,23,40),(NULL,0,'2019-11-29 22:12:59',NULL,475,255,22,2),(NULL,0,'2019-11-29 22:12:59',NULL,476,255,23,40),(NULL,0,'2019-11-29 22:12:59',NULL,477,256,22,2),(NULL,0,'2019-11-29 22:12:59',NULL,478,256,23,40),(NULL,0,'2019-11-29 22:13:00',NULL,479,257,22,2),(NULL,0,'2019-11-29 22:13:00',NULL,480,257,23,40),(NULL,0,'2019-11-29 22:13:00',NULL,481,258,22,2),(NULL,0,'2019-11-29 22:13:00',NULL,482,258,23,40),(NULL,0,'2019-11-29 22:13:00',NULL,483,259,22,2),(NULL,0,'2019-11-29 22:13:00',NULL,484,259,23,40),(NULL,0,'2019-11-29 22:13:00',NULL,485,261,22,2),(NULL,0,'2019-11-29 22:13:00',NULL,486,261,23,40),(NULL,0,'2019-11-29 22:13:01',NULL,487,262,22,2),(NULL,0,'2019-11-29 22:13:01',NULL,488,262,23,40),(NULL,0,'2019-11-29 22:13:01',NULL,489,263,22,2),(NULL,0,'2019-11-29 22:13:01',NULL,490,263,23,40),(NULL,0,'2019-11-29 22:13:01',NULL,491,264,22,2),(NULL,0,'2019-11-29 22:13:01',NULL,492,264,23,40),(NULL,0,'2019-11-29 22:13:01',NULL,493,265,22,2),(NULL,0,'2019-11-29 22:13:01',NULL,494,265,23,40),(NULL,0,'2019-11-29 22:13:02',NULL,495,266,22,2),(NULL,0,'2019-11-29 22:13:02',NULL,496,266,23,40),(NULL,0,'2019-11-29 22:13:02',NULL,497,267,22,2),(NULL,0,'2019-11-29 22:13:02',NULL,498,267,23,40),(NULL,0,'2019-11-29 22:13:02',NULL,499,268,22,2),(NULL,0,'2019-11-29 22:13:02',NULL,500,268,23,40),(NULL,0,'2019-11-29 22:13:02',NULL,501,269,22,2),(NULL,0,'2019-11-29 22:13:02',NULL,502,269,23,40),(NULL,0,'2019-11-29 22:13:02',NULL,503,270,22,2),(NULL,0,'2019-11-29 22:13:03',NULL,504,270,23,40),(NULL,0,'2019-11-29 22:13:03',NULL,505,271,22,2),(NULL,0,'2019-11-29 22:13:03',NULL,506,271,23,40),(NULL,0,'2019-11-29 22:13:03',NULL,507,272,22,2),(NULL,0,'2019-11-29 22:13:03',NULL,508,272,23,40),(NULL,0,'2019-11-29 22:13:03',NULL,509,273,22,2),(NULL,0,'2019-11-29 22:13:03',NULL,510,273,23,40),(NULL,0,'2019-11-29 22:13:03',NULL,511,274,22,2),(NULL,0,'2019-11-29 22:13:03',NULL,512,274,23,40),(NULL,0,'2019-11-29 22:13:04',NULL,513,275,22,2),(NULL,0,'2019-11-29 22:13:04',NULL,514,275,23,40),(NULL,0,'2019-11-29 22:13:04',NULL,515,276,22,2),(NULL,0,'2019-11-29 22:13:04',NULL,516,276,23,40),(NULL,0,'2019-11-29 22:13:04',NULL,517,278,22,2),(NULL,0,'2019-11-29 22:13:04',NULL,518,278,23,40),(NULL,0,'2019-11-29 22:13:04',NULL,519,279,22,2),(NULL,0,'2019-11-29 22:13:04',NULL,520,279,23,40),(NULL,0,'2019-11-29 22:13:05',NULL,521,280,22,2),(NULL,0,'2019-11-29 22:13:05',NULL,522,280,23,40),(NULL,0,'2019-11-29 22:13:05',NULL,523,281,22,2),(NULL,0,'2019-11-29 22:13:05',NULL,524,281,23,40),(NULL,0,'2019-11-29 22:13:05',NULL,525,282,22,2),(NULL,0,'2019-11-29 22:13:05',NULL,526,282,23,40),(NULL,0,'2019-11-29 22:13:05',NULL,527,283,22,2),(NULL,0,'2019-11-29 22:13:05',NULL,528,283,23,40),(NULL,0,'2019-11-29 22:13:06',NULL,529,284,22,2),(NULL,0,'2019-11-29 22:13:06',NULL,530,284,23,40),(NULL,0,'2019-11-29 22:13:06',NULL,531,285,22,2),(NULL,0,'2019-11-29 22:13:06',NULL,532,285,23,40),(NULL,0,'2019-11-29 22:13:06',NULL,533,286,22,2),(NULL,0,'2019-11-29 22:13:06',NULL,534,286,23,40),(NULL,0,'2019-11-29 22:13:06',NULL,535,287,22,2),(NULL,0,'2019-11-29 22:13:06',NULL,536,287,23,40),(NULL,0,'2019-11-29 22:13:06',NULL,537,288,22,2),(NULL,0,'2019-11-29 22:13:07',NULL,538,288,23,40),(NULL,0,'2019-11-29 22:13:07',NULL,539,289,22,2),(NULL,0,'2019-11-29 22:13:07',NULL,540,289,23,40),(NULL,0,'2019-11-29 22:13:07',NULL,541,290,22,2),(NULL,0,'2019-11-29 22:13:07',NULL,542,290,23,40),(NULL,0,'2019-11-29 22:13:07',NULL,543,291,22,2),(NULL,0,'2019-11-29 22:13:07',NULL,544,291,23,40),(NULL,0,'2019-11-29 22:13:07',NULL,545,292,22,2),(NULL,0,'2019-11-29 22:13:07',NULL,546,292,23,40),(NULL,0,'2019-11-29 22:13:08',NULL,547,293,22,2),(NULL,0,'2019-11-29 22:13:08',NULL,548,293,23,40),(NULL,0,'2019-11-29 22:13:08',NULL,549,295,22,2),(NULL,0,'2019-11-29 22:13:08',NULL,550,295,23,40),(NULL,0,'2019-11-29 22:13:08',NULL,551,296,22,2),(NULL,0,'2019-11-29 22:13:08',NULL,552,296,23,40),(NULL,0,'2019-11-29 22:13:08',NULL,553,297,22,2),(NULL,0,'2019-11-29 22:13:08',NULL,554,297,23,40),(NULL,0,'2019-11-29 22:13:09',NULL,555,298,22,2),(NULL,0,'2019-11-29 22:13:09',NULL,556,298,23,40),(NULL,0,'2019-11-29 22:13:09',NULL,557,299,22,2),(NULL,0,'2019-11-29 22:13:09',NULL,558,299,23,40),(NULL,0,'2019-11-29 22:13:09',NULL,559,300,22,2),(NULL,0,'2019-11-29 22:13:09',NULL,560,300,23,40),(NULL,0,'2019-11-29 22:13:09',NULL,561,301,22,2),(NULL,0,'2019-11-29 22:13:09',NULL,562,301,23,40),(NULL,0,'2019-11-29 22:13:09',NULL,563,302,22,2),(NULL,0,'2019-11-29 22:13:10',NULL,564,302,23,40),(NULL,0,'2019-11-29 22:13:10',NULL,565,303,22,2),(NULL,0,'2019-11-29 22:13:10',NULL,566,303,23,40),(NULL,0,'2019-11-29 22:13:10',NULL,567,304,22,2),(NULL,0,'2019-11-29 22:13:10',NULL,568,304,23,40),(NULL,0,'2019-11-29 22:13:10',NULL,569,305,22,2),(NULL,0,'2019-11-29 22:13:10',NULL,570,305,23,40),(NULL,0,'2019-11-29 22:13:10',NULL,571,306,22,2),(NULL,0,'2019-11-29 22:13:10',NULL,572,306,23,40),(NULL,0,'2019-11-29 22:13:11',NULL,573,307,22,2),(NULL,0,'2019-11-29 22:13:11',NULL,574,307,23,40),(NULL,0,'2019-11-29 22:13:11',NULL,575,308,22,2),(NULL,0,'2019-11-29 22:13:11',NULL,576,308,23,40),(NULL,0,'2019-11-29 22:13:11',NULL,577,309,22,2),(NULL,0,'2019-11-29 22:13:11',NULL,578,309,23,40),(NULL,0,'2019-11-29 22:13:11',NULL,579,310,22,2),(NULL,0,'2019-11-29 22:13:11',NULL,580,310,23,40),(NULL,0,'2019-11-29 22:13:12',NULL,581,312,22,2),(NULL,0,'2019-11-29 22:13:12',NULL,582,312,23,40),(NULL,0,'2019-11-29 22:13:12',NULL,583,313,22,2),(NULL,0,'2019-11-29 22:13:12',NULL,584,313,23,40),(NULL,0,'2019-11-29 22:13:12',NULL,585,314,22,2),(NULL,0,'2019-11-29 22:13:12',NULL,586,314,23,40),(NULL,0,'2019-11-29 22:13:12',NULL,587,315,22,2),(NULL,0,'2019-11-29 22:13:12',NULL,588,315,23,40),(NULL,0,'2019-11-29 22:13:13',NULL,589,316,22,2),(NULL,0,'2019-11-29 22:13:13',NULL,590,316,23,40),(NULL,0,'2019-11-29 22:13:13',NULL,591,317,22,2),(NULL,0,'2019-11-29 22:13:13',NULL,592,317,23,40),(NULL,0,'2019-11-29 22:13:13',NULL,593,318,22,2),(NULL,0,'2019-11-29 22:13:13',NULL,594,318,23,40),(NULL,0,'2019-11-29 22:13:13',NULL,595,319,22,2),(NULL,0,'2019-11-29 22:13:13',NULL,596,319,23,40),(NULL,0,'2019-11-29 22:13:13',NULL,597,320,22,2),(NULL,0,'2019-11-29 22:13:14',NULL,598,320,23,40),(NULL,0,'2019-11-29 22:13:14',NULL,599,321,22,2),(NULL,0,'2019-11-29 22:13:14',NULL,600,321,23,40),(NULL,0,'2019-11-29 22:13:14',NULL,601,322,22,2),(NULL,0,'2019-11-29 22:13:14',NULL,602,322,23,40),(NULL,0,'2019-11-29 22:13:14',NULL,603,323,22,2),(NULL,0,'2019-11-29 22:13:14',NULL,604,323,23,40),(NULL,0,'2019-11-29 22:13:14',NULL,605,324,22,2),(NULL,0,'2019-11-29 22:13:14',NULL,606,324,23,40),(NULL,0,'2019-11-29 22:13:15',NULL,607,325,22,2),(NULL,0,'2019-11-29 22:13:15',NULL,608,325,23,40),(NULL,0,'2019-11-29 22:13:15',NULL,609,326,22,2),(NULL,0,'2019-11-29 22:13:15',NULL,610,326,23,40),(NULL,0,'2019-11-29 22:13:15',NULL,611,327,22,2),(NULL,0,'2019-11-29 22:13:15',NULL,612,327,23,40),(NULL,0,'2019-11-29 22:13:15',NULL,613,330,22,2),(NULL,0,'2019-11-29 22:13:16',NULL,614,330,23,40),(NULL,0,'2019-11-29 22:13:16',NULL,615,331,22,2),(NULL,0,'2019-11-29 22:13:16',NULL,616,331,23,40),(NULL,0,'2019-11-29 22:13:16',NULL,617,332,22,2),(NULL,0,'2019-11-29 22:13:16',NULL,618,332,23,40),(NULL,0,'2019-11-29 22:13:16',NULL,619,333,22,2),(NULL,0,'2019-11-29 22:13:16',NULL,620,333,23,40),(NULL,0,'2019-11-29 22:13:16',NULL,621,334,22,2),(NULL,0,'2019-11-29 22:13:16',NULL,622,334,23,40),(NULL,0,'2019-11-29 22:13:17',NULL,623,335,22,2),(NULL,0,'2019-11-29 22:13:17',NULL,624,335,23,40),(NULL,0,'2019-11-29 22:13:17',NULL,625,336,22,2),(NULL,0,'2019-11-29 22:13:17',NULL,626,336,23,40),(NULL,0,'2019-11-29 22:13:17',NULL,627,337,22,2),(NULL,0,'2019-11-29 22:13:17',NULL,628,337,23,40),(NULL,0,'2019-11-29 22:13:17',NULL,629,338,22,2),(NULL,0,'2019-11-29 22:13:17',NULL,630,338,23,40),(NULL,0,'2019-11-29 22:13:18',NULL,631,339,22,2),(NULL,0,'2019-11-29 22:13:18',NULL,632,339,23,40),(NULL,0,'2019-11-29 22:13:18',NULL,633,340,22,2),(NULL,0,'2019-11-29 22:13:18',NULL,634,340,23,40),(NULL,0,'2019-11-29 22:13:18',NULL,635,341,22,2),(NULL,0,'2019-11-29 22:13:18',NULL,636,341,23,40),(NULL,0,'2019-11-29 22:13:18',NULL,637,342,22,2),(NULL,0,'2019-11-29 22:13:18',NULL,638,342,23,40),(NULL,0,'2019-11-29 22:13:18',NULL,639,343,22,2),(NULL,0,'2019-11-29 22:13:18',NULL,640,343,23,40),(NULL,0,'2019-11-29 22:13:19',NULL,641,344,22,2),(NULL,0,'2019-11-29 22:13:19',NULL,642,344,23,40),(NULL,0,'2019-11-29 22:13:19',NULL,643,345,22,2),(NULL,0,'2019-11-29 22:13:19',NULL,644,345,23,40),(NULL,0,'2019-11-29 22:13:19',NULL,645,347,22,2),(NULL,0,'2019-11-29 22:13:19',NULL,646,347,23,40),(NULL,0,'2019-11-29 22:13:19',NULL,647,348,22,2),(NULL,0,'2019-11-29 22:13:19',NULL,648,348,23,40),(NULL,0,'2019-11-29 22:13:20',NULL,649,349,22,2),(NULL,0,'2019-11-29 22:13:20',NULL,650,349,23,40),(NULL,0,'2019-11-29 22:13:20',NULL,651,350,22,2),(NULL,0,'2019-11-29 22:13:20',NULL,652,350,23,40),(NULL,0,'2019-11-29 22:13:20',NULL,653,351,22,2),(NULL,0,'2019-11-29 22:13:20',NULL,654,351,23,40),(NULL,0,'2019-11-29 22:13:20',NULL,655,352,22,2),(NULL,0,'2019-11-29 22:13:20',NULL,656,352,23,40),(NULL,0,'2019-11-29 22:13:21',NULL,657,353,22,2),(NULL,0,'2019-11-29 22:13:21',NULL,658,353,23,40),(NULL,0,'2019-11-29 22:13:21',NULL,659,354,22,2),(NULL,0,'2019-11-29 22:13:21',NULL,660,354,23,40),(NULL,0,'2019-11-29 22:13:21',NULL,661,355,22,2),(NULL,0,'2019-11-29 22:13:21',NULL,662,355,23,40),(NULL,0,'2019-11-29 22:13:21',NULL,663,356,22,2),(NULL,0,'2019-11-29 22:13:21',NULL,664,356,23,40),(NULL,0,'2019-11-29 22:13:21',NULL,665,357,22,2),(NULL,0,'2019-11-29 22:13:22',NULL,666,357,23,40),(NULL,0,'2019-11-29 22:13:22',NULL,667,358,22,2),(NULL,0,'2019-11-29 22:13:22',NULL,668,358,23,40),(NULL,0,'2019-11-29 22:13:22',NULL,669,359,22,2),(NULL,0,'2019-11-29 22:13:22',NULL,670,359,23,40),(NULL,0,'2019-11-29 22:13:22',NULL,671,360,22,2),(NULL,0,'2019-11-29 22:13:22',NULL,672,360,23,40),(NULL,0,'2019-11-29 22:13:22',NULL,673,361,22,2),(NULL,0,'2019-11-29 22:13:22',NULL,674,361,23,40),(NULL,0,'2019-11-29 22:13:23',NULL,675,362,22,2),(NULL,0,'2019-11-29 22:13:23',NULL,676,362,23,40),(NULL,0,'2019-11-29 22:13:23',NULL,677,364,22,2),(NULL,0,'2019-11-29 22:13:23',NULL,678,364,23,40),(NULL,0,'2019-11-29 22:13:23',NULL,679,365,22,2),(NULL,0,'2019-11-29 22:13:23',NULL,680,365,23,40),(NULL,0,'2019-11-29 22:13:23',NULL,681,366,22,2),(NULL,0,'2019-11-29 22:13:23',NULL,682,366,23,40),(NULL,0,'2019-11-29 22:13:24',NULL,683,367,22,2),(NULL,0,'2019-11-29 22:13:24',NULL,684,367,23,40),(NULL,0,'2019-11-29 22:13:24',NULL,685,368,22,2),(NULL,0,'2019-11-29 22:13:24',NULL,686,368,23,40),(NULL,0,'2019-11-29 22:13:24',NULL,687,369,22,2),(NULL,0,'2019-11-29 22:13:24',NULL,688,369,23,40),(NULL,0,'2019-11-29 22:13:24',NULL,689,370,22,2),(NULL,0,'2019-11-29 22:13:24',NULL,690,370,23,40),(NULL,0,'2019-11-29 22:13:25',NULL,691,371,22,2),(NULL,0,'2019-11-29 22:13:25',NULL,692,371,23,40),(NULL,0,'2019-11-29 22:13:25',NULL,693,372,22,2),(NULL,0,'2019-11-29 22:13:25',NULL,694,372,23,40),(NULL,0,'2019-11-29 22:13:25',NULL,695,373,22,2),(NULL,0,'2019-11-29 22:13:25',NULL,696,373,23,40),(NULL,0,'2019-11-29 22:13:25',NULL,697,374,22,2),(NULL,0,'2019-11-29 22:13:25',NULL,698,374,23,40),(NULL,0,'2019-11-29 22:13:25',NULL,699,375,22,2),(NULL,0,'2019-11-29 22:13:25',NULL,700,375,23,40),(NULL,0,'2019-11-29 22:13:26',NULL,701,376,22,2),(NULL,0,'2019-11-29 22:13:26',NULL,702,376,23,40),(NULL,0,'2019-11-29 22:13:26',NULL,703,377,22,2),(NULL,0,'2019-11-29 22:13:26',NULL,704,377,23,40),(NULL,0,'2019-11-29 22:13:26',NULL,705,378,22,2),(NULL,0,'2019-11-29 22:13:26',NULL,706,378,23,40),(NULL,0,'2019-11-29 22:13:26',NULL,707,379,22,2),(NULL,0,'2019-11-29 22:13:26',NULL,708,379,23,40),(NULL,0,'2019-11-29 22:13:27',NULL,709,381,22,2),(NULL,0,'2019-11-29 22:13:27',NULL,710,381,23,40),(NULL,0,'2019-11-29 22:13:27',NULL,711,382,22,2),(NULL,0,'2019-11-29 22:13:27',NULL,712,382,23,40),(NULL,0,'2019-11-29 22:13:27',NULL,713,383,22,2),(NULL,0,'2019-11-29 22:13:27',NULL,714,383,23,40),(NULL,0,'2019-11-29 22:13:27',NULL,715,384,22,2),(NULL,0,'2019-11-29 22:13:27',NULL,716,384,23,40),(NULL,0,'2019-11-29 22:13:28',NULL,717,385,22,2),(NULL,0,'2019-11-29 22:13:28',NULL,718,385,23,40),(NULL,0,'2019-11-29 22:13:28',NULL,719,386,22,2),(NULL,0,'2019-11-29 22:13:28',NULL,720,386,23,40),(NULL,0,'2019-11-29 22:13:28',NULL,721,387,22,2),(NULL,0,'2019-11-29 22:13:28',NULL,722,387,23,40),(NULL,0,'2019-11-29 22:13:28',NULL,723,388,22,2),(NULL,0,'2019-11-29 22:13:28',NULL,724,388,23,40),(NULL,0,'2019-11-29 22:13:28',NULL,725,389,22,2),(NULL,0,'2019-11-29 22:13:29',NULL,726,389,23,40),(NULL,0,'2019-11-29 22:13:29',NULL,727,390,22,2),(NULL,0,'2019-11-29 22:13:29',NULL,728,390,23,40),(NULL,0,'2019-11-29 22:13:29',NULL,729,391,22,2),(NULL,0,'2019-11-29 22:13:29',NULL,730,391,23,40),(NULL,0,'2019-11-29 22:13:29',NULL,731,392,22,2),(NULL,0,'2019-11-29 22:13:29',NULL,732,392,23,40),(NULL,0,'2019-11-29 22:13:29',NULL,733,393,22,2),(NULL,0,'2019-11-29 22:13:29',NULL,734,393,23,40),(NULL,0,'2019-11-29 22:13:30',NULL,735,394,22,2),(NULL,0,'2019-11-29 22:13:30',NULL,736,394,23,40),(NULL,0,'2019-11-29 22:13:30',NULL,737,395,22,2),(NULL,0,'2019-11-29 22:13:30',NULL,738,395,23,40),(NULL,0,'2019-11-29 22:13:30',NULL,739,396,22,2),(NULL,0,'2019-11-29 22:13:30',NULL,740,396,23,40),(NULL,0,'2019-11-29 22:13:30',NULL,741,398,22,2),(NULL,0,'2019-11-29 22:13:30',NULL,742,398,23,40),(NULL,0,'2019-11-29 22:13:31',NULL,743,399,22,2),(NULL,0,'2019-11-29 22:13:31',NULL,744,399,23,40),(NULL,0,'2019-11-29 22:13:31',NULL,745,400,22,2),(NULL,0,'2019-11-29 22:13:31',NULL,746,400,23,40),(NULL,0,'2019-11-29 22:13:31',NULL,747,401,22,2),(NULL,0,'2019-11-29 22:13:31',NULL,748,401,23,40),(NULL,0,'2019-11-29 22:13:31',NULL,749,402,22,2),(NULL,0,'2019-11-29 22:13:31',NULL,750,402,23,40),(NULL,0,'2019-11-29 22:13:32',NULL,751,403,22,2),(NULL,0,'2019-11-29 22:13:32',NULL,752,403,23,40),(NULL,0,'2019-11-29 22:13:32',NULL,753,404,22,2),(NULL,0,'2019-11-29 22:13:32',NULL,754,404,23,40),(NULL,0,'2019-11-29 22:13:32',NULL,755,405,22,2),(NULL,0,'2019-11-29 22:13:32',NULL,756,405,23,40),(NULL,0,'2019-11-29 22:13:32',NULL,757,406,22,2),(NULL,0,'2019-11-29 22:13:32',NULL,758,406,23,40),(NULL,0,'2019-11-29 22:13:32',NULL,759,407,22,2),(NULL,0,'2019-11-29 22:13:33',NULL,760,407,23,40),(NULL,0,'2019-11-29 22:13:33',NULL,761,408,22,2),(NULL,0,'2019-11-29 22:13:33',NULL,762,408,23,40),(NULL,0,'2019-11-29 22:13:33',NULL,763,409,22,2),(NULL,0,'2019-11-29 22:13:33',NULL,764,409,23,40),(NULL,0,'2019-11-29 22:13:33',NULL,765,410,22,2),(NULL,0,'2019-11-29 22:13:33',NULL,766,410,23,40),(NULL,0,'2019-11-29 22:13:33',NULL,767,411,22,2),(NULL,0,'2019-11-29 22:13:33',NULL,768,411,23,40),(NULL,0,'2019-11-29 22:13:34',NULL,769,412,22,2),(NULL,0,'2019-11-29 22:13:34',NULL,770,412,23,40),(NULL,0,'2019-11-29 22:13:34',NULL,771,413,22,2),(NULL,0,'2019-11-29 22:13:34',NULL,772,413,23,40),(NULL,0,'2019-11-29 22:13:34',NULL,773,415,22,2),(NULL,0,'2019-11-29 22:13:34',NULL,774,415,23,40),(NULL,0,'2019-11-29 22:13:34',NULL,775,416,22,2),(NULL,0,'2019-11-29 22:13:34',NULL,776,416,23,40),(NULL,0,'2019-11-29 22:13:35',NULL,777,417,22,2),(NULL,0,'2019-11-29 22:13:35',NULL,778,417,23,40),(NULL,0,'2019-11-29 22:13:35',NULL,779,418,22,2),(NULL,0,'2019-11-29 22:13:35',NULL,780,418,23,40),(NULL,0,'2019-11-29 22:13:35',NULL,781,419,22,2),(NULL,0,'2019-11-29 22:13:35',NULL,782,419,23,40),(NULL,0,'2019-11-29 22:13:35',NULL,783,420,22,2),(NULL,0,'2019-11-29 22:13:35',NULL,784,420,23,40),(NULL,0,'2019-11-29 22:13:36',NULL,785,421,22,2),(NULL,0,'2019-11-29 22:13:36',NULL,786,421,23,40),(NULL,0,'2019-11-29 22:13:36',NULL,787,422,22,2),(NULL,0,'2019-11-29 22:13:36',NULL,788,422,23,40),(NULL,0,'2019-11-29 22:13:36',NULL,789,423,22,2),(NULL,0,'2019-11-29 22:13:36',NULL,790,423,23,40),(NULL,0,'2019-11-29 22:13:36',NULL,791,424,22,2),(NULL,0,'2019-11-29 22:13:36',NULL,792,424,23,40),(NULL,0,'2019-11-29 22:13:36',NULL,793,425,22,2),(NULL,0,'2019-11-29 22:13:37',NULL,794,425,23,40),(NULL,0,'2019-11-29 22:13:37',NULL,795,426,22,2),(NULL,0,'2019-11-29 22:13:37',NULL,796,426,23,40),(NULL,0,'2019-11-29 22:13:37',NULL,797,427,22,2),(NULL,0,'2019-11-29 22:13:37',NULL,798,427,23,40),(NULL,0,'2019-11-29 22:13:37',NULL,799,428,22,2),(NULL,0,'2019-11-29 22:13:37',NULL,800,428,23,40),(NULL,0,'2019-11-29 22:13:37',NULL,801,429,22,2),(NULL,0,'2019-11-29 22:13:37',NULL,802,429,23,40),(NULL,0,'2019-11-29 22:13:38',NULL,803,430,22,2),(NULL,0,'2019-11-29 22:13:38',NULL,804,430,23,40),(NULL,0,'2019-11-29 22:13:38',NULL,805,432,22,2),(NULL,0,'2019-11-29 22:13:38',NULL,806,432,23,40),(NULL,0,'2019-11-29 22:13:38',NULL,807,433,22,2),(NULL,0,'2019-11-29 22:13:38',NULL,808,433,23,40),(NULL,0,'2019-11-29 22:13:38',NULL,809,434,22,2),(NULL,0,'2019-11-29 22:13:38',NULL,810,434,23,40),(NULL,0,'2019-11-29 22:13:39',NULL,811,435,22,2),(NULL,0,'2019-11-29 22:13:39',NULL,812,435,23,40),(NULL,0,'2019-11-29 22:13:39',NULL,813,436,22,2),(NULL,0,'2019-11-29 22:13:39',NULL,814,436,23,40),(NULL,0,'2019-11-29 22:13:39',NULL,815,437,22,2),(NULL,0,'2019-11-29 22:13:39',NULL,816,437,23,40),(NULL,0,'2019-11-29 22:13:39',NULL,817,438,22,2),(NULL,0,'2019-11-29 22:13:39',NULL,818,438,23,40),(NULL,0,'2019-11-29 22:13:40',NULL,819,439,22,2),(NULL,0,'2019-11-29 22:13:40',NULL,820,439,23,40),(NULL,0,'2019-11-29 22:13:40',NULL,821,440,22,2),(NULL,0,'2019-11-29 22:13:40',NULL,822,440,23,40),(NULL,0,'2019-11-29 22:13:40',NULL,823,441,22,2),(NULL,0,'2019-11-29 22:13:40',NULL,824,441,23,40),(NULL,0,'2019-11-29 22:13:40',NULL,825,442,22,2),(NULL,0,'2019-11-29 22:13:40',NULL,826,442,23,40),(NULL,0,'2019-11-29 22:13:40',NULL,827,443,22,2),(NULL,0,'2019-11-29 22:13:41',NULL,828,443,23,40),(NULL,0,'2019-11-29 22:13:41',NULL,829,444,22,2),(NULL,0,'2019-11-29 22:13:41',NULL,830,444,23,40),(NULL,0,'2019-11-29 22:13:41',NULL,831,445,22,2),(NULL,0,'2019-11-29 22:13:41',NULL,832,445,23,40),(NULL,0,'2019-11-29 22:13:41',NULL,833,446,22,2),(NULL,0,'2019-11-29 22:13:41',NULL,834,446,23,40),(NULL,0,'2019-11-29 22:13:41',NULL,835,447,22,2),(NULL,0,'2019-11-29 22:13:41',NULL,836,447,23,40),(NULL,0,'2019-11-29 22:13:42',NULL,837,449,22,2),(NULL,0,'2019-11-29 22:13:42',NULL,838,449,23,40),(NULL,0,'2019-11-29 22:13:42',NULL,839,450,22,2),(NULL,0,'2019-11-29 22:13:42',NULL,840,450,23,40),(NULL,0,'2019-11-29 22:13:42',NULL,841,451,22,2),(NULL,0,'2019-11-29 22:13:42',NULL,842,451,23,40),(NULL,0,'2019-11-29 22:13:42',NULL,843,452,22,2),(NULL,0,'2019-11-29 22:13:42',NULL,844,452,23,40),(NULL,0,'2019-11-29 22:13:43',NULL,845,453,22,2),(NULL,0,'2019-11-29 22:13:43',NULL,846,453,23,40),(NULL,0,'2019-11-29 22:13:43',NULL,847,454,22,2),(NULL,0,'2019-11-29 22:13:43',NULL,848,454,23,40),(NULL,0,'2019-11-29 22:13:43',NULL,849,455,22,2),(NULL,0,'2019-11-29 22:13:43',NULL,850,455,23,40),(NULL,0,'2019-11-29 22:13:43',NULL,851,456,22,2),(NULL,0,'2019-11-29 22:13:43',NULL,852,456,23,40),(NULL,0,'2019-11-29 22:13:44',NULL,853,457,22,2),(NULL,0,'2019-11-29 22:13:44',NULL,854,457,23,40),(NULL,0,'2019-11-29 22:13:44',NULL,855,458,22,2),(NULL,0,'2019-11-29 22:13:44',NULL,856,458,23,40),(NULL,0,'2019-11-29 22:13:44',NULL,857,459,22,2),(NULL,0,'2019-11-29 22:13:44',NULL,858,459,23,40),(NULL,0,'2019-11-29 22:13:44',NULL,859,460,22,2),(NULL,0,'2019-11-29 22:13:44',NULL,860,460,23,40),(NULL,0,'2019-11-29 22:13:44',NULL,861,461,22,2),(NULL,0,'2019-11-29 22:13:45',NULL,862,461,23,40),(NULL,0,'2019-11-29 22:13:45',NULL,863,462,22,2),(NULL,0,'2019-11-29 22:13:45',NULL,864,462,23,40),(NULL,0,'2019-11-29 22:13:45',NULL,865,463,22,2),(NULL,0,'2019-11-29 22:13:45',NULL,866,463,23,40),(NULL,0,'2019-11-29 22:13:45',NULL,867,464,22,2),(NULL,0,'2019-11-29 22:13:45',NULL,868,464,23,40),(NULL,0,'2019-11-29 22:13:46',NULL,869,467,22,2),(NULL,0,'2019-11-29 22:13:46',NULL,870,467,23,40),(NULL,0,'2019-11-29 22:13:46',NULL,871,468,22,2),(NULL,0,'2019-11-29 22:13:46',NULL,872,468,23,40),(NULL,0,'2019-11-29 22:13:46',NULL,873,469,22,2),(NULL,0,'2019-11-29 22:13:46',NULL,874,469,23,40),(NULL,0,'2019-11-29 22:13:46',NULL,875,470,22,2),(NULL,0,'2019-11-29 22:13:46',NULL,876,470,23,40),(NULL,0,'2019-11-29 22:13:46',NULL,877,471,22,2),(NULL,0,'2019-11-29 22:13:46',NULL,878,471,23,40),(NULL,0,'2019-11-29 22:13:47',NULL,879,472,22,2),(NULL,0,'2019-11-29 22:13:47',NULL,880,472,23,40),(NULL,0,'2019-11-29 22:13:47',NULL,881,473,22,2),(NULL,0,'2019-11-29 22:13:47',NULL,882,473,23,40),(NULL,0,'2019-11-29 22:13:47',NULL,883,474,22,2),(NULL,0,'2019-11-29 22:13:47',NULL,884,474,23,40),(NULL,0,'2019-11-29 22:13:47',NULL,885,475,22,2),(NULL,0,'2019-11-29 22:13:47',NULL,886,475,23,40),(NULL,0,'2019-11-29 22:13:48',NULL,887,476,22,2),(NULL,0,'2019-11-29 22:13:48',NULL,888,476,23,40),(NULL,0,'2019-11-29 22:13:48',NULL,889,477,22,2),(NULL,0,'2019-11-29 22:13:48',NULL,890,477,23,40),(NULL,0,'2019-11-29 22:13:48',NULL,891,478,22,2),(NULL,0,'2019-11-29 22:13:48',NULL,892,478,23,40),(NULL,0,'2019-11-29 22:13:48',NULL,893,479,22,2),(NULL,0,'2019-11-29 22:13:48',NULL,894,479,23,40),(NULL,0,'2019-11-29 22:13:48',NULL,895,480,22,2),(NULL,0,'2019-11-29 22:13:49',NULL,896,480,23,40),(NULL,0,'2019-11-29 22:13:49',NULL,897,481,22,2),(NULL,0,'2019-11-29 22:13:49',NULL,898,481,23,40),(NULL,0,'2019-11-29 22:13:49',NULL,899,482,22,2),(NULL,0,'2019-11-29 22:13:49',NULL,900,482,23,40),(NULL,0,'2019-11-29 22:13:49',NULL,901,484,22,2),(NULL,0,'2019-11-29 22:13:49',NULL,902,484,23,40),(NULL,0,'2019-11-29 22:13:49',NULL,903,485,22,2),(NULL,0,'2019-11-29 22:13:50',NULL,904,485,23,40),(NULL,0,'2019-11-29 22:13:50',NULL,905,486,22,2),(NULL,0,'2019-11-29 22:13:50',NULL,906,486,23,40),(NULL,0,'2019-11-29 22:13:50',NULL,907,487,22,2),(NULL,0,'2019-11-29 22:13:50',NULL,908,487,23,40),(NULL,0,'2019-11-29 22:13:50',NULL,909,488,22,2),(NULL,0,'2019-11-29 22:13:50',NULL,910,488,23,40),(NULL,0,'2019-11-29 22:13:50',NULL,911,489,22,2),(NULL,0,'2019-11-29 22:13:50',NULL,912,489,23,40),(NULL,0,'2019-11-29 22:13:51',NULL,913,490,22,2),(NULL,0,'2019-11-29 22:13:51',NULL,914,490,23,40),(NULL,0,'2019-11-29 22:13:51',NULL,915,491,22,2),(NULL,0,'2019-11-29 22:13:51',NULL,916,491,23,40),(NULL,0,'2019-11-29 22:13:51',NULL,917,492,22,2),(NULL,0,'2019-11-29 22:13:51',NULL,918,492,23,40),(NULL,0,'2019-11-29 22:13:51',NULL,919,493,22,2),(NULL,0,'2019-11-29 22:13:51',NULL,920,493,23,40),(NULL,0,'2019-11-29 22:13:52',NULL,921,494,22,2),(NULL,0,'2019-11-29 22:13:52',NULL,922,494,23,40),(NULL,0,'2019-11-29 22:13:52',NULL,923,495,22,2),(NULL,0,'2019-11-29 22:13:52',NULL,924,495,23,40),(NULL,0,'2019-11-29 22:13:52',NULL,925,496,22,2),(NULL,0,'2019-11-29 22:13:52',NULL,926,496,23,40),(NULL,0,'2019-11-29 22:13:52',NULL,927,497,22,2),(NULL,0,'2019-11-29 22:13:52',NULL,928,497,23,40),(NULL,0,'2019-11-29 22:13:52',NULL,929,498,22,2),(NULL,0,'2019-11-29 22:13:53',NULL,930,498,23,40),(NULL,0,'2019-11-29 22:13:53',NULL,931,499,22,2),(NULL,0,'2019-11-29 22:13:53',NULL,932,499,23,40),(NULL,0,'2019-11-29 22:13:53',NULL,933,501,22,2),(NULL,0,'2019-11-29 22:13:53',NULL,934,501,23,40),(NULL,0,'2019-11-29 22:13:53',NULL,935,502,22,2),(NULL,0,'2019-11-29 22:13:53',NULL,936,502,23,40),(NULL,0,'2019-11-29 22:13:53',NULL,937,503,22,2),(NULL,0,'2019-11-29 22:13:54',NULL,938,503,23,40),(NULL,0,'2019-11-29 22:13:54',NULL,939,504,22,2),(NULL,0,'2019-11-29 22:13:54',NULL,940,504,23,40),(NULL,0,'2019-11-29 22:13:54',NULL,941,505,22,2),(NULL,0,'2019-11-29 22:13:54',NULL,942,505,23,40),(NULL,0,'2019-11-29 22:13:54',NULL,943,506,22,2),(NULL,0,'2019-11-29 22:13:54',NULL,944,506,23,40),(NULL,0,'2019-11-29 22:13:54',NULL,945,507,22,2),(NULL,0,'2019-11-29 22:13:54',NULL,946,507,23,40),(NULL,0,'2019-11-29 22:13:55',NULL,947,508,22,2),(NULL,0,'2019-11-29 22:13:55',NULL,948,508,23,40),(NULL,0,'2019-11-29 22:13:55',NULL,949,509,22,2),(NULL,0,'2019-11-29 22:13:55',NULL,950,509,23,40),(NULL,0,'2019-11-29 22:13:55',NULL,951,510,22,2),(NULL,0,'2019-11-29 22:13:55',NULL,952,510,23,40),(NULL,0,'2019-11-29 22:13:55',NULL,953,511,22,2),(NULL,0,'2019-11-29 22:13:55',NULL,954,511,23,40),(NULL,0,'2019-11-29 22:13:55',NULL,955,512,22,2),(NULL,0,'2019-11-29 22:13:56',NULL,956,512,23,40),(NULL,0,'2019-11-29 22:13:56',NULL,957,513,22,2),(NULL,0,'2019-11-29 22:13:56',NULL,958,513,23,40),(NULL,0,'2019-11-29 22:13:56',NULL,959,514,22,2),(NULL,0,'2019-11-29 22:13:56',NULL,960,514,23,40),(NULL,0,'2019-11-29 22:13:56',NULL,961,515,22,2),(NULL,0,'2019-11-29 22:13:56',NULL,962,515,23,40),(NULL,0,'2019-11-29 22:13:56',NULL,963,516,22,2),(NULL,0,'2019-11-29 22:13:56',NULL,964,516,23,40),(NULL,0,'2019-11-29 22:13:57',NULL,965,518,22,2),(NULL,0,'2019-11-29 22:13:57',NULL,966,518,23,40),(NULL,0,'2019-11-29 22:13:57',NULL,967,519,22,2),(NULL,0,'2019-11-29 22:13:57',NULL,968,519,23,40),(NULL,0,'2019-11-29 22:13:57',NULL,969,520,22,2),(NULL,0,'2019-11-29 22:13:57',NULL,970,520,23,40),(NULL,0,'2019-11-29 22:13:57',NULL,971,521,22,2),(NULL,0,'2019-11-29 22:13:57',NULL,972,521,23,40),(NULL,0,'2019-11-29 22:13:58',NULL,973,522,22,2),(NULL,0,'2019-11-29 22:13:58',NULL,974,522,23,40),(NULL,0,'2019-11-29 22:13:58',NULL,975,523,22,2),(NULL,0,'2019-11-29 22:13:58',NULL,976,523,23,40),(NULL,0,'2019-11-29 22:13:58',NULL,977,524,22,2),(NULL,0,'2019-11-29 22:13:58',NULL,978,524,23,40),(NULL,0,'2019-11-29 22:13:58',NULL,979,525,22,2),(NULL,0,'2019-11-29 22:13:58',NULL,980,525,23,40),(NULL,0,'2019-11-29 22:13:59',NULL,981,526,22,2),(NULL,0,'2019-11-29 22:13:59',NULL,982,526,23,40),(NULL,0,'2019-11-29 22:13:59',NULL,983,527,22,2),(NULL,0,'2019-11-29 22:13:59',NULL,984,527,23,40),(NULL,0,'2019-11-29 22:13:59',NULL,985,528,22,2),(NULL,0,'2019-11-29 22:13:59',NULL,986,528,23,40),(NULL,0,'2019-11-29 22:13:59',NULL,987,529,22,2),(NULL,0,'2019-11-29 22:13:59',NULL,988,529,23,40),(NULL,0,'2019-11-29 22:14:00',NULL,989,530,22,2),(NULL,0,'2019-11-29 22:14:00',NULL,990,530,23,40),(NULL,0,'2019-11-29 22:14:00',NULL,991,531,22,2),(NULL,0,'2019-11-29 22:14:00',NULL,992,531,23,40),(NULL,0,'2019-11-29 22:14:00',NULL,993,532,22,2),(NULL,0,'2019-11-29 22:14:00',NULL,994,532,23,40),(NULL,0,'2019-11-29 22:14:00',NULL,995,533,22,2),(NULL,0,'2019-11-29 22:14:00',NULL,996,533,23,40),(NULL,0,'2019-11-29 22:14:01',NULL,997,535,22,2),(NULL,0,'2019-11-29 22:14:01',NULL,998,535,23,40),(NULL,0,'2019-11-29 22:14:01',NULL,999,536,22,2),(NULL,0,'2019-11-29 22:14:01',NULL,1000,536,23,40),(NULL,0,'2019-11-29 22:14:01',NULL,1001,537,22,2),(NULL,0,'2019-11-29 22:14:01',NULL,1002,537,23,40),(NULL,0,'2019-11-29 22:14:01',NULL,1003,538,22,2),(NULL,0,'2019-11-29 22:14:01',NULL,1004,538,23,40),(NULL,0,'2019-11-29 22:14:01',NULL,1005,539,22,2),(NULL,0,'2019-11-29 22:14:01',NULL,1006,539,23,40),(NULL,0,'2019-11-29 22:14:02',NULL,1007,540,22,2),(NULL,0,'2019-11-29 22:14:02',NULL,1008,540,23,40),(NULL,0,'2019-11-29 22:14:02',NULL,1009,541,22,2),(NULL,0,'2019-11-29 22:14:02',NULL,1010,541,23,40),(NULL,0,'2019-11-29 22:14:02',NULL,1011,542,22,2),(NULL,0,'2019-11-29 22:14:02',NULL,1012,542,23,40),(NULL,0,'2019-11-29 22:14:02',NULL,1013,543,22,2),(NULL,0,'2019-11-29 22:14:02',NULL,1014,543,23,40),(NULL,0,'2019-11-29 22:14:03',NULL,1015,544,22,2),(NULL,0,'2019-11-29 22:14:03',NULL,1016,544,23,40),(NULL,0,'2019-11-29 22:14:03',NULL,1017,545,22,2),(NULL,0,'2019-11-29 22:14:03',NULL,1018,545,23,40),(NULL,0,'2019-11-29 22:14:03',NULL,1019,546,22,2),(NULL,0,'2019-11-29 22:14:03',NULL,1020,546,23,40),(NULL,0,'2019-11-29 22:14:03',NULL,1021,547,22,2),(NULL,0,'2019-11-29 22:14:03',NULL,1022,547,23,40),(NULL,0,'2019-11-29 22:14:04',NULL,1023,548,22,2),(NULL,0,'2019-11-29 22:14:04',NULL,1024,548,23,40),(NULL,0,'2019-11-29 22:14:04',NULL,1025,549,22,2),(NULL,0,'2019-11-29 22:14:04',NULL,1026,549,23,40),(NULL,0,'2019-11-29 22:14:04',NULL,1027,550,22,2),(NULL,0,'2019-11-29 22:14:04',NULL,1028,550,23,40),(NULL,0,'2019-11-29 22:14:04',NULL,1029,552,22,2),(NULL,0,'2019-11-29 22:14:04',NULL,1030,552,23,40),(NULL,0,'2019-11-29 22:14:04',NULL,1031,553,22,2),(NULL,0,'2019-11-29 22:14:05',NULL,1032,553,23,40),(NULL,0,'2019-11-29 22:14:05',NULL,1033,554,22,2),(NULL,0,'2019-11-29 22:14:05',NULL,1034,554,23,40),(NULL,0,'2019-11-29 22:14:05',NULL,1035,555,22,2),(NULL,0,'2019-11-29 22:14:05',NULL,1036,555,23,40),(NULL,0,'2019-11-29 22:14:05',NULL,1037,556,22,2),(NULL,0,'2019-11-29 22:14:05',NULL,1038,556,23,40),(NULL,0,'2019-11-29 22:14:05',NULL,1039,557,22,2),(NULL,0,'2019-11-29 22:14:05',NULL,1040,557,23,40),(NULL,0,'2019-11-29 22:14:06',NULL,1041,558,22,2),(NULL,0,'2019-11-29 22:14:06',NULL,1042,558,23,40),(NULL,0,'2019-11-29 22:14:06',NULL,1043,559,22,2),(NULL,0,'2019-11-29 22:14:06',NULL,1044,559,23,40),(NULL,0,'2019-11-29 22:14:06',NULL,1045,560,22,2),(NULL,0,'2019-11-29 22:14:06',NULL,1046,560,23,40),(NULL,0,'2019-11-29 22:14:06',NULL,1047,561,22,2),(NULL,0,'2019-11-29 22:14:06',NULL,1048,561,23,40),(NULL,0,'2019-11-29 22:14:07',NULL,1049,562,22,2),(NULL,0,'2019-11-29 22:14:07',NULL,1050,562,23,40),(NULL,0,'2019-11-29 22:14:07',NULL,1051,563,22,2),(NULL,0,'2019-11-29 22:14:07',NULL,1052,563,23,40),(NULL,0,'2019-11-29 22:14:07',NULL,1053,564,22,2),(NULL,0,'2019-11-29 22:14:07',NULL,1054,564,23,40),(NULL,0,'2019-11-29 22:14:07',NULL,1055,565,22,2),(NULL,0,'2019-11-29 22:14:07',NULL,1056,565,23,40),(NULL,0,'2019-11-29 22:14:08',NULL,1057,566,22,2),(NULL,0,'2019-11-29 22:14:08',NULL,1058,566,23,40),(NULL,0,'2019-11-29 22:14:08',NULL,1059,567,22,2),(NULL,0,'2019-11-29 22:14:08',NULL,1060,567,23,40),(NULL,0,'2019-11-29 22:14:08',NULL,1061,569,22,2),(NULL,0,'2019-11-29 22:14:08',NULL,1062,569,23,40),(NULL,0,'2019-11-29 22:14:08',NULL,1063,570,22,2),(NULL,0,'2019-11-29 22:14:08',NULL,1064,570,23,40),(NULL,0,'2019-11-29 22:14:08',NULL,1065,571,22,2),(NULL,0,'2019-11-29 22:14:09',NULL,1066,571,23,40),(NULL,0,'2019-11-29 22:14:09',NULL,1067,572,22,2),(NULL,0,'2019-11-29 22:14:09',NULL,1068,572,23,40),(NULL,0,'2019-11-29 22:14:09',NULL,1069,573,22,2),(NULL,0,'2019-11-29 22:14:09',NULL,1070,573,23,40),(NULL,0,'2019-11-29 22:14:09',NULL,1071,574,22,2),(NULL,0,'2019-11-29 22:14:09',NULL,1072,574,23,40),(NULL,0,'2019-11-29 22:14:09',NULL,1073,575,22,2),(NULL,0,'2019-11-29 22:14:09',NULL,1074,575,23,40),(NULL,0,'2019-11-29 22:14:10',NULL,1075,576,22,2),(NULL,0,'2019-11-29 22:14:10',NULL,1076,576,23,40),(NULL,0,'2019-11-29 22:14:10',NULL,1077,577,22,2),(NULL,0,'2019-11-29 22:14:10',NULL,1078,577,23,40),(NULL,0,'2019-11-29 22:14:10',NULL,1079,578,22,2),(NULL,0,'2019-11-29 22:14:10',NULL,1080,578,23,40),(NULL,0,'2019-11-29 22:14:10',NULL,1081,579,22,2),(NULL,0,'2019-11-29 22:14:10',NULL,1082,579,23,40),(NULL,0,'2019-11-29 22:14:11',NULL,1083,580,22,2),(NULL,0,'2019-11-29 22:14:11',NULL,1084,580,23,40),(NULL,0,'2019-11-29 22:14:11',NULL,1085,581,22,2),(NULL,0,'2019-11-29 22:14:11',NULL,1086,581,23,40),(NULL,0,'2019-11-29 22:14:11',NULL,1087,582,22,2),(NULL,0,'2019-11-29 22:14:11',NULL,1088,582,23,40),(NULL,0,'2019-11-29 22:14:11',NULL,1089,583,22,2),(NULL,0,'2019-11-29 22:14:11',NULL,1090,583,23,40),(NULL,0,'2019-11-29 22:14:11',NULL,1091,584,22,2),(NULL,0,'2019-11-29 22:14:12',NULL,1092,584,23,40),(NULL,0,'2019-11-29 22:14:12',NULL,1093,586,22,2),(NULL,0,'2019-11-29 22:14:12',NULL,1094,586,23,40),(NULL,0,'2019-11-29 22:14:12',NULL,1095,587,22,2),(NULL,0,'2019-11-29 22:14:12',NULL,1096,587,23,40),(NULL,0,'2019-11-29 22:14:12',NULL,1097,588,22,2),(NULL,0,'2019-11-29 22:14:12',NULL,1098,588,23,40),(NULL,0,'2019-11-29 22:14:12',NULL,1099,589,22,2),(NULL,0,'2019-11-29 22:14:13',NULL,1100,589,23,40),(NULL,0,'2019-11-29 22:14:13',NULL,1101,590,22,2),(NULL,0,'2019-11-29 22:14:13',NULL,1102,590,23,40),(NULL,0,'2019-11-29 22:14:13',NULL,1103,591,22,2),(NULL,0,'2019-11-29 22:14:13',NULL,1104,591,23,40),(NULL,0,'2019-11-29 22:14:13',NULL,1105,592,22,2),(NULL,0,'2019-11-29 22:14:13',NULL,1106,592,23,40),(NULL,0,'2019-11-29 22:14:13',NULL,1107,593,22,2),(NULL,0,'2019-11-29 22:14:13',NULL,1108,593,23,40),(NULL,0,'2019-11-29 22:14:14',NULL,1109,594,22,2),(NULL,0,'2019-11-29 22:14:14',NULL,1110,594,23,40),(NULL,0,'2019-11-29 22:14:14',NULL,1111,595,22,2),(NULL,0,'2019-11-29 22:14:14',NULL,1112,595,23,40),(NULL,0,'2019-11-29 22:14:14',NULL,1113,596,22,2),(NULL,0,'2019-11-29 22:14:14',NULL,1114,596,23,40),(NULL,0,'2019-11-29 22:14:14',NULL,1115,597,22,2),(NULL,0,'2019-11-29 22:14:14',NULL,1116,597,23,40),(NULL,0,'2019-11-29 22:14:15',NULL,1117,598,22,2),(NULL,0,'2019-11-29 22:14:15',NULL,1118,598,23,40),(NULL,0,'2019-11-29 22:14:15',NULL,1119,599,22,2),(NULL,0,'2019-11-29 22:14:15',NULL,1120,599,23,40),(NULL,0,'2019-11-29 22:14:15',NULL,1121,600,22,2),(NULL,0,'2019-11-29 22:14:15',NULL,1122,600,23,40),(NULL,0,'2019-11-29 22:14:15',NULL,1123,601,22,2),(NULL,0,'2019-11-29 22:14:15',NULL,1124,601,23,40),(NULL,0,'2019-11-29 22:15:20',NULL,1637,879,22,2),(NULL,0,'2019-11-29 22:15:20',NULL,1638,879,23,40),(NULL,0,'2019-11-29 22:15:20',NULL,1639,880,22,2),(NULL,0,'2019-11-29 22:15:20',NULL,1640,880,23,40),(NULL,0,'2019-11-29 22:15:20',NULL,1641,881,22,2),(NULL,0,'2019-11-29 22:15:20',NULL,1642,881,23,40),(NULL,0,'2019-11-29 22:15:20',NULL,1643,882,22,2),(NULL,0,'2019-11-29 22:15:20',NULL,1644,882,23,40),(NULL,0,'2019-11-29 22:15:21',NULL,1645,883,22,2),(NULL,0,'2019-11-29 22:15:21',NULL,1646,883,23,40),(NULL,0,'2019-11-29 22:15:21',NULL,1647,884,22,2),(NULL,0,'2019-11-29 22:15:21',NULL,1648,884,23,40),(NULL,0,'2019-11-29 22:15:21',NULL,1649,885,22,2),(NULL,0,'2019-11-29 22:15:21',NULL,1650,885,23,40),(NULL,0,'2019-11-29 22:15:21',NULL,1651,886,22,2),(NULL,0,'2019-11-29 22:15:21',NULL,1652,886,23,40),(NULL,0,'2019-11-29 22:15:21',NULL,1653,887,22,2),(NULL,0,'2019-11-29 22:15:21',NULL,1654,887,23,40),(NULL,0,'2019-11-29 22:15:22',NULL,1655,888,22,2),(NULL,0,'2019-11-29 22:15:22',NULL,1656,888,23,40),(NULL,0,'2019-11-29 22:15:22',NULL,1657,889,22,2),(NULL,0,'2019-11-29 22:15:22',NULL,1658,889,23,40),(NULL,0,'2019-11-29 22:15:22',NULL,1659,890,22,2),(NULL,0,'2019-11-29 22:15:22',NULL,1660,890,23,40),(NULL,0,'2019-11-29 22:15:22',NULL,1661,891,22,2),(NULL,0,'2019-11-29 22:15:22',NULL,1662,891,23,40),(NULL,0,'2019-11-29 22:15:23',NULL,1663,892,22,2),(NULL,0,'2019-11-29 22:15:23',NULL,1664,892,23,40),(NULL,0,'2019-11-29 22:15:23',NULL,1665,893,22,2),(NULL,0,'2019-11-29 22:15:23',NULL,1666,893,23,40),(NULL,0,'2019-11-29 22:15:23',NULL,1667,894,22,2),(NULL,0,'2019-11-29 22:15:23',NULL,1668,894,23,40),(NULL,0,'2019-11-29 22:15:23',NULL,1669,896,22,2),(NULL,0,'2019-11-29 22:15:23',NULL,1670,896,23,40),(NULL,0,'2019-11-29 22:15:24',NULL,1671,897,22,2),(NULL,0,'2019-11-29 22:15:24',NULL,1672,897,23,40),(NULL,0,'2019-11-29 22:15:24',NULL,1673,898,22,2),(NULL,0,'2019-11-29 22:15:24',NULL,1674,898,23,40),(NULL,0,'2019-11-29 22:15:24',NULL,1675,899,22,2),(NULL,0,'2019-11-29 22:15:24',NULL,1676,899,23,40),(NULL,0,'2019-11-29 22:15:24',NULL,1677,900,22,2),(NULL,0,'2019-11-29 22:15:24',NULL,1678,900,23,40),(NULL,0,'2019-11-29 22:15:25',NULL,1679,901,22,2),(NULL,0,'2019-11-29 22:15:25',NULL,1680,901,23,40),(NULL,0,'2019-11-29 22:15:25',NULL,1681,902,22,2),(NULL,0,'2019-11-29 22:15:25',NULL,1682,902,23,40),(NULL,0,'2019-11-29 22:15:25',NULL,1683,903,22,2),(NULL,0,'2019-11-29 22:15:25',NULL,1684,903,23,40),(NULL,0,'2019-11-29 22:15:25',NULL,1685,904,22,2),(NULL,0,'2019-11-29 22:15:25',NULL,1686,904,23,40),(NULL,0,'2019-11-29 22:15:25',NULL,1687,905,22,2),(NULL,0,'2019-11-29 22:15:25',NULL,1688,905,23,40),(NULL,0,'2019-11-29 22:15:26',NULL,1689,906,22,2),(NULL,0,'2019-11-29 22:15:26',NULL,1690,906,23,40),(NULL,0,'2019-11-29 22:15:26',NULL,1691,907,22,2),(NULL,0,'2019-11-29 22:15:26',NULL,1692,907,23,40),(NULL,0,'2019-11-29 22:15:26',NULL,1693,908,22,2),(NULL,0,'2019-11-29 22:15:26',NULL,1694,908,23,40),(NULL,0,'2019-11-29 22:15:26',NULL,1695,909,22,2),(NULL,0,'2019-11-29 22:15:26',NULL,1696,909,23,40),(NULL,0,'2019-11-29 22:15:27',NULL,1697,910,22,2),(NULL,0,'2019-11-29 22:15:27',NULL,1698,910,23,40),(NULL,0,'2019-11-29 22:15:27',NULL,1699,911,22,2),(NULL,0,'2019-11-29 22:15:27',NULL,1700,911,23,40),(NULL,0,'2019-11-29 22:15:27',NULL,1701,913,22,2),(NULL,0,'2019-11-29 22:15:27',NULL,1702,913,23,40),(NULL,0,'2019-11-29 22:15:27',NULL,1703,914,22,2),(NULL,0,'2019-11-29 22:15:27',NULL,1704,914,23,40),(NULL,0,'2019-11-29 22:15:28',NULL,1705,915,22,2),(NULL,0,'2019-11-29 22:15:28',NULL,1706,915,23,40),(NULL,0,'2019-11-29 22:15:28',NULL,1707,916,22,2),(NULL,0,'2019-11-29 22:15:28',NULL,1708,916,23,40),(NULL,0,'2019-11-29 22:15:28',NULL,1709,917,22,2),(NULL,0,'2019-11-29 22:15:28',NULL,1710,917,23,40),(NULL,0,'2019-11-29 22:15:28',NULL,1711,918,22,2),(NULL,0,'2019-11-29 22:15:28',NULL,1712,918,23,40),(NULL,0,'2019-11-29 22:15:28',NULL,1713,919,22,2),(NULL,0,'2019-11-29 22:15:29',NULL,1714,919,23,40),(NULL,0,'2019-11-29 22:15:29',NULL,1715,920,22,2),(NULL,0,'2019-11-29 22:15:29',NULL,1716,920,23,40),(NULL,0,'2019-11-29 22:15:29',NULL,1717,921,22,2),(NULL,0,'2019-11-29 22:15:29',NULL,1718,921,23,40),(NULL,0,'2019-11-29 22:15:29',NULL,1719,922,22,2),(NULL,0,'2019-11-29 22:15:29',NULL,1720,922,23,40),(NULL,0,'2019-11-29 22:15:29',NULL,1721,923,22,2),(NULL,0,'2019-11-29 22:15:29',NULL,1722,923,23,40),(NULL,0,'2019-11-29 22:15:30',NULL,1723,924,22,2),(NULL,0,'2019-11-29 22:15:30',NULL,1724,924,23,40),(NULL,0,'2019-11-29 22:15:30',NULL,1725,925,22,2),(NULL,0,'2019-11-29 22:15:30',NULL,1726,925,23,40),(NULL,0,'2019-11-29 22:15:30',NULL,1727,926,22,2),(NULL,0,'2019-11-29 22:15:30',NULL,1728,926,23,40),(NULL,0,'2019-11-29 22:15:30',NULL,1729,927,22,2),(NULL,0,'2019-11-29 22:15:30',NULL,1730,927,23,40),(NULL,0,'2019-11-29 22:15:31',NULL,1731,928,22,2),(NULL,0,'2019-11-29 22:15:31',NULL,1732,928,23,40),(NULL,0,'2019-11-29 22:15:31',NULL,1733,930,22,2),(NULL,0,'2019-11-29 22:15:31',NULL,1734,930,23,40),(NULL,0,'2019-11-29 22:15:31',NULL,1735,931,22,2),(NULL,0,'2019-11-29 22:15:31',NULL,1736,931,23,40),(NULL,0,'2019-11-29 22:15:31',NULL,1737,932,22,2),(NULL,0,'2019-11-29 22:15:31',NULL,1738,932,23,40),(NULL,0,'2019-11-29 22:15:32',NULL,1739,933,22,2),(NULL,0,'2019-11-29 22:15:32',NULL,1740,933,23,40),(NULL,0,'2019-11-29 22:15:32',NULL,1741,934,22,2),(NULL,0,'2019-11-29 22:15:32',NULL,1742,934,23,40),(NULL,0,'2019-11-29 22:15:32',NULL,1743,935,22,2),(NULL,0,'2019-11-29 22:15:32',NULL,1744,935,23,40),(NULL,0,'2019-11-29 22:15:32',NULL,1745,936,22,2),(NULL,0,'2019-11-29 22:15:32',NULL,1746,936,23,40),(NULL,0,'2019-11-29 22:15:32',NULL,1747,937,22,2),(NULL,0,'2019-11-29 22:15:33',NULL,1748,937,23,40),(NULL,0,'2019-11-29 22:15:33',NULL,1749,938,22,2),(NULL,0,'2019-11-29 22:15:33',NULL,1750,938,23,40),(NULL,0,'2019-11-29 22:15:33',NULL,1751,939,22,2),(NULL,0,'2019-11-29 22:15:33',NULL,1752,939,23,40),(NULL,0,'2019-11-29 22:15:33',NULL,1753,940,22,2),(NULL,0,'2019-11-29 22:15:33',NULL,1754,940,23,40),(NULL,0,'2019-11-29 22:15:33',NULL,1755,941,22,2),(NULL,0,'2019-11-29 22:15:33',NULL,1756,941,23,40),(NULL,0,'2019-11-29 22:15:34',NULL,1757,942,22,2),(NULL,0,'2019-11-29 22:15:34',NULL,1758,942,23,40),(NULL,0,'2019-11-29 22:15:34',NULL,1759,943,22,2),(NULL,0,'2019-11-29 22:15:34',NULL,1760,943,23,40),(NULL,0,'2019-11-29 22:15:34',NULL,1761,944,22,2),(NULL,0,'2019-11-29 22:15:34',NULL,1762,944,23,40),(NULL,0,'2019-11-29 22:15:34',NULL,1763,945,22,2),(NULL,0,'2019-11-29 22:15:34',NULL,1764,945,23,40),(NULL,0,'2019-11-29 22:15:35',NULL,1765,947,22,2),(NULL,0,'2019-11-29 22:15:35',NULL,1766,947,23,40),(NULL,0,'2019-11-29 22:15:35',NULL,1767,948,22,2),(NULL,0,'2019-11-29 22:15:35',NULL,1768,948,23,40),(NULL,0,'2019-11-29 22:15:35',NULL,1769,949,22,2),(NULL,0,'2019-11-29 22:15:35',NULL,1770,949,23,40),(NULL,0,'2019-11-29 22:15:35',NULL,1771,950,22,2),(NULL,0,'2019-11-29 22:15:35',NULL,1772,950,23,40),(NULL,0,'2019-11-29 22:15:36',NULL,1773,951,22,2),(NULL,0,'2019-11-29 22:15:36',NULL,1774,951,23,40),(NULL,0,'2019-11-29 22:15:36',NULL,1775,952,22,2),(NULL,0,'2019-11-29 22:15:36',NULL,1776,952,23,40),(NULL,0,'2019-11-29 22:15:36',NULL,1777,953,22,2),(NULL,0,'2019-11-29 22:15:36',NULL,1778,953,23,40),(NULL,0,'2019-11-29 22:15:36',NULL,1779,954,22,2),(NULL,0,'2019-11-29 22:15:36',NULL,1780,954,23,40),(NULL,0,'2019-11-29 22:15:36',NULL,1781,955,22,2),(NULL,0,'2019-11-29 22:15:37',NULL,1782,955,23,40),(NULL,0,'2019-11-29 22:15:37',NULL,1783,956,22,2),(NULL,0,'2019-11-29 22:15:37',NULL,1784,956,23,40),(NULL,0,'2019-11-29 22:15:37',NULL,1785,957,22,2),(NULL,0,'2019-11-29 22:15:37',NULL,1786,957,23,40),(NULL,0,'2019-11-29 22:15:37',NULL,1787,958,22,2),(NULL,0,'2019-11-29 22:15:37',NULL,1788,958,23,40),(NULL,0,'2019-11-29 22:15:37',NULL,1789,959,22,2),(NULL,0,'2019-11-29 22:15:37',NULL,1790,959,23,40),(NULL,0,'2019-11-29 22:15:38',NULL,1791,960,22,2),(NULL,0,'2019-11-29 22:15:38',NULL,1792,960,23,40),(NULL,0,'2019-11-29 22:15:38',NULL,1793,961,22,2),(NULL,0,'2019-11-29 22:15:38',NULL,1794,961,23,40),(NULL,0,'2019-11-29 22:15:38',NULL,1795,962,22,2),(NULL,0,'2019-11-29 22:15:38',NULL,1796,962,23,40),(NULL,0,'2019-11-29 22:15:38',NULL,1797,964,22,2),(NULL,0,'2019-11-29 22:15:38',NULL,1798,964,23,40),(NULL,0,'2019-11-29 22:15:39',NULL,1799,965,22,2),(NULL,0,'2019-11-29 22:15:39',NULL,1800,965,23,40),(NULL,0,'2019-11-29 22:15:39',NULL,1801,966,22,2),(NULL,0,'2019-11-29 22:15:39',NULL,1802,966,23,40),(NULL,0,'2019-11-29 22:15:39',NULL,1803,967,22,2),(NULL,0,'2019-11-29 22:15:39',NULL,1804,967,23,40),(NULL,0,'2019-11-29 22:15:39',NULL,1805,968,22,2),(NULL,0,'2019-11-29 22:15:39',NULL,1806,968,23,40),(NULL,0,'2019-11-29 22:15:40',NULL,1807,969,22,2),(NULL,0,'2019-11-29 22:15:40',NULL,1808,969,23,40),(NULL,0,'2019-11-29 22:15:40',NULL,1809,970,22,2),(NULL,0,'2019-11-29 22:15:40',NULL,1810,970,23,40),(NULL,0,'2019-11-29 22:15:40',NULL,1811,971,22,2),(NULL,0,'2019-11-29 22:15:40',NULL,1812,971,23,40),(NULL,0,'2019-11-29 22:15:40',NULL,1813,972,22,2),(NULL,0,'2019-11-29 22:15:40',NULL,1814,972,23,40),(NULL,0,'2019-11-29 22:15:40',NULL,1815,973,22,2),(NULL,0,'2019-11-29 22:15:41',NULL,1816,973,23,40),(NULL,0,'2019-11-29 22:15:41',NULL,1817,974,22,2),(NULL,0,'2019-11-29 22:15:41',NULL,1818,974,23,40),(NULL,0,'2019-11-29 22:15:41',NULL,1819,975,22,2),(NULL,0,'2019-11-29 22:15:41',NULL,1820,975,23,40),(NULL,0,'2019-11-29 22:15:41',NULL,1821,976,22,2),(NULL,0,'2019-11-29 22:15:41',NULL,1822,976,23,40),(NULL,0,'2019-11-29 22:15:41',NULL,1823,977,22,2),(NULL,0,'2019-11-29 22:15:41',NULL,1824,977,23,40),(NULL,0,'2019-11-29 22:15:42',NULL,1825,978,22,2),(NULL,0,'2019-11-29 22:15:42',NULL,1826,978,23,40),(NULL,0,'2019-11-29 22:15:42',NULL,1827,979,22,2),(NULL,0,'2019-11-29 22:15:42',NULL,1828,979,23,40),(NULL,0,'2019-11-29 22:15:42',NULL,1829,981,22,2),(NULL,0,'2019-11-29 22:15:42',NULL,1830,981,23,40),(NULL,0,'2019-11-29 22:15:42',NULL,1831,982,22,2),(NULL,0,'2019-11-29 22:15:42',NULL,1832,982,23,40),(NULL,0,'2019-11-29 22:15:43',NULL,1833,983,22,2),(NULL,0,'2019-11-29 22:15:43',NULL,1834,983,23,40),(NULL,0,'2019-11-29 22:15:43',NULL,1835,984,22,2),(NULL,0,'2019-11-29 22:15:43',NULL,1836,984,23,40),(NULL,0,'2019-11-29 22:15:43',NULL,1837,985,22,2),(NULL,0,'2019-11-29 22:15:43',NULL,1838,985,23,40),(NULL,0,'2019-11-29 22:15:43',NULL,1839,986,22,2),(NULL,0,'2019-11-29 22:15:43',NULL,1840,986,23,40),(NULL,0,'2019-11-29 22:15:44',NULL,1841,987,22,2),(NULL,0,'2019-11-29 22:15:44',NULL,1842,987,23,40),(NULL,0,'2019-11-29 22:15:44',NULL,1843,988,22,2),(NULL,0,'2019-11-29 22:15:44',NULL,1844,988,23,40),(NULL,0,'2019-11-29 22:15:44',NULL,1845,989,22,2),(NULL,0,'2019-11-29 22:15:44',NULL,1846,989,23,40),(NULL,0,'2019-11-29 22:15:44',NULL,1847,990,22,2),(NULL,0,'2019-11-29 22:15:44',NULL,1848,990,23,40),(NULL,0,'2019-11-29 22:15:44',NULL,1849,991,22,2),(NULL,0,'2019-11-29 22:15:45',NULL,1850,991,23,40),(NULL,0,'2019-11-29 22:15:45',NULL,1851,992,22,2),(NULL,0,'2019-11-29 22:15:45',NULL,1852,992,23,40),(NULL,0,'2019-11-29 22:15:45',NULL,1853,993,22,2),(NULL,0,'2019-11-29 22:15:45',NULL,1854,993,23,40),(NULL,0,'2019-11-29 22:15:45',NULL,1855,994,22,2),(NULL,0,'2019-11-29 22:15:45',NULL,1856,994,23,40),(NULL,0,'2019-11-29 22:15:45',NULL,1857,995,22,2),(NULL,0,'2019-11-29 22:15:45',NULL,1858,995,23,40),(NULL,0,'2019-11-29 22:15:46',NULL,1859,996,22,2),(NULL,0,'2019-11-29 22:15:46',NULL,1860,996,23,40),(NULL,0,'2019-11-29 22:15:46',NULL,1861,998,22,2),(NULL,0,'2019-11-29 22:15:46',NULL,1862,998,23,40),(NULL,0,'2019-11-29 22:15:46',NULL,1863,999,22,2),(NULL,0,'2019-11-29 22:15:46',NULL,1864,999,23,40),(NULL,0,'2019-11-29 22:15:46',NULL,1865,1000,22,2),(NULL,0,'2019-11-29 22:15:46',NULL,1866,1000,23,40),(NULL,0,'2019-11-29 22:15:47',NULL,1867,1001,22,2),(NULL,0,'2019-11-29 22:15:47',NULL,1868,1001,23,40),(NULL,0,'2019-11-29 22:15:47',NULL,1869,1002,22,2),(NULL,0,'2019-11-29 22:15:47',NULL,1870,1002,23,40),(NULL,0,'2019-11-29 22:15:47',NULL,1871,1003,22,2),(NULL,0,'2019-11-29 22:15:47',NULL,1872,1003,23,40),(NULL,0,'2019-11-29 22:15:47',NULL,1873,1004,22,2),(NULL,0,'2019-11-29 22:15:47',NULL,1874,1004,23,40),(NULL,0,'2019-11-29 22:15:48',NULL,1875,1005,22,2),(NULL,0,'2019-11-29 22:15:48',NULL,1876,1005,23,40),(NULL,0,'2019-11-29 22:15:48',NULL,1877,1006,22,2),(NULL,0,'2019-11-29 22:15:48',NULL,1878,1006,23,40),(NULL,0,'2019-11-29 22:15:48',NULL,1879,1007,22,2),(NULL,0,'2019-11-29 22:15:48',NULL,1880,1007,23,40),(NULL,0,'2019-11-29 22:15:48',NULL,1881,1008,22,2),(NULL,0,'2019-11-29 22:15:48',NULL,1882,1008,23,40),(NULL,0,'2019-11-29 22:15:48',NULL,1883,1009,22,2),(NULL,0,'2019-11-29 22:15:49',NULL,1884,1009,23,40),(NULL,0,'2019-11-29 22:15:49',NULL,1885,1010,22,2),(NULL,0,'2019-11-29 22:15:49',NULL,1886,1010,23,40),(NULL,0,'2019-11-29 22:15:49',NULL,1887,1011,22,2),(NULL,0,'2019-11-29 22:15:49',NULL,1888,1011,23,40),(NULL,0,'2019-11-29 22:15:49',NULL,1889,1012,22,2),(NULL,0,'2019-11-29 22:15:49',NULL,1890,1012,23,40),(NULL,0,'2019-11-29 22:15:49',NULL,1891,1013,22,2),(NULL,0,'2019-11-29 22:15:49',NULL,1892,1013,23,40),(NULL,0,'2019-11-29 22:15:50',NULL,1893,1016,22,2),(NULL,0,'2019-11-29 22:15:50',NULL,1894,1016,23,40),(NULL,0,'2019-11-29 22:15:50',NULL,1895,1017,22,2),(NULL,0,'2019-11-29 22:15:50',NULL,1896,1017,23,40),(NULL,0,'2019-11-29 22:15:50',NULL,1897,1018,22,2),(NULL,0,'2019-11-29 22:15:50',NULL,1898,1018,23,40),(NULL,0,'2019-11-29 22:15:50',NULL,1899,1019,22,2),(NULL,0,'2019-11-29 22:15:50',NULL,1900,1019,23,40),(NULL,0,'2019-11-29 22:15:51',NULL,1901,1020,22,2),(NULL,0,'2019-11-29 22:15:51',NULL,1902,1020,23,40),(NULL,0,'2019-11-29 22:15:51',NULL,1903,1021,22,2),(NULL,0,'2019-11-29 22:15:51',NULL,1904,1021,23,40),(NULL,0,'2019-11-29 22:15:51',NULL,1905,1022,22,2),(NULL,0,'2019-11-29 22:15:51',NULL,1906,1022,23,40),(NULL,0,'2019-11-29 22:15:51',NULL,1907,1023,22,2),(NULL,0,'2019-11-29 22:15:51',NULL,1908,1023,23,40),(NULL,0,'2019-11-29 22:15:52',NULL,1909,1024,22,2),(NULL,0,'2019-11-29 22:15:52',NULL,1910,1024,23,40),(NULL,0,'2019-11-29 22:15:52',NULL,1911,1025,22,2),(NULL,0,'2019-11-29 22:15:52',NULL,1912,1025,23,40),(NULL,0,'2019-11-29 22:15:52',NULL,1913,1026,22,2),(NULL,0,'2019-11-29 22:15:52',NULL,1914,1026,23,40),(NULL,0,'2019-11-29 22:15:52',NULL,1915,1027,22,2),(NULL,0,'2019-11-29 22:15:52',NULL,1916,1027,23,40),(NULL,0,'2019-11-29 22:15:52',NULL,1917,1028,22,2),(NULL,0,'2019-11-29 22:15:53',NULL,1918,1028,23,40),(NULL,0,'2019-11-29 22:15:53',NULL,1919,1029,22,2),(NULL,0,'2019-11-29 22:15:53',NULL,1920,1029,23,40),(NULL,0,'2019-11-29 22:15:53',NULL,1921,1030,22,2),(NULL,0,'2019-11-29 22:15:53',NULL,1922,1030,23,40),(NULL,0,'2019-11-29 22:15:53',NULL,1923,1031,22,2),(NULL,0,'2019-11-29 22:15:53',NULL,1924,1031,23,40),(NULL,0,'2019-11-29 22:15:53',NULL,1925,1033,22,2),(NULL,0,'2019-11-29 22:15:54',NULL,1926,1033,23,40),(NULL,0,'2019-11-29 22:15:54',NULL,1927,1034,22,2),(NULL,0,'2019-11-29 22:15:54',NULL,1928,1034,23,40),(NULL,0,'2019-11-29 22:15:54',NULL,1929,1035,22,2),(NULL,0,'2019-11-29 22:15:54',NULL,1930,1035,23,40),(NULL,0,'2019-11-29 22:15:54',NULL,1931,1036,22,2),(NULL,0,'2019-11-29 22:15:54',NULL,1932,1036,23,40),(NULL,0,'2019-11-29 22:15:54',NULL,1933,1037,22,2),(NULL,0,'2019-11-29 22:15:54',NULL,1934,1037,23,40),(NULL,0,'2019-11-29 22:15:55',NULL,1935,1038,22,2),(NULL,0,'2019-11-29 22:15:55',NULL,1936,1038,23,40),(NULL,0,'2019-11-29 22:15:55',NULL,1937,1039,22,2),(NULL,0,'2019-11-29 22:15:55',NULL,1938,1039,23,40),(NULL,0,'2019-11-29 22:15:55',NULL,1939,1040,22,2),(NULL,0,'2019-11-29 22:15:55',NULL,1940,1040,23,40),(NULL,0,'2019-11-29 22:15:55',NULL,1941,1041,22,2),(NULL,0,'2019-11-29 22:15:55',NULL,1942,1041,23,40),(NULL,0,'2019-11-29 22:15:56',NULL,1943,1042,22,2),(NULL,0,'2019-11-29 22:15:56',NULL,1944,1042,23,40),(NULL,0,'2019-11-29 22:15:56',NULL,1945,1043,22,2),(NULL,0,'2019-11-29 22:15:56',NULL,1946,1043,23,40),(NULL,0,'2019-11-29 22:15:56',NULL,1947,1044,22,2),(NULL,0,'2019-11-29 22:15:56',NULL,1948,1044,23,40),(NULL,0,'2019-11-29 22:15:56',NULL,1949,1045,22,2),(NULL,0,'2019-11-29 22:15:56',NULL,1950,1045,23,40),(NULL,0,'2019-11-29 22:15:56',NULL,1951,1046,22,2),(NULL,0,'2019-11-29 22:15:57',NULL,1952,1046,23,40),(NULL,0,'2019-11-29 22:15:57',NULL,1953,1047,22,2),(NULL,0,'2019-11-29 22:15:57',NULL,1954,1047,23,40),(NULL,0,'2019-11-29 22:15:57',NULL,1955,1048,22,2),(NULL,0,'2019-11-29 22:15:57',NULL,1956,1048,23,40),(NULL,0,'2019-11-29 22:15:57',NULL,1957,1050,22,2),(NULL,0,'2019-11-29 22:15:57',NULL,1958,1050,23,40),(NULL,0,'2019-11-29 22:15:57',NULL,1959,1051,22,2),(NULL,0,'2019-11-29 22:15:58',NULL,1960,1051,23,40),(NULL,0,'2019-11-29 22:15:58',NULL,1961,1052,22,2),(NULL,0,'2019-11-29 22:15:58',NULL,1962,1052,23,40),(NULL,0,'2019-11-29 22:15:58',NULL,1963,1053,22,2),(NULL,0,'2019-11-29 22:15:58',NULL,1964,1053,23,40),(NULL,0,'2019-11-29 22:15:58',NULL,1965,1054,22,2),(NULL,0,'2019-11-29 22:15:58',NULL,1966,1054,23,40),(NULL,0,'2019-11-29 22:15:58',NULL,1967,1055,22,2),(NULL,0,'2019-11-29 22:15:58',NULL,1968,1055,23,40),(NULL,0,'2019-11-29 22:15:59',NULL,1969,1056,22,2),(NULL,0,'2019-11-29 22:15:59',NULL,1970,1056,23,40),(NULL,0,'2019-11-29 22:15:59',NULL,1971,1057,22,2),(NULL,0,'2019-11-29 22:15:59',NULL,1972,1057,23,40),(NULL,0,'2019-11-29 22:15:59',NULL,1973,1058,22,2),(NULL,0,'2019-11-29 22:15:59',NULL,1974,1058,23,40),(NULL,0,'2019-11-29 22:15:59',NULL,1975,1059,22,2),(NULL,0,'2019-11-29 22:15:59',NULL,1976,1059,23,40),(NULL,0,'2019-11-29 22:16:00',NULL,1977,1060,22,2),(NULL,0,'2019-11-29 22:16:00',NULL,1978,1060,23,40),(NULL,0,'2019-11-29 22:16:00',NULL,1979,1061,22,2),(NULL,0,'2019-11-29 22:16:00',NULL,1980,1061,23,40),(NULL,0,'2019-11-29 22:16:00',NULL,1981,1062,22,2),(NULL,0,'2019-11-29 22:16:00',NULL,1982,1062,23,40),(NULL,0,'2019-11-29 22:16:00',NULL,1983,1063,22,2),(NULL,0,'2019-11-29 22:16:00',NULL,1984,1063,23,40),(NULL,0,'2019-11-29 22:16:00',NULL,1985,1064,22,2),(NULL,0,'2019-11-29 22:16:01',NULL,1986,1064,23,40),(NULL,0,'2019-11-29 22:16:01',NULL,1987,1065,22,2),(NULL,0,'2019-11-29 22:16:01',NULL,1988,1065,23,40),(NULL,0,'2019-11-29 22:16:01',NULL,1989,1067,22,2),(NULL,0,'2019-11-29 22:16:01',NULL,1990,1067,23,40),(NULL,0,'2019-11-29 22:16:01',NULL,1991,1068,22,2),(NULL,0,'2019-11-29 22:16:01',NULL,1992,1068,23,40),(NULL,0,'2019-11-29 22:16:01',NULL,1993,1069,22,2),(NULL,0,'2019-11-29 22:16:02',NULL,1994,1069,23,40),(NULL,0,'2019-11-29 22:16:02',NULL,1995,1070,22,2),(NULL,0,'2019-11-29 22:16:02',NULL,1996,1070,23,40),(NULL,0,'2019-11-29 22:16:02',NULL,1997,1071,22,2),(NULL,0,'2019-11-29 22:16:02',NULL,1998,1071,23,40),(NULL,0,'2019-11-29 22:16:02',NULL,1999,1072,22,2),(NULL,0,'2019-11-29 22:16:02',NULL,2000,1072,23,40),(NULL,0,'2019-11-29 22:16:02',NULL,2001,1073,22,2),(NULL,0,'2019-11-29 22:16:02',NULL,2002,1073,23,40),(NULL,0,'2019-11-29 22:16:03',NULL,2003,1074,22,2),(NULL,0,'2019-11-29 22:16:03',NULL,2004,1074,23,40),(NULL,0,'2019-11-29 22:16:03',NULL,2005,1075,22,2),(NULL,0,'2019-11-29 22:16:03',NULL,2006,1075,23,40),(NULL,0,'2019-11-29 22:16:03',NULL,2007,1076,22,2),(NULL,0,'2019-11-29 22:16:03',NULL,2008,1076,23,40),(NULL,0,'2019-11-29 22:16:03',NULL,2009,1077,22,2),(NULL,0,'2019-11-29 22:16:03',NULL,2010,1077,23,40),(NULL,0,'2019-11-29 22:16:04',NULL,2011,1078,22,2),(NULL,0,'2019-11-29 22:16:04',NULL,2012,1078,23,40),(NULL,0,'2019-11-29 22:16:04',NULL,2013,1079,22,2),(NULL,0,'2019-11-29 22:16:04',NULL,2014,1079,23,40),(NULL,0,'2019-11-29 22:16:04',NULL,2015,1080,22,2),(NULL,0,'2019-11-29 22:16:04',NULL,2016,1080,23,40),(NULL,0,'2019-11-29 22:16:04',NULL,2017,1081,22,2),(NULL,0,'2019-11-29 22:16:04',NULL,2018,1081,23,40),(NULL,0,'2019-11-29 22:16:04',NULL,2019,1082,22,2),(NULL,0,'2019-11-29 22:16:05',NULL,2020,1082,23,40),(NULL,0,'2019-11-29 22:16:05',NULL,2021,1084,22,2),(NULL,0,'2019-11-29 22:16:05',NULL,2022,1084,23,40),(NULL,0,'2019-11-29 22:16:05',NULL,2023,1085,22,2),(NULL,0,'2019-11-29 22:16:05',NULL,2024,1085,23,40),(NULL,0,'2019-11-29 22:16:05',NULL,2025,1086,22,2),(NULL,0,'2019-11-29 22:16:05',NULL,2026,1086,23,40),(NULL,0,'2019-11-29 22:16:05',NULL,2027,1087,22,2),(NULL,0,'2019-11-29 22:16:06',NULL,2028,1087,23,40),(NULL,0,'2019-11-29 22:16:06',NULL,2029,1088,22,2),(NULL,0,'2019-11-29 22:16:06',NULL,2030,1088,23,40),(NULL,0,'2019-11-29 22:16:06',NULL,2031,1089,22,2),(NULL,0,'2019-11-29 22:16:06',NULL,2032,1089,23,40),(NULL,0,'2019-11-29 22:16:06',NULL,2033,1090,22,2),(NULL,0,'2019-11-29 22:16:06',NULL,2034,1090,23,40),(NULL,0,'2019-11-29 22:16:06',NULL,2035,1091,22,2),(NULL,0,'2019-11-29 22:16:06',NULL,2036,1091,23,40),(NULL,0,'2019-11-29 22:16:07',NULL,2037,1092,22,2),(NULL,0,'2019-11-29 22:16:07',NULL,2038,1092,23,40),(NULL,0,'2019-11-29 22:16:07',NULL,2039,1093,22,2),(NULL,0,'2019-11-29 22:16:07',NULL,2040,1093,23,40),(NULL,0,'2019-11-29 22:16:07',NULL,2041,1094,22,2),(NULL,0,'2019-11-29 22:16:07',NULL,2042,1094,23,40),(NULL,0,'2019-11-29 22:16:07',NULL,2043,1095,22,2),(NULL,0,'2019-11-29 22:16:07',NULL,2044,1095,23,40),(NULL,0,'2019-11-29 22:16:08',NULL,2045,1096,22,2),(NULL,0,'2019-11-29 22:16:08',NULL,2046,1096,23,40),(NULL,0,'2019-11-29 22:16:08',NULL,2047,1097,22,2),(NULL,0,'2019-11-29 22:16:08',NULL,2048,1097,23,40),(NULL,0,'2019-11-29 22:16:08',NULL,2049,1098,22,2),(NULL,0,'2019-11-29 22:16:08',NULL,2050,1098,23,40),(NULL,0,'2019-11-29 22:16:08',NULL,2051,1099,22,2),(NULL,0,'2019-11-29 22:16:08',NULL,2052,1099,23,40),(NULL,0,'2019-11-29 22:16:09',NULL,2053,1101,22,2),(NULL,0,'2019-11-29 22:16:09',NULL,2054,1101,23,40),(NULL,0,'2019-11-29 22:16:09',NULL,2055,1102,22,2),(NULL,0,'2019-11-29 22:16:09',NULL,2056,1102,23,40),(NULL,0,'2019-11-29 22:16:09',NULL,2057,1103,22,2),(NULL,0,'2019-11-29 22:16:09',NULL,2058,1103,23,40),(NULL,0,'2019-11-29 22:16:09',NULL,2059,1104,22,2),(NULL,0,'2019-11-29 22:16:09',NULL,2060,1104,23,40),(NULL,0,'2019-11-29 22:16:09',NULL,2061,1105,22,2),(NULL,0,'2019-11-29 22:16:09',NULL,2062,1105,23,40),(NULL,0,'2019-11-29 22:16:10',NULL,2063,1106,22,2),(NULL,0,'2019-11-29 22:16:10',NULL,2064,1106,23,40),(NULL,0,'2019-11-29 22:16:10',NULL,2065,1107,22,2),(NULL,0,'2019-11-29 22:16:10',NULL,2066,1107,23,40),(NULL,0,'2019-11-29 22:16:10',NULL,2067,1108,22,2),(NULL,0,'2019-11-29 22:16:10',NULL,2068,1108,23,40),(NULL,0,'2019-11-29 22:16:10',NULL,2069,1109,22,2),(NULL,0,'2019-11-29 22:16:10',NULL,2070,1109,23,40),(NULL,0,'2019-11-29 22:16:11',NULL,2071,1110,22,2),(NULL,0,'2019-11-29 22:16:11',NULL,2072,1110,23,40),(NULL,0,'2019-11-29 22:16:11',NULL,2073,1111,22,2),(NULL,0,'2019-11-29 22:16:11',NULL,2074,1111,23,40),(NULL,0,'2019-11-29 22:16:11',NULL,2075,1112,22,2),(NULL,0,'2019-11-29 22:16:11',NULL,2076,1112,23,40),(NULL,0,'2019-11-29 22:16:11',NULL,2077,1113,22,2),(NULL,0,'2019-11-29 22:16:11',NULL,2078,1113,23,40),(NULL,0,'2019-11-29 22:16:11',NULL,2079,1114,22,2),(NULL,0,'2019-11-29 22:16:12',NULL,2080,1114,23,40),(NULL,0,'2019-11-29 22:16:12',NULL,2081,1115,22,2),(NULL,0,'2019-11-29 22:16:12',NULL,2082,1115,23,40),(NULL,0,'2019-11-29 22:16:12',NULL,2083,1116,22,2),(NULL,0,'2019-11-29 22:16:12',NULL,2084,1116,23,40),(NULL,0,'2019-11-29 22:16:12',NULL,2085,1118,22,2),(NULL,0,'2019-11-29 22:16:12',NULL,2086,1118,23,40),(NULL,0,'2019-11-29 22:16:12',NULL,2087,1119,22,2),(NULL,0,'2019-11-29 22:16:13',NULL,2088,1119,23,40),(NULL,0,'2019-11-29 22:16:13',NULL,2089,1120,22,2),(NULL,0,'2019-11-29 22:16:13',NULL,2090,1120,23,40),(NULL,0,'2019-11-29 22:16:13',NULL,2091,1121,22,2),(NULL,0,'2019-11-29 22:16:13',NULL,2092,1121,23,40),(NULL,0,'2019-11-29 22:16:13',NULL,2093,1122,22,2),(NULL,0,'2019-11-29 22:16:13',NULL,2094,1122,23,40),(NULL,0,'2019-11-29 22:16:13',NULL,2095,1123,22,2),(NULL,0,'2019-11-29 22:16:13',NULL,2096,1123,23,40),(NULL,0,'2019-11-29 22:16:14',NULL,2097,1124,22,2),(NULL,0,'2019-11-29 22:16:14',NULL,2098,1124,23,40),(NULL,0,'2019-11-29 22:16:14',NULL,2099,1125,22,2),(NULL,0,'2019-11-29 22:16:14',NULL,2100,1125,23,40),(NULL,0,'2019-11-29 22:16:14',NULL,2101,1126,22,2),(NULL,0,'2019-11-29 22:16:14',NULL,2102,1126,23,40),(NULL,0,'2019-11-29 22:16:14',NULL,2103,1127,22,2),(NULL,0,'2019-11-29 22:16:14',NULL,2104,1127,23,40),(NULL,0,'2019-11-29 22:16:15',NULL,2105,1128,22,2),(NULL,0,'2019-11-29 22:16:15',NULL,2106,1128,23,40),(NULL,0,'2019-11-29 22:16:15',NULL,2107,1129,22,2),(NULL,0,'2019-11-29 22:16:15',NULL,2108,1129,23,40),(NULL,0,'2019-11-29 22:16:15',NULL,2109,1130,22,2),(NULL,0,'2019-11-29 22:16:15',NULL,2110,1130,23,40),(NULL,0,'2019-11-29 22:16:15',NULL,2111,1131,22,2),(NULL,0,'2019-11-29 22:16:15',NULL,2112,1131,23,40),(NULL,0,'2019-11-29 22:16:15',NULL,2113,1132,22,2),(NULL,0,'2019-11-29 22:16:16',NULL,2114,1132,23,40),(NULL,0,'2019-11-29 22:16:16',NULL,2115,1133,22,2),(NULL,0,'2019-11-29 22:16:16',NULL,2116,1133,23,40),(NULL,0,'2019-11-29 22:16:16',NULL,2117,1135,22,2),(NULL,0,'2019-11-29 22:16:16',NULL,2118,1135,23,40),(NULL,0,'2019-11-29 22:16:16',NULL,2119,1136,22,2),(NULL,0,'2019-11-29 22:16:16',NULL,2120,1136,23,40),(NULL,0,'2019-11-29 22:16:16',NULL,2121,1137,22,2),(NULL,0,'2019-11-29 22:16:17',NULL,2122,1137,23,40),(NULL,0,'2019-11-29 22:16:17',NULL,2123,1138,22,2),(NULL,0,'2019-11-29 22:16:17',NULL,2124,1138,23,40),(NULL,0,'2019-11-29 22:16:17',NULL,2125,1139,22,2),(NULL,0,'2019-11-29 22:16:17',NULL,2126,1139,23,40),(NULL,0,'2019-11-29 22:16:17',NULL,2127,1140,22,2),(NULL,0,'2019-11-29 22:16:17',NULL,2128,1140,23,40),(NULL,0,'2019-11-29 22:16:17',NULL,2129,1141,22,2),(NULL,0,'2019-11-29 22:16:17',NULL,2130,1141,23,40),(NULL,0,'2019-11-29 22:16:18',NULL,2131,1142,22,2),(NULL,0,'2019-11-29 22:16:18',NULL,2132,1142,23,40),(NULL,0,'2019-11-29 22:16:18',NULL,2133,1143,22,2),(NULL,0,'2019-11-29 22:16:18',NULL,2134,1143,23,40),(NULL,0,'2019-11-29 22:16:18',NULL,2135,1144,22,2),(NULL,0,'2019-11-29 22:16:18',NULL,2136,1144,23,40),(NULL,0,'2019-11-29 22:16:18',NULL,2137,1145,22,2),(NULL,0,'2019-11-29 22:16:18',NULL,2138,1145,23,40),(NULL,0,'2019-11-29 22:16:19',NULL,2139,1146,22,2),(NULL,0,'2019-11-29 22:16:19',NULL,2140,1146,23,40),(NULL,0,'2019-11-29 22:16:19',NULL,2141,1147,22,2),(NULL,0,'2019-11-29 22:16:19',NULL,2142,1147,23,40),(NULL,0,'2019-11-29 22:16:19',NULL,2143,1148,22,2),(NULL,0,'2019-11-29 22:16:19',NULL,2144,1148,23,40),(NULL,0,'2019-11-29 22:16:19',NULL,2145,1149,22,2),(NULL,0,'2019-11-29 22:16:19',NULL,2146,1149,23,40),(NULL,0,'2019-11-29 22:16:19',NULL,2147,1150,22,2),(NULL,0,'2019-11-29 22:16:20',NULL,2148,1150,23,40);
/*!40000 ALTER TABLE `c_value_index_integers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_index_texts`
--

DROP TABLE IF EXISTS `c_value_index_texts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_index_texts` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` varchar(128) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `ix_c_value_index_texts_deleted` (`deleted`),
  KEY `text_attr_value_index` (`attr_id`,`value`),
  CONSTRAINT `c_value_index_texts_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_index_texts_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10056 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_index_texts`
--

LOCK TABLES `c_value_index_texts` WRITE;
/*!40000 ALTER TABLE `c_value_index_texts` DISABLE KEYS */;
INSERT INTO `c_value_index_texts` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,509,53,1,'BU0001'),(NULL,0,'2019-11-29 22:12:14',NULL,510,54,3,'Product1-1'),(NULL,0,'2019-11-29 22:12:14',NULL,511,55,4,'App1-1-1'),(NULL,0,'2019-11-29 22:12:14',NULL,512,56,16,'cmdb1-1-1-1'),(NULL,0,'2019-11-29 22:12:15',NULL,513,56,28,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,514,56,24,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,515,56,29,'ZJ'),(NULL,0,'2019-11-29 22:12:15',NULL,516,56,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,517,56,11,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,518,56,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,519,56,15,'10.1.1.1'),(NULL,0,'2019-11-29 22:12:15',NULL,520,56,5,'e0e2de4550164ffd8e8e0a5e9d93143a'),(NULL,0,'2019-11-29 22:12:15',NULL,521,56,17,'online'),(NULL,0,'2019-11-29 22:12:15',NULL,522,57,16,'cmdb1-1-1-2'),(NULL,0,'2019-11-29 22:12:15',NULL,523,57,28,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,524,57,24,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,525,57,29,'ZJ'),(NULL,0,'2019-11-29 22:12:15',NULL,526,57,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,527,57,11,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,528,57,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,529,57,15,'10.1.1.2'),(NULL,0,'2019-11-29 22:12:15',NULL,530,57,5,'135709447098441fa1e002688f271125'),(NULL,0,'2019-11-29 22:12:15',NULL,531,57,17,'online'),(NULL,0,'2019-11-29 22:12:15',NULL,532,58,16,'cmdb1-1-1-3'),(NULL,0,'2019-11-29 22:12:15',NULL,533,58,28,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,534,58,24,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,535,58,29,'ZJ'),(NULL,0,'2019-11-29 22:12:15',NULL,536,58,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,537,58,11,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,538,58,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,539,58,15,'10.1.1.3'),(NULL,0,'2019-11-29 22:12:15',NULL,540,58,5,'1b64e1e09d5a414aa4bb523662161cb1'),(NULL,0,'2019-11-29 22:12:15',NULL,541,58,17,'online'),(NULL,0,'2019-11-29 22:12:15',NULL,542,59,16,'cmdb1-1-1-4'),(NULL,0,'2019-11-29 22:12:15',NULL,543,59,28,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,544,59,24,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,545,59,29,'ZJ'),(NULL,0,'2019-11-29 22:12:15',NULL,546,59,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:15',NULL,547,59,11,'pycook'),(NULL,0,'2019-11-29 22:12:15',NULL,548,59,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:15',NULL,549,59,15,'10.1.1.4'),(NULL,0,'2019-11-29 22:12:15',NULL,550,59,5,'ba95232e7a0548d3b1ddf97992025a81'),(NULL,0,'2019-11-29 22:12:15',NULL,551,59,17,'online'),(NULL,0,'2019-11-29 22:12:15',NULL,552,60,16,'cmdb1-1-1-5'),(NULL,0,'2019-11-29 22:12:15',NULL,553,60,28,'prod'),(NULL,0,'2019-11-29 22:12:15',NULL,554,60,24,'enable'),(NULL,0,'2019-11-29 22:12:15',NULL,555,60,29,'ZJ'),(NULL,0,'2019-11-29 22:12:16',NULL,556,60,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,557,60,11,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,558,60,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,559,60,15,'10.1.1.5'),(NULL,0,'2019-11-29 22:12:16',NULL,560,60,5,'ca3ce54d669441bba11691f60fba6f18'),(NULL,0,'2019-11-29 22:12:16',NULL,561,60,17,'online'),(NULL,0,'2019-11-29 22:12:16',NULL,562,61,16,'cmdb1-1-1-6'),(NULL,0,'2019-11-29 22:12:16',NULL,563,61,28,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,564,61,24,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,565,61,29,'ZJ'),(NULL,0,'2019-11-29 22:12:16',NULL,566,61,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,567,61,11,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,568,61,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,569,61,15,'10.1.1.6'),(NULL,0,'2019-11-29 22:12:16',NULL,570,61,5,'ff775e7d32ea48c28eddc138c789d1f5'),(NULL,0,'2019-11-29 22:12:16',NULL,571,61,17,'online'),(NULL,0,'2019-11-29 22:12:16',NULL,572,62,16,'cmdb1-1-1-7'),(NULL,0,'2019-11-29 22:12:16',NULL,573,62,28,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,574,62,24,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,575,62,29,'ZJ'),(NULL,0,'2019-11-29 22:12:16',NULL,576,62,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,577,62,11,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,578,62,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,579,62,15,'10.1.1.7'),(NULL,0,'2019-11-29 22:12:16',NULL,580,62,5,'aa7e9b6e6bc64d829ba514a551aa85b0'),(NULL,0,'2019-11-29 22:12:16',NULL,581,62,17,'online'),(NULL,0,'2019-11-29 22:12:16',NULL,582,63,16,'cmdb1-1-1-8'),(NULL,0,'2019-11-29 22:12:16',NULL,583,63,28,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,584,63,24,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,585,63,29,'ZJ'),(NULL,0,'2019-11-29 22:12:16',NULL,586,63,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,587,63,11,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,588,63,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,589,63,15,'10.1.1.8'),(NULL,0,'2019-11-29 22:12:16',NULL,590,63,5,'353684a6f1fe406da1713f9e357a7ed1'),(NULL,0,'2019-11-29 22:12:16',NULL,591,63,17,'online'),(NULL,0,'2019-11-29 22:12:16',NULL,592,64,16,'cmdb1-1-1-9'),(NULL,0,'2019-11-29 22:12:16',NULL,593,64,28,'prod'),(NULL,0,'2019-11-29 22:12:16',NULL,594,64,24,'enable'),(NULL,0,'2019-11-29 22:12:16',NULL,595,64,29,'ZJ'),(NULL,0,'2019-11-29 22:12:16',NULL,596,64,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:16',NULL,597,64,11,'pycook'),(NULL,0,'2019-11-29 22:12:16',NULL,598,64,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:16',NULL,599,64,15,'10.1.1.9'),(NULL,0,'2019-11-29 22:12:16',NULL,600,64,5,'f522f5ba167f4dccbaaed0b4ecd19a1e'),(NULL,0,'2019-11-29 22:12:16',NULL,601,64,17,'online'),(NULL,0,'2019-11-29 22:12:17',NULL,602,65,16,'cmdb1-1-1-10'),(NULL,0,'2019-11-29 22:12:17',NULL,603,65,28,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,604,65,24,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,605,65,29,'ZJ'),(NULL,0,'2019-11-29 22:12:17',NULL,606,65,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,607,65,11,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,608,65,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,609,65,15,'10.1.1.10'),(NULL,0,'2019-11-29 22:12:17',NULL,610,65,5,'4234b45efeda416e8886e97844142f35'),(NULL,0,'2019-11-29 22:12:17',NULL,611,65,17,'online'),(NULL,0,'2019-11-29 22:12:17',NULL,612,66,16,'cmdb1-1-1-11'),(NULL,0,'2019-11-29 22:12:17',NULL,613,66,28,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,614,66,24,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,615,66,29,'ZJ'),(NULL,0,'2019-11-29 22:12:17',NULL,616,66,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,617,66,11,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,618,66,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,619,66,15,'10.1.1.11'),(NULL,0,'2019-11-29 22:12:17',NULL,620,66,5,'3575873b2aaa45c9bb0ab14e514eef17'),(NULL,0,'2019-11-29 22:12:17',NULL,621,66,17,'online'),(NULL,0,'2019-11-29 22:12:17',NULL,622,67,16,'cmdb1-1-1-12'),(NULL,0,'2019-11-29 22:12:17',NULL,623,67,28,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,624,67,24,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,625,67,29,'ZJ'),(NULL,0,'2019-11-29 22:12:17',NULL,626,67,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,627,67,11,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,628,67,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,629,67,15,'10.1.1.12'),(NULL,0,'2019-11-29 22:12:17',NULL,630,67,5,'db36a13391f540318849cb9d300ebf80'),(NULL,0,'2019-11-29 22:12:17',NULL,631,67,17,'online'),(NULL,0,'2019-11-29 22:12:17',NULL,632,68,16,'cmdb1-1-1-13'),(NULL,0,'2019-11-29 22:12:17',NULL,633,68,28,'prod'),(NULL,0,'2019-11-29 22:12:17',NULL,634,68,24,'enable'),(NULL,0,'2019-11-29 22:12:17',NULL,635,68,29,'ZJ'),(NULL,0,'2019-11-29 22:12:17',NULL,636,68,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:17',NULL,637,68,11,'pycook'),(NULL,0,'2019-11-29 22:12:17',NULL,638,68,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:17',NULL,639,68,15,'10.1.1.13'),(NULL,0,'2019-11-29 22:12:17',NULL,640,68,5,'5ce2b965cff74ab2b09bb3bb6e50011e'),(NULL,0,'2019-11-29 22:12:17',NULL,641,68,17,'online'),(NULL,0,'2019-11-29 22:12:17',NULL,642,69,16,'cmdb1-1-1-14'),(NULL,0,'2019-11-29 22:12:18',NULL,643,69,28,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,644,69,24,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,645,69,29,'ZJ'),(NULL,0,'2019-11-29 22:12:18',NULL,646,69,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,647,69,11,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,648,69,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,649,69,15,'10.1.1.14'),(NULL,0,'2019-11-29 22:12:18',NULL,650,69,5,'3dcef8bc56e9441dbec5aa8cbcafa1a6'),(NULL,0,'2019-11-29 22:12:18',NULL,651,69,17,'online'),(NULL,0,'2019-11-29 22:12:18',NULL,652,70,16,'cmdb1-1-1-15'),(NULL,0,'2019-11-29 22:12:18',NULL,653,70,28,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,654,70,24,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,655,70,29,'ZJ'),(NULL,0,'2019-11-29 22:12:18',NULL,656,70,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,657,70,11,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,658,70,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,659,70,15,'10.1.1.15'),(NULL,0,'2019-11-29 22:12:18',NULL,660,70,5,'9abcc9da6f7b4eeb907cd8935c92c0f4'),(NULL,0,'2019-11-29 22:12:18',NULL,661,70,17,'online'),(NULL,0,'2019-11-29 22:12:18',NULL,662,71,16,'cmdb1-1-1-16'),(NULL,0,'2019-11-29 22:12:18',NULL,663,71,28,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,664,71,24,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,665,71,29,'ZJ'),(NULL,0,'2019-11-29 22:12:18',NULL,666,71,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,667,71,11,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,668,71,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,669,71,15,'10.1.1.16'),(NULL,0,'2019-11-29 22:12:18',NULL,670,71,5,'18bb99daaab64863be1eac53dcaaa8f8'),(NULL,0,'2019-11-29 22:12:18',NULL,671,71,17,'online'),(NULL,0,'2019-11-29 22:12:18',NULL,672,72,4,'App1-1-2'),(NULL,0,'2019-11-29 22:12:18',NULL,673,73,16,'cmdb1-1-2-1'),(NULL,0,'2019-11-29 22:12:18',NULL,674,73,28,'prod'),(NULL,0,'2019-11-29 22:12:18',NULL,675,73,24,'enable'),(NULL,0,'2019-11-29 22:12:18',NULL,676,73,29,'ZJ'),(NULL,0,'2019-11-29 22:12:18',NULL,677,73,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:18',NULL,678,73,11,'pycook'),(NULL,0,'2019-11-29 22:12:18',NULL,679,73,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:18',NULL,680,73,15,'10.1.2.1'),(NULL,0,'2019-11-29 22:12:18',NULL,681,73,5,'239fc3502444440d84937b089b864380'),(NULL,0,'2019-11-29 22:12:18',NULL,682,73,17,'online'),(NULL,0,'2019-11-29 22:12:19',NULL,683,74,16,'cmdb1-1-2-2'),(NULL,0,'2019-11-29 22:12:19',NULL,684,74,28,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,685,74,24,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,686,74,29,'ZJ'),(NULL,0,'2019-11-29 22:12:19',NULL,687,74,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,688,74,11,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,689,74,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,690,74,15,'10.1.2.2'),(NULL,0,'2019-11-29 22:12:19',NULL,691,74,5,'5d1a52bbb8714a72978eeef79b5508e4'),(NULL,0,'2019-11-29 22:12:19',NULL,692,74,17,'online'),(NULL,0,'2019-11-29 22:12:19',NULL,693,75,16,'cmdb1-1-2-3'),(NULL,0,'2019-11-29 22:12:19',NULL,694,75,28,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,695,75,24,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,696,75,29,'ZJ'),(NULL,0,'2019-11-29 22:12:19',NULL,697,75,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,698,75,11,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,699,75,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,700,75,15,'10.1.2.3'),(NULL,0,'2019-11-29 22:12:19',NULL,701,75,5,'0c1340ce25cf4817a3bf5db3a1373315'),(NULL,0,'2019-11-29 22:12:19',NULL,702,75,17,'online'),(NULL,0,'2019-11-29 22:12:19',NULL,703,76,16,'cmdb1-1-2-4'),(NULL,0,'2019-11-29 22:12:19',NULL,704,76,28,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,705,76,24,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,706,76,29,'ZJ'),(NULL,0,'2019-11-29 22:12:19',NULL,707,76,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,708,76,11,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,709,76,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,710,76,15,'10.1.2.4'),(NULL,0,'2019-11-29 22:12:19',NULL,711,76,5,'d6e35c79c2d84aec81aa8dc59c52e48f'),(NULL,0,'2019-11-29 22:12:19',NULL,712,76,17,'online'),(NULL,0,'2019-11-29 22:12:19',NULL,713,77,16,'cmdb1-1-2-5'),(NULL,0,'2019-11-29 22:12:19',NULL,714,77,28,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,715,77,24,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,716,77,29,'ZJ'),(NULL,0,'2019-11-29 22:12:19',NULL,717,77,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:19',NULL,718,77,11,'pycook'),(NULL,0,'2019-11-29 22:12:19',NULL,719,77,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:19',NULL,720,77,15,'10.1.2.5'),(NULL,0,'2019-11-29 22:12:19',NULL,721,77,5,'f8d04a04737c44ccbbedb49acaa71d2f'),(NULL,0,'2019-11-29 22:12:19',NULL,722,77,17,'online'),(NULL,0,'2019-11-29 22:12:19',NULL,723,78,16,'cmdb1-1-2-6'),(NULL,0,'2019-11-29 22:12:19',NULL,724,78,28,'prod'),(NULL,0,'2019-11-29 22:12:19',NULL,725,78,24,'enable'),(NULL,0,'2019-11-29 22:12:19',NULL,726,78,29,'ZJ'),(NULL,0,'2019-11-29 22:12:20',NULL,727,78,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,728,78,11,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,729,78,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,730,78,15,'10.1.2.6'),(NULL,0,'2019-11-29 22:12:20',NULL,731,78,5,'a8911eff0b0949648f0fa298c0b310d2'),(NULL,0,'2019-11-29 22:12:20',NULL,732,78,17,'online'),(NULL,0,'2019-11-29 22:12:20',NULL,733,79,16,'cmdb1-1-2-7'),(NULL,0,'2019-11-29 22:12:20',NULL,734,79,28,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,735,79,24,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,736,79,29,'ZJ'),(NULL,0,'2019-11-29 22:12:20',NULL,737,79,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,738,79,11,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,739,79,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,740,79,15,'10.1.2.7'),(NULL,0,'2019-11-29 22:12:20',NULL,741,79,5,'3b7d27e1f4944012a8ba823e6f1a0431'),(NULL,0,'2019-11-29 22:12:20',NULL,742,79,17,'online'),(NULL,0,'2019-11-29 22:12:20',NULL,743,80,16,'cmdb1-1-2-8'),(NULL,0,'2019-11-29 22:12:20',NULL,744,80,28,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,745,80,24,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,746,80,29,'ZJ'),(NULL,0,'2019-11-29 22:12:20',NULL,747,80,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,748,80,11,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,749,80,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,750,80,15,'10.1.2.8'),(NULL,0,'2019-11-29 22:12:20',NULL,751,80,5,'1635073bb8c54cfcbda05bee97dd3e9b'),(NULL,0,'2019-11-29 22:12:20',NULL,752,80,17,'online'),(NULL,0,'2019-11-29 22:12:20',NULL,753,81,16,'cmdb1-1-2-9'),(NULL,0,'2019-11-29 22:12:20',NULL,754,81,28,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,755,81,24,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,756,81,29,'ZJ'),(NULL,0,'2019-11-29 22:12:20',NULL,757,81,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,758,81,11,'pycook'),(NULL,0,'2019-11-29 22:12:20',NULL,759,81,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:20',NULL,760,81,15,'10.1.2.9'),(NULL,0,'2019-11-29 22:12:20',NULL,761,81,5,'bf196f5716084a77b28212cda7292119'),(NULL,0,'2019-11-29 22:12:20',NULL,762,81,17,'online'),(NULL,0,'2019-11-29 22:12:20',NULL,763,82,16,'cmdb1-1-2-10'),(NULL,0,'2019-11-29 22:12:20',NULL,764,82,28,'prod'),(NULL,0,'2019-11-29 22:12:20',NULL,765,82,24,'enable'),(NULL,0,'2019-11-29 22:12:20',NULL,766,82,29,'ZJ'),(NULL,0,'2019-11-29 22:12:20',NULL,767,82,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:20',NULL,768,82,11,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,769,82,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,770,82,15,'10.1.2.10'),(NULL,0,'2019-11-29 22:12:21',NULL,771,82,5,'122b6bad5438493dab32ff11140bcd43'),(NULL,0,'2019-11-29 22:12:21',NULL,772,82,17,'online'),(NULL,0,'2019-11-29 22:12:21',NULL,773,83,16,'cmdb1-1-2-11'),(NULL,0,'2019-11-29 22:12:21',NULL,774,83,28,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,775,83,24,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,776,83,29,'ZJ'),(NULL,0,'2019-11-29 22:12:21',NULL,777,83,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,778,83,11,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,779,83,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,780,83,15,'10.1.2.11'),(NULL,0,'2019-11-29 22:12:21',NULL,781,83,5,'8ca08fa7aed34d368ffe461a9367968d'),(NULL,0,'2019-11-29 22:12:21',NULL,782,83,17,'online'),(NULL,0,'2019-11-29 22:12:21',NULL,783,84,16,'cmdb1-1-2-12'),(NULL,0,'2019-11-29 22:12:21',NULL,784,84,28,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,785,84,24,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,786,84,29,'ZJ'),(NULL,0,'2019-11-29 22:12:21',NULL,787,84,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,788,84,11,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,789,84,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,790,84,15,'10.1.2.12'),(NULL,0,'2019-11-29 22:12:21',NULL,791,84,5,'db52739533a14bafa3026ccb6379ffb4'),(NULL,0,'2019-11-29 22:12:21',NULL,792,84,17,'online'),(NULL,0,'2019-11-29 22:12:21',NULL,793,85,16,'cmdb1-1-2-13'),(NULL,0,'2019-11-29 22:12:21',NULL,794,85,28,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,795,85,24,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,796,85,29,'ZJ'),(NULL,0,'2019-11-29 22:12:21',NULL,797,85,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,798,85,11,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,799,85,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:21',NULL,800,85,15,'10.1.2.13'),(NULL,0,'2019-11-29 22:12:21',NULL,801,85,5,'eb3020709bd0494d9ef02db001e69b15'),(NULL,0,'2019-11-29 22:12:21',NULL,802,85,17,'online'),(NULL,0,'2019-11-29 22:12:21',NULL,803,86,16,'cmdb1-1-2-14'),(NULL,0,'2019-11-29 22:12:21',NULL,804,86,28,'prod'),(NULL,0,'2019-11-29 22:12:21',NULL,805,86,24,'enable'),(NULL,0,'2019-11-29 22:12:21',NULL,806,86,29,'ZJ'),(NULL,0,'2019-11-29 22:12:21',NULL,807,86,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:21',NULL,808,86,11,'pycook'),(NULL,0,'2019-11-29 22:12:21',NULL,809,86,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,810,86,15,'10.1.2.14'),(NULL,0,'2019-11-29 22:12:22',NULL,811,86,5,'47936f6996af4a7482300c786000b27f'),(NULL,0,'2019-11-29 22:12:22',NULL,812,86,17,'online'),(NULL,0,'2019-11-29 22:12:22',NULL,813,87,16,'cmdb1-1-2-15'),(NULL,0,'2019-11-29 22:12:22',NULL,814,87,28,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,815,87,24,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,816,87,29,'ZJ'),(NULL,0,'2019-11-29 22:12:22',NULL,817,87,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,818,87,11,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,819,87,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,820,87,15,'10.1.2.15'),(NULL,0,'2019-11-29 22:12:22',NULL,821,87,5,'276165379af3447aa5049104ec4ca6c2'),(NULL,0,'2019-11-29 22:12:22',NULL,822,87,17,'online'),(NULL,0,'2019-11-29 22:12:22',NULL,823,88,16,'cmdb1-1-2-16'),(NULL,0,'2019-11-29 22:12:22',NULL,824,88,28,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,825,88,24,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,826,88,29,'ZJ'),(NULL,0,'2019-11-29 22:12:22',NULL,827,88,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,828,88,11,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,829,88,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,830,88,15,'10.1.2.16'),(NULL,0,'2019-11-29 22:12:22',NULL,831,88,5,'16c1bc4061404873bfac0ec788ff5743'),(NULL,0,'2019-11-29 22:12:22',NULL,832,88,17,'online'),(NULL,0,'2019-11-29 22:12:22',NULL,833,89,4,'App1-1-3'),(NULL,0,'2019-11-29 22:12:22',NULL,834,90,16,'cmdb1-1-3-1'),(NULL,0,'2019-11-29 22:12:22',NULL,835,90,28,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,836,90,24,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,837,90,29,'ZJ'),(NULL,0,'2019-11-29 22:12:22',NULL,838,90,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:22',NULL,839,90,11,'pycook'),(NULL,0,'2019-11-29 22:12:22',NULL,840,90,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:22',NULL,841,90,15,'10.1.3.1'),(NULL,0,'2019-11-29 22:12:22',NULL,842,90,5,'e938bb89ea8540ce8399f1b4291d653b'),(NULL,0,'2019-11-29 22:12:22',NULL,843,90,17,'online'),(NULL,0,'2019-11-29 22:12:22',NULL,844,91,16,'cmdb1-1-3-2'),(NULL,0,'2019-11-29 22:12:22',NULL,845,91,28,'prod'),(NULL,0,'2019-11-29 22:12:22',NULL,846,91,24,'enable'),(NULL,0,'2019-11-29 22:12:22',NULL,847,91,29,'ZJ'),(NULL,0,'2019-11-29 22:12:22',NULL,848,91,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,849,91,11,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,850,91,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,851,91,15,'10.1.3.2'),(NULL,0,'2019-11-29 22:12:23',NULL,852,91,5,'ab170301858f4e749c87f4b3e493e010'),(NULL,0,'2019-11-29 22:12:23',NULL,853,91,17,'online'),(NULL,0,'2019-11-29 22:12:23',NULL,854,92,16,'cmdb1-1-3-3'),(NULL,0,'2019-11-29 22:12:23',NULL,855,92,28,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,856,92,24,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,857,92,29,'ZJ'),(NULL,0,'2019-11-29 22:12:23',NULL,858,92,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,859,92,11,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,860,92,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,861,92,15,'10.1.3.3'),(NULL,0,'2019-11-29 22:12:23',NULL,862,92,5,'f2654b9365a94cf28de26a36aeba4517'),(NULL,0,'2019-11-29 22:12:23',NULL,863,92,17,'online'),(NULL,0,'2019-11-29 22:12:23',NULL,864,93,16,'cmdb1-1-3-4'),(NULL,0,'2019-11-29 22:12:23',NULL,865,93,28,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,866,93,24,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,867,93,29,'ZJ'),(NULL,0,'2019-11-29 22:12:23',NULL,868,93,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,869,93,11,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,870,93,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,871,93,15,'10.1.3.4'),(NULL,0,'2019-11-29 22:12:23',NULL,872,93,5,'b15448f0309a423a941ba34b1ea6ee52'),(NULL,0,'2019-11-29 22:12:23',NULL,873,93,17,'online'),(NULL,0,'2019-11-29 22:12:23',NULL,874,94,16,'cmdb1-1-3-5'),(NULL,0,'2019-11-29 22:12:23',NULL,875,94,28,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,876,94,24,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,877,94,29,'ZJ'),(NULL,0,'2019-11-29 22:12:23',NULL,878,94,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,879,94,11,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,880,94,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,881,94,15,'10.1.3.5'),(NULL,0,'2019-11-29 22:12:23',NULL,882,94,5,'f9da1eb4ecb64a79a575c132985dca6c'),(NULL,0,'2019-11-29 22:12:23',NULL,883,94,17,'online'),(NULL,0,'2019-11-29 22:12:23',NULL,884,95,16,'cmdb1-1-3-6'),(NULL,0,'2019-11-29 22:12:23',NULL,885,95,28,'prod'),(NULL,0,'2019-11-29 22:12:23',NULL,886,95,24,'enable'),(NULL,0,'2019-11-29 22:12:23',NULL,887,95,29,'ZJ'),(NULL,0,'2019-11-29 22:12:23',NULL,888,95,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:23',NULL,889,95,11,'pycook'),(NULL,0,'2019-11-29 22:12:23',NULL,890,95,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:23',NULL,891,95,15,'10.1.3.6'),(NULL,0,'2019-11-29 22:12:24',NULL,892,95,5,'871a00bcc2684f679ef010ff94a04084'),(NULL,0,'2019-11-29 22:12:24',NULL,893,95,17,'online'),(NULL,0,'2019-11-29 22:12:24',NULL,894,96,16,'cmdb1-1-3-7'),(NULL,0,'2019-11-29 22:12:24',NULL,895,96,28,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,896,96,24,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,897,96,29,'ZJ'),(NULL,0,'2019-11-29 22:12:24',NULL,898,96,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,899,96,11,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,900,96,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,901,96,15,'10.1.3.7'),(NULL,0,'2019-11-29 22:12:24',NULL,902,96,5,'cdc790dc6bd048d8b86626fa0220a499'),(NULL,0,'2019-11-29 22:12:24',NULL,903,96,17,'online'),(NULL,0,'2019-11-29 22:12:24',NULL,904,97,16,'cmdb1-1-3-8'),(NULL,0,'2019-11-29 22:12:24',NULL,905,97,28,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,906,97,24,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,907,97,29,'ZJ'),(NULL,0,'2019-11-29 22:12:24',NULL,908,97,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,909,97,11,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,910,97,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,911,97,15,'10.1.3.8'),(NULL,0,'2019-11-29 22:12:24',NULL,912,97,5,'5600072aea9d40bcb640c3e0e6d4e6f4'),(NULL,0,'2019-11-29 22:12:24',NULL,913,97,17,'online'),(NULL,0,'2019-11-29 22:12:24',NULL,914,98,16,'cmdb1-1-3-9'),(NULL,0,'2019-11-29 22:12:24',NULL,915,98,28,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,916,98,24,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,917,98,29,'ZJ'),(NULL,0,'2019-11-29 22:12:24',NULL,918,98,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,919,98,11,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,920,98,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,921,98,15,'10.1.3.9'),(NULL,0,'2019-11-29 22:12:24',NULL,922,98,5,'7d0f7edbbf804646a6d596ca8d85f79e'),(NULL,0,'2019-11-29 22:12:24',NULL,923,98,17,'online'),(NULL,0,'2019-11-29 22:12:24',NULL,924,99,16,'cmdb1-1-3-10'),(NULL,0,'2019-11-29 22:12:24',NULL,925,99,28,'prod'),(NULL,0,'2019-11-29 22:12:24',NULL,926,99,24,'enable'),(NULL,0,'2019-11-29 22:12:24',NULL,927,99,29,'ZJ'),(NULL,0,'2019-11-29 22:12:24',NULL,928,99,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:24',NULL,929,99,11,'pycook'),(NULL,0,'2019-11-29 22:12:24',NULL,930,99,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:24',NULL,931,99,15,'10.1.3.10'),(NULL,0,'2019-11-29 22:12:24',NULL,932,99,5,'d052d2f48dd04b738045c780cf65a1f5'),(NULL,0,'2019-11-29 22:12:24',NULL,933,99,17,'online'),(NULL,0,'2019-11-29 22:12:25',NULL,934,100,16,'cmdb1-1-3-11'),(NULL,0,'2019-11-29 22:12:25',NULL,935,100,28,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,936,100,24,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,937,100,29,'ZJ'),(NULL,0,'2019-11-29 22:12:25',NULL,938,100,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,939,100,11,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,940,100,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,941,100,15,'10.1.3.11'),(NULL,0,'2019-11-29 22:12:25',NULL,942,100,5,'7416b86efe78466ca45e87ef384d5651'),(NULL,0,'2019-11-29 22:12:25',NULL,943,100,17,'online'),(NULL,0,'2019-11-29 22:12:25',NULL,944,101,16,'cmdb1-1-3-12'),(NULL,0,'2019-11-29 22:12:25',NULL,945,101,28,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,946,101,24,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,947,101,29,'ZJ'),(NULL,0,'2019-11-29 22:12:25',NULL,948,101,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,949,101,11,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,950,101,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,951,101,15,'10.1.3.12'),(NULL,0,'2019-11-29 22:12:25',NULL,952,101,5,'611605f1335f419286cd3bf644dee0b8'),(NULL,0,'2019-11-29 22:12:25',NULL,953,101,17,'online'),(NULL,0,'2019-11-29 22:12:25',NULL,954,102,16,'cmdb1-1-3-13'),(NULL,0,'2019-11-29 22:12:25',NULL,955,102,28,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,956,102,24,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,957,102,29,'ZJ'),(NULL,0,'2019-11-29 22:12:25',NULL,958,102,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,959,102,11,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,960,102,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,961,102,15,'10.1.3.13'),(NULL,0,'2019-11-29 22:12:25',NULL,962,102,5,'cbb4a8b7fcd5439881b46a530e39a5b5'),(NULL,0,'2019-11-29 22:12:25',NULL,963,102,17,'online'),(NULL,0,'2019-11-29 22:12:25',NULL,964,103,16,'cmdb1-1-3-14'),(NULL,0,'2019-11-29 22:12:25',NULL,965,103,28,'prod'),(NULL,0,'2019-11-29 22:12:25',NULL,966,103,24,'enable'),(NULL,0,'2019-11-29 22:12:25',NULL,967,103,29,'ZJ'),(NULL,0,'2019-11-29 22:12:25',NULL,968,103,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:25',NULL,969,103,11,'pycook'),(NULL,0,'2019-11-29 22:12:25',NULL,970,103,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:25',NULL,971,103,15,'10.1.3.14'),(NULL,0,'2019-11-29 22:12:25',NULL,972,103,5,'cd90cb4f28cb4dcea853f3688c00204b'),(NULL,0,'2019-11-29 22:12:25',NULL,973,103,17,'online'),(NULL,0,'2019-11-29 22:12:25',NULL,974,104,16,'cmdb1-1-3-15'),(NULL,0,'2019-11-29 22:12:25',NULL,975,104,28,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,976,104,24,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,977,104,29,'ZJ'),(NULL,0,'2019-11-29 22:12:26',NULL,978,104,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,979,104,11,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,980,104,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,981,104,15,'10.1.3.15'),(NULL,0,'2019-11-29 22:12:26',NULL,982,104,5,'c16cdceccb424460ae7be842fd6b47f7'),(NULL,0,'2019-11-29 22:12:26',NULL,983,104,17,'online'),(NULL,0,'2019-11-29 22:12:26',NULL,984,105,16,'cmdb1-1-3-16'),(NULL,0,'2019-11-29 22:12:26',NULL,985,105,28,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,986,105,24,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,987,105,29,'ZJ'),(NULL,0,'2019-11-29 22:12:26',NULL,988,105,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,989,105,11,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,990,105,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,991,105,15,'10.1.3.16'),(NULL,0,'2019-11-29 22:12:26',NULL,992,105,5,'eda837f02ab34f78bb15b3af29b6eef2'),(NULL,0,'2019-11-29 22:12:26',NULL,993,105,17,'online'),(NULL,0,'2019-11-29 22:12:26',NULL,994,106,4,'App1-1-4'),(NULL,0,'2019-11-29 22:12:26',NULL,995,107,16,'cmdb1-1-4-1'),(NULL,0,'2019-11-29 22:12:26',NULL,996,107,28,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,997,107,24,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,998,107,29,'ZJ'),(NULL,0,'2019-11-29 22:12:26',NULL,999,107,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,1000,107,11,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,1001,107,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,1002,107,15,'10.1.4.1'),(NULL,0,'2019-11-29 22:12:26',NULL,1003,107,5,'7aa64345966d47329e5c3addcd9725d6'),(NULL,0,'2019-11-29 22:12:26',NULL,1004,107,17,'online'),(NULL,0,'2019-11-29 22:12:26',NULL,1005,108,16,'cmdb1-1-4-2'),(NULL,0,'2019-11-29 22:12:26',NULL,1006,108,28,'prod'),(NULL,0,'2019-11-29 22:12:26',NULL,1007,108,24,'enable'),(NULL,0,'2019-11-29 22:12:26',NULL,1008,108,29,'ZJ'),(NULL,0,'2019-11-29 22:12:26',NULL,1009,108,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:26',NULL,1010,108,11,'pycook'),(NULL,0,'2019-11-29 22:12:26',NULL,1011,108,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:26',NULL,1012,108,15,'10.1.4.2'),(NULL,0,'2019-11-29 22:12:26',NULL,1013,108,5,'21637e7680d64c0f8f98bb2c79a483e9'),(NULL,0,'2019-11-29 22:12:26',NULL,1014,108,17,'online'),(NULL,0,'2019-11-29 22:12:26',NULL,1015,109,16,'cmdb1-1-4-3'),(NULL,0,'2019-11-29 22:12:26',NULL,1016,109,28,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,1017,109,24,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,1018,109,29,'ZJ'),(NULL,0,'2019-11-29 22:12:27',NULL,1019,109,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,1020,109,11,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,1021,109,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,1022,109,15,'10.1.4.3'),(NULL,0,'2019-11-29 22:12:27',NULL,1023,109,5,'c9c7ad2b972345d5baff0ef01dc8da35'),(NULL,0,'2019-11-29 22:12:27',NULL,1024,109,17,'online'),(NULL,0,'2019-11-29 22:12:27',NULL,1025,110,16,'cmdb1-1-4-4'),(NULL,0,'2019-11-29 22:12:27',NULL,1026,110,28,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,1027,110,24,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,1028,110,29,'ZJ'),(NULL,0,'2019-11-29 22:12:27',NULL,1029,110,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,1030,110,11,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,1031,110,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,1032,110,15,'10.1.4.4'),(NULL,0,'2019-11-29 22:12:27',NULL,1033,110,5,'a74a926f1ad54526ad8727643e786b69'),(NULL,0,'2019-11-29 22:12:27',NULL,1034,110,17,'online'),(NULL,0,'2019-11-29 22:12:27',NULL,1035,111,16,'cmdb1-1-4-5'),(NULL,0,'2019-11-29 22:12:27',NULL,1036,111,28,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,1037,111,24,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,1038,111,29,'ZJ'),(NULL,0,'2019-11-29 22:12:27',NULL,1039,111,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,1040,111,11,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,1041,111,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,1042,111,15,'10.1.4.5'),(NULL,0,'2019-11-29 22:12:27',NULL,1043,111,5,'8748983683664ae1835845c479e5b88c'),(NULL,0,'2019-11-29 22:12:27',NULL,1044,111,17,'online'),(NULL,0,'2019-11-29 22:12:27',NULL,1045,112,16,'cmdb1-1-4-6'),(NULL,0,'2019-11-29 22:12:27',NULL,1046,112,28,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,1047,112,24,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,1048,112,29,'ZJ'),(NULL,0,'2019-11-29 22:12:27',NULL,1049,112,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,1050,112,11,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,1051,112,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,1052,112,15,'10.1.4.6'),(NULL,0,'2019-11-29 22:12:27',NULL,1053,112,5,'9fa0b1d109924d78a2bc885516749c9f'),(NULL,0,'2019-11-29 22:12:27',NULL,1054,112,17,'online'),(NULL,0,'2019-11-29 22:12:27',NULL,1055,113,16,'cmdb1-1-4-7'),(NULL,0,'2019-11-29 22:12:27',NULL,1056,113,28,'prod'),(NULL,0,'2019-11-29 22:12:27',NULL,1057,113,24,'enable'),(NULL,0,'2019-11-29 22:12:27',NULL,1058,113,29,'ZJ'),(NULL,0,'2019-11-29 22:12:27',NULL,1059,113,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:27',NULL,1060,113,11,'pycook'),(NULL,0,'2019-11-29 22:12:27',NULL,1061,113,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:27',NULL,1062,113,15,'10.1.4.7'),(NULL,0,'2019-11-29 22:12:28',NULL,1063,113,5,'9a812be9a6dd4601ba9340a9946bb0f6'),(NULL,0,'2019-11-29 22:12:28',NULL,1064,113,17,'online'),(NULL,0,'2019-11-29 22:12:28',NULL,1065,114,16,'cmdb1-1-4-8'),(NULL,0,'2019-11-29 22:12:28',NULL,1066,114,28,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,1067,114,24,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,1068,114,29,'ZJ'),(NULL,0,'2019-11-29 22:12:28',NULL,1069,114,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,1070,114,11,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,1071,114,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,1072,114,15,'10.1.4.8'),(NULL,0,'2019-11-29 22:12:28',NULL,1073,114,5,'2c4cefaca8034724abbce5a12516dda2'),(NULL,0,'2019-11-29 22:12:28',NULL,1074,114,17,'online'),(NULL,0,'2019-11-29 22:12:28',NULL,1075,115,16,'cmdb1-1-4-9'),(NULL,0,'2019-11-29 22:12:28',NULL,1076,115,28,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,1077,115,24,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,1078,115,29,'ZJ'),(NULL,0,'2019-11-29 22:12:28',NULL,1079,115,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,1080,115,11,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,1081,115,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,1082,115,15,'10.1.4.9'),(NULL,0,'2019-11-29 22:12:28',NULL,1083,115,5,'68819755b43c47719b65b3f7d17d6d23'),(NULL,0,'2019-11-29 22:12:28',NULL,1084,115,17,'online'),(NULL,0,'2019-11-29 22:12:28',NULL,1085,116,16,'cmdb1-1-4-10'),(NULL,0,'2019-11-29 22:12:28',NULL,1086,116,28,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,1087,116,24,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,1088,116,29,'ZJ'),(NULL,0,'2019-11-29 22:12:28',NULL,1089,116,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,1090,116,11,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,1091,116,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,1092,116,15,'10.1.4.10'),(NULL,0,'2019-11-29 22:12:28',NULL,1093,116,5,'c19a177302474c549c51ec61a095a738'),(NULL,0,'2019-11-29 22:12:28',NULL,1094,116,17,'online'),(NULL,0,'2019-11-29 22:12:28',NULL,1095,117,16,'cmdb1-1-4-11'),(NULL,0,'2019-11-29 22:12:28',NULL,1096,117,28,'prod'),(NULL,0,'2019-11-29 22:12:28',NULL,1097,117,24,'enable'),(NULL,0,'2019-11-29 22:12:28',NULL,1098,117,29,'ZJ'),(NULL,0,'2019-11-29 22:12:28',NULL,1099,117,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:28',NULL,1100,117,11,'pycook'),(NULL,0,'2019-11-29 22:12:28',NULL,1101,117,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:28',NULL,1102,117,15,'10.1.4.11'),(NULL,0,'2019-11-29 22:12:28',NULL,1103,117,5,'ce01c1bd04c14f7d87b964f62747bac2'),(NULL,0,'2019-11-29 22:12:28',NULL,1104,117,17,'online'),(NULL,0,'2019-11-29 22:12:29',NULL,1105,118,16,'cmdb1-1-4-12'),(NULL,0,'2019-11-29 22:12:29',NULL,1106,118,28,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,1107,118,24,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,1108,118,29,'ZJ'),(NULL,0,'2019-11-29 22:12:29',NULL,1109,118,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,1110,118,11,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,1111,118,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,1112,118,15,'10.1.4.12'),(NULL,0,'2019-11-29 22:12:29',NULL,1113,118,5,'ec509835eb7a47a685488087338e93fa'),(NULL,0,'2019-11-29 22:12:29',NULL,1114,118,17,'online'),(NULL,0,'2019-11-29 22:12:29',NULL,1115,119,16,'cmdb1-1-4-13'),(NULL,0,'2019-11-29 22:12:29',NULL,1116,119,28,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,1117,119,24,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,1118,119,29,'ZJ'),(NULL,0,'2019-11-29 22:12:29',NULL,1119,119,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,1120,119,11,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,1121,119,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,1122,119,15,'10.1.4.13'),(NULL,0,'2019-11-29 22:12:29',NULL,1123,119,5,'593a221c75cc45acb0925004356df4c4'),(NULL,0,'2019-11-29 22:12:29',NULL,1124,119,17,'online'),(NULL,0,'2019-11-29 22:12:29',NULL,1125,120,16,'cmdb1-1-4-14'),(NULL,0,'2019-11-29 22:12:29',NULL,1126,120,28,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,1127,120,24,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,1128,120,29,'ZJ'),(NULL,0,'2019-11-29 22:12:29',NULL,1129,120,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,1130,120,11,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,1131,120,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,1132,120,15,'10.1.4.14'),(NULL,0,'2019-11-29 22:12:29',NULL,1133,120,5,'603bd6e09d854a3cb4d680abfc3a7b92'),(NULL,0,'2019-11-29 22:12:29',NULL,1134,120,17,'online'),(NULL,0,'2019-11-29 22:12:29',NULL,1135,121,16,'cmdb1-1-4-15'),(NULL,0,'2019-11-29 22:12:29',NULL,1136,121,28,'prod'),(NULL,0,'2019-11-29 22:12:29',NULL,1137,121,24,'enable'),(NULL,0,'2019-11-29 22:12:29',NULL,1138,121,29,'ZJ'),(NULL,0,'2019-11-29 22:12:29',NULL,1139,121,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:29',NULL,1140,121,11,'pycook'),(NULL,0,'2019-11-29 22:12:29',NULL,1141,121,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:29',NULL,1142,121,15,'10.1.4.15'),(NULL,0,'2019-11-29 22:12:29',NULL,1143,121,5,'9e9bbec3932143bcac837693768c1e93'),(NULL,0,'2019-11-29 22:12:29',NULL,1144,121,17,'online'),(NULL,0,'2019-11-29 22:12:30',NULL,1145,122,16,'cmdb1-1-4-16'),(NULL,0,'2019-11-29 22:12:30',NULL,1146,122,28,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,1147,122,24,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,1148,122,29,'ZJ'),(NULL,0,'2019-11-29 22:12:30',NULL,1149,122,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,1150,122,11,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,1151,122,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,1152,122,15,'10.1.4.16'),(NULL,0,'2019-11-29 22:12:30',NULL,1153,122,5,'21ab637d13914f19975346675975ca95'),(NULL,0,'2019-11-29 22:12:30',NULL,1154,122,17,'online'),(NULL,0,'2019-11-29 22:12:30',NULL,1155,123,4,'App1-1-5'),(NULL,0,'2019-11-29 22:12:30',NULL,1156,124,16,'cmdb1-1-5-1'),(NULL,0,'2019-11-29 22:12:30',NULL,1157,124,28,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,1158,124,24,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,1159,124,29,'ZJ'),(NULL,0,'2019-11-29 22:12:30',NULL,1160,124,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,1161,124,11,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,1162,124,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,1163,124,15,'10.1.5.1'),(NULL,0,'2019-11-29 22:12:30',NULL,1164,124,5,'a787d1d2393d42ab84ebfd6a6c586953'),(NULL,0,'2019-11-29 22:12:30',NULL,1165,124,17,'online'),(NULL,0,'2019-11-29 22:12:30',NULL,1166,125,16,'cmdb1-1-5-2'),(NULL,0,'2019-11-29 22:12:30',NULL,1167,125,28,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,1168,125,24,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,1169,125,29,'ZJ'),(NULL,0,'2019-11-29 22:12:30',NULL,1170,125,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,1171,125,11,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,1172,125,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,1173,125,15,'10.1.5.2'),(NULL,0,'2019-11-29 22:12:30',NULL,1174,125,5,'e267be5f1c7446e39ca4ce8f83f2feef'),(NULL,0,'2019-11-29 22:12:30',NULL,1175,125,17,'online'),(NULL,0,'2019-11-29 22:12:30',NULL,1176,126,16,'cmdb1-1-5-3'),(NULL,0,'2019-11-29 22:12:30',NULL,1177,126,28,'prod'),(NULL,0,'2019-11-29 22:12:30',NULL,1178,126,24,'enable'),(NULL,0,'2019-11-29 22:12:30',NULL,1179,126,29,'ZJ'),(NULL,0,'2019-11-29 22:12:30',NULL,1180,126,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:30',NULL,1181,126,11,'pycook'),(NULL,0,'2019-11-29 22:12:30',NULL,1182,126,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:30',NULL,1183,126,15,'10.1.5.3'),(NULL,0,'2019-11-29 22:12:30',NULL,1184,126,5,'095b2349bf0a4fc9bf3210f3d156772e'),(NULL,0,'2019-11-29 22:12:30',NULL,1185,126,17,'online'),(NULL,0,'2019-11-29 22:12:31',NULL,1186,127,16,'cmdb1-1-5-4'),(NULL,0,'2019-11-29 22:12:31',NULL,1187,127,28,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1188,127,24,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1189,127,29,'ZJ'),(NULL,0,'2019-11-29 22:12:31',NULL,1190,127,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1191,127,11,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1192,127,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1193,127,15,'10.1.5.4'),(NULL,0,'2019-11-29 22:12:31',NULL,1194,127,5,'034f1e9bfd63429986dca69c0d32b74f'),(NULL,0,'2019-11-29 22:12:31',NULL,1195,127,17,'online'),(NULL,0,'2019-11-29 22:12:31',NULL,1196,128,16,'cmdb1-1-5-5'),(NULL,0,'2019-11-29 22:12:31',NULL,1197,128,28,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1198,128,24,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1199,128,29,'ZJ'),(NULL,0,'2019-11-29 22:12:31',NULL,1200,128,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1201,128,11,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1202,128,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1203,128,15,'10.1.5.5'),(NULL,0,'2019-11-29 22:12:31',NULL,1204,128,5,'96275a5ddfc04669bcb5e7cb0e7b93de'),(NULL,0,'2019-11-29 22:12:31',NULL,1205,128,17,'online'),(NULL,0,'2019-11-29 22:12:31',NULL,1206,129,16,'cmdb1-1-5-6'),(NULL,0,'2019-11-29 22:12:31',NULL,1207,129,28,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1208,129,24,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1209,129,29,'ZJ'),(NULL,0,'2019-11-29 22:12:31',NULL,1210,129,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1211,129,11,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1212,129,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1213,129,15,'10.1.5.6'),(NULL,0,'2019-11-29 22:12:31',NULL,1214,129,5,'f9f3a981e89441249771203e06692778'),(NULL,0,'2019-11-29 22:12:31',NULL,1215,129,17,'online'),(NULL,0,'2019-11-29 22:12:31',NULL,1216,130,16,'cmdb1-1-5-7'),(NULL,0,'2019-11-29 22:12:31',NULL,1217,130,28,'prod'),(NULL,0,'2019-11-29 22:12:31',NULL,1218,130,24,'enable'),(NULL,0,'2019-11-29 22:12:31',NULL,1219,130,29,'ZJ'),(NULL,0,'2019-11-29 22:12:31',NULL,1220,130,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:31',NULL,1221,130,11,'pycook'),(NULL,0,'2019-11-29 22:12:31',NULL,1222,130,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:31',NULL,1223,130,15,'10.1.5.7'),(NULL,0,'2019-11-29 22:12:31',NULL,1224,130,5,'e0d866782eed4009bddfb5bba0d64b6f'),(NULL,0,'2019-11-29 22:12:31',NULL,1225,130,17,'online'),(NULL,0,'2019-11-29 22:12:31',NULL,1226,131,16,'cmdb1-1-5-8'),(NULL,0,'2019-11-29 22:12:32',NULL,1227,131,28,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1228,131,24,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1229,131,29,'ZJ'),(NULL,0,'2019-11-29 22:12:32',NULL,1230,131,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1231,131,11,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1232,131,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1233,131,15,'10.1.5.8'),(NULL,0,'2019-11-29 22:12:32',NULL,1234,131,5,'3800cf3b658f4eaea7d3158c5a10fd8b'),(NULL,0,'2019-11-29 22:12:32',NULL,1235,131,17,'online'),(NULL,0,'2019-11-29 22:12:32',NULL,1236,132,16,'cmdb1-1-5-9'),(NULL,0,'2019-11-29 22:12:32',NULL,1237,132,28,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1238,132,24,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1239,132,29,'ZJ'),(NULL,0,'2019-11-29 22:12:32',NULL,1240,132,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1241,132,11,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1242,132,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1243,132,15,'10.1.5.9'),(NULL,0,'2019-11-29 22:12:32',NULL,1244,132,5,'24aafefc3fd74a039c57ce8e2daefe6b'),(NULL,0,'2019-11-29 22:12:32',NULL,1245,132,17,'online'),(NULL,0,'2019-11-29 22:12:32',NULL,1246,133,16,'cmdb1-1-5-10'),(NULL,0,'2019-11-29 22:12:32',NULL,1247,133,28,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1248,133,24,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1249,133,29,'ZJ'),(NULL,0,'2019-11-29 22:12:32',NULL,1250,133,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1251,133,11,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1252,133,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1253,133,15,'10.1.5.10'),(NULL,0,'2019-11-29 22:12:32',NULL,1254,133,5,'074090947f6849ec9509415817070ccb'),(NULL,0,'2019-11-29 22:12:32',NULL,1255,133,17,'online'),(NULL,0,'2019-11-29 22:12:32',NULL,1256,134,16,'cmdb1-1-5-11'),(NULL,0,'2019-11-29 22:12:32',NULL,1257,134,28,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1258,134,24,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1259,134,29,'ZJ'),(NULL,0,'2019-11-29 22:12:32',NULL,1260,134,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:32',NULL,1261,134,11,'pycook'),(NULL,0,'2019-11-29 22:12:32',NULL,1262,134,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:32',NULL,1263,134,15,'10.1.5.11'),(NULL,0,'2019-11-29 22:12:32',NULL,1264,134,5,'2e1e94d3953f4b9988ad0f1b79b15757'),(NULL,0,'2019-11-29 22:12:32',NULL,1265,134,17,'online'),(NULL,0,'2019-11-29 22:12:32',NULL,1266,135,16,'cmdb1-1-5-12'),(NULL,0,'2019-11-29 22:12:32',NULL,1267,135,28,'prod'),(NULL,0,'2019-11-29 22:12:32',NULL,1268,135,24,'enable'),(NULL,0,'2019-11-29 22:12:32',NULL,1269,135,29,'ZJ'),(NULL,0,'2019-11-29 22:12:32',NULL,1270,135,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1271,135,11,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1272,135,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1273,135,15,'10.1.5.12'),(NULL,0,'2019-11-29 22:12:33',NULL,1274,135,5,'acdbd1e1797446d4b1b8d81dd1272c2a'),(NULL,0,'2019-11-29 22:12:33',NULL,1275,135,17,'online'),(NULL,0,'2019-11-29 22:12:33',NULL,1276,136,16,'cmdb1-1-5-13'),(NULL,0,'2019-11-29 22:12:33',NULL,1277,136,28,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1278,136,24,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1279,136,29,'ZJ'),(NULL,0,'2019-11-29 22:12:33',NULL,1280,136,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1281,136,11,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1282,136,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1283,136,15,'10.1.5.13'),(NULL,0,'2019-11-29 22:12:33',NULL,1284,136,5,'550dccc4aa264b3b8da89af9afc0b0d1'),(NULL,0,'2019-11-29 22:12:33',NULL,1285,136,17,'online'),(NULL,0,'2019-11-29 22:12:33',NULL,1286,137,16,'cmdb1-1-5-14'),(NULL,0,'2019-11-29 22:12:33',NULL,1287,137,28,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1288,137,24,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1289,137,29,'ZJ'),(NULL,0,'2019-11-29 22:12:33',NULL,1290,137,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1291,137,11,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1292,137,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1293,137,15,'10.1.5.14'),(NULL,0,'2019-11-29 22:12:33',NULL,1294,137,5,'ae31164dcdee40e4934c0514d5d7f125'),(NULL,0,'2019-11-29 22:12:33',NULL,1295,137,17,'online'),(NULL,0,'2019-11-29 22:12:33',NULL,1296,138,16,'cmdb1-1-5-15'),(NULL,0,'2019-11-29 22:12:33',NULL,1297,138,28,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1298,138,24,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1299,138,29,'ZJ'),(NULL,0,'2019-11-29 22:12:33',NULL,1300,138,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1301,138,11,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1302,138,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1303,138,15,'10.1.5.15'),(NULL,0,'2019-11-29 22:12:33',NULL,1304,138,5,'808267a5a78b41a59914cbfda71e5d04'),(NULL,0,'2019-11-29 22:12:33',NULL,1305,138,17,'online'),(NULL,0,'2019-11-29 22:12:33',NULL,1306,139,16,'cmdb1-1-5-16'),(NULL,0,'2019-11-29 22:12:33',NULL,1307,139,28,'prod'),(NULL,0,'2019-11-29 22:12:33',NULL,1308,139,24,'enable'),(NULL,0,'2019-11-29 22:12:33',NULL,1309,139,29,'ZJ'),(NULL,0,'2019-11-29 22:12:33',NULL,1310,139,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:33',NULL,1311,139,11,'pycook'),(NULL,0,'2019-11-29 22:12:33',NULL,1312,139,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:33',NULL,1313,139,15,'10.1.5.16'),(NULL,0,'2019-11-29 22:12:33',NULL,1314,139,5,'fec2f97c7cb541eaafa66517ea08ffaf'),(NULL,0,'2019-11-29 22:12:34',NULL,1315,139,17,'online'),(NULL,0,'2019-11-29 22:12:34',NULL,1316,140,4,'App1-1-6'),(NULL,0,'2019-11-29 22:12:34',NULL,1317,141,16,'cmdb1-1-6-1'),(NULL,0,'2019-11-29 22:12:34',NULL,1318,141,28,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1319,141,24,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1320,141,29,'ZJ'),(NULL,0,'2019-11-29 22:12:34',NULL,1321,141,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1322,141,11,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1323,141,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1324,141,15,'10.1.6.1'),(NULL,0,'2019-11-29 22:12:34',NULL,1325,141,5,'4f4da7d22dab4a3594e55203bace84ef'),(NULL,0,'2019-11-29 22:12:34',NULL,1326,141,17,'online'),(NULL,0,'2019-11-29 22:12:34',NULL,1327,142,16,'cmdb1-1-6-2'),(NULL,0,'2019-11-29 22:12:34',NULL,1328,142,28,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1329,142,24,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1330,142,29,'ZJ'),(NULL,0,'2019-11-29 22:12:34',NULL,1331,142,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1332,142,11,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1333,142,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1334,142,15,'10.1.6.2'),(NULL,0,'2019-11-29 22:12:34',NULL,1335,142,5,'fc8abfc5512d4cb58444731707ea801d'),(NULL,0,'2019-11-29 22:12:34',NULL,1336,142,17,'online'),(NULL,0,'2019-11-29 22:12:34',NULL,1337,143,16,'cmdb1-1-6-3'),(NULL,0,'2019-11-29 22:12:34',NULL,1338,143,28,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1339,143,24,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1340,143,29,'ZJ'),(NULL,0,'2019-11-29 22:12:34',NULL,1341,143,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1342,143,11,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1343,143,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1344,143,15,'10.1.6.3'),(NULL,0,'2019-11-29 22:12:34',NULL,1345,143,5,'1589642b52e34fac85db0ccf4b051e40'),(NULL,0,'2019-11-29 22:12:34',NULL,1346,143,17,'online'),(NULL,0,'2019-11-29 22:12:34',NULL,1347,144,16,'cmdb1-1-6-4'),(NULL,0,'2019-11-29 22:12:34',NULL,1348,144,28,'prod'),(NULL,0,'2019-11-29 22:12:34',NULL,1349,144,24,'enable'),(NULL,0,'2019-11-29 22:12:34',NULL,1350,144,29,'ZJ'),(NULL,0,'2019-11-29 22:12:34',NULL,1351,144,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:34',NULL,1352,144,11,'pycook'),(NULL,0,'2019-11-29 22:12:34',NULL,1353,144,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:34',NULL,1354,144,15,'10.1.6.4'),(NULL,0,'2019-11-29 22:12:34',NULL,1355,144,5,'04172ddb77c7486d922636c4d538db32'),(NULL,0,'2019-11-29 22:12:35',NULL,1356,144,17,'online'),(NULL,0,'2019-11-29 22:12:35',NULL,1357,145,16,'cmdb1-1-6-5'),(NULL,0,'2019-11-29 22:12:35',NULL,1358,145,28,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1359,145,24,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1360,145,29,'ZJ'),(NULL,0,'2019-11-29 22:12:35',NULL,1361,145,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1362,145,11,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1363,145,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1364,145,15,'10.1.6.5'),(NULL,0,'2019-11-29 22:12:35',NULL,1365,145,5,'7a438f7b2d4f4298a15994a7341af502'),(NULL,0,'2019-11-29 22:12:35',NULL,1366,145,17,'online'),(NULL,0,'2019-11-29 22:12:35',NULL,1367,146,16,'cmdb1-1-6-6'),(NULL,0,'2019-11-29 22:12:35',NULL,1368,146,28,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1369,146,24,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1370,146,29,'ZJ'),(NULL,0,'2019-11-29 22:12:35',NULL,1371,146,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1372,146,11,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1373,146,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1374,146,15,'10.1.6.6'),(NULL,0,'2019-11-29 22:12:35',NULL,1375,146,5,'a74bc24ec13349c0962de62e3bc80319'),(NULL,0,'2019-11-29 22:12:35',NULL,1376,146,17,'online'),(NULL,0,'2019-11-29 22:12:35',NULL,1377,147,16,'cmdb1-1-6-7'),(NULL,0,'2019-11-29 22:12:35',NULL,1378,147,28,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1379,147,24,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1380,147,29,'ZJ'),(NULL,0,'2019-11-29 22:12:35',NULL,1381,147,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1382,147,11,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1383,147,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1384,147,15,'10.1.6.7'),(NULL,0,'2019-11-29 22:12:35',NULL,1385,147,5,'8c62d4a141404af9a2862b7e79a95ed4'),(NULL,0,'2019-11-29 22:12:35',NULL,1386,147,17,'online'),(NULL,0,'2019-11-29 22:12:35',NULL,1387,148,16,'cmdb1-1-6-8'),(NULL,0,'2019-11-29 22:12:35',NULL,1388,148,28,'prod'),(NULL,0,'2019-11-29 22:12:35',NULL,1389,148,24,'enable'),(NULL,0,'2019-11-29 22:12:35',NULL,1390,148,29,'ZJ'),(NULL,0,'2019-11-29 22:12:35',NULL,1391,148,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:35',NULL,1392,148,11,'pycook'),(NULL,0,'2019-11-29 22:12:35',NULL,1393,148,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:35',NULL,1394,148,15,'10.1.6.8'),(NULL,0,'2019-11-29 22:12:35',NULL,1395,148,5,'1afa76ee19de4b06beb044c352756792'),(NULL,0,'2019-11-29 22:12:35',NULL,1396,148,17,'online'),(NULL,0,'2019-11-29 22:12:36',NULL,1397,149,16,'cmdb1-1-6-9'),(NULL,0,'2019-11-29 22:12:36',NULL,1398,149,28,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1399,149,24,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1400,149,29,'ZJ'),(NULL,0,'2019-11-29 22:12:36',NULL,1401,149,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1402,149,11,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1403,149,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1404,149,15,'10.1.6.9'),(NULL,0,'2019-11-29 22:12:36',NULL,1405,149,5,'1fd01049ab98495f8bca9bbd35b696e6'),(NULL,0,'2019-11-29 22:12:36',NULL,1406,149,17,'online'),(NULL,0,'2019-11-29 22:12:36',NULL,1407,150,16,'cmdb1-1-6-10'),(NULL,0,'2019-11-29 22:12:36',NULL,1408,150,28,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1409,150,24,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1410,150,29,'ZJ'),(NULL,0,'2019-11-29 22:12:36',NULL,1411,150,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1412,150,11,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1413,150,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1414,150,15,'10.1.6.10'),(NULL,0,'2019-11-29 22:12:36',NULL,1415,150,5,'47b9983de6eb46029479deb51051bf13'),(NULL,0,'2019-11-29 22:12:36',NULL,1416,150,17,'online'),(NULL,0,'2019-11-29 22:12:36',NULL,1417,151,16,'cmdb1-1-6-11'),(NULL,0,'2019-11-29 22:12:36',NULL,1418,151,28,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1419,151,24,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1420,151,29,'ZJ'),(NULL,0,'2019-11-29 22:12:36',NULL,1421,151,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1422,151,11,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1423,151,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1424,151,15,'10.1.6.11'),(NULL,0,'2019-11-29 22:12:36',NULL,1425,151,5,'b0e86d12e28a4a4b8af8dd44c2d02ce2'),(NULL,0,'2019-11-29 22:12:36',NULL,1426,151,17,'online'),(NULL,0,'2019-11-29 22:12:36',NULL,1427,152,16,'cmdb1-1-6-12'),(NULL,0,'2019-11-29 22:12:36',NULL,1428,152,28,'prod'),(NULL,0,'2019-11-29 22:12:36',NULL,1429,152,24,'enable'),(NULL,0,'2019-11-29 22:12:36',NULL,1430,152,29,'ZJ'),(NULL,0,'2019-11-29 22:12:36',NULL,1431,152,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:36',NULL,1432,152,11,'pycook'),(NULL,0,'2019-11-29 22:12:36',NULL,1433,152,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:36',NULL,1434,152,15,'10.1.6.12'),(NULL,0,'2019-11-29 22:12:36',NULL,1435,152,5,'059325a77baa4c8d8a955eda371a6d0d'),(NULL,0,'2019-11-29 22:12:36',NULL,1436,152,17,'online'),(NULL,0,'2019-11-29 22:12:36',NULL,1437,153,16,'cmdb1-1-6-13'),(NULL,0,'2019-11-29 22:12:36',NULL,1438,153,28,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1439,153,24,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1440,153,29,'ZJ'),(NULL,0,'2019-11-29 22:12:37',NULL,1441,153,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1442,153,11,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1443,153,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1444,153,15,'10.1.6.13'),(NULL,0,'2019-11-29 22:12:37',NULL,1445,153,5,'f3c25a24f8f843deb29b671a23ff1d95'),(NULL,0,'2019-11-29 22:12:37',NULL,1446,153,17,'online'),(NULL,0,'2019-11-29 22:12:37',NULL,1447,154,16,'cmdb1-1-6-14'),(NULL,0,'2019-11-29 22:12:37',NULL,1448,154,28,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1449,154,24,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1450,154,29,'ZJ'),(NULL,0,'2019-11-29 22:12:37',NULL,1451,154,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1452,154,11,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1453,154,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1454,154,15,'10.1.6.14'),(NULL,0,'2019-11-29 22:12:37',NULL,1455,154,5,'acabbc340bca466db1202dc203fe7ba9'),(NULL,0,'2019-11-29 22:12:37',NULL,1456,154,17,'online'),(NULL,0,'2019-11-29 22:12:37',NULL,1457,155,16,'cmdb1-1-6-15'),(NULL,0,'2019-11-29 22:12:37',NULL,1458,155,28,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1459,155,24,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1460,155,29,'ZJ'),(NULL,0,'2019-11-29 22:12:37',NULL,1461,155,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1462,155,11,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1463,155,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1464,155,15,'10.1.6.15'),(NULL,0,'2019-11-29 22:12:37',NULL,1465,155,5,'dc51de0525dc4dda90d0b624bc028177'),(NULL,0,'2019-11-29 22:12:37',NULL,1466,155,17,'online'),(NULL,0,'2019-11-29 22:12:37',NULL,1467,156,16,'cmdb1-1-6-16'),(NULL,0,'2019-11-29 22:12:37',NULL,1468,156,28,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1469,156,24,'enable'),(NULL,0,'2019-11-29 22:12:37',NULL,1470,156,29,'ZJ'),(NULL,0,'2019-11-29 22:12:37',NULL,1471,156,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:37',NULL,1472,156,11,'pycook'),(NULL,0,'2019-11-29 22:12:37',NULL,1473,156,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:37',NULL,1474,156,15,'10.1.6.16'),(NULL,0,'2019-11-29 22:12:37',NULL,1475,156,5,'c576916b20bd419f88668457b5c62ac7'),(NULL,0,'2019-11-29 22:12:37',NULL,1476,156,17,'online'),(NULL,0,'2019-11-29 22:12:37',NULL,1477,157,4,'App1-1-7'),(NULL,0,'2019-11-29 22:12:37',NULL,1478,158,16,'cmdb1-1-7-1'),(NULL,0,'2019-11-29 22:12:37',NULL,1479,158,28,'prod'),(NULL,0,'2019-11-29 22:12:37',NULL,1480,158,24,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1481,158,29,'ZJ'),(NULL,0,'2019-11-29 22:12:38',NULL,1482,158,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1483,158,11,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1484,158,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1485,158,15,'10.1.7.1'),(NULL,0,'2019-11-29 22:12:38',NULL,1486,158,5,'e4ae01ee254643cbbcf570d510294645'),(NULL,0,'2019-11-29 22:12:38',NULL,1487,158,17,'online'),(NULL,0,'2019-11-29 22:12:38',NULL,1488,159,16,'cmdb1-1-7-2'),(NULL,0,'2019-11-29 22:12:38',NULL,1489,159,28,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1490,159,24,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1491,159,29,'ZJ'),(NULL,0,'2019-11-29 22:12:38',NULL,1492,159,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1493,159,11,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1494,159,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1495,159,15,'10.1.7.2'),(NULL,0,'2019-11-29 22:12:38',NULL,1496,159,5,'f11f1f67a41c40949b167af2488572cd'),(NULL,0,'2019-11-29 22:12:38',NULL,1497,159,17,'online'),(NULL,0,'2019-11-29 22:12:38',NULL,1498,160,16,'cmdb1-1-7-3'),(NULL,0,'2019-11-29 22:12:38',NULL,1499,160,28,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1500,160,24,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1501,160,29,'ZJ'),(NULL,0,'2019-11-29 22:12:38',NULL,1502,160,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1503,160,11,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1504,160,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1505,160,15,'10.1.7.3'),(NULL,0,'2019-11-29 22:12:38',NULL,1506,160,5,'04f194edffea44409dafe3f4cb0e9934'),(NULL,0,'2019-11-29 22:12:38',NULL,1507,160,17,'online'),(NULL,0,'2019-11-29 22:12:38',NULL,1508,161,16,'cmdb1-1-7-4'),(NULL,0,'2019-11-29 22:12:38',NULL,1509,161,28,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1510,161,24,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1511,161,29,'ZJ'),(NULL,0,'2019-11-29 22:12:38',NULL,1512,161,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1513,161,11,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1514,161,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:38',NULL,1515,161,15,'10.1.7.4'),(NULL,0,'2019-11-29 22:12:38',NULL,1516,161,5,'9800ac1d5733474db5947edd7458a484'),(NULL,0,'2019-11-29 22:12:38',NULL,1517,161,17,'online'),(NULL,0,'2019-11-29 22:12:38',NULL,1518,162,16,'cmdb1-1-7-5'),(NULL,0,'2019-11-29 22:12:38',NULL,1519,162,28,'prod'),(NULL,0,'2019-11-29 22:12:38',NULL,1520,162,24,'enable'),(NULL,0,'2019-11-29 22:12:38',NULL,1521,162,29,'ZJ'),(NULL,0,'2019-11-29 22:12:38',NULL,1522,162,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:38',NULL,1523,162,11,'pycook'),(NULL,0,'2019-11-29 22:12:38',NULL,1524,162,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1525,162,15,'10.1.7.5'),(NULL,0,'2019-11-29 22:12:39',NULL,1526,162,5,'25c2f18c0d6d4071a5d3458049745126'),(NULL,0,'2019-11-29 22:12:39',NULL,1527,162,17,'online'),(NULL,0,'2019-11-29 22:12:39',NULL,1528,163,16,'cmdb1-1-7-6'),(NULL,0,'2019-11-29 22:12:39',NULL,1529,163,28,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1530,163,24,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1531,163,29,'ZJ'),(NULL,0,'2019-11-29 22:12:39',NULL,1532,163,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1533,163,11,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1534,163,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1535,163,15,'10.1.7.6'),(NULL,0,'2019-11-29 22:12:39',NULL,1536,163,5,'580a9a59f1134a138bfe0146c7f608b1'),(NULL,0,'2019-11-29 22:12:39',NULL,1537,163,17,'online'),(NULL,0,'2019-11-29 22:12:39',NULL,1538,164,16,'cmdb1-1-7-7'),(NULL,0,'2019-11-29 22:12:39',NULL,1539,164,28,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1540,164,24,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1541,164,29,'ZJ'),(NULL,0,'2019-11-29 22:12:39',NULL,1542,164,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1543,164,11,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1544,164,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1545,164,15,'10.1.7.7'),(NULL,0,'2019-11-29 22:12:39',NULL,1546,164,5,'9cb24c1ba504491caf21ec1985b4575c'),(NULL,0,'2019-11-29 22:12:39',NULL,1547,164,17,'online'),(NULL,0,'2019-11-29 22:12:39',NULL,1548,165,16,'cmdb1-1-7-8'),(NULL,0,'2019-11-29 22:12:39',NULL,1549,165,28,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1550,165,24,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1551,165,29,'ZJ'),(NULL,0,'2019-11-29 22:12:39',NULL,1552,165,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1553,165,11,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1554,165,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1555,165,15,'10.1.7.8'),(NULL,0,'2019-11-29 22:12:39',NULL,1556,165,5,'9beb1c2b6e51475c8a59fc8347e1be6e'),(NULL,0,'2019-11-29 22:12:39',NULL,1557,165,17,'online'),(NULL,0,'2019-11-29 22:12:39',NULL,1558,166,16,'cmdb1-1-7-9'),(NULL,0,'2019-11-29 22:12:39',NULL,1559,166,28,'prod'),(NULL,0,'2019-11-29 22:12:39',NULL,1560,166,24,'enable'),(NULL,0,'2019-11-29 22:12:39',NULL,1561,166,29,'ZJ'),(NULL,0,'2019-11-29 22:12:39',NULL,1562,166,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:39',NULL,1563,166,11,'pycook'),(NULL,0,'2019-11-29 22:12:39',NULL,1564,166,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:39',NULL,1565,166,15,'10.1.7.9'),(NULL,0,'2019-11-29 22:12:39',NULL,1566,166,5,'a0155f427f6a4b8d84d093fd5ed4bda4'),(NULL,0,'2019-11-29 22:12:39',NULL,1567,166,17,'online'),(NULL,0,'2019-11-29 22:12:40',NULL,1568,167,16,'cmdb1-1-7-10'),(NULL,0,'2019-11-29 22:12:40',NULL,1569,167,28,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1570,167,24,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1571,167,29,'ZJ'),(NULL,0,'2019-11-29 22:12:40',NULL,1572,167,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1573,167,11,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1574,167,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1575,167,15,'10.1.7.10'),(NULL,0,'2019-11-29 22:12:40',NULL,1576,167,5,'dfd1a30796f74c27971e641136a09ce4'),(NULL,0,'2019-11-29 22:12:40',NULL,1577,167,17,'online'),(NULL,0,'2019-11-29 22:12:40',NULL,1578,168,16,'cmdb1-1-7-11'),(NULL,0,'2019-11-29 22:12:40',NULL,1579,168,28,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1580,168,24,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1581,168,29,'ZJ'),(NULL,0,'2019-11-29 22:12:40',NULL,1582,168,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1583,168,11,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1584,168,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1585,168,15,'10.1.7.11'),(NULL,0,'2019-11-29 22:12:40',NULL,1586,168,5,'e22bb43856d64920ad10559e6928bd79'),(NULL,0,'2019-11-29 22:12:40',NULL,1587,168,17,'online'),(NULL,0,'2019-11-29 22:12:40',NULL,1588,169,16,'cmdb1-1-7-12'),(NULL,0,'2019-11-29 22:12:40',NULL,1589,169,28,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1590,169,24,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1591,169,29,'ZJ'),(NULL,0,'2019-11-29 22:12:40',NULL,1592,169,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1593,169,11,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1594,169,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1595,169,15,'10.1.7.12'),(NULL,0,'2019-11-29 22:12:40',NULL,1596,169,5,'d931702f8503482eac27b6c24a87da2f'),(NULL,0,'2019-11-29 22:12:40',NULL,1597,169,17,'online'),(NULL,0,'2019-11-29 22:12:40',NULL,1598,170,16,'cmdb1-1-7-13'),(NULL,0,'2019-11-29 22:12:40',NULL,1599,170,28,'prod'),(NULL,0,'2019-11-29 22:12:40',NULL,1600,170,24,'enable'),(NULL,0,'2019-11-29 22:12:40',NULL,1601,170,29,'ZJ'),(NULL,0,'2019-11-29 22:12:40',NULL,1602,170,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:40',NULL,1603,170,11,'pycook'),(NULL,0,'2019-11-29 22:12:40',NULL,1604,170,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:40',NULL,1605,170,15,'10.1.7.13'),(NULL,0,'2019-11-29 22:12:40',NULL,1606,170,5,'1907ac0c59a7404babb2b2407fac19db'),(NULL,0,'2019-11-29 22:12:40',NULL,1607,170,17,'online'),(NULL,0,'2019-11-29 22:12:40',NULL,1608,171,16,'cmdb1-1-7-14'),(NULL,0,'2019-11-29 22:12:41',NULL,1609,171,28,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1610,171,24,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1611,171,29,'ZJ'),(NULL,0,'2019-11-29 22:12:41',NULL,1612,171,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1613,171,11,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1614,171,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1615,171,15,'10.1.7.14'),(NULL,0,'2019-11-29 22:12:41',NULL,1616,171,5,'c19d624245f24d10b0b453af4da4c73c'),(NULL,0,'2019-11-29 22:12:41',NULL,1617,171,17,'online'),(NULL,0,'2019-11-29 22:12:41',NULL,1618,172,16,'cmdb1-1-7-15'),(NULL,0,'2019-11-29 22:12:41',NULL,1619,172,28,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1620,172,24,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1621,172,29,'ZJ'),(NULL,0,'2019-11-29 22:12:41',NULL,1622,172,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1623,172,11,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1624,172,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1625,172,15,'10.1.7.15'),(NULL,0,'2019-11-29 22:12:41',NULL,1626,172,5,'ee93c2752e3d4f2f90580a286cf3e523'),(NULL,0,'2019-11-29 22:12:41',NULL,1627,172,17,'online'),(NULL,0,'2019-11-29 22:12:41',NULL,1628,173,16,'cmdb1-1-7-16'),(NULL,0,'2019-11-29 22:12:41',NULL,1629,173,28,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1630,173,24,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1631,173,29,'ZJ'),(NULL,0,'2019-11-29 22:12:41',NULL,1632,173,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1633,173,11,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1634,173,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1635,173,15,'10.1.7.16'),(NULL,0,'2019-11-29 22:12:41',NULL,1636,173,5,'8f5fbf45ee9340bfa2f4d4809cacb2e0'),(NULL,0,'2019-11-29 22:12:41',NULL,1637,173,17,'online'),(NULL,0,'2019-11-29 22:12:41',NULL,1638,174,4,'App1-1-8'),(NULL,0,'2019-11-29 22:12:41',NULL,1639,175,16,'cmdb1-1-8-1'),(NULL,0,'2019-11-29 22:12:41',NULL,1640,175,28,'prod'),(NULL,0,'2019-11-29 22:12:41',NULL,1641,175,24,'enable'),(NULL,0,'2019-11-29 22:12:41',NULL,1642,175,29,'ZJ'),(NULL,0,'2019-11-29 22:12:41',NULL,1643,175,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:41',NULL,1644,175,11,'pycook'),(NULL,0,'2019-11-29 22:12:41',NULL,1645,175,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:41',NULL,1646,175,15,'10.1.8.1'),(NULL,0,'2019-11-29 22:12:41',NULL,1647,175,5,'54cba24ac9054b79b1e3a728bd508da8'),(NULL,0,'2019-11-29 22:12:41',NULL,1648,175,17,'online'),(NULL,0,'2019-11-29 22:12:41',NULL,1649,176,16,'cmdb1-1-8-2'),(NULL,0,'2019-11-29 22:12:42',NULL,1650,176,28,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1651,176,24,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1652,176,29,'ZJ'),(NULL,0,'2019-11-29 22:12:42',NULL,1653,176,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1654,176,11,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1655,176,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1656,176,15,'10.1.8.2'),(NULL,0,'2019-11-29 22:12:42',NULL,1657,176,5,'97ed95492c714ce59e8ef6954bc77f56'),(NULL,0,'2019-11-29 22:12:42',NULL,1658,176,17,'online'),(NULL,0,'2019-11-29 22:12:42',NULL,1659,177,16,'cmdb1-1-8-3'),(NULL,0,'2019-11-29 22:12:42',NULL,1660,177,28,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1661,177,24,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1662,177,29,'ZJ'),(NULL,0,'2019-11-29 22:12:42',NULL,1663,177,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1664,177,11,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1665,177,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1666,177,15,'10.1.8.3'),(NULL,0,'2019-11-29 22:12:42',NULL,1667,177,5,'c8f0bcabdae54f7ab2522e8dfdfb4625'),(NULL,0,'2019-11-29 22:12:42',NULL,1668,177,17,'online'),(NULL,0,'2019-11-29 22:12:42',NULL,1669,178,16,'cmdb1-1-8-4'),(NULL,0,'2019-11-29 22:12:42',NULL,1670,178,28,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1671,178,24,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1672,178,29,'ZJ'),(NULL,0,'2019-11-29 22:12:42',NULL,1673,178,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1674,178,11,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1675,178,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1676,178,15,'10.1.8.4'),(NULL,0,'2019-11-29 22:12:42',NULL,1677,178,5,'d0947f55eb9c46f0b987b0f506f983e0'),(NULL,0,'2019-11-29 22:12:42',NULL,1678,178,17,'online'),(NULL,0,'2019-11-29 22:12:42',NULL,1679,179,16,'cmdb1-1-8-5'),(NULL,0,'2019-11-29 22:12:42',NULL,1680,179,28,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1681,179,24,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1682,179,29,'ZJ'),(NULL,0,'2019-11-29 22:12:42',NULL,1683,179,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:42',NULL,1684,179,11,'pycook'),(NULL,0,'2019-11-29 22:12:42',NULL,1685,179,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:42',NULL,1686,179,15,'10.1.8.5'),(NULL,0,'2019-11-29 22:12:42',NULL,1687,179,5,'5b4ab4d00a5b407592265287a4362fe0'),(NULL,0,'2019-11-29 22:12:42',NULL,1688,179,17,'online'),(NULL,0,'2019-11-29 22:12:42',NULL,1689,180,16,'cmdb1-1-8-6'),(NULL,0,'2019-11-29 22:12:42',NULL,1690,180,28,'prod'),(NULL,0,'2019-11-29 22:12:42',NULL,1691,180,24,'enable'),(NULL,0,'2019-11-29 22:12:42',NULL,1692,180,29,'ZJ'),(NULL,0,'2019-11-29 22:12:42',NULL,1693,180,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1694,180,11,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1695,180,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1696,180,15,'10.1.8.6'),(NULL,0,'2019-11-29 22:12:43',NULL,1697,180,5,'d98821fc54d544af8f3a1f7cfda78623'),(NULL,0,'2019-11-29 22:12:43',NULL,1698,180,17,'online'),(NULL,0,'2019-11-29 22:12:43',NULL,1699,181,16,'cmdb1-1-8-7'),(NULL,0,'2019-11-29 22:12:43',NULL,1700,181,28,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1701,181,24,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1702,181,29,'ZJ'),(NULL,0,'2019-11-29 22:12:43',NULL,1703,181,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1704,181,11,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1705,181,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1706,181,15,'10.1.8.7'),(NULL,0,'2019-11-29 22:12:43',NULL,1707,181,5,'2f4f6c46827d4f1d861d2617819c665c'),(NULL,0,'2019-11-29 22:12:43',NULL,1708,181,17,'online'),(NULL,0,'2019-11-29 22:12:43',NULL,1709,182,16,'cmdb1-1-8-8'),(NULL,0,'2019-11-29 22:12:43',NULL,1710,182,28,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1711,182,24,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1712,182,29,'ZJ'),(NULL,0,'2019-11-29 22:12:43',NULL,1713,182,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1714,182,11,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1715,182,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1716,182,15,'10.1.8.8'),(NULL,0,'2019-11-29 22:12:43',NULL,1717,182,5,'6c608ab7dd364b24b9b902885843ed93'),(NULL,0,'2019-11-29 22:12:43',NULL,1718,182,17,'online'),(NULL,0,'2019-11-29 22:12:43',NULL,1719,183,16,'cmdb1-1-8-9'),(NULL,0,'2019-11-29 22:12:43',NULL,1720,183,28,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1721,183,24,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1722,183,29,'ZJ'),(NULL,0,'2019-11-29 22:12:43',NULL,1723,183,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1724,183,11,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1725,183,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1726,183,15,'10.1.8.9'),(NULL,0,'2019-11-29 22:12:43',NULL,1727,183,5,'20986c66ae4d465d979b03ae73689dff'),(NULL,0,'2019-11-29 22:12:43',NULL,1728,183,17,'online'),(NULL,0,'2019-11-29 22:12:43',NULL,1729,184,16,'cmdb1-1-8-10'),(NULL,0,'2019-11-29 22:12:43',NULL,1730,184,28,'prod'),(NULL,0,'2019-11-29 22:12:43',NULL,1731,184,24,'enable'),(NULL,0,'2019-11-29 22:12:43',NULL,1732,184,29,'ZJ'),(NULL,0,'2019-11-29 22:12:43',NULL,1733,184,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:43',NULL,1734,184,11,'pycook'),(NULL,0,'2019-11-29 22:12:43',NULL,1735,184,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:43',NULL,1736,184,15,'10.1.8.10'),(NULL,0,'2019-11-29 22:12:44',NULL,1737,184,5,'fe6fcf932d924f2bbb5ccf5dce7d9a82'),(NULL,0,'2019-11-29 22:12:44',NULL,1738,184,17,'online'),(NULL,0,'2019-11-29 22:12:44',NULL,1739,185,16,'cmdb1-1-8-11'),(NULL,0,'2019-11-29 22:12:44',NULL,1740,185,28,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1741,185,24,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1742,185,29,'ZJ'),(NULL,0,'2019-11-29 22:12:44',NULL,1743,185,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1744,185,11,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1745,185,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1746,185,15,'10.1.8.11'),(NULL,0,'2019-11-29 22:12:44',NULL,1747,185,5,'e9c0884ef0fe4a09a8e4b0490b533d7f'),(NULL,0,'2019-11-29 22:12:44',NULL,1748,185,17,'online'),(NULL,0,'2019-11-29 22:12:44',NULL,1749,186,16,'cmdb1-1-8-12'),(NULL,0,'2019-11-29 22:12:44',NULL,1750,186,28,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1751,186,24,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1752,186,29,'ZJ'),(NULL,0,'2019-11-29 22:12:44',NULL,1753,186,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1754,186,11,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1755,186,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1756,186,15,'10.1.8.12'),(NULL,0,'2019-11-29 22:12:44',NULL,1757,186,5,'5cda340ac8b54a4ca5509694124f18b7'),(NULL,0,'2019-11-29 22:12:44',NULL,1758,186,17,'online'),(NULL,0,'2019-11-29 22:12:44',NULL,1759,187,16,'cmdb1-1-8-13'),(NULL,0,'2019-11-29 22:12:44',NULL,1760,187,28,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1761,187,24,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1762,187,29,'ZJ'),(NULL,0,'2019-11-29 22:12:44',NULL,1763,187,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1764,187,11,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1765,187,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1766,187,15,'10.1.8.13'),(NULL,0,'2019-11-29 22:12:44',NULL,1767,187,5,'6ef2254752564a36932ebe9b16a9225b'),(NULL,0,'2019-11-29 22:12:44',NULL,1768,187,17,'online'),(NULL,0,'2019-11-29 22:12:44',NULL,1769,188,16,'cmdb1-1-8-14'),(NULL,0,'2019-11-29 22:12:44',NULL,1770,188,28,'prod'),(NULL,0,'2019-11-29 22:12:44',NULL,1771,188,24,'enable'),(NULL,0,'2019-11-29 22:12:44',NULL,1772,188,29,'ZJ'),(NULL,0,'2019-11-29 22:12:44',NULL,1773,188,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:44',NULL,1774,188,11,'pycook'),(NULL,0,'2019-11-29 22:12:44',NULL,1775,188,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:44',NULL,1776,188,15,'10.1.8.14'),(NULL,0,'2019-11-29 22:12:44',NULL,1777,188,5,'c19e69a4abe2495b9a54574be1d047f8'),(NULL,0,'2019-11-29 22:12:44',NULL,1778,188,17,'online'),(NULL,0,'2019-11-29 22:12:45',NULL,1779,189,16,'cmdb1-1-8-15'),(NULL,0,'2019-11-29 22:12:45',NULL,1780,189,28,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1781,189,24,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1782,189,29,'ZJ'),(NULL,0,'2019-11-29 22:12:45',NULL,1783,189,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1784,189,11,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1785,189,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1786,189,15,'10.1.8.15'),(NULL,0,'2019-11-29 22:12:45',NULL,1787,189,5,'7a88c92bc3944ce9bde19d9ace6fe2d2'),(NULL,0,'2019-11-29 22:12:45',NULL,1788,189,17,'online'),(NULL,0,'2019-11-29 22:12:45',NULL,1789,190,16,'cmdb1-1-8-16'),(NULL,0,'2019-11-29 22:12:45',NULL,1790,190,28,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1791,190,24,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1792,190,29,'ZJ'),(NULL,0,'2019-11-29 22:12:45',NULL,1793,190,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1794,190,11,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1795,190,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1796,190,15,'10.1.8.16'),(NULL,0,'2019-11-29 22:12:45',NULL,1797,190,5,'361cd6e87c9a4dd1b07392c3e47acdc9'),(NULL,0,'2019-11-29 22:12:45',NULL,1798,190,17,'online'),(NULL,0,'2019-11-29 22:12:45',NULL,1799,191,3,'Product1-2'),(NULL,0,'2019-11-29 22:12:45',NULL,1800,192,4,'App1-2-1'),(NULL,0,'2019-11-29 22:12:45',NULL,1801,193,16,'cmdb1-2-1-1'),(NULL,0,'2019-11-29 22:12:45',NULL,1802,193,28,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1803,193,24,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1804,193,29,'ZJ'),(NULL,0,'2019-11-29 22:12:45',NULL,1805,193,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1806,193,11,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1807,193,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1808,193,15,'10.2.1.1'),(NULL,0,'2019-11-29 22:12:45',NULL,1809,193,5,'38d16dfa27f44db39a5d838a1e435969'),(NULL,0,'2019-11-29 22:12:45',NULL,1810,193,17,'online'),(NULL,0,'2019-11-29 22:12:45',NULL,1811,194,16,'cmdb1-2-1-2'),(NULL,0,'2019-11-29 22:12:45',NULL,1812,194,28,'prod'),(NULL,0,'2019-11-29 22:12:45',NULL,1813,194,24,'enable'),(NULL,0,'2019-11-29 22:12:45',NULL,1814,194,29,'ZJ'),(NULL,0,'2019-11-29 22:12:45',NULL,1815,194,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:45',NULL,1816,194,11,'pycook'),(NULL,0,'2019-11-29 22:12:45',NULL,1817,194,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:45',NULL,1818,194,15,'10.2.1.2'),(NULL,0,'2019-11-29 22:12:46',NULL,1819,194,5,'47dea1ab28e84dea963422a3fa5ffb9e'),(NULL,0,'2019-11-29 22:12:46',NULL,1820,194,17,'online'),(NULL,0,'2019-11-29 22:12:46',NULL,1821,195,16,'cmdb1-2-1-3'),(NULL,0,'2019-11-29 22:12:46',NULL,1822,195,28,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1823,195,24,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1824,195,29,'ZJ'),(NULL,0,'2019-11-29 22:12:46',NULL,1825,195,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1826,195,11,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1827,195,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1828,195,15,'10.2.1.3'),(NULL,0,'2019-11-29 22:12:46',NULL,1829,195,5,'15b3fddb912342bbadbda03491ab2f23'),(NULL,0,'2019-11-29 22:12:46',NULL,1830,195,17,'online'),(NULL,0,'2019-11-29 22:12:46',NULL,1831,196,16,'cmdb1-2-1-4'),(NULL,0,'2019-11-29 22:12:46',NULL,1832,196,28,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1833,196,24,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1834,196,29,'ZJ'),(NULL,0,'2019-11-29 22:12:46',NULL,1835,196,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1836,196,11,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1837,196,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1838,196,15,'10.2.1.4'),(NULL,0,'2019-11-29 22:12:46',NULL,1839,196,5,'e10767ad6b154e05a4c3660a5031e351'),(NULL,0,'2019-11-29 22:12:46',NULL,1840,196,17,'online'),(NULL,0,'2019-11-29 22:12:46',NULL,1841,197,16,'cmdb1-2-1-5'),(NULL,0,'2019-11-29 22:12:46',NULL,1842,197,28,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1843,197,24,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1844,197,29,'ZJ'),(NULL,0,'2019-11-29 22:12:46',NULL,1845,197,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1846,197,11,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1847,197,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1848,197,15,'10.2.1.5'),(NULL,0,'2019-11-29 22:12:46',NULL,1849,197,5,'7762d96a85944720b1cd299022f5aa15'),(NULL,0,'2019-11-29 22:12:46',NULL,1850,197,17,'online'),(NULL,0,'2019-11-29 22:12:46',NULL,1851,198,16,'cmdb1-2-1-6'),(NULL,0,'2019-11-29 22:12:46',NULL,1852,198,28,'prod'),(NULL,0,'2019-11-29 22:12:46',NULL,1853,198,24,'enable'),(NULL,0,'2019-11-29 22:12:46',NULL,1854,198,29,'ZJ'),(NULL,0,'2019-11-29 22:12:46',NULL,1855,198,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:46',NULL,1856,198,11,'pycook'),(NULL,0,'2019-11-29 22:12:46',NULL,1857,198,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:46',NULL,1858,198,15,'10.2.1.6'),(NULL,0,'2019-11-29 22:12:46',NULL,1859,198,5,'911b7b2374a845a9bdac8f990de74d7a'),(NULL,0,'2019-11-29 22:12:46',NULL,1860,198,17,'online'),(NULL,0,'2019-11-29 22:12:47',NULL,1861,199,16,'cmdb1-2-1-7'),(NULL,0,'2019-11-29 22:12:47',NULL,1862,199,28,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,1863,199,24,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,1864,199,29,'ZJ'),(NULL,0,'2019-11-29 22:12:47',NULL,1865,199,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,1866,199,11,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,1867,199,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,1868,199,15,'10.2.1.7'),(NULL,0,'2019-11-29 22:12:47',NULL,1869,199,5,'8d0ab4bf7d6d4e0a80f74688961383f6'),(NULL,0,'2019-11-29 22:12:47',NULL,1870,199,17,'online'),(NULL,0,'2019-11-29 22:12:47',NULL,1871,200,16,'cmdb1-2-1-8'),(NULL,0,'2019-11-29 22:12:47',NULL,1872,200,28,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,1873,200,24,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,1874,200,29,'ZJ'),(NULL,0,'2019-11-29 22:12:47',NULL,1875,200,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,1876,200,11,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,1877,200,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,1878,200,15,'10.2.1.8'),(NULL,0,'2019-11-29 22:12:47',NULL,1879,200,5,'9912d08b79bc489e90651228986ffbe2'),(NULL,0,'2019-11-29 22:12:47',NULL,1880,200,17,'online'),(NULL,0,'2019-11-29 22:12:47',NULL,1881,201,16,'cmdb1-2-1-9'),(NULL,0,'2019-11-29 22:12:47',NULL,1882,201,28,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,1883,201,24,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,1884,201,29,'ZJ'),(NULL,0,'2019-11-29 22:12:47',NULL,1885,201,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,1886,201,11,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,1887,201,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,1888,201,15,'10.2.1.9'),(NULL,0,'2019-11-29 22:12:47',NULL,1889,201,5,'0b0b6e52e57a4ce78b5782d3fca855af'),(NULL,0,'2019-11-29 22:12:47',NULL,1890,201,17,'online'),(NULL,0,'2019-11-29 22:12:47',NULL,1891,202,16,'cmdb1-2-1-10'),(NULL,0,'2019-11-29 22:12:47',NULL,1892,202,28,'prod'),(NULL,0,'2019-11-29 22:12:47',NULL,1893,202,24,'enable'),(NULL,0,'2019-11-29 22:12:47',NULL,1894,202,29,'ZJ'),(NULL,0,'2019-11-29 22:12:47',NULL,1895,202,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:47',NULL,1896,202,11,'pycook'),(NULL,0,'2019-11-29 22:12:47',NULL,1897,202,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:47',NULL,1898,202,15,'10.2.1.10'),(NULL,0,'2019-11-29 22:12:47',NULL,1899,202,5,'eb485d5a9bb4429487b7585b4fcc3ff9'),(NULL,0,'2019-11-29 22:12:47',NULL,1900,202,17,'online'),(NULL,0,'2019-11-29 22:12:47',NULL,1901,203,16,'cmdb1-2-1-11'),(NULL,0,'2019-11-29 22:12:48',NULL,1902,203,28,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,1903,203,24,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,1904,203,29,'ZJ'),(NULL,0,'2019-11-29 22:12:48',NULL,1905,203,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,1906,203,11,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,1907,203,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,1908,203,15,'10.2.1.11'),(NULL,0,'2019-11-29 22:12:48',NULL,1909,203,5,'c723da3ff2534fbbb32fb92255dd045d'),(NULL,0,'2019-11-29 22:12:48',NULL,1910,203,17,'online'),(NULL,0,'2019-11-29 22:12:48',NULL,1911,204,16,'cmdb1-2-1-12'),(NULL,0,'2019-11-29 22:12:48',NULL,1912,204,28,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,1913,204,24,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,1914,204,29,'ZJ'),(NULL,0,'2019-11-29 22:12:48',NULL,1915,204,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,1916,204,11,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,1917,204,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,1918,204,15,'10.2.1.12'),(NULL,0,'2019-11-29 22:12:48',NULL,1919,204,5,'44e5bf35026f4442b98be5b6699255e7'),(NULL,0,'2019-11-29 22:12:48',NULL,1920,204,17,'online'),(NULL,0,'2019-11-29 22:12:48',NULL,1921,205,16,'cmdb1-2-1-13'),(NULL,0,'2019-11-29 22:12:48',NULL,1922,205,28,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,1923,205,24,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,1924,205,29,'ZJ'),(NULL,0,'2019-11-29 22:12:48',NULL,1925,205,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,1926,205,11,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,1927,205,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,1928,205,15,'10.2.1.13'),(NULL,0,'2019-11-29 22:12:48',NULL,1929,205,5,'7c4b8f30e3654b03a1090f195f1858fb'),(NULL,0,'2019-11-29 22:12:48',NULL,1930,205,17,'online'),(NULL,0,'2019-11-29 22:12:48',NULL,1931,206,16,'cmdb1-2-1-14'),(NULL,0,'2019-11-29 22:12:48',NULL,1932,206,28,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,1933,206,24,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,1934,206,29,'ZJ'),(NULL,0,'2019-11-29 22:12:48',NULL,1935,206,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,1936,206,11,'pycook'),(NULL,0,'2019-11-29 22:12:48',NULL,1937,206,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:48',NULL,1938,206,15,'10.2.1.14'),(NULL,0,'2019-11-29 22:12:48',NULL,1939,206,5,'a6daa6ef1a3540bcaf3a82548db4b44b'),(NULL,0,'2019-11-29 22:12:48',NULL,1940,206,17,'online'),(NULL,0,'2019-11-29 22:12:48',NULL,1941,207,16,'cmdb1-2-1-15'),(NULL,0,'2019-11-29 22:12:48',NULL,1942,207,28,'prod'),(NULL,0,'2019-11-29 22:12:48',NULL,1943,207,24,'enable'),(NULL,0,'2019-11-29 22:12:48',NULL,1944,207,29,'ZJ'),(NULL,0,'2019-11-29 22:12:48',NULL,1945,207,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:48',NULL,1946,207,11,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,1947,207,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,1948,207,15,'10.2.1.15'),(NULL,0,'2019-11-29 22:12:49',NULL,1949,207,5,'5a55f873445d4bee9acf404e6bd56db4'),(NULL,0,'2019-11-29 22:12:49',NULL,1950,207,17,'online'),(NULL,0,'2019-11-29 22:12:49',NULL,1951,208,16,'cmdb1-2-1-16'),(NULL,0,'2019-11-29 22:12:49',NULL,1952,208,28,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,1953,208,24,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,1954,208,29,'ZJ'),(NULL,0,'2019-11-29 22:12:49',NULL,1955,208,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,1956,208,11,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,1957,208,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,1958,208,15,'10.2.1.16'),(NULL,0,'2019-11-29 22:12:49',NULL,1959,208,5,'1f29e13d92b149e6a0c8621def400af9'),(NULL,0,'2019-11-29 22:12:49',NULL,1960,208,17,'online'),(NULL,0,'2019-11-29 22:12:49',NULL,1961,209,4,'App1-2-2'),(NULL,0,'2019-11-29 22:12:49',NULL,1962,210,16,'cmdb1-2-2-1'),(NULL,0,'2019-11-29 22:12:49',NULL,1963,210,28,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,1964,210,24,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,1965,210,29,'ZJ'),(NULL,0,'2019-11-29 22:12:49',NULL,1966,210,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,1967,210,11,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,1968,210,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,1969,210,15,'10.2.2.1'),(NULL,0,'2019-11-29 22:12:49',NULL,1970,210,5,'269a4a1d4c8a42c195a48bd52e81515b'),(NULL,0,'2019-11-29 22:12:49',NULL,1971,210,17,'online'),(NULL,0,'2019-11-29 22:12:49',NULL,1972,211,16,'cmdb1-2-2-2'),(NULL,0,'2019-11-29 22:12:49',NULL,1973,211,28,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,1974,211,24,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,1975,211,29,'ZJ'),(NULL,0,'2019-11-29 22:12:49',NULL,1976,211,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:49',NULL,1977,211,11,'pycook'),(NULL,0,'2019-11-29 22:12:49',NULL,1978,211,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:49',NULL,1979,211,15,'10.2.2.2'),(NULL,0,'2019-11-29 22:12:49',NULL,1980,211,5,'bc530af7a1a14611b22092fe179ac3e3'),(NULL,0,'2019-11-29 22:12:49',NULL,1981,211,17,'online'),(NULL,0,'2019-11-29 22:12:49',NULL,1982,212,16,'cmdb1-2-2-3'),(NULL,0,'2019-11-29 22:12:49',NULL,1983,212,28,'prod'),(NULL,0,'2019-11-29 22:12:49',NULL,1984,212,24,'enable'),(NULL,0,'2019-11-29 22:12:49',NULL,1985,212,29,'ZJ'),(NULL,0,'2019-11-29 22:12:49',NULL,1986,212,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,1987,212,11,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,1988,212,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,1989,212,15,'10.2.2.3'),(NULL,0,'2019-11-29 22:12:50',NULL,1990,212,5,'c174da2b22f244e0841c40f863b3bb50'),(NULL,0,'2019-11-29 22:12:50',NULL,1991,212,17,'online'),(NULL,0,'2019-11-29 22:12:50',NULL,1992,213,16,'cmdb1-2-2-4'),(NULL,0,'2019-11-29 22:12:50',NULL,1993,213,28,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,1994,213,24,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,1995,213,29,'ZJ'),(NULL,0,'2019-11-29 22:12:50',NULL,1996,213,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,1997,213,11,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,1998,213,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,1999,213,15,'10.2.2.4'),(NULL,0,'2019-11-29 22:12:50',NULL,2000,213,5,'58abb77c298846be9533dde009ba5da1'),(NULL,0,'2019-11-29 22:12:50',NULL,2001,213,17,'online'),(NULL,0,'2019-11-29 22:12:50',NULL,2002,214,16,'cmdb1-2-2-5'),(NULL,0,'2019-11-29 22:12:50',NULL,2003,214,28,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2004,214,24,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2005,214,29,'ZJ'),(NULL,0,'2019-11-29 22:12:50',NULL,2006,214,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2007,214,11,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2008,214,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2009,214,15,'10.2.2.5'),(NULL,0,'2019-11-29 22:12:50',NULL,2010,214,5,'4f700fffaad84d9a8bfe7ab1231e7779'),(NULL,0,'2019-11-29 22:12:50',NULL,2011,214,17,'online'),(NULL,0,'2019-11-29 22:12:50',NULL,2012,215,16,'cmdb1-2-2-6'),(NULL,0,'2019-11-29 22:12:50',NULL,2013,215,28,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2014,215,24,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2015,215,29,'ZJ'),(NULL,0,'2019-11-29 22:12:50',NULL,2016,215,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2017,215,11,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2018,215,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2019,215,15,'10.2.2.6'),(NULL,0,'2019-11-29 22:12:50',NULL,2020,215,5,'2d9a2e0629264d2ba07070b44494abb6'),(NULL,0,'2019-11-29 22:12:50',NULL,2021,215,17,'online'),(NULL,0,'2019-11-29 22:12:50',NULL,2022,216,16,'cmdb1-2-2-7'),(NULL,0,'2019-11-29 22:12:50',NULL,2023,216,28,'prod'),(NULL,0,'2019-11-29 22:12:50',NULL,2024,216,24,'enable'),(NULL,0,'2019-11-29 22:12:50',NULL,2025,216,29,'ZJ'),(NULL,0,'2019-11-29 22:12:50',NULL,2026,216,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:50',NULL,2027,216,11,'pycook'),(NULL,0,'2019-11-29 22:12:50',NULL,2028,216,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:50',NULL,2029,216,15,'10.2.2.7'),(NULL,0,'2019-11-29 22:12:50',NULL,2030,216,5,'b792163ebbdf437d892c23d13b310bee'),(NULL,0,'2019-11-29 22:12:50',NULL,2031,216,17,'online'),(NULL,0,'2019-11-29 22:12:51',NULL,2032,217,16,'cmdb1-2-2-8'),(NULL,0,'2019-11-29 22:12:51',NULL,2033,217,28,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2034,217,24,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2035,217,29,'ZJ'),(NULL,0,'2019-11-29 22:12:51',NULL,2036,217,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2037,217,11,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2038,217,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2039,217,15,'10.2.2.8'),(NULL,0,'2019-11-29 22:12:51',NULL,2040,217,5,'b1850aeb2e9045d29cfb547c0c7c2c86'),(NULL,0,'2019-11-29 22:12:51',NULL,2041,217,17,'online'),(NULL,0,'2019-11-29 22:12:51',NULL,2042,218,16,'cmdb1-2-2-9'),(NULL,0,'2019-11-29 22:12:51',NULL,2043,218,28,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2044,218,24,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2045,218,29,'ZJ'),(NULL,0,'2019-11-29 22:12:51',NULL,2046,218,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2047,218,11,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2048,218,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2049,218,15,'10.2.2.9'),(NULL,0,'2019-11-29 22:12:51',NULL,2050,218,5,'e72c27733ca14beab43fc82ba7dc4cea'),(NULL,0,'2019-11-29 22:12:51',NULL,2051,218,17,'online'),(NULL,0,'2019-11-29 22:12:51',NULL,2052,219,16,'cmdb1-2-2-10'),(NULL,0,'2019-11-29 22:12:51',NULL,2053,219,28,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2054,219,24,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2055,219,29,'ZJ'),(NULL,0,'2019-11-29 22:12:51',NULL,2056,219,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2057,219,11,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2058,219,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2059,219,15,'10.2.2.10'),(NULL,0,'2019-11-29 22:12:51',NULL,2060,219,5,'9ef89b51660e45808b035ec8ef81e66b'),(NULL,0,'2019-11-29 22:12:51',NULL,2061,219,17,'online'),(NULL,0,'2019-11-29 22:12:51',NULL,2062,220,16,'cmdb1-2-2-11'),(NULL,0,'2019-11-29 22:12:51',NULL,2063,220,28,'prod'),(NULL,0,'2019-11-29 22:12:51',NULL,2064,220,24,'enable'),(NULL,0,'2019-11-29 22:12:51',NULL,2065,220,29,'ZJ'),(NULL,0,'2019-11-29 22:12:51',NULL,2066,220,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:51',NULL,2067,220,11,'pycook'),(NULL,0,'2019-11-29 22:12:51',NULL,2068,220,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:51',NULL,2069,220,15,'10.2.2.11'),(NULL,0,'2019-11-29 22:12:51',NULL,2070,220,5,'c134f3e8978f4c27822efaa7f03a4a1a'),(NULL,0,'2019-11-29 22:12:51',NULL,2071,220,17,'online'),(NULL,0,'2019-11-29 22:12:52',NULL,2072,221,16,'cmdb1-2-2-12'),(NULL,0,'2019-11-29 22:12:52',NULL,2073,221,28,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2074,221,24,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2075,221,29,'ZJ'),(NULL,0,'2019-11-29 22:12:52',NULL,2076,221,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2077,221,11,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2078,221,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2079,221,15,'10.2.2.12'),(NULL,0,'2019-11-29 22:12:52',NULL,2080,221,5,'65d1f480e8a74150a736b4bd820bb9a0'),(NULL,0,'2019-11-29 22:12:52',NULL,2081,221,17,'online'),(NULL,0,'2019-11-29 22:12:52',NULL,2082,222,16,'cmdb1-2-2-13'),(NULL,0,'2019-11-29 22:12:52',NULL,2083,222,28,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2084,222,24,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2085,222,29,'ZJ'),(NULL,0,'2019-11-29 22:12:52',NULL,2086,222,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2087,222,11,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2088,222,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2089,222,15,'10.2.2.13'),(NULL,0,'2019-11-29 22:12:52',NULL,2090,222,5,'09a9287b5fa04b338452630a9db50019'),(NULL,0,'2019-11-29 22:12:52',NULL,2091,222,17,'online'),(NULL,0,'2019-11-29 22:12:52',NULL,2092,223,16,'cmdb1-2-2-14'),(NULL,0,'2019-11-29 22:12:52',NULL,2093,223,28,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2094,223,24,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2095,223,29,'ZJ'),(NULL,0,'2019-11-29 22:12:52',NULL,2096,223,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2097,223,11,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2098,223,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2099,223,15,'10.2.2.14'),(NULL,0,'2019-11-29 22:12:52',NULL,2100,223,5,'89fd6e6244f64dcf8664610aed8b1824'),(NULL,0,'2019-11-29 22:12:52',NULL,2101,223,17,'online'),(NULL,0,'2019-11-29 22:12:52',NULL,2102,224,16,'cmdb1-2-2-15'),(NULL,0,'2019-11-29 22:12:52',NULL,2103,224,28,'prod'),(NULL,0,'2019-11-29 22:12:52',NULL,2104,224,24,'enable'),(NULL,0,'2019-11-29 22:12:52',NULL,2105,224,29,'ZJ'),(NULL,0,'2019-11-29 22:12:52',NULL,2106,224,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:52',NULL,2107,224,11,'pycook'),(NULL,0,'2019-11-29 22:12:52',NULL,2108,224,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:52',NULL,2109,224,15,'10.2.2.15'),(NULL,0,'2019-11-29 22:12:52',NULL,2110,224,5,'c99523c8a0994d119b15bead8d05b3ee'),(NULL,0,'2019-11-29 22:12:52',NULL,2111,224,17,'online'),(NULL,0,'2019-11-29 22:12:53',NULL,2112,225,16,'cmdb1-2-2-16'),(NULL,0,'2019-11-29 22:12:53',NULL,2113,225,28,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2114,225,24,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2115,225,29,'ZJ'),(NULL,0,'2019-11-29 22:12:53',NULL,2116,225,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2117,225,11,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2118,225,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2119,225,15,'10.2.2.16'),(NULL,0,'2019-11-29 22:12:53',NULL,2120,225,5,'4838cb9e23a64592a84a4aa6f3c7e7de'),(NULL,0,'2019-11-29 22:12:53',NULL,2121,225,17,'online'),(NULL,0,'2019-11-29 22:12:53',NULL,2122,226,4,'App1-2-3'),(NULL,0,'2019-11-29 22:12:53',NULL,2123,227,16,'cmdb1-2-3-1'),(NULL,0,'2019-11-29 22:12:53',NULL,2124,227,28,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2125,227,24,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2126,227,29,'ZJ'),(NULL,0,'2019-11-29 22:12:53',NULL,2127,227,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2128,227,11,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2129,227,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2130,227,15,'10.2.3.1'),(NULL,0,'2019-11-29 22:12:53',NULL,2131,227,5,'6a84fd010e96429e9d2d0fc8585a4fc9'),(NULL,0,'2019-11-29 22:12:53',NULL,2132,227,17,'online'),(NULL,0,'2019-11-29 22:12:53',NULL,2133,228,16,'cmdb1-2-3-2'),(NULL,0,'2019-11-29 22:12:53',NULL,2134,228,28,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2135,228,24,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2136,228,29,'ZJ'),(NULL,0,'2019-11-29 22:12:53',NULL,2137,228,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2138,228,11,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2139,228,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2140,228,15,'10.2.3.2'),(NULL,0,'2019-11-29 22:12:53',NULL,2141,228,5,'6d02c8d4219f428b94d4aeada7d9a9a6'),(NULL,0,'2019-11-29 22:12:53',NULL,2142,228,17,'online'),(NULL,0,'2019-11-29 22:12:53',NULL,2143,229,16,'cmdb1-2-3-3'),(NULL,0,'2019-11-29 22:12:53',NULL,2144,229,28,'prod'),(NULL,0,'2019-11-29 22:12:53',NULL,2145,229,24,'enable'),(NULL,0,'2019-11-29 22:12:53',NULL,2146,229,29,'ZJ'),(NULL,0,'2019-11-29 22:12:53',NULL,2147,229,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:53',NULL,2148,229,11,'pycook'),(NULL,0,'2019-11-29 22:12:53',NULL,2149,229,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:53',NULL,2150,229,15,'10.2.3.3'),(NULL,0,'2019-11-29 22:12:53',NULL,2151,229,5,'94aa5a91c7a84571a7b27ee141de2623'),(NULL,0,'2019-11-29 22:12:53',NULL,2152,229,17,'online'),(NULL,0,'2019-11-29 22:12:54',NULL,2153,230,16,'cmdb1-2-3-4'),(NULL,0,'2019-11-29 22:12:54',NULL,2154,230,28,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2155,230,24,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2156,230,29,'ZJ'),(NULL,0,'2019-11-29 22:12:54',NULL,2157,230,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2158,230,11,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2159,230,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2160,230,15,'10.2.3.4'),(NULL,0,'2019-11-29 22:12:54',NULL,2161,230,5,'4867c2608c07473189ec146d64cdbb89'),(NULL,0,'2019-11-29 22:12:54',NULL,2162,230,17,'online'),(NULL,0,'2019-11-29 22:12:54',NULL,2163,231,16,'cmdb1-2-3-5'),(NULL,0,'2019-11-29 22:12:54',NULL,2164,231,28,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2165,231,24,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2166,231,29,'ZJ'),(NULL,0,'2019-11-29 22:12:54',NULL,2167,231,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2168,231,11,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2169,231,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2170,231,15,'10.2.3.5'),(NULL,0,'2019-11-29 22:12:54',NULL,2171,231,5,'e0f4ff4ce80349c8ad0bd1287ff6ddff'),(NULL,0,'2019-11-29 22:12:54',NULL,2172,231,17,'online'),(NULL,0,'2019-11-29 22:12:54',NULL,2173,232,16,'cmdb1-2-3-6'),(NULL,0,'2019-11-29 22:12:54',NULL,2174,232,28,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2175,232,24,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2176,232,29,'ZJ'),(NULL,0,'2019-11-29 22:12:54',NULL,2177,232,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2178,232,11,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2179,232,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2180,232,15,'10.2.3.6'),(NULL,0,'2019-11-29 22:12:54',NULL,2181,232,5,'ab3524a2389f4e6c92bd822cc6944df1'),(NULL,0,'2019-11-29 22:12:54',NULL,2182,232,17,'online'),(NULL,0,'2019-11-29 22:12:54',NULL,2183,233,16,'cmdb1-2-3-7'),(NULL,0,'2019-11-29 22:12:54',NULL,2184,233,28,'prod'),(NULL,0,'2019-11-29 22:12:54',NULL,2185,233,24,'enable'),(NULL,0,'2019-11-29 22:12:54',NULL,2186,233,29,'ZJ'),(NULL,0,'2019-11-29 22:12:54',NULL,2187,233,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:54',NULL,2188,233,11,'pycook'),(NULL,0,'2019-11-29 22:12:54',NULL,2189,233,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:54',NULL,2190,233,15,'10.2.3.7'),(NULL,0,'2019-11-29 22:12:54',NULL,2191,233,5,'9706e308382c4e8fbe2803b4a6ecbfe5'),(NULL,0,'2019-11-29 22:12:54',NULL,2192,233,17,'online'),(NULL,0,'2019-11-29 22:12:54',NULL,2193,234,16,'cmdb1-2-3-8'),(NULL,0,'2019-11-29 22:12:54',NULL,2194,234,28,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2195,234,24,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2196,234,29,'ZJ'),(NULL,0,'2019-11-29 22:12:55',NULL,2197,234,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2198,234,11,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2199,234,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2200,234,15,'10.2.3.8'),(NULL,0,'2019-11-29 22:12:55',NULL,2201,234,5,'3ebdc26582ba405781a3e2c18216b962'),(NULL,0,'2019-11-29 22:12:55',NULL,2202,234,17,'online'),(NULL,0,'2019-11-29 22:12:55',NULL,2203,235,16,'cmdb1-2-3-9'),(NULL,0,'2019-11-29 22:12:55',NULL,2204,235,28,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2205,235,24,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2206,235,29,'ZJ'),(NULL,0,'2019-11-29 22:12:55',NULL,2207,235,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2208,235,11,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2209,235,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2210,235,15,'10.2.3.9'),(NULL,0,'2019-11-29 22:12:55',NULL,2211,235,5,'78a4bc645ee54644b4d67679d7614aeb'),(NULL,0,'2019-11-29 22:12:55',NULL,2212,235,17,'online'),(NULL,0,'2019-11-29 22:12:55',NULL,2213,236,16,'cmdb1-2-3-10'),(NULL,0,'2019-11-29 22:12:55',NULL,2214,236,28,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2215,236,24,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2216,236,29,'ZJ'),(NULL,0,'2019-11-29 22:12:55',NULL,2217,236,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2218,236,11,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2219,236,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2220,236,15,'10.2.3.10'),(NULL,0,'2019-11-29 22:12:55',NULL,2221,236,5,'65c40694e19e4df59ef6dbe32ceaab19'),(NULL,0,'2019-11-29 22:12:55',NULL,2222,236,17,'online'),(NULL,0,'2019-11-29 22:12:55',NULL,2223,237,16,'cmdb1-2-3-11'),(NULL,0,'2019-11-29 22:12:55',NULL,2224,237,28,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2225,237,24,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2226,237,29,'ZJ'),(NULL,0,'2019-11-29 22:12:55',NULL,2227,237,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:55',NULL,2228,237,11,'pycook'),(NULL,0,'2019-11-29 22:12:55',NULL,2229,237,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:55',NULL,2230,237,15,'10.2.3.11'),(NULL,0,'2019-11-29 22:12:55',NULL,2231,237,5,'1bba58b66fca45e28193f72a9e480363'),(NULL,0,'2019-11-29 22:12:55',NULL,2232,237,17,'online'),(NULL,0,'2019-11-29 22:12:55',NULL,2233,238,16,'cmdb1-2-3-12'),(NULL,0,'2019-11-29 22:12:55',NULL,2234,238,28,'prod'),(NULL,0,'2019-11-29 22:12:55',NULL,2235,238,24,'enable'),(NULL,0,'2019-11-29 22:12:55',NULL,2236,238,29,'ZJ'),(NULL,0,'2019-11-29 22:12:55',NULL,2237,238,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2238,238,11,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2239,238,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2240,238,15,'10.2.3.12'),(NULL,0,'2019-11-29 22:12:56',NULL,2241,238,5,'36fdef4909ae4e07b21f59bb6867739b'),(NULL,0,'2019-11-29 22:12:56',NULL,2242,238,17,'online'),(NULL,0,'2019-11-29 22:12:56',NULL,2243,239,16,'cmdb1-2-3-13'),(NULL,0,'2019-11-29 22:12:56',NULL,2244,239,28,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2245,239,24,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2246,239,29,'ZJ'),(NULL,0,'2019-11-29 22:12:56',NULL,2247,239,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2248,239,11,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2249,239,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2250,239,15,'10.2.3.13'),(NULL,0,'2019-11-29 22:12:56',NULL,2251,239,5,'f393f76ffe354c8baaee032c788bd4f2'),(NULL,0,'2019-11-29 22:12:56',NULL,2252,239,17,'online'),(NULL,0,'2019-11-29 22:12:56',NULL,2253,240,16,'cmdb1-2-3-14'),(NULL,0,'2019-11-29 22:12:56',NULL,2254,240,28,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2255,240,24,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2256,240,29,'ZJ'),(NULL,0,'2019-11-29 22:12:56',NULL,2257,240,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2258,240,11,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2259,240,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2260,240,15,'10.2.3.14'),(NULL,0,'2019-11-29 22:12:56',NULL,2261,240,5,'906954eb16fe453ba67c79b35296945b'),(NULL,0,'2019-11-29 22:12:56',NULL,2262,240,17,'online'),(NULL,0,'2019-11-29 22:12:56',NULL,2263,241,16,'cmdb1-2-3-15'),(NULL,0,'2019-11-29 22:12:56',NULL,2264,241,28,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2265,241,24,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2266,241,29,'ZJ'),(NULL,0,'2019-11-29 22:12:56',NULL,2267,241,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2268,241,11,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2269,241,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2270,241,15,'10.2.3.15'),(NULL,0,'2019-11-29 22:12:56',NULL,2271,241,5,'fca15b033f1745c4b3ab10b51bdf563e'),(NULL,0,'2019-11-29 22:12:56',NULL,2272,241,17,'online'),(NULL,0,'2019-11-29 22:12:56',NULL,2273,242,16,'cmdb1-2-3-16'),(NULL,0,'2019-11-29 22:12:56',NULL,2274,242,28,'prod'),(NULL,0,'2019-11-29 22:12:56',NULL,2275,242,24,'enable'),(NULL,0,'2019-11-29 22:12:56',NULL,2276,242,29,'ZJ'),(NULL,0,'2019-11-29 22:12:56',NULL,2277,242,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:56',NULL,2278,242,11,'pycook'),(NULL,0,'2019-11-29 22:12:56',NULL,2279,242,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:56',NULL,2280,242,15,'10.2.3.16'),(NULL,0,'2019-11-29 22:12:56',NULL,2281,242,5,'c16efe4425c34120a155fab15700adc6'),(NULL,0,'2019-11-29 22:12:56',NULL,2282,242,17,'online'),(NULL,0,'2019-11-29 22:12:57',NULL,2283,243,4,'App1-2-4'),(NULL,0,'2019-11-29 22:12:57',NULL,2284,244,16,'cmdb1-2-4-1'),(NULL,0,'2019-11-29 22:12:57',NULL,2285,244,28,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2286,244,24,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2287,244,29,'ZJ'),(NULL,0,'2019-11-29 22:12:57',NULL,2288,244,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2289,244,11,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2290,244,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2291,244,15,'10.2.4.1'),(NULL,0,'2019-11-29 22:12:57',NULL,2292,244,5,'20f85fe6091c47068a5c10b6d3c9d4e8'),(NULL,0,'2019-11-29 22:12:57',NULL,2293,244,17,'online'),(NULL,0,'2019-11-29 22:12:57',NULL,2294,245,16,'cmdb1-2-4-2'),(NULL,0,'2019-11-29 22:12:57',NULL,2295,245,28,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2296,245,24,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2297,245,29,'ZJ'),(NULL,0,'2019-11-29 22:12:57',NULL,2298,245,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2299,245,11,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2300,245,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2301,245,15,'10.2.4.2'),(NULL,0,'2019-11-29 22:12:57',NULL,2302,245,5,'4cb9f8df43ae4b5baca4844f004d0320'),(NULL,0,'2019-11-29 22:12:57',NULL,2303,245,17,'online'),(NULL,0,'2019-11-29 22:12:57',NULL,2304,246,16,'cmdb1-2-4-3'),(NULL,0,'2019-11-29 22:12:57',NULL,2305,246,28,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2306,246,24,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2307,246,29,'ZJ'),(NULL,0,'2019-11-29 22:12:57',NULL,2308,246,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2309,246,11,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2310,246,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2311,246,15,'10.2.4.3'),(NULL,0,'2019-11-29 22:12:57',NULL,2312,246,5,'f48c2ea6816741f79ba8bd169bf3005d'),(NULL,0,'2019-11-29 22:12:57',NULL,2313,246,17,'online'),(NULL,0,'2019-11-29 22:12:57',NULL,2314,247,16,'cmdb1-2-4-4'),(NULL,0,'2019-11-29 22:12:57',NULL,2315,247,28,'prod'),(NULL,0,'2019-11-29 22:12:57',NULL,2316,247,24,'enable'),(NULL,0,'2019-11-29 22:12:57',NULL,2317,247,29,'ZJ'),(NULL,0,'2019-11-29 22:12:57',NULL,2318,247,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:57',NULL,2319,247,11,'pycook'),(NULL,0,'2019-11-29 22:12:57',NULL,2320,247,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:57',NULL,2321,247,15,'10.2.4.4'),(NULL,0,'2019-11-29 22:12:57',NULL,2322,247,5,'284327c1d86d43e7b5ba9f4b34bf9d20'),(NULL,0,'2019-11-29 22:12:57',NULL,2323,247,17,'online'),(NULL,0,'2019-11-29 22:12:58',NULL,2324,248,16,'cmdb1-2-4-5'),(NULL,0,'2019-11-29 22:12:58',NULL,2325,248,28,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2326,248,24,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2327,248,29,'ZJ'),(NULL,0,'2019-11-29 22:12:58',NULL,2328,248,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2329,248,11,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2330,248,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2331,248,15,'10.2.4.5'),(NULL,0,'2019-11-29 22:12:58',NULL,2332,248,5,'a6563721c0c34c8b99b7692969ab1927'),(NULL,0,'2019-11-29 22:12:58',NULL,2333,248,17,'online'),(NULL,0,'2019-11-29 22:12:58',NULL,2334,249,16,'cmdb1-2-4-6'),(NULL,0,'2019-11-29 22:12:58',NULL,2335,249,28,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2336,249,24,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2337,249,29,'ZJ'),(NULL,0,'2019-11-29 22:12:58',NULL,2338,249,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2339,249,11,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2340,249,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2341,249,15,'10.2.4.6'),(NULL,0,'2019-11-29 22:12:58',NULL,2342,249,5,'d807db739e2c46d3a2622a0031fcfc42'),(NULL,0,'2019-11-29 22:12:58',NULL,2343,249,17,'online'),(NULL,0,'2019-11-29 22:12:58',NULL,2344,250,16,'cmdb1-2-4-7'),(NULL,0,'2019-11-29 22:12:58',NULL,2345,250,28,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2346,250,24,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2347,250,29,'ZJ'),(NULL,0,'2019-11-29 22:12:58',NULL,2348,250,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2349,250,11,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2350,250,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2351,250,15,'10.2.4.7'),(NULL,0,'2019-11-29 22:12:58',NULL,2352,250,5,'cc022020f5d3404b9bf95918d65cd783'),(NULL,0,'2019-11-29 22:12:58',NULL,2353,250,17,'online'),(NULL,0,'2019-11-29 22:12:58',NULL,2354,251,16,'cmdb1-2-4-8'),(NULL,0,'2019-11-29 22:12:58',NULL,2355,251,28,'prod'),(NULL,0,'2019-11-29 22:12:58',NULL,2356,251,24,'enable'),(NULL,0,'2019-11-29 22:12:58',NULL,2357,251,29,'ZJ'),(NULL,0,'2019-11-29 22:12:58',NULL,2358,251,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:58',NULL,2359,251,11,'pycook'),(NULL,0,'2019-11-29 22:12:58',NULL,2360,251,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:58',NULL,2361,251,15,'10.2.4.8'),(NULL,0,'2019-11-29 22:12:58',NULL,2362,251,5,'3fa7378404f1457f9a93caccab3d2809'),(NULL,0,'2019-11-29 22:12:58',NULL,2363,251,17,'online'),(NULL,0,'2019-11-29 22:12:58',NULL,2364,252,16,'cmdb1-2-4-9'),(NULL,0,'2019-11-29 22:12:59',NULL,2365,252,28,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2366,252,24,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2367,252,29,'ZJ'),(NULL,0,'2019-11-29 22:12:59',NULL,2368,252,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2369,252,11,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2370,252,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2371,252,15,'10.2.4.9'),(NULL,0,'2019-11-29 22:12:59',NULL,2372,252,5,'573fa7095d1f46adb6f200400bd909ee'),(NULL,0,'2019-11-29 22:12:59',NULL,2373,252,17,'online'),(NULL,0,'2019-11-29 22:12:59',NULL,2374,253,16,'cmdb1-2-4-10'),(NULL,0,'2019-11-29 22:12:59',NULL,2375,253,28,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2376,253,24,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2377,253,29,'ZJ'),(NULL,0,'2019-11-29 22:12:59',NULL,2378,253,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2379,253,11,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2380,253,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2381,253,15,'10.2.4.10'),(NULL,0,'2019-11-29 22:12:59',NULL,2382,253,5,'47ab0abf194641b08ebad1760eab4903'),(NULL,0,'2019-11-29 22:12:59',NULL,2383,253,17,'online'),(NULL,0,'2019-11-29 22:12:59',NULL,2384,254,16,'cmdb1-2-4-11'),(NULL,0,'2019-11-29 22:12:59',NULL,2385,254,28,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2386,254,24,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2387,254,29,'ZJ'),(NULL,0,'2019-11-29 22:12:59',NULL,2388,254,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2389,254,11,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2390,254,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2391,254,15,'10.2.4.11'),(NULL,0,'2019-11-29 22:12:59',NULL,2392,254,5,'d60372447cf84cd2ae78fabcf874aeeb'),(NULL,0,'2019-11-29 22:12:59',NULL,2393,254,17,'online'),(NULL,0,'2019-11-29 22:12:59',NULL,2394,255,16,'cmdb1-2-4-12'),(NULL,0,'2019-11-29 22:12:59',NULL,2395,255,28,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2396,255,24,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2397,255,29,'ZJ'),(NULL,0,'2019-11-29 22:12:59',NULL,2398,255,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2399,255,11,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2400,255,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:12:59',NULL,2401,255,15,'10.2.4.12'),(NULL,0,'2019-11-29 22:12:59',NULL,2402,255,5,'5af3e7ace4dc41a29718a65f0648a4bc'),(NULL,0,'2019-11-29 22:12:59',NULL,2403,255,17,'online'),(NULL,0,'2019-11-29 22:12:59',NULL,2404,256,16,'cmdb1-2-4-13'),(NULL,0,'2019-11-29 22:12:59',NULL,2405,256,28,'prod'),(NULL,0,'2019-11-29 22:12:59',NULL,2406,256,24,'enable'),(NULL,0,'2019-11-29 22:12:59',NULL,2407,256,29,'ZJ'),(NULL,0,'2019-11-29 22:12:59',NULL,2408,256,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:12:59',NULL,2409,256,11,'pycook'),(NULL,0,'2019-11-29 22:12:59',NULL,2410,256,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2411,256,15,'10.2.4.13'),(NULL,0,'2019-11-29 22:13:00',NULL,2412,256,5,'6c10e5495886459e9e88eb7c37625d66'),(NULL,0,'2019-11-29 22:13:00',NULL,2413,256,17,'online'),(NULL,0,'2019-11-29 22:13:00',NULL,2414,257,16,'cmdb1-2-4-14'),(NULL,0,'2019-11-29 22:13:00',NULL,2415,257,28,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2416,257,24,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2417,257,29,'ZJ'),(NULL,0,'2019-11-29 22:13:00',NULL,2418,257,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2419,257,11,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2420,257,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2421,257,15,'10.2.4.14'),(NULL,0,'2019-11-29 22:13:00',NULL,2422,257,5,'7740020e765b4454af47f80853705922'),(NULL,0,'2019-11-29 22:13:00',NULL,2423,257,17,'online'),(NULL,0,'2019-11-29 22:13:00',NULL,2424,258,16,'cmdb1-2-4-15'),(NULL,0,'2019-11-29 22:13:00',NULL,2425,258,28,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2426,258,24,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2427,258,29,'ZJ'),(NULL,0,'2019-11-29 22:13:00',NULL,2428,258,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2429,258,11,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2430,258,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2431,258,15,'10.2.4.15'),(NULL,0,'2019-11-29 22:13:00',NULL,2432,258,5,'67278edf4ec445c2b6da70a9666c843a'),(NULL,0,'2019-11-29 22:13:00',NULL,2433,258,17,'online'),(NULL,0,'2019-11-29 22:13:00',NULL,2434,259,16,'cmdb1-2-4-16'),(NULL,0,'2019-11-29 22:13:00',NULL,2435,259,28,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2436,259,24,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2437,259,29,'ZJ'),(NULL,0,'2019-11-29 22:13:00',NULL,2438,259,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2439,259,11,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2440,259,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2441,259,15,'10.2.4.16'),(NULL,0,'2019-11-29 22:13:00',NULL,2442,259,5,'f2d6c61af1ec4e44bb99d013fac883c6'),(NULL,0,'2019-11-29 22:13:00',NULL,2443,259,17,'online'),(NULL,0,'2019-11-29 22:13:00',NULL,2444,260,4,'App1-2-5'),(NULL,0,'2019-11-29 22:13:00',NULL,2445,261,16,'cmdb1-2-5-1'),(NULL,0,'2019-11-29 22:13:00',NULL,2446,261,28,'prod'),(NULL,0,'2019-11-29 22:13:00',NULL,2447,261,24,'enable'),(NULL,0,'2019-11-29 22:13:00',NULL,2448,261,29,'ZJ'),(NULL,0,'2019-11-29 22:13:00',NULL,2449,261,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:00',NULL,2450,261,11,'pycook'),(NULL,0,'2019-11-29 22:13:00',NULL,2451,261,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:00',NULL,2452,261,15,'10.2.5.1'),(NULL,0,'2019-11-29 22:13:01',NULL,2453,261,5,'840309194e69481d8064fc1596a74bc8'),(NULL,0,'2019-11-29 22:13:01',NULL,2454,261,17,'online'),(NULL,0,'2019-11-29 22:13:01',NULL,2455,262,16,'cmdb1-2-5-2'),(NULL,0,'2019-11-29 22:13:01',NULL,2456,262,28,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2457,262,24,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2458,262,29,'ZJ'),(NULL,0,'2019-11-29 22:13:01',NULL,2459,262,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2460,262,11,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2461,262,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2462,262,15,'10.2.5.2'),(NULL,0,'2019-11-29 22:13:01',NULL,2463,262,5,'fa047f3c95fc4c079d402f98ec18322d'),(NULL,0,'2019-11-29 22:13:01',NULL,2464,262,17,'online'),(NULL,0,'2019-11-29 22:13:01',NULL,2465,263,16,'cmdb1-2-5-3'),(NULL,0,'2019-11-29 22:13:01',NULL,2466,263,28,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2467,263,24,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2468,263,29,'ZJ'),(NULL,0,'2019-11-29 22:13:01',NULL,2469,263,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2470,263,11,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2471,263,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2472,263,15,'10.2.5.3'),(NULL,0,'2019-11-29 22:13:01',NULL,2473,263,5,'b0c6482f8ec14fb59dad329a46b2934e'),(NULL,0,'2019-11-29 22:13:01',NULL,2474,263,17,'online'),(NULL,0,'2019-11-29 22:13:01',NULL,2475,264,16,'cmdb1-2-5-4'),(NULL,0,'2019-11-29 22:13:01',NULL,2476,264,28,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2477,264,24,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2478,264,29,'ZJ'),(NULL,0,'2019-11-29 22:13:01',NULL,2479,264,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2480,264,11,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2481,264,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2482,264,15,'10.2.5.4'),(NULL,0,'2019-11-29 22:13:01',NULL,2483,264,5,'b01773f3f6af4fa6b848476ec062c424'),(NULL,0,'2019-11-29 22:13:01',NULL,2484,264,17,'online'),(NULL,0,'2019-11-29 22:13:01',NULL,2485,265,16,'cmdb1-2-5-5'),(NULL,0,'2019-11-29 22:13:01',NULL,2486,265,28,'prod'),(NULL,0,'2019-11-29 22:13:01',NULL,2487,265,24,'enable'),(NULL,0,'2019-11-29 22:13:01',NULL,2488,265,29,'ZJ'),(NULL,0,'2019-11-29 22:13:01',NULL,2489,265,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:01',NULL,2490,265,11,'pycook'),(NULL,0,'2019-11-29 22:13:01',NULL,2491,265,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:01',NULL,2492,265,15,'10.2.5.5'),(NULL,0,'2019-11-29 22:13:01',NULL,2493,265,5,'03847b361e6a4c69ba910ff2e3e41859'),(NULL,0,'2019-11-29 22:13:01',NULL,2494,265,17,'online'),(NULL,0,'2019-11-29 22:13:02',NULL,2495,266,16,'cmdb1-2-5-6'),(NULL,0,'2019-11-29 22:13:02',NULL,2496,266,28,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2497,266,24,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2498,266,29,'ZJ'),(NULL,0,'2019-11-29 22:13:02',NULL,2499,266,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2500,266,11,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2501,266,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2502,266,15,'10.2.5.6'),(NULL,0,'2019-11-29 22:13:02',NULL,2503,266,5,'f296133e3fa34b5ea675bb3f442df68e'),(NULL,0,'2019-11-29 22:13:02',NULL,2504,266,17,'online'),(NULL,0,'2019-11-29 22:13:02',NULL,2505,267,16,'cmdb1-2-5-7'),(NULL,0,'2019-11-29 22:13:02',NULL,2506,267,28,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2507,267,24,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2508,267,29,'ZJ'),(NULL,0,'2019-11-29 22:13:02',NULL,2509,267,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2510,267,11,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2511,267,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2512,267,15,'10.2.5.7'),(NULL,0,'2019-11-29 22:13:02',NULL,2513,267,5,'de14e731a7bd49368cdb0e7822f5d136'),(NULL,0,'2019-11-29 22:13:02',NULL,2514,267,17,'online'),(NULL,0,'2019-11-29 22:13:02',NULL,2515,268,16,'cmdb1-2-5-8'),(NULL,0,'2019-11-29 22:13:02',NULL,2516,268,28,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2517,268,24,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2518,268,29,'ZJ'),(NULL,0,'2019-11-29 22:13:02',NULL,2519,268,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2520,268,11,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2521,268,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2522,268,15,'10.2.5.8'),(NULL,0,'2019-11-29 22:13:02',NULL,2523,268,5,'6a25414594c6434099f73b28ba9bf1b9'),(NULL,0,'2019-11-29 22:13:02',NULL,2524,268,17,'online'),(NULL,0,'2019-11-29 22:13:02',NULL,2525,269,16,'cmdb1-2-5-9'),(NULL,0,'2019-11-29 22:13:02',NULL,2526,269,28,'prod'),(NULL,0,'2019-11-29 22:13:02',NULL,2527,269,24,'enable'),(NULL,0,'2019-11-29 22:13:02',NULL,2528,269,29,'ZJ'),(NULL,0,'2019-11-29 22:13:02',NULL,2529,269,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:02',NULL,2530,269,11,'pycook'),(NULL,0,'2019-11-29 22:13:02',NULL,2531,269,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:02',NULL,2532,269,15,'10.2.5.9'),(NULL,0,'2019-11-29 22:13:02',NULL,2533,269,5,'be152ad131f441f3b8935b3d7b16cf89'),(NULL,0,'2019-11-29 22:13:02',NULL,2534,269,17,'online'),(NULL,0,'2019-11-29 22:13:02',NULL,2535,270,16,'cmdb1-2-5-10'),(NULL,0,'2019-11-29 22:13:02',NULL,2536,270,28,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,2537,270,24,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,2538,270,29,'ZJ'),(NULL,0,'2019-11-29 22:13:03',NULL,2539,270,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,2540,270,11,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,2541,270,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,2542,270,15,'10.2.5.10'),(NULL,0,'2019-11-29 22:13:03',NULL,2543,270,5,'88c4e19454bf4e89866ecf7ef3ac632b'),(NULL,0,'2019-11-29 22:13:03',NULL,2544,270,17,'online'),(NULL,0,'2019-11-29 22:13:03',NULL,2545,271,16,'cmdb1-2-5-11'),(NULL,0,'2019-11-29 22:13:03',NULL,2546,271,28,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,2547,271,24,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,2548,271,29,'ZJ'),(NULL,0,'2019-11-29 22:13:03',NULL,2549,271,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,2550,271,11,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,2551,271,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,2552,271,15,'10.2.5.11'),(NULL,0,'2019-11-29 22:13:03',NULL,2553,271,5,'b637d11ff2a54ab9a500853f7f3328b2'),(NULL,0,'2019-11-29 22:13:03',NULL,2554,271,17,'online'),(NULL,0,'2019-11-29 22:13:03',NULL,2555,272,16,'cmdb1-2-5-12'),(NULL,0,'2019-11-29 22:13:03',NULL,2556,272,28,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,2557,272,24,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,2558,272,29,'ZJ'),(NULL,0,'2019-11-29 22:13:03',NULL,2559,272,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,2560,272,11,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,2561,272,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,2562,272,15,'10.2.5.12'),(NULL,0,'2019-11-29 22:13:03',NULL,2563,272,5,'63495d6782884a68b303943b235dc9d9'),(NULL,0,'2019-11-29 22:13:03',NULL,2564,272,17,'online'),(NULL,0,'2019-11-29 22:13:03',NULL,2565,273,16,'cmdb1-2-5-13'),(NULL,0,'2019-11-29 22:13:03',NULL,2566,273,28,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,2567,273,24,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,2568,273,29,'ZJ'),(NULL,0,'2019-11-29 22:13:03',NULL,2569,273,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,2570,273,11,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,2571,273,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,2572,273,15,'10.2.5.13'),(NULL,0,'2019-11-29 22:13:03',NULL,2573,273,5,'1243259bf5024c4cb638c1bd12b0b6a2'),(NULL,0,'2019-11-29 22:13:03',NULL,2574,273,17,'online'),(NULL,0,'2019-11-29 22:13:03',NULL,2575,274,16,'cmdb1-2-5-14'),(NULL,0,'2019-11-29 22:13:03',NULL,2576,274,28,'prod'),(NULL,0,'2019-11-29 22:13:03',NULL,2577,274,24,'enable'),(NULL,0,'2019-11-29 22:13:03',NULL,2578,274,29,'ZJ'),(NULL,0,'2019-11-29 22:13:03',NULL,2579,274,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:03',NULL,2580,274,11,'pycook'),(NULL,0,'2019-11-29 22:13:03',NULL,2581,274,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:03',NULL,2582,274,15,'10.2.5.14'),(NULL,0,'2019-11-29 22:13:04',NULL,2583,274,5,'a5f995e8fec34552a6d54b43a00da3ff'),(NULL,0,'2019-11-29 22:13:04',NULL,2584,274,17,'online'),(NULL,0,'2019-11-29 22:13:04',NULL,2585,275,16,'cmdb1-2-5-15'),(NULL,0,'2019-11-29 22:13:04',NULL,2586,275,28,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,2587,275,24,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,2588,275,29,'ZJ'),(NULL,0,'2019-11-29 22:13:04',NULL,2589,275,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,2590,275,11,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,2591,275,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,2592,275,15,'10.2.5.15'),(NULL,0,'2019-11-29 22:13:04',NULL,2593,275,5,'ff5c7cb4029b43579d71ed3e3555a466'),(NULL,0,'2019-11-29 22:13:04',NULL,2594,275,17,'online'),(NULL,0,'2019-11-29 22:13:04',NULL,2595,276,16,'cmdb1-2-5-16'),(NULL,0,'2019-11-29 22:13:04',NULL,2596,276,28,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,2597,276,24,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,2598,276,29,'ZJ'),(NULL,0,'2019-11-29 22:13:04',NULL,2599,276,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,2600,276,11,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,2601,276,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,2602,276,15,'10.2.5.16'),(NULL,0,'2019-11-29 22:13:04',NULL,2603,276,5,'c02004194f3344edba970befc53afef0'),(NULL,0,'2019-11-29 22:13:04',NULL,2604,276,17,'online'),(NULL,0,'2019-11-29 22:13:04',NULL,2605,277,4,'App1-2-6'),(NULL,0,'2019-11-29 22:13:04',NULL,2606,278,16,'cmdb1-2-6-1'),(NULL,0,'2019-11-29 22:13:04',NULL,2607,278,28,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,2608,278,24,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,2609,278,29,'ZJ'),(NULL,0,'2019-11-29 22:13:04',NULL,2610,278,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,2611,278,11,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,2612,278,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,2613,278,15,'10.2.6.1'),(NULL,0,'2019-11-29 22:13:04',NULL,2614,278,5,'ee02b907467d447581d41719fc9bac4d'),(NULL,0,'2019-11-29 22:13:04',NULL,2615,278,17,'online'),(NULL,0,'2019-11-29 22:13:04',NULL,2616,279,16,'cmdb1-2-6-2'),(NULL,0,'2019-11-29 22:13:04',NULL,2617,279,28,'prod'),(NULL,0,'2019-11-29 22:13:04',NULL,2618,279,24,'enable'),(NULL,0,'2019-11-29 22:13:04',NULL,2619,279,29,'ZJ'),(NULL,0,'2019-11-29 22:13:04',NULL,2620,279,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:04',NULL,2621,279,11,'pycook'),(NULL,0,'2019-11-29 22:13:04',NULL,2622,279,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:04',NULL,2623,279,15,'10.2.6.2'),(NULL,0,'2019-11-29 22:13:05',NULL,2624,279,5,'946f0faa892e430993d157f49e56e9cc'),(NULL,0,'2019-11-29 22:13:05',NULL,2625,279,17,'online'),(NULL,0,'2019-11-29 22:13:05',NULL,2626,280,16,'cmdb1-2-6-3'),(NULL,0,'2019-11-29 22:13:05',NULL,2627,280,28,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,2628,280,24,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,2629,280,29,'ZJ'),(NULL,0,'2019-11-29 22:13:05',NULL,2630,280,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,2631,280,11,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,2632,280,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,2633,280,15,'10.2.6.3'),(NULL,0,'2019-11-29 22:13:05',NULL,2634,280,5,'681eec74ec794d359937c375145de094'),(NULL,0,'2019-11-29 22:13:05',NULL,2635,280,17,'online'),(NULL,0,'2019-11-29 22:13:05',NULL,2636,281,16,'cmdb1-2-6-4'),(NULL,0,'2019-11-29 22:13:05',NULL,2637,281,28,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,2638,281,24,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,2639,281,29,'ZJ'),(NULL,0,'2019-11-29 22:13:05',NULL,2640,281,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,2641,281,11,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,2642,281,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,2643,281,15,'10.2.6.4'),(NULL,0,'2019-11-29 22:13:05',NULL,2644,281,5,'d1f524ad59534e7faeb27c07a03781b7'),(NULL,0,'2019-11-29 22:13:05',NULL,2645,281,17,'online'),(NULL,0,'2019-11-29 22:13:05',NULL,2646,282,16,'cmdb1-2-6-5'),(NULL,0,'2019-11-29 22:13:05',NULL,2647,282,28,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,2648,282,24,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,2649,282,29,'ZJ'),(NULL,0,'2019-11-29 22:13:05',NULL,2650,282,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,2651,282,11,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,2652,282,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,2653,282,15,'10.2.6.5'),(NULL,0,'2019-11-29 22:13:05',NULL,2654,282,5,'73af42a97e1b4bf1a218ff8d06a748b2'),(NULL,0,'2019-11-29 22:13:05',NULL,2655,282,17,'online'),(NULL,0,'2019-11-29 22:13:05',NULL,2656,283,16,'cmdb1-2-6-6'),(NULL,0,'2019-11-29 22:13:05',NULL,2657,283,28,'prod'),(NULL,0,'2019-11-29 22:13:05',NULL,2658,283,24,'enable'),(NULL,0,'2019-11-29 22:13:05',NULL,2659,283,29,'ZJ'),(NULL,0,'2019-11-29 22:13:05',NULL,2660,283,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:05',NULL,2661,283,11,'pycook'),(NULL,0,'2019-11-29 22:13:05',NULL,2662,283,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:05',NULL,2663,283,15,'10.2.6.6'),(NULL,0,'2019-11-29 22:13:05',NULL,2664,283,5,'3789c1870be740d6819bfd6c2b9ddae6'),(NULL,0,'2019-11-29 22:13:05',NULL,2665,283,17,'online'),(NULL,0,'2019-11-29 22:13:06',NULL,2666,284,16,'cmdb1-2-6-7'),(NULL,0,'2019-11-29 22:13:06',NULL,2667,284,28,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,2668,284,24,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,2669,284,29,'ZJ'),(NULL,0,'2019-11-29 22:13:06',NULL,2670,284,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,2671,284,11,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,2672,284,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,2673,284,15,'10.2.6.7'),(NULL,0,'2019-11-29 22:13:06',NULL,2674,284,5,'ce5f40cae7c54bd9aa2840316e340dc4'),(NULL,0,'2019-11-29 22:13:06',NULL,2675,284,17,'online'),(NULL,0,'2019-11-29 22:13:06',NULL,2676,285,16,'cmdb1-2-6-8'),(NULL,0,'2019-11-29 22:13:06',NULL,2677,285,28,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,2678,285,24,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,2679,285,29,'ZJ'),(NULL,0,'2019-11-29 22:13:06',NULL,2680,285,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,2681,285,11,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,2682,285,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,2683,285,15,'10.2.6.8'),(NULL,0,'2019-11-29 22:13:06',NULL,2684,285,5,'05f2911cefa849efb661da4266044c8b'),(NULL,0,'2019-11-29 22:13:06',NULL,2685,285,17,'online'),(NULL,0,'2019-11-29 22:13:06',NULL,2686,286,16,'cmdb1-2-6-9'),(NULL,0,'2019-11-29 22:13:06',NULL,2687,286,28,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,2688,286,24,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,2689,286,29,'ZJ'),(NULL,0,'2019-11-29 22:13:06',NULL,2690,286,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,2691,286,11,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,2692,286,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,2693,286,15,'10.2.6.9'),(NULL,0,'2019-11-29 22:13:06',NULL,2694,286,5,'a9efead21b48458e9730086656058b12'),(NULL,0,'2019-11-29 22:13:06',NULL,2695,286,17,'online'),(NULL,0,'2019-11-29 22:13:06',NULL,2696,287,16,'cmdb1-2-6-10'),(NULL,0,'2019-11-29 22:13:06',NULL,2697,287,28,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,2698,287,24,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,2699,287,29,'ZJ'),(NULL,0,'2019-11-29 22:13:06',NULL,2700,287,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:06',NULL,2701,287,11,'pycook'),(NULL,0,'2019-11-29 22:13:06',NULL,2702,287,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:06',NULL,2703,287,15,'10.2.6.10'),(NULL,0,'2019-11-29 22:13:06',NULL,2704,287,5,'e3e654edf9224649a7ef4145d4563fdd'),(NULL,0,'2019-11-29 22:13:06',NULL,2705,287,17,'online'),(NULL,0,'2019-11-29 22:13:06',NULL,2706,288,16,'cmdb1-2-6-11'),(NULL,0,'2019-11-29 22:13:06',NULL,2707,288,28,'prod'),(NULL,0,'2019-11-29 22:13:06',NULL,2708,288,24,'enable'),(NULL,0,'2019-11-29 22:13:06',NULL,2709,288,29,'ZJ'),(NULL,0,'2019-11-29 22:13:07',NULL,2710,288,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,2711,288,11,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,2712,288,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,2713,288,15,'10.2.6.11'),(NULL,0,'2019-11-29 22:13:07',NULL,2714,288,5,'c1be81e35a0643489432633322615bdf'),(NULL,0,'2019-11-29 22:13:07',NULL,2715,288,17,'online'),(NULL,0,'2019-11-29 22:13:07',NULL,2716,289,16,'cmdb1-2-6-12'),(NULL,0,'2019-11-29 22:13:07',NULL,2717,289,28,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,2718,289,24,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,2719,289,29,'ZJ'),(NULL,0,'2019-11-29 22:13:07',NULL,2720,289,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,2721,289,11,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,2722,289,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,2723,289,15,'10.2.6.12'),(NULL,0,'2019-11-29 22:13:07',NULL,2724,289,5,'7c90d42e09a640b0b09feff524938eaa'),(NULL,0,'2019-11-29 22:13:07',NULL,2725,289,17,'online'),(NULL,0,'2019-11-29 22:13:07',NULL,2726,290,16,'cmdb1-2-6-13'),(NULL,0,'2019-11-29 22:13:07',NULL,2727,290,28,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,2728,290,24,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,2729,290,29,'ZJ'),(NULL,0,'2019-11-29 22:13:07',NULL,2730,290,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,2731,290,11,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,2732,290,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,2733,290,15,'10.2.6.13'),(NULL,0,'2019-11-29 22:13:07',NULL,2734,290,5,'e291ce403c084a0f8016153d0e2f793c'),(NULL,0,'2019-11-29 22:13:07',NULL,2735,290,17,'online'),(NULL,0,'2019-11-29 22:13:07',NULL,2736,291,16,'cmdb1-2-6-14'),(NULL,0,'2019-11-29 22:13:07',NULL,2737,291,28,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,2738,291,24,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,2739,291,29,'ZJ'),(NULL,0,'2019-11-29 22:13:07',NULL,2740,291,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,2741,291,11,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,2742,291,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,2743,291,15,'10.2.6.14'),(NULL,0,'2019-11-29 22:13:07',NULL,2744,291,5,'d1a26bda7c1c402bbec3317affc46679'),(NULL,0,'2019-11-29 22:13:07',NULL,2745,291,17,'online'),(NULL,0,'2019-11-29 22:13:07',NULL,2746,292,16,'cmdb1-2-6-15'),(NULL,0,'2019-11-29 22:13:07',NULL,2747,292,28,'prod'),(NULL,0,'2019-11-29 22:13:07',NULL,2748,292,24,'enable'),(NULL,0,'2019-11-29 22:13:07',NULL,2749,292,29,'ZJ'),(NULL,0,'2019-11-29 22:13:07',NULL,2750,292,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:07',NULL,2751,292,11,'pycook'),(NULL,0,'2019-11-29 22:13:07',NULL,2752,292,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:07',NULL,2753,292,15,'10.2.6.15'),(NULL,0,'2019-11-29 22:13:07',NULL,2754,292,5,'016bc6ace6f44ba5987cc86af71b62d9'),(NULL,0,'2019-11-29 22:13:08',NULL,2755,292,17,'online'),(NULL,0,'2019-11-29 22:13:08',NULL,2756,293,16,'cmdb1-2-6-16'),(NULL,0,'2019-11-29 22:13:08',NULL,2757,293,28,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,2758,293,24,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,2759,293,29,'ZJ'),(NULL,0,'2019-11-29 22:13:08',NULL,2760,293,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,2761,293,11,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,2762,293,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,2763,293,15,'10.2.6.16'),(NULL,0,'2019-11-29 22:13:08',NULL,2764,293,5,'60c8b59019204ddf809b4cd077224cbe'),(NULL,0,'2019-11-29 22:13:08',NULL,2765,293,17,'online'),(NULL,0,'2019-11-29 22:13:08',NULL,2766,294,4,'App1-2-7'),(NULL,0,'2019-11-29 22:13:08',NULL,2767,295,16,'cmdb1-2-7-1'),(NULL,0,'2019-11-29 22:13:08',NULL,2768,295,28,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,2769,295,24,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,2770,295,29,'ZJ'),(NULL,0,'2019-11-29 22:13:08',NULL,2771,295,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,2772,295,11,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,2773,295,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,2774,295,15,'10.2.7.1'),(NULL,0,'2019-11-29 22:13:08',NULL,2775,295,5,'009524700ccf4e689a8ad2f59433452d'),(NULL,0,'2019-11-29 22:13:08',NULL,2776,295,17,'online'),(NULL,0,'2019-11-29 22:13:08',NULL,2777,296,16,'cmdb1-2-7-2'),(NULL,0,'2019-11-29 22:13:08',NULL,2778,296,28,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,2779,296,24,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,2780,296,29,'ZJ'),(NULL,0,'2019-11-29 22:13:08',NULL,2781,296,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,2782,296,11,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,2783,296,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,2784,296,15,'10.2.7.2'),(NULL,0,'2019-11-29 22:13:08',NULL,2785,296,5,'3c024fef992c47009b9fe41f579260c2'),(NULL,0,'2019-11-29 22:13:08',NULL,2786,296,17,'online'),(NULL,0,'2019-11-29 22:13:08',NULL,2787,297,16,'cmdb1-2-7-3'),(NULL,0,'2019-11-29 22:13:08',NULL,2788,297,28,'prod'),(NULL,0,'2019-11-29 22:13:08',NULL,2789,297,24,'enable'),(NULL,0,'2019-11-29 22:13:08',NULL,2790,297,29,'ZJ'),(NULL,0,'2019-11-29 22:13:08',NULL,2791,297,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:08',NULL,2792,297,11,'pycook'),(NULL,0,'2019-11-29 22:13:08',NULL,2793,297,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:08',NULL,2794,297,15,'10.2.7.3'),(NULL,0,'2019-11-29 22:13:08',NULL,2795,297,5,'838c3240b4874bf2a5db622a4fa3f8ca'),(NULL,0,'2019-11-29 22:13:08',NULL,2796,297,17,'online'),(NULL,0,'2019-11-29 22:13:09',NULL,2797,298,16,'cmdb1-2-7-4'),(NULL,0,'2019-11-29 22:13:09',NULL,2798,298,28,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,2799,298,24,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,2800,298,29,'ZJ'),(NULL,0,'2019-11-29 22:13:09',NULL,2801,298,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,2802,298,11,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,2803,298,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,2804,298,15,'10.2.7.4'),(NULL,0,'2019-11-29 22:13:09',NULL,2805,298,5,'dd11cd9fc77a43249854e6b894ff5382'),(NULL,0,'2019-11-29 22:13:09',NULL,2806,298,17,'online'),(NULL,0,'2019-11-29 22:13:09',NULL,2807,299,16,'cmdb1-2-7-5'),(NULL,0,'2019-11-29 22:13:09',NULL,2808,299,28,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,2809,299,24,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,2810,299,29,'ZJ'),(NULL,0,'2019-11-29 22:13:09',NULL,2811,299,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,2812,299,11,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,2813,299,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,2814,299,15,'10.2.7.5'),(NULL,0,'2019-11-29 22:13:09',NULL,2815,299,5,'4ae20c99ddbe41afa7a6853688cc4258'),(NULL,0,'2019-11-29 22:13:09',NULL,2816,299,17,'online'),(NULL,0,'2019-11-29 22:13:09',NULL,2817,300,16,'cmdb1-2-7-6'),(NULL,0,'2019-11-29 22:13:09',NULL,2818,300,28,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,2819,300,24,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,2820,300,29,'ZJ'),(NULL,0,'2019-11-29 22:13:09',NULL,2821,300,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,2822,300,11,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,2823,300,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,2824,300,15,'10.2.7.6'),(NULL,0,'2019-11-29 22:13:09',NULL,2825,300,5,'53a37c3a02854a7f8aef740502063a5b'),(NULL,0,'2019-11-29 22:13:09',NULL,2826,300,17,'online'),(NULL,0,'2019-11-29 22:13:09',NULL,2827,301,16,'cmdb1-2-7-7'),(NULL,0,'2019-11-29 22:13:09',NULL,2828,301,28,'prod'),(NULL,0,'2019-11-29 22:13:09',NULL,2829,301,24,'enable'),(NULL,0,'2019-11-29 22:13:09',NULL,2830,301,29,'ZJ'),(NULL,0,'2019-11-29 22:13:09',NULL,2831,301,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:09',NULL,2832,301,11,'pycook'),(NULL,0,'2019-11-29 22:13:09',NULL,2833,301,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:09',NULL,2834,301,15,'10.2.7.7'),(NULL,0,'2019-11-29 22:13:09',NULL,2835,301,5,'29018eee86a84181b123240c2bad7963'),(NULL,0,'2019-11-29 22:13:09',NULL,2836,301,17,'online'),(NULL,0,'2019-11-29 22:13:09',NULL,2837,302,16,'cmdb1-2-7-8'),(NULL,0,'2019-11-29 22:13:10',NULL,2838,302,28,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,2839,302,24,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,2840,302,29,'ZJ'),(NULL,0,'2019-11-29 22:13:10',NULL,2841,302,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,2842,302,11,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,2843,302,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,2844,302,15,'10.2.7.8'),(NULL,0,'2019-11-29 22:13:10',NULL,2845,302,5,'7c5319eacb2d43fd9fd26dff6e5f8f62'),(NULL,0,'2019-11-29 22:13:10',NULL,2846,302,17,'online'),(NULL,0,'2019-11-29 22:13:10',NULL,2847,303,16,'cmdb1-2-7-9'),(NULL,0,'2019-11-29 22:13:10',NULL,2848,303,28,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,2849,303,24,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,2850,303,29,'ZJ'),(NULL,0,'2019-11-29 22:13:10',NULL,2851,303,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,2852,303,11,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,2853,303,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,2854,303,15,'10.2.7.9'),(NULL,0,'2019-11-29 22:13:10',NULL,2855,303,5,'8b8eb8bbbd9d43c5ab50fc40aaf421a6'),(NULL,0,'2019-11-29 22:13:10',NULL,2856,303,17,'online'),(NULL,0,'2019-11-29 22:13:10',NULL,2857,304,16,'cmdb1-2-7-10'),(NULL,0,'2019-11-29 22:13:10',NULL,2858,304,28,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,2859,304,24,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,2860,304,29,'ZJ'),(NULL,0,'2019-11-29 22:13:10',NULL,2861,304,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,2862,304,11,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,2863,304,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,2864,304,15,'10.2.7.10'),(NULL,0,'2019-11-29 22:13:10',NULL,2865,304,5,'1697c3d5d84449e1bd27c46a70048ad2'),(NULL,0,'2019-11-29 22:13:10',NULL,2866,304,17,'online'),(NULL,0,'2019-11-29 22:13:10',NULL,2867,305,16,'cmdb1-2-7-11'),(NULL,0,'2019-11-29 22:13:10',NULL,2868,305,28,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,2869,305,24,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,2870,305,29,'ZJ'),(NULL,0,'2019-11-29 22:13:10',NULL,2871,305,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,2872,305,11,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,2873,305,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,2874,305,15,'10.2.7.11'),(NULL,0,'2019-11-29 22:13:10',NULL,2875,305,5,'17bdcbd8d4214a57a910c2fb6e10701a'),(NULL,0,'2019-11-29 22:13:10',NULL,2876,305,17,'online'),(NULL,0,'2019-11-29 22:13:10',NULL,2877,306,16,'cmdb1-2-7-12'),(NULL,0,'2019-11-29 22:13:10',NULL,2878,306,28,'prod'),(NULL,0,'2019-11-29 22:13:10',NULL,2879,306,24,'enable'),(NULL,0,'2019-11-29 22:13:10',NULL,2880,306,29,'ZJ'),(NULL,0,'2019-11-29 22:13:10',NULL,2881,306,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:10',NULL,2882,306,11,'pycook'),(NULL,0,'2019-11-29 22:13:10',NULL,2883,306,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:10',NULL,2884,306,15,'10.2.7.12'),(NULL,0,'2019-11-29 22:13:11',NULL,2885,306,5,'95b8cd29aeed417fb46156c24606c84d'),(NULL,0,'2019-11-29 22:13:11',NULL,2886,306,17,'online'),(NULL,0,'2019-11-29 22:13:11',NULL,2887,307,16,'cmdb1-2-7-13'),(NULL,0,'2019-11-29 22:13:11',NULL,2888,307,28,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,2889,307,24,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,2890,307,29,'ZJ'),(NULL,0,'2019-11-29 22:13:11',NULL,2891,307,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,2892,307,11,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,2893,307,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,2894,307,15,'10.2.7.13'),(NULL,0,'2019-11-29 22:13:11',NULL,2895,307,5,'89e45af8e2a743548d24282a7d6094b6'),(NULL,0,'2019-11-29 22:13:11',NULL,2896,307,17,'online'),(NULL,0,'2019-11-29 22:13:11',NULL,2897,308,16,'cmdb1-2-7-14'),(NULL,0,'2019-11-29 22:13:11',NULL,2898,308,28,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,2899,308,24,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,2900,308,29,'ZJ'),(NULL,0,'2019-11-29 22:13:11',NULL,2901,308,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,2902,308,11,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,2903,308,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,2904,308,15,'10.2.7.14'),(NULL,0,'2019-11-29 22:13:11',NULL,2905,308,5,'eea1201d8993428c8198f4ddc1548d4d'),(NULL,0,'2019-11-29 22:13:11',NULL,2906,308,17,'online'),(NULL,0,'2019-11-29 22:13:11',NULL,2907,309,16,'cmdb1-2-7-15'),(NULL,0,'2019-11-29 22:13:11',NULL,2908,309,28,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,2909,309,24,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,2910,309,29,'ZJ'),(NULL,0,'2019-11-29 22:13:11',NULL,2911,309,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,2912,309,11,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,2913,309,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,2914,309,15,'10.2.7.15'),(NULL,0,'2019-11-29 22:13:11',NULL,2915,309,5,'6ebed311427c4f3b81f88f00ad2c819d'),(NULL,0,'2019-11-29 22:13:11',NULL,2916,309,17,'online'),(NULL,0,'2019-11-29 22:13:11',NULL,2917,310,16,'cmdb1-2-7-16'),(NULL,0,'2019-11-29 22:13:11',NULL,2918,310,28,'prod'),(NULL,0,'2019-11-29 22:13:11',NULL,2919,310,24,'enable'),(NULL,0,'2019-11-29 22:13:11',NULL,2920,310,29,'ZJ'),(NULL,0,'2019-11-29 22:13:11',NULL,2921,310,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:11',NULL,2922,310,11,'pycook'),(NULL,0,'2019-11-29 22:13:11',NULL,2923,310,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:11',NULL,2924,310,15,'10.2.7.16'),(NULL,0,'2019-11-29 22:13:11',NULL,2925,310,5,'f942f46d14834c4b9ec167eb601efcf6'),(NULL,0,'2019-11-29 22:13:11',NULL,2926,310,17,'online'),(NULL,0,'2019-11-29 22:13:12',NULL,2927,311,4,'App1-2-8'),(NULL,0,'2019-11-29 22:13:12',NULL,2928,312,16,'cmdb1-2-8-1'),(NULL,0,'2019-11-29 22:13:12',NULL,2929,312,28,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,2930,312,24,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,2931,312,29,'ZJ'),(NULL,0,'2019-11-29 22:13:12',NULL,2932,312,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,2933,312,11,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,2934,312,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,2935,312,15,'10.2.8.1'),(NULL,0,'2019-11-29 22:13:12',NULL,2936,312,5,'4aa34260e6e94534a520f669f1ba3611'),(NULL,0,'2019-11-29 22:13:12',NULL,2937,312,17,'online'),(NULL,0,'2019-11-29 22:13:12',NULL,2938,313,16,'cmdb1-2-8-2'),(NULL,0,'2019-11-29 22:13:12',NULL,2939,313,28,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,2940,313,24,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,2941,313,29,'ZJ'),(NULL,0,'2019-11-29 22:13:12',NULL,2942,313,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,2943,313,11,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,2944,313,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,2945,313,15,'10.2.8.2'),(NULL,0,'2019-11-29 22:13:12',NULL,2946,313,5,'1f6a433483474b29a900af5523ea7707'),(NULL,0,'2019-11-29 22:13:12',NULL,2947,313,17,'online'),(NULL,0,'2019-11-29 22:13:12',NULL,2948,314,16,'cmdb1-2-8-3'),(NULL,0,'2019-11-29 22:13:12',NULL,2949,314,28,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,2950,314,24,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,2951,314,29,'ZJ'),(NULL,0,'2019-11-29 22:13:12',NULL,2952,314,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,2953,314,11,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,2954,314,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,2955,314,15,'10.2.8.3'),(NULL,0,'2019-11-29 22:13:12',NULL,2956,314,5,'89dc0a1c2f1f4125a00170bd777ca1cc'),(NULL,0,'2019-11-29 22:13:12',NULL,2957,314,17,'online'),(NULL,0,'2019-11-29 22:13:12',NULL,2958,315,16,'cmdb1-2-8-4'),(NULL,0,'2019-11-29 22:13:12',NULL,2959,315,28,'prod'),(NULL,0,'2019-11-29 22:13:12',NULL,2960,315,24,'enable'),(NULL,0,'2019-11-29 22:13:12',NULL,2961,315,29,'ZJ'),(NULL,0,'2019-11-29 22:13:12',NULL,2962,315,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:12',NULL,2963,315,11,'pycook'),(NULL,0,'2019-11-29 22:13:12',NULL,2964,315,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:12',NULL,2965,315,15,'10.2.8.4'),(NULL,0,'2019-11-29 22:13:12',NULL,2966,315,5,'b42fbe8991744bb1a8a4a9110c20f644'),(NULL,0,'2019-11-29 22:13:12',NULL,2967,315,17,'online'),(NULL,0,'2019-11-29 22:13:13',NULL,2968,316,16,'cmdb1-2-8-5'),(NULL,0,'2019-11-29 22:13:13',NULL,2969,316,28,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,2970,316,24,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,2971,316,29,'ZJ'),(NULL,0,'2019-11-29 22:13:13',NULL,2972,316,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,2973,316,11,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,2974,316,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,2975,316,15,'10.2.8.5'),(NULL,0,'2019-11-29 22:13:13',NULL,2976,316,5,'0a154a1ed9174c1db1965c012e31b6e9'),(NULL,0,'2019-11-29 22:13:13',NULL,2977,316,17,'online'),(NULL,0,'2019-11-29 22:13:13',NULL,2978,317,16,'cmdb1-2-8-6'),(NULL,0,'2019-11-29 22:13:13',NULL,2979,317,28,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,2980,317,24,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,2981,317,29,'ZJ'),(NULL,0,'2019-11-29 22:13:13',NULL,2982,317,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,2983,317,11,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,2984,317,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,2985,317,15,'10.2.8.6'),(NULL,0,'2019-11-29 22:13:13',NULL,2986,317,5,'ecb4f2a555664b01bacfccd8f0d135a5'),(NULL,0,'2019-11-29 22:13:13',NULL,2987,317,17,'online'),(NULL,0,'2019-11-29 22:13:13',NULL,2988,318,16,'cmdb1-2-8-7'),(NULL,0,'2019-11-29 22:13:13',NULL,2989,318,28,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,2990,318,24,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,2991,318,29,'ZJ'),(NULL,0,'2019-11-29 22:13:13',NULL,2992,318,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,2993,318,11,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,2994,318,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,2995,318,15,'10.2.8.7'),(NULL,0,'2019-11-29 22:13:13',NULL,2996,318,5,'9e0f8426ae264ae096b1eec539e994ea'),(NULL,0,'2019-11-29 22:13:13',NULL,2997,318,17,'online'),(NULL,0,'2019-11-29 22:13:13',NULL,2998,319,16,'cmdb1-2-8-8'),(NULL,0,'2019-11-29 22:13:13',NULL,2999,319,28,'prod'),(NULL,0,'2019-11-29 22:13:13',NULL,3000,319,24,'enable'),(NULL,0,'2019-11-29 22:13:13',NULL,3001,319,29,'ZJ'),(NULL,0,'2019-11-29 22:13:13',NULL,3002,319,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:13',NULL,3003,319,11,'pycook'),(NULL,0,'2019-11-29 22:13:13',NULL,3004,319,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:13',NULL,3005,319,15,'10.2.8.8'),(NULL,0,'2019-11-29 22:13:13',NULL,3006,319,5,'f21200a1fb134831b6a30ccc62dcbcb8'),(NULL,0,'2019-11-29 22:13:13',NULL,3007,319,17,'online'),(NULL,0,'2019-11-29 22:13:13',NULL,3008,320,16,'cmdb1-2-8-9'),(NULL,0,'2019-11-29 22:13:13',NULL,3009,320,28,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3010,320,24,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3011,320,29,'ZJ'),(NULL,0,'2019-11-29 22:13:14',NULL,3012,320,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3013,320,11,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3014,320,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3015,320,15,'10.2.8.9'),(NULL,0,'2019-11-29 22:13:14',NULL,3016,320,5,'6b1e0416a8064ff5acf20c829fe8a7c0'),(NULL,0,'2019-11-29 22:13:14',NULL,3017,320,17,'online'),(NULL,0,'2019-11-29 22:13:14',NULL,3018,321,16,'cmdb1-2-8-10'),(NULL,0,'2019-11-29 22:13:14',NULL,3019,321,28,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3020,321,24,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3021,321,29,'ZJ'),(NULL,0,'2019-11-29 22:13:14',NULL,3022,321,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3023,321,11,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3024,321,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3025,321,15,'10.2.8.10'),(NULL,0,'2019-11-29 22:13:14',NULL,3026,321,5,'831596be2da84f87a34c864e4fd4056c'),(NULL,0,'2019-11-29 22:13:14',NULL,3027,321,17,'online'),(NULL,0,'2019-11-29 22:13:14',NULL,3028,322,16,'cmdb1-2-8-11'),(NULL,0,'2019-11-29 22:13:14',NULL,3029,322,28,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3030,322,24,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3031,322,29,'ZJ'),(NULL,0,'2019-11-29 22:13:14',NULL,3032,322,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3033,322,11,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3034,322,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3035,322,15,'10.2.8.11'),(NULL,0,'2019-11-29 22:13:14',NULL,3036,322,5,'e6dee890f1b1473a9374117450c609f0'),(NULL,0,'2019-11-29 22:13:14',NULL,3037,322,17,'online'),(NULL,0,'2019-11-29 22:13:14',NULL,3038,323,16,'cmdb1-2-8-12'),(NULL,0,'2019-11-29 22:13:14',NULL,3039,323,28,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3040,323,24,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3041,323,29,'ZJ'),(NULL,0,'2019-11-29 22:13:14',NULL,3042,323,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3043,323,11,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3044,323,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3045,323,15,'10.2.8.12'),(NULL,0,'2019-11-29 22:13:14',NULL,3046,323,5,'a0b10eafe4ba4806a68477c58eff73ec'),(NULL,0,'2019-11-29 22:13:14',NULL,3047,323,17,'online'),(NULL,0,'2019-11-29 22:13:14',NULL,3048,324,16,'cmdb1-2-8-13'),(NULL,0,'2019-11-29 22:13:14',NULL,3049,324,28,'prod'),(NULL,0,'2019-11-29 22:13:14',NULL,3050,324,24,'enable'),(NULL,0,'2019-11-29 22:13:14',NULL,3051,324,29,'ZJ'),(NULL,0,'2019-11-29 22:13:14',NULL,3052,324,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:14',NULL,3053,324,11,'pycook'),(NULL,0,'2019-11-29 22:13:14',NULL,3054,324,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:14',NULL,3055,324,15,'10.2.8.13'),(NULL,0,'2019-11-29 22:13:15',NULL,3056,324,5,'bf345d003f8a479785cd25bd9761c7f6'),(NULL,0,'2019-11-29 22:13:15',NULL,3057,324,17,'online'),(NULL,0,'2019-11-29 22:13:15',NULL,3058,325,16,'cmdb1-2-8-14'),(NULL,0,'2019-11-29 22:13:15',NULL,3059,325,28,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3060,325,24,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3061,325,29,'ZJ'),(NULL,0,'2019-11-29 22:13:15',NULL,3062,325,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3063,325,11,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3064,325,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3065,325,15,'10.2.8.14'),(NULL,0,'2019-11-29 22:13:15',NULL,3066,325,5,'6665b45a24bb455bbd75a668d29c07ad'),(NULL,0,'2019-11-29 22:13:15',NULL,3067,325,17,'online'),(NULL,0,'2019-11-29 22:13:15',NULL,3068,326,16,'cmdb1-2-8-15'),(NULL,0,'2019-11-29 22:13:15',NULL,3069,326,28,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3070,326,24,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3071,326,29,'ZJ'),(NULL,0,'2019-11-29 22:13:15',NULL,3072,326,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3073,326,11,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3074,326,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3075,326,15,'10.2.8.15'),(NULL,0,'2019-11-29 22:13:15',NULL,3076,326,5,'6fc0d020978a416f9e85010c43a1f0b3'),(NULL,0,'2019-11-29 22:13:15',NULL,3077,326,17,'online'),(NULL,0,'2019-11-29 22:13:15',NULL,3078,327,16,'cmdb1-2-8-16'),(NULL,0,'2019-11-29 22:13:15',NULL,3079,327,28,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3080,327,24,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3081,327,29,'ZJ'),(NULL,0,'2019-11-29 22:13:15',NULL,3082,327,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:15',NULL,3083,327,11,'pycook'),(NULL,0,'2019-11-29 22:13:15',NULL,3084,327,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:15',NULL,3085,327,15,'10.2.8.16'),(NULL,0,'2019-11-29 22:13:15',NULL,3086,327,5,'ff13aa4242da486b9e77d0c8445306a8'),(NULL,0,'2019-11-29 22:13:15',NULL,3087,327,17,'online'),(NULL,0,'2019-11-29 22:13:15',NULL,3088,328,3,'Product1-3'),(NULL,0,'2019-11-29 22:13:15',NULL,3089,329,4,'App1-3-1'),(NULL,0,'2019-11-29 22:13:15',NULL,3090,330,16,'cmdb1-3-1-1'),(NULL,0,'2019-11-29 22:13:15',NULL,3091,330,28,'prod'),(NULL,0,'2019-11-29 22:13:15',NULL,3092,330,24,'enable'),(NULL,0,'2019-11-29 22:13:15',NULL,3093,330,29,'ZJ'),(NULL,0,'2019-11-29 22:13:15',NULL,3094,330,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3095,330,11,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3096,330,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3097,330,15,'10.3.1.1'),(NULL,0,'2019-11-29 22:13:16',NULL,3098,330,5,'b63a3416587e4487b8ee9a8056c26fa8'),(NULL,0,'2019-11-29 22:13:16',NULL,3099,330,17,'online'),(NULL,0,'2019-11-29 22:13:16',NULL,3100,331,16,'cmdb1-3-1-2'),(NULL,0,'2019-11-29 22:13:16',NULL,3101,331,28,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3102,331,24,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3103,331,29,'ZJ'),(NULL,0,'2019-11-29 22:13:16',NULL,3104,331,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3105,331,11,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3106,331,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3107,331,15,'10.3.1.2'),(NULL,0,'2019-11-29 22:13:16',NULL,3108,331,5,'469a9209d749411ead1daa3e60b456c9'),(NULL,0,'2019-11-29 22:13:16',NULL,3109,331,17,'online'),(NULL,0,'2019-11-29 22:13:16',NULL,3110,332,16,'cmdb1-3-1-3'),(NULL,0,'2019-11-29 22:13:16',NULL,3111,332,28,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3112,332,24,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3113,332,29,'ZJ'),(NULL,0,'2019-11-29 22:13:16',NULL,3114,332,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3115,332,11,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3116,332,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3117,332,15,'10.3.1.3'),(NULL,0,'2019-11-29 22:13:16',NULL,3118,332,5,'f579f9dc1fb443a2b0849ea81e19b56d'),(NULL,0,'2019-11-29 22:13:16',NULL,3119,332,17,'online'),(NULL,0,'2019-11-29 22:13:16',NULL,3120,333,16,'cmdb1-3-1-4'),(NULL,0,'2019-11-29 22:13:16',NULL,3121,333,28,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3122,333,24,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3123,333,29,'ZJ'),(NULL,0,'2019-11-29 22:13:16',NULL,3124,333,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3125,333,11,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3126,333,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3127,333,15,'10.3.1.4'),(NULL,0,'2019-11-29 22:13:16',NULL,3128,333,5,'4b22e6ed919d4306acf4aa225e4d650e'),(NULL,0,'2019-11-29 22:13:16',NULL,3129,333,17,'online'),(NULL,0,'2019-11-29 22:13:16',NULL,3130,334,16,'cmdb1-3-1-5'),(NULL,0,'2019-11-29 22:13:16',NULL,3131,334,28,'prod'),(NULL,0,'2019-11-29 22:13:16',NULL,3132,334,24,'enable'),(NULL,0,'2019-11-29 22:13:16',NULL,3133,334,29,'ZJ'),(NULL,0,'2019-11-29 22:13:16',NULL,3134,334,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:16',NULL,3135,334,11,'pycook'),(NULL,0,'2019-11-29 22:13:16',NULL,3136,334,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:16',NULL,3137,334,15,'10.3.1.5'),(NULL,0,'2019-11-29 22:13:16',NULL,3138,334,5,'1a1d8e0296624901bc6337178146b7dc'),(NULL,0,'2019-11-29 22:13:16',NULL,3139,334,17,'online'),(NULL,0,'2019-11-29 22:13:17',NULL,3140,335,16,'cmdb1-3-1-6'),(NULL,0,'2019-11-29 22:13:17',NULL,3141,335,28,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3142,335,24,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3143,335,29,'ZJ'),(NULL,0,'2019-11-29 22:13:17',NULL,3144,335,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3145,335,11,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3146,335,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3147,335,15,'10.3.1.6'),(NULL,0,'2019-11-29 22:13:17',NULL,3148,335,5,'71020fa1bb604d4d99f1adaad2305bc8'),(NULL,0,'2019-11-29 22:13:17',NULL,3149,335,17,'online'),(NULL,0,'2019-11-29 22:13:17',NULL,3150,336,16,'cmdb1-3-1-7'),(NULL,0,'2019-11-29 22:13:17',NULL,3151,336,28,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3152,336,24,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3153,336,29,'ZJ'),(NULL,0,'2019-11-29 22:13:17',NULL,3154,336,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3155,336,11,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3156,336,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3157,336,15,'10.3.1.7'),(NULL,0,'2019-11-29 22:13:17',NULL,3158,336,5,'9583ce53991245ee938dee87252bc12e'),(NULL,0,'2019-11-29 22:13:17',NULL,3159,336,17,'online'),(NULL,0,'2019-11-29 22:13:17',NULL,3160,337,16,'cmdb1-3-1-8'),(NULL,0,'2019-11-29 22:13:17',NULL,3161,337,28,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3162,337,24,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3163,337,29,'ZJ'),(NULL,0,'2019-11-29 22:13:17',NULL,3164,337,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3165,337,11,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3166,337,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3167,337,15,'10.3.1.8'),(NULL,0,'2019-11-29 22:13:17',NULL,3168,337,5,'4d215f68627b4e778e88cece7a735ef7'),(NULL,0,'2019-11-29 22:13:17',NULL,3169,337,17,'online'),(NULL,0,'2019-11-29 22:13:17',NULL,3170,338,16,'cmdb1-3-1-9'),(NULL,0,'2019-11-29 22:13:17',NULL,3171,338,28,'prod'),(NULL,0,'2019-11-29 22:13:17',NULL,3172,338,24,'enable'),(NULL,0,'2019-11-29 22:13:17',NULL,3173,338,29,'ZJ'),(NULL,0,'2019-11-29 22:13:17',NULL,3174,338,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:17',NULL,3175,338,11,'pycook'),(NULL,0,'2019-11-29 22:13:17',NULL,3176,338,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:17',NULL,3177,338,15,'10.3.1.9'),(NULL,0,'2019-11-29 22:13:17',NULL,3178,338,5,'28122034789940e59bc1511e2e757763'),(NULL,0,'2019-11-29 22:13:17',NULL,3179,338,17,'online'),(NULL,0,'2019-11-29 22:13:17',NULL,3180,339,16,'cmdb1-3-1-10'),(NULL,0,'2019-11-29 22:13:18',NULL,3181,339,28,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,3182,339,24,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,3183,339,29,'ZJ'),(NULL,0,'2019-11-29 22:13:18',NULL,3184,339,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,3185,339,11,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,3186,339,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,3187,339,15,'10.3.1.10'),(NULL,0,'2019-11-29 22:13:18',NULL,3188,339,5,'5ed7fe3638434a19af7d89cbee7ca3f2'),(NULL,0,'2019-11-29 22:13:18',NULL,3189,339,17,'online'),(NULL,0,'2019-11-29 22:13:18',NULL,3190,340,16,'cmdb1-3-1-11'),(NULL,0,'2019-11-29 22:13:18',NULL,3191,340,28,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,3192,340,24,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,3193,340,29,'ZJ'),(NULL,0,'2019-11-29 22:13:18',NULL,3194,340,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,3195,340,11,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,3196,340,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,3197,340,15,'10.3.1.11'),(NULL,0,'2019-11-29 22:13:18',NULL,3198,340,5,'6d8df46d68374bc3bbda3bded7a2afe2'),(NULL,0,'2019-11-29 22:13:18',NULL,3199,340,17,'online'),(NULL,0,'2019-11-29 22:13:18',NULL,3200,341,16,'cmdb1-3-1-12'),(NULL,0,'2019-11-29 22:13:18',NULL,3201,341,28,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,3202,341,24,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,3203,341,29,'ZJ'),(NULL,0,'2019-11-29 22:13:18',NULL,3204,341,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,3205,341,11,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,3206,341,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,3207,341,15,'10.3.1.12'),(NULL,0,'2019-11-29 22:13:18',NULL,3208,341,5,'96cd64a33c7f45ff9c04531e6446cabd'),(NULL,0,'2019-11-29 22:13:18',NULL,3209,341,17,'online'),(NULL,0,'2019-11-29 22:13:18',NULL,3210,342,16,'cmdb1-3-1-13'),(NULL,0,'2019-11-29 22:13:18',NULL,3211,342,28,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,3212,342,24,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,3213,342,29,'ZJ'),(NULL,0,'2019-11-29 22:13:18',NULL,3214,342,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,3215,342,11,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,3216,342,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:18',NULL,3217,342,15,'10.3.1.13'),(NULL,0,'2019-11-29 22:13:18',NULL,3218,342,5,'bc49010d859f4a26a633c7987ce1a74c'),(NULL,0,'2019-11-29 22:13:18',NULL,3219,342,17,'online'),(NULL,0,'2019-11-29 22:13:18',NULL,3220,343,16,'cmdb1-3-1-14'),(NULL,0,'2019-11-29 22:13:18',NULL,3221,343,28,'prod'),(NULL,0,'2019-11-29 22:13:18',NULL,3222,343,24,'enable'),(NULL,0,'2019-11-29 22:13:18',NULL,3223,343,29,'ZJ'),(NULL,0,'2019-11-29 22:13:18',NULL,3224,343,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:18',NULL,3225,343,11,'pycook'),(NULL,0,'2019-11-29 22:13:18',NULL,3226,343,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,3227,343,15,'10.3.1.14'),(NULL,0,'2019-11-29 22:13:19',NULL,3228,343,5,'852cd74ca426459ab03558ded22e6a24'),(NULL,0,'2019-11-29 22:13:19',NULL,3229,343,17,'online'),(NULL,0,'2019-11-29 22:13:19',NULL,3230,344,16,'cmdb1-3-1-15'),(NULL,0,'2019-11-29 22:13:19',NULL,3231,344,28,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,3232,344,24,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,3233,344,29,'ZJ'),(NULL,0,'2019-11-29 22:13:19',NULL,3234,344,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,3235,344,11,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,3236,344,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,3237,344,15,'10.3.1.15'),(NULL,0,'2019-11-29 22:13:19',NULL,3238,344,5,'1068f097b23d448e8fd82fd986acbcad'),(NULL,0,'2019-11-29 22:13:19',NULL,3239,344,17,'online'),(NULL,0,'2019-11-29 22:13:19',NULL,3240,345,16,'cmdb1-3-1-16'),(NULL,0,'2019-11-29 22:13:19',NULL,3241,345,28,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,3242,345,24,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,3243,345,29,'ZJ'),(NULL,0,'2019-11-29 22:13:19',NULL,3244,345,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,3245,345,11,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,3246,345,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,3247,345,15,'10.3.1.16'),(NULL,0,'2019-11-29 22:13:19',NULL,3248,345,5,'97c0172fa28b4f20bd33afac65631a39'),(NULL,0,'2019-11-29 22:13:19',NULL,3249,345,17,'online'),(NULL,0,'2019-11-29 22:13:19',NULL,3250,346,4,'App1-3-2'),(NULL,0,'2019-11-29 22:13:19',NULL,3251,347,16,'cmdb1-3-2-1'),(NULL,0,'2019-11-29 22:13:19',NULL,3252,347,28,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,3253,347,24,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,3254,347,29,'ZJ'),(NULL,0,'2019-11-29 22:13:19',NULL,3255,347,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,3256,347,11,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,3257,347,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,3258,347,15,'10.3.2.1'),(NULL,0,'2019-11-29 22:13:19',NULL,3259,347,5,'08ddd16f1e9b4d28a884153fb303d525'),(NULL,0,'2019-11-29 22:13:19',NULL,3260,347,17,'online'),(NULL,0,'2019-11-29 22:13:19',NULL,3261,348,16,'cmdb1-3-2-2'),(NULL,0,'2019-11-29 22:13:19',NULL,3262,348,28,'prod'),(NULL,0,'2019-11-29 22:13:19',NULL,3263,348,24,'enable'),(NULL,0,'2019-11-29 22:13:19',NULL,3264,348,29,'ZJ'),(NULL,0,'2019-11-29 22:13:19',NULL,3265,348,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:19',NULL,3266,348,11,'pycook'),(NULL,0,'2019-11-29 22:13:19',NULL,3267,348,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:19',NULL,3268,348,15,'10.3.2.2'),(NULL,0,'2019-11-29 22:13:20',NULL,3269,348,5,'44077d060a3140a2a64fabfc8fbc297c'),(NULL,0,'2019-11-29 22:13:20',NULL,3270,348,17,'online'),(NULL,0,'2019-11-29 22:13:20',NULL,3271,349,16,'cmdb1-3-2-3'),(NULL,0,'2019-11-29 22:13:20',NULL,3272,349,28,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,3273,349,24,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,3274,349,29,'ZJ'),(NULL,0,'2019-11-29 22:13:20',NULL,3275,349,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,3276,349,11,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,3277,349,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,3278,349,15,'10.3.2.3'),(NULL,0,'2019-11-29 22:13:20',NULL,3279,349,5,'d3af8b79f67e4b1889a1f7afe0ad8d36'),(NULL,0,'2019-11-29 22:13:20',NULL,3280,349,17,'online'),(NULL,0,'2019-11-29 22:13:20',NULL,3281,350,16,'cmdb1-3-2-4'),(NULL,0,'2019-11-29 22:13:20',NULL,3282,350,28,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,3283,350,24,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,3284,350,29,'ZJ'),(NULL,0,'2019-11-29 22:13:20',NULL,3285,350,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,3286,350,11,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,3287,350,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,3288,350,15,'10.3.2.4'),(NULL,0,'2019-11-29 22:13:20',NULL,3289,350,5,'5e548a19ac1e4b8fb325556faf32bb5e'),(NULL,0,'2019-11-29 22:13:20',NULL,3290,350,17,'online'),(NULL,0,'2019-11-29 22:13:20',NULL,3291,351,16,'cmdb1-3-2-5'),(NULL,0,'2019-11-29 22:13:20',NULL,3292,351,28,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,3293,351,24,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,3294,351,29,'ZJ'),(NULL,0,'2019-11-29 22:13:20',NULL,3295,351,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,3296,351,11,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,3297,351,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,3298,351,15,'10.3.2.5'),(NULL,0,'2019-11-29 22:13:20',NULL,3299,351,5,'64f0b8348315425189f046f92522f054'),(NULL,0,'2019-11-29 22:13:20',NULL,3300,351,17,'online'),(NULL,0,'2019-11-29 22:13:20',NULL,3301,352,16,'cmdb1-3-2-6'),(NULL,0,'2019-11-29 22:13:20',NULL,3302,352,28,'prod'),(NULL,0,'2019-11-29 22:13:20',NULL,3303,352,24,'enable'),(NULL,0,'2019-11-29 22:13:20',NULL,3304,352,29,'ZJ'),(NULL,0,'2019-11-29 22:13:20',NULL,3305,352,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:20',NULL,3306,352,11,'pycook'),(NULL,0,'2019-11-29 22:13:20',NULL,3307,352,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:20',NULL,3308,352,15,'10.3.2.6'),(NULL,0,'2019-11-29 22:13:20',NULL,3309,352,5,'285da03c3d0e42c685a332959401d949'),(NULL,0,'2019-11-29 22:13:20',NULL,3310,352,17,'online'),(NULL,0,'2019-11-29 22:13:21',NULL,3311,353,16,'cmdb1-3-2-7'),(NULL,0,'2019-11-29 22:13:21',NULL,3312,353,28,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,3313,353,24,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,3314,353,29,'ZJ'),(NULL,0,'2019-11-29 22:13:21',NULL,3315,353,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,3316,353,11,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,3317,353,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,3318,353,15,'10.3.2.7'),(NULL,0,'2019-11-29 22:13:21',NULL,3319,353,5,'7b870224c52444e3bdd10e20a1cda063'),(NULL,0,'2019-11-29 22:13:21',NULL,3320,353,17,'online'),(NULL,0,'2019-11-29 22:13:21',NULL,3321,354,16,'cmdb1-3-2-8'),(NULL,0,'2019-11-29 22:13:21',NULL,3322,354,28,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,3323,354,24,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,3324,354,29,'ZJ'),(NULL,0,'2019-11-29 22:13:21',NULL,3325,354,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,3326,354,11,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,3327,354,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,3328,354,15,'10.3.2.8'),(NULL,0,'2019-11-29 22:13:21',NULL,3329,354,5,'90cc258dc0d54454ab75ee150cbe3940'),(NULL,0,'2019-11-29 22:13:21',NULL,3330,354,17,'online'),(NULL,0,'2019-11-29 22:13:21',NULL,3331,355,16,'cmdb1-3-2-9'),(NULL,0,'2019-11-29 22:13:21',NULL,3332,355,28,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,3333,355,24,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,3334,355,29,'ZJ'),(NULL,0,'2019-11-29 22:13:21',NULL,3335,355,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,3336,355,11,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,3337,355,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,3338,355,15,'10.3.2.9'),(NULL,0,'2019-11-29 22:13:21',NULL,3339,355,5,'b069775983ad4fc5b5b5d930f77fe58d'),(NULL,0,'2019-11-29 22:13:21',NULL,3340,355,17,'online'),(NULL,0,'2019-11-29 22:13:21',NULL,3341,356,16,'cmdb1-3-2-10'),(NULL,0,'2019-11-29 22:13:21',NULL,3342,356,28,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,3343,356,24,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,3344,356,29,'ZJ'),(NULL,0,'2019-11-29 22:13:21',NULL,3345,356,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:21',NULL,3346,356,11,'pycook'),(NULL,0,'2019-11-29 22:13:21',NULL,3347,356,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:21',NULL,3348,356,15,'10.3.2.10'),(NULL,0,'2019-11-29 22:13:21',NULL,3349,356,5,'e55bf4a27e114b8a801479d3ee794d98'),(NULL,0,'2019-11-29 22:13:21',NULL,3350,356,17,'online'),(NULL,0,'2019-11-29 22:13:21',NULL,3351,357,16,'cmdb1-3-2-11'),(NULL,0,'2019-11-29 22:13:21',NULL,3352,357,28,'prod'),(NULL,0,'2019-11-29 22:13:21',NULL,3353,357,24,'enable'),(NULL,0,'2019-11-29 22:13:21',NULL,3354,357,29,'ZJ'),(NULL,0,'2019-11-29 22:13:22',NULL,3355,357,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,3356,357,11,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,3357,357,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,3358,357,15,'10.3.2.11'),(NULL,0,'2019-11-29 22:13:22',NULL,3359,357,5,'14433921d60a4aee825e832c04ec1ea2'),(NULL,0,'2019-11-29 22:13:22',NULL,3360,357,17,'online'),(NULL,0,'2019-11-29 22:13:22',NULL,3361,358,16,'cmdb1-3-2-12'),(NULL,0,'2019-11-29 22:13:22',NULL,3362,358,28,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,3363,358,24,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,3364,358,29,'ZJ'),(NULL,0,'2019-11-29 22:13:22',NULL,3365,358,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,3366,358,11,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,3367,358,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,3368,358,15,'10.3.2.12'),(NULL,0,'2019-11-29 22:13:22',NULL,3369,358,5,'05c03df6ff4543e3af4aee82e5d9d18c'),(NULL,0,'2019-11-29 22:13:22',NULL,3370,358,17,'online'),(NULL,0,'2019-11-29 22:13:22',NULL,3371,359,16,'cmdb1-3-2-13'),(NULL,0,'2019-11-29 22:13:22',NULL,3372,359,28,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,3373,359,24,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,3374,359,29,'ZJ'),(NULL,0,'2019-11-29 22:13:22',NULL,3375,359,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,3376,359,11,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,3377,359,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,3378,359,15,'10.3.2.13'),(NULL,0,'2019-11-29 22:13:22',NULL,3379,359,5,'9d1d4cdfa0be49338636bb248d2f19e1'),(NULL,0,'2019-11-29 22:13:22',NULL,3380,359,17,'online'),(NULL,0,'2019-11-29 22:13:22',NULL,3381,360,16,'cmdb1-3-2-14'),(NULL,0,'2019-11-29 22:13:22',NULL,3382,360,28,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,3383,360,24,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,3384,360,29,'ZJ'),(NULL,0,'2019-11-29 22:13:22',NULL,3385,360,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,3386,360,11,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,3387,360,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,3388,360,15,'10.3.2.14'),(NULL,0,'2019-11-29 22:13:22',NULL,3389,360,5,'08569f12e6e146d2b7b31a4be5130b18'),(NULL,0,'2019-11-29 22:13:22',NULL,3390,360,17,'online'),(NULL,0,'2019-11-29 22:13:22',NULL,3391,361,16,'cmdb1-3-2-15'),(NULL,0,'2019-11-29 22:13:22',NULL,3392,361,28,'prod'),(NULL,0,'2019-11-29 22:13:22',NULL,3393,361,24,'enable'),(NULL,0,'2019-11-29 22:13:22',NULL,3394,361,29,'ZJ'),(NULL,0,'2019-11-29 22:13:22',NULL,3395,361,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:22',NULL,3396,361,11,'pycook'),(NULL,0,'2019-11-29 22:13:22',NULL,3397,361,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:22',NULL,3398,361,15,'10.3.2.15'),(NULL,0,'2019-11-29 22:13:23',NULL,3399,361,5,'a67a96496b5d47ae8a12285408a82b00'),(NULL,0,'2019-11-29 22:13:23',NULL,3400,361,17,'online'),(NULL,0,'2019-11-29 22:13:23',NULL,3401,362,16,'cmdb1-3-2-16'),(NULL,0,'2019-11-29 22:13:23',NULL,3402,362,28,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,3403,362,24,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,3404,362,29,'ZJ'),(NULL,0,'2019-11-29 22:13:23',NULL,3405,362,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,3406,362,11,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,3407,362,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,3408,362,15,'10.3.2.16'),(NULL,0,'2019-11-29 22:13:23',NULL,3409,362,5,'00bac21c49024549835c7aadd2d6a93e'),(NULL,0,'2019-11-29 22:13:23',NULL,3410,362,17,'online'),(NULL,0,'2019-11-29 22:13:23',NULL,3411,363,4,'App1-3-3'),(NULL,0,'2019-11-29 22:13:23',NULL,3412,364,16,'cmdb1-3-3-1'),(NULL,0,'2019-11-29 22:13:23',NULL,3413,364,28,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,3414,364,24,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,3415,364,29,'ZJ'),(NULL,0,'2019-11-29 22:13:23',NULL,3416,364,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,3417,364,11,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,3418,364,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,3419,364,15,'10.3.3.1'),(NULL,0,'2019-11-29 22:13:23',NULL,3420,364,5,'1429014f80d649bb83da55087d91fd7f'),(NULL,0,'2019-11-29 22:13:23',NULL,3421,364,17,'online'),(NULL,0,'2019-11-29 22:13:23',NULL,3422,365,16,'cmdb1-3-3-2'),(NULL,0,'2019-11-29 22:13:23',NULL,3423,365,28,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,3424,365,24,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,3425,365,29,'ZJ'),(NULL,0,'2019-11-29 22:13:23',NULL,3426,365,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,3427,365,11,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,3428,365,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,3429,365,15,'10.3.3.2'),(NULL,0,'2019-11-29 22:13:23',NULL,3430,365,5,'1342d41830f0426299b1051697658394'),(NULL,0,'2019-11-29 22:13:23',NULL,3431,365,17,'online'),(NULL,0,'2019-11-29 22:13:23',NULL,3432,366,16,'cmdb1-3-3-3'),(NULL,0,'2019-11-29 22:13:23',NULL,3433,366,28,'prod'),(NULL,0,'2019-11-29 22:13:23',NULL,3434,366,24,'enable'),(NULL,0,'2019-11-29 22:13:23',NULL,3435,366,29,'ZJ'),(NULL,0,'2019-11-29 22:13:23',NULL,3436,366,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:23',NULL,3437,366,11,'pycook'),(NULL,0,'2019-11-29 22:13:23',NULL,3438,366,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:23',NULL,3439,366,15,'10.3.3.3'),(NULL,0,'2019-11-29 22:13:23',NULL,3440,366,5,'c3fba6ff0b3d430e95fd0aa2119d8284'),(NULL,0,'2019-11-29 22:13:24',NULL,3441,366,17,'online'),(NULL,0,'2019-11-29 22:13:24',NULL,3442,367,16,'cmdb1-3-3-4'),(NULL,0,'2019-11-29 22:13:24',NULL,3443,367,28,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,3444,367,24,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,3445,367,29,'ZJ'),(NULL,0,'2019-11-29 22:13:24',NULL,3446,367,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,3447,367,11,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,3448,367,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,3449,367,15,'10.3.3.4'),(NULL,0,'2019-11-29 22:13:24',NULL,3450,367,5,'54b43cb8d6d64d5e8b74f4956adfcb87'),(NULL,0,'2019-11-29 22:13:24',NULL,3451,367,17,'online'),(NULL,0,'2019-11-29 22:13:24',NULL,3452,368,16,'cmdb1-3-3-5'),(NULL,0,'2019-11-29 22:13:24',NULL,3453,368,28,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,3454,368,24,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,3455,368,29,'ZJ'),(NULL,0,'2019-11-29 22:13:24',NULL,3456,368,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,3457,368,11,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,3458,368,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,3459,368,15,'10.3.3.5'),(NULL,0,'2019-11-29 22:13:24',NULL,3460,368,5,'b3720a1fff1b4ef3b597467fd7eeadfa'),(NULL,0,'2019-11-29 22:13:24',NULL,3461,368,17,'online'),(NULL,0,'2019-11-29 22:13:24',NULL,3462,369,16,'cmdb1-3-3-6'),(NULL,0,'2019-11-29 22:13:24',NULL,3463,369,28,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,3464,369,24,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,3465,369,29,'ZJ'),(NULL,0,'2019-11-29 22:13:24',NULL,3466,369,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,3467,369,11,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,3468,369,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,3469,369,15,'10.3.3.6'),(NULL,0,'2019-11-29 22:13:24',NULL,3470,369,5,'50dea25ecece4b4a8bc01cd0d387a956'),(NULL,0,'2019-11-29 22:13:24',NULL,3471,369,17,'online'),(NULL,0,'2019-11-29 22:13:24',NULL,3472,370,16,'cmdb1-3-3-7'),(NULL,0,'2019-11-29 22:13:24',NULL,3473,370,28,'prod'),(NULL,0,'2019-11-29 22:13:24',NULL,3474,370,24,'enable'),(NULL,0,'2019-11-29 22:13:24',NULL,3475,370,29,'ZJ'),(NULL,0,'2019-11-29 22:13:24',NULL,3476,370,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:24',NULL,3477,370,11,'pycook'),(NULL,0,'2019-11-29 22:13:24',NULL,3478,370,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:24',NULL,3479,370,15,'10.3.3.7'),(NULL,0,'2019-11-29 22:13:24',NULL,3480,370,5,'7b1b3c45cffe4d39bd29afb9c8c1ac1f'),(NULL,0,'2019-11-29 22:13:24',NULL,3481,370,17,'online'),(NULL,0,'2019-11-29 22:13:24',NULL,3482,371,16,'cmdb1-3-3-8'),(NULL,0,'2019-11-29 22:13:25',NULL,3483,371,28,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,3484,371,24,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,3485,371,29,'ZJ'),(NULL,0,'2019-11-29 22:13:25',NULL,3486,371,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,3487,371,11,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,3488,371,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,3489,371,15,'10.3.3.8'),(NULL,0,'2019-11-29 22:13:25',NULL,3490,371,5,'a0da7b8fd31f4cea903130720800223a'),(NULL,0,'2019-11-29 22:13:25',NULL,3491,371,17,'online'),(NULL,0,'2019-11-29 22:13:25',NULL,3492,372,16,'cmdb1-3-3-9'),(NULL,0,'2019-11-29 22:13:25',NULL,3493,372,28,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,3494,372,24,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,3495,372,29,'ZJ'),(NULL,0,'2019-11-29 22:13:25',NULL,3496,372,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,3497,372,11,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,3498,372,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,3499,372,15,'10.3.3.9'),(NULL,0,'2019-11-29 22:13:25',NULL,3500,372,5,'c43bec26c31941f78fb7f49c47853002'),(NULL,0,'2019-11-29 22:13:25',NULL,3501,372,17,'online'),(NULL,0,'2019-11-29 22:13:25',NULL,3502,373,16,'cmdb1-3-3-10'),(NULL,0,'2019-11-29 22:13:25',NULL,3503,373,28,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,3504,373,24,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,3505,373,29,'ZJ'),(NULL,0,'2019-11-29 22:13:25',NULL,3506,373,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,3507,373,11,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,3508,373,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,3509,373,15,'10.3.3.10'),(NULL,0,'2019-11-29 22:13:25',NULL,3510,373,5,'6e2301755fdb4013b9a5595a4cd73f40'),(NULL,0,'2019-11-29 22:13:25',NULL,3511,373,17,'online'),(NULL,0,'2019-11-29 22:13:25',NULL,3512,374,16,'cmdb1-3-3-11'),(NULL,0,'2019-11-29 22:13:25',NULL,3513,374,28,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,3514,374,24,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,3515,374,29,'ZJ'),(NULL,0,'2019-11-29 22:13:25',NULL,3516,374,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:25',NULL,3517,374,11,'pycook'),(NULL,0,'2019-11-29 22:13:25',NULL,3518,374,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:25',NULL,3519,374,15,'10.3.3.11'),(NULL,0,'2019-11-29 22:13:25',NULL,3520,374,5,'b7cfe9bc55ce41c2b5b030f984160852'),(NULL,0,'2019-11-29 22:13:25',NULL,3521,374,17,'online'),(NULL,0,'2019-11-29 22:13:25',NULL,3522,375,16,'cmdb1-3-3-12'),(NULL,0,'2019-11-29 22:13:25',NULL,3523,375,28,'prod'),(NULL,0,'2019-11-29 22:13:25',NULL,3524,375,24,'enable'),(NULL,0,'2019-11-29 22:13:25',NULL,3525,375,29,'ZJ'),(NULL,0,'2019-11-29 22:13:25',NULL,3526,375,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,3527,375,11,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,3528,375,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,3529,375,15,'10.3.3.12'),(NULL,0,'2019-11-29 22:13:26',NULL,3530,375,5,'32e18385f3c24e9183818b463cb62951'),(NULL,0,'2019-11-29 22:13:26',NULL,3531,375,17,'online'),(NULL,0,'2019-11-29 22:13:26',NULL,3532,376,16,'cmdb1-3-3-13'),(NULL,0,'2019-11-29 22:13:26',NULL,3533,376,28,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,3534,376,24,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,3535,376,29,'ZJ'),(NULL,0,'2019-11-29 22:13:26',NULL,3536,376,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,3537,376,11,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,3538,376,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,3539,376,15,'10.3.3.13'),(NULL,0,'2019-11-29 22:13:26',NULL,3540,376,5,'dd28195fba604e788a405b71985327bc'),(NULL,0,'2019-11-29 22:13:26',NULL,3541,376,17,'online'),(NULL,0,'2019-11-29 22:13:26',NULL,3542,377,16,'cmdb1-3-3-14'),(NULL,0,'2019-11-29 22:13:26',NULL,3543,377,28,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,3544,377,24,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,3545,377,29,'ZJ'),(NULL,0,'2019-11-29 22:13:26',NULL,3546,377,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,3547,377,11,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,3548,377,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,3549,377,15,'10.3.3.14'),(NULL,0,'2019-11-29 22:13:26',NULL,3550,377,5,'52e06fd49b344d4bbad67c0b8c2c511c'),(NULL,0,'2019-11-29 22:13:26',NULL,3551,377,17,'online'),(NULL,0,'2019-11-29 22:13:26',NULL,3552,378,16,'cmdb1-3-3-15'),(NULL,0,'2019-11-29 22:13:26',NULL,3553,378,28,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,3554,378,24,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,3555,378,29,'ZJ'),(NULL,0,'2019-11-29 22:13:26',NULL,3556,378,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,3557,378,11,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,3558,378,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,3559,378,15,'10.3.3.15'),(NULL,0,'2019-11-29 22:13:26',NULL,3560,378,5,'a20aaa68996344cc9565b2afec65bf81'),(NULL,0,'2019-11-29 22:13:26',NULL,3561,378,17,'online'),(NULL,0,'2019-11-29 22:13:26',NULL,3562,379,16,'cmdb1-3-3-16'),(NULL,0,'2019-11-29 22:13:26',NULL,3563,379,28,'prod'),(NULL,0,'2019-11-29 22:13:26',NULL,3564,379,24,'enable'),(NULL,0,'2019-11-29 22:13:26',NULL,3565,379,29,'ZJ'),(NULL,0,'2019-11-29 22:13:26',NULL,3566,379,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:26',NULL,3567,379,11,'pycook'),(NULL,0,'2019-11-29 22:13:26',NULL,3568,379,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:26',NULL,3569,379,15,'10.3.3.16'),(NULL,0,'2019-11-29 22:13:26',NULL,3570,379,5,'3cbf6c98d356474593887fc9b55c139e'),(NULL,0,'2019-11-29 22:13:26',NULL,3571,379,17,'online'),(NULL,0,'2019-11-29 22:13:27',NULL,3572,380,4,'App1-3-4'),(NULL,0,'2019-11-29 22:13:27',NULL,3573,381,16,'cmdb1-3-4-1'),(NULL,0,'2019-11-29 22:13:27',NULL,3574,381,28,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,3575,381,24,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,3576,381,29,'ZJ'),(NULL,0,'2019-11-29 22:13:27',NULL,3577,381,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,3578,381,11,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,3579,381,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,3580,381,15,'10.3.4.1'),(NULL,0,'2019-11-29 22:13:27',NULL,3581,381,5,'f543a268cd704013b7d3bb003f48c857'),(NULL,0,'2019-11-29 22:13:27',NULL,3582,381,17,'online'),(NULL,0,'2019-11-29 22:13:27',NULL,3583,382,16,'cmdb1-3-4-2'),(NULL,0,'2019-11-29 22:13:27',NULL,3584,382,28,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,3585,382,24,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,3586,382,29,'ZJ'),(NULL,0,'2019-11-29 22:13:27',NULL,3587,382,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,3588,382,11,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,3589,382,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,3590,382,15,'10.3.4.2'),(NULL,0,'2019-11-29 22:13:27',NULL,3591,382,5,'b5bb7d85644c494f9003fe09b6d9a0fd'),(NULL,0,'2019-11-29 22:13:27',NULL,3592,382,17,'online'),(NULL,0,'2019-11-29 22:13:27',NULL,3593,383,16,'cmdb1-3-4-3'),(NULL,0,'2019-11-29 22:13:27',NULL,3594,383,28,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,3595,383,24,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,3596,383,29,'ZJ'),(NULL,0,'2019-11-29 22:13:27',NULL,3597,383,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,3598,383,11,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,3599,383,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,3600,383,15,'10.3.4.3'),(NULL,0,'2019-11-29 22:13:27',NULL,3601,383,5,'8d3daf978c294b6384a762634f317640'),(NULL,0,'2019-11-29 22:13:27',NULL,3602,383,17,'online'),(NULL,0,'2019-11-29 22:13:27',NULL,3603,384,16,'cmdb1-3-4-4'),(NULL,0,'2019-11-29 22:13:27',NULL,3604,384,28,'prod'),(NULL,0,'2019-11-29 22:13:27',NULL,3605,384,24,'enable'),(NULL,0,'2019-11-29 22:13:27',NULL,3606,384,29,'ZJ'),(NULL,0,'2019-11-29 22:13:27',NULL,3607,384,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:27',NULL,3608,384,11,'pycook'),(NULL,0,'2019-11-29 22:13:27',NULL,3609,384,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:27',NULL,3610,384,15,'10.3.4.4'),(NULL,0,'2019-11-29 22:13:27',NULL,3611,384,5,'b7724f4c8a9f4d978f74b85c4ab7f80e'),(NULL,0,'2019-11-29 22:13:27',NULL,3612,384,17,'online'),(NULL,0,'2019-11-29 22:13:28',NULL,3613,385,16,'cmdb1-3-4-5'),(NULL,0,'2019-11-29 22:13:28',NULL,3614,385,28,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,3615,385,24,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,3616,385,29,'ZJ'),(NULL,0,'2019-11-29 22:13:28',NULL,3617,385,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,3618,385,11,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,3619,385,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,3620,385,15,'10.3.4.5'),(NULL,0,'2019-11-29 22:13:28',NULL,3621,385,5,'1928ad1823504fd385304cf35231d2ac'),(NULL,0,'2019-11-29 22:13:28',NULL,3622,385,17,'online'),(NULL,0,'2019-11-29 22:13:28',NULL,3623,386,16,'cmdb1-3-4-6'),(NULL,0,'2019-11-29 22:13:28',NULL,3624,386,28,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,3625,386,24,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,3626,386,29,'ZJ'),(NULL,0,'2019-11-29 22:13:28',NULL,3627,386,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,3628,386,11,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,3629,386,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,3630,386,15,'10.3.4.6'),(NULL,0,'2019-11-29 22:13:28',NULL,3631,386,5,'8391a7845d424ed4b59d318111be0d7d'),(NULL,0,'2019-11-29 22:13:28',NULL,3632,386,17,'online'),(NULL,0,'2019-11-29 22:13:28',NULL,3633,387,16,'cmdb1-3-4-7'),(NULL,0,'2019-11-29 22:13:28',NULL,3634,387,28,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,3635,387,24,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,3636,387,29,'ZJ'),(NULL,0,'2019-11-29 22:13:28',NULL,3637,387,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,3638,387,11,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,3639,387,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,3640,387,15,'10.3.4.7'),(NULL,0,'2019-11-29 22:13:28',NULL,3641,387,5,'ef8eb47b7e384916b6bea88d2724f084'),(NULL,0,'2019-11-29 22:13:28',NULL,3642,387,17,'online'),(NULL,0,'2019-11-29 22:13:28',NULL,3643,388,16,'cmdb1-3-4-8'),(NULL,0,'2019-11-29 22:13:28',NULL,3644,388,28,'prod'),(NULL,0,'2019-11-29 22:13:28',NULL,3645,388,24,'enable'),(NULL,0,'2019-11-29 22:13:28',NULL,3646,388,29,'ZJ'),(NULL,0,'2019-11-29 22:13:28',NULL,3647,388,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:28',NULL,3648,388,11,'pycook'),(NULL,0,'2019-11-29 22:13:28',NULL,3649,388,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:28',NULL,3650,388,15,'10.3.4.8'),(NULL,0,'2019-11-29 22:13:28',NULL,3651,388,5,'4fb44e5453e2478f9c931a1275cee2a1'),(NULL,0,'2019-11-29 22:13:28',NULL,3652,388,17,'online'),(NULL,0,'2019-11-29 22:13:28',NULL,3653,389,16,'cmdb1-3-4-9'),(NULL,0,'2019-11-29 22:13:29',NULL,3654,389,28,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,3655,389,24,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,3656,389,29,'ZJ'),(NULL,0,'2019-11-29 22:13:29',NULL,3657,389,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,3658,389,11,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,3659,389,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,3660,389,15,'10.3.4.9'),(NULL,0,'2019-11-29 22:13:29',NULL,3661,389,5,'242da1291ba24b5aafea96d0cc58e233'),(NULL,0,'2019-11-29 22:13:29',NULL,3662,389,17,'online'),(NULL,0,'2019-11-29 22:13:29',NULL,3663,390,16,'cmdb1-3-4-10'),(NULL,0,'2019-11-29 22:13:29',NULL,3664,390,28,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,3665,390,24,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,3666,390,29,'ZJ'),(NULL,0,'2019-11-29 22:13:29',NULL,3667,390,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,3668,390,11,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,3669,390,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,3670,390,15,'10.3.4.10'),(NULL,0,'2019-11-29 22:13:29',NULL,3671,390,5,'94f3344570604e47a6bfc52b0e271b59'),(NULL,0,'2019-11-29 22:13:29',NULL,3672,390,17,'online'),(NULL,0,'2019-11-29 22:13:29',NULL,3673,391,16,'cmdb1-3-4-11'),(NULL,0,'2019-11-29 22:13:29',NULL,3674,391,28,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,3675,391,24,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,3676,391,29,'ZJ'),(NULL,0,'2019-11-29 22:13:29',NULL,3677,391,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,3678,391,11,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,3679,391,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,3680,391,15,'10.3.4.11'),(NULL,0,'2019-11-29 22:13:29',NULL,3681,391,5,'9489d645245c4f8f9c555c1977e3e38a'),(NULL,0,'2019-11-29 22:13:29',NULL,3682,391,17,'online'),(NULL,0,'2019-11-29 22:13:29',NULL,3683,392,16,'cmdb1-3-4-12'),(NULL,0,'2019-11-29 22:13:29',NULL,3684,392,28,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,3685,392,24,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,3686,392,29,'ZJ'),(NULL,0,'2019-11-29 22:13:29',NULL,3687,392,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,3688,392,11,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,3689,392,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:29',NULL,3690,392,15,'10.3.4.12'),(NULL,0,'2019-11-29 22:13:29',NULL,3691,392,5,'048c000293b545be96d70bbffbc91057'),(NULL,0,'2019-11-29 22:13:29',NULL,3692,392,17,'online'),(NULL,0,'2019-11-29 22:13:29',NULL,3693,393,16,'cmdb1-3-4-13'),(NULL,0,'2019-11-29 22:13:29',NULL,3694,393,28,'prod'),(NULL,0,'2019-11-29 22:13:29',NULL,3695,393,24,'enable'),(NULL,0,'2019-11-29 22:13:29',NULL,3696,393,29,'ZJ'),(NULL,0,'2019-11-29 22:13:29',NULL,3697,393,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:29',NULL,3698,393,11,'pycook'),(NULL,0,'2019-11-29 22:13:29',NULL,3699,393,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,3700,393,15,'10.3.4.13'),(NULL,0,'2019-11-29 22:13:30',NULL,3701,393,5,'9ea6549b62b246e39ae48fa216b342bc'),(NULL,0,'2019-11-29 22:13:30',NULL,3702,393,17,'online'),(NULL,0,'2019-11-29 22:13:30',NULL,3703,394,16,'cmdb1-3-4-14'),(NULL,0,'2019-11-29 22:13:30',NULL,3704,394,28,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,3705,394,24,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,3706,394,29,'ZJ'),(NULL,0,'2019-11-29 22:13:30',NULL,3707,394,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,3708,394,11,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,3709,394,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,3710,394,15,'10.3.4.14'),(NULL,0,'2019-11-29 22:13:30',NULL,3711,394,5,'83c0cd6f56b44a658ec65fc306afc46c'),(NULL,0,'2019-11-29 22:13:30',NULL,3712,394,17,'online'),(NULL,0,'2019-11-29 22:13:30',NULL,3713,395,16,'cmdb1-3-4-15'),(NULL,0,'2019-11-29 22:13:30',NULL,3714,395,28,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,3715,395,24,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,3716,395,29,'ZJ'),(NULL,0,'2019-11-29 22:13:30',NULL,3717,395,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,3718,395,11,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,3719,395,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,3720,395,15,'10.3.4.15'),(NULL,0,'2019-11-29 22:13:30',NULL,3721,395,5,'86cbd068d48446f9b45667b7cd261408'),(NULL,0,'2019-11-29 22:13:30',NULL,3722,395,17,'online'),(NULL,0,'2019-11-29 22:13:30',NULL,3723,396,16,'cmdb1-3-4-16'),(NULL,0,'2019-11-29 22:13:30',NULL,3724,396,28,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,3725,396,24,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,3726,396,29,'ZJ'),(NULL,0,'2019-11-29 22:13:30',NULL,3727,396,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,3728,396,11,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,3729,396,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,3730,396,15,'10.3.4.16'),(NULL,0,'2019-11-29 22:13:30',NULL,3731,396,5,'97fecc0f54504089b69929b65cfc41b8'),(NULL,0,'2019-11-29 22:13:30',NULL,3732,396,17,'online'),(NULL,0,'2019-11-29 22:13:30',NULL,3733,397,4,'App1-3-5'),(NULL,0,'2019-11-29 22:13:30',NULL,3734,398,16,'cmdb1-3-5-1'),(NULL,0,'2019-11-29 22:13:30',NULL,3735,398,28,'prod'),(NULL,0,'2019-11-29 22:13:30',NULL,3736,398,24,'enable'),(NULL,0,'2019-11-29 22:13:30',NULL,3737,398,29,'ZJ'),(NULL,0,'2019-11-29 22:13:30',NULL,3738,398,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:30',NULL,3739,398,11,'pycook'),(NULL,0,'2019-11-29 22:13:30',NULL,3740,398,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:30',NULL,3741,398,15,'10.3.5.1'),(NULL,0,'2019-11-29 22:13:31',NULL,3742,398,5,'412b23525d5547abafbdcfc49469a78b'),(NULL,0,'2019-11-29 22:13:31',NULL,3743,398,17,'online'),(NULL,0,'2019-11-29 22:13:31',NULL,3744,399,16,'cmdb1-3-5-2'),(NULL,0,'2019-11-29 22:13:31',NULL,3745,399,28,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,3746,399,24,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,3747,399,29,'ZJ'),(NULL,0,'2019-11-29 22:13:31',NULL,3748,399,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,3749,399,11,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,3750,399,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,3751,399,15,'10.3.5.2'),(NULL,0,'2019-11-29 22:13:31',NULL,3752,399,5,'6f5a55b6b2e04fd0b99e25c57332303b'),(NULL,0,'2019-11-29 22:13:31',NULL,3753,399,17,'online'),(NULL,0,'2019-11-29 22:13:31',NULL,3754,400,16,'cmdb1-3-5-3'),(NULL,0,'2019-11-29 22:13:31',NULL,3755,400,28,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,3756,400,24,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,3757,400,29,'ZJ'),(NULL,0,'2019-11-29 22:13:31',NULL,3758,400,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,3759,400,11,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,3760,400,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,3761,400,15,'10.3.5.3'),(NULL,0,'2019-11-29 22:13:31',NULL,3762,400,5,'fb291402278842359774b4813df682e6'),(NULL,0,'2019-11-29 22:13:31',NULL,3763,400,17,'online'),(NULL,0,'2019-11-29 22:13:31',NULL,3764,401,16,'cmdb1-3-5-4'),(NULL,0,'2019-11-29 22:13:31',NULL,3765,401,28,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,3766,401,24,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,3767,401,29,'ZJ'),(NULL,0,'2019-11-29 22:13:31',NULL,3768,401,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,3769,401,11,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,3770,401,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,3771,401,15,'10.3.5.4'),(NULL,0,'2019-11-29 22:13:31',NULL,3772,401,5,'27538d2410a844f1b2d770afd2749b35'),(NULL,0,'2019-11-29 22:13:31',NULL,3773,401,17,'online'),(NULL,0,'2019-11-29 22:13:31',NULL,3774,402,16,'cmdb1-3-5-5'),(NULL,0,'2019-11-29 22:13:31',NULL,3775,402,28,'prod'),(NULL,0,'2019-11-29 22:13:31',NULL,3776,402,24,'enable'),(NULL,0,'2019-11-29 22:13:31',NULL,3777,402,29,'ZJ'),(NULL,0,'2019-11-29 22:13:31',NULL,3778,402,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:31',NULL,3779,402,11,'pycook'),(NULL,0,'2019-11-29 22:13:31',NULL,3780,402,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:31',NULL,3781,402,15,'10.3.5.5'),(NULL,0,'2019-11-29 22:13:31',NULL,3782,402,5,'1d547eac7f1a4594afb5290ded225729'),(NULL,0,'2019-11-29 22:13:31',NULL,3783,402,17,'online'),(NULL,0,'2019-11-29 22:13:32',NULL,3784,403,16,'cmdb1-3-5-6'),(NULL,0,'2019-11-29 22:13:32',NULL,3785,403,28,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,3786,403,24,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,3787,403,29,'ZJ'),(NULL,0,'2019-11-29 22:13:32',NULL,3788,403,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,3789,403,11,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,3790,403,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,3791,403,15,'10.3.5.6'),(NULL,0,'2019-11-29 22:13:32',NULL,3792,403,5,'0db127de0cfb4f75b5010c7a3fa89128'),(NULL,0,'2019-11-29 22:13:32',NULL,3793,403,17,'online'),(NULL,0,'2019-11-29 22:13:32',NULL,3794,404,16,'cmdb1-3-5-7'),(NULL,0,'2019-11-29 22:13:32',NULL,3795,404,28,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,3796,404,24,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,3797,404,29,'ZJ'),(NULL,0,'2019-11-29 22:13:32',NULL,3798,404,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,3799,404,11,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,3800,404,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,3801,404,15,'10.3.5.7'),(NULL,0,'2019-11-29 22:13:32',NULL,3802,404,5,'dfbc3c70affd4802a19e491a2e97b3a6'),(NULL,0,'2019-11-29 22:13:32',NULL,3803,404,17,'online'),(NULL,0,'2019-11-29 22:13:32',NULL,3804,405,16,'cmdb1-3-5-8'),(NULL,0,'2019-11-29 22:13:32',NULL,3805,405,28,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,3806,405,24,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,3807,405,29,'ZJ'),(NULL,0,'2019-11-29 22:13:32',NULL,3808,405,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,3809,405,11,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,3810,405,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,3811,405,15,'10.3.5.8'),(NULL,0,'2019-11-29 22:13:32',NULL,3812,405,5,'36046716487c4ab98231a8f73885691e'),(NULL,0,'2019-11-29 22:13:32',NULL,3813,405,17,'online'),(NULL,0,'2019-11-29 22:13:32',NULL,3814,406,16,'cmdb1-3-5-9'),(NULL,0,'2019-11-29 22:13:32',NULL,3815,406,28,'prod'),(NULL,0,'2019-11-29 22:13:32',NULL,3816,406,24,'enable'),(NULL,0,'2019-11-29 22:13:32',NULL,3817,406,29,'ZJ'),(NULL,0,'2019-11-29 22:13:32',NULL,3818,406,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:32',NULL,3819,406,11,'pycook'),(NULL,0,'2019-11-29 22:13:32',NULL,3820,406,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:32',NULL,3821,406,15,'10.3.5.9'),(NULL,0,'2019-11-29 22:13:32',NULL,3822,406,5,'20b79be57dac45eb927c48362c116758'),(NULL,0,'2019-11-29 22:13:32',NULL,3823,406,17,'online'),(NULL,0,'2019-11-29 22:13:32',NULL,3824,407,16,'cmdb1-3-5-10'),(NULL,0,'2019-11-29 22:13:33',NULL,3825,407,28,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,3826,407,24,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,3827,407,29,'ZJ'),(NULL,0,'2019-11-29 22:13:33',NULL,3828,407,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,3829,407,11,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,3830,407,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,3831,407,15,'10.3.5.10'),(NULL,0,'2019-11-29 22:13:33',NULL,3832,407,5,'8691c0a0127742b5a212fba11ac70e7d'),(NULL,0,'2019-11-29 22:13:33',NULL,3833,407,17,'online'),(NULL,0,'2019-11-29 22:13:33',NULL,3834,408,16,'cmdb1-3-5-11'),(NULL,0,'2019-11-29 22:13:33',NULL,3835,408,28,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,3836,408,24,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,3837,408,29,'ZJ'),(NULL,0,'2019-11-29 22:13:33',NULL,3838,408,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,3839,408,11,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,3840,408,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,3841,408,15,'10.3.5.11'),(NULL,0,'2019-11-29 22:13:33',NULL,3842,408,5,'28865fead11648fc81f0acd2bfaa4942'),(NULL,0,'2019-11-29 22:13:33',NULL,3843,408,17,'online'),(NULL,0,'2019-11-29 22:13:33',NULL,3844,409,16,'cmdb1-3-5-12'),(NULL,0,'2019-11-29 22:13:33',NULL,3845,409,28,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,3846,409,24,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,3847,409,29,'ZJ'),(NULL,0,'2019-11-29 22:13:33',NULL,3848,409,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,3849,409,11,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,3850,409,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,3851,409,15,'10.3.5.12'),(NULL,0,'2019-11-29 22:13:33',NULL,3852,409,5,'bb2e990965b94908b6d095c68f17e692'),(NULL,0,'2019-11-29 22:13:33',NULL,3853,409,17,'online'),(NULL,0,'2019-11-29 22:13:33',NULL,3854,410,16,'cmdb1-3-5-13'),(NULL,0,'2019-11-29 22:13:33',NULL,3855,410,28,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,3856,410,24,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,3857,410,29,'ZJ'),(NULL,0,'2019-11-29 22:13:33',NULL,3858,410,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,3859,410,11,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,3860,410,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:33',NULL,3861,410,15,'10.3.5.13'),(NULL,0,'2019-11-29 22:13:33',NULL,3862,410,5,'96f2ffe945ce4fb1adfb343f21706923'),(NULL,0,'2019-11-29 22:13:33',NULL,3863,410,17,'online'),(NULL,0,'2019-11-29 22:13:33',NULL,3864,411,16,'cmdb1-3-5-14'),(NULL,0,'2019-11-29 22:13:33',NULL,3865,411,28,'prod'),(NULL,0,'2019-11-29 22:13:33',NULL,3866,411,24,'enable'),(NULL,0,'2019-11-29 22:13:33',NULL,3867,411,29,'ZJ'),(NULL,0,'2019-11-29 22:13:33',NULL,3868,411,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:33',NULL,3869,411,11,'pycook'),(NULL,0,'2019-11-29 22:13:33',NULL,3870,411,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,3871,411,15,'10.3.5.14'),(NULL,0,'2019-11-29 22:13:34',NULL,3872,411,5,'b255a192c6074b55bd6e217e0762b761'),(NULL,0,'2019-11-29 22:13:34',NULL,3873,411,17,'online'),(NULL,0,'2019-11-29 22:13:34',NULL,3874,412,16,'cmdb1-3-5-15'),(NULL,0,'2019-11-29 22:13:34',NULL,3875,412,28,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,3876,412,24,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,3877,412,29,'ZJ'),(NULL,0,'2019-11-29 22:13:34',NULL,3878,412,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,3879,412,11,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,3880,412,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,3881,412,15,'10.3.5.15'),(NULL,0,'2019-11-29 22:13:34',NULL,3882,412,5,'0cc0edaa4e5e4f7cac7dc1c7925f5f6f'),(NULL,0,'2019-11-29 22:13:34',NULL,3883,412,17,'online'),(NULL,0,'2019-11-29 22:13:34',NULL,3884,413,16,'cmdb1-3-5-16'),(NULL,0,'2019-11-29 22:13:34',NULL,3885,413,28,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,3886,413,24,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,3887,413,29,'ZJ'),(NULL,0,'2019-11-29 22:13:34',NULL,3888,413,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,3889,413,11,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,3890,413,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,3891,413,15,'10.3.5.16'),(NULL,0,'2019-11-29 22:13:34',NULL,3892,413,5,'7381cce7748c4c37982ef9b1eb22432b'),(NULL,0,'2019-11-29 22:13:34',NULL,3893,413,17,'online'),(NULL,0,'2019-11-29 22:13:34',NULL,3894,414,4,'App1-3-6'),(NULL,0,'2019-11-29 22:13:34',NULL,3895,415,16,'cmdb1-3-6-1'),(NULL,0,'2019-11-29 22:13:34',NULL,3896,415,28,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,3897,415,24,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,3898,415,29,'ZJ'),(NULL,0,'2019-11-29 22:13:34',NULL,3899,415,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:34',NULL,3900,415,11,'pycook'),(NULL,0,'2019-11-29 22:13:34',NULL,3901,415,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:34',NULL,3902,415,15,'10.3.6.1'),(NULL,0,'2019-11-29 22:13:34',NULL,3903,415,5,'a313edb64c724ff0ae7d65db72080ba7'),(NULL,0,'2019-11-29 22:13:34',NULL,3904,415,17,'online'),(NULL,0,'2019-11-29 22:13:34',NULL,3905,416,16,'cmdb1-3-6-2'),(NULL,0,'2019-11-29 22:13:34',NULL,3906,416,28,'prod'),(NULL,0,'2019-11-29 22:13:34',NULL,3907,416,24,'enable'),(NULL,0,'2019-11-29 22:13:34',NULL,3908,416,29,'ZJ'),(NULL,0,'2019-11-29 22:13:34',NULL,3909,416,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,3910,416,11,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,3911,416,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,3912,416,15,'10.3.6.2'),(NULL,0,'2019-11-29 22:13:35',NULL,3913,416,5,'d9d94f95e2c64eb3a5553fa7f30e813b'),(NULL,0,'2019-11-29 22:13:35',NULL,3914,416,17,'online'),(NULL,0,'2019-11-29 22:13:35',NULL,3915,417,16,'cmdb1-3-6-3'),(NULL,0,'2019-11-29 22:13:35',NULL,3916,417,28,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,3917,417,24,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,3918,417,29,'ZJ'),(NULL,0,'2019-11-29 22:13:35',NULL,3919,417,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,3920,417,11,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,3921,417,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,3922,417,15,'10.3.6.3'),(NULL,0,'2019-11-29 22:13:35',NULL,3923,417,5,'d9dd331139124a5180de7349e162a49a'),(NULL,0,'2019-11-29 22:13:35',NULL,3924,417,17,'online'),(NULL,0,'2019-11-29 22:13:35',NULL,3925,418,16,'cmdb1-3-6-4'),(NULL,0,'2019-11-29 22:13:35',NULL,3926,418,28,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,3927,418,24,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,3928,418,29,'ZJ'),(NULL,0,'2019-11-29 22:13:35',NULL,3929,418,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,3930,418,11,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,3931,418,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,3932,418,15,'10.3.6.4'),(NULL,0,'2019-11-29 22:13:35',NULL,3933,418,5,'a77a4b9c18264267b786c46794a370d2'),(NULL,0,'2019-11-29 22:13:35',NULL,3934,418,17,'online'),(NULL,0,'2019-11-29 22:13:35',NULL,3935,419,16,'cmdb1-3-6-5'),(NULL,0,'2019-11-29 22:13:35',NULL,3936,419,28,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,3937,419,24,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,3938,419,29,'ZJ'),(NULL,0,'2019-11-29 22:13:35',NULL,3939,419,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,3940,419,11,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,3941,419,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,3942,419,15,'10.3.6.5'),(NULL,0,'2019-11-29 22:13:35',NULL,3943,419,5,'8fe44d6eb808449f985ecfe5dfa70394'),(NULL,0,'2019-11-29 22:13:35',NULL,3944,419,17,'online'),(NULL,0,'2019-11-29 22:13:35',NULL,3945,420,16,'cmdb1-3-6-6'),(NULL,0,'2019-11-29 22:13:35',NULL,3946,420,28,'prod'),(NULL,0,'2019-11-29 22:13:35',NULL,3947,420,24,'enable'),(NULL,0,'2019-11-29 22:13:35',NULL,3948,420,29,'ZJ'),(NULL,0,'2019-11-29 22:13:35',NULL,3949,420,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:35',NULL,3950,420,11,'pycook'),(NULL,0,'2019-11-29 22:13:35',NULL,3951,420,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:35',NULL,3952,420,15,'10.3.6.6'),(NULL,0,'2019-11-29 22:13:35',NULL,3953,420,5,'53279c4c01e048e691b3d3258ffc8297'),(NULL,0,'2019-11-29 22:13:35',NULL,3954,420,17,'online'),(NULL,0,'2019-11-29 22:13:36',NULL,3955,421,16,'cmdb1-3-6-7'),(NULL,0,'2019-11-29 22:13:36',NULL,3956,421,28,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,3957,421,24,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,3958,421,29,'ZJ'),(NULL,0,'2019-11-29 22:13:36',NULL,3959,421,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,3960,421,11,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,3961,421,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,3962,421,15,'10.3.6.7'),(NULL,0,'2019-11-29 22:13:36',NULL,3963,421,5,'5d1e5d99a6fd4c14acb6f9a797b0e43f'),(NULL,0,'2019-11-29 22:13:36',NULL,3964,421,17,'online'),(NULL,0,'2019-11-29 22:13:36',NULL,3965,422,16,'cmdb1-3-6-8'),(NULL,0,'2019-11-29 22:13:36',NULL,3966,422,28,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,3967,422,24,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,3968,422,29,'ZJ'),(NULL,0,'2019-11-29 22:13:36',NULL,3969,422,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,3970,422,11,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,3971,422,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,3972,422,15,'10.3.6.8'),(NULL,0,'2019-11-29 22:13:36',NULL,3973,422,5,'8af81ddae88040518dd13ebd52e0c62a'),(NULL,0,'2019-11-29 22:13:36',NULL,3974,422,17,'online'),(NULL,0,'2019-11-29 22:13:36',NULL,3975,423,16,'cmdb1-3-6-9'),(NULL,0,'2019-11-29 22:13:36',NULL,3976,423,28,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,3977,423,24,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,3978,423,29,'ZJ'),(NULL,0,'2019-11-29 22:13:36',NULL,3979,423,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,3980,423,11,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,3981,423,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,3982,423,15,'10.3.6.9'),(NULL,0,'2019-11-29 22:13:36',NULL,3983,423,5,'141454a4568449e0b140b0ae3d5eace5'),(NULL,0,'2019-11-29 22:13:36',NULL,3984,423,17,'online'),(NULL,0,'2019-11-29 22:13:36',NULL,3985,424,16,'cmdb1-3-6-10'),(NULL,0,'2019-11-29 22:13:36',NULL,3986,424,28,'prod'),(NULL,0,'2019-11-29 22:13:36',NULL,3987,424,24,'enable'),(NULL,0,'2019-11-29 22:13:36',NULL,3988,424,29,'ZJ'),(NULL,0,'2019-11-29 22:13:36',NULL,3989,424,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:36',NULL,3990,424,11,'pycook'),(NULL,0,'2019-11-29 22:13:36',NULL,3991,424,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:36',NULL,3992,424,15,'10.3.6.10'),(NULL,0,'2019-11-29 22:13:36',NULL,3993,424,5,'a188720819d04a4b827537834662d5e4'),(NULL,0,'2019-11-29 22:13:36',NULL,3994,424,17,'online'),(NULL,0,'2019-11-29 22:13:36',NULL,3995,425,16,'cmdb1-3-6-11'),(NULL,0,'2019-11-29 22:13:37',NULL,3996,425,28,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,3997,425,24,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,3998,425,29,'ZJ'),(NULL,0,'2019-11-29 22:13:37',NULL,3999,425,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,4000,425,11,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,4001,425,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,4002,425,15,'10.3.6.11'),(NULL,0,'2019-11-29 22:13:37',NULL,4003,425,5,'4e1bf31d5b304d0dbcc709fd564899a7'),(NULL,0,'2019-11-29 22:13:37',NULL,4004,425,17,'online'),(NULL,0,'2019-11-29 22:13:37',NULL,4005,426,16,'cmdb1-3-6-12'),(NULL,0,'2019-11-29 22:13:37',NULL,4006,426,28,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,4007,426,24,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,4008,426,29,'ZJ'),(NULL,0,'2019-11-29 22:13:37',NULL,4009,426,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,4010,426,11,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,4011,426,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,4012,426,15,'10.3.6.12'),(NULL,0,'2019-11-29 22:13:37',NULL,4013,426,5,'9ff9d5ec1b564dcbbd8409b57487a5a7'),(NULL,0,'2019-11-29 22:13:37',NULL,4014,426,17,'online'),(NULL,0,'2019-11-29 22:13:37',NULL,4015,427,16,'cmdb1-3-6-13'),(NULL,0,'2019-11-29 22:13:37',NULL,4016,427,28,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,4017,427,24,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,4018,427,29,'ZJ'),(NULL,0,'2019-11-29 22:13:37',NULL,4019,427,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,4020,427,11,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,4021,427,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,4022,427,15,'10.3.6.13'),(NULL,0,'2019-11-29 22:13:37',NULL,4023,427,5,'fdeabc125d494ecfbc0ae71b95caf396'),(NULL,0,'2019-11-29 22:13:37',NULL,4024,427,17,'online'),(NULL,0,'2019-11-29 22:13:37',NULL,4025,428,16,'cmdb1-3-6-14'),(NULL,0,'2019-11-29 22:13:37',NULL,4026,428,28,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,4027,428,24,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,4028,428,29,'ZJ'),(NULL,0,'2019-11-29 22:13:37',NULL,4029,428,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,4030,428,11,'pycook'),(NULL,0,'2019-11-29 22:13:37',NULL,4031,428,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:37',NULL,4032,428,15,'10.3.6.14'),(NULL,0,'2019-11-29 22:13:37',NULL,4033,428,5,'a4169a0aeff549c985a9f45765bc512f'),(NULL,0,'2019-11-29 22:13:37',NULL,4034,428,17,'online'),(NULL,0,'2019-11-29 22:13:37',NULL,4035,429,16,'cmdb1-3-6-15'),(NULL,0,'2019-11-29 22:13:37',NULL,4036,429,28,'prod'),(NULL,0,'2019-11-29 22:13:37',NULL,4037,429,24,'enable'),(NULL,0,'2019-11-29 22:13:37',NULL,4038,429,29,'ZJ'),(NULL,0,'2019-11-29 22:13:37',NULL,4039,429,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:37',NULL,4040,429,11,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,4041,429,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,4042,429,15,'10.3.6.15'),(NULL,0,'2019-11-29 22:13:38',NULL,4043,429,5,'7b5e34cdc6b44b11b2c29457758dc709'),(NULL,0,'2019-11-29 22:13:38',NULL,4044,429,17,'online'),(NULL,0,'2019-11-29 22:13:38',NULL,4045,430,16,'cmdb1-3-6-16'),(NULL,0,'2019-11-29 22:13:38',NULL,4046,430,28,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,4047,430,24,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,4048,430,29,'ZJ'),(NULL,0,'2019-11-29 22:13:38',NULL,4049,430,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,4050,430,11,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,4051,430,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,4052,430,15,'10.3.6.16'),(NULL,0,'2019-11-29 22:13:38',NULL,4053,430,5,'3d8bd8c6e28c4daeb3d8b808cbbdd874'),(NULL,0,'2019-11-29 22:13:38',NULL,4054,430,17,'online'),(NULL,0,'2019-11-29 22:13:38',NULL,4055,431,4,'App1-3-7'),(NULL,0,'2019-11-29 22:13:38',NULL,4056,432,16,'cmdb1-3-7-1'),(NULL,0,'2019-11-29 22:13:38',NULL,4057,432,28,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,4058,432,24,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,4059,432,29,'ZJ'),(NULL,0,'2019-11-29 22:13:38',NULL,4060,432,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,4061,432,11,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,4062,432,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,4063,432,15,'10.3.7.1'),(NULL,0,'2019-11-29 22:13:38',NULL,4064,432,5,'c65cc0936b4e44babbf6b0d0c40cf6d1'),(NULL,0,'2019-11-29 22:13:38',NULL,4065,432,17,'online'),(NULL,0,'2019-11-29 22:13:38',NULL,4066,433,16,'cmdb1-3-7-2'),(NULL,0,'2019-11-29 22:13:38',NULL,4067,433,28,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,4068,433,24,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,4069,433,29,'ZJ'),(NULL,0,'2019-11-29 22:13:38',NULL,4070,433,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,4071,433,11,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,4072,433,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,4073,433,15,'10.3.7.2'),(NULL,0,'2019-11-29 22:13:38',NULL,4074,433,5,'37d73c01969f49a4b39922426283046d'),(NULL,0,'2019-11-29 22:13:38',NULL,4075,433,17,'online'),(NULL,0,'2019-11-29 22:13:38',NULL,4076,434,16,'cmdb1-3-7-3'),(NULL,0,'2019-11-29 22:13:38',NULL,4077,434,28,'prod'),(NULL,0,'2019-11-29 22:13:38',NULL,4078,434,24,'enable'),(NULL,0,'2019-11-29 22:13:38',NULL,4079,434,29,'ZJ'),(NULL,0,'2019-11-29 22:13:38',NULL,4080,434,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:38',NULL,4081,434,11,'pycook'),(NULL,0,'2019-11-29 22:13:38',NULL,4082,434,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:38',NULL,4083,434,15,'10.3.7.3'),(NULL,0,'2019-11-29 22:13:39',NULL,4084,434,5,'1d6b93eb8bb64b3cbf1edd4106b112ea'),(NULL,0,'2019-11-29 22:13:39',NULL,4085,434,17,'online'),(NULL,0,'2019-11-29 22:13:39',NULL,4086,435,16,'cmdb1-3-7-4'),(NULL,0,'2019-11-29 22:13:39',NULL,4087,435,28,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,4088,435,24,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,4089,435,29,'ZJ'),(NULL,0,'2019-11-29 22:13:39',NULL,4090,435,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,4091,435,11,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,4092,435,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,4093,435,15,'10.3.7.4'),(NULL,0,'2019-11-29 22:13:39',NULL,4094,435,5,'38488b97611341ebafa6341a064e6d60'),(NULL,0,'2019-11-29 22:13:39',NULL,4095,435,17,'online'),(NULL,0,'2019-11-29 22:13:39',NULL,4096,436,16,'cmdb1-3-7-5'),(NULL,0,'2019-11-29 22:13:39',NULL,4097,436,28,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,4098,436,24,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,4099,436,29,'ZJ'),(NULL,0,'2019-11-29 22:13:39',NULL,4100,436,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,4101,436,11,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,4102,436,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,4103,436,15,'10.3.7.5'),(NULL,0,'2019-11-29 22:13:39',NULL,4104,436,5,'abaeb04123994a10b2e9588ff990c43f'),(NULL,0,'2019-11-29 22:13:39',NULL,4105,436,17,'online'),(NULL,0,'2019-11-29 22:13:39',NULL,4106,437,16,'cmdb1-3-7-6'),(NULL,0,'2019-11-29 22:13:39',NULL,4107,437,28,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,4108,437,24,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,4109,437,29,'ZJ'),(NULL,0,'2019-11-29 22:13:39',NULL,4110,437,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,4111,437,11,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,4112,437,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,4113,437,15,'10.3.7.6'),(NULL,0,'2019-11-29 22:13:39',NULL,4114,437,5,'e6a96167ad1040bd98ac50a053839692'),(NULL,0,'2019-11-29 22:13:39',NULL,4115,437,17,'online'),(NULL,0,'2019-11-29 22:13:39',NULL,4116,438,16,'cmdb1-3-7-7'),(NULL,0,'2019-11-29 22:13:39',NULL,4117,438,28,'prod'),(NULL,0,'2019-11-29 22:13:39',NULL,4118,438,24,'enable'),(NULL,0,'2019-11-29 22:13:39',NULL,4119,438,29,'ZJ'),(NULL,0,'2019-11-29 22:13:39',NULL,4120,438,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:39',NULL,4121,438,11,'pycook'),(NULL,0,'2019-11-29 22:13:39',NULL,4122,438,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:39',NULL,4123,438,15,'10.3.7.7'),(NULL,0,'2019-11-29 22:13:39',NULL,4124,438,5,'d6eed198a1934dcbb6beee0092148ca1'),(NULL,0,'2019-11-29 22:13:39',NULL,4125,438,17,'online'),(NULL,0,'2019-11-29 22:13:40',NULL,4126,439,16,'cmdb1-3-7-8'),(NULL,0,'2019-11-29 22:13:40',NULL,4127,439,28,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,4128,439,24,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,4129,439,29,'ZJ'),(NULL,0,'2019-11-29 22:13:40',NULL,4130,439,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,4131,439,11,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,4132,439,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,4133,439,15,'10.3.7.8'),(NULL,0,'2019-11-29 22:13:40',NULL,4134,439,5,'395899d43f144ab39af654fa88d9b2aa'),(NULL,0,'2019-11-29 22:13:40',NULL,4135,439,17,'online'),(NULL,0,'2019-11-29 22:13:40',NULL,4136,440,16,'cmdb1-3-7-9'),(NULL,0,'2019-11-29 22:13:40',NULL,4137,440,28,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,4138,440,24,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,4139,440,29,'ZJ'),(NULL,0,'2019-11-29 22:13:40',NULL,4140,440,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,4141,440,11,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,4142,440,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,4143,440,15,'10.3.7.9'),(NULL,0,'2019-11-29 22:13:40',NULL,4144,440,5,'5a94392267b44f05985fbe92fc355167'),(NULL,0,'2019-11-29 22:13:40',NULL,4145,440,17,'online'),(NULL,0,'2019-11-29 22:13:40',NULL,4146,441,16,'cmdb1-3-7-10'),(NULL,0,'2019-11-29 22:13:40',NULL,4147,441,28,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,4148,441,24,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,4149,441,29,'ZJ'),(NULL,0,'2019-11-29 22:13:40',NULL,4150,441,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,4151,441,11,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,4152,441,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,4153,441,15,'10.3.7.10'),(NULL,0,'2019-11-29 22:13:40',NULL,4154,441,5,'aa83098c42394c19b3b001efc18a86ea'),(NULL,0,'2019-11-29 22:13:40',NULL,4155,441,17,'online'),(NULL,0,'2019-11-29 22:13:40',NULL,4156,442,16,'cmdb1-3-7-11'),(NULL,0,'2019-11-29 22:13:40',NULL,4157,442,28,'prod'),(NULL,0,'2019-11-29 22:13:40',NULL,4158,442,24,'enable'),(NULL,0,'2019-11-29 22:13:40',NULL,4159,442,29,'ZJ'),(NULL,0,'2019-11-29 22:13:40',NULL,4160,442,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:40',NULL,4161,442,11,'pycook'),(NULL,0,'2019-11-29 22:13:40',NULL,4162,442,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:40',NULL,4163,442,15,'10.3.7.11'),(NULL,0,'2019-11-29 22:13:40',NULL,4164,442,5,'35797a8b4266483aab82442cacbe661e'),(NULL,0,'2019-11-29 22:13:40',NULL,4165,442,17,'online'),(NULL,0,'2019-11-29 22:13:40',NULL,4166,443,16,'cmdb1-3-7-12'),(NULL,0,'2019-11-29 22:13:40',NULL,4167,443,28,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,4168,443,24,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,4169,443,29,'ZJ'),(NULL,0,'2019-11-29 22:13:41',NULL,4170,443,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,4171,443,11,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,4172,443,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,4173,443,15,'10.3.7.12'),(NULL,0,'2019-11-29 22:13:41',NULL,4174,443,5,'7669932171544319b3a6e634f809a412'),(NULL,0,'2019-11-29 22:13:41',NULL,4175,443,17,'online'),(NULL,0,'2019-11-29 22:13:41',NULL,4176,444,16,'cmdb1-3-7-13'),(NULL,0,'2019-11-29 22:13:41',NULL,4177,444,28,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,4178,444,24,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,4179,444,29,'ZJ'),(NULL,0,'2019-11-29 22:13:41',NULL,4180,444,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,4181,444,11,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,4182,444,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,4183,444,15,'10.3.7.13'),(NULL,0,'2019-11-29 22:13:41',NULL,4184,444,5,'abb891f1244e4cb08db1e5222c32e18a'),(NULL,0,'2019-11-29 22:13:41',NULL,4185,444,17,'online'),(NULL,0,'2019-11-29 22:13:41',NULL,4186,445,16,'cmdb1-3-7-14'),(NULL,0,'2019-11-29 22:13:41',NULL,4187,445,28,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,4188,445,24,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,4189,445,29,'ZJ'),(NULL,0,'2019-11-29 22:13:41',NULL,4190,445,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,4191,445,11,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,4192,445,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,4193,445,15,'10.3.7.14'),(NULL,0,'2019-11-29 22:13:41',NULL,4194,445,5,'f3556a4cecaf4191b884ea0b2c648044'),(NULL,0,'2019-11-29 22:13:41',NULL,4195,445,17,'online'),(NULL,0,'2019-11-29 22:13:41',NULL,4196,446,16,'cmdb1-3-7-15'),(NULL,0,'2019-11-29 22:13:41',NULL,4197,446,28,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,4198,446,24,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,4199,446,29,'ZJ'),(NULL,0,'2019-11-29 22:13:41',NULL,4200,446,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,4201,446,11,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,4202,446,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,4203,446,15,'10.3.7.15'),(NULL,0,'2019-11-29 22:13:41',NULL,4204,446,5,'ac2e391252544016a17f7320c40a6a12'),(NULL,0,'2019-11-29 22:13:41',NULL,4205,446,17,'online'),(NULL,0,'2019-11-29 22:13:41',NULL,4206,447,16,'cmdb1-3-7-16'),(NULL,0,'2019-11-29 22:13:41',NULL,4207,447,28,'prod'),(NULL,0,'2019-11-29 22:13:41',NULL,4208,447,24,'enable'),(NULL,0,'2019-11-29 22:13:41',NULL,4209,447,29,'ZJ'),(NULL,0,'2019-11-29 22:13:41',NULL,4210,447,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:41',NULL,4211,447,11,'pycook'),(NULL,0,'2019-11-29 22:13:41',NULL,4212,447,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:41',NULL,4213,447,15,'10.3.7.16'),(NULL,0,'2019-11-29 22:13:42',NULL,4214,447,5,'712500f8ec6f40798c6dee7f1989c02b'),(NULL,0,'2019-11-29 22:13:42',NULL,4215,447,17,'online'),(NULL,0,'2019-11-29 22:13:42',NULL,4216,448,4,'App1-3-8'),(NULL,0,'2019-11-29 22:13:42',NULL,4217,449,16,'cmdb1-3-8-1'),(NULL,0,'2019-11-29 22:13:42',NULL,4218,449,28,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,4219,449,24,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,4220,449,29,'ZJ'),(NULL,0,'2019-11-29 22:13:42',NULL,4221,449,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,4222,449,11,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,4223,449,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,4224,449,15,'10.3.8.1'),(NULL,0,'2019-11-29 22:13:42',NULL,4225,449,5,'6143b2c007484a3d869d6d3f611be73a'),(NULL,0,'2019-11-29 22:13:42',NULL,4226,449,17,'online'),(NULL,0,'2019-11-29 22:13:42',NULL,4227,450,16,'cmdb1-3-8-2'),(NULL,0,'2019-11-29 22:13:42',NULL,4228,450,28,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,4229,450,24,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,4230,450,29,'ZJ'),(NULL,0,'2019-11-29 22:13:42',NULL,4231,450,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,4232,450,11,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,4233,450,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,4234,450,15,'10.3.8.2'),(NULL,0,'2019-11-29 22:13:42',NULL,4235,450,5,'932a620b971144b8a91cbfd41f3ecbca'),(NULL,0,'2019-11-29 22:13:42',NULL,4236,450,17,'online'),(NULL,0,'2019-11-29 22:13:42',NULL,4237,451,16,'cmdb1-3-8-3'),(NULL,0,'2019-11-29 22:13:42',NULL,4238,451,28,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,4239,451,24,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,4240,451,29,'ZJ'),(NULL,0,'2019-11-29 22:13:42',NULL,4241,451,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,4242,451,11,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,4243,451,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,4244,451,15,'10.3.8.3'),(NULL,0,'2019-11-29 22:13:42',NULL,4245,451,5,'2cf343badd474bda934522618bb90833'),(NULL,0,'2019-11-29 22:13:42',NULL,4246,451,17,'online'),(NULL,0,'2019-11-29 22:13:42',NULL,4247,452,16,'cmdb1-3-8-4'),(NULL,0,'2019-11-29 22:13:42',NULL,4248,452,28,'prod'),(NULL,0,'2019-11-29 22:13:42',NULL,4249,452,24,'enable'),(NULL,0,'2019-11-29 22:13:42',NULL,4250,452,29,'ZJ'),(NULL,0,'2019-11-29 22:13:42',NULL,4251,452,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:42',NULL,4252,452,11,'pycook'),(NULL,0,'2019-11-29 22:13:42',NULL,4253,452,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:42',NULL,4254,452,15,'10.3.8.4'),(NULL,0,'2019-11-29 22:13:43',NULL,4255,452,5,'2e11f7ff09e742bc8ba6a93ad8d57df8'),(NULL,0,'2019-11-29 22:13:43',NULL,4256,452,17,'online'),(NULL,0,'2019-11-29 22:13:43',NULL,4257,453,16,'cmdb1-3-8-5'),(NULL,0,'2019-11-29 22:13:43',NULL,4258,453,28,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,4259,453,24,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,4260,453,29,'ZJ'),(NULL,0,'2019-11-29 22:13:43',NULL,4261,453,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,4262,453,11,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,4263,453,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,4264,453,15,'10.3.8.5'),(NULL,0,'2019-11-29 22:13:43',NULL,4265,453,5,'4f497a1abecd4f83889b0a91d1aeda35'),(NULL,0,'2019-11-29 22:13:43',NULL,4266,453,17,'online'),(NULL,0,'2019-11-29 22:13:43',NULL,4267,454,16,'cmdb1-3-8-6'),(NULL,0,'2019-11-29 22:13:43',NULL,4268,454,28,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,4269,454,24,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,4270,454,29,'ZJ'),(NULL,0,'2019-11-29 22:13:43',NULL,4271,454,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,4272,454,11,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,4273,454,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,4274,454,15,'10.3.8.6'),(NULL,0,'2019-11-29 22:13:43',NULL,4275,454,5,'680bfe1abb3047b2b827fdd87c29900f'),(NULL,0,'2019-11-29 22:13:43',NULL,4276,454,17,'online'),(NULL,0,'2019-11-29 22:13:43',NULL,4277,455,16,'cmdb1-3-8-7'),(NULL,0,'2019-11-29 22:13:43',NULL,4278,455,28,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,4279,455,24,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,4280,455,29,'ZJ'),(NULL,0,'2019-11-29 22:13:43',NULL,4281,455,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,4282,455,11,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,4283,455,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,4284,455,15,'10.3.8.7'),(NULL,0,'2019-11-29 22:13:43',NULL,4285,455,5,'8e47bfb26fb343478846053098a14d06'),(NULL,0,'2019-11-29 22:13:43',NULL,4286,455,17,'online'),(NULL,0,'2019-11-29 22:13:43',NULL,4287,456,16,'cmdb1-3-8-8'),(NULL,0,'2019-11-29 22:13:43',NULL,4288,456,28,'prod'),(NULL,0,'2019-11-29 22:13:43',NULL,4289,456,24,'enable'),(NULL,0,'2019-11-29 22:13:43',NULL,4290,456,29,'ZJ'),(NULL,0,'2019-11-29 22:13:43',NULL,4291,456,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:43',NULL,4292,456,11,'pycook'),(NULL,0,'2019-11-29 22:13:43',NULL,4293,456,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:43',NULL,4294,456,15,'10.3.8.8'),(NULL,0,'2019-11-29 22:13:43',NULL,4295,456,5,'4f72e58fa1234f3ab156f100c7f588bb'),(NULL,0,'2019-11-29 22:13:43',NULL,4296,456,17,'online'),(NULL,0,'2019-11-29 22:13:44',NULL,4297,457,16,'cmdb1-3-8-9'),(NULL,0,'2019-11-29 22:13:44',NULL,4298,457,28,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,4299,457,24,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,4300,457,29,'ZJ'),(NULL,0,'2019-11-29 22:13:44',NULL,4301,457,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,4302,457,11,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,4303,457,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,4304,457,15,'10.3.8.9'),(NULL,0,'2019-11-29 22:13:44',NULL,4305,457,5,'2903c75f6d0541278ea8476ad3c40deb'),(NULL,0,'2019-11-29 22:13:44',NULL,4306,457,17,'online'),(NULL,0,'2019-11-29 22:13:44',NULL,4307,458,16,'cmdb1-3-8-10'),(NULL,0,'2019-11-29 22:13:44',NULL,4308,458,28,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,4309,458,24,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,4310,458,29,'ZJ'),(NULL,0,'2019-11-29 22:13:44',NULL,4311,458,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,4312,458,11,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,4313,458,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,4314,458,15,'10.3.8.10'),(NULL,0,'2019-11-29 22:13:44',NULL,4315,458,5,'b7d549c62d9a485ba8b31313363c2240'),(NULL,0,'2019-11-29 22:13:44',NULL,4316,458,17,'online'),(NULL,0,'2019-11-29 22:13:44',NULL,4317,459,16,'cmdb1-3-8-11'),(NULL,0,'2019-11-29 22:13:44',NULL,4318,459,28,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,4319,459,24,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,4320,459,29,'ZJ'),(NULL,0,'2019-11-29 22:13:44',NULL,4321,459,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,4322,459,11,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,4323,459,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,4324,459,15,'10.3.8.11'),(NULL,0,'2019-11-29 22:13:44',NULL,4325,459,5,'e45df55ed327452a95bea4cb2ecd6acd'),(NULL,0,'2019-11-29 22:13:44',NULL,4326,459,17,'online'),(NULL,0,'2019-11-29 22:13:44',NULL,4327,460,16,'cmdb1-3-8-12'),(NULL,0,'2019-11-29 22:13:44',NULL,4328,460,28,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,4329,460,24,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,4330,460,29,'ZJ'),(NULL,0,'2019-11-29 22:13:44',NULL,4331,460,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:44',NULL,4332,460,11,'pycook'),(NULL,0,'2019-11-29 22:13:44',NULL,4333,460,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:44',NULL,4334,460,15,'10.3.8.12'),(NULL,0,'2019-11-29 22:13:44',NULL,4335,460,5,'5dc6145953524868b9cfec8de0d42ddc'),(NULL,0,'2019-11-29 22:13:44',NULL,4336,460,17,'online'),(NULL,0,'2019-11-29 22:13:44',NULL,4337,461,16,'cmdb1-3-8-13'),(NULL,0,'2019-11-29 22:13:44',NULL,4338,461,28,'prod'),(NULL,0,'2019-11-29 22:13:44',NULL,4339,461,24,'enable'),(NULL,0,'2019-11-29 22:13:44',NULL,4340,461,29,'ZJ'),(NULL,0,'2019-11-29 22:13:45',NULL,4341,461,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,4342,461,11,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,4343,461,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,4344,461,15,'10.3.8.13'),(NULL,0,'2019-11-29 22:13:45',NULL,4345,461,5,'e5c963b9ff6b44e0a3f39f1916f272ef'),(NULL,0,'2019-11-29 22:13:45',NULL,4346,461,17,'online'),(NULL,0,'2019-11-29 22:13:45',NULL,4347,462,16,'cmdb1-3-8-14'),(NULL,0,'2019-11-29 22:13:45',NULL,4348,462,28,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,4349,462,24,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,4350,462,29,'ZJ'),(NULL,0,'2019-11-29 22:13:45',NULL,4351,462,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,4352,462,11,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,4353,462,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,4354,462,15,'10.3.8.14'),(NULL,0,'2019-11-29 22:13:45',NULL,4355,462,5,'2a634e578d7c43fe98371c8bb85f4889'),(NULL,0,'2019-11-29 22:13:45',NULL,4356,462,17,'online'),(NULL,0,'2019-11-29 22:13:45',NULL,4357,463,16,'cmdb1-3-8-15'),(NULL,0,'2019-11-29 22:13:45',NULL,4358,463,28,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,4359,463,24,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,4360,463,29,'ZJ'),(NULL,0,'2019-11-29 22:13:45',NULL,4361,463,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,4362,463,11,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,4363,463,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,4364,463,15,'10.3.8.15'),(NULL,0,'2019-11-29 22:13:45',NULL,4365,463,5,'8996c0012a0b459fac16e9e674b0af60'),(NULL,0,'2019-11-29 22:13:45',NULL,4366,463,17,'online'),(NULL,0,'2019-11-29 22:13:45',NULL,4367,464,16,'cmdb1-3-8-16'),(NULL,0,'2019-11-29 22:13:45',NULL,4368,464,28,'prod'),(NULL,0,'2019-11-29 22:13:45',NULL,4369,464,24,'enable'),(NULL,0,'2019-11-29 22:13:45',NULL,4370,464,29,'ZJ'),(NULL,0,'2019-11-29 22:13:45',NULL,4371,464,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:45',NULL,4372,464,11,'pycook'),(NULL,0,'2019-11-29 22:13:45',NULL,4373,464,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:45',NULL,4374,464,15,'10.3.8.16'),(NULL,0,'2019-11-29 22:13:45',NULL,4375,464,5,'5cddc85686ef40f9a04c980c2fa62bcd'),(NULL,0,'2019-11-29 22:13:45',NULL,4376,464,17,'online'),(NULL,0,'2019-11-29 22:13:45',NULL,4377,465,3,'Product1-4'),(NULL,0,'2019-11-29 22:13:45',NULL,4378,466,4,'App1-4-1'),(NULL,0,'2019-11-29 22:13:45',NULL,4379,467,16,'cmdb1-4-1-1'),(NULL,0,'2019-11-29 22:13:46',NULL,4380,467,28,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,4381,467,24,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,4382,467,29,'ZJ'),(NULL,0,'2019-11-29 22:13:46',NULL,4383,467,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,4384,467,11,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,4385,467,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,4386,467,15,'10.4.1.1'),(NULL,0,'2019-11-29 22:13:46',NULL,4387,467,5,'94d5490f44814c7581c861e59cd42df6'),(NULL,0,'2019-11-29 22:13:46',NULL,4388,467,17,'online'),(NULL,0,'2019-11-29 22:13:46',NULL,4389,468,16,'cmdb1-4-1-2'),(NULL,0,'2019-11-29 22:13:46',NULL,4390,468,28,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,4391,468,24,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,4392,468,29,'ZJ'),(NULL,0,'2019-11-29 22:13:46',NULL,4393,468,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,4394,468,11,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,4395,468,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,4396,468,15,'10.4.1.2'),(NULL,0,'2019-11-29 22:13:46',NULL,4397,468,5,'0089e0bd1c6640b8b25bf2b1f60315cf'),(NULL,0,'2019-11-29 22:13:46',NULL,4398,468,17,'online'),(NULL,0,'2019-11-29 22:13:46',NULL,4399,469,16,'cmdb1-4-1-3'),(NULL,0,'2019-11-29 22:13:46',NULL,4400,469,28,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,4401,469,24,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,4402,469,29,'ZJ'),(NULL,0,'2019-11-29 22:13:46',NULL,4403,469,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,4404,469,11,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,4405,469,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,4406,469,15,'10.4.1.3'),(NULL,0,'2019-11-29 22:13:46',NULL,4407,469,5,'1480cf9dbd2445d4980d67b731d08097'),(NULL,0,'2019-11-29 22:13:46',NULL,4408,469,17,'online'),(NULL,0,'2019-11-29 22:13:46',NULL,4409,470,16,'cmdb1-4-1-4'),(NULL,0,'2019-11-29 22:13:46',NULL,4410,470,28,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,4411,470,24,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,4412,470,29,'ZJ'),(NULL,0,'2019-11-29 22:13:46',NULL,4413,470,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,4414,470,11,'pycook'),(NULL,0,'2019-11-29 22:13:46',NULL,4415,470,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:46',NULL,4416,470,15,'10.4.1.4'),(NULL,0,'2019-11-29 22:13:46',NULL,4417,470,5,'26c9b4332a664e4085b0616e6a4ffbc6'),(NULL,0,'2019-11-29 22:13:46',NULL,4418,470,17,'online'),(NULL,0,'2019-11-29 22:13:46',NULL,4419,471,16,'cmdb1-4-1-5'),(NULL,0,'2019-11-29 22:13:46',NULL,4420,471,28,'prod'),(NULL,0,'2019-11-29 22:13:46',NULL,4421,471,24,'enable'),(NULL,0,'2019-11-29 22:13:46',NULL,4422,471,29,'ZJ'),(NULL,0,'2019-11-29 22:13:46',NULL,4423,471,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:46',NULL,4424,471,11,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,4425,471,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,4426,471,15,'10.4.1.5'),(NULL,0,'2019-11-29 22:13:47',NULL,4427,471,5,'32b637da2a854f66a6c1ae27385b37d3'),(NULL,0,'2019-11-29 22:13:47',NULL,4428,471,17,'online'),(NULL,0,'2019-11-29 22:13:47',NULL,4429,472,16,'cmdb1-4-1-6'),(NULL,0,'2019-11-29 22:13:47',NULL,4430,472,28,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,4431,472,24,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,4432,472,29,'ZJ'),(NULL,0,'2019-11-29 22:13:47',NULL,4433,472,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,4434,472,11,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,4435,472,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,4436,472,15,'10.4.1.6'),(NULL,0,'2019-11-29 22:13:47',NULL,4437,472,5,'1a1db4d91f544c1dbee68633d5b2ff96'),(NULL,0,'2019-11-29 22:13:47',NULL,4438,472,17,'online'),(NULL,0,'2019-11-29 22:13:47',NULL,4439,473,16,'cmdb1-4-1-7'),(NULL,0,'2019-11-29 22:13:47',NULL,4440,473,28,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,4441,473,24,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,4442,473,29,'ZJ'),(NULL,0,'2019-11-29 22:13:47',NULL,4443,473,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,4444,473,11,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,4445,473,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,4446,473,15,'10.4.1.7'),(NULL,0,'2019-11-29 22:13:47',NULL,4447,473,5,'8b4861b293994a2d8e6f8ea825a04b5e'),(NULL,0,'2019-11-29 22:13:47',NULL,4448,473,17,'online'),(NULL,0,'2019-11-29 22:13:47',NULL,4449,474,16,'cmdb1-4-1-8'),(NULL,0,'2019-11-29 22:13:47',NULL,4450,474,28,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,4451,474,24,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,4452,474,29,'ZJ'),(NULL,0,'2019-11-29 22:13:47',NULL,4453,474,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,4454,474,11,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,4455,474,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,4456,474,15,'10.4.1.8'),(NULL,0,'2019-11-29 22:13:47',NULL,4457,474,5,'922ae03ab56942319bcf03a88b16dfe0'),(NULL,0,'2019-11-29 22:13:47',NULL,4458,474,17,'online'),(NULL,0,'2019-11-29 22:13:47',NULL,4459,475,16,'cmdb1-4-1-9'),(NULL,0,'2019-11-29 22:13:47',NULL,4460,475,28,'prod'),(NULL,0,'2019-11-29 22:13:47',NULL,4461,475,24,'enable'),(NULL,0,'2019-11-29 22:13:47',NULL,4462,475,29,'ZJ'),(NULL,0,'2019-11-29 22:13:47',NULL,4463,475,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:47',NULL,4464,475,11,'pycook'),(NULL,0,'2019-11-29 22:13:47',NULL,4465,475,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:47',NULL,4466,475,15,'10.4.1.9'),(NULL,0,'2019-11-29 22:13:47',NULL,4467,475,5,'0e94d33be15b46019e5a2d34f84c950d'),(NULL,0,'2019-11-29 22:13:47',NULL,4468,475,17,'online'),(NULL,0,'2019-11-29 22:13:48',NULL,4469,476,16,'cmdb1-4-1-10'),(NULL,0,'2019-11-29 22:13:48',NULL,4470,476,28,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,4471,476,24,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,4472,476,29,'ZJ'),(NULL,0,'2019-11-29 22:13:48',NULL,4473,476,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,4474,476,11,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,4475,476,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,4476,476,15,'10.4.1.10'),(NULL,0,'2019-11-29 22:13:48',NULL,4477,476,5,'5bbb7fc415ee4528a4a54743c0af3de5'),(NULL,0,'2019-11-29 22:13:48',NULL,4478,476,17,'online'),(NULL,0,'2019-11-29 22:13:48',NULL,4479,477,16,'cmdb1-4-1-11'),(NULL,0,'2019-11-29 22:13:48',NULL,4480,477,28,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,4481,477,24,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,4482,477,29,'ZJ'),(NULL,0,'2019-11-29 22:13:48',NULL,4483,477,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,4484,477,11,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,4485,477,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,4486,477,15,'10.4.1.11'),(NULL,0,'2019-11-29 22:13:48',NULL,4487,477,5,'47d60ba791c148958694975ce51c6e26'),(NULL,0,'2019-11-29 22:13:48',NULL,4488,477,17,'online'),(NULL,0,'2019-11-29 22:13:48',NULL,4489,478,16,'cmdb1-4-1-12'),(NULL,0,'2019-11-29 22:13:48',NULL,4490,478,28,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,4491,478,24,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,4492,478,29,'ZJ'),(NULL,0,'2019-11-29 22:13:48',NULL,4493,478,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,4494,478,11,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,4495,478,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,4496,478,15,'10.4.1.12'),(NULL,0,'2019-11-29 22:13:48',NULL,4497,478,5,'f14032e8a1c7400d8b68b5e795c5a4fd'),(NULL,0,'2019-11-29 22:13:48',NULL,4498,478,17,'online'),(NULL,0,'2019-11-29 22:13:48',NULL,4499,479,16,'cmdb1-4-1-13'),(NULL,0,'2019-11-29 22:13:48',NULL,4500,479,28,'prod'),(NULL,0,'2019-11-29 22:13:48',NULL,4501,479,24,'enable'),(NULL,0,'2019-11-29 22:13:48',NULL,4502,479,29,'ZJ'),(NULL,0,'2019-11-29 22:13:48',NULL,4503,479,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:48',NULL,4504,479,11,'pycook'),(NULL,0,'2019-11-29 22:13:48',NULL,4505,479,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:48',NULL,4506,479,15,'10.4.1.13'),(NULL,0,'2019-11-29 22:13:48',NULL,4507,479,5,'3c17cecb628b43838c52456044f459d0'),(NULL,0,'2019-11-29 22:13:48',NULL,4508,479,17,'online'),(NULL,0,'2019-11-29 22:13:48',NULL,4509,480,16,'cmdb1-4-1-14'),(NULL,0,'2019-11-29 22:13:48',NULL,4510,480,28,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,4511,480,24,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,4512,480,29,'ZJ'),(NULL,0,'2019-11-29 22:13:49',NULL,4513,480,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,4514,480,11,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,4515,480,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,4516,480,15,'10.4.1.14'),(NULL,0,'2019-11-29 22:13:49',NULL,4517,480,5,'93e6139bdc4e450d82bbf1fc84069305'),(NULL,0,'2019-11-29 22:13:49',NULL,4518,480,17,'online'),(NULL,0,'2019-11-29 22:13:49',NULL,4519,481,16,'cmdb1-4-1-15'),(NULL,0,'2019-11-29 22:13:49',NULL,4520,481,28,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,4521,481,24,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,4522,481,29,'ZJ'),(NULL,0,'2019-11-29 22:13:49',NULL,4523,481,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,4524,481,11,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,4525,481,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,4526,481,15,'10.4.1.15'),(NULL,0,'2019-11-29 22:13:49',NULL,4527,481,5,'2f37d636566949e4bf81242a0b590995'),(NULL,0,'2019-11-29 22:13:49',NULL,4528,481,17,'online'),(NULL,0,'2019-11-29 22:13:49',NULL,4529,482,16,'cmdb1-4-1-16'),(NULL,0,'2019-11-29 22:13:49',NULL,4530,482,28,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,4531,482,24,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,4532,482,29,'ZJ'),(NULL,0,'2019-11-29 22:13:49',NULL,4533,482,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,4534,482,11,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,4535,482,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,4536,482,15,'10.4.1.16'),(NULL,0,'2019-11-29 22:13:49',NULL,4537,482,5,'ba4dbe2928ff4c23aedc4e9d6745dc96'),(NULL,0,'2019-11-29 22:13:49',NULL,4538,482,17,'online'),(NULL,0,'2019-11-29 22:13:49',NULL,4539,483,4,'App1-4-2'),(NULL,0,'2019-11-29 22:13:49',NULL,4540,484,16,'cmdb1-4-2-1'),(NULL,0,'2019-11-29 22:13:49',NULL,4541,484,28,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,4542,484,24,'enable'),(NULL,0,'2019-11-29 22:13:49',NULL,4543,484,29,'ZJ'),(NULL,0,'2019-11-29 22:13:49',NULL,4544,484,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:49',NULL,4545,484,11,'pycook'),(NULL,0,'2019-11-29 22:13:49',NULL,4546,484,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:49',NULL,4547,484,15,'10.4.2.1'),(NULL,0,'2019-11-29 22:13:49',NULL,4548,484,5,'3b562e22fa0742c5ba64cede1e993c2c'),(NULL,0,'2019-11-29 22:13:49',NULL,4549,484,17,'online'),(NULL,0,'2019-11-29 22:13:49',NULL,4550,485,16,'cmdb1-4-2-2'),(NULL,0,'2019-11-29 22:13:49',NULL,4551,485,28,'prod'),(NULL,0,'2019-11-29 22:13:49',NULL,4552,485,24,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,4553,485,29,'ZJ'),(NULL,0,'2019-11-29 22:13:50',NULL,4554,485,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,4555,485,11,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,4556,485,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,4557,485,15,'10.4.2.2'),(NULL,0,'2019-11-29 22:13:50',NULL,4558,485,5,'d8db9341158d41e7994f72c0e6a98f56'),(NULL,0,'2019-11-29 22:13:50',NULL,4559,485,17,'online'),(NULL,0,'2019-11-29 22:13:50',NULL,4560,486,16,'cmdb1-4-2-3'),(NULL,0,'2019-11-29 22:13:50',NULL,4561,486,28,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,4562,486,24,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,4563,486,29,'ZJ'),(NULL,0,'2019-11-29 22:13:50',NULL,4564,486,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,4565,486,11,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,4566,486,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,4567,486,15,'10.4.2.3'),(NULL,0,'2019-11-29 22:13:50',NULL,4568,486,5,'9678c2e20b33415189dde6d1c9063fdc'),(NULL,0,'2019-11-29 22:13:50',NULL,4569,486,17,'online'),(NULL,0,'2019-11-29 22:13:50',NULL,4570,487,16,'cmdb1-4-2-4'),(NULL,0,'2019-11-29 22:13:50',NULL,4571,487,28,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,4572,487,24,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,4573,487,29,'ZJ'),(NULL,0,'2019-11-29 22:13:50',NULL,4574,487,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,4575,487,11,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,4576,487,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,4577,487,15,'10.4.2.4'),(NULL,0,'2019-11-29 22:13:50',NULL,4578,487,5,'31c02f14413d4b108dfbdbc9c9ba3ef2'),(NULL,0,'2019-11-29 22:13:50',NULL,4579,487,17,'online'),(NULL,0,'2019-11-29 22:13:50',NULL,4580,488,16,'cmdb1-4-2-5'),(NULL,0,'2019-11-29 22:13:50',NULL,4581,488,28,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,4582,488,24,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,4583,488,29,'ZJ'),(NULL,0,'2019-11-29 22:13:50',NULL,4584,488,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,4585,488,11,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,4586,488,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,4587,488,15,'10.4.2.5'),(NULL,0,'2019-11-29 22:13:50',NULL,4588,488,5,'bcf13e5b2ff64ccbb3da3246d174d64a'),(NULL,0,'2019-11-29 22:13:50',NULL,4589,488,17,'online'),(NULL,0,'2019-11-29 22:13:50',NULL,4590,489,16,'cmdb1-4-2-6'),(NULL,0,'2019-11-29 22:13:50',NULL,4591,489,28,'prod'),(NULL,0,'2019-11-29 22:13:50',NULL,4592,489,24,'enable'),(NULL,0,'2019-11-29 22:13:50',NULL,4593,489,29,'ZJ'),(NULL,0,'2019-11-29 22:13:50',NULL,4594,489,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:50',NULL,4595,489,11,'pycook'),(NULL,0,'2019-11-29 22:13:50',NULL,4596,489,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:50',NULL,4597,489,15,'10.4.2.6'),(NULL,0,'2019-11-29 22:13:51',NULL,4598,489,5,'c54dbda67ea04a828ab199bfe882fe3b'),(NULL,0,'2019-11-29 22:13:51',NULL,4599,489,17,'online'),(NULL,0,'2019-11-29 22:13:51',NULL,4600,490,16,'cmdb1-4-2-7'),(NULL,0,'2019-11-29 22:13:51',NULL,4601,490,28,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,4602,490,24,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,4603,490,29,'ZJ'),(NULL,0,'2019-11-29 22:13:51',NULL,4604,490,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,4605,490,11,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,4606,490,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,4607,490,15,'10.4.2.7'),(NULL,0,'2019-11-29 22:13:51',NULL,4608,490,5,'b173ec65243c49ab8f32c209d3fbf461'),(NULL,0,'2019-11-29 22:13:51',NULL,4609,490,17,'online'),(NULL,0,'2019-11-29 22:13:51',NULL,4610,491,16,'cmdb1-4-2-8'),(NULL,0,'2019-11-29 22:13:51',NULL,4611,491,28,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,4612,491,24,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,4613,491,29,'ZJ'),(NULL,0,'2019-11-29 22:13:51',NULL,4614,491,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,4615,491,11,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,4616,491,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,4617,491,15,'10.4.2.8'),(NULL,0,'2019-11-29 22:13:51',NULL,4618,491,5,'5c2cd2c6e7ed4740acfccdc6d09c35a5'),(NULL,0,'2019-11-29 22:13:51',NULL,4619,491,17,'online'),(NULL,0,'2019-11-29 22:13:51',NULL,4620,492,16,'cmdb1-4-2-9'),(NULL,0,'2019-11-29 22:13:51',NULL,4621,492,28,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,4622,492,24,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,4623,492,29,'ZJ'),(NULL,0,'2019-11-29 22:13:51',NULL,4624,492,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,4625,492,11,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,4626,492,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,4627,492,15,'10.4.2.9'),(NULL,0,'2019-11-29 22:13:51',NULL,4628,492,5,'8e3f7b069f6344218688c57a51c0b8cc'),(NULL,0,'2019-11-29 22:13:51',NULL,4629,492,17,'online'),(NULL,0,'2019-11-29 22:13:51',NULL,4630,493,16,'cmdb1-4-2-10'),(NULL,0,'2019-11-29 22:13:51',NULL,4631,493,28,'prod'),(NULL,0,'2019-11-29 22:13:51',NULL,4632,493,24,'enable'),(NULL,0,'2019-11-29 22:13:51',NULL,4633,493,29,'ZJ'),(NULL,0,'2019-11-29 22:13:51',NULL,4634,493,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:51',NULL,4635,493,11,'pycook'),(NULL,0,'2019-11-29 22:13:51',NULL,4636,493,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:51',NULL,4637,493,15,'10.4.2.10'),(NULL,0,'2019-11-29 22:13:51',NULL,4638,493,5,'a4b4ec5178a748bfb672aad87293a063'),(NULL,0,'2019-11-29 22:13:51',NULL,4639,493,17,'online'),(NULL,0,'2019-11-29 22:13:52',NULL,4640,494,16,'cmdb1-4-2-11'),(NULL,0,'2019-11-29 22:13:52',NULL,4641,494,28,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,4642,494,24,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,4643,494,29,'ZJ'),(NULL,0,'2019-11-29 22:13:52',NULL,4644,494,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,4645,494,11,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,4646,494,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,4647,494,15,'10.4.2.11'),(NULL,0,'2019-11-29 22:13:52',NULL,4648,494,5,'321c1a920947442dbfae84f802e3a1ae'),(NULL,0,'2019-11-29 22:13:52',NULL,4649,494,17,'online'),(NULL,0,'2019-11-29 22:13:52',NULL,4650,495,16,'cmdb1-4-2-12'),(NULL,0,'2019-11-29 22:13:52',NULL,4651,495,28,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,4652,495,24,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,4653,495,29,'ZJ'),(NULL,0,'2019-11-29 22:13:52',NULL,4654,495,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,4655,495,11,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,4656,495,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,4657,495,15,'10.4.2.12'),(NULL,0,'2019-11-29 22:13:52',NULL,4658,495,5,'8f2ed38879e24525952fdda6969a29b1'),(NULL,0,'2019-11-29 22:13:52',NULL,4659,495,17,'online'),(NULL,0,'2019-11-29 22:13:52',NULL,4660,496,16,'cmdb1-4-2-13'),(NULL,0,'2019-11-29 22:13:52',NULL,4661,496,28,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,4662,496,24,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,4663,496,29,'ZJ'),(NULL,0,'2019-11-29 22:13:52',NULL,4664,496,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,4665,496,11,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,4666,496,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,4667,496,15,'10.4.2.13'),(NULL,0,'2019-11-29 22:13:52',NULL,4668,496,5,'e093d028695d4dcf8ac96420d40fa203'),(NULL,0,'2019-11-29 22:13:52',NULL,4669,496,17,'online'),(NULL,0,'2019-11-29 22:13:52',NULL,4670,497,16,'cmdb1-4-2-14'),(NULL,0,'2019-11-29 22:13:52',NULL,4671,497,28,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,4672,497,24,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,4673,497,29,'ZJ'),(NULL,0,'2019-11-29 22:13:52',NULL,4674,497,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:52',NULL,4675,497,11,'pycook'),(NULL,0,'2019-11-29 22:13:52',NULL,4676,497,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:52',NULL,4677,497,15,'10.4.2.14'),(NULL,0,'2019-11-29 22:13:52',NULL,4678,497,5,'05d80eb74a5a40f5a7f7cac1efe2e66d'),(NULL,0,'2019-11-29 22:13:52',NULL,4679,497,17,'online'),(NULL,0,'2019-11-29 22:13:52',NULL,4680,498,16,'cmdb1-4-2-15'),(NULL,0,'2019-11-29 22:13:52',NULL,4681,498,28,'prod'),(NULL,0,'2019-11-29 22:13:52',NULL,4682,498,24,'enable'),(NULL,0,'2019-11-29 22:13:52',NULL,4683,498,29,'ZJ'),(NULL,0,'2019-11-29 22:13:53',NULL,4684,498,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,4685,498,11,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,4686,498,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,4687,498,15,'10.4.2.15'),(NULL,0,'2019-11-29 22:13:53',NULL,4688,498,5,'bd865c183aec4a188ece7b44ea27b85c'),(NULL,0,'2019-11-29 22:13:53',NULL,4689,498,17,'online'),(NULL,0,'2019-11-29 22:13:53',NULL,4690,499,16,'cmdb1-4-2-16'),(NULL,0,'2019-11-29 22:13:53',NULL,4691,499,28,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,4692,499,24,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,4693,499,29,'ZJ'),(NULL,0,'2019-11-29 22:13:53',NULL,4694,499,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,4695,499,11,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,4696,499,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,4697,499,15,'10.4.2.16'),(NULL,0,'2019-11-29 22:13:53',NULL,4698,499,5,'51cf56e08990437e99a58745db1694cc'),(NULL,0,'2019-11-29 22:13:53',NULL,4699,499,17,'online'),(NULL,0,'2019-11-29 22:13:53',NULL,4700,500,4,'App1-4-3'),(NULL,0,'2019-11-29 22:13:53',NULL,4701,501,16,'cmdb1-4-3-1'),(NULL,0,'2019-11-29 22:13:53',NULL,4702,501,28,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,4703,501,24,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,4704,501,29,'ZJ'),(NULL,0,'2019-11-29 22:13:53',NULL,4705,501,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,4706,501,11,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,4707,501,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,4708,501,15,'10.4.3.1'),(NULL,0,'2019-11-29 22:13:53',NULL,4709,501,5,'4dc9092043984af0a2aaa3f9a7291aa3'),(NULL,0,'2019-11-29 22:13:53',NULL,4710,501,17,'online'),(NULL,0,'2019-11-29 22:13:53',NULL,4711,502,16,'cmdb1-4-3-2'),(NULL,0,'2019-11-29 22:13:53',NULL,4712,502,28,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,4713,502,24,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,4714,502,29,'ZJ'),(NULL,0,'2019-11-29 22:13:53',NULL,4715,502,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:53',NULL,4716,502,11,'pycook'),(NULL,0,'2019-11-29 22:13:53',NULL,4717,502,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:53',NULL,4718,502,15,'10.4.3.2'),(NULL,0,'2019-11-29 22:13:53',NULL,4719,502,5,'63713541682445f6a844d268511a794b'),(NULL,0,'2019-11-29 22:13:53',NULL,4720,502,17,'online'),(NULL,0,'2019-11-29 22:13:53',NULL,4721,503,16,'cmdb1-4-3-3'),(NULL,0,'2019-11-29 22:13:53',NULL,4722,503,28,'prod'),(NULL,0,'2019-11-29 22:13:53',NULL,4723,503,24,'enable'),(NULL,0,'2019-11-29 22:13:53',NULL,4724,503,29,'ZJ'),(NULL,0,'2019-11-29 22:13:53',NULL,4725,503,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,4726,503,11,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,4727,503,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,4728,503,15,'10.4.3.3'),(NULL,0,'2019-11-29 22:13:54',NULL,4729,503,5,'03b800ef4d5d440793d8e463a75a0738'),(NULL,0,'2019-11-29 22:13:54',NULL,4730,503,17,'online'),(NULL,0,'2019-11-29 22:13:54',NULL,4731,504,16,'cmdb1-4-3-4'),(NULL,0,'2019-11-29 22:13:54',NULL,4732,504,28,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,4733,504,24,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,4734,504,29,'ZJ'),(NULL,0,'2019-11-29 22:13:54',NULL,4735,504,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,4736,504,11,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,4737,504,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,4738,504,15,'10.4.3.4'),(NULL,0,'2019-11-29 22:13:54',NULL,4739,504,5,'11e29872385a484798b4be57625b6cda'),(NULL,0,'2019-11-29 22:13:54',NULL,4740,504,17,'online'),(NULL,0,'2019-11-29 22:13:54',NULL,4741,505,16,'cmdb1-4-3-5'),(NULL,0,'2019-11-29 22:13:54',NULL,4742,505,28,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,4743,505,24,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,4744,505,29,'ZJ'),(NULL,0,'2019-11-29 22:13:54',NULL,4745,505,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,4746,505,11,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,4747,505,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,4748,505,15,'10.4.3.5'),(NULL,0,'2019-11-29 22:13:54',NULL,4749,505,5,'a7fd3ad2ba454f6c93e0119ca6e4c9c6'),(NULL,0,'2019-11-29 22:13:54',NULL,4750,505,17,'online'),(NULL,0,'2019-11-29 22:13:54',NULL,4751,506,16,'cmdb1-4-3-6'),(NULL,0,'2019-11-29 22:13:54',NULL,4752,506,28,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,4753,506,24,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,4754,506,29,'ZJ'),(NULL,0,'2019-11-29 22:13:54',NULL,4755,506,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,4756,506,11,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,4757,506,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,4758,506,15,'10.4.3.6'),(NULL,0,'2019-11-29 22:13:54',NULL,4759,506,5,'d50429e843d5482c89155e0d5022374f'),(NULL,0,'2019-11-29 22:13:54',NULL,4760,506,17,'online'),(NULL,0,'2019-11-29 22:13:54',NULL,4761,507,16,'cmdb1-4-3-7'),(NULL,0,'2019-11-29 22:13:54',NULL,4762,507,28,'prod'),(NULL,0,'2019-11-29 22:13:54',NULL,4763,507,24,'enable'),(NULL,0,'2019-11-29 22:13:54',NULL,4764,507,29,'ZJ'),(NULL,0,'2019-11-29 22:13:54',NULL,4765,507,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:54',NULL,4766,507,11,'pycook'),(NULL,0,'2019-11-29 22:13:54',NULL,4767,507,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:54',NULL,4768,507,15,'10.4.3.7'),(NULL,0,'2019-11-29 22:13:54',NULL,4769,507,5,'9b6fc763687f444aa22cba5ee8c089c2'),(NULL,0,'2019-11-29 22:13:54',NULL,4770,507,17,'online'),(NULL,0,'2019-11-29 22:13:55',NULL,4771,508,16,'cmdb1-4-3-8'),(NULL,0,'2019-11-29 22:13:55',NULL,4772,508,28,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,4773,508,24,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,4774,508,29,'ZJ'),(NULL,0,'2019-11-29 22:13:55',NULL,4775,508,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,4776,508,11,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,4777,508,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,4778,508,15,'10.4.3.8'),(NULL,0,'2019-11-29 22:13:55',NULL,4779,508,5,'b32055d5cff243519bc5f89f2b47feef'),(NULL,0,'2019-11-29 22:13:55',NULL,4780,508,17,'online'),(NULL,0,'2019-11-29 22:13:55',NULL,4781,509,16,'cmdb1-4-3-9'),(NULL,0,'2019-11-29 22:13:55',NULL,4782,509,28,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,4783,509,24,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,4784,509,29,'ZJ'),(NULL,0,'2019-11-29 22:13:55',NULL,4785,509,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,4786,509,11,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,4787,509,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,4788,509,15,'10.4.3.9'),(NULL,0,'2019-11-29 22:13:55',NULL,4789,509,5,'aca46bc05ad94911be15e0c1ef597865'),(NULL,0,'2019-11-29 22:13:55',NULL,4790,509,17,'online'),(NULL,0,'2019-11-29 22:13:55',NULL,4791,510,16,'cmdb1-4-3-10'),(NULL,0,'2019-11-29 22:13:55',NULL,4792,510,28,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,4793,510,24,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,4794,510,29,'ZJ'),(NULL,0,'2019-11-29 22:13:55',NULL,4795,510,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,4796,510,11,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,4797,510,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,4798,510,15,'10.4.3.10'),(NULL,0,'2019-11-29 22:13:55',NULL,4799,510,5,'60f5e5ce1b7941f38bc1ce6fd055dee2'),(NULL,0,'2019-11-29 22:13:55',NULL,4800,510,17,'online'),(NULL,0,'2019-11-29 22:13:55',NULL,4801,511,16,'cmdb1-4-3-11'),(NULL,0,'2019-11-29 22:13:55',NULL,4802,511,28,'prod'),(NULL,0,'2019-11-29 22:13:55',NULL,4803,511,24,'enable'),(NULL,0,'2019-11-29 22:13:55',NULL,4804,511,29,'ZJ'),(NULL,0,'2019-11-29 22:13:55',NULL,4805,511,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:55',NULL,4806,511,11,'pycook'),(NULL,0,'2019-11-29 22:13:55',NULL,4807,511,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:55',NULL,4808,511,15,'10.4.3.11'),(NULL,0,'2019-11-29 22:13:55',NULL,4809,511,5,'5822ac551b12454684c50defa178bd56'),(NULL,0,'2019-11-29 22:13:55',NULL,4810,511,17,'online'),(NULL,0,'2019-11-29 22:13:55',NULL,4811,512,16,'cmdb1-4-3-12'),(NULL,0,'2019-11-29 22:13:56',NULL,4812,512,28,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,4813,512,24,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,4814,512,29,'ZJ'),(NULL,0,'2019-11-29 22:13:56',NULL,4815,512,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,4816,512,11,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,4817,512,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,4818,512,15,'10.4.3.12'),(NULL,0,'2019-11-29 22:13:56',NULL,4819,512,5,'10257bf032b74faebdee0b52a7efa975'),(NULL,0,'2019-11-29 22:13:56',NULL,4820,512,17,'online'),(NULL,0,'2019-11-29 22:13:56',NULL,4821,513,16,'cmdb1-4-3-13'),(NULL,0,'2019-11-29 22:13:56',NULL,4822,513,28,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,4823,513,24,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,4824,513,29,'ZJ'),(NULL,0,'2019-11-29 22:13:56',NULL,4825,513,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,4826,513,11,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,4827,513,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,4828,513,15,'10.4.3.13'),(NULL,0,'2019-11-29 22:13:56',NULL,4829,513,5,'f429ddebd8e64d7293cc3a9b397abff5'),(NULL,0,'2019-11-29 22:13:56',NULL,4830,513,17,'online'),(NULL,0,'2019-11-29 22:13:56',NULL,4831,514,16,'cmdb1-4-3-14'),(NULL,0,'2019-11-29 22:13:56',NULL,4832,514,28,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,4833,514,24,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,4834,514,29,'ZJ'),(NULL,0,'2019-11-29 22:13:56',NULL,4835,514,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,4836,514,11,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,4837,514,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,4838,514,15,'10.4.3.14'),(NULL,0,'2019-11-29 22:13:56',NULL,4839,514,5,'6e5e3cc023fa4b34acda33d5c96f7ae7'),(NULL,0,'2019-11-29 22:13:56',NULL,4840,514,17,'online'),(NULL,0,'2019-11-29 22:13:56',NULL,4841,515,16,'cmdb1-4-3-15'),(NULL,0,'2019-11-29 22:13:56',NULL,4842,515,28,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,4843,515,24,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,4844,515,29,'ZJ'),(NULL,0,'2019-11-29 22:13:56',NULL,4845,515,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,4846,515,11,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,4847,515,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:56',NULL,4848,515,15,'10.4.3.15'),(NULL,0,'2019-11-29 22:13:56',NULL,4849,515,5,'6a3630b304634f41b8d0d493bf5ae838'),(NULL,0,'2019-11-29 22:13:56',NULL,4850,515,17,'online'),(NULL,0,'2019-11-29 22:13:56',NULL,4851,516,16,'cmdb1-4-3-16'),(NULL,0,'2019-11-29 22:13:56',NULL,4852,516,28,'prod'),(NULL,0,'2019-11-29 22:13:56',NULL,4853,516,24,'enable'),(NULL,0,'2019-11-29 22:13:56',NULL,4854,516,29,'ZJ'),(NULL,0,'2019-11-29 22:13:56',NULL,4855,516,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:56',NULL,4856,516,11,'pycook'),(NULL,0,'2019-11-29 22:13:56',NULL,4857,516,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,4858,516,15,'10.4.3.16'),(NULL,0,'2019-11-29 22:13:57',NULL,4859,516,5,'5492cc0fb1654849abdcc39517cb613f'),(NULL,0,'2019-11-29 22:13:57',NULL,4860,516,17,'online'),(NULL,0,'2019-11-29 22:13:57',NULL,4861,517,4,'App1-4-4'),(NULL,0,'2019-11-29 22:13:57',NULL,4862,518,16,'cmdb1-4-4-1'),(NULL,0,'2019-11-29 22:13:57',NULL,4863,518,28,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,4864,518,24,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,4865,518,29,'ZJ'),(NULL,0,'2019-11-29 22:13:57',NULL,4866,518,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,4867,518,11,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,4868,518,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,4869,518,15,'10.4.4.1'),(NULL,0,'2019-11-29 22:13:57',NULL,4870,518,5,'98e1d4470bfc425ea02c3971ed21c726'),(NULL,0,'2019-11-29 22:13:57',NULL,4871,518,17,'online'),(NULL,0,'2019-11-29 22:13:57',NULL,4872,519,16,'cmdb1-4-4-2'),(NULL,0,'2019-11-29 22:13:57',NULL,4873,519,28,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,4874,519,24,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,4875,519,29,'ZJ'),(NULL,0,'2019-11-29 22:13:57',NULL,4876,519,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,4877,519,11,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,4878,519,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,4879,519,15,'10.4.4.2'),(NULL,0,'2019-11-29 22:13:57',NULL,4880,519,5,'c9b77e2bac504aa195e617c107dfc7b5'),(NULL,0,'2019-11-29 22:13:57',NULL,4881,519,17,'online'),(NULL,0,'2019-11-29 22:13:57',NULL,4882,520,16,'cmdb1-4-4-3'),(NULL,0,'2019-11-29 22:13:57',NULL,4883,520,28,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,4884,520,24,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,4885,520,29,'ZJ'),(NULL,0,'2019-11-29 22:13:57',NULL,4886,520,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,4887,520,11,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,4888,520,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,4889,520,15,'10.4.4.3'),(NULL,0,'2019-11-29 22:13:57',NULL,4890,520,5,'bc796cd0c1e34f9fb37a75a74f739684'),(NULL,0,'2019-11-29 22:13:57',NULL,4891,520,17,'online'),(NULL,0,'2019-11-29 22:13:57',NULL,4892,521,16,'cmdb1-4-4-4'),(NULL,0,'2019-11-29 22:13:57',NULL,4893,521,28,'prod'),(NULL,0,'2019-11-29 22:13:57',NULL,4894,521,24,'enable'),(NULL,0,'2019-11-29 22:13:57',NULL,4895,521,29,'ZJ'),(NULL,0,'2019-11-29 22:13:57',NULL,4896,521,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:57',NULL,4897,521,11,'pycook'),(NULL,0,'2019-11-29 22:13:57',NULL,4898,521,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:57',NULL,4899,521,15,'10.4.4.4'),(NULL,0,'2019-11-29 22:13:58',NULL,4900,521,5,'eccc625506e440e58f7db6f2c00ef239'),(NULL,0,'2019-11-29 22:13:58',NULL,4901,521,17,'online'),(NULL,0,'2019-11-29 22:13:58',NULL,4902,522,16,'cmdb1-4-4-5'),(NULL,0,'2019-11-29 22:13:58',NULL,4903,522,28,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,4904,522,24,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,4905,522,29,'ZJ'),(NULL,0,'2019-11-29 22:13:58',NULL,4906,522,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,4907,522,11,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,4908,522,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,4909,522,15,'10.4.4.5'),(NULL,0,'2019-11-29 22:13:58',NULL,4910,522,5,'7c27818a5aed43b3a3d8fbfedb81084a'),(NULL,0,'2019-11-29 22:13:58',NULL,4911,522,17,'online'),(NULL,0,'2019-11-29 22:13:58',NULL,4912,523,16,'cmdb1-4-4-6'),(NULL,0,'2019-11-29 22:13:58',NULL,4913,523,28,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,4914,523,24,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,4915,523,29,'ZJ'),(NULL,0,'2019-11-29 22:13:58',NULL,4916,523,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,4917,523,11,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,4918,523,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,4919,523,15,'10.4.4.6'),(NULL,0,'2019-11-29 22:13:58',NULL,4920,523,5,'3011b3a039a44849b3cc2da1b21c98e1'),(NULL,0,'2019-11-29 22:13:58',NULL,4921,523,17,'online'),(NULL,0,'2019-11-29 22:13:58',NULL,4922,524,16,'cmdb1-4-4-7'),(NULL,0,'2019-11-29 22:13:58',NULL,4923,524,28,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,4924,524,24,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,4925,524,29,'ZJ'),(NULL,0,'2019-11-29 22:13:58',NULL,4926,524,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,4927,524,11,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,4928,524,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,4929,524,15,'10.4.4.7'),(NULL,0,'2019-11-29 22:13:58',NULL,4930,524,5,'bce2a1d2bac34e0da1e791b1d2c80f52'),(NULL,0,'2019-11-29 22:13:58',NULL,4931,524,17,'online'),(NULL,0,'2019-11-29 22:13:58',NULL,4932,525,16,'cmdb1-4-4-8'),(NULL,0,'2019-11-29 22:13:58',NULL,4933,525,28,'prod'),(NULL,0,'2019-11-29 22:13:58',NULL,4934,525,24,'enable'),(NULL,0,'2019-11-29 22:13:58',NULL,4935,525,29,'ZJ'),(NULL,0,'2019-11-29 22:13:58',NULL,4936,525,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:58',NULL,4937,525,11,'pycook'),(NULL,0,'2019-11-29 22:13:58',NULL,4938,525,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:58',NULL,4939,525,15,'10.4.4.8'),(NULL,0,'2019-11-29 22:13:58',NULL,4940,525,5,'b2e7d47c08e444bcbadd7d38bdf2868a'),(NULL,0,'2019-11-29 22:13:58',NULL,4941,525,17,'online'),(NULL,0,'2019-11-29 22:13:59',NULL,4942,526,16,'cmdb1-4-4-9'),(NULL,0,'2019-11-29 22:13:59',NULL,4943,526,28,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,4944,526,24,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,4945,526,29,'ZJ'),(NULL,0,'2019-11-29 22:13:59',NULL,4946,526,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,4947,526,11,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,4948,526,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,4949,526,15,'10.4.4.9'),(NULL,0,'2019-11-29 22:13:59',NULL,4950,526,5,'ae322c90da664d47a6552edfa9a14f00'),(NULL,0,'2019-11-29 22:13:59',NULL,4951,526,17,'online'),(NULL,0,'2019-11-29 22:13:59',NULL,4952,527,16,'cmdb1-4-4-10'),(NULL,0,'2019-11-29 22:13:59',NULL,4953,527,28,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,4954,527,24,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,4955,527,29,'ZJ'),(NULL,0,'2019-11-29 22:13:59',NULL,4956,527,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,4957,527,11,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,4958,527,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,4959,527,15,'10.4.4.10'),(NULL,0,'2019-11-29 22:13:59',NULL,4960,527,5,'51ad8b8f5c7941daaac34c49092856ae'),(NULL,0,'2019-11-29 22:13:59',NULL,4961,527,17,'online'),(NULL,0,'2019-11-29 22:13:59',NULL,4962,528,16,'cmdb1-4-4-11'),(NULL,0,'2019-11-29 22:13:59',NULL,4963,528,28,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,4964,528,24,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,4965,528,29,'ZJ'),(NULL,0,'2019-11-29 22:13:59',NULL,4966,528,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,4967,528,11,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,4968,528,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,4969,528,15,'10.4.4.11'),(NULL,0,'2019-11-29 22:13:59',NULL,4970,528,5,'d7aea06543754716999bebfdc781a5f1'),(NULL,0,'2019-11-29 22:13:59',NULL,4971,528,17,'online'),(NULL,0,'2019-11-29 22:13:59',NULL,4972,529,16,'cmdb1-4-4-12'),(NULL,0,'2019-11-29 22:13:59',NULL,4973,529,28,'prod'),(NULL,0,'2019-11-29 22:13:59',NULL,4974,529,24,'enable'),(NULL,0,'2019-11-29 22:13:59',NULL,4975,529,29,'ZJ'),(NULL,0,'2019-11-29 22:13:59',NULL,4976,529,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:13:59',NULL,4977,529,11,'pycook'),(NULL,0,'2019-11-29 22:13:59',NULL,4978,529,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:13:59',NULL,4979,529,15,'10.4.4.12'),(NULL,0,'2019-11-29 22:13:59',NULL,4980,529,5,'a49dcd92e23f466296cb85a5d2c54c3b'),(NULL,0,'2019-11-29 22:13:59',NULL,4981,529,17,'online'),(NULL,0,'2019-11-29 22:13:59',NULL,4982,530,16,'cmdb1-4-4-13'),(NULL,0,'2019-11-29 22:14:00',NULL,4983,530,28,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,4984,530,24,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,4985,530,29,'ZJ'),(NULL,0,'2019-11-29 22:14:00',NULL,4986,530,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,4987,530,11,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,4988,530,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,4989,530,15,'10.4.4.13'),(NULL,0,'2019-11-29 22:14:00',NULL,4990,530,5,'5e870ab25be1472f924000d8abf7a223'),(NULL,0,'2019-11-29 22:14:00',NULL,4991,530,17,'online'),(NULL,0,'2019-11-29 22:14:00',NULL,4992,531,16,'cmdb1-4-4-14'),(NULL,0,'2019-11-29 22:14:00',NULL,4993,531,28,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,4994,531,24,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,4995,531,29,'ZJ'),(NULL,0,'2019-11-29 22:14:00',NULL,4996,531,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,4997,531,11,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,4998,531,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,4999,531,15,'10.4.4.14'),(NULL,0,'2019-11-29 22:14:00',NULL,5000,531,5,'ac367e9a2ec1403cbfa986c73c5b4401'),(NULL,0,'2019-11-29 22:14:00',NULL,5001,531,17,'online'),(NULL,0,'2019-11-29 22:14:00',NULL,5002,532,16,'cmdb1-4-4-15'),(NULL,0,'2019-11-29 22:14:00',NULL,5003,532,28,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,5004,532,24,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,5005,532,29,'ZJ'),(NULL,0,'2019-11-29 22:14:00',NULL,5006,532,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,5007,532,11,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,5008,532,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,5009,532,15,'10.4.4.15'),(NULL,0,'2019-11-29 22:14:00',NULL,5010,532,5,'a255550e225343f6b6a93a1c02af573a'),(NULL,0,'2019-11-29 22:14:00',NULL,5011,532,17,'online'),(NULL,0,'2019-11-29 22:14:00',NULL,5012,533,16,'cmdb1-4-4-16'),(NULL,0,'2019-11-29 22:14:00',NULL,5013,533,28,'prod'),(NULL,0,'2019-11-29 22:14:00',NULL,5014,533,24,'enable'),(NULL,0,'2019-11-29 22:14:00',NULL,5015,533,29,'ZJ'),(NULL,0,'2019-11-29 22:14:00',NULL,5016,533,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:00',NULL,5017,533,11,'pycook'),(NULL,0,'2019-11-29 22:14:00',NULL,5018,533,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:00',NULL,5019,533,15,'10.4.4.16'),(NULL,0,'2019-11-29 22:14:00',NULL,5020,533,5,'2cefc970e584488b8e78545978ca1f6c'),(NULL,0,'2019-11-29 22:14:00',NULL,5021,533,17,'online'),(NULL,0,'2019-11-29 22:14:00',NULL,5022,534,4,'App1-4-5'),(NULL,0,'2019-11-29 22:14:00',NULL,5023,535,16,'cmdb1-4-5-1'),(NULL,0,'2019-11-29 22:14:01',NULL,5024,535,28,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,5025,535,24,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,5026,535,29,'ZJ'),(NULL,0,'2019-11-29 22:14:01',NULL,5027,535,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,5028,535,11,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,5029,535,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,5030,535,15,'10.4.5.1'),(NULL,0,'2019-11-29 22:14:01',NULL,5031,535,5,'a9ba47ae20f94daeb306b7b24d1f7033'),(NULL,0,'2019-11-29 22:14:01',NULL,5032,535,17,'online'),(NULL,0,'2019-11-29 22:14:01',NULL,5033,536,16,'cmdb1-4-5-2'),(NULL,0,'2019-11-29 22:14:01',NULL,5034,536,28,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,5035,536,24,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,5036,536,29,'ZJ'),(NULL,0,'2019-11-29 22:14:01',NULL,5037,536,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,5038,536,11,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,5039,536,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,5040,536,15,'10.4.5.2'),(NULL,0,'2019-11-29 22:14:01',NULL,5041,536,5,'61c98b4f97e14366a4e610793b61baec'),(NULL,0,'2019-11-29 22:14:01',NULL,5042,536,17,'online'),(NULL,0,'2019-11-29 22:14:01',NULL,5043,537,16,'cmdb1-4-5-3'),(NULL,0,'2019-11-29 22:14:01',NULL,5044,537,28,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,5045,537,24,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,5046,537,29,'ZJ'),(NULL,0,'2019-11-29 22:14:01',NULL,5047,537,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,5048,537,11,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,5049,537,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,5050,537,15,'10.4.5.3'),(NULL,0,'2019-11-29 22:14:01',NULL,5051,537,5,'7075138424c143f3aab77ccdbe9c7456'),(NULL,0,'2019-11-29 22:14:01',NULL,5052,537,17,'online'),(NULL,0,'2019-11-29 22:14:01',NULL,5053,538,16,'cmdb1-4-5-4'),(NULL,0,'2019-11-29 22:14:01',NULL,5054,538,28,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,5055,538,24,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,5056,538,29,'ZJ'),(NULL,0,'2019-11-29 22:14:01',NULL,5057,538,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:01',NULL,5058,538,11,'pycook'),(NULL,0,'2019-11-29 22:14:01',NULL,5059,538,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:01',NULL,5060,538,15,'10.4.5.4'),(NULL,0,'2019-11-29 22:14:01',NULL,5061,538,5,'4b9e56573a224de595335628e8e3ac93'),(NULL,0,'2019-11-29 22:14:01',NULL,5062,538,17,'online'),(NULL,0,'2019-11-29 22:14:01',NULL,5063,539,16,'cmdb1-4-5-5'),(NULL,0,'2019-11-29 22:14:01',NULL,5064,539,28,'prod'),(NULL,0,'2019-11-29 22:14:01',NULL,5065,539,24,'enable'),(NULL,0,'2019-11-29 22:14:01',NULL,5066,539,29,'ZJ'),(NULL,0,'2019-11-29 22:14:01',NULL,5067,539,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,5068,539,11,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,5069,539,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,5070,539,15,'10.4.5.5'),(NULL,0,'2019-11-29 22:14:02',NULL,5071,539,5,'5349a0363eb64bc08df37af961d3669c'),(NULL,0,'2019-11-29 22:14:02',NULL,5072,539,17,'online'),(NULL,0,'2019-11-29 22:14:02',NULL,5073,540,16,'cmdb1-4-5-6'),(NULL,0,'2019-11-29 22:14:02',NULL,5074,540,28,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,5075,540,24,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,5076,540,29,'ZJ'),(NULL,0,'2019-11-29 22:14:02',NULL,5077,540,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,5078,540,11,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,5079,540,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,5080,540,15,'10.4.5.6'),(NULL,0,'2019-11-29 22:14:02',NULL,5081,540,5,'2e1dcfa21fce485ba12a825c11a771e1'),(NULL,0,'2019-11-29 22:14:02',NULL,5082,540,17,'online'),(NULL,0,'2019-11-29 22:14:02',NULL,5083,541,16,'cmdb1-4-5-7'),(NULL,0,'2019-11-29 22:14:02',NULL,5084,541,28,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,5085,541,24,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,5086,541,29,'ZJ'),(NULL,0,'2019-11-29 22:14:02',NULL,5087,541,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,5088,541,11,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,5089,541,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,5090,541,15,'10.4.5.7'),(NULL,0,'2019-11-29 22:14:02',NULL,5091,541,5,'49d211b152984c71a183f51add44224a'),(NULL,0,'2019-11-29 22:14:02',NULL,5092,541,17,'online'),(NULL,0,'2019-11-29 22:14:02',NULL,5093,542,16,'cmdb1-4-5-8'),(NULL,0,'2019-11-29 22:14:02',NULL,5094,542,28,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,5095,542,24,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,5096,542,29,'ZJ'),(NULL,0,'2019-11-29 22:14:02',NULL,5097,542,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,5098,542,11,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,5099,542,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,5100,542,15,'10.4.5.8'),(NULL,0,'2019-11-29 22:14:02',NULL,5101,542,5,'bd41820553224143bc39a4f53437eb1a'),(NULL,0,'2019-11-29 22:14:02',NULL,5102,542,17,'online'),(NULL,0,'2019-11-29 22:14:02',NULL,5103,543,16,'cmdb1-4-5-9'),(NULL,0,'2019-11-29 22:14:02',NULL,5104,543,28,'prod'),(NULL,0,'2019-11-29 22:14:02',NULL,5105,543,24,'enable'),(NULL,0,'2019-11-29 22:14:02',NULL,5106,543,29,'ZJ'),(NULL,0,'2019-11-29 22:14:02',NULL,5107,543,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:02',NULL,5108,543,11,'pycook'),(NULL,0,'2019-11-29 22:14:02',NULL,5109,543,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:02',NULL,5110,543,15,'10.4.5.9'),(NULL,0,'2019-11-29 22:14:02',NULL,5111,543,5,'433176e93fa14606ac5c145211192b14'),(NULL,0,'2019-11-29 22:14:02',NULL,5112,543,17,'online'),(NULL,0,'2019-11-29 22:14:03',NULL,5113,544,16,'cmdb1-4-5-10'),(NULL,0,'2019-11-29 22:14:03',NULL,5114,544,28,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,5115,544,24,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,5116,544,29,'ZJ'),(NULL,0,'2019-11-29 22:14:03',NULL,5117,544,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,5118,544,11,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,5119,544,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,5120,544,15,'10.4.5.10'),(NULL,0,'2019-11-29 22:14:03',NULL,5121,544,5,'78137b5e539a4d0f93751219de54593f'),(NULL,0,'2019-11-29 22:14:03',NULL,5122,544,17,'online'),(NULL,0,'2019-11-29 22:14:03',NULL,5123,545,16,'cmdb1-4-5-11'),(NULL,0,'2019-11-29 22:14:03',NULL,5124,545,28,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,5125,545,24,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,5126,545,29,'ZJ'),(NULL,0,'2019-11-29 22:14:03',NULL,5127,545,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,5128,545,11,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,5129,545,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,5130,545,15,'10.4.5.11'),(NULL,0,'2019-11-29 22:14:03',NULL,5131,545,5,'9e870b3731e24038a80824ca841fdde7'),(NULL,0,'2019-11-29 22:14:03',NULL,5132,545,17,'online'),(NULL,0,'2019-11-29 22:14:03',NULL,5133,546,16,'cmdb1-4-5-12'),(NULL,0,'2019-11-29 22:14:03',NULL,5134,546,28,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,5135,546,24,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,5136,546,29,'ZJ'),(NULL,0,'2019-11-29 22:14:03',NULL,5137,546,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,5138,546,11,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,5139,546,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,5140,546,15,'10.4.5.12'),(NULL,0,'2019-11-29 22:14:03',NULL,5141,546,5,'8a39bf57e8524ebdbc86243a394ae7b0'),(NULL,0,'2019-11-29 22:14:03',NULL,5142,546,17,'online'),(NULL,0,'2019-11-29 22:14:03',NULL,5143,547,16,'cmdb1-4-5-13'),(NULL,0,'2019-11-29 22:14:03',NULL,5144,547,28,'prod'),(NULL,0,'2019-11-29 22:14:03',NULL,5145,547,24,'enable'),(NULL,0,'2019-11-29 22:14:03',NULL,5146,547,29,'ZJ'),(NULL,0,'2019-11-29 22:14:03',NULL,5147,547,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:03',NULL,5148,547,11,'pycook'),(NULL,0,'2019-11-29 22:14:03',NULL,5149,547,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:03',NULL,5150,547,15,'10.4.5.13'),(NULL,0,'2019-11-29 22:14:03',NULL,5151,547,5,'f608203deeb646e7a102c3d0a99e39dc'),(NULL,0,'2019-11-29 22:14:03',NULL,5152,547,17,'online'),(NULL,0,'2019-11-29 22:14:03',NULL,5153,548,16,'cmdb1-4-5-14'),(NULL,0,'2019-11-29 22:14:04',NULL,5154,548,28,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,5155,548,24,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,5156,548,29,'ZJ'),(NULL,0,'2019-11-29 22:14:04',NULL,5157,548,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,5158,548,11,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,5159,548,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,5160,548,15,'10.4.5.14'),(NULL,0,'2019-11-29 22:14:04',NULL,5161,548,5,'65e5312dc3fe4494a9c975648bd6876a'),(NULL,0,'2019-11-29 22:14:04',NULL,5162,548,17,'online'),(NULL,0,'2019-11-29 22:14:04',NULL,5163,549,16,'cmdb1-4-5-15'),(NULL,0,'2019-11-29 22:14:04',NULL,5164,549,28,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,5165,549,24,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,5166,549,29,'ZJ'),(NULL,0,'2019-11-29 22:14:04',NULL,5167,549,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,5168,549,11,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,5169,549,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,5170,549,15,'10.4.5.15'),(NULL,0,'2019-11-29 22:14:04',NULL,5171,549,5,'fe3413b341b3454694a4793b7a499831'),(NULL,0,'2019-11-29 22:14:04',NULL,5172,549,17,'online'),(NULL,0,'2019-11-29 22:14:04',NULL,5173,550,16,'cmdb1-4-5-16'),(NULL,0,'2019-11-29 22:14:04',NULL,5174,550,28,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,5175,550,24,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,5176,550,29,'ZJ'),(NULL,0,'2019-11-29 22:14:04',NULL,5177,550,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,5178,550,11,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,5179,550,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,5180,550,15,'10.4.5.16'),(NULL,0,'2019-11-29 22:14:04',NULL,5181,550,5,'68c2ced0a2854192b1f18a6f6bea4954'),(NULL,0,'2019-11-29 22:14:04',NULL,5182,550,17,'online'),(NULL,0,'2019-11-29 22:14:04',NULL,5183,551,4,'App1-4-6'),(NULL,0,'2019-11-29 22:14:04',NULL,5184,552,16,'cmdb1-4-6-1'),(NULL,0,'2019-11-29 22:14:04',NULL,5185,552,28,'prod'),(NULL,0,'2019-11-29 22:14:04',NULL,5186,552,24,'enable'),(NULL,0,'2019-11-29 22:14:04',NULL,5187,552,29,'ZJ'),(NULL,0,'2019-11-29 22:14:04',NULL,5188,552,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:04',NULL,5189,552,11,'pycook'),(NULL,0,'2019-11-29 22:14:04',NULL,5190,552,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:04',NULL,5191,552,15,'10.4.6.1'),(NULL,0,'2019-11-29 22:14:04',NULL,5192,552,5,'88089f0644ba45ce97f97711092af978'),(NULL,0,'2019-11-29 22:14:04',NULL,5193,552,17,'online'),(NULL,0,'2019-11-29 22:14:04',NULL,5194,553,16,'cmdb1-4-6-2'),(NULL,0,'2019-11-29 22:14:05',NULL,5195,553,28,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,5196,553,24,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,5197,553,29,'ZJ'),(NULL,0,'2019-11-29 22:14:05',NULL,5198,553,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,5199,553,11,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,5200,553,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,5201,553,15,'10.4.6.2'),(NULL,0,'2019-11-29 22:14:05',NULL,5202,553,5,'d4770b1642d941ddad77ad7868d5f1a0'),(NULL,0,'2019-11-29 22:14:05',NULL,5203,553,17,'online'),(NULL,0,'2019-11-29 22:14:05',NULL,5204,554,16,'cmdb1-4-6-3'),(NULL,0,'2019-11-29 22:14:05',NULL,5205,554,28,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,5206,554,24,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,5207,554,29,'ZJ'),(NULL,0,'2019-11-29 22:14:05',NULL,5208,554,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,5209,554,11,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,5210,554,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,5211,554,15,'10.4.6.3'),(NULL,0,'2019-11-29 22:14:05',NULL,5212,554,5,'76fef15ad2854f73b78b9f28b9f3ab47'),(NULL,0,'2019-11-29 22:14:05',NULL,5213,554,17,'online'),(NULL,0,'2019-11-29 22:14:05',NULL,5214,555,16,'cmdb1-4-6-4'),(NULL,0,'2019-11-29 22:14:05',NULL,5215,555,28,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,5216,555,24,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,5217,555,29,'ZJ'),(NULL,0,'2019-11-29 22:14:05',NULL,5218,555,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,5219,555,11,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,5220,555,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,5221,555,15,'10.4.6.4'),(NULL,0,'2019-11-29 22:14:05',NULL,5222,555,5,'abd45c279fb74b40a312d8189410e6b9'),(NULL,0,'2019-11-29 22:14:05',NULL,5223,555,17,'online'),(NULL,0,'2019-11-29 22:14:05',NULL,5224,556,16,'cmdb1-4-6-5'),(NULL,0,'2019-11-29 22:14:05',NULL,5225,556,28,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,5226,556,24,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,5227,556,29,'ZJ'),(NULL,0,'2019-11-29 22:14:05',NULL,5228,556,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,5229,556,11,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,5230,556,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:05',NULL,5231,556,15,'10.4.6.5'),(NULL,0,'2019-11-29 22:14:05',NULL,5232,556,5,'2d3442ca640c4bfea283d211819961fb'),(NULL,0,'2019-11-29 22:14:05',NULL,5233,556,17,'online'),(NULL,0,'2019-11-29 22:14:05',NULL,5234,557,16,'cmdb1-4-6-6'),(NULL,0,'2019-11-29 22:14:05',NULL,5235,557,28,'prod'),(NULL,0,'2019-11-29 22:14:05',NULL,5236,557,24,'enable'),(NULL,0,'2019-11-29 22:14:05',NULL,5237,557,29,'ZJ'),(NULL,0,'2019-11-29 22:14:05',NULL,5238,557,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:05',NULL,5239,557,11,'pycook'),(NULL,0,'2019-11-29 22:14:05',NULL,5240,557,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,5241,557,15,'10.4.6.6'),(NULL,0,'2019-11-29 22:14:06',NULL,5242,557,5,'ee992be6b70a47a58009a599f8d99684'),(NULL,0,'2019-11-29 22:14:06',NULL,5243,557,17,'online'),(NULL,0,'2019-11-29 22:14:06',NULL,5244,558,16,'cmdb1-4-6-7'),(NULL,0,'2019-11-29 22:14:06',NULL,5245,558,28,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,5246,558,24,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,5247,558,29,'ZJ'),(NULL,0,'2019-11-29 22:14:06',NULL,5248,558,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,5249,558,11,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,5250,558,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,5251,558,15,'10.4.6.7'),(NULL,0,'2019-11-29 22:14:06',NULL,5252,558,5,'18131210436d4d779e90eaae5596d2f6'),(NULL,0,'2019-11-29 22:14:06',NULL,5253,558,17,'online'),(NULL,0,'2019-11-29 22:14:06',NULL,5254,559,16,'cmdb1-4-6-8'),(NULL,0,'2019-11-29 22:14:06',NULL,5255,559,28,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,5256,559,24,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,5257,559,29,'ZJ'),(NULL,0,'2019-11-29 22:14:06',NULL,5258,559,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,5259,559,11,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,5260,559,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,5261,559,15,'10.4.6.8'),(NULL,0,'2019-11-29 22:14:06',NULL,5262,559,5,'6e4776e443404433b7b95729af5fbb80'),(NULL,0,'2019-11-29 22:14:06',NULL,5263,559,17,'online'),(NULL,0,'2019-11-29 22:14:06',NULL,5264,560,16,'cmdb1-4-6-9'),(NULL,0,'2019-11-29 22:14:06',NULL,5265,560,28,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,5266,560,24,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,5267,560,29,'ZJ'),(NULL,0,'2019-11-29 22:14:06',NULL,5268,560,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,5269,560,11,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,5270,560,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,5271,560,15,'10.4.6.9'),(NULL,0,'2019-11-29 22:14:06',NULL,5272,560,5,'2d33b323023748dab82b5e4b2dac37d1'),(NULL,0,'2019-11-29 22:14:06',NULL,5273,560,17,'online'),(NULL,0,'2019-11-29 22:14:06',NULL,5274,561,16,'cmdb1-4-6-10'),(NULL,0,'2019-11-29 22:14:06',NULL,5275,561,28,'prod'),(NULL,0,'2019-11-29 22:14:06',NULL,5276,561,24,'enable'),(NULL,0,'2019-11-29 22:14:06',NULL,5277,561,29,'ZJ'),(NULL,0,'2019-11-29 22:14:06',NULL,5278,561,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:06',NULL,5279,561,11,'pycook'),(NULL,0,'2019-11-29 22:14:06',NULL,5280,561,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:06',NULL,5281,561,15,'10.4.6.10'),(NULL,0,'2019-11-29 22:14:06',NULL,5282,561,5,'6f3b82fd90b0423890e855c08801efce'),(NULL,0,'2019-11-29 22:14:06',NULL,5283,561,17,'online'),(NULL,0,'2019-11-29 22:14:07',NULL,5284,562,16,'cmdb1-4-6-11'),(NULL,0,'2019-11-29 22:14:07',NULL,5285,562,28,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,5286,562,24,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,5287,562,29,'ZJ'),(NULL,0,'2019-11-29 22:14:07',NULL,5288,562,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,5289,562,11,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,5290,562,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,5291,562,15,'10.4.6.11'),(NULL,0,'2019-11-29 22:14:07',NULL,5292,562,5,'0db9fa42abfa4373803727038fa1b9fb'),(NULL,0,'2019-11-29 22:14:07',NULL,5293,562,17,'online'),(NULL,0,'2019-11-29 22:14:07',NULL,5294,563,16,'cmdb1-4-6-12'),(NULL,0,'2019-11-29 22:14:07',NULL,5295,563,28,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,5296,563,24,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,5297,563,29,'ZJ'),(NULL,0,'2019-11-29 22:14:07',NULL,5298,563,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,5299,563,11,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,5300,563,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,5301,563,15,'10.4.6.12'),(NULL,0,'2019-11-29 22:14:07',NULL,5302,563,5,'3dad434cdd634548b9cb77c2af8582c5'),(NULL,0,'2019-11-29 22:14:07',NULL,5303,563,17,'online'),(NULL,0,'2019-11-29 22:14:07',NULL,5304,564,16,'cmdb1-4-6-13'),(NULL,0,'2019-11-29 22:14:07',NULL,5305,564,28,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,5306,564,24,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,5307,564,29,'ZJ'),(NULL,0,'2019-11-29 22:14:07',NULL,5308,564,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,5309,564,11,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,5310,564,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,5311,564,15,'10.4.6.13'),(NULL,0,'2019-11-29 22:14:07',NULL,5312,564,5,'237add16ec084ea9bbee04bfdd499c5a'),(NULL,0,'2019-11-29 22:14:07',NULL,5313,564,17,'online'),(NULL,0,'2019-11-29 22:14:07',NULL,5314,565,16,'cmdb1-4-6-14'),(NULL,0,'2019-11-29 22:14:07',NULL,5315,565,28,'prod'),(NULL,0,'2019-11-29 22:14:07',NULL,5316,565,24,'enable'),(NULL,0,'2019-11-29 22:14:07',NULL,5317,565,29,'ZJ'),(NULL,0,'2019-11-29 22:14:07',NULL,5318,565,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:07',NULL,5319,565,11,'pycook'),(NULL,0,'2019-11-29 22:14:07',NULL,5320,565,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:07',NULL,5321,565,15,'10.4.6.14'),(NULL,0,'2019-11-29 22:14:07',NULL,5322,565,5,'4e92a7ce3058451fa8770453d9166d7c'),(NULL,0,'2019-11-29 22:14:07',NULL,5323,565,17,'online'),(NULL,0,'2019-11-29 22:14:07',NULL,5324,566,16,'cmdb1-4-6-15'),(NULL,0,'2019-11-29 22:14:08',NULL,5325,566,28,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,5326,566,24,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,5327,566,29,'ZJ'),(NULL,0,'2019-11-29 22:14:08',NULL,5328,566,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,5329,566,11,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,5330,566,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,5331,566,15,'10.4.6.15'),(NULL,0,'2019-11-29 22:14:08',NULL,5332,566,5,'89b41fb8f6de439a8b90153f8278f5ef'),(NULL,0,'2019-11-29 22:14:08',NULL,5333,566,17,'online'),(NULL,0,'2019-11-29 22:14:08',NULL,5334,567,16,'cmdb1-4-6-16'),(NULL,0,'2019-11-29 22:14:08',NULL,5335,567,28,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,5336,567,24,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,5337,567,29,'ZJ'),(NULL,0,'2019-11-29 22:14:08',NULL,5338,567,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,5339,567,11,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,5340,567,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,5341,567,15,'10.4.6.16'),(NULL,0,'2019-11-29 22:14:08',NULL,5342,567,5,'4957a679fe23419dbeefa52035718f74'),(NULL,0,'2019-11-29 22:14:08',NULL,5343,567,17,'online'),(NULL,0,'2019-11-29 22:14:08',NULL,5344,568,4,'App1-4-7'),(NULL,0,'2019-11-29 22:14:08',NULL,5345,569,16,'cmdb1-4-7-1'),(NULL,0,'2019-11-29 22:14:08',NULL,5346,569,28,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,5347,569,24,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,5348,569,29,'ZJ'),(NULL,0,'2019-11-29 22:14:08',NULL,5349,569,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,5350,569,11,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,5351,569,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,5352,569,15,'10.4.7.1'),(NULL,0,'2019-11-29 22:14:08',NULL,5353,569,5,'e03ac4739b5541ff94433533688aba9a'),(NULL,0,'2019-11-29 22:14:08',NULL,5354,569,17,'online'),(NULL,0,'2019-11-29 22:14:08',NULL,5355,570,16,'cmdb1-4-7-2'),(NULL,0,'2019-11-29 22:14:08',NULL,5356,570,28,'prod'),(NULL,0,'2019-11-29 22:14:08',NULL,5357,570,24,'enable'),(NULL,0,'2019-11-29 22:14:08',NULL,5358,570,29,'ZJ'),(NULL,0,'2019-11-29 22:14:08',NULL,5359,570,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:08',NULL,5360,570,11,'pycook'),(NULL,0,'2019-11-29 22:14:08',NULL,5361,570,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:08',NULL,5362,570,15,'10.4.7.2'),(NULL,0,'2019-11-29 22:14:08',NULL,5363,570,5,'57f6b209181f4ab6bc3f0e97bfa2d163'),(NULL,0,'2019-11-29 22:14:08',NULL,5364,570,17,'online'),(NULL,0,'2019-11-29 22:14:08',NULL,5365,571,16,'cmdb1-4-7-3'),(NULL,0,'2019-11-29 22:14:09',NULL,5366,571,28,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,5367,571,24,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,5368,571,29,'ZJ'),(NULL,0,'2019-11-29 22:14:09',NULL,5369,571,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,5370,571,11,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,5371,571,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,5372,571,15,'10.4.7.3'),(NULL,0,'2019-11-29 22:14:09',NULL,5373,571,5,'e7f331aee8314e30becfc78c242306ec'),(NULL,0,'2019-11-29 22:14:09',NULL,5374,571,17,'online'),(NULL,0,'2019-11-29 22:14:09',NULL,5375,572,16,'cmdb1-4-7-4'),(NULL,0,'2019-11-29 22:14:09',NULL,5376,572,28,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,5377,572,24,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,5378,572,29,'ZJ'),(NULL,0,'2019-11-29 22:14:09',NULL,5379,572,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,5380,572,11,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,5381,572,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,5382,572,15,'10.4.7.4'),(NULL,0,'2019-11-29 22:14:09',NULL,5383,572,5,'50580cc807054ab98b463f6458cf16d5'),(NULL,0,'2019-11-29 22:14:09',NULL,5384,572,17,'online'),(NULL,0,'2019-11-29 22:14:09',NULL,5385,573,16,'cmdb1-4-7-5'),(NULL,0,'2019-11-29 22:14:09',NULL,5386,573,28,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,5387,573,24,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,5388,573,29,'ZJ'),(NULL,0,'2019-11-29 22:14:09',NULL,5389,573,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,5390,573,11,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,5391,573,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,5392,573,15,'10.4.7.5'),(NULL,0,'2019-11-29 22:14:09',NULL,5393,573,5,'002d003cb0544f5a96be5f2e84a036d4'),(NULL,0,'2019-11-29 22:14:09',NULL,5394,573,17,'online'),(NULL,0,'2019-11-29 22:14:09',NULL,5395,574,16,'cmdb1-4-7-6'),(NULL,0,'2019-11-29 22:14:09',NULL,5396,574,28,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,5397,574,24,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,5398,574,29,'ZJ'),(NULL,0,'2019-11-29 22:14:09',NULL,5399,574,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,5400,574,11,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,5401,574,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:09',NULL,5402,574,15,'10.4.7.6'),(NULL,0,'2019-11-29 22:14:09',NULL,5403,574,5,'fc68f9746def4e39b94ba4a8489f6e41'),(NULL,0,'2019-11-29 22:14:09',NULL,5404,574,17,'online'),(NULL,0,'2019-11-29 22:14:09',NULL,5405,575,16,'cmdb1-4-7-7'),(NULL,0,'2019-11-29 22:14:09',NULL,5406,575,28,'prod'),(NULL,0,'2019-11-29 22:14:09',NULL,5407,575,24,'enable'),(NULL,0,'2019-11-29 22:14:09',NULL,5408,575,29,'ZJ'),(NULL,0,'2019-11-29 22:14:09',NULL,5409,575,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:09',NULL,5410,575,11,'pycook'),(NULL,0,'2019-11-29 22:14:09',NULL,5411,575,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,5412,575,15,'10.4.7.7'),(NULL,0,'2019-11-29 22:14:10',NULL,5413,575,5,'e8f8a779f27048189f0a299b0b43f0c8'),(NULL,0,'2019-11-29 22:14:10',NULL,5414,575,17,'online'),(NULL,0,'2019-11-29 22:14:10',NULL,5415,576,16,'cmdb1-4-7-8'),(NULL,0,'2019-11-29 22:14:10',NULL,5416,576,28,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,5417,576,24,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,5418,576,29,'ZJ'),(NULL,0,'2019-11-29 22:14:10',NULL,5419,576,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,5420,576,11,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,5421,576,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,5422,576,15,'10.4.7.8'),(NULL,0,'2019-11-29 22:14:10',NULL,5423,576,5,'65b2f0416e79483e8320b3415de8f091'),(NULL,0,'2019-11-29 22:14:10',NULL,5424,576,17,'online'),(NULL,0,'2019-11-29 22:14:10',NULL,5425,577,16,'cmdb1-4-7-9'),(NULL,0,'2019-11-29 22:14:10',NULL,5426,577,28,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,5427,577,24,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,5428,577,29,'ZJ'),(NULL,0,'2019-11-29 22:14:10',NULL,5429,577,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,5430,577,11,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,5431,577,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,5432,577,15,'10.4.7.9'),(NULL,0,'2019-11-29 22:14:10',NULL,5433,577,5,'8c357f99ee74488da78465cb9e9018ea'),(NULL,0,'2019-11-29 22:14:10',NULL,5434,577,17,'online'),(NULL,0,'2019-11-29 22:14:10',NULL,5435,578,16,'cmdb1-4-7-10'),(NULL,0,'2019-11-29 22:14:10',NULL,5436,578,28,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,5437,578,24,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,5438,578,29,'ZJ'),(NULL,0,'2019-11-29 22:14:10',NULL,5439,578,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,5440,578,11,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,5441,578,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,5442,578,15,'10.4.7.10'),(NULL,0,'2019-11-29 22:14:10',NULL,5443,578,5,'604678a98b0945999d1c6d5193baddb1'),(NULL,0,'2019-11-29 22:14:10',NULL,5444,578,17,'online'),(NULL,0,'2019-11-29 22:14:10',NULL,5445,579,16,'cmdb1-4-7-11'),(NULL,0,'2019-11-29 22:14:10',NULL,5446,579,28,'prod'),(NULL,0,'2019-11-29 22:14:10',NULL,5447,579,24,'enable'),(NULL,0,'2019-11-29 22:14:10',NULL,5448,579,29,'ZJ'),(NULL,0,'2019-11-29 22:14:10',NULL,5449,579,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:10',NULL,5450,579,11,'pycook'),(NULL,0,'2019-11-29 22:14:10',NULL,5451,579,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:10',NULL,5452,579,15,'10.4.7.11'),(NULL,0,'2019-11-29 22:14:10',NULL,5453,579,5,'09e5ee08c8af42bbb923abc9afe46a2c'),(NULL,0,'2019-11-29 22:14:10',NULL,5454,579,17,'online'),(NULL,0,'2019-11-29 22:14:11',NULL,5455,580,16,'cmdb1-4-7-12'),(NULL,0,'2019-11-29 22:14:11',NULL,5456,580,28,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,5457,580,24,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,5458,580,29,'ZJ'),(NULL,0,'2019-11-29 22:14:11',NULL,5459,580,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,5460,580,11,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,5461,580,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,5462,580,15,'10.4.7.12'),(NULL,0,'2019-11-29 22:14:11',NULL,5463,580,5,'fa36b2f8b0764c109af884ee38284ae4'),(NULL,0,'2019-11-29 22:14:11',NULL,5464,580,17,'online'),(NULL,0,'2019-11-29 22:14:11',NULL,5465,581,16,'cmdb1-4-7-13'),(NULL,0,'2019-11-29 22:14:11',NULL,5466,581,28,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,5467,581,24,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,5468,581,29,'ZJ'),(NULL,0,'2019-11-29 22:14:11',NULL,5469,581,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,5470,581,11,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,5471,581,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,5472,581,15,'10.4.7.13'),(NULL,0,'2019-11-29 22:14:11',NULL,5473,581,5,'52c8e20009234c84956a5f59ca09ec87'),(NULL,0,'2019-11-29 22:14:11',NULL,5474,581,17,'online'),(NULL,0,'2019-11-29 22:14:11',NULL,5475,582,16,'cmdb1-4-7-14'),(NULL,0,'2019-11-29 22:14:11',NULL,5476,582,28,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,5477,582,24,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,5478,582,29,'ZJ'),(NULL,0,'2019-11-29 22:14:11',NULL,5479,582,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,5480,582,11,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,5481,582,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,5482,582,15,'10.4.7.14'),(NULL,0,'2019-11-29 22:14:11',NULL,5483,582,5,'74af0ebc45cf41d5b9cae14b9718ed5f'),(NULL,0,'2019-11-29 22:14:11',NULL,5484,582,17,'online'),(NULL,0,'2019-11-29 22:14:11',NULL,5485,583,16,'cmdb1-4-7-15'),(NULL,0,'2019-11-29 22:14:11',NULL,5486,583,28,'prod'),(NULL,0,'2019-11-29 22:14:11',NULL,5487,583,24,'enable'),(NULL,0,'2019-11-29 22:14:11',NULL,5488,583,29,'ZJ'),(NULL,0,'2019-11-29 22:14:11',NULL,5489,583,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:11',NULL,5490,583,11,'pycook'),(NULL,0,'2019-11-29 22:14:11',NULL,5491,583,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:11',NULL,5492,583,15,'10.4.7.15'),(NULL,0,'2019-11-29 22:14:11',NULL,5493,583,5,'35e0212e4d0b49719f4854288cf42e65'),(NULL,0,'2019-11-29 22:14:11',NULL,5494,583,17,'online'),(NULL,0,'2019-11-29 22:14:11',NULL,5495,584,16,'cmdb1-4-7-16'),(NULL,0,'2019-11-29 22:14:11',NULL,5496,584,28,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,5497,584,24,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,5498,584,29,'ZJ'),(NULL,0,'2019-11-29 22:14:12',NULL,5499,584,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,5500,584,11,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,5501,584,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,5502,584,15,'10.4.7.16'),(NULL,0,'2019-11-29 22:14:12',NULL,5503,584,5,'ba018b916df54a6da353df679322abc0'),(NULL,0,'2019-11-29 22:14:12',NULL,5504,584,17,'online'),(NULL,0,'2019-11-29 22:14:12',NULL,5505,585,4,'App1-4-8'),(NULL,0,'2019-11-29 22:14:12',NULL,5506,586,16,'cmdb1-4-8-1'),(NULL,0,'2019-11-29 22:14:12',NULL,5507,586,28,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,5508,586,24,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,5509,586,29,'ZJ'),(NULL,0,'2019-11-29 22:14:12',NULL,5510,586,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,5511,586,11,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,5512,586,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,5513,586,15,'10.4.8.1'),(NULL,0,'2019-11-29 22:14:12',NULL,5514,586,5,'8b04dfff1c6348c1a94dffd07c6e1f9c'),(NULL,0,'2019-11-29 22:14:12',NULL,5515,586,17,'online'),(NULL,0,'2019-11-29 22:14:12',NULL,5516,587,16,'cmdb1-4-8-2'),(NULL,0,'2019-11-29 22:14:12',NULL,5517,587,28,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,5518,587,24,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,5519,587,29,'ZJ'),(NULL,0,'2019-11-29 22:14:12',NULL,5520,587,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,5521,587,11,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,5522,587,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,5523,587,15,'10.4.8.2'),(NULL,0,'2019-11-29 22:14:12',NULL,5524,587,5,'8a139eb2fc2f4cfdad631b8fac14e671'),(NULL,0,'2019-11-29 22:14:12',NULL,5525,587,17,'online'),(NULL,0,'2019-11-29 22:14:12',NULL,5526,588,16,'cmdb1-4-8-3'),(NULL,0,'2019-11-29 22:14:12',NULL,5527,588,28,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,5528,588,24,'enable'),(NULL,0,'2019-11-29 22:14:12',NULL,5529,588,29,'ZJ'),(NULL,0,'2019-11-29 22:14:12',NULL,5530,588,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:12',NULL,5531,588,11,'pycook'),(NULL,0,'2019-11-29 22:14:12',NULL,5532,588,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:12',NULL,5533,588,15,'10.4.8.3'),(NULL,0,'2019-11-29 22:14:12',NULL,5534,588,5,'997b3ab39bf24fc5acf90e55033e573a'),(NULL,0,'2019-11-29 22:14:12',NULL,5535,588,17,'online'),(NULL,0,'2019-11-29 22:14:12',NULL,5536,589,16,'cmdb1-4-8-4'),(NULL,0,'2019-11-29 22:14:12',NULL,5537,589,28,'prod'),(NULL,0,'2019-11-29 22:14:12',NULL,5538,589,24,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,5539,589,29,'ZJ'),(NULL,0,'2019-11-29 22:14:13',NULL,5540,589,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,5541,589,11,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,5542,589,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,5543,589,15,'10.4.8.4'),(NULL,0,'2019-11-29 22:14:13',NULL,5544,589,5,'330acde820fa47abbbcebb3a91fd1b3e'),(NULL,0,'2019-11-29 22:14:13',NULL,5545,589,17,'online'),(NULL,0,'2019-11-29 22:14:13',NULL,5546,590,16,'cmdb1-4-8-5'),(NULL,0,'2019-11-29 22:14:13',NULL,5547,590,28,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,5548,590,24,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,5549,590,29,'ZJ'),(NULL,0,'2019-11-29 22:14:13',NULL,5550,590,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,5551,590,11,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,5552,590,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,5553,590,15,'10.4.8.5'),(NULL,0,'2019-11-29 22:14:13',NULL,5554,590,5,'2426982b469c40c7aef748894f134f64'),(NULL,0,'2019-11-29 22:14:13',NULL,5555,590,17,'online'),(NULL,0,'2019-11-29 22:14:13',NULL,5556,591,16,'cmdb1-4-8-6'),(NULL,0,'2019-11-29 22:14:13',NULL,5557,591,28,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,5558,591,24,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,5559,591,29,'ZJ'),(NULL,0,'2019-11-29 22:14:13',NULL,5560,591,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,5561,591,11,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,5562,591,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,5563,591,15,'10.4.8.6'),(NULL,0,'2019-11-29 22:14:13',NULL,5564,591,5,'3bf02860dfec4cb99f3bc355e7c6a1b3'),(NULL,0,'2019-11-29 22:14:13',NULL,5565,591,17,'online'),(NULL,0,'2019-11-29 22:14:13',NULL,5566,592,16,'cmdb1-4-8-7'),(NULL,0,'2019-11-29 22:14:13',NULL,5567,592,28,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,5568,592,24,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,5569,592,29,'ZJ'),(NULL,0,'2019-11-29 22:14:13',NULL,5570,592,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,5571,592,11,'pycook'),(NULL,0,'2019-11-29 22:14:13',NULL,5572,592,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:13',NULL,5573,592,15,'10.4.8.7'),(NULL,0,'2019-11-29 22:14:13',NULL,5574,592,5,'367b27dc515e46afb17b1df7fbb9f01a'),(NULL,0,'2019-11-29 22:14:13',NULL,5575,592,17,'online'),(NULL,0,'2019-11-29 22:14:13',NULL,5576,593,16,'cmdb1-4-8-8'),(NULL,0,'2019-11-29 22:14:13',NULL,5577,593,28,'prod'),(NULL,0,'2019-11-29 22:14:13',NULL,5578,593,24,'enable'),(NULL,0,'2019-11-29 22:14:13',NULL,5579,593,29,'ZJ'),(NULL,0,'2019-11-29 22:14:13',NULL,5580,593,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:13',NULL,5581,593,11,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,5582,593,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,5583,593,15,'10.4.8.8'),(NULL,0,'2019-11-29 22:14:14',NULL,5584,593,5,'baa02f8a050448578407692dbd5c9dca'),(NULL,0,'2019-11-29 22:14:14',NULL,5585,593,17,'online'),(NULL,0,'2019-11-29 22:14:14',NULL,5586,594,16,'cmdb1-4-8-9'),(NULL,0,'2019-11-29 22:14:14',NULL,5587,594,28,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,5588,594,24,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,5589,594,29,'ZJ'),(NULL,0,'2019-11-29 22:14:14',NULL,5590,594,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,5591,594,11,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,5592,594,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,5593,594,15,'10.4.8.9'),(NULL,0,'2019-11-29 22:14:14',NULL,5594,594,5,'90d39fe8f11e4ad0b47db79b68bfb9ca'),(NULL,0,'2019-11-29 22:14:14',NULL,5595,594,17,'online'),(NULL,0,'2019-11-29 22:14:14',NULL,5596,595,16,'cmdb1-4-8-10'),(NULL,0,'2019-11-29 22:14:14',NULL,5597,595,28,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,5598,595,24,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,5599,595,29,'ZJ'),(NULL,0,'2019-11-29 22:14:14',NULL,5600,595,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,5601,595,11,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,5602,595,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,5603,595,15,'10.4.8.10'),(NULL,0,'2019-11-29 22:14:14',NULL,5604,595,5,'d74fe8d2571a43f99f0a8f9a2f6b3512'),(NULL,0,'2019-11-29 22:14:14',NULL,5605,595,17,'online'),(NULL,0,'2019-11-29 22:14:14',NULL,5606,596,16,'cmdb1-4-8-11'),(NULL,0,'2019-11-29 22:14:14',NULL,5607,596,28,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,5608,596,24,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,5609,596,29,'ZJ'),(NULL,0,'2019-11-29 22:14:14',NULL,5610,596,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,5611,596,11,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,5612,596,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,5613,596,15,'10.4.8.11'),(NULL,0,'2019-11-29 22:14:14',NULL,5614,596,5,'a4d0d22c9ce84cf2ae63286aed7373be'),(NULL,0,'2019-11-29 22:14:14',NULL,5615,596,17,'online'),(NULL,0,'2019-11-29 22:14:14',NULL,5616,597,16,'cmdb1-4-8-12'),(NULL,0,'2019-11-29 22:14:14',NULL,5617,597,28,'prod'),(NULL,0,'2019-11-29 22:14:14',NULL,5618,597,24,'enable'),(NULL,0,'2019-11-29 22:14:14',NULL,5619,597,29,'ZJ'),(NULL,0,'2019-11-29 22:14:14',NULL,5620,597,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:14',NULL,5621,597,11,'pycook'),(NULL,0,'2019-11-29 22:14:14',NULL,5622,597,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:14',NULL,5623,597,15,'10.4.8.12'),(NULL,0,'2019-11-29 22:14:14',NULL,5624,597,5,'a121b090b249441388a0725781df34c5'),(NULL,0,'2019-11-29 22:14:14',NULL,5625,597,17,'online'),(NULL,0,'2019-11-29 22:14:15',NULL,5626,598,16,'cmdb1-4-8-13'),(NULL,0,'2019-11-29 22:14:15',NULL,5627,598,28,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,5628,598,24,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,5629,598,29,'ZJ'),(NULL,0,'2019-11-29 22:14:15',NULL,5630,598,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,5631,598,11,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,5632,598,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,5633,598,15,'10.4.8.13'),(NULL,0,'2019-11-29 22:14:15',NULL,5634,598,5,'f1939d7704824e47ac0d4a06ec6f9ec9'),(NULL,0,'2019-11-29 22:14:15',NULL,5635,598,17,'online'),(NULL,0,'2019-11-29 22:14:15',NULL,5636,599,16,'cmdb1-4-8-14'),(NULL,0,'2019-11-29 22:14:15',NULL,5637,599,28,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,5638,599,24,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,5639,599,29,'ZJ'),(NULL,0,'2019-11-29 22:14:15',NULL,5640,599,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,5641,599,11,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,5642,599,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,5643,599,15,'10.4.8.14'),(NULL,0,'2019-11-29 22:14:15',NULL,5644,599,5,'d1e2330817584df6bc7f2156405b01d5'),(NULL,0,'2019-11-29 22:14:15',NULL,5645,599,17,'online'),(NULL,0,'2019-11-29 22:14:15',NULL,5646,600,16,'cmdb1-4-8-15'),(NULL,0,'2019-11-29 22:14:15',NULL,5647,600,28,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,5648,600,24,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,5649,600,29,'ZJ'),(NULL,0,'2019-11-29 22:14:15',NULL,5650,600,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,5651,600,11,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,5652,600,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,5653,600,15,'10.4.8.15'),(NULL,0,'2019-11-29 22:14:15',NULL,5654,600,5,'cde414de3e97466599fd309d2a19ca69'),(NULL,0,'2019-11-29 22:14:15',NULL,5655,600,17,'online'),(NULL,0,'2019-11-29 22:14:15',NULL,5656,601,16,'cmdb1-4-8-16'),(NULL,0,'2019-11-29 22:14:15',NULL,5657,601,28,'prod'),(NULL,0,'2019-11-29 22:14:15',NULL,5658,601,24,'enable'),(NULL,0,'2019-11-29 22:14:15',NULL,5659,601,29,'ZJ'),(NULL,0,'2019-11-29 22:14:15',NULL,5660,601,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:14:15',NULL,5661,601,11,'pycook'),(NULL,0,'2019-11-29 22:14:15',NULL,5662,601,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:14:15',NULL,5663,601,15,'10.4.8.16'),(NULL,0,'2019-11-29 22:14:15',NULL,5664,601,5,'3645b5fda28e499d9d8bf19397682263'),(NULL,0,'2019-11-29 22:14:15',NULL,5665,601,17,'online'),(NULL,0,'2019-11-29 22:14:16',NULL,5666,602,1,'BU0002'),(NULL,0,'2019-11-29 22:14:16',NULL,5667,603,3,'Product2-1'),(NULL,0,'2019-11-29 22:14:16',NULL,5668,604,4,'App2-1-1'),(NULL,0,'2019-11-29 22:14:20',NULL,5781,621,4,'App2-1-2'),(NULL,0,'2019-11-29 22:14:24',NULL,5894,638,4,'App2-1-3'),(NULL,0,'2019-11-29 22:14:28',NULL,6007,655,4,'App2-1-4'),(NULL,0,'2019-11-29 22:14:32',NULL,6120,672,4,'App2-1-5'),(NULL,0,'2019-11-29 22:14:35',NULL,6233,689,4,'App2-1-6'),(NULL,0,'2019-11-29 22:14:39',NULL,6346,706,4,'App2-1-7'),(NULL,0,'2019-11-29 22:14:43',NULL,6459,723,4,'App2-1-8'),(NULL,0,'2019-11-29 22:14:48',NULL,6572,740,3,'Product2-2'),(NULL,0,'2019-11-29 22:14:48',NULL,6573,741,4,'App2-2-1'),(NULL,0,'2019-11-29 22:14:52',NULL,6686,758,4,'App2-2-2'),(NULL,0,'2019-11-29 22:14:56',NULL,6799,775,4,'App2-2-3'),(NULL,0,'2019-11-29 22:15:00',NULL,6912,792,4,'App2-2-4'),(NULL,0,'2019-11-29 22:15:03',NULL,7025,809,4,'App2-2-5'),(NULL,0,'2019-11-29 22:15:07',NULL,7138,826,4,'App2-2-6'),(NULL,0,'2019-11-29 22:15:11',NULL,7251,843,4,'App2-2-7'),(NULL,0,'2019-11-29 22:15:15',NULL,7364,860,4,'App2-2-8'),(NULL,0,'2019-11-29 22:15:19',NULL,7477,877,3,'Product2-3'),(NULL,0,'2019-11-29 22:15:20',NULL,7478,878,4,'App2-3-1'),(NULL,0,'2019-11-29 22:15:20',NULL,7479,879,16,'cmdb2-3-1-1'),(NULL,0,'2019-11-29 22:15:20',NULL,7480,879,28,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,7481,879,24,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,7482,879,29,'ZJ'),(NULL,0,'2019-11-29 22:15:20',NULL,7483,879,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,7484,879,11,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,7485,879,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,7486,879,15,'10.6.1.1'),(NULL,0,'2019-11-29 22:15:20',NULL,7487,879,5,'a51588e5ff69413dbd3a62a5e59ab75f'),(NULL,0,'2019-11-29 22:15:20',NULL,7488,879,17,'online'),(NULL,0,'2019-11-29 22:15:20',NULL,7489,880,16,'cmdb2-3-1-2'),(NULL,0,'2019-11-29 22:15:20',NULL,7490,880,28,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,7491,880,24,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,7492,880,29,'ZJ'),(NULL,0,'2019-11-29 22:15:20',NULL,7493,880,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,7494,880,11,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,7495,880,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,7496,880,15,'10.6.1.2'),(NULL,0,'2019-11-29 22:15:20',NULL,7497,880,5,'e7401a12eefb43e190ac00219b1b854e'),(NULL,0,'2019-11-29 22:15:20',NULL,7498,880,17,'online'),(NULL,0,'2019-11-29 22:15:20',NULL,7499,881,16,'cmdb2-3-1-3'),(NULL,0,'2019-11-29 22:15:20',NULL,7500,881,28,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,7501,881,24,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,7502,881,29,'ZJ'),(NULL,0,'2019-11-29 22:15:20',NULL,7503,881,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,7504,881,11,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,7505,881,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,7506,881,15,'10.6.1.3'),(NULL,0,'2019-11-29 22:15:20',NULL,7507,881,5,'d6739e303ad6477daba35cfdc7168486'),(NULL,0,'2019-11-29 22:15:20',NULL,7508,881,17,'online'),(NULL,0,'2019-11-29 22:15:20',NULL,7509,882,16,'cmdb2-3-1-4'),(NULL,0,'2019-11-29 22:15:20',NULL,7510,882,28,'prod'),(NULL,0,'2019-11-29 22:15:20',NULL,7511,882,24,'enable'),(NULL,0,'2019-11-29 22:15:20',NULL,7512,882,29,'ZJ'),(NULL,0,'2019-11-29 22:15:20',NULL,7513,882,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:20',NULL,7514,882,11,'pycook'),(NULL,0,'2019-11-29 22:15:20',NULL,7515,882,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:20',NULL,7516,882,15,'10.6.1.4'),(NULL,0,'2019-11-29 22:15:20',NULL,7517,882,5,'fede831bf67e4b6384dcf9cfc0f6e9cf'),(NULL,0,'2019-11-29 22:15:20',NULL,7518,882,17,'online'),(NULL,0,'2019-11-29 22:15:20',NULL,7519,883,16,'cmdb2-3-1-5'),(NULL,0,'2019-11-29 22:15:21',NULL,7520,883,28,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,7521,883,24,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,7522,883,29,'ZJ'),(NULL,0,'2019-11-29 22:15:21',NULL,7523,883,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,7524,883,11,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,7525,883,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,7526,883,15,'10.6.1.5'),(NULL,0,'2019-11-29 22:15:21',NULL,7527,883,5,'f86695c415354fd8b76a2fd0d4ed5632'),(NULL,0,'2019-11-29 22:15:21',NULL,7528,883,17,'online'),(NULL,0,'2019-11-29 22:15:21',NULL,7529,884,16,'cmdb2-3-1-6'),(NULL,0,'2019-11-29 22:15:21',NULL,7530,884,28,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,7531,884,24,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,7532,884,29,'ZJ'),(NULL,0,'2019-11-29 22:15:21',NULL,7533,884,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,7534,884,11,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,7535,884,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,7536,884,15,'10.6.1.6'),(NULL,0,'2019-11-29 22:15:21',NULL,7537,884,5,'346bc36452324ef18772e7a2f1e9334c'),(NULL,0,'2019-11-29 22:15:21',NULL,7538,884,17,'online'),(NULL,0,'2019-11-29 22:15:21',NULL,7539,885,16,'cmdb2-3-1-7'),(NULL,0,'2019-11-29 22:15:21',NULL,7540,885,28,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,7541,885,24,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,7542,885,29,'ZJ'),(NULL,0,'2019-11-29 22:15:21',NULL,7543,885,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,7544,885,11,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,7545,885,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,7546,885,15,'10.6.1.7'),(NULL,0,'2019-11-29 22:15:21',NULL,7547,885,5,'129c945885a84f86b4cf8f69ca6ff6dd'),(NULL,0,'2019-11-29 22:15:21',NULL,7548,885,17,'online'),(NULL,0,'2019-11-29 22:15:21',NULL,7549,886,16,'cmdb2-3-1-8'),(NULL,0,'2019-11-29 22:15:21',NULL,7550,886,28,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,7551,886,24,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,7552,886,29,'ZJ'),(NULL,0,'2019-11-29 22:15:21',NULL,7553,886,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:21',NULL,7554,886,11,'pycook'),(NULL,0,'2019-11-29 22:15:21',NULL,7555,886,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:21',NULL,7556,886,15,'10.6.1.8'),(NULL,0,'2019-11-29 22:15:21',NULL,7557,886,5,'8775da8c72da4e96a0afe20680d2908d'),(NULL,0,'2019-11-29 22:15:21',NULL,7558,886,17,'online'),(NULL,0,'2019-11-29 22:15:21',NULL,7559,887,16,'cmdb2-3-1-9'),(NULL,0,'2019-11-29 22:15:21',NULL,7560,887,28,'prod'),(NULL,0,'2019-11-29 22:15:21',NULL,7561,887,24,'enable'),(NULL,0,'2019-11-29 22:15:21',NULL,7562,887,29,'ZJ'),(NULL,0,'2019-11-29 22:15:21',NULL,7563,887,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,7564,887,11,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,7565,887,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,7566,887,15,'10.6.1.9'),(NULL,0,'2019-11-29 22:15:22',NULL,7567,887,5,'0dadd45c144542c1a94ffd125061daa4'),(NULL,0,'2019-11-29 22:15:22',NULL,7568,887,17,'online'),(NULL,0,'2019-11-29 22:15:22',NULL,7569,888,16,'cmdb2-3-1-10'),(NULL,0,'2019-11-29 22:15:22',NULL,7570,888,28,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,7571,888,24,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,7572,888,29,'ZJ'),(NULL,0,'2019-11-29 22:15:22',NULL,7573,888,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,7574,888,11,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,7575,888,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,7576,888,15,'10.6.1.10'),(NULL,0,'2019-11-29 22:15:22',NULL,7577,888,5,'40cc9f7ddaa1484dba1e34dc45a47e48'),(NULL,0,'2019-11-29 22:15:22',NULL,7578,888,17,'online'),(NULL,0,'2019-11-29 22:15:22',NULL,7579,889,16,'cmdb2-3-1-11'),(NULL,0,'2019-11-29 22:15:22',NULL,7580,889,28,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,7581,889,24,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,7582,889,29,'ZJ'),(NULL,0,'2019-11-29 22:15:22',NULL,7583,889,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,7584,889,11,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,7585,889,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,7586,889,15,'10.6.1.11'),(NULL,0,'2019-11-29 22:15:22',NULL,7587,889,5,'0967866961f1471d8a12671d87d27ca3'),(NULL,0,'2019-11-29 22:15:22',NULL,7588,889,17,'online'),(NULL,0,'2019-11-29 22:15:22',NULL,7589,890,16,'cmdb2-3-1-12'),(NULL,0,'2019-11-29 22:15:22',NULL,7590,890,28,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,7591,890,24,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,7592,890,29,'ZJ'),(NULL,0,'2019-11-29 22:15:22',NULL,7593,890,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,7594,890,11,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,7595,890,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,7596,890,15,'10.6.1.12'),(NULL,0,'2019-11-29 22:15:22',NULL,7597,890,5,'955586eca6eb4b2aa414c2bab0a4f6aa'),(NULL,0,'2019-11-29 22:15:22',NULL,7598,890,17,'online'),(NULL,0,'2019-11-29 22:15:22',NULL,7599,891,16,'cmdb2-3-1-13'),(NULL,0,'2019-11-29 22:15:22',NULL,7600,891,28,'prod'),(NULL,0,'2019-11-29 22:15:22',NULL,7601,891,24,'enable'),(NULL,0,'2019-11-29 22:15:22',NULL,7602,891,29,'ZJ'),(NULL,0,'2019-11-29 22:15:22',NULL,7603,891,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:22',NULL,7604,891,11,'pycook'),(NULL,0,'2019-11-29 22:15:22',NULL,7605,891,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:22',NULL,7606,891,15,'10.6.1.13'),(NULL,0,'2019-11-29 22:15:22',NULL,7607,891,5,'200ffc9f7c9a4e86a176ef7ef8960072'),(NULL,0,'2019-11-29 22:15:23',NULL,7608,891,17,'online'),(NULL,0,'2019-11-29 22:15:23',NULL,7609,892,16,'cmdb2-3-1-14'),(NULL,0,'2019-11-29 22:15:23',NULL,7610,892,28,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,7611,892,24,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,7612,892,29,'ZJ'),(NULL,0,'2019-11-29 22:15:23',NULL,7613,892,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,7614,892,11,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,7615,892,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,7616,892,15,'10.6.1.14'),(NULL,0,'2019-11-29 22:15:23',NULL,7617,892,5,'50c2ce4f47a74b89b3cefd2990b3e339'),(NULL,0,'2019-11-29 22:15:23',NULL,7618,892,17,'online'),(NULL,0,'2019-11-29 22:15:23',NULL,7619,893,16,'cmdb2-3-1-15'),(NULL,0,'2019-11-29 22:15:23',NULL,7620,893,28,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,7621,893,24,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,7622,893,29,'ZJ'),(NULL,0,'2019-11-29 22:15:23',NULL,7623,893,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,7624,893,11,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,7625,893,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,7626,893,15,'10.6.1.15'),(NULL,0,'2019-11-29 22:15:23',NULL,7627,893,5,'70d5e923a72443fd9f1c1fe17a4aa2fa'),(NULL,0,'2019-11-29 22:15:23',NULL,7628,893,17,'online'),(NULL,0,'2019-11-29 22:15:23',NULL,7629,894,16,'cmdb2-3-1-16'),(NULL,0,'2019-11-29 22:15:23',NULL,7630,894,28,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,7631,894,24,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,7632,894,29,'ZJ'),(NULL,0,'2019-11-29 22:15:23',NULL,7633,894,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,7634,894,11,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,7635,894,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,7636,894,15,'10.6.1.16'),(NULL,0,'2019-11-29 22:15:23',NULL,7637,894,5,'d6299d23c68c414594d2c71d5861ee62'),(NULL,0,'2019-11-29 22:15:23',NULL,7638,894,17,'online'),(NULL,0,'2019-11-29 22:15:23',NULL,7639,895,4,'App2-3-2'),(NULL,0,'2019-11-29 22:15:23',NULL,7640,896,16,'cmdb2-3-2-1'),(NULL,0,'2019-11-29 22:15:23',NULL,7641,896,28,'prod'),(NULL,0,'2019-11-29 22:15:23',NULL,7642,896,24,'enable'),(NULL,0,'2019-11-29 22:15:23',NULL,7643,896,29,'ZJ'),(NULL,0,'2019-11-29 22:15:23',NULL,7644,896,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:23',NULL,7645,896,11,'pycook'),(NULL,0,'2019-11-29 22:15:23',NULL,7646,896,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:23',NULL,7647,896,15,'10.6.2.1'),(NULL,0,'2019-11-29 22:15:23',NULL,7648,896,5,'4906bee8655348be85d89cde35504ba5'),(NULL,0,'2019-11-29 22:15:23',NULL,7649,896,17,'online'),(NULL,0,'2019-11-29 22:15:24',NULL,7650,897,16,'cmdb2-3-2-2'),(NULL,0,'2019-11-29 22:15:24',NULL,7651,897,28,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,7652,897,24,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,7653,897,29,'ZJ'),(NULL,0,'2019-11-29 22:15:24',NULL,7654,897,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,7655,897,11,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,7656,897,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,7657,897,15,'10.6.2.2'),(NULL,0,'2019-11-29 22:15:24',NULL,7658,897,5,'8f7d4ebadae44507a4ba71374c42cd96'),(NULL,0,'2019-11-29 22:15:24',NULL,7659,897,17,'online'),(NULL,0,'2019-11-29 22:15:24',NULL,7660,898,16,'cmdb2-3-2-3'),(NULL,0,'2019-11-29 22:15:24',NULL,7661,898,28,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,7662,898,24,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,7663,898,29,'ZJ'),(NULL,0,'2019-11-29 22:15:24',NULL,7664,898,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,7665,898,11,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,7666,898,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,7667,898,15,'10.6.2.3'),(NULL,0,'2019-11-29 22:15:24',NULL,7668,898,5,'aba7ad28c5cb4a5cb38451bac746fac4'),(NULL,0,'2019-11-29 22:15:24',NULL,7669,898,17,'online'),(NULL,0,'2019-11-29 22:15:24',NULL,7670,899,16,'cmdb2-3-2-4'),(NULL,0,'2019-11-29 22:15:24',NULL,7671,899,28,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,7672,899,24,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,7673,899,29,'ZJ'),(NULL,0,'2019-11-29 22:15:24',NULL,7674,899,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,7675,899,11,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,7676,899,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,7677,899,15,'10.6.2.4'),(NULL,0,'2019-11-29 22:15:24',NULL,7678,899,5,'8d808b6436a24345884fc9095d741838'),(NULL,0,'2019-11-29 22:15:24',NULL,7679,899,17,'online'),(NULL,0,'2019-11-29 22:15:24',NULL,7680,900,16,'cmdb2-3-2-5'),(NULL,0,'2019-11-29 22:15:24',NULL,7681,900,28,'prod'),(NULL,0,'2019-11-29 22:15:24',NULL,7682,900,24,'enable'),(NULL,0,'2019-11-29 22:15:24',NULL,7683,900,29,'ZJ'),(NULL,0,'2019-11-29 22:15:24',NULL,7684,900,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:24',NULL,7685,900,11,'pycook'),(NULL,0,'2019-11-29 22:15:24',NULL,7686,900,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:24',NULL,7687,900,15,'10.6.2.5'),(NULL,0,'2019-11-29 22:15:24',NULL,7688,900,5,'75b8dddf52914a6c96a89ae377dd7ac3'),(NULL,0,'2019-11-29 22:15:24',NULL,7689,900,17,'online'),(NULL,0,'2019-11-29 22:15:24',NULL,7690,901,16,'cmdb2-3-2-6'),(NULL,0,'2019-11-29 22:15:25',NULL,7691,901,28,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,7692,901,24,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,7693,901,29,'ZJ'),(NULL,0,'2019-11-29 22:15:25',NULL,7694,901,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,7695,901,11,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,7696,901,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,7697,901,15,'10.6.2.6'),(NULL,0,'2019-11-29 22:15:25',NULL,7698,901,5,'929ae3f143b742ee81ec316a25ede075'),(NULL,0,'2019-11-29 22:15:25',NULL,7699,901,17,'online'),(NULL,0,'2019-11-29 22:15:25',NULL,7700,902,16,'cmdb2-3-2-7'),(NULL,0,'2019-11-29 22:15:25',NULL,7701,902,28,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,7702,902,24,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,7703,902,29,'ZJ'),(NULL,0,'2019-11-29 22:15:25',NULL,7704,902,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,7705,902,11,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,7706,902,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,7707,902,15,'10.6.2.7'),(NULL,0,'2019-11-29 22:15:25',NULL,7708,902,5,'da27aba3d9ef4234ae715878b034920c'),(NULL,0,'2019-11-29 22:15:25',NULL,7709,902,17,'online'),(NULL,0,'2019-11-29 22:15:25',NULL,7710,903,16,'cmdb2-3-2-8'),(NULL,0,'2019-11-29 22:15:25',NULL,7711,903,28,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,7712,903,24,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,7713,903,29,'ZJ'),(NULL,0,'2019-11-29 22:15:25',NULL,7714,903,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,7715,903,11,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,7716,903,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,7717,903,15,'10.6.2.8'),(NULL,0,'2019-11-29 22:15:25',NULL,7718,903,5,'e2c2df1da0f8426181f5d64da5bf8d3b'),(NULL,0,'2019-11-29 22:15:25',NULL,7719,903,17,'online'),(NULL,0,'2019-11-29 22:15:25',NULL,7720,904,16,'cmdb2-3-2-9'),(NULL,0,'2019-11-29 22:15:25',NULL,7721,904,28,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,7722,904,24,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,7723,904,29,'ZJ'),(NULL,0,'2019-11-29 22:15:25',NULL,7724,904,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,7725,904,11,'pycook'),(NULL,0,'2019-11-29 22:15:25',NULL,7726,904,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:25',NULL,7727,904,15,'10.6.2.9'),(NULL,0,'2019-11-29 22:15:25',NULL,7728,904,5,'3f615595fe3a47ed8a71f054f32803b2'),(NULL,0,'2019-11-29 22:15:25',NULL,7729,904,17,'online'),(NULL,0,'2019-11-29 22:15:25',NULL,7730,905,16,'cmdb2-3-2-10'),(NULL,0,'2019-11-29 22:15:25',NULL,7731,905,28,'prod'),(NULL,0,'2019-11-29 22:15:25',NULL,7732,905,24,'enable'),(NULL,0,'2019-11-29 22:15:25',NULL,7733,905,29,'ZJ'),(NULL,0,'2019-11-29 22:15:25',NULL,7734,905,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:25',NULL,7735,905,11,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,7736,905,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,7737,905,15,'10.6.2.10'),(NULL,0,'2019-11-29 22:15:26',NULL,7738,905,5,'653cf1ca94884b42a20b62ed1f77fd0f'),(NULL,0,'2019-11-29 22:15:26',NULL,7739,905,17,'online'),(NULL,0,'2019-11-29 22:15:26',NULL,7740,906,16,'cmdb2-3-2-11'),(NULL,0,'2019-11-29 22:15:26',NULL,7741,906,28,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,7742,906,24,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,7743,906,29,'ZJ'),(NULL,0,'2019-11-29 22:15:26',NULL,7744,906,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,7745,906,11,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,7746,906,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,7747,906,15,'10.6.2.11'),(NULL,0,'2019-11-29 22:15:26',NULL,7748,906,5,'e2a689f0bf364e4cb0388801c1744506'),(NULL,0,'2019-11-29 22:15:26',NULL,7749,906,17,'online'),(NULL,0,'2019-11-29 22:15:26',NULL,7750,907,16,'cmdb2-3-2-12'),(NULL,0,'2019-11-29 22:15:26',NULL,7751,907,28,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,7752,907,24,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,7753,907,29,'ZJ'),(NULL,0,'2019-11-29 22:15:26',NULL,7754,907,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,7755,907,11,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,7756,907,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,7757,907,15,'10.6.2.12'),(NULL,0,'2019-11-29 22:15:26',NULL,7758,907,5,'ffc8e85cb1a54f44b52dfad60befd8cf'),(NULL,0,'2019-11-29 22:15:26',NULL,7759,907,17,'online'),(NULL,0,'2019-11-29 22:15:26',NULL,7760,908,16,'cmdb2-3-2-13'),(NULL,0,'2019-11-29 22:15:26',NULL,7761,908,28,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,7762,908,24,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,7763,908,29,'ZJ'),(NULL,0,'2019-11-29 22:15:26',NULL,7764,908,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,7765,908,11,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,7766,908,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,7767,908,15,'10.6.2.13'),(NULL,0,'2019-11-29 22:15:26',NULL,7768,908,5,'e085988d580c4b94a5dc7f433d557846'),(NULL,0,'2019-11-29 22:15:26',NULL,7769,908,17,'online'),(NULL,0,'2019-11-29 22:15:26',NULL,7770,909,16,'cmdb2-3-2-14'),(NULL,0,'2019-11-29 22:15:26',NULL,7771,909,28,'prod'),(NULL,0,'2019-11-29 22:15:26',NULL,7772,909,24,'enable'),(NULL,0,'2019-11-29 22:15:26',NULL,7773,909,29,'ZJ'),(NULL,0,'2019-11-29 22:15:26',NULL,7774,909,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:26',NULL,7775,909,11,'pycook'),(NULL,0,'2019-11-29 22:15:26',NULL,7776,909,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:26',NULL,7777,909,15,'10.6.2.14'),(NULL,0,'2019-11-29 22:15:26',NULL,7778,909,5,'50faee862d2841348f5570812bc7a8ff'),(NULL,0,'2019-11-29 22:15:26',NULL,7779,909,17,'online'),(NULL,0,'2019-11-29 22:15:27',NULL,7780,910,16,'cmdb2-3-2-15'),(NULL,0,'2019-11-29 22:15:27',NULL,7781,910,28,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,7782,910,24,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,7783,910,29,'ZJ'),(NULL,0,'2019-11-29 22:15:27',NULL,7784,910,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,7785,910,11,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,7786,910,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,7787,910,15,'10.6.2.15'),(NULL,0,'2019-11-29 22:15:27',NULL,7788,910,5,'a262f90dea93417cb60c0bacba34f35e'),(NULL,0,'2019-11-29 22:15:27',NULL,7789,910,17,'online'),(NULL,0,'2019-11-29 22:15:27',NULL,7790,911,16,'cmdb2-3-2-16'),(NULL,0,'2019-11-29 22:15:27',NULL,7791,911,28,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,7792,911,24,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,7793,911,29,'ZJ'),(NULL,0,'2019-11-29 22:15:27',NULL,7794,911,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,7795,911,11,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,7796,911,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,7797,911,15,'10.6.2.16'),(NULL,0,'2019-11-29 22:15:27',NULL,7798,911,5,'e7609bf8c37e4df9b1c668d8fe923e31'),(NULL,0,'2019-11-29 22:15:27',NULL,7799,911,17,'online'),(NULL,0,'2019-11-29 22:15:27',NULL,7800,912,4,'App2-3-3'),(NULL,0,'2019-11-29 22:15:27',NULL,7801,913,16,'cmdb2-3-3-1'),(NULL,0,'2019-11-29 22:15:27',NULL,7802,913,28,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,7803,913,24,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,7804,913,29,'ZJ'),(NULL,0,'2019-11-29 22:15:27',NULL,7805,913,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,7806,913,11,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,7807,913,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,7808,913,15,'10.6.3.1'),(NULL,0,'2019-11-29 22:15:27',NULL,7809,913,5,'8121e27494e94612a3334771af9bce6c'),(NULL,0,'2019-11-29 22:15:27',NULL,7810,913,17,'online'),(NULL,0,'2019-11-29 22:15:27',NULL,7811,914,16,'cmdb2-3-3-2'),(NULL,0,'2019-11-29 22:15:27',NULL,7812,914,28,'prod'),(NULL,0,'2019-11-29 22:15:27',NULL,7813,914,24,'enable'),(NULL,0,'2019-11-29 22:15:27',NULL,7814,914,29,'ZJ'),(NULL,0,'2019-11-29 22:15:27',NULL,7815,914,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:27',NULL,7816,914,11,'pycook'),(NULL,0,'2019-11-29 22:15:27',NULL,7817,914,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:27',NULL,7818,914,15,'10.6.3.2'),(NULL,0,'2019-11-29 22:15:27',NULL,7819,914,5,'c90204263f8942168ae0b146c3a36a01'),(NULL,0,'2019-11-29 22:15:27',NULL,7820,914,17,'online'),(NULL,0,'2019-11-29 22:15:28',NULL,7821,915,16,'cmdb2-3-3-3'),(NULL,0,'2019-11-29 22:15:28',NULL,7822,915,28,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,7823,915,24,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,7824,915,29,'ZJ'),(NULL,0,'2019-11-29 22:15:28',NULL,7825,915,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,7826,915,11,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,7827,915,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,7828,915,15,'10.6.3.3'),(NULL,0,'2019-11-29 22:15:28',NULL,7829,915,5,'f7d03b9ecc084bd391b58d1afd02671c'),(NULL,0,'2019-11-29 22:15:28',NULL,7830,915,17,'online'),(NULL,0,'2019-11-29 22:15:28',NULL,7831,916,16,'cmdb2-3-3-4'),(NULL,0,'2019-11-29 22:15:28',NULL,7832,916,28,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,7833,916,24,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,7834,916,29,'ZJ'),(NULL,0,'2019-11-29 22:15:28',NULL,7835,916,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,7836,916,11,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,7837,916,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,7838,916,15,'10.6.3.4'),(NULL,0,'2019-11-29 22:15:28',NULL,7839,916,5,'3f9b57fbb9bd4cb7bb99058cee005d20'),(NULL,0,'2019-11-29 22:15:28',NULL,7840,916,17,'online'),(NULL,0,'2019-11-29 22:15:28',NULL,7841,917,16,'cmdb2-3-3-5'),(NULL,0,'2019-11-29 22:15:28',NULL,7842,917,28,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,7843,917,24,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,7844,917,29,'ZJ'),(NULL,0,'2019-11-29 22:15:28',NULL,7845,917,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,7846,917,11,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,7847,917,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,7848,917,15,'10.6.3.5'),(NULL,0,'2019-11-29 22:15:28',NULL,7849,917,5,'b427ee9775784e19b35042dbe748dc10'),(NULL,0,'2019-11-29 22:15:28',NULL,7850,917,17,'online'),(NULL,0,'2019-11-29 22:15:28',NULL,7851,918,16,'cmdb2-3-3-6'),(NULL,0,'2019-11-29 22:15:28',NULL,7852,918,28,'prod'),(NULL,0,'2019-11-29 22:15:28',NULL,7853,918,24,'enable'),(NULL,0,'2019-11-29 22:15:28',NULL,7854,918,29,'ZJ'),(NULL,0,'2019-11-29 22:15:28',NULL,7855,918,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:28',NULL,7856,918,11,'pycook'),(NULL,0,'2019-11-29 22:15:28',NULL,7857,918,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:28',NULL,7858,918,15,'10.6.3.6'),(NULL,0,'2019-11-29 22:15:28',NULL,7859,918,5,'1c453a163b5b43ae80db3477e3a83cf1'),(NULL,0,'2019-11-29 22:15:28',NULL,7860,918,17,'online'),(NULL,0,'2019-11-29 22:15:28',NULL,7861,919,16,'cmdb2-3-3-7'),(NULL,0,'2019-11-29 22:15:28',NULL,7862,919,28,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,7863,919,24,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,7864,919,29,'ZJ'),(NULL,0,'2019-11-29 22:15:29',NULL,7865,919,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,7866,919,11,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,7867,919,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,7868,919,15,'10.6.3.7'),(NULL,0,'2019-11-29 22:15:29',NULL,7869,919,5,'85b2b06c544048ae99979a310f5f7023'),(NULL,0,'2019-11-29 22:15:29',NULL,7870,919,17,'online'),(NULL,0,'2019-11-29 22:15:29',NULL,7871,920,16,'cmdb2-3-3-8'),(NULL,0,'2019-11-29 22:15:29',NULL,7872,920,28,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,7873,920,24,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,7874,920,29,'ZJ'),(NULL,0,'2019-11-29 22:15:29',NULL,7875,920,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,7876,920,11,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,7877,920,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,7878,920,15,'10.6.3.8'),(NULL,0,'2019-11-29 22:15:29',NULL,7879,920,5,'617cac71514d46cdb163b9c057593f4d'),(NULL,0,'2019-11-29 22:15:29',NULL,7880,920,17,'online'),(NULL,0,'2019-11-29 22:15:29',NULL,7881,921,16,'cmdb2-3-3-9'),(NULL,0,'2019-11-29 22:15:29',NULL,7882,921,28,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,7883,921,24,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,7884,921,29,'ZJ'),(NULL,0,'2019-11-29 22:15:29',NULL,7885,921,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,7886,921,11,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,7887,921,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,7888,921,15,'10.6.3.9'),(NULL,0,'2019-11-29 22:15:29',NULL,7889,921,5,'fa575de38b4d4d94986391b9a7b70729'),(NULL,0,'2019-11-29 22:15:29',NULL,7890,921,17,'online'),(NULL,0,'2019-11-29 22:15:29',NULL,7891,922,16,'cmdb2-3-3-10'),(NULL,0,'2019-11-29 22:15:29',NULL,7892,922,28,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,7893,922,24,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,7894,922,29,'ZJ'),(NULL,0,'2019-11-29 22:15:29',NULL,7895,922,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,7896,922,11,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,7897,922,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,7898,922,15,'10.6.3.10'),(NULL,0,'2019-11-29 22:15:29',NULL,7899,922,5,'026da94df6a5447992e7361ddb6b45ba'),(NULL,0,'2019-11-29 22:15:29',NULL,7900,922,17,'online'),(NULL,0,'2019-11-29 22:15:29',NULL,7901,923,16,'cmdb2-3-3-11'),(NULL,0,'2019-11-29 22:15:29',NULL,7902,923,28,'prod'),(NULL,0,'2019-11-29 22:15:29',NULL,7903,923,24,'enable'),(NULL,0,'2019-11-29 22:15:29',NULL,7904,923,29,'ZJ'),(NULL,0,'2019-11-29 22:15:29',NULL,7905,923,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:29',NULL,7906,923,11,'pycook'),(NULL,0,'2019-11-29 22:15:29',NULL,7907,923,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:29',NULL,7908,923,15,'10.6.3.11'),(NULL,0,'2019-11-29 22:15:30',NULL,7909,923,5,'e346bad70c874d488adcf8bee9b6bd00'),(NULL,0,'2019-11-29 22:15:30',NULL,7910,923,17,'online'),(NULL,0,'2019-11-29 22:15:30',NULL,7911,924,16,'cmdb2-3-3-12'),(NULL,0,'2019-11-29 22:15:30',NULL,7912,924,28,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,7913,924,24,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,7914,924,29,'ZJ'),(NULL,0,'2019-11-29 22:15:30',NULL,7915,924,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,7916,924,11,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,7917,924,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,7918,924,15,'10.6.3.12'),(NULL,0,'2019-11-29 22:15:30',NULL,7919,924,5,'a13595606ec741ea8bdc7266c163a76a'),(NULL,0,'2019-11-29 22:15:30',NULL,7920,924,17,'online'),(NULL,0,'2019-11-29 22:15:30',NULL,7921,925,16,'cmdb2-3-3-13'),(NULL,0,'2019-11-29 22:15:30',NULL,7922,925,28,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,7923,925,24,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,7924,925,29,'ZJ'),(NULL,0,'2019-11-29 22:15:30',NULL,7925,925,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,7926,925,11,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,7927,925,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,7928,925,15,'10.6.3.13'),(NULL,0,'2019-11-29 22:15:30',NULL,7929,925,5,'9eeeaddf6dd74582bd5f5c55120b6dd2'),(NULL,0,'2019-11-29 22:15:30',NULL,7930,925,17,'online'),(NULL,0,'2019-11-29 22:15:30',NULL,7931,926,16,'cmdb2-3-3-14'),(NULL,0,'2019-11-29 22:15:30',NULL,7932,926,28,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,7933,926,24,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,7934,926,29,'ZJ'),(NULL,0,'2019-11-29 22:15:30',NULL,7935,926,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,7936,926,11,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,7937,926,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,7938,926,15,'10.6.3.14'),(NULL,0,'2019-11-29 22:15:30',NULL,7939,926,5,'0f342327ef7741e694d63833f6dc41cb'),(NULL,0,'2019-11-29 22:15:30',NULL,7940,926,17,'online'),(NULL,0,'2019-11-29 22:15:30',NULL,7941,927,16,'cmdb2-3-3-15'),(NULL,0,'2019-11-29 22:15:30',NULL,7942,927,28,'prod'),(NULL,0,'2019-11-29 22:15:30',NULL,7943,927,24,'enable'),(NULL,0,'2019-11-29 22:15:30',NULL,7944,927,29,'ZJ'),(NULL,0,'2019-11-29 22:15:30',NULL,7945,927,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:30',NULL,7946,927,11,'pycook'),(NULL,0,'2019-11-29 22:15:30',NULL,7947,927,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:30',NULL,7948,927,15,'10.6.3.15'),(NULL,0,'2019-11-29 22:15:30',NULL,7949,927,5,'ade4a2dc470b487b853d0335faa8f662'),(NULL,0,'2019-11-29 22:15:30',NULL,7950,927,17,'online'),(NULL,0,'2019-11-29 22:15:31',NULL,7951,928,16,'cmdb2-3-3-16'),(NULL,0,'2019-11-29 22:15:31',NULL,7952,928,28,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,7953,928,24,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,7954,928,29,'ZJ'),(NULL,0,'2019-11-29 22:15:31',NULL,7955,928,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,7956,928,11,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,7957,928,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,7958,928,15,'10.6.3.16'),(NULL,0,'2019-11-29 22:15:31',NULL,7959,928,5,'726485a0297740eaa1484195cfa46ac9'),(NULL,0,'2019-11-29 22:15:31',NULL,7960,928,17,'online'),(NULL,0,'2019-11-29 22:15:31',NULL,7961,929,4,'App2-3-4'),(NULL,0,'2019-11-29 22:15:31',NULL,7962,930,16,'cmdb2-3-4-1'),(NULL,0,'2019-11-29 22:15:31',NULL,7963,930,28,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,7964,930,24,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,7965,930,29,'ZJ'),(NULL,0,'2019-11-29 22:15:31',NULL,7966,930,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,7967,930,11,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,7968,930,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,7969,930,15,'10.6.4.1'),(NULL,0,'2019-11-29 22:15:31',NULL,7970,930,5,'0f8beca863f64c35981fcd0b6da79051'),(NULL,0,'2019-11-29 22:15:31',NULL,7971,930,17,'online'),(NULL,0,'2019-11-29 22:15:31',NULL,7972,931,16,'cmdb2-3-4-2'),(NULL,0,'2019-11-29 22:15:31',NULL,7973,931,28,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,7974,931,24,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,7975,931,29,'ZJ'),(NULL,0,'2019-11-29 22:15:31',NULL,7976,931,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,7977,931,11,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,7978,931,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,7979,931,15,'10.6.4.2'),(NULL,0,'2019-11-29 22:15:31',NULL,7980,931,5,'b324341056974b87bb63eba4e1e84d09'),(NULL,0,'2019-11-29 22:15:31',NULL,7981,931,17,'online'),(NULL,0,'2019-11-29 22:15:31',NULL,7982,932,16,'cmdb2-3-4-3'),(NULL,0,'2019-11-29 22:15:31',NULL,7983,932,28,'prod'),(NULL,0,'2019-11-29 22:15:31',NULL,7984,932,24,'enable'),(NULL,0,'2019-11-29 22:15:31',NULL,7985,932,29,'ZJ'),(NULL,0,'2019-11-29 22:15:31',NULL,7986,932,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:31',NULL,7987,932,11,'pycook'),(NULL,0,'2019-11-29 22:15:31',NULL,7988,932,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:31',NULL,7989,932,15,'10.6.4.3'),(NULL,0,'2019-11-29 22:15:31',NULL,7990,932,5,'6105d4e9a9f74c42bee6e512300c3c11'),(NULL,0,'2019-11-29 22:15:31',NULL,7991,932,17,'online'),(NULL,0,'2019-11-29 22:15:32',NULL,7992,933,16,'cmdb2-3-4-4'),(NULL,0,'2019-11-29 22:15:32',NULL,7993,933,28,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,7994,933,24,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,7995,933,29,'ZJ'),(NULL,0,'2019-11-29 22:15:32',NULL,7996,933,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,7997,933,11,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,7998,933,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,7999,933,15,'10.6.4.4'),(NULL,0,'2019-11-29 22:15:32',NULL,8000,933,5,'9c23f2955b0c4bb3b9199dd01d3f6ba3'),(NULL,0,'2019-11-29 22:15:32',NULL,8001,933,17,'online'),(NULL,0,'2019-11-29 22:15:32',NULL,8002,934,16,'cmdb2-3-4-5'),(NULL,0,'2019-11-29 22:15:32',NULL,8003,934,28,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,8004,934,24,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,8005,934,29,'ZJ'),(NULL,0,'2019-11-29 22:15:32',NULL,8006,934,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,8007,934,11,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,8008,934,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,8009,934,15,'10.6.4.5'),(NULL,0,'2019-11-29 22:15:32',NULL,8010,934,5,'6fa3953735fd4c42910eb251a22405f1'),(NULL,0,'2019-11-29 22:15:32',NULL,8011,934,17,'online'),(NULL,0,'2019-11-29 22:15:32',NULL,8012,935,16,'cmdb2-3-4-6'),(NULL,0,'2019-11-29 22:15:32',NULL,8013,935,28,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,8014,935,24,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,8015,935,29,'ZJ'),(NULL,0,'2019-11-29 22:15:32',NULL,8016,935,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,8017,935,11,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,8018,935,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,8019,935,15,'10.6.4.6'),(NULL,0,'2019-11-29 22:15:32',NULL,8020,935,5,'cb8f2371a62842498407cd35f2a6153b'),(NULL,0,'2019-11-29 22:15:32',NULL,8021,935,17,'online'),(NULL,0,'2019-11-29 22:15:32',NULL,8022,936,16,'cmdb2-3-4-7'),(NULL,0,'2019-11-29 22:15:32',NULL,8023,936,28,'prod'),(NULL,0,'2019-11-29 22:15:32',NULL,8024,936,24,'enable'),(NULL,0,'2019-11-29 22:15:32',NULL,8025,936,29,'ZJ'),(NULL,0,'2019-11-29 22:15:32',NULL,8026,936,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:32',NULL,8027,936,11,'pycook'),(NULL,0,'2019-11-29 22:15:32',NULL,8028,936,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:32',NULL,8029,936,15,'10.6.4.7'),(NULL,0,'2019-11-29 22:15:32',NULL,8030,936,5,'c5b03f91d9554f81afd7c8b0c0ac756a'),(NULL,0,'2019-11-29 22:15:32',NULL,8031,936,17,'online'),(NULL,0,'2019-11-29 22:15:32',NULL,8032,937,16,'cmdb2-3-4-8'),(NULL,0,'2019-11-29 22:15:32',NULL,8033,937,28,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,8034,937,24,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,8035,937,29,'ZJ'),(NULL,0,'2019-11-29 22:15:33',NULL,8036,937,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,8037,937,11,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,8038,937,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,8039,937,15,'10.6.4.8'),(NULL,0,'2019-11-29 22:15:33',NULL,8040,937,5,'7d508f974e3c4df69ffa5da9e6abab37'),(NULL,0,'2019-11-29 22:15:33',NULL,8041,937,17,'online'),(NULL,0,'2019-11-29 22:15:33',NULL,8042,938,16,'cmdb2-3-4-9'),(NULL,0,'2019-11-29 22:15:33',NULL,8043,938,28,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,8044,938,24,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,8045,938,29,'ZJ'),(NULL,0,'2019-11-29 22:15:33',NULL,8046,938,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,8047,938,11,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,8048,938,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,8049,938,15,'10.6.4.9'),(NULL,0,'2019-11-29 22:15:33',NULL,8050,938,5,'bc2d884128df4300adc5f7be1461c780'),(NULL,0,'2019-11-29 22:15:33',NULL,8051,938,17,'online'),(NULL,0,'2019-11-29 22:15:33',NULL,8052,939,16,'cmdb2-3-4-10'),(NULL,0,'2019-11-29 22:15:33',NULL,8053,939,28,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,8054,939,24,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,8055,939,29,'ZJ'),(NULL,0,'2019-11-29 22:15:33',NULL,8056,939,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,8057,939,11,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,8058,939,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,8059,939,15,'10.6.4.10'),(NULL,0,'2019-11-29 22:15:33',NULL,8060,939,5,'0b89dd5d406849748a963c7597b11ddb'),(NULL,0,'2019-11-29 22:15:33',NULL,8061,939,17,'online'),(NULL,0,'2019-11-29 22:15:33',NULL,8062,940,16,'cmdb2-3-4-11'),(NULL,0,'2019-11-29 22:15:33',NULL,8063,940,28,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,8064,940,24,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,8065,940,29,'ZJ'),(NULL,0,'2019-11-29 22:15:33',NULL,8066,940,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,8067,940,11,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,8068,940,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,8069,940,15,'10.6.4.11'),(NULL,0,'2019-11-29 22:15:33',NULL,8070,940,5,'792ef66eda2046f6a0699fbfe2d1a781'),(NULL,0,'2019-11-29 22:15:33',NULL,8071,940,17,'online'),(NULL,0,'2019-11-29 22:15:33',NULL,8072,941,16,'cmdb2-3-4-12'),(NULL,0,'2019-11-29 22:15:33',NULL,8073,941,28,'prod'),(NULL,0,'2019-11-29 22:15:33',NULL,8074,941,24,'enable'),(NULL,0,'2019-11-29 22:15:33',NULL,8075,941,29,'ZJ'),(NULL,0,'2019-11-29 22:15:33',NULL,8076,941,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:33',NULL,8077,941,11,'pycook'),(NULL,0,'2019-11-29 22:15:33',NULL,8078,941,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:33',NULL,8079,941,15,'10.6.4.12'),(NULL,0,'2019-11-29 22:15:34',NULL,8080,941,5,'c5eac1cf026b4fb2a20662ff2b2d89ab'),(NULL,0,'2019-11-29 22:15:34',NULL,8081,941,17,'online'),(NULL,0,'2019-11-29 22:15:34',NULL,8082,942,16,'cmdb2-3-4-13'),(NULL,0,'2019-11-29 22:15:34',NULL,8083,942,28,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,8084,942,24,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,8085,942,29,'ZJ'),(NULL,0,'2019-11-29 22:15:34',NULL,8086,942,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,8087,942,11,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,8088,942,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,8089,942,15,'10.6.4.13'),(NULL,0,'2019-11-29 22:15:34',NULL,8090,942,5,'cf93ff9fdf0246a3afb252f85f33dea8'),(NULL,0,'2019-11-29 22:15:34',NULL,8091,942,17,'online'),(NULL,0,'2019-11-29 22:15:34',NULL,8092,943,16,'cmdb2-3-4-14'),(NULL,0,'2019-11-29 22:15:34',NULL,8093,943,28,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,8094,943,24,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,8095,943,29,'ZJ'),(NULL,0,'2019-11-29 22:15:34',NULL,8096,943,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,8097,943,11,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,8098,943,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,8099,943,15,'10.6.4.14'),(NULL,0,'2019-11-29 22:15:34',NULL,8100,943,5,'789183f3a6554fe6ab4b33f9a81c7f79'),(NULL,0,'2019-11-29 22:15:34',NULL,8101,943,17,'online'),(NULL,0,'2019-11-29 22:15:34',NULL,8102,944,16,'cmdb2-3-4-15'),(NULL,0,'2019-11-29 22:15:34',NULL,8103,944,28,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,8104,944,24,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,8105,944,29,'ZJ'),(NULL,0,'2019-11-29 22:15:34',NULL,8106,944,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,8107,944,11,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,8108,944,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,8109,944,15,'10.6.4.15'),(NULL,0,'2019-11-29 22:15:34',NULL,8110,944,5,'2a4acaa1d49149fcb247177c027e8128'),(NULL,0,'2019-11-29 22:15:34',NULL,8111,944,17,'online'),(NULL,0,'2019-11-29 22:15:34',NULL,8112,945,16,'cmdb2-3-4-16'),(NULL,0,'2019-11-29 22:15:34',NULL,8113,945,28,'prod'),(NULL,0,'2019-11-29 22:15:34',NULL,8114,945,24,'enable'),(NULL,0,'2019-11-29 22:15:34',NULL,8115,945,29,'ZJ'),(NULL,0,'2019-11-29 22:15:34',NULL,8116,945,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:34',NULL,8117,945,11,'pycook'),(NULL,0,'2019-11-29 22:15:34',NULL,8118,945,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:34',NULL,8119,945,15,'10.6.4.16'),(NULL,0,'2019-11-29 22:15:34',NULL,8120,945,5,'8cdf163dd50546ef9125c4a7bad1fd5c'),(NULL,0,'2019-11-29 22:15:34',NULL,8121,945,17,'online'),(NULL,0,'2019-11-29 22:15:35',NULL,8122,946,4,'App2-3-5'),(NULL,0,'2019-11-29 22:15:35',NULL,8123,947,16,'cmdb2-3-5-1'),(NULL,0,'2019-11-29 22:15:35',NULL,8124,947,28,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,8125,947,24,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,8126,947,29,'ZJ'),(NULL,0,'2019-11-29 22:15:35',NULL,8127,947,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,8128,947,11,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,8129,947,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,8130,947,15,'10.6.5.1'),(NULL,0,'2019-11-29 22:15:35',NULL,8131,947,5,'45d2099af1034aca9f1a4f0bfcf88f09'),(NULL,0,'2019-11-29 22:15:35',NULL,8132,947,17,'online'),(NULL,0,'2019-11-29 22:15:35',NULL,8133,948,16,'cmdb2-3-5-2'),(NULL,0,'2019-11-29 22:15:35',NULL,8134,948,28,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,8135,948,24,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,8136,948,29,'ZJ'),(NULL,0,'2019-11-29 22:15:35',NULL,8137,948,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,8138,948,11,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,8139,948,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,8140,948,15,'10.6.5.2'),(NULL,0,'2019-11-29 22:15:35',NULL,8141,948,5,'f98e3993085b45adac4a0ab9a007bf11'),(NULL,0,'2019-11-29 22:15:35',NULL,8142,948,17,'online'),(NULL,0,'2019-11-29 22:15:35',NULL,8143,949,16,'cmdb2-3-5-3'),(NULL,0,'2019-11-29 22:15:35',NULL,8144,949,28,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,8145,949,24,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,8146,949,29,'ZJ'),(NULL,0,'2019-11-29 22:15:35',NULL,8147,949,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,8148,949,11,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,8149,949,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,8150,949,15,'10.6.5.3'),(NULL,0,'2019-11-29 22:15:35',NULL,8151,949,5,'94c173e2a2c0493e85b3f2288f05843d'),(NULL,0,'2019-11-29 22:15:35',NULL,8152,949,17,'online'),(NULL,0,'2019-11-29 22:15:35',NULL,8153,950,16,'cmdb2-3-5-4'),(NULL,0,'2019-11-29 22:15:35',NULL,8154,950,28,'prod'),(NULL,0,'2019-11-29 22:15:35',NULL,8155,950,24,'enable'),(NULL,0,'2019-11-29 22:15:35',NULL,8156,950,29,'ZJ'),(NULL,0,'2019-11-29 22:15:35',NULL,8157,950,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:35',NULL,8158,950,11,'pycook'),(NULL,0,'2019-11-29 22:15:35',NULL,8159,950,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:35',NULL,8160,950,15,'10.6.5.4'),(NULL,0,'2019-11-29 22:15:35',NULL,8161,950,5,'3a200c82ac0f47f48e8f16f03e328064'),(NULL,0,'2019-11-29 22:15:35',NULL,8162,950,17,'online'),(NULL,0,'2019-11-29 22:15:36',NULL,8163,951,16,'cmdb2-3-5-5'),(NULL,0,'2019-11-29 22:15:36',NULL,8164,951,28,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,8165,951,24,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,8166,951,29,'ZJ'),(NULL,0,'2019-11-29 22:15:36',NULL,8167,951,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,8168,951,11,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,8169,951,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,8170,951,15,'10.6.5.5'),(NULL,0,'2019-11-29 22:15:36',NULL,8171,951,5,'d49836803eed4ba9abe9873391b729fc'),(NULL,0,'2019-11-29 22:15:36',NULL,8172,951,17,'online'),(NULL,0,'2019-11-29 22:15:36',NULL,8173,952,16,'cmdb2-3-5-6'),(NULL,0,'2019-11-29 22:15:36',NULL,8174,952,28,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,8175,952,24,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,8176,952,29,'ZJ'),(NULL,0,'2019-11-29 22:15:36',NULL,8177,952,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,8178,952,11,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,8179,952,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,8180,952,15,'10.6.5.6'),(NULL,0,'2019-11-29 22:15:36',NULL,8181,952,5,'6ed982a4c7b84e30872c555248a58ce2'),(NULL,0,'2019-11-29 22:15:36',NULL,8182,952,17,'online'),(NULL,0,'2019-11-29 22:15:36',NULL,8183,953,16,'cmdb2-3-5-7'),(NULL,0,'2019-11-29 22:15:36',NULL,8184,953,28,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,8185,953,24,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,8186,953,29,'ZJ'),(NULL,0,'2019-11-29 22:15:36',NULL,8187,953,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,8188,953,11,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,8189,953,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,8190,953,15,'10.6.5.7'),(NULL,0,'2019-11-29 22:15:36',NULL,8191,953,5,'bb29e40425de4f40baaa1fb1878f8cc5'),(NULL,0,'2019-11-29 22:15:36',NULL,8192,953,17,'online'),(NULL,0,'2019-11-29 22:15:36',NULL,8193,954,16,'cmdb2-3-5-8'),(NULL,0,'2019-11-29 22:15:36',NULL,8194,954,28,'prod'),(NULL,0,'2019-11-29 22:15:36',NULL,8195,954,24,'enable'),(NULL,0,'2019-11-29 22:15:36',NULL,8196,954,29,'ZJ'),(NULL,0,'2019-11-29 22:15:36',NULL,8197,954,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:36',NULL,8198,954,11,'pycook'),(NULL,0,'2019-11-29 22:15:36',NULL,8199,954,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:36',NULL,8200,954,15,'10.6.5.8'),(NULL,0,'2019-11-29 22:15:36',NULL,8201,954,5,'548a4b736fd74bb5ad890741f16ba062'),(NULL,0,'2019-11-29 22:15:36',NULL,8202,954,17,'online'),(NULL,0,'2019-11-29 22:15:36',NULL,8203,955,16,'cmdb2-3-5-9'),(NULL,0,'2019-11-29 22:15:36',NULL,8204,955,28,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,8205,955,24,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,8206,955,29,'ZJ'),(NULL,0,'2019-11-29 22:15:37',NULL,8207,955,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,8208,955,11,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,8209,955,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,8210,955,15,'10.6.5.9'),(NULL,0,'2019-11-29 22:15:37',NULL,8211,955,5,'f2e625041b9d40ccb719a8733f0291ca'),(NULL,0,'2019-11-29 22:15:37',NULL,8212,955,17,'online'),(NULL,0,'2019-11-29 22:15:37',NULL,8213,956,16,'cmdb2-3-5-10'),(NULL,0,'2019-11-29 22:15:37',NULL,8214,956,28,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,8215,956,24,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,8216,956,29,'ZJ'),(NULL,0,'2019-11-29 22:15:37',NULL,8217,956,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,8218,956,11,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,8219,956,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,8220,956,15,'10.6.5.10'),(NULL,0,'2019-11-29 22:15:37',NULL,8221,956,5,'713853c7ffed48b4aff314ea2980a405'),(NULL,0,'2019-11-29 22:15:37',NULL,8222,956,17,'online'),(NULL,0,'2019-11-29 22:15:37',NULL,8223,957,16,'cmdb2-3-5-11'),(NULL,0,'2019-11-29 22:15:37',NULL,8224,957,28,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,8225,957,24,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,8226,957,29,'ZJ'),(NULL,0,'2019-11-29 22:15:37',NULL,8227,957,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,8228,957,11,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,8229,957,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,8230,957,15,'10.6.5.11'),(NULL,0,'2019-11-29 22:15:37',NULL,8231,957,5,'3ba64d42a56645b8abae961d9de01ab2'),(NULL,0,'2019-11-29 22:15:37',NULL,8232,957,17,'online'),(NULL,0,'2019-11-29 22:15:37',NULL,8233,958,16,'cmdb2-3-5-12'),(NULL,0,'2019-11-29 22:15:37',NULL,8234,958,28,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,8235,958,24,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,8236,958,29,'ZJ'),(NULL,0,'2019-11-29 22:15:37',NULL,8237,958,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,8238,958,11,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,8239,958,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,8240,958,15,'10.6.5.12'),(NULL,0,'2019-11-29 22:15:37',NULL,8241,958,5,'8655c18b5751458fa4c30788d33ee8a6'),(NULL,0,'2019-11-29 22:15:37',NULL,8242,958,17,'online'),(NULL,0,'2019-11-29 22:15:37',NULL,8243,959,16,'cmdb2-3-5-13'),(NULL,0,'2019-11-29 22:15:37',NULL,8244,959,28,'prod'),(NULL,0,'2019-11-29 22:15:37',NULL,8245,959,24,'enable'),(NULL,0,'2019-11-29 22:15:37',NULL,8246,959,29,'ZJ'),(NULL,0,'2019-11-29 22:15:37',NULL,8247,959,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:37',NULL,8248,959,11,'pycook'),(NULL,0,'2019-11-29 22:15:37',NULL,8249,959,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:37',NULL,8250,959,15,'10.6.5.13'),(NULL,0,'2019-11-29 22:15:38',NULL,8251,959,5,'d223d1350c9e4f58bf78f300aab17ea8'),(NULL,0,'2019-11-29 22:15:38',NULL,8252,959,17,'online'),(NULL,0,'2019-11-29 22:15:38',NULL,8253,960,16,'cmdb2-3-5-14'),(NULL,0,'2019-11-29 22:15:38',NULL,8254,960,28,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,8255,960,24,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,8256,960,29,'ZJ'),(NULL,0,'2019-11-29 22:15:38',NULL,8257,960,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,8258,960,11,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,8259,960,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,8260,960,15,'10.6.5.14'),(NULL,0,'2019-11-29 22:15:38',NULL,8261,960,5,'63974d2f1d664108857fb871b6add483'),(NULL,0,'2019-11-29 22:15:38',NULL,8262,960,17,'online'),(NULL,0,'2019-11-29 22:15:38',NULL,8263,961,16,'cmdb2-3-5-15'),(NULL,0,'2019-11-29 22:15:38',NULL,8264,961,28,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,8265,961,24,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,8266,961,29,'ZJ'),(NULL,0,'2019-11-29 22:15:38',NULL,8267,961,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,8268,961,11,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,8269,961,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,8270,961,15,'10.6.5.15'),(NULL,0,'2019-11-29 22:15:38',NULL,8271,961,5,'030e00a2c82545dc9a3fc42c275f22e4'),(NULL,0,'2019-11-29 22:15:38',NULL,8272,961,17,'online'),(NULL,0,'2019-11-29 22:15:38',NULL,8273,962,16,'cmdb2-3-5-16'),(NULL,0,'2019-11-29 22:15:38',NULL,8274,962,28,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,8275,962,24,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,8276,962,29,'ZJ'),(NULL,0,'2019-11-29 22:15:38',NULL,8277,962,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,8278,962,11,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,8279,962,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,8280,962,15,'10.6.5.16'),(NULL,0,'2019-11-29 22:15:38',NULL,8281,962,5,'bc6794d967444206b53e44d17bfd77b2'),(NULL,0,'2019-11-29 22:15:38',NULL,8282,962,17,'online'),(NULL,0,'2019-11-29 22:15:38',NULL,8283,963,4,'App2-3-6'),(NULL,0,'2019-11-29 22:15:38',NULL,8284,964,16,'cmdb2-3-6-1'),(NULL,0,'2019-11-29 22:15:38',NULL,8285,964,28,'prod'),(NULL,0,'2019-11-29 22:15:38',NULL,8286,964,24,'enable'),(NULL,0,'2019-11-29 22:15:38',NULL,8287,964,29,'ZJ'),(NULL,0,'2019-11-29 22:15:38',NULL,8288,964,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:38',NULL,8289,964,11,'pycook'),(NULL,0,'2019-11-29 22:15:38',NULL,8290,964,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:38',NULL,8291,964,15,'10.6.6.1'),(NULL,0,'2019-11-29 22:15:38',NULL,8292,964,5,'ec5a9583582c45ceb60d9f4eb0362e33'),(NULL,0,'2019-11-29 22:15:39',NULL,8293,964,17,'online'),(NULL,0,'2019-11-29 22:15:39',NULL,8294,965,16,'cmdb2-3-6-2'),(NULL,0,'2019-11-29 22:15:39',NULL,8295,965,28,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,8296,965,24,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,8297,965,29,'ZJ'),(NULL,0,'2019-11-29 22:15:39',NULL,8298,965,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,8299,965,11,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,8300,965,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,8301,965,15,'10.6.6.2'),(NULL,0,'2019-11-29 22:15:39',NULL,8302,965,5,'9a5546eb08be46e3a9a30e5679ad9588'),(NULL,0,'2019-11-29 22:15:39',NULL,8303,965,17,'online'),(NULL,0,'2019-11-29 22:15:39',NULL,8304,966,16,'cmdb2-3-6-3'),(NULL,0,'2019-11-29 22:15:39',NULL,8305,966,28,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,8306,966,24,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,8307,966,29,'ZJ'),(NULL,0,'2019-11-29 22:15:39',NULL,8308,966,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,8309,966,11,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,8310,966,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,8311,966,15,'10.6.6.3'),(NULL,0,'2019-11-29 22:15:39',NULL,8312,966,5,'122b56d579084755b5e30f1a5b49c1cc'),(NULL,0,'2019-11-29 22:15:39',NULL,8313,966,17,'online'),(NULL,0,'2019-11-29 22:15:39',NULL,8314,967,16,'cmdb2-3-6-4'),(NULL,0,'2019-11-29 22:15:39',NULL,8315,967,28,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,8316,967,24,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,8317,967,29,'ZJ'),(NULL,0,'2019-11-29 22:15:39',NULL,8318,967,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,8319,967,11,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,8320,967,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,8321,967,15,'10.6.6.4'),(NULL,0,'2019-11-29 22:15:39',NULL,8322,967,5,'e953abb618354d8090a284eab155e40e'),(NULL,0,'2019-11-29 22:15:39',NULL,8323,967,17,'online'),(NULL,0,'2019-11-29 22:15:39',NULL,8324,968,16,'cmdb2-3-6-5'),(NULL,0,'2019-11-29 22:15:39',NULL,8325,968,28,'prod'),(NULL,0,'2019-11-29 22:15:39',NULL,8326,968,24,'enable'),(NULL,0,'2019-11-29 22:15:39',NULL,8327,968,29,'ZJ'),(NULL,0,'2019-11-29 22:15:39',NULL,8328,968,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:39',NULL,8329,968,11,'pycook'),(NULL,0,'2019-11-29 22:15:39',NULL,8330,968,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:39',NULL,8331,968,15,'10.6.6.5'),(NULL,0,'2019-11-29 22:15:39',NULL,8332,968,5,'cb893a3216f54f62aade291a11cf90ed'),(NULL,0,'2019-11-29 22:15:39',NULL,8333,968,17,'online'),(NULL,0,'2019-11-29 22:15:39',NULL,8334,969,16,'cmdb2-3-6-6'),(NULL,0,'2019-11-29 22:15:40',NULL,8335,969,28,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,8336,969,24,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,8337,969,29,'ZJ'),(NULL,0,'2019-11-29 22:15:40',NULL,8338,969,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,8339,969,11,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,8340,969,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,8341,969,15,'10.6.6.6'),(NULL,0,'2019-11-29 22:15:40',NULL,8342,969,5,'8377ccac8ee7411587abf86a28e2c10d'),(NULL,0,'2019-11-29 22:15:40',NULL,8343,969,17,'online'),(NULL,0,'2019-11-29 22:15:40',NULL,8344,970,16,'cmdb2-3-6-7'),(NULL,0,'2019-11-29 22:15:40',NULL,8345,970,28,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,8346,970,24,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,8347,970,29,'ZJ'),(NULL,0,'2019-11-29 22:15:40',NULL,8348,970,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,8349,970,11,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,8350,970,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,8351,970,15,'10.6.6.7'),(NULL,0,'2019-11-29 22:15:40',NULL,8352,970,5,'935a04fc3a6743ce98ddd3d997b8ff70'),(NULL,0,'2019-11-29 22:15:40',NULL,8353,970,17,'online'),(NULL,0,'2019-11-29 22:15:40',NULL,8354,971,16,'cmdb2-3-6-8'),(NULL,0,'2019-11-29 22:15:40',NULL,8355,971,28,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,8356,971,24,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,8357,971,29,'ZJ'),(NULL,0,'2019-11-29 22:15:40',NULL,8358,971,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,8359,971,11,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,8360,971,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,8361,971,15,'10.6.6.8'),(NULL,0,'2019-11-29 22:15:40',NULL,8362,971,5,'470484578a5d444a824892da8ebf4a93'),(NULL,0,'2019-11-29 22:15:40',NULL,8363,971,17,'online'),(NULL,0,'2019-11-29 22:15:40',NULL,8364,972,16,'cmdb2-3-6-9'),(NULL,0,'2019-11-29 22:15:40',NULL,8365,972,28,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,8366,972,24,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,8367,972,29,'ZJ'),(NULL,0,'2019-11-29 22:15:40',NULL,8368,972,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:40',NULL,8369,972,11,'pycook'),(NULL,0,'2019-11-29 22:15:40',NULL,8370,972,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:40',NULL,8371,972,15,'10.6.6.9'),(NULL,0,'2019-11-29 22:15:40',NULL,8372,972,5,'581c96ee4915468d9124e133c36037d6'),(NULL,0,'2019-11-29 22:15:40',NULL,8373,972,17,'online'),(NULL,0,'2019-11-29 22:15:40',NULL,8374,973,16,'cmdb2-3-6-10'),(NULL,0,'2019-11-29 22:15:40',NULL,8375,973,28,'prod'),(NULL,0,'2019-11-29 22:15:40',NULL,8376,973,24,'enable'),(NULL,0,'2019-11-29 22:15:40',NULL,8377,973,29,'ZJ'),(NULL,0,'2019-11-29 22:15:40',NULL,8378,973,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,8379,973,11,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,8380,973,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,8381,973,15,'10.6.6.10'),(NULL,0,'2019-11-29 22:15:41',NULL,8382,973,5,'7d248203ef334599958c7e7727b00927'),(NULL,0,'2019-11-29 22:15:41',NULL,8383,973,17,'online'),(NULL,0,'2019-11-29 22:15:41',NULL,8384,974,16,'cmdb2-3-6-11'),(NULL,0,'2019-11-29 22:15:41',NULL,8385,974,28,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,8386,974,24,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,8387,974,29,'ZJ'),(NULL,0,'2019-11-29 22:15:41',NULL,8388,974,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,8389,974,11,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,8390,974,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,8391,974,15,'10.6.6.11'),(NULL,0,'2019-11-29 22:15:41',NULL,8392,974,5,'facffa3b32f44e9890a960306dd67069'),(NULL,0,'2019-11-29 22:15:41',NULL,8393,974,17,'online'),(NULL,0,'2019-11-29 22:15:41',NULL,8394,975,16,'cmdb2-3-6-12'),(NULL,0,'2019-11-29 22:15:41',NULL,8395,975,28,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,8396,975,24,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,8397,975,29,'ZJ'),(NULL,0,'2019-11-29 22:15:41',NULL,8398,975,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,8399,975,11,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,8400,975,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,8401,975,15,'10.6.6.12'),(NULL,0,'2019-11-29 22:15:41',NULL,8402,975,5,'6cae4694ddb14d3aaebbbbee8abb1b37'),(NULL,0,'2019-11-29 22:15:41',NULL,8403,975,17,'online'),(NULL,0,'2019-11-29 22:15:41',NULL,8404,976,16,'cmdb2-3-6-13'),(NULL,0,'2019-11-29 22:15:41',NULL,8405,976,28,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,8406,976,24,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,8407,976,29,'ZJ'),(NULL,0,'2019-11-29 22:15:41',NULL,8408,976,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,8409,976,11,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,8410,976,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,8411,976,15,'10.6.6.13'),(NULL,0,'2019-11-29 22:15:41',NULL,8412,976,5,'2459a335d0904682aa3e680414daaf47'),(NULL,0,'2019-11-29 22:15:41',NULL,8413,976,17,'online'),(NULL,0,'2019-11-29 22:15:41',NULL,8414,977,16,'cmdb2-3-6-14'),(NULL,0,'2019-11-29 22:15:41',NULL,8415,977,28,'prod'),(NULL,0,'2019-11-29 22:15:41',NULL,8416,977,24,'enable'),(NULL,0,'2019-11-29 22:15:41',NULL,8417,977,29,'ZJ'),(NULL,0,'2019-11-29 22:15:41',NULL,8418,977,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:41',NULL,8419,977,11,'pycook'),(NULL,0,'2019-11-29 22:15:41',NULL,8420,977,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:41',NULL,8421,977,15,'10.6.6.14'),(NULL,0,'2019-11-29 22:15:41',NULL,8422,977,5,'5a271c4af80a4b0cbee6d06c02995634'),(NULL,0,'2019-11-29 22:15:42',NULL,8423,977,17,'online'),(NULL,0,'2019-11-29 22:15:42',NULL,8424,978,16,'cmdb2-3-6-15'),(NULL,0,'2019-11-29 22:15:42',NULL,8425,978,28,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,8426,978,24,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,8427,978,29,'ZJ'),(NULL,0,'2019-11-29 22:15:42',NULL,8428,978,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,8429,978,11,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,8430,978,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,8431,978,15,'10.6.6.15'),(NULL,0,'2019-11-29 22:15:42',NULL,8432,978,5,'05d3def759034097b36eca3fd38f8f53'),(NULL,0,'2019-11-29 22:15:42',NULL,8433,978,17,'online'),(NULL,0,'2019-11-29 22:15:42',NULL,8434,979,16,'cmdb2-3-6-16'),(NULL,0,'2019-11-29 22:15:42',NULL,8435,979,28,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,8436,979,24,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,8437,979,29,'ZJ'),(NULL,0,'2019-11-29 22:15:42',NULL,8438,979,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,8439,979,11,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,8440,979,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,8441,979,15,'10.6.6.16'),(NULL,0,'2019-11-29 22:15:42',NULL,8442,979,5,'c516a5d167da4c31a452756698b9df51'),(NULL,0,'2019-11-29 22:15:42',NULL,8443,979,17,'online'),(NULL,0,'2019-11-29 22:15:42',NULL,8444,980,4,'App2-3-7'),(NULL,0,'2019-11-29 22:15:42',NULL,8445,981,16,'cmdb2-3-7-1'),(NULL,0,'2019-11-29 22:15:42',NULL,8446,981,28,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,8447,981,24,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,8448,981,29,'ZJ'),(NULL,0,'2019-11-29 22:15:42',NULL,8449,981,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,8450,981,11,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,8451,981,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,8452,981,15,'10.6.7.1'),(NULL,0,'2019-11-29 22:15:42',NULL,8453,981,5,'fb250053978341dd8217dec4d7fb7b78'),(NULL,0,'2019-11-29 22:15:42',NULL,8454,981,17,'online'),(NULL,0,'2019-11-29 22:15:42',NULL,8455,982,16,'cmdb2-3-7-2'),(NULL,0,'2019-11-29 22:15:42',NULL,8456,982,28,'prod'),(NULL,0,'2019-11-29 22:15:42',NULL,8457,982,24,'enable'),(NULL,0,'2019-11-29 22:15:42',NULL,8458,982,29,'ZJ'),(NULL,0,'2019-11-29 22:15:42',NULL,8459,982,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:42',NULL,8460,982,11,'pycook'),(NULL,0,'2019-11-29 22:15:42',NULL,8461,982,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:42',NULL,8462,982,15,'10.6.7.2'),(NULL,0,'2019-11-29 22:15:42',NULL,8463,982,5,'8cb2dbc46b38472d9aef955792f58e53'),(NULL,0,'2019-11-29 22:15:42',NULL,8464,982,17,'online'),(NULL,0,'2019-11-29 22:15:43',NULL,8465,983,16,'cmdb2-3-7-3'),(NULL,0,'2019-11-29 22:15:43',NULL,8466,983,28,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,8467,983,24,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,8468,983,29,'ZJ'),(NULL,0,'2019-11-29 22:15:43',NULL,8469,983,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,8470,983,11,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,8471,983,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,8472,983,15,'10.6.7.3'),(NULL,0,'2019-11-29 22:15:43',NULL,8473,983,5,'9745b19ca24742cd8662d9f124b6d31b'),(NULL,0,'2019-11-29 22:15:43',NULL,8474,983,17,'online'),(NULL,0,'2019-11-29 22:15:43',NULL,8475,984,16,'cmdb2-3-7-4'),(NULL,0,'2019-11-29 22:15:43',NULL,8476,984,28,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,8477,984,24,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,8478,984,29,'ZJ'),(NULL,0,'2019-11-29 22:15:43',NULL,8479,984,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,8480,984,11,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,8481,984,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,8482,984,15,'10.6.7.4'),(NULL,0,'2019-11-29 22:15:43',NULL,8483,984,5,'b349914826e9429db94389dfefcb91a6'),(NULL,0,'2019-11-29 22:15:43',NULL,8484,984,17,'online'),(NULL,0,'2019-11-29 22:15:43',NULL,8485,985,16,'cmdb2-3-7-5'),(NULL,0,'2019-11-29 22:15:43',NULL,8486,985,28,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,8487,985,24,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,8488,985,29,'ZJ'),(NULL,0,'2019-11-29 22:15:43',NULL,8489,985,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,8490,985,11,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,8491,985,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,8492,985,15,'10.6.7.5'),(NULL,0,'2019-11-29 22:15:43',NULL,8493,985,5,'c9308a0cce5d4467a0b91685033191ce'),(NULL,0,'2019-11-29 22:15:43',NULL,8494,985,17,'online'),(NULL,0,'2019-11-29 22:15:43',NULL,8495,986,16,'cmdb2-3-7-6'),(NULL,0,'2019-11-29 22:15:43',NULL,8496,986,28,'prod'),(NULL,0,'2019-11-29 22:15:43',NULL,8497,986,24,'enable'),(NULL,0,'2019-11-29 22:15:43',NULL,8498,986,29,'ZJ'),(NULL,0,'2019-11-29 22:15:43',NULL,8499,986,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:43',NULL,8500,986,11,'pycook'),(NULL,0,'2019-11-29 22:15:43',NULL,8501,986,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:43',NULL,8502,986,15,'10.6.7.6'),(NULL,0,'2019-11-29 22:15:43',NULL,8503,986,5,'be452e0f2d374d13a284f7b2ce4e033a'),(NULL,0,'2019-11-29 22:15:43',NULL,8504,986,17,'online'),(NULL,0,'2019-11-29 22:15:43',NULL,8505,987,16,'cmdb2-3-7-7'),(NULL,0,'2019-11-29 22:15:44',NULL,8506,987,28,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,8507,987,24,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,8508,987,29,'ZJ'),(NULL,0,'2019-11-29 22:15:44',NULL,8509,987,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,8510,987,11,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,8511,987,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,8512,987,15,'10.6.7.7'),(NULL,0,'2019-11-29 22:15:44',NULL,8513,987,5,'ee84600553414f8a9ee63a3bb5d1efa2'),(NULL,0,'2019-11-29 22:15:44',NULL,8514,987,17,'online'),(NULL,0,'2019-11-29 22:15:44',NULL,8515,988,16,'cmdb2-3-7-8'),(NULL,0,'2019-11-29 22:15:44',NULL,8516,988,28,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,8517,988,24,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,8518,988,29,'ZJ'),(NULL,0,'2019-11-29 22:15:44',NULL,8519,988,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,8520,988,11,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,8521,988,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,8522,988,15,'10.6.7.8'),(NULL,0,'2019-11-29 22:15:44',NULL,8523,988,5,'330e1db7a68c42b0882a785da4c980d3'),(NULL,0,'2019-11-29 22:15:44',NULL,8524,988,17,'online'),(NULL,0,'2019-11-29 22:15:44',NULL,8525,989,16,'cmdb2-3-7-9'),(NULL,0,'2019-11-29 22:15:44',NULL,8526,989,28,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,8527,989,24,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,8528,989,29,'ZJ'),(NULL,0,'2019-11-29 22:15:44',NULL,8529,989,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,8530,989,11,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,8531,989,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,8532,989,15,'10.6.7.9'),(NULL,0,'2019-11-29 22:15:44',NULL,8533,989,5,'01781d0f4e784d419c91c3719c2cafe2'),(NULL,0,'2019-11-29 22:15:44',NULL,8534,989,17,'online'),(NULL,0,'2019-11-29 22:15:44',NULL,8535,990,16,'cmdb2-3-7-10'),(NULL,0,'2019-11-29 22:15:44',NULL,8536,990,28,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,8537,990,24,'enable'),(NULL,0,'2019-11-29 22:15:44',NULL,8538,990,29,'ZJ'),(NULL,0,'2019-11-29 22:15:44',NULL,8539,990,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:44',NULL,8540,990,11,'pycook'),(NULL,0,'2019-11-29 22:15:44',NULL,8541,990,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:44',NULL,8542,990,15,'10.6.7.10'),(NULL,0,'2019-11-29 22:15:44',NULL,8543,990,5,'c58f7bb0a8014ca3904d92c58f19ea63'),(NULL,0,'2019-11-29 22:15:44',NULL,8544,990,17,'online'),(NULL,0,'2019-11-29 22:15:44',NULL,8545,991,16,'cmdb2-3-7-11'),(NULL,0,'2019-11-29 22:15:44',NULL,8546,991,28,'prod'),(NULL,0,'2019-11-29 22:15:44',NULL,8547,991,24,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,8548,991,29,'ZJ'),(NULL,0,'2019-11-29 22:15:45',NULL,8549,991,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,8550,991,11,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,8551,991,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,8552,991,15,'10.6.7.11'),(NULL,0,'2019-11-29 22:15:45',NULL,8553,991,5,'5b0463d2e25c45ceb2c81ae0ab5e30fa'),(NULL,0,'2019-11-29 22:15:45',NULL,8554,991,17,'online'),(NULL,0,'2019-11-29 22:15:45',NULL,8555,992,16,'cmdb2-3-7-12'),(NULL,0,'2019-11-29 22:15:45',NULL,8556,992,28,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,8557,992,24,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,8558,992,29,'ZJ'),(NULL,0,'2019-11-29 22:15:45',NULL,8559,992,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,8560,992,11,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,8561,992,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,8562,992,15,'10.6.7.12'),(NULL,0,'2019-11-29 22:15:45',NULL,8563,992,5,'ca63579637f7429bb537ed88f7d039c0'),(NULL,0,'2019-11-29 22:15:45',NULL,8564,992,17,'online'),(NULL,0,'2019-11-29 22:15:45',NULL,8565,993,16,'cmdb2-3-7-13'),(NULL,0,'2019-11-29 22:15:45',NULL,8566,993,28,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,8567,993,24,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,8568,993,29,'ZJ'),(NULL,0,'2019-11-29 22:15:45',NULL,8569,993,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,8570,993,11,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,8571,993,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,8572,993,15,'10.6.7.13'),(NULL,0,'2019-11-29 22:15:45',NULL,8573,993,5,'0569f2250e074a4d9f8655c41783dcc3'),(NULL,0,'2019-11-29 22:15:45',NULL,8574,993,17,'online'),(NULL,0,'2019-11-29 22:15:45',NULL,8575,994,16,'cmdb2-3-7-14'),(NULL,0,'2019-11-29 22:15:45',NULL,8576,994,28,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,8577,994,24,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,8578,994,29,'ZJ'),(NULL,0,'2019-11-29 22:15:45',NULL,8579,994,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,8580,994,11,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,8581,994,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:45',NULL,8582,994,15,'10.6.7.14'),(NULL,0,'2019-11-29 22:15:45',NULL,8583,994,5,'fce6a732c533426f9628d8d23ff2a904'),(NULL,0,'2019-11-29 22:15:45',NULL,8584,994,17,'online'),(NULL,0,'2019-11-29 22:15:45',NULL,8585,995,16,'cmdb2-3-7-15'),(NULL,0,'2019-11-29 22:15:45',NULL,8586,995,28,'prod'),(NULL,0,'2019-11-29 22:15:45',NULL,8587,995,24,'enable'),(NULL,0,'2019-11-29 22:15:45',NULL,8588,995,29,'ZJ'),(NULL,0,'2019-11-29 22:15:45',NULL,8589,995,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:45',NULL,8590,995,11,'pycook'),(NULL,0,'2019-11-29 22:15:45',NULL,8591,995,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,8592,995,15,'10.6.7.15'),(NULL,0,'2019-11-29 22:15:46',NULL,8593,995,5,'e28d9a1a3b0c4020a8ab7f3c22de4144'),(NULL,0,'2019-11-29 22:15:46',NULL,8594,995,17,'online'),(NULL,0,'2019-11-29 22:15:46',NULL,8595,996,16,'cmdb2-3-7-16'),(NULL,0,'2019-11-29 22:15:46',NULL,8596,996,28,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,8597,996,24,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,8598,996,29,'ZJ'),(NULL,0,'2019-11-29 22:15:46',NULL,8599,996,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,8600,996,11,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,8601,996,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,8602,996,15,'10.6.7.16'),(NULL,0,'2019-11-29 22:15:46',NULL,8603,996,5,'6b489daa718d40bab66683eb7ad3584a'),(NULL,0,'2019-11-29 22:15:46',NULL,8604,996,17,'online'),(NULL,0,'2019-11-29 22:15:46',NULL,8605,997,4,'App2-3-8'),(NULL,0,'2019-11-29 22:15:46',NULL,8606,998,16,'cmdb2-3-8-1'),(NULL,0,'2019-11-29 22:15:46',NULL,8607,998,28,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,8608,998,24,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,8609,998,29,'ZJ'),(NULL,0,'2019-11-29 22:15:46',NULL,8610,998,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,8611,998,11,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,8612,998,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,8613,998,15,'10.6.8.1'),(NULL,0,'2019-11-29 22:15:46',NULL,8614,998,5,'d93ba051ec4b44ccb77e4d029d576a34'),(NULL,0,'2019-11-29 22:15:46',NULL,8615,998,17,'online'),(NULL,0,'2019-11-29 22:15:46',NULL,8616,999,16,'cmdb2-3-8-2'),(NULL,0,'2019-11-29 22:15:46',NULL,8617,999,28,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,8618,999,24,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,8619,999,29,'ZJ'),(NULL,0,'2019-11-29 22:15:46',NULL,8620,999,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,8621,999,11,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,8622,999,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,8623,999,15,'10.6.8.2'),(NULL,0,'2019-11-29 22:15:46',NULL,8624,999,5,'50f26ec6aeab4f4ca5784483cbf45b4b'),(NULL,0,'2019-11-29 22:15:46',NULL,8625,999,17,'online'),(NULL,0,'2019-11-29 22:15:46',NULL,8626,1000,16,'cmdb2-3-8-3'),(NULL,0,'2019-11-29 22:15:46',NULL,8627,1000,28,'prod'),(NULL,0,'2019-11-29 22:15:46',NULL,8628,1000,24,'enable'),(NULL,0,'2019-11-29 22:15:46',NULL,8629,1000,29,'ZJ'),(NULL,0,'2019-11-29 22:15:46',NULL,8630,1000,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:46',NULL,8631,1000,11,'pycook'),(NULL,0,'2019-11-29 22:15:46',NULL,8632,1000,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:46',NULL,8633,1000,15,'10.6.8.3'),(NULL,0,'2019-11-29 22:15:47',NULL,8634,1000,5,'8a18ea58afbd40c1a80500277c320e7e'),(NULL,0,'2019-11-29 22:15:47',NULL,8635,1000,17,'online'),(NULL,0,'2019-11-29 22:15:47',NULL,8636,1001,16,'cmdb2-3-8-4'),(NULL,0,'2019-11-29 22:15:47',NULL,8637,1001,28,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,8638,1001,24,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,8639,1001,29,'ZJ'),(NULL,0,'2019-11-29 22:15:47',NULL,8640,1001,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,8641,1001,11,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,8642,1001,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,8643,1001,15,'10.6.8.4'),(NULL,0,'2019-11-29 22:15:47',NULL,8644,1001,5,'084bbd89baed45888b4c366714ee9176'),(NULL,0,'2019-11-29 22:15:47',NULL,8645,1001,17,'online'),(NULL,0,'2019-11-29 22:15:47',NULL,8646,1002,16,'cmdb2-3-8-5'),(NULL,0,'2019-11-29 22:15:47',NULL,8647,1002,28,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,8648,1002,24,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,8649,1002,29,'ZJ'),(NULL,0,'2019-11-29 22:15:47',NULL,8650,1002,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,8651,1002,11,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,8652,1002,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,8653,1002,15,'10.6.8.5'),(NULL,0,'2019-11-29 22:15:47',NULL,8654,1002,5,'bbddc57aab58492397197765f86a1f35'),(NULL,0,'2019-11-29 22:15:47',NULL,8655,1002,17,'online'),(NULL,0,'2019-11-29 22:15:47',NULL,8656,1003,16,'cmdb2-3-8-6'),(NULL,0,'2019-11-29 22:15:47',NULL,8657,1003,28,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,8658,1003,24,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,8659,1003,29,'ZJ'),(NULL,0,'2019-11-29 22:15:47',NULL,8660,1003,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,8661,1003,11,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,8662,1003,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,8663,1003,15,'10.6.8.6'),(NULL,0,'2019-11-29 22:15:47',NULL,8664,1003,5,'488e7a7c24a54ae784065595a35f77c1'),(NULL,0,'2019-11-29 22:15:47',NULL,8665,1003,17,'online'),(NULL,0,'2019-11-29 22:15:47',NULL,8666,1004,16,'cmdb2-3-8-7'),(NULL,0,'2019-11-29 22:15:47',NULL,8667,1004,28,'prod'),(NULL,0,'2019-11-29 22:15:47',NULL,8668,1004,24,'enable'),(NULL,0,'2019-11-29 22:15:47',NULL,8669,1004,29,'ZJ'),(NULL,0,'2019-11-29 22:15:47',NULL,8670,1004,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:47',NULL,8671,1004,11,'pycook'),(NULL,0,'2019-11-29 22:15:47',NULL,8672,1004,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:47',NULL,8673,1004,15,'10.6.8.7'),(NULL,0,'2019-11-29 22:15:47',NULL,8674,1004,5,'ce6237678b48494698fb56b54bafcc5a'),(NULL,0,'2019-11-29 22:15:47',NULL,8675,1004,17,'online'),(NULL,0,'2019-11-29 22:15:48',NULL,8676,1005,16,'cmdb2-3-8-8'),(NULL,0,'2019-11-29 22:15:48',NULL,8677,1005,28,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,8678,1005,24,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,8679,1005,29,'ZJ'),(NULL,0,'2019-11-29 22:15:48',NULL,8680,1005,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,8681,1005,11,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,8682,1005,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,8683,1005,15,'10.6.8.8'),(NULL,0,'2019-11-29 22:15:48',NULL,8684,1005,5,'11001bc3f0044e2ca65271ef8d444abf'),(NULL,0,'2019-11-29 22:15:48',NULL,8685,1005,17,'online'),(NULL,0,'2019-11-29 22:15:48',NULL,8686,1006,16,'cmdb2-3-8-9'),(NULL,0,'2019-11-29 22:15:48',NULL,8687,1006,28,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,8688,1006,24,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,8689,1006,29,'ZJ'),(NULL,0,'2019-11-29 22:15:48',NULL,8690,1006,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,8691,1006,11,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,8692,1006,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,8693,1006,15,'10.6.8.9'),(NULL,0,'2019-11-29 22:15:48',NULL,8694,1006,5,'df9b8dec1a7a47aebfcb5d8d754c2b2b'),(NULL,0,'2019-11-29 22:15:48',NULL,8695,1006,17,'online'),(NULL,0,'2019-11-29 22:15:48',NULL,8696,1007,16,'cmdb2-3-8-10'),(NULL,0,'2019-11-29 22:15:48',NULL,8697,1007,28,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,8698,1007,24,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,8699,1007,29,'ZJ'),(NULL,0,'2019-11-29 22:15:48',NULL,8700,1007,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,8701,1007,11,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,8702,1007,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,8703,1007,15,'10.6.8.10'),(NULL,0,'2019-11-29 22:15:48',NULL,8704,1007,5,'76ab67bd8faa499cbdbd524508c115fc'),(NULL,0,'2019-11-29 22:15:48',NULL,8705,1007,17,'online'),(NULL,0,'2019-11-29 22:15:48',NULL,8706,1008,16,'cmdb2-3-8-11'),(NULL,0,'2019-11-29 22:15:48',NULL,8707,1008,28,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,8708,1008,24,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,8709,1008,29,'ZJ'),(NULL,0,'2019-11-29 22:15:48',NULL,8710,1008,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:48',NULL,8711,1008,11,'pycook'),(NULL,0,'2019-11-29 22:15:48',NULL,8712,1008,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:48',NULL,8713,1008,15,'10.6.8.11'),(NULL,0,'2019-11-29 22:15:48',NULL,8714,1008,5,'e1e5d3ce07e846ccb4acbf5c9730f51b'),(NULL,0,'2019-11-29 22:15:48',NULL,8715,1008,17,'online'),(NULL,0,'2019-11-29 22:15:48',NULL,8716,1009,16,'cmdb2-3-8-12'),(NULL,0,'2019-11-29 22:15:48',NULL,8717,1009,28,'prod'),(NULL,0,'2019-11-29 22:15:48',NULL,8718,1009,24,'enable'),(NULL,0,'2019-11-29 22:15:48',NULL,8719,1009,29,'ZJ'),(NULL,0,'2019-11-29 22:15:48',NULL,8720,1009,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,8721,1009,11,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,8722,1009,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,8723,1009,15,'10.6.8.12'),(NULL,0,'2019-11-29 22:15:49',NULL,8724,1009,5,'5ecb36599fa34f4d87be8b43a78af8dd'),(NULL,0,'2019-11-29 22:15:49',NULL,8725,1009,17,'online'),(NULL,0,'2019-11-29 22:15:49',NULL,8726,1010,16,'cmdb2-3-8-13'),(NULL,0,'2019-11-29 22:15:49',NULL,8727,1010,28,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,8728,1010,24,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,8729,1010,29,'ZJ'),(NULL,0,'2019-11-29 22:15:49',NULL,8730,1010,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,8731,1010,11,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,8732,1010,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,8733,1010,15,'10.6.8.13'),(NULL,0,'2019-11-29 22:15:49',NULL,8734,1010,5,'605227e802f14fe1b5e40485b4baa502'),(NULL,0,'2019-11-29 22:15:49',NULL,8735,1010,17,'online'),(NULL,0,'2019-11-29 22:15:49',NULL,8736,1011,16,'cmdb2-3-8-14'),(NULL,0,'2019-11-29 22:15:49',NULL,8737,1011,28,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,8738,1011,24,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,8739,1011,29,'ZJ'),(NULL,0,'2019-11-29 22:15:49',NULL,8740,1011,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,8741,1011,11,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,8742,1011,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,8743,1011,15,'10.6.8.14'),(NULL,0,'2019-11-29 22:15:49',NULL,8744,1011,5,'fbbf0be2c8a54beabe59e5bfa7111d85'),(NULL,0,'2019-11-29 22:15:49',NULL,8745,1011,17,'online'),(NULL,0,'2019-11-29 22:15:49',NULL,8746,1012,16,'cmdb2-3-8-15'),(NULL,0,'2019-11-29 22:15:49',NULL,8747,1012,28,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,8748,1012,24,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,8749,1012,29,'ZJ'),(NULL,0,'2019-11-29 22:15:49',NULL,8750,1012,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,8751,1012,11,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,8752,1012,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,8753,1012,15,'10.6.8.15'),(NULL,0,'2019-11-29 22:15:49',NULL,8754,1012,5,'722393d22a7c403ab83d3c39d6a0735c'),(NULL,0,'2019-11-29 22:15:49',NULL,8755,1012,17,'online'),(NULL,0,'2019-11-29 22:15:49',NULL,8756,1013,16,'cmdb2-3-8-16'),(NULL,0,'2019-11-29 22:15:49',NULL,8757,1013,28,'prod'),(NULL,0,'2019-11-29 22:15:49',NULL,8758,1013,24,'enable'),(NULL,0,'2019-11-29 22:15:49',NULL,8759,1013,29,'ZJ'),(NULL,0,'2019-11-29 22:15:49',NULL,8760,1013,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:49',NULL,8761,1013,11,'pycook'),(NULL,0,'2019-11-29 22:15:49',NULL,8762,1013,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:49',NULL,8763,1013,15,'10.6.8.16'),(NULL,0,'2019-11-29 22:15:49',NULL,8764,1013,5,'6cf0e714d2864f72ac529cbc649142d8'),(NULL,0,'2019-11-29 22:15:50',NULL,8765,1013,17,'online'),(NULL,0,'2019-11-29 22:15:50',NULL,8766,1014,3,'Product2-4'),(NULL,0,'2019-11-29 22:15:50',NULL,8767,1015,4,'App2-4-1'),(NULL,0,'2019-11-29 22:15:50',NULL,8768,1016,16,'cmdb2-4-1-1'),(NULL,0,'2019-11-29 22:15:50',NULL,8769,1016,28,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,8770,1016,24,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,8771,1016,29,'ZJ'),(NULL,0,'2019-11-29 22:15:50',NULL,8772,1016,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,8773,1016,11,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,8774,1016,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,8775,1016,15,'10.8.1.1'),(NULL,0,'2019-11-29 22:15:50',NULL,8776,1016,5,'9d2a6e24a8284c948a27dbb041f2e6e9'),(NULL,0,'2019-11-29 22:15:50',NULL,8777,1016,17,'online'),(NULL,0,'2019-11-29 22:15:50',NULL,8778,1017,16,'cmdb2-4-1-2'),(NULL,0,'2019-11-29 22:15:50',NULL,8779,1017,28,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,8780,1017,24,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,8781,1017,29,'ZJ'),(NULL,0,'2019-11-29 22:15:50',NULL,8782,1017,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,8783,1017,11,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,8784,1017,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,8785,1017,15,'10.8.1.2'),(NULL,0,'2019-11-29 22:15:50',NULL,8786,1017,5,'980c4afee3024ecc93280ff7a9126583'),(NULL,0,'2019-11-29 22:15:50',NULL,8787,1017,17,'online'),(NULL,0,'2019-11-29 22:15:50',NULL,8788,1018,16,'cmdb2-4-1-3'),(NULL,0,'2019-11-29 22:15:50',NULL,8789,1018,28,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,8790,1018,24,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,8791,1018,29,'ZJ'),(NULL,0,'2019-11-29 22:15:50',NULL,8792,1018,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,8793,1018,11,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,8794,1018,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:50',NULL,8795,1018,15,'10.8.1.3'),(NULL,0,'2019-11-29 22:15:50',NULL,8796,1018,5,'25c6611771fe44b99544f774f1b771a2'),(NULL,0,'2019-11-29 22:15:50',NULL,8797,1018,17,'online'),(NULL,0,'2019-11-29 22:15:50',NULL,8798,1019,16,'cmdb2-4-1-4'),(NULL,0,'2019-11-29 22:15:50',NULL,8799,1019,28,'prod'),(NULL,0,'2019-11-29 22:15:50',NULL,8800,1019,24,'enable'),(NULL,0,'2019-11-29 22:15:50',NULL,8801,1019,29,'ZJ'),(NULL,0,'2019-11-29 22:15:50',NULL,8802,1019,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:50',NULL,8803,1019,11,'pycook'),(NULL,0,'2019-11-29 22:15:50',NULL,8804,1019,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,8805,1019,15,'10.8.1.4'),(NULL,0,'2019-11-29 22:15:51',NULL,8806,1019,5,'4271b3e3953b41649a7ad591537119ca'),(NULL,0,'2019-11-29 22:15:51',NULL,8807,1019,17,'online'),(NULL,0,'2019-11-29 22:15:51',NULL,8808,1020,16,'cmdb2-4-1-5'),(NULL,0,'2019-11-29 22:15:51',NULL,8809,1020,28,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,8810,1020,24,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,8811,1020,29,'ZJ'),(NULL,0,'2019-11-29 22:15:51',NULL,8812,1020,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,8813,1020,11,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,8814,1020,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,8815,1020,15,'10.8.1.5'),(NULL,0,'2019-11-29 22:15:51',NULL,8816,1020,5,'e91d7052f0d64800ada3901d2e11a2e3'),(NULL,0,'2019-11-29 22:15:51',NULL,8817,1020,17,'online'),(NULL,0,'2019-11-29 22:15:51',NULL,8818,1021,16,'cmdb2-4-1-6'),(NULL,0,'2019-11-29 22:15:51',NULL,8819,1021,28,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,8820,1021,24,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,8821,1021,29,'ZJ'),(NULL,0,'2019-11-29 22:15:51',NULL,8822,1021,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,8823,1021,11,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,8824,1021,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,8825,1021,15,'10.8.1.6'),(NULL,0,'2019-11-29 22:15:51',NULL,8826,1021,5,'96237283543d48c6a0462d9f5a4006f2'),(NULL,0,'2019-11-29 22:15:51',NULL,8827,1021,17,'online'),(NULL,0,'2019-11-29 22:15:51',NULL,8828,1022,16,'cmdb2-4-1-7'),(NULL,0,'2019-11-29 22:15:51',NULL,8829,1022,28,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,8830,1022,24,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,8831,1022,29,'ZJ'),(NULL,0,'2019-11-29 22:15:51',NULL,8832,1022,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,8833,1022,11,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,8834,1022,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,8835,1022,15,'10.8.1.7'),(NULL,0,'2019-11-29 22:15:51',NULL,8836,1022,5,'e5a8b331ba0447be8c7cfb6f391e155c'),(NULL,0,'2019-11-29 22:15:51',NULL,8837,1022,17,'online'),(NULL,0,'2019-11-29 22:15:51',NULL,8838,1023,16,'cmdb2-4-1-8'),(NULL,0,'2019-11-29 22:15:51',NULL,8839,1023,28,'prod'),(NULL,0,'2019-11-29 22:15:51',NULL,8840,1023,24,'enable'),(NULL,0,'2019-11-29 22:15:51',NULL,8841,1023,29,'ZJ'),(NULL,0,'2019-11-29 22:15:51',NULL,8842,1023,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:51',NULL,8843,1023,11,'pycook'),(NULL,0,'2019-11-29 22:15:51',NULL,8844,1023,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:51',NULL,8845,1023,15,'10.8.1.8'),(NULL,0,'2019-11-29 22:15:51',NULL,8846,1023,5,'82114dab1ac24e3d92184f40415fb5ed'),(NULL,0,'2019-11-29 22:15:51',NULL,8847,1023,17,'online'),(NULL,0,'2019-11-29 22:15:52',NULL,8848,1024,16,'cmdb2-4-1-9'),(NULL,0,'2019-11-29 22:15:52',NULL,8849,1024,28,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,8850,1024,24,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,8851,1024,29,'ZJ'),(NULL,0,'2019-11-29 22:15:52',NULL,8852,1024,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,8853,1024,11,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,8854,1024,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,8855,1024,15,'10.8.1.9'),(NULL,0,'2019-11-29 22:15:52',NULL,8856,1024,5,'c7484cc24d614919a1ef7d5c6aba37db'),(NULL,0,'2019-11-29 22:15:52',NULL,8857,1024,17,'online'),(NULL,0,'2019-11-29 22:15:52',NULL,8858,1025,16,'cmdb2-4-1-10'),(NULL,0,'2019-11-29 22:15:52',NULL,8859,1025,28,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,8860,1025,24,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,8861,1025,29,'ZJ'),(NULL,0,'2019-11-29 22:15:52',NULL,8862,1025,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,8863,1025,11,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,8864,1025,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,8865,1025,15,'10.8.1.10'),(NULL,0,'2019-11-29 22:15:52',NULL,8866,1025,5,'123fc39f1cd3410999ef9f564ff546da'),(NULL,0,'2019-11-29 22:15:52',NULL,8867,1025,17,'online'),(NULL,0,'2019-11-29 22:15:52',NULL,8868,1026,16,'cmdb2-4-1-11'),(NULL,0,'2019-11-29 22:15:52',NULL,8869,1026,28,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,8870,1026,24,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,8871,1026,29,'ZJ'),(NULL,0,'2019-11-29 22:15:52',NULL,8872,1026,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,8873,1026,11,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,8874,1026,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,8875,1026,15,'10.8.1.11'),(NULL,0,'2019-11-29 22:15:52',NULL,8876,1026,5,'92b413f7f82840768d9c774f816e5f61'),(NULL,0,'2019-11-29 22:15:52',NULL,8877,1026,17,'online'),(NULL,0,'2019-11-29 22:15:52',NULL,8878,1027,16,'cmdb2-4-1-12'),(NULL,0,'2019-11-29 22:15:52',NULL,8879,1027,28,'prod'),(NULL,0,'2019-11-29 22:15:52',NULL,8880,1027,24,'enable'),(NULL,0,'2019-11-29 22:15:52',NULL,8881,1027,29,'ZJ'),(NULL,0,'2019-11-29 22:15:52',NULL,8882,1027,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:52',NULL,8883,1027,11,'pycook'),(NULL,0,'2019-11-29 22:15:52',NULL,8884,1027,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:52',NULL,8885,1027,15,'10.8.1.12'),(NULL,0,'2019-11-29 22:15:52',NULL,8886,1027,5,'677b3740a35f4c7f8b4e498b7f495c4e'),(NULL,0,'2019-11-29 22:15:52',NULL,8887,1027,17,'online'),(NULL,0,'2019-11-29 22:15:52',NULL,8888,1028,16,'cmdb2-4-1-13'),(NULL,0,'2019-11-29 22:15:52',NULL,8889,1028,28,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,8890,1028,24,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,8891,1028,29,'ZJ'),(NULL,0,'2019-11-29 22:15:53',NULL,8892,1028,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,8893,1028,11,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,8894,1028,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,8895,1028,15,'10.8.1.13'),(NULL,0,'2019-11-29 22:15:53',NULL,8896,1028,5,'25ac0f09731e4a699e75c29c75ccc14f'),(NULL,0,'2019-11-29 22:15:53',NULL,8897,1028,17,'online'),(NULL,0,'2019-11-29 22:15:53',NULL,8898,1029,16,'cmdb2-4-1-14'),(NULL,0,'2019-11-29 22:15:53',NULL,8899,1029,28,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,8900,1029,24,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,8901,1029,29,'ZJ'),(NULL,0,'2019-11-29 22:15:53',NULL,8902,1029,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,8903,1029,11,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,8904,1029,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,8905,1029,15,'10.8.1.14'),(NULL,0,'2019-11-29 22:15:53',NULL,8906,1029,5,'c790fe82a6fb4bbba1b614eb0e389ad3'),(NULL,0,'2019-11-29 22:15:53',NULL,8907,1029,17,'online'),(NULL,0,'2019-11-29 22:15:53',NULL,8908,1030,16,'cmdb2-4-1-15'),(NULL,0,'2019-11-29 22:15:53',NULL,8909,1030,28,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,8910,1030,24,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,8911,1030,29,'ZJ'),(NULL,0,'2019-11-29 22:15:53',NULL,8912,1030,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,8913,1030,11,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,8914,1030,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,8915,1030,15,'10.8.1.15'),(NULL,0,'2019-11-29 22:15:53',NULL,8916,1030,5,'f6899d474ba343b0837f2f984c6f7f68'),(NULL,0,'2019-11-29 22:15:53',NULL,8917,1030,17,'online'),(NULL,0,'2019-11-29 22:15:53',NULL,8918,1031,16,'cmdb2-4-1-16'),(NULL,0,'2019-11-29 22:15:53',NULL,8919,1031,28,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,8920,1031,24,'enable'),(NULL,0,'2019-11-29 22:15:53',NULL,8921,1031,29,'ZJ'),(NULL,0,'2019-11-29 22:15:53',NULL,8922,1031,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:53',NULL,8923,1031,11,'pycook'),(NULL,0,'2019-11-29 22:15:53',NULL,8924,1031,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:53',NULL,8925,1031,15,'10.8.1.16'),(NULL,0,'2019-11-29 22:15:53',NULL,8926,1031,5,'8a14df81c0cc4bdbb373e60c0bdf4141'),(NULL,0,'2019-11-29 22:15:53',NULL,8927,1031,17,'online'),(NULL,0,'2019-11-29 22:15:53',NULL,8928,1032,4,'App2-4-2'),(NULL,0,'2019-11-29 22:15:53',NULL,8929,1033,16,'cmdb2-4-2-1'),(NULL,0,'2019-11-29 22:15:53',NULL,8930,1033,28,'prod'),(NULL,0,'2019-11-29 22:15:53',NULL,8931,1033,24,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,8932,1033,29,'ZJ'),(NULL,0,'2019-11-29 22:15:54',NULL,8933,1033,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,8934,1033,11,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,8935,1033,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,8936,1033,15,'10.8.2.1'),(NULL,0,'2019-11-29 22:15:54',NULL,8937,1033,5,'a40eff57dddf408ba5a127864cd21883'),(NULL,0,'2019-11-29 22:15:54',NULL,8938,1033,17,'online'),(NULL,0,'2019-11-29 22:15:54',NULL,8939,1034,16,'cmdb2-4-2-2'),(NULL,0,'2019-11-29 22:15:54',NULL,8940,1034,28,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,8941,1034,24,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,8942,1034,29,'ZJ'),(NULL,0,'2019-11-29 22:15:54',NULL,8943,1034,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,8944,1034,11,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,8945,1034,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,8946,1034,15,'10.8.2.2'),(NULL,0,'2019-11-29 22:15:54',NULL,8947,1034,5,'b27c27b8ecf941a58702b41c18e51e42'),(NULL,0,'2019-11-29 22:15:54',NULL,8948,1034,17,'online'),(NULL,0,'2019-11-29 22:15:54',NULL,8949,1035,16,'cmdb2-4-2-3'),(NULL,0,'2019-11-29 22:15:54',NULL,8950,1035,28,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,8951,1035,24,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,8952,1035,29,'ZJ'),(NULL,0,'2019-11-29 22:15:54',NULL,8953,1035,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,8954,1035,11,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,8955,1035,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,8956,1035,15,'10.8.2.3'),(NULL,0,'2019-11-29 22:15:54',NULL,8957,1035,5,'3a02345ffbf74bd7bfed2ac4e569d22e'),(NULL,0,'2019-11-29 22:15:54',NULL,8958,1035,17,'online'),(NULL,0,'2019-11-29 22:15:54',NULL,8959,1036,16,'cmdb2-4-2-4'),(NULL,0,'2019-11-29 22:15:54',NULL,8960,1036,28,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,8961,1036,24,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,8962,1036,29,'ZJ'),(NULL,0,'2019-11-29 22:15:54',NULL,8963,1036,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,8964,1036,11,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,8965,1036,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,8966,1036,15,'10.8.2.4'),(NULL,0,'2019-11-29 22:15:54',NULL,8967,1036,5,'6a6634e29d484e229c64dce10629c459'),(NULL,0,'2019-11-29 22:15:54',NULL,8968,1036,17,'online'),(NULL,0,'2019-11-29 22:15:54',NULL,8969,1037,16,'cmdb2-4-2-5'),(NULL,0,'2019-11-29 22:15:54',NULL,8970,1037,28,'prod'),(NULL,0,'2019-11-29 22:15:54',NULL,8971,1037,24,'enable'),(NULL,0,'2019-11-29 22:15:54',NULL,8972,1037,29,'ZJ'),(NULL,0,'2019-11-29 22:15:54',NULL,8973,1037,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:54',NULL,8974,1037,11,'pycook'),(NULL,0,'2019-11-29 22:15:54',NULL,8975,1037,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:54',NULL,8976,1037,15,'10.8.2.5'),(NULL,0,'2019-11-29 22:15:55',NULL,8977,1037,5,'2cf2870fb36d46c59554ff734eb1e5df'),(NULL,0,'2019-11-29 22:15:55',NULL,8978,1037,17,'online'),(NULL,0,'2019-11-29 22:15:55',NULL,8979,1038,16,'cmdb2-4-2-6'),(NULL,0,'2019-11-29 22:15:55',NULL,8980,1038,28,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,8981,1038,24,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,8982,1038,29,'ZJ'),(NULL,0,'2019-11-29 22:15:55',NULL,8983,1038,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,8984,1038,11,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,8985,1038,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,8986,1038,15,'10.8.2.6'),(NULL,0,'2019-11-29 22:15:55',NULL,8987,1038,5,'d0b474e37f8e4188bab04e04c1080517'),(NULL,0,'2019-11-29 22:15:55',NULL,8988,1038,17,'online'),(NULL,0,'2019-11-29 22:15:55',NULL,8989,1039,16,'cmdb2-4-2-7'),(NULL,0,'2019-11-29 22:15:55',NULL,8990,1039,28,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,8991,1039,24,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,8992,1039,29,'ZJ'),(NULL,0,'2019-11-29 22:15:55',NULL,8993,1039,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,8994,1039,11,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,8995,1039,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,8996,1039,15,'10.8.2.7'),(NULL,0,'2019-11-29 22:15:55',NULL,8997,1039,5,'f7267a593dc94988867e44d0a6073ef4'),(NULL,0,'2019-11-29 22:15:55',NULL,8998,1039,17,'online'),(NULL,0,'2019-11-29 22:15:55',NULL,8999,1040,16,'cmdb2-4-2-8'),(NULL,0,'2019-11-29 22:15:55',NULL,9000,1040,28,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,9001,1040,24,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,9002,1040,29,'ZJ'),(NULL,0,'2019-11-29 22:15:55',NULL,9003,1040,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,9004,1040,11,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,9005,1040,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,9006,1040,15,'10.8.2.8'),(NULL,0,'2019-11-29 22:15:55',NULL,9007,1040,5,'1dad41b947ff4471bbbacd33c53a34a0'),(NULL,0,'2019-11-29 22:15:55',NULL,9008,1040,17,'online'),(NULL,0,'2019-11-29 22:15:55',NULL,9009,1041,16,'cmdb2-4-2-9'),(NULL,0,'2019-11-29 22:15:55',NULL,9010,1041,28,'prod'),(NULL,0,'2019-11-29 22:15:55',NULL,9011,1041,24,'enable'),(NULL,0,'2019-11-29 22:15:55',NULL,9012,1041,29,'ZJ'),(NULL,0,'2019-11-29 22:15:55',NULL,9013,1041,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:55',NULL,9014,1041,11,'pycook'),(NULL,0,'2019-11-29 22:15:55',NULL,9015,1041,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:55',NULL,9016,1041,15,'10.8.2.9'),(NULL,0,'2019-11-29 22:15:55',NULL,9017,1041,5,'261b5cb0e5e647699638c358fd826d5c'),(NULL,0,'2019-11-29 22:15:55',NULL,9018,1041,17,'online'),(NULL,0,'2019-11-29 22:15:56',NULL,9019,1042,16,'cmdb2-4-2-10'),(NULL,0,'2019-11-29 22:15:56',NULL,9020,1042,28,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,9021,1042,24,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,9022,1042,29,'ZJ'),(NULL,0,'2019-11-29 22:15:56',NULL,9023,1042,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,9024,1042,11,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,9025,1042,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,9026,1042,15,'10.8.2.10'),(NULL,0,'2019-11-29 22:15:56',NULL,9027,1042,5,'3699900cdc6d4877afc1da97ce983fb6'),(NULL,0,'2019-11-29 22:15:56',NULL,9028,1042,17,'online'),(NULL,0,'2019-11-29 22:15:56',NULL,9029,1043,16,'cmdb2-4-2-11'),(NULL,0,'2019-11-29 22:15:56',NULL,9030,1043,28,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,9031,1043,24,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,9032,1043,29,'ZJ'),(NULL,0,'2019-11-29 22:15:56',NULL,9033,1043,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,9034,1043,11,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,9035,1043,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,9036,1043,15,'10.8.2.11'),(NULL,0,'2019-11-29 22:15:56',NULL,9037,1043,5,'e9adfadfe705431bb11e28d0bd418105'),(NULL,0,'2019-11-29 22:15:56',NULL,9038,1043,17,'online'),(NULL,0,'2019-11-29 22:15:56',NULL,9039,1044,16,'cmdb2-4-2-12'),(NULL,0,'2019-11-29 22:15:56',NULL,9040,1044,28,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,9041,1044,24,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,9042,1044,29,'ZJ'),(NULL,0,'2019-11-29 22:15:56',NULL,9043,1044,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,9044,1044,11,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,9045,1044,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,9046,1044,15,'10.8.2.12'),(NULL,0,'2019-11-29 22:15:56',NULL,9047,1044,5,'e4da5c49801c441da7a9584e51386c31'),(NULL,0,'2019-11-29 22:15:56',NULL,9048,1044,17,'online'),(NULL,0,'2019-11-29 22:15:56',NULL,9049,1045,16,'cmdb2-4-2-13'),(NULL,0,'2019-11-29 22:15:56',NULL,9050,1045,28,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,9051,1045,24,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,9052,1045,29,'ZJ'),(NULL,0,'2019-11-29 22:15:56',NULL,9053,1045,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:56',NULL,9054,1045,11,'pycook'),(NULL,0,'2019-11-29 22:15:56',NULL,9055,1045,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:56',NULL,9056,1045,15,'10.8.2.13'),(NULL,0,'2019-11-29 22:15:56',NULL,9057,1045,5,'6c4fb5174994401f871320762aab4680'),(NULL,0,'2019-11-29 22:15:56',NULL,9058,1045,17,'online'),(NULL,0,'2019-11-29 22:15:56',NULL,9059,1046,16,'cmdb2-4-2-14'),(NULL,0,'2019-11-29 22:15:56',NULL,9060,1046,28,'prod'),(NULL,0,'2019-11-29 22:15:56',NULL,9061,1046,24,'enable'),(NULL,0,'2019-11-29 22:15:56',NULL,9062,1046,29,'ZJ'),(NULL,0,'2019-11-29 22:15:57',NULL,9063,1046,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,9064,1046,11,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,9065,1046,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,9066,1046,15,'10.8.2.14'),(NULL,0,'2019-11-29 22:15:57',NULL,9067,1046,5,'9153657595214fc7a549176cfefa7980'),(NULL,0,'2019-11-29 22:15:57',NULL,9068,1046,17,'online'),(NULL,0,'2019-11-29 22:15:57',NULL,9069,1047,16,'cmdb2-4-2-15'),(NULL,0,'2019-11-29 22:15:57',NULL,9070,1047,28,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,9071,1047,24,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,9072,1047,29,'ZJ'),(NULL,0,'2019-11-29 22:15:57',NULL,9073,1047,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,9074,1047,11,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,9075,1047,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,9076,1047,15,'10.8.2.15'),(NULL,0,'2019-11-29 22:15:57',NULL,9077,1047,5,'ccb1744825ed4bfcaaedc418af1c91ca'),(NULL,0,'2019-11-29 22:15:57',NULL,9078,1047,17,'online'),(NULL,0,'2019-11-29 22:15:57',NULL,9079,1048,16,'cmdb2-4-2-16'),(NULL,0,'2019-11-29 22:15:57',NULL,9080,1048,28,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,9081,1048,24,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,9082,1048,29,'ZJ'),(NULL,0,'2019-11-29 22:15:57',NULL,9083,1048,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,9084,1048,11,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,9085,1048,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,9086,1048,15,'10.8.2.16'),(NULL,0,'2019-11-29 22:15:57',NULL,9087,1048,5,'fd882e1d405c4e958a20065f6878e3a5'),(NULL,0,'2019-11-29 22:15:57',NULL,9088,1048,17,'online'),(NULL,0,'2019-11-29 22:15:57',NULL,9089,1049,4,'App2-4-3'),(NULL,0,'2019-11-29 22:15:57',NULL,9090,1050,16,'cmdb2-4-3-1'),(NULL,0,'2019-11-29 22:15:57',NULL,9091,1050,28,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,9092,1050,24,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,9093,1050,29,'ZJ'),(NULL,0,'2019-11-29 22:15:57',NULL,9094,1050,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:57',NULL,9095,1050,11,'pycook'),(NULL,0,'2019-11-29 22:15:57',NULL,9096,1050,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:57',NULL,9097,1050,15,'10.8.3.1'),(NULL,0,'2019-11-29 22:15:57',NULL,9098,1050,5,'570f667a7f8e465cbbd6609c3c2c92f7'),(NULL,0,'2019-11-29 22:15:57',NULL,9099,1050,17,'online'),(NULL,0,'2019-11-29 22:15:57',NULL,9100,1051,16,'cmdb2-4-3-2'),(NULL,0,'2019-11-29 22:15:57',NULL,9101,1051,28,'prod'),(NULL,0,'2019-11-29 22:15:57',NULL,9102,1051,24,'enable'),(NULL,0,'2019-11-29 22:15:57',NULL,9103,1051,29,'ZJ'),(NULL,0,'2019-11-29 22:15:57',NULL,9104,1051,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,9105,1051,11,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,9106,1051,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,9107,1051,15,'10.8.3.2'),(NULL,0,'2019-11-29 22:15:58',NULL,9108,1051,5,'4a24b0924da84c3b9dbca591b5a5c99a'),(NULL,0,'2019-11-29 22:15:58',NULL,9109,1051,17,'online'),(NULL,0,'2019-11-29 22:15:58',NULL,9110,1052,16,'cmdb2-4-3-3'),(NULL,0,'2019-11-29 22:15:58',NULL,9111,1052,28,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,9112,1052,24,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,9113,1052,29,'ZJ'),(NULL,0,'2019-11-29 22:15:58',NULL,9114,1052,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,9115,1052,11,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,9116,1052,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,9117,1052,15,'10.8.3.3'),(NULL,0,'2019-11-29 22:15:58',NULL,9118,1052,5,'ccab04214b814c96bd9a8bd2cce0c1df'),(NULL,0,'2019-11-29 22:15:58',NULL,9119,1052,17,'online'),(NULL,0,'2019-11-29 22:15:58',NULL,9120,1053,16,'cmdb2-4-3-4'),(NULL,0,'2019-11-29 22:15:58',NULL,9121,1053,28,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,9122,1053,24,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,9123,1053,29,'ZJ'),(NULL,0,'2019-11-29 22:15:58',NULL,9124,1053,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,9125,1053,11,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,9126,1053,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,9127,1053,15,'10.8.3.4'),(NULL,0,'2019-11-29 22:15:58',NULL,9128,1053,5,'86e50f937c50484ab1de19c9d5106ed0'),(NULL,0,'2019-11-29 22:15:58',NULL,9129,1053,17,'online'),(NULL,0,'2019-11-29 22:15:58',NULL,9130,1054,16,'cmdb2-4-3-5'),(NULL,0,'2019-11-29 22:15:58',NULL,9131,1054,28,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,9132,1054,24,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,9133,1054,29,'ZJ'),(NULL,0,'2019-11-29 22:15:58',NULL,9134,1054,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,9135,1054,11,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,9136,1054,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:58',NULL,9137,1054,15,'10.8.3.5'),(NULL,0,'2019-11-29 22:15:58',NULL,9138,1054,5,'11b4c6001c7f4f07a764a26f713f6498'),(NULL,0,'2019-11-29 22:15:58',NULL,9139,1054,17,'online'),(NULL,0,'2019-11-29 22:15:58',NULL,9140,1055,16,'cmdb2-4-3-6'),(NULL,0,'2019-11-29 22:15:58',NULL,9141,1055,28,'prod'),(NULL,0,'2019-11-29 22:15:58',NULL,9142,1055,24,'enable'),(NULL,0,'2019-11-29 22:15:58',NULL,9143,1055,29,'ZJ'),(NULL,0,'2019-11-29 22:15:58',NULL,9144,1055,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:58',NULL,9145,1055,11,'pycook'),(NULL,0,'2019-11-29 22:15:58',NULL,9146,1055,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,9147,1055,15,'10.8.3.6'),(NULL,0,'2019-11-29 22:15:59',NULL,9148,1055,5,'5fd30f933b524ce98339237d78cffb2d'),(NULL,0,'2019-11-29 22:15:59',NULL,9149,1055,17,'online'),(NULL,0,'2019-11-29 22:15:59',NULL,9150,1056,16,'cmdb2-4-3-7'),(NULL,0,'2019-11-29 22:15:59',NULL,9151,1056,28,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,9152,1056,24,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,9153,1056,29,'ZJ'),(NULL,0,'2019-11-29 22:15:59',NULL,9154,1056,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,9155,1056,11,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,9156,1056,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,9157,1056,15,'10.8.3.7'),(NULL,0,'2019-11-29 22:15:59',NULL,9158,1056,5,'b56d5c2d016a4a0bbf0352654a53e648'),(NULL,0,'2019-11-29 22:15:59',NULL,9159,1056,17,'online'),(NULL,0,'2019-11-29 22:15:59',NULL,9160,1057,16,'cmdb2-4-3-8'),(NULL,0,'2019-11-29 22:15:59',NULL,9161,1057,28,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,9162,1057,24,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,9163,1057,29,'ZJ'),(NULL,0,'2019-11-29 22:15:59',NULL,9164,1057,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,9165,1057,11,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,9166,1057,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,9167,1057,15,'10.8.3.8'),(NULL,0,'2019-11-29 22:15:59',NULL,9168,1057,5,'ebb58dea825d40ce81fe68b6206689dc'),(NULL,0,'2019-11-29 22:15:59',NULL,9169,1057,17,'online'),(NULL,0,'2019-11-29 22:15:59',NULL,9170,1058,16,'cmdb2-4-3-9'),(NULL,0,'2019-11-29 22:15:59',NULL,9171,1058,28,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,9172,1058,24,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,9173,1058,29,'ZJ'),(NULL,0,'2019-11-29 22:15:59',NULL,9174,1058,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,9175,1058,11,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,9176,1058,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,9177,1058,15,'10.8.3.9'),(NULL,0,'2019-11-29 22:15:59',NULL,9178,1058,5,'7e965452847a4fc297ff7d494f5a5ba2'),(NULL,0,'2019-11-29 22:15:59',NULL,9179,1058,17,'online'),(NULL,0,'2019-11-29 22:15:59',NULL,9180,1059,16,'cmdb2-4-3-10'),(NULL,0,'2019-11-29 22:15:59',NULL,9181,1059,28,'prod'),(NULL,0,'2019-11-29 22:15:59',NULL,9182,1059,24,'enable'),(NULL,0,'2019-11-29 22:15:59',NULL,9183,1059,29,'ZJ'),(NULL,0,'2019-11-29 22:15:59',NULL,9184,1059,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:15:59',NULL,9185,1059,11,'pycook'),(NULL,0,'2019-11-29 22:15:59',NULL,9186,1059,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:15:59',NULL,9187,1059,15,'10.8.3.10'),(NULL,0,'2019-11-29 22:15:59',NULL,9188,1059,5,'539e74b5297d45828c2eaf0512e65c3f'),(NULL,0,'2019-11-29 22:15:59',NULL,9189,1059,17,'online'),(NULL,0,'2019-11-29 22:16:00',NULL,9190,1060,16,'cmdb2-4-3-11'),(NULL,0,'2019-11-29 22:16:00',NULL,9191,1060,28,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,9192,1060,24,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,9193,1060,29,'ZJ'),(NULL,0,'2019-11-29 22:16:00',NULL,9194,1060,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,9195,1060,11,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,9196,1060,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,9197,1060,15,'10.8.3.11'),(NULL,0,'2019-11-29 22:16:00',NULL,9198,1060,5,'0d8ff5db57be4a3aa9035dce8e28f1a1'),(NULL,0,'2019-11-29 22:16:00',NULL,9199,1060,17,'online'),(NULL,0,'2019-11-29 22:16:00',NULL,9200,1061,16,'cmdb2-4-3-12'),(NULL,0,'2019-11-29 22:16:00',NULL,9201,1061,28,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,9202,1061,24,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,9203,1061,29,'ZJ'),(NULL,0,'2019-11-29 22:16:00',NULL,9204,1061,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,9205,1061,11,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,9206,1061,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,9207,1061,15,'10.8.3.12'),(NULL,0,'2019-11-29 22:16:00',NULL,9208,1061,5,'eb9870897d6f4af4be485098e9ed068c'),(NULL,0,'2019-11-29 22:16:00',NULL,9209,1061,17,'online'),(NULL,0,'2019-11-29 22:16:00',NULL,9210,1062,16,'cmdb2-4-3-13'),(NULL,0,'2019-11-29 22:16:00',NULL,9211,1062,28,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,9212,1062,24,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,9213,1062,29,'ZJ'),(NULL,0,'2019-11-29 22:16:00',NULL,9214,1062,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,9215,1062,11,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,9216,1062,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,9217,1062,15,'10.8.3.13'),(NULL,0,'2019-11-29 22:16:00',NULL,9218,1062,5,'8722ef9e22a744d9befe0c34d9a3866f'),(NULL,0,'2019-11-29 22:16:00',NULL,9219,1062,17,'online'),(NULL,0,'2019-11-29 22:16:00',NULL,9220,1063,16,'cmdb2-4-3-14'),(NULL,0,'2019-11-29 22:16:00',NULL,9221,1063,28,'prod'),(NULL,0,'2019-11-29 22:16:00',NULL,9222,1063,24,'enable'),(NULL,0,'2019-11-29 22:16:00',NULL,9223,1063,29,'ZJ'),(NULL,0,'2019-11-29 22:16:00',NULL,9224,1063,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:00',NULL,9225,1063,11,'pycook'),(NULL,0,'2019-11-29 22:16:00',NULL,9226,1063,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:00',NULL,9227,1063,15,'10.8.3.14'),(NULL,0,'2019-11-29 22:16:00',NULL,9228,1063,5,'527deee973a44ef68da770477a5cd17f'),(NULL,0,'2019-11-29 22:16:00',NULL,9229,1063,17,'online'),(NULL,0,'2019-11-29 22:16:00',NULL,9230,1064,16,'cmdb2-4-3-15'),(NULL,0,'2019-11-29 22:16:00',NULL,9231,1064,28,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,9232,1064,24,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,9233,1064,29,'ZJ'),(NULL,0,'2019-11-29 22:16:01',NULL,9234,1064,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,9235,1064,11,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,9236,1064,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,9237,1064,15,'10.8.3.15'),(NULL,0,'2019-11-29 22:16:01',NULL,9238,1064,5,'8861f1eb99e644409de0e0d1c85d9ff1'),(NULL,0,'2019-11-29 22:16:01',NULL,9239,1064,17,'online'),(NULL,0,'2019-11-29 22:16:01',NULL,9240,1065,16,'cmdb2-4-3-16'),(NULL,0,'2019-11-29 22:16:01',NULL,9241,1065,28,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,9242,1065,24,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,9243,1065,29,'ZJ'),(NULL,0,'2019-11-29 22:16:01',NULL,9244,1065,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,9245,1065,11,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,9246,1065,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,9247,1065,15,'10.8.3.16'),(NULL,0,'2019-11-29 22:16:01',NULL,9248,1065,5,'32e54a813fc549e190358aa5f5d732fd'),(NULL,0,'2019-11-29 22:16:01',NULL,9249,1065,17,'online'),(NULL,0,'2019-11-29 22:16:01',NULL,9250,1066,4,'App2-4-4'),(NULL,0,'2019-11-29 22:16:01',NULL,9251,1067,16,'cmdb2-4-4-1'),(NULL,0,'2019-11-29 22:16:01',NULL,9252,1067,28,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,9253,1067,24,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,9254,1067,29,'ZJ'),(NULL,0,'2019-11-29 22:16:01',NULL,9255,1067,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,9256,1067,11,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,9257,1067,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,9258,1067,15,'10.8.4.1'),(NULL,0,'2019-11-29 22:16:01',NULL,9259,1067,5,'7c97eb85a3db475a9a5cc4b49a9b7699'),(NULL,0,'2019-11-29 22:16:01',NULL,9260,1067,17,'online'),(NULL,0,'2019-11-29 22:16:01',NULL,9261,1068,16,'cmdb2-4-4-2'),(NULL,0,'2019-11-29 22:16:01',NULL,9262,1068,28,'prod'),(NULL,0,'2019-11-29 22:16:01',NULL,9263,1068,24,'enable'),(NULL,0,'2019-11-29 22:16:01',NULL,9264,1068,29,'ZJ'),(NULL,0,'2019-11-29 22:16:01',NULL,9265,1068,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:01',NULL,9266,1068,11,'pycook'),(NULL,0,'2019-11-29 22:16:01',NULL,9267,1068,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:01',NULL,9268,1068,15,'10.8.4.2'),(NULL,0,'2019-11-29 22:16:01',NULL,9269,1068,5,'0767fecac798486da66c53d8157ad1b1'),(NULL,0,'2019-11-29 22:16:01',NULL,9270,1068,17,'online'),(NULL,0,'2019-11-29 22:16:01',NULL,9271,1069,16,'cmdb2-4-4-3'),(NULL,0,'2019-11-29 22:16:01',NULL,9272,1069,28,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,9273,1069,24,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,9274,1069,29,'ZJ'),(NULL,0,'2019-11-29 22:16:02',NULL,9275,1069,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,9276,1069,11,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,9277,1069,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,9278,1069,15,'10.8.4.3'),(NULL,0,'2019-11-29 22:16:02',NULL,9279,1069,5,'16ace48258264dd192e743c0dc2ccc6c'),(NULL,0,'2019-11-29 22:16:02',NULL,9280,1069,17,'online'),(NULL,0,'2019-11-29 22:16:02',NULL,9281,1070,16,'cmdb2-4-4-4'),(NULL,0,'2019-11-29 22:16:02',NULL,9282,1070,28,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,9283,1070,24,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,9284,1070,29,'ZJ'),(NULL,0,'2019-11-29 22:16:02',NULL,9285,1070,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,9286,1070,11,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,9287,1070,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,9288,1070,15,'10.8.4.4'),(NULL,0,'2019-11-29 22:16:02',NULL,9289,1070,5,'180141b6ae6246e0a418bfa827aed593'),(NULL,0,'2019-11-29 22:16:02',NULL,9290,1070,17,'online'),(NULL,0,'2019-11-29 22:16:02',NULL,9291,1071,16,'cmdb2-4-4-5'),(NULL,0,'2019-11-29 22:16:02',NULL,9292,1071,28,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,9293,1071,24,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,9294,1071,29,'ZJ'),(NULL,0,'2019-11-29 22:16:02',NULL,9295,1071,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,9296,1071,11,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,9297,1071,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,9298,1071,15,'10.8.4.5'),(NULL,0,'2019-11-29 22:16:02',NULL,9299,1071,5,'065f0b658c7142e8a9793ec9b8e7ce7f'),(NULL,0,'2019-11-29 22:16:02',NULL,9300,1071,17,'online'),(NULL,0,'2019-11-29 22:16:02',NULL,9301,1072,16,'cmdb2-4-4-6'),(NULL,0,'2019-11-29 22:16:02',NULL,9302,1072,28,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,9303,1072,24,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,9304,1072,29,'ZJ'),(NULL,0,'2019-11-29 22:16:02',NULL,9305,1072,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,9306,1072,11,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,9307,1072,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,9308,1072,15,'10.8.4.6'),(NULL,0,'2019-11-29 22:16:02',NULL,9309,1072,5,'3b08020ae8154e319bbe10b6f84d87b9'),(NULL,0,'2019-11-29 22:16:02',NULL,9310,1072,17,'online'),(NULL,0,'2019-11-29 22:16:02',NULL,9311,1073,16,'cmdb2-4-4-7'),(NULL,0,'2019-11-29 22:16:02',NULL,9312,1073,28,'prod'),(NULL,0,'2019-11-29 22:16:02',NULL,9313,1073,24,'enable'),(NULL,0,'2019-11-29 22:16:02',NULL,9314,1073,29,'ZJ'),(NULL,0,'2019-11-29 22:16:02',NULL,9315,1073,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:02',NULL,9316,1073,11,'pycook'),(NULL,0,'2019-11-29 22:16:02',NULL,9317,1073,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:02',NULL,9318,1073,15,'10.8.4.7'),(NULL,0,'2019-11-29 22:16:03',NULL,9319,1073,5,'c41f3964e68a41029c6b4207c4b63a16'),(NULL,0,'2019-11-29 22:16:03',NULL,9320,1073,17,'online'),(NULL,0,'2019-11-29 22:16:03',NULL,9321,1074,16,'cmdb2-4-4-8'),(NULL,0,'2019-11-29 22:16:03',NULL,9322,1074,28,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,9323,1074,24,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,9324,1074,29,'ZJ'),(NULL,0,'2019-11-29 22:16:03',NULL,9325,1074,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,9326,1074,11,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,9327,1074,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,9328,1074,15,'10.8.4.8'),(NULL,0,'2019-11-29 22:16:03',NULL,9329,1074,5,'3b6721cac2a5470d91fa7f16829769a4'),(NULL,0,'2019-11-29 22:16:03',NULL,9330,1074,17,'online'),(NULL,0,'2019-11-29 22:16:03',NULL,9331,1075,16,'cmdb2-4-4-9'),(NULL,0,'2019-11-29 22:16:03',NULL,9332,1075,28,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,9333,1075,24,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,9334,1075,29,'ZJ'),(NULL,0,'2019-11-29 22:16:03',NULL,9335,1075,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,9336,1075,11,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,9337,1075,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,9338,1075,15,'10.8.4.9'),(NULL,0,'2019-11-29 22:16:03',NULL,9339,1075,5,'21cbae733b6b47a986a6cc91935884da'),(NULL,0,'2019-11-29 22:16:03',NULL,9340,1075,17,'online'),(NULL,0,'2019-11-29 22:16:03',NULL,9341,1076,16,'cmdb2-4-4-10'),(NULL,0,'2019-11-29 22:16:03',NULL,9342,1076,28,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,9343,1076,24,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,9344,1076,29,'ZJ'),(NULL,0,'2019-11-29 22:16:03',NULL,9345,1076,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,9346,1076,11,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,9347,1076,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,9348,1076,15,'10.8.4.10'),(NULL,0,'2019-11-29 22:16:03',NULL,9349,1076,5,'76fb009863ee4cbb85b6077e187386a9'),(NULL,0,'2019-11-29 22:16:03',NULL,9350,1076,17,'online'),(NULL,0,'2019-11-29 22:16:03',NULL,9351,1077,16,'cmdb2-4-4-11'),(NULL,0,'2019-11-29 22:16:03',NULL,9352,1077,28,'prod'),(NULL,0,'2019-11-29 22:16:03',NULL,9353,1077,24,'enable'),(NULL,0,'2019-11-29 22:16:03',NULL,9354,1077,29,'ZJ'),(NULL,0,'2019-11-29 22:16:03',NULL,9355,1077,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:03',NULL,9356,1077,11,'pycook'),(NULL,0,'2019-11-29 22:16:03',NULL,9357,1077,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:03',NULL,9358,1077,15,'10.8.4.11'),(NULL,0,'2019-11-29 22:16:03',NULL,9359,1077,5,'6c867bbbe095463088f2b5d5cb78dfad'),(NULL,0,'2019-11-29 22:16:03',NULL,9360,1077,17,'online'),(NULL,0,'2019-11-29 22:16:04',NULL,9361,1078,16,'cmdb2-4-4-12'),(NULL,0,'2019-11-29 22:16:04',NULL,9362,1078,28,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,9363,1078,24,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,9364,1078,29,'ZJ'),(NULL,0,'2019-11-29 22:16:04',NULL,9365,1078,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,9366,1078,11,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,9367,1078,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,9368,1078,15,'10.8.4.12'),(NULL,0,'2019-11-29 22:16:04',NULL,9369,1078,5,'bb5dc2000f8e44089b45d6105ea43601'),(NULL,0,'2019-11-29 22:16:04',NULL,9370,1078,17,'online'),(NULL,0,'2019-11-29 22:16:04',NULL,9371,1079,16,'cmdb2-4-4-13'),(NULL,0,'2019-11-29 22:16:04',NULL,9372,1079,28,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,9373,1079,24,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,9374,1079,29,'ZJ'),(NULL,0,'2019-11-29 22:16:04',NULL,9375,1079,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,9376,1079,11,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,9377,1079,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,9378,1079,15,'10.8.4.13'),(NULL,0,'2019-11-29 22:16:04',NULL,9379,1079,5,'278e04319f4041e68d5b09e05144abb2'),(NULL,0,'2019-11-29 22:16:04',NULL,9380,1079,17,'online'),(NULL,0,'2019-11-29 22:16:04',NULL,9381,1080,16,'cmdb2-4-4-14'),(NULL,0,'2019-11-29 22:16:04',NULL,9382,1080,28,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,9383,1080,24,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,9384,1080,29,'ZJ'),(NULL,0,'2019-11-29 22:16:04',NULL,9385,1080,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,9386,1080,11,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,9387,1080,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,9388,1080,15,'10.8.4.14'),(NULL,0,'2019-11-29 22:16:04',NULL,9389,1080,5,'6c0f93d1b5764176a7b6542850b4690b'),(NULL,0,'2019-11-29 22:16:04',NULL,9390,1080,17,'online'),(NULL,0,'2019-11-29 22:16:04',NULL,9391,1081,16,'cmdb2-4-4-15'),(NULL,0,'2019-11-29 22:16:04',NULL,9392,1081,28,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,9393,1081,24,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,9394,1081,29,'ZJ'),(NULL,0,'2019-11-29 22:16:04',NULL,9395,1081,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:04',NULL,9396,1081,11,'pycook'),(NULL,0,'2019-11-29 22:16:04',NULL,9397,1081,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:04',NULL,9398,1081,15,'10.8.4.15'),(NULL,0,'2019-11-29 22:16:04',NULL,9399,1081,5,'cbce35ad727748f497638bfd10ee34d0'),(NULL,0,'2019-11-29 22:16:04',NULL,9400,1081,17,'online'),(NULL,0,'2019-11-29 22:16:04',NULL,9401,1082,16,'cmdb2-4-4-16'),(NULL,0,'2019-11-29 22:16:04',NULL,9402,1082,28,'prod'),(NULL,0,'2019-11-29 22:16:04',NULL,9403,1082,24,'enable'),(NULL,0,'2019-11-29 22:16:04',NULL,9404,1082,29,'ZJ'),(NULL,0,'2019-11-29 22:16:05',NULL,9405,1082,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,9406,1082,11,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,9407,1082,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,9408,1082,15,'10.8.4.16'),(NULL,0,'2019-11-29 22:16:05',NULL,9409,1082,5,'63e9b83658f7424392b6cc4a2311c26c'),(NULL,0,'2019-11-29 22:16:05',NULL,9410,1082,17,'online'),(NULL,0,'2019-11-29 22:16:05',NULL,9411,1083,4,'App2-4-5'),(NULL,0,'2019-11-29 22:16:05',NULL,9412,1084,16,'cmdb2-4-5-1'),(NULL,0,'2019-11-29 22:16:05',NULL,9413,1084,28,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,9414,1084,24,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,9415,1084,29,'ZJ'),(NULL,0,'2019-11-29 22:16:05',NULL,9416,1084,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,9417,1084,11,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,9418,1084,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,9419,1084,15,'10.8.5.1'),(NULL,0,'2019-11-29 22:16:05',NULL,9420,1084,5,'e4cf22096b784c509cc0e68c567c37bb'),(NULL,0,'2019-11-29 22:16:05',NULL,9421,1084,17,'online'),(NULL,0,'2019-11-29 22:16:05',NULL,9422,1085,16,'cmdb2-4-5-2'),(NULL,0,'2019-11-29 22:16:05',NULL,9423,1085,28,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,9424,1085,24,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,9425,1085,29,'ZJ'),(NULL,0,'2019-11-29 22:16:05',NULL,9426,1085,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,9427,1085,11,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,9428,1085,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,9429,1085,15,'10.8.5.2'),(NULL,0,'2019-11-29 22:16:05',NULL,9430,1085,5,'67bde2d1157b463d95e4e45a65667afa'),(NULL,0,'2019-11-29 22:16:05',NULL,9431,1085,17,'online'),(NULL,0,'2019-11-29 22:16:05',NULL,9432,1086,16,'cmdb2-4-5-3'),(NULL,0,'2019-11-29 22:16:05',NULL,9433,1086,28,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,9434,1086,24,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,9435,1086,29,'ZJ'),(NULL,0,'2019-11-29 22:16:05',NULL,9436,1086,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:05',NULL,9437,1086,11,'pycook'),(NULL,0,'2019-11-29 22:16:05',NULL,9438,1086,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:05',NULL,9439,1086,15,'10.8.5.3'),(NULL,0,'2019-11-29 22:16:05',NULL,9440,1086,5,'2fe4fec4bb664eb4b75339d97e802036'),(NULL,0,'2019-11-29 22:16:05',NULL,9441,1086,17,'online'),(NULL,0,'2019-11-29 22:16:05',NULL,9442,1087,16,'cmdb2-4-5-4'),(NULL,0,'2019-11-29 22:16:05',NULL,9443,1087,28,'prod'),(NULL,0,'2019-11-29 22:16:05',NULL,9444,1087,24,'enable'),(NULL,0,'2019-11-29 22:16:05',NULL,9445,1087,29,'ZJ'),(NULL,0,'2019-11-29 22:16:05',NULL,9446,1087,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,9447,1087,11,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,9448,1087,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,9449,1087,15,'10.8.5.4'),(NULL,0,'2019-11-29 22:16:06',NULL,9450,1087,5,'0286ccae8bb244c1b96240641455b6d4'),(NULL,0,'2019-11-29 22:16:06',NULL,9451,1087,17,'online'),(NULL,0,'2019-11-29 22:16:06',NULL,9452,1088,16,'cmdb2-4-5-5'),(NULL,0,'2019-11-29 22:16:06',NULL,9453,1088,28,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,9454,1088,24,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,9455,1088,29,'ZJ'),(NULL,0,'2019-11-29 22:16:06',NULL,9456,1088,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,9457,1088,11,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,9458,1088,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,9459,1088,15,'10.8.5.5'),(NULL,0,'2019-11-29 22:16:06',NULL,9460,1088,5,'0f3fcd0c6b414e7d9fb0e428e519a568'),(NULL,0,'2019-11-29 22:16:06',NULL,9461,1088,17,'online'),(NULL,0,'2019-11-29 22:16:06',NULL,9462,1089,16,'cmdb2-4-5-6'),(NULL,0,'2019-11-29 22:16:06',NULL,9463,1089,28,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,9464,1089,24,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,9465,1089,29,'ZJ'),(NULL,0,'2019-11-29 22:16:06',NULL,9466,1089,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,9467,1089,11,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,9468,1089,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,9469,1089,15,'10.8.5.6'),(NULL,0,'2019-11-29 22:16:06',NULL,9470,1089,5,'545b72645d6742c9b37c95132fc69b3d'),(NULL,0,'2019-11-29 22:16:06',NULL,9471,1089,17,'online'),(NULL,0,'2019-11-29 22:16:06',NULL,9472,1090,16,'cmdb2-4-5-7'),(NULL,0,'2019-11-29 22:16:06',NULL,9473,1090,28,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,9474,1090,24,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,9475,1090,29,'ZJ'),(NULL,0,'2019-11-29 22:16:06',NULL,9476,1090,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,9477,1090,11,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,9478,1090,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,9479,1090,15,'10.8.5.7'),(NULL,0,'2019-11-29 22:16:06',NULL,9480,1090,5,'c4cf4d4a6851421986175c59d5aac9ad'),(NULL,0,'2019-11-29 22:16:06',NULL,9481,1090,17,'online'),(NULL,0,'2019-11-29 22:16:06',NULL,9482,1091,16,'cmdb2-4-5-8'),(NULL,0,'2019-11-29 22:16:06',NULL,9483,1091,28,'prod'),(NULL,0,'2019-11-29 22:16:06',NULL,9484,1091,24,'enable'),(NULL,0,'2019-11-29 22:16:06',NULL,9485,1091,29,'ZJ'),(NULL,0,'2019-11-29 22:16:06',NULL,9486,1091,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:06',NULL,9487,1091,11,'pycook'),(NULL,0,'2019-11-29 22:16:06',NULL,9488,1091,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:06',NULL,9489,1091,15,'10.8.5.8'),(NULL,0,'2019-11-29 22:16:06',NULL,9490,1091,5,'878bd43fc0c24c149d8bf76e4dc39256'),(NULL,0,'2019-11-29 22:16:07',NULL,9491,1091,17,'online'),(NULL,0,'2019-11-29 22:16:07',NULL,9492,1092,16,'cmdb2-4-5-9'),(NULL,0,'2019-11-29 22:16:07',NULL,9493,1092,28,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,9494,1092,24,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,9495,1092,29,'ZJ'),(NULL,0,'2019-11-29 22:16:07',NULL,9496,1092,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,9497,1092,11,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,9498,1092,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,9499,1092,15,'10.8.5.9'),(NULL,0,'2019-11-29 22:16:07',NULL,9500,1092,5,'83a2a83ed6714288b941809540f3bebb'),(NULL,0,'2019-11-29 22:16:07',NULL,9501,1092,17,'online'),(NULL,0,'2019-11-29 22:16:07',NULL,9502,1093,16,'cmdb2-4-5-10'),(NULL,0,'2019-11-29 22:16:07',NULL,9503,1093,28,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,9504,1093,24,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,9505,1093,29,'ZJ'),(NULL,0,'2019-11-29 22:16:07',NULL,9506,1093,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,9507,1093,11,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,9508,1093,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,9509,1093,15,'10.8.5.10'),(NULL,0,'2019-11-29 22:16:07',NULL,9510,1093,5,'55d77047d6de4132b6c7c3673fcdd542'),(NULL,0,'2019-11-29 22:16:07',NULL,9511,1093,17,'online'),(NULL,0,'2019-11-29 22:16:07',NULL,9512,1094,16,'cmdb2-4-5-11'),(NULL,0,'2019-11-29 22:16:07',NULL,9513,1094,28,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,9514,1094,24,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,9515,1094,29,'ZJ'),(NULL,0,'2019-11-29 22:16:07',NULL,9516,1094,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,9517,1094,11,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,9518,1094,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,9519,1094,15,'10.8.5.11'),(NULL,0,'2019-11-29 22:16:07',NULL,9520,1094,5,'10d8605049174d7982da8b835d692cd9'),(NULL,0,'2019-11-29 22:16:07',NULL,9521,1094,17,'online'),(NULL,0,'2019-11-29 22:16:07',NULL,9522,1095,16,'cmdb2-4-5-12'),(NULL,0,'2019-11-29 22:16:07',NULL,9523,1095,28,'prod'),(NULL,0,'2019-11-29 22:16:07',NULL,9524,1095,24,'enable'),(NULL,0,'2019-11-29 22:16:07',NULL,9525,1095,29,'ZJ'),(NULL,0,'2019-11-29 22:16:07',NULL,9526,1095,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:07',NULL,9527,1095,11,'pycook'),(NULL,0,'2019-11-29 22:16:07',NULL,9528,1095,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:07',NULL,9529,1095,15,'10.8.5.12'),(NULL,0,'2019-11-29 22:16:07',NULL,9530,1095,5,'8ea3dad88e36472fbe1b2b2a8af50a7a'),(NULL,0,'2019-11-29 22:16:07',NULL,9531,1095,17,'online'),(NULL,0,'2019-11-29 22:16:07',NULL,9532,1096,16,'cmdb2-4-5-13'),(NULL,0,'2019-11-29 22:16:08',NULL,9533,1096,28,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,9534,1096,24,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,9535,1096,29,'ZJ'),(NULL,0,'2019-11-29 22:16:08',NULL,9536,1096,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,9537,1096,11,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,9538,1096,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,9539,1096,15,'10.8.5.13'),(NULL,0,'2019-11-29 22:16:08',NULL,9540,1096,5,'58086836b5c5485aa7001333c654e26e'),(NULL,0,'2019-11-29 22:16:08',NULL,9541,1096,17,'online'),(NULL,0,'2019-11-29 22:16:08',NULL,9542,1097,16,'cmdb2-4-5-14'),(NULL,0,'2019-11-29 22:16:08',NULL,9543,1097,28,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,9544,1097,24,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,9545,1097,29,'ZJ'),(NULL,0,'2019-11-29 22:16:08',NULL,9546,1097,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,9547,1097,11,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,9548,1097,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,9549,1097,15,'10.8.5.14'),(NULL,0,'2019-11-29 22:16:08',NULL,9550,1097,5,'6cf1733cec2f4ab4ad27ce49dce1bbd3'),(NULL,0,'2019-11-29 22:16:08',NULL,9551,1097,17,'online'),(NULL,0,'2019-11-29 22:16:08',NULL,9552,1098,16,'cmdb2-4-5-15'),(NULL,0,'2019-11-29 22:16:08',NULL,9553,1098,28,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,9554,1098,24,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,9555,1098,29,'ZJ'),(NULL,0,'2019-11-29 22:16:08',NULL,9556,1098,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,9557,1098,11,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,9558,1098,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,9559,1098,15,'10.8.5.15'),(NULL,0,'2019-11-29 22:16:08',NULL,9560,1098,5,'40371cc58b1349d5853dcc697f881f0b'),(NULL,0,'2019-11-29 22:16:08',NULL,9561,1098,17,'online'),(NULL,0,'2019-11-29 22:16:08',NULL,9562,1099,16,'cmdb2-4-5-16'),(NULL,0,'2019-11-29 22:16:08',NULL,9563,1099,28,'prod'),(NULL,0,'2019-11-29 22:16:08',NULL,9564,1099,24,'enable'),(NULL,0,'2019-11-29 22:16:08',NULL,9565,1099,29,'ZJ'),(NULL,0,'2019-11-29 22:16:08',NULL,9566,1099,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:08',NULL,9567,1099,11,'pycook'),(NULL,0,'2019-11-29 22:16:08',NULL,9568,1099,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:08',NULL,9569,1099,15,'10.8.5.16'),(NULL,0,'2019-11-29 22:16:08',NULL,9570,1099,5,'d95139398a674f22b2609f423d246e2a'),(NULL,0,'2019-11-29 22:16:08',NULL,9571,1099,17,'online'),(NULL,0,'2019-11-29 22:16:08',NULL,9572,1100,4,'App2-4-6'),(NULL,0,'2019-11-29 22:16:08',NULL,9573,1101,16,'cmdb2-4-6-1'),(NULL,0,'2019-11-29 22:16:09',NULL,9574,1101,28,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,9575,1101,24,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,9576,1101,29,'ZJ'),(NULL,0,'2019-11-29 22:16:09',NULL,9577,1101,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,9578,1101,11,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,9579,1101,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,9580,1101,15,'10.8.6.1'),(NULL,0,'2019-11-29 22:16:09',NULL,9581,1101,5,'ca3745dbe791458fa6ca8f63c3c6e9a2'),(NULL,0,'2019-11-29 22:16:09',NULL,9582,1101,17,'online'),(NULL,0,'2019-11-29 22:16:09',NULL,9583,1102,16,'cmdb2-4-6-2'),(NULL,0,'2019-11-29 22:16:09',NULL,9584,1102,28,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,9585,1102,24,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,9586,1102,29,'ZJ'),(NULL,0,'2019-11-29 22:16:09',NULL,9587,1102,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,9588,1102,11,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,9589,1102,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,9590,1102,15,'10.8.6.2'),(NULL,0,'2019-11-29 22:16:09',NULL,9591,1102,5,'1db34cf74fbf40c2a4bf21db880ae298'),(NULL,0,'2019-11-29 22:16:09',NULL,9592,1102,17,'online'),(NULL,0,'2019-11-29 22:16:09',NULL,9593,1103,16,'cmdb2-4-6-3'),(NULL,0,'2019-11-29 22:16:09',NULL,9594,1103,28,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,9595,1103,24,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,9596,1103,29,'ZJ'),(NULL,0,'2019-11-29 22:16:09',NULL,9597,1103,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,9598,1103,11,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,9599,1103,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,9600,1103,15,'10.8.6.3'),(NULL,0,'2019-11-29 22:16:09',NULL,9601,1103,5,'ec216c8a298249818d4e835880716aa5'),(NULL,0,'2019-11-29 22:16:09',NULL,9602,1103,17,'online'),(NULL,0,'2019-11-29 22:16:09',NULL,9603,1104,16,'cmdb2-4-6-4'),(NULL,0,'2019-11-29 22:16:09',NULL,9604,1104,28,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,9605,1104,24,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,9606,1104,29,'ZJ'),(NULL,0,'2019-11-29 22:16:09',NULL,9607,1104,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,9608,1104,11,'pycook'),(NULL,0,'2019-11-29 22:16:09',NULL,9609,1104,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:09',NULL,9610,1104,15,'10.8.6.4'),(NULL,0,'2019-11-29 22:16:09',NULL,9611,1104,5,'5b443248e53745c2b4c92f7b59ca5618'),(NULL,0,'2019-11-29 22:16:09',NULL,9612,1104,17,'online'),(NULL,0,'2019-11-29 22:16:09',NULL,9613,1105,16,'cmdb2-4-6-5'),(NULL,0,'2019-11-29 22:16:09',NULL,9614,1105,28,'prod'),(NULL,0,'2019-11-29 22:16:09',NULL,9615,1105,24,'enable'),(NULL,0,'2019-11-29 22:16:09',NULL,9616,1105,29,'ZJ'),(NULL,0,'2019-11-29 22:16:09',NULL,9617,1105,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:09',NULL,9618,1105,11,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,9619,1105,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,9620,1105,15,'10.8.6.5'),(NULL,0,'2019-11-29 22:16:10',NULL,9621,1105,5,'dea7a2a2958a42df9ee5e3c8afabe60b'),(NULL,0,'2019-11-29 22:16:10',NULL,9622,1105,17,'online'),(NULL,0,'2019-11-29 22:16:10',NULL,9623,1106,16,'cmdb2-4-6-6'),(NULL,0,'2019-11-29 22:16:10',NULL,9624,1106,28,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,9625,1106,24,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,9626,1106,29,'ZJ'),(NULL,0,'2019-11-29 22:16:10',NULL,9627,1106,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,9628,1106,11,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,9629,1106,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,9630,1106,15,'10.8.6.6'),(NULL,0,'2019-11-29 22:16:10',NULL,9631,1106,5,'f4e09fc345274b75ba762ac68e2ec005'),(NULL,0,'2019-11-29 22:16:10',NULL,9632,1106,17,'online'),(NULL,0,'2019-11-29 22:16:10',NULL,9633,1107,16,'cmdb2-4-6-7'),(NULL,0,'2019-11-29 22:16:10',NULL,9634,1107,28,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,9635,1107,24,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,9636,1107,29,'ZJ'),(NULL,0,'2019-11-29 22:16:10',NULL,9637,1107,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,9638,1107,11,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,9639,1107,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,9640,1107,15,'10.8.6.7'),(NULL,0,'2019-11-29 22:16:10',NULL,9641,1107,5,'191cae6e64274448b7c063e41959d7b3'),(NULL,0,'2019-11-29 22:16:10',NULL,9642,1107,17,'online'),(NULL,0,'2019-11-29 22:16:10',NULL,9643,1108,16,'cmdb2-4-6-8'),(NULL,0,'2019-11-29 22:16:10',NULL,9644,1108,28,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,9645,1108,24,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,9646,1108,29,'ZJ'),(NULL,0,'2019-11-29 22:16:10',NULL,9647,1108,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,9648,1108,11,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,9649,1108,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,9650,1108,15,'10.8.6.8'),(NULL,0,'2019-11-29 22:16:10',NULL,9651,1108,5,'4d7a27300cc340fabdbdd56d2469e698'),(NULL,0,'2019-11-29 22:16:10',NULL,9652,1108,17,'online'),(NULL,0,'2019-11-29 22:16:10',NULL,9653,1109,16,'cmdb2-4-6-9'),(NULL,0,'2019-11-29 22:16:10',NULL,9654,1109,28,'prod'),(NULL,0,'2019-11-29 22:16:10',NULL,9655,1109,24,'enable'),(NULL,0,'2019-11-29 22:16:10',NULL,9656,1109,29,'ZJ'),(NULL,0,'2019-11-29 22:16:10',NULL,9657,1109,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:10',NULL,9658,1109,11,'pycook'),(NULL,0,'2019-11-29 22:16:10',NULL,9659,1109,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:10',NULL,9660,1109,15,'10.8.6.9'),(NULL,0,'2019-11-29 22:16:10',NULL,9661,1109,5,'bea738516ad747529b8f40b068646664'),(NULL,0,'2019-11-29 22:16:10',NULL,9662,1109,17,'online'),(NULL,0,'2019-11-29 22:16:11',NULL,9663,1110,16,'cmdb2-4-6-10'),(NULL,0,'2019-11-29 22:16:11',NULL,9664,1110,28,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,9665,1110,24,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,9666,1110,29,'ZJ'),(NULL,0,'2019-11-29 22:16:11',NULL,9667,1110,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,9668,1110,11,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,9669,1110,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,9670,1110,15,'10.8.6.10'),(NULL,0,'2019-11-29 22:16:11',NULL,9671,1110,5,'9d09f592d3a746c6ba6c0b10951dba73'),(NULL,0,'2019-11-29 22:16:11',NULL,9672,1110,17,'online'),(NULL,0,'2019-11-29 22:16:11',NULL,9673,1111,16,'cmdb2-4-6-11'),(NULL,0,'2019-11-29 22:16:11',NULL,9674,1111,28,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,9675,1111,24,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,9676,1111,29,'ZJ'),(NULL,0,'2019-11-29 22:16:11',NULL,9677,1111,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,9678,1111,11,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,9679,1111,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,9680,1111,15,'10.8.6.11'),(NULL,0,'2019-11-29 22:16:11',NULL,9681,1111,5,'87691d8dd1cc4158ba613e53a16dbaae'),(NULL,0,'2019-11-29 22:16:11',NULL,9682,1111,17,'online'),(NULL,0,'2019-11-29 22:16:11',NULL,9683,1112,16,'cmdb2-4-6-12'),(NULL,0,'2019-11-29 22:16:11',NULL,9684,1112,28,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,9685,1112,24,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,9686,1112,29,'ZJ'),(NULL,0,'2019-11-29 22:16:11',NULL,9687,1112,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,9688,1112,11,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,9689,1112,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,9690,1112,15,'10.8.6.12'),(NULL,0,'2019-11-29 22:16:11',NULL,9691,1112,5,'cb71f77be4574bc6ab9c6077ac9451db'),(NULL,0,'2019-11-29 22:16:11',NULL,9692,1112,17,'online'),(NULL,0,'2019-11-29 22:16:11',NULL,9693,1113,16,'cmdb2-4-6-13'),(NULL,0,'2019-11-29 22:16:11',NULL,9694,1113,28,'prod'),(NULL,0,'2019-11-29 22:16:11',NULL,9695,1113,24,'enable'),(NULL,0,'2019-11-29 22:16:11',NULL,9696,1113,29,'ZJ'),(NULL,0,'2019-11-29 22:16:11',NULL,9697,1113,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:11',NULL,9698,1113,11,'pycook'),(NULL,0,'2019-11-29 22:16:11',NULL,9699,1113,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:11',NULL,9700,1113,15,'10.8.6.13'),(NULL,0,'2019-11-29 22:16:11',NULL,9701,1113,5,'f9585471285e4a668a34202c97a26b93'),(NULL,0,'2019-11-29 22:16:11',NULL,9702,1113,17,'online'),(NULL,0,'2019-11-29 22:16:11',NULL,9703,1114,16,'cmdb2-4-6-14'),(NULL,0,'2019-11-29 22:16:11',NULL,9704,1114,28,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,9705,1114,24,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,9706,1114,29,'ZJ'),(NULL,0,'2019-11-29 22:16:12',NULL,9707,1114,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,9708,1114,11,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,9709,1114,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,9710,1114,15,'10.8.6.14'),(NULL,0,'2019-11-29 22:16:12',NULL,9711,1114,5,'d5cf07efe1f44ab18e18d0f48aeefdad'),(NULL,0,'2019-11-29 22:16:12',NULL,9712,1114,17,'online'),(NULL,0,'2019-11-29 22:16:12',NULL,9713,1115,16,'cmdb2-4-6-15'),(NULL,0,'2019-11-29 22:16:12',NULL,9714,1115,28,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,9715,1115,24,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,9716,1115,29,'ZJ'),(NULL,0,'2019-11-29 22:16:12',NULL,9717,1115,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,9718,1115,11,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,9719,1115,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,9720,1115,15,'10.8.6.15'),(NULL,0,'2019-11-29 22:16:12',NULL,9721,1115,5,'232c0bde5bc64f46baaf7ee512e4df92'),(NULL,0,'2019-11-29 22:16:12',NULL,9722,1115,17,'online'),(NULL,0,'2019-11-29 22:16:12',NULL,9723,1116,16,'cmdb2-4-6-16'),(NULL,0,'2019-11-29 22:16:12',NULL,9724,1116,28,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,9725,1116,24,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,9726,1116,29,'ZJ'),(NULL,0,'2019-11-29 22:16:12',NULL,9727,1116,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,9728,1116,11,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,9729,1116,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,9730,1116,15,'10.8.6.16'),(NULL,0,'2019-11-29 22:16:12',NULL,9731,1116,5,'e76020b4a82f40a9bbfe49683e4d0f13'),(NULL,0,'2019-11-29 22:16:12',NULL,9732,1116,17,'online'),(NULL,0,'2019-11-29 22:16:12',NULL,9733,1117,4,'App2-4-7'),(NULL,0,'2019-11-29 22:16:12',NULL,9734,1118,16,'cmdb2-4-7-1'),(NULL,0,'2019-11-29 22:16:12',NULL,9735,1118,28,'prod'),(NULL,0,'2019-11-29 22:16:12',NULL,9736,1118,24,'enable'),(NULL,0,'2019-11-29 22:16:12',NULL,9737,1118,29,'ZJ'),(NULL,0,'2019-11-29 22:16:12',NULL,9738,1118,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:12',NULL,9739,1118,11,'pycook'),(NULL,0,'2019-11-29 22:16:12',NULL,9740,1118,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:12',NULL,9741,1118,15,'10.8.7.1'),(NULL,0,'2019-11-29 22:16:12',NULL,9742,1118,5,'f91216b43bfe4946b8c0aa7cc7967b1f'),(NULL,0,'2019-11-29 22:16:12',NULL,9743,1118,17,'online'),(NULL,0,'2019-11-29 22:16:12',NULL,9744,1119,16,'cmdb2-4-7-2'),(NULL,0,'2019-11-29 22:16:12',NULL,9745,1119,28,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,9746,1119,24,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,9747,1119,29,'ZJ'),(NULL,0,'2019-11-29 22:16:13',NULL,9748,1119,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,9749,1119,11,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,9750,1119,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,9751,1119,15,'10.8.7.2'),(NULL,0,'2019-11-29 22:16:13',NULL,9752,1119,5,'aacc0c2e051f4fbda8366890d48c3976'),(NULL,0,'2019-11-29 22:16:13',NULL,9753,1119,17,'online'),(NULL,0,'2019-11-29 22:16:13',NULL,9754,1120,16,'cmdb2-4-7-3'),(NULL,0,'2019-11-29 22:16:13',NULL,9755,1120,28,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,9756,1120,24,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,9757,1120,29,'ZJ'),(NULL,0,'2019-11-29 22:16:13',NULL,9758,1120,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,9759,1120,11,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,9760,1120,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,9761,1120,15,'10.8.7.3'),(NULL,0,'2019-11-29 22:16:13',NULL,9762,1120,5,'ca5c56dc48b442e4b49b5280e56f3afe'),(NULL,0,'2019-11-29 22:16:13',NULL,9763,1120,17,'online'),(NULL,0,'2019-11-29 22:16:13',NULL,9764,1121,16,'cmdb2-4-7-4'),(NULL,0,'2019-11-29 22:16:13',NULL,9765,1121,28,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,9766,1121,24,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,9767,1121,29,'ZJ'),(NULL,0,'2019-11-29 22:16:13',NULL,9768,1121,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,9769,1121,11,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,9770,1121,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,9771,1121,15,'10.8.7.4'),(NULL,0,'2019-11-29 22:16:13',NULL,9772,1121,5,'f7f2c3d8a2a9417b824e935e8badd575'),(NULL,0,'2019-11-29 22:16:13',NULL,9773,1121,17,'online'),(NULL,0,'2019-11-29 22:16:13',NULL,9774,1122,16,'cmdb2-4-7-5'),(NULL,0,'2019-11-29 22:16:13',NULL,9775,1122,28,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,9776,1122,24,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,9777,1122,29,'ZJ'),(NULL,0,'2019-11-29 22:16:13',NULL,9778,1122,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,9779,1122,11,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,9780,1122,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,9781,1122,15,'10.8.7.5'),(NULL,0,'2019-11-29 22:16:13',NULL,9782,1122,5,'1eb0746578644fcab6fb2214fc255249'),(NULL,0,'2019-11-29 22:16:13',NULL,9783,1122,17,'online'),(NULL,0,'2019-11-29 22:16:13',NULL,9784,1123,16,'cmdb2-4-7-6'),(NULL,0,'2019-11-29 22:16:13',NULL,9785,1123,28,'prod'),(NULL,0,'2019-11-29 22:16:13',NULL,9786,1123,24,'enable'),(NULL,0,'2019-11-29 22:16:13',NULL,9787,1123,29,'ZJ'),(NULL,0,'2019-11-29 22:16:13',NULL,9788,1123,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:13',NULL,9789,1123,11,'pycook'),(NULL,0,'2019-11-29 22:16:13',NULL,9790,1123,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:13',NULL,9791,1123,15,'10.8.7.6'),(NULL,0,'2019-11-29 22:16:14',NULL,9792,1123,5,'7af2a91c08d9499585954f0594ad1c00'),(NULL,0,'2019-11-29 22:16:14',NULL,9793,1123,17,'online'),(NULL,0,'2019-11-29 22:16:14',NULL,9794,1124,16,'cmdb2-4-7-7'),(NULL,0,'2019-11-29 22:16:14',NULL,9795,1124,28,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,9796,1124,24,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,9797,1124,29,'ZJ'),(NULL,0,'2019-11-29 22:16:14',NULL,9798,1124,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,9799,1124,11,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,9800,1124,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,9801,1124,15,'10.8.7.7'),(NULL,0,'2019-11-29 22:16:14',NULL,9802,1124,5,'3ffe383a556847568e13de7a553abaf0'),(NULL,0,'2019-11-29 22:16:14',NULL,9803,1124,17,'online'),(NULL,0,'2019-11-29 22:16:14',NULL,9804,1125,16,'cmdb2-4-7-8'),(NULL,0,'2019-11-29 22:16:14',NULL,9805,1125,28,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,9806,1125,24,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,9807,1125,29,'ZJ'),(NULL,0,'2019-11-29 22:16:14',NULL,9808,1125,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,9809,1125,11,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,9810,1125,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,9811,1125,15,'10.8.7.8'),(NULL,0,'2019-11-29 22:16:14',NULL,9812,1125,5,'0a4a8273537f480cbc7c35526a121f79'),(NULL,0,'2019-11-29 22:16:14',NULL,9813,1125,17,'online'),(NULL,0,'2019-11-29 22:16:14',NULL,9814,1126,16,'cmdb2-4-7-9'),(NULL,0,'2019-11-29 22:16:14',NULL,9815,1126,28,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,9816,1126,24,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,9817,1126,29,'ZJ'),(NULL,0,'2019-11-29 22:16:14',NULL,9818,1126,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,9819,1126,11,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,9820,1126,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,9821,1126,15,'10.8.7.9'),(NULL,0,'2019-11-29 22:16:14',NULL,9822,1126,5,'6518467515a24cdea0d64e9691304fce'),(NULL,0,'2019-11-29 22:16:14',NULL,9823,1126,17,'online'),(NULL,0,'2019-11-29 22:16:14',NULL,9824,1127,16,'cmdb2-4-7-10'),(NULL,0,'2019-11-29 22:16:14',NULL,9825,1127,28,'prod'),(NULL,0,'2019-11-29 22:16:14',NULL,9826,1127,24,'enable'),(NULL,0,'2019-11-29 22:16:14',NULL,9827,1127,29,'ZJ'),(NULL,0,'2019-11-29 22:16:14',NULL,9828,1127,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:14',NULL,9829,1127,11,'pycook'),(NULL,0,'2019-11-29 22:16:14',NULL,9830,1127,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:14',NULL,9831,1127,15,'10.8.7.10'),(NULL,0,'2019-11-29 22:16:14',NULL,9832,1127,5,'84871df1f0114c70a271f580707d4fb7'),(NULL,0,'2019-11-29 22:16:14',NULL,9833,1127,17,'online'),(NULL,0,'2019-11-29 22:16:15',NULL,9834,1128,16,'cmdb2-4-7-11'),(NULL,0,'2019-11-29 22:16:15',NULL,9835,1128,28,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,9836,1128,24,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,9837,1128,29,'ZJ'),(NULL,0,'2019-11-29 22:16:15',NULL,9838,1128,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,9839,1128,11,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,9840,1128,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,9841,1128,15,'10.8.7.11'),(NULL,0,'2019-11-29 22:16:15',NULL,9842,1128,5,'1c49623659874c04bd8513969c97a849'),(NULL,0,'2019-11-29 22:16:15',NULL,9843,1128,17,'online'),(NULL,0,'2019-11-29 22:16:15',NULL,9844,1129,16,'cmdb2-4-7-12'),(NULL,0,'2019-11-29 22:16:15',NULL,9845,1129,28,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,9846,1129,24,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,9847,1129,29,'ZJ'),(NULL,0,'2019-11-29 22:16:15',NULL,9848,1129,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,9849,1129,11,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,9850,1129,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,9851,1129,15,'10.8.7.12'),(NULL,0,'2019-11-29 22:16:15',NULL,9852,1129,5,'122a99a332ec413f9090661c08a19355'),(NULL,0,'2019-11-29 22:16:15',NULL,9853,1129,17,'online'),(NULL,0,'2019-11-29 22:16:15',NULL,9854,1130,16,'cmdb2-4-7-13'),(NULL,0,'2019-11-29 22:16:15',NULL,9855,1130,28,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,9856,1130,24,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,9857,1130,29,'ZJ'),(NULL,0,'2019-11-29 22:16:15',NULL,9858,1130,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,9859,1130,11,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,9860,1130,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,9861,1130,15,'10.8.7.13'),(NULL,0,'2019-11-29 22:16:15',NULL,9862,1130,5,'42115011c6004482bed577d2cb371cfb'),(NULL,0,'2019-11-29 22:16:15',NULL,9863,1130,17,'online'),(NULL,0,'2019-11-29 22:16:15',NULL,9864,1131,16,'cmdb2-4-7-14'),(NULL,0,'2019-11-29 22:16:15',NULL,9865,1131,28,'prod'),(NULL,0,'2019-11-29 22:16:15',NULL,9866,1131,24,'enable'),(NULL,0,'2019-11-29 22:16:15',NULL,9867,1131,29,'ZJ'),(NULL,0,'2019-11-29 22:16:15',NULL,9868,1131,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:15',NULL,9869,1131,11,'pycook'),(NULL,0,'2019-11-29 22:16:15',NULL,9870,1131,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:15',NULL,9871,1131,15,'10.8.7.14'),(NULL,0,'2019-11-29 22:16:15',NULL,9872,1131,5,'9d8526f7b1b74b1aabe81417ced78011'),(NULL,0,'2019-11-29 22:16:15',NULL,9873,1131,17,'online'),(NULL,0,'2019-11-29 22:16:15',NULL,9874,1132,16,'cmdb2-4-7-15'),(NULL,0,'2019-11-29 22:16:15',NULL,9875,1132,28,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,9876,1132,24,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,9877,1132,29,'ZJ'),(NULL,0,'2019-11-29 22:16:16',NULL,9878,1132,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,9879,1132,11,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,9880,1132,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,9881,1132,15,'10.8.7.15'),(NULL,0,'2019-11-29 22:16:16',NULL,9882,1132,5,'228e1661257447cf99d4ed5461f5587a'),(NULL,0,'2019-11-29 22:16:16',NULL,9883,1132,17,'online'),(NULL,0,'2019-11-29 22:16:16',NULL,9884,1133,16,'cmdb2-4-7-16'),(NULL,0,'2019-11-29 22:16:16',NULL,9885,1133,28,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,9886,1133,24,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,9887,1133,29,'ZJ'),(NULL,0,'2019-11-29 22:16:16',NULL,9888,1133,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,9889,1133,11,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,9890,1133,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,9891,1133,15,'10.8.7.16'),(NULL,0,'2019-11-29 22:16:16',NULL,9892,1133,5,'5851e497c1ff4ab68d8174567d4c0c64'),(NULL,0,'2019-11-29 22:16:16',NULL,9893,1133,17,'online'),(NULL,0,'2019-11-29 22:16:16',NULL,9894,1134,4,'App2-4-8'),(NULL,0,'2019-11-29 22:16:16',NULL,9895,1135,16,'cmdb2-4-8-1'),(NULL,0,'2019-11-29 22:16:16',NULL,9896,1135,28,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,9897,1135,24,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,9898,1135,29,'ZJ'),(NULL,0,'2019-11-29 22:16:16',NULL,9899,1135,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,9900,1135,11,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,9901,1135,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,9902,1135,15,'10.8.8.1'),(NULL,0,'2019-11-29 22:16:16',NULL,9903,1135,5,'5764491d77e34de2b0e8f06fad634bf0'),(NULL,0,'2019-11-29 22:16:16',NULL,9904,1135,17,'online'),(NULL,0,'2019-11-29 22:16:16',NULL,9905,1136,16,'cmdb2-4-8-2'),(NULL,0,'2019-11-29 22:16:16',NULL,9906,1136,28,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,9907,1136,24,'enable'),(NULL,0,'2019-11-29 22:16:16',NULL,9908,1136,29,'ZJ'),(NULL,0,'2019-11-29 22:16:16',NULL,9909,1136,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:16',NULL,9910,1136,11,'pycook'),(NULL,0,'2019-11-29 22:16:16',NULL,9911,1136,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:16',NULL,9912,1136,15,'10.8.8.2'),(NULL,0,'2019-11-29 22:16:16',NULL,9913,1136,5,'32d27af4c1164aafbe8d67cd36ccb3f2'),(NULL,0,'2019-11-29 22:16:16',NULL,9914,1136,17,'online'),(NULL,0,'2019-11-29 22:16:16',NULL,9915,1137,16,'cmdb2-4-8-3'),(NULL,0,'2019-11-29 22:16:16',NULL,9916,1137,28,'prod'),(NULL,0,'2019-11-29 22:16:16',NULL,9917,1137,24,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,9918,1137,29,'ZJ'),(NULL,0,'2019-11-29 22:16:17',NULL,9919,1137,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,9920,1137,11,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,9921,1137,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,9922,1137,15,'10.8.8.3'),(NULL,0,'2019-11-29 22:16:17',NULL,9923,1137,5,'226ffb5af5d34d26a4738a3e91fbfb89'),(NULL,0,'2019-11-29 22:16:17',NULL,9924,1137,17,'online'),(NULL,0,'2019-11-29 22:16:17',NULL,9925,1138,16,'cmdb2-4-8-4'),(NULL,0,'2019-11-29 22:16:17',NULL,9926,1138,28,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,9927,1138,24,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,9928,1138,29,'ZJ'),(NULL,0,'2019-11-29 22:16:17',NULL,9929,1138,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,9930,1138,11,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,9931,1138,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,9932,1138,15,'10.8.8.4'),(NULL,0,'2019-11-29 22:16:17',NULL,9933,1138,5,'ef00d3134ebc431688d10a93a52a5264'),(NULL,0,'2019-11-29 22:16:17',NULL,9934,1138,17,'online'),(NULL,0,'2019-11-29 22:16:17',NULL,9935,1139,16,'cmdb2-4-8-5'),(NULL,0,'2019-11-29 22:16:17',NULL,9936,1139,28,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,9937,1139,24,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,9938,1139,29,'ZJ'),(NULL,0,'2019-11-29 22:16:17',NULL,9939,1139,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,9940,1139,11,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,9941,1139,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,9942,1139,15,'10.8.8.5'),(NULL,0,'2019-11-29 22:16:17',NULL,9943,1139,5,'cb26fe974719452289f41d171dda9709'),(NULL,0,'2019-11-29 22:16:17',NULL,9944,1139,17,'online'),(NULL,0,'2019-11-29 22:16:17',NULL,9945,1140,16,'cmdb2-4-8-6'),(NULL,0,'2019-11-29 22:16:17',NULL,9946,1140,28,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,9947,1140,24,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,9948,1140,29,'ZJ'),(NULL,0,'2019-11-29 22:16:17',NULL,9949,1140,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,9950,1140,11,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,9951,1140,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,9952,1140,15,'10.8.8.6'),(NULL,0,'2019-11-29 22:16:17',NULL,9953,1140,5,'f1a708a99d3a4bdcb2f5f4d4b0bd292b'),(NULL,0,'2019-11-29 22:16:17',NULL,9954,1140,17,'online'),(NULL,0,'2019-11-29 22:16:17',NULL,9955,1141,16,'cmdb2-4-8-7'),(NULL,0,'2019-11-29 22:16:17',NULL,9956,1141,28,'prod'),(NULL,0,'2019-11-29 22:16:17',NULL,9957,1141,24,'enable'),(NULL,0,'2019-11-29 22:16:17',NULL,9958,1141,29,'ZJ'),(NULL,0,'2019-11-29 22:16:17',NULL,9959,1141,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:17',NULL,9960,1141,11,'pycook'),(NULL,0,'2019-11-29 22:16:17',NULL,9961,1141,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:17',NULL,9962,1141,15,'10.8.8.7'),(NULL,0,'2019-11-29 22:16:18',NULL,9963,1141,5,'b1276ce3f1fc4361a9fb5f85b411d416'),(NULL,0,'2019-11-29 22:16:18',NULL,9964,1141,17,'online'),(NULL,0,'2019-11-29 22:16:18',NULL,9965,1142,16,'cmdb2-4-8-8'),(NULL,0,'2019-11-29 22:16:18',NULL,9966,1142,28,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,9967,1142,24,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,9968,1142,29,'ZJ'),(NULL,0,'2019-11-29 22:16:18',NULL,9969,1142,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,9970,1142,11,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,9971,1142,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,9972,1142,15,'10.8.8.8'),(NULL,0,'2019-11-29 22:16:18',NULL,9973,1142,5,'e094574c5c40496099bb8bf911caab6e'),(NULL,0,'2019-11-29 22:16:18',NULL,9974,1142,17,'online'),(NULL,0,'2019-11-29 22:16:18',NULL,9975,1143,16,'cmdb2-4-8-9'),(NULL,0,'2019-11-29 22:16:18',NULL,9976,1143,28,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,9977,1143,24,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,9978,1143,29,'ZJ'),(NULL,0,'2019-11-29 22:16:18',NULL,9979,1143,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,9980,1143,11,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,9981,1143,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,9982,1143,15,'10.8.8.9'),(NULL,0,'2019-11-29 22:16:18',NULL,9983,1143,5,'484b1e95c6e34194be0ff4765acc3846'),(NULL,0,'2019-11-29 22:16:18',NULL,9984,1143,17,'online'),(NULL,0,'2019-11-29 22:16:18',NULL,9985,1144,16,'cmdb2-4-8-10'),(NULL,0,'2019-11-29 22:16:18',NULL,9986,1144,28,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,9987,1144,24,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,9988,1144,29,'ZJ'),(NULL,0,'2019-11-29 22:16:18',NULL,9989,1144,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,9990,1144,11,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,9991,1144,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,9992,1144,15,'10.8.8.10'),(NULL,0,'2019-11-29 22:16:18',NULL,9993,1144,5,'31947ad9c9b6417588c468d2a6cb7e4d'),(NULL,0,'2019-11-29 22:16:18',NULL,9994,1144,17,'online'),(NULL,0,'2019-11-29 22:16:18',NULL,9995,1145,16,'cmdb2-4-8-11'),(NULL,0,'2019-11-29 22:16:18',NULL,9996,1145,28,'prod'),(NULL,0,'2019-11-29 22:16:18',NULL,9997,1145,24,'enable'),(NULL,0,'2019-11-29 22:16:18',NULL,9998,1145,29,'ZJ'),(NULL,0,'2019-11-29 22:16:18',NULL,9999,1145,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:18',NULL,10000,1145,11,'pycook'),(NULL,0,'2019-11-29 22:16:18',NULL,10001,1145,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:18',NULL,10002,1145,15,'10.8.8.11'),(NULL,0,'2019-11-29 22:16:18',NULL,10003,1145,5,'518a7ec0c199425397a8bf5d57517d11'),(NULL,0,'2019-11-29 22:16:18',NULL,10004,1145,17,'online'),(NULL,0,'2019-11-29 22:16:19',NULL,10005,1146,16,'cmdb2-4-8-12'),(NULL,0,'2019-11-29 22:16:19',NULL,10006,1146,28,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,10007,1146,24,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,10008,1146,29,'ZJ'),(NULL,0,'2019-11-29 22:16:19',NULL,10009,1146,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,10010,1146,11,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,10011,1146,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,10012,1146,15,'10.8.8.12'),(NULL,0,'2019-11-29 22:16:19',NULL,10013,1146,5,'84fda9fd4175418780324086af5a9317'),(NULL,0,'2019-11-29 22:16:19',NULL,10014,1146,17,'online'),(NULL,0,'2019-11-29 22:16:19',NULL,10015,1147,16,'cmdb2-4-8-13'),(NULL,0,'2019-11-29 22:16:19',NULL,10016,1147,28,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,10017,1147,24,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,10018,1147,29,'ZJ'),(NULL,0,'2019-11-29 22:16:19',NULL,10019,1147,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,10020,1147,11,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,10021,1147,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,10022,1147,15,'10.8.8.13'),(NULL,0,'2019-11-29 22:16:19',NULL,10023,1147,5,'8a36a0017b0946f1a7c5c23ffaa665bc'),(NULL,0,'2019-11-29 22:16:19',NULL,10024,1147,17,'online'),(NULL,0,'2019-11-29 22:16:19',NULL,10025,1148,16,'cmdb2-4-8-14'),(NULL,0,'2019-11-29 22:16:19',NULL,10026,1148,28,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,10027,1148,24,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,10028,1148,29,'ZJ'),(NULL,0,'2019-11-29 22:16:19',NULL,10029,1148,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,10030,1148,11,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,10031,1148,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,10032,1148,15,'10.8.8.14'),(NULL,0,'2019-11-29 22:16:19',NULL,10033,1148,5,'ce8d4d595e19471b90aa147e000ffc78'),(NULL,0,'2019-11-29 22:16:19',NULL,10034,1148,17,'online'),(NULL,0,'2019-11-29 22:16:19',NULL,10035,1149,16,'cmdb2-4-8-15'),(NULL,0,'2019-11-29 22:16:19',NULL,10036,1149,28,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,10037,1149,24,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,10038,1149,29,'ZJ'),(NULL,0,'2019-11-29 22:16:19',NULL,10039,1149,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:19',NULL,10040,1149,11,'pycook'),(NULL,0,'2019-11-29 22:16:19',NULL,10041,1149,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:19',NULL,10042,1149,15,'10.8.8.15'),(NULL,0,'2019-11-29 22:16:19',NULL,10043,1149,5,'133309ea54ea4e40b19dabbcc77ef8ca'),(NULL,0,'2019-11-29 22:16:19',NULL,10044,1149,17,'online'),(NULL,0,'2019-11-29 22:16:19',NULL,10045,1150,16,'cmdb2-4-8-16'),(NULL,0,'2019-11-29 22:16:19',NULL,10046,1150,28,'prod'),(NULL,0,'2019-11-29 22:16:19',NULL,10047,1150,24,'enable'),(NULL,0,'2019-11-29 22:16:19',NULL,10048,1150,29,'ZJ'),(NULL,0,'2019-11-29 22:16:20',NULL,10049,1150,20,'3.10.0-862.9.1.el7.x86_64'),(NULL,0,'2019-11-29 22:16:20',NULL,10050,1150,11,'pycook'),(NULL,0,'2019-11-29 22:16:20',NULL,10051,1150,19,'CentOS Linux release 7.5.1804 (Core)'),(NULL,0,'2019-11-29 22:16:20',NULL,10052,1150,15,'10.8.8.16'),(NULL,0,'2019-11-29 22:16:20',NULL,10053,1150,5,'cdc42f0ed8a94bad9fae14f9f04228ab'),(NULL,0,'2019-11-29 22:16:20',NULL,10054,1150,17,'online'),(NULL,0,'2019-12-11 12:09:47','2019-12-11 12:09:52',10055,56,18,'');
/*!40000 ALTER TABLE `c_value_index_texts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_integers`
--

DROP TABLE IF EXISTS `c_value_integers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_integers` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_value_integers_deleted` (`deleted`),
  CONSTRAINT `c_value_integers_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_integers_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_integers`
--

LOCK TABLES `c_value_integers` WRITE;
/*!40000 ALTER TABLE `c_value_integers` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_integers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_json`
--

DROP TABLE IF EXISTS `c_value_json`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_json` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` json NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_value_json_deleted` (`deleted`),
  CONSTRAINT `c_value_json_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_json_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_json`
--

LOCK TABLES `c_value_json` WRITE;
/*!40000 ALTER TABLE `c_value_json` DISABLE KEYS */;
/*!40000 ALTER TABLE `c_value_json` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `c_value_texts`
--

DROP TABLE IF EXISTS `c_value_texts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `c_value_texts` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ci_id` int(11) NOT NULL,
  `attr_id` int(11) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ci_id` (`ci_id`),
  KEY `attr_id` (`attr_id`),
  KEY `ix_c_value_texts_deleted` (`deleted`),
  CONSTRAINT `c_value_texts_ibfk_1` FOREIGN KEY (`ci_id`) REFERENCES `c_cis` (`id`),
  CONSTRAINT `c_value_texts_ibfk_2` FOREIGN KEY (`attr_id`) REFERENCES `c_attributes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2712 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `c_value_texts`
--

LOCK TABLES `c_value_texts` WRITE;
/*!40000 ALTER TABLE `c_value_texts` DISABLE KEYS */;
INSERT INTO `c_value_texts` VALUES (NULL,0,'2019-11-29 22:12:14',NULL,152,56,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,153,56,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,154,56,30,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,155,57,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,156,57,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,157,57,30,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,158,58,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,159,58,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,160,58,30,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,161,59,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:15',NULL,162,59,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:15',NULL,163,59,30,'64GB'),(NULL,0,'2019-11-29 22:12:15',NULL,164,60,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,165,60,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,166,60,30,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,167,61,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,168,61,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,169,61,30,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,170,62,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,171,62,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,172,62,30,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,173,63,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,174,63,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,175,63,30,'64GB'),(NULL,0,'2019-11-29 22:12:16',NULL,176,64,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:16',NULL,177,64,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:16',NULL,178,64,30,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,179,65,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,180,65,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,181,65,30,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,182,66,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,183,66,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,184,66,30,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,185,67,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,186,67,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,187,67,30,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,188,68,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:17',NULL,189,68,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:17',NULL,190,68,30,'64GB'),(NULL,0,'2019-11-29 22:12:17',NULL,191,69,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,192,69,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,193,69,30,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,194,70,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,195,70,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,196,70,30,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,197,71,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,198,71,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,199,71,30,'64GB'),(NULL,0,'2019-11-29 22:12:18',NULL,200,73,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:18',NULL,201,73,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:18',NULL,202,73,30,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,203,74,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,204,74,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,205,74,30,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,206,75,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,207,75,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,208,75,30,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,209,76,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,210,76,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,211,76,30,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,212,77,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:19',NULL,213,77,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:19',NULL,214,77,30,'64GB'),(NULL,0,'2019-11-29 22:12:19',NULL,215,78,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,216,78,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,217,78,30,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,218,79,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,219,79,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,220,79,30,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,221,80,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,222,80,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,223,80,30,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,224,81,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:20',NULL,225,81,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:20',NULL,226,81,30,'64GB'),(NULL,0,'2019-11-29 22:12:20',NULL,227,82,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,228,82,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,229,82,30,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,230,83,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,231,83,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,232,83,30,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,233,84,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,234,84,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,235,84,30,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,236,85,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:21',NULL,237,85,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:21',NULL,238,85,30,'64GB'),(NULL,0,'2019-11-29 22:12:21',NULL,239,86,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,240,86,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,241,86,30,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,242,87,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,243,87,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,244,87,30,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,245,88,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,246,88,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,247,88,30,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,248,90,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:22',NULL,249,90,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:22',NULL,250,90,30,'64GB'),(NULL,0,'2019-11-29 22:12:22',NULL,251,91,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,252,91,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,253,91,30,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,254,92,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,255,92,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,256,92,30,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,257,93,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,258,93,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,259,93,30,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,260,94,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,261,94,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:23',NULL,262,94,30,'64GB'),(NULL,0,'2019-11-29 22:12:23',NULL,263,95,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:23',NULL,264,95,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,265,95,30,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,266,96,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,267,96,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,268,96,30,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,269,97,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,270,97,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,271,97,30,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,272,98,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,273,98,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,274,98,30,'64GB'),(NULL,0,'2019-11-29 22:12:24',NULL,275,99,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:24',NULL,276,99,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:24',NULL,277,99,30,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,278,100,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,279,100,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,280,100,30,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,281,101,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,282,101,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,283,101,30,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,284,102,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,285,102,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,286,102,30,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,287,103,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:25',NULL,288,103,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:25',NULL,289,103,30,'64GB'),(NULL,0,'2019-11-29 22:12:25',NULL,290,104,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,291,104,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,292,104,30,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,293,105,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,294,105,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,295,105,30,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,296,107,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,297,107,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,298,107,30,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,299,108,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:26',NULL,300,108,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:26',NULL,301,108,30,'64GB'),(NULL,0,'2019-11-29 22:12:26',NULL,302,109,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,303,109,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,304,109,30,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,305,110,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,306,110,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,307,110,30,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,308,111,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,309,111,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,310,111,30,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,311,112,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:27',NULL,312,112,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:27',NULL,313,112,30,'64GB'),(NULL,0,'2019-11-29 22:12:27',NULL,314,113,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,315,113,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,316,113,30,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,317,114,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,318,114,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,319,114,30,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,320,115,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,321,115,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,322,115,30,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,323,116,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,324,116,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,325,116,30,'64GB'),(NULL,0,'2019-11-29 22:12:28',NULL,326,117,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:28',NULL,327,117,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:28',NULL,328,117,30,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,329,118,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,330,118,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,331,118,30,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,332,119,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,333,119,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,334,119,30,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,335,120,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,336,120,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,337,120,30,'64GB'),(NULL,0,'2019-11-29 22:12:29',NULL,338,121,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:29',NULL,339,121,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:29',NULL,340,121,30,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,341,122,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,342,122,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,343,122,30,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,344,124,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,345,124,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,346,124,30,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,347,125,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,348,125,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,349,125,30,'64GB'),(NULL,0,'2019-11-29 22:12:30',NULL,350,126,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:30',NULL,351,126,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:30',NULL,352,126,30,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,353,127,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,354,127,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,355,127,30,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,356,128,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,357,128,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,358,128,30,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,359,129,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,360,129,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,361,129,30,'64GB'),(NULL,0,'2019-11-29 22:12:31',NULL,362,130,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:31',NULL,363,130,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:31',NULL,364,130,30,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,365,131,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,366,131,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,367,131,30,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,368,132,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,369,132,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,370,132,30,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,371,133,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,372,133,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,373,133,30,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,374,134,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:32',NULL,375,134,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:32',NULL,376,134,30,'64GB'),(NULL,0,'2019-11-29 22:12:32',NULL,377,135,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,378,135,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,379,135,30,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,380,136,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,381,136,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,382,136,30,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,383,137,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,384,137,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,385,137,30,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,386,138,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,387,138,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,388,138,30,'64GB'),(NULL,0,'2019-11-29 22:12:33',NULL,389,139,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:33',NULL,390,139,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:33',NULL,391,139,30,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,392,141,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,393,141,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,394,141,30,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,395,142,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,396,142,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,397,142,30,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,398,143,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,399,143,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,400,143,30,'64GB'),(NULL,0,'2019-11-29 22:12:34',NULL,401,144,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:34',NULL,402,144,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:34',NULL,403,144,30,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,404,145,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,405,145,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,406,145,30,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,407,146,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,408,146,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,409,146,30,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,410,147,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,411,147,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,412,147,30,'64GB'),(NULL,0,'2019-11-29 22:12:35',NULL,413,148,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:35',NULL,414,148,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:35',NULL,415,148,30,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,416,149,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,417,149,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,418,149,30,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,419,150,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,420,150,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,421,150,30,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,422,151,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,423,151,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,424,151,30,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,425,152,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:36',NULL,426,152,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:36',NULL,427,152,30,'64GB'),(NULL,0,'2019-11-29 22:12:36',NULL,428,153,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,429,153,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,430,153,30,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,431,154,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,432,154,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,433,154,30,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,434,155,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,435,155,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,436,155,30,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,437,156,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:37',NULL,438,156,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:37',NULL,439,156,30,'64GB'),(NULL,0,'2019-11-29 22:12:37',NULL,440,158,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,441,158,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,442,158,30,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,443,159,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,444,159,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,445,159,30,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,446,160,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,447,160,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,448,160,30,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,449,161,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:38',NULL,450,161,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:38',NULL,451,161,30,'64GB'),(NULL,0,'2019-11-29 22:12:38',NULL,452,162,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,453,162,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,454,162,30,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,455,163,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,456,163,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,457,163,30,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,458,164,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,459,164,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,460,164,30,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,461,165,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,462,165,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,463,165,30,'64GB'),(NULL,0,'2019-11-29 22:12:39',NULL,464,166,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:39',NULL,465,166,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:39',NULL,466,166,30,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,467,167,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,468,167,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,469,167,30,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,470,168,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,471,168,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,472,168,30,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,473,169,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,474,169,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,475,169,30,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,476,170,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:40',NULL,477,170,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:40',NULL,478,170,30,'64GB'),(NULL,0,'2019-11-29 22:12:40',NULL,479,171,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,480,171,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,481,171,30,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,482,172,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,483,172,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,484,172,30,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,485,173,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,486,173,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,487,173,30,'64GB'),(NULL,0,'2019-11-29 22:12:41',NULL,488,175,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:41',NULL,489,175,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:41',NULL,490,175,30,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,491,176,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,492,176,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,493,176,30,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,494,177,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,495,177,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,496,177,30,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,497,178,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,498,178,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,499,178,30,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,500,179,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:42',NULL,501,179,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:42',NULL,502,179,30,'64GB'),(NULL,0,'2019-11-29 22:12:42',NULL,503,180,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,504,180,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,505,180,30,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,506,181,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,507,181,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,508,181,30,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,509,182,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,510,182,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,511,182,30,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,512,183,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,513,183,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:43',NULL,514,183,30,'64GB'),(NULL,0,'2019-11-29 22:12:43',NULL,515,184,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:43',NULL,516,184,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,517,184,30,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,518,185,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,519,185,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,520,185,30,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,521,186,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,522,186,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,523,186,30,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,524,187,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,525,187,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,526,187,30,'64GB'),(NULL,0,'2019-11-29 22:12:44',NULL,527,188,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:44',NULL,528,188,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:44',NULL,529,188,30,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,530,189,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,531,189,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,532,189,30,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,533,190,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,534,190,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,535,190,30,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,536,193,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,537,193,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,538,193,30,'64GB'),(NULL,0,'2019-11-29 22:12:45',NULL,539,194,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:45',NULL,540,194,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:45',NULL,541,194,30,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,542,195,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,543,195,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,544,195,30,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,545,196,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,546,196,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,547,196,30,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,548,197,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,549,197,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,550,197,30,'64GB'),(NULL,0,'2019-11-29 22:12:46',NULL,551,198,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:46',NULL,552,198,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:46',NULL,553,198,30,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,554,199,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,555,199,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,556,199,30,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,557,200,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,558,200,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,559,200,30,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,560,201,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,561,201,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,562,201,30,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,563,202,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:47',NULL,564,202,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:47',NULL,565,202,30,'64GB'),(NULL,0,'2019-11-29 22:12:47',NULL,566,203,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,567,203,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,568,203,30,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,569,204,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,570,204,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,571,204,30,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,572,205,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,573,205,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,574,205,30,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,575,206,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:48',NULL,576,206,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:48',NULL,577,206,30,'64GB'),(NULL,0,'2019-11-29 22:12:48',NULL,578,207,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,579,207,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,580,207,30,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,581,208,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,582,208,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,583,208,30,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,584,210,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,585,210,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,586,210,30,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,587,211,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:49',NULL,588,211,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:49',NULL,589,211,30,'64GB'),(NULL,0,'2019-11-29 22:12:49',NULL,590,212,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,591,212,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,592,212,30,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,593,213,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,594,213,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,595,213,30,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,596,214,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,597,214,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,598,214,30,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,599,215,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,600,215,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,601,215,30,'64GB'),(NULL,0,'2019-11-29 22:12:50',NULL,602,216,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:50',NULL,603,216,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:50',NULL,604,216,30,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,605,217,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,606,217,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,607,217,30,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,608,218,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,609,218,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,610,218,30,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,611,219,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,612,219,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,613,219,30,'64GB'),(NULL,0,'2019-11-29 22:12:51',NULL,614,220,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:51',NULL,615,220,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:51',NULL,616,220,30,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,617,221,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,618,221,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,619,221,30,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,620,222,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,621,222,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,622,222,30,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,623,223,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,624,223,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,625,223,30,'64GB'),(NULL,0,'2019-11-29 22:12:52',NULL,626,224,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:52',NULL,627,224,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:52',NULL,628,224,30,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,629,225,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,630,225,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,631,225,30,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,632,227,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,633,227,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,634,227,30,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,635,228,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,636,228,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,637,228,30,'64GB'),(NULL,0,'2019-11-29 22:12:53',NULL,638,229,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:53',NULL,639,229,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:53',NULL,640,229,30,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,641,230,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,642,230,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,643,230,30,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,644,231,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,645,231,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,646,231,30,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,647,232,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,648,232,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,649,232,30,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,650,233,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:54',NULL,651,233,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:54',NULL,652,233,30,'64GB'),(NULL,0,'2019-11-29 22:12:54',NULL,653,234,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,654,234,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,655,234,30,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,656,235,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,657,235,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,658,235,30,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,659,236,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,660,236,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,661,236,30,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,662,237,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:55',NULL,663,237,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:55',NULL,664,237,30,'64GB'),(NULL,0,'2019-11-29 22:12:55',NULL,665,238,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,666,238,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,667,238,30,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,668,239,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,669,239,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,670,239,30,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,671,240,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,672,240,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,673,240,30,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,674,241,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,675,241,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,676,241,30,'64GB'),(NULL,0,'2019-11-29 22:12:56',NULL,677,242,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:56',NULL,678,242,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:56',NULL,679,242,30,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,680,244,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,681,244,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,682,244,30,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,683,245,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,684,245,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,685,245,30,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,686,246,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,687,246,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,688,246,30,'64GB'),(NULL,0,'2019-11-29 22:12:57',NULL,689,247,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:57',NULL,690,247,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:57',NULL,691,247,30,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,692,248,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,693,248,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,694,248,30,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,695,249,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,696,249,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,697,249,30,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,698,250,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,699,250,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,700,250,30,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,701,251,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:58',NULL,702,251,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:58',NULL,703,251,30,'64GB'),(NULL,0,'2019-11-29 22:12:58',NULL,704,252,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,705,252,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,706,252,30,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,707,253,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,708,253,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,709,253,30,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,710,254,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,711,254,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,712,254,30,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,713,255,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:12:59',NULL,714,255,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:12:59',NULL,715,255,30,'64GB'),(NULL,0,'2019-11-29 22:12:59',NULL,716,256,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,717,256,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,718,256,30,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,719,257,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,720,257,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,721,257,30,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,722,258,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,723,258,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,724,258,30,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,725,259,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,726,259,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:00',NULL,727,259,30,'64GB'),(NULL,0,'2019-11-29 22:13:00',NULL,728,261,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:00',NULL,729,261,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,730,261,30,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,731,262,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,732,262,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,733,262,30,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,734,263,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,735,263,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,736,263,30,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,737,264,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,738,264,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,739,264,30,'64GB'),(NULL,0,'2019-11-29 22:13:01',NULL,740,265,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:01',NULL,741,265,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:01',NULL,742,265,30,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,743,266,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,744,266,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,745,266,30,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,746,267,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,747,267,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,748,267,30,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,749,268,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,750,268,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,751,268,30,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,752,269,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:02',NULL,753,269,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:02',NULL,754,269,30,'64GB'),(NULL,0,'2019-11-29 22:13:02',NULL,755,270,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,756,270,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,757,270,30,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,758,271,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,759,271,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,760,271,30,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,761,272,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,762,272,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,763,272,30,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,764,273,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,765,273,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:03',NULL,766,273,30,'64GB'),(NULL,0,'2019-11-29 22:13:03',NULL,767,274,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:03',NULL,768,274,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,769,274,30,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,770,275,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,771,275,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,772,275,30,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,773,276,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,774,276,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,775,276,30,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,776,278,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,777,278,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,778,278,30,'64GB'),(NULL,0,'2019-11-29 22:13:04',NULL,779,279,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:04',NULL,780,279,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:04',NULL,781,279,30,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,782,280,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,783,280,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,784,280,30,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,785,281,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,786,281,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,787,281,30,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,788,282,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,789,282,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,790,282,30,'64GB'),(NULL,0,'2019-11-29 22:13:05',NULL,791,283,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:05',NULL,792,283,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:05',NULL,793,283,30,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,794,284,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,795,284,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,796,284,30,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,797,285,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,798,285,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,799,285,30,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,800,286,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,801,286,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,802,286,30,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,803,287,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:06',NULL,804,287,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:06',NULL,805,287,30,'64GB'),(NULL,0,'2019-11-29 22:13:06',NULL,806,288,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,807,288,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,808,288,30,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,809,289,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,810,289,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,811,289,30,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,812,290,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,813,290,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,814,290,30,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,815,291,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,816,291,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,817,291,30,'64GB'),(NULL,0,'2019-11-29 22:13:07',NULL,818,292,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:07',NULL,819,292,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:07',NULL,820,292,30,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,821,293,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,822,293,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,823,293,30,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,824,295,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,825,295,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,826,295,30,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,827,296,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,828,296,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,829,296,30,'64GB'),(NULL,0,'2019-11-29 22:13:08',NULL,830,297,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:08',NULL,831,297,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:08',NULL,832,297,30,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,833,298,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,834,298,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,835,298,30,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,836,299,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,837,299,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,838,299,30,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,839,300,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,840,300,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,841,300,30,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,842,301,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:09',NULL,843,301,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:09',NULL,844,301,30,'64GB'),(NULL,0,'2019-11-29 22:13:09',NULL,845,302,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,846,302,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,847,302,30,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,848,303,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,849,303,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,850,303,30,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,851,304,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,852,304,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,853,304,30,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,854,305,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:10',NULL,855,305,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:10',NULL,856,305,30,'64GB'),(NULL,0,'2019-11-29 22:13:10',NULL,857,306,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,858,306,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,859,306,30,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,860,307,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,861,307,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,862,307,30,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,863,308,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,864,308,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,865,308,30,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,866,309,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,867,309,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,868,309,30,'64GB'),(NULL,0,'2019-11-29 22:13:11',NULL,869,310,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:11',NULL,870,310,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:11',NULL,871,310,30,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,872,312,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,873,312,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,874,312,30,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,875,313,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,876,313,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,877,313,30,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,878,314,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,879,314,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,880,314,30,'64GB'),(NULL,0,'2019-11-29 22:13:12',NULL,881,315,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:12',NULL,882,315,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:12',NULL,883,315,30,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,884,316,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,885,316,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,886,316,30,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,887,317,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,888,317,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,889,317,30,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,890,318,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,891,318,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,892,318,30,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,893,319,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:13',NULL,894,319,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:13',NULL,895,319,30,'64GB'),(NULL,0,'2019-11-29 22:13:13',NULL,896,320,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,897,320,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,898,320,30,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,899,321,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,900,321,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,901,321,30,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,902,322,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,903,322,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,904,322,30,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,905,323,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:14',NULL,906,323,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:14',NULL,907,323,30,'64GB'),(NULL,0,'2019-11-29 22:13:14',NULL,908,324,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,909,324,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,910,324,30,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,911,325,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,912,325,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,913,325,30,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,914,326,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,915,326,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,916,326,30,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,917,327,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:15',NULL,918,327,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:15',NULL,919,327,30,'64GB'),(NULL,0,'2019-11-29 22:13:15',NULL,920,330,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,921,330,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,922,330,30,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,923,331,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,924,331,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,925,331,30,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,926,332,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,927,332,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,928,332,30,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,929,333,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,930,333,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,931,333,30,'64GB'),(NULL,0,'2019-11-29 22:13:16',NULL,932,334,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:16',NULL,933,334,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:16',NULL,934,334,30,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,935,335,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,936,335,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,937,335,30,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,938,336,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,939,336,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,940,336,30,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,941,337,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,942,337,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,943,337,30,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,944,338,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:17',NULL,945,338,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:17',NULL,946,338,30,'64GB'),(NULL,0,'2019-11-29 22:13:17',NULL,947,339,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,948,339,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,949,339,30,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,950,340,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,951,340,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,952,340,30,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,953,341,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,954,341,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,955,341,30,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,956,342,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:18',NULL,957,342,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:18',NULL,958,342,30,'64GB'),(NULL,0,'2019-11-29 22:13:18',NULL,959,343,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,960,343,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,961,343,30,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,962,344,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,963,344,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,964,344,30,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,965,345,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,966,345,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,967,345,30,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,968,347,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:19',NULL,969,347,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:19',NULL,970,347,30,'64GB'),(NULL,0,'2019-11-29 22:13:19',NULL,971,348,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,972,348,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,973,348,30,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,974,349,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,975,349,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,976,349,30,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,977,350,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,978,350,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,979,350,30,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,980,351,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,981,351,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,982,351,30,'64GB'),(NULL,0,'2019-11-29 22:13:20',NULL,983,352,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:20',NULL,984,352,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:20',NULL,985,352,30,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,986,353,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,987,353,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,988,353,30,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,989,354,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,990,354,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,991,354,30,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,992,355,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,993,355,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,994,355,30,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,995,356,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:21',NULL,996,356,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:21',NULL,997,356,30,'64GB'),(NULL,0,'2019-11-29 22:13:21',NULL,998,357,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,999,357,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,1000,357,30,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,1001,358,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,1002,358,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,1003,358,30,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,1004,359,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,1005,359,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,1006,359,30,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,1007,360,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,1008,360,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,1009,360,30,'64GB'),(NULL,0,'2019-11-29 22:13:22',NULL,1010,361,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:22',NULL,1011,361,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:22',NULL,1012,361,30,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,1013,362,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,1014,362,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,1015,362,30,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,1016,364,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,1017,364,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,1018,364,30,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,1019,365,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,1020,365,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,1021,365,30,'64GB'),(NULL,0,'2019-11-29 22:13:23',NULL,1022,366,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:23',NULL,1023,366,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:23',NULL,1024,366,30,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,1025,367,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,1026,367,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,1027,367,30,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,1028,368,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,1029,368,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,1030,368,30,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,1031,369,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,1032,369,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,1033,369,30,'64GB'),(NULL,0,'2019-11-29 22:13:24',NULL,1034,370,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:24',NULL,1035,370,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:24',NULL,1036,370,30,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,1037,371,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,1038,371,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,1039,371,30,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,1040,372,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,1041,372,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,1042,372,30,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,1043,373,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,1044,373,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,1045,373,30,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,1046,374,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:25',NULL,1047,374,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:25',NULL,1048,374,30,'64GB'),(NULL,0,'2019-11-29 22:13:25',NULL,1049,375,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,1050,375,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,1051,375,30,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,1052,376,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,1053,376,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,1054,376,30,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,1055,377,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,1056,377,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,1057,377,30,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,1058,378,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,1059,378,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,1060,378,30,'64GB'),(NULL,0,'2019-11-29 22:13:26',NULL,1061,379,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:26',NULL,1062,379,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:26',NULL,1063,379,30,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,1064,381,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,1065,381,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,1066,381,30,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,1067,382,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,1068,382,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,1069,382,30,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,1070,383,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,1071,383,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,1072,383,30,'64GB'),(NULL,0,'2019-11-29 22:13:27',NULL,1073,384,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:27',NULL,1074,384,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:27',NULL,1075,384,30,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,1076,385,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,1077,385,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,1078,385,30,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,1079,386,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,1080,386,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,1081,386,30,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,1082,387,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,1083,387,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,1084,387,30,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,1085,388,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:28',NULL,1086,388,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:28',NULL,1087,388,30,'64GB'),(NULL,0,'2019-11-29 22:13:28',NULL,1088,389,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,1089,389,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,1090,389,30,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,1091,390,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,1092,390,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,1093,390,30,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,1094,391,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,1095,391,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,1096,391,30,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,1097,392,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:29',NULL,1098,392,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:29',NULL,1099,392,30,'64GB'),(NULL,0,'2019-11-29 22:13:29',NULL,1100,393,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,1101,393,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,1102,393,30,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,1103,394,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,1104,394,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,1105,394,30,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,1106,395,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,1107,395,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,1108,395,30,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,1109,396,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:30',NULL,1110,396,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:30',NULL,1111,396,30,'64GB'),(NULL,0,'2019-11-29 22:13:30',NULL,1112,398,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,1113,398,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,1114,398,30,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,1115,399,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,1116,399,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,1117,399,30,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,1118,400,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,1119,400,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,1120,400,30,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,1121,401,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,1122,401,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,1123,401,30,'64GB'),(NULL,0,'2019-11-29 22:13:31',NULL,1124,402,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:31',NULL,1125,402,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:31',NULL,1126,402,30,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,1127,403,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,1128,403,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,1129,403,30,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,1130,404,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,1131,404,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,1132,404,30,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,1133,405,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,1134,405,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,1135,405,30,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,1136,406,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:32',NULL,1137,406,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:32',NULL,1138,406,30,'64GB'),(NULL,0,'2019-11-29 22:13:32',NULL,1139,407,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,1140,407,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,1141,407,30,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,1142,408,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,1143,408,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,1144,408,30,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,1145,409,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,1146,409,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,1147,409,30,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,1148,410,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:33',NULL,1149,410,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:33',NULL,1150,410,30,'64GB'),(NULL,0,'2019-11-29 22:13:33',NULL,1151,411,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,1152,411,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,1153,411,30,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,1154,412,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,1155,412,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,1156,412,30,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,1157,413,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,1158,413,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,1159,413,30,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,1160,415,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:34',NULL,1161,415,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:34',NULL,1162,415,30,'64GB'),(NULL,0,'2019-11-29 22:13:34',NULL,1163,416,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,1164,416,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,1165,416,30,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,1166,417,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,1167,417,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,1168,417,30,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,1169,418,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,1170,418,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,1171,418,30,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,1172,419,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,1173,419,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,1174,419,30,'64GB'),(NULL,0,'2019-11-29 22:13:35',NULL,1175,420,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:35',NULL,1176,420,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:35',NULL,1177,420,30,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,1178,421,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,1179,421,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,1180,421,30,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,1181,422,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,1182,422,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,1183,422,30,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,1184,423,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,1185,423,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,1186,423,30,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,1187,424,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:36',NULL,1188,424,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:36',NULL,1189,424,30,'64GB'),(NULL,0,'2019-11-29 22:13:36',NULL,1190,425,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,1191,425,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,1192,425,30,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,1193,426,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,1194,426,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,1195,426,30,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,1196,427,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,1197,427,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,1198,427,30,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,1199,428,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:37',NULL,1200,428,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:37',NULL,1201,428,30,'64GB'),(NULL,0,'2019-11-29 22:13:37',NULL,1202,429,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,1203,429,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,1204,429,30,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,1205,430,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,1206,430,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,1207,430,30,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,1208,432,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,1209,432,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,1210,432,30,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,1211,433,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:38',NULL,1212,433,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:38',NULL,1213,433,30,'64GB'),(NULL,0,'2019-11-29 22:13:38',NULL,1214,434,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,1215,434,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,1216,434,30,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,1217,435,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,1218,435,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,1219,435,30,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,1220,436,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,1221,436,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,1222,436,30,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,1223,437,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,1224,437,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,1225,437,30,'64GB'),(NULL,0,'2019-11-29 22:13:39',NULL,1226,438,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:39',NULL,1227,438,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:39',NULL,1228,438,30,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,1229,439,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,1230,439,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,1231,439,30,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,1232,440,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,1233,440,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,1234,440,30,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,1235,441,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,1236,441,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,1237,441,30,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,1238,442,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:40',NULL,1239,442,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:40',NULL,1240,442,30,'64GB'),(NULL,0,'2019-11-29 22:13:40',NULL,1241,443,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,1242,443,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,1243,443,30,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,1244,444,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,1245,444,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,1246,444,30,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,1247,445,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,1248,445,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,1249,445,30,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,1250,446,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,1251,446,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:41',NULL,1252,446,30,'64GB'),(NULL,0,'2019-11-29 22:13:41',NULL,1253,447,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:41',NULL,1254,447,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,1255,447,30,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,1256,449,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,1257,449,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,1258,449,30,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,1259,450,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,1260,450,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,1261,450,30,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,1262,451,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,1263,451,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,1264,451,30,'64GB'),(NULL,0,'2019-11-29 22:13:42',NULL,1265,452,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:42',NULL,1266,452,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:42',NULL,1267,452,30,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,1268,453,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,1269,453,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,1270,453,30,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,1271,454,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,1272,454,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,1273,454,30,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,1274,455,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,1275,455,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,1276,455,30,'64GB'),(NULL,0,'2019-11-29 22:13:43',NULL,1277,456,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:43',NULL,1278,456,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:43',NULL,1279,456,30,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,1280,457,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,1281,457,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,1282,457,30,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,1283,458,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,1284,458,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,1285,458,30,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,1286,459,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,1287,459,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,1288,459,30,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,1289,460,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:44',NULL,1290,460,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:44',NULL,1291,460,30,'64GB'),(NULL,0,'2019-11-29 22:13:44',NULL,1292,461,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,1293,461,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,1294,461,30,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,1295,462,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,1296,462,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,1297,462,30,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,1298,463,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,1299,463,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,1300,463,30,'64GB'),(NULL,0,'2019-11-29 22:13:45',NULL,1301,464,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:45',NULL,1302,464,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:45',NULL,1303,464,30,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,1304,467,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,1305,467,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,1306,467,30,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,1307,468,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,1308,468,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,1309,468,30,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,1310,469,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,1311,469,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,1312,469,30,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,1313,470,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:46',NULL,1314,470,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:46',NULL,1315,470,30,'64GB'),(NULL,0,'2019-11-29 22:13:46',NULL,1316,471,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,1317,471,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,1318,471,30,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,1319,472,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,1320,472,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,1321,472,30,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,1322,473,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,1323,473,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,1324,473,30,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,1325,474,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,1326,474,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,1327,474,30,'64GB'),(NULL,0,'2019-11-29 22:13:47',NULL,1328,475,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:47',NULL,1329,475,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:47',NULL,1330,475,30,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,1331,476,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,1332,476,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,1333,476,30,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,1334,477,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,1335,477,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,1336,477,30,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,1337,478,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,1338,478,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,1339,478,30,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,1340,479,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:48',NULL,1341,479,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:48',NULL,1342,479,30,'64GB'),(NULL,0,'2019-11-29 22:13:48',NULL,1343,480,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,1344,480,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,1345,480,30,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,1346,481,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,1347,481,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,1348,481,30,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,1349,482,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,1350,482,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,1351,482,30,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,1352,484,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:49',NULL,1353,484,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:49',NULL,1354,484,30,'64GB'),(NULL,0,'2019-11-29 22:13:49',NULL,1355,485,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,1356,485,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,1357,485,30,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,1358,486,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,1359,486,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,1360,486,30,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,1361,487,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,1362,487,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,1363,487,30,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,1364,488,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,1365,488,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:50',NULL,1366,488,30,'64GB'),(NULL,0,'2019-11-29 22:13:50',NULL,1367,489,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:50',NULL,1368,489,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,1369,489,30,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,1370,490,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,1371,490,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,1372,490,30,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,1373,491,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,1374,491,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,1375,491,30,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,1376,492,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,1377,492,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,1378,492,30,'64GB'),(NULL,0,'2019-11-29 22:13:51',NULL,1379,493,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:51',NULL,1380,493,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:51',NULL,1381,493,30,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,1382,494,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,1383,494,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,1384,494,30,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,1385,495,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,1386,495,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,1387,495,30,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,1388,496,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,1389,496,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,1390,496,30,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,1391,497,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:52',NULL,1392,497,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:52',NULL,1393,497,30,'64GB'),(NULL,0,'2019-11-29 22:13:52',NULL,1394,498,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,1395,498,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,1396,498,30,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,1397,499,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,1398,499,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,1399,499,30,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,1400,501,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,1401,501,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,1402,501,30,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,1403,502,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:53',NULL,1404,502,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:53',NULL,1405,502,30,'64GB'),(NULL,0,'2019-11-29 22:13:53',NULL,1406,503,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,1407,503,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,1408,503,30,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,1409,504,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,1410,504,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,1411,504,30,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,1412,505,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,1413,505,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,1414,505,30,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,1415,506,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,1416,506,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,1417,506,30,'64GB'),(NULL,0,'2019-11-29 22:13:54',NULL,1418,507,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:54',NULL,1419,507,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:54',NULL,1420,507,30,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,1421,508,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,1422,508,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,1423,508,30,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,1424,509,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,1425,509,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,1426,509,30,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,1427,510,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,1428,510,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,1429,510,30,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,1430,511,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:55',NULL,1431,511,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:55',NULL,1432,511,30,'64GB'),(NULL,0,'2019-11-29 22:13:55',NULL,1433,512,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,1434,512,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,1435,512,30,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,1436,513,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,1437,513,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,1438,513,30,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,1439,514,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,1440,514,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,1441,514,30,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,1442,515,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:56',NULL,1443,515,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:56',NULL,1444,515,30,'64GB'),(NULL,0,'2019-11-29 22:13:56',NULL,1445,516,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,1446,516,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,1447,516,30,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,1448,518,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,1449,518,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,1450,518,30,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,1451,519,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,1452,519,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,1453,519,30,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,1454,520,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:57',NULL,1455,520,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:57',NULL,1456,520,30,'64GB'),(NULL,0,'2019-11-29 22:13:57',NULL,1457,521,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,1458,521,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,1459,521,30,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,1460,522,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,1461,522,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,1462,522,30,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,1463,523,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,1464,523,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,1465,523,30,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,1466,524,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,1467,524,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,1468,524,30,'64GB'),(NULL,0,'2019-11-29 22:13:58',NULL,1469,525,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:58',NULL,1470,525,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:58',NULL,1471,525,30,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,1472,526,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,1473,526,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,1474,526,30,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,1475,527,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,1476,527,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,1477,527,30,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,1478,528,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,1479,528,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,1480,528,30,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,1481,529,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:13:59',NULL,1482,529,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:13:59',NULL,1483,529,30,'64GB'),(NULL,0,'2019-11-29 22:13:59',NULL,1484,530,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,1485,530,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,1486,530,30,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,1487,531,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,1488,531,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,1489,531,30,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,1490,532,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,1491,532,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,1492,532,30,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,1493,533,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:00',NULL,1494,533,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:00',NULL,1495,533,30,'64GB'),(NULL,0,'2019-11-29 22:14:00',NULL,1496,535,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,1497,535,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,1498,535,30,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,1499,536,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,1500,536,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,1501,536,30,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,1502,537,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,1503,537,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,1504,537,30,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,1505,538,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:01',NULL,1506,538,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:01',NULL,1507,538,30,'64GB'),(NULL,0,'2019-11-29 22:14:01',NULL,1508,539,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,1509,539,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,1510,539,30,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,1511,540,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,1512,540,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,1513,540,30,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,1514,541,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,1515,541,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,1516,541,30,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,1517,542,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,1518,542,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,1519,542,30,'64GB'),(NULL,0,'2019-11-29 22:14:02',NULL,1520,543,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:02',NULL,1521,543,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:02',NULL,1522,543,30,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,1523,544,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,1524,544,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,1525,544,30,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,1526,545,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,1527,545,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,1528,545,30,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,1529,546,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,1530,546,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,1531,546,30,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,1532,547,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:03',NULL,1533,547,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:03',NULL,1534,547,30,'64GB'),(NULL,0,'2019-11-29 22:14:03',NULL,1535,548,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,1536,548,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,1537,548,30,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,1538,549,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,1539,549,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,1540,549,30,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,1541,550,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,1542,550,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,1543,550,30,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,1544,552,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:04',NULL,1545,552,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:04',NULL,1546,552,30,'64GB'),(NULL,0,'2019-11-29 22:14:04',NULL,1547,553,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,1548,553,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,1549,553,30,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,1550,554,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,1551,554,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,1552,554,30,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,1553,555,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,1554,555,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,1555,555,30,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,1556,556,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:05',NULL,1557,556,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:05',NULL,1558,556,30,'64GB'),(NULL,0,'2019-11-29 22:14:05',NULL,1559,557,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,1560,557,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,1561,557,30,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,1562,558,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,1563,558,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,1564,558,30,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,1565,559,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,1566,559,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,1567,559,30,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,1568,560,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,1569,560,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,1570,560,30,'64GB'),(NULL,0,'2019-11-29 22:14:06',NULL,1571,561,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:06',NULL,1572,561,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:06',NULL,1573,561,30,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,1574,562,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,1575,562,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,1576,562,30,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,1577,563,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,1578,563,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,1579,563,30,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,1580,564,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,1581,564,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,1582,564,30,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,1583,565,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:07',NULL,1584,565,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:07',NULL,1585,565,30,'64GB'),(NULL,0,'2019-11-29 22:14:07',NULL,1586,566,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,1587,566,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,1588,566,30,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,1589,567,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,1590,567,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,1591,567,30,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,1592,569,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,1593,569,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,1594,569,30,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,1595,570,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:08',NULL,1596,570,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:08',NULL,1597,570,30,'64GB'),(NULL,0,'2019-11-29 22:14:08',NULL,1598,571,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,1599,571,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,1600,571,30,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,1601,572,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,1602,572,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,1603,572,30,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,1604,573,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,1605,573,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,1606,573,30,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,1607,574,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:09',NULL,1608,574,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:09',NULL,1609,574,30,'64GB'),(NULL,0,'2019-11-29 22:14:09',NULL,1610,575,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,1611,575,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,1612,575,30,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,1613,576,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,1614,576,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,1615,576,30,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,1616,577,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,1617,577,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,1618,577,30,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,1619,578,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,1620,578,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,1621,578,30,'64GB'),(NULL,0,'2019-11-29 22:14:10',NULL,1622,579,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:10',NULL,1623,579,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:10',NULL,1624,579,30,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,1625,580,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,1626,580,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,1627,580,30,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,1628,581,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,1629,581,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,1630,581,30,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,1631,582,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,1632,582,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,1633,582,30,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,1634,583,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:11',NULL,1635,583,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:11',NULL,1636,583,30,'64GB'),(NULL,0,'2019-11-29 22:14:11',NULL,1637,584,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,1638,584,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,1639,584,30,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,1640,586,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,1641,586,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,1642,586,30,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,1643,587,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,1644,587,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,1645,587,30,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,1646,588,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:12',NULL,1647,588,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:12',NULL,1648,588,30,'64GB'),(NULL,0,'2019-11-29 22:14:12',NULL,1649,589,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,1650,589,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,1651,589,30,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,1652,590,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,1653,590,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,1654,590,30,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,1655,591,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,1656,591,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,1657,591,30,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,1658,592,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:13',NULL,1659,592,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:13',NULL,1660,592,30,'64GB'),(NULL,0,'2019-11-29 22:14:13',NULL,1661,593,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,1662,593,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,1663,593,30,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,1664,594,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,1665,594,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,1666,594,30,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,1667,595,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,1668,595,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,1669,595,30,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,1670,596,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,1671,596,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,1672,596,30,'64GB'),(NULL,0,'2019-11-29 22:14:14',NULL,1673,597,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:14',NULL,1674,597,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:14',NULL,1675,597,30,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,1676,598,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,1677,598,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,1678,598,30,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,1679,599,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,1680,599,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,1681,599,30,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,1682,600,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,1683,600,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,1684,600,30,'64GB'),(NULL,0,'2019-11-29 22:14:15',NULL,1685,601,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:14:15',NULL,1686,601,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:14:15',NULL,1687,601,30,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,1944,879,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,1945,879,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,1946,879,30,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,1947,880,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,1948,880,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,1949,880,30,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,1950,881,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,1951,881,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,1952,881,30,'64GB'),(NULL,0,'2019-11-29 22:15:20',NULL,1953,882,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:20',NULL,1954,882,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:20',NULL,1955,882,30,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,1956,883,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,1957,883,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,1958,883,30,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,1959,884,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,1960,884,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,1961,884,30,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,1962,885,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,1963,885,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,1964,885,30,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,1965,886,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:21',NULL,1966,886,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:21',NULL,1967,886,30,'64GB'),(NULL,0,'2019-11-29 22:15:21',NULL,1968,887,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,1969,887,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,1970,887,30,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,1971,888,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,1972,888,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,1973,888,30,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,1974,889,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,1975,889,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,1976,889,30,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,1977,890,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,1978,890,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,1979,890,30,'64GB'),(NULL,0,'2019-11-29 22:15:22',NULL,1980,891,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:22',NULL,1981,891,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:22',NULL,1982,891,30,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,1983,892,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,1984,892,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,1985,892,30,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,1986,893,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,1987,893,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,1988,893,30,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,1989,894,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,1990,894,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,1991,894,30,'64GB'),(NULL,0,'2019-11-29 22:15:23',NULL,1992,896,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:23',NULL,1993,896,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:23',NULL,1994,896,30,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,1995,897,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,1996,897,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,1997,897,30,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,1998,898,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,1999,898,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,2000,898,30,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,2001,899,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,2002,899,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,2003,899,30,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,2004,900,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:24',NULL,2005,900,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:24',NULL,2006,900,30,'64GB'),(NULL,0,'2019-11-29 22:15:24',NULL,2007,901,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,2008,901,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,2009,901,30,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,2010,902,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,2011,902,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,2012,902,30,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,2013,903,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,2014,903,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,2015,903,30,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,2016,904,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:25',NULL,2017,904,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:25',NULL,2018,904,30,'64GB'),(NULL,0,'2019-11-29 22:15:25',NULL,2019,905,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,2020,905,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,2021,905,30,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,2022,906,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,2023,906,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,2024,906,30,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,2025,907,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,2026,907,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,2027,907,30,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,2028,908,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,2029,908,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,2030,908,30,'64GB'),(NULL,0,'2019-11-29 22:15:26',NULL,2031,909,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:26',NULL,2032,909,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:26',NULL,2033,909,30,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,2034,910,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,2035,910,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,2036,910,30,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,2037,911,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,2038,911,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,2039,911,30,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,2040,913,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,2041,913,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,2042,913,30,'64GB'),(NULL,0,'2019-11-29 22:15:27',NULL,2043,914,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:27',NULL,2044,914,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:27',NULL,2045,914,30,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,2046,915,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,2047,915,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,2048,915,30,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,2049,916,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,2050,916,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,2051,916,30,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,2052,917,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,2053,917,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,2054,917,30,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,2055,918,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:28',NULL,2056,918,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:28',NULL,2057,918,30,'64GB'),(NULL,0,'2019-11-29 22:15:28',NULL,2058,919,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,2059,919,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,2060,919,30,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,2061,920,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,2062,920,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,2063,920,30,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,2064,921,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,2065,921,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,2066,921,30,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,2067,922,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:29',NULL,2068,922,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:29',NULL,2069,922,30,'64GB'),(NULL,0,'2019-11-29 22:15:29',NULL,2070,923,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,2071,923,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,2072,923,30,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,2073,924,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,2074,924,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,2075,924,30,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,2076,925,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,2077,925,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,2078,925,30,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,2079,926,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,2080,926,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,2081,926,30,'64GB'),(NULL,0,'2019-11-29 22:15:30',NULL,2082,927,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:30',NULL,2083,927,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:30',NULL,2084,927,30,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,2085,928,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,2086,928,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,2087,928,30,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,2088,930,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,2089,930,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,2090,930,30,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,2091,931,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,2092,931,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,2093,931,30,'64GB'),(NULL,0,'2019-11-29 22:15:31',NULL,2094,932,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:31',NULL,2095,932,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:31',NULL,2096,932,30,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,2097,933,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,2098,933,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,2099,933,30,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,2100,934,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,2101,934,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,2102,934,30,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,2103,935,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,2104,935,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,2105,935,30,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,2106,936,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:32',NULL,2107,936,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:32',NULL,2108,936,30,'64GB'),(NULL,0,'2019-11-29 22:15:32',NULL,2109,937,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,2110,937,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,2111,937,30,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,2112,938,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,2113,938,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,2114,938,30,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,2115,939,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,2116,939,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,2117,939,30,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,2118,940,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:33',NULL,2119,940,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:33',NULL,2120,940,30,'64GB'),(NULL,0,'2019-11-29 22:15:33',NULL,2121,941,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,2122,941,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,2123,941,30,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,2124,942,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,2125,942,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,2126,942,30,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,2127,943,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,2128,943,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,2129,943,30,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,2130,944,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,2131,944,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,2132,944,30,'64GB'),(NULL,0,'2019-11-29 22:15:34',NULL,2133,945,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:34',NULL,2134,945,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:34',NULL,2135,945,30,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,2136,947,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,2137,947,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,2138,947,30,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,2139,948,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,2140,948,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,2141,948,30,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,2142,949,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,2143,949,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,2144,949,30,'64GB'),(NULL,0,'2019-11-29 22:15:35',NULL,2145,950,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:35',NULL,2146,950,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:35',NULL,2147,950,30,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,2148,951,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,2149,951,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,2150,951,30,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,2151,952,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,2152,952,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,2153,952,30,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,2154,953,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,2155,953,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,2156,953,30,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,2157,954,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:36',NULL,2158,954,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:36',NULL,2159,954,30,'64GB'),(NULL,0,'2019-11-29 22:15:36',NULL,2160,955,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,2161,955,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,2162,955,30,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,2163,956,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,2164,956,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,2165,956,30,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,2166,957,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,2167,957,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,2168,957,30,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,2169,958,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:37',NULL,2170,958,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:37',NULL,2171,958,30,'64GB'),(NULL,0,'2019-11-29 22:15:37',NULL,2172,959,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,2173,959,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,2174,959,30,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,2175,960,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,2176,960,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,2177,960,30,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,2178,961,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,2179,961,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,2180,961,30,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,2181,962,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,2182,962,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,2183,962,30,'64GB'),(NULL,0,'2019-11-29 22:15:38',NULL,2184,964,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:38',NULL,2185,964,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:38',NULL,2186,964,30,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,2187,965,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,2188,965,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,2189,965,30,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,2190,966,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,2191,966,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,2192,966,30,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,2193,967,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,2194,967,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,2195,967,30,'64GB'),(NULL,0,'2019-11-29 22:15:39',NULL,2196,968,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:39',NULL,2197,968,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:39',NULL,2198,968,30,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,2199,969,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,2200,969,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,2201,969,30,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,2202,970,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,2203,970,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,2204,970,30,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,2205,971,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,2206,971,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,2207,971,30,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,2208,972,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:40',NULL,2209,972,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:40',NULL,2210,972,30,'64GB'),(NULL,0,'2019-11-29 22:15:40',NULL,2211,973,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,2212,973,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,2213,973,30,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,2214,974,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,2215,974,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,2216,974,30,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,2217,975,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,2218,975,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,2219,975,30,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,2220,976,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,2221,976,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,2222,976,30,'64GB'),(NULL,0,'2019-11-29 22:15:41',NULL,2223,977,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:41',NULL,2224,977,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:41',NULL,2225,977,30,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,2226,978,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,2227,978,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,2228,978,30,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,2229,979,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,2230,979,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,2231,979,30,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,2232,981,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,2233,981,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,2234,981,30,'64GB'),(NULL,0,'2019-11-29 22:15:42',NULL,2235,982,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:42',NULL,2236,982,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:42',NULL,2237,982,30,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,2238,983,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,2239,983,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,2240,983,30,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,2241,984,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,2242,984,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,2243,984,30,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,2244,985,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,2245,985,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,2246,985,30,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,2247,986,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:43',NULL,2248,986,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:43',NULL,2249,986,30,'64GB'),(NULL,0,'2019-11-29 22:15:43',NULL,2250,987,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,2251,987,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,2252,987,30,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,2253,988,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,2254,988,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,2255,988,30,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,2256,989,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,2257,989,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,2258,989,30,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,2259,990,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:44',NULL,2260,990,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:44',NULL,2261,990,30,'64GB'),(NULL,0,'2019-11-29 22:15:44',NULL,2262,991,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,2263,991,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,2264,991,30,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,2265,992,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,2266,992,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,2267,992,30,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,2268,993,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,2269,993,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,2270,993,30,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,2271,994,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:45',NULL,2272,994,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:45',NULL,2273,994,30,'64GB'),(NULL,0,'2019-11-29 22:15:45',NULL,2274,995,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,2275,995,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,2276,995,30,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,2277,996,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,2278,996,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,2279,996,30,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,2280,998,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,2281,998,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,2282,998,30,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,2283,999,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,2284,999,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:46',NULL,2285,999,30,'64GB'),(NULL,0,'2019-11-29 22:15:46',NULL,2286,1000,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:46',NULL,2287,1000,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,2288,1000,30,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,2289,1001,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,2290,1001,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,2291,1001,30,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,2292,1002,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,2293,1002,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,2294,1002,30,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,2295,1003,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,2296,1003,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,2297,1003,30,'64GB'),(NULL,0,'2019-11-29 22:15:47',NULL,2298,1004,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:47',NULL,2299,1004,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:47',NULL,2300,1004,30,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,2301,1005,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,2302,1005,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,2303,1005,30,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,2304,1006,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,2305,1006,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,2306,1006,30,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,2307,1007,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,2308,1007,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,2309,1007,30,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,2310,1008,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:48',NULL,2311,1008,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:48',NULL,2312,1008,30,'64GB'),(NULL,0,'2019-11-29 22:15:48',NULL,2313,1009,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,2314,1009,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,2315,1009,30,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,2316,1010,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,2317,1010,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,2318,1010,30,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,2319,1011,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,2320,1011,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,2321,1011,30,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,2322,1012,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,2323,1012,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,2324,1012,30,'64GB'),(NULL,0,'2019-11-29 22:15:49',NULL,2325,1013,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:49',NULL,2326,1013,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:49',NULL,2327,1013,30,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,2328,1016,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,2329,1016,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,2330,1016,30,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,2331,1017,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,2332,1017,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,2333,1017,30,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,2334,1018,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:50',NULL,2335,1018,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:50',NULL,2336,1018,30,'64GB'),(NULL,0,'2019-11-29 22:15:50',NULL,2337,1019,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,2338,1019,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,2339,1019,30,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,2340,1020,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,2341,1020,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,2342,1020,30,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,2343,1021,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,2344,1021,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,2345,1021,30,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,2346,1022,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,2347,1022,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,2348,1022,30,'64GB'),(NULL,0,'2019-11-29 22:15:51',NULL,2349,1023,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:51',NULL,2350,1023,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:51',NULL,2351,1023,30,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,2352,1024,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,2353,1024,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,2354,1024,30,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,2355,1025,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,2356,1025,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,2357,1025,30,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,2358,1026,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,2359,1026,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,2360,1026,30,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,2361,1027,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:52',NULL,2362,1027,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:52',NULL,2363,1027,30,'64GB'),(NULL,0,'2019-11-29 22:15:52',NULL,2364,1028,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,2365,1028,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,2366,1028,30,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,2367,1029,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,2368,1029,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,2369,1029,30,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,2370,1030,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,2371,1030,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,2372,1030,30,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,2373,1031,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:53',NULL,2374,1031,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:53',NULL,2375,1031,30,'64GB'),(NULL,0,'2019-11-29 22:15:53',NULL,2376,1033,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,2377,1033,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,2378,1033,30,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,2379,1034,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,2380,1034,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,2381,1034,30,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,2382,1035,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,2383,1035,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,2384,1035,30,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,2385,1036,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,2386,1036,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:54',NULL,2387,1036,30,'64GB'),(NULL,0,'2019-11-29 22:15:54',NULL,2388,1037,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:54',NULL,2389,1037,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,2390,1037,30,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,2391,1038,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,2392,1038,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,2393,1038,30,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,2394,1039,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,2395,1039,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,2396,1039,30,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,2397,1040,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,2398,1040,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,2399,1040,30,'64GB'),(NULL,0,'2019-11-29 22:15:55',NULL,2400,1041,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:55',NULL,2401,1041,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:55',NULL,2402,1041,30,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,2403,1042,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,2404,1042,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,2405,1042,30,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,2406,1043,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,2407,1043,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,2408,1043,30,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,2409,1044,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,2410,1044,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,2411,1044,30,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,2412,1045,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:56',NULL,2413,1045,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:56',NULL,2414,1045,30,'64GB'),(NULL,0,'2019-11-29 22:15:56',NULL,2415,1046,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,2416,1046,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,2417,1046,30,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,2418,1047,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,2419,1047,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,2420,1047,30,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,2421,1048,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,2422,1048,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,2423,1048,30,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,2424,1050,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:57',NULL,2425,1050,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:57',NULL,2426,1050,30,'64GB'),(NULL,0,'2019-11-29 22:15:57',NULL,2427,1051,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,2428,1051,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,2429,1051,30,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,2430,1052,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,2431,1052,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,2432,1052,30,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,2433,1053,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,2434,1053,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,2435,1053,30,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,2436,1054,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:58',NULL,2437,1054,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:58',NULL,2438,1054,30,'64GB'),(NULL,0,'2019-11-29 22:15:58',NULL,2439,1055,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,2440,1055,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,2441,1055,30,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,2442,1056,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,2443,1056,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,2444,1056,30,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,2445,1057,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,2446,1057,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,2447,1057,30,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,2448,1058,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,2449,1058,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,2450,1058,30,'64GB'),(NULL,0,'2019-11-29 22:15:59',NULL,2451,1059,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:15:59',NULL,2452,1059,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:15:59',NULL,2453,1059,30,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,2454,1060,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,2455,1060,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,2456,1060,30,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,2457,1061,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,2458,1061,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,2459,1061,30,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,2460,1062,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,2461,1062,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,2462,1062,30,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,2463,1063,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:00',NULL,2464,1063,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:00',NULL,2465,1063,30,'64GB'),(NULL,0,'2019-11-29 22:16:00',NULL,2466,1064,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,2467,1064,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,2468,1064,30,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,2469,1065,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,2470,1065,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,2471,1065,30,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,2472,1067,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,2473,1067,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,2474,1067,30,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,2475,1068,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:01',NULL,2476,1068,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:01',NULL,2477,1068,30,'64GB'),(NULL,0,'2019-11-29 22:16:01',NULL,2478,1069,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,2479,1069,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,2480,1069,30,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,2481,1070,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,2482,1070,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,2483,1070,30,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,2484,1071,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,2485,1071,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,2486,1071,30,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,2487,1072,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:02',NULL,2488,1072,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:02',NULL,2489,1072,30,'64GB'),(NULL,0,'2019-11-29 22:16:02',NULL,2490,1073,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,2491,1073,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,2492,1073,30,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,2493,1074,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,2494,1074,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,2495,1074,30,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,2496,1075,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,2497,1075,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,2498,1075,30,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,2499,1076,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,2500,1076,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,2501,1076,30,'64GB'),(NULL,0,'2019-11-29 22:16:03',NULL,2502,1077,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:03',NULL,2503,1077,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:03',NULL,2504,1077,30,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,2505,1078,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,2506,1078,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,2507,1078,30,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,2508,1079,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,2509,1079,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,2510,1079,30,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,2511,1080,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,2512,1080,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,2513,1080,30,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,2514,1081,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:04',NULL,2515,1081,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:04',NULL,2516,1081,30,'64GB'),(NULL,0,'2019-11-29 22:16:04',NULL,2517,1082,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,2518,1082,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,2519,1082,30,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,2520,1084,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,2521,1084,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,2522,1084,30,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,2523,1085,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,2524,1085,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,2525,1085,30,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,2526,1086,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:05',NULL,2527,1086,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:05',NULL,2528,1086,30,'64GB'),(NULL,0,'2019-11-29 22:16:05',NULL,2529,1087,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,2530,1087,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,2531,1087,30,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,2532,1088,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,2533,1088,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,2534,1088,30,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,2535,1089,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,2536,1089,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,2537,1089,30,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,2538,1090,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,2539,1090,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,2540,1090,30,'64GB'),(NULL,0,'2019-11-29 22:16:06',NULL,2541,1091,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:06',NULL,2542,1091,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:06',NULL,2543,1091,30,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,2544,1092,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,2545,1092,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,2546,1092,30,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,2547,1093,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,2548,1093,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,2549,1093,30,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,2550,1094,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,2551,1094,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,2552,1094,30,'64GB'),(NULL,0,'2019-11-29 22:16:07',NULL,2553,1095,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:07',NULL,2554,1095,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:07',NULL,2555,1095,30,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,2556,1096,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,2557,1096,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,2558,1096,30,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,2559,1097,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,2560,1097,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,2561,1097,30,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,2562,1098,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,2563,1098,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,2564,1098,30,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,2565,1099,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:08',NULL,2566,1099,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:08',NULL,2567,1099,30,'64GB'),(NULL,0,'2019-11-29 22:16:08',NULL,2568,1101,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,2569,1101,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,2570,1101,30,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,2571,1102,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,2572,1102,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,2573,1102,30,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,2574,1103,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,2575,1103,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,2576,1103,30,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,2577,1104,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:09',NULL,2578,1104,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:09',NULL,2579,1104,30,'64GB'),(NULL,0,'2019-11-29 22:16:09',NULL,2580,1105,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,2581,1105,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,2582,1105,30,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,2583,1106,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,2584,1106,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,2585,1106,30,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,2586,1107,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,2587,1107,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,2588,1107,30,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,2589,1108,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,2590,1108,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,2591,1108,30,'64GB'),(NULL,0,'2019-11-29 22:16:10',NULL,2592,1109,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:10',NULL,2593,1109,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:10',NULL,2594,1109,30,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,2595,1110,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,2596,1110,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,2597,1110,30,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,2598,1111,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,2599,1111,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,2600,1111,30,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,2601,1112,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,2602,1112,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,2603,1112,30,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,2604,1113,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:11',NULL,2605,1113,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:11',NULL,2606,1113,30,'64GB'),(NULL,0,'2019-11-29 22:16:11',NULL,2607,1114,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,2608,1114,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,2609,1114,30,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,2610,1115,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,2611,1115,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,2612,1115,30,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,2613,1116,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,2614,1116,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,2615,1116,30,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,2616,1118,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:12',NULL,2617,1118,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:12',NULL,2618,1118,30,'64GB'),(NULL,0,'2019-11-29 22:16:12',NULL,2619,1119,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,2620,1119,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,2621,1119,30,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,2622,1120,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,2623,1120,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,2624,1120,30,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,2625,1121,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,2626,1121,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,2627,1121,30,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,2628,1122,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:13',NULL,2629,1122,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:13',NULL,2630,1122,30,'64GB'),(NULL,0,'2019-11-29 22:16:13',NULL,2631,1123,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,2632,1123,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,2633,1123,30,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,2634,1124,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,2635,1124,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,2636,1124,30,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,2637,1125,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,2638,1125,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,2639,1125,30,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,2640,1126,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,2641,1126,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,2642,1126,30,'64GB'),(NULL,0,'2019-11-29 22:16:14',NULL,2643,1127,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:14',NULL,2644,1127,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:14',NULL,2645,1127,30,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,2646,1128,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,2647,1128,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,2648,1128,30,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,2649,1129,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,2650,1129,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,2651,1129,30,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,2652,1130,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,2653,1130,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,2654,1130,30,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,2655,1131,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:15',NULL,2656,1131,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:15',NULL,2657,1131,30,'64GB'),(NULL,0,'2019-11-29 22:16:15',NULL,2658,1132,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,2659,1132,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,2660,1132,30,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,2661,1133,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,2662,1133,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,2663,1133,30,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,2664,1135,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,2665,1135,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,2666,1135,30,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,2667,1136,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:16',NULL,2668,1136,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:16',NULL,2669,1136,30,'64GB'),(NULL,0,'2019-11-29 22:16:16',NULL,2670,1137,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,2671,1137,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,2672,1137,30,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,2673,1138,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,2674,1138,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,2675,1138,30,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,2676,1139,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,2677,1139,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,2678,1139,30,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,2679,1140,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,2680,1140,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:17',NULL,2681,1140,30,'64GB'),(NULL,0,'2019-11-29 22:16:17',NULL,2682,1141,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:17',NULL,2683,1141,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,2684,1141,30,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,2685,1142,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,2686,1142,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,2687,1142,30,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,2688,1143,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,2689,1143,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,2690,1143,30,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,2691,1144,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,2692,1144,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,2693,1144,30,'64GB'),(NULL,0,'2019-11-29 22:16:18',NULL,2694,1145,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:18',NULL,2695,1145,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:18',NULL,2696,1145,30,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,2697,1146,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,2698,1146,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,2699,1146,30,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,2700,1147,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,2701,1147,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,2702,1147,30,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,2703,1148,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,2704,1148,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,2705,1148,30,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,2706,1149,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:19',NULL,2707,1149,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:19',NULL,2708,1149,30,'64GB'),(NULL,0,'2019-11-29 22:16:19',NULL,2709,1150,21,'Intel Xeon Silver 4114 Processor'),(NULL,0,'2019-11-29 22:16:20',NULL,2710,1150,25,'3.273TB/RAID5'),(NULL,0,'2019-11-29 22:16:20',NULL,2711,1150,30,'64GB');
/*!40000 ALTER TABLE `c_value_texts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_company_info_json`
--

DROP TABLE IF EXISTS `common_company_info_json`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_company_info_json` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `info` json DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_common_company_info_json_deleted` (`deleted`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_company_info_json`
--

LOCK TABLES `common_company_info_json` WRITE;
/*!40000 ALTER TABLE `common_company_info_json` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_company_info_json` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_department`
--

DROP TABLE IF EXISTS `common_department`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_department` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `department_id` int(11) NOT NULL AUTO_INCREMENT,
  `department_name` varchar(255) DEFAULT NULL COMMENT '部门名称',
  `department_director_id` int(11) DEFAULT NULL COMMENT '部门负责人ID',
  `department_parent_id` int(11) DEFAULT NULL COMMENT '上级部门ID',
  `sort_value` int(11) DEFAULT NULL COMMENT '排序值',
  `acl_rid` int(11) DEFAULT NULL COMMENT 'ACL中rid',
  PRIMARY KEY (`department_id`),
  KEY `ix_common_department_deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_department`
--

LOCK TABLES `common_department` WRITE;
/*!40000 ALTER TABLE `common_department` DISABLE KEYS */;
INSERT INTO `common_department` VALUES (NULL,0,'2023-07-11 14:16:33','2023-07-11 14:16:33',0,'全公司',0,-1,0,0);
/*!40000 ALTER TABLE `common_department` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_employee`
--

DROP TABLE IF EXISTS `common_employee`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_employee` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `employee_id` int(11) NOT NULL AUTO_INCREMENT,
  `email` varchar(255) DEFAULT NULL COMMENT '邮箱',
  `username` varchar(255) DEFAULT NULL COMMENT '用户名',
  `nickname` varchar(255) DEFAULT NULL COMMENT '姓名',
  `sex` varchar(64) DEFAULT NULL COMMENT '性别',
  `position_name` varchar(255) DEFAULT NULL COMMENT '职位名称',
  `mobile` varchar(255) DEFAULT NULL COMMENT '电话号码',
  `avatar` varchar(255) DEFAULT NULL COMMENT '头像',
  `direct_supervisor_id` int(11) DEFAULT NULL COMMENT '直接上级ID',
  `department_id` int(11) DEFAULT NULL COMMENT '部门ID',
  `acl_uid` int(11) DEFAULT NULL COMMENT 'ACL中uid',
  `acl_rid` int(11) DEFAULT NULL COMMENT 'ACL中rid',
  `acl_virtual_rid` int(11) DEFAULT NULL COMMENT 'ACL中虚拟角色rid',
  `last_login` timestamp NULL DEFAULT NULL COMMENT '上次登录时间',
  `block` int(11) DEFAULT NULL COMMENT '锁定状态',
  PRIMARY KEY (`employee_id`),
  KEY `department_id` (`department_id`),
  KEY `ix_common_employee_deleted` (`deleted`),
  CONSTRAINT `common_employee_ibfk_1` FOREIGN KEY (`department_id`) REFERENCES `common_department` (`department_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_employee`
--

LOCK TABLES `common_employee` WRITE;
/*!40000 ALTER TABLE `common_employee` DISABLE KEYS */;
INSERT INTO `common_employee` VALUES (NULL,0,'2023-07-11 14:17:25',NULL,1,'demo@xxx.com','demo','demo','','','','',0,0,3,0,0,'2023-07-11 04:36:38',0);
/*!40000 ALTER TABLE `common_employee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_employee_info`
--

DROP TABLE IF EXISTS `common_employee_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_employee_info` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `info` json DEFAULT NULL COMMENT '员工信息',
  `employee_id` int(11) DEFAULT NULL COMMENT '员工ID',
  PRIMARY KEY (`id`),
  KEY `employee_id` (`employee_id`),
  KEY `ix_common_employee_info_deleted` (`deleted`),
  CONSTRAINT `common_employee_info_ibfk_1` FOREIGN KEY (`employee_id`) REFERENCES `common_employee` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_employee_info`
--

LOCK TABLES `common_employee_info` WRITE;
/*!40000 ALTER TABLE `common_employee_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_employee_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_internal_message`
--

DROP TABLE IF EXISTS `common_internal_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_internal_message` (
  `deleted_at` datetime DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `content` text COMMENT '内容',
  `path` varchar(255) DEFAULT NULL COMMENT '跳转路径',
  `is_read` tinyint(1) DEFAULT NULL COMMENT '是否已读',
  `app_name` varchar(128) NOT NULL COMMENT '应用名称',
  `category` varchar(128) NOT NULL COMMENT '分类',
  `message_data` json DEFAULT NULL COMMENT '数据',
  `employee_id` int(11) DEFAULT NULL COMMENT 'ID',
  PRIMARY KEY (`id`),
  KEY `employee_id` (`employee_id`),
  KEY `ix_common_internal_message_deleted` (`deleted`),
  CONSTRAINT `common_internal_message_ibfk_1` FOREIGN KEY (`employee_id`) REFERENCES `common_employee` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_internal_message`
--

LOCK TABLES `common_internal_message` WRITE;
/*!40000 ALTER TABLE `common_internal_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_internal_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(32) DEFAULT NULL,
  `nickname` varchar(20) DEFAULT NULL,
  `department` varchar(20) DEFAULT NULL,
  `catalog` varchar(64) DEFAULT NULL,
  `email` varchar(100) NOT NULL,
  `mobile` varchar(14) DEFAULT NULL,
  `password` varchar(80) DEFAULT NULL,
  `key` varchar(32) NOT NULL,
  `secret` varchar(32) NOT NULL,
  `date_joined` datetime DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `block` tinyint(1) DEFAULT NULL,
  `has_logined` tinyint(1) DEFAULT NULL,
  `deleted_at` date DEFAULT NULL,
  `wx_id` varchar(32) DEFAULT NULL,
  `avatar` varchar(128) DEFAULT NULL,
  `deleted` tinyint(1) DEFAULT NULL,
  `employee_id` varchar(16) DEFAULT NULL,
  PRIMARY KEY (`uid`),
  UNIQUE KEY `email` (`email`),
  UNIQUE KEY `username` (`username`),
  UNIQUE KEY `mobile` (`mobile`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (1,'worker','worker',NULL,NULL,'worker@xxx.com',NULL,NULL,'','',NULL,NULL,0,NULL,NULL,NULL,NULL,0,NULL),(3,'demo','demo',NULL,NULL,'demo@xxx.com',NULL,'e10adc3949ba59abbe56e057f20f883e','2f59b72d70234728aa8a813b1c27349f','9AIVmo8iDaz%3h5#lrJb~Eytf2!B0R6n','2019-12-11 04:01:40','2023-07-11 15:07:57',0,1,NULL,NULL,NULL,0,NULL);
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2023-07-11 15:25:49
